/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ekvdefs.h"
#include "ngspice/sperror.h"
#include "ngspice/suffix.h"

int ekvtrunc(GENmodel *inModel, CKTcircuit *ckt, double *timeStep)
{
  ekvmodel *model = (ekvmodel*)inModel;
  ekvinstance *here;

#ifdef STEPDEBUG
    double debugtemp;
#endif /* STEPDEBUG */  
  
  for ( ; model != NULL; model = ekvnextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = ekvinstances(model); here != NULL ; here = ekvnextInstance(here))
    {
#ifdef STEPDEBUG
            debugtemp = *timeStep;
#endif /* STEPDEBUG */   
 
            CKTterr(here->state_g_dp, ckt, timeStep);
            CKTterr(here->state_g_sp, ckt, timeStep);
            CKTterr(here->state_b_dp, ckt, timeStep);
            CKTterr(here->state_b_sp, ckt, timeStep);
            CKTterr(here->state_g_b, ckt, timeStep);
            CKTterr(here->state_sp_b, ckt, timeStep);
            CKTterr(here->state_dp_b, ckt, timeStep);
    
 
#ifdef STEPDEBUG
            if(debugtemp != *timeStep)
	    {  printf("device %s reduces step from %g to %g\n",
                       here->ekvname,debugtemp,*timeStep);
            }
#endif /* STEPDEBUG */
   
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
