/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/

#define NGSPICE_DEBUG_OK


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "psp102defs.h"
#include "ngspice/const.h"
#include "ngspice/trandefs.h"
#include "ngspice/sperror.h"
#include "ngspice/devdefs.h"
#include "ngspice/suffix.h"

/*fixme: noise not implemented in ngspice*/
#define ngspice_flickernoise(p,n,mag,freq,info)\
{\
}
#define ngspice_whitenoise(p,n,mag,info)\
{\
}

#define NP(p) *(ckt->CKTrhsOld+here->p ## Node)
#define BP(p,n) (NP(p)-NP(n))
#define DBGNODE(p) printf(#p "=%i - v=%e\n",here->p ## Node,NP(p));
static void psp102debug (CKTcircuit *ckt, psp102model *model, psp102instance *here)
{
  fprintf(stdout,"voltage: D=%e\n",NP(D));
  fprintf(stdout,"voltage: G=%e\n",NP(G));
  fprintf(stdout,"voltage: S=%e\n",NP(S));
  fprintf(stdout,"voltage: B=%e\n",NP(B));
  fprintf(stdout,"voltage: NOI=%e\n",NP(NOI));
  fprintf(stdout,"voltage: NOI2=%e\n",NP(NOI2));
  fprintf(stdout,"voltage: GP=%e\n",NP(GP));
  fprintf(stdout,"voltage: BP=%e\n",NP(BP));
  fprintf(stdout,"voltage: BI=%e\n",NP(BI));
  fprintf(stdout,"voltage: BS=%e\n",NP(BS));
  fprintf(stdout,"voltage: BD=%e\n",NP(BD));
  fprintf(stdout,"Parameter: model: LEVEL=%e\n",model->LEVEL);
  fprintf(stdout,"Parameter: model: TYPE=%i\n",model->TYPE);
  fprintf(stdout,"Parameter: model: nmos=%i\n",model->nmos);
  fprintf(stdout,"Parameter: model: pmos=%i\n",model->pmos);
  fprintf(stdout,"Parameter: model: TR=%e\n",model->TR);
  fprintf(stdout,"Parameter: model: SWIGATE=%e\n",model->SWIGATE);
  fprintf(stdout,"Parameter: model: SWIMPACT=%e\n",model->SWIMPACT);
  fprintf(stdout,"Parameter: model: SWGIDL=%e\n",model->SWGIDL);
  fprintf(stdout,"Parameter: model: SWJUNCAP=%e\n",model->SWJUNCAP);
  fprintf(stdout,"Parameter: model: SWJUNASYM=%e\n",model->SWJUNASYM);
  fprintf(stdout,"Parameter: model: QMC=%e\n",model->QMC);
  fprintf(stdout,"Parameter: model: LVARO=%e\n",model->LVARO);
  fprintf(stdout,"Parameter: model: LVARL=%e\n",model->LVARL);
  fprintf(stdout,"Parameter: model: LVARW=%e\n",model->LVARW);
  fprintf(stdout,"Parameter: model: LAP=%e\n",model->LAP);
  fprintf(stdout,"Parameter: model: WVARO=%e\n",model->WVARO);
  fprintf(stdout,"Parameter: model: WVARL=%e\n",model->WVARL);
  fprintf(stdout,"Parameter: model: WVARW=%e\n",model->WVARW);
  fprintf(stdout,"Parameter: model: WOT=%e\n",model->WOT);
  fprintf(stdout,"Parameter: model: DLQ=%e\n",model->DLQ);
  fprintf(stdout,"Parameter: model: DWQ=%e\n",model->DWQ);
  fprintf(stdout,"Parameter: model: VFBO=%e\n",model->VFBO);
  fprintf(stdout,"Parameter: model: VFBL=%e\n",model->VFBL);
  fprintf(stdout,"Parameter: model: VFBW=%e\n",model->VFBW);
  fprintf(stdout,"Parameter: model: VFBLW=%e\n",model->VFBLW);
  fprintf(stdout,"Parameter: model: STVFBO=%e\n",model->STVFBO);
  fprintf(stdout,"Parameter: model: STVFBL=%e\n",model->STVFBL);
  fprintf(stdout,"Parameter: model: STVFBW=%e\n",model->STVFBW);
  fprintf(stdout,"Parameter: model: STVFBLW=%e\n",model->STVFBLW);
  fprintf(stdout,"Parameter: model: TOXO=%e\n",model->TOXO);
  fprintf(stdout,"Parameter: model: EPSROXO=%e\n",model->EPSROXO);
  fprintf(stdout,"Parameter: model: NSUBO=%e\n",model->NSUBO);
  fprintf(stdout,"Parameter: model: NSUBW=%e\n",model->NSUBW);
  fprintf(stdout,"Parameter: model: WSEG=%e\n",model->WSEG);
  fprintf(stdout,"Parameter: model: NPCK=%e\n",model->NPCK);
  fprintf(stdout,"Parameter: model: NPCKW=%e\n",model->NPCKW);
  fprintf(stdout,"Parameter: model: WSEGP=%e\n",model->WSEGP);
  fprintf(stdout,"Parameter: model: LPCK=%e\n",model->LPCK);
  fprintf(stdout,"Parameter: model: LPCKW=%e\n",model->LPCKW);
  fprintf(stdout,"Parameter: model: FOL1=%e\n",model->FOL1);
  fprintf(stdout,"Parameter: model: FOL2=%e\n",model->FOL2);
  fprintf(stdout,"Parameter: model: VNSUBO=%e\n",model->VNSUBO);
  fprintf(stdout,"Parameter: model: NSLPO=%e\n",model->NSLPO);
  fprintf(stdout,"Parameter: model: DNSUBO=%e\n",model->DNSUBO);
  fprintf(stdout,"Parameter: model: DPHIBO=%e\n",model->DPHIBO);
  fprintf(stdout,"Parameter: model: DPHIBL=%e\n",model->DPHIBL);
  fprintf(stdout,"Parameter: model: DPHIBLEXP=%e\n",model->DPHIBLEXP);
  fprintf(stdout,"Parameter: model: DPHIBW=%e\n",model->DPHIBW);
  fprintf(stdout,"Parameter: model: DPHIBLW=%e\n",model->DPHIBLW);
  fprintf(stdout,"Parameter: model: NPO=%e\n",model->NPO);
  fprintf(stdout,"Parameter: model: NPL=%e\n",model->NPL);
  fprintf(stdout,"Parameter: model: CTO=%e\n",model->CTO);
  fprintf(stdout,"Parameter: model: CTL=%e\n",model->CTL);
  fprintf(stdout,"Parameter: model: CTLEXP=%e\n",model->CTLEXP);
  fprintf(stdout,"Parameter: model: CTW=%e\n",model->CTW);
  fprintf(stdout,"Parameter: model: CTLW=%e\n",model->CTLW);
  fprintf(stdout,"Parameter: model: TOXOVO=%e\n",model->TOXOVO);
  fprintf(stdout,"Parameter: model: TOXOVDO=%e\n",model->TOXOVDO);
  fprintf(stdout,"Parameter: model: LOV=%e\n",model->LOV);
  fprintf(stdout,"Parameter: model: LOVD=%e\n",model->LOVD);
  fprintf(stdout,"Parameter: model: NOVO=%e\n",model->NOVO);
  fprintf(stdout,"Parameter: model: NOVDO=%e\n",model->NOVDO);
  fprintf(stdout,"Parameter: model: CFL=%e\n",model->CFL);
  fprintf(stdout,"Parameter: model: CFLEXP=%e\n",model->CFLEXP);
  fprintf(stdout,"Parameter: model: CFW=%e\n",model->CFW);
  fprintf(stdout,"Parameter: model: CFBO=%e\n",model->CFBO);
  fprintf(stdout,"Parameter: model: UO=%e\n",model->UO);
  fprintf(stdout,"Parameter: model: FBET1=%e\n",model->FBET1);
  fprintf(stdout,"Parameter: model: FBET1W=%e\n",model->FBET1W);
  fprintf(stdout,"Parameter: model: LP1=%e\n",model->LP1);
  fprintf(stdout,"Parameter: model: LP1W=%e\n",model->LP1W);
  fprintf(stdout,"Parameter: model: FBET2=%e\n",model->FBET2);
  fprintf(stdout,"Parameter: model: LP2=%e\n",model->LP2);
  fprintf(stdout,"Parameter: model: BETW1=%e\n",model->BETW1);
  fprintf(stdout,"Parameter: model: BETW2=%e\n",model->BETW2);
  fprintf(stdout,"Parameter: model: WBET=%e\n",model->WBET);
  fprintf(stdout,"Parameter: model: STBETO=%e\n",model->STBETO);
  fprintf(stdout,"Parameter: model: STBETL=%e\n",model->STBETL);
  fprintf(stdout,"Parameter: model: STBETW=%e\n",model->STBETW);
  fprintf(stdout,"Parameter: model: STBETLW=%e\n",model->STBETLW);
  fprintf(stdout,"Parameter: model: MUEO=%e\n",model->MUEO);
  fprintf(stdout,"Parameter: model: MUEW=%e\n",model->MUEW);
  fprintf(stdout,"Parameter: model: STMUEO=%e\n",model->STMUEO);
  fprintf(stdout,"Parameter: model: THEMUO=%e\n",model->THEMUO);
  fprintf(stdout,"Parameter: model: STTHEMUO=%e\n",model->STTHEMUO);
  fprintf(stdout,"Parameter: model: CSO=%e\n",model->CSO);
  fprintf(stdout,"Parameter: model: CSL=%e\n",model->CSL);
  fprintf(stdout,"Parameter: model: CSLEXP=%e\n",model->CSLEXP);
  fprintf(stdout,"Parameter: model: CSW=%e\n",model->CSW);
  fprintf(stdout,"Parameter: model: CSLW=%e\n",model->CSLW);
  fprintf(stdout,"Parameter: model: STCSO=%e\n",model->STCSO);
  fprintf(stdout,"Parameter: model: XCORO=%e\n",model->XCORO);
  fprintf(stdout,"Parameter: model: XCORL=%e\n",model->XCORL);
  fprintf(stdout,"Parameter: model: XCORW=%e\n",model->XCORW);
  fprintf(stdout,"Parameter: model: XCORLW=%e\n",model->XCORLW);
  fprintf(stdout,"Parameter: model: STXCORO=%e\n",model->STXCORO);
  fprintf(stdout,"Parameter: model: FETAO=%e\n",model->FETAO);
  fprintf(stdout,"Parameter: model: RSW1=%e\n",model->RSW1);
  fprintf(stdout,"Parameter: model: RSW2=%e\n",model->RSW2);
  fprintf(stdout,"Parameter: model: STRSO=%e\n",model->STRSO);
  fprintf(stdout,"Parameter: model: RSBO=%e\n",model->RSBO);
  fprintf(stdout,"Parameter: model: RSGO=%e\n",model->RSGO);
  fprintf(stdout,"Parameter: model: THESATO=%e\n",model->THESATO);
  fprintf(stdout,"Parameter: model: THESATL=%e\n",model->THESATL);
  fprintf(stdout,"Parameter: model: THESATLEXP=%e\n",model->THESATLEXP);
  fprintf(stdout,"Parameter: model: THESATW=%e\n",model->THESATW);
  fprintf(stdout,"Parameter: model: THESATLW=%e\n",model->THESATLW);
  fprintf(stdout,"Parameter: model: STTHESATO=%e\n",model->STTHESATO);
  fprintf(stdout,"Parameter: model: STTHESATL=%e\n",model->STTHESATL);
  fprintf(stdout,"Parameter: model: STTHESATW=%e\n",model->STTHESATW);
  fprintf(stdout,"Parameter: model: STTHESATLW=%e\n",model->STTHESATLW);
  fprintf(stdout,"Parameter: model: THESATBO=%e\n",model->THESATBO);
  fprintf(stdout,"Parameter: model: THESATGO=%e\n",model->THESATGO);
  fprintf(stdout,"Parameter: model: AXO=%e\n",model->AXO);
  fprintf(stdout,"Parameter: model: AXL=%e\n",model->AXL);
  fprintf(stdout,"Parameter: model: ALPL=%e\n",model->ALPL);
  fprintf(stdout,"Parameter: model: ALPLEXP=%e\n",model->ALPLEXP);
  fprintf(stdout,"Parameter: model: ALPW=%e\n",model->ALPW);
  fprintf(stdout,"Parameter: model: ALP1L1=%e\n",model->ALP1L1);
  fprintf(stdout,"Parameter: model: ALP1LEXP=%e\n",model->ALP1LEXP);
  fprintf(stdout,"Parameter: model: ALP1L2=%e\n",model->ALP1L2);
  fprintf(stdout,"Parameter: model: ALP1W=%e\n",model->ALP1W);
  fprintf(stdout,"Parameter: model: ALP2L1=%e\n",model->ALP2L1);
  fprintf(stdout,"Parameter: model: ALP2LEXP=%e\n",model->ALP2LEXP);
  fprintf(stdout,"Parameter: model: ALP2L2=%e\n",model->ALP2L2);
  fprintf(stdout,"Parameter: model: ALP2W=%e\n",model->ALP2W);
  fprintf(stdout,"Parameter: model: VPO=%e\n",model->VPO);
  fprintf(stdout,"Parameter: model: A1O=%e\n",model->A1O);
  fprintf(stdout,"Parameter: model: A1L=%e\n",model->A1L);
  fprintf(stdout,"Parameter: model: A1W=%e\n",model->A1W);
  fprintf(stdout,"Parameter: model: A2O=%e\n",model->A2O);
  fprintf(stdout,"Parameter: model: STA2O=%e\n",model->STA2O);
  fprintf(stdout,"Parameter: model: A3O=%e\n",model->A3O);
  fprintf(stdout,"Parameter: model: A3L=%e\n",model->A3L);
  fprintf(stdout,"Parameter: model: A3W=%e\n",model->A3W);
  fprintf(stdout,"Parameter: model: A4O=%e\n",model->A4O);
  fprintf(stdout,"Parameter: model: A4L=%e\n",model->A4L);
  fprintf(stdout,"Parameter: model: A4W=%e\n",model->A4W);
  fprintf(stdout,"Parameter: model: GCOO=%e\n",model->GCOO);
  fprintf(stdout,"Parameter: model: IGINVLW=%e\n",model->IGINVLW);
  fprintf(stdout,"Parameter: model: IGOVW=%e\n",model->IGOVW);
  fprintf(stdout,"Parameter: model: IGOVDW=%e\n",model->IGOVDW);
  fprintf(stdout,"Parameter: model: STIGO=%e\n",model->STIGO);
  fprintf(stdout,"Parameter: model: GC2O=%e\n",model->GC2O);
  fprintf(stdout,"Parameter: model: GC3O=%e\n",model->GC3O);
  fprintf(stdout,"Parameter: model: CHIBO=%e\n",model->CHIBO);
  fprintf(stdout,"Parameter: model: AGIDLW=%e\n",model->AGIDLW);
  fprintf(stdout,"Parameter: model: AGIDLDW=%e\n",model->AGIDLDW);
  fprintf(stdout,"Parameter: model: BGIDLO=%e\n",model->BGIDLO);
  fprintf(stdout,"Parameter: model: BGIDLDO=%e\n",model->BGIDLDO);
  fprintf(stdout,"Parameter: model: STBGIDLO=%e\n",model->STBGIDLO);
  fprintf(stdout,"Parameter: model: STBGIDLDO=%e\n",model->STBGIDLDO);
  fprintf(stdout,"Parameter: model: CGIDLO=%e\n",model->CGIDLO);
  fprintf(stdout,"Parameter: model: CGIDLDO=%e\n",model->CGIDLDO);
  fprintf(stdout,"Parameter: model: CGBOVL=%e\n",model->CGBOVL);
  fprintf(stdout,"Parameter: model: CFRW=%e\n",model->CFRW);
  fprintf(stdout,"Parameter: model: CFRDW=%e\n",model->CFRDW);
  fprintf(stdout,"Parameter: model: FNTO=%e\n",model->FNTO);
  fprintf(stdout,"Parameter: model: FNTEXCL=%e\n",model->FNTEXCL);
  fprintf(stdout,"Parameter: model: NFALW=%e\n",model->NFALW);
  fprintf(stdout,"Parameter: model: NFBLW=%e\n",model->NFBLW);
  fprintf(stdout,"Parameter: model: NFCLW=%e\n",model->NFCLW);
  fprintf(stdout,"Parameter: model: EFO=%e\n",model->EFO);
  fprintf(stdout,"Parameter: model: LINTNOI=%e\n",model->LINTNOI);
  fprintf(stdout,"Parameter: model: ALPNOI=%e\n",model->ALPNOI);
  fprintf(stdout,"Parameter: model: DTA=%e\n",model->DTA);
  fprintf(stdout,"Parameter: model: KVTHOWEO=%e\n",model->KVTHOWEO);
  fprintf(stdout,"Parameter: model: KVTHOWEL=%e\n",model->KVTHOWEL);
  fprintf(stdout,"Parameter: model: KVTHOWEW=%e\n",model->KVTHOWEW);
  fprintf(stdout,"Parameter: model: KVTHOWELW=%e\n",model->KVTHOWELW);
  fprintf(stdout,"Parameter: model: KUOWEO=%e\n",model->KUOWEO);
  fprintf(stdout,"Parameter: model: KUOWEL=%e\n",model->KUOWEL);
  fprintf(stdout,"Parameter: model: KUOWEW=%e\n",model->KUOWEW);
  fprintf(stdout,"Parameter: model: KUOWELW=%e\n",model->KUOWELW);
  fprintf(stdout,"Parameter: model: RGO=%e\n",model->RGO);
  fprintf(stdout,"Parameter: model: RBULKO=%e\n",model->RBULKO);
  fprintf(stdout,"Parameter: model: RWELLO=%e\n",model->RWELLO);
  fprintf(stdout,"Parameter: model: RJUNSO=%e\n",model->RJUNSO);
  fprintf(stdout,"Parameter: model: RJUNDO=%e\n",model->RJUNDO);
  fprintf(stdout,"Parameter: model: RINT=%e\n",model->RINT);
  fprintf(stdout,"Parameter: model: RVPOLY=%e\n",model->RVPOLY);
  fprintf(stdout,"Parameter: model: RSHG=%e\n",model->RSHG);
  fprintf(stdout,"Parameter: model: DLSIL=%e\n",model->DLSIL);
  fprintf(stdout,"Parameter: model: SAREF=%e\n",model->SAREF);
  fprintf(stdout,"Parameter: model: SBREF=%e\n",model->SBREF);
  fprintf(stdout,"Parameter: model: WLOD=%e\n",model->WLOD);
  fprintf(stdout,"Parameter: model: KUO=%e\n",model->KUO);
  fprintf(stdout,"Parameter: model: KVSAT=%e\n",model->KVSAT);
  fprintf(stdout,"Parameter: model: TKUO=%e\n",model->TKUO);
  fprintf(stdout,"Parameter: model: LKUO=%e\n",model->LKUO);
  fprintf(stdout,"Parameter: model: WKUO=%e\n",model->WKUO);
  fprintf(stdout,"Parameter: model: PKUO=%e\n",model->PKUO);
  fprintf(stdout,"Parameter: model: LLODKUO=%e\n",model->LLODKUO);
  fprintf(stdout,"Parameter: model: WLODKUO=%e\n",model->WLODKUO);
  fprintf(stdout,"Parameter: model: KVTHO=%e\n",model->KVTHO);
  fprintf(stdout,"Parameter: model: LKVTHO=%e\n",model->LKVTHO);
  fprintf(stdout,"Parameter: model: WKVTHO=%e\n",model->WKVTHO);
  fprintf(stdout,"Parameter: model: PKVTHO=%e\n",model->PKVTHO);
  fprintf(stdout,"Parameter: model: LLODVTH=%e\n",model->LLODVTH);
  fprintf(stdout,"Parameter: model: WLODVTH=%e\n",model->WLODVTH);
  fprintf(stdout,"Parameter: model: STETAO=%e\n",model->STETAO);
  fprintf(stdout,"Parameter: model: LODETAO=%e\n",model->LODETAO);
  fprintf(stdout,"Parameter: model: SCREF=%e\n",model->SCREF);
  fprintf(stdout,"Parameter: model: WEB=%e\n",model->WEB);
  fprintf(stdout,"Parameter: model: WEC=%e\n",model->WEC);
  fprintf(stdout,"Parameter: model: IMAX=%e\n",model->IMAX);
  fprintf(stdout,"Parameter: model: TRJ=%e\n",model->TRJ);
  fprintf(stdout,"Parameter: model: CJORBOT=%e\n",model->CJORBOT);
  fprintf(stdout,"Parameter: model: CJORSTI=%e\n",model->CJORSTI);
  fprintf(stdout,"Parameter: model: CJORGAT=%e\n",model->CJORGAT);
  fprintf(stdout,"Parameter: model: VBIRBOT=%e\n",model->VBIRBOT);
  fprintf(stdout,"Parameter: model: VBIRSTI=%e\n",model->VBIRSTI);
  fprintf(stdout,"Parameter: model: VBIRGAT=%e\n",model->VBIRGAT);
  fprintf(stdout,"Parameter: model: PBOT=%e\n",model->PBOT);
  fprintf(stdout,"Parameter: model: PSTI=%e\n",model->PSTI);
  fprintf(stdout,"Parameter: model: PGAT=%e\n",model->PGAT);
  fprintf(stdout,"Parameter: model: PHIGBOT=%e\n",model->PHIGBOT);
  fprintf(stdout,"Parameter: model: PHIGSTI=%e\n",model->PHIGSTI);
  fprintf(stdout,"Parameter: model: PHIGGAT=%e\n",model->PHIGGAT);
  fprintf(stdout,"Parameter: model: IDSATRBOT=%e\n",model->IDSATRBOT);
  fprintf(stdout,"Parameter: model: IDSATRSTI=%e\n",model->IDSATRSTI);
  fprintf(stdout,"Parameter: model: IDSATRGAT=%e\n",model->IDSATRGAT);
  fprintf(stdout,"Parameter: model: CSRHBOT=%e\n",model->CSRHBOT);
  fprintf(stdout,"Parameter: model: CSRHSTI=%e\n",model->CSRHSTI);
  fprintf(stdout,"Parameter: model: CSRHGAT=%e\n",model->CSRHGAT);
  fprintf(stdout,"Parameter: model: XJUNSTI=%e\n",model->XJUNSTI);
  fprintf(stdout,"Parameter: model: XJUNGAT=%e\n",model->XJUNGAT);
  fprintf(stdout,"Parameter: model: CTATBOT=%e\n",model->CTATBOT);
  fprintf(stdout,"Parameter: model: CTATSTI=%e\n",model->CTATSTI);
  fprintf(stdout,"Parameter: model: CTATGAT=%e\n",model->CTATGAT);
  fprintf(stdout,"Parameter: model: MEFFTATBOT=%e\n",model->MEFFTATBOT);
  fprintf(stdout,"Parameter: model: MEFFTATSTI=%e\n",model->MEFFTATSTI);
  fprintf(stdout,"Parameter: model: MEFFTATGAT=%e\n",model->MEFFTATGAT);
  fprintf(stdout,"Parameter: model: CBBTBOT=%e\n",model->CBBTBOT);
  fprintf(stdout,"Parameter: model: CBBTSTI=%e\n",model->CBBTSTI);
  fprintf(stdout,"Parameter: model: CBBTGAT=%e\n",model->CBBTGAT);
  fprintf(stdout,"Parameter: model: FBBTRBOT=%e\n",model->FBBTRBOT);
  fprintf(stdout,"Parameter: model: FBBTRSTI=%e\n",model->FBBTRSTI);
  fprintf(stdout,"Parameter: model: FBBTRGAT=%e\n",model->FBBTRGAT);
  fprintf(stdout,"Parameter: model: STFBBTBOT=%e\n",model->STFBBTBOT);
  fprintf(stdout,"Parameter: model: STFBBTSTI=%e\n",model->STFBBTSTI);
  fprintf(stdout,"Parameter: model: STFBBTGAT=%e\n",model->STFBBTGAT);
  fprintf(stdout,"Parameter: model: VBRBOT=%e\n",model->VBRBOT);
  fprintf(stdout,"Parameter: model: VBRSTI=%e\n",model->VBRSTI);
  fprintf(stdout,"Parameter: model: VBRGAT=%e\n",model->VBRGAT);
  fprintf(stdout,"Parameter: model: PBRBOT=%e\n",model->PBRBOT);
  fprintf(stdout,"Parameter: model: PBRSTI=%e\n",model->PBRSTI);
  fprintf(stdout,"Parameter: model: PBRGAT=%e\n",model->PBRGAT);
  fprintf(stdout,"Parameter: model: CJORBOTD=%e\n",model->CJORBOTD);
  fprintf(stdout,"Parameter: model: CJORSTID=%e\n",model->CJORSTID);
  fprintf(stdout,"Parameter: model: CJORGATD=%e\n",model->CJORGATD);
  fprintf(stdout,"Parameter: model: VBIRBOTD=%e\n",model->VBIRBOTD);
  fprintf(stdout,"Parameter: model: VBIRSTID=%e\n",model->VBIRSTID);
  fprintf(stdout,"Parameter: model: VBIRGATD=%e\n",model->VBIRGATD);
  fprintf(stdout,"Parameter: model: PBOTD=%e\n",model->PBOTD);
  fprintf(stdout,"Parameter: model: PSTID=%e\n",model->PSTID);
  fprintf(stdout,"Parameter: model: PGATD=%e\n",model->PGATD);
  fprintf(stdout,"Parameter: model: PHIGBOTD=%e\n",model->PHIGBOTD);
  fprintf(stdout,"Parameter: model: PHIGSTID=%e\n",model->PHIGSTID);
  fprintf(stdout,"Parameter: model: PHIGGATD=%e\n",model->PHIGGATD);
  fprintf(stdout,"Parameter: model: IDSATRBOTD=%e\n",model->IDSATRBOTD);
  fprintf(stdout,"Parameter: model: IDSATRSTID=%e\n",model->IDSATRSTID);
  fprintf(stdout,"Parameter: model: IDSATRGATD=%e\n",model->IDSATRGATD);
  fprintf(stdout,"Parameter: model: CSRHBOTD=%e\n",model->CSRHBOTD);
  fprintf(stdout,"Parameter: model: CSRHSTID=%e\n",model->CSRHSTID);
  fprintf(stdout,"Parameter: model: CSRHGATD=%e\n",model->CSRHGATD);
  fprintf(stdout,"Parameter: model: XJUNSTID=%e\n",model->XJUNSTID);
  fprintf(stdout,"Parameter: model: XJUNGATD=%e\n",model->XJUNGATD);
  fprintf(stdout,"Parameter: model: CTATBOTD=%e\n",model->CTATBOTD);
  fprintf(stdout,"Parameter: model: CTATSTID=%e\n",model->CTATSTID);
  fprintf(stdout,"Parameter: model: CTATGATD=%e\n",model->CTATGATD);
  fprintf(stdout,"Parameter: model: MEFFTATBOTD=%e\n",model->MEFFTATBOTD);
  fprintf(stdout,"Parameter: model: MEFFTATSTID=%e\n",model->MEFFTATSTID);
  fprintf(stdout,"Parameter: model: MEFFTATGATD=%e\n",model->MEFFTATGATD);
  fprintf(stdout,"Parameter: model: CBBTBOTD=%e\n",model->CBBTBOTD);
  fprintf(stdout,"Parameter: model: CBBTSTID=%e\n",model->CBBTSTID);
  fprintf(stdout,"Parameter: model: CBBTGATD=%e\n",model->CBBTGATD);
  fprintf(stdout,"Parameter: model: FBBTRBOTD=%e\n",model->FBBTRBOTD);
  fprintf(stdout,"Parameter: model: FBBTRSTID=%e\n",model->FBBTRSTID);
  fprintf(stdout,"Parameter: model: FBBTRGATD=%e\n",model->FBBTRGATD);
  fprintf(stdout,"Parameter: model: STFBBTBOTD=%e\n",model->STFBBTBOTD);
  fprintf(stdout,"Parameter: model: STFBBTSTID=%e\n",model->STFBBTSTID);
  fprintf(stdout,"Parameter: model: STFBBTGATD=%e\n",model->STFBBTGATD);
  fprintf(stdout,"Parameter: model: VBRBOTD=%e\n",model->VBRBOTD);
  fprintf(stdout,"Parameter: model: VBRSTID=%e\n",model->VBRSTID);
  fprintf(stdout,"Parameter: model: VBRGATD=%e\n",model->VBRGATD);
  fprintf(stdout,"Parameter: model: PBRBOTD=%e\n",model->PBRBOTD);
  fprintf(stdout,"Parameter: model: PBRSTID=%e\n",model->PBRSTID);
  fprintf(stdout,"Parameter: model: PBRGATD=%e\n",model->PBRGATD);
  fprintf(stdout,"Parameter: model: SWJUNEXP=%e\n",model->SWJUNEXP);
  fprintf(stdout,"Parameter: model: VJUNREF=%e\n",model->VJUNREF);
  fprintf(stdout,"Parameter: model: FJUNQ=%e\n",model->FJUNQ);
  fprintf(stdout,"Parameter: model: VJUNREFD=%e\n",model->VJUNREFD);
  fprintf(stdout,"Parameter: model: FJUNQD=%e\n",model->FJUNQD);
  fprintf(stdout,"Parameter: instance: L=%e\n",here->L);
  fprintf(stdout,"Parameter: instance: W=%e\n",here->W);
  fprintf(stdout,"Parameter: instance: SA=%e\n",here->SA);
  fprintf(stdout,"Parameter: instance: SB=%e\n",here->SB);
  fprintf(stdout,"Parameter: instance: SD=%e\n",here->SD);
  fprintf(stdout,"Parameter: instance: SCA=%e\n",here->SCA);
  fprintf(stdout,"Parameter: instance: SCB=%e\n",here->SCB);
  fprintf(stdout,"Parameter: instance: SCC=%e\n",here->SCC);
  fprintf(stdout,"Parameter: instance: SC=%e\n",here->SC);
  fprintf(stdout,"Parameter: instance: DELVTO=%e\n",here->DELVTO);
  fprintf(stdout,"Parameter: instance: FACTUO=%e\n",here->FACTUO);
  fprintf(stdout,"Parameter: instance: ABSOURCE=%e\n",here->ABSOURCE);
  fprintf(stdout,"Parameter: instance: LSSOURCE=%e\n",here->LSSOURCE);
  fprintf(stdout,"Parameter: instance: LGSOURCE=%e\n",here->LGSOURCE);
  fprintf(stdout,"Parameter: instance: ABDRAIN=%e\n",here->ABDRAIN);
  fprintf(stdout,"Parameter: instance: LSDRAIN=%e\n",here->LSDRAIN);
  fprintf(stdout,"Parameter: instance: LGDRAIN=%e\n",here->LGDRAIN);
  fprintf(stdout,"Parameter: instance: AS=%e\n",here->AS);
  fprintf(stdout,"Parameter: instance: PS=%e\n",here->PS);
  fprintf(stdout,"Parameter: instance: AD=%e\n",here->AD);
  fprintf(stdout,"Parameter: instance: PD=%e\n",here->PD);
  fprintf(stdout,"Parameter: instance: MULT=%e\n",here->MULT);
  fprintf(stdout,"Parameter: instance: NF=%e\n",here->NF);
  fprintf(stdout,"Parameter: instance: NGCON=%e\n",here->NGCON);
  fprintf(stdout,"Parameter: instance: XGW=%e\n",here->XGW);
  fprintf(stdout,"model: NSUBO_i=%e\n",model->NSUBO_i);
  fprintf(stdout,"model: WSEG_i=%e\n",model->WSEG_i);
  fprintf(stdout,"model: NPCK_i=%e\n",model->NPCK_i);
  fprintf(stdout,"model: WSEGP_i=%e\n",model->WSEGP_i);
  fprintf(stdout,"model: LPCK_i=%e\n",model->LPCK_i);
  fprintf(stdout,"model: LOV_i=%e\n",model->LOV_i);
  fprintf(stdout,"model: LOVD_i=%e\n",model->LOVD_i);
  fprintf(stdout,"model: LP1_i=%e\n",model->LP1_i);
  fprintf(stdout,"model: LP2_i=%e\n",model->LP2_i);
  fprintf(stdout,"model: WBET_i=%e\n",model->WBET_i);
  fprintf(stdout,"model: AXL_i=%e\n",model->AXL_i);
  fprintf(stdout,"model: ALP1L2_i=%e\n",model->ALP1L2_i);
  fprintf(stdout,"model: ALP2L2_i=%e\n",model->ALP2L2_i);
  fprintf(stdout,"model: RINT_i=%e\n",model->RINT_i);
  fprintf(stdout,"model: RVPOLY_i=%e\n",model->RVPOLY_i);
  fprintf(stdout,"model: SAREF_i=%e\n",model->SAREF_i);
  fprintf(stdout,"model: SBREF_i=%e\n",model->SBREF_i);
  fprintf(stdout,"model: KVSAT_i=%e\n",model->KVSAT_i);
  fprintf(stdout,"model: LLODKUO_i=%e\n",model->LLODKUO_i);
  fprintf(stdout,"model: WLODKUO_i=%e\n",model->WLODKUO_i);
  fprintf(stdout,"model: LLODVTH_i=%e\n",model->LLODVTH_i);
  fprintf(stdout,"model: WLODVTH_i=%e\n",model->WLODVTH_i);
  fprintf(stdout,"model: LODETAO_i=%e\n",model->LODETAO_i);
  fprintf(stdout,"model: SCREF_i=%e\n",model->SCREF_i);
  fprintf(stdout,"model: WEB_i=%e\n",model->WEB_i);
  fprintf(stdout,"model: WEC_i=%e\n",model->WEC_i);
  fprintf(stdout,"model: TOX_i=%e\n",model->TOX_i);
  fprintf(stdout,"model: EPSROX_i=%e\n",model->EPSROX_i);
  fprintf(stdout,"model: TOXOV_i=%e\n",model->TOXOV_i);
  fprintf(stdout,"model: TOXOVD_i=%e\n",model->TOXOVD_i);
  fprintf(stdout,"model: TKD=%e\n",model->TKD);
  fprintf(stdout,"model: dT=%e\n",model->dT);
  fprintf(stdout,"model: rT=%e\n",model->rT);
  fprintf(stdout,"model: rTn=%e\n",model->rTn);
  fprintf(stdout,"model: EPSSI=%e\n",model->EPSSI);
  fprintf(stdout,"model: phit=%e\n",model->phit);
  fprintf(stdout,"model: inv_phit=%e\n",model->inv_phit);
  fprintf(stdout,"model: Eg=%e\n",model->Eg);
  fprintf(stdout,"model: phibFac=%e\n",model->phibFac);
  fprintf(stdout,"model: nt0=%e\n",model->nt0);
  fprintf(stdout,"model: CHNL_TYPE=%i\n",model->CHNL_TYPE);
  fprintf(stdout,"model: IMAX_i=%e\n",model->IMAX_i);
  fprintf(stdout,"model: VBIRBOT_i=%e\n",model->VBIRBOT_i);
  fprintf(stdout,"model: VBIRSTI_i=%e\n",model->VBIRSTI_i);
  fprintf(stdout,"model: VBIRGAT_i=%e\n",model->VBIRGAT_i);
  fprintf(stdout,"model: PBOT_i=%e\n",model->PBOT_i);
  fprintf(stdout,"model: PSTI_i=%e\n",model->PSTI_i);
  fprintf(stdout,"model: PGAT_i=%e\n",model->PGAT_i);
  fprintf(stdout,"model: CSRHBOT_i=%e\n",model->CSRHBOT_i);
  fprintf(stdout,"model: CSRHSTI_i=%e\n",model->CSRHSTI_i);
  fprintf(stdout,"model: CSRHGAT_i=%e\n",model->CSRHGAT_i);
  fprintf(stdout,"model: CTATBOT_i=%e\n",model->CTATBOT_i);
  fprintf(stdout,"model: CTATSTI_i=%e\n",model->CTATSTI_i);
  fprintf(stdout,"model: CTATGAT_i=%e\n",model->CTATGAT_i);
  fprintf(stdout,"model: CBBTBOT_i=%e\n",model->CBBTBOT_i);
  fprintf(stdout,"model: CBBTSTI_i=%e\n",model->CBBTSTI_i);
  fprintf(stdout,"model: CBBTGAT_i=%e\n",model->CBBTGAT_i);
  fprintf(stdout,"model: VBRBOT_i=%e\n",model->VBRBOT_i);
  fprintf(stdout,"model: VBRSTI_i=%e\n",model->VBRSTI_i);
  fprintf(stdout,"model: VBRGAT_i=%e\n",model->VBRGAT_i);
  fprintf(stdout,"model: PBRBOT_i=%e\n",model->PBRBOT_i);
  fprintf(stdout,"model: PBRSTI_i=%e\n",model->PBRSTI_i);
  fprintf(stdout,"model: PBRGAT_i=%e\n",model->PBRGAT_i);
  fprintf(stdout,"model: SWJUNEXP_i=%e\n",model->SWJUNEXP_i);
  fprintf(stdout,"model: VJUNREF_i=%e\n",model->VJUNREF_i);
  fprintf(stdout,"model: FJUNQ_i=%e\n",model->FJUNQ_i);
  fprintf(stdout,"model: phitr=%e\n",model->phitr);
  fprintf(stdout,"model: phitd=%e\n",model->phitd);
  fprintf(stdout,"model: phitdinv=%e\n",model->phitdinv);
  fprintf(stdout,"model: perfc=%e\n",model->perfc);
  fprintf(stdout,"model: berfc=%e\n",model->berfc);
  fprintf(stdout,"model: cerfc=%e\n",model->cerfc);
  fprintf(stdout,"model: ftdbot=%e\n",model->ftdbot);
  fprintf(stdout,"model: ftdsti=%e\n",model->ftdsti);
  fprintf(stdout,"model: ftdgat=%e\n",model->ftdgat);
  fprintf(stdout,"model: idsatbot=%e\n",model->idsatbot);
  fprintf(stdout,"model: idsatsti=%e\n",model->idsatsti);
  fprintf(stdout,"model: idsatgat=%e\n",model->idsatgat);
  fprintf(stdout,"model: vbibot=%e\n",model->vbibot);
  fprintf(stdout,"model: vbisti=%e\n",model->vbisti);
  fprintf(stdout,"model: vbigat=%e\n",model->vbigat);
  fprintf(stdout,"model: vbiinvbot=%e\n",model->vbiinvbot);
  fprintf(stdout,"model: vbiinvsti=%e\n",model->vbiinvsti);
  fprintf(stdout,"model: vbiinvgat=%e\n",model->vbiinvgat);
  fprintf(stdout,"model: one_minus_PBOT=%e\n",model->one_minus_PBOT);
  fprintf(stdout,"model: one_minus_PSTI=%e\n",model->one_minus_PSTI);
  fprintf(stdout,"model: one_minus_PGAT=%e\n",model->one_minus_PGAT);
  fprintf(stdout,"model: one_over_one_minus_PBOT=%e\n",model->one_over_one_minus_PBOT);
  fprintf(stdout,"model: one_over_one_minus_PSTI=%e\n",model->one_over_one_minus_PSTI);
  fprintf(stdout,"model: one_over_one_minus_PGAT=%e\n",model->one_over_one_minus_PGAT);
  fprintf(stdout,"model: cjobot=%e\n",model->cjobot);
  fprintf(stdout,"model: cjosti=%e\n",model->cjosti);
  fprintf(stdout,"model: cjogat=%e\n",model->cjogat);
  fprintf(stdout,"model: qprefbot=%e\n",model->qprefbot);
  fprintf(stdout,"model: qprefsti=%e\n",model->qprefsti);
  fprintf(stdout,"model: qprefgat=%e\n",model->qprefgat);
  fprintf(stdout,"model: qpref2bot=%e\n",model->qpref2bot);
  fprintf(stdout,"model: qpref2sti=%e\n",model->qpref2sti);
  fprintf(stdout,"model: qpref2gat=%e\n",model->qpref2gat);
  fprintf(stdout,"model: wdepnulrbot=%e\n",model->wdepnulrbot);
  fprintf(stdout,"model: wdepnulrsti=%e\n",model->wdepnulrsti);
  fprintf(stdout,"model: wdepnulrgat=%e\n",model->wdepnulrgat);
  fprintf(stdout,"model: wdepnulrinvbot=%e\n",model->wdepnulrinvbot);
  fprintf(stdout,"model: wdepnulrinvsti=%e\n",model->wdepnulrinvsti);
  fprintf(stdout,"model: wdepnulrinvgat=%e\n",model->wdepnulrinvgat);
  fprintf(stdout,"model: VBIRBOTinv=%e\n",model->VBIRBOTinv);
  fprintf(stdout,"model: VBIRSTIinv=%e\n",model->VBIRSTIinv);
  fprintf(stdout,"model: VBIRGATinv=%e\n",model->VBIRGATinv);
  fprintf(stdout,"model: atatbot=%e\n",model->atatbot);
  fprintf(stdout,"model: atatsti=%e\n",model->atatsti);
  fprintf(stdout,"model: atatgat=%e\n",model->atatgat);
  fprintf(stdout,"model: btatpartbot=%e\n",model->btatpartbot);
  fprintf(stdout,"model: btatpartsti=%e\n",model->btatpartsti);
  fprintf(stdout,"model: btatpartgat=%e\n",model->btatpartgat);
  fprintf(stdout,"model: fbbtbot=%e\n",model->fbbtbot);
  fprintf(stdout,"model: fbbtsti=%e\n",model->fbbtsti);
  fprintf(stdout,"model: fbbtgat=%e\n",model->fbbtgat);
  fprintf(stdout,"model: fstopbot=%e\n",model->fstopbot);
  fprintf(stdout,"model: fstopsti=%e\n",model->fstopsti);
  fprintf(stdout,"model: fstopgat=%e\n",model->fstopgat);
  fprintf(stdout,"model: VBRinvbot=%e\n",model->VBRinvbot);
  fprintf(stdout,"model: VBRinvsti=%e\n",model->VBRinvsti);
  fprintf(stdout,"model: VBRinvgat=%e\n",model->VBRinvgat);
  fprintf(stdout,"model: slopebot=%e\n",model->slopebot);
  fprintf(stdout,"model: slopesti=%e\n",model->slopesti);
  fprintf(stdout,"model: slopegat=%e\n",model->slopegat);
  fprintf(stdout,"model: VBIRBOTD_i=%e\n",model->VBIRBOTD_i);
  fprintf(stdout,"model: VBIRSTID_i=%e\n",model->VBIRSTID_i);
  fprintf(stdout,"model: VBIRGATD_i=%e\n",model->VBIRGATD_i);
  fprintf(stdout,"model: PBOTD_i=%e\n",model->PBOTD_i);
  fprintf(stdout,"model: PSTID_i=%e\n",model->PSTID_i);
  fprintf(stdout,"model: PGATD_i=%e\n",model->PGATD_i);
  fprintf(stdout,"model: CSRHBOTD_i=%e\n",model->CSRHBOTD_i);
  fprintf(stdout,"model: CSRHSTID_i=%e\n",model->CSRHSTID_i);
  fprintf(stdout,"model: CSRHGATD_i=%e\n",model->CSRHGATD_i);
  fprintf(stdout,"model: CTATBOTD_i=%e\n",model->CTATBOTD_i);
  fprintf(stdout,"model: CTATSTID_i=%e\n",model->CTATSTID_i);
  fprintf(stdout,"model: CTATGATD_i=%e\n",model->CTATGATD_i);
  fprintf(stdout,"model: CBBTBOTD_i=%e\n",model->CBBTBOTD_i);
  fprintf(stdout,"model: CBBTSTID_i=%e\n",model->CBBTSTID_i);
  fprintf(stdout,"model: CBBTGATD_i=%e\n",model->CBBTGATD_i);
  fprintf(stdout,"model: VBRBOTD_i=%e\n",model->VBRBOTD_i);
  fprintf(stdout,"model: VBRSTID_i=%e\n",model->VBRSTID_i);
  fprintf(stdout,"model: VBRGATD_i=%e\n",model->VBRGATD_i);
  fprintf(stdout,"model: PBRBOTD_i=%e\n",model->PBRBOTD_i);
  fprintf(stdout,"model: PBRSTID_i=%e\n",model->PBRSTID_i);
  fprintf(stdout,"model: PBRGATD_i=%e\n",model->PBRGATD_i);
  fprintf(stdout,"model: VJUNREFD_i=%e\n",model->VJUNREFD_i);
  fprintf(stdout,"model: FJUNQD_i=%e\n",model->FJUNQD_i);
  fprintf(stdout,"model: ftdbot_d=%e\n",model->ftdbot_d);
  fprintf(stdout,"model: ftdsti_d=%e\n",model->ftdsti_d);
  fprintf(stdout,"model: ftdgat_d=%e\n",model->ftdgat_d);
  fprintf(stdout,"model: idsatbot_d=%e\n",model->idsatbot_d);
  fprintf(stdout,"model: idsatsti_d=%e\n",model->idsatsti_d);
  fprintf(stdout,"model: idsatgat_d=%e\n",model->idsatgat_d);
  fprintf(stdout,"model: vbibot_d=%e\n",model->vbibot_d);
  fprintf(stdout,"model: vbisti_d=%e\n",model->vbisti_d);
  fprintf(stdout,"model: vbigat_d=%e\n",model->vbigat_d);
  fprintf(stdout,"model: vbiinvbot_d=%e\n",model->vbiinvbot_d);
  fprintf(stdout,"model: vbiinvsti_d=%e\n",model->vbiinvsti_d);
  fprintf(stdout,"model: vbiinvgat_d=%e\n",model->vbiinvgat_d);
  fprintf(stdout,"model: one_minus_PBOT_d=%e\n",model->one_minus_PBOT_d);
  fprintf(stdout,"model: one_minus_PSTI_d=%e\n",model->one_minus_PSTI_d);
  fprintf(stdout,"model: one_minus_PGAT_d=%e\n",model->one_minus_PGAT_d);
  fprintf(stdout,"model: one_over_one_minus_PBOT_d=%e\n",model->one_over_one_minus_PBOT_d);
  fprintf(stdout,"model: one_over_one_minus_PSTI_d=%e\n",model->one_over_one_minus_PSTI_d);
  fprintf(stdout,"model: one_over_one_minus_PGAT_d=%e\n",model->one_over_one_minus_PGAT_d);
  fprintf(stdout,"model: cjobot_d=%e\n",model->cjobot_d);
  fprintf(stdout,"model: cjosti_d=%e\n",model->cjosti_d);
  fprintf(stdout,"model: cjogat_d=%e\n",model->cjogat_d);
  fprintf(stdout,"model: qprefbot_d=%e\n",model->qprefbot_d);
  fprintf(stdout,"model: qprefsti_d=%e\n",model->qprefsti_d);
  fprintf(stdout,"model: qprefgat_d=%e\n",model->qprefgat_d);
  fprintf(stdout,"model: qpref2bot_d=%e\n",model->qpref2bot_d);
  fprintf(stdout,"model: qpref2sti_d=%e\n",model->qpref2sti_d);
  fprintf(stdout,"model: qpref2gat_d=%e\n",model->qpref2gat_d);
  fprintf(stdout,"model: wdepnulrbot_d=%e\n",model->wdepnulrbot_d);
  fprintf(stdout,"model: wdepnulrsti_d=%e\n",model->wdepnulrsti_d);
  fprintf(stdout,"model: wdepnulrgat_d=%e\n",model->wdepnulrgat_d);
  fprintf(stdout,"model: wdepnulrinvbot_d=%e\n",model->wdepnulrinvbot_d);
  fprintf(stdout,"model: wdepnulrinvsti_d=%e\n",model->wdepnulrinvsti_d);
  fprintf(stdout,"model: wdepnulrinvgat_d=%e\n",model->wdepnulrinvgat_d);
  fprintf(stdout,"model: VBIRBOTinv_d=%e\n",model->VBIRBOTinv_d);
  fprintf(stdout,"model: VBIRSTIinv_d=%e\n",model->VBIRSTIinv_d);
  fprintf(stdout,"model: VBIRGATinv_d=%e\n",model->VBIRGATinv_d);
  fprintf(stdout,"model: atatbot_d=%e\n",model->atatbot_d);
  fprintf(stdout,"model: atatsti_d=%e\n",model->atatsti_d);
  fprintf(stdout,"model: atatgat_d=%e\n",model->atatgat_d);
  fprintf(stdout,"model: btatpartbot_d=%e\n",model->btatpartbot_d);
  fprintf(stdout,"model: btatpartsti_d=%e\n",model->btatpartsti_d);
  fprintf(stdout,"model: btatpartgat_d=%e\n",model->btatpartgat_d);
  fprintf(stdout,"model: fbbtbot_d=%e\n",model->fbbtbot_d);
  fprintf(stdout,"model: fbbtsti_d=%e\n",model->fbbtsti_d);
  fprintf(stdout,"model: fbbtgat_d=%e\n",model->fbbtgat_d);
  fprintf(stdout,"model: fstopbot_d=%e\n",model->fstopbot_d);
  fprintf(stdout,"model: fstopsti_d=%e\n",model->fstopsti_d);
  fprintf(stdout,"model: fstopgat_d=%e\n",model->fstopgat_d);
  fprintf(stdout,"model: VBRinvbot_d=%e\n",model->VBRinvbot_d);
  fprintf(stdout,"model: VBRinvsti_d=%e\n",model->VBRinvsti_d);
  fprintf(stdout,"model: VBRinvgat_d=%e\n",model->VBRinvgat_d);
  fprintf(stdout,"model: slopebot_d=%e\n",model->slopebot_d);
  fprintf(stdout,"model: slopesti_d=%e\n",model->slopesti_d);
  fprintf(stdout,"model: slopegat_d=%e\n",model->slopegat_d);
  fprintf(stdout,"instance: LE=%e\n",here->LE);
  fprintf(stdout,"instance: WE=%e\n",here->WE);
  fprintf(stdout,"instance: VFB_i=%e\n",here->VFB_i);
  fprintf(stdout,"instance: STVFB_i=%e\n",here->STVFB_i);
  fprintf(stdout,"instance: NEFF_i=%e\n",here->NEFF_i);
  fprintf(stdout,"instance: VNSUB_i=%e\n",here->VNSUB_i);
  fprintf(stdout,"instance: NSLP_i=%e\n",here->NSLP_i);
  fprintf(stdout,"instance: DNSUB_i=%e\n",here->DNSUB_i);
  fprintf(stdout,"instance: NP_i=%e\n",here->NP_i);
  fprintf(stdout,"instance: CT_i=%e\n",here->CT_i);
  fprintf(stdout,"instance: NOV_i=%e\n",here->NOV_i);
  fprintf(stdout,"instance: NOVD_i=%e\n",here->NOVD_i);
  fprintf(stdout,"instance: CF_i=%e\n",here->CF_i);
  fprintf(stdout,"instance: CFB_i=%e\n",here->CFB_i);
  fprintf(stdout,"instance: DPHIB_i=%e\n",here->DPHIB_i);
  fprintf(stdout,"instance: BETN_i=%e\n",here->BETN_i);
  fprintf(stdout,"instance: STBET_i=%e\n",here->STBET_i);
  fprintf(stdout,"instance: MUE_i=%e\n",here->MUE_i);
  fprintf(stdout,"instance: STMUE_i=%e\n",here->STMUE_i);
  fprintf(stdout,"instance: THEMU_i=%e\n",here->THEMU_i);
  fprintf(stdout,"instance: STTHEMU_i=%e\n",here->STTHEMU_i);
  fprintf(stdout,"instance: CS_i=%e\n",here->CS_i);
  fprintf(stdout,"instance: STCS_i=%e\n",here->STCS_i);
  fprintf(stdout,"instance: XCOR_i=%e\n",here->XCOR_i);
  fprintf(stdout,"instance: STXCOR_i=%e\n",here->STXCOR_i);
  fprintf(stdout,"instance: FETA_i=%e\n",here->FETA_i);
  fprintf(stdout,"instance: RS_i=%e\n",here->RS_i);
  fprintf(stdout,"instance: THER_i=%e\n",here->THER_i);
  fprintf(stdout,"instance: STRS_i=%e\n",here->STRS_i);
  fprintf(stdout,"instance: RSB_i=%e\n",here->RSB_i);
  fprintf(stdout,"instance: RSG_i=%e\n",here->RSG_i);
  fprintf(stdout,"instance: THESAT_i=%e\n",here->THESAT_i);
  fprintf(stdout,"instance: STTHESAT_i=%e\n",here->STTHESAT_i);
  fprintf(stdout,"instance: THESATB_i=%e\n",here->THESATB_i);
  fprintf(stdout,"instance: THESATG_i=%e\n",here->THESATG_i);
  fprintf(stdout,"instance: AX_i=%e\n",here->AX_i);
  fprintf(stdout,"instance: ALP_i=%e\n",here->ALP_i);
  fprintf(stdout,"instance: ALP1_i=%e\n",here->ALP1_i);
  fprintf(stdout,"instance: ALP2_i=%e\n",here->ALP2_i);
  fprintf(stdout,"instance: VP_i=%e\n",here->VP_i);
  fprintf(stdout,"instance: A1_i=%e\n",here->A1_i);
  fprintf(stdout,"instance: A2_i=%e\n",here->A2_i);
  fprintf(stdout,"instance: STA2_i=%e\n",here->STA2_i);
  fprintf(stdout,"instance: A3_i=%e\n",here->A3_i);
  fprintf(stdout,"instance: A4_i=%e\n",here->A4_i);
  fprintf(stdout,"instance: GCO_i=%e\n",here->GCO_i);
  fprintf(stdout,"instance: IGINV_i=%e\n",here->IGINV_i);
  fprintf(stdout,"instance: IGOV_i=%e\n",here->IGOV_i);
  fprintf(stdout,"instance: IGOVD_i=%e\n",here->IGOVD_i);
  fprintf(stdout,"instance: STIG_i=%e\n",here->STIG_i);
  fprintf(stdout,"instance: GC2_i=%e\n",here->GC2_i);
  fprintf(stdout,"instance: GC3_i=%e\n",here->GC3_i);
  fprintf(stdout,"instance: CHIB_i=%e\n",here->CHIB_i);
  fprintf(stdout,"instance: AGIDL_i=%e\n",here->AGIDL_i);
  fprintf(stdout,"instance: STBGIDL_i=%e\n",here->STBGIDL_i);
  fprintf(stdout,"instance: CGIDL_i=%e\n",here->CGIDL_i);
  fprintf(stdout,"instance: AGIDLD_i=%e\n",here->AGIDLD_i);
  fprintf(stdout,"instance: STBGIDLD_i=%e\n",here->STBGIDLD_i);
  fprintf(stdout,"instance: CGIDLD_i=%e\n",here->CGIDLD_i);
  fprintf(stdout,"instance: COX_i=%e\n",here->COX_i);
  fprintf(stdout,"instance: CGOV_i=%e\n",here->CGOV_i);
  fprintf(stdout,"instance: CGOVD_i=%e\n",here->CGOVD_i);
  fprintf(stdout,"instance: CGBOV_i=%e\n",here->CGBOV_i);
  fprintf(stdout,"instance: CFR_i=%e\n",here->CFR_i);
  fprintf(stdout,"instance: CFRD_i=%e\n",here->CFRD_i);
  fprintf(stdout,"instance: FNT_i=%e\n",here->FNT_i);
  fprintf(stdout,"instance: NFA_i=%e\n",here->NFA_i);
  fprintf(stdout,"instance: NFB_i=%e\n",here->NFB_i);
  fprintf(stdout,"instance: NFC_i=%e\n",here->NFC_i);
  fprintf(stdout,"instance: EF_i=%e\n",here->EF_i);
  fprintf(stdout,"instance: FNTEXC_i=%e\n",here->FNTEXC_i);
  fprintf(stdout,"instance: MULT_i=%e\n",here->MULT_i);
  fprintf(stdout,"instance: BET_i=%e\n",here->BET_i);
  fprintf(stdout,"instance: kp=%e\n",here->kp);
  fprintf(stdout,"instance: qq=%e\n",here->qq);
  fprintf(stdout,"instance: qlim2=%e\n",here->qlim2);
  fprintf(stdout,"instance: E_eff0=%e\n",here->E_eff0);
  fprintf(stdout,"instance: eta_mu=%e\n",here->eta_mu);
  fprintf(stdout,"instance: BCH=%e\n",here->BCH);
  fprintf(stdout,"instance: BOV=%e\n",here->BOV);
  fprintf(stdout,"instance: inv_CHIB=%e\n",here->inv_CHIB);
  fprintf(stdout,"instance: GCQ=%e\n",here->GCQ);
  fprintf(stdout,"instance: Dch=%e\n",here->Dch);
  fprintf(stdout,"instance: Dov=%e\n",here->Dov);
  fprintf(stdout,"instance: x1=%e\n",here->x1);
  fprintf(stdout,"instance: Vdsat_lim=%e\n",here->Vdsat_lim);
  fprintf(stdout,"instance: nt=%e\n",here->nt);
  fprintf(stdout,"instance: Cox_over_q=%e\n",here->Cox_over_q);
  fprintf(stdout,"instance: GOV_s=%e\n",here->GOV_s);
  fprintf(stdout,"instance: GOV_d=%e\n",here->GOV_d);
  fprintf(stdout,"instance: GOV2_s=%e\n",here->GOV2_s);
  fprintf(stdout,"instance: GOV2_d=%e\n",here->GOV2_d);
  fprintf(stdout,"instance: BOV_d=%e\n",here->BOV_d);
  fprintf(stdout,"instance: xi_ov_s=%e\n",here->xi_ov_s);
  fprintf(stdout,"instance: xi_ov_d=%e\n",here->xi_ov_d);
  fprintf(stdout,"instance: inv_xi_ov_s=%e\n",here->inv_xi_ov_s);
  fprintf(stdout,"instance: inv_xi_ov_d=%e\n",here->inv_xi_ov_d);
  fprintf(stdout,"instance: x_mrg_ov_s=%e\n",here->x_mrg_ov_s);
  fprintf(stdout,"instance: x_mrg_ov_d=%e\n",here->x_mrg_ov_d);
  fprintf(stdout,"instance: inv_xg1_s=%e\n",here->inv_xg1_s);
  fprintf(stdout,"instance: inv_xg1_d=%e\n",here->inv_xg1_d);
  fprintf(stdout,"instance: AGIDLs=%e\n",here->AGIDLs);
  fprintf(stdout,"instance: AGIDLDs=%e\n",here->AGIDLDs);
  fprintf(stdout,"instance: BGIDLs=%e\n",here->BGIDLs);
  fprintf(stdout,"instance: BGIDLDs=%e\n",here->BGIDLDs);
  fprintf(stdout,"instance: BGIDL_T=%e\n",here->BGIDL_T);
  fprintf(stdout,"instance: BGIDLD_T=%e\n",here->BGIDLD_T);
  fprintf(stdout,"instance: phib=%e\n",here->phib);
  fprintf(stdout,"instance: sqrt_phib=%e\n",here->sqrt_phib);
  fprintf(stdout,"instance: phix=%e\n",here->phix);
  fprintf(stdout,"instance: aphi=%e\n",here->aphi);
  fprintf(stdout,"instance: bphi=%e\n",here->bphi);
  fprintf(stdout,"instance: phix1=%e\n",here->phix1);
  fprintf(stdout,"instance: G_0=%e\n",here->G_0);
  fprintf(stdout,"instance: phit1=%e\n",here->phit1);
  fprintf(stdout,"instance: inv_phit1=%e\n",here->inv_phit1);
  fprintf(stdout,"instance: alpha_b=%e\n",here->alpha_b);
  fprintf(stdout,"instance: inv_VP=%e\n",here->inv_VP);
  fprintf(stdout,"instance: inv_AX=%e\n",here->inv_AX);
  fprintf(stdout,"instance: Sfl_prefac=%e\n",here->Sfl_prefac);
  fprintf(stdout,"instance: fac_exc=%e\n",here->fac_exc);
  fprintf(stdout,"instance: RG_i=%e\n",here->RG_i);
  fprintf(stdout,"instance: RBULK_i=%e\n",here->RBULK_i);
  fprintf(stdout,"instance: RWELL_i=%e\n",here->RWELL_i);
  fprintf(stdout,"instance: RJUNS_i=%e\n",here->RJUNS_i);
  fprintf(stdout,"instance: RJUND_i=%e\n",here->RJUND_i);
  fprintf(stdout,"instance: ggate=%e\n",here->ggate);
  fprintf(stdout,"instance: gbulk=%e\n",here->gbulk);
  fprintf(stdout,"instance: gwell=%e\n",here->gwell);
  fprintf(stdout,"instance: gjund=%e\n",here->gjund);
  fprintf(stdout,"instance: gjuns=%e\n",here->gjuns);
  fprintf(stdout,"instance: ysq=%e\n",here->ysq);
  fprintf(stdout,"instance: terfc=%e\n",here->terfc);
  fprintf(stdout,"instance: erfcpos=%e\n",here->erfcpos);
  fprintf(stdout,"instance: h1=%e\n",here->h1);
  fprintf(stdout,"instance: h2=%e\n",here->h2);
  fprintf(stdout,"instance: h2d=%e\n",here->h2d);
  fprintf(stdout,"instance: h3=%e\n",here->h3);
  fprintf(stdout,"instance: h4=%e\n",here->h4);
  fprintf(stdout,"instance: h5=%e\n",here->h5);
  fprintf(stdout,"instance: idmult=%e\n",here->idmult);
  fprintf(stdout,"instance: vj=%e\n",here->vj);
  fprintf(stdout,"instance: z=%e\n",here->z);
  fprintf(stdout,"instance: zinv=%e\n",here->zinv);
  fprintf(stdout,"instance: two_psistar=%e\n",here->two_psistar);
  fprintf(stdout,"instance: vjlim=%e\n",here->vjlim);
  fprintf(stdout,"instance: vjsrh=%e\n",here->vjsrh);
  fprintf(stdout,"instance: vbbt=%e\n",here->vbbt);
  fprintf(stdout,"instance: vav=%e\n",here->vav);
  fprintf(stdout,"instance: tmp=%e\n",here->tmp);
  fprintf(stdout,"instance: id=%e\n",here->id);
  fprintf(stdout,"instance: isrh=%e\n",here->isrh);
  fprintf(stdout,"instance: vbi_minus_vjsrh=%e\n",here->vbi_minus_vjsrh);
  fprintf(stdout,"instance: wsrhstep=%e\n",here->wsrhstep);
  fprintf(stdout,"instance: dwsrh=%e\n",here->dwsrh);
  fprintf(stdout,"instance: wsrh=%e\n",here->wsrh);
  fprintf(stdout,"instance: wdep=%e\n",here->wdep);
  fprintf(stdout,"instance: asrh=%e\n",here->asrh);
  fprintf(stdout,"instance: itat=%e\n",here->itat);
  fprintf(stdout,"instance: btat=%e\n",here->btat);
  fprintf(stdout,"instance: twoatatoverthreebtat=%e\n",here->twoatatoverthreebtat);
  fprintf(stdout,"instance: umaxbeforelimiting=%e\n",here->umaxbeforelimiting);
  fprintf(stdout,"instance: umax=%e\n",here->umax);
  fprintf(stdout,"instance: sqrtumax=%e\n",here->sqrtumax);
  fprintf(stdout,"instance: umaxpoweronepointfive=%e\n",here->umaxpoweronepointfive);
  fprintf(stdout,"instance: wgamma=%e\n",here->wgamma);
  fprintf(stdout,"instance: wtat=%e\n",here->wtat);
  fprintf(stdout,"instance: ktat=%e\n",here->ktat);
  fprintf(stdout,"instance: ltat=%e\n",here->ltat);
  fprintf(stdout,"instance: mtat=%e\n",here->mtat);
  fprintf(stdout,"instance: xerfc=%e\n",here->xerfc);
  fprintf(stdout,"instance: erfctimesexpmtat=%e\n",here->erfctimesexpmtat);
  fprintf(stdout,"instance: gammamax=%e\n",here->gammamax);
  fprintf(stdout,"instance: ibbt=%e\n",here->ibbt);
  fprintf(stdout,"instance: Fmaxr=%e\n",here->Fmaxr);
  fprintf(stdout,"instance: fbreakdown=%e\n",here->fbreakdown);
  fprintf(stdout,"instance: ABSOURCE_i=%e\n",here->ABSOURCE_i);
  fprintf(stdout,"instance: LSSOURCE_i=%e\n",here->LSSOURCE_i);
  fprintf(stdout,"instance: LGSOURCE_i=%e\n",here->LGSOURCE_i);
  fprintf(stdout,"instance: zflagbot_s=%e\n",here->zflagbot_s);
  fprintf(stdout,"instance: zflagsti_s=%e\n",here->zflagsti_s);
  fprintf(stdout,"instance: zflaggat_s=%e\n",here->zflaggat_s);
  fprintf(stdout,"instance: VMAX_s=%e\n",here->VMAX_s);
  fprintf(stdout,"instance: exp_VMAX_over_phitd_s=%e\n",here->exp_VMAX_over_phitd_s);
  fprintf(stdout,"instance: vbimin_s=%e\n",here->vbimin_s);
  fprintf(stdout,"instance: vch_s=%e\n",here->vch_s);
  fprintf(stdout,"instance: vfmin_s=%e\n",here->vfmin_s);
  fprintf(stdout,"instance: vbbtlim_s=%e\n",here->vbbtlim_s);
  fprintf(stdout,"instance: xhighf1_s=%e\n",here->xhighf1_s);
  fprintf(stdout,"instance: expxhf1_s=%e\n",here->expxhf1_s);
  fprintf(stdout,"instance: xhighf2_s=%e\n",here->xhighf2_s);
  fprintf(stdout,"instance: expxhf2_s=%e\n",here->expxhf2_s);
  fprintf(stdout,"instance: xhighr_s=%e\n",here->xhighr_s);
  fprintf(stdout,"instance: expxhr_s=%e\n",here->expxhr_s);
  fprintf(stdout,"instance: m0flag_s=%e\n",here->m0flag_s);
  fprintf(stdout,"instance: ISATFOR1_s=%e\n",here->ISATFOR1_s);
  fprintf(stdout,"instance: MFOR1_s=%e\n",here->MFOR1_s);
  fprintf(stdout,"instance: ISATFOR2_s=%e\n",here->ISATFOR2_s);
  fprintf(stdout,"instance: MFOR2_s=%e\n",here->MFOR2_s);
  fprintf(stdout,"instance: ISATREV_s=%e\n",here->ISATREV_s);
  fprintf(stdout,"instance: MREV_s=%e\n",here->MREV_s);
  fprintf(stdout,"instance: ABDRAIN_i=%e\n",here->ABDRAIN_i);
  fprintf(stdout,"instance: LSDRAIN_i=%e\n",here->LSDRAIN_i);
  fprintf(stdout,"instance: LGDRAIN_i=%e\n",here->LGDRAIN_i);
  fprintf(stdout,"instance: zflagbot_d=%e\n",here->zflagbot_d);
  fprintf(stdout,"instance: zflagsti_d=%e\n",here->zflagsti_d);
  fprintf(stdout,"instance: zflaggat_d=%e\n",here->zflaggat_d);
  fprintf(stdout,"instance: VMAX_d=%e\n",here->VMAX_d);
  fprintf(stdout,"instance: exp_VMAX_over_phitd_d=%e\n",here->exp_VMAX_over_phitd_d);
  fprintf(stdout,"instance: vbimin_d=%e\n",here->vbimin_d);
  fprintf(stdout,"instance: vch_d=%e\n",here->vch_d);
  fprintf(stdout,"instance: vfmin_d=%e\n",here->vfmin_d);
  fprintf(stdout,"instance: vbbtlim_d=%e\n",here->vbbtlim_d);
  fprintf(stdout,"instance: xhighf1_d=%e\n",here->xhighf1_d);
  fprintf(stdout,"instance: expxhf1_d=%e\n",here->expxhf1_d);
  fprintf(stdout,"instance: xhighf2_d=%e\n",here->xhighf2_d);
  fprintf(stdout,"instance: expxhf2_d=%e\n",here->expxhf2_d);
  fprintf(stdout,"instance: xhighr_d=%e\n",here->xhighr_d);
  fprintf(stdout,"instance: expxhr_d=%e\n",here->expxhr_d);
  fprintf(stdout,"instance: m0flag_d=%e\n",here->m0flag_d);
  fprintf(stdout,"instance: ISATFOR1_d=%e\n",here->ISATFOR1_d);
  fprintf(stdout,"instance: MFOR1_d=%e\n",here->MFOR1_d);
  fprintf(stdout,"instance: ISATFOR2_d=%e\n",here->ISATFOR2_d);
  fprintf(stdout,"instance: MFOR2_d=%e\n",here->MFOR2_d);
  fprintf(stdout,"instance: ISATREV_d=%e\n",here->ISATREV_d);
  fprintf(stdout,"instance: MREV_d=%e\n",here->MREV_d);
}


#define _STATIC
#define _DYNAMIC
#define _DERIVATE

#define _load_static_residual2(p,n,v)\
  *(ckt->CKTrhs+here->p ## Node)-=v;\
  *(ckt->CKTrhs+here->n ## Node)+=v;
#define _load_static_residual1(p,v)\
  *(ckt->CKTrhs+here->p ## Node)-=v;

#define _load_static_jacobian4(Sp,Sn,Pp,Pn,v)\
  _load_static_residual2(Sp,Sn,-v*BP(Pp,Pn))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pn)+=v;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sn ## _ ## Pn)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pn)-=v;\
  (here->JSVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_static_jacobian2s(Sp,Sn,Pp,v)\
  _load_static_residual2(Sp,Sn,-v*NP(Pp))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_static_jacobian2p(Sp,Pp,Pn,v)\
  _load_static_residual1(Sp,-v*BP(Pp,Pn))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pn)-=v;
#define _load_static_jacobian1(Sp,Pp,v)\
  _load_static_residual1(Sp,-v*NP(Pp))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;

#define _load_dynamic_residual2(p,n,v)\
if(ChargeComputationNeeded)\
{\
  int error;\
  double unused;\
  *(ckt->CKTstate0+here->state_##p##_##n)=v;\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_##n)=*(ckt->CKTstate0+here->state_##p##_##n);\
  error = NIintegrate(ckt,&unused,&unused,0.0,here->state_##p##_##n);\
  if(error) return(error);\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_##n+1) = *(ckt->CKTstate0+here->state_##p##_##n+1);\
  *(ckt->CKTrhs+here->p##Node)-=*(ckt->CKTstate0+here->state_##p##_##n+1);\
  *(ckt->CKTrhs+here->n##Node)+=*(ckt->CKTstate0+here->state_##p##_##n+1);\
}
#define _load_dynamic_residual1(p,v)\
if(ChargeComputationNeeded)\
{\
  int error;\
  double unused;\
  *(ckt->CKTstate0+here->state_##p##_GND)=v;\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_GND)=*(ckt->CKTstate0+here->state_##p##_GND);\
  error = NIintegrate(ckt,&unused,&unused,0.0,here->state_##p##_GND);\
  if(error) return(error);\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_GND+1) = *(ckt->CKTstate0+here->state_##p##_GND+1);\
  *(ckt->CKTrhs+here->p##Node)-=*(ckt->CKTstate0+here->state_##p##_GND+1);\
}

#define _load_dynamic_jacobian4(Sp,Sn,Pp,Pn,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*BP(Pp,Pn);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(ckt->CKTrhs+here->Sn##Node)-=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pn)+=geq;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sn ## _ ## Pn)+=v;\
  (here->JDVAL_ ## Sp ## _ ## Pn)-=v;\
  (here->JDVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_dynamic_jacobian2s(Sp,Sn,Pp,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*NP(Pp);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(ckt->CKTrhs+here->Sn##Node)-=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_dynamic_jacobian2p(Sp,Pp,Pn,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*BP(Pp,Pn);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sp ## _ ## Pn)-=v;
#define _load_dynamic_jacobian1(Sp,Pp,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*NP(Pp);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
}\
(here->JDVAL_ ## Sp ## _ ## Pp)+=v;

int psp102load(GENmodel *inModel, CKTcircuit *ckt)
     /* actually load the current value into the 
      * sparse matrix previously provided 
      */
{
  psp102model *model = (psp102model*)inModel;
  psp102instance *here;
  int ChargeComputationNeeded =  
                 ((ckt->CKTmode & (MODEAC | MODETRAN | MODEINITSMSIG)) ||
                 ((ckt->CKTmode & MODETRANOP) && (ckt->CKTmode & MODEUIC)))
                 ? 1 : 0;

  for ( ; model != NULL; model = psp102nextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = psp102instances(model); here != NULL ; here = psp102nextInstance(here))
    {
{  here->JSVAL_D_S=0.0;
  here->JSVAL_D_BP=0.0;
  here->JSVAL_BP_S=0.0;
  here->JSVAL_BP_BP=0.0;
  here->JSVAL_D_D=0.0;
  here->JSVAL_BP_D=0.0;
  here->JSVAL_D_GP=0.0;
  here->JSVAL_BP_GP=0.0;
  here->JSVAL_S_S=0.0;
  here->JSVAL_S_BP=0.0;
  here->JSVAL_S_D=0.0;
  here->JSVAL_S_GP=0.0;
  here->JSVAL_GP_S=0.0;
  here->JSVAL_GP_BP=0.0;
  here->JSVAL_GP_D=0.0;
  here->JSVAL_GP_GP=0.0;
  here->JSVAL_BS_S=0.0;
  here->JSVAL_BS_BS=0.0;
  here->JSVAL_S_BS=0.0;
  here->JSVAL_BS_D=0.0;
  here->JSVAL_BS_BD=0.0;
  here->JSVAL_S_BD=0.0;
  here->JSVAL_BD_S=0.0;
  here->JSVAL_BD_BS=0.0;
  here->JSVAL_D_BS=0.0;
  here->JSVAL_BD_D=0.0;
  here->JSVAL_BD_BD=0.0;
  here->JSVAL_D_BD=0.0;
  here->JSVAL_G_G=0.0;
  here->JSVAL_G_GP=0.0;
  here->JSVAL_GP_G=0.0;
  here->JSVAL_BP_BI=0.0;
  here->JSVAL_BI_BP=0.0;
  here->JSVAL_BI_BI=0.0;
  here->JSVAL_BS_BI=0.0;
  here->JSVAL_BI_BS=0.0;
  here->JSVAL_BD_BI=0.0;
  here->JSVAL_BI_BD=0.0;
  here->JSVAL_B_B=0.0;
  here->JSVAL_B_BI=0.0;
  here->JSVAL_BI_B=0.0;
  here->JSVAL_NOI2_NOI2=0.0;
  here->JSVAL_NOI2_S=0.0;
  here->JSVAL_NOI2_BP=0.0;
  here->JSVAL_NOI2_GP=0.0;
  here->JSVAL_NOI2_D=0.0;
  here->JSVAL_NOI_S=0.0;
  here->JSVAL_NOI_BP=0.0;
  here->JSVAL_NOI_GP=0.0;
  here->JSVAL_NOI_D=0.0;
  here->JSVAL_NOI_NOI2=0.0;
  here->JSVAL_NOI_NOI=0.0;
  here->JSVAL_BS_BP=0.0;
  here->JSVAL_BS_GP=0.0;
  here->JSVAL_BD_BP=0.0;
  here->JSVAL_BD_GP=0.0;
  here->JDVAL_D_S=0.0;
  here->JDVAL_D_BP=0.0;
  here->JDVAL_BP_S=0.0;
  here->JDVAL_BP_BP=0.0;
  here->JDVAL_D_D=0.0;
  here->JDVAL_BP_D=0.0;
  here->JDVAL_D_GP=0.0;
  here->JDVAL_BP_GP=0.0;
  here->JDVAL_S_S=0.0;
  here->JDVAL_S_BP=0.0;
  here->JDVAL_S_D=0.0;
  here->JDVAL_S_GP=0.0;
  here->JDVAL_GP_S=0.0;
  here->JDVAL_GP_BP=0.0;
  here->JDVAL_GP_D=0.0;
  here->JDVAL_GP_GP=0.0;
  here->JDVAL_BS_S=0.0;
  here->JDVAL_BS_BS=0.0;
  here->JDVAL_S_BS=0.0;
  here->JDVAL_BS_D=0.0;
  here->JDVAL_BS_BD=0.0;
  here->JDVAL_S_BD=0.0;
  here->JDVAL_BD_S=0.0;
  here->JDVAL_BD_BS=0.0;
  here->JDVAL_D_BS=0.0;
  here->JDVAL_BD_D=0.0;
  here->JDVAL_BD_BD=0.0;
  here->JDVAL_D_BD=0.0;
  here->JDVAL_NOI_S=0.0;
  here->JDVAL_NOI_BP=0.0;
  here->JDVAL_NOI_GP=0.0;
  here->JDVAL_NOI_D=0.0;
  here->JDVAL_NOI_NOI=0.0;

}
{
#include "psp102.hxx"
}
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
