/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "psp103defs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

#define jacobian(a,b) here->PTR_J_##a##_##b##_required=1;
#define static_jacobian4(p,q,r,s)  jacobian(p,r) jacobian(p,s) jacobian(q,r) jacobian(q,s)
#define static_jacobian2s(p,q,r)   jacobian(p,r) jacobian(q,r)
#define static_jacobian2p(p,r,s)   jacobian(p,r) jacobian(p,s)
#define static_jacobian1(p,r)      jacobian(p,r)
#define dynamic_jacobian4(p,q,r,s) jacobian(p,r) jacobian(p,s) jacobian(q,r) jacobian(q,s)
#define dynamic_jacobian2s(p,q,r)  jacobian(p,r) jacobian(q,r)
#define dynamic_jacobian2p(p,r,s)  jacobian(p,r) jacobian(p,s)
#define dynamic_jacobian1(p,r)     jacobian(p,r)
#define whitenoise_jacobian4(p,q,r,s)
#define whitenoise_jacobian2s(p,q,r)
#define whitenoise_jacobian2p(p,r,s)
#define whitenoise_jacobian1(p)
#define flickernoise_jacobian4(p,q,r,s)
#define flickernoise_jacobian2s(p,q,r)
#define flickernoise_jacobian2p(p,r,s)
#define flickernoise_jacobian1(p)


int psp103guesstopology (SMPmatrix *matrix, CKTcircuit *ckt, psp103model *model, psp103instance *here)
     /* guess topology */
{
  NG_IGNOREABLE(matrix);
  NG_IGNOREABLE(ckt);
double rwellnoise=0.0/0.0;
double rjundnoise=0.0/0.0;
double rjunsnoise=0.0/0.0;
double rbulknoise=0.0/0.0;
double rdrainnoise=0.0/0.0;
double rsourcenoise=0.0/0.0;
double rgatenoise=0.0/0.0;
double tme1=0.0/0.0;
double Fs2=0.0/0.0;
double xbct=0.0/0.0;
double alploc=0.0/0.0;
double axloc=0.0/0.0;
double thesatloc=0.0/0.0;
double cfloc=0.0/0.0;
double G_0=0.0/0.0;
double phib=0.0/0.0;
if
((model->CHNL_TYPE==(+1)))
{
}
else
{
}
if
(((model->SWNUD_i!=0)&&(here->GFACNUD_i!=1.0)))
{
}
phib=here->phib_dc;
G_0=here->G_0_dc;
cfloc=here->CF_i;
thesatloc=here->THESAT_T;
axloc=here->AX_i;
alploc=here->ALP_i;
if
((here->DNSUB_i>0.0))
{
}
else
{
}
if
((here->CTG_i>0.0))
{
xbct=(phib*model->inv_phit);
}
if
((((((model->SWIGATE_i!=0)&&((here->IGOV_i>0.0)||(here->IGOVD_i>0.0)))||((model->SWGIDL_i!=0)&&((here->AGIDL_i>0.0)||(here->AGIDLD_i>0.0))))||(here->CGOV_i>0.0))||(here->CGOVD_i>0.0)))
{
}
if
((model->SWIGATE_i!=0))
{
if
((here->IGOV_i>0.0))
{
if
((here->GC3OV_i<0.0))
{
}
Fs2=((-3.0)-here->GCO_i);
tme1=(4.0-0.9);
tme1=(4.0-0.3);
}
if
((here->IGOVD_i>0.0))
{
if
((here->GC3OV_i<0.0))
{
}
Fs2=((-3.0)-here->GCO_i);
tme1=(4.0-0.9);
tme1=(4.0-0.3);
}
if
((here->IGINV_i>0.0))
{
if
((here->GC3_i<0.0))
{
}
}
}
if
((model->SWGIDL_i!=0))
{
}
if
(((model->SWEDGE_i!=0.0)&&(here->BETNEDGE_i>0)))
{
}
if
((((model->SWNUD_i==1)||(model->SWDELVTAC_i!=0))||(model->SWQSAT_i==1)))
{
phib=here->phib_dc;
G_0=here->G_0_dc;
cfloc=here->CF_i;
thesatloc=here->THESAT_T;
axloc=here->AX_i;
alploc=here->ALP_i;
if
((model->SWDELVTAC_i!=0))
{
phib=here->phib_ac;
G_0=here->G_0_ac;
}
if
((model->SWQSAT_i!=0))
{
cfloc=here->CFAC_i;
thesatloc=here->THESATAC_T;
axloc=here->AXAC_i;
alploc=here->ALPAC_i;
}
if
((here->DNSUB_i>0.0))
{
}
else
{
}
if
((here->CTG_i>0.0))
{
xbct=(phib*model->inv_phit);
}
}
else
{
}
if
((here->qq>0.0))
{
}
if
((model->SWJUNCAP_i>0))
{
if
((model->SWJUNEXP_i==1))
{
if
((here->m0flag_s>0.0))
{
}
else
{
}
if
((here->m0flag_d>0.0))
{
}
else
{
}
here->h1=((4.0*here->vch_s)*here->vch_s);
here->h2=(here->vch_s/here->vfmin_s);
if
((here->zflagbot_s>0.5))
{
if
((model->one_minus_PBOT==0.5))
{
}
else
{
}
}
if
((here->zflagsti_s>0.5))
{
if
((model->one_minus_PSTI==0.5))
{
}
else
{
}
}
if
((here->zflaggat_s>0.5))
{
if
((model->one_minus_PGAT==0.5))
{
}
else
{
}
}
here->h1=((4.0*here->vch_d)*here->vch_d);
here->h2=(here->vch_d/here->vfmin_d);
if
((here->zflagbot_d>0.5))
{
if
((model->one_minus_PBOT_d==0.5))
{
}
else
{
}
}
if
((here->zflagsti_d>0.5))
{
if
((model->one_minus_PSTI_d==0.5))
{
}
else
{
}
}
if
((here->zflaggat_d>0.5))
{
if
((model->one_minus_PGAT_d==0.5))
{
}
else
{
}
}
}
else
{
if
((!(((here->ABSOURCE_i==0.0)&&(here->LSSOURCE_i==0.0))&&(here->LGSOURCE_i==0.0))))
{
here->h1=((4.0*here->vch_s)*here->vch_s);
here->h2=(here->vch_s/here->vfmin_s);
}
if
((here->ABSOURCE_i==0.0))
{
}
else
{
if
((model->one_minus_PBOT==0.5))
{
}
else
{
}
if
(((model->CSRHBOT_i==0.0)&&(model->CTATBOT_i==0.0)))
{
}
else
{
if
((model->PBOT_i==0.5))
{
}
else
{
}
if
((model->PBOT_i==0.5))
{
}
else
{
}
}
if
((model->CTATBOT_i==0.0))
{
}
else
{
if
((((-model->PBOT_i)*model->one_over_one_minus_PBOT)==(-1.0)))
{
}
else
{
}
}
if
((model->CBBTBOT_i==0.0))
{
}
else
{
if
((model->PBOT_i==0.5))
{
}
else
{
}
}
if
((model->VBRBOT_i>1.0e3))
{
}
else
{
}
}
if
((here->LSSOURCE_i==0.0))
{
}
else
{
if
((model->one_minus_PSTI==0.5))
{
}
else
{
}
if
(((model->CSRHSTI_i==0.0)&&(model->CTATSTI_i==0.0)))
{
}
else
{
if
((model->PSTI_i==0.5))
{
}
else
{
}
if
((model->PSTI_i==0.5))
{
}
else
{
}
}
if
((model->CTATSTI_i==0.0))
{
}
else
{
if
((((-model->PSTI_i)*model->one_over_one_minus_PSTI)==(-1.0)))
{
}
else
{
}
}
if
((model->CBBTSTI_i==0.0))
{
}
else
{
if
((model->PSTI_i==0.5))
{
}
else
{
}
}
if
((model->VBRSTI_i>1.0e3))
{
}
else
{
}
}
if
((here->LGSOURCE_i==0.0))
{
}
else
{
if
((model->one_minus_PGAT==0.5))
{
}
else
{
}
if
(((model->CSRHGAT_i==0.0)&&(model->CTATGAT_i==0.0)))
{
}
else
{
if
((model->PGAT_i==0.5))
{
}
else
{
}
if
((model->PGAT_i==0.5))
{
}
else
{
}
}
if
((model->CTATGAT_i==0.0))
{
}
else
{
if
((((-model->PGAT_i)*model->one_over_one_minus_PGAT)==(-1.0)))
{
}
else
{
}
}
if
((model->CBBTGAT_i==0.0))
{
}
else
{
if
((model->PGAT_i==0.5))
{
}
else
{
}
}
if
((model->VBRGAT_i>1.0e3))
{
}
else
{
}
}
if
((!(((here->ABDRAIN_i==0.0)&&(here->LSDRAIN_i==0.0))&&(here->LGDRAIN_i==0.0))))
{
here->h1=((4.0*here->vch_d)*here->vch_d);
here->h2=(here->vch_d/here->vfmin_d);
}
if
((here->ABDRAIN_i==0.0))
{
}
else
{
if
((model->one_minus_PBOT_d==0.5))
{
}
else
{
}
if
(((model->CSRHBOTD_i==0.0)&&(model->CTATBOTD_i==0.0)))
{
}
else
{
if
((model->PBOTD_i==0.5))
{
}
else
{
}
if
((model->PBOTD_i==0.5))
{
}
else
{
}
}
if
((model->CTATBOTD_i==0.0))
{
}
else
{
if
((((-model->PBOTD_i)*model->one_over_one_minus_PBOT_d)==(-1.0)))
{
}
else
{
}
}
if
((model->CBBTBOTD_i==0.0))
{
}
else
{
if
((model->PBOTD_i==0.5))
{
}
else
{
}
}
if
((model->VBRBOTD_i>1.0e3))
{
}
else
{
}
}
if
((here->LSDRAIN_i==0.0))
{
}
else
{
if
((model->one_minus_PSTI_d==0.5))
{
}
else
{
}
if
(((model->CSRHSTID_i==0.0)&&(model->CTATSTID_i==0.0)))
{
}
else
{
if
((model->PSTID_i==0.5))
{
}
else
{
}
if
((model->PSTID_i==0.5))
{
}
else
{
}
}
if
((model->CTATSTID_i==0.0))
{
}
else
{
if
((((-model->PSTID_i)*model->one_over_one_minus_PSTI_d)==(-1.0)))
{
}
else
{
}
}
if
((model->CBBTSTID_i==0.0))
{
}
else
{
if
((model->PSTID_i==0.5))
{
}
else
{
}
}
if
((model->VBRSTID_i>1.0e3))
{
}
else
{
}
}
if
((here->LGDRAIN_i==0.0))
{
}
else
{
if
((model->one_minus_PGAT_d==0.5))
{
}
else
{
}
if
(((model->CSRHGATD_i==0.0)&&(model->CTATGATD_i==0.0)))
{
}
else
{
if
((model->PGATD_i==0.5))
{
}
else
{
}
if
((model->PGATD_i==0.5))
{
}
else
{
}
}
if
((model->CTATGATD_i==0.0))
{
}
else
{
if
((((-model->PGATD_i)*model->one_over_one_minus_PGAT_d)==(-1.0)))
{
}
else
{
}
}
if
((model->CBBTGATD_i==0.0))
{
}
else
{
if
((model->PGATD_i==0.5))
{
}
else
{
}
}
if
((model->VBRGATD_i>1.0e3))
{
}
else
{
}
}
}
}
rgatenoise=(model->nt0*here->ggate);
rsourcenoise=(model->nt0*here->gsource);
rdrainnoise=(model->nt0*here->gdrain);
rbulknoise=(model->nt0*here->gbulk);
rjunsnoise=(model->nt0*here->gjuns);
rjundnoise=(model->nt0*here->gjund);
rwellnoise=(model->nt0*here->gwell);
  static_jacobian4(GP,BP,SI,BP)
  static_jacobian4(GP,BP,DI,SI)
  static_jacobian4(GP,BP,GP,SI)
  static_jacobian4(GP,SI,SI,BP)
  static_jacobian4(GP,SI,DI,SI)
  static_jacobian4(GP,SI,GP,SI)
  static_jacobian4(GP,DI,SI,BP)
  static_jacobian4(GP,DI,DI,SI)
  static_jacobian4(GP,DI,GP,SI)
  static_jacobian4(SI,BP,DI,SI)
  static_jacobian4(SI,BP,GP,SI)
  static_jacobian4(SI,BP,SI,BP)
  static_jacobian4(DI,BP,GP,SI)
  static_jacobian4(DI,BP,SI,BP)
  static_jacobian4(DI,BP,DI,SI)
  static_jacobian4(BS,SI,SI,BS)
  static_jacobian4(BS,SI,DI,BD)
  static_jacobian4(BD,DI,SI,BS)
  static_jacobian4(BD,DI,DI,BD)
  static_jacobian4(G,GP,G,GP)
  static_jacobian4(S,SI,S,SI)
  static_jacobian4(D,DI,D,DI)
  static_jacobian4(BP,BI,BP,BI)
  static_jacobian4(BS,BI,BS,BI)
  static_jacobian4(BD,BI,BD,BI)
  static_jacobian4(B,BI,B,BI)
  static_jacobian4(DI,SI,DI,SI)
  dynamic_jacobian4(GP,SI,SI,BP)
  dynamic_jacobian4(GP,SI,GP,SI)
  dynamic_jacobian4(GP,SI,DI,SI)
  dynamic_jacobian4(BP,SI,SI,BP)
  dynamic_jacobian4(BP,SI,GP,SI)
  dynamic_jacobian4(BP,SI,DI,SI)
  dynamic_jacobian4(DI,SI,SI,BP)
  dynamic_jacobian4(DI,SI,GP,SI)
  dynamic_jacobian4(DI,SI,DI,SI)
  dynamic_jacobian4(GP,SI,GP,SI)
  dynamic_jacobian4(GP,DI,DI,SI)
  dynamic_jacobian4(GP,DI,GP,SI)
  dynamic_jacobian4(GP,BP,SI,BP)
  dynamic_jacobian4(GP,BP,GP,SI)
  dynamic_jacobian4(BS,SI,SI,BS)
  dynamic_jacobian4(BS,SI,DI,BD)
  dynamic_jacobian4(BD,DI,SI,BS)
  dynamic_jacobian4(BD,DI,DI,BD)
  static_jacobian2p(NOI,SI,BP)
  static_jacobian2p(NOI,GP,SI)
  static_jacobian2p(NOI,DI,SI)
  static_jacobian2p(NOI,SI,BP)
  static_jacobian2p(NOI,GP,SI)
  static_jacobian2p(NOI,DI,SI)
  static_jacobian1(NOI,NOI)
  dynamic_jacobian1(NOI,NOI)
  dynamic_jacobian2p(NOI,SI,BP)
  dynamic_jacobian2p(NOI,GP,SI)
  dynamic_jacobian2p(NOI,DI,SI)
  static_jacobian4(DI,SI,SI,BP)
  static_jacobian4(DI,SI,GP,SI)
  static_jacobian4(DI,SI,DI,SI)
  static_jacobian4(DI,SI,SI,BP)
  static_jacobian4(DI,SI,GP,SI)
  static_jacobian4(DI,SI,DI,SI)
  static_jacobian4(GP,SI,SI,BP)
  static_jacobian4(GP,SI,DI,SI)
  static_jacobian4(GP,SI,GP,SI)
  static_jacobian4(GP,DI,SI,BP)
  static_jacobian4(GP,DI,DI,SI)
  static_jacobian4(GP,DI,GP,SI)
  static_jacobian4(BS,SI,SI,BS)
  static_jacobian4(BS,SI,DI,BD)
  static_jacobian4(BS,SI,SI,BP)
  static_jacobian4(BS,SI,GP,SI)
  static_jacobian4(BS,SI,DI,SI)
  static_jacobian4(BD,DI,SI,BP)
  static_jacobian4(BD,DI,GP,SI)
  static_jacobian4(BD,DI,DI,SI)
  static_jacobian4(BD,DI,SI,BS)
  static_jacobian4(BD,DI,DI,BD)
  static_jacobian4(DI,SI,SI,BP)
  static_jacobian4(DI,SI,GP,SI)
  static_jacobian4(DI,SI,DI,SI)
  static_jacobian4(DI,SI,SI,BP)
  static_jacobian4(DI,SI,GP,SI)
  static_jacobian4(DI,SI,DI,SI)

  return(OK);
}
