

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

/* arithmetics */
#define EXP90 1.220403294317841e+039
#define m00_hypot(v00,x,y)      v00 = sqrt((x)*(x)+(y)*(y));
#define m10_hypot(v10,v00,x,y)  v10 = (x)/(v00);
#define m11_hypot(v11,v00,x,y)  v11 = (y)/(v00);
#define m00_max(v00,x,y)        v00 = ((x)>(y))?(x):(y);
#define m10_max(v10,v00,x,y)    v10 = ((x)>(y))?1.0:0.0;
#define m11_max(v11,v00,x,y)    v11 = ((x)>(y))?0.0:1.0;
#define m00_min(v00,x,y)        v00 = ((x)<(y))?(x):(y);
#define m10_min(v10,v00,x,y)    v10 = ((x)<(y))?1.0:0.0;
#define m11_min(v11,v00,x,y)    v11 = ((x)<(y))?0.0:1.0;
#define m00_pow(v00,x,y)        v00 = pow(x,y);
#define m10_pow(v10,v00,x,y)    v10 = (x==0.0)?0.0:(v00)*(y)/(x);
#define m11_pow(v11,v00,x,y)    v11 = (x==0.0)?0.0:(log(x)*(v00));
#define m00_div(v00,v10,x,y)    double v10=1/(y); double v00=(x)*v10;
#define m10_div(v10,v00,vv,x,y)
#define m11_div(v11,v00,vv,x,y) double v11 = -v00*vv;
#define m00_mult(v00,v10,v11,x,y) double v10=(x); double v11=(y); double v00=v10*v11;
#define m00_add(v00,x,y)        double v00=(x)+(y);
#define m00_cos(v00,x)          v00 = cos(x);
#define m10_cos(v10,v00,x)      v10 = (-sin(x));
#define m00_sin(v00,x)          v00 = sin(x);
#define m10_sin(v10,v00,x)      v10 = (cos(x));
#define m00_tan(v00,x)          v00 = tan(x);
#define m10_tan(v10,v00,x)      v10 = (1.0/cos(x)/cos(x));
#define m00_cosh(v00,x)         v00 = cosh(x);
#define m10_cosh(v10,v00,x)     v10 = (sinh(x));
#define m00_sinh(v00,x)         v00 = sinh(x);
#define m10_sinh(v10,v00,x)     v10 = (cosh(x));
#define m00_tanh(v00,x)         v00 = tanh(x);
#define m10_tanh(v10,v00,x)     v10 = (1.0/cosh(x)/cosh(x));
#define m00_acos(v00,x)         v00 = acos(x);
#define m10_acos(v10,v00,x)     v10 = (-1.0/sqrt(1-x*x));
#define m00_asin(v00,x)         v00 = asin(x);
#define m10_asin(v10,v00,x)     v10 = (+1.0/sqrt(1-x*x));
#define m00_atan(v00,x)         v00 = atan(x);
#define m10_atan(v10,v00,x)     v10 = (+1.0/(1+x*x));
#define m00_logE(v00,x)         v00 = log(x);
#define m10_logE(v10,v00,x)     v10 = (1.0/x);
#define m00_log10(v00,x)        v00 = log10(x);
#define m10_log10(v10,v00,x)    v10 = (1.0/x/log(10));
#define m00_sqrt(v00,x)         v00 = sqrt(x);
#define m10_sqrt(v10,v00,x)     v10 = (0.5/v00);
#define m00_fabs(v00,x)         v00 = fabs(x);
#define m10_fabs(v10,v00,x)     v10 = (((x)>=0)?(+1.0):(-1.0));
#define m00_exp(v00,x)          v00 = exp(x);
#define m10_exp(v10,v00,x)      v10 = v00;
#define m00_abs(v00)            ((v00)<(0)?(-(v00)):(v00))
#define m00_floor(v00,x)        v00 = floor(x);
#define m00_ceil(v00,x)         v00 = ceil(x);
#define m00_limexp(v00,x)       v00 = ((x)<90.0?exp(x):EXP90*(x-89.0));
#define m10_limexp(v10,v00,x)   v10 = ((x)<90.0?(v00):EXP90);
#define m00_atan2(v00,x,y)      v00 = atan2(x,y);
#define m10_atan2(v10,x,y)      v10 = (-(y)/((x)*(x)+(y)*(y)));
#define m11_atan2(v11,x,y)      v11 = ((x)/((x)*(x)+(y)*(y)));
#define m00_acosh(v00,x)        v00 = acosh(x);
#define m10_acosh(v10,v00,x)    v10 = (1.0/(sqrt(x-1)*sqrt(x+1)));
#define m00_asinh(v00,x)        v00 = asinh(x);
#define m10_asinh(v10,v00,x)    v10 = (1.0/(sqrt(x*x+1)));
#define m00_atanh(v00,x)        v00 = atanh(x);
#define m10_atanh(v10,v00,x)    v10 = (1.0/(1-x*x));

#define m20_logE(v00)         (-1.0/v00/v00)
#define m20_exp(v00)          exp(v00)
#define m20_limexp(v00)       ((v00)<90.0?exp(v00):0.0)
#define m20_sqrt(v00)         (-0.25/(v00)/sqrt(v00))
#define m20_fabs(v00)         0.0

/*wrapper*/
#define pModel model
#define pInst here
#define mint_get_circuit_tempK() _circuit_temp
#define voltages(n) NP(n)
#define _DDT(q) q
#define _DDX
#define _DERIVATEFORDDX
pInst->fpnoise0=0.0; pInst->fenoise0=0.0;
pInst->wnoise0=0.0;
pInst->wnoise1=0.0;
pInst->wnoise2=0.0;
pInst->wnoise3=0.0;
pInst->wnoise4=0.0;
pInst->wnoise5=0.0;
pInst->wnoise6=0.0;
pInst->wnoise7=0.0;
pInst->wnoise8=0.0;
pInst->wnoise9=0.0;
pInst->wnoise10=0.0;
double sig1k;
double ib;
double ig;
double is;
double id_op;
double sf;
#if defined(_DERIVATE)
double sf_VD_S;
double sf_VGP_S;
double sf_VS_BP;
#endif
double jnoise_d;
#if defined(_DERIVATE)
double jnoise_d_VD_BD;
double jnoise_d_VS_BS;
double jnoise_d_VD_S;
double jnoise_d_VGP_S;
double jnoise_d_VS_BP;
#endif
double jnoise_s;
#if defined(_DERIVATE)
double jnoise_s_VD_S;
double jnoise_s_VGP_S;
double jnoise_s_VS_BP;
double jnoise_s_VD_BD;
double jnoise_s_VS_BS;
#endif
double shot_igd;
#if defined(_DERIVATE)
double shot_igd_VGP_S;
double shot_igd_VD_S;
double shot_igd_VS_BP;
#endif
double shot_igs;
#if defined(_DERIVATE)
double shot_igs_VGP_S;
double shot_igs_VD_S;
double shot_igs_VS_BP;
#endif
#if defined(_DERIVATE)
double jnoisex_d_VD_BD;
double jnoisex_d_VS_BS;
#endif
#if defined(_DERIVATE)
double jnoisex_s_VD_BD;
double jnoisex_s_VS_BS;
#endif
#if defined(_DERIVATE)
double shot_iavl_VD_S;
double shot_iavl_VGP_S;
double shot_iavl_VS_BP;
#endif
#if defined(_DERIVATE)
double shot_igdov_VGP_S;
double shot_igdov_VD_S;
double shot_igdov_VS_BP;
#endif
#if defined(_DERIVATE)
double shot_igsov_VGP_S;
double shot_igsov_VD_S;
double shot_igsov_VS_BP;
#endif
#if defined(_DERIVATE)
double shot_igcdx_VGP_S;
double shot_igcdx_VD_S;
double shot_igcdx_VS_BP;
#endif
#if defined(_DERIVATE)
double shot_igcsx_VGP_S;
double shot_igcsx_VD_S;
double shot_igcsx_VS_BP;
#endif
double Sidexc;
#if defined(_DERIVATE)
double Sidexc_VGP_S;
double Sidexc_VD_S;
double Sidexc_VS_BP;
#endif
double gfac;
#if defined(_DERIVATE)
double gfac_VD_S;
double gfac_VGP_S;
double gfac_VS_BP;
#endif
double Gvsat_exc;
#if defined(_DERIVATE)
double Gvsat_exc_VD_S;
double Gvsat_exc_VGP_S;
double Gvsat_exc_VS_BP;
#endif
double zsat_exc;
#if defined(_DERIVATE)
double zsat_exc_VD_S;
double zsat_exc_VGP_S;
double zsat_exc_VS_BP;
#endif
double thesat1_exc;
#if defined(_DERIVATE)
double thesat1_exc_VD_S;
double thesat1_exc_VGP_S;
double thesat1_exc_VS_BP;
#endif
double temp_exc;
#if defined(_DERIVATE)
double temp_exc_VD_S;
double temp_exc_VGP_S;
double temp_exc_VS_BP;
#endif
double wsat_exc;
#if defined(_DERIVATE)
double wsat_exc_VD_S;
double wsat_exc_VGP_S;
double wsat_exc_VS_BP;
#endif
double temp2_exc;
#if defined(_DERIVATE)
double temp2_exc_VD_S;
double temp2_exc_VGP_S;
double temp2_exc_VS_BP;
#endif
double g_ideal;
#if defined(_DERIVATE)
double g_ideal_VGP_S;
double g_ideal_VD_S;
double g_ideal_VS_BP;
#endif
double lcinv2;
#if defined(_DERIVATE)
double lcinv2_VD_S;
double lcinv2_VGP_S;
double lcinv2_VS_BP;
#endif
double lc;
#if defined(_DERIVATE)
double lc_VD_S;
double lc_VGP_S;
double lc_VS_BP;
#endif
double r;
#if defined(_DERIVATE)
double r_VD_S;
double r_VGP_S;
double r_VS_BP;
#endif
double t2;
#if defined(_DERIVATE)
double t2_VD_S;
double t2_VGP_S;
double t2_VS_BP;
#endif
double sqt2;
#if defined(_DERIVATE)
double sqt2_VD_S;
double sqt2_VGP_S;
double sqt2_VS_BP;
#endif
double t1;
#if defined(_DERIVATE)
double t1_VD_S;
double t1_VGP_S;
double t1_VS_BP;
#endif
double H0;
#if defined(_DERIVATE)
double H0_VD_S;
double H0_VGP_S;
double H0_VS_BP;
#endif
double Delta_N1;
#if defined(_DERIVATE)
double Delta_N1_VD_S;
double Delta_N1_VGP_S;
double Delta_N1_VS_BP;
#endif
double Nm1;
#if defined(_DERIVATE)
double Nm1_VD_S;
double Nm1_VGP_S;
double Nm1_VS_BP;
#endif
double N1;
#if defined(_DERIVATE)
double N1_VD_S;
double N1_VGP_S;
double N1_VS_BP;
#endif
double sqig;
#if defined(_DERIVATE)
double sqig_VD_S;
double sqig_VGP_S;
double sqig_VS_BP;
#endif
#if defined(_DERIVATE)
double sqid_VD_S;
double sqid_VGP_S;
double sqid_VS_BP;
#endif
#if defined(_DERIVATE)
double CGeff_VD_S;
double CGeff_VGP_S;
double CGeff_VS_BP;
#endif
#if defined(_DERIVATE)
double c_igid_VD_S;
double c_igid_VGP_S;
double c_igid_VS_BP;
#endif
double migid;
#if defined(_DERIVATE)
double migid_VD_S;
double migid_VGP_S;
double migid_VS_BP;
#endif
#if defined(_DERIVATE)
double mig_VD_S;
double mig_VGP_S;
double mig_VS_BP;
#endif
double mid;
#if defined(_DERIVATE)
double mid_VD_S;
double mid_VGP_S;
double mid_VS_BP;
#endif
#if defined(_DERIVATE)
double Sfl_VD_S;
double Sfl_VGP_S;
double Sfl_VS_BP;
#endif
#if defined(_DYNAMIC)
double Qs;
#if defined(_DERIVATEFORDDX)
double Qs_VD_S;
double Qs_VGP_S;
double Qs_VS_BP;
#if defined(_DERIVATE2)
  double Qs_VS_BP_VD_S;
  double Qs_VS_BP_VGP_S;
  double Qs_VS_BP_VS_BP;
  double Qs_VGP_S_VD_S;
  double Qs_VGP_S_VGP_S;
  double Qs_VGP_S_VS_BP;
  double Qs_VD_S_VD_S;
  double Qs_VD_S_VGP_S;
  double Qs_VD_S_VS_BP;
#endif
#endif
#endif
double rwellnoise;
double rjundnoise;
double rjunsnoise;
double rbulknoise;
double rgatenoise;
#if defined(_DERIVATEFORDDX)
double fbreakdown_VS_BS;
double fbreakdown_VD_BD;
#if defined(_DERIVATE2)
  double fbreakdown_VD_BD_VS_BS;
  double fbreakdown_VD_BD_VD_BD;
  double fbreakdown_VS_BS_VS_BS;
  double fbreakdown_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Fmaxr_VS_BS;
double Fmaxr_VD_BD;
#if defined(_DERIVATE2)
  double Fmaxr_VD_BD_VS_BS;
  double Fmaxr_VD_BD_VD_BD;
  double Fmaxr_VS_BS_VS_BS;
  double Fmaxr_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double ibbt_VS_BS;
double ibbt_VD_BD;
#if defined(_DERIVATE2)
  double ibbt_VD_BD_VS_BS;
  double ibbt_VD_BD_VD_BD;
  double ibbt_VS_BS_VS_BS;
  double ibbt_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double gammamax_VS_BS;
double gammamax_VD_BD;
#if defined(_DERIVATE2)
  double gammamax_VD_BD_VS_BS;
  double gammamax_VD_BD_VD_BD;
  double gammamax_VS_BS_VS_BS;
  double gammamax_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double erfctimesexpmtat_VS_BS;
double erfctimesexpmtat_VD_BD;
#if defined(_DERIVATE2)
  double erfctimesexpmtat_VD_BD_VS_BS;
  double erfctimesexpmtat_VD_BD_VD_BD;
  double erfctimesexpmtat_VS_BS_VS_BS;
  double erfctimesexpmtat_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double erfcpos_VS_BS;
double erfcpos_VD_BD;
#if defined(_DERIVATE2)
  double erfcpos_VD_BD_VS_BS;
  double erfcpos_VD_BD_VD_BD;
  double erfcpos_VS_BS_VS_BS;
  double erfcpos_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double terfc_VS_BS;
double terfc_VD_BD;
#if defined(_DERIVATE2)
  double terfc_VD_BD_VS_BS;
  double terfc_VD_BD_VD_BD;
  double terfc_VS_BS_VS_BS;
  double terfc_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double ysq_VS_BS;
double ysq_VD_BD;
#if defined(_DERIVATE2)
  double ysq_VD_BD_VS_BS;
  double ysq_VD_BD_VD_BD;
  double ysq_VS_BS_VS_BS;
  double ysq_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double xerfc_VS_BS;
double xerfc_VD_BD;
#if defined(_DERIVATE2)
  double xerfc_VD_BD_VS_BS;
  double xerfc_VD_BD_VD_BD;
  double xerfc_VS_BS_VS_BS;
  double xerfc_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double mtat_VS_BS;
double mtat_VD_BD;
#if defined(_DERIVATE2)
  double mtat_VD_BD_VS_BS;
  double mtat_VD_BD_VD_BD;
  double mtat_VS_BS_VS_BS;
  double mtat_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double ltat_VS_BS;
double ltat_VD_BD;
#if defined(_DERIVATE2)
  double ltat_VD_BD_VS_BS;
  double ltat_VD_BD_VD_BD;
  double ltat_VS_BS_VS_BS;
  double ltat_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double ktat_VS_BS;
double ktat_VD_BD;
#if defined(_DERIVATE2)
  double ktat_VD_BD_VS_BS;
  double ktat_VD_BD_VD_BD;
  double ktat_VS_BS_VS_BS;
  double ktat_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double wtat_VS_BS;
double wtat_VD_BD;
#if defined(_DERIVATE2)
  double wtat_VD_BD_VS_BS;
  double wtat_VD_BD_VD_BD;
  double wtat_VS_BS_VS_BS;
  double wtat_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double wgamma_VS_BS;
double wgamma_VD_BD;
#if defined(_DERIVATE2)
  double wgamma_VD_BD_VS_BS;
  double wgamma_VD_BD_VD_BD;
  double wgamma_VS_BS_VS_BS;
  double wgamma_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double umaxpoweronepointfive_VS_BS;
double umaxpoweronepointfive_VD_BD;
#if defined(_DERIVATE2)
  double umaxpoweronepointfive_VD_BD_VS_BS;
  double umaxpoweronepointfive_VD_BD_VD_BD;
  double umaxpoweronepointfive_VS_BS_VS_BS;
  double umaxpoweronepointfive_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double sqrtumax_VS_BS;
double sqrtumax_VD_BD;
#if defined(_DERIVATE2)
  double sqrtumax_VD_BD_VS_BS;
  double sqrtumax_VD_BD_VD_BD;
  double sqrtumax_VS_BS_VS_BS;
  double sqrtumax_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double umax_VS_BS;
double umax_VD_BD;
#if defined(_DERIVATE2)
  double umax_VD_BD_VS_BS;
  double umax_VD_BD_VD_BD;
  double umax_VS_BS_VS_BS;
  double umax_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double umaxbeforelimiting_VS_BS;
double umaxbeforelimiting_VD_BD;
#if defined(_DERIVATE2)
  double umaxbeforelimiting_VD_BD_VS_BS;
  double umaxbeforelimiting_VD_BD_VD_BD;
  double umaxbeforelimiting_VS_BS_VS_BS;
  double umaxbeforelimiting_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double twoatatoverthreebtat_VS_BS;
double twoatatoverthreebtat_VD_BD;
#if defined(_DERIVATE2)
  double twoatatoverthreebtat_VD_BD_VS_BS;
  double twoatatoverthreebtat_VD_BD_VD_BD;
  double twoatatoverthreebtat_VS_BS_VS_BS;
  double twoatatoverthreebtat_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double btat_VS_BS;
double btat_VD_BD;
#if defined(_DERIVATE2)
  double btat_VD_BD_VS_BS;
  double btat_VD_BD_VD_BD;
  double btat_VS_BS_VS_BS;
  double btat_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double itat_VS_BS;
double itat_VD_BD;
#if defined(_DERIVATE2)
  double itat_VD_BD_VS_BS;
  double itat_VD_BD_VD_BD;
  double itat_VS_BS_VS_BS;
  double itat_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double asrh_VS_BS;
double asrh_VD_BD;
#if defined(_DERIVATE2)
  double asrh_VD_BD_VS_BS;
  double asrh_VD_BD_VD_BD;
  double asrh_VS_BS_VS_BS;
  double asrh_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double wdep_VS_BS;
double wdep_VD_BD;
#if defined(_DERIVATE2)
  double wdep_VD_BD_VS_BS;
  double wdep_VD_BD_VD_BD;
  double wdep_VS_BS_VS_BS;
  double wdep_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double wsrh_VD_BD;
double wsrh_VS_BS;
#if defined(_DERIVATE2)
  double wsrh_VS_BS_VD_BD;
  double wsrh_VS_BS_VS_BS;
  double wsrh_VD_BD_VD_BD;
  double wsrh_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double dwsrh_VD_BD;
double dwsrh_VS_BS;
#if defined(_DERIVATE2)
  double dwsrh_VS_BS_VD_BD;
  double dwsrh_VS_BS_VS_BS;
  double dwsrh_VD_BD_VD_BD;
  double dwsrh_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double wsrhstep_VD_BD;
double wsrhstep_VS_BS;
#if defined(_DERIVATE2)
  double wsrhstep_VS_BS_VD_BD;
  double wsrhstep_VS_BS_VS_BS;
  double wsrhstep_VD_BD_VD_BD;
  double wsrhstep_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double vbi_minus_vjsrh_VD_BD;
double vbi_minus_vjsrh_VS_BS;
#if defined(_DERIVATE2)
  double vbi_minus_vjsrh_VS_BS_VD_BD;
  double vbi_minus_vjsrh_VS_BS_VS_BS;
  double vbi_minus_vjsrh_VD_BD_VD_BD;
  double vbi_minus_vjsrh_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double isrh_VS_BS;
double isrh_VD_BD;
#if defined(_DERIVATE2)
  double isrh_VD_BD_VS_BS;
  double isrh_VD_BD_VD_BD;
  double isrh_VS_BS_VS_BS;
  double isrh_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double id_VD_BD;
double id_VS_BS;
#if defined(_DERIVATE2)
  double id_VS_BS_VD_BD;
  double id_VS_BS_VS_BS;
  double id_VD_BD_VD_BD;
  double id_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double tmp_VS_BS;
double tmp_VD_BD;
#if defined(_DERIVATE2)
  double tmp_VD_BD_VS_BS;
  double tmp_VD_BD_VD_BD;
  double tmp_VS_BS_VS_BS;
  double tmp_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double vav_VD_BD;
double vav_VS_BS;
#if defined(_DERIVATE2)
  double vav_VS_BS_VD_BD;
  double vav_VS_BS_VS_BS;
  double vav_VD_BD_VD_BD;
  double vav_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double vjsrh_VD_BD;
double vjsrh_VS_BS;
#if defined(_DERIVATE2)
  double vjsrh_VS_BS_VD_BD;
  double vjsrh_VS_BS_VS_BS;
  double vjsrh_VD_BD_VD_BD;
  double vjsrh_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double vjlim_VD_BD;
double vjlim_VS_BS;
#if defined(_DERIVATE2)
  double vjlim_VS_BS_VD_BD;
  double vjlim_VS_BS_VS_BS;
  double vjlim_VD_BD_VD_BD;
  double vjlim_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double z_VD_BD;
double z_VS_BS;
#if defined(_DERIVATE2)
  double z_VS_BS_VD_BD;
  double z_VS_BS_VS_BS;
  double z_VD_BD_VD_BD;
  double z_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double idmult_VD_BD;
double idmult_VS_BS;
#if defined(_DERIVATE2)
  double idmult_VS_BS_VD_BD;
  double idmult_VS_BS_VS_BS;
  double idmult_VD_BD_VD_BD;
  double idmult_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double zinv_VD_BD;
double zinv_VS_BS;
#if defined(_DERIVATE2)
  double zinv_VS_BS_VD_BD;
  double zinv_VS_BS_VS_BS;
  double zinv_VD_BD_VD_BD;
  double zinv_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double vj_VS_BS;
double vj_VD_BD;
#if defined(_DERIVATE2)
  double vj_VD_BD_VS_BS;
  double vj_VD_BD_VD_BD;
  double vj_VS_BS_VS_BS;
  double vj_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double two_psistar_VD_BD;
double two_psistar_VS_BS;
#if defined(_DERIVATE2)
  double two_psistar_VS_BS_VD_BD;
  double two_psistar_VS_BS_VS_BS;
  double two_psistar_VD_BD_VD_BD;
  double two_psistar_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double vbbt_VD_BD;
double vbbt_VS_BS;
#if defined(_DERIVATE2)
  double vbbt_VS_BS_VD_BD;
  double vbbt_VS_BS_VS_BS;
  double vbbt_VD_BD_VD_BD;
  double vbbt_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double h5_VD_BD;
double h5_VS_BS;
#if defined(_DERIVATE2)
  double h5_VS_BS_VD_BD;
  double h5_VS_BS_VS_BS;
  double h5_VD_BD_VD_BD;
  double h5_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double h4_VD_BD;
double h4_VS_BS;
#if defined(_DERIVATE2)
  double h4_VS_BS_VD_BD;
  double h4_VS_BS_VS_BS;
  double h4_VD_BD_VD_BD;
  double h4_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double h3_VD_BD;
double h3_VS_BS;
#if defined(_DERIVATE2)
  double h3_VS_BS_VD_BD;
  double h3_VS_BS_VS_BS;
  double h3_VD_BD_VD_BD;
  double h3_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double h2d_VD_BD;
double h2d_VS_BS;
#if defined(_DERIVATE2)
  double h2d_VS_BS_VD_BD;
  double h2d_VS_BS_VS_BS;
  double h2d_VD_BD_VD_BD;
  double h2d_VD_BD_VS_BS;
#endif
#endif
#if defined(_DYNAMIC)
double vjv;
#if defined(_DERIVATEFORDDX)
double vjv_VD_BD;
double vjv_VS_BS;
#if defined(_DERIVATE2)
  double vjv_VS_BS_VD_BD;
  double vjv_VS_BS_VS_BS;
  double vjv_VD_BD_VD_BD;
  double vjv_VD_BD_VS_BS;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double tmpv;
#if defined(_DERIVATEFORDDX)
double tmpv_VD_BD;
double tmpv_VS_BS;
#if defined(_DERIVATE2)
  double tmpv_VS_BS_VD_BD;
  double tmpv_VS_BS_VS_BS;
  double tmpv_VD_BD_VD_BD;
  double tmpv_VD_BD_VS_BS;
#endif
#endif
#endif
double ijunrev;
#if defined(_DERIVATEFORDDX)
double ijunrev_VD_BD;
double ijunrev_VS_BS;
#if defined(_DERIVATE2)
  double ijunrev_VS_BS_VD_BD;
  double ijunrev_VS_BS_VS_BS;
  double ijunrev_VD_BD_VD_BD;
  double ijunrev_VD_BD_VS_BS;
#endif
#endif
double ijunfor2;
#if defined(_DERIVATEFORDDX)
double ijunfor2_VD_BD;
double ijunfor2_VS_BS;
#if defined(_DERIVATE2)
  double ijunfor2_VS_BS_VD_BD;
  double ijunfor2_VS_BS_VS_BS;
  double ijunfor2_VD_BD_VD_BD;
  double ijunfor2_VD_BD_VS_BS;
#endif
#endif
double ijunfor1;
#if defined(_DERIVATEFORDDX)
double ijunfor1_VD_BD;
double ijunfor1_VS_BS;
#if defined(_DERIVATE2)
  double ijunfor1_VS_BS_VD_BD;
  double ijunfor1_VS_BS_VS_BS;
  double ijunfor1_VD_BD_VD_BD;
  double ijunfor1_VD_BD_VS_BS;
#endif
#endif
double tm1;
#if defined(_DERIVATEFORDDX)
double tm1_VD_BD;
double tm1_VS_BS;
#if defined(_DERIVATE2)
  double tm1_VS_BS_VD_BD;
  double tm1_VS_BS_VS_BS;
  double tm1_VD_BD_VD_BD;
  double tm1_VD_BD_VS_BS;
#endif
#endif
double tm0;
#if defined(_DERIVATEFORDDX)
double tm0_VD_BD;
double tm0_VS_BS;
#if defined(_DERIVATE2)
  double tm0_VS_BS_VD_BD;
  double tm0_VS_BS_VS_BS;
  double tm0_VD_BD_VD_BD;
  double tm0_VD_BD_VS_BS;
#endif
#endif
#if defined(_DYNAMIC)
double qjungat_d;
#if defined(_DERIVATEFORDDX)
double qjungat_d_VD_BD;
double qjungat_d_VS_BS;
#if defined(_DERIVATE2)
  double qjungat_d_VD_BD_VD_BD;
  double qjungat_d_VD_BD_VS_BS;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qjunsti_d;
#if defined(_DERIVATEFORDDX)
double qjunsti_d_VD_BD;
double qjunsti_d_VS_BS;
#if defined(_DERIVATE2)
  double qjunsti_d_VD_BD_VD_BD;
  double qjunsti_d_VD_BD_VS_BS;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qjunbot_d;
#if defined(_DERIVATEFORDDX)
double qjunbot_d_VD_BD;
double qjunbot_d_VS_BS;
#if defined(_DERIVATE2)
  double qjunbot_d_VD_BD_VD_BD;
  double qjunbot_d_VD_BD_VS_BS;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qjun_d;
#if defined(_DERIVATE)
double qjun_d_VD_BD;
double qjun_d_VS_BS;
#endif
#endif
#if defined(_DYNAMIC)
double qjungat_s;
#if defined(_DERIVATEFORDDX)
double qjungat_s_VD_BD;
double qjungat_s_VS_BS;
#if defined(_DERIVATE2)
  double qjungat_s_VS_BS_VD_BD;
  double qjungat_s_VS_BS_VS_BS;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qjunsti_s;
#if defined(_DERIVATEFORDDX)
double qjunsti_s_VD_BD;
double qjunsti_s_VS_BS;
#if defined(_DERIVATE2)
  double qjunsti_s_VS_BS_VD_BD;
  double qjunsti_s_VS_BS_VS_BS;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qjunbot_s;
#if defined(_DERIVATEFORDDX)
double qjunbot_s_VD_BD;
double qjunbot_s_VS_BS;
#if defined(_DERIVATE2)
  double qjunbot_s_VS_BS_VD_BD;
  double qjunbot_s_VS_BS_VS_BS;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qjun_s;
#if defined(_DERIVATE)
double qjun_s_VD_BD;
double qjun_s_VS_BS;
#endif
#endif
double ijungat_d;
#if defined(_DERIVATEFORDDX)
double ijungat_d_VD_BD;
double ijungat_d_VS_BS;
#if defined(_DERIVATE2)
  double ijungat_d_VS_BS_VD_BD;
  double ijungat_d_VS_BS_VS_BS;
  double ijungat_d_VD_BD_VD_BD;
  double ijungat_d_VD_BD_VS_BS;
#endif
#endif
double ijunsti_d;
#if defined(_DERIVATEFORDDX)
double ijunsti_d_VD_BD;
double ijunsti_d_VS_BS;
#if defined(_DERIVATE2)
  double ijunsti_d_VS_BS_VD_BD;
  double ijunsti_d_VS_BS_VS_BS;
  double ijunsti_d_VD_BD_VD_BD;
  double ijunsti_d_VD_BD_VS_BS;
#endif
#endif
double ijunbot_d;
#if defined(_DERIVATEFORDDX)
double ijunbot_d_VD_BD;
double ijunbot_d_VS_BS;
#if defined(_DERIVATE2)
  double ijunbot_d_VS_BS_VD_BD;
  double ijunbot_d_VS_BS_VS_BS;
  double ijunbot_d_VD_BD_VD_BD;
  double ijunbot_d_VD_BD_VS_BS;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double ijun_d_VD_BD;
double ijun_d_VS_BS;
#if defined(_DERIVATE2)
  double ijun_d_VS_BS_VD_BD;
  double ijun_d_VS_BS_VS_BS;
  double ijun_d_VD_BD_VD_BD;
  double ijun_d_VD_BD_VS_BS;
#endif
#endif
double ijungat_s;
#if defined(_DERIVATEFORDDX)
double ijungat_s_VS_BS;
double ijungat_s_VD_BD;
#if defined(_DERIVATE2)
  double ijungat_s_VD_BD_VS_BS;
  double ijungat_s_VD_BD_VD_BD;
  double ijungat_s_VS_BS_VS_BS;
  double ijungat_s_VS_BS_VD_BD;
#endif
#endif
double ijunsti_s;
#if defined(_DERIVATEFORDDX)
double ijunsti_s_VS_BS;
double ijunsti_s_VD_BD;
#if defined(_DERIVATE2)
  double ijunsti_s_VD_BD_VS_BS;
  double ijunsti_s_VD_BD_VD_BD;
  double ijunsti_s_VS_BS_VS_BS;
  double ijunsti_s_VS_BS_VD_BD;
#endif
#endif
double ijunbot_s;
#if defined(_DERIVATEFORDDX)
double ijunbot_s_VS_BS;
double ijunbot_s_VD_BD;
#if defined(_DERIVATE2)
  double ijunbot_s_VD_BD_VS_BS;
  double ijunbot_s_VD_BD_VD_BD;
  double ijunbot_s_VS_BS_VS_BS;
  double ijunbot_s_VS_BS_VD_BD;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double ijun_s_VD_BD;
double ijun_s_VS_BS;
#if defined(_DERIVATE2)
  double ijun_s_VS_BS_VD_BD;
  double ijun_s_VS_BS_VS_BS;
  double ijun_s_VD_BD_VD_BD;
  double ijun_s_VD_BD_VS_BS;
#endif
#endif
#if defined(_DYNAMIC)
double Qfgd;
#if defined(_DERIVATEFORDDX)
double Qfgd_VS_BP;
double Qfgd_VGP_S;
double Qfgd_VD_S;
#if defined(_DERIVATE2)
  double Qfgd_VGP_S_VS_BP;
  double Qfgd_VGP_S_VGP_S;
  double Qfgd_VGP_S_VD_S;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qfgs;
#if defined(_DERIVATEFORDDX)
double Qfgs_VD_S;
double Qfgs_VS_BP;
double Qfgs_VGP_S;
#if defined(_DERIVATE2)
  double Qfgs_VGP_S_VD_S;
  double Qfgs_VGP_S_VS_BP;
  double Qfgs_VGP_S_VGP_S;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qgb_ov;
#if defined(_DERIVATE)
double Qgb_ov_VD_S;
double Qgb_ov_VGP_S;
double Qgb_ov_VS_BP;
#endif
#endif
#if defined(_DYNAMIC)
double Qgd_ov;
#if defined(_DERIVATEFORDDX)
double Qgd_ov_VGP_S;
double Qgd_ov_VD_S;
double Qgd_ov_VS_BP;
#if defined(_DERIVATE2)
  double Qgd_ov_VGP_S_VGP_S;
  double Qgd_ov_VGP_S_VD_S;
  double Qgd_ov_VGP_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qgs_ov;
#if defined(_DERIVATEFORDDX)
double Qgs_ov_VGP_S;
double Qgs_ov_VD_S;
double Qgs_ov_VS_BP;
#if defined(_DERIVATE2)
  double Qgs_ov_VGP_S_VGP_S;
  double Qgs_ov_VGP_S_VD_S;
  double Qgs_ov_VGP_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qb;
#if defined(_DERIVATEFORDDX)
double Qb_VD_S;
double Qb_VGP_S;
double Qb_VS_BP;
#if defined(_DERIVATE2)
  double Qb_VS_BP_VD_S;
  double Qb_VS_BP_VGP_S;
  double Qb_VS_BP_VS_BP;
  double Qb_VGP_S_VD_S;
  double Qb_VGP_S_VGP_S;
  double Qb_VGP_S_VS_BP;
  double Qb_VD_S_VD_S;
  double Qb_VD_S_VGP_S;
  double Qb_VD_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qd;
#if defined(_DERIVATEFORDDX)
double Qd_VGP_S;
double Qd_VD_S;
double Qd_VS_BP;
#if defined(_DERIVATE2)
  double Qd_VS_BP_VGP_S;
  double Qd_VS_BP_VD_S;
  double Qd_VS_BP_VS_BP;
  double Qd_VD_S_VGP_S;
  double Qd_VD_S_VD_S;
  double Qd_VD_S_VS_BP;
  double Qd_VGP_S_VGP_S;
  double Qd_VGP_S_VD_S;
  double Qd_VGP_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qg;
#if defined(_DERIVATEFORDDX)
double Qg_VD_S;
double Qg_VGP_S;
double Qg_VS_BP;
#if defined(_DERIVATE2)
  double Qg_VS_BP_VD_S;
  double Qg_VS_BP_VGP_S;
  double Qg_VS_BP_VS_BP;
  double Qg_VGP_S_VD_S;
  double Qg_VGP_S_VGP_S;
  double Qg_VGP_S_VS_BP;
  double Qg_VD_S_VD_S;
  double Qg_VD_S_VGP_S;
  double Qg_VD_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Fj2;
#if defined(_DERIVATEFORDDX)
double Fj2_VD_S;
double Fj2_VGP_S;
double Fj2_VS_BP;
#if defined(_DERIVATE2)
  double Fj2_VS_BP_VD_S;
  double Fj2_VS_BP_VGP_S;
  double Fj2_VS_BP_VS_BP;
  double Fj2_VGP_S_VD_S;
  double Fj2_VGP_S_VGP_S;
  double Fj2_VGP_S_VS_BP;
  double Fj2_VD_S_VD_S;
  double Fj2_VD_S_VGP_S;
  double Fj2_VD_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Fj;
#if defined(_DERIVATEFORDDX)
double Fj_VD_S;
double Fj_VGP_S;
double Fj_VS_BP;
#if defined(_DERIVATE2)
  double Fj_VS_BP_VD_S;
  double Fj_VS_BP_VGP_S;
  double Fj_VS_BP_VS_BP;
  double Fj_VGP_S_VD_S;
  double Fj_VGP_S_VGP_S;
  double Fj_VGP_S_VS_BP;
  double Fj_VD_S_VD_S;
  double Fj_VD_S_VGP_S;
  double Fj_VD_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double QB;
#if defined(_DERIVATEFORDDX)
double QB_VD_S;
double QB_VGP_S;
double QB_VS_BP;
#if defined(_DERIVATE2)
  double QB_VS_BP_VD_S;
  double QB_VS_BP_VGP_S;
  double QB_VS_BP_VS_BP;
  double QB_VGP_S_VD_S;
  double QB_VGP_S_VGP_S;
  double QB_VGP_S_VS_BP;
  double QB_VD_S_VD_S;
  double QB_VD_S_VGP_S;
  double QB_VD_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double QD;
#if defined(_DERIVATEFORDDX)
double QD_VGP_S;
double QD_VD_S;
double QD_VS_BP;
#if defined(_DERIVATE2)
  double QD_VS_BP_VGP_S;
  double QD_VS_BP_VD_S;
  double QD_VS_BP_VS_BP;
  double QD_VD_S_VGP_S;
  double QD_VD_S_VD_S;
  double QD_VD_S_VS_BP;
  double QD_VGP_S_VGP_S;
  double QD_VGP_S_VD_S;
  double QD_VGP_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double QI;
#if defined(_DERIVATEFORDDX)
double QI_VGP_S;
double QI_VD_S;
double QI_VS_BP;
#if defined(_DERIVATE2)
  double QI_VS_BP_VGP_S;
  double QI_VS_BP_VD_S;
  double QI_VS_BP_VS_BP;
  double QI_VD_S_VGP_S;
  double QI_VD_S_VD_S;
  double QI_VD_S_VS_BP;
  double QI_VGP_S_VGP_S;
  double QI_VGP_S_VD_S;
  double QI_VGP_S_VS_BP;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double QG;
#if defined(_DERIVATEFORDDX)
double QG_VD_S;
double QG_VGP_S;
double QG_VS_BP;
#if defined(_DERIVATE2)
  double QG_VS_BP_VD_S;
  double QG_VS_BP_VGP_S;
  double QG_VS_BP_VS_BP;
  double QG_VGP_S_VD_S;
  double QG_VGP_S_VGP_S;
  double QG_VGP_S_VS_BP;
  double QG_VD_S_VD_S;
  double QG_VD_S_VGP_S;
  double QG_VD_S_VS_BP;
#endif
#endif
#endif
#if defined(_DERIVATEFORDDX)
double COX_qm_VD_S;
double COX_qm_VGP_S;
double COX_qm_VS_BP;
#if defined(_DERIVATE2)
  double COX_qm_VS_BP_VD_S;
  double COX_qm_VS_BP_VGP_S;
  double COX_qm_VS_BP_VS_BP;
  double COX_qm_VGP_S_VD_S;
  double COX_qm_VGP_S_VGP_S;
  double COX_qm_VGP_S_VS_BP;
  double COX_qm_VD_S_VD_S;
  double COX_qm_VD_S_VGP_S;
  double COX_qm_VD_S_VS_BP;
#endif
#endif
#if defined(_DYNAMIC)
double Vgb;
#if defined(_DERIVATE)
double Vgb_VD_S;
double Vgb_VGP_S;
double Vgb_VS_BP;
#endif
#endif
double vth_i;
double vts_i;
double facvsb;
double facvsb0;
double P_D;
double Vtovs;
#if defined(_DERIVATEFORDDX)
double Vtovs_VGP_S;
double Vtovs_VD_S;
double Vtovs_VS_BP;
#if defined(_DERIVATE2)
  double Vtovs_VS_BP_VGP_S;
  double Vtovs_VS_BP_VD_S;
  double Vtovs_VS_BP_VS_BP;
  double Vtovs_VD_S_VGP_S;
  double Vtovs_VD_S_VD_S;
  double Vtovs_VD_S_VS_BP;
  double Vtovs_VGP_S_VGP_S;
  double Vtovs_VGP_S_VD_S;
  double Vtovs_VGP_S_VS_BP;
#endif
#endif
double Vtovd;
#if defined(_DERIVATEFORDDX)
double Vtovd_VGP_S;
double Vtovd_VD_S;
double Vtovd_VS_BP;
#if defined(_DERIVATE2)
  double Vtovd_VS_BP_VGP_S;
  double Vtovd_VS_BP_VD_S;
  double Vtovd_VS_BP_VS_BP;
  double Vtovd_VD_S_VGP_S;
  double Vtovd_VD_S_VD_S;
  double Vtovd_VD_S_VS_BP;
  double Vtovd_VGP_S_VGP_S;
  double Vtovd_VGP_S_VD_S;
  double Vtovd_VGP_S_VS_BP;
#endif
#endif
double Igisl;
#if defined(_DERIVATEFORDDX)
double Igisl_VS_BP;
double Igisl_VGP_S;
double Igisl_VD_S;
#if defined(_DERIVATE2)
  double Igisl_VD_S_VS_BP;
  double Igisl_VD_S_VGP_S;
  double Igisl_VD_S_VD_S;
  double Igisl_VGP_S_VS_BP;
  double Igisl_VGP_S_VGP_S;
  double Igisl_VGP_S_VD_S;
  double Igisl_VS_BP_VS_BP;
  double Igisl_VS_BP_VGP_S;
  double Igisl_VS_BP_VD_S;
#endif
#endif
double Igidl;
#if defined(_DERIVATEFORDDX)
double Igidl_VD_S;
double Igidl_VS_BP;
double Igidl_VGP_S;
#if defined(_DERIVATE2)
  double Igidl_VGP_S_VD_S;
  double Igidl_VGP_S_VS_BP;
  double Igidl_VGP_S_VGP_S;
  double Igidl_VS_BP_VD_S;
  double Igidl_VS_BP_VS_BP;
  double Igidl_VS_BP_VGP_S;
  double Igidl_VD_S_VD_S;
  double Igidl_VD_S_VS_BP;
  double Igidl_VD_S_VGP_S;
#endif
#endif
double Sg;
#if defined(_DERIVATEFORDDX)
double Sg_VD_S;
double Sg_VGP_S;
double Sg_VS_BP;
#if defined(_DERIVATE2)
  double Sg_VS_BP_VD_S;
  double Sg_VS_BP_VGP_S;
  double Sg_VS_BP_VS_BP;
  double Sg_VGP_S_VD_S;
  double Sg_VGP_S_VGP_S;
  double Sg_VGP_S_VS_BP;
  double Sg_VD_S_VD_S;
  double Sg_VD_S_VGP_S;
  double Sg_VD_S_VS_BP;
#endif
#endif
double inv_ex;
#if defined(_DERIVATEFORDDX)
double inv_ex_VD_S;
double inv_ex_VGP_S;
double inv_ex_VS_BP;
#if defined(_DERIVATE2)
  double inv_ex_VS_BP_VD_S;
  double inv_ex_VS_BP_VGP_S;
  double inv_ex_VS_BP_VS_BP;
  double inv_ex_VGP_S_VD_S;
  double inv_ex_VGP_S_VGP_S;
  double inv_ex_VGP_S_VS_BP;
  double inv_ex_VD_S_VD_S;
  double inv_ex_VD_S_VGP_S;
  double inv_ex_VD_S_VS_BP;
#endif
#endif
double ex;
#if defined(_DERIVATEFORDDX)
double ex_VD_S;
double ex_VGP_S;
double ex_VS_BP;
#if defined(_DERIVATE2)
  double ex_VS_BP_VD_S;
  double ex_VS_BP_VGP_S;
  double ex_VS_BP_VS_BP;
  double ex_VGP_S_VD_S;
  double ex_VGP_S_VGP_S;
  double ex_VGP_S_VS_BP;
  double ex_VD_S_VD_S;
  double ex_VD_S_VGP_S;
  double ex_VD_S_VS_BP;
#endif
#endif
double inv_x;
#if defined(_DERIVATEFORDDX)
double inv_x_VD_S;
double inv_x_VGP_S;
double inv_x_VS_BP;
#if defined(_DERIVATE2)
  double inv_x_VS_BP_VD_S;
  double inv_x_VS_BP_VGP_S;
  double inv_x_VS_BP_VS_BP;
  double inv_x_VGP_S_VD_S;
  double inv_x_VGP_S_VGP_S;
  double inv_x_VGP_S_VS_BP;
  double inv_x_VD_S_VD_S;
  double inv_x_VD_S_VGP_S;
  double inv_x_VD_S_VS_BP;
#endif
#endif
double xsq;
#if defined(_DERIVATEFORDDX)
double xsq_VD_S;
double xsq_VGP_S;
double xsq_VS_BP;
#if defined(_DERIVATE2)
  double xsq_VS_BP_VD_S;
  double xsq_VS_BP_VGP_S;
  double xsq_VS_BP_VS_BP;
  double xsq_VGP_S_VD_S;
  double xsq_VGP_S_VGP_S;
  double xsq_VGP_S_VS_BP;
  double xsq_VD_S_VD_S;
  double xsq_VD_S_VGP_S;
  double xsq_VD_S_VS_BP;
#endif
#endif
double Ag;
#if defined(_DERIVATEFORDDX)
double Ag_VGP_S;
double Ag_VD_S;
double Ag_VS_BP;
#if defined(_DERIVATE2)
  double Ag_VS_BP_VGP_S;
  double Ag_VS_BP_VD_S;
  double Ag_VS_BP_VS_BP;
  double Ag_VD_S_VGP_S;
  double Ag_VD_S_VD_S;
  double Ag_VD_S_VS_BP;
  double Ag_VGP_S_VGP_S;
  double Ag_VGP_S_VD_S;
  double Ag_VGP_S_VS_BP;
#endif
#endif
double Bg;
#if defined(_DERIVATEFORDDX)
double Bg_VGP_S;
double Bg_VD_S;
double Bg_VS_BP;
#if defined(_DERIVATE2)
  double Bg_VS_BP_VGP_S;
  double Bg_VS_BP_VD_S;
  double Bg_VS_BP_VS_BP;
  double Bg_VD_S_VGP_S;
  double Bg_VD_S_VD_S;
  double Bg_VD_S_VS_BP;
  double Bg_VGP_S_VGP_S;
  double Bg_VGP_S_VD_S;
  double Bg_VGP_S_VS_BP;
#endif
#endif
double u0_div_H;
#if defined(_DERIVATEFORDDX)
double u0_div_H_VGP_S;
double u0_div_H_VD_S;
double u0_div_H_VS_BP;
#if defined(_DERIVATE2)
  double u0_div_H_VS_BP_VGP_S;
  double u0_div_H_VS_BP_VD_S;
  double u0_div_H_VS_BP_VS_BP;
  double u0_div_H_VD_S_VGP_S;
  double u0_div_H_VD_S_VD_S;
  double u0_div_H_VD_S_VS_BP;
  double u0_div_H_VGP_S_VGP_S;
  double u0_div_H_VGP_S_VD_S;
  double u0_div_H_VGP_S_VS_BP;
#endif
#endif
double x;
#if defined(_DERIVATEFORDDX)
double x_VD_S;
double x_VGP_S;
double x_VS_BP;
#if defined(_DERIVATE2)
  double x_VS_BP_VD_S;
  double x_VS_BP_VGP_S;
  double x_VS_BP_VS_BP;
  double x_VGP_S_VD_S;
  double x_VGP_S_VGP_S;
  double x_VGP_S_VS_BP;
  double x_VD_S_VD_S;
  double x_VD_S_VGP_S;
  double x_VD_S_VS_BP;
#endif
#endif
double u0;
#if defined(_DERIVATEFORDDX)
double u0_VGP_S;
double u0_VD_S;
double u0_VS_BP;
#if defined(_DERIVATE2)
  double u0_VS_BP_VGP_S;
  double u0_VS_BP_VD_S;
  double u0_VS_BP_VS_BP;
  double u0_VD_S_VGP_S;
  double u0_VD_S_VD_S;
  double u0_VD_S_VS_BP;
  double u0_VGP_S_VGP_S;
  double u0_VGP_S_VD_S;
  double u0_VGP_S_VS_BP;
#endif
#endif
double igcd_h;
#if defined(_DERIVATEFORDDX)
double igcd_h_VD_S;
double igcd_h_VGP_S;
double igcd_h_VS_BP;
#if defined(_DERIVATE2)
  double igcd_h_VS_BP_VD_S;
  double igcd_h_VS_BP_VGP_S;
  double igcd_h_VS_BP_VS_BP;
  double igcd_h_VGP_S_VD_S;
  double igcd_h_VGP_S_VGP_S;
  double igcd_h_VGP_S_VS_BP;
  double igcd_h_VD_S_VD_S;
  double igcd_h_VD_S_VGP_S;
  double igcd_h_VD_S_VS_BP;
#endif
#endif
double igc;
#if defined(_DERIVATEFORDDX)
double igc_VD_S;
double igc_VGP_S;
double igc_VS_BP;
#if defined(_DERIVATE2)
  double igc_VS_BP_VD_S;
  double igc_VS_BP_VGP_S;
  double igc_VS_BP_VS_BP;
  double igc_VGP_S_VD_S;
  double igc_VGP_S_VGP_S;
  double igc_VGP_S_VS_BP;
  double igc_VD_S_VD_S;
  double igc_VD_S_VGP_S;
  double igc_VD_S_VS_BP;
#endif
#endif
double Igc0;
#if defined(_DERIVATEFORDDX)
double Igc0_VGP_S;
double Igc0_VD_S;
double Igc0_VS_BP;
#if defined(_DERIVATE2)
  double Igc0_VS_BP_VGP_S;
  double Igc0_VS_BP_VD_S;
  double Igc0_VS_BP_VS_BP;
  double Igc0_VD_S_VGP_S;
  double Igc0_VD_S_VD_S;
  double Igc0_VD_S_VS_BP;
  double Igc0_VGP_S_VGP_S;
  double Igc0_VGP_S_VD_S;
  double Igc0_VGP_S_VS_BP;
#endif
#endif
double Vm;
#if defined(_DERIVATEFORDDX)
double Vm_VD_S;
double Vm_VS_BP;
double Vm_VGP_S;
#if defined(_DERIVATE2)
  double Vm_VGP_S_VD_S;
  double Vm_VGP_S_VS_BP;
  double Vm_VGP_S_VGP_S;
  double Vm_VS_BP_VD_S;
  double Vm_VS_BP_VS_BP;
  double Vm_VS_BP_VGP_S;
  double Vm_VD_S_VD_S;
  double Vm_VD_S_VS_BP;
  double Vm_VD_S_VGP_S;
#endif
#endif
double TP;
#if defined(_DERIVATEFORDDX)
double TP_VGP_S;
double TP_VD_S;
double TP_VS_BP;
#if defined(_DERIVATE2)
  double TP_VS_BP_VGP_S;
  double TP_VS_BP_VD_S;
  double TP_VS_BP_VS_BP;
  double TP_VD_S_VGP_S;
  double TP_VD_S_VD_S;
  double TP_VD_S_VS_BP;
  double TP_VGP_S_VGP_S;
  double TP_VGP_S_VD_S;
  double TP_VGP_S_VS_BP;
#endif
#endif
double Dgate;
#if defined(_DERIVATEFORDDX)
double Dgate_VD_S;
double Dgate_VS_BP;
double Dgate_VGP_S;
#if defined(_DERIVATE2)
  double Dgate_VGP_S_VD_S;
  double Dgate_VGP_S_VS_BP;
  double Dgate_VGP_S_VGP_S;
  double Dgate_VS_BP_VD_S;
  double Dgate_VS_BP_VS_BP;
  double Dgate_VS_BP_VGP_S;
  double Dgate_VD_S_VD_S;
  double Dgate_VD_S_VS_BP;
  double Dgate_VD_S_VGP_S;
#endif
#endif
double Dsi;
#if defined(_DERIVATEFORDDX)
double Dsi_VD_S;
double Dsi_VS_BP;
double Dsi_VGP_S;
#if defined(_DERIVATE2)
  double Dsi_VGP_S_VD_S;
  double Dsi_VGP_S_VS_BP;
  double Dsi_VGP_S_VGP_S;
  double Dsi_VS_BP_VD_S;
  double Dsi_VS_BP_VS_BP;
  double Dsi_VS_BP_VGP_S;
  double Dsi_VD_S_VD_S;
  double Dsi_VD_S_VS_BP;
  double Dsi_VD_S_VGP_S;
#endif
#endif
double arg1;
#if defined(_DERIVATEFORDDX)
double arg1_VD_S;
double arg1_VS_BP;
double arg1_VGP_S;
#if defined(_DERIVATE2)
  double arg1_VGP_S_VD_S;
  double arg1_VGP_S_VS_BP;
  double arg1_VGP_S_VGP_S;
  double arg1_VS_BP_VD_S;
  double arg1_VS_BP_VS_BP;
  double arg1_VS_BP_VGP_S;
  double arg1_VD_S_VD_S;
  double arg1_VD_S_VS_BP;
  double arg1_VD_S_VGP_S;
#endif
#endif
double zg;
#if defined(_DERIVATEFORDDX)
double zg_VGP_S;
double zg_VD_S;
double zg_VS_BP;
#if defined(_DERIVATE2)
  double zg_VS_BP_VGP_S;
  double zg_VS_BP_VD_S;
  double zg_VS_BP_VS_BP;
  double zg_VD_S_VGP_S;
  double zg_VD_S_VD_S;
  double zg_VD_S_VS_BP;
  double zg_VGP_S_VGP_S;
  double zg_VGP_S_VD_S;
  double zg_VGP_S_VS_BP;
#endif
#endif
double psi_t;
#if defined(_DERIVATEFORDDX)
double psi_t_VGP_S;
double psi_t_VD_S;
double psi_t_VS_BP;
#if defined(_DERIVATE2)
  double psi_t_VS_BP_VGP_S;
  double psi_t_VS_BP_VD_S;
  double psi_t_VS_BP_VS_BP;
  double psi_t_VD_S_VGP_S;
  double psi_t_VD_S_VD_S;
  double psi_t_VD_S_VS_BP;
  double psi_t_VGP_S_VGP_S;
  double psi_t_VGP_S_VD_S;
  double psi_t_VGP_S_VS_BP;
#endif
#endif
double arg2mina;
#if defined(_DERIVATEFORDDX)
double arg2mina_VGP_S;
double arg2mina_VD_S;
double arg2mina_VS_BP;
#if defined(_DERIVATE2)
  double arg2mina_VS_BP_VGP_S;
  double arg2mina_VS_BP_VD_S;
  double arg2mina_VS_BP_VS_BP;
  double arg2mina_VD_S_VGP_S;
  double arg2mina_VD_S_VD_S;
  double arg2mina_VD_S_VS_BP;
  double arg2mina_VGP_S_VGP_S;
  double arg2mina_VGP_S_VD_S;
  double arg2mina_VGP_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Igcd_VGP_S;
double Igcd_VD_S;
double Igcd_VS_BP;
#if defined(_DERIVATE2)
  double Igcd_VS_BP_VGP_S;
  double Igcd_VS_BP_VD_S;
  double Igcd_VS_BP_VS_BP;
  double Igcd_VD_S_VGP_S;
  double Igcd_VD_S_VD_S;
  double Igcd_VD_S_VS_BP;
  double Igcd_VGP_S_VGP_S;
  double Igcd_VGP_S_VD_S;
  double Igcd_VGP_S_VS_BP;
#endif
#endif
#if defined(_DERIVATE)
double Igcs_VGP_S;
double Igcs_VD_S;
double Igcs_VS_BP;
#endif
double Igb;
#if defined(_DERIVATE)
double Igb_VGP_S;
double Igb_VD_S;
double Igb_VS_BP;
#endif
double Igc;
#if defined(_DERIVATE)
double Igc_VGP_S;
double Igc_VD_S;
double Igc_VS_BP;
#endif
#if defined(_DERIVATEFORDDX)
double Igdov_VGP_S;
double Igdov_VD_S;
double Igdov_VS_BP;
#if defined(_DERIVATE2)
  double Igdov_VS_BP_VGP_S;
  double Igdov_VS_BP_VD_S;
  double Igdov_VS_BP_VS_BP;
  double Igdov_VD_S_VGP_S;
  double Igdov_VD_S_VD_S;
  double Igdov_VD_S_VS_BP;
  double Igdov_VGP_S_VGP_S;
  double Igdov_VGP_S_VD_S;
  double Igdov_VGP_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Igsov_VGP_S;
double Igsov_VD_S;
double Igsov_VS_BP;
#if defined(_DERIVATE2)
  double Igsov_VS_BP_VGP_S;
  double Igsov_VS_BP_VD_S;
  double Igsov_VS_BP_VS_BP;
  double Igsov_VD_S_VGP_S;
  double Igsov_VD_S_VD_S;
  double Igsov_VD_S_VS_BP;
  double Igsov_VGP_S_VGP_S;
  double Igsov_VGP_S_VD_S;
  double Igsov_VGP_S_VS_BP;
#endif
#endif
double SP_OV_u;
#if defined(_DERIVATEFORDDX)
double SP_OV_u_VGP_S;
double SP_OV_u_VD_S;
double SP_OV_u_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_u_VS_BP_VGP_S;
  double SP_OV_u_VS_BP_VD_S;
  double SP_OV_u_VS_BP_VS_BP;
  double SP_OV_u_VD_S_VGP_S;
  double SP_OV_u_VD_S_VD_S;
  double SP_OV_u_VD_S_VS_BP;
  double SP_OV_u_VGP_S_VGP_S;
  double SP_OV_u_VGP_S_VD_S;
  double SP_OV_u_VGP_S_VS_BP;
#endif
#endif
double SP_OV_x0;
#if defined(_DERIVATEFORDDX)
double SP_OV_x0_VGP_S;
double SP_OV_x0_VD_S;
double SP_OV_x0_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_x0_VS_BP_VGP_S;
  double SP_OV_x0_VS_BP_VD_S;
  double SP_OV_x0_VS_BP_VS_BP;
  double SP_OV_x0_VD_S_VGP_S;
  double SP_OV_x0_VD_S_VD_S;
  double SP_OV_x0_VD_S_VS_BP;
  double SP_OV_x0_VGP_S_VGP_S;
  double SP_OV_x0_VGP_S_VD_S;
  double SP_OV_x0_VGP_S_VS_BP;
#endif
#endif
double SP_OV_xbar;
#if defined(_DERIVATEFORDDX)
double SP_OV_xbar_VD_S;
double SP_OV_xbar_VGP_S;
#if defined(_DERIVATE2)
  double SP_OV_xbar_VGP_S_VD_S;
  double SP_OV_xbar_VGP_S_VGP_S;
  double SP_OV_xbar_VD_S_VD_S;
  double SP_OV_xbar_VD_S_VGP_S;
#endif
#endif
double SP_OV_Afac;
double SP_OV_w;
#if defined(_DERIVATEFORDDX)
double SP_OV_w_VGP_S;
double SP_OV_w_VD_S;
double SP_OV_w_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_w_VS_BP_VGP_S;
  double SP_OV_w_VS_BP_VD_S;
  double SP_OV_w_VS_BP_VS_BP;
  double SP_OV_w_VD_S_VGP_S;
  double SP_OV_w_VD_S_VD_S;
  double SP_OV_w_VD_S_VS_BP;
  double SP_OV_w_VGP_S_VGP_S;
  double SP_OV_w_VGP_S_VD_S;
  double SP_OV_w_VGP_S_VS_BP;
#endif
#endif
double SP_OV_xi;
#if defined(_DERIVATEFORDDX)
double SP_OV_xi_VGP_S;
double SP_OV_xi_VD_S;
double SP_OV_xi_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_xi_VS_BP_VGP_S;
  double SP_OV_xi_VS_BP_VD_S;
  double SP_OV_xi_VS_BP_VS_BP;
  double SP_OV_xi_VD_S_VGP_S;
  double SP_OV_xi_VD_S_VD_S;
  double SP_OV_xi_VD_S_VS_BP;
  double SP_OV_xi_VGP_S_VGP_S;
  double SP_OV_xi_VGP_S_VD_S;
  double SP_OV_xi_VGP_S_VS_BP;
#endif
#endif
double SP_OV_q;
#if defined(_DERIVATEFORDDX)
double SP_OV_q_VGP_S;
double SP_OV_q_VD_S;
double SP_OV_q_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_q_VS_BP_VGP_S;
  double SP_OV_q_VS_BP_VD_S;
  double SP_OV_q_VS_BP_VS_BP;
  double SP_OV_q_VD_S_VGP_S;
  double SP_OV_q_VD_S_VD_S;
  double SP_OV_q_VD_S_VS_BP;
  double SP_OV_q_VGP_S_VGP_S;
  double SP_OV_q_VGP_S_VD_S;
  double SP_OV_q_VGP_S_VS_BP;
#endif
#endif
double SP_OV_p;
#if defined(_DERIVATEFORDDX)
double SP_OV_p_VGP_S;
double SP_OV_p_VD_S;
double SP_OV_p_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_p_VS_BP_VGP_S;
  double SP_OV_p_VS_BP_VD_S;
  double SP_OV_p_VS_BP_VS_BP;
  double SP_OV_p_VD_S_VGP_S;
  double SP_OV_p_VD_S_VD_S;
  double SP_OV_p_VD_S_VS_BP;
  double SP_OV_p_VGP_S_VGP_S;
  double SP_OV_p_VGP_S_VD_S;
  double SP_OV_p_VGP_S_VS_BP;
#endif
#endif
double SP_OV_temp;
#if defined(_DERIVATEFORDDX)
double SP_OV_temp_VGP_S;
double SP_OV_temp_VD_S;
double SP_OV_temp_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_temp_VS_BP_VGP_S;
  double SP_OV_temp_VS_BP_VD_S;
  double SP_OV_temp_VS_BP_VS_BP;
  double SP_OV_temp_VD_S_VGP_S;
  double SP_OV_temp_VD_S_VD_S;
  double SP_OV_temp_VD_S_VS_BP;
  double SP_OV_temp_VGP_S_VGP_S;
  double SP_OV_temp_VGP_S_VD_S;
  double SP_OV_temp_VGP_S_VS_BP;
#endif
#endif
double SP_OV_D0;
#if defined(_DERIVATEFORDDX)
double SP_OV_D0_VGP_S;
double SP_OV_D0_VD_S;
double SP_OV_D0_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_D0_VS_BP_VGP_S;
  double SP_OV_D0_VS_BP_VD_S;
  double SP_OV_D0_VS_BP_VS_BP;
  double SP_OV_D0_VD_S_VGP_S;
  double SP_OV_D0_VD_S_VD_S;
  double SP_OV_D0_VD_S_VS_BP;
  double SP_OV_D0_VGP_S_VGP_S;
  double SP_OV_D0_VGP_S_VD_S;
  double SP_OV_D0_VGP_S_VS_BP;
#endif
#endif
double SP_OV_y0;
#if defined(_DERIVATEFORDDX)
double SP_OV_y0_VGP_S;
double SP_OV_y0_VD_S;
double SP_OV_y0_VS_BP;
#if defined(_DERIVATE2)
  double SP_OV_y0_VS_BP_VGP_S;
  double SP_OV_y0_VS_BP_VD_S;
  double SP_OV_y0_VS_BP_VS_BP;
  double SP_OV_y0_VD_S_VGP_S;
  double SP_OV_y0_VD_S_VD_S;
  double SP_OV_y0_VD_S_VS_BP;
  double SP_OV_y0_VGP_S_VGP_S;
  double SP_OV_y0_VGP_S_VD_S;
  double SP_OV_y0_VGP_S_VS_BP;
#endif
#endif
double SP_OV_tau;
#if defined(_DERIVATEFORDDX)
double SP_OV_tau_VD_S;
double SP_OV_tau_VGP_S;
#if defined(_DERIVATE2)
  double SP_OV_tau_VGP_S_VD_S;
  double SP_OV_tau_VGP_S_VGP_S;
  double SP_OV_tau_VD_S_VD_S;
  double SP_OV_tau_VD_S_VGP_S;
#endif
#endif
double SP_OV_c;
#if defined(_DERIVATEFORDDX)
double SP_OV_c_VD_S;
double SP_OV_c_VGP_S;
#if defined(_DERIVATE2)
  double SP_OV_c_VGP_S_VD_S;
  double SP_OV_c_VGP_S_VGP_S;
  double SP_OV_c_VD_S_VD_S;
  double SP_OV_c_VD_S_VGP_S;
#endif
#endif
double SP_OV_a;
#if defined(_DERIVATEFORDDX)
double SP_OV_a_VD_S;
double SP_OV_a_VGP_S;
#if defined(_DERIVATE2)
  double SP_OV_a_VGP_S_VD_S;
  double SP_OV_a_VGP_S_VGP_S;
  double SP_OV_a_VD_S_VD_S;
  double SP_OV_a_VD_S_VGP_S;
#endif
#endif
double SP_OV_eta;
#if defined(_DERIVATEFORDDX)
double SP_OV_eta_VD_S;
double SP_OV_eta_VGP_S;
#if defined(_DERIVATE2)
  double SP_OV_eta_VGP_S_VD_S;
  double SP_OV_eta_VGP_S_VGP_S;
  double SP_OV_eta_VD_S_VD_S;
  double SP_OV_eta_VD_S_VGP_S;
#endif
#endif
double SP_OV_z;
#if defined(_DERIVATEFORDDX)
double SP_OV_z_VD_S;
double SP_OV_z_VGP_S;
#if defined(_DERIVATE2)
  double SP_OV_z_VGP_S_VD_S;
  double SP_OV_z_VGP_S_VGP_S;
  double SP_OV_z_VD_S_VD_S;
  double SP_OV_z_VD_S_VGP_S;
#endif
#endif
double SP_OV_yg;
#if defined(_DERIVATEFORDDX)
double SP_OV_yg_VD_S;
double SP_OV_yg_VGP_S;
#if defined(_DERIVATE2)
  double SP_OV_yg_VGP_S_VD_S;
  double SP_OV_yg_VGP_S_VGP_S;
  double SP_OV_yg_VD_S_VD_S;
  double SP_OV_yg_VD_S_VGP_S;
#endif
#endif
double inv_xg1;
double x_mrg_ov;
double inv_xi_ov;
double xi_ov;
double GOV2;
double GOV;
double delVsat;
#if defined(_DERIVATEFORDDX)
double delVsat_VD_S;
double delVsat_VGP_S;
double delVsat_VS_BP;
#if defined(_DERIVATE2)
  double delVsat_VS_BP_VD_S;
  double delVsat_VS_BP_VGP_S;
  double delVsat_VS_BP_VS_BP;
  double delVsat_VGP_S_VD_S;
  double delVsat_VGP_S_VGP_S;
  double delVsat_VGP_S_VS_BP;
  double delVsat_VD_S_VD_S;
  double delVsat_VD_S_VGP_S;
  double delVsat_VD_S_VS_BP;
#endif
#endif
double alpha1;
#if defined(_DERIVATEFORDDX)
double alpha1_VD_S;
double alpha1_VGP_S;
double alpha1_VS_BP;
#if defined(_DERIVATE2)
  double alpha1_VS_BP_VD_S;
  double alpha1_VS_BP_VGP_S;
  double alpha1_VS_BP_VS_BP;
  double alpha1_VGP_S_VD_S;
  double alpha1_VGP_S_VGP_S;
  double alpha1_VGP_S_VS_BP;
  double alpha1_VD_S_VD_S;
  double alpha1_VD_S_VGP_S;
  double alpha1_VD_S_VS_BP;
#endif
#endif
double zsat;
#if defined(_DERIVATEFORDDX)
double zsat_VGP_S;
double zsat_VD_S;
double zsat_VS_BP;
#if defined(_DERIVATE2)
  double zsat_VS_BP_VGP_S;
  double zsat_VS_BP_VD_S;
  double zsat_VS_BP_VS_BP;
  double zsat_VD_S_VGP_S;
  double zsat_VD_S_VD_S;
  double zsat_VD_S_VS_BP;
  double zsat_VGP_S_VGP_S;
  double zsat_VGP_S_VD_S;
  double zsat_VGP_S_VS_BP;
#endif
#endif
double dL1;
#if defined(_DERIVATEFORDDX)
double dL1_VGP_S;
double dL1_VD_S;
double dL1_VS_BP;
#if defined(_DERIVATE2)
  double dL1_VS_BP_VGP_S;
  double dL1_VS_BP_VD_S;
  double dL1_VS_BP_VS_BP;
  double dL1_VD_S_VGP_S;
  double dL1_VD_S_VD_S;
  double dL1_VD_S_VS_BP;
  double dL1_VGP_S_VGP_S;
  double dL1_VGP_S_VD_S;
  double dL1_VGP_S_VS_BP;
#endif
#endif
double dL;
#if defined(_DERIVATEFORDDX)
double dL_VGP_S;
double dL_VD_S;
double dL_VS_BP;
#if defined(_DERIVATE2)
  double dL_VS_BP_VGP_S;
  double dL_VS_BP_VD_S;
  double dL_VS_BP_VS_BP;
  double dL_VD_S_VGP_S;
  double dL_VD_S_VD_S;
  double dL_VD_S_VS_BP;
  double dL_VGP_S_VGP_S;
  double dL_VGP_S_VD_S;
  double dL_VGP_S_VS_BP;
#endif
#endif
double r2;
#if defined(_DERIVATEFORDDX)
double r2_VD_S;
double r2_VGP_S;
double r2_VS_BP;
#if defined(_DERIVATE2)
  double r2_VS_BP_VD_S;
  double r2_VS_BP_VGP_S;
  double r2_VS_BP_VS_BP;
  double r2_VGP_S_VD_S;
  double r2_VGP_S_VGP_S;
  double r2_VGP_S_VS_BP;
  double r2_VD_S_VD_S;
  double r2_VD_S_VGP_S;
  double r2_VD_S_VS_BP;
#endif
#endif
double r1;
#if defined(_DERIVATEFORDDX)
double r1_VD_S;
double r1_VGP_S;
double r1_VS_BP;
#if defined(_DERIVATE2)
  double r1_VS_BP_VD_S;
  double r1_VS_BP_VGP_S;
  double r1_VS_BP_VS_BP;
  double r1_VGP_S_VD_S;
  double r1_VGP_S_VGP_S;
  double r1_VGP_S_VS_BP;
  double r1_VD_S_VD_S;
  double r1_VD_S_VGP_S;
  double r1_VD_S_VS_BP;
#endif
#endif
double qbm;
#if defined(_DERIVATEFORDDX)
double qbm_VD_S;
double qbm_VGP_S;
double qbm_VS_BP;
#if defined(_DERIVATE2)
  double qbm_VS_BP_VD_S;
  double qbm_VS_BP_VGP_S;
  double qbm_VS_BP_VS_BP;
  double qbm_VGP_S_VD_S;
  double qbm_VGP_S_VGP_S;
  double qbm_VGP_S_VS_BP;
  double qbm_VD_S_VD_S;
  double qbm_VD_S_VGP_S;
  double qbm_VD_S_VS_BP;
#endif
#endif
double qim1_1;
#if defined(_DERIVATEFORDDX)
double qim1_1_VD_S;
double qim1_1_VGP_S;
double qim1_1_VS_BP;
#if defined(_DERIVATE2)
  double qim1_1_VS_BP_VD_S;
  double qim1_1_VS_BP_VGP_S;
  double qim1_1_VS_BP_VS_BP;
  double qim1_1_VGP_S_VD_S;
  double qim1_1_VGP_S_VGP_S;
  double qim1_1_VGP_S_VS_BP;
  double qim1_1_VD_S_VD_S;
  double qim1_1_VD_S_VGP_S;
  double qim1_1_VD_S_VS_BP;
#endif
#endif
double help;
#if defined(_DERIVATEFORDDX)
double help_VD_S;
double help_VGP_S;
double help_VS_BP;
#if defined(_DERIVATE2)
  double help_VS_BP_VD_S;
  double help_VS_BP_VGP_S;
  double help_VS_BP_VS_BP;
  double help_VGP_S_VD_S;
  double help_VGP_S_VGP_S;
  double help_VGP_S_VS_BP;
  double help_VD_S_VD_S;
  double help_VD_S_VGP_S;
  double help_VD_S_VS_BP;
#endif
#endif
double km;
#if defined(_DERIVATEFORDDX)
double km_VGP_S;
double km_VD_S;
double km_VS_BP;
#if defined(_DERIVATE2)
  double km_VS_BP_VGP_S;
  double km_VS_BP_VD_S;
  double km_VS_BP_VS_BP;
  double km_VD_S_VGP_S;
  double km_VD_S_VD_S;
  double km_VD_S_VS_BP;
  double km_VGP_S_VGP_S;
  double km_VGP_S_VD_S;
  double km_VGP_S_VS_BP;
#endif
#endif
double u_pd;
#if defined(_DERIVATEFORDDX)
double u_pd_VGP_S;
double u_pd_VD_S;
double u_pd_VS_BP;
#if defined(_DERIVATE2)
  double u_pd_VS_BP_VGP_S;
  double u_pd_VS_BP_VD_S;
  double u_pd_VS_BP_VS_BP;
  double u_pd_VD_S_VGP_S;
  double u_pd_VD_S_VD_S;
  double u_pd_VD_S_VS_BP;
  double u_pd_VGP_S_VGP_S;
  double u_pd_VGP_S_VD_S;
  double u_pd_VGP_S_VS_BP;
#endif
#endif
double xi_pd;
#if defined(_DERIVATEFORDDX)
double xi_pd_VD_S;
double xi_pd_VGP_S;
double xi_pd_VS_BP;
#if defined(_DERIVATE2)
  double xi_pd_VS_BP_VD_S;
  double xi_pd_VS_BP_VGP_S;
  double xi_pd_VS_BP_VS_BP;
  double xi_pd_VGP_S_VD_S;
  double xi_pd_VGP_S_VGP_S;
  double xi_pd_VGP_S_VS_BP;
  double xi_pd_VD_S_VD_S;
  double xi_pd_VD_S_VGP_S;
  double xi_pd_VD_S_VS_BP;
#endif
#endif
double q_pd;
#if defined(_DERIVATEFORDDX)
double q_pd_VGP_S;
double q_pd_VD_S;
double q_pd_VS_BP;
#if defined(_DERIVATE2)
  double q_pd_VS_BP_VGP_S;
  double q_pd_VS_BP_VD_S;
  double q_pd_VS_BP_VS_BP;
  double q_pd_VD_S_VGP_S;
  double q_pd_VD_S_VD_S;
  double q_pd_VD_S_VS_BP;
  double q_pd_VGP_S_VGP_S;
  double q_pd_VGP_S_VD_S;
  double q_pd_VGP_S_VS_BP;
#endif
#endif
double p_pd;
#if defined(_DERIVATEFORDDX)
double p_pd_VD_S;
double p_pd_VGP_S;
double p_pd_VS_BP;
#if defined(_DERIVATE2)
  double p_pd_VS_BP_VD_S;
  double p_pd_VS_BP_VGP_S;
  double p_pd_VS_BP_VS_BP;
  double p_pd_VGP_S_VD_S;
  double p_pd_VGP_S_VGP_S;
  double p_pd_VGP_S_VS_BP;
  double p_pd_VD_S_VD_S;
  double p_pd_VD_S_VGP_S;
  double p_pd_VD_S_VS_BP;
#endif
#endif
double x_pm;
#if defined(_DERIVATEFORDDX)
double x_pm_VGP_S;
double x_pm_VD_S;
double x_pm_VS_BP;
#if defined(_DERIVATE2)
  double x_pm_VS_BP_VGP_S;
  double x_pm_VS_BP_VD_S;
  double x_pm_VS_BP_VS_BP;
  double x_pm_VD_S_VGP_S;
  double x_pm_VD_S_VD_S;
  double x_pm_VD_S_VS_BP;
  double x_pm_VGP_S_VGP_S;
  double x_pm_VGP_S_VD_S;
  double x_pm_VGP_S_VS_BP;
#endif
#endif
double d0;
#if defined(_DERIVATEFORDDX)
double d0_VD_S;
double d0_VGP_S;
double d0_VS_BP;
#if defined(_DERIVATE2)
  double d0_VS_BP_VD_S;
  double d0_VS_BP_VGP_S;
  double d0_VS_BP_VS_BP;
  double d0_VGP_S_VD_S;
  double d0_VGP_S_VGP_S;
  double d0_VGP_S_VS_BP;
  double d0_VD_S_VD_S;
  double d0_VD_S_VGP_S;
  double d0_VD_S_VS_BP;
#endif
#endif
double Pm;
#if defined(_DERIVATEFORDDX)
double Pm_VD_S;
double Pm_VGP_S;
double Pm_VS_BP;
#if defined(_DERIVATE2)
  double Pm_VS_BP_VD_S;
  double Pm_VS_BP_VGP_S;
  double Pm_VS_BP_VS_BP;
  double Pm_VGP_S_VD_S;
  double Pm_VGP_S_VGP_S;
  double Pm_VGP_S_VS_BP;
  double Pm_VD_S_VD_S;
  double Pm_VD_S_VGP_S;
  double Pm_VD_S_VS_BP;
#endif
#endif
double D_bar;
#if defined(_DERIVATEFORDDX)
double D_bar_VD_S;
double D_bar_VGP_S;
double D_bar_VS_BP;
#if defined(_DERIVATE2)
  double D_bar_VS_BP_VD_S;
  double D_bar_VS_BP_VGP_S;
  double D_bar_VS_BP_VS_BP;
  double D_bar_VGP_S_VD_S;
  double D_bar_VGP_S_VGP_S;
  double D_bar_VGP_S_VS_BP;
  double D_bar_VD_S_VD_S;
  double D_bar_VD_S_VGP_S;
  double D_bar_VD_S_VS_BP;
#endif
#endif
double xi0d;
#if defined(_DERIVATEFORDDX)
double xi0d_VD_S;
double xi0d_VGP_S;
double xi0d_VS_BP;
#if defined(_DERIVATE2)
  double xi0d_VS_BP_VD_S;
  double xi0d_VS_BP_VGP_S;
  double xi0d_VS_BP_VS_BP;
  double xi0d_VGP_S_VD_S;
  double xi0d_VGP_S_VGP_S;
  double xi0d_VGP_S_VS_BP;
  double xi0d_VD_S_VD_S;
  double xi0d_VD_S_VGP_S;
  double xi0d_VD_S_VS_BP;
#endif
#endif
double qC;
#if defined(_DERIVATEFORDDX)
double qC_VD_S;
double qC_VGP_S;
double qC_VS_BP;
#if defined(_DERIVATE2)
  double qC_VS_BP_VD_S;
  double qC_VS_BP_VGP_S;
  double qC_VS_BP_VS_BP;
  double qC_VGP_S_VD_S;
  double qC_VGP_S_VGP_S;
  double qC_VGP_S_VS_BP;
  double qC_VD_S_VD_S;
  double qC_VD_S_VGP_S;
  double qC_VD_S_VS_BP;
#endif
#endif
double pC;
#if defined(_DERIVATEFORDDX)
double pC_VD_S;
double pC_VGP_S;
double pC_VS_BP;
#if defined(_DERIVATE2)
  double pC_VS_BP_VD_S;
  double pC_VS_BP_VGP_S;
  double pC_VS_BP_VS_BP;
  double pC_VGP_S_VD_S;
  double pC_VGP_S_VGP_S;
  double pC_VGP_S_VS_BP;
  double pC_VD_S_VD_S;
  double pC_VD_S_VGP_S;
  double pC_VD_S_VS_BP;
#endif
#endif
double delta_nd;
#if defined(_DERIVATEFORDDX)
double delta_nd_VD_S;
double delta_nd_VS_BP;
double delta_nd_VGP_S;
#if defined(_DERIVATE2)
  double delta_nd_VGP_S_VD_S;
  double delta_nd_VGP_S_VS_BP;
  double delta_nd_VGP_S_VGP_S;
  double delta_nd_VS_BP_VD_S;
  double delta_nd_VS_BP_VS_BP;
  double delta_nd_VS_BP_VGP_S;
  double delta_nd_VD_S_VD_S;
  double delta_nd_VD_S_VS_BP;
  double delta_nd_VD_S_VGP_S;
#endif
#endif
double k_ds;
#if defined(_DERIVATEFORDDX)
double k_ds_VGP_S;
double k_ds_VS_BP;
double k_ds_VD_S;
#if defined(_DERIVATE2)
  double k_ds_VD_S_VGP_S;
  double k_ds_VD_S_VS_BP;
  double k_ds_VD_S_VD_S;
  double k_ds_VS_BP_VGP_S;
  double k_ds_VS_BP_VS_BP;
  double k_ds_VS_BP_VD_S;
  double k_ds_VGP_S_VGP_S;
  double k_ds_VGP_S_VS_BP;
  double k_ds_VGP_S_VD_S;
#endif
#endif
double xn_d;
#if defined(_DERIVATEFORDDX)
double xn_d_VD_S;
double xn_d_VS_BP;
double xn_d_VGP_S;
#if defined(_DERIVATE2)
  double xn_d_VGP_S_VD_S;
  double xn_d_VGP_S_VS_BP;
  double xn_d_VGP_S_VGP_S;
  double xn_d_VS_BP_VD_S;
  double xn_d_VS_BP_VS_BP;
  double xn_d_VS_BP_VGP_S;
  double xn_d_VD_S_VD_S;
  double xn_d_VD_S_VS_BP;
  double xn_d_VD_S_VGP_S;
#endif
#endif
double Phi_sat;
#if defined(_DERIVATEFORDDX)
double Phi_sat_VD_S;
double Phi_sat_VGP_S;
double Phi_sat_VS_BP;
#if defined(_DERIVATE2)
  double Phi_sat_VS_BP_VD_S;
  double Phi_sat_VS_BP_VGP_S;
  double Phi_sat_VS_BP_VS_BP;
  double Phi_sat_VGP_S_VD_S;
  double Phi_sat_VGP_S_VGP_S;
  double Phi_sat_VGP_S_VS_BP;
  double Phi_sat_VD_S_VD_S;
  double Phi_sat_VD_S_VGP_S;
  double Phi_sat_VD_S_VS_BP;
#endif
#endif
double Phi0_Phi2;
#if defined(_DERIVATEFORDDX)
double Phi0_Phi2_VD_S;
double Phi0_Phi2_VGP_S;
double Phi0_Phi2_VS_BP;
#if defined(_DERIVATE2)
  double Phi0_Phi2_VS_BP_VD_S;
  double Phi0_Phi2_VS_BP_VGP_S;
  double Phi0_Phi2_VS_BP_VS_BP;
  double Phi0_Phi2_VGP_S_VD_S;
  double Phi0_Phi2_VGP_S_VGP_S;
  double Phi0_Phi2_VGP_S_VS_BP;
  double Phi0_Phi2_VD_S_VD_S;
  double Phi0_Phi2_VD_S_VGP_S;
  double Phi0_Phi2_VD_S_VS_BP;
#endif
#endif
double Phi_0_2;
#if defined(_DERIVATEFORDDX)
double Phi_0_2_VD_S;
double Phi_0_2_VGP_S;
double Phi_0_2_VS_BP;
#if defined(_DERIVATE2)
  double Phi_0_2_VS_BP_VD_S;
  double Phi_0_2_VS_BP_VGP_S;
  double Phi_0_2_VS_BP_VS_BP;
  double Phi_0_2_VGP_S_VD_S;
  double Phi_0_2_VGP_S_VGP_S;
  double Phi_0_2_VGP_S_VS_BP;
  double Phi_0_2_VD_S_VD_S;
  double Phi_0_2_VD_S_VGP_S;
  double Phi_0_2_VD_S_VS_BP;
#endif
#endif
double Phi_2;
#if defined(_DERIVATEFORDDX)
double Phi_2_VD_S;
double Phi_2_VGP_S;
double Phi_2_VS_BP;
#if defined(_DERIVATE2)
  double Phi_2_VS_BP_VD_S;
  double Phi_2_VS_BP_VGP_S;
  double Phi_2_VS_BP_VS_BP;
  double Phi_2_VGP_S_VD_S;
  double Phi_2_VGP_S_VGP_S;
  double Phi_2_VGP_S_VS_BP;
  double Phi_2_VD_S_VD_S;
  double Phi_2_VD_S_VGP_S;
  double Phi_2_VD_S_VS_BP;
#endif
#endif
double asat;
#if defined(_DERIVATEFORDDX)
double asat_VD_S;
double asat_VGP_S;
double asat_VS_BP;
#if defined(_DERIVATE2)
  double asat_VS_BP_VD_S;
  double asat_VS_BP_VGP_S;
  double asat_VS_BP_VS_BP;
  double asat_VGP_S_VD_S;
  double asat_VGP_S_VGP_S;
  double asat_VGP_S_VS_BP;
  double asat_VD_S_VD_S;
  double asat_VD_S_VGP_S;
  double asat_VD_S_VS_BP;
#endif
#endif
double Phi_0;
#if defined(_DERIVATEFORDDX)
double Phi_0_VD_S;
double Phi_0_VGP_S;
double Phi_0_VS_BP;
#if defined(_DERIVATE2)
  double Phi_0_VS_BP_VD_S;
  double Phi_0_VS_BP_VGP_S;
  double Phi_0_VS_BP_VS_BP;
  double Phi_0_VGP_S_VD_S;
  double Phi_0_VGP_S_VGP_S;
  double Phi_0_VGP_S_VS_BP;
  double Phi_0_VD_S_VD_S;
  double Phi_0_VD_S_VGP_S;
  double Phi_0_VD_S_VS_BP;
#endif
#endif
double temp1;
#if defined(_DERIVATEFORDDX)
double temp1_VGP_S;
double temp1_VD_S;
double temp1_VS_BP;
#if defined(_DERIVATE2)
  double temp1_VS_BP_VGP_S;
  double temp1_VS_BP_VD_S;
  double temp1_VS_BP_VS_BP;
  double temp1_VD_S_VGP_S;
  double temp1_VD_S_VD_S;
  double temp1_VD_S_VS_BP;
  double temp1_VGP_S_VGP_S;
  double temp1_VGP_S_VD_S;
  double temp1_VGP_S_VS_BP;
#endif
#endif
double za;
#if defined(_DERIVATEFORDDX)
double za_VGP_S;
double za_VD_S;
double za_VS_BP;
#if defined(_DERIVATE2)
  double za_VS_BP_VGP_S;
  double za_VS_BP_VD_S;
  double za_VS_BP_VS_BP;
  double za_VD_S_VGP_S;
  double za_VD_S_VD_S;
  double za_VD_S_VS_BP;
  double za_VGP_S_VGP_S;
  double za_VGP_S_VD_S;
  double za_VGP_S_VS_BP;
#endif
#endif
double ysat;
#if defined(_DERIVATEFORDDX)
double ysat_VGP_S;
double ysat_VD_S;
double ysat_VS_BP;
#if defined(_DERIVATE2)
  double ysat_VS_BP_VGP_S;
  double ysat_VS_BP_VD_S;
  double ysat_VS_BP_VS_BP;
  double ysat_VD_S_VGP_S;
  double ysat_VD_S_VD_S;
  double ysat_VD_S_VS_BP;
  double ysat_VGP_S_VGP_S;
  double ysat_VGP_S_VD_S;
  double ysat_VGP_S_VS_BP;
#endif
#endif
double phi_inf;
#if defined(_DERIVATEFORDDX)
double phi_inf_VD_S;
double phi_inf_VGP_S;
double phi_inf_VS_BP;
#if defined(_DERIVATE2)
  double phi_inf_VS_BP_VD_S;
  double phi_inf_VS_BP_VGP_S;
  double phi_inf_VS_BP_VS_BP;
  double phi_inf_VGP_S_VD_S;
  double phi_inf_VGP_S_VGP_S;
  double phi_inf_VGP_S_VS_BP;
  double phi_inf_VD_S_VD_S;
  double phi_inf_VD_S_VGP_S;
  double phi_inf_VD_S_VS_BP;
#endif
#endif
double wsat;
#if defined(_DERIVATEFORDDX)
double wsat_VD_S;
double wsat_VGP_S;
double wsat_VS_BP;
#if defined(_DERIVATE2)
  double wsat_VS_BP_VD_S;
  double wsat_VS_BP_VGP_S;
  double wsat_VS_BP_VS_BP;
  double wsat_VGP_S_VD_S;
  double wsat_VGP_S_VGP_S;
  double wsat_VGP_S_VS_BP;
  double wsat_VD_S_VD_S;
  double wsat_VD_S_VGP_S;
  double wsat_VD_S_VS_BP;
#endif
#endif
double temp2;
#if defined(_DERIVATEFORDDX)
double temp2_VD_S;
double temp2_VGP_S;
double temp2_VS_BP;
#if defined(_DERIVATE2)
  double temp2_VS_BP_VD_S;
  double temp2_VS_BP_VGP_S;
  double temp2_VS_BP_VS_BP;
  double temp2_VGP_S_VD_S;
  double temp2_VGP_S_VGP_S;
  double temp2_VGP_S_VS_BP;
  double temp2_VD_S_VD_S;
  double temp2_VD_S_VGP_S;
  double temp2_VD_S_VS_BP;
#endif
#endif
double Mutmp;
#if defined(_DERIVATEFORDDX)
double Mutmp_VD_S;
double Mutmp_VGP_S;
double Mutmp_VS_BP;
#if defined(_DERIVATE2)
  double Mutmp_VS_BP_VD_S;
  double Mutmp_VS_BP_VGP_S;
  double Mutmp_VS_BP_VS_BP;
  double Mutmp_VGP_S_VD_S;
  double Mutmp_VGP_S_VGP_S;
  double Mutmp_VGP_S_VS_BP;
  double Mutmp_VD_S_VD_S;
  double Mutmp_VD_S_VGP_S;
  double Mutmp_VD_S_VS_BP;
#endif
#endif
double Eeffm;
#if defined(_DERIVATEFORDDX)
double Eeffm_VD_S;
double Eeffm_VGP_S;
double Eeffm_VS_BP;
#if defined(_DERIVATE2)
  double Eeffm_VS_BP_VD_S;
  double Eeffm_VS_BP_VGP_S;
  double Eeffm_VS_BP_VS_BP;
  double Eeffm_VGP_S_VD_S;
  double Eeffm_VGP_S_VGP_S;
  double Eeffm_VGP_S_VS_BP;
  double Eeffm_VD_S_VD_S;
  double Eeffm_VD_S_VGP_S;
  double Eeffm_VD_S_VS_BP;
#endif
#endif
double GR;
#if defined(_DERIVATEFORDDX)
double GR_VD_S;
double GR_VS_BP;
double GR_VGP_S;
#if defined(_DERIVATE2)
  double GR_VGP_S_VD_S;
  double GR_VGP_S_VS_BP;
  double GR_VGP_S_VGP_S;
  double GR_VS_BP_VD_S;
  double GR_VS_BP_VS_BP;
  double GR_VS_BP_VGP_S;
  double GR_VD_S_VD_S;
  double GR_VD_S_VS_BP;
  double GR_VD_S_VGP_S;
#endif
#endif
double qbs;
#if defined(_DERIVATEFORDDX)
double qbs_VD_S;
double qbs_VGP_S;
double qbs_VS_BP;
#if defined(_DERIVATE2)
  double qbs_VS_BP_VD_S;
  double qbs_VS_BP_VGP_S;
  double qbs_VS_BP_VS_BP;
  double qbs_VGP_S_VD_S;
  double qbs_VGP_S_VGP_S;
  double qbs_VGP_S_VS_BP;
  double qbs_VD_S_VD_S;
  double qbs_VD_S_VGP_S;
  double qbs_VD_S_VS_BP;
#endif
#endif
double xgs;
#if defined(_DERIVATEFORDDX)
double xgs_VD_S;
double xgs_VGP_S;
double xgs_VS_BP;
#if defined(_DERIVATE2)
  double xgs_VS_BP_VD_S;
  double xgs_VS_BP_VGP_S;
  double xgs_VS_BP_VS_BP;
  double xgs_VGP_S_VD_S;
  double xgs_VGP_S_VGP_S;
  double xgs_VGP_S_VS_BP;
  double xgs_VD_S_VD_S;
  double xgs_VD_S_VGP_S;
  double xgs_VD_S_VS_BP;
#endif
#endif
double Rxcor;
#if defined(_DERIVATEFORDDX)
double Rxcor_VD_S;
double Rxcor_VS_BP;
#if defined(_DERIVATE2)
  double Rxcor_VS_BP_VD_S;
  double Rxcor_VS_BP_VS_BP;
  double Rxcor_VD_S_VD_S;
  double Rxcor_VD_S_VS_BP;
#endif
#endif
double Dd;
#if defined(_DERIVATEFORDDX)
double Dd_VD_S;
double Dd_VGP_S;
double Dd_VS_BP;
#if defined(_DERIVATE2)
  double Dd_VS_BP_VD_S;
  double Dd_VS_BP_VGP_S;
  double Dd_VS_BP_VS_BP;
  double Dd_VGP_S_VD_S;
  double Dd_VGP_S_VGP_S;
  double Dd_VGP_S_VS_BP;
  double Dd_VD_S_VD_S;
  double Dd_VD_S_VGP_S;
  double Dd_VD_S_VS_BP;
#endif
#endif
double Dm;
#if defined(_DERIVATEFORDDX)
double Dm_VD_S;
double Dm_VGP_S;
double Dm_VS_BP;
#if defined(_DERIVATE2)
  double Dm_VS_BP_VD_S;
  double Dm_VS_BP_VGP_S;
  double Dm_VS_BP_VS_BP;
  double Dm_VGP_S_VD_S;
  double Dm_VGP_S_VGP_S;
  double Dm_VGP_S_VS_BP;
  double Dm_VD_S_VD_S;
  double Dm_VD_S_VGP_S;
  double Dm_VD_S_VS_BP;
#endif
#endif
double Ed;
#if defined(_DERIVATEFORDDX)
double Ed_VD_S;
double Ed_VGP_S;
double Ed_VS_BP;
#if defined(_DERIVATE2)
  double Ed_VS_BP_VD_S;
  double Ed_VS_BP_VGP_S;
  double Ed_VS_BP_VS_BP;
  double Ed_VGP_S_VD_S;
  double Ed_VGP_S_VGP_S;
  double Ed_VGP_S_VS_BP;
  double Ed_VD_S_VD_S;
  double Ed_VD_S_VGP_S;
  double Ed_VD_S_VS_BP;
#endif
#endif
double Em;
#if defined(_DERIVATEFORDDX)
double Em_VD_S;
double Em_VGP_S;
double Em_VS_BP;
#if defined(_DERIVATE2)
  double Em_VS_BP_VD_S;
  double Em_VS_BP_VGP_S;
  double Em_VS_BP_VS_BP;
  double Em_VGP_S_VD_S;
  double Em_VGP_S_VGP_S;
  double Em_VGP_S_VS_BP;
  double Em_VD_S_VD_S;
  double Em_VD_S_VGP_S;
  double Em_VD_S_VS_BP;
#endif
#endif
double Ps;
#if defined(_DERIVATEFORDDX)
double Ps_VD_S;
double Ps_VGP_S;
double Ps_VS_BP;
#if defined(_DERIVATE2)
  double Ps_VS_BP_VD_S;
  double Ps_VS_BP_VGP_S;
  double Ps_VS_BP_VS_BP;
  double Ps_VGP_S_VD_S;
  double Ps_VGP_S_VGP_S;
  double Ps_VGP_S_VS_BP;
  double Ps_VD_S_VD_S;
  double Ps_VD_S_VGP_S;
  double Ps_VD_S_VS_BP;
#endif
#endif
double Ds;
#if defined(_DERIVATEFORDDX)
double Ds_VD_S;
double Ds_VGP_S;
double Ds_VS_BP;
#if defined(_DERIVATE2)
  double Ds_VS_BP_VD_S;
  double Ds_VS_BP_VGP_S;
  double Ds_VS_BP_VS_BP;
  double Ds_VGP_S_VD_S;
  double Ds_VGP_S_VGP_S;
  double Ds_VGP_S_VS_BP;
  double Ds_VD_S_VD_S;
  double Ds_VD_S_VGP_S;
  double Ds_VD_S_VS_BP;
#endif
#endif
double Es;
#if defined(_DERIVATEFORDDX)
double Es_VD_S;
double Es_VGP_S;
double Es_VS_BP;
#if defined(_DERIVATE2)
  double Es_VS_BP_VD_S;
  double Es_VS_BP_VGP_S;
  double Es_VS_BP_VS_BP;
  double Es_VGP_S_VD_S;
  double Es_VGP_S_VGP_S;
  double Es_VGP_S_VS_BP;
  double Es_VD_S_VD_S;
  double Es_VD_S_VGP_S;
  double Es_VD_S_VS_BP;
#endif
#endif
double xi2s;
#if defined(_DERIVATEFORDDX)
double xi2s_VGP_S;
double xi2s_VD_S;
double xi2s_VS_BP;
#if defined(_DERIVATE2)
  double xi2s_VS_BP_VGP_S;
  double xi2s_VS_BP_VD_S;
  double xi2s_VS_BP_VS_BP;
  double xi2s_VD_S_VGP_S;
  double xi2s_VD_S_VD_S;
  double xi2s_VD_S_VS_BP;
  double xi2s_VGP_S_VGP_S;
  double xi2s_VGP_S_VD_S;
  double xi2s_VGP_S_VS_BP;
#endif
#endif
double xi1s;
#if defined(_DERIVATEFORDDX)
double xi1s_VD_S;
double xi1s_VGP_S;
double xi1s_VS_BP;
#if defined(_DERIVATE2)
  double xi1s_VS_BP_VD_S;
  double xi1s_VS_BP_VGP_S;
  double xi1s_VS_BP_VS_BP;
  double xi1s_VGP_S_VD_S;
  double xi1s_VGP_S_VGP_S;
  double xi1s_VGP_S_VS_BP;
  double xi1s_VD_S_VD_S;
  double xi1s_VD_S_VGP_S;
  double xi1s_VD_S_VS_BP;
#endif
#endif
double xi0s;
#if defined(_DERIVATEFORDDX)
double xi0s_VD_S;
double xi0s_VGP_S;
double xi0s_VS_BP;
#if defined(_DERIVATE2)
  double xi0s_VS_BP_VD_S;
  double xi0s_VS_BP_VGP_S;
  double xi0s_VS_BP_VS_BP;
  double xi0s_VGP_S_VD_S;
  double xi0s_VGP_S_VGP_S;
  double xi0s_VGP_S_VS_BP;
  double xi0s_VD_S_VD_S;
  double xi0s_VD_S_VGP_S;
  double xi0s_VD_S_VS_BP;
#endif
#endif
double delta_1s;
#if defined(_DERIVATEFORDDX)
double delta_1s_VD_S;
double delta_1s_VGP_S;
double delta_1s_VS_BP;
#if defined(_DERIVATE2)
  double delta_1s_VS_BP_VD_S;
  double delta_1s_VS_BP_VGP_S;
  double delta_1s_VS_BP_VS_BP;
  double delta_1s_VGP_S_VD_S;
  double delta_1s_VGP_S_VGP_S;
  double delta_1s_VGP_S_VS_BP;
  double delta_1s_VD_S_VD_S;
  double delta_1s_VD_S_VGP_S;
  double delta_1s_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Vdse_VGP_S;
double Vdse_VS_BP;
double Vdse_VD_S;
#if defined(_DERIVATE2)
  double Vdse_VD_S_VGP_S;
  double Vdse_VD_S_VS_BP;
  double Vdse_VD_S_VD_S;
  double Vdse_VS_BP_VGP_S;
  double Vdse_VS_BP_VS_BP;
  double Vdse_VS_BP_VD_S;
  double Vdse_VGP_S_VGP_S;
  double Vdse_VGP_S_VS_BP;
  double Vdse_VGP_S_VD_S;
#endif
#endif
double Vdsat;
#if defined(_DERIVATEFORDDX)
double Vdsat_VD_S;
double Vdsat_VGP_S;
double Vdsat_VS_BP;
#if defined(_DERIVATE2)
  double Vdsat_VS_BP_VD_S;
  double Vdsat_VS_BP_VGP_S;
  double Vdsat_VS_BP_VS_BP;
  double Vdsat_VGP_S_VD_S;
  double Vdsat_VGP_S_VGP_S;
  double Vdsat_VGP_S_VS_BP;
  double Vdsat_VD_S_VD_S;
  double Vdsat_VD_S_VGP_S;
  double Vdsat_VD_S_VS_BP;
#endif
#endif
double qeff;
#if defined(_DERIVATEFORDDX)
double qeff_VD_S;
double qeff_VGP_S;
double qeff_VS_BP;
#if defined(_DERIVATE2)
  double qeff_VS_BP_VD_S;
  double qeff_VS_BP_VGP_S;
  double qeff_VS_BP_VS_BP;
  double qeff_VGP_S_VD_S;
  double qeff_VGP_S_VGP_S;
  double qeff_VGP_S_VS_BP;
  double qeff_VD_S_VD_S;
  double qeff_VD_S_VGP_S;
  double qeff_VD_S_VS_BP;
#endif
#endif
double Voxm;
#if defined(_DERIVATEFORDDX)
double Voxm_VD_S;
double Voxm_VGP_S;
double Voxm_VS_BP;
#if defined(_DERIVATE2)
  double Voxm_VS_BP_VD_S;
  double Voxm_VS_BP_VGP_S;
  double Voxm_VS_BP_VS_BP;
  double Voxm_VGP_S_VD_S;
  double Voxm_VGP_S_VGP_S;
  double Voxm_VGP_S_VS_BP;
  double Voxm_VD_S_VD_S;
  double Voxm_VD_S_VGP_S;
  double Voxm_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Ids_VGP_S;
double Ids_VD_S;
double Ids_VS_BP;
#if defined(_DERIVATE2)
  double Ids_VS_BP_VGP_S;
  double Ids_VS_BP_VD_S;
  double Ids_VS_BP_VS_BP;
  double Ids_VD_S_VGP_S;
  double Ids_VD_S_VD_S;
  double Ids_VD_S_VS_BP;
  double Ids_VGP_S_VGP_S;
  double Ids_VGP_S_VD_S;
  double Ids_VGP_S_VS_BP;
#endif
#endif
double qis;
#if defined(_DERIVATEFORDDX)
double qis_VD_S;
double qis_VGP_S;
double qis_VS_BP;
#if defined(_DERIVATE2)
  double qis_VS_BP_VD_S;
  double qis_VS_BP_VGP_S;
  double qis_VS_BP_VS_BP;
  double qis_VGP_S_VD_S;
  double qis_VGP_S_VGP_S;
  double qis_VGP_S_VS_BP;
  double qis_VD_S_VD_S;
  double qis_VD_S_VGP_S;
  double qis_VD_S_VS_BP;
#endif
#endif
double x_ds;
#if defined(_DERIVATEFORDDX)
double x_ds_VD_S;
double x_ds_VGP_S;
double x_ds_VS_BP;
#if defined(_DERIVATE2)
  double x_ds_VS_BP_VD_S;
  double x_ds_VS_BP_VGP_S;
  double x_ds_VS_BP_VS_BP;
  double x_ds_VGP_S_VD_S;
  double x_ds_VGP_S_VGP_S;
  double x_ds_VGP_S_VS_BP;
  double x_ds_VD_S_VD_S;
  double x_ds_VD_S_VGP_S;
  double x_ds_VD_S_VS_BP;
#endif
#endif
double x_m;
#if defined(_DERIVATEFORDDX)
double x_m_VD_S;
double x_m_VGP_S;
double x_m_VS_BP;
#if defined(_DERIVATE2)
  double x_m_VS_BP_VD_S;
  double x_m_VS_BP_VGP_S;
  double x_m_VS_BP_VS_BP;
  double x_m_VGP_S_VD_S;
  double x_m_VGP_S_VGP_S;
  double x_m_VGP_S_VS_BP;
  double x_m_VD_S_VD_S;
  double x_m_VD_S_VGP_S;
  double x_m_VD_S_VS_BP;
#endif
#endif
double x_d;
#if defined(_DERIVATEFORDDX)
double x_d_VD_S;
double x_d_VGP_S;
double x_d_VS_BP;
#if defined(_DERIVATE2)
  double x_d_VS_BP_VD_S;
  double x_d_VS_BP_VGP_S;
  double x_d_VS_BP_VS_BP;
  double x_d_VGP_S_VD_S;
  double x_d_VGP_S_VGP_S;
  double x_d_VGP_S_VS_BP;
  double x_d_VD_S_VD_S;
  double x_d_VD_S_VGP_S;
  double x_d_VD_S_VS_BP;
#endif
#endif
double SP_S_x0;
#if defined(_DERIVATEFORDDX)
double SP_S_x0_VD_S;
double SP_S_x0_VGP_S;
double SP_S_x0_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_x0_VS_BP_VD_S;
  double SP_S_x0_VS_BP_VGP_S;
  double SP_S_x0_VS_BP_VS_BP;
  double SP_S_x0_VGP_S_VD_S;
  double SP_S_x0_VGP_S_VGP_S;
  double SP_S_x0_VGP_S_VS_BP;
  double SP_S_x0_VD_S_VD_S;
  double SP_S_x0_VD_S_VGP_S;
  double SP_S_x0_VD_S_VS_BP;
#endif
#endif
double SP_S_b;
#if defined(_DERIVATEFORDDX)
double SP_S_b_VD_S;
double SP_S_b_VGP_S;
double SP_S_b_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_b_VS_BP_VD_S;
  double SP_S_b_VS_BP_VGP_S;
  double SP_S_b_VS_BP_VS_BP;
  double SP_S_b_VGP_S_VD_S;
  double SP_S_b_VGP_S_VGP_S;
  double SP_S_b_VGP_S_VS_BP;
  double SP_S_b_VD_S_VD_S;
  double SP_S_b_VD_S_VGP_S;
  double SP_S_b_VD_S_VS_BP;
#endif
#endif
double SP_S_temp2;
#if defined(_DERIVATEFORDDX)
double SP_S_temp2_VD_S;
double SP_S_temp2_VGP_S;
double SP_S_temp2_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_temp2_VS_BP_VD_S;
  double SP_S_temp2_VS_BP_VGP_S;
  double SP_S_temp2_VS_BP_VS_BP;
  double SP_S_temp2_VGP_S_VD_S;
  double SP_S_temp2_VGP_S_VGP_S;
  double SP_S_temp2_VGP_S_VS_BP;
  double SP_S_temp2_VD_S_VD_S;
  double SP_S_temp2_VD_S_VGP_S;
  double SP_S_temp2_VD_S_VS_BP;
#endif
#endif
double SP_S_bx;
#if defined(_DERIVATEFORDDX)
double SP_S_bx_VGP_S;
double SP_S_bx_VD_S;
double SP_S_bx_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_bx_VS_BP_VGP_S;
  double SP_S_bx_VS_BP_VD_S;
  double SP_S_bx_VS_BP_VS_BP;
  double SP_S_bx_VD_S_VGP_S;
  double SP_S_bx_VD_S_VD_S;
  double SP_S_bx_VD_S_VS_BP;
  double SP_S_bx_VGP_S_VGP_S;
  double SP_S_bx_VGP_S_VD_S;
  double SP_S_bx_VGP_S_VS_BP;
#endif
#endif
double SP_S_w;
#if defined(_DERIVATEFORDDX)
double SP_S_w_VD_S;
double SP_S_w_VGP_S;
double SP_S_w_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_w_VS_BP_VD_S;
  double SP_S_w_VS_BP_VGP_S;
  double SP_S_w_VS_BP_VS_BP;
  double SP_S_w_VGP_S_VD_S;
  double SP_S_w_VGP_S_VGP_S;
  double SP_S_w_VGP_S_VS_BP;
  double SP_S_w_VD_S_VD_S;
  double SP_S_w_VD_S_VGP_S;
  double SP_S_w_VD_S_VS_BP;
#endif
#endif
double SP_S_xbar;
#if defined(_DERIVATEFORDDX)
double SP_S_xbar_VD_S;
double SP_S_xbar_VGP_S;
double SP_S_xbar_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_xbar_VS_BP_VD_S;
  double SP_S_xbar_VS_BP_VGP_S;
  double SP_S_xbar_VS_BP_VS_BP;
  double SP_S_xbar_VGP_S_VD_S;
  double SP_S_xbar_VGP_S_VGP_S;
  double SP_S_xbar_VGP_S_VS_BP;
  double SP_S_xbar_VD_S_VD_S;
  double SP_S_xbar_VD_S_VGP_S;
  double SP_S_xbar_VD_S_VS_BP;
#endif
#endif
double SP_S_A_fac;
#if defined(_DERIVATEFORDDX)
double SP_S_A_fac_VD_S;
double SP_S_A_fac_VGP_S;
double SP_S_A_fac_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_A_fac_VS_BP_VD_S;
  double SP_S_A_fac_VS_BP_VGP_S;
  double SP_S_A_fac_VS_BP_VS_BP;
  double SP_S_A_fac_VGP_S_VD_S;
  double SP_S_A_fac_VGP_S_VGP_S;
  double SP_S_A_fac_VGP_S_VS_BP;
  double SP_S_A_fac_VD_S_VD_S;
  double SP_S_A_fac_VD_S_VGP_S;
  double SP_S_A_fac_VD_S_VS_BP;
#endif
#endif
double SP_xg1;
#if defined(_DERIVATEFORDDX)
double SP_xg1_VD_S;
double SP_xg1_VGP_S;
double SP_xg1_VS_BP;
#if defined(_DERIVATE2)
  double SP_xg1_VS_BP_VD_S;
  double SP_xg1_VS_BP_VGP_S;
  double SP_xg1_VS_BP_VS_BP;
  double SP_xg1_VGP_S_VD_S;
  double SP_xg1_VGP_S_VGP_S;
  double SP_xg1_VGP_S_VS_BP;
  double SP_xg1_VD_S_VD_S;
  double SP_xg1_VD_S_VGP_S;
  double SP_xg1_VD_S_VS_BP;
#endif
#endif
double SP_S_qC;
#if defined(_DERIVATEFORDDX)
double SP_S_qC_VD_S;
double SP_S_qC_VGP_S;
double SP_S_qC_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_qC_VS_BP_VD_S;
  double SP_S_qC_VS_BP_VGP_S;
  double SP_S_qC_VS_BP_VS_BP;
  double SP_S_qC_VGP_S_VD_S;
  double SP_S_qC_VGP_S_VGP_S;
  double SP_S_qC_VGP_S_VS_BP;
  double SP_S_qC_VD_S_VD_S;
  double SP_S_qC_VD_S_VGP_S;
  double SP_S_qC_VD_S_VS_BP;
#endif
#endif
double SP_S_pC;
#if defined(_DERIVATEFORDDX)
double SP_S_pC_VD_S;
double SP_S_pC_VGP_S;
double SP_S_pC_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_pC_VS_BP_VD_S;
  double SP_S_pC_VS_BP_VGP_S;
  double SP_S_pC_VS_BP_VS_BP;
  double SP_S_pC_VGP_S_VD_S;
  double SP_S_pC_VGP_S_VGP_S;
  double SP_S_pC_VGP_S_VS_BP;
  double SP_S_pC_VD_S_VD_S;
  double SP_S_pC_VD_S_VGP_S;
  double SP_S_pC_VD_S_VS_BP;
#endif
#endif
double SP_S_xi2;
#if defined(_DERIVATEFORDDX)
double SP_S_xi2_VD_S;
double SP_S_xi2_VGP_S;
double SP_S_xi2_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_xi2_VS_BP_VD_S;
  double SP_S_xi2_VS_BP_VGP_S;
  double SP_S_xi2_VS_BP_VS_BP;
  double SP_S_xi2_VGP_S_VD_S;
  double SP_S_xi2_VGP_S_VGP_S;
  double SP_S_xi2_VGP_S_VS_BP;
  double SP_S_xi2_VD_S_VD_S;
  double SP_S_xi2_VD_S_VGP_S;
  double SP_S_xi2_VD_S_VS_BP;
#endif
#endif
double SP_S_xi1;
#if defined(_DERIVATEFORDDX)
double SP_S_xi1_VD_S;
double SP_S_xi1_VGP_S;
double SP_S_xi1_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_xi1_VS_BP_VD_S;
  double SP_S_xi1_VS_BP_VGP_S;
  double SP_S_xi1_VS_BP_VS_BP;
  double SP_S_xi1_VGP_S_VD_S;
  double SP_S_xi1_VGP_S_VGP_S;
  double SP_S_xi1_VGP_S_VS_BP;
  double SP_S_xi1_VD_S_VD_S;
  double SP_S_xi1_VD_S_VGP_S;
  double SP_S_xi1_VD_S_VS_BP;
#endif
#endif
double SP_S_xi0;
#if defined(_DERIVATEFORDDX)
double SP_S_xi0_VD_S;
double SP_S_xi0_VGP_S;
double SP_S_xi0_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_xi0_VS_BP_VD_S;
  double SP_S_xi0_VS_BP_VGP_S;
  double SP_S_xi0_VS_BP_VS_BP;
  double SP_S_xi0_VGP_S_VD_S;
  double SP_S_xi0_VGP_S_VGP_S;
  double SP_S_xi0_VGP_S_VS_BP;
  double SP_S_xi0_VD_S_VD_S;
  double SP_S_xi0_VD_S_VGP_S;
  double SP_S_xi0_VD_S_VS_BP;
#endif
#endif
double SP_S_delta1;
#if defined(_DERIVATEFORDDX)
double SP_S_delta1_VD_S;
double SP_S_delta1_VGP_S;
double SP_S_delta1_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_delta1_VS_BP_VD_S;
  double SP_S_delta1_VS_BP_VGP_S;
  double SP_S_delta1_VS_BP_VS_BP;
  double SP_S_delta1_VGP_S_VD_S;
  double SP_S_delta1_VGP_S_VGP_S;
  double SP_S_delta1_VGP_S_VS_BP;
  double SP_S_delta1_VD_S_VD_S;
  double SP_S_delta1_VD_S_VGP_S;
  double SP_S_delta1_VD_S_VS_BP;
#endif
#endif
double SP_S_delta0;
#if defined(_DERIVATEFORDDX)
double SP_S_delta0_VD_S;
double SP_S_delta0_VGP_S;
double SP_S_delta0_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_delta0_VS_BP_VD_S;
  double SP_S_delta0_VS_BP_VGP_S;
  double SP_S_delta0_VS_BP_VS_BP;
  double SP_S_delta0_VGP_S_VD_S;
  double SP_S_delta0_VGP_S_VGP_S;
  double SP_S_delta0_VGP_S_VS_BP;
  double SP_S_delta0_VD_S_VD_S;
  double SP_S_delta0_VD_S_VGP_S;
  double SP_S_delta0_VD_S_VS_BP;
#endif
#endif
double SP_S_y0;
#if defined(_DERIVATEFORDDX)
double SP_S_y0_VD_S;
double SP_S_y0_VGP_S;
double SP_S_y0_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_y0_VS_BP_VD_S;
  double SP_S_y0_VS_BP_VGP_S;
  double SP_S_y0_VS_BP_VS_BP;
  double SP_S_y0_VGP_S_VD_S;
  double SP_S_y0_VGP_S_VGP_S;
  double SP_S_y0_VGP_S_VS_BP;
  double SP_S_y0_VD_S_VD_S;
  double SP_S_y0_VD_S_VGP_S;
  double SP_S_y0_VD_S_VS_BP;
#endif
#endif
double mutau;
#if defined(_DERIVATEFORDDX)
double mutau_VD_S;
double mutau_VGP_S;
double mutau_VS_BP;
#if defined(_DERIVATE2)
  double mutau_VS_BP_VD_S;
  double mutau_VS_BP_VGP_S;
  double mutau_VS_BP_VS_BP;
  double mutau_VGP_S_VD_S;
  double mutau_VGP_S_VGP_S;
  double mutau_VGP_S_VS_BP;
  double mutau_VD_S_VD_S;
  double mutau_VD_S_VGP_S;
  double mutau_VD_S_VS_BP;
#endif
#endif
double nu;
#if defined(_DERIVATEFORDDX)
double nu_VD_S;
double nu_VGP_S;
double nu_VS_BP;
#if defined(_DERIVATE2)
  double nu_VS_BP_VD_S;
  double nu_VS_BP_VGP_S;
  double nu_VS_BP_VS_BP;
  double nu_VGP_S_VD_S;
  double nu_VGP_S_VGP_S;
  double nu_VGP_S_VS_BP;
  double nu_VD_S_VD_S;
  double nu_VD_S_VGP_S;
  double nu_VD_S_VS_BP;
#endif
#endif
double SP_S_tau;
#if defined(_DERIVATEFORDDX)
double SP_S_tau_VD_S;
double SP_S_tau_VGP_S;
double SP_S_tau_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_tau_VS_BP_VD_S;
  double SP_S_tau_VS_BP_VGP_S;
  double SP_S_tau_VS_BP_VS_BP;
  double SP_S_tau_VGP_S_VD_S;
  double SP_S_tau_VGP_S_VGP_S;
  double SP_S_tau_VGP_S_VS_BP;
  double SP_S_tau_VD_S_VD_S;
  double SP_S_tau_VD_S_VGP_S;
  double SP_S_tau_VD_S_VS_BP;
#endif
#endif
double SP_S_c;
#if defined(_DERIVATEFORDDX)
double SP_S_c_VD_S;
double SP_S_c_VGP_S;
double SP_S_c_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_c_VS_BP_VD_S;
  double SP_S_c_VS_BP_VGP_S;
  double SP_S_c_VS_BP_VS_BP;
  double SP_S_c_VGP_S_VD_S;
  double SP_S_c_VGP_S_VGP_S;
  double SP_S_c_VGP_S_VS_BP;
  double SP_S_c_VD_S_VD_S;
  double SP_S_c_VD_S_VGP_S;
  double SP_S_c_VD_S_VS_BP;
#endif
#endif
double SP_S_a;
#if defined(_DERIVATEFORDDX)
double SP_S_a_VD_S;
double SP_S_a_VGP_S;
double SP_S_a_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_a_VS_BP_VD_S;
  double SP_S_a_VS_BP_VGP_S;
  double SP_S_a_VS_BP_VS_BP;
  double SP_S_a_VGP_S_VD_S;
  double SP_S_a_VGP_S_VGP_S;
  double SP_S_a_VGP_S_VS_BP;
  double SP_S_a_VD_S_VD_S;
  double SP_S_a_VD_S_VGP_S;
  double SP_S_a_VD_S_VS_BP;
#endif
#endif
double SP_S_temp;
#if defined(_DERIVATEFORDDX)
double SP_S_temp_VD_S;
double SP_S_temp_VGP_S;
double SP_S_temp_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_temp_VS_BP_VD_S;
  double SP_S_temp_VS_BP_VGP_S;
  double SP_S_temp_VS_BP_VS_BP;
  double SP_S_temp_VGP_S_VD_S;
  double SP_S_temp_VGP_S_VGP_S;
  double SP_S_temp_VGP_S_VS_BP;
  double SP_S_temp_VD_S_VD_S;
  double SP_S_temp_VD_S_VGP_S;
  double SP_S_temp_VD_S_VS_BP;
#endif
#endif
double SP_S_eta;
#if defined(_DERIVATEFORDDX)
double SP_S_eta_VD_S;
double SP_S_eta_VGP_S;
double SP_S_eta_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_eta_VS_BP_VD_S;
  double SP_S_eta_VS_BP_VGP_S;
  double SP_S_eta_VS_BP_VS_BP;
  double SP_S_eta_VGP_S_VD_S;
  double SP_S_eta_VGP_S_VGP_S;
  double SP_S_eta_VGP_S_VS_BP;
  double SP_S_eta_VD_S_VD_S;
  double SP_S_eta_VD_S_VGP_S;
  double SP_S_eta_VD_S_VS_BP;
#endif
#endif
double SP_S_ysub;
#if defined(_DERIVATEFORDDX)
double SP_S_ysub_VD_S;
double SP_S_ysub_VGP_S;
double SP_S_ysub_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_ysub_VS_BP_VD_S;
  double SP_S_ysub_VS_BP_VGP_S;
  double SP_S_ysub_VS_BP_VS_BP;
  double SP_S_ysub_VGP_S_VD_S;
  double SP_S_ysub_VGP_S_VGP_S;
  double SP_S_ysub_VGP_S_VS_BP;
  double SP_S_ysub_VD_S_VD_S;
  double SP_S_ysub_VD_S_VGP_S;
  double SP_S_ysub_VD_S_VS_BP;
#endif
#endif
double SP_S_yg;
#if defined(_DERIVATEFORDDX)
double SP_S_yg_VD_S;
double SP_S_yg_VGP_S;
double SP_S_yg_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_yg_VS_BP_VD_S;
  double SP_S_yg_VS_BP_VGP_S;
  double SP_S_yg_VS_BP_VS_BP;
  double SP_S_yg_VGP_S_VD_S;
  double SP_S_yg_VGP_S_VGP_S;
  double SP_S_yg_VGP_S_VS_BP;
  double SP_S_yg_VD_S_VD_S;
  double SP_S_yg_VD_S_VGP_S;
  double SP_S_yg_VD_S_VS_BP;
#endif
#endif
double SP_S_temp1;
#if defined(_DERIVATEFORDDX)
double SP_S_temp1_VD_S;
double SP_S_temp1_VGP_S;
double SP_S_temp1_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_temp1_VS_BP_VD_S;
  double SP_S_temp1_VS_BP_VGP_S;
  double SP_S_temp1_VS_BP_VS_BP;
  double SP_S_temp1_VGP_S_VD_S;
  double SP_S_temp1_VGP_S_VGP_S;
  double SP_S_temp1_VGP_S_VS_BP;
  double SP_S_temp1_VD_S_VD_S;
  double SP_S_temp1_VD_S_VGP_S;
  double SP_S_temp1_VD_S_VS_BP;
#endif
#endif
double margin;
#if defined(_DERIVATE)
double margin_VD_S;
double margin_VGP_S;
double margin_VS_BP;
#endif
double delta_ns;
#if defined(_DERIVATEFORDDX)
double delta_ns_VD_S;
double delta_ns_VS_BP;
#if defined(_DERIVATE2)
  double delta_ns_VS_BP_VD_S;
  double delta_ns_VS_BP_VS_BP;
  double delta_ns_VD_S_VD_S;
  double delta_ns_VD_S_VS_BP;
#endif
#endif
double xn_s;
#if defined(_DERIVATEFORDDX)
double xn_s_VD_S;
double xn_s_VS_BP;
#if defined(_DERIVATE2)
  double xn_s_VS_BP_VD_S;
  double xn_s_VS_BP_VS_BP;
  double xn_s_VD_S_VD_S;
  double xn_s_VD_S_VS_BP;
#endif
#endif
double Ux;
#if defined(_DERIVATEFORDDX)
double Ux_VD_S;
double Ux_VS_BP;
#if defined(_DERIVATE2)
  double Ux_VS_BP_VD_S;
  double Ux_VS_BP_VS_BP;
  double Ux_VD_S_VD_S;
  double Ux_VD_S_VS_BP;
#endif
#endif
double inv_xi;
#if defined(_DERIVATEFORDDX)
double inv_xi_VD_S;
double inv_xi_VGP_S;
double inv_xi_VS_BP;
#if defined(_DERIVATE2)
  double inv_xi_VS_BP_VD_S;
  double inv_xi_VS_BP_VGP_S;
  double inv_xi_VS_BP_VS_BP;
  double inv_xi_VGP_S_VD_S;
  double inv_xi_VGP_S_VGP_S;
  double inv_xi_VGP_S_VS_BP;
  double inv_xi_VD_S_VD_S;
  double inv_xi_VD_S_VGP_S;
  double inv_xi_VD_S_VS_BP;
#endif
#endif
double xi;
#if defined(_DERIVATEFORDDX)
double xi_VD_S;
double xi_VGP_S;
double xi_VS_BP;
#if defined(_DERIVATE2)
  double xi_VS_BP_VD_S;
  double xi_VS_BP_VGP_S;
  double xi_VS_BP_VS_BP;
  double xi_VGP_S_VD_S;
  double xi_VGP_S_VGP_S;
  double xi_VGP_S_VS_BP;
  double xi_VD_S_VD_S;
  double xi_VD_S_VGP_S;
  double xi_VD_S_VS_BP;
#endif
#endif
double inv_Gf2;
#if defined(_DERIVATEFORDDX)
double inv_Gf2_VD_S;
double inv_Gf2_VGP_S;
double inv_Gf2_VS_BP;
#if defined(_DERIVATE2)
  double inv_Gf2_VS_BP_VD_S;
  double inv_Gf2_VS_BP_VGP_S;
  double inv_Gf2_VS_BP_VS_BP;
  double inv_Gf2_VGP_S_VD_S;
  double inv_Gf2_VGP_S_VGP_S;
  double inv_Gf2_VGP_S_VS_BP;
  double inv_Gf2_VD_S_VD_S;
  double inv_Gf2_VD_S_VGP_S;
  double inv_Gf2_VD_S_VS_BP;
#endif
#endif
double Gf2;
#if defined(_DERIVATEFORDDX)
double Gf2_VD_S;
double Gf2_VGP_S;
double Gf2_VS_BP;
#if defined(_DERIVATE2)
  double Gf2_VS_BP_VD_S;
  double Gf2_VS_BP_VGP_S;
  double Gf2_VS_BP_VS_BP;
  double Gf2_VGP_S_VD_S;
  double Gf2_VGP_S_VGP_S;
  double Gf2_VGP_S_VS_BP;
  double Gf2_VD_S_VD_S;
  double Gf2_VD_S_VGP_S;
  double Gf2_VD_S_VS_BP;
#endif
#endif
double Gf;
#if defined(_DERIVATEFORDDX)
double Gf_VD_S;
double Gf_VGP_S;
double Gf_VS_BP;
#if defined(_DERIVATE2)
  double Gf_VS_BP_VD_S;
  double Gf_VS_BP_VGP_S;
  double Gf_VS_BP_VS_BP;
  double Gf_VGP_S_VD_S;
  double Gf_VGP_S_VGP_S;
  double Gf_VGP_S_VS_BP;
  double Gf_VD_S_VD_S;
  double Gf_VD_S_VGP_S;
  double Gf_VD_S_VS_BP;
#endif
#endif
double Dnsub;
#if defined(_DERIVATEFORDDX)
double Dnsub_VD_S;
double Dnsub_VGP_S;
double Dnsub_VS_BP;
#if defined(_DERIVATE2)
  double Dnsub_VS_BP_VD_S;
  double Dnsub_VS_BP_VGP_S;
  double Dnsub_VS_BP_VS_BP;
  double Dnsub_VGP_S_VD_S;
  double Dnsub_VGP_S_VGP_S;
  double Dnsub_VGP_S_VS_BP;
  double Dnsub_VD_S_VD_S;
  double Dnsub_VD_S_VGP_S;
  double Dnsub_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double xg_VD_S;
double xg_VGP_S;
double xg_VS_BP;
#if defined(_DERIVATE2)
  double xg_VS_BP_VD_S;
  double xg_VS_BP_VGP_S;
  double xg_VS_BP_VS_BP;
  double xg_VGP_S_VD_S;
  double xg_VGP_S_VGP_S;
  double xg_VGP_S_VS_BP;
  double xg_VD_S_VD_S;
  double xg_VD_S_VGP_S;
  double xg_VD_S_VS_BP;
#endif
#endif
double delVg;
#if defined(_DERIVATEFORDDX)
double delVg_VD_S;
double delVg_VS_BP;
#if defined(_DERIVATE2)
  double delVg_VS_BP_VD_S;
  double delVg_VS_BP_VS_BP;
  double delVg_VD_S_VD_S;
  double delVg_VD_S_VS_BP;
#endif
#endif
double Vsbx;
#if defined(_DERIVATEFORDDX)
double Vsbx_VD_S;
double Vsbx_VS_BP;
#if defined(_DERIVATE2)
  double Vsbx_VS_BP_VD_S;
  double Vsbx_VS_BP_VS_BP;
  double Vsbx_VD_S_VD_S;
  double Vsbx_VD_S_VS_BP;
#endif
#endif
double Vdsx;
#if defined(_DERIVATEFORDDX)
double Vdsx_VD_S;
#if defined(_DERIVATE2)
  double Vdsx_VD_S_VD_S;
#endif
#endif
double Vgb1;
#if defined(_DERIVATEFORDDX)
double Vgb1_VD_S;
double Vgb1_VGP_S;
double Vgb1_VS_BP;
#if defined(_DERIVATE2)
  double Vgb1_VS_BP_VD_S;
  double Vgb1_VS_BP_VGP_S;
  double Vgb1_VS_BP_VS_BP;
  double Vgb1_VGP_S_VD_S;
  double Vgb1_VGP_S_VGP_S;
  double Vgb1_VGP_S_VS_BP;
  double Vgb1_VD_S_VD_S;
  double Vgb1_VD_S_VGP_S;
  double Vgb1_VD_S_VS_BP;
#endif
#endif
double Vgbstar;
#if defined(_DERIVATEFORDDX)
double Vgbstar_VD_S;
double Vgbstar_VGP_S;
double Vgbstar_VS_BP;
#if defined(_DERIVATE2)
  double Vgbstar_VS_BP_VD_S;
  double Vgbstar_VS_BP_VGP_S;
  double Vgbstar_VS_BP_VS_BP;
  double Vgbstar_VGP_S_VD_S;
  double Vgbstar_VGP_S_VGP_S;
  double Vgbstar_VGP_S_VS_BP;
  double Vgbstar_VD_S_VD_S;
  double Vgbstar_VD_S_VGP_S;
  double Vgbstar_VD_S_VS_BP;
#endif
#endif
double Vsbstar;
#if defined(_DERIVATEFORDDX)
double Vsbstar_VD_S;
double Vsbstar_VS_BP;
#if defined(_DERIVATE2)
  double Vsbstar_VS_BP_VD_S;
  double Vsbstar_VS_BP_VS_BP;
  double Vsbstar_VD_S_VD_S;
  double Vsbstar_VD_S_VS_BP;
#endif
#endif
double temp;
#if defined(_DERIVATEFORDDX)
double temp_VD_BD;
double temp_VS_BS;
double temp_VGP_S;
double temp_VD_S;
double temp_VS_BP;
#if defined(_DERIVATE2)
  double temp_VS_BP_VD_BD;
  double temp_VS_BP_VS_BS;
  double temp_VS_BP_VGP_S;
  double temp_VS_BP_VD_S;
  double temp_VS_BP_VS_BP;
  double temp_VD_S_VD_BD;
  double temp_VD_S_VS_BS;
  double temp_VD_S_VGP_S;
  double temp_VD_S_VD_S;
  double temp_VD_S_VS_BP;
  double temp_VGP_S_VD_BD;
  double temp_VGP_S_VS_BS;
  double temp_VGP_S_VGP_S;
  double temp_VGP_S_VD_S;
  double temp_VGP_S_VS_BP;
  double temp_VS_BS_VD_BD;
  double temp_VS_BS_VS_BS;
  double temp_VS_BS_VGP_S;
  double temp_VS_BS_VD_S;
  double temp_VS_BS_VS_BP;
  double temp_VD_BD_VD_BD;
  double temp_VD_BD_VS_BS;
  double temp_VD_BD_VGP_S;
  double temp_VD_BD_VD_S;
  double temp_VD_BD_VS_BP;
#endif
#endif
double Vdb;
#if defined(_DERIVATEFORDDX)
double Vdb_VD_S;
double Vdb_VS_BP;
#if defined(_DERIVATE2)
  double Vdb_VS_BP_VD_S;
  double Vdb_VS_BP_VS_BP;
  double Vdb_VD_S_VD_S;
  double Vdb_VD_S_VS_BP;
#endif
#endif
double xgd_ov;
#if defined(_DERIVATEFORDDX)
double xgd_ov_VGP_S;
double xgd_ov_VD_S;
#if defined(_DERIVATE2)
  double xgd_ov_VD_S_VGP_S;
  double xgd_ov_VD_S_VD_S;
  double xgd_ov_VGP_S_VGP_S;
  double xgd_ov_VGP_S_VD_S;
#endif
#endif
double xgs_ov;
#if defined(_DERIVATEFORDDX)
double xgs_ov_VGP_S;
#if defined(_DERIVATE2)
  double xgs_ov_VGP_S_VGP_S;
#endif
#endif
double VgdPrime;
#if defined(_DERIVATEFORDDX)
double VgdPrime_VGP_S;
double VgdPrime_VD_S;
#if defined(_DERIVATE2)
  double VgdPrime_VD_S_VGP_S;
  double VgdPrime_VD_S_VD_S;
  double VgdPrime_VGP_S_VGP_S;
  double VgdPrime_VGP_S_VD_S;
#endif
#endif
double VdbPrime;
#if defined(_DERIVATEFORDDX)
double VdbPrime_VD_S;
double VdbPrime_VS_BP;
#if defined(_DERIVATE2)
  double VdbPrime_VS_BP_VD_S;
  double VdbPrime_VS_BP_VS_BP;
  double VdbPrime_VD_S_VD_S;
  double VdbPrime_VD_S_VS_BP;
#endif
#endif
double VsbPrime;
#if defined(_DERIVATEFORDDX)
double VsbPrime_VS_BP;
#if defined(_DERIVATE2)
  double VsbPrime_VS_BP_VS_BP;
#endif
#endif
double VgsPrime;
#if defined(_DERIVATEFORDDX)
double VgsPrime_VGP_S;
#if defined(_DERIVATE2)
  double VgsPrime_VGP_S_VGP_S;
#endif
#endif
double Vjun_d;
#if defined(_DERIVATEFORDDX)
double Vjun_d_VD_BD;
#if defined(_DERIVATE2)
  double Vjun_d_VD_BD_VD_BD;
#endif
#endif
double Vjun_s;
#if defined(_DERIVATEFORDDX)
double Vjun_s_VS_BS;
#if defined(_DERIVATE2)
  double Vjun_s_VS_BS_VS_BS;
#endif
#endif
double Vsb;
#if defined(_DERIVATEFORDDX)
double Vsb_VD_S;
double Vsb_VS_BP;
#if defined(_DERIVATE2)
  double Vsb_VS_BP_VD_S;
  double Vsb_VS_BP_VS_BP;
  double Vsb_VD_S_VD_S;
  double Vsb_VD_S_VS_BP;
#endif
#endif
double Vds;
#if defined(_DERIVATEFORDDX)
double Vds_VD_S;
#if defined(_DERIVATE2)
  double Vds_VD_S_VD_S;
#endif
#endif
double Vgs;
#if defined(_DERIVATEFORDDX)
double Vgs_VD_S;
double Vgs_VGP_S;
#if defined(_DERIVATE2)
  double Vgs_VGP_S_VD_S;
  double Vgs_VGP_S_VGP_S;
  double Vgs_VD_S_VD_S;
  double Vgs_VD_S_VGP_S;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double mavl_VD_S;
double mavl_VGP_S;
double mavl_VS_BP;
#if defined(_DERIVATE2)
  double mavl_VS_BP_VD_S;
  double mavl_VS_BP_VGP_S;
  double mavl_VS_BP_VS_BP;
  double mavl_VGP_S_VD_S;
  double mavl_VGP_S_VGP_S;
  double mavl_VGP_S_VS_BP;
  double mavl_VD_S_VD_S;
  double mavl_VD_S_VGP_S;
  double mavl_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Iimpact_VGP_S;
double Iimpact_VD_S;
double Iimpact_VS_BP;
#if defined(_DERIVATE2)
  double Iimpact_VS_BP_VGP_S;
  double Iimpact_VS_BP_VD_S;
  double Iimpact_VS_BP_VS_BP;
  double Iimpact_VD_S_VGP_S;
  double Iimpact_VD_S_VD_S;
  double Iimpact_VD_S_VS_BP;
  double Iimpact_VGP_S_VGP_S;
  double Iimpact_VGP_S_VD_S;
  double Iimpact_VGP_S_VS_BP;
#endif
#endif
double Vovd;
#if defined(_DERIVATEFORDDX)
double Vovd_VGP_S;
double Vovd_VD_S;
double Vovd_VS_BP;
#if defined(_DERIVATE2)
  double Vovd_VS_BP_VGP_S;
  double Vovd_VS_BP_VD_S;
  double Vovd_VS_BP_VS_BP;
  double Vovd_VD_S_VGP_S;
  double Vovd_VD_S_VD_S;
  double Vovd_VD_S_VS_BP;
  double Vovd_VGP_S_VGP_S;
  double Vovd_VGP_S_VD_S;
  double Vovd_VGP_S_VS_BP;
#endif
#endif
double Vovs;
#if defined(_DERIVATEFORDDX)
double Vovs_VGP_S;
double Vovs_VD_S;
double Vovs_VS_BP;
#if defined(_DERIVATE2)
  double Vovs_VS_BP_VGP_S;
  double Vovs_VS_BP_VD_S;
  double Vovs_VS_BP_VS_BP;
  double Vovs_VD_S_VGP_S;
  double Vovs_VD_S_VD_S;
  double Vovs_VD_S_VS_BP;
  double Vovs_VGP_S_VGP_S;
  double Vovs_VGP_S_VD_S;
  double Vovs_VGP_S_VS_BP;
#endif
#endif
double xd_ov;
#if defined(_DERIVATEFORDDX)
double xd_ov_VS_BP;
double xd_ov_VGP_S;
double xd_ov_VD_S;
#if defined(_DERIVATE2)
  double xd_ov_VD_S_VS_BP;
  double xd_ov_VD_S_VGP_S;
  double xd_ov_VD_S_VD_S;
  double xd_ov_VGP_S_VS_BP;
  double xd_ov_VGP_S_VGP_S;
  double xd_ov_VGP_S_VD_S;
  double xd_ov_VS_BP_VS_BP;
  double xd_ov_VS_BP_VGP_S;
  double xd_ov_VS_BP_VD_S;
#endif
#endif
double xs_ov;
#if defined(_DERIVATEFORDDX)
double xs_ov_VD_S;
double xs_ov_VS_BP;
double xs_ov_VGP_S;
#if defined(_DERIVATE2)
  double xs_ov_VGP_S_VD_S;
  double xs_ov_VGP_S_VS_BP;
  double xs_ov_VGP_S_VGP_S;
  double xs_ov_VS_BP_VD_S;
  double xs_ov_VS_BP_VS_BP;
  double xs_ov_VS_BP_VGP_S;
  double xs_ov_VD_S_VD_S;
  double xs_ov_VD_S_VS_BP;
  double xs_ov_VD_S_VGP_S;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double H_VGP_S;
double H_VD_S;
double H_VS_BP;
#if defined(_DERIVATE2)
  double H_VS_BP_VGP_S;
  double H_VS_BP_VD_S;
  double H_VS_BP_VS_BP;
  double H_VD_S_VGP_S;
  double H_VD_S_VD_S;
  double H_VD_S_VS_BP;
  double H_VGP_S_VGP_S;
  double H_VGP_S_VD_S;
  double H_VGP_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double qim1_VD_S;
double qim1_VGP_S;
double qim1_VS_BP;
#if defined(_DERIVATE2)
  double qim1_VS_BP_VD_S;
  double qim1_VS_BP_VGP_S;
  double qim1_VS_BP_VS_BP;
  double qim1_VGP_S_VD_S;
  double qim1_VGP_S_VGP_S;
  double qim1_VGP_S_VS_BP;
  double qim1_VD_S_VD_S;
  double qim1_VD_S_VGP_S;
  double qim1_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double qim_VD_S;
double qim_VGP_S;
double qim_VS_BP;
#if defined(_DERIVATE2)
  double qim_VS_BP_VD_S;
  double qim_VS_BP_VGP_S;
  double qim_VS_BP_VS_BP;
  double qim_VGP_S_VD_S;
  double qim_VGP_S_VGP_S;
  double qim_VGP_S_VS_BP;
  double qim_VD_S_VD_S;
  double qim_VD_S_VGP_S;
  double qim_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double dps_VD_S;
double dps_VGP_S;
double dps_VS_BP;
#if defined(_DERIVATE2)
  double dps_VS_BP_VD_S;
  double dps_VS_BP_VGP_S;
  double dps_VS_BP_VS_BP;
  double dps_VGP_S_VD_S;
  double dps_VGP_S_VGP_S;
  double dps_VGP_S_VS_BP;
  double dps_VD_S_VD_S;
  double dps_VD_S_VGP_S;
  double dps_VD_S_VS_BP;
#endif
#endif
double xgm;
#if defined(_DERIVATEFORDDX)
double xgm_VD_S;
double xgm_VGP_S;
double xgm_VS_BP;
#if defined(_DERIVATE2)
  double xgm_VS_BP_VD_S;
  double xgm_VS_BP_VGP_S;
  double xgm_VS_BP_VS_BP;
  double xgm_VGP_S_VD_S;
  double xgm_VGP_S_VGP_S;
  double xgm_VGP_S_VS_BP;
  double xgm_VD_S_VD_S;
  double xgm_VD_S_VGP_S;
  double xgm_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Gvsatinv_VD_S;
double Gvsatinv_VGP_S;
double Gvsatinv_VS_BP;
#if defined(_DERIVATE2)
  double Gvsatinv_VS_BP_VD_S;
  double Gvsatinv_VS_BP_VGP_S;
  double Gvsatinv_VS_BP_VS_BP;
  double Gvsatinv_VGP_S_VD_S;
  double Gvsatinv_VGP_S_VGP_S;
  double Gvsatinv_VGP_S_VS_BP;
  double Gvsatinv_VD_S_VD_S;
  double Gvsatinv_VD_S_VGP_S;
  double Gvsatinv_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Gvsat_VD_S;
double Gvsat_VGP_S;
double Gvsat_VS_BP;
#if defined(_DERIVATE2)
  double Gvsat_VS_BP_VD_S;
  double Gvsat_VS_BP_VGP_S;
  double Gvsat_VS_BP_VS_BP;
  double Gvsat_VGP_S_VD_S;
  double Gvsat_VGP_S_VGP_S;
  double Gvsat_VGP_S_VS_BP;
  double Gvsat_VD_S_VD_S;
  double Gvsat_VD_S_VGP_S;
  double Gvsat_VD_S_VS_BP;
#endif
#endif
double thesat1;
#if defined(_DERIVATEFORDDX)
double thesat1_VGP_S;
double thesat1_VD_S;
double thesat1_VS_BP;
#if defined(_DERIVATE2)
  double thesat1_VS_BP_VGP_S;
  double thesat1_VS_BP_VD_S;
  double thesat1_VS_BP_VS_BP;
  double thesat1_VD_S_VGP_S;
  double thesat1_VD_S_VD_S;
  double thesat1_VD_S_VS_BP;
  double thesat1_VGP_S_VGP_S;
  double thesat1_VGP_S_VD_S;
  double thesat1_VGP_S_VS_BP;
#endif
#endif
#if defined(_DYNAMIC)
double QCLM;
#if defined(_DERIVATEFORDDX)
double QCLM_VGP_S;
double QCLM_VD_S;
double QCLM_VS_BP;
#if defined(_DERIVATE2)
  double QCLM_VS_BP_VGP_S;
  double QCLM_VS_BP_VD_S;
  double QCLM_VS_BP_VS_BP;
  double QCLM_VD_S_VGP_S;
  double QCLM_VD_S_VD_S;
  double QCLM_VD_S_VS_BP;
  double QCLM_VGP_S_VGP_S;
  double QCLM_VGP_S_VD_S;
  double QCLM_VGP_S_VS_BP;
#endif
#endif
#endif
double Udse;
#if defined(_DERIVATEFORDDX)
double Udse_VGP_S;
double Udse_VS_BP;
double Udse_VD_S;
#if defined(_DERIVATE2)
  double Udse_VD_S_VGP_S;
  double Udse_VD_S_VS_BP;
  double Udse_VD_S_VD_S;
  double Udse_VS_BP_VGP_S;
  double Udse_VS_BP_VS_BP;
  double Udse_VS_BP_VD_S;
  double Udse_VGP_S_VGP_S;
  double Udse_VGP_S_VS_BP;
  double Udse_VGP_S_VD_S;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Gmob_dL_VD_S;
double Gmob_dL_VGP_S;
double Gmob_dL_VS_BP;
#if defined(_DERIVATE2)
  double Gmob_dL_VS_BP_VD_S;
  double Gmob_dL_VS_BP_VGP_S;
  double Gmob_dL_VS_BP_VS_BP;
  double Gmob_dL_VGP_S_VD_S;
  double Gmob_dL_VGP_S_VGP_S;
  double Gmob_dL_VGP_S_VS_BP;
  double Gmob_dL_VD_S_VD_S;
  double Gmob_dL_VD_S_VGP_S;
  double Gmob_dL_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Gmob_VD_S;
double Gmob_VGP_S;
double Gmob_VS_BP;
#if defined(_DERIVATE2)
  double Gmob_VS_BP_VD_S;
  double Gmob_VS_BP_VGP_S;
  double Gmob_VS_BP_VS_BP;
  double Gmob_VGP_S_VD_S;
  double Gmob_VGP_S_VGP_S;
  double Gmob_VGP_S_VS_BP;
  double Gmob_VD_S_VD_S;
  double Gmob_VD_S_VGP_S;
  double Gmob_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double FdL_VGP_S;
double FdL_VD_S;
double FdL_VS_BP;
#if defined(_DERIVATE2)
  double FdL_VS_BP_VGP_S;
  double FdL_VS_BP_VD_S;
  double FdL_VS_BP_VS_BP;
  double FdL_VD_S_VGP_S;
  double FdL_VD_S_VD_S;
  double FdL_VD_S_VS_BP;
  double FdL_VGP_S_VGP_S;
  double FdL_VGP_S_VD_S;
  double FdL_VGP_S_VS_BP;
#endif
#endif
double GdL;
#if defined(_DERIVATEFORDDX)
double GdL_VGP_S;
double GdL_VD_S;
double GdL_VS_BP;
#if defined(_DERIVATE2)
  double GdL_VS_BP_VGP_S;
  double GdL_VS_BP_VD_S;
  double GdL_VS_BP_VS_BP;
  double GdL_VD_S_VGP_S;
  double GdL_VD_S_VD_S;
  double GdL_VD_S_VS_BP;
  double GdL_VGP_S_VGP_S;
  double GdL_VGP_S_VD_S;
  double GdL_VGP_S_VS_BP;
#endif
#endif
double rhob;
#if defined(_DERIVATEFORDDX)
double rhob_VD_S;
double rhob_VS_BP;
#if defined(_DERIVATE2)
  double rhob_VS_BP_VD_S;
  double rhob_VS_BP_VS_BP;
  double rhob_VD_S_VD_S;
  double rhob_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double xitsb_VD_S;
double xitsb_VS_BP;
#if defined(_DERIVATE2)
  double xitsb_VS_BP_VD_S;
  double xitsb_VS_BP_VS_BP;
  double xitsb_VD_S_VD_S;
  double xitsb_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double eta_p_VD_S;
double eta_p_VGP_S;
double eta_p_VS_BP;
#if defined(_DERIVATE2)
  double eta_p_VS_BP_VD_S;
  double eta_p_VS_BP_VGP_S;
  double eta_p_VS_BP_VS_BP;
  double eta_p_VGP_S_VD_S;
  double eta_p_VGP_S_VGP_S;
  double eta_p_VGP_S_VS_BP;
  double eta_p_VD_S_VD_S;
  double eta_p_VD_S_VGP_S;
  double eta_p_VD_S_VS_BP;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double alpha_VD_S;
double alpha_VGP_S;
double alpha_VS_BP;
#if defined(_DERIVATE2)
  double alpha_VS_BP_VD_S;
  double alpha_VS_BP_VGP_S;
  double alpha_VS_BP_VS_BP;
  double alpha_VGP_S_VD_S;
  double alpha_VGP_S_VGP_S;
  double alpha_VGP_S_VS_BP;
  double alpha_VD_S_VD_S;
  double alpha_VD_S_VGP_S;
  double alpha_VD_S_VS_BP;
#endif
#endif
double sqm;
#if defined(_DERIVATEFORDDX)
double sqm_VD_S;
double sqm_VGP_S;
double sqm_VS_BP;
#if defined(_DERIVATE2)
  double sqm_VS_BP_VD_S;
  double sqm_VS_BP_VGP_S;
  double sqm_VS_BP_VS_BP;
  double sqm_VGP_S_VD_S;
  double sqm_VGP_S_VGP_S;
  double sqm_VGP_S_VS_BP;
  double sqm_VD_S_VD_S;
  double sqm_VD_S_VGP_S;
  double sqm_VD_S_VS_BP;
#endif
#endif
double x_s;
#if defined(_DERIVATEFORDDX)
double x_s_VD_S;
double x_s_VGP_S;
double x_s_VS_BP;
#if defined(_DERIVATE2)
  double x_s_VS_BP_VD_S;
  double x_s_VS_BP_VGP_S;
  double x_s_VS_BP_VS_BP;
  double x_s_VGP_S_VD_S;
  double x_s_VGP_S_VGP_S;
  double x_s_VGP_S_VS_BP;
  double x_s_VD_S_VD_S;
  double x_s_VD_S_VGP_S;
  double x_s_VD_S_VS_BP;
#endif
#endif
double SP_S_x1;
#if defined(_DERIVATEFORDDX)
double SP_S_x1_VD_S;
double SP_S_x1_VGP_S;
double SP_S_x1_VS_BP;
#if defined(_DERIVATE2)
  double SP_S_x1_VS_BP_VD_S;
  double SP_S_x1_VS_BP_VGP_S;
  double SP_S_x1_VS_BP_VS_BP;
  double SP_S_x1_VGP_S_VD_S;
  double SP_S_x1_VGP_S_VGP_S;
  double SP_S_x1_VGP_S_VS_BP;
  double SP_S_x1_VD_S_VD_S;
  double SP_S_x1_VD_S_VGP_S;
  double SP_S_x1_VD_S_VS_BP;
#endif
#endif
{
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_x1_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_S_x1_VD_S_VD_S=0.0;
  SP_S_x1_VD_S_VGP_S=0.0;
  SP_S_x1_VD_S_VS_BP=0.0;
#endif
SP_S_x1_VGP_S=0.0;
#if defined(_DERIVATE2)
  SP_S_x1_VGP_S_VD_S=0.0;
  SP_S_x1_VGP_S_VGP_S=0.0;
  SP_S_x1_VGP_S_VS_BP=0.0;
#endif
SP_S_x1_VS_BP=0.0;
#if defined(_DERIVATE2)
  SP_S_x1_VS_BP_VD_S=0.0;
  SP_S_x1_VS_BP_VGP_S=0.0;
  SP_S_x1_VS_BP_VS_BP=0.0;
#endif
#endif
SP_S_x1=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_s_VD_S=0.0;
#if defined(_DERIVATE2)
  x_s_VD_S_VD_S=0.0;
  x_s_VD_S_VGP_S=0.0;
  x_s_VD_S_VS_BP=0.0;
#endif
x_s_VGP_S=0.0;
#if defined(_DERIVATE2)
  x_s_VGP_S_VD_S=0.0;
  x_s_VGP_S_VGP_S=0.0;
  x_s_VGP_S_VS_BP=0.0;
#endif
x_s_VS_BP=0.0;
#if defined(_DERIVATE2)
  x_s_VS_BP_VD_S=0.0;
  x_s_VS_BP_VGP_S=0.0;
  x_s_VS_BP_VS_BP=0.0;
#endif
#endif
x_s=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
sqm_VD_S=0.0;
#if defined(_DERIVATE2)
  sqm_VD_S_VD_S=0.0;
  sqm_VD_S_VGP_S=0.0;
  sqm_VD_S_VS_BP=0.0;
#endif
sqm_VGP_S=0.0;
#if defined(_DERIVATE2)
  sqm_VGP_S_VD_S=0.0;
  sqm_VGP_S_VGP_S=0.0;
  sqm_VGP_S_VS_BP=0.0;
#endif
sqm_VS_BP=0.0;
#if defined(_DERIVATE2)
  sqm_VS_BP_VD_S=0.0;
  sqm_VS_BP_VGP_S=0.0;
  sqm_VS_BP_VS_BP=0.0;
#endif
#endif
sqm=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
alpha_VD_S=0.0;
#if defined(_DERIVATE2)
  alpha_VD_S_VD_S=0.0;
  alpha_VD_S_VGP_S=0.0;
  alpha_VD_S_VS_BP=0.0;
#endif
alpha_VGP_S=0.0;
#if defined(_DERIVATE2)
  alpha_VGP_S_VD_S=0.0;
  alpha_VGP_S_VGP_S=0.0;
  alpha_VGP_S_VS_BP=0.0;
#endif
alpha_VS_BP=0.0;
#if defined(_DERIVATE2)
  alpha_VS_BP_VD_S=0.0;
  alpha_VS_BP_VGP_S=0.0;
  alpha_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->alpha=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
eta_p_VD_S=0.0;
#if defined(_DERIVATE2)
  eta_p_VD_S_VD_S=0.0;
  eta_p_VD_S_VGP_S=0.0;
  eta_p_VD_S_VS_BP=0.0;
#endif
eta_p_VGP_S=0.0;
#if defined(_DERIVATE2)
  eta_p_VGP_S_VD_S=0.0;
  eta_p_VGP_S_VGP_S=0.0;
  eta_p_VGP_S_VS_BP=0.0;
#endif
eta_p_VS_BP=0.0;
#if defined(_DERIVATE2)
  eta_p_VS_BP_VD_S=0.0;
  eta_p_VS_BP_VGP_S=0.0;
  eta_p_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->eta_p=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xitsb_VD_S=0.0;
#if defined(_DERIVATE2)
  xitsb_VD_S_VD_S=0.0;
  xitsb_VD_S_VS_BP=0.0;
#endif
xitsb_VS_BP=0.0;
#if defined(_DERIVATE2)
  xitsb_VS_BP_VD_S=0.0;
  xitsb_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->xitsb=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
rhob_VD_S=0.0;
#if defined(_DERIVATE2)
  rhob_VD_S_VD_S=0.0;
  rhob_VD_S_VS_BP=0.0;
#endif
rhob_VS_BP=0.0;
#if defined(_DERIVATE2)
  rhob_VS_BP_VD_S=0.0;
  rhob_VS_BP_VS_BP=0.0;
#endif
#endif
rhob=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
GdL_VGP_S=0.0;
#if defined(_DERIVATE2)
  GdL_VGP_S_VGP_S=0.0;
  GdL_VGP_S_VD_S=0.0;
  GdL_VGP_S_VS_BP=0.0;
#endif
GdL_VD_S=0.0;
#if defined(_DERIVATE2)
  GdL_VD_S_VGP_S=0.0;
  GdL_VD_S_VD_S=0.0;
  GdL_VD_S_VS_BP=0.0;
#endif
GdL_VS_BP=0.0;
#if defined(_DERIVATE2)
  GdL_VS_BP_VGP_S=0.0;
  GdL_VS_BP_VD_S=0.0;
  GdL_VS_BP_VS_BP=0.0;
#endif
#endif
GdL=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
FdL_VGP_S=0.0;
#if defined(_DERIVATE2)
  FdL_VGP_S_VGP_S=0.0;
  FdL_VGP_S_VD_S=0.0;
  FdL_VGP_S_VS_BP=0.0;
#endif
FdL_VD_S=0.0;
#if defined(_DERIVATE2)
  FdL_VD_S_VGP_S=0.0;
  FdL_VD_S_VD_S=0.0;
  FdL_VD_S_VS_BP=0.0;
#endif
FdL_VS_BP=0.0;
#if defined(_DERIVATE2)
  FdL_VS_BP_VGP_S=0.0;
  FdL_VS_BP_VD_S=0.0;
  FdL_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->FdL=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Gmob_VD_S=0.0;
#if defined(_DERIVATE2)
  Gmob_VD_S_VD_S=0.0;
  Gmob_VD_S_VGP_S=0.0;
  Gmob_VD_S_VS_BP=0.0;
#endif
Gmob_VGP_S=0.0;
#if defined(_DERIVATE2)
  Gmob_VGP_S_VD_S=0.0;
  Gmob_VGP_S_VGP_S=0.0;
  Gmob_VGP_S_VS_BP=0.0;
#endif
Gmob_VS_BP=0.0;
#if defined(_DERIVATE2)
  Gmob_VS_BP_VD_S=0.0;
  Gmob_VS_BP_VGP_S=0.0;
  Gmob_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Gmob=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Gmob_dL_VD_S=0.0;
#if defined(_DERIVATE2)
  Gmob_dL_VD_S_VD_S=0.0;
  Gmob_dL_VD_S_VGP_S=0.0;
  Gmob_dL_VD_S_VS_BP=0.0;
#endif
Gmob_dL_VGP_S=0.0;
#if defined(_DERIVATE2)
  Gmob_dL_VGP_S_VD_S=0.0;
  Gmob_dL_VGP_S_VGP_S=0.0;
  Gmob_dL_VGP_S_VS_BP=0.0;
#endif
Gmob_dL_VS_BP=0.0;
#if defined(_DERIVATE2)
  Gmob_dL_VS_BP_VD_S=0.0;
  Gmob_dL_VS_BP_VGP_S=0.0;
  Gmob_dL_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Gmob_dL=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(S,BP)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Udse_VGP_S=0.0;
#if defined(_DERIVATE2)
  Udse_VGP_S_VGP_S=0.0;
  Udse_VGP_S_VS_BP=0.0;
  Udse_VGP_S_VD_S=0.0;
#endif
Udse_VS_BP=0.0;
#if defined(_DERIVATE2)
  Udse_VS_BP_VGP_S=0.0;
  Udse_VS_BP_VS_BP=0.0;
  Udse_VS_BP_VD_S=0.0;
#endif
Udse_VD_S=0.0;
#if defined(_DERIVATE2)
  Udse_VD_S_VGP_S=0.0;
  Udse_VD_S_VS_BP=0.0;
  Udse_VD_S_VD_S=0.0;
#endif
#endif
Udse=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
QCLM_VGP_S=0.0;
#if defined(_DERIVATE2)
  QCLM_VGP_S_VGP_S=0.0;
  QCLM_VGP_S_VD_S=0.0;
  QCLM_VGP_S_VS_BP=0.0;
#endif
QCLM_VD_S=0.0;
#if defined(_DERIVATE2)
  QCLM_VD_S_VGP_S=0.0;
  QCLM_VD_S_VD_S=0.0;
  QCLM_VD_S_VS_BP=0.0;
#endif
QCLM_VS_BP=0.0;
#if defined(_DERIVATE2)
  QCLM_VS_BP_VGP_S=0.0;
  QCLM_VS_BP_VD_S=0.0;
  QCLM_VS_BP_VS_BP=0.0;
#endif
#endif
QCLM=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
thesat1_VGP_S=0.0;
#if defined(_DERIVATE2)
  thesat1_VGP_S_VGP_S=0.0;
  thesat1_VGP_S_VD_S=0.0;
  thesat1_VGP_S_VS_BP=0.0;
#endif
thesat1_VD_S=0.0;
#if defined(_DERIVATE2)
  thesat1_VD_S_VGP_S=0.0;
  thesat1_VD_S_VD_S=0.0;
  thesat1_VD_S_VS_BP=0.0;
#endif
thesat1_VS_BP=0.0;
#if defined(_DERIVATE2)
  thesat1_VS_BP_VGP_S=0.0;
  thesat1_VS_BP_VD_S=0.0;
  thesat1_VS_BP_VS_BP=0.0;
#endif
#endif
thesat1=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Gvsat_VD_S=0.0;
#if defined(_DERIVATE2)
  Gvsat_VD_S_VD_S=0.0;
  Gvsat_VD_S_VGP_S=0.0;
  Gvsat_VD_S_VS_BP=0.0;
#endif
Gvsat_VGP_S=0.0;
#if defined(_DERIVATE2)
  Gvsat_VGP_S_VD_S=0.0;
  Gvsat_VGP_S_VGP_S=0.0;
  Gvsat_VGP_S_VS_BP=0.0;
#endif
Gvsat_VS_BP=0.0;
#if defined(_DERIVATE2)
  Gvsat_VS_BP_VD_S=0.0;
  Gvsat_VS_BP_VGP_S=0.0;
  Gvsat_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Gvsat=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Gvsatinv_VD_S=0.0;
#if defined(_DERIVATE2)
  Gvsatinv_VD_S_VD_S=0.0;
  Gvsatinv_VD_S_VGP_S=0.0;
  Gvsatinv_VD_S_VS_BP=0.0;
#endif
Gvsatinv_VGP_S=0.0;
#if defined(_DERIVATE2)
  Gvsatinv_VGP_S_VD_S=0.0;
  Gvsatinv_VGP_S_VGP_S=0.0;
  Gvsatinv_VGP_S_VS_BP=0.0;
#endif
Gvsatinv_VS_BP=0.0;
#if defined(_DERIVATE2)
  Gvsatinv_VS_BP_VD_S=0.0;
  Gvsatinv_VS_BP_VGP_S=0.0;
  Gvsatinv_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Gvsatinv=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
xgm_VD_S=0.0;
#if defined(_DERIVATE2)
  xgm_VD_S_VD_S=0.0;
  xgm_VD_S_VGP_S=0.0;
  xgm_VD_S_VS_BP=0.0;
#endif
xgm_VGP_S=0.0;
#if defined(_DERIVATE2)
  xgm_VGP_S_VD_S=0.0;
  xgm_VGP_S_VGP_S=0.0;
  xgm_VGP_S_VS_BP=0.0;
#endif
xgm_VS_BP=0.0;
#if defined(_DERIVATE2)
  xgm_VS_BP_VD_S=0.0;
  xgm_VS_BP_VGP_S=0.0;
  xgm_VS_BP_VS_BP=0.0;
#endif
#endif
xgm=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
dps_VD_S=0.0;
#if defined(_DERIVATE2)
  dps_VD_S_VD_S=0.0;
  dps_VD_S_VGP_S=0.0;
  dps_VD_S_VS_BP=0.0;
#endif
dps_VGP_S=0.0;
#if defined(_DERIVATE2)
  dps_VGP_S_VD_S=0.0;
  dps_VGP_S_VGP_S=0.0;
  dps_VGP_S_VS_BP=0.0;
#endif
dps_VS_BP=0.0;
#if defined(_DERIVATE2)
  dps_VS_BP_VD_S=0.0;
  dps_VS_BP_VGP_S=0.0;
  dps_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->dps=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
qim_VD_S=0.0;
#if defined(_DERIVATE2)
  qim_VD_S_VD_S=0.0;
  qim_VD_S_VGP_S=0.0;
  qim_VD_S_VS_BP=0.0;
#endif
qim_VGP_S=0.0;
#if defined(_DERIVATE2)
  qim_VGP_S_VD_S=0.0;
  qim_VGP_S_VGP_S=0.0;
  qim_VGP_S_VS_BP=0.0;
#endif
qim_VS_BP=0.0;
#if defined(_DERIVATE2)
  qim_VS_BP_VD_S=0.0;
  qim_VS_BP_VGP_S=0.0;
  qim_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->qim=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
qim1_VD_S=0.0;
#if defined(_DERIVATE2)
  qim1_VD_S_VD_S=0.0;
  qim1_VD_S_VGP_S=0.0;
  qim1_VD_S_VS_BP=0.0;
#endif
qim1_VGP_S=0.0;
#if defined(_DERIVATE2)
  qim1_VGP_S_VD_S=0.0;
  qim1_VGP_S_VGP_S=0.0;
  qim1_VGP_S_VS_BP=0.0;
#endif
qim1_VS_BP=0.0;
#if defined(_DERIVATE2)
  qim1_VS_BP_VD_S=0.0;
  qim1_VS_BP_VGP_S=0.0;
  qim1_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->qim1=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
H_VGP_S=0.0;
#if defined(_DERIVATE2)
  H_VGP_S_VGP_S=0.0;
  H_VGP_S_VD_S=0.0;
  H_VGP_S_VS_BP=0.0;
#endif
H_VD_S=0.0;
#if defined(_DERIVATE2)
  H_VD_S_VGP_S=0.0;
  H_VD_S_VD_S=0.0;
  H_VD_S_VS_BP=0.0;
#endif
H_VS_BP=0.0;
#if defined(_DERIVATE2)
  H_VS_BP_VGP_S=0.0;
  H_VS_BP_VD_S=0.0;
  H_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->H=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xs_ov_VD_S=0.0;
#if defined(_DERIVATE2)
  xs_ov_VD_S_VD_S=0.0;
  xs_ov_VD_S_VS_BP=0.0;
  xs_ov_VD_S_VGP_S=0.0;
#endif
xs_ov_VS_BP=0.0;
#if defined(_DERIVATE2)
  xs_ov_VS_BP_VD_S=0.0;
  xs_ov_VS_BP_VS_BP=0.0;
  xs_ov_VS_BP_VGP_S=0.0;
#endif
xs_ov_VGP_S=0.0;
#if defined(_DERIVATE2)
  xs_ov_VGP_S_VD_S=0.0;
  xs_ov_VGP_S_VS_BP=0.0;
  xs_ov_VGP_S_VGP_S=0.0;
#endif
#endif
xs_ov=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xd_ov_VS_BP=0.0;
#if defined(_DERIVATE2)
  xd_ov_VS_BP_VS_BP=0.0;
  xd_ov_VS_BP_VGP_S=0.0;
  xd_ov_VS_BP_VD_S=0.0;
#endif
xd_ov_VGP_S=0.0;
#if defined(_DERIVATE2)
  xd_ov_VGP_S_VS_BP=0.0;
  xd_ov_VGP_S_VGP_S=0.0;
  xd_ov_VGP_S_VD_S=0.0;
#endif
xd_ov_VD_S=0.0;
#if defined(_DERIVATE2)
  xd_ov_VD_S_VS_BP=0.0;
  xd_ov_VD_S_VGP_S=0.0;
  xd_ov_VD_S_VD_S=0.0;
#endif
#endif
xd_ov=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vovs_VGP_S=0.0;
#if defined(_DERIVATE2)
  Vovs_VGP_S_VGP_S=0.0;
  Vovs_VGP_S_VD_S=0.0;
  Vovs_VGP_S_VS_BP=0.0;
#endif
Vovs_VD_S=0.0;
#if defined(_DERIVATE2)
  Vovs_VD_S_VGP_S=0.0;
  Vovs_VD_S_VD_S=0.0;
  Vovs_VD_S_VS_BP=0.0;
#endif
Vovs_VS_BP=0.0;
#if defined(_DERIVATE2)
  Vovs_VS_BP_VGP_S=0.0;
  Vovs_VS_BP_VD_S=0.0;
  Vovs_VS_BP_VS_BP=0.0;
#endif
#endif
Vovs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vovd_VGP_S=0.0;
#if defined(_DERIVATE2)
  Vovd_VGP_S_VGP_S=0.0;
  Vovd_VGP_S_VD_S=0.0;
  Vovd_VGP_S_VS_BP=0.0;
#endif
Vovd_VD_S=0.0;
#if defined(_DERIVATE2)
  Vovd_VD_S_VGP_S=0.0;
  Vovd_VD_S_VD_S=0.0;
  Vovd_VD_S_VS_BP=0.0;
#endif
Vovd_VS_BP=0.0;
#if defined(_DERIVATE2)
  Vovd_VS_BP_VGP_S=0.0;
  Vovd_VS_BP_VD_S=0.0;
  Vovd_VS_BP_VS_BP=0.0;
#endif
#endif
Vovd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Iimpact_VGP_S=0.0;
#if defined(_DERIVATE2)
  Iimpact_VGP_S_VGP_S=0.0;
  Iimpact_VGP_S_VD_S=0.0;
  Iimpact_VGP_S_VS_BP=0.0;
#endif
Iimpact_VD_S=0.0;
#if defined(_DERIVATE2)
  Iimpact_VD_S_VGP_S=0.0;
  Iimpact_VD_S_VD_S=0.0;
  Iimpact_VD_S_VS_BP=0.0;
#endif
Iimpact_VS_BP=0.0;
#if defined(_DERIVATE2)
  Iimpact_VS_BP_VGP_S=0.0;
  Iimpact_VS_BP_VD_S=0.0;
  Iimpact_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Iimpact=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
mavl_VD_S=0.0;
#if defined(_DERIVATE2)
  mavl_VD_S_VD_S=0.0;
  mavl_VD_S_VGP_S=0.0;
  mavl_VD_S_VS_BP=0.0;
#endif
mavl_VGP_S=0.0;
#if defined(_DERIVATE2)
  mavl_VGP_S_VD_S=0.0;
  mavl_VGP_S_VGP_S=0.0;
  mavl_VGP_S_VS_BP=0.0;
#endif
mavl_VS_BP=0.0;
#if defined(_DERIVATE2)
  mavl_VS_BP_VD_S=0.0;
  mavl_VS_BP_VGP_S=0.0;
  mavl_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->mavl=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->CHNL_TYPE==(+1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vgs_VD_S=0.0;
#if defined(_DERIVATE2)
  Vgs_VD_S_VD_S=0.0;
  Vgs_VD_S_VGP_S=0.0;
#endif
Vgs_VGP_S=1.0;
#if defined(_DERIVATE2)
  Vgs_VGP_S_VD_S=0.0;
  Vgs_VGP_S_VGP_S=0.0;
#endif
#endif
Vgs=(NP(GP)-NP(S));
EXIT_IF_ISNAN((NP(GP)-NP(S)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vds_VD_S=1.0;
#if defined(_DERIVATE2)
  Vds_VD_S_VD_S=0.0;
#endif
#endif
Vds=(NP(D)-NP(S));
EXIT_IF_ISNAN((NP(D)-NP(S)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vsb_VD_S=0.0;
#if defined(_DERIVATE2)
  Vsb_VD_S_VD_S=0.0;
  Vsb_VD_S_VS_BP=0.0;
#endif
Vsb_VS_BP=1.0;
#if defined(_DERIVATE2)
  Vsb_VS_BP_VD_S=0.0;
  Vsb_VS_BP_VS_BP=0.0;
#endif
#endif
Vsb=(NP(S)-NP(BP));
EXIT_IF_ISNAN((NP(S)-NP(BP)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND)V(BS,GND) */
Vjun_s_VS_BS=(-1.0);
#if defined(_DERIVATE2)
  Vjun_s_VS_BS_VS_BS=0.0;
#endif
#endif
Vjun_s=(-(NP(S)-NP(BS)));
EXIT_IF_ISNAN((-(NP(S)-NP(BS))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vjun_d_VD_BD=(-1.0);
#if defined(_DERIVATE2)
  Vjun_d_VD_BD_VD_BD=0.0;
#endif
#endif
Vjun_d=(-(NP(D)-NP(BD)));
EXIT_IF_ISNAN((-(NP(D)-NP(BD))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vgs_VD_S=0.0;
#if defined(_DERIVATE2)
  Vgs_VD_S_VD_S=0.0;
  Vgs_VD_S_VGP_S=0.0;
#endif
Vgs_VGP_S=(-1.0);
#if defined(_DERIVATE2)
  Vgs_VGP_S_VD_S=0.0;
  Vgs_VGP_S_VGP_S=0.0;
#endif
#endif
Vgs=(-(NP(GP)-NP(S)));
EXIT_IF_ISNAN((-(NP(GP)-NP(S))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vds_VD_S=(-1.0);
#if defined(_DERIVATE2)
  Vds_VD_S_VD_S=0.0;
#endif
#endif
Vds=(-(NP(D)-NP(S)));
EXIT_IF_ISNAN((-(NP(D)-NP(S))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vsb_VD_S=0.0;
#if defined(_DERIVATE2)
  Vsb_VD_S_VD_S=0.0;
  Vsb_VD_S_VS_BP=0.0;
#endif
Vsb_VS_BP=(-1.0);
#if defined(_DERIVATE2)
  Vsb_VS_BP_VD_S=0.0;
  Vsb_VS_BP_VS_BP=0.0;
#endif
#endif
Vsb=(-(NP(S)-NP(BP)));
EXIT_IF_ISNAN((-(NP(S)-NP(BP))))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND)V(BS,GND) */
Vjun_s_VS_BS=1.0;
#if defined(_DERIVATE2)
  Vjun_s_VS_BS_VS_BS=0.0;
#endif
#endif
Vjun_s=(NP(S)-NP(BS));
EXIT_IF_ISNAN((NP(S)-NP(BS)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vjun_d_VD_BD=1.0;
#if defined(_DERIVATE2)
  Vjun_d_VD_BD_VD_BD=0.0;
#endif
#endif
Vjun_d=(NP(D)-NP(BD));
EXIT_IF_ISNAN((NP(D)-NP(BD)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
VgsPrime_VGP_S=Vgs_VGP_S;
#if defined(_DERIVATE2)
  VgsPrime_VGP_S_VGP_S=Vgs_VGP_S_VGP_S;
#endif
#endif
VgsPrime=Vgs;
EXIT_IF_ISNAN(Vgs)
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
VsbPrime_VS_BP=Vsb_VS_BP;
#if defined(_DERIVATE2)
  VsbPrime_VS_BP_VS_BP=Vsb_VS_BP_VS_BP;
#endif
#endif
VsbPrime=Vsb;
EXIT_IF_ISNAN(Vsb)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
VdbPrime_VD_S=(Vds_VD_S+Vsb_VD_S);
#if defined(_DERIVATE2)
  VdbPrime_VD_S_VD_S=(+Vds_VD_S_VD_S+Vsb_VD_S_VD_S);
  VdbPrime_VD_S_VS_BP=(+0.0+Vsb_VD_S_VS_BP);
#endif
VdbPrime_VS_BP=Vsb_VS_BP;
#if defined(_DERIVATE2)
  VdbPrime_VS_BP_VD_S=(+0.0+Vsb_VS_BP_VD_S);
  VdbPrime_VS_BP_VS_BP=(+0.0+Vsb_VS_BP_VS_BP);
#endif
#endif
VdbPrime=(Vds+Vsb);
EXIT_IF_ISNAN((Vds+Vsb))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
VgdPrime_VGP_S=Vgs_VGP_S;
#if defined(_DERIVATE2)
  VgdPrime_VGP_S_VGP_S=(+Vgs_VGP_S_VGP_S-0.0);
  VgdPrime_VGP_S_VD_S=(+Vgs_VGP_S_VD_S-0.0);
#endif
VgdPrime_VD_S=(Vgs_VD_S-Vds_VD_S);
#if defined(_DERIVATE2)
  VgdPrime_VD_S_VGP_S=(+Vgs_VD_S_VGP_S-0.0);
  VgdPrime_VD_S_VD_S=(+Vgs_VD_S_VD_S-Vds_VD_S_VD_S);
#endif
#endif
VgdPrime=(Vgs-Vds);
EXIT_IF_ISNAN((Vgs-Vds))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xgs_ov_VGP_S=(-VgsPrime_VGP_S)*pModel->inv_phit;
#if defined(_DERIVATE2)
  xgs_ov_VGP_S_VGP_S=(+0.0*pModel->inv_phit+(-VgsPrime_VGP_S)*0.0+(-VgsPrime_VGP_S)*0.0+(-VgsPrime)*0.0);
#endif
#endif
xgs_ov=((-VgsPrime)*pModel->inv_phit);
EXIT_IF_ISNAN(((-VgsPrime)*pModel->inv_phit))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xgd_ov_VGP_S=(-VgdPrime_VGP_S)*pModel->inv_phit;
#if defined(_DERIVATE2)
  xgd_ov_VGP_S_VGP_S=(+0.0*pModel->inv_phit+(-VgdPrime_VGP_S)*0.0+(-VgdPrime_VGP_S)*0.0+(-VgdPrime)*0.0);
  xgd_ov_VGP_S_VD_S=(+0.0*pModel->inv_phit+(-VgdPrime_VGP_S)*0.0+(-VgdPrime_VD_S)*0.0+(-VgdPrime)*0.0);
#endif
xgd_ov_VD_S=(-VgdPrime_VD_S)*pModel->inv_phit;
#if defined(_DERIVATE2)
  xgd_ov_VD_S_VGP_S=(+0.0*pModel->inv_phit+(-VgdPrime_VD_S)*0.0+(-VgdPrime_VGP_S)*0.0+(-VgdPrime)*0.0);
  xgd_ov_VD_S_VD_S=(+0.0*pModel->inv_phit+(-VgdPrime_VD_S)*0.0+(-VgdPrime_VD_S)*0.0+(-VgdPrime)*0.0);
#endif
#endif
xgd_ov=((-VgdPrime)*pModel->inv_phit);
EXIT_IF_ISNAN(((-VgdPrime)*pModel->inv_phit))
pInst->sigVds=1.0;
EXIT_IF_ISNAN(1.0)
if
((Vds<0.0))
{
pInst->sigVds=(-1.0);
EXIT_IF_ISNAN((-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vgs_VD_S=(Vgs_VD_S-Vds_VD_S);
#if defined(_DERIVATE2)
  Vgs_VD_S_VD_S=(+Vgs_VD_S_VD_S-Vds_VD_S_VD_S);
  Vgs_VD_S_VGP_S=(+Vgs_VD_S_VGP_S-0.0);
#endif
Vgs_VGP_S=Vgs_VGP_S;
#if defined(_DERIVATE2)
  Vgs_VGP_S_VD_S=(+Vgs_VGP_S_VD_S-0.0);
  Vgs_VGP_S_VGP_S=(+Vgs_VGP_S_VGP_S-0.0);
#endif
#endif
Vgs=(Vgs-Vds);
EXIT_IF_ISNAN((Vgs-Vds))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vsb_VD_S=(Vsb_VD_S+Vds_VD_S);
#if defined(_DERIVATE2)
  Vsb_VD_S_VD_S=(+Vsb_VD_S_VD_S+Vds_VD_S_VD_S);
  Vsb_VD_S_VS_BP=(+Vsb_VD_S_VS_BP+0.0);
#endif
Vsb_VS_BP=Vsb_VS_BP;
#if defined(_DERIVATE2)
  Vsb_VS_BP_VD_S=(+Vsb_VS_BP_VD_S+0.0);
  Vsb_VS_BP_VS_BP=(+Vsb_VS_BP_VS_BP+0.0);
#endif
#endif
Vsb=(Vsb+Vds);
EXIT_IF_ISNAN((Vsb+Vds))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vds_VD_S=(-Vds_VD_S);
#if defined(_DERIVATE2)
  Vds_VD_S_VD_S=0.0;
#endif
#endif
Vds=(-Vds);
EXIT_IF_ISNAN((-Vds))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vdb_VD_S=(Vds_VD_S+Vsb_VD_S);
#if defined(_DERIVATE2)
  Vdb_VD_S_VD_S=(+Vds_VD_S_VD_S+Vsb_VD_S_VD_S);
  Vdb_VD_S_VS_BP=(+0.0+Vsb_VD_S_VS_BP);
#endif
Vdb_VS_BP=Vsb_VS_BP;
#if defined(_DERIVATE2)
  Vdb_VS_BP_VD_S=(+0.0+Vsb_VS_BP_VD_S);
  Vdb_VS_BP_VS_BP=(+0.0+Vsb_VS_BP_VS_BP);
#endif
#endif
Vdb=(Vds+Vsb);
EXIT_IF_ISNAN((Vds+Vsb))
{
double m00_sqrt(d00_sqrt0,(((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=0.0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=0.0;
  temp_VGP_S_VD_S=0.0;
  temp_VGP_S_VS_BP=0.0;
#endif
temp_VD_S=(0.5*((Vdb_VD_S+Vsb_VD_S)-(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))*d10_sqrt0));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*(-(0.0)*d10_sqrt0)+0.0*((Vdb_VD_S+Vsb_VD_S)-(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*(0.0)*(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))+d10_sqrt0*(+(+(+0.0-0.0)*(Vdb-Vsb)+(Vdb_VD_S-Vsb_VD_S)*0.0+0.0*(Vdb_VD_S-Vsb_VD_S)+(Vdb-Vsb)*(+0.0-0.0))+0.0))))+0.0);
  temp_VD_S_VS_BS=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*(-(0.0)*d10_sqrt0)+0.0*((Vdb_VD_S+Vsb_VD_S)-(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*(0.0)*(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))+d10_sqrt0*(+(+(+0.0-0.0)*(Vdb-Vsb)+(Vdb_VD_S-Vsb_VD_S)*0.0+0.0*(Vdb_VD_S-Vsb_VD_S)+(Vdb-Vsb)*(+0.0-0.0))+0.0))))+0.0);
  temp_VD_S_VGP_S=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*(-(0.0)*d10_sqrt0)+0.0*((Vdb_VD_S+Vsb_VD_S)-(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*(0.0)*(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))+d10_sqrt0*(+(+(+0.0-0.0)*(Vdb-Vsb)+(Vdb_VD_S-Vsb_VD_S)*0.0+0.0*(Vdb_VD_S-Vsb_VD_S)+(Vdb-Vsb)*(+0.0-0.0))+0.0))))+0.0);
  temp_VD_S_VD_S=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*((Vdb_VD_S+Vsb_VD_S)-((((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S))))*d10_sqrt0)+0.0*((Vdb_VD_S+Vsb_VD_S)-(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))*d10_sqrt0)+0.5*(+(+Vdb_VD_S_VD_S+Vsb_VD_S_VD_S)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*((((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S))))*(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))+d10_sqrt0*(+(+(+Vdb_VD_S_VD_S-Vsb_VD_S_VD_S)*(Vdb-Vsb)+(Vdb_VD_S-Vsb_VD_S)*(Vdb_VD_S-Vsb_VD_S)+(Vdb_VD_S-Vsb_VD_S)*(Vdb_VD_S-Vsb_VD_S)+(Vdb-Vsb)*(+Vdb_VD_S_VD_S-Vsb_VD_S_VD_S))+0.0))))+0.0);
  temp_VD_S_VS_BP=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*((Vdb_VS_BP+Vsb_VS_BP)-((((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP))))*d10_sqrt0)+0.0*((Vdb_VD_S+Vsb_VD_S)-(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))*d10_sqrt0)+0.5*(+(+Vdb_VD_S_VS_BP+Vsb_VD_S_VS_BP)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*((((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP))))*(((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S)))+d10_sqrt0*(+(+(+Vdb_VD_S_VS_BP-Vsb_VD_S_VS_BP)*(Vdb-Vsb)+(Vdb_VD_S-Vsb_VD_S)*(Vdb_VS_BP-Vsb_VS_BP)+(Vdb_VS_BP-Vsb_VS_BP)*(Vdb_VD_S-Vsb_VD_S)+(Vdb-Vsb)*(+Vdb_VD_S_VS_BP-Vsb_VD_S_VS_BP))+0.0))))+0.0);
#endif
temp_VS_BP=(0.5*((Vdb_VS_BP+Vsb_VS_BP)-(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))*d10_sqrt0));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*(-(0.0)*d10_sqrt0)+0.0*((Vdb_VS_BP+Vsb_VS_BP)-(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*(0.0)*(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))+d10_sqrt0*(+(+(+0.0-0.0)*(Vdb-Vsb)+(Vdb_VS_BP-Vsb_VS_BP)*0.0+0.0*(Vdb_VS_BP-Vsb_VS_BP)+(Vdb-Vsb)*(+0.0-0.0))+0.0))))+0.0);
  temp_VS_BP_VS_BS=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*(-(0.0)*d10_sqrt0)+0.0*((Vdb_VS_BP+Vsb_VS_BP)-(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*(0.0)*(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))+d10_sqrt0*(+(+(+0.0-0.0)*(Vdb-Vsb)+(Vdb_VS_BP-Vsb_VS_BP)*0.0+0.0*(Vdb_VS_BP-Vsb_VS_BP)+(Vdb-Vsb)*(+0.0-0.0))+0.0))))+0.0);
  temp_VS_BP_VGP_S=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*(-(0.0)*d10_sqrt0)+0.0*((Vdb_VS_BP+Vsb_VS_BP)-(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*(0.0)*(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))+d10_sqrt0*(+(+(+0.0-0.0)*(Vdb-Vsb)+(Vdb_VS_BP-Vsb_VS_BP)*0.0+0.0*(Vdb_VS_BP-Vsb_VS_BP)+(Vdb-Vsb)*(+0.0-0.0))+0.0))))+0.0);
  temp_VS_BP_VD_S=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*((Vdb_VD_S+Vsb_VD_S)-((((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S))))*d10_sqrt0)+0.0*((Vdb_VS_BP+Vsb_VS_BP)-(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))*d10_sqrt0)+0.5*(+(+Vdb_VS_BP_VD_S+Vsb_VS_BP_VD_S)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*((((Vdb_VD_S-Vsb_VD_S)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VD_S-Vsb_VD_S))))*(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))+d10_sqrt0*(+(+(+Vdb_VS_BP_VD_S-Vsb_VS_BP_VD_S)*(Vdb-Vsb)+(Vdb_VS_BP-Vsb_VS_BP)*(Vdb_VD_S-Vsb_VD_S)+(Vdb_VD_S-Vsb_VD_S)*(Vdb_VS_BP-Vsb_VS_BP)+(Vdb-Vsb)*(+Vdb_VS_BP_VD_S-Vsb_VS_BP_VD_S))+0.0))))+0.0);
  temp_VS_BP_VS_BP=(+(+0.0*((Vdb+Vsb)-d00_sqrt0)+0.0*((Vdb_VS_BP+Vsb_VS_BP)-((((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP))))*d10_sqrt0)+0.0*((Vdb_VS_BP+Vsb_VS_BP)-(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))*d10_sqrt0)+0.5*(+(+Vdb_VS_BP_VS_BP+Vsb_VS_BP_VS_BP)-(m20_sqrt((((Vdb-Vsb)*(Vdb-Vsb))+pInst->bphi))*((((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP))))*(((Vdb_VS_BP-Vsb_VS_BP)*(Vdb-Vsb))+((Vdb-Vsb)*(Vdb_VS_BP-Vsb_VS_BP)))+d10_sqrt0*(+(+(+Vdb_VS_BP_VS_BP-Vsb_VS_BP_VS_BP)*(Vdb-Vsb)+(Vdb_VS_BP-Vsb_VS_BP)*(Vdb_VS_BP-Vsb_VS_BP)+(Vdb_VS_BP-Vsb_VS_BP)*(Vdb_VS_BP-Vsb_VS_BP)+(Vdb-Vsb)*(+Vdb_VS_BP_VS_BP-Vsb_VS_BP_VS_BP))+0.0))))+0.0);
#endif
#endif
temp=((0.5*((Vdb+Vsb)-d00_sqrt0))+pInst->phix);
EXIT_IF_ISNAN(((0.5*((Vdb+Vsb)-d00_sqrt0))+pInst->phix))
}
{
double m00_sqrt(d00_sqrt0,((temp*temp)+pInst->aphi))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((temp*temp)+pInst->aphi))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vsbstar_VD_S=(Vsb_VD_S-(0.5*(temp_VD_S-((temp_VD_S*temp)+(temp*temp_VD_S))*d10_sqrt0)));
#if defined(_DERIVATE2)
  Vsbstar_VD_S_VD_S=(+(+Vsb_VD_S_VD_S-(+0.0*(temp-d00_sqrt0)+0.0*(temp_VD_S-(((temp_VD_S*temp)+(temp*temp_VD_S)))*d10_sqrt0)+0.0*(temp_VD_S-((temp_VD_S*temp)+(temp*temp_VD_S))*d10_sqrt0)+0.5*(+(+temp_VD_S_VD_S+0.0)-(m20_sqrt(((temp*temp)+pInst->aphi))*(((temp_VD_S*temp)+(temp*temp_VD_S)))*((temp_VD_S*temp)+(temp*temp_VD_S))+d10_sqrt0*(+(+(+temp_VD_S_VD_S-0.0)*temp+temp_VD_S*temp_VD_S+temp_VD_S*temp_VD_S+temp*(+temp_VD_S_VD_S-0.0))+0.0)))))+0.0);
  Vsbstar_VD_S_VS_BP=(+(+Vsb_VD_S_VS_BP-(+0.0*(temp-d00_sqrt0)+0.0*(temp_VS_BP-(((temp_VS_BP*temp)+(temp*temp_VS_BP)))*d10_sqrt0)+0.0*(temp_VD_S-((temp_VD_S*temp)+(temp*temp_VD_S))*d10_sqrt0)+0.5*(+(+temp_VD_S_VS_BP+0.0)-(m20_sqrt(((temp*temp)+pInst->aphi))*(((temp_VS_BP*temp)+(temp*temp_VS_BP)))*((temp_VD_S*temp)+(temp*temp_VD_S))+d10_sqrt0*(+(+(+temp_VD_S_VS_BP-0.0)*temp+temp_VD_S*temp_VS_BP+temp_VS_BP*temp_VD_S+temp*(+temp_VD_S_VS_BP-0.0))+0.0)))))+0.0);
#endif
Vsbstar_VS_BP=(Vsb_VS_BP-(0.5*(temp_VS_BP-((temp_VS_BP*temp)+(temp*temp_VS_BP))*d10_sqrt0)));
#if defined(_DERIVATE2)
  Vsbstar_VS_BP_VD_S=(+(+Vsb_VS_BP_VD_S-(+0.0*(temp-d00_sqrt0)+0.0*(temp_VD_S-(((temp_VD_S*temp)+(temp*temp_VD_S)))*d10_sqrt0)+0.0*(temp_VS_BP-((temp_VS_BP*temp)+(temp*temp_VS_BP))*d10_sqrt0)+0.5*(+(+temp_VS_BP_VD_S+0.0)-(m20_sqrt(((temp*temp)+pInst->aphi))*(((temp_VD_S*temp)+(temp*temp_VD_S)))*((temp_VS_BP*temp)+(temp*temp_VS_BP))+d10_sqrt0*(+(+(+temp_VS_BP_VD_S-0.0)*temp+temp_VS_BP*temp_VD_S+temp_VD_S*temp_VS_BP+temp*(+temp_VS_BP_VD_S-0.0))+0.0)))))+0.0);
  Vsbstar_VS_BP_VS_BP=(+(+Vsb_VS_BP_VS_BP-(+0.0*(temp-d00_sqrt0)+0.0*(temp_VS_BP-(((temp_VS_BP*temp)+(temp*temp_VS_BP)))*d10_sqrt0)+0.0*(temp_VS_BP-((temp_VS_BP*temp)+(temp*temp_VS_BP))*d10_sqrt0)+0.5*(+(+temp_VS_BP_VS_BP+0.0)-(m20_sqrt(((temp*temp)+pInst->aphi))*(((temp_VS_BP*temp)+(temp*temp_VS_BP)))*((temp_VS_BP*temp)+(temp*temp_VS_BP))+d10_sqrt0*(+(+(+temp_VS_BP_VS_BP-0.0)*temp+temp_VS_BP*temp_VS_BP+temp_VS_BP*temp_VS_BP+temp*(+temp_VS_BP_VS_BP-0.0))+0.0)))))+0.0);
#endif
#endif
Vsbstar=((Vsb-(0.5*(temp-d00_sqrt0)))+pInst->phix1);
EXIT_IF_ISNAN(((Vsb-(0.5*(temp-d00_sqrt0)))+pInst->phix1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vgbstar_VD_S=(Vgs_VD_S+Vsbstar_VD_S);
#if defined(_DERIVATE2)
  Vgbstar_VD_S_VD_S=(+Vgs_VD_S_VD_S+Vsbstar_VD_S_VD_S);
  Vgbstar_VD_S_VGP_S=(+Vgs_VD_S_VGP_S+0.0);
  Vgbstar_VD_S_VS_BP=(+0.0+Vsbstar_VD_S_VS_BP);
#endif
Vgbstar_VGP_S=Vgs_VGP_S;
#if defined(_DERIVATE2)
  Vgbstar_VGP_S_VD_S=(+Vgs_VGP_S_VD_S+0.0);
  Vgbstar_VGP_S_VGP_S=(+Vgs_VGP_S_VGP_S+0.0);
  Vgbstar_VGP_S_VS_BP=(+0.0+0.0);
#endif
Vgbstar_VS_BP=Vsbstar_VS_BP;
#if defined(_DERIVATE2)
  Vgbstar_VS_BP_VD_S=(+0.0+Vsbstar_VS_BP_VD_S);
  Vgbstar_VS_BP_VGP_S=(+0.0+0.0);
  Vgbstar_VS_BP_VS_BP=(+0.0+Vsbstar_VS_BP_VS_BP);
#endif
#endif
Vgbstar=(Vgs+Vsbstar);
EXIT_IF_ISNAN((Vgs+Vsbstar))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vgb1_VD_S=Vgbstar_VD_S;
#if defined(_DERIVATE2)
  Vgb1_VD_S_VD_S=(+Vgbstar_VD_S_VD_S-0.0);
  Vgb1_VD_S_VGP_S=(+Vgbstar_VD_S_VGP_S-0.0);
  Vgb1_VD_S_VS_BP=(+Vgbstar_VD_S_VS_BP-0.0);
#endif
Vgb1_VGP_S=Vgbstar_VGP_S;
#if defined(_DERIVATE2)
  Vgb1_VGP_S_VD_S=(+Vgbstar_VGP_S_VD_S-0.0);
  Vgb1_VGP_S_VGP_S=(+Vgbstar_VGP_S_VGP_S-0.0);
  Vgb1_VGP_S_VS_BP=(+Vgbstar_VGP_S_VS_BP-0.0);
#endif
Vgb1_VS_BP=Vgbstar_VS_BP;
#if defined(_DERIVATE2)
  Vgb1_VS_BP_VD_S=(+Vgbstar_VS_BP_VD_S-0.0);
  Vgb1_VS_BP_VGP_S=(+Vgbstar_VS_BP_VGP_S-0.0);
  Vgb1_VS_BP_VS_BP=(+Vgbstar_VS_BP_VS_BP-0.0);
#endif
#endif
Vgb1=(Vgbstar-pInst->VFB_i);
EXIT_IF_ISNAN((Vgbstar-pInst->VFB_i))
{
double m00_sqrt(d00_sqrt0,((Vds*Vds)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Vds*Vds)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vdsx_VD_S=((Vds_VD_S*Vds)+(Vds*Vds_VD_S))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdsx_VD_S_VD_S=(+(m20_sqrt(((Vds*Vds)+0.01))*(((Vds_VD_S*Vds)+(Vds*Vds_VD_S)))*((Vds_VD_S*Vds)+(Vds*Vds_VD_S))+d10_sqrt0*(+(+Vds_VD_S_VD_S*Vds+Vds_VD_S*Vds_VD_S+Vds_VD_S*Vds_VD_S+Vds*Vds_VD_S_VD_S)+0.0))-0.0);
#endif
#endif
Vdsx=(d00_sqrt0-0.1);
EXIT_IF_ISNAN((d00_sqrt0-0.1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vsbx_VD_S=(Vsbstar_VD_S+(0.5*(Vds_VD_S-Vdsx_VD_S)));
#if defined(_DERIVATE2)
  Vsbx_VD_S_VD_S=(+Vsbstar_VD_S_VD_S+(+0.0*(Vds-Vdsx)+0.0*(Vds_VD_S-Vdsx_VD_S)+0.0*(Vds_VD_S-Vdsx_VD_S)+0.5*(+Vds_VD_S_VD_S-Vdsx_VD_S_VD_S)));
  Vsbx_VD_S_VS_BP=(+Vsbstar_VD_S_VS_BP+(+0.0*(Vds-Vdsx)+0.0*0.0+0.0*(Vds_VD_S-Vdsx_VD_S)+0.5*(+0.0-0.0)));
#endif
Vsbx_VS_BP=Vsbstar_VS_BP;
#if defined(_DERIVATE2)
  Vsbx_VS_BP_VD_S=(+Vsbstar_VS_BP_VD_S+(+0.0*(Vds-Vdsx)+0.0*(Vds_VD_S-Vdsx_VD_S)+0.0*0.0+0.5*(+0.0-0.0)));
  Vsbx_VS_BP_VS_BP=(+Vsbstar_VS_BP_VS_BP+(+0.0*(Vds-Vdsx)+0.0*0.0+0.0*0.0+0.5*(+0.0-0.0)));
#endif
#endif
Vsbx=(Vsbstar+(0.5*(Vds-Vdsx)));
EXIT_IF_ISNAN((Vsbstar+(0.5*(Vds-Vdsx))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delVg_VD_S=(pInst->CF_i*((Vdsx_VD_S*(1+(pInst->CFB_i*Vsbx)))+(Vdsx*(pInst->CFB_i*Vsbx_VD_S))));
#if defined(_DERIVATE2)
  delVg_VD_S_VD_S=(+0.0*(Vdsx*(1+(pInst->CFB_i*Vsbx)))+0.0*(((Vdsx_VD_S*(1+(pInst->CFB_i*Vsbx)))+(Vdsx*((pInst->CFB_i*Vsbx_VD_S)))))+0.0*((Vdsx_VD_S*(1+(pInst->CFB_i*Vsbx)))+(Vdsx*(pInst->CFB_i*Vsbx_VD_S)))+pInst->CF_i*(+Vdsx_VD_S_VD_S*(1+(pInst->CFB_i*Vsbx))+Vdsx_VD_S*((pInst->CFB_i*Vsbx_VD_S))+Vdsx_VD_S*(pInst->CFB_i*Vsbx_VD_S)+Vdsx*(+0.0+(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VD_S+pInst->CFB_i*Vsbx_VD_S_VD_S))));
  delVg_VD_S_VS_BP=(+0.0*(Vdsx*(1+(pInst->CFB_i*Vsbx)))+0.0*((Vdsx*((pInst->CFB_i*Vsbx_VS_BP))))+0.0*((Vdsx_VD_S*(1+(pInst->CFB_i*Vsbx)))+(Vdsx*(pInst->CFB_i*Vsbx_VD_S)))+pInst->CF_i*(+0.0*(1+(pInst->CFB_i*Vsbx))+Vdsx_VD_S*((pInst->CFB_i*Vsbx_VS_BP))+0.0*(pInst->CFB_i*Vsbx_VD_S)+Vdsx*(+0.0+(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VD_S+pInst->CFB_i*Vsbx_VD_S_VS_BP))));
#endif
delVg_VS_BP=(pInst->CF_i*(Vdsx*(pInst->CFB_i*Vsbx_VS_BP)));
#if defined(_DERIVATE2)
  delVg_VS_BP_VD_S=(+0.0*(Vdsx*(1+(pInst->CFB_i*Vsbx)))+0.0*(((Vdsx_VD_S*(1+(pInst->CFB_i*Vsbx)))+(Vdsx*((pInst->CFB_i*Vsbx_VD_S)))))+0.0*(Vdsx*(pInst->CFB_i*Vsbx_VS_BP))+pInst->CF_i*(+0.0*(1+(pInst->CFB_i*Vsbx))+0.0*((pInst->CFB_i*Vsbx_VD_S))+Vdsx_VD_S*(pInst->CFB_i*Vsbx_VS_BP)+Vdsx*(+0.0+(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VS_BP+pInst->CFB_i*Vsbx_VS_BP_VD_S))));
  delVg_VS_BP_VS_BP=(+0.0*(Vdsx*(1+(pInst->CFB_i*Vsbx)))+0.0*((Vdsx*((pInst->CFB_i*Vsbx_VS_BP))))+0.0*(Vdsx*(pInst->CFB_i*Vsbx_VS_BP))+pInst->CF_i*(+0.0*(1+(pInst->CFB_i*Vsbx))+0.0*((pInst->CFB_i*Vsbx_VS_BP))+0.0*(pInst->CFB_i*Vsbx_VS_BP)+Vdsx*(+0.0+(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VS_BP+pInst->CFB_i*Vsbx_VS_BP_VS_BP))));
#endif
#endif
delVg=(pInst->CF_i*(Vdsx*(1+(pInst->CFB_i*Vsbx))));
EXIT_IF_ISNAN((pInst->CF_i*(Vdsx*(1+(pInst->CFB_i*Vsbx)))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vgb1_VD_S=(Vgb1_VD_S+delVg_VD_S);
#if defined(_DERIVATE2)
  Vgb1_VD_S_VD_S=(+Vgb1_VD_S_VD_S+delVg_VD_S_VD_S);
  Vgb1_VD_S_VGP_S=(+Vgb1_VD_S_VGP_S+0.0);
  Vgb1_VD_S_VS_BP=(+Vgb1_VD_S_VS_BP+delVg_VD_S_VS_BP);
#endif
Vgb1_VGP_S=Vgb1_VGP_S;
#if defined(_DERIVATE2)
  Vgb1_VGP_S_VD_S=(+Vgb1_VGP_S_VD_S+0.0);
  Vgb1_VGP_S_VGP_S=(+Vgb1_VGP_S_VGP_S+0.0);
  Vgb1_VGP_S_VS_BP=(+Vgb1_VGP_S_VS_BP+0.0);
#endif
Vgb1_VS_BP=(Vgb1_VS_BP+delVg_VS_BP);
#if defined(_DERIVATE2)
  Vgb1_VS_BP_VD_S=(+Vgb1_VS_BP_VD_S+delVg_VS_BP_VD_S);
  Vgb1_VS_BP_VGP_S=(+Vgb1_VS_BP_VGP_S+0.0);
  Vgb1_VS_BP_VS_BP=(+Vgb1_VS_BP_VS_BP+delVg_VS_BP_VS_BP);
#endif
#endif
Vgb1=(Vgb1+delVg);
EXIT_IF_ISNAN((Vgb1+delVg))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xg_VD_S=Vgb1_VD_S*pInst->inv_phit1;
#if defined(_DERIVATE2)
  xg_VD_S_VD_S=(+Vgb1_VD_S_VD_S*pInst->inv_phit1+Vgb1_VD_S*0.0+Vgb1_VD_S*0.0+Vgb1*0.0);
  xg_VD_S_VGP_S=(+Vgb1_VD_S_VGP_S*pInst->inv_phit1+Vgb1_VD_S*0.0+Vgb1_VGP_S*0.0+Vgb1*0.0);
  xg_VD_S_VS_BP=(+Vgb1_VD_S_VS_BP*pInst->inv_phit1+Vgb1_VD_S*0.0+Vgb1_VS_BP*0.0+Vgb1*0.0);
#endif
xg_VGP_S=Vgb1_VGP_S*pInst->inv_phit1;
#if defined(_DERIVATE2)
  xg_VGP_S_VD_S=(+Vgb1_VGP_S_VD_S*pInst->inv_phit1+Vgb1_VGP_S*0.0+Vgb1_VD_S*0.0+Vgb1*0.0);
  xg_VGP_S_VGP_S=(+Vgb1_VGP_S_VGP_S*pInst->inv_phit1+Vgb1_VGP_S*0.0+Vgb1_VGP_S*0.0+Vgb1*0.0);
  xg_VGP_S_VS_BP=(+Vgb1_VGP_S_VS_BP*pInst->inv_phit1+Vgb1_VGP_S*0.0+Vgb1_VS_BP*0.0+Vgb1*0.0);
#endif
xg_VS_BP=Vgb1_VS_BP*pInst->inv_phit1;
#if defined(_DERIVATE2)
  xg_VS_BP_VD_S=(+Vgb1_VS_BP_VD_S*pInst->inv_phit1+Vgb1_VS_BP*0.0+Vgb1_VD_S*0.0+Vgb1*0.0);
  xg_VS_BP_VGP_S=(+Vgb1_VS_BP_VGP_S*pInst->inv_phit1+Vgb1_VS_BP*0.0+Vgb1_VGP_S*0.0+Vgb1*0.0);
  xg_VS_BP_VS_BP=(+Vgb1_VS_BP_VS_BP*pInst->inv_phit1+Vgb1_VS_BP*0.0+Vgb1_VS_BP*0.0+Vgb1*0.0);
#endif
#endif
pInst->xg=(Vgb1*pInst->inv_phit1);
EXIT_IF_ISNAN((Vgb1*pInst->inv_phit1))
if
((pInst->DNSUB_i>0.0))
{
{
double m00_sqrt(d00_sqrt0,(((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Dnsub_VD_S=((pInst->DNSUB_i*0.5)*((Vgs_VD_S+Vsb_VD_S)+(((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S))))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dnsub_VD_S_VD_S=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*((Vgs_VD_S+Vsb_VD_S)+((((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S)))))*d10_sqrt0)+(0.0)*((Vgs_VD_S+Vsb_VD_S)+(((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S))))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+Vgs_VD_S_VD_S+Vsb_VD_S_VD_S)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S)))))*(((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S))))+d10_sqrt0*(+(+(+0.0-(+(+Vgs_VD_S_VD_S+Vsb_VD_S_VD_S)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-(Vgs_VD_S+Vsb_VD_S))*(-(Vgs_VD_S+Vsb_VD_S))+(-(Vgs_VD_S+Vsb_VD_S))*(-(Vgs_VD_S+Vsb_VD_S))+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+Vgs_VD_S_VD_S+Vsb_VD_S_VD_S)-0.0)))+0.0))));
  Dnsub_VD_S_VGP_S=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*(Vgs_VGP_S+((((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S))))*d10_sqrt0)+(0.0)*((Vgs_VD_S+Vsb_VD_S)+(((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S))))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+Vgs_VD_S_VGP_S+0.0)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S))))*(((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S))))+d10_sqrt0*(+(+(+0.0-(+(+Vgs_VD_S_VGP_S+0.0)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-(Vgs_VD_S+Vsb_VD_S))*(-Vgs_VGP_S)+(-Vgs_VGP_S)*(-(Vgs_VD_S+Vsb_VD_S))+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+Vgs_VD_S_VGP_S+0.0)-0.0)))+0.0))));
  Dnsub_VD_S_VS_BP=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*(Vsb_VS_BP+((((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP))))*d10_sqrt0)+(0.0)*((Vgs_VD_S+Vsb_VD_S)+(((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S))))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+0.0+Vsb_VD_S_VS_BP)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP))))*(((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S))))+d10_sqrt0*(+(+(+0.0-(+(+0.0+Vsb_VD_S_VS_BP)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-(Vgs_VD_S+Vsb_VD_S))*(-Vsb_VS_BP)+(-Vsb_VS_BP)*(-(Vgs_VD_S+Vsb_VD_S))+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+0.0+Vsb_VD_S_VS_BP)-0.0)))+0.0))));
#endif
Dnsub_VGP_S=((pInst->DNSUB_i*0.5)*(Vgs_VGP_S+(((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S)))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dnsub_VGP_S_VD_S=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*((Vgs_VD_S+Vsb_VD_S)+((((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S)))))*d10_sqrt0)+(0.0)*(Vgs_VGP_S+(((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S)))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+Vgs_VGP_S_VD_S+0.0)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S)))))*(((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S)))+d10_sqrt0*(+(+(+0.0-(+(+Vgs_VGP_S_VD_S+0.0)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-Vgs_VGP_S)*(-(Vgs_VD_S+Vsb_VD_S))+(-(Vgs_VD_S+Vsb_VD_S))*(-Vgs_VGP_S)+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+Vgs_VGP_S_VD_S+0.0)-0.0)))+0.0))));
  Dnsub_VGP_S_VGP_S=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*(Vgs_VGP_S+((((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S))))*d10_sqrt0)+(0.0)*(Vgs_VGP_S+(((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S)))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+Vgs_VGP_S_VGP_S+0.0)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S))))*(((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S)))+d10_sqrt0*(+(+(+0.0-(+(+Vgs_VGP_S_VGP_S+0.0)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-Vgs_VGP_S)*(-Vgs_VGP_S)+(-Vgs_VGP_S)*(-Vgs_VGP_S)+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+Vgs_VGP_S_VGP_S+0.0)-0.0)))+0.0))));
  Dnsub_VGP_S_VS_BP=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*(Vsb_VS_BP+((((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP))))*d10_sqrt0)+(0.0)*(Vgs_VGP_S+(((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S)))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+0.0+0.0)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP))))*(((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S)))+d10_sqrt0*(+(+(+0.0-(+(+0.0+0.0)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-Vgs_VGP_S)*(-Vsb_VS_BP)+(-Vsb_VS_BP)*(-Vgs_VGP_S)+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+0.0+0.0)-0.0)))+0.0))));
#endif
Dnsub_VS_BP=((pInst->DNSUB_i*0.5)*(Vsb_VS_BP+(((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP)))*d10_sqrt0));
#if defined(_DERIVATE2)
  Dnsub_VS_BP_VD_S=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*((Vgs_VD_S+Vsb_VD_S)+((((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S)))))*d10_sqrt0)+(0.0)*(Vsb_VS_BP+(((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP)))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+0.0+Vsb_VS_BP_VD_S)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-(Vgs_VD_S+Vsb_VD_S))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-(Vgs_VD_S+Vsb_VD_S)))))*(((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP)))+d10_sqrt0*(+(+(+0.0-(+(+0.0+Vsb_VS_BP_VD_S)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-Vsb_VS_BP)*(-(Vgs_VD_S+Vsb_VD_S))+(-(Vgs_VD_S+Vsb_VD_S))*(-Vsb_VS_BP)+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+0.0+Vsb_VS_BP_VD_S)-0.0)))+0.0))));
  Dnsub_VS_BP_VGP_S=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*(Vgs_VGP_S+((((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S))))*d10_sqrt0)+(0.0)*(Vsb_VS_BP+(((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP)))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+0.0+0.0)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-Vgs_VGP_S)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vgs_VGP_S))))*(((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP)))+d10_sqrt0*(+(+(+0.0-(+(+0.0+0.0)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-Vsb_VS_BP)*(-Vgs_VGP_S)+(-Vgs_VGP_S)*(-Vsb_VS_BP)+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+0.0+0.0)-0.0)))+0.0))));
  Dnsub_VS_BP_VS_BP=(+(+0.0*0.5+0.0*0.0+0.0*0.0+pInst->DNSUB_i*0.0)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)+0.0*(Vsb_VS_BP+((((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP))))*d10_sqrt0)+(0.0)*(Vsb_VS_BP+(((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP)))*d10_sqrt0)+(pInst->DNSUB_i*0.5)*(+(+0.0+(+(+0.0+Vsb_VS_BP_VS_BP)-0.0))+(m20_sqrt((((-((Vgs+Vsb)-pInst->VNSUB_i))*(-((Vgs+Vsb)-pInst->VNSUB_i)))+pInst->NSLP_i))*((((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP))))*(((-Vsb_VS_BP)*(-((Vgs+Vsb)-pInst->VNSUB_i)))+((-((Vgs+Vsb)-pInst->VNSUB_i))*(-Vsb_VS_BP)))+d10_sqrt0*(+(+(+0.0-(+(+0.0+Vsb_VS_BP_VS_BP)-0.0))*(-((Vgs+Vsb)-pInst->VNSUB_i))+(-Vsb_VS_BP)*(-Vsb_VS_BP)+(-Vsb_VS_BP)*(-Vsb_VS_BP)+(-((Vgs+Vsb)-pInst->VNSUB_i))*(+0.0-(+(+0.0+Vsb_VS_BP_VS_BP)-0.0)))+0.0))));
#endif
#endif
Dnsub=((pInst->DNSUB_i*0.5)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0));
EXIT_IF_ISNAN(((pInst->DNSUB_i*0.5)*((+((Vgs+Vsb)-pInst->VNSUB_i))+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,(1.0+Dnsub))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+Dnsub))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Gf_VD_S=(pInst->G_0*Dnsub_VD_S*d10_sqrt0);
#if defined(_DERIVATE2)
  Gf_VD_S_VD_S=(+0.0*d00_sqrt0+0.0*Dnsub_VD_S*d10_sqrt0+0.0*Dnsub_VD_S*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VD_S*Dnsub_VD_S+d10_sqrt0*(+0.0+Dnsub_VD_S_VD_S)));
  Gf_VD_S_VGP_S=(+0.0*d00_sqrt0+0.0*Dnsub_VGP_S*d10_sqrt0+0.0*Dnsub_VD_S*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VGP_S*Dnsub_VD_S+d10_sqrt0*(+0.0+Dnsub_VD_S_VGP_S)));
  Gf_VD_S_VS_BP=(+0.0*d00_sqrt0+0.0*Dnsub_VS_BP*d10_sqrt0+0.0*Dnsub_VD_S*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VS_BP*Dnsub_VD_S+d10_sqrt0*(+0.0+Dnsub_VD_S_VS_BP)));
#endif
Gf_VGP_S=(pInst->G_0*Dnsub_VGP_S*d10_sqrt0);
#if defined(_DERIVATE2)
  Gf_VGP_S_VD_S=(+0.0*d00_sqrt0+0.0*Dnsub_VD_S*d10_sqrt0+0.0*Dnsub_VGP_S*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VD_S*Dnsub_VGP_S+d10_sqrt0*(+0.0+Dnsub_VGP_S_VD_S)));
  Gf_VGP_S_VGP_S=(+0.0*d00_sqrt0+0.0*Dnsub_VGP_S*d10_sqrt0+0.0*Dnsub_VGP_S*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VGP_S*Dnsub_VGP_S+d10_sqrt0*(+0.0+Dnsub_VGP_S_VGP_S)));
  Gf_VGP_S_VS_BP=(+0.0*d00_sqrt0+0.0*Dnsub_VS_BP*d10_sqrt0+0.0*Dnsub_VGP_S*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VS_BP*Dnsub_VGP_S+d10_sqrt0*(+0.0+Dnsub_VGP_S_VS_BP)));
#endif
Gf_VS_BP=(pInst->G_0*Dnsub_VS_BP*d10_sqrt0);
#if defined(_DERIVATE2)
  Gf_VS_BP_VD_S=(+0.0*d00_sqrt0+0.0*Dnsub_VD_S*d10_sqrt0+0.0*Dnsub_VS_BP*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VD_S*Dnsub_VS_BP+d10_sqrt0*(+0.0+Dnsub_VS_BP_VD_S)));
  Gf_VS_BP_VGP_S=(+0.0*d00_sqrt0+0.0*Dnsub_VGP_S*d10_sqrt0+0.0*Dnsub_VS_BP*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VGP_S*Dnsub_VS_BP+d10_sqrt0*(+0.0+Dnsub_VS_BP_VGP_S)));
  Gf_VS_BP_VS_BP=(+0.0*d00_sqrt0+0.0*Dnsub_VS_BP*d10_sqrt0+0.0*Dnsub_VS_BP*d10_sqrt0+pInst->G_0*(m20_sqrt((1.0+Dnsub))*Dnsub_VS_BP*Dnsub_VS_BP+d10_sqrt0*(+0.0+Dnsub_VS_BP_VS_BP)));
#endif
#endif
Gf=(pInst->G_0*d00_sqrt0);
EXIT_IF_ISNAN((pInst->G_0*d00_sqrt0))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Gf_VD_S=0.0;
#if defined(_DERIVATE2)
  Gf_VD_S_VD_S=0.0;
  Gf_VD_S_VGP_S=0.0;
  Gf_VD_S_VS_BP=0.0;
#endif
Gf_VGP_S=0.0;
#if defined(_DERIVATE2)
  Gf_VGP_S_VD_S=0.0;
  Gf_VGP_S_VGP_S=0.0;
  Gf_VGP_S_VS_BP=0.0;
#endif
Gf_VS_BP=0.0;
#if defined(_DERIVATE2)
  Gf_VS_BP_VD_S=0.0;
  Gf_VS_BP_VGP_S=0.0;
  Gf_VS_BP_VS_BP=0.0;
#endif
#endif
Gf=pInst->G_0;
EXIT_IF_ISNAN(pInst->G_0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
Gf2_VD_S=((Gf_VD_S*Gf)+(Gf*Gf_VD_S));
#if defined(_DERIVATE2)
  Gf2_VD_S_VD_S=(+Gf_VD_S_VD_S*Gf+Gf_VD_S*Gf_VD_S+Gf_VD_S*Gf_VD_S+Gf*Gf_VD_S_VD_S);
  Gf2_VD_S_VGP_S=(+Gf_VD_S_VGP_S*Gf+Gf_VD_S*Gf_VGP_S+Gf_VGP_S*Gf_VD_S+Gf*Gf_VD_S_VGP_S);
  Gf2_VD_S_VS_BP=(+Gf_VD_S_VS_BP*Gf+Gf_VD_S*Gf_VS_BP+Gf_VS_BP*Gf_VD_S+Gf*Gf_VD_S_VS_BP);
#endif
Gf2_VGP_S=((Gf_VGP_S*Gf)+(Gf*Gf_VGP_S));
#if defined(_DERIVATE2)
  Gf2_VGP_S_VD_S=(+Gf_VGP_S_VD_S*Gf+Gf_VGP_S*Gf_VD_S+Gf_VD_S*Gf_VGP_S+Gf*Gf_VGP_S_VD_S);
  Gf2_VGP_S_VGP_S=(+Gf_VGP_S_VGP_S*Gf+Gf_VGP_S*Gf_VGP_S+Gf_VGP_S*Gf_VGP_S+Gf*Gf_VGP_S_VGP_S);
  Gf2_VGP_S_VS_BP=(+Gf_VGP_S_VS_BP*Gf+Gf_VGP_S*Gf_VS_BP+Gf_VS_BP*Gf_VGP_S+Gf*Gf_VGP_S_VS_BP);
#endif
Gf2_VS_BP=((Gf_VS_BP*Gf)+(Gf*Gf_VS_BP));
#if defined(_DERIVATE2)
  Gf2_VS_BP_VD_S=(+Gf_VS_BP_VD_S*Gf+Gf_VS_BP*Gf_VD_S+Gf_VD_S*Gf_VS_BP+Gf*Gf_VS_BP_VD_S);
  Gf2_VS_BP_VGP_S=(+Gf_VS_BP_VGP_S*Gf+Gf_VS_BP*Gf_VGP_S+Gf_VGP_S*Gf_VS_BP+Gf*Gf_VS_BP_VGP_S);
  Gf2_VS_BP_VS_BP=(+Gf_VS_BP_VS_BP*Gf+Gf_VS_BP*Gf_VS_BP+Gf_VS_BP*Gf_VS_BP+Gf*Gf_VS_BP_VS_BP);
#endif
#endif
Gf2=(Gf*Gf);
EXIT_IF_ISNAN((Gf*Gf))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
inv_Gf2_VD_S=(-Gf2_VD_S/Gf2/Gf2);
#if defined(_DERIVATE2)
  inv_Gf2_VD_S_VD_S=(0.0/Gf2-(0.0*Gf2_VD_S+0.0*Gf2_VD_S+1.0*Gf2_VD_S_VD_S)/Gf2/Gf2+2*1.0*Gf2_VD_S*Gf2_VD_S/Gf2/Gf2/Gf2);
  inv_Gf2_VD_S_VGP_S=(0.0/Gf2-(0.0*Gf2_VGP_S+0.0*Gf2_VD_S+1.0*Gf2_VD_S_VGP_S)/Gf2/Gf2+2*1.0*Gf2_VD_S*Gf2_VGP_S/Gf2/Gf2/Gf2);
  inv_Gf2_VD_S_VS_BP=(0.0/Gf2-(0.0*Gf2_VS_BP+0.0*Gf2_VD_S+1.0*Gf2_VD_S_VS_BP)/Gf2/Gf2+2*1.0*Gf2_VD_S*Gf2_VS_BP/Gf2/Gf2/Gf2);
#endif
inv_Gf2_VGP_S=(-Gf2_VGP_S/Gf2/Gf2);
#if defined(_DERIVATE2)
  inv_Gf2_VGP_S_VD_S=(0.0/Gf2-(0.0*Gf2_VD_S+0.0*Gf2_VGP_S+1.0*Gf2_VGP_S_VD_S)/Gf2/Gf2+2*1.0*Gf2_VGP_S*Gf2_VD_S/Gf2/Gf2/Gf2);
  inv_Gf2_VGP_S_VGP_S=(0.0/Gf2-(0.0*Gf2_VGP_S+0.0*Gf2_VGP_S+1.0*Gf2_VGP_S_VGP_S)/Gf2/Gf2+2*1.0*Gf2_VGP_S*Gf2_VGP_S/Gf2/Gf2/Gf2);
  inv_Gf2_VGP_S_VS_BP=(0.0/Gf2-(0.0*Gf2_VS_BP+0.0*Gf2_VGP_S+1.0*Gf2_VGP_S_VS_BP)/Gf2/Gf2+2*1.0*Gf2_VGP_S*Gf2_VS_BP/Gf2/Gf2/Gf2);
#endif
inv_Gf2_VS_BP=(-Gf2_VS_BP/Gf2/Gf2);
#if defined(_DERIVATE2)
  inv_Gf2_VS_BP_VD_S=(0.0/Gf2-(0.0*Gf2_VD_S+0.0*Gf2_VS_BP+1.0*Gf2_VS_BP_VD_S)/Gf2/Gf2+2*1.0*Gf2_VS_BP*Gf2_VD_S/Gf2/Gf2/Gf2);
  inv_Gf2_VS_BP_VGP_S=(0.0/Gf2-(0.0*Gf2_VGP_S+0.0*Gf2_VS_BP+1.0*Gf2_VS_BP_VGP_S)/Gf2/Gf2+2*1.0*Gf2_VS_BP*Gf2_VGP_S/Gf2/Gf2/Gf2);
  inv_Gf2_VS_BP_VS_BP=(0.0/Gf2-(0.0*Gf2_VS_BP+0.0*Gf2_VS_BP+1.0*Gf2_VS_BP_VS_BP)/Gf2/Gf2+2*1.0*Gf2_VS_BP*Gf2_VS_BP/Gf2/Gf2/Gf2);
#endif
#endif
inv_Gf2=(1.0/Gf2);
EXIT_IF_ISNAN((1.0/Gf2))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xi_VD_S=Gf_VD_S*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  xi_VD_S_VD_S=(+0.0+(+Gf_VD_S_VD_S*7.0710678118654746e-01+Gf_VD_S*0.0+Gf_VD_S*0.0+Gf*0.0));
  xi_VD_S_VGP_S=(+0.0+(+Gf_VD_S_VGP_S*7.0710678118654746e-01+Gf_VD_S*0.0+Gf_VGP_S*0.0+Gf*0.0));
  xi_VD_S_VS_BP=(+0.0+(+Gf_VD_S_VS_BP*7.0710678118654746e-01+Gf_VD_S*0.0+Gf_VS_BP*0.0+Gf*0.0));
#endif
xi_VGP_S=Gf_VGP_S*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  xi_VGP_S_VD_S=(+0.0+(+Gf_VGP_S_VD_S*7.0710678118654746e-01+Gf_VGP_S*0.0+Gf_VD_S*0.0+Gf*0.0));
  xi_VGP_S_VGP_S=(+0.0+(+Gf_VGP_S_VGP_S*7.0710678118654746e-01+Gf_VGP_S*0.0+Gf_VGP_S*0.0+Gf*0.0));
  xi_VGP_S_VS_BP=(+0.0+(+Gf_VGP_S_VS_BP*7.0710678118654746e-01+Gf_VGP_S*0.0+Gf_VS_BP*0.0+Gf*0.0));
#endif
xi_VS_BP=Gf_VS_BP*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  xi_VS_BP_VD_S=(+0.0+(+Gf_VS_BP_VD_S*7.0710678118654746e-01+Gf_VS_BP*0.0+Gf_VD_S*0.0+Gf*0.0));
  xi_VS_BP_VGP_S=(+0.0+(+Gf_VS_BP_VGP_S*7.0710678118654746e-01+Gf_VS_BP*0.0+Gf_VGP_S*0.0+Gf*0.0));
  xi_VS_BP_VS_BP=(+0.0+(+Gf_VS_BP_VS_BP*7.0710678118654746e-01+Gf_VS_BP*0.0+Gf_VS_BP*0.0+Gf*0.0));
#endif
#endif
xi=(1.0+(Gf*7.0710678118654746e-01));
EXIT_IF_ISNAN((1.0+(Gf*7.0710678118654746e-01)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
inv_xi_VD_S=(-xi_VD_S/xi/xi);
#if defined(_DERIVATE2)
  inv_xi_VD_S_VD_S=(0.0/xi-(0.0*xi_VD_S+0.0*xi_VD_S+1.0*xi_VD_S_VD_S)/xi/xi+2*1.0*xi_VD_S*xi_VD_S/xi/xi/xi);
  inv_xi_VD_S_VGP_S=(0.0/xi-(0.0*xi_VGP_S+0.0*xi_VD_S+1.0*xi_VD_S_VGP_S)/xi/xi+2*1.0*xi_VD_S*xi_VGP_S/xi/xi/xi);
  inv_xi_VD_S_VS_BP=(0.0/xi-(0.0*xi_VS_BP+0.0*xi_VD_S+1.0*xi_VD_S_VS_BP)/xi/xi+2*1.0*xi_VD_S*xi_VS_BP/xi/xi/xi);
#endif
inv_xi_VGP_S=(-xi_VGP_S/xi/xi);
#if defined(_DERIVATE2)
  inv_xi_VGP_S_VD_S=(0.0/xi-(0.0*xi_VD_S+0.0*xi_VGP_S+1.0*xi_VGP_S_VD_S)/xi/xi+2*1.0*xi_VGP_S*xi_VD_S/xi/xi/xi);
  inv_xi_VGP_S_VGP_S=(0.0/xi-(0.0*xi_VGP_S+0.0*xi_VGP_S+1.0*xi_VGP_S_VGP_S)/xi/xi+2*1.0*xi_VGP_S*xi_VGP_S/xi/xi/xi);
  inv_xi_VGP_S_VS_BP=(0.0/xi-(0.0*xi_VS_BP+0.0*xi_VGP_S+1.0*xi_VGP_S_VS_BP)/xi/xi+2*1.0*xi_VGP_S*xi_VS_BP/xi/xi/xi);
#endif
inv_xi_VS_BP=(-xi_VS_BP/xi/xi);
#if defined(_DERIVATE2)
  inv_xi_VS_BP_VD_S=(0.0/xi-(0.0*xi_VD_S+0.0*xi_VS_BP+1.0*xi_VS_BP_VD_S)/xi/xi+2*1.0*xi_VS_BP*xi_VD_S/xi/xi/xi);
  inv_xi_VS_BP_VGP_S=(0.0/xi-(0.0*xi_VGP_S+0.0*xi_VS_BP+1.0*xi_VS_BP_VGP_S)/xi/xi+2*1.0*xi_VS_BP*xi_VGP_S/xi/xi/xi);
  inv_xi_VS_BP_VS_BP=(0.0/xi-(0.0*xi_VS_BP+0.0*xi_VS_BP+1.0*xi_VS_BP_VS_BP)/xi/xi+2*1.0*xi_VS_BP*xi_VS_BP/xi/xi/xi);
#endif
#endif
inv_xi=(1.0/xi);
EXIT_IF_ISNAN((1.0/xi))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ux_VD_S=Vsbstar_VD_S*pInst->inv_phit1;
#if defined(_DERIVATE2)
  Ux_VD_S_VD_S=(+Vsbstar_VD_S_VD_S*pInst->inv_phit1+Vsbstar_VD_S*0.0+Vsbstar_VD_S*0.0+Vsbstar*0.0);
  Ux_VD_S_VS_BP=(+Vsbstar_VD_S_VS_BP*pInst->inv_phit1+Vsbstar_VD_S*0.0+Vsbstar_VS_BP*0.0+Vsbstar*0.0);
#endif
Ux_VS_BP=Vsbstar_VS_BP*pInst->inv_phit1;
#if defined(_DERIVATE2)
  Ux_VS_BP_VD_S=(+Vsbstar_VS_BP_VD_S*pInst->inv_phit1+Vsbstar_VS_BP*0.0+Vsbstar_VD_S*0.0+Vsbstar*0.0);
  Ux_VS_BP_VS_BP=(+Vsbstar_VS_BP_VS_BP*pInst->inv_phit1+Vsbstar_VS_BP*0.0+Vsbstar_VS_BP*0.0+Vsbstar*0.0);
#endif
#endif
Ux=(Vsbstar*pInst->inv_phit1);
EXIT_IF_ISNAN((Vsbstar*pInst->inv_phit1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xn_s_VD_S=Ux_VD_S;
#if defined(_DERIVATE2)
  xn_s_VD_S_VD_S=(+(+0.0*pInst->inv_phit1+0.0*0.0+0.0*0.0+pInst->phib*0.0)+Ux_VD_S_VD_S);
  xn_s_VD_S_VS_BP=(+(+0.0*pInst->inv_phit1+0.0*0.0+0.0*0.0+pInst->phib*0.0)+Ux_VD_S_VS_BP);
#endif
xn_s_VS_BP=Ux_VS_BP;
#if defined(_DERIVATE2)
  xn_s_VS_BP_VD_S=(+(+0.0*pInst->inv_phit1+0.0*0.0+0.0*0.0+pInst->phib*0.0)+Ux_VS_BP_VD_S);
  xn_s_VS_BP_VS_BP=(+(+0.0*pInst->inv_phit1+0.0*0.0+0.0*0.0+pInst->phib*0.0)+Ux_VS_BP_VS_BP);
#endif
#endif
xn_s=((pInst->phib*pInst->inv_phit1)+Ux);
EXIT_IF_ISNAN(((pInst->phib*pInst->inv_phit1)+Ux))
if
((xn_s<4.6051701859880916e+02))
{
{
double m00_exp(d00_exp0,(-xn_s))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delta_ns_VD_S=(-xn_s_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  delta_ns_VD_S_VD_S=(m20_exp((-xn_s))*(-xn_s_VD_S)*(-xn_s_VD_S)+d10_exp0*0.0);
  delta_ns_VD_S_VS_BP=(m20_exp((-xn_s))*(-xn_s_VS_BP)*(-xn_s_VD_S)+d10_exp0*0.0);
#endif
delta_ns_VS_BP=(-xn_s_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  delta_ns_VS_BP_VD_S=(m20_exp((-xn_s))*(-xn_s_VD_S)*(-xn_s_VS_BP)+d10_exp0*0.0);
  delta_ns_VS_BP_VS_BP=(m20_exp((-xn_s))*(-xn_s_VS_BP)*(-xn_s_VS_BP)+d10_exp0*0.0);
#endif
#endif
delta_ns=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delta_ns_VD_S=(-1.0e-200*((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01)))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  delta_ns_VD_S_VD_S=(0.0/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*((0.5*(((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VD_S*3.3333333333333333e-01)))))))))+0.0*((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+xn_s_VD_S_VD_S-0.0)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))+xn_s_VD_S*((0.5*(((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VD_S*3.3333333333333333e-01))))))+xn_s_VD_S*(0.5*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01)))+(xn_s-4.6051701859880916e+02)*(+0.0+(+0.0*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VD_S*3.3333333333333333e-01))))+0.0*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01))+0.5*(+(+xn_s_VD_S_VD_S-0.0)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))+xn_s_VD_S*(xn_s_VD_S*3.3333333333333333e-01)+xn_s_VD_S*xn_s_VD_S*3.3333333333333333e-01+(xn_s-4.6051701859880916e+02)*(+0.0+(+(+xn_s_VD_S_VD_S-0.0)*3.3333333333333333e-01+xn_s_VD_S*0.0+xn_s_VD_S*0.0+(xn_s-4.6051701859880916e+02)*0.0))))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01)))))*(((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*((0.5*(((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VD_S*3.3333333333333333e-01)))))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
  delta_ns_VD_S_VS_BP=(0.0/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*((0.5*(((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VS_BP*3.3333333333333333e-01)))))))))+0.0*((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+xn_s_VD_S_VS_BP-0.0)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))+xn_s_VD_S*((0.5*(((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VS_BP*3.3333333333333333e-01))))))+xn_s_VS_BP*(0.5*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01)))+(xn_s-4.6051701859880916e+02)*(+0.0+(+0.0*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VS_BP*3.3333333333333333e-01))))+0.0*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01))+0.5*(+(+xn_s_VD_S_VS_BP-0.0)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))+xn_s_VD_S*(xn_s_VS_BP*3.3333333333333333e-01)+xn_s_VS_BP*xn_s_VD_S*3.3333333333333333e-01+(xn_s-4.6051701859880916e+02)*(+0.0+(+(+xn_s_VD_S_VS_BP-0.0)*3.3333333333333333e-01+xn_s_VD_S*0.0+xn_s_VS_BP*0.0+(xn_s-4.6051701859880916e+02)*0.0))))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VD_S*3.3333333333333333e-01)))))*(((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*((0.5*(((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#endif
delta_ns_VS_BP=(-1.0e-200*((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01)))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  delta_ns_VS_BP_VD_S=(0.0/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*((0.5*(((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VD_S*3.3333333333333333e-01)))))))))+0.0*((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+xn_s_VS_BP_VD_S-0.0)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))+xn_s_VS_BP*((0.5*(((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VD_S*3.3333333333333333e-01))))))+xn_s_VD_S*(0.5*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01)))+(xn_s-4.6051701859880916e+02)*(+0.0+(+0.0*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VD_S*3.3333333333333333e-01))))+0.0*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01))+0.5*(+(+xn_s_VS_BP_VD_S-0.0)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))+xn_s_VS_BP*(xn_s_VD_S*3.3333333333333333e-01)+xn_s_VD_S*xn_s_VS_BP*3.3333333333333333e-01+(xn_s-4.6051701859880916e+02)*(+0.0+(+(+xn_s_VS_BP_VD_S-0.0)*3.3333333333333333e-01+xn_s_VS_BP*0.0+xn_s_VD_S*0.0+(xn_s-4.6051701859880916e+02)*0.0))))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01)))))*(((xn_s_VD_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*((0.5*(((xn_s_VD_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VD_S*3.3333333333333333e-01)))))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
  delta_ns_VS_BP_VS_BP=(0.0/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*((0.5*(((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VS_BP*3.3333333333333333e-01)))))))))+0.0*((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+xn_s_VS_BP_VS_BP-0.0)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))+xn_s_VS_BP*((0.5*(((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VS_BP*3.3333333333333333e-01))))))+xn_s_VS_BP*(0.5*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01)))+(xn_s-4.6051701859880916e+02)*(+0.0+(+0.0*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VS_BP*3.3333333333333333e-01))))+0.0*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01))+0.5*(+(+xn_s_VS_BP_VS_BP-0.0)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))+xn_s_VS_BP*(xn_s_VS_BP*3.3333333333333333e-01)+xn_s_VS_BP*xn_s_VS_BP*3.3333333333333333e-01+(xn_s-4.6051701859880916e+02)*(+0.0+(+(+xn_s_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+xn_s_VS_BP*0.0+xn_s_VS_BP*0.0+(xn_s-4.6051701859880916e+02)*0.0))))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*(0.5*((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*xn_s_VS_BP*3.3333333333333333e-01)))))*(((xn_s_VS_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((xn_s-4.6051701859880916e+02)*((0.5*(((xn_s_VS_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+((xn_s-4.6051701859880916e+02)*(xn_s_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#endif
#endif
delta_ns=(1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
margin_VD_S=(1e-5*xi_VD_S);
margin_VGP_S=(1e-5*xi_VGP_S);
margin_VS_BP=(1e-5*xi_VS_BP);
#endif
margin=(1e-5*xi);
EXIT_IF_ISNAN((1e-5*xi))
{
double m00_fabs(d00_fabs0,pInst->xg)
if
((d00_fabs0<=margin))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp1_VD_S=((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*1.6666666666666667e-01*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  SP_S_temp1_VD_S_VD_S=(+(+(+inv_xi_VD_S_VD_S*inv_xi+inv_xi_VD_S*inv_xi_VD_S+inv_xi_VD_S*inv_xi_VD_S+inv_xi*inv_xi_VD_S_VD_S)*1.6666666666666667e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*0.0+(((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*1.6666666666666667e-01*0.0+((((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VD_S_VGP_S=(+(+(+inv_xi_VD_S_VGP_S*inv_xi+inv_xi_VD_S*inv_xi_VGP_S+inv_xi_VGP_S*inv_xi_VD_S+inv_xi*inv_xi_VD_S_VGP_S)*1.6666666666666667e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*0.0+(((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*1.6666666666666667e-01*0.0+((((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VD_S_VS_BP=(+(+(+inv_xi_VD_S_VS_BP*inv_xi+inv_xi_VD_S*inv_xi_VS_BP+inv_xi_VS_BP*inv_xi_VD_S+inv_xi*inv_xi_VD_S_VS_BP)*1.6666666666666667e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*0.0+(((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*1.6666666666666667e-01*0.0+((((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
#endif
SP_S_temp1_VGP_S=((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*1.6666666666666667e-01*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  SP_S_temp1_VGP_S_VD_S=(+(+(+inv_xi_VGP_S_VD_S*inv_xi+inv_xi_VGP_S*inv_xi_VD_S+inv_xi_VD_S*inv_xi_VGP_S+inv_xi*inv_xi_VGP_S_VD_S)*1.6666666666666667e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*0.0+(((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*1.6666666666666667e-01*0.0+((((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VGP_S_VGP_S=(+(+(+inv_xi_VGP_S_VGP_S*inv_xi+inv_xi_VGP_S*inv_xi_VGP_S+inv_xi_VGP_S*inv_xi_VGP_S+inv_xi*inv_xi_VGP_S_VGP_S)*1.6666666666666667e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*0.0+(((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*1.6666666666666667e-01*0.0+((((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VGP_S_VS_BP=(+(+(+inv_xi_VGP_S_VS_BP*inv_xi+inv_xi_VGP_S*inv_xi_VS_BP+inv_xi_VS_BP*inv_xi_VGP_S+inv_xi*inv_xi_VGP_S_VS_BP)*1.6666666666666667e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*0.0+(((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*1.6666666666666667e-01*0.0+((((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
#endif
SP_S_temp1_VS_BP=((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*1.6666666666666667e-01*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  SP_S_temp1_VS_BP_VD_S=(+(+(+inv_xi_VS_BP_VD_S*inv_xi+inv_xi_VS_BP*inv_xi_VD_S+inv_xi_VD_S*inv_xi_VS_BP+inv_xi*inv_xi_VS_BP_VD_S)*1.6666666666666667e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*0.0+(((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*1.6666666666666667e-01*0.0+((((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VS_BP_VGP_S=(+(+(+inv_xi_VS_BP_VGP_S*inv_xi+inv_xi_VS_BP*inv_xi_VGP_S+inv_xi_VGP_S*inv_xi_VS_BP+inv_xi*inv_xi_VS_BP_VGP_S)*1.6666666666666667e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*0.0+(((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*1.6666666666666667e-01*0.0+((((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VS_BP_VS_BP=(+(+(+inv_xi_VS_BP_VS_BP*inv_xi+inv_xi_VS_BP*inv_xi_VS_BP+inv_xi_VS_BP*inv_xi_VS_BP+inv_xi*inv_xi_VS_BP_VS_BP)*1.6666666666666667e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*0.0+(((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*1.6666666666666667e-01*0.0+((((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
#endif
#endif
SP_S_temp1=(((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
EXIT_IF_ISNAN((((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_s_VD_S=((((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1)))+((pInst->xg*inv_xi)*((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S))));
#if defined(_DERIVATE2)
  x_s_VD_S_VD_S=(+(+xg_VD_S_VD_S*inv_xi+xg_VD_S*inv_xi_VD_S+xg_VD_S*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VD_S)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VD_S_VD_S*(1.0-delta_ns)+xg_VD_S*(-delta_ns_VD_S)+xg_VD_S*(-delta_ns_VD_S)+pInst->xg*(+0.0-delta_ns_VD_S_VD_S))*Gf+((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf_VD_S+(((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf_VD_S+(pInst->xg*(1.0-delta_ns))*Gf_VD_S_VD_S)*SP_S_temp1+((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S))*SP_S_temp1_VD_S+((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S)))*SP_S_temp1_VD_S+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S_VD_S)));
  x_s_VD_S_VGP_S=(+(+xg_VD_S_VGP_S*inv_xi+xg_VD_S*inv_xi_VGP_S+xg_VGP_S*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VGP_S)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((((((xg_VGP_S*(1.0-delta_ns))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VD_S_VGP_S*(1.0-delta_ns)+xg_VD_S*0.0+xg_VGP_S*(-delta_ns_VD_S)+pInst->xg*(+0.0-0.0))*Gf+((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf_VGP_S+(xg_VGP_S*(1.0-delta_ns))*Gf_VD_S+(pInst->xg*(1.0-delta_ns))*Gf_VD_S_VGP_S)*SP_S_temp1+((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S))*SP_S_temp1_VGP_S+((((xg_VGP_S*(1.0-delta_ns))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S)))*SP_S_temp1_VD_S+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S_VGP_S)));
  x_s_VD_S_VS_BP=(+(+xg_VD_S_VS_BP*inv_xi+xg_VD_S*inv_xi_VS_BP+xg_VS_BP*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VS_BP)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VD_S_VS_BP*(1.0-delta_ns)+xg_VD_S*(-delta_ns_VS_BP)+xg_VS_BP*(-delta_ns_VD_S)+pInst->xg*(+0.0-delta_ns_VD_S_VS_BP))*Gf+((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf_VS_BP+(((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf_VD_S+(pInst->xg*(1.0-delta_ns))*Gf_VD_S_VS_BP)*SP_S_temp1+((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S))*SP_S_temp1_VS_BP+((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP)))*SP_S_temp1_VD_S+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S_VS_BP)));
#endif
x_s_VGP_S=((((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1)))+((pInst->xg*inv_xi)*((((xg_VGP_S*(1.0-delta_ns)*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S))));
#if defined(_DERIVATE2)
  x_s_VGP_S_VD_S=(+(+xg_VGP_S_VD_S*inv_xi+xg_VGP_S*inv_xi_VD_S+xg_VD_S*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VD_S)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((((xg_VGP_S*(1.0-delta_ns)*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VGP_S_VD_S*(1.0-delta_ns)+xg_VGP_S*(-delta_ns_VD_S)+xg_VD_S*0.0+pInst->xg*(+0.0-0.0))*Gf+xg_VGP_S*(1.0-delta_ns)*Gf_VD_S+(((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf_VGP_S+(pInst->xg*(1.0-delta_ns))*Gf_VGP_S_VD_S)*SP_S_temp1+((xg_VGP_S*(1.0-delta_ns)*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S))*SP_S_temp1_VD_S+((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S)))*SP_S_temp1_VGP_S+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S_VD_S)));
  x_s_VGP_S_VGP_S=(+(+xg_VGP_S_VGP_S*inv_xi+xg_VGP_S*inv_xi_VGP_S+xg_VGP_S*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VGP_S)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((((((xg_VGP_S*(1.0-delta_ns))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((((xg_VGP_S*(1.0-delta_ns)*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VGP_S_VGP_S*(1.0-delta_ns)+xg_VGP_S*0.0+xg_VGP_S*0.0+pInst->xg*(+0.0-0.0))*Gf+xg_VGP_S*(1.0-delta_ns)*Gf_VGP_S+(xg_VGP_S*(1.0-delta_ns))*Gf_VGP_S+(pInst->xg*(1.0-delta_ns))*Gf_VGP_S_VGP_S)*SP_S_temp1+((xg_VGP_S*(1.0-delta_ns)*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S))*SP_S_temp1_VGP_S+((((xg_VGP_S*(1.0-delta_ns))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S)))*SP_S_temp1_VGP_S+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S_VGP_S)));
  x_s_VGP_S_VS_BP=(+(+xg_VGP_S_VS_BP*inv_xi+xg_VGP_S*inv_xi_VS_BP+xg_VS_BP*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VS_BP)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((((xg_VGP_S*(1.0-delta_ns)*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VGP_S_VS_BP*(1.0-delta_ns)+xg_VGP_S*(-delta_ns_VS_BP)+xg_VS_BP*0.0+pInst->xg*(+0.0-0.0))*Gf+xg_VGP_S*(1.0-delta_ns)*Gf_VS_BP+(((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf_VGP_S+(pInst->xg*(1.0-delta_ns))*Gf_VGP_S_VS_BP)*SP_S_temp1+((xg_VGP_S*(1.0-delta_ns)*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S))*SP_S_temp1_VS_BP+((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP)))*SP_S_temp1_VGP_S+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S_VS_BP)));
#endif
x_s_VS_BP=((((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1)))+((pInst->xg*inv_xi)*((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP))));
#if defined(_DERIVATE2)
  x_s_VS_BP_VD_S=(+(+xg_VS_BP_VD_S*inv_xi+xg_VS_BP*inv_xi_VD_S+xg_VD_S*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VD_S)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VS_BP_VD_S*(1.0-delta_ns)+xg_VS_BP*(-delta_ns_VD_S)+xg_VD_S*(-delta_ns_VS_BP)+pInst->xg*(+0.0-delta_ns_VS_BP_VD_S))*Gf+((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf_VD_S+(((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf_VS_BP+(pInst->xg*(1.0-delta_ns))*Gf_VS_BP_VD_S)*SP_S_temp1+((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP))*SP_S_temp1_VD_S+((((((xg_VD_S*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VD_S))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VD_S)))*SP_S_temp1_VS_BP+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP_VD_S)));
  x_s_VS_BP_VGP_S=(+(+xg_VS_BP_VGP_S*inv_xi+xg_VS_BP*inv_xi_VGP_S+xg_VGP_S*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VGP_S)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((((((xg_VGP_S*(1.0-delta_ns))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VS_BP_VGP_S*(1.0-delta_ns)+xg_VS_BP*0.0+xg_VGP_S*(-delta_ns_VS_BP)+pInst->xg*(+0.0-0.0))*Gf+((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf_VGP_S+(xg_VGP_S*(1.0-delta_ns))*Gf_VS_BP+(pInst->xg*(1.0-delta_ns))*Gf_VS_BP_VGP_S)*SP_S_temp1+((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP))*SP_S_temp1_VGP_S+((((xg_VGP_S*(1.0-delta_ns))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VGP_S)))*SP_S_temp1_VS_BP+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP_VGP_S)));
  x_s_VS_BP_VS_BP=(+(+xg_VS_BP_VS_BP*inv_xi+xg_VS_BP*inv_xi_VS_BP+xg_VS_BP*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VS_BP)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP))*SP_S_temp1)+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VS_BP_VS_BP*(1.0-delta_ns)+xg_VS_BP*(-delta_ns_VS_BP)+xg_VS_BP*(-delta_ns_VS_BP)+pInst->xg*(+0.0-delta_ns_VS_BP_VS_BP))*Gf+((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf_VS_BP+(((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf_VS_BP+(pInst->xg*(1.0-delta_ns))*Gf_VS_BP_VS_BP)*SP_S_temp1+((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP))*SP_S_temp1_VS_BP+((((((xg_VS_BP*(1.0-delta_ns))+(pInst->xg*(-delta_ns_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_ns))*Gf_VS_BP)))*SP_S_temp1_VS_BP+((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1_VS_BP_VS_BP)));
#endif
#endif
x_s=((pInst->xg*inv_xi)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
EXIT_IF_ISNAN(((pInst->xg*inv_xi)*(1.0+(((pInst->xg*(1.0-delta_ns))*Gf)*SP_S_temp1))))
}
else
{
if
((pInst->xg<(-margin)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_yg_VD_S=(-xg_VD_S);
#if defined(_DERIVATE2)
  SP_S_yg_VD_S_VD_S=0.0;
  SP_S_yg_VD_S_VGP_S=0.0;
  SP_S_yg_VD_S_VS_BP=0.0;
#endif
SP_S_yg_VGP_S=(-xg_VGP_S);
#if defined(_DERIVATE2)
  SP_S_yg_VGP_S_VD_S=0.0;
  SP_S_yg_VGP_S_VGP_S=0.0;
  SP_S_yg_VGP_S_VS_BP=0.0;
#endif
SP_S_yg_VS_BP=(-xg_VS_BP);
#if defined(_DERIVATE2)
  SP_S_yg_VS_BP_VD_S=0.0;
  SP_S_yg_VS_BP_VGP_S=0.0;
  SP_S_yg_VS_BP_VS_BP=0.0;
#endif
#endif
SP_S_yg=(-pInst->xg);
EXIT_IF_ISNAN((-pInst->xg))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_ysub_VD_S=(1.25*((SP_S_yg_VD_S*inv_xi)+(SP_S_yg*inv_xi_VD_S)));
#if defined(_DERIVATE2)
  SP_S_ysub_VD_S_VD_S=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VD_S*inv_xi)+(SP_S_yg*inv_xi_VD_S)))+0.0*((SP_S_yg_VD_S*inv_xi)+(SP_S_yg*inv_xi_VD_S))+1.25*(+SP_S_yg_VD_S_VD_S*inv_xi+SP_S_yg_VD_S*inv_xi_VD_S+SP_S_yg_VD_S*inv_xi_VD_S+SP_S_yg*inv_xi_VD_S_VD_S));
  SP_S_ysub_VD_S_VGP_S=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VGP_S*inv_xi)+(SP_S_yg*inv_xi_VGP_S)))+0.0*((SP_S_yg_VD_S*inv_xi)+(SP_S_yg*inv_xi_VD_S))+1.25*(+SP_S_yg_VD_S_VGP_S*inv_xi+SP_S_yg_VD_S*inv_xi_VGP_S+SP_S_yg_VGP_S*inv_xi_VD_S+SP_S_yg*inv_xi_VD_S_VGP_S));
  SP_S_ysub_VD_S_VS_BP=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VS_BP*inv_xi)+(SP_S_yg*inv_xi_VS_BP)))+0.0*((SP_S_yg_VD_S*inv_xi)+(SP_S_yg*inv_xi_VD_S))+1.25*(+SP_S_yg_VD_S_VS_BP*inv_xi+SP_S_yg_VD_S*inv_xi_VS_BP+SP_S_yg_VS_BP*inv_xi_VD_S+SP_S_yg*inv_xi_VD_S_VS_BP));
#endif
SP_S_ysub_VGP_S=(1.25*((SP_S_yg_VGP_S*inv_xi)+(SP_S_yg*inv_xi_VGP_S)));
#if defined(_DERIVATE2)
  SP_S_ysub_VGP_S_VD_S=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VD_S*inv_xi)+(SP_S_yg*inv_xi_VD_S)))+0.0*((SP_S_yg_VGP_S*inv_xi)+(SP_S_yg*inv_xi_VGP_S))+1.25*(+SP_S_yg_VGP_S_VD_S*inv_xi+SP_S_yg_VGP_S*inv_xi_VD_S+SP_S_yg_VD_S*inv_xi_VGP_S+SP_S_yg*inv_xi_VGP_S_VD_S));
  SP_S_ysub_VGP_S_VGP_S=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VGP_S*inv_xi)+(SP_S_yg*inv_xi_VGP_S)))+0.0*((SP_S_yg_VGP_S*inv_xi)+(SP_S_yg*inv_xi_VGP_S))+1.25*(+SP_S_yg_VGP_S_VGP_S*inv_xi+SP_S_yg_VGP_S*inv_xi_VGP_S+SP_S_yg_VGP_S*inv_xi_VGP_S+SP_S_yg*inv_xi_VGP_S_VGP_S));
  SP_S_ysub_VGP_S_VS_BP=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VS_BP*inv_xi)+(SP_S_yg*inv_xi_VS_BP)))+0.0*((SP_S_yg_VGP_S*inv_xi)+(SP_S_yg*inv_xi_VGP_S))+1.25*(+SP_S_yg_VGP_S_VS_BP*inv_xi+SP_S_yg_VGP_S*inv_xi_VS_BP+SP_S_yg_VS_BP*inv_xi_VGP_S+SP_S_yg*inv_xi_VGP_S_VS_BP));
#endif
SP_S_ysub_VS_BP=(1.25*((SP_S_yg_VS_BP*inv_xi)+(SP_S_yg*inv_xi_VS_BP)));
#if defined(_DERIVATE2)
  SP_S_ysub_VS_BP_VD_S=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VD_S*inv_xi)+(SP_S_yg*inv_xi_VD_S)))+0.0*((SP_S_yg_VS_BP*inv_xi)+(SP_S_yg*inv_xi_VS_BP))+1.25*(+SP_S_yg_VS_BP_VD_S*inv_xi+SP_S_yg_VS_BP*inv_xi_VD_S+SP_S_yg_VD_S*inv_xi_VS_BP+SP_S_yg*inv_xi_VS_BP_VD_S));
  SP_S_ysub_VS_BP_VGP_S=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VGP_S*inv_xi)+(SP_S_yg*inv_xi_VGP_S)))+0.0*((SP_S_yg_VS_BP*inv_xi)+(SP_S_yg*inv_xi_VS_BP))+1.25*(+SP_S_yg_VS_BP_VGP_S*inv_xi+SP_S_yg_VS_BP*inv_xi_VGP_S+SP_S_yg_VGP_S*inv_xi_VS_BP+SP_S_yg*inv_xi_VS_BP_VGP_S));
  SP_S_ysub_VS_BP_VS_BP=(+0.0*(SP_S_yg*inv_xi)+0.0*(((SP_S_yg_VS_BP*inv_xi)+(SP_S_yg*inv_xi_VS_BP)))+0.0*((SP_S_yg_VS_BP*inv_xi)+(SP_S_yg*inv_xi_VS_BP))+1.25*(+SP_S_yg_VS_BP_VS_BP*inv_xi+SP_S_yg_VS_BP*inv_xi_VS_BP+SP_S_yg_VS_BP*inv_xi_VS_BP+SP_S_yg*inv_xi_VS_BP_VS_BP));
#endif
#endif
SP_S_ysub=(1.25*(SP_S_yg*inv_xi));
EXIT_IF_ISNAN((1.25*(SP_S_yg*inv_xi)))
{
double m00_sqrt(d00_sqrt0,(((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_eta_VD_S=(0.5*(SP_S_ysub_VD_S-((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_S_eta_VD_S_VD_S=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VD_S-(((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S)))*d10_sqrt0)+0.0*(SP_S_ysub_VD_S-((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VD_S_VD_S+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S)))*((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S))+d10_sqrt0*(+(+(+SP_S_ysub_VD_S_VD_S-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VD_S*SP_S_ysub_VD_S+SP_S_ysub_VD_S*SP_S_ysub_VD_S+(SP_S_ysub-6.0)*(+SP_S_ysub_VD_S_VD_S-0.0))+0.0))));
  SP_S_eta_VD_S_VGP_S=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VGP_S-(((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S)))*d10_sqrt0)+0.0*(SP_S_ysub_VD_S-((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VD_S_VGP_S+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S)))*((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S))+d10_sqrt0*(+(+(+SP_S_ysub_VD_S_VGP_S-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VD_S*SP_S_ysub_VGP_S+SP_S_ysub_VGP_S*SP_S_ysub_VD_S+(SP_S_ysub-6.0)*(+SP_S_ysub_VD_S_VGP_S-0.0))+0.0))));
  SP_S_eta_VD_S_VS_BP=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VS_BP-(((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP)))*d10_sqrt0)+0.0*(SP_S_ysub_VD_S-((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VD_S_VS_BP+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP)))*((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S))+d10_sqrt0*(+(+(+SP_S_ysub_VD_S_VS_BP-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VD_S*SP_S_ysub_VS_BP+SP_S_ysub_VS_BP*SP_S_ysub_VD_S+(SP_S_ysub-6.0)*(+SP_S_ysub_VD_S_VS_BP-0.0))+0.0))));
#endif
SP_S_eta_VGP_S=(0.5*(SP_S_ysub_VGP_S-((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_S_eta_VGP_S_VD_S=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VD_S-(((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S)))*d10_sqrt0)+0.0*(SP_S_ysub_VGP_S-((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VGP_S_VD_S+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S)))*((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S))+d10_sqrt0*(+(+(+SP_S_ysub_VGP_S_VD_S-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VGP_S*SP_S_ysub_VD_S+SP_S_ysub_VD_S*SP_S_ysub_VGP_S+(SP_S_ysub-6.0)*(+SP_S_ysub_VGP_S_VD_S-0.0))+0.0))));
  SP_S_eta_VGP_S_VGP_S=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VGP_S-(((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S)))*d10_sqrt0)+0.0*(SP_S_ysub_VGP_S-((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VGP_S_VGP_S+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S)))*((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S))+d10_sqrt0*(+(+(+SP_S_ysub_VGP_S_VGP_S-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VGP_S*SP_S_ysub_VGP_S+SP_S_ysub_VGP_S*SP_S_ysub_VGP_S+(SP_S_ysub-6.0)*(+SP_S_ysub_VGP_S_VGP_S-0.0))+0.0))));
  SP_S_eta_VGP_S_VS_BP=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VS_BP-(((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP)))*d10_sqrt0)+0.0*(SP_S_ysub_VGP_S-((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VGP_S_VS_BP+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP)))*((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S))+d10_sqrt0*(+(+(+SP_S_ysub_VGP_S_VS_BP-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VGP_S*SP_S_ysub_VS_BP+SP_S_ysub_VS_BP*SP_S_ysub_VGP_S+(SP_S_ysub-6.0)*(+SP_S_ysub_VGP_S_VS_BP-0.0))+0.0))));
#endif
SP_S_eta_VS_BP=(0.5*(SP_S_ysub_VS_BP-((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP))*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_S_eta_VS_BP_VD_S=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VD_S-(((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S)))*d10_sqrt0)+0.0*(SP_S_ysub_VS_BP-((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VS_BP_VD_S+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VD_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VD_S)))*((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP))+d10_sqrt0*(+(+(+SP_S_ysub_VS_BP_VD_S-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VS_BP*SP_S_ysub_VD_S+SP_S_ysub_VD_S*SP_S_ysub_VS_BP+(SP_S_ysub-6.0)*(+SP_S_ysub_VS_BP_VD_S-0.0))+0.0))));
  SP_S_eta_VS_BP_VGP_S=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VGP_S-(((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S)))*d10_sqrt0)+0.0*(SP_S_ysub_VS_BP-((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VS_BP_VGP_S+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VGP_S*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VGP_S)))*((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP))+d10_sqrt0*(+(+(+SP_S_ysub_VS_BP_VGP_S-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VS_BP*SP_S_ysub_VGP_S+SP_S_ysub_VGP_S*SP_S_ysub_VS_BP+(SP_S_ysub-6.0)*(+SP_S_ysub_VS_BP_VGP_S-0.0))+0.0))));
  SP_S_eta_VS_BP_VS_BP=(+0.0*((SP_S_ysub+10)-d00_sqrt0)+0.0*(SP_S_ysub_VS_BP-(((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP)))*d10_sqrt0)+0.0*(SP_S_ysub_VS_BP-((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP))*d10_sqrt0)+0.5*(+(+SP_S_ysub_VS_BP_VS_BP+0.0)-(m20_sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0))*(((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP)))*((SP_S_ysub_VS_BP*(SP_S_ysub-6.0))+((SP_S_ysub-6.0)*SP_S_ysub_VS_BP))+d10_sqrt0*(+(+(+SP_S_ysub_VS_BP_VS_BP-0.0)*(SP_S_ysub-6.0)+SP_S_ysub_VS_BP*SP_S_ysub_VS_BP+SP_S_ysub_VS_BP*SP_S_ysub_VS_BP+(SP_S_ysub-6.0)*(+SP_S_ysub_VS_BP_VS_BP-0.0))+0.0))));
#endif
#endif
SP_S_eta=(0.5*((SP_S_ysub+10)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((SP_S_ysub+10)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(SP_S_yg_VD_S-SP_S_eta_VD_S);
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+SP_S_yg_VD_S_VD_S-SP_S_eta_VD_S_VD_S);
  SP_S_temp_VD_S_VGP_S=(+SP_S_yg_VD_S_VGP_S-SP_S_eta_VD_S_VGP_S);
  SP_S_temp_VD_S_VS_BP=(+SP_S_yg_VD_S_VS_BP-SP_S_eta_VD_S_VS_BP);
#endif
SP_S_temp_VGP_S=(SP_S_yg_VGP_S-SP_S_eta_VGP_S);
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+SP_S_yg_VGP_S_VD_S-SP_S_eta_VGP_S_VD_S);
  SP_S_temp_VGP_S_VGP_S=(+SP_S_yg_VGP_S_VGP_S-SP_S_eta_VGP_S_VGP_S);
  SP_S_temp_VGP_S_VS_BP=(+SP_S_yg_VGP_S_VS_BP-SP_S_eta_VGP_S_VS_BP);
#endif
SP_S_temp_VS_BP=(SP_S_yg_VS_BP-SP_S_eta_VS_BP);
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+SP_S_yg_VS_BP_VD_S-SP_S_eta_VS_BP_VD_S);
  SP_S_temp_VS_BP_VGP_S=(+SP_S_yg_VS_BP_VGP_S-SP_S_eta_VS_BP_VGP_S);
  SP_S_temp_VS_BP_VS_BP=(+SP_S_yg_VS_BP_VS_BP-SP_S_eta_VS_BP_VS_BP);
#endif
#endif
SP_S_temp=(SP_S_yg-SP_S_eta);
EXIT_IF_ISNAN((SP_S_yg-SP_S_eta))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_a_VD_S=(((SP_S_temp_VD_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VD_S))+((Gf2_VD_S*(SP_S_eta+1.0))+(Gf2*SP_S_eta_VD_S)));
#if defined(_DERIVATE2)
  SP_S_a_VD_S_VD_S=(+(+SP_S_temp_VD_S_VD_S*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VD_S)+(+Gf2_VD_S_VD_S*(SP_S_eta+1.0)+Gf2_VD_S*SP_S_eta_VD_S+Gf2_VD_S*SP_S_eta_VD_S+Gf2*(+SP_S_eta_VD_S_VD_S+0.0)));
  SP_S_a_VD_S_VGP_S=(+(+SP_S_temp_VD_S_VGP_S*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VGP_S)+(+Gf2_VD_S_VGP_S*(SP_S_eta+1.0)+Gf2_VD_S*SP_S_eta_VGP_S+Gf2_VGP_S*SP_S_eta_VD_S+Gf2*(+SP_S_eta_VD_S_VGP_S+0.0)));
  SP_S_a_VD_S_VS_BP=(+(+SP_S_temp_VD_S_VS_BP*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VS_BP)+(+Gf2_VD_S_VS_BP*(SP_S_eta+1.0)+Gf2_VD_S*SP_S_eta_VS_BP+Gf2_VS_BP*SP_S_eta_VD_S+Gf2*(+SP_S_eta_VD_S_VS_BP+0.0)));
#endif
SP_S_a_VGP_S=(((SP_S_temp_VGP_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VGP_S))+((Gf2_VGP_S*(SP_S_eta+1.0))+(Gf2*SP_S_eta_VGP_S)));
#if defined(_DERIVATE2)
  SP_S_a_VGP_S_VD_S=(+(+SP_S_temp_VGP_S_VD_S*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VD_S)+(+Gf2_VGP_S_VD_S*(SP_S_eta+1.0)+Gf2_VGP_S*SP_S_eta_VD_S+Gf2_VD_S*SP_S_eta_VGP_S+Gf2*(+SP_S_eta_VGP_S_VD_S+0.0)));
  SP_S_a_VGP_S_VGP_S=(+(+SP_S_temp_VGP_S_VGP_S*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VGP_S)+(+Gf2_VGP_S_VGP_S*(SP_S_eta+1.0)+Gf2_VGP_S*SP_S_eta_VGP_S+Gf2_VGP_S*SP_S_eta_VGP_S+Gf2*(+SP_S_eta_VGP_S_VGP_S+0.0)));
  SP_S_a_VGP_S_VS_BP=(+(+SP_S_temp_VGP_S_VS_BP*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VS_BP)+(+Gf2_VGP_S_VS_BP*(SP_S_eta+1.0)+Gf2_VGP_S*SP_S_eta_VS_BP+Gf2_VS_BP*SP_S_eta_VGP_S+Gf2*(+SP_S_eta_VGP_S_VS_BP+0.0)));
#endif
SP_S_a_VS_BP=(((SP_S_temp_VS_BP*SP_S_temp)+(SP_S_temp*SP_S_temp_VS_BP))+((Gf2_VS_BP*(SP_S_eta+1.0))+(Gf2*SP_S_eta_VS_BP)));
#if defined(_DERIVATE2)
  SP_S_a_VS_BP_VD_S=(+(+SP_S_temp_VS_BP_VD_S*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VD_S)+(+Gf2_VS_BP_VD_S*(SP_S_eta+1.0)+Gf2_VS_BP*SP_S_eta_VD_S+Gf2_VD_S*SP_S_eta_VS_BP+Gf2*(+SP_S_eta_VS_BP_VD_S+0.0)));
  SP_S_a_VS_BP_VGP_S=(+(+SP_S_temp_VS_BP_VGP_S*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VGP_S)+(+Gf2_VS_BP_VGP_S*(SP_S_eta+1.0)+Gf2_VS_BP*SP_S_eta_VGP_S+Gf2_VGP_S*SP_S_eta_VS_BP+Gf2*(+SP_S_eta_VS_BP_VGP_S+0.0)));
  SP_S_a_VS_BP_VS_BP=(+(+SP_S_temp_VS_BP_VS_BP*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VS_BP)+(+Gf2_VS_BP_VS_BP*(SP_S_eta+1.0)+Gf2_VS_BP*SP_S_eta_VS_BP+Gf2_VS_BP*SP_S_eta_VS_BP+Gf2*(+SP_S_eta_VS_BP_VS_BP+0.0)));
#endif
#endif
SP_S_a=((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));
EXIT_IF_ISNAN(((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_c_VD_S=((2.0*SP_S_temp_VD_S)-Gf2_VD_S);
#if defined(_DERIVATE2)
  SP_S_c_VD_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VD_S)-Gf2_VD_S_VD_S);
  SP_S_c_VD_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VGP_S)-Gf2_VD_S_VGP_S);
  SP_S_c_VD_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VS_BP)-Gf2_VD_S_VS_BP);
#endif
SP_S_c_VGP_S=((2.0*SP_S_temp_VGP_S)-Gf2_VGP_S);
#if defined(_DERIVATE2)
  SP_S_c_VGP_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VD_S)-Gf2_VGP_S_VD_S);
  SP_S_c_VGP_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VGP_S)-Gf2_VGP_S_VGP_S);
  SP_S_c_VGP_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VS_BP)-Gf2_VGP_S_VS_BP);
#endif
SP_S_c_VS_BP=((2.0*SP_S_temp_VS_BP)-Gf2_VS_BP);
#if defined(_DERIVATE2)
  SP_S_c_VS_BP_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VD_S)-Gf2_VS_BP_VD_S);
  SP_S_c_VS_BP_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VGP_S)-Gf2_VS_BP_VGP_S);
  SP_S_c_VS_BP_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VS_BP)-Gf2_VS_BP_VS_BP);
#endif
#endif
SP_S_c=((2.0*SP_S_temp)-Gf2);
EXIT_IF_ISNAN(((2.0*SP_S_temp)-Gf2))
{
double m00_logE(d00_logE0,(SP_S_a*inv_Gf2))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(SP_S_a*inv_Gf2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_tau_VD_S=((-SP_S_eta_VD_S)+((SP_S_a_VD_S*inv_Gf2)+(SP_S_a*inv_Gf2_VD_S))*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VD_S_VD_S=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VD_S*inv_Gf2)+(SP_S_a*inv_Gf2_VD_S)))*((SP_S_a_VD_S*inv_Gf2)+(SP_S_a*inv_Gf2_VD_S))+d10_logE0*(+SP_S_a_VD_S_VD_S*inv_Gf2+SP_S_a_VD_S*inv_Gf2_VD_S+SP_S_a_VD_S*inv_Gf2_VD_S+SP_S_a*inv_Gf2_VD_S_VD_S)));
  SP_S_tau_VD_S_VGP_S=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VGP_S*inv_Gf2)+(SP_S_a*inv_Gf2_VGP_S)))*((SP_S_a_VD_S*inv_Gf2)+(SP_S_a*inv_Gf2_VD_S))+d10_logE0*(+SP_S_a_VD_S_VGP_S*inv_Gf2+SP_S_a_VD_S*inv_Gf2_VGP_S+SP_S_a_VGP_S*inv_Gf2_VD_S+SP_S_a*inv_Gf2_VD_S_VGP_S)));
  SP_S_tau_VD_S_VS_BP=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VS_BP*inv_Gf2)+(SP_S_a*inv_Gf2_VS_BP)))*((SP_S_a_VD_S*inv_Gf2)+(SP_S_a*inv_Gf2_VD_S))+d10_logE0*(+SP_S_a_VD_S_VS_BP*inv_Gf2+SP_S_a_VD_S*inv_Gf2_VS_BP+SP_S_a_VS_BP*inv_Gf2_VD_S+SP_S_a*inv_Gf2_VD_S_VS_BP)));
#endif
SP_S_tau_VGP_S=((-SP_S_eta_VGP_S)+((SP_S_a_VGP_S*inv_Gf2)+(SP_S_a*inv_Gf2_VGP_S))*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VGP_S_VD_S=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VD_S*inv_Gf2)+(SP_S_a*inv_Gf2_VD_S)))*((SP_S_a_VGP_S*inv_Gf2)+(SP_S_a*inv_Gf2_VGP_S))+d10_logE0*(+SP_S_a_VGP_S_VD_S*inv_Gf2+SP_S_a_VGP_S*inv_Gf2_VD_S+SP_S_a_VD_S*inv_Gf2_VGP_S+SP_S_a*inv_Gf2_VGP_S_VD_S)));
  SP_S_tau_VGP_S_VGP_S=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VGP_S*inv_Gf2)+(SP_S_a*inv_Gf2_VGP_S)))*((SP_S_a_VGP_S*inv_Gf2)+(SP_S_a*inv_Gf2_VGP_S))+d10_logE0*(+SP_S_a_VGP_S_VGP_S*inv_Gf2+SP_S_a_VGP_S*inv_Gf2_VGP_S+SP_S_a_VGP_S*inv_Gf2_VGP_S+SP_S_a*inv_Gf2_VGP_S_VGP_S)));
  SP_S_tau_VGP_S_VS_BP=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VS_BP*inv_Gf2)+(SP_S_a*inv_Gf2_VS_BP)))*((SP_S_a_VGP_S*inv_Gf2)+(SP_S_a*inv_Gf2_VGP_S))+d10_logE0*(+SP_S_a_VGP_S_VS_BP*inv_Gf2+SP_S_a_VGP_S*inv_Gf2_VS_BP+SP_S_a_VS_BP*inv_Gf2_VGP_S+SP_S_a*inv_Gf2_VGP_S_VS_BP)));
#endif
SP_S_tau_VS_BP=((-SP_S_eta_VS_BP)+((SP_S_a_VS_BP*inv_Gf2)+(SP_S_a*inv_Gf2_VS_BP))*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VS_BP_VD_S=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VD_S*inv_Gf2)+(SP_S_a*inv_Gf2_VD_S)))*((SP_S_a_VS_BP*inv_Gf2)+(SP_S_a*inv_Gf2_VS_BP))+d10_logE0*(+SP_S_a_VS_BP_VD_S*inv_Gf2+SP_S_a_VS_BP*inv_Gf2_VD_S+SP_S_a_VD_S*inv_Gf2_VS_BP+SP_S_a*inv_Gf2_VS_BP_VD_S)));
  SP_S_tau_VS_BP_VGP_S=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VGP_S*inv_Gf2)+(SP_S_a*inv_Gf2_VGP_S)))*((SP_S_a_VS_BP*inv_Gf2)+(SP_S_a*inv_Gf2_VS_BP))+d10_logE0*(+SP_S_a_VS_BP_VGP_S*inv_Gf2+SP_S_a_VS_BP*inv_Gf2_VGP_S+SP_S_a_VGP_S*inv_Gf2_VS_BP+SP_S_a*inv_Gf2_VS_BP_VGP_S)));
  SP_S_tau_VS_BP_VS_BP=(+0.0+(m20_logE((SP_S_a*inv_Gf2))*(((SP_S_a_VS_BP*inv_Gf2)+(SP_S_a*inv_Gf2_VS_BP)))*((SP_S_a_VS_BP*inv_Gf2)+(SP_S_a*inv_Gf2_VS_BP))+d10_logE0*(+SP_S_a_VS_BP_VS_BP*inv_Gf2+SP_S_a_VS_BP*inv_Gf2_VS_BP+SP_S_a_VS_BP*inv_Gf2_VS_BP+SP_S_a*inv_Gf2_VS_BP_VS_BP)));
#endif
#endif
SP_S_tau=((-SP_S_eta)+d00_logE0);
EXIT_IF_ISNAN(((-SP_S_eta)+d00_logE0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
nu_VD_S=(SP_S_a_VD_S+SP_S_c_VD_S);
#if defined(_DERIVATE2)
  nu_VD_S_VD_S=(+SP_S_a_VD_S_VD_S+SP_S_c_VD_S_VD_S);
  nu_VD_S_VGP_S=(+SP_S_a_VD_S_VGP_S+SP_S_c_VD_S_VGP_S);
  nu_VD_S_VS_BP=(+SP_S_a_VD_S_VS_BP+SP_S_c_VD_S_VS_BP);
#endif
nu_VGP_S=(SP_S_a_VGP_S+SP_S_c_VGP_S);
#if defined(_DERIVATE2)
  nu_VGP_S_VD_S=(+SP_S_a_VGP_S_VD_S+SP_S_c_VGP_S_VD_S);
  nu_VGP_S_VGP_S=(+SP_S_a_VGP_S_VGP_S+SP_S_c_VGP_S_VGP_S);
  nu_VGP_S_VS_BP=(+SP_S_a_VGP_S_VS_BP+SP_S_c_VGP_S_VS_BP);
#endif
nu_VS_BP=(SP_S_a_VS_BP+SP_S_c_VS_BP);
#if defined(_DERIVATE2)
  nu_VS_BP_VD_S=(+SP_S_a_VS_BP_VD_S+SP_S_c_VS_BP_VD_S);
  nu_VS_BP_VGP_S=(+SP_S_a_VS_BP_VGP_S+SP_S_c_VS_BP_VGP_S);
  nu_VS_BP_VS_BP=(+SP_S_a_VS_BP_VS_BP+SP_S_c_VS_BP_VS_BP);
#endif
#endif
nu=(SP_S_a+SP_S_c);
EXIT_IF_ISNAN((SP_S_a+SP_S_c))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
mutau_VD_S=(((nu_VD_S*nu)+(nu*nu_VD_S))+((SP_S_tau_VD_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a))+(SP_S_tau*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-SP_S_a_VD_S))));
#if defined(_DERIVATE2)
  mutau_VD_S_VD_S=(+(+nu_VD_S_VD_S*nu+nu_VD_S*nu_VD_S+nu_VD_S*nu_VD_S+nu*nu_VD_S_VD_S)+(+SP_S_tau_VD_S_VD_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-SP_S_a_VD_S)+SP_S_tau_VD_S*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-SP_S_a_VD_S)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VD_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VD_S))-SP_S_a_VD_S_VD_S)));
  mutau_VD_S_VGP_S=(+(+nu_VD_S_VGP_S*nu+nu_VD_S*nu_VGP_S+nu_VGP_S*nu_VD_S+nu*nu_VD_S_VGP_S)+(+SP_S_tau_VD_S_VGP_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-SP_S_a_VGP_S)+SP_S_tau_VGP_S*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-SP_S_a_VD_S)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VGP_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VGP_S))-SP_S_a_VD_S_VGP_S)));
  mutau_VD_S_VS_BP=(+(+nu_VD_S_VS_BP*nu+nu_VD_S*nu_VS_BP+nu_VS_BP*nu_VD_S+nu*nu_VD_S_VS_BP)+(+SP_S_tau_VD_S_VS_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-SP_S_a_VS_BP)+SP_S_tau_VS_BP*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-SP_S_a_VD_S)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VS_BP*SP_S_c+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VS_BP))-SP_S_a_VD_S_VS_BP)));
#endif
mutau_VGP_S=(((nu_VGP_S*nu)+(nu*nu_VGP_S))+((SP_S_tau_VGP_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a))+(SP_S_tau*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-SP_S_a_VGP_S))));
#if defined(_DERIVATE2)
  mutau_VGP_S_VD_S=(+(+nu_VGP_S_VD_S*nu+nu_VGP_S*nu_VD_S+nu_VD_S*nu_VGP_S+nu*nu_VGP_S_VD_S)+(+SP_S_tau_VGP_S_VD_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-SP_S_a_VD_S)+SP_S_tau_VD_S*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-SP_S_a_VGP_S)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VD_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VD_S))-SP_S_a_VGP_S_VD_S)));
  mutau_VGP_S_VGP_S=(+(+nu_VGP_S_VGP_S*nu+nu_VGP_S*nu_VGP_S+nu_VGP_S*nu_VGP_S+nu*nu_VGP_S_VGP_S)+(+SP_S_tau_VGP_S_VGP_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-SP_S_a_VGP_S)+SP_S_tau_VGP_S*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-SP_S_a_VGP_S)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VGP_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VGP_S))-SP_S_a_VGP_S_VGP_S)));
  mutau_VGP_S_VS_BP=(+(+nu_VGP_S_VS_BP*nu+nu_VGP_S*nu_VS_BP+nu_VS_BP*nu_VGP_S+nu*nu_VGP_S_VS_BP)+(+SP_S_tau_VGP_S_VS_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-SP_S_a_VS_BP)+SP_S_tau_VS_BP*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-SP_S_a_VGP_S)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VS_BP*SP_S_c+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VS_BP))-SP_S_a_VGP_S_VS_BP)));
#endif
mutau_VS_BP=(((nu_VS_BP*nu)+(nu*nu_VS_BP))+((SP_S_tau_VS_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a))+(SP_S_tau*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-SP_S_a_VS_BP))));
#if defined(_DERIVATE2)
  mutau_VS_BP_VD_S=(+(+nu_VS_BP_VD_S*nu+nu_VS_BP*nu_VD_S+nu_VD_S*nu_VS_BP+nu*nu_VS_BP_VD_S)+(+SP_S_tau_VS_BP_VD_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-SP_S_a_VD_S)+SP_S_tau_VD_S*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-SP_S_a_VS_BP)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VD_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VD_S))-SP_S_a_VS_BP_VD_S)));
  mutau_VS_BP_VGP_S=(+(+nu_VS_BP_VGP_S*nu+nu_VS_BP*nu_VGP_S+nu_VGP_S*nu_VS_BP+nu*nu_VS_BP_VGP_S)+(+SP_S_tau_VS_BP_VGP_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-SP_S_a_VGP_S)+SP_S_tau_VGP_S*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-SP_S_a_VS_BP)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VGP_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VGP_S))-SP_S_a_VS_BP_VGP_S)));
  mutau_VS_BP_VS_BP=(+(+nu_VS_BP_VS_BP*nu+nu_VS_BP*nu_VS_BP+nu_VS_BP*nu_VS_BP+nu*nu_VS_BP_VS_BP)+(+SP_S_tau_VS_BP_VS_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a)+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-SP_S_a_VS_BP)+SP_S_tau_VS_BP*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-SP_S_a_VS_BP)+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VS_BP*SP_S_c+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VS_BP))-SP_S_a_VS_BP_VS_BP)));
#endif
#endif
mutau=((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
EXIT_IF_ISNAN(((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_y0_VD_S=(SP_S_eta_VD_S+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
#if defined(_DERIVATE2)
  SP_S_y0_VD_S_VD_S=(+SP_S_eta_VD_S_VD_S+((+(+SP_S_a_VD_S_VD_S*nu+SP_S_a_VD_S*nu_VD_S+SP_S_a_VD_S*nu_VD_S+SP_S_a*nu_VD_S_VD_S)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VD_S+(+(+(+(+(nu_VD_S_VD_S/mutau-(nu_VD_S*mutau_VD_S+nu_VD_S*mutau_VD_S+nu*mutau_VD_S_VD_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VD_S)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VD_S)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VD_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VD_S)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VD_S_VD_S))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
  SP_S_y0_VD_S_VGP_S=(+SP_S_eta_VD_S_VGP_S+((+(+SP_S_a_VD_S_VGP_S*nu+SP_S_a_VD_S*nu_VGP_S+SP_S_a_VGP_S*nu_VD_S+SP_S_a*nu_VD_S_VGP_S)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VGP_S+(+(+(+(+(nu_VD_S_VGP_S/mutau-(nu_VD_S*mutau_VGP_S+nu_VGP_S*mutau_VD_S+nu*mutau_VD_S_VGP_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VGP_S)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VGP_S)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VGP_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VGP_S)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VD_S_VGP_S))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
  SP_S_y0_VD_S_VS_BP=(+SP_S_eta_VD_S_VS_BP+((+(+SP_S_a_VD_S_VS_BP*nu+SP_S_a_VD_S*nu_VS_BP+SP_S_a_VS_BP*nu_VD_S+SP_S_a*nu_VD_S_VS_BP)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VS_BP+(+(+(+(+(nu_VD_S_VS_BP/mutau-(nu_VD_S*mutau_VS_BP+nu_VS_BP*mutau_VD_S+nu*mutau_VD_S_VS_BP)/mutau/mutau+2*nu*mutau_VD_S*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VS_BP)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VS_BP)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VS_BP*SP_S_c+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VS_BP)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VD_S_VS_BP))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-SP_S_a_VD_S))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
#endif
SP_S_y0_VGP_S=(SP_S_eta_VGP_S+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
#if defined(_DERIVATE2)
  SP_S_y0_VGP_S_VD_S=(+SP_S_eta_VGP_S_VD_S+((+(+SP_S_a_VGP_S_VD_S*nu+SP_S_a_VGP_S*nu_VD_S+SP_S_a_VD_S*nu_VGP_S+SP_S_a*nu_VGP_S_VD_S)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VD_S+(+(+(+(+(nu_VGP_S_VD_S/mutau-(nu_VGP_S*mutau_VD_S+nu_VD_S*mutau_VGP_S+nu*mutau_VGP_S_VD_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VD_S)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VD_S)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VD_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VD_S)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VGP_S_VD_S))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
  SP_S_y0_VGP_S_VGP_S=(+SP_S_eta_VGP_S_VGP_S+((+(+SP_S_a_VGP_S_VGP_S*nu+SP_S_a_VGP_S*nu_VGP_S+SP_S_a_VGP_S*nu_VGP_S+SP_S_a*nu_VGP_S_VGP_S)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VGP_S+(+(+(+(+(nu_VGP_S_VGP_S/mutau-(nu_VGP_S*mutau_VGP_S+nu_VGP_S*mutau_VGP_S+nu*mutau_VGP_S_VGP_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VGP_S)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VGP_S)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VGP_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VGP_S)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VGP_S_VGP_S))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
  SP_S_y0_VGP_S_VS_BP=(+SP_S_eta_VGP_S_VS_BP+((+(+SP_S_a_VGP_S_VS_BP*nu+SP_S_a_VGP_S*nu_VS_BP+SP_S_a_VS_BP*nu_VGP_S+SP_S_a*nu_VGP_S_VS_BP)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VS_BP+(+(+(+(+(nu_VGP_S_VS_BP/mutau-(nu_VGP_S*mutau_VS_BP+nu_VS_BP*mutau_VGP_S+nu*mutau_VGP_S_VS_BP)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VS_BP)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VS_BP)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VS_BP*SP_S_c+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VS_BP)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VGP_S_VS_BP))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-SP_S_a_VGP_S))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
#endif
SP_S_y0_VS_BP=(SP_S_eta_VS_BP+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
#if defined(_DERIVATE2)
  SP_S_y0_VS_BP_VD_S=(+SP_S_eta_VS_BP_VD_S+((+(+SP_S_a_VS_BP_VD_S*nu+SP_S_a_VS_BP*nu_VD_S+SP_S_a_VD_S*nu_VS_BP+SP_S_a*nu_VS_BP_VD_S)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VD_S+(+(+(+(+(nu_VS_BP_VD_S/mutau-(nu_VS_BP*mutau_VD_S+nu_VD_S*mutau_VS_BP+nu*mutau_VS_BP_VD_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VD_S)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VD_S)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VD_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VD_S)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VS_BP_VD_S))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-SP_S_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
  SP_S_y0_VS_BP_VGP_S=(+SP_S_eta_VS_BP_VGP_S+((+(+SP_S_a_VS_BP_VGP_S*nu+SP_S_a_VS_BP*nu_VGP_S+SP_S_a_VGP_S*nu_VS_BP+SP_S_a*nu_VS_BP_VGP_S)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VGP_S+(+(+(+(+(nu_VS_BP_VGP_S/mutau-(nu_VS_BP*mutau_VGP_S+nu_VGP_S*mutau_VS_BP+nu*mutau_VS_BP_VGP_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VGP_S)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VGP_S)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VGP_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VGP_S)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VS_BP_VGP_S))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-SP_S_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
  SP_S_y0_VS_BP_VS_BP=(+SP_S_eta_VS_BP_VS_BP+((+(+SP_S_a_VS_BP_VS_BP*nu+SP_S_a_VS_BP*nu_VS_BP+SP_S_a_VS_BP*nu_VS_BP+SP_S_a*nu_VS_BP_VS_BP)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VS_BP+(+(+(+(+(nu_VS_BP_VS_BP/mutau-(nu_VS_BP*mutau_VS_BP+nu_VS_BP*mutau_VS_BP+nu*mutau_VS_BP_VS_BP)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VS_BP)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VS_BP)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VS_BP*SP_S_c+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VS_BP)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-SP_S_a_VS_BP_VS_BP))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-SP_S_a_VS_BP))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-SP_S_a_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
#endif
#endif
SP_S_y0=(SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
EXIT_IF_ISNAN((SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))))
if
((SP_S_y0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,SP_S_y0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=SP_S_y0_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(m20_exp(SP_S_y0)*SP_S_y0_VD_S*SP_S_y0_VD_S+d10_exp0*SP_S_y0_VD_S_VD_S);
  SP_S_delta0_VD_S_VGP_S=(m20_exp(SP_S_y0)*SP_S_y0_VGP_S*SP_S_y0_VD_S+d10_exp0*SP_S_y0_VD_S_VGP_S);
  SP_S_delta0_VD_S_VS_BP=(m20_exp(SP_S_y0)*SP_S_y0_VS_BP*SP_S_y0_VD_S+d10_exp0*SP_S_y0_VD_S_VS_BP);
#endif
SP_S_delta0_VGP_S=SP_S_y0_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(m20_exp(SP_S_y0)*SP_S_y0_VD_S*SP_S_y0_VGP_S+d10_exp0*SP_S_y0_VGP_S_VD_S);
  SP_S_delta0_VGP_S_VGP_S=(m20_exp(SP_S_y0)*SP_S_y0_VGP_S*SP_S_y0_VGP_S+d10_exp0*SP_S_y0_VGP_S_VGP_S);
  SP_S_delta0_VGP_S_VS_BP=(m20_exp(SP_S_y0)*SP_S_y0_VS_BP*SP_S_y0_VGP_S+d10_exp0*SP_S_y0_VGP_S_VS_BP);
#endif
SP_S_delta0_VS_BP=SP_S_y0_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(m20_exp(SP_S_y0)*SP_S_y0_VD_S*SP_S_y0_VS_BP+d10_exp0*SP_S_y0_VS_BP_VD_S);
  SP_S_delta0_VS_BP_VGP_S=(m20_exp(SP_S_y0)*SP_S_y0_VGP_S*SP_S_y0_VS_BP+d10_exp0*SP_S_y0_VS_BP_VGP_S);
  SP_S_delta0_VS_BP_VS_BP=(m20_exp(SP_S_y0)*SP_S_y0_VS_BP*SP_S_y0_VS_BP+d10_exp0*SP_S_y0_VS_BP_VS_BP);
#endif
#endif
SP_S_delta0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=(1.0e100*((SP_S_y0_VD_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VD_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VD_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VD_S_VD_S-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VD_S*((0.5*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01))))))+SP_S_y0_VD_S*(0.5*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VD_S_VD_S-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VD_S*(SP_S_y0_VD_S*3.3333333333333333e-01)+SP_S_y0_VD_S*SP_S_y0_VD_S*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VD_S_VD_S-0.0)*3.3333333333333333e-01+SP_S_y0_VD_S*0.0+SP_S_y0_VD_S*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
  SP_S_delta0_VD_S_VGP_S=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VGP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VD_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VD_S_VGP_S-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VD_S*((0.5*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01))))))+SP_S_y0_VGP_S*(0.5*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VD_S_VGP_S-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VD_S*(SP_S_y0_VGP_S*3.3333333333333333e-01)+SP_S_y0_VGP_S*SP_S_y0_VD_S*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VD_S_VGP_S-0.0)*3.3333333333333333e-01+SP_S_y0_VD_S*0.0+SP_S_y0_VGP_S*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
  SP_S_delta0_VD_S_VS_BP=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VS_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VD_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VD_S_VS_BP-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VD_S*((0.5*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01))))))+SP_S_y0_VS_BP*(0.5*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VD_S_VS_BP-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VD_S*(SP_S_y0_VS_BP*3.3333333333333333e-01)+SP_S_y0_VS_BP*SP_S_y0_VD_S*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VD_S_VS_BP-0.0)*3.3333333333333333e-01+SP_S_y0_VD_S*0.0+SP_S_y0_VS_BP*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
#endif
SP_S_delta0_VGP_S=(1.0e100*((SP_S_y0_VGP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VD_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VGP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VGP_S_VD_S-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VGP_S*((0.5*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01))))))+SP_S_y0_VD_S*(0.5*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VGP_S_VD_S-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VGP_S*(SP_S_y0_VD_S*3.3333333333333333e-01)+SP_S_y0_VD_S*SP_S_y0_VGP_S*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VGP_S_VD_S-0.0)*3.3333333333333333e-01+SP_S_y0_VGP_S*0.0+SP_S_y0_VD_S*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
  SP_S_delta0_VGP_S_VGP_S=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VGP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VGP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VGP_S_VGP_S-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VGP_S*((0.5*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01))))))+SP_S_y0_VGP_S*(0.5*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VGP_S_VGP_S-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VGP_S*(SP_S_y0_VGP_S*3.3333333333333333e-01)+SP_S_y0_VGP_S*SP_S_y0_VGP_S*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+SP_S_y0_VGP_S*0.0+SP_S_y0_VGP_S*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
  SP_S_delta0_VGP_S_VS_BP=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VS_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VGP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VGP_S_VS_BP-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VGP_S*((0.5*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01))))))+SP_S_y0_VS_BP*(0.5*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VGP_S_VS_BP-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VGP_S*(SP_S_y0_VS_BP*3.3333333333333333e-01)+SP_S_y0_VS_BP*SP_S_y0_VGP_S*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+SP_S_y0_VGP_S*0.0+SP_S_y0_VS_BP*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
#endif
SP_S_delta0_VS_BP=(1.0e100*((SP_S_y0_VS_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VD_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VS_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VS_BP_VD_S-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VS_BP*((0.5*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01))))))+SP_S_y0_VD_S*(0.5*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VD_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VS_BP_VD_S-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VS_BP*(SP_S_y0_VD_S*3.3333333333333333e-01)+SP_S_y0_VD_S*SP_S_y0_VS_BP*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VS_BP_VD_S-0.0)*3.3333333333333333e-01+SP_S_y0_VS_BP*0.0+SP_S_y0_VD_S*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
  SP_S_delta0_VS_BP_VGP_S=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VGP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VS_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VS_BP_VGP_S-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VS_BP*((0.5*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01))))))+SP_S_y0_VGP_S*(0.5*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VGP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VS_BP_VGP_S-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VS_BP*(SP_S_y0_VGP_S*3.3333333333333333e-01)+SP_S_y0_VGP_S*SP_S_y0_VS_BP*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+SP_S_y0_VS_BP*0.0+SP_S_y0_VGP_S*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
  SP_S_delta0_VS_BP_VS_BP=(+0.0*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((SP_S_y0_VS_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*((0.5*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_y0_VS_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_y0-2.3025850929940458e+02)*(0.5*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+SP_S_y0_VS_BP_VS_BP-0.0)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_y0_VS_BP*((0.5*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01))))))+SP_S_y0_VS_BP*(0.5*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01)))+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*(SP_S_y0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_y0_VS_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_y0-2.3025850929940458e+02)*SP_S_y0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_y0_VS_BP_VS_BP-0.0)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_y0_VS_BP*(SP_S_y0_VS_BP*3.3333333333333333e-01)+SP_S_y0_VS_BP*SP_S_y0_VS_BP*3.3333333333333333e-01+(SP_S_y0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_y0_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+SP_S_y0_VS_BP*0.0+SP_S_y0_VS_BP*0.0+(SP_S_y0-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
SP_S_delta0=(1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta1_VD_S=(-SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VD_S_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VGP_S=(-SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VGP_S_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VS_BP=(-SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VS_BP_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
#endif
SP_S_delta1=(1.0/SP_S_delta0);
EXIT_IF_ISNAN((1.0/SP_S_delta0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(-((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))+0.0*((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))+1.0*(+0.0+(+SP_S_y0_VD_S_VD_S*SP_S_y0+SP_S_y0_VD_S*SP_S_y0_VD_S+SP_S_y0_VD_S*SP_S_y0_VD_S+SP_S_y0*SP_S_y0_VD_S_VD_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))*(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
  SP_S_temp_VD_S_VGP_S=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))+0.0*((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))+1.0*(+0.0+(+SP_S_y0_VD_S_VGP_S*SP_S_y0+SP_S_y0_VD_S*SP_S_y0_VGP_S+SP_S_y0_VGP_S*SP_S_y0_VD_S+SP_S_y0*SP_S_y0_VD_S_VGP_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))*(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
  SP_S_temp_VD_S_VS_BP=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))+0.0*((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))+1.0*(+0.0+(+SP_S_y0_VD_S_VS_BP*SP_S_y0+SP_S_y0_VD_S*SP_S_y0_VS_BP+SP_S_y0_VS_BP*SP_S_y0_VD_S+SP_S_y0*SP_S_y0_VD_S_VS_BP)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))*(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
#endif
SP_S_temp_VGP_S=(-((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))+0.0*((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))+1.0*(+0.0+(+SP_S_y0_VGP_S_VD_S*SP_S_y0+SP_S_y0_VGP_S*SP_S_y0_VD_S+SP_S_y0_VD_S*SP_S_y0_VGP_S+SP_S_y0*SP_S_y0_VGP_S_VD_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))*(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
  SP_S_temp_VGP_S_VGP_S=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))+0.0*((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))+1.0*(+0.0+(+SP_S_y0_VGP_S_VGP_S*SP_S_y0+SP_S_y0_VGP_S*SP_S_y0_VGP_S+SP_S_y0_VGP_S*SP_S_y0_VGP_S+SP_S_y0*SP_S_y0_VGP_S_VGP_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))*(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
  SP_S_temp_VGP_S_VS_BP=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))+0.0*((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))+1.0*(+0.0+(+SP_S_y0_VGP_S_VS_BP*SP_S_y0+SP_S_y0_VGP_S*SP_S_y0_VS_BP+SP_S_y0_VS_BP*SP_S_y0_VGP_S+SP_S_y0*SP_S_y0_VGP_S_VS_BP)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))*(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
#endif
SP_S_temp_VS_BP=(-((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))+0.0*((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))+1.0*(+0.0+(+SP_S_y0_VS_BP_VD_S*SP_S_y0+SP_S_y0_VS_BP*SP_S_y0_VD_S+SP_S_y0_VD_S*SP_S_y0_VS_BP+SP_S_y0*SP_S_y0_VS_BP_VD_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))*(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
  SP_S_temp_VS_BP_VGP_S=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))+0.0*((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))+1.0*(+0.0+(+SP_S_y0_VS_BP_VGP_S*SP_S_y0+SP_S_y0_VS_BP*SP_S_y0_VGP_S+SP_S_y0_VGP_S*SP_S_y0_VS_BP+SP_S_y0*SP_S_y0_VS_BP_VGP_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))*(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
  SP_S_temp_VS_BP_VS_BP=(0.0/(2.0+(SP_S_y0*SP_S_y0))-(0.0*(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))+0.0*((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))+1.0*(+0.0+(+SP_S_y0_VS_BP_VS_BP*SP_S_y0+SP_S_y0_VS_BP*SP_S_y0_VS_BP+SP_S_y0_VS_BP*SP_S_y0_VS_BP+SP_S_y0*SP_S_y0_VS_BP_VS_BP)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))+2*1.0*((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))*(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
#endif
#endif
SP_S_temp=(1.0/(2.0+(SP_S_y0*SP_S_y0)));
EXIT_IF_ISNAN((1.0/(2.0+(SP_S_y0*SP_S_y0))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi0_VD_S=((((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))*SP_S_temp)+((SP_S_y0*SP_S_y0)*SP_S_temp_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VD_S_VD_S=(+(+SP_S_y0_VD_S_VD_S*SP_S_y0+SP_S_y0_VD_S*SP_S_y0_VD_S+SP_S_y0_VD_S*SP_S_y0_VD_S+SP_S_y0*SP_S_y0_VD_S_VD_S)*SP_S_temp+((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))*SP_S_temp_VD_S+(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))*SP_S_temp_VD_S+(SP_S_y0*SP_S_y0)*SP_S_temp_VD_S_VD_S);
  SP_S_xi0_VD_S_VGP_S=(+(+SP_S_y0_VD_S_VGP_S*SP_S_y0+SP_S_y0_VD_S*SP_S_y0_VGP_S+SP_S_y0_VGP_S*SP_S_y0_VD_S+SP_S_y0*SP_S_y0_VD_S_VGP_S)*SP_S_temp+((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))*SP_S_temp_VGP_S+(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))*SP_S_temp_VD_S+(SP_S_y0*SP_S_y0)*SP_S_temp_VD_S_VGP_S);
  SP_S_xi0_VD_S_VS_BP=(+(+SP_S_y0_VD_S_VS_BP*SP_S_y0+SP_S_y0_VD_S*SP_S_y0_VS_BP+SP_S_y0_VS_BP*SP_S_y0_VD_S+SP_S_y0*SP_S_y0_VD_S_VS_BP)*SP_S_temp+((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S))*SP_S_temp_VS_BP+(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))*SP_S_temp_VD_S+(SP_S_y0*SP_S_y0)*SP_S_temp_VD_S_VS_BP);
#endif
SP_S_xi0_VGP_S=((((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))*SP_S_temp)+((SP_S_y0*SP_S_y0)*SP_S_temp_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VGP_S_VD_S=(+(+SP_S_y0_VGP_S_VD_S*SP_S_y0+SP_S_y0_VGP_S*SP_S_y0_VD_S+SP_S_y0_VD_S*SP_S_y0_VGP_S+SP_S_y0*SP_S_y0_VGP_S_VD_S)*SP_S_temp+((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))*SP_S_temp_VD_S+(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))*SP_S_temp_VGP_S+(SP_S_y0*SP_S_y0)*SP_S_temp_VGP_S_VD_S);
  SP_S_xi0_VGP_S_VGP_S=(+(+SP_S_y0_VGP_S_VGP_S*SP_S_y0+SP_S_y0_VGP_S*SP_S_y0_VGP_S+SP_S_y0_VGP_S*SP_S_y0_VGP_S+SP_S_y0*SP_S_y0_VGP_S_VGP_S)*SP_S_temp+((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))*SP_S_temp_VGP_S+(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))*SP_S_temp_VGP_S+(SP_S_y0*SP_S_y0)*SP_S_temp_VGP_S_VGP_S);
  SP_S_xi0_VGP_S_VS_BP=(+(+SP_S_y0_VGP_S_VS_BP*SP_S_y0+SP_S_y0_VGP_S*SP_S_y0_VS_BP+SP_S_y0_VS_BP*SP_S_y0_VGP_S+SP_S_y0*SP_S_y0_VGP_S_VS_BP)*SP_S_temp+((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S))*SP_S_temp_VS_BP+(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))*SP_S_temp_VGP_S+(SP_S_y0*SP_S_y0)*SP_S_temp_VGP_S_VS_BP);
#endif
SP_S_xi0_VS_BP=((((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))*SP_S_temp)+((SP_S_y0*SP_S_y0)*SP_S_temp_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi0_VS_BP_VD_S=(+(+SP_S_y0_VS_BP_VD_S*SP_S_y0+SP_S_y0_VS_BP*SP_S_y0_VD_S+SP_S_y0_VD_S*SP_S_y0_VS_BP+SP_S_y0*SP_S_y0_VS_BP_VD_S)*SP_S_temp+((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))*SP_S_temp_VD_S+(((SP_S_y0_VD_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VD_S)))*SP_S_temp_VS_BP+(SP_S_y0*SP_S_y0)*SP_S_temp_VS_BP_VD_S);
  SP_S_xi0_VS_BP_VGP_S=(+(+SP_S_y0_VS_BP_VGP_S*SP_S_y0+SP_S_y0_VS_BP*SP_S_y0_VGP_S+SP_S_y0_VGP_S*SP_S_y0_VS_BP+SP_S_y0*SP_S_y0_VS_BP_VGP_S)*SP_S_temp+((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))*SP_S_temp_VGP_S+(((SP_S_y0_VGP_S*SP_S_y0)+(SP_S_y0*SP_S_y0_VGP_S)))*SP_S_temp_VS_BP+(SP_S_y0*SP_S_y0)*SP_S_temp_VS_BP_VGP_S);
  SP_S_xi0_VS_BP_VS_BP=(+(+SP_S_y0_VS_BP_VS_BP*SP_S_y0+SP_S_y0_VS_BP*SP_S_y0_VS_BP+SP_S_y0_VS_BP*SP_S_y0_VS_BP+SP_S_y0*SP_S_y0_VS_BP_VS_BP)*SP_S_temp+((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP))*SP_S_temp_VS_BP+(((SP_S_y0_VS_BP*SP_S_y0)+(SP_S_y0*SP_S_y0_VS_BP)))*SP_S_temp_VS_BP+(SP_S_y0*SP_S_y0)*SP_S_temp_VS_BP_VS_BP);
#endif
#endif
SP_S_xi0=((SP_S_y0*SP_S_y0)*SP_S_temp);
EXIT_IF_ISNAN(((SP_S_y0*SP_S_y0)*SP_S_temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi1_VD_S=(4.0*((((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VD_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VD_S_VD_S=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_y0_VD_S_VD_S*SP_S_temp+SP_S_y0_VD_S*SP_S_temp_VD_S+SP_S_y0_VD_S*SP_S_temp_VD_S+SP_S_y0*SP_S_temp_VD_S_VD_S)*SP_S_temp+((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S))*SP_S_temp_VD_S+(((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S)))*SP_S_temp_VD_S+(SP_S_y0*SP_S_temp)*SP_S_temp_VD_S_VD_S));
  SP_S_xi1_VD_S_VGP_S=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_y0_VD_S_VGP_S*SP_S_temp+SP_S_y0_VD_S*SP_S_temp_VGP_S+SP_S_y0_VGP_S*SP_S_temp_VD_S+SP_S_y0*SP_S_temp_VD_S_VGP_S)*SP_S_temp+((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S))*SP_S_temp_VGP_S+(((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S)))*SP_S_temp_VD_S+(SP_S_y0*SP_S_temp)*SP_S_temp_VD_S_VGP_S));
  SP_S_xi1_VD_S_VS_BP=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_y0_VD_S_VS_BP*SP_S_temp+SP_S_y0_VD_S*SP_S_temp_VS_BP+SP_S_y0_VS_BP*SP_S_temp_VD_S+SP_S_y0*SP_S_temp_VD_S_VS_BP)*SP_S_temp+((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S))*SP_S_temp_VS_BP+(((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP)))*SP_S_temp_VD_S+(SP_S_y0*SP_S_temp)*SP_S_temp_VD_S_VS_BP));
#endif
SP_S_xi1_VGP_S=(4.0*((((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VGP_S_VD_S=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_y0_VGP_S_VD_S*SP_S_temp+SP_S_y0_VGP_S*SP_S_temp_VD_S+SP_S_y0_VD_S*SP_S_temp_VGP_S+SP_S_y0*SP_S_temp_VGP_S_VD_S)*SP_S_temp+((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S))*SP_S_temp_VD_S+(((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S)))*SP_S_temp_VGP_S+(SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S_VD_S));
  SP_S_xi1_VGP_S_VGP_S=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_y0_VGP_S_VGP_S*SP_S_temp+SP_S_y0_VGP_S*SP_S_temp_VGP_S+SP_S_y0_VGP_S*SP_S_temp_VGP_S+SP_S_y0*SP_S_temp_VGP_S_VGP_S)*SP_S_temp+((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S))*SP_S_temp_VGP_S+(((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S)))*SP_S_temp_VGP_S+(SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S_VGP_S));
  SP_S_xi1_VGP_S_VS_BP=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_y0_VGP_S_VS_BP*SP_S_temp+SP_S_y0_VGP_S*SP_S_temp_VS_BP+SP_S_y0_VS_BP*SP_S_temp_VGP_S+SP_S_y0*SP_S_temp_VGP_S_VS_BP)*SP_S_temp+((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S))*SP_S_temp_VS_BP+(((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP)))*SP_S_temp_VGP_S+(SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S_VS_BP));
#endif
SP_S_xi1_VS_BP=(4.0*((((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP)));
#if defined(_DERIVATE2)
  SP_S_xi1_VS_BP_VD_S=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_y0_VS_BP_VD_S*SP_S_temp+SP_S_y0_VS_BP*SP_S_temp_VD_S+SP_S_y0_VD_S*SP_S_temp_VS_BP+SP_S_y0*SP_S_temp_VS_BP_VD_S)*SP_S_temp+((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP))*SP_S_temp_VD_S+(((SP_S_y0_VD_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VD_S)))*SP_S_temp_VS_BP+(SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP_VD_S));
  SP_S_xi1_VS_BP_VGP_S=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_y0_VS_BP_VGP_S*SP_S_temp+SP_S_y0_VS_BP*SP_S_temp_VGP_S+SP_S_y0_VGP_S*SP_S_temp_VS_BP+SP_S_y0*SP_S_temp_VS_BP_VGP_S)*SP_S_temp+((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP))*SP_S_temp_VGP_S+(((SP_S_y0_VGP_S*SP_S_temp)+(SP_S_y0*SP_S_temp_VGP_S)))*SP_S_temp_VS_BP+(SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP_VGP_S));
  SP_S_xi1_VS_BP_VS_BP=(+0.0*((SP_S_y0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_y0_VS_BP_VS_BP*SP_S_temp+SP_S_y0_VS_BP*SP_S_temp_VS_BP+SP_S_y0_VS_BP*SP_S_temp_VS_BP+SP_S_y0*SP_S_temp_VS_BP_VS_BP)*SP_S_temp+((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP))*SP_S_temp_VS_BP+(((SP_S_y0_VS_BP*SP_S_temp)+(SP_S_y0*SP_S_temp_VS_BP)))*SP_S_temp_VS_BP+(SP_S_y0*SP_S_temp)*SP_S_temp_VS_BP_VS_BP));
#endif
#endif
SP_S_xi1=(4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));
EXIT_IF_ISNAN((4.0*((SP_S_y0*SP_S_temp)*SP_S_temp)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi2_VD_S=((((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VD_S_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VD_S))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VD_S);
  SP_S_xi2_VD_S_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VGP_S);
  SP_S_xi2_VD_S_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VS_BP);
#endif
SP_S_xi2_VGP_S=((((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VGP_S_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VD_S))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VD_S);
  SP_S_xi2_VGP_S_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VGP_S);
  SP_S_xi2_VGP_S_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VS_BP);
#endif
SP_S_xi2_VS_BP=((((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi2_VS_BP_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VD_S))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VD_S);
  SP_S_xi2_VS_BP_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VGP_S);
  SP_S_xi2_VS_BP_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VS_BP);
#endif
#endif
SP_S_xi2=((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
EXIT_IF_ISNAN(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(SP_S_yg_VD_S-SP_S_y0_VD_S);
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+SP_S_yg_VD_S_VD_S-SP_S_y0_VD_S_VD_S);
  SP_S_temp_VD_S_VGP_S=(+SP_S_yg_VD_S_VGP_S-SP_S_y0_VD_S_VGP_S);
  SP_S_temp_VD_S_VS_BP=(+SP_S_yg_VD_S_VS_BP-SP_S_y0_VD_S_VS_BP);
#endif
SP_S_temp_VGP_S=(SP_S_yg_VGP_S-SP_S_y0_VGP_S);
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+SP_S_yg_VGP_S_VD_S-SP_S_y0_VGP_S_VD_S);
  SP_S_temp_VGP_S_VGP_S=(+SP_S_yg_VGP_S_VGP_S-SP_S_y0_VGP_S_VGP_S);
  SP_S_temp_VGP_S_VS_BP=(+SP_S_yg_VGP_S_VS_BP-SP_S_y0_VGP_S_VS_BP);
#endif
SP_S_temp_VS_BP=(SP_S_yg_VS_BP-SP_S_y0_VS_BP);
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+SP_S_yg_VS_BP_VD_S-SP_S_y0_VS_BP_VD_S);
  SP_S_temp_VS_BP_VGP_S=(+SP_S_yg_VS_BP_VGP_S-SP_S_y0_VS_BP_VGP_S);
  SP_S_temp_VS_BP_VS_BP=(+SP_S_yg_VS_BP_VS_BP-SP_S_y0_VS_BP_VS_BP);
#endif
#endif
SP_S_temp=(SP_S_yg-SP_S_y0);
EXIT_IF_ISNAN((SP_S_yg-SP_S_y0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp1_VD_S=((delta_ns_VD_S*SP_S_delta1)+(delta_ns*SP_S_delta1_VD_S));
#if defined(_DERIVATE2)
  SP_S_temp1_VD_S_VD_S=(+delta_ns_VD_S_VD_S*SP_S_delta1+delta_ns_VD_S*SP_S_delta1_VD_S+delta_ns_VD_S*SP_S_delta1_VD_S+delta_ns*SP_S_delta1_VD_S_VD_S);
  SP_S_temp1_VD_S_VGP_S=(+0.0*SP_S_delta1+delta_ns_VD_S*SP_S_delta1_VGP_S+0.0*SP_S_delta1_VD_S+delta_ns*SP_S_delta1_VD_S_VGP_S);
  SP_S_temp1_VD_S_VS_BP=(+delta_ns_VD_S_VS_BP*SP_S_delta1+delta_ns_VD_S*SP_S_delta1_VS_BP+delta_ns_VS_BP*SP_S_delta1_VD_S+delta_ns*SP_S_delta1_VD_S_VS_BP);
#endif
SP_S_temp1_VGP_S=(delta_ns*SP_S_delta1_VGP_S);
#if defined(_DERIVATE2)
  SP_S_temp1_VGP_S_VD_S=(+0.0*SP_S_delta1+0.0*SP_S_delta1_VD_S+delta_ns_VD_S*SP_S_delta1_VGP_S+delta_ns*SP_S_delta1_VGP_S_VD_S);
  SP_S_temp1_VGP_S_VGP_S=(+0.0*SP_S_delta1+0.0*SP_S_delta1_VGP_S+0.0*SP_S_delta1_VGP_S+delta_ns*SP_S_delta1_VGP_S_VGP_S);
  SP_S_temp1_VGP_S_VS_BP=(+0.0*SP_S_delta1+0.0*SP_S_delta1_VS_BP+delta_ns_VS_BP*SP_S_delta1_VGP_S+delta_ns*SP_S_delta1_VGP_S_VS_BP);
#endif
SP_S_temp1_VS_BP=((delta_ns_VS_BP*SP_S_delta1)+(delta_ns*SP_S_delta1_VS_BP));
#if defined(_DERIVATE2)
  SP_S_temp1_VS_BP_VD_S=(+delta_ns_VS_BP_VD_S*SP_S_delta1+delta_ns_VS_BP*SP_S_delta1_VD_S+delta_ns_VD_S*SP_S_delta1_VS_BP+delta_ns*SP_S_delta1_VS_BP_VD_S);
  SP_S_temp1_VS_BP_VGP_S=(+0.0*SP_S_delta1+delta_ns_VS_BP*SP_S_delta1_VGP_S+0.0*SP_S_delta1_VS_BP+delta_ns*SP_S_delta1_VS_BP_VGP_S);
  SP_S_temp1_VS_BP_VS_BP=(+delta_ns_VS_BP_VS_BP*SP_S_delta1+delta_ns_VS_BP*SP_S_delta1_VS_BP+delta_ns_VS_BP*SP_S_delta1_VS_BP+delta_ns*SP_S_delta1_VS_BP_VS_BP);
#endif
#endif
SP_S_temp1=(delta_ns*SP_S_delta1);
EXIT_IF_ISNAN((delta_ns*SP_S_delta1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_pC_VD_S=((2.0*SP_S_temp_VD_S)+((Gf2_VD_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))+(Gf2*((SP_S_delta0_VD_S-SP_S_temp1_VD_S)+((delta_ns_VD_S*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VD_S)))))));
#if defined(_DERIVATE2)
  SP_S_pC_VD_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VD_S)+(+Gf2_VD_S_VD_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VD_S*((SP_S_delta0_VD_S-SP_S_temp1_VD_S)+(((delta_ns_VD_S*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VD_S)))))+Gf2_VD_S*((SP_S_delta0_VD_S-SP_S_temp1_VD_S)+((delta_ns_VD_S*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VD_S))))+Gf2*(+(+(+SP_S_delta0_VD_S_VD_S-0.0)-SP_S_temp1_VD_S_VD_S)+(+delta_ns_VD_S_VD_S*(1.0-SP_S_xi1)+delta_ns_VD_S*(-SP_S_xi1_VD_S)+delta_ns_VD_S*(-SP_S_xi1_VD_S)+delta_ns*(+0.0-SP_S_xi1_VD_S_VD_S)))));
  SP_S_pC_VD_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VGP_S)+(+Gf2_VD_S_VGP_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VD_S*((SP_S_delta0_VGP_S-SP_S_temp1_VGP_S)+((delta_ns*(-SP_S_xi1_VGP_S))))+Gf2_VGP_S*((SP_S_delta0_VD_S-SP_S_temp1_VD_S)+((delta_ns_VD_S*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VD_S))))+Gf2*(+(+(+SP_S_delta0_VD_S_VGP_S-0.0)-SP_S_temp1_VD_S_VGP_S)+(+0.0*(1.0-SP_S_xi1)+delta_ns_VD_S*(-SP_S_xi1_VGP_S)+0.0*(-SP_S_xi1_VD_S)+delta_ns*(+0.0-SP_S_xi1_VD_S_VGP_S)))));
  SP_S_pC_VD_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VS_BP)+(+Gf2_VD_S_VS_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VD_S*((SP_S_delta0_VS_BP-SP_S_temp1_VS_BP)+(((delta_ns_VS_BP*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VS_BP)))))+Gf2_VS_BP*((SP_S_delta0_VD_S-SP_S_temp1_VD_S)+((delta_ns_VD_S*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VD_S))))+Gf2*(+(+(+SP_S_delta0_VD_S_VS_BP-0.0)-SP_S_temp1_VD_S_VS_BP)+(+delta_ns_VD_S_VS_BP*(1.0-SP_S_xi1)+delta_ns_VD_S*(-SP_S_xi1_VS_BP)+delta_ns_VS_BP*(-SP_S_xi1_VD_S)+delta_ns*(+0.0-SP_S_xi1_VD_S_VS_BP)))));
#endif
SP_S_pC_VGP_S=((2.0*SP_S_temp_VGP_S)+((Gf2_VGP_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))+(Gf2*((SP_S_delta0_VGP_S-SP_S_temp1_VGP_S)+(delta_ns*(-SP_S_xi1_VGP_S))))));
#if defined(_DERIVATE2)
  SP_S_pC_VGP_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VD_S)+(+Gf2_VGP_S_VD_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VGP_S*((SP_S_delta0_VD_S-SP_S_temp1_VD_S)+(((delta_ns_VD_S*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VD_S)))))+Gf2_VD_S*((SP_S_delta0_VGP_S-SP_S_temp1_VGP_S)+(delta_ns*(-SP_S_xi1_VGP_S)))+Gf2*(+(+(+SP_S_delta0_VGP_S_VD_S-0.0)-SP_S_temp1_VGP_S_VD_S)+(+0.0*(1.0-SP_S_xi1)+0.0*(-SP_S_xi1_VD_S)+delta_ns_VD_S*(-SP_S_xi1_VGP_S)+delta_ns*(+0.0-SP_S_xi1_VGP_S_VD_S)))));
  SP_S_pC_VGP_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VGP_S)+(+Gf2_VGP_S_VGP_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VGP_S*((SP_S_delta0_VGP_S-SP_S_temp1_VGP_S)+((delta_ns*(-SP_S_xi1_VGP_S))))+Gf2_VGP_S*((SP_S_delta0_VGP_S-SP_S_temp1_VGP_S)+(delta_ns*(-SP_S_xi1_VGP_S)))+Gf2*(+(+(+SP_S_delta0_VGP_S_VGP_S-0.0)-SP_S_temp1_VGP_S_VGP_S)+(+0.0*(1.0-SP_S_xi1)+0.0*(-SP_S_xi1_VGP_S)+0.0*(-SP_S_xi1_VGP_S)+delta_ns*(+0.0-SP_S_xi1_VGP_S_VGP_S)))));
  SP_S_pC_VGP_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VS_BP)+(+Gf2_VGP_S_VS_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VGP_S*((SP_S_delta0_VS_BP-SP_S_temp1_VS_BP)+(((delta_ns_VS_BP*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VS_BP)))))+Gf2_VS_BP*((SP_S_delta0_VGP_S-SP_S_temp1_VGP_S)+(delta_ns*(-SP_S_xi1_VGP_S)))+Gf2*(+(+(+SP_S_delta0_VGP_S_VS_BP-0.0)-SP_S_temp1_VGP_S_VS_BP)+(+0.0*(1.0-SP_S_xi1)+0.0*(-SP_S_xi1_VS_BP)+delta_ns_VS_BP*(-SP_S_xi1_VGP_S)+delta_ns*(+0.0-SP_S_xi1_VGP_S_VS_BP)))));
#endif
SP_S_pC_VS_BP=((2.0*SP_S_temp_VS_BP)+((Gf2_VS_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))+(Gf2*((SP_S_delta0_VS_BP-SP_S_temp1_VS_BP)+((delta_ns_VS_BP*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VS_BP)))))));
#if defined(_DERIVATE2)
  SP_S_pC_VS_BP_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VD_S)+(+Gf2_VS_BP_VD_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VS_BP*((SP_S_delta0_VD_S-SP_S_temp1_VD_S)+(((delta_ns_VD_S*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VD_S)))))+Gf2_VD_S*((SP_S_delta0_VS_BP-SP_S_temp1_VS_BP)+((delta_ns_VS_BP*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VS_BP))))+Gf2*(+(+(+SP_S_delta0_VS_BP_VD_S-0.0)-SP_S_temp1_VS_BP_VD_S)+(+delta_ns_VS_BP_VD_S*(1.0-SP_S_xi1)+delta_ns_VS_BP*(-SP_S_xi1_VD_S)+delta_ns_VD_S*(-SP_S_xi1_VS_BP)+delta_ns*(+0.0-SP_S_xi1_VS_BP_VD_S)))));
  SP_S_pC_VS_BP_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VGP_S)+(+Gf2_VS_BP_VGP_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VS_BP*((SP_S_delta0_VGP_S-SP_S_temp1_VGP_S)+((delta_ns*(-SP_S_xi1_VGP_S))))+Gf2_VGP_S*((SP_S_delta0_VS_BP-SP_S_temp1_VS_BP)+((delta_ns_VS_BP*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VS_BP))))+Gf2*(+(+(+SP_S_delta0_VS_BP_VGP_S-0.0)-SP_S_temp1_VS_BP_VGP_S)+(+0.0*(1.0-SP_S_xi1)+delta_ns_VS_BP*(-SP_S_xi1_VGP_S)+0.0*(-SP_S_xi1_VS_BP)+delta_ns*(+0.0-SP_S_xi1_VS_BP_VGP_S)))));
  SP_S_pC_VS_BP_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VS_BP)+(+Gf2_VS_BP_VS_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))+Gf2_VS_BP*((SP_S_delta0_VS_BP-SP_S_temp1_VS_BP)+(((delta_ns_VS_BP*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VS_BP)))))+Gf2_VS_BP*((SP_S_delta0_VS_BP-SP_S_temp1_VS_BP)+((delta_ns_VS_BP*(1.0-SP_S_xi1))+(delta_ns*(-SP_S_xi1_VS_BP))))+Gf2*(+(+(+SP_S_delta0_VS_BP_VS_BP-0.0)-SP_S_temp1_VS_BP_VS_BP)+(+delta_ns_VS_BP_VS_BP*(1.0-SP_S_xi1)+delta_ns_VS_BP*(-SP_S_xi1_VS_BP)+delta_ns_VS_BP*(-SP_S_xi1_VS_BP)+delta_ns*(+0.0-SP_S_xi1_VS_BP_VS_BP)))));
#endif
#endif
SP_S_pC=((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
EXIT_IF_ISNAN(((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_qC_VD_S=(((SP_S_temp_VD_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VD_S))-((Gf2_VD_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))+(Gf2*(((SP_S_delta0_VD_S-SP_S_y0_VD_S)+SP_S_temp1_VD_S)+((delta_ns_VD_S*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VD_S-SP_S_xi0_VD_S)))))));
#if defined(_DERIVATE2)
  SP_S_qC_VD_S_VD_S=(+(+SP_S_temp_VD_S_VD_S*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VD_S)-(+Gf2_VD_S_VD_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta0_VD_S-SP_S_y0_VD_S)+SP_S_temp1_VD_S)+(((delta_ns_VD_S*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VD_S-SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta0_VD_S-SP_S_y0_VD_S)+SP_S_temp1_VD_S)+((delta_ns_VD_S*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VD_S-SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta0_VD_S_VD_S-SP_S_y0_VD_S_VD_S)-0.0)+SP_S_temp1_VD_S_VD_S)+(+delta_ns_VD_S_VD_S*((SP_S_y0-1.0)-SP_S_xi0)+delta_ns_VD_S*(SP_S_y0_VD_S-SP_S_xi0_VD_S)+delta_ns_VD_S*(SP_S_y0_VD_S-SP_S_xi0_VD_S)+delta_ns*(+(+SP_S_y0_VD_S_VD_S-0.0)-SP_S_xi0_VD_S_VD_S)))));
  SP_S_qC_VD_S_VGP_S=(+(+SP_S_temp_VD_S_VGP_S*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VGP_S)-(+Gf2_VD_S_VGP_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta0_VGP_S-SP_S_y0_VGP_S)+SP_S_temp1_VGP_S)+((delta_ns*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S))))+Gf2_VGP_S*(((SP_S_delta0_VD_S-SP_S_y0_VD_S)+SP_S_temp1_VD_S)+((delta_ns_VD_S*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VD_S-SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta0_VD_S_VGP_S-SP_S_y0_VD_S_VGP_S)-0.0)+SP_S_temp1_VD_S_VGP_S)+(+0.0*((SP_S_y0-1.0)-SP_S_xi0)+delta_ns_VD_S*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)+0.0*(SP_S_y0_VD_S-SP_S_xi0_VD_S)+delta_ns*(+(+SP_S_y0_VD_S_VGP_S-0.0)-SP_S_xi0_VD_S_VGP_S)))));
  SP_S_qC_VD_S_VS_BP=(+(+SP_S_temp_VD_S_VS_BP*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VS_BP)-(+Gf2_VD_S_VS_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta0_VS_BP-SP_S_y0_VS_BP)+SP_S_temp1_VS_BP)+(((delta_ns_VS_BP*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta0_VD_S-SP_S_y0_VD_S)+SP_S_temp1_VD_S)+((delta_ns_VD_S*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VD_S-SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta0_VD_S_VS_BP-SP_S_y0_VD_S_VS_BP)-0.0)+SP_S_temp1_VD_S_VS_BP)+(+delta_ns_VD_S_VS_BP*((SP_S_y0-1.0)-SP_S_xi0)+delta_ns_VD_S*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)+delta_ns_VS_BP*(SP_S_y0_VD_S-SP_S_xi0_VD_S)+delta_ns*(+(+SP_S_y0_VD_S_VS_BP-0.0)-SP_S_xi0_VD_S_VS_BP)))));
#endif
SP_S_qC_VGP_S=(((SP_S_temp_VGP_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VGP_S))-((Gf2_VGP_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))+(Gf2*(((SP_S_delta0_VGP_S-SP_S_y0_VGP_S)+SP_S_temp1_VGP_S)+(delta_ns*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S))))));
#if defined(_DERIVATE2)
  SP_S_qC_VGP_S_VD_S=(+(+SP_S_temp_VGP_S_VD_S*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VD_S)-(+Gf2_VGP_S_VD_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta0_VD_S-SP_S_y0_VD_S)+SP_S_temp1_VD_S)+(((delta_ns_VD_S*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VD_S-SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta0_VGP_S-SP_S_y0_VGP_S)+SP_S_temp1_VGP_S)+(delta_ns*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)))+Gf2*(+(+(+(+SP_S_delta0_VGP_S_VD_S-SP_S_y0_VGP_S_VD_S)-0.0)+SP_S_temp1_VGP_S_VD_S)+(+0.0*((SP_S_y0-1.0)-SP_S_xi0)+0.0*(SP_S_y0_VD_S-SP_S_xi0_VD_S)+delta_ns_VD_S*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)+delta_ns*(+(+SP_S_y0_VGP_S_VD_S-0.0)-SP_S_xi0_VGP_S_VD_S)))));
  SP_S_qC_VGP_S_VGP_S=(+(+SP_S_temp_VGP_S_VGP_S*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VGP_S)-(+Gf2_VGP_S_VGP_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta0_VGP_S-SP_S_y0_VGP_S)+SP_S_temp1_VGP_S)+((delta_ns*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S))))+Gf2_VGP_S*(((SP_S_delta0_VGP_S-SP_S_y0_VGP_S)+SP_S_temp1_VGP_S)+(delta_ns*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)))+Gf2*(+(+(+(+SP_S_delta0_VGP_S_VGP_S-SP_S_y0_VGP_S_VGP_S)-0.0)+SP_S_temp1_VGP_S_VGP_S)+(+0.0*((SP_S_y0-1.0)-SP_S_xi0)+0.0*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)+0.0*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)+delta_ns*(+(+SP_S_y0_VGP_S_VGP_S-0.0)-SP_S_xi0_VGP_S_VGP_S)))));
  SP_S_qC_VGP_S_VS_BP=(+(+SP_S_temp_VGP_S_VS_BP*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VS_BP)-(+Gf2_VGP_S_VS_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta0_VS_BP-SP_S_y0_VS_BP)+SP_S_temp1_VS_BP)+(((delta_ns_VS_BP*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta0_VGP_S-SP_S_y0_VGP_S)+SP_S_temp1_VGP_S)+(delta_ns*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)))+Gf2*(+(+(+(+SP_S_delta0_VGP_S_VS_BP-SP_S_y0_VGP_S_VS_BP)-0.0)+SP_S_temp1_VGP_S_VS_BP)+(+0.0*((SP_S_y0-1.0)-SP_S_xi0)+0.0*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)+delta_ns_VS_BP*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)+delta_ns*(+(+SP_S_y0_VGP_S_VS_BP-0.0)-SP_S_xi0_VGP_S_VS_BP)))));
#endif
SP_S_qC_VS_BP=(((SP_S_temp_VS_BP*SP_S_temp)+(SP_S_temp*SP_S_temp_VS_BP))-((Gf2_VS_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))+(Gf2*(((SP_S_delta0_VS_BP-SP_S_y0_VS_BP)+SP_S_temp1_VS_BP)+((delta_ns_VS_BP*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)))))));
#if defined(_DERIVATE2)
  SP_S_qC_VS_BP_VD_S=(+(+SP_S_temp_VS_BP_VD_S*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VD_S)-(+Gf2_VS_BP_VD_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta0_VD_S-SP_S_y0_VD_S)+SP_S_temp1_VD_S)+(((delta_ns_VD_S*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VD_S-SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta0_VS_BP-SP_S_y0_VS_BP)+SP_S_temp1_VS_BP)+((delta_ns_VS_BP*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta0_VS_BP_VD_S-SP_S_y0_VS_BP_VD_S)-0.0)+SP_S_temp1_VS_BP_VD_S)+(+delta_ns_VS_BP_VD_S*((SP_S_y0-1.0)-SP_S_xi0)+delta_ns_VS_BP*(SP_S_y0_VD_S-SP_S_xi0_VD_S)+delta_ns_VD_S*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)+delta_ns*(+(+SP_S_y0_VS_BP_VD_S-0.0)-SP_S_xi0_VS_BP_VD_S)))));
  SP_S_qC_VS_BP_VGP_S=(+(+SP_S_temp_VS_BP_VGP_S*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VGP_S)-(+Gf2_VS_BP_VGP_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta0_VGP_S-SP_S_y0_VGP_S)+SP_S_temp1_VGP_S)+((delta_ns*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S))))+Gf2_VGP_S*(((SP_S_delta0_VS_BP-SP_S_y0_VS_BP)+SP_S_temp1_VS_BP)+((delta_ns_VS_BP*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta0_VS_BP_VGP_S-SP_S_y0_VS_BP_VGP_S)-0.0)+SP_S_temp1_VS_BP_VGP_S)+(+0.0*((SP_S_y0-1.0)-SP_S_xi0)+delta_ns_VS_BP*(SP_S_y0_VGP_S-SP_S_xi0_VGP_S)+0.0*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)+delta_ns*(+(+SP_S_y0_VS_BP_VGP_S-0.0)-SP_S_xi0_VS_BP_VGP_S)))));
  SP_S_qC_VS_BP_VS_BP=(+(+SP_S_temp_VS_BP_VS_BP*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VS_BP)-(+Gf2_VS_BP_VS_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta0_VS_BP-SP_S_y0_VS_BP)+SP_S_temp1_VS_BP)+(((delta_ns_VS_BP*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta0_VS_BP-SP_S_y0_VS_BP)+SP_S_temp1_VS_BP)+((delta_ns_VS_BP*((SP_S_y0-1.0)-SP_S_xi0))+(delta_ns*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta0_VS_BP_VS_BP-SP_S_y0_VS_BP_VS_BP)-0.0)+SP_S_temp1_VS_BP_VS_BP)+(+delta_ns_VS_BP_VS_BP*((SP_S_y0-1.0)-SP_S_xi0)+delta_ns_VS_BP*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)+delta_ns_VS_BP*(SP_S_y0_VS_BP-SP_S_xi0_VS_BP)+delta_ns*(+(+SP_S_y0_VS_BP_VS_BP-0.0)-SP_S_xi0_VS_BP_VS_BP)))));
#endif
#endif
SP_S_qC=((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
EXIT_IF_ISNAN(((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(-((Gf2_VD_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))+(Gf2*((SP_S_delta0_VD_S+SP_S_temp1_VD_S)-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+0.0-(+Gf2_VD_S_VD_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VD_S*((SP_S_delta0_VD_S+SP_S_temp1_VD_S)-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta0_VD_S+SP_S_temp1_VD_S)-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta0_VD_S_VD_S+SP_S_temp1_VD_S_VD_S)-(+delta_ns_VD_S_VD_S*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VD_S))));
  SP_S_temp_VD_S_VGP_S=(+0.0-(+Gf2_VD_S_VGP_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VD_S*((SP_S_delta0_VGP_S+SP_S_temp1_VGP_S)-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*((SP_S_delta0_VD_S+SP_S_temp1_VD_S)-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta0_VD_S_VGP_S+SP_S_temp1_VD_S_VGP_S)-(+0.0*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VGP_S))));
  SP_S_temp_VD_S_VS_BP=(+0.0-(+Gf2_VD_S_VS_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VD_S*((SP_S_delta0_VS_BP+SP_S_temp1_VS_BP)-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta0_VD_S+SP_S_temp1_VD_S)-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta0_VD_S_VS_BP+SP_S_temp1_VD_S_VS_BP)-(+delta_ns_VD_S_VS_BP*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VS_BP))));
#endif
SP_S_temp_VGP_S=(-((Gf2_VGP_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))+(Gf2*((SP_S_delta0_VGP_S+SP_S_temp1_VGP_S)-(delta_ns*SP_S_xi2_VGP_S)))));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+0.0-(+Gf2_VGP_S_VD_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta0_VD_S+SP_S_temp1_VD_S)-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta0_VGP_S+SP_S_temp1_VGP_S)-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+(+SP_S_delta0_VGP_S_VD_S+SP_S_temp1_VGP_S_VD_S)-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VD_S))));
  SP_S_temp_VGP_S_VGP_S=(+0.0-(+Gf2_VGP_S_VGP_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta0_VGP_S+SP_S_temp1_VGP_S)-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*((SP_S_delta0_VGP_S+SP_S_temp1_VGP_S)-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+(+SP_S_delta0_VGP_S_VGP_S+SP_S_temp1_VGP_S_VGP_S)-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VGP_S))));
  SP_S_temp_VGP_S_VS_BP=(+0.0-(+Gf2_VGP_S_VS_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta0_VS_BP+SP_S_temp1_VS_BP)-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta0_VGP_S+SP_S_temp1_VGP_S)-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+(+SP_S_delta0_VGP_S_VS_BP+SP_S_temp1_VGP_S_VS_BP)-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VS_BP))));
#endif
SP_S_temp_VS_BP=(-((Gf2_VS_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))+(Gf2*((SP_S_delta0_VS_BP+SP_S_temp1_VS_BP)-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+0.0-(+Gf2_VS_BP_VD_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta0_VD_S+SP_S_temp1_VD_S)-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta0_VS_BP+SP_S_temp1_VS_BP)-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta0_VS_BP_VD_S+SP_S_temp1_VS_BP_VD_S)-(+delta_ns_VS_BP_VD_S*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VD_S))));
  SP_S_temp_VS_BP_VGP_S=(+0.0-(+Gf2_VS_BP_VGP_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta0_VGP_S+SP_S_temp1_VGP_S)-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*((SP_S_delta0_VS_BP+SP_S_temp1_VS_BP)-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta0_VS_BP_VGP_S+SP_S_temp1_VS_BP_VGP_S)-(+0.0*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VGP_S))));
  SP_S_temp_VS_BP_VS_BP=(+0.0-(+Gf2_VS_BP_VS_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta0_VS_BP+SP_S_temp1_VS_BP)-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta0_VS_BP+SP_S_temp1_VS_BP)-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta0_VS_BP_VS_BP+SP_S_temp1_VS_BP_VS_BP)-(+delta_ns_VS_BP_VS_BP*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VS_BP))));
#endif
#endif
SP_S_temp=(2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
EXIT_IF_ISNAN((2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2)))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(((SP_S_pC_VD_S*SP_S_pC)+(SP_S_pC*SP_S_pC_VD_S))-(2.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+(+SP_S_pC_VD_S_VD_S*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VD_S*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VD_S)));
  SP_S_temp_VD_S_VGP_S=(+(+SP_S_pC_VD_S_VGP_S*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VGP_S*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VGP_S)));
  SP_S_temp_VD_S_VS_BP=(+(+SP_S_pC_VD_S_VS_BP*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VS_BP*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VS_BP)));
#endif
SP_S_temp_VGP_S=(((SP_S_pC_VGP_S*SP_S_pC)+(SP_S_pC*SP_S_pC_VGP_S))-(2.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+(+SP_S_pC_VGP_S_VD_S*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VD_S*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VD_S)));
  SP_S_temp_VGP_S_VGP_S=(+(+SP_S_pC_VGP_S_VGP_S*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VGP_S*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VGP_S)));
  SP_S_temp_VGP_S_VS_BP=(+(+SP_S_pC_VGP_S_VS_BP*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VS_BP*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VS_BP)));
#endif
SP_S_temp_VS_BP=(((SP_S_pC_VS_BP*SP_S_pC)+(SP_S_pC*SP_S_pC_VS_BP))-(2.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+(+SP_S_pC_VS_BP_VD_S*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VD_S*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VD_S)));
  SP_S_temp_VS_BP_VGP_S=(+(+SP_S_pC_VS_BP_VGP_S*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VGP_S*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VGP_S)));
  SP_S_temp_VS_BP_VS_BP=(+(+SP_S_pC_VS_BP_VS_BP*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VS_BP*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VS_BP)));
#endif
#endif
SP_S_temp=((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
EXIT_IF_ISNAN(((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp))))
{
double m00_sqrt(d00_sqrt0,SP_S_temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,SP_S_temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_s_VD_S=((-SP_S_y0_VD_S)-(2.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_s_VD_S_VD_S=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VD_S_VGP_S=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VD_S_VS_BP=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
x_s_VGP_S=((-SP_S_y0_VGP_S)-(2.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_s_VGP_S_VD_S=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VGP_S_VGP_S=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VGP_S_VS_BP=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
x_s_VS_BP=((-SP_S_y0_VS_BP)-(2.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_s_VS_BP_VD_S=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VS_BP_VGP_S=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VS_BP_VS_BP=(+0.0-(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
#endif
x_s=((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))));
EXIT_IF_ISNAN(((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+d00_sqrt0)))))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_xg1_VD_S=(-Gf_VD_S*7.324648775608221e-001/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
#if defined(_DERIVATE2)
  SP_xg1_VD_S_VD_S=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VD_S*7.324648775608221e-001)+0.0*Gf_VD_S*7.324648775608221e-001+1.0*(+0.0+(+Gf_VD_S_VD_S*7.324648775608221e-001+Gf_VD_S*0.0+Gf_VD_S*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VD_S*7.324648775608221e-001*(Gf_VD_S*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
  SP_xg1_VD_S_VGP_S=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VGP_S*7.324648775608221e-001)+0.0*Gf_VD_S*7.324648775608221e-001+1.0*(+0.0+(+Gf_VD_S_VGP_S*7.324648775608221e-001+Gf_VD_S*0.0+Gf_VGP_S*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VD_S*7.324648775608221e-001*(Gf_VGP_S*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
  SP_xg1_VD_S_VS_BP=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VS_BP*7.324648775608221e-001)+0.0*Gf_VD_S*7.324648775608221e-001+1.0*(+0.0+(+Gf_VD_S_VS_BP*7.324648775608221e-001+Gf_VD_S*0.0+Gf_VS_BP*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VD_S*7.324648775608221e-001*(Gf_VS_BP*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
#endif
SP_xg1_VGP_S=(-Gf_VGP_S*7.324648775608221e-001/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
#if defined(_DERIVATE2)
  SP_xg1_VGP_S_VD_S=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VD_S*7.324648775608221e-001)+0.0*Gf_VGP_S*7.324648775608221e-001+1.0*(+0.0+(+Gf_VGP_S_VD_S*7.324648775608221e-001+Gf_VGP_S*0.0+Gf_VD_S*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VGP_S*7.324648775608221e-001*(Gf_VD_S*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
  SP_xg1_VGP_S_VGP_S=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VGP_S*7.324648775608221e-001)+0.0*Gf_VGP_S*7.324648775608221e-001+1.0*(+0.0+(+Gf_VGP_S_VGP_S*7.324648775608221e-001+Gf_VGP_S*0.0+Gf_VGP_S*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VGP_S*7.324648775608221e-001*(Gf_VGP_S*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
  SP_xg1_VGP_S_VS_BP=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VS_BP*7.324648775608221e-001)+0.0*Gf_VGP_S*7.324648775608221e-001+1.0*(+0.0+(+Gf_VGP_S_VS_BP*7.324648775608221e-001+Gf_VGP_S*0.0+Gf_VS_BP*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VGP_S*7.324648775608221e-001*(Gf_VS_BP*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
#endif
SP_xg1_VS_BP=(-Gf_VS_BP*7.324648775608221e-001/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
#if defined(_DERIVATE2)
  SP_xg1_VS_BP_VD_S=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VD_S*7.324648775608221e-001)+0.0*Gf_VS_BP*7.324648775608221e-001+1.0*(+0.0+(+Gf_VS_BP_VD_S*7.324648775608221e-001+Gf_VS_BP*0.0+Gf_VD_S*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VS_BP*7.324648775608221e-001*(Gf_VD_S*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
  SP_xg1_VS_BP_VGP_S=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VGP_S*7.324648775608221e-001)+0.0*Gf_VS_BP*7.324648775608221e-001+1.0*(+0.0+(+Gf_VS_BP_VGP_S*7.324648775608221e-001+Gf_VS_BP*0.0+Gf_VGP_S*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VS_BP*7.324648775608221e-001*(Gf_VGP_S*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
  SP_xg1_VS_BP_VS_BP=(0.0/(pInst->x1+(Gf*7.324648775608221e-001))-(0.0*(Gf_VS_BP*7.324648775608221e-001)+0.0*Gf_VS_BP*7.324648775608221e-001+1.0*(+0.0+(+Gf_VS_BP_VS_BP*7.324648775608221e-001+Gf_VS_BP*0.0+Gf_VS_BP*0.0+Gf*0.0)))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))+2*1.0*Gf_VS_BP*7.324648775608221e-001*(Gf_VS_BP*7.324648775608221e-001)/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001))/(pInst->x1+(Gf*7.324648775608221e-001)));
#endif
#endif
SP_xg1=(1.0/(pInst->x1+(Gf*7.324648775608221e-001)));
EXIT_IF_ISNAN((1.0/(pInst->x1+(Gf*7.324648775608221e-001))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_A_fac_VD_S=((((xi_VD_S*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VD_S))*SP_xg1)+((((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VD_S));
#if defined(_DERIVATE2)
  SP_S_A_fac_VD_S_VD_S=(+(+(+(+xi_VD_S_VD_S*pInst->x1+xi_VD_S*0.0+xi_VD_S*0.0+xi*0.0)*SP_xg1+xi_VD_S*pInst->x1*SP_xg1_VD_S+(xi_VD_S*pInst->x1)*SP_xg1_VD_S+(xi*pInst->x1)*SP_xg1_VD_S_VD_S)-0.0)*SP_xg1+((xi_VD_S*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VD_S))*SP_xg1_VD_S+((((xi_VD_S*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VD_S)))*SP_xg1_VD_S+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VD_S_VD_S);
  SP_S_A_fac_VD_S_VGP_S=(+(+(+(+xi_VD_S_VGP_S*pInst->x1+xi_VD_S*0.0+xi_VGP_S*0.0+xi*0.0)*SP_xg1+xi_VD_S*pInst->x1*SP_xg1_VGP_S+(xi_VGP_S*pInst->x1)*SP_xg1_VD_S+(xi*pInst->x1)*SP_xg1_VD_S_VGP_S)-0.0)*SP_xg1+((xi_VD_S*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VD_S))*SP_xg1_VGP_S+((((xi_VGP_S*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VGP_S)))*SP_xg1_VD_S+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VD_S_VGP_S);
  SP_S_A_fac_VD_S_VS_BP=(+(+(+(+xi_VD_S_VS_BP*pInst->x1+xi_VD_S*0.0+xi_VS_BP*0.0+xi*0.0)*SP_xg1+xi_VD_S*pInst->x1*SP_xg1_VS_BP+(xi_VS_BP*pInst->x1)*SP_xg1_VD_S+(xi*pInst->x1)*SP_xg1_VD_S_VS_BP)-0.0)*SP_xg1+((xi_VD_S*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VD_S))*SP_xg1_VS_BP+((((xi_VS_BP*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VS_BP)))*SP_xg1_VD_S+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VD_S_VS_BP);
#endif
SP_S_A_fac_VGP_S=((((xi_VGP_S*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VGP_S))*SP_xg1)+((((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VGP_S));
#if defined(_DERIVATE2)
  SP_S_A_fac_VGP_S_VD_S=(+(+(+(+xi_VGP_S_VD_S*pInst->x1+xi_VGP_S*0.0+xi_VD_S*0.0+xi*0.0)*SP_xg1+xi_VGP_S*pInst->x1*SP_xg1_VD_S+(xi_VD_S*pInst->x1)*SP_xg1_VGP_S+(xi*pInst->x1)*SP_xg1_VGP_S_VD_S)-0.0)*SP_xg1+((xi_VGP_S*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VGP_S))*SP_xg1_VD_S+((((xi_VD_S*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VD_S)))*SP_xg1_VGP_S+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VGP_S_VD_S);
  SP_S_A_fac_VGP_S_VGP_S=(+(+(+(+xi_VGP_S_VGP_S*pInst->x1+xi_VGP_S*0.0+xi_VGP_S*0.0+xi*0.0)*SP_xg1+xi_VGP_S*pInst->x1*SP_xg1_VGP_S+(xi_VGP_S*pInst->x1)*SP_xg1_VGP_S+(xi*pInst->x1)*SP_xg1_VGP_S_VGP_S)-0.0)*SP_xg1+((xi_VGP_S*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VGP_S))*SP_xg1_VGP_S+((((xi_VGP_S*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VGP_S)))*SP_xg1_VGP_S+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VGP_S_VGP_S);
  SP_S_A_fac_VGP_S_VS_BP=(+(+(+(+xi_VGP_S_VS_BP*pInst->x1+xi_VGP_S*0.0+xi_VS_BP*0.0+xi*0.0)*SP_xg1+xi_VGP_S*pInst->x1*SP_xg1_VS_BP+(xi_VS_BP*pInst->x1)*SP_xg1_VGP_S+(xi*pInst->x1)*SP_xg1_VGP_S_VS_BP)-0.0)*SP_xg1+((xi_VGP_S*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VGP_S))*SP_xg1_VS_BP+((((xi_VS_BP*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VS_BP)))*SP_xg1_VGP_S+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VGP_S_VS_BP);
#endif
SP_S_A_fac_VS_BP=((((xi_VS_BP*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VS_BP))*SP_xg1)+((((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VS_BP));
#if defined(_DERIVATE2)
  SP_S_A_fac_VS_BP_VD_S=(+(+(+(+xi_VS_BP_VD_S*pInst->x1+xi_VS_BP*0.0+xi_VD_S*0.0+xi*0.0)*SP_xg1+xi_VS_BP*pInst->x1*SP_xg1_VD_S+(xi_VD_S*pInst->x1)*SP_xg1_VS_BP+(xi*pInst->x1)*SP_xg1_VS_BP_VD_S)-0.0)*SP_xg1+((xi_VS_BP*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VS_BP))*SP_xg1_VD_S+((((xi_VD_S*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VD_S)))*SP_xg1_VS_BP+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VS_BP_VD_S);
  SP_S_A_fac_VS_BP_VGP_S=(+(+(+(+xi_VS_BP_VGP_S*pInst->x1+xi_VS_BP*0.0+xi_VGP_S*0.0+xi*0.0)*SP_xg1+xi_VS_BP*pInst->x1*SP_xg1_VGP_S+(xi_VGP_S*pInst->x1)*SP_xg1_VS_BP+(xi*pInst->x1)*SP_xg1_VS_BP_VGP_S)-0.0)*SP_xg1+((xi_VS_BP*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VS_BP))*SP_xg1_VGP_S+((((xi_VGP_S*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VGP_S)))*SP_xg1_VS_BP+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VS_BP_VGP_S);
  SP_S_A_fac_VS_BP_VS_BP=(+(+(+(+xi_VS_BP_VS_BP*pInst->x1+xi_VS_BP*0.0+xi_VS_BP*0.0+xi*0.0)*SP_xg1+xi_VS_BP*pInst->x1*SP_xg1_VS_BP+(xi_VS_BP*pInst->x1)*SP_xg1_VS_BP+(xi*pInst->x1)*SP_xg1_VS_BP_VS_BP)-0.0)*SP_xg1+((xi_VS_BP*pInst->x1*SP_xg1)+((xi*pInst->x1)*SP_xg1_VS_BP))*SP_xg1_VS_BP+((((xi_VS_BP*pInst->x1)*SP_xg1)+((xi*pInst->x1)*SP_xg1_VS_BP)))*SP_xg1_VS_BP+(((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1_VS_BP_VS_BP);
#endif
#endif
SP_S_A_fac=((((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1);
EXIT_IF_ISNAN(((((xi*pInst->x1)*SP_xg1)-1.0)*SP_xg1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xbar_VD_S=((((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(1.0+(SP_S_A_fac*pInst->xg)))+((pInst->xg*inv_xi)*((SP_S_A_fac_VD_S*pInst->xg)+(SP_S_A_fac*xg_VD_S))));
#if defined(_DERIVATE2)
  SP_S_xbar_VD_S_VD_S=(+(+xg_VD_S_VD_S*inv_xi+xg_VD_S*inv_xi_VD_S+xg_VD_S*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VD_S)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((SP_S_A_fac_VD_S*pInst->xg)+(SP_S_A_fac*xg_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((SP_S_A_fac_VD_S*pInst->xg)+(SP_S_A_fac*xg_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VD_S_VD_S*pInst->xg+SP_S_A_fac_VD_S*xg_VD_S+SP_S_A_fac_VD_S*xg_VD_S+SP_S_A_fac*xg_VD_S_VD_S)));
  SP_S_xbar_VD_S_VGP_S=(+(+xg_VD_S_VGP_S*inv_xi+xg_VD_S*inv_xi_VGP_S+xg_VGP_S*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VGP_S)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((SP_S_A_fac_VGP_S*pInst->xg)+(SP_S_A_fac*xg_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((SP_S_A_fac_VD_S*pInst->xg)+(SP_S_A_fac*xg_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VD_S_VGP_S*pInst->xg+SP_S_A_fac_VD_S*xg_VGP_S+SP_S_A_fac_VGP_S*xg_VD_S+SP_S_A_fac*xg_VD_S_VGP_S)));
  SP_S_xbar_VD_S_VS_BP=(+(+xg_VD_S_VS_BP*inv_xi+xg_VD_S*inv_xi_VS_BP+xg_VS_BP*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VS_BP)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((SP_S_A_fac_VS_BP*pInst->xg)+(SP_S_A_fac*xg_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((SP_S_A_fac_VD_S*pInst->xg)+(SP_S_A_fac*xg_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VD_S_VS_BP*pInst->xg+SP_S_A_fac_VD_S*xg_VS_BP+SP_S_A_fac_VS_BP*xg_VD_S+SP_S_A_fac*xg_VD_S_VS_BP)));
#endif
SP_S_xbar_VGP_S=((((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(1.0+(SP_S_A_fac*pInst->xg)))+((pInst->xg*inv_xi)*((SP_S_A_fac_VGP_S*pInst->xg)+(SP_S_A_fac*xg_VGP_S))));
#if defined(_DERIVATE2)
  SP_S_xbar_VGP_S_VD_S=(+(+xg_VGP_S_VD_S*inv_xi+xg_VGP_S*inv_xi_VD_S+xg_VD_S*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VD_S)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((SP_S_A_fac_VD_S*pInst->xg)+(SP_S_A_fac*xg_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((SP_S_A_fac_VGP_S*pInst->xg)+(SP_S_A_fac*xg_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VGP_S_VD_S*pInst->xg+SP_S_A_fac_VGP_S*xg_VD_S+SP_S_A_fac_VD_S*xg_VGP_S+SP_S_A_fac*xg_VGP_S_VD_S)));
  SP_S_xbar_VGP_S_VGP_S=(+(+xg_VGP_S_VGP_S*inv_xi+xg_VGP_S*inv_xi_VGP_S+xg_VGP_S*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VGP_S)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((SP_S_A_fac_VGP_S*pInst->xg)+(SP_S_A_fac*xg_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((SP_S_A_fac_VGP_S*pInst->xg)+(SP_S_A_fac*xg_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VGP_S_VGP_S*pInst->xg+SP_S_A_fac_VGP_S*xg_VGP_S+SP_S_A_fac_VGP_S*xg_VGP_S+SP_S_A_fac*xg_VGP_S_VGP_S)));
  SP_S_xbar_VGP_S_VS_BP=(+(+xg_VGP_S_VS_BP*inv_xi+xg_VGP_S*inv_xi_VS_BP+xg_VS_BP*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VS_BP)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((SP_S_A_fac_VS_BP*pInst->xg)+(SP_S_A_fac*xg_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((SP_S_A_fac_VGP_S*pInst->xg)+(SP_S_A_fac*xg_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VGP_S_VS_BP*pInst->xg+SP_S_A_fac_VGP_S*xg_VS_BP+SP_S_A_fac_VS_BP*xg_VGP_S+SP_S_A_fac*xg_VGP_S_VS_BP)));
#endif
SP_S_xbar_VS_BP=((((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(1.0+(SP_S_A_fac*pInst->xg)))+((pInst->xg*inv_xi)*((SP_S_A_fac_VS_BP*pInst->xg)+(SP_S_A_fac*xg_VS_BP))));
#if defined(_DERIVATE2)
  SP_S_xbar_VS_BP_VD_S=(+(+xg_VS_BP_VD_S*inv_xi+xg_VS_BP*inv_xi_VD_S+xg_VD_S*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VD_S)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((SP_S_A_fac_VD_S*pInst->xg)+(SP_S_A_fac*xg_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((SP_S_A_fac_VS_BP*pInst->xg)+(SP_S_A_fac*xg_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VS_BP_VD_S*pInst->xg+SP_S_A_fac_VS_BP*xg_VD_S+SP_S_A_fac_VD_S*xg_VS_BP+SP_S_A_fac*xg_VS_BP_VD_S)));
  SP_S_xbar_VS_BP_VGP_S=(+(+xg_VS_BP_VGP_S*inv_xi+xg_VS_BP*inv_xi_VGP_S+xg_VGP_S*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VGP_S)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((SP_S_A_fac_VGP_S*pInst->xg)+(SP_S_A_fac*xg_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((SP_S_A_fac_VS_BP*pInst->xg)+(SP_S_A_fac*xg_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VS_BP_VGP_S*pInst->xg+SP_S_A_fac_VS_BP*xg_VGP_S+SP_S_A_fac_VGP_S*xg_VS_BP+SP_S_A_fac*xg_VS_BP_VGP_S)));
  SP_S_xbar_VS_BP_VS_BP=(+(+xg_VS_BP_VS_BP*inv_xi+xg_VS_BP*inv_xi_VS_BP+xg_VS_BP*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VS_BP)*(1.0+(SP_S_A_fac*pInst->xg))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((SP_S_A_fac_VS_BP*pInst->xg)+(SP_S_A_fac*xg_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((SP_S_A_fac_VS_BP*pInst->xg)+(SP_S_A_fac*xg_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+SP_S_A_fac_VS_BP_VS_BP*pInst->xg+SP_S_A_fac_VS_BP*xg_VS_BP+SP_S_A_fac_VS_BP*xg_VS_BP+SP_S_A_fac*xg_VS_BP_VS_BP)));
#endif
#endif
SP_S_xbar=((pInst->xg*inv_xi)*(1.0+(SP_S_A_fac*pInst->xg)));
EXIT_IF_ISNAN(((pInst->xg*inv_xi)*(1.0+(SP_S_A_fac*pInst->xg))))
if
(((-SP_S_xbar)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(-SP_S_xbar))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(-SP_S_xbar_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VD_S)*(-SP_S_xbar_VD_S)+d10_exp0*0.0);
  SP_S_temp_VD_S_VGP_S=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VGP_S)*(-SP_S_xbar_VD_S)+d10_exp0*0.0);
  SP_S_temp_VD_S_VS_BP=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VS_BP)*(-SP_S_xbar_VD_S)+d10_exp0*0.0);
#endif
SP_S_temp_VGP_S=(-SP_S_xbar_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VD_S)*(-SP_S_xbar_VGP_S)+d10_exp0*0.0);
  SP_S_temp_VGP_S_VGP_S=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VGP_S)*(-SP_S_xbar_VGP_S)+d10_exp0*0.0);
  SP_S_temp_VGP_S_VS_BP=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VS_BP)*(-SP_S_xbar_VGP_S)+d10_exp0*0.0);
#endif
SP_S_temp_VS_BP=(-SP_S_xbar_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VD_S)*(-SP_S_xbar_VS_BP)+d10_exp0*0.0);
  SP_S_temp_VS_BP_VGP_S=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VGP_S)*(-SP_S_xbar_VS_BP)+d10_exp0*0.0);
  SP_S_temp_VS_BP_VS_BP=(m20_exp((-SP_S_xbar))*(-SP_S_xbar_VS_BP)*(-SP_S_xbar_VS_BP)+d10_exp0*0.0);
#endif
#endif
SP_S_temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(-1.0e-100*(((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VD_S))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VD_S))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VD_S))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)+(-(-SP_S_xbar_VD_S))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VD_S))*0.0+(-(-SP_S_xbar_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
  SP_S_temp_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VD_S))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VGP_S))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VD_S))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)+(-(-SP_S_xbar_VGP_S))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VD_S))*0.0+(-(-SP_S_xbar_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
  SP_S_temp_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VD_S))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VS_BP))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VD_S))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)+(-(-SP_S_xbar_VS_BP))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VD_S))*0.0+(-(-SP_S_xbar_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
#endif
SP_S_temp_VGP_S=(-1.0e-100*(((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VGP_S))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VD_S))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VGP_S))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)+(-(-SP_S_xbar_VD_S))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VGP_S))*0.0+(-(-SP_S_xbar_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
  SP_S_temp_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VGP_S))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VGP_S))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VGP_S))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)+(-(-SP_S_xbar_VGP_S))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VGP_S))*0.0+(-(-SP_S_xbar_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
  SP_S_temp_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VGP_S))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VS_BP))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VGP_S))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)+(-(-SP_S_xbar_VS_BP))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VGP_S))*0.0+(-(-SP_S_xbar_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
#endif
SP_S_temp_VS_BP=(-1.0e-100*(((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VS_BP))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VD_S))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VS_BP))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)+(-(-SP_S_xbar_VD_S))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VS_BP))*0.0+(-(-SP_S_xbar_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
  SP_S_temp_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VS_BP))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VGP_S))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VS_BP))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)+(-(-SP_S_xbar_VGP_S))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VS_BP))*0.0+(-(-SP_S_xbar_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
  SP_S_temp_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))+(-(-SP_S_xbar_VS_BP))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_S_xbar_VS_BP))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))+(-(-SP_S_xbar_VS_BP))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)+(-(-SP_S_xbar_VS_BP))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_S_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_S_xbar_VS_BP))*0.0+(-(-SP_S_xbar_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_S_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(0.5*(((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_S_xbar_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((0.5*((((-(-SP_S_xbar_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_S_xbar))*((-(-SP_S_xbar_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
#endif
#endif
SP_S_temp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_w_VD_S=(-SP_S_temp_VD_S);
#if defined(_DERIVATE2)
  SP_S_w_VD_S_VD_S=(+0.0-SP_S_temp_VD_S_VD_S);
  SP_S_w_VD_S_VGP_S=(+0.0-SP_S_temp_VD_S_VGP_S);
  SP_S_w_VD_S_VS_BP=(+0.0-SP_S_temp_VD_S_VS_BP);
#endif
SP_S_w_VGP_S=(-SP_S_temp_VGP_S);
#if defined(_DERIVATE2)
  SP_S_w_VGP_S_VD_S=(+0.0-SP_S_temp_VGP_S_VD_S);
  SP_S_w_VGP_S_VGP_S=(+0.0-SP_S_temp_VGP_S_VGP_S);
  SP_S_w_VGP_S_VS_BP=(+0.0-SP_S_temp_VGP_S_VS_BP);
#endif
SP_S_w_VS_BP=(-SP_S_temp_VS_BP);
#if defined(_DERIVATE2)
  SP_S_w_VS_BP_VD_S=(+0.0-SP_S_temp_VS_BP_VD_S);
  SP_S_w_VS_BP_VGP_S=(+0.0-SP_S_temp_VS_BP_VGP_S);
  SP_S_w_VS_BP_VS_BP=(+0.0-SP_S_temp_VS_BP_VS_BP);
#endif
#endif
SP_S_w=(1.0-SP_S_temp);
EXIT_IF_ISNAN((1.0-SP_S_temp))
{
double m00_sqrt(d00_sqrt0,((pInst->xg+(Gf2*0.25))-SP_S_w))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->xg+(Gf2*0.25))-SP_S_w))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_x1_VD_S=((xg_VD_S+Gf2_VD_S*0.5)-((Gf_VD_S*d00_sqrt0)+(Gf*((xg_VD_S+Gf2_VD_S*0.25)-SP_S_w_VD_S)*d10_sqrt0)));
#if defined(_DERIVATE2)
  SP_S_x1_VD_S_VD_S=(+(+xg_VD_S_VD_S+(+Gf2_VD_S_VD_S*0.5+Gf2_VD_S*0.0+Gf2_VD_S*0.0+Gf2*0.0))-(+Gf_VD_S_VD_S*d00_sqrt0+Gf_VD_S*((xg_VD_S+(Gf2_VD_S*0.25))-SP_S_w_VD_S)*d10_sqrt0+Gf_VD_S*((xg_VD_S+Gf2_VD_S*0.25)-SP_S_w_VD_S)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VD_S+(Gf2_VD_S*0.25))-SP_S_w_VD_S)*((xg_VD_S+Gf2_VD_S*0.25)-SP_S_w_VD_S)+d10_sqrt0*(+(+xg_VD_S_VD_S+(+Gf2_VD_S_VD_S*0.25+Gf2_VD_S*0.0+Gf2_VD_S*0.0+Gf2*0.0))-SP_S_w_VD_S_VD_S))));
  SP_S_x1_VD_S_VGP_S=(+(+xg_VD_S_VGP_S+(+Gf2_VD_S_VGP_S*0.5+Gf2_VD_S*0.0+Gf2_VGP_S*0.0+Gf2*0.0))-(+Gf_VD_S_VGP_S*d00_sqrt0+Gf_VD_S*((xg_VGP_S+(Gf2_VGP_S*0.25))-SP_S_w_VGP_S)*d10_sqrt0+Gf_VGP_S*((xg_VD_S+Gf2_VD_S*0.25)-SP_S_w_VD_S)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VGP_S+(Gf2_VGP_S*0.25))-SP_S_w_VGP_S)*((xg_VD_S+Gf2_VD_S*0.25)-SP_S_w_VD_S)+d10_sqrt0*(+(+xg_VD_S_VGP_S+(+Gf2_VD_S_VGP_S*0.25+Gf2_VD_S*0.0+Gf2_VGP_S*0.0+Gf2*0.0))-SP_S_w_VD_S_VGP_S))));
  SP_S_x1_VD_S_VS_BP=(+(+xg_VD_S_VS_BP+(+Gf2_VD_S_VS_BP*0.5+Gf2_VD_S*0.0+Gf2_VS_BP*0.0+Gf2*0.0))-(+Gf_VD_S_VS_BP*d00_sqrt0+Gf_VD_S*((xg_VS_BP+(Gf2_VS_BP*0.25))-SP_S_w_VS_BP)*d10_sqrt0+Gf_VS_BP*((xg_VD_S+Gf2_VD_S*0.25)-SP_S_w_VD_S)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VS_BP+(Gf2_VS_BP*0.25))-SP_S_w_VS_BP)*((xg_VD_S+Gf2_VD_S*0.25)-SP_S_w_VD_S)+d10_sqrt0*(+(+xg_VD_S_VS_BP+(+Gf2_VD_S_VS_BP*0.25+Gf2_VD_S*0.0+Gf2_VS_BP*0.0+Gf2*0.0))-SP_S_w_VD_S_VS_BP))));
#endif
SP_S_x1_VGP_S=((xg_VGP_S+Gf2_VGP_S*0.5)-((Gf_VGP_S*d00_sqrt0)+(Gf*((xg_VGP_S+Gf2_VGP_S*0.25)-SP_S_w_VGP_S)*d10_sqrt0)));
#if defined(_DERIVATE2)
  SP_S_x1_VGP_S_VD_S=(+(+xg_VGP_S_VD_S+(+Gf2_VGP_S_VD_S*0.5+Gf2_VGP_S*0.0+Gf2_VD_S*0.0+Gf2*0.0))-(+Gf_VGP_S_VD_S*d00_sqrt0+Gf_VGP_S*((xg_VD_S+(Gf2_VD_S*0.25))-SP_S_w_VD_S)*d10_sqrt0+Gf_VD_S*((xg_VGP_S+Gf2_VGP_S*0.25)-SP_S_w_VGP_S)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VD_S+(Gf2_VD_S*0.25))-SP_S_w_VD_S)*((xg_VGP_S+Gf2_VGP_S*0.25)-SP_S_w_VGP_S)+d10_sqrt0*(+(+xg_VGP_S_VD_S+(+Gf2_VGP_S_VD_S*0.25+Gf2_VGP_S*0.0+Gf2_VD_S*0.0+Gf2*0.0))-SP_S_w_VGP_S_VD_S))));
  SP_S_x1_VGP_S_VGP_S=(+(+xg_VGP_S_VGP_S+(+Gf2_VGP_S_VGP_S*0.5+Gf2_VGP_S*0.0+Gf2_VGP_S*0.0+Gf2*0.0))-(+Gf_VGP_S_VGP_S*d00_sqrt0+Gf_VGP_S*((xg_VGP_S+(Gf2_VGP_S*0.25))-SP_S_w_VGP_S)*d10_sqrt0+Gf_VGP_S*((xg_VGP_S+Gf2_VGP_S*0.25)-SP_S_w_VGP_S)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VGP_S+(Gf2_VGP_S*0.25))-SP_S_w_VGP_S)*((xg_VGP_S+Gf2_VGP_S*0.25)-SP_S_w_VGP_S)+d10_sqrt0*(+(+xg_VGP_S_VGP_S+(+Gf2_VGP_S_VGP_S*0.25+Gf2_VGP_S*0.0+Gf2_VGP_S*0.0+Gf2*0.0))-SP_S_w_VGP_S_VGP_S))));
  SP_S_x1_VGP_S_VS_BP=(+(+xg_VGP_S_VS_BP+(+Gf2_VGP_S_VS_BP*0.5+Gf2_VGP_S*0.0+Gf2_VS_BP*0.0+Gf2*0.0))-(+Gf_VGP_S_VS_BP*d00_sqrt0+Gf_VGP_S*((xg_VS_BP+(Gf2_VS_BP*0.25))-SP_S_w_VS_BP)*d10_sqrt0+Gf_VS_BP*((xg_VGP_S+Gf2_VGP_S*0.25)-SP_S_w_VGP_S)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VS_BP+(Gf2_VS_BP*0.25))-SP_S_w_VS_BP)*((xg_VGP_S+Gf2_VGP_S*0.25)-SP_S_w_VGP_S)+d10_sqrt0*(+(+xg_VGP_S_VS_BP+(+Gf2_VGP_S_VS_BP*0.25+Gf2_VGP_S*0.0+Gf2_VS_BP*0.0+Gf2*0.0))-SP_S_w_VGP_S_VS_BP))));
#endif
SP_S_x1_VS_BP=((xg_VS_BP+Gf2_VS_BP*0.5)-((Gf_VS_BP*d00_sqrt0)+(Gf*((xg_VS_BP+Gf2_VS_BP*0.25)-SP_S_w_VS_BP)*d10_sqrt0)));
#if defined(_DERIVATE2)
  SP_S_x1_VS_BP_VD_S=(+(+xg_VS_BP_VD_S+(+Gf2_VS_BP_VD_S*0.5+Gf2_VS_BP*0.0+Gf2_VD_S*0.0+Gf2*0.0))-(+Gf_VS_BP_VD_S*d00_sqrt0+Gf_VS_BP*((xg_VD_S+(Gf2_VD_S*0.25))-SP_S_w_VD_S)*d10_sqrt0+Gf_VD_S*((xg_VS_BP+Gf2_VS_BP*0.25)-SP_S_w_VS_BP)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VD_S+(Gf2_VD_S*0.25))-SP_S_w_VD_S)*((xg_VS_BP+Gf2_VS_BP*0.25)-SP_S_w_VS_BP)+d10_sqrt0*(+(+xg_VS_BP_VD_S+(+Gf2_VS_BP_VD_S*0.25+Gf2_VS_BP*0.0+Gf2_VD_S*0.0+Gf2*0.0))-SP_S_w_VS_BP_VD_S))));
  SP_S_x1_VS_BP_VGP_S=(+(+xg_VS_BP_VGP_S+(+Gf2_VS_BP_VGP_S*0.5+Gf2_VS_BP*0.0+Gf2_VGP_S*0.0+Gf2*0.0))-(+Gf_VS_BP_VGP_S*d00_sqrt0+Gf_VS_BP*((xg_VGP_S+(Gf2_VGP_S*0.25))-SP_S_w_VGP_S)*d10_sqrt0+Gf_VGP_S*((xg_VS_BP+Gf2_VS_BP*0.25)-SP_S_w_VS_BP)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VGP_S+(Gf2_VGP_S*0.25))-SP_S_w_VGP_S)*((xg_VS_BP+Gf2_VS_BP*0.25)-SP_S_w_VS_BP)+d10_sqrt0*(+(+xg_VS_BP_VGP_S+(+Gf2_VS_BP_VGP_S*0.25+Gf2_VS_BP*0.0+Gf2_VGP_S*0.0+Gf2*0.0))-SP_S_w_VS_BP_VGP_S))));
  SP_S_x1_VS_BP_VS_BP=(+(+xg_VS_BP_VS_BP+(+Gf2_VS_BP_VS_BP*0.5+Gf2_VS_BP*0.0+Gf2_VS_BP*0.0+Gf2*0.0))-(+Gf_VS_BP_VS_BP*d00_sqrt0+Gf_VS_BP*((xg_VS_BP+(Gf2_VS_BP*0.25))-SP_S_w_VS_BP)*d10_sqrt0+Gf_VS_BP*((xg_VS_BP+Gf2_VS_BP*0.25)-SP_S_w_VS_BP)*d10_sqrt0+Gf*(m20_sqrt(((pInst->xg+(Gf2*0.25))-SP_S_w))*((xg_VS_BP+(Gf2_VS_BP*0.25))-SP_S_w_VS_BP)*((xg_VS_BP+Gf2_VS_BP*0.25)-SP_S_w_VS_BP)+d10_sqrt0*(+(+xg_VS_BP_VS_BP+(+Gf2_VS_BP_VS_BP*0.25+Gf2_VS_BP*0.0+Gf2_VS_BP*0.0+Gf2*0.0))-SP_S_w_VS_BP_VS_BP))));
#endif
#endif
SP_S_x1=((pInst->xg+(Gf2*0.5))-(Gf*d00_sqrt0));
EXIT_IF_ISNAN(((pInst->xg+(Gf2*0.5))-(Gf*d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_bx_VGP_S=0.0;
#if defined(_DERIVATE2)
  SP_S_bx_VGP_S_VGP_S=0.0;
  SP_S_bx_VGP_S_VD_S=0.0;
  SP_S_bx_VGP_S_VS_BP=0.0;
#endif
SP_S_bx_VD_S=xn_s_VD_S;
#if defined(_DERIVATE2)
  SP_S_bx_VD_S_VGP_S=(+0.0+0.0);
  SP_S_bx_VD_S_VD_S=(+xn_s_VD_S_VD_S+0.0);
  SP_S_bx_VD_S_VS_BP=(+xn_s_VD_S_VS_BP+0.0);
#endif
SP_S_bx_VS_BP=xn_s_VS_BP;
#if defined(_DERIVATE2)
  SP_S_bx_VS_BP_VGP_S=(+0.0+0.0);
  SP_S_bx_VS_BP_VD_S=(+xn_s_VS_BP_VD_S+0.0);
  SP_S_bx_VS_BP_VS_BP=(+xn_s_VS_BP_VS_BP+0.0);
#endif
#endif
SP_S_bx=(xn_s+3.0);
EXIT_IF_ISNAN((xn_s+3.0))
{
double m00_sqrt(d00_sqrt0,(((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))
double m00_sqrt(d00_sqrt1,((SP_S_bx*SP_S_bx)+5.0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))
double m10_sqrt(d10_sqrt1,d00_sqrt1,((SP_S_bx*SP_S_bx)+5.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_eta_VD_S=((0.5*((SP_S_x1_VD_S+SP_S_bx_VD_S)-(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))*d10_sqrt0))-(0.5*(SP_S_bx_VD_S-((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))*d10_sqrt1)));
#if defined(_DERIVATE2)
  SP_S_eta_VD_S_VD_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*d10_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VD_S_VD_S+SP_S_bx_VD_S_VD_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))+d10_sqrt0*(+(+(+SP_S_x1_VD_S_VD_S-SP_S_bx_VD_S_VD_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VD_S_VD_S-SP_S_bx_VD_S_VD_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VD_S-(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*d10_sqrt1)+0.0*(SP_S_bx_VD_S-((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))*d10_sqrt1)+0.5*(+SP_S_bx_VD_S_VD_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))+d10_sqrt1*(+(+SP_S_bx_VD_S_VD_S*SP_S_bx+SP_S_bx_VD_S*SP_S_bx_VD_S+SP_S_bx_VD_S*SP_S_bx_VD_S+SP_S_bx*SP_S_bx_VD_S_VD_S)+0.0)))));
  SP_S_eta_VD_S_VGP_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*d10_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VD_S_VGP_S+SP_S_bx_VD_S_VGP_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))+d10_sqrt0*(+(+(+SP_S_x1_VD_S_VGP_S-SP_S_bx_VD_S_VGP_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VD_S_VGP_S-SP_S_bx_VD_S_VGP_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VGP_S-(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*d10_sqrt1)+0.0*(SP_S_bx_VD_S-((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))*d10_sqrt1)+0.5*(+SP_S_bx_VD_S_VGP_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))+d10_sqrt1*(+(+SP_S_bx_VD_S_VGP_S*SP_S_bx+SP_S_bx_VD_S*SP_S_bx_VGP_S+SP_S_bx_VGP_S*SP_S_bx_VD_S+SP_S_bx*SP_S_bx_VD_S_VGP_S)+0.0)))));
  SP_S_eta_VD_S_VS_BP=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*d10_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VD_S_VS_BP+SP_S_bx_VD_S_VS_BP)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))+d10_sqrt0*(+(+(+SP_S_x1_VD_S_VS_BP-SP_S_bx_VD_S_VS_BP)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VD_S_VS_BP-SP_S_bx_VD_S_VS_BP))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VS_BP-(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*d10_sqrt1)+0.0*(SP_S_bx_VD_S-((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))*d10_sqrt1)+0.5*(+SP_S_bx_VD_S_VS_BP-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))+d10_sqrt1*(+(+SP_S_bx_VD_S_VS_BP*SP_S_bx+SP_S_bx_VD_S*SP_S_bx_VS_BP+SP_S_bx_VS_BP*SP_S_bx_VD_S+SP_S_bx*SP_S_bx_VD_S_VS_BP)+0.0)))));
#endif
SP_S_eta_VGP_S=((0.5*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))*d10_sqrt0))-(0.5*(SP_S_bx_VGP_S-((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))*d10_sqrt1)));
#if defined(_DERIVATE2)
  SP_S_eta_VGP_S_VD_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*d10_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VGP_S_VD_S+SP_S_bx_VGP_S_VD_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))+d10_sqrt0*(+(+(+SP_S_x1_VGP_S_VD_S-SP_S_bx_VGP_S_VD_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VGP_S_VD_S-SP_S_bx_VGP_S_VD_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VD_S-(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*d10_sqrt1)+0.0*(SP_S_bx_VGP_S-((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))*d10_sqrt1)+0.5*(+SP_S_bx_VGP_S_VD_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))+d10_sqrt1*(+(+SP_S_bx_VGP_S_VD_S*SP_S_bx+SP_S_bx_VGP_S*SP_S_bx_VD_S+SP_S_bx_VD_S*SP_S_bx_VGP_S+SP_S_bx*SP_S_bx_VGP_S_VD_S)+0.0)))));
  SP_S_eta_VGP_S_VGP_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*d10_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VGP_S_VGP_S+SP_S_bx_VGP_S_VGP_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))+d10_sqrt0*(+(+(+SP_S_x1_VGP_S_VGP_S-SP_S_bx_VGP_S_VGP_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VGP_S_VGP_S-SP_S_bx_VGP_S_VGP_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VGP_S-(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*d10_sqrt1)+0.0*(SP_S_bx_VGP_S-((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))*d10_sqrt1)+0.5*(+SP_S_bx_VGP_S_VGP_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))+d10_sqrt1*(+(+SP_S_bx_VGP_S_VGP_S*SP_S_bx+SP_S_bx_VGP_S*SP_S_bx_VGP_S+SP_S_bx_VGP_S*SP_S_bx_VGP_S+SP_S_bx*SP_S_bx_VGP_S_VGP_S)+0.0)))));
  SP_S_eta_VGP_S_VS_BP=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*d10_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VGP_S_VS_BP+SP_S_bx_VGP_S_VS_BP)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))+d10_sqrt0*(+(+(+SP_S_x1_VGP_S_VS_BP-SP_S_bx_VGP_S_VS_BP)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VGP_S_VS_BP-SP_S_bx_VGP_S_VS_BP))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VS_BP-(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*d10_sqrt1)+0.0*(SP_S_bx_VGP_S-((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))*d10_sqrt1)+0.5*(+SP_S_bx_VGP_S_VS_BP-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))+d10_sqrt1*(+(+SP_S_bx_VGP_S_VS_BP*SP_S_bx+SP_S_bx_VGP_S*SP_S_bx_VS_BP+SP_S_bx_VS_BP*SP_S_bx_VGP_S+SP_S_bx*SP_S_bx_VGP_S_VS_BP)+0.0)))));
#endif
SP_S_eta_VS_BP=((0.5*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))*d10_sqrt0))-(0.5*(SP_S_bx_VS_BP-((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))*d10_sqrt1)));
#if defined(_DERIVATE2)
  SP_S_eta_VS_BP_VD_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*d10_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VS_BP_VD_S+SP_S_bx_VS_BP_VD_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))+d10_sqrt0*(+(+(+SP_S_x1_VS_BP_VD_S-SP_S_bx_VS_BP_VD_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VS_BP_VD_S-SP_S_bx_VS_BP_VD_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VD_S-(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*d10_sqrt1)+0.0*(SP_S_bx_VS_BP-((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))*d10_sqrt1)+0.5*(+SP_S_bx_VS_BP_VD_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))+d10_sqrt1*(+(+SP_S_bx_VS_BP_VD_S*SP_S_bx+SP_S_bx_VS_BP*SP_S_bx_VD_S+SP_S_bx_VD_S*SP_S_bx_VS_BP+SP_S_bx*SP_S_bx_VS_BP_VD_S)+0.0)))));
  SP_S_eta_VS_BP_VGP_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*d10_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VS_BP_VGP_S+SP_S_bx_VS_BP_VGP_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))+d10_sqrt0*(+(+(+SP_S_x1_VS_BP_VGP_S-SP_S_bx_VS_BP_VGP_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VS_BP_VGP_S-SP_S_bx_VS_BP_VGP_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VGP_S-(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*d10_sqrt1)+0.0*(SP_S_bx_VS_BP-((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))*d10_sqrt1)+0.5*(+SP_S_bx_VS_BP_VGP_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))+d10_sqrt1*(+(+SP_S_bx_VS_BP_VGP_S*SP_S_bx+SP_S_bx_VS_BP*SP_S_bx_VGP_S+SP_S_bx_VGP_S*SP_S_bx_VS_BP+SP_S_bx*SP_S_bx_VS_BP_VGP_S)+0.0)))));
  SP_S_eta_VS_BP_VS_BP=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*d10_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VS_BP_VS_BP+SP_S_bx_VS_BP_VS_BP)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))+d10_sqrt0*(+(+(+SP_S_x1_VS_BP_VS_BP-SP_S_bx_VS_BP_VS_BP)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VS_BP_VS_BP-SP_S_bx_VS_BP_VS_BP))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VS_BP-(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*d10_sqrt1)+0.0*(SP_S_bx_VS_BP-((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))*d10_sqrt1)+0.5*(+SP_S_bx_VS_BP_VS_BP-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))+d10_sqrt1*(+(+SP_S_bx_VS_BP_VS_BP*SP_S_bx+SP_S_bx_VS_BP*SP_S_bx_VS_BP+SP_S_bx_VS_BP*SP_S_bx_VS_BP+SP_S_bx*SP_S_bx_VS_BP_VS_BP)+0.0)))));
#endif
#endif
SP_S_eta=((0.5*((SP_S_x1+SP_S_bx)-d00_sqrt0))-(0.5*(SP_S_bx-d00_sqrt1)));
EXIT_IF_ISNAN(((0.5*((SP_S_x1+SP_S_bx)-d00_sqrt0))-(0.5*(SP_S_bx-d00_sqrt1))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(xg_VD_S-SP_S_eta_VD_S);
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+xg_VD_S_VD_S-SP_S_eta_VD_S_VD_S);
  SP_S_temp_VD_S_VGP_S=(+xg_VD_S_VGP_S-SP_S_eta_VD_S_VGP_S);
  SP_S_temp_VD_S_VS_BP=(+xg_VD_S_VS_BP-SP_S_eta_VD_S_VS_BP);
#endif
SP_S_temp_VGP_S=(xg_VGP_S-SP_S_eta_VGP_S);
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+xg_VGP_S_VD_S-SP_S_eta_VGP_S_VD_S);
  SP_S_temp_VGP_S_VGP_S=(+xg_VGP_S_VGP_S-SP_S_eta_VGP_S_VGP_S);
  SP_S_temp_VGP_S_VS_BP=(+xg_VGP_S_VS_BP-SP_S_eta_VGP_S_VS_BP);
#endif
SP_S_temp_VS_BP=(xg_VS_BP-SP_S_eta_VS_BP);
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+xg_VS_BP_VD_S-SP_S_eta_VS_BP_VD_S);
  SP_S_temp_VS_BP_VGP_S=(+xg_VS_BP_VGP_S-SP_S_eta_VS_BP_VGP_S);
  SP_S_temp_VS_BP_VS_BP=(+xg_VS_BP_VS_BP-SP_S_eta_VS_BP_VS_BP);
#endif
#endif
SP_S_temp=(pInst->xg-SP_S_eta);
EXIT_IF_ISNAN((pInst->xg-SP_S_eta))
{
double m00_exp(d00_exp0,(-SP_S_eta))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp1_VD_S=(-SP_S_eta_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp1_VD_S_VD_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VD_S)*(-SP_S_eta_VD_S)+d10_exp0*0.0);
  SP_S_temp1_VD_S_VGP_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VGP_S)*(-SP_S_eta_VD_S)+d10_exp0*0.0);
  SP_S_temp1_VD_S_VS_BP=(m20_exp((-SP_S_eta))*(-SP_S_eta_VS_BP)*(-SP_S_eta_VD_S)+d10_exp0*0.0);
#endif
SP_S_temp1_VGP_S=(-SP_S_eta_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp1_VGP_S_VD_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VD_S)*(-SP_S_eta_VGP_S)+d10_exp0*0.0);
  SP_S_temp1_VGP_S_VGP_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VGP_S)*(-SP_S_eta_VGP_S)+d10_exp0*0.0);
  SP_S_temp1_VGP_S_VS_BP=(m20_exp((-SP_S_eta))*(-SP_S_eta_VS_BP)*(-SP_S_eta_VGP_S)+d10_exp0*0.0);
#endif
SP_S_temp1_VS_BP=(-SP_S_eta_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp1_VS_BP_VD_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VD_S)*(-SP_S_eta_VS_BP)+d10_exp0*0.0);
  SP_S_temp1_VS_BP_VGP_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VGP_S)*(-SP_S_eta_VS_BP)+d10_exp0*0.0);
  SP_S_temp1_VS_BP_VS_BP=(m20_exp((-SP_S_eta))*(-SP_S_eta_VS_BP)*(-SP_S_eta_VS_BP)+d10_exp0*0.0);
#endif
#endif
SP_S_temp1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp2_VD_S=(-((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#if defined(_DERIVATE2)
  SP_S_temp2_VD_S_VD_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))+0.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))+1.0*(+0.0+(+SP_S_eta_VD_S_VD_S*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VD_S_VGP_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))+0.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))+1.0*(+0.0+(+SP_S_eta_VD_S_VGP_S*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VD_S_VS_BP=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))+0.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))+1.0*(+0.0+(+SP_S_eta_VD_S_VS_BP*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#endif
SP_S_temp2_VGP_S=(-((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#if defined(_DERIVATE2)
  SP_S_temp2_VGP_S_VD_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))+0.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))+1.0*(+0.0+(+SP_S_eta_VGP_S_VD_S*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VGP_S_VGP_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))+0.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))+1.0*(+0.0+(+SP_S_eta_VGP_S_VGP_S*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VGP_S_VS_BP=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))+0.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))+1.0*(+0.0+(+SP_S_eta_VGP_S_VS_BP*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#endif
SP_S_temp2_VS_BP=(-((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#if defined(_DERIVATE2)
  SP_S_temp2_VS_BP_VD_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))+0.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))+1.0*(+0.0+(+SP_S_eta_VS_BP_VD_S*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VS_BP_VGP_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))+0.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))+1.0*(+0.0+(+SP_S_eta_VS_BP_VGP_S*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VS_BP_VS_BP=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))+0.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))+1.0*(+0.0+(+SP_S_eta_VS_BP_VS_BP*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#endif
#endif
SP_S_temp2=(1.0/(2.0+(SP_S_eta*SP_S_eta)));
EXIT_IF_ISNAN((1.0/(2.0+(SP_S_eta*SP_S_eta))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi0_VD_S=((((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_eta)*SP_S_temp2_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VD_S_VD_S=(+(+SP_S_eta_VD_S_VD_S*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VD_S)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VD_S_VD_S);
  SP_S_xi0_VD_S_VGP_S=(+(+SP_S_eta_VD_S_VGP_S*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VGP_S)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VD_S_VGP_S);
  SP_S_xi0_VD_S_VS_BP=(+(+SP_S_eta_VD_S_VS_BP*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VS_BP)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VD_S_VS_BP);
#endif
SP_S_xi0_VGP_S=((((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_eta)*SP_S_temp2_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VGP_S_VD_S=(+(+SP_S_eta_VGP_S_VD_S*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VD_S)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VGP_S_VD_S);
  SP_S_xi0_VGP_S_VGP_S=(+(+SP_S_eta_VGP_S_VGP_S*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VGP_S)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VGP_S_VGP_S);
  SP_S_xi0_VGP_S_VS_BP=(+(+SP_S_eta_VGP_S_VS_BP*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VS_BP)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VGP_S_VS_BP);
#endif
SP_S_xi0_VS_BP=((((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_eta)*SP_S_temp2_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi0_VS_BP_VD_S=(+(+SP_S_eta_VS_BP_VD_S*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VD_S)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_eta)*SP_S_temp2_VS_BP_VD_S);
  SP_S_xi0_VS_BP_VGP_S=(+(+SP_S_eta_VS_BP_VGP_S*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VGP_S)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_eta)*SP_S_temp2_VS_BP_VGP_S);
  SP_S_xi0_VS_BP_VS_BP=(+(+SP_S_eta_VS_BP_VS_BP*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VS_BP)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_eta)*SP_S_temp2_VS_BP_VS_BP);
#endif
#endif
SP_S_xi0=((SP_S_eta*SP_S_eta)*SP_S_temp2);
EXIT_IF_ISNAN(((SP_S_eta*SP_S_eta)*SP_S_temp2))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi1_VD_S=(4.0*((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VD_S_VD_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S)))+0.0*((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S))+4.0*(+(+SP_S_eta_VD_S_VD_S*SP_S_temp2+SP_S_eta_VD_S*SP_S_temp2_VD_S+SP_S_eta_VD_S*SP_S_temp2_VD_S+SP_S_eta*SP_S_temp2_VD_S_VD_S)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S_VD_S));
  SP_S_xi1_VD_S_VGP_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S)))+0.0*((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S))+4.0*(+(+SP_S_eta_VD_S_VGP_S*SP_S_temp2+SP_S_eta_VD_S*SP_S_temp2_VGP_S+SP_S_eta_VGP_S*SP_S_temp2_VD_S+SP_S_eta*SP_S_temp2_VD_S_VGP_S)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S_VGP_S));
  SP_S_xi1_VD_S_VS_BP=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP)))+0.0*((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S))+4.0*(+(+SP_S_eta_VD_S_VS_BP*SP_S_temp2+SP_S_eta_VD_S*SP_S_temp2_VS_BP+SP_S_eta_VS_BP*SP_S_temp2_VD_S+SP_S_eta*SP_S_temp2_VD_S_VS_BP)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S_VS_BP));
#endif
SP_S_xi1_VGP_S=(4.0*((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VGP_S_VD_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S)))+0.0*((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S))+4.0*(+(+SP_S_eta_VGP_S_VD_S*SP_S_temp2+SP_S_eta_VGP_S*SP_S_temp2_VD_S+SP_S_eta_VD_S*SP_S_temp2_VGP_S+SP_S_eta*SP_S_temp2_VGP_S_VD_S)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S_VD_S));
  SP_S_xi1_VGP_S_VGP_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S)))+0.0*((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S))+4.0*(+(+SP_S_eta_VGP_S_VGP_S*SP_S_temp2+SP_S_eta_VGP_S*SP_S_temp2_VGP_S+SP_S_eta_VGP_S*SP_S_temp2_VGP_S+SP_S_eta*SP_S_temp2_VGP_S_VGP_S)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S_VGP_S));
  SP_S_xi1_VGP_S_VS_BP=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP)))+0.0*((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S))+4.0*(+(+SP_S_eta_VGP_S_VS_BP*SP_S_temp2+SP_S_eta_VGP_S*SP_S_temp2_VS_BP+SP_S_eta_VS_BP*SP_S_temp2_VGP_S+SP_S_eta*SP_S_temp2_VGP_S_VS_BP)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S_VS_BP));
#endif
SP_S_xi1_VS_BP=(4.0*((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP)));
#if defined(_DERIVATE2)
  SP_S_xi1_VS_BP_VD_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S)))+0.0*((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP))+4.0*(+(+SP_S_eta_VS_BP_VD_S*SP_S_temp2+SP_S_eta_VS_BP*SP_S_temp2_VD_S+SP_S_eta_VD_S*SP_S_temp2_VS_BP+SP_S_eta*SP_S_temp2_VS_BP_VD_S)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP_VD_S));
  SP_S_xi1_VS_BP_VGP_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S)))+0.0*((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP))+4.0*(+(+SP_S_eta_VS_BP_VGP_S*SP_S_temp2+SP_S_eta_VS_BP*SP_S_temp2_VGP_S+SP_S_eta_VGP_S*SP_S_temp2_VS_BP+SP_S_eta*SP_S_temp2_VS_BP_VGP_S)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP_VGP_S));
  SP_S_xi1_VS_BP_VS_BP=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP)))+0.0*((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP))+4.0*(+(+SP_S_eta_VS_BP_VS_BP*SP_S_temp2+SP_S_eta_VS_BP*SP_S_temp2_VS_BP+SP_S_eta_VS_BP*SP_S_temp2_VS_BP+SP_S_eta*SP_S_temp2_VS_BP_VS_BP)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP_VS_BP));
#endif
#endif
SP_S_xi1=(4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
EXIT_IF_ISNAN((4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi2_VD_S=((((((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S))*SP_S_temp2)+((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VD_S_VD_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VD_S+0.0*SP_S_temp2_VD_S+8.0*SP_S_temp2_VD_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VD_S))*SP_S_temp2+((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2_VD_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S_VD_S)*SP_S_temp2+((((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S))*SP_S_temp2_VD_S+((((((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S)))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VD_S_VD_S);
  SP_S_xi2_VD_S_VGP_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VGP_S+0.0*SP_S_temp2_VD_S+8.0*SP_S_temp2_VD_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VGP_S))*SP_S_temp2+((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2_VD_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S_VGP_S)*SP_S_temp2+((((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S))*SP_S_temp2_VGP_S+((((((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S)))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VD_S_VGP_S);
  SP_S_xi2_VD_S_VS_BP=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VS_BP+0.0*SP_S_temp2_VD_S+8.0*SP_S_temp2_VD_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VS_BP))*SP_S_temp2+((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2_VD_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S_VS_BP)*SP_S_temp2+((((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S))*SP_S_temp2_VS_BP+((((((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP)))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VD_S_VS_BP);
#endif
SP_S_xi2_VGP_S=((((((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S))*SP_S_temp2)+((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VGP_S_VD_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VD_S+0.0*SP_S_temp2_VGP_S+8.0*SP_S_temp2_VGP_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VD_S))*SP_S_temp2+((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2_VGP_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S_VD_S)*SP_S_temp2+((((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S))*SP_S_temp2_VD_S+((((((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S)))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VGP_S_VD_S);
  SP_S_xi2_VGP_S_VGP_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VGP_S+0.0*SP_S_temp2_VGP_S+8.0*SP_S_temp2_VGP_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VGP_S))*SP_S_temp2+((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2_VGP_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S_VGP_S)*SP_S_temp2+((((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S))*SP_S_temp2_VGP_S+((((((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S)))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VGP_S_VGP_S);
  SP_S_xi2_VGP_S_VS_BP=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VS_BP+0.0*SP_S_temp2_VGP_S+8.0*SP_S_temp2_VGP_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VS_BP))*SP_S_temp2+((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2_VGP_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S_VS_BP)*SP_S_temp2+((((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S))*SP_S_temp2_VS_BP+((((((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP)))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VGP_S_VS_BP);
#endif
SP_S_xi2_VS_BP=((((((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP))*SP_S_temp2)+((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi2_VS_BP_VD_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VD_S+0.0*SP_S_temp2_VS_BP+8.0*SP_S_temp2_VS_BP_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VD_S))*SP_S_temp2+((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2_VS_BP+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP_VD_S)*SP_S_temp2+((((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP))*SP_S_temp2_VD_S+((((((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S)))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VS_BP_VD_S);
  SP_S_xi2_VS_BP_VGP_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VGP_S+0.0*SP_S_temp2_VS_BP+8.0*SP_S_temp2_VS_BP_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VGP_S))*SP_S_temp2+((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2_VS_BP+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP_VGP_S)*SP_S_temp2+((((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP))*SP_S_temp2_VGP_S+((((((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S)))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VS_BP_VGP_S);
  SP_S_xi2_VS_BP_VS_BP=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VS_BP+0.0*SP_S_temp2_VS_BP+8.0*SP_S_temp2_VS_BP_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VS_BP))*SP_S_temp2+((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2_VS_BP+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP_VS_BP)*SP_S_temp2+((((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP))*SP_S_temp2_VS_BP+((((((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP)))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VS_BP_VS_BP);
#endif
#endif
SP_S_xi2=((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
EXIT_IF_ISNAN(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2))
{
double m00_max(d00_max0,1.0e-40,((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))
#if defined(_DERIVATEFORDDX)
double m11_max(d11_max0,d00_max0,1.0e-40,((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_a_VD_S=(d11_max0*(((SP_S_temp_VD_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VD_S))-((Gf2_VD_S*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))+(Gf2*((SP_S_temp1_VD_S+SP_S_eta_VD_S)-((delta_ns_VD_S*((SP_S_eta+1.0)+SP_S_xi0))+(delta_ns*(SP_S_eta_VD_S+SP_S_xi0_VD_S))))))));
#if defined(_DERIVATE2)
  SP_S_a_VD_S_VD_S=fixme;
  SP_S_a_VD_S_VGP_S=fixme;
  SP_S_a_VD_S_VS_BP=fixme;
#endif
SP_S_a_VGP_S=(d11_max0*(((SP_S_temp_VGP_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VGP_S))-((Gf2_VGP_S*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))+(Gf2*((SP_S_temp1_VGP_S+SP_S_eta_VGP_S)-(delta_ns*(SP_S_eta_VGP_S+SP_S_xi0_VGP_S)))))));
#if defined(_DERIVATE2)
  SP_S_a_VGP_S_VD_S=fixme;
  SP_S_a_VGP_S_VGP_S=fixme;
  SP_S_a_VGP_S_VS_BP=fixme;
#endif
SP_S_a_VS_BP=(d11_max0*(((SP_S_temp_VS_BP*SP_S_temp)+(SP_S_temp*SP_S_temp_VS_BP))-((Gf2_VS_BP*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))+(Gf2*((SP_S_temp1_VS_BP+SP_S_eta_VS_BP)-((delta_ns_VS_BP*((SP_S_eta+1.0)+SP_S_xi0))+(delta_ns*(SP_S_eta_VS_BP+SP_S_xi0_VS_BP))))))));
#if defined(_DERIVATE2)
  SP_S_a_VS_BP_VD_S=fixme;
  SP_S_a_VS_BP_VGP_S=fixme;
  SP_S_a_VS_BP_VS_BP=fixme;
#endif
#endif
SP_S_a=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_b_VD_S=(-(0.5*((Gf2_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))))));
#if defined(_DERIVATE2)
  SP_S_b_VD_S_VD_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))))))+0.0*((Gf2_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))))+0.5*(+Gf2_VD_S_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VD_S*(SP_S_temp1_VD_S-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*(SP_S_temp1_VD_S-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+SP_S_temp1_VD_S_VD_S-(+delta_ns_VD_S_VD_S*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VD_S)))));
  SP_S_b_VD_S_VGP_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-((delta_ns*SP_S_xi2_VGP_S))))))+0.0*((Gf2_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))))+0.5*(+Gf2_VD_S_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VD_S*(SP_S_temp1_VGP_S-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*(SP_S_temp1_VD_S-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+SP_S_temp1_VD_S_VGP_S-(+0.0*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VGP_S)))));
  SP_S_b_VD_S_VS_BP=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))))))+0.0*((Gf2_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))))+0.5*(+Gf2_VD_S_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VD_S*(SP_S_temp1_VS_BP-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*(SP_S_temp1_VD_S-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+SP_S_temp1_VD_S_VS_BP-(+delta_ns_VD_S_VS_BP*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VS_BP)))));
#endif
SP_S_b_VGP_S=(-(0.5*((Gf2_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-(delta_ns*SP_S_xi2_VGP_S))))));
#if defined(_DERIVATE2)
  SP_S_b_VGP_S_VD_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))))))+0.0*((Gf2_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-(delta_ns*SP_S_xi2_VGP_S))))+0.5*(+Gf2_VGP_S_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VGP_S*(SP_S_temp1_VD_S-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*(SP_S_temp1_VGP_S-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+SP_S_temp1_VGP_S_VD_S-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VD_S)))));
  SP_S_b_VGP_S_VGP_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-((delta_ns*SP_S_xi2_VGP_S))))))+0.0*((Gf2_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-(delta_ns*SP_S_xi2_VGP_S))))+0.5*(+Gf2_VGP_S_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VGP_S*(SP_S_temp1_VGP_S-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*(SP_S_temp1_VGP_S-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+SP_S_temp1_VGP_S_VGP_S-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VGP_S)))));
  SP_S_b_VGP_S_VS_BP=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))))))+0.0*((Gf2_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-(delta_ns*SP_S_xi2_VGP_S))))+0.5*(+Gf2_VGP_S_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VGP_S*(SP_S_temp1_VS_BP-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*(SP_S_temp1_VGP_S-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+SP_S_temp1_VGP_S_VS_BP-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VS_BP)))));
#endif
SP_S_b_VS_BP=(-(0.5*((Gf2_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))))));
#if defined(_DERIVATE2)
  SP_S_b_VS_BP_VD_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))))))+0.0*((Gf2_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))))+0.5*(+Gf2_VS_BP_VD_S*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VS_BP*(SP_S_temp1_VD_S-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*(SP_S_temp1_VS_BP-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+SP_S_temp1_VS_BP_VD_S-(+delta_ns_VS_BP_VD_S*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VD_S)))));
  SP_S_b_VS_BP_VGP_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-((delta_ns*SP_S_xi2_VGP_S))))))+0.0*((Gf2_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))))+0.5*(+Gf2_VS_BP_VGP_S*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VS_BP*(SP_S_temp1_VGP_S-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*(SP_S_temp1_VS_BP-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+SP_S_temp1_VS_BP_VGP_S-(+0.0*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VGP_S)))));
  SP_S_b_VS_BP_VS_BP=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))+0.0*(((Gf2_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))))))+0.0*((Gf2_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))))+0.5*(+Gf2_VS_BP_VS_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))+Gf2_VS_BP*(SP_S_temp1_VS_BP-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*(SP_S_temp1_VS_BP-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+SP_S_temp1_VS_BP_VS_BP-(+delta_ns_VS_BP_VS_BP*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VS_BP)))));
#endif
#endif
SP_S_b=(1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));
EXIT_IF_ISNAN((1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_c_VD_S=((2.0*SP_S_temp_VD_S)+((Gf2_VD_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))+(Gf2*((-SP_S_temp1_VD_S)-((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S))))));
#if defined(_DERIVATE2)
  SP_S_c_VD_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VD_S)+(+Gf2_VD_S_VD_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VD_S*((-SP_S_temp1_VD_S)-(((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S))))+Gf2_VD_S*((-SP_S_temp1_VD_S)-((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S)))+Gf2*(+(+0.0-SP_S_temp1_VD_S_VD_S)-(+delta_ns_VD_S_VD_S*(1.0+SP_S_xi1)+delta_ns_VD_S*SP_S_xi1_VD_S+delta_ns_VD_S*SP_S_xi1_VD_S+delta_ns*(+0.0+SP_S_xi1_VD_S_VD_S)))));
  SP_S_c_VD_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VGP_S)+(+Gf2_VD_S_VGP_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VD_S*((-SP_S_temp1_VGP_S)-((delta_ns*SP_S_xi1_VGP_S)))+Gf2_VGP_S*((-SP_S_temp1_VD_S)-((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S)))+Gf2*(+(+0.0-SP_S_temp1_VD_S_VGP_S)-(+0.0*(1.0+SP_S_xi1)+delta_ns_VD_S*SP_S_xi1_VGP_S+0.0*SP_S_xi1_VD_S+delta_ns*(+0.0+SP_S_xi1_VD_S_VGP_S)))));
  SP_S_c_VD_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VS_BP)+(+Gf2_VD_S_VS_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VD_S*((-SP_S_temp1_VS_BP)-(((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP))))+Gf2_VS_BP*((-SP_S_temp1_VD_S)-((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S)))+Gf2*(+(+0.0-SP_S_temp1_VD_S_VS_BP)-(+delta_ns_VD_S_VS_BP*(1.0+SP_S_xi1)+delta_ns_VD_S*SP_S_xi1_VS_BP+delta_ns_VS_BP*SP_S_xi1_VD_S+delta_ns*(+0.0+SP_S_xi1_VD_S_VS_BP)))));
#endif
SP_S_c_VGP_S=((2.0*SP_S_temp_VGP_S)+((Gf2_VGP_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))+(Gf2*((-SP_S_temp1_VGP_S)-(delta_ns*SP_S_xi1_VGP_S)))));
#if defined(_DERIVATE2)
  SP_S_c_VGP_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VD_S)+(+Gf2_VGP_S_VD_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VGP_S*((-SP_S_temp1_VD_S)-(((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S))))+Gf2_VD_S*((-SP_S_temp1_VGP_S)-(delta_ns*SP_S_xi1_VGP_S))+Gf2*(+(+0.0-SP_S_temp1_VGP_S_VD_S)-(+0.0*(1.0+SP_S_xi1)+0.0*SP_S_xi1_VD_S+delta_ns_VD_S*SP_S_xi1_VGP_S+delta_ns*(+0.0+SP_S_xi1_VGP_S_VD_S)))));
  SP_S_c_VGP_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VGP_S)+(+Gf2_VGP_S_VGP_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VGP_S*((-SP_S_temp1_VGP_S)-((delta_ns*SP_S_xi1_VGP_S)))+Gf2_VGP_S*((-SP_S_temp1_VGP_S)-(delta_ns*SP_S_xi1_VGP_S))+Gf2*(+(+0.0-SP_S_temp1_VGP_S_VGP_S)-(+0.0*(1.0+SP_S_xi1)+0.0*SP_S_xi1_VGP_S+0.0*SP_S_xi1_VGP_S+delta_ns*(+0.0+SP_S_xi1_VGP_S_VGP_S)))));
  SP_S_c_VGP_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VS_BP)+(+Gf2_VGP_S_VS_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VGP_S*((-SP_S_temp1_VS_BP)-(((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP))))+Gf2_VS_BP*((-SP_S_temp1_VGP_S)-(delta_ns*SP_S_xi1_VGP_S))+Gf2*(+(+0.0-SP_S_temp1_VGP_S_VS_BP)-(+0.0*(1.0+SP_S_xi1)+0.0*SP_S_xi1_VS_BP+delta_ns_VS_BP*SP_S_xi1_VGP_S+delta_ns*(+0.0+SP_S_xi1_VGP_S_VS_BP)))));
#endif
SP_S_c_VS_BP=((2.0*SP_S_temp_VS_BP)+((Gf2_VS_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))+(Gf2*((-SP_S_temp1_VS_BP)-((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP))))));
#if defined(_DERIVATE2)
  SP_S_c_VS_BP_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VD_S)+(+Gf2_VS_BP_VD_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VS_BP*((-SP_S_temp1_VD_S)-(((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S))))+Gf2_VD_S*((-SP_S_temp1_VS_BP)-((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP)))+Gf2*(+(+0.0-SP_S_temp1_VS_BP_VD_S)-(+delta_ns_VS_BP_VD_S*(1.0+SP_S_xi1)+delta_ns_VS_BP*SP_S_xi1_VD_S+delta_ns_VD_S*SP_S_xi1_VS_BP+delta_ns*(+0.0+SP_S_xi1_VS_BP_VD_S)))));
  SP_S_c_VS_BP_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VGP_S)+(+Gf2_VS_BP_VGP_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VS_BP*((-SP_S_temp1_VGP_S)-((delta_ns*SP_S_xi1_VGP_S)))+Gf2_VGP_S*((-SP_S_temp1_VS_BP)-((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP)))+Gf2*(+(+0.0-SP_S_temp1_VS_BP_VGP_S)-(+0.0*(1.0+SP_S_xi1)+delta_ns_VS_BP*SP_S_xi1_VGP_S+0.0*SP_S_xi1_VS_BP+delta_ns*(+0.0+SP_S_xi1_VS_BP_VGP_S)))));
  SP_S_c_VS_BP_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VS_BP)+(+Gf2_VS_BP_VS_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VS_BP*((-SP_S_temp1_VS_BP)-(((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP))))+Gf2_VS_BP*((-SP_S_temp1_VS_BP)-((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP)))+Gf2*(+(+0.0-SP_S_temp1_VS_BP_VS_BP)-(+delta_ns_VS_BP_VS_BP*(1.0+SP_S_xi1)+delta_ns_VS_BP*SP_S_xi1_VS_BP+delta_ns_VS_BP*SP_S_xi1_VS_BP+delta_ns*(+0.0+SP_S_xi1_VS_BP_VS_BP)))));
#endif
#endif
SP_S_c=((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
EXIT_IF_ISNAN(((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1))))))
{
double m00_logE(d00_logE0,(SP_S_a/Gf2))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(SP_S_a/Gf2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_tau_VD_S=((xn_s_VD_S-SP_S_eta_VD_S)+((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VD_S_VD_S=(+(+xn_s_VD_S_VD_S-SP_S_eta_VD_S_VD_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VD_S_VD_S/Gf2-(SP_S_a_VD_S*Gf2_VD_S+SP_S_a_VD_S*Gf2_VD_S+SP_S_a*Gf2_VD_S_VD_S)/Gf2/Gf2+2*SP_S_a*Gf2_VD_S*Gf2_VD_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VD_S_VGP_S=(+(+0.0-SP_S_eta_VD_S_VGP_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VD_S_VGP_S/Gf2-(SP_S_a_VD_S*Gf2_VGP_S+SP_S_a_VGP_S*Gf2_VD_S+SP_S_a*Gf2_VD_S_VGP_S)/Gf2/Gf2+2*SP_S_a*Gf2_VD_S*Gf2_VGP_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VD_S_VS_BP=(+(+xn_s_VD_S_VS_BP-SP_S_eta_VD_S_VS_BP)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VD_S_VS_BP/Gf2-(SP_S_a_VD_S*Gf2_VS_BP+SP_S_a_VS_BP*Gf2_VD_S+SP_S_a*Gf2_VD_S_VS_BP)/Gf2/Gf2+2*SP_S_a*Gf2_VD_S*Gf2_VS_BP/Gf2/Gf2/Gf2)));
#endif
SP_S_tau_VGP_S=((-SP_S_eta_VGP_S)+((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VGP_S_VD_S=(+(+0.0-SP_S_eta_VGP_S_VD_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VGP_S_VD_S/Gf2-(SP_S_a_VGP_S*Gf2_VD_S+SP_S_a_VD_S*Gf2_VGP_S+SP_S_a*Gf2_VGP_S_VD_S)/Gf2/Gf2+2*SP_S_a*Gf2_VGP_S*Gf2_VD_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VGP_S_VGP_S=(+(+0.0-SP_S_eta_VGP_S_VGP_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VGP_S_VGP_S/Gf2-(SP_S_a_VGP_S*Gf2_VGP_S+SP_S_a_VGP_S*Gf2_VGP_S+SP_S_a*Gf2_VGP_S_VGP_S)/Gf2/Gf2+2*SP_S_a*Gf2_VGP_S*Gf2_VGP_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VGP_S_VS_BP=(+(+0.0-SP_S_eta_VGP_S_VS_BP)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VGP_S_VS_BP/Gf2-(SP_S_a_VGP_S*Gf2_VS_BP+SP_S_a_VS_BP*Gf2_VGP_S+SP_S_a*Gf2_VGP_S_VS_BP)/Gf2/Gf2+2*SP_S_a*Gf2_VGP_S*Gf2_VS_BP/Gf2/Gf2/Gf2)));
#endif
SP_S_tau_VS_BP=((xn_s_VS_BP-SP_S_eta_VS_BP)+((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VS_BP_VD_S=(+(+xn_s_VS_BP_VD_S-SP_S_eta_VS_BP_VD_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)+d10_logE0*(SP_S_a_VS_BP_VD_S/Gf2-(SP_S_a_VS_BP*Gf2_VD_S+SP_S_a_VD_S*Gf2_VS_BP+SP_S_a*Gf2_VS_BP_VD_S)/Gf2/Gf2+2*SP_S_a*Gf2_VS_BP*Gf2_VD_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VS_BP_VGP_S=(+(+0.0-SP_S_eta_VS_BP_VGP_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)+d10_logE0*(SP_S_a_VS_BP_VGP_S/Gf2-(SP_S_a_VS_BP*Gf2_VGP_S+SP_S_a_VGP_S*Gf2_VS_BP+SP_S_a*Gf2_VS_BP_VGP_S)/Gf2/Gf2+2*SP_S_a*Gf2_VS_BP*Gf2_VGP_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VS_BP_VS_BP=(+(+xn_s_VS_BP_VS_BP-SP_S_eta_VS_BP_VS_BP)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)+d10_logE0*(SP_S_a_VS_BP_VS_BP/Gf2-(SP_S_a_VS_BP*Gf2_VS_BP+SP_S_a_VS_BP*Gf2_VS_BP+SP_S_a*Gf2_VS_BP_VS_BP)/Gf2/Gf2+2*SP_S_a*Gf2_VS_BP*Gf2_VS_BP/Gf2/Gf2/Gf2)));
#endif
#endif
SP_S_tau=((xn_s-SP_S_eta)+d00_logE0);
EXIT_IF_ISNAN(((xn_s-SP_S_eta)+d00_logE0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
nu_VD_S=(SP_S_a_VD_S+SP_S_c_VD_S);
#if defined(_DERIVATE2)
  nu_VD_S_VD_S=(+SP_S_a_VD_S_VD_S+SP_S_c_VD_S_VD_S);
  nu_VD_S_VGP_S=(+SP_S_a_VD_S_VGP_S+SP_S_c_VD_S_VGP_S);
  nu_VD_S_VS_BP=(+SP_S_a_VD_S_VS_BP+SP_S_c_VD_S_VS_BP);
#endif
nu_VGP_S=(SP_S_a_VGP_S+SP_S_c_VGP_S);
#if defined(_DERIVATE2)
  nu_VGP_S_VD_S=(+SP_S_a_VGP_S_VD_S+SP_S_c_VGP_S_VD_S);
  nu_VGP_S_VGP_S=(+SP_S_a_VGP_S_VGP_S+SP_S_c_VGP_S_VGP_S);
  nu_VGP_S_VS_BP=(+SP_S_a_VGP_S_VS_BP+SP_S_c_VGP_S_VS_BP);
#endif
nu_VS_BP=(SP_S_a_VS_BP+SP_S_c_VS_BP);
#if defined(_DERIVATE2)
  nu_VS_BP_VD_S=(+SP_S_a_VS_BP_VD_S+SP_S_c_VS_BP_VD_S);
  nu_VS_BP_VGP_S=(+SP_S_a_VS_BP_VGP_S+SP_S_c_VS_BP_VGP_S);
  nu_VS_BP_VS_BP=(+SP_S_a_VS_BP_VS_BP+SP_S_c_VS_BP_VS_BP);
#endif
#endif
nu=(SP_S_a+SP_S_c);
EXIT_IF_ISNAN((SP_S_a+SP_S_c))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
mutau_VD_S=(((nu_VD_S*nu)+(nu*nu_VD_S))+((SP_S_tau_VD_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))+(SP_S_tau*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))));
#if defined(_DERIVATE2)
  mutau_VD_S_VD_S=(+(+nu_VD_S_VD_S*nu+nu_VD_S*nu_VD_S+nu_VD_S*nu_VD_S+nu*nu_VD_S_VD_S)+(+SP_S_tau_VD_S_VD_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+SP_S_tau_VD_S*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VD_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VD_S))-(+SP_S_a_VD_S_VD_S*SP_S_b+SP_S_a_VD_S*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VD_S))));
  mutau_VD_S_VGP_S=(+(+nu_VD_S_VGP_S*nu+nu_VD_S*nu_VGP_S+nu_VGP_S*nu_VD_S+nu*nu_VD_S_VGP_S)+(+SP_S_tau_VD_S_VGP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+SP_S_tau_VGP_S*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VGP_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VGP_S))-(+SP_S_a_VD_S_VGP_S*SP_S_b+SP_S_a_VD_S*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VGP_S))));
  mutau_VD_S_VS_BP=(+(+nu_VD_S_VS_BP*nu+nu_VD_S*nu_VS_BP+nu_VS_BP*nu_VD_S+nu*nu_VD_S_VS_BP)+(+SP_S_tau_VD_S_VS_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+SP_S_tau_VS_BP*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VS_BP*SP_S_c+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VS_BP))-(+SP_S_a_VD_S_VS_BP*SP_S_b+SP_S_a_VD_S*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VS_BP))));
#endif
mutau_VGP_S=(((nu_VGP_S*nu)+(nu*nu_VGP_S))+((SP_S_tau_VGP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))+(SP_S_tau*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))));
#if defined(_DERIVATE2)
  mutau_VGP_S_VD_S=(+(+nu_VGP_S_VD_S*nu+nu_VGP_S*nu_VD_S+nu_VD_S*nu_VGP_S+nu*nu_VGP_S_VD_S)+(+SP_S_tau_VGP_S_VD_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+SP_S_tau_VD_S*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VD_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VD_S))-(+SP_S_a_VGP_S_VD_S*SP_S_b+SP_S_a_VGP_S*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VD_S))));
  mutau_VGP_S_VGP_S=(+(+nu_VGP_S_VGP_S*nu+nu_VGP_S*nu_VGP_S+nu_VGP_S*nu_VGP_S+nu*nu_VGP_S_VGP_S)+(+SP_S_tau_VGP_S_VGP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+SP_S_tau_VGP_S*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VGP_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VGP_S))-(+SP_S_a_VGP_S_VGP_S*SP_S_b+SP_S_a_VGP_S*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VGP_S))));
  mutau_VGP_S_VS_BP=(+(+nu_VGP_S_VS_BP*nu+nu_VGP_S*nu_VS_BP+nu_VS_BP*nu_VGP_S+nu*nu_VGP_S_VS_BP)+(+SP_S_tau_VGP_S_VS_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+SP_S_tau_VS_BP*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VS_BP*SP_S_c+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VS_BP))-(+SP_S_a_VGP_S_VS_BP*SP_S_b+SP_S_a_VGP_S*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VS_BP))));
#endif
mutau_VS_BP=(((nu_VS_BP*nu)+(nu*nu_VS_BP))+((SP_S_tau_VS_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))+(SP_S_tau*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))));
#if defined(_DERIVATE2)
  mutau_VS_BP_VD_S=(+(+nu_VS_BP_VD_S*nu+nu_VS_BP*nu_VD_S+nu_VD_S*nu_VS_BP+nu*nu_VS_BP_VD_S)+(+SP_S_tau_VS_BP_VD_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+SP_S_tau_VD_S*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VD_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VD_S))-(+SP_S_a_VS_BP_VD_S*SP_S_b+SP_S_a_VS_BP*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VD_S))));
  mutau_VS_BP_VGP_S=(+(+nu_VS_BP_VGP_S*nu+nu_VS_BP*nu_VGP_S+nu_VGP_S*nu_VS_BP+nu*nu_VS_BP_VGP_S)+(+SP_S_tau_VS_BP_VGP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+SP_S_tau_VGP_S*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VGP_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VGP_S))-(+SP_S_a_VS_BP_VGP_S*SP_S_b+SP_S_a_VS_BP*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VGP_S))));
  mutau_VS_BP_VS_BP=(+(+nu_VS_BP_VS_BP*nu+nu_VS_BP*nu_VS_BP+nu_VS_BP*nu_VS_BP+nu*nu_VS_BP_VS_BP)+(+SP_S_tau_VS_BP_VS_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+SP_S_tau_VS_BP*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VS_BP*SP_S_c+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VS_BP))-(+SP_S_a_VS_BP_VS_BP*SP_S_b+SP_S_a_VS_BP*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VS_BP))));
#endif
#endif
mutau=((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
EXIT_IF_ISNAN(((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_x0_VD_S=(SP_S_eta_VD_S+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#if defined(_DERIVATE2)
  SP_S_x0_VD_S_VD_S=(+SP_S_eta_VD_S_VD_S+((+(+SP_S_a_VD_S_VD_S*nu+SP_S_a_VD_S*nu_VD_S+SP_S_a_VD_S*nu_VD_S+SP_S_a*nu_VD_S_VD_S)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VD_S+(+(+(+(+(nu_VD_S_VD_S/mutau-(nu_VD_S*mutau_VD_S+nu_VD_S*mutau_VD_S+nu*mutau_VD_S_VD_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VD_S)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VD_S)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VD_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VD_S)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VD_S_VD_S*SP_S_b+SP_S_a_VD_S*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VD_S_VGP_S=(+SP_S_eta_VD_S_VGP_S+((+(+SP_S_a_VD_S_VGP_S*nu+SP_S_a_VD_S*nu_VGP_S+SP_S_a_VGP_S*nu_VD_S+SP_S_a*nu_VD_S_VGP_S)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VGP_S+(+(+(+(+(nu_VD_S_VGP_S/mutau-(nu_VD_S*mutau_VGP_S+nu_VGP_S*mutau_VD_S+nu*mutau_VD_S_VGP_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VGP_S)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VGP_S)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VGP_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VGP_S)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VD_S_VGP_S*SP_S_b+SP_S_a_VD_S*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VD_S_VS_BP=(+SP_S_eta_VD_S_VS_BP+((+(+SP_S_a_VD_S_VS_BP*nu+SP_S_a_VD_S*nu_VS_BP+SP_S_a_VS_BP*nu_VD_S+SP_S_a*nu_VD_S_VS_BP)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VS_BP+(+(+(+(+(nu_VD_S_VS_BP/mutau-(nu_VD_S*mutau_VS_BP+nu_VS_BP*mutau_VD_S+nu*mutau_VD_S_VS_BP)/mutau/mutau+2*nu*mutau_VD_S*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VS_BP)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VS_BP)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VS_BP*SP_S_c+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VS_BP)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VD_S_VS_BP*SP_S_b+SP_S_a_VD_S*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#endif
SP_S_x0_VGP_S=(SP_S_eta_VGP_S+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#if defined(_DERIVATE2)
  SP_S_x0_VGP_S_VD_S=(+SP_S_eta_VGP_S_VD_S+((+(+SP_S_a_VGP_S_VD_S*nu+SP_S_a_VGP_S*nu_VD_S+SP_S_a_VD_S*nu_VGP_S+SP_S_a*nu_VGP_S_VD_S)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VD_S+(+(+(+(+(nu_VGP_S_VD_S/mutau-(nu_VGP_S*mutau_VD_S+nu_VD_S*mutau_VGP_S+nu*mutau_VGP_S_VD_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VD_S)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VD_S)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VD_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VD_S)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VGP_S_VD_S*SP_S_b+SP_S_a_VGP_S*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VGP_S_VGP_S=(+SP_S_eta_VGP_S_VGP_S+((+(+SP_S_a_VGP_S_VGP_S*nu+SP_S_a_VGP_S*nu_VGP_S+SP_S_a_VGP_S*nu_VGP_S+SP_S_a*nu_VGP_S_VGP_S)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VGP_S+(+(+(+(+(nu_VGP_S_VGP_S/mutau-(nu_VGP_S*mutau_VGP_S+nu_VGP_S*mutau_VGP_S+nu*mutau_VGP_S_VGP_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VGP_S)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VGP_S)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VGP_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VGP_S)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VGP_S_VGP_S*SP_S_b+SP_S_a_VGP_S*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VGP_S_VS_BP=(+SP_S_eta_VGP_S_VS_BP+((+(+SP_S_a_VGP_S_VS_BP*nu+SP_S_a_VGP_S*nu_VS_BP+SP_S_a_VS_BP*nu_VGP_S+SP_S_a*nu_VGP_S_VS_BP)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VS_BP+(+(+(+(+(nu_VGP_S_VS_BP/mutau-(nu_VGP_S*mutau_VS_BP+nu_VS_BP*mutau_VGP_S+nu*mutau_VGP_S_VS_BP)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VS_BP)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VS_BP)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VS_BP*SP_S_c+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VS_BP)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VGP_S_VS_BP*SP_S_b+SP_S_a_VGP_S*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#endif
SP_S_x0_VS_BP=(SP_S_eta_VS_BP+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#if defined(_DERIVATE2)
  SP_S_x0_VS_BP_VD_S=(+SP_S_eta_VS_BP_VD_S+((+(+SP_S_a_VS_BP_VD_S*nu+SP_S_a_VS_BP*nu_VD_S+SP_S_a_VD_S*nu_VS_BP+SP_S_a*nu_VS_BP_VD_S)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VD_S+(+(+(+(+(nu_VS_BP_VD_S/mutau-(nu_VS_BP*mutau_VD_S+nu_VD_S*mutau_VS_BP+nu*mutau_VS_BP_VD_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VD_S)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VD_S)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VD_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VD_S)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VS_BP_VD_S*SP_S_b+SP_S_a_VS_BP*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VS_BP_VGP_S=(+SP_S_eta_VS_BP_VGP_S+((+(+SP_S_a_VS_BP_VGP_S*nu+SP_S_a_VS_BP*nu_VGP_S+SP_S_a_VGP_S*nu_VS_BP+SP_S_a*nu_VS_BP_VGP_S)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VGP_S+(+(+(+(+(nu_VS_BP_VGP_S/mutau-(nu_VS_BP*mutau_VGP_S+nu_VGP_S*mutau_VS_BP+nu*mutau_VS_BP_VGP_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VGP_S)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VGP_S)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VGP_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VGP_S)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VS_BP_VGP_S*SP_S_b+SP_S_a_VS_BP*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VS_BP_VS_BP=(+SP_S_eta_VS_BP_VS_BP+((+(+SP_S_a_VS_BP_VS_BP*nu+SP_S_a_VS_BP*nu_VS_BP+SP_S_a_VS_BP*nu_VS_BP+SP_S_a*nu_VS_BP_VS_BP)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VS_BP+(+(+(+(+(nu_VS_BP_VS_BP/mutau-(nu_VS_BP*mutau_VS_BP+nu_VS_BP*mutau_VS_BP+nu*mutau_VS_BP_VS_BP)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VS_BP)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VS_BP)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VS_BP*SP_S_c+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VS_BP)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VS_BP_VS_BP*SP_S_b+SP_S_a_VS_BP*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#endif
#endif
SP_S_x0=(SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
EXIT_IF_ISNAN((SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))))
if
((SP_S_x0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,SP_S_x0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=SP_S_x0_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(m20_exp(SP_S_x0)*SP_S_x0_VD_S*SP_S_x0_VD_S+d10_exp0*SP_S_x0_VD_S_VD_S);
  SP_S_delta0_VD_S_VGP_S=(m20_exp(SP_S_x0)*SP_S_x0_VGP_S*SP_S_x0_VD_S+d10_exp0*SP_S_x0_VD_S_VGP_S);
  SP_S_delta0_VD_S_VS_BP=(m20_exp(SP_S_x0)*SP_S_x0_VS_BP*SP_S_x0_VD_S+d10_exp0*SP_S_x0_VD_S_VS_BP);
#endif
SP_S_delta0_VGP_S=SP_S_x0_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(m20_exp(SP_S_x0)*SP_S_x0_VD_S*SP_S_x0_VGP_S+d10_exp0*SP_S_x0_VGP_S_VD_S);
  SP_S_delta0_VGP_S_VGP_S=(m20_exp(SP_S_x0)*SP_S_x0_VGP_S*SP_S_x0_VGP_S+d10_exp0*SP_S_x0_VGP_S_VGP_S);
  SP_S_delta0_VGP_S_VS_BP=(m20_exp(SP_S_x0)*SP_S_x0_VS_BP*SP_S_x0_VGP_S+d10_exp0*SP_S_x0_VGP_S_VS_BP);
#endif
SP_S_delta0_VS_BP=SP_S_x0_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(m20_exp(SP_S_x0)*SP_S_x0_VD_S*SP_S_x0_VS_BP+d10_exp0*SP_S_x0_VS_BP_VD_S);
  SP_S_delta0_VS_BP_VGP_S=(m20_exp(SP_S_x0)*SP_S_x0_VGP_S*SP_S_x0_VS_BP+d10_exp0*SP_S_x0_VS_BP_VGP_S);
  SP_S_delta0_VS_BP_VS_BP=(m20_exp(SP_S_x0)*SP_S_x0_VS_BP*SP_S_x0_VS_BP+d10_exp0*SP_S_x0_VS_BP_VS_BP);
#endif
#endif
SP_S_delta0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta1_VD_S=(-SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VD_S_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VGP_S=(-SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VGP_S_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VS_BP=(-SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VS_BP_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
#endif
SP_S_delta1=(1.0/SP_S_delta0);
EXIT_IF_ISNAN((1.0/SP_S_delta0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=((delta_ns_VD_S*SP_S_delta0)+(delta_ns*SP_S_delta0_VD_S));
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(+delta_ns_VD_S_VD_S*SP_S_delta0+delta_ns_VD_S*SP_S_delta0_VD_S+delta_ns_VD_S*SP_S_delta0_VD_S+delta_ns*SP_S_delta0_VD_S_VD_S);
  SP_S_delta0_VD_S_VGP_S=(+0.0*SP_S_delta0+delta_ns_VD_S*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VD_S+delta_ns*SP_S_delta0_VD_S_VGP_S);
  SP_S_delta0_VD_S_VS_BP=(+delta_ns_VD_S_VS_BP*SP_S_delta0+delta_ns_VD_S*SP_S_delta0_VS_BP+delta_ns_VS_BP*SP_S_delta0_VD_S+delta_ns*SP_S_delta0_VD_S_VS_BP);
#endif
SP_S_delta0_VGP_S=(delta_ns*SP_S_delta0_VGP_S);
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(+0.0*SP_S_delta0+0.0*SP_S_delta0_VD_S+delta_ns_VD_S*SP_S_delta0_VGP_S+delta_ns*SP_S_delta0_VGP_S_VD_S);
  SP_S_delta0_VGP_S_VGP_S=(+0.0*SP_S_delta0+0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VGP_S+delta_ns*SP_S_delta0_VGP_S_VGP_S);
  SP_S_delta0_VGP_S_VS_BP=(+0.0*SP_S_delta0+0.0*SP_S_delta0_VS_BP+delta_ns_VS_BP*SP_S_delta0_VGP_S+delta_ns*SP_S_delta0_VGP_S_VS_BP);
#endif
SP_S_delta0_VS_BP=((delta_ns_VS_BP*SP_S_delta0)+(delta_ns*SP_S_delta0_VS_BP));
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(+delta_ns_VS_BP_VD_S*SP_S_delta0+delta_ns_VS_BP*SP_S_delta0_VD_S+delta_ns_VD_S*SP_S_delta0_VS_BP+delta_ns*SP_S_delta0_VS_BP_VD_S);
  SP_S_delta0_VS_BP_VGP_S=(+0.0*SP_S_delta0+delta_ns_VS_BP*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VS_BP+delta_ns*SP_S_delta0_VS_BP_VGP_S);
  SP_S_delta0_VS_BP_VS_BP=(+delta_ns_VS_BP_VS_BP*SP_S_delta0+delta_ns_VS_BP*SP_S_delta0_VS_BP+delta_ns_VS_BP*SP_S_delta0_VS_BP+delta_ns*SP_S_delta0_VS_BP_VS_BP);
#endif
#endif
SP_S_delta0=(delta_ns*SP_S_delta0);
EXIT_IF_ISNAN((delta_ns*SP_S_delta0))
}
else
{
if
((SP_S_x0>(xn_s-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(SP_S_x0-xn_s))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=(SP_S_x0_VD_S-xn_s_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(m20_exp((SP_S_x0-xn_s))*(SP_S_x0_VD_S-xn_s_VD_S)*(SP_S_x0_VD_S-xn_s_VD_S)+d10_exp0*(+SP_S_x0_VD_S_VD_S-xn_s_VD_S_VD_S));
  SP_S_delta0_VD_S_VGP_S=(m20_exp((SP_S_x0-xn_s))*SP_S_x0_VGP_S*(SP_S_x0_VD_S-xn_s_VD_S)+d10_exp0*(+SP_S_x0_VD_S_VGP_S-0.0));
  SP_S_delta0_VD_S_VS_BP=(m20_exp((SP_S_x0-xn_s))*(SP_S_x0_VS_BP-xn_s_VS_BP)*(SP_S_x0_VD_S-xn_s_VD_S)+d10_exp0*(+SP_S_x0_VD_S_VS_BP-xn_s_VD_S_VS_BP));
#endif
SP_S_delta0_VGP_S=SP_S_x0_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(m20_exp((SP_S_x0-xn_s))*(SP_S_x0_VD_S-xn_s_VD_S)*SP_S_x0_VGP_S+d10_exp0*(+SP_S_x0_VGP_S_VD_S-0.0));
  SP_S_delta0_VGP_S_VGP_S=(m20_exp((SP_S_x0-xn_s))*SP_S_x0_VGP_S*SP_S_x0_VGP_S+d10_exp0*(+SP_S_x0_VGP_S_VGP_S-0.0));
  SP_S_delta0_VGP_S_VS_BP=(m20_exp((SP_S_x0-xn_s))*(SP_S_x0_VS_BP-xn_s_VS_BP)*SP_S_x0_VGP_S+d10_exp0*(+SP_S_x0_VGP_S_VS_BP-0.0));
#endif
SP_S_delta0_VS_BP=(SP_S_x0_VS_BP-xn_s_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(m20_exp((SP_S_x0-xn_s))*(SP_S_x0_VD_S-xn_s_VD_S)*(SP_S_x0_VS_BP-xn_s_VS_BP)+d10_exp0*(+SP_S_x0_VS_BP_VD_S-xn_s_VS_BP_VD_S));
  SP_S_delta0_VS_BP_VGP_S=(m20_exp((SP_S_x0-xn_s))*SP_S_x0_VGP_S*(SP_S_x0_VS_BP-xn_s_VS_BP)+d10_exp0*(+SP_S_x0_VS_BP_VGP_S-0.0));
  SP_S_delta0_VS_BP_VS_BP=(m20_exp((SP_S_x0-xn_s))*(SP_S_x0_VS_BP-xn_s_VS_BP)*(SP_S_x0_VS_BP-xn_s_VS_BP)+d10_exp0*(+SP_S_x0_VS_BP_VS_BP-xn_s_VS_BP_VS_BP));
#endif
#endif
SP_S_delta0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta1_VD_S=((delta_ns_VD_S*SP_S_delta0-delta_ns*SP_S_delta0_VD_S)/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VD_S_VD_S=(delta_ns_VD_S_VD_S/SP_S_delta0-(delta_ns_VD_S*SP_S_delta0_VD_S+delta_ns_VD_S*SP_S_delta0_VD_S+delta_ns*SP_S_delta0_VD_S_VD_S)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VD_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VGP_S=(0.0/SP_S_delta0-(delta_ns_VD_S*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VD_S+delta_ns*SP_S_delta0_VD_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VD_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VS_BP=(delta_ns_VD_S_VS_BP/SP_S_delta0-(delta_ns_VD_S*SP_S_delta0_VS_BP+delta_ns_VS_BP*SP_S_delta0_VD_S+delta_ns*SP_S_delta0_VD_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VD_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VGP_S=(-delta_ns*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VGP_S_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+delta_ns_VD_S*SP_S_delta0_VGP_S+delta_ns*SP_S_delta0_VGP_S_VD_S)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VGP_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VGP_S+delta_ns*SP_S_delta0_VGP_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VGP_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+delta_ns_VS_BP*SP_S_delta0_VGP_S+delta_ns*SP_S_delta0_VGP_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VGP_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VS_BP=((delta_ns_VS_BP*SP_S_delta0-delta_ns*SP_S_delta0_VS_BP)/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VS_BP_VD_S=(delta_ns_VS_BP_VD_S/SP_S_delta0-(delta_ns_VS_BP*SP_S_delta0_VD_S+delta_ns_VD_S*SP_S_delta0_VS_BP+delta_ns*SP_S_delta0_VS_BP_VD_S)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VS_BP*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VGP_S=(0.0/SP_S_delta0-(delta_ns_VS_BP*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VS_BP+delta_ns*SP_S_delta0_VS_BP_VGP_S)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VS_BP*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VS_BP=(delta_ns_VS_BP_VS_BP/SP_S_delta0-(delta_ns_VS_BP*SP_S_delta0_VS_BP+delta_ns_VS_BP*SP_S_delta0_VS_BP+delta_ns*SP_S_delta0_VS_BP_VS_BP)/SP_S_delta0/SP_S_delta0+2*delta_ns*SP_S_delta0_VS_BP*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
#endif
SP_S_delta1=(delta_ns/SP_S_delta0);
EXIT_IF_ISNAN((delta_ns/SP_S_delta0))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=(-1.0e-100*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_s_VD_S_VD_S-SP_S_x0_VD_S_VD_S)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VD_S-SP_S_x0_VD_S)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))))+(xn_s_VD_S-SP_S_x0_VD_S)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_s_VD_S_VD_S-SP_S_x0_VD_S_VD_S)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VD_S-SP_S_x0_VD_S)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)+(xn_s_VD_S-SP_S_x0_VD_S)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_s_VD_S_VD_S-SP_S_x0_VD_S_VD_S)-0.0)*3.3333333333333333e-01+(xn_s_VD_S-SP_S_x0_VD_S)*0.0+(xn_s_VD_S-SP_S_x0_VD_S)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VD_S_VGP_S=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-SP_S_x0_VD_S_VGP_S)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VD_S-SP_S_x0_VD_S)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01))))))+(-SP_S_x0_VGP_S)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-SP_S_x0_VD_S_VGP_S)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VD_S-SP_S_x0_VD_S)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)+(-SP_S_x0_VGP_S)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-SP_S_x0_VD_S_VGP_S)-0.0)*3.3333333333333333e-01+(xn_s_VD_S-SP_S_x0_VD_S)*0.0+(-SP_S_x0_VGP_S)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))*((((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VD_S_VS_BP=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_s_VD_S_VS_BP-SP_S_x0_VD_S_VS_BP)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VD_S-SP_S_x0_VD_S)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))))+(xn_s_VS_BP-SP_S_x0_VS_BP)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_s_VD_S_VS_BP-SP_S_x0_VD_S_VS_BP)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VD_S-SP_S_x0_VD_S)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)+(xn_s_VS_BP-SP_S_x0_VS_BP)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_s_VD_S_VS_BP-SP_S_x0_VD_S_VS_BP)-0.0)*3.3333333333333333e-01+(xn_s_VD_S-SP_S_x0_VD_S)*0.0+(xn_s_VS_BP-SP_S_x0_VS_BP)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
SP_S_delta0_VGP_S=(-1.0e-100*(((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-SP_S_x0_VGP_S_VD_S)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-SP_S_x0_VGP_S)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))))+(xn_s_VD_S-SP_S_x0_VD_S)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))+0.0*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-SP_S_x0_VGP_S_VD_S)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-SP_S_x0_VGP_S)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)+(xn_s_VD_S-SP_S_x0_VD_S)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-SP_S_x0_VGP_S_VD_S)-0.0)*3.3333333333333333e-01+(-SP_S_x0_VGP_S)*0.0+(xn_s_VD_S-SP_S_x0_VD_S)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VGP_S_VGP_S=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-SP_S_x0_VGP_S_VGP_S)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-SP_S_x0_VGP_S)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01))))))+(-SP_S_x0_VGP_S)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01))))+0.0*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-SP_S_x0_VGP_S_VGP_S)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-SP_S_x0_VGP_S)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)+(-SP_S_x0_VGP_S)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-SP_S_x0_VGP_S_VGP_S)-0.0)*3.3333333333333333e-01+(-SP_S_x0_VGP_S)*0.0+(-SP_S_x0_VGP_S)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))*((((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VGP_S_VS_BP=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-SP_S_x0_VGP_S_VS_BP)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-SP_S_x0_VGP_S)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))))+(xn_s_VS_BP-SP_S_x0_VS_BP)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))+0.0*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-SP_S_x0_VGP_S_VS_BP)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-SP_S_x0_VGP_S)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)+(xn_s_VS_BP-SP_S_x0_VS_BP)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-SP_S_x0_VGP_S_VS_BP)-0.0)*3.3333333333333333e-01+(-SP_S_x0_VGP_S)*0.0+(xn_s_VS_BP-SP_S_x0_VS_BP)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
SP_S_delta0_VS_BP=(-1.0e-100*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_s_VS_BP_VD_S-SP_S_x0_VS_BP_VD_S)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VS_BP-SP_S_x0_VS_BP)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))))+(xn_s_VD_S-SP_S_x0_VD_S)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_s_VS_BP_VD_S-SP_S_x0_VS_BP_VD_S)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VS_BP-SP_S_x0_VS_BP)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)+(xn_s_VD_S-SP_S_x0_VD_S)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_s_VS_BP_VD_S-SP_S_x0_VS_BP_VD_S)-0.0)*3.3333333333333333e-01+(xn_s_VS_BP-SP_S_x0_VS_BP)*0.0+(xn_s_VD_S-SP_S_x0_VD_S)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VS_BP_VGP_S=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-SP_S_x0_VS_BP_VGP_S)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VS_BP-SP_S_x0_VS_BP)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01))))))+(-SP_S_x0_VGP_S)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+0.0-SP_S_x0_VS_BP_VGP_S)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VS_BP-SP_S_x0_VS_BP)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)+(-SP_S_x0_VGP_S)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-SP_S_x0_VS_BP_VGP_S)-0.0)*3.3333333333333333e-01+(xn_s_VS_BP-SP_S_x0_VS_BP)*0.0+(-SP_S_x0_VGP_S)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))*((((-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((-SP_S_x0_VGP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VS_BP_VS_BP=(0.0/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_s_VS_BP_VS_BP-SP_S_x0_VS_BP_VS_BP)-0.0)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VS_BP-SP_S_x0_VS_BP)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))))+(xn_s_VS_BP-SP_S_x0_VS_BP)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_s_VS_BP_VS_BP-SP_S_x0_VS_BP_VS_BP)-0.0)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VS_BP-SP_S_x0_VS_BP)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)+(xn_s_VS_BP-SP_S_x0_VS_BP)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01+((xn_s-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_s_VS_BP_VS_BP-SP_S_x0_VS_BP_VS_BP)-0.0)*3.3333333333333333e-01+(xn_s_VS_BP-SP_S_x0_VS_BP)*0.0+(xn_s_VS_BP-SP_S_x0_VS_BP)*0.0+((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*((xn_s_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
#endif
SP_S_delta0=(1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta1_VD_S=(-1.0e-100*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta1_VD_S_VD_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VD_S_VD_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VD_S*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))))+SP_S_x0_VD_S*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VD_S_VD_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VD_S*(SP_S_x0_VD_S*3.3333333333333333e-01)+SP_S_x0_VD_S*SP_S_x0_VD_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VD_S_VD_S-0.0)*3.3333333333333333e-01+SP_S_x0_VD_S*0.0+SP_S_x0_VD_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VD_S_VGP_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VD_S_VGP_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VD_S*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))))+SP_S_x0_VGP_S*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VD_S_VGP_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VD_S*(SP_S_x0_VGP_S*3.3333333333333333e-01)+SP_S_x0_VGP_S*SP_S_x0_VD_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VD_S_VGP_S-0.0)*3.3333333333333333e-01+SP_S_x0_VD_S*0.0+SP_S_x0_VGP_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VD_S_VS_BP=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VD_S_VS_BP-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VD_S*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))))+SP_S_x0_VS_BP*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VD_S_VS_BP-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VD_S*(SP_S_x0_VS_BP*3.3333333333333333e-01)+SP_S_x0_VS_BP*SP_S_x0_VD_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VD_S_VS_BP-0.0)*3.3333333333333333e-01+SP_S_x0_VD_S*0.0+SP_S_x0_VS_BP*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
SP_S_delta1_VGP_S=(-1.0e-100*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta1_VGP_S_VD_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VGP_S_VD_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VGP_S*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))))+SP_S_x0_VD_S*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VGP_S_VD_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VGP_S*(SP_S_x0_VD_S*3.3333333333333333e-01)+SP_S_x0_VD_S*SP_S_x0_VGP_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VGP_S_VD_S-0.0)*3.3333333333333333e-01+SP_S_x0_VGP_S*0.0+SP_S_x0_VD_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VGP_S_VGP_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VGP_S_VGP_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VGP_S*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))))+SP_S_x0_VGP_S*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VGP_S_VGP_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VGP_S*(SP_S_x0_VGP_S*3.3333333333333333e-01)+SP_S_x0_VGP_S*SP_S_x0_VGP_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+SP_S_x0_VGP_S*0.0+SP_S_x0_VGP_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VGP_S_VS_BP=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VGP_S_VS_BP-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VGP_S*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))))+SP_S_x0_VS_BP*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VGP_S_VS_BP-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VGP_S*(SP_S_x0_VS_BP*3.3333333333333333e-01)+SP_S_x0_VS_BP*SP_S_x0_VGP_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+SP_S_x0_VGP_S*0.0+SP_S_x0_VS_BP*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
SP_S_delta1_VS_BP=(-1.0e-100*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta1_VS_BP_VD_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VS_BP_VD_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VS_BP*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))))+SP_S_x0_VD_S*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VS_BP_VD_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VS_BP*(SP_S_x0_VD_S*3.3333333333333333e-01)+SP_S_x0_VD_S*SP_S_x0_VS_BP*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VS_BP_VD_S-0.0)*3.3333333333333333e-01+SP_S_x0_VS_BP*0.0+SP_S_x0_VD_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VS_BP_VGP_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VS_BP_VGP_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VS_BP*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))))+SP_S_x0_VGP_S*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VS_BP_VGP_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VS_BP*(SP_S_x0_VGP_S*3.3333333333333333e-01)+SP_S_x0_VGP_S*SP_S_x0_VS_BP*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+SP_S_x0_VS_BP*0.0+SP_S_x0_VGP_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VS_BP_VS_BP=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VS_BP_VS_BP-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VS_BP*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))))+SP_S_x0_VS_BP*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VS_BP_VS_BP-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VS_BP*(SP_S_x0_VS_BP*3.3333333333333333e-01)+SP_S_x0_VS_BP*SP_S_x0_VS_BP*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+SP_S_x0_VS_BP*0.0+SP_S_x0_VS_BP*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
#endif
SP_S_delta1=(1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(-((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))+0.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))+1.0*(+0.0+(+SP_S_x0_VD_S_VD_S*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VD_S_VGP_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))+0.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))+1.0*(+0.0+(+SP_S_x0_VD_S_VGP_S*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VD_S_VS_BP=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))+0.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))+1.0*(+0.0+(+SP_S_x0_VD_S_VS_BP*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#endif
SP_S_temp_VGP_S=(-((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))+0.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))+1.0*(+0.0+(+SP_S_x0_VGP_S_VD_S*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VGP_S_VGP_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))+0.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))+1.0*(+0.0+(+SP_S_x0_VGP_S_VGP_S*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VGP_S_VS_BP=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))+0.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))+1.0*(+0.0+(+SP_S_x0_VGP_S_VS_BP*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#endif
SP_S_temp_VS_BP=(-((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))+0.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))+1.0*(+0.0+(+SP_S_x0_VS_BP_VD_S*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VS_BP_VGP_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))+0.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))+1.0*(+0.0+(+SP_S_x0_VS_BP_VGP_S*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VS_BP_VS_BP=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))+0.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))+1.0*(+0.0+(+SP_S_x0_VS_BP_VS_BP*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#endif
#endif
SP_S_temp=(1.0/(2.0+(SP_S_x0*SP_S_x0)));
EXIT_IF_ISNAN((1.0/(2.0+(SP_S_x0*SP_S_x0))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi0_VD_S=((((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_x0)*SP_S_temp_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VD_S_VD_S=(+(+SP_S_x0_VD_S_VD_S*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VD_S)*SP_S_temp+((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VD_S_VD_S);
  SP_S_xi0_VD_S_VGP_S=(+(+SP_S_x0_VD_S_VGP_S*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VGP_S)*SP_S_temp+((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VD_S_VGP_S);
  SP_S_xi0_VD_S_VS_BP=(+(+SP_S_x0_VD_S_VS_BP*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VS_BP)*SP_S_temp+((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VD_S_VS_BP);
#endif
SP_S_xi0_VGP_S=((((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_x0)*SP_S_temp_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VGP_S_VD_S=(+(+SP_S_x0_VGP_S_VD_S*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VD_S)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VGP_S_VD_S);
  SP_S_xi0_VGP_S_VGP_S=(+(+SP_S_x0_VGP_S_VGP_S*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VGP_S)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VGP_S_VGP_S);
  SP_S_xi0_VGP_S_VS_BP=(+(+SP_S_x0_VGP_S_VS_BP*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VS_BP)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VGP_S_VS_BP);
#endif
SP_S_xi0_VS_BP=((((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_x0)*SP_S_temp_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi0_VS_BP_VD_S=(+(+SP_S_x0_VS_BP_VD_S*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VD_S)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_x0)*SP_S_temp_VS_BP_VD_S);
  SP_S_xi0_VS_BP_VGP_S=(+(+SP_S_x0_VS_BP_VGP_S*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VGP_S)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_x0)*SP_S_temp_VS_BP_VGP_S);
  SP_S_xi0_VS_BP_VS_BP=(+(+SP_S_x0_VS_BP_VS_BP*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VS_BP)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_x0)*SP_S_temp_VS_BP_VS_BP);
#endif
#endif
SP_S_xi0=((SP_S_x0*SP_S_x0)*SP_S_temp);
EXIT_IF_ISNAN(((SP_S_x0*SP_S_x0)*SP_S_temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi1_VD_S=(4.0*((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VD_S_VD_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_x0_VD_S_VD_S*SP_S_temp+SP_S_x0_VD_S*SP_S_temp_VD_S+SP_S_x0_VD_S*SP_S_temp_VD_S+SP_S_x0*SP_S_temp_VD_S_VD_S)*SP_S_temp+((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VD_S_VD_S));
  SP_S_xi1_VD_S_VGP_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_x0_VD_S_VGP_S*SP_S_temp+SP_S_x0_VD_S*SP_S_temp_VGP_S+SP_S_x0_VGP_S*SP_S_temp_VD_S+SP_S_x0*SP_S_temp_VD_S_VGP_S)*SP_S_temp+((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VD_S_VGP_S));
  SP_S_xi1_VD_S_VS_BP=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_x0_VD_S_VS_BP*SP_S_temp+SP_S_x0_VD_S*SP_S_temp_VS_BP+SP_S_x0_VS_BP*SP_S_temp_VD_S+SP_S_x0*SP_S_temp_VD_S_VS_BP)*SP_S_temp+((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VD_S_VS_BP));
#endif
SP_S_xi1_VGP_S=(4.0*((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VGP_S_VD_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_x0_VGP_S_VD_S*SP_S_temp+SP_S_x0_VGP_S*SP_S_temp_VD_S+SP_S_x0_VD_S*SP_S_temp_VGP_S+SP_S_x0*SP_S_temp_VGP_S_VD_S)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S_VD_S));
  SP_S_xi1_VGP_S_VGP_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_x0_VGP_S_VGP_S*SP_S_temp+SP_S_x0_VGP_S*SP_S_temp_VGP_S+SP_S_x0_VGP_S*SP_S_temp_VGP_S+SP_S_x0*SP_S_temp_VGP_S_VGP_S)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S_VGP_S));
  SP_S_xi1_VGP_S_VS_BP=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_x0_VGP_S_VS_BP*SP_S_temp+SP_S_x0_VGP_S*SP_S_temp_VS_BP+SP_S_x0_VS_BP*SP_S_temp_VGP_S+SP_S_x0*SP_S_temp_VGP_S_VS_BP)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S_VS_BP));
#endif
SP_S_xi1_VS_BP=(4.0*((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP)));
#if defined(_DERIVATE2)
  SP_S_xi1_VS_BP_VD_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_x0_VS_BP_VD_S*SP_S_temp+SP_S_x0_VS_BP*SP_S_temp_VD_S+SP_S_x0_VD_S*SP_S_temp_VS_BP+SP_S_x0*SP_S_temp_VS_BP_VD_S)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP_VD_S));
  SP_S_xi1_VS_BP_VGP_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_x0_VS_BP_VGP_S*SP_S_temp+SP_S_x0_VS_BP*SP_S_temp_VGP_S+SP_S_x0_VGP_S*SP_S_temp_VS_BP+SP_S_x0*SP_S_temp_VS_BP_VGP_S)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP_VGP_S));
  SP_S_xi1_VS_BP_VS_BP=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_x0_VS_BP_VS_BP*SP_S_temp+SP_S_x0_VS_BP*SP_S_temp_VS_BP+SP_S_x0_VS_BP*SP_S_temp_VS_BP+SP_S_x0*SP_S_temp_VS_BP_VS_BP)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP_VS_BP));
#endif
#endif
SP_S_xi1=(4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
EXIT_IF_ISNAN((4.0*((SP_S_x0*SP_S_temp)*SP_S_temp)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi2_VD_S=((((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VD_S_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VD_S))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VD_S);
  SP_S_xi2_VD_S_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VGP_S);
  SP_S_xi2_VD_S_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VS_BP);
#endif
SP_S_xi2_VGP_S=((((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VGP_S_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VD_S))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VD_S);
  SP_S_xi2_VGP_S_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VGP_S);
  SP_S_xi2_VGP_S_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VS_BP);
#endif
SP_S_xi2_VS_BP=((((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi2_VS_BP_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VD_S))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VD_S);
  SP_S_xi2_VS_BP_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VGP_S);
  SP_S_xi2_VS_BP_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VS_BP);
#endif
#endif
SP_S_xi2=((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
EXIT_IF_ISNAN(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(xg_VD_S-SP_S_x0_VD_S);
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+xg_VD_S_VD_S-SP_S_x0_VD_S_VD_S);
  SP_S_temp_VD_S_VGP_S=(+xg_VD_S_VGP_S-SP_S_x0_VD_S_VGP_S);
  SP_S_temp_VD_S_VS_BP=(+xg_VD_S_VS_BP-SP_S_x0_VD_S_VS_BP);
#endif
SP_S_temp_VGP_S=(xg_VGP_S-SP_S_x0_VGP_S);
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+xg_VGP_S_VD_S-SP_S_x0_VGP_S_VD_S);
  SP_S_temp_VGP_S_VGP_S=(+xg_VGP_S_VGP_S-SP_S_x0_VGP_S_VGP_S);
  SP_S_temp_VGP_S_VS_BP=(+xg_VGP_S_VS_BP-SP_S_x0_VGP_S_VS_BP);
#endif
SP_S_temp_VS_BP=(xg_VS_BP-SP_S_x0_VS_BP);
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+xg_VS_BP_VD_S-SP_S_x0_VS_BP_VD_S);
  SP_S_temp_VS_BP_VGP_S=(+xg_VS_BP_VGP_S-SP_S_x0_VS_BP_VGP_S);
  SP_S_temp_VS_BP_VS_BP=(+xg_VS_BP_VS_BP-SP_S_x0_VS_BP_VS_BP);
#endif
#endif
SP_S_temp=(pInst->xg-SP_S_x0);
EXIT_IF_ISNAN((pInst->xg-SP_S_x0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_pC_VD_S=((2.0*SP_S_temp_VD_S)+((Gf2_VD_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))+(Gf2*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S))))));
#if defined(_DERIVATE2)
  SP_S_pC_VD_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VD_S)+(+Gf2_VD_S_VD_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VD_S*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-(((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S))))+Gf2_VD_S*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VD_S_VD_S)+SP_S_delta0_VD_S_VD_S)-(+delta_ns_VD_S_VD_S*(1.0+SP_S_xi1)+delta_ns_VD_S*SP_S_xi1_VD_S+delta_ns_VD_S*SP_S_xi1_VD_S+delta_ns*(+0.0+SP_S_xi1_VD_S_VD_S)))));
  SP_S_pC_VD_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VGP_S)+(+Gf2_VD_S_VGP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VD_S*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-((delta_ns*SP_S_xi1_VGP_S)))+Gf2_VGP_S*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VD_S_VGP_S)+SP_S_delta0_VD_S_VGP_S)-(+0.0*(1.0+SP_S_xi1)+delta_ns_VD_S*SP_S_xi1_VGP_S+0.0*SP_S_xi1_VD_S+delta_ns*(+0.0+SP_S_xi1_VD_S_VGP_S)))));
  SP_S_pC_VD_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VS_BP)+(+Gf2_VD_S_VS_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VD_S*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP))))+Gf2_VS_BP*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VD_S_VS_BP)+SP_S_delta0_VD_S_VS_BP)-(+delta_ns_VD_S_VS_BP*(1.0+SP_S_xi1)+delta_ns_VD_S*SP_S_xi1_VS_BP+delta_ns_VS_BP*SP_S_xi1_VD_S+delta_ns*(+0.0+SP_S_xi1_VD_S_VS_BP)))));
#endif
SP_S_pC_VGP_S=((2.0*SP_S_temp_VGP_S)+((Gf2_VGP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))+(Gf2*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-(delta_ns*SP_S_xi1_VGP_S)))));
#if defined(_DERIVATE2)
  SP_S_pC_VGP_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VD_S)+(+Gf2_VGP_S_VD_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VGP_S*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-(((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S))))+Gf2_VD_S*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-(delta_ns*SP_S_xi1_VGP_S))+Gf2*(+(+(+0.0-SP_S_delta1_VGP_S_VD_S)+SP_S_delta0_VGP_S_VD_S)-(+0.0*(1.0+SP_S_xi1)+0.0*SP_S_xi1_VD_S+delta_ns_VD_S*SP_S_xi1_VGP_S+delta_ns*(+0.0+SP_S_xi1_VGP_S_VD_S)))));
  SP_S_pC_VGP_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VGP_S)+(+Gf2_VGP_S_VGP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VGP_S*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-((delta_ns*SP_S_xi1_VGP_S)))+Gf2_VGP_S*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-(delta_ns*SP_S_xi1_VGP_S))+Gf2*(+(+(+0.0-SP_S_delta1_VGP_S_VGP_S)+SP_S_delta0_VGP_S_VGP_S)-(+0.0*(1.0+SP_S_xi1)+0.0*SP_S_xi1_VGP_S+0.0*SP_S_xi1_VGP_S+delta_ns*(+0.0+SP_S_xi1_VGP_S_VGP_S)))));
  SP_S_pC_VGP_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VS_BP)+(+Gf2_VGP_S_VS_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VGP_S*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP))))+Gf2_VS_BP*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-(delta_ns*SP_S_xi1_VGP_S))+Gf2*(+(+(+0.0-SP_S_delta1_VGP_S_VS_BP)+SP_S_delta0_VGP_S_VS_BP)-(+0.0*(1.0+SP_S_xi1)+0.0*SP_S_xi1_VS_BP+delta_ns_VS_BP*SP_S_xi1_VGP_S+delta_ns*(+0.0+SP_S_xi1_VGP_S_VS_BP)))));
#endif
SP_S_pC_VS_BP=((2.0*SP_S_temp_VS_BP)+((Gf2_VS_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))+(Gf2*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP))))));
#if defined(_DERIVATE2)
  SP_S_pC_VS_BP_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VD_S)+(+Gf2_VS_BP_VD_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VS_BP*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-(((delta_ns_VD_S*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VD_S))))+Gf2_VD_S*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP)))+Gf2*(+(+(+0.0-SP_S_delta1_VS_BP_VD_S)+SP_S_delta0_VS_BP_VD_S)-(+delta_ns_VS_BP_VD_S*(1.0+SP_S_xi1)+delta_ns_VS_BP*SP_S_xi1_VD_S+delta_ns_VD_S*SP_S_xi1_VS_BP+delta_ns*(+0.0+SP_S_xi1_VS_BP_VD_S)))));
  SP_S_pC_VS_BP_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VGP_S)+(+Gf2_VS_BP_VGP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VS_BP*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-((delta_ns*SP_S_xi1_VGP_S)))+Gf2_VGP_S*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP)))+Gf2*(+(+(+0.0-SP_S_delta1_VS_BP_VGP_S)+SP_S_delta0_VS_BP_VGP_S)-(+0.0*(1.0+SP_S_xi1)+delta_ns_VS_BP*SP_S_xi1_VGP_S+0.0*SP_S_xi1_VS_BP+delta_ns*(+0.0+SP_S_xi1_VS_BP_VGP_S)))));
  SP_S_pC_VS_BP_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VS_BP)+(+Gf2_VS_BP_VS_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))+Gf2_VS_BP*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP))))+Gf2_VS_BP*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*(1.0+SP_S_xi1))+(delta_ns*SP_S_xi1_VS_BP)))+Gf2*(+(+(+0.0-SP_S_delta1_VS_BP_VS_BP)+SP_S_delta0_VS_BP_VS_BP)-(+delta_ns_VS_BP_VS_BP*(1.0+SP_S_xi1)+delta_ns_VS_BP*SP_S_xi1_VS_BP+delta_ns_VS_BP*SP_S_xi1_VS_BP+delta_ns*(+0.0+SP_S_xi1_VS_BP_VS_BP)))));
#endif
#endif
SP_S_pC=((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
EXIT_IF_ISNAN(((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_qC_VD_S=(((SP_S_temp_VD_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VD_S))-((Gf2_VD_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))+(Gf2*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-((delta_ns_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VD_S+SP_S_xi0_VD_S)))))));
#if defined(_DERIVATE2)
  SP_S_qC_VD_S_VD_S=(+(+SP_S_temp_VD_S_VD_S*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VD_S)-(+Gf2_VD_S_VD_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-(((delta_ns_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VD_S+SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-((delta_ns_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VD_S+SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta1_VD_S_VD_S+SP_S_x0_VD_S_VD_S)-0.0)+SP_S_delta0_VD_S_VD_S)-(+delta_ns_VD_S_VD_S*((SP_S_x0+1.0)+SP_S_xi0)+delta_ns_VD_S*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_ns_VD_S*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_ns*(+(+SP_S_x0_VD_S_VD_S+0.0)+SP_S_xi0_VD_S_VD_S)))));
  SP_S_qC_VD_S_VGP_S=(+(+SP_S_temp_VD_S_VGP_S*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VGP_S)-(+Gf2_VD_S_VGP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-((delta_ns*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S))))+Gf2_VGP_S*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-((delta_ns_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VD_S+SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta1_VD_S_VGP_S+SP_S_x0_VD_S_VGP_S)-0.0)+SP_S_delta0_VD_S_VGP_S)-(+0.0*((SP_S_x0+1.0)+SP_S_xi0)+delta_ns_VD_S*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+0.0*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_ns*(+(+SP_S_x0_VD_S_VGP_S+0.0)+SP_S_xi0_VD_S_VGP_S)))));
  SP_S_qC_VD_S_VS_BP=(+(+SP_S_temp_VD_S_VS_BP*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VS_BP)-(+Gf2_VD_S_VS_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-((delta_ns_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VD_S+SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta1_VD_S_VS_BP+SP_S_x0_VD_S_VS_BP)-0.0)+SP_S_delta0_VD_S_VS_BP)-(+delta_ns_VD_S_VS_BP*((SP_S_x0+1.0)+SP_S_xi0)+delta_ns_VD_S*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_ns_VS_BP*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_ns*(+(+SP_S_x0_VD_S_VS_BP+0.0)+SP_S_xi0_VD_S_VS_BP)))));
#endif
SP_S_qC_VGP_S=(((SP_S_temp_VGP_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VGP_S))-((Gf2_VGP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))+(Gf2*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-(delta_ns*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S))))));
#if defined(_DERIVATE2)
  SP_S_qC_VGP_S_VD_S=(+(+SP_S_temp_VGP_S_VD_S*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VD_S)-(+Gf2_VGP_S_VD_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-(((delta_ns_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VD_S+SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-(delta_ns*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)))+Gf2*(+(+(+(+SP_S_delta1_VGP_S_VD_S+SP_S_x0_VGP_S_VD_S)-0.0)+SP_S_delta0_VGP_S_VD_S)-(+0.0*((SP_S_x0+1.0)+SP_S_xi0)+0.0*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_ns_VD_S*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_ns*(+(+SP_S_x0_VGP_S_VD_S+0.0)+SP_S_xi0_VGP_S_VD_S)))));
  SP_S_qC_VGP_S_VGP_S=(+(+SP_S_temp_VGP_S_VGP_S*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VGP_S)-(+Gf2_VGP_S_VGP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-((delta_ns*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S))))+Gf2_VGP_S*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-(delta_ns*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)))+Gf2*(+(+(+(+SP_S_delta1_VGP_S_VGP_S+SP_S_x0_VGP_S_VGP_S)-0.0)+SP_S_delta0_VGP_S_VGP_S)-(+0.0*((SP_S_x0+1.0)+SP_S_xi0)+0.0*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+0.0*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_ns*(+(+SP_S_x0_VGP_S_VGP_S+0.0)+SP_S_xi0_VGP_S_VGP_S)))));
  SP_S_qC_VGP_S_VS_BP=(+(+SP_S_temp_VGP_S_VS_BP*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VS_BP)-(+Gf2_VGP_S_VS_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-(delta_ns*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)))+Gf2*(+(+(+(+SP_S_delta1_VGP_S_VS_BP+SP_S_x0_VGP_S_VS_BP)-0.0)+SP_S_delta0_VGP_S_VS_BP)-(+0.0*((SP_S_x0+1.0)+SP_S_xi0)+0.0*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_ns_VS_BP*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_ns*(+(+SP_S_x0_VGP_S_VS_BP+0.0)+SP_S_xi0_VGP_S_VS_BP)))));
#endif
SP_S_qC_VS_BP=(((SP_S_temp_VS_BP*SP_S_temp)+(SP_S_temp*SP_S_temp_VS_BP))-((Gf2_VS_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))+(Gf2*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)))))));
#if defined(_DERIVATE2)
  SP_S_qC_VS_BP_VD_S=(+(+SP_S_temp_VS_BP_VD_S*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VD_S)-(+Gf2_VS_BP_VD_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-(((delta_ns_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VD_S+SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta1_VS_BP_VD_S+SP_S_x0_VS_BP_VD_S)-0.0)+SP_S_delta0_VS_BP_VD_S)-(+delta_ns_VS_BP_VD_S*((SP_S_x0+1.0)+SP_S_xi0)+delta_ns_VS_BP*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_ns_VD_S*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_ns*(+(+SP_S_x0_VS_BP_VD_S+0.0)+SP_S_xi0_VS_BP_VD_S)))));
  SP_S_qC_VS_BP_VGP_S=(+(+SP_S_temp_VS_BP_VGP_S*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VGP_S)-(+Gf2_VS_BP_VGP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-((delta_ns*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S))))+Gf2_VGP_S*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta1_VS_BP_VGP_S+SP_S_x0_VS_BP_VGP_S)-0.0)+SP_S_delta0_VS_BP_VGP_S)-(+0.0*((SP_S_x0+1.0)+SP_S_xi0)+delta_ns_VS_BP*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+0.0*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_ns*(+(+SP_S_x0_VS_BP_VGP_S+0.0)+SP_S_xi0_VS_BP_VGP_S)))));
  SP_S_qC_VS_BP_VS_BP=(+(+SP_S_temp_VS_BP_VS_BP*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VS_BP)-(+Gf2_VS_BP_VS_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_ns*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta1_VS_BP_VS_BP+SP_S_x0_VS_BP_VS_BP)-0.0)+SP_S_delta0_VS_BP_VS_BP)-(+delta_ns_VS_BP_VS_BP*((SP_S_x0+1.0)+SP_S_xi0)+delta_ns_VS_BP*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_ns_VS_BP*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_ns*(+(+SP_S_x0_VS_BP_VS_BP+0.0)+SP_S_xi0_VS_BP_VS_BP)))));
#endif
#endif
SP_S_qC=((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
EXIT_IF_ISNAN(((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(-((Gf2_VD_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))+(Gf2*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+0.0-(+Gf2_VD_S_VD_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VD_S*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta1_VD_S_VD_S+SP_S_delta0_VD_S_VD_S)-(+delta_ns_VD_S_VD_S*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VD_S))));
  SP_S_temp_VD_S_VGP_S=(+0.0-(+Gf2_VD_S_VGP_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VD_S*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta1_VD_S_VGP_S+SP_S_delta0_VD_S_VGP_S)-(+0.0*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VGP_S))));
  SP_S_temp_VD_S_VS_BP=(+0.0-(+Gf2_VD_S_VS_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VD_S*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta1_VD_S_VS_BP+SP_S_delta0_VD_S_VS_BP)-(+delta_ns_VD_S_VS_BP*SP_S_xi2+delta_ns_VD_S*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VD_S+delta_ns*SP_S_xi2_VD_S_VS_BP))));
#endif
SP_S_temp_VGP_S=(-((Gf2_VGP_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))+(Gf2*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-(delta_ns*SP_S_xi2_VGP_S)))));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+0.0-(+Gf2_VGP_S_VD_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+(+SP_S_delta1_VGP_S_VD_S+SP_S_delta0_VGP_S_VD_S)-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VD_S))));
  SP_S_temp_VGP_S_VGP_S=(+0.0-(+Gf2_VGP_S_VGP_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+(+SP_S_delta1_VGP_S_VGP_S+SP_S_delta0_VGP_S_VGP_S)-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VGP_S))));
  SP_S_temp_VGP_S_VS_BP=(+0.0-(+Gf2_VGP_S_VS_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-(delta_ns*SP_S_xi2_VGP_S))+Gf2*(+(+SP_S_delta1_VGP_S_VS_BP+SP_S_delta0_VGP_S_VS_BP)-(+0.0*SP_S_xi2+0.0*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VGP_S+delta_ns*SP_S_xi2_VGP_S_VS_BP))));
#endif
SP_S_temp_VS_BP=(-((Gf2_VS_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))+(Gf2*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+0.0-(+Gf2_VS_BP_VD_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-(((delta_ns_VD_S*SP_S_xi2)+(delta_ns*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta1_VS_BP_VD_S+SP_S_delta0_VS_BP_VD_S)-(+delta_ns_VS_BP_VD_S*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VD_S+delta_ns_VD_S*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VD_S))));
  SP_S_temp_VS_BP_VGP_S=(+0.0-(+Gf2_VS_BP_VGP_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-((delta_ns*SP_S_xi2_VGP_S)))+Gf2_VGP_S*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta1_VS_BP_VGP_S+SP_S_delta0_VS_BP_VGP_S)-(+0.0*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VGP_S+0.0*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VGP_S))));
  SP_S_temp_VS_BP_VS_BP=(+0.0-(+Gf2_VS_BP_VS_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-(((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-((delta_ns_VS_BP*SP_S_xi2)+(delta_ns*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta1_VS_BP_VS_BP+SP_S_delta0_VS_BP_VS_BP)-(+delta_ns_VS_BP_VS_BP*SP_S_xi2+delta_ns_VS_BP*SP_S_xi2_VS_BP+delta_ns_VS_BP*SP_S_xi2_VS_BP+delta_ns*SP_S_xi2_VS_BP_VS_BP))));
#endif
#endif
SP_S_temp=(2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
EXIT_IF_ISNAN((2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2)))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(((SP_S_pC_VD_S*SP_S_pC)+(SP_S_pC*SP_S_pC_VD_S))-(2.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+(+SP_S_pC_VD_S_VD_S*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VD_S*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VD_S)));
  SP_S_temp_VD_S_VGP_S=(+(+SP_S_pC_VD_S_VGP_S*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VGP_S*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VGP_S)));
  SP_S_temp_VD_S_VS_BP=(+(+SP_S_pC_VD_S_VS_BP*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VS_BP*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VS_BP)));
#endif
SP_S_temp_VGP_S=(((SP_S_pC_VGP_S*SP_S_pC)+(SP_S_pC*SP_S_pC_VGP_S))-(2.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+(+SP_S_pC_VGP_S_VD_S*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VD_S*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VD_S)));
  SP_S_temp_VGP_S_VGP_S=(+(+SP_S_pC_VGP_S_VGP_S*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VGP_S*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VGP_S)));
  SP_S_temp_VGP_S_VS_BP=(+(+SP_S_pC_VGP_S_VS_BP*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VS_BP*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VS_BP)));
#endif
SP_S_temp_VS_BP=(((SP_S_pC_VS_BP*SP_S_pC)+(SP_S_pC*SP_S_pC_VS_BP))-(2.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+(+SP_S_pC_VS_BP_VD_S*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VD_S*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VD_S)));
  SP_S_temp_VS_BP_VGP_S=(+(+SP_S_pC_VS_BP_VGP_S*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VGP_S*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VGP_S)));
  SP_S_temp_VS_BP_VS_BP=(+(+SP_S_pC_VS_BP_VS_BP*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VS_BP*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VS_BP)));
#endif
#endif
SP_S_temp=((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
EXIT_IF_ISNAN(((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp))))
{
double m00_sqrt(d00_sqrt0,SP_S_temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,SP_S_temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_s_VD_S=(SP_S_x0_VD_S+(2.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_s_VD_S_VD_S=(+SP_S_x0_VD_S_VD_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VD_S_VGP_S=(+SP_S_x0_VD_S_VGP_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VD_S_VS_BP=(+SP_S_x0_VD_S_VS_BP+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
x_s_VGP_S=(SP_S_x0_VGP_S+(2.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_s_VGP_S_VD_S=(+SP_S_x0_VGP_S_VD_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VGP_S_VGP_S=(+SP_S_x0_VGP_S_VGP_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VGP_S_VS_BP=(+SP_S_x0_VGP_S_VS_BP+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
x_s_VS_BP=(SP_S_x0_VS_BP+(2.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_s_VS_BP_VD_S=(+SP_S_x0_VS_BP_VD_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VS_BP_VGP_S=(+SP_S_x0_VS_BP_VGP_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_s_VS_BP_VS_BP=(+SP_S_x0_VS_BP_VS_BP+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
#endif
x_s=(SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))));
EXIT_IF_ISNAN((SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+d00_sqrt0)))))
}
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_d_VD_S=x_s_VD_S;
#if defined(_DERIVATE2)
  x_d_VD_S_VD_S=x_s_VD_S_VD_S;
  x_d_VD_S_VGP_S=x_s_VD_S_VGP_S;
  x_d_VD_S_VS_BP=x_s_VD_S_VS_BP;
#endif
x_d_VGP_S=x_s_VGP_S;
#if defined(_DERIVATE2)
  x_d_VGP_S_VD_S=x_s_VGP_S_VD_S;
  x_d_VGP_S_VGP_S=x_s_VGP_S_VGP_S;
  x_d_VGP_S_VS_BP=x_s_VGP_S_VS_BP;
#endif
x_d_VS_BP=x_s_VS_BP;
#if defined(_DERIVATE2)
  x_d_VS_BP_VD_S=x_s_VS_BP_VD_S;
  x_d_VS_BP_VGP_S=x_s_VS_BP_VGP_S;
  x_d_VS_BP_VS_BP=x_s_VS_BP_VS_BP;
#endif
#endif
x_d=x_s;
EXIT_IF_ISNAN(x_s)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
x_m_VD_S=x_s_VD_S;
#if defined(_DERIVATE2)
  x_m_VD_S_VD_S=x_s_VD_S_VD_S;
  x_m_VD_S_VGP_S=x_s_VD_S_VGP_S;
  x_m_VD_S_VS_BP=x_s_VD_S_VS_BP;
#endif
x_m_VGP_S=x_s_VGP_S;
#if defined(_DERIVATE2)
  x_m_VGP_S_VD_S=x_s_VGP_S_VD_S;
  x_m_VGP_S_VGP_S=x_s_VGP_S_VGP_S;
  x_m_VGP_S_VS_BP=x_s_VGP_S_VS_BP;
#endif
x_m_VS_BP=x_s_VS_BP;
#if defined(_DERIVATE2)
  x_m_VS_BP_VD_S=x_s_VS_BP_VD_S;
  x_m_VS_BP_VGP_S=x_s_VS_BP_VGP_S;
  x_m_VS_BP_VS_BP=x_s_VS_BP_VS_BP;
#endif
#endif
x_m=x_s;
EXIT_IF_ISNAN(x_s)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_ds_VD_S=0.0;
#if defined(_DERIVATE2)
  x_ds_VD_S_VD_S=0.0;
  x_ds_VD_S_VGP_S=0.0;
  x_ds_VD_S_VS_BP=0.0;
#endif
x_ds_VGP_S=0.0;
#if defined(_DERIVATE2)
  x_ds_VGP_S_VD_S=0.0;
  x_ds_VGP_S_VGP_S=0.0;
  x_ds_VGP_S_VS_BP=0.0;
#endif
x_ds_VS_BP=0.0;
#if defined(_DERIVATE2)
  x_ds_VS_BP_VD_S=0.0;
  x_ds_VS_BP_VGP_S=0.0;
  x_ds_VS_BP_VS_BP=0.0;
#endif
#endif
x_ds=0.0;
EXIT_IF_ISNAN(0.0)
if
((pInst->xg<=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
qis_VD_S=0.0;
#if defined(_DERIVATE2)
  qis_VD_S_VD_S=0.0;
  qis_VD_S_VGP_S=0.0;
  qis_VD_S_VS_BP=0.0;
#endif
qis_VGP_S=0.0;
#if defined(_DERIVATE2)
  qis_VGP_S_VD_S=0.0;
  qis_VGP_S_VGP_S=0.0;
  qis_VGP_S_VS_BP=0.0;
#endif
qis_VS_BP=0.0;
#if defined(_DERIVATE2)
  qis_VS_BP_VD_S=0.0;
  qis_VS_BP_VGP_S=0.0;
  qis_VS_BP_VS_BP=0.0;
#endif
#endif
qis=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ids_VGP_S=0.0;
#if defined(_DERIVATE2)
  Ids_VGP_S_VGP_S=0.0;
  Ids_VGP_S_VD_S=0.0;
  Ids_VGP_S_VS_BP=0.0;
#endif
Ids_VD_S=0.0;
#if defined(_DERIVATE2)
  Ids_VD_S_VGP_S=0.0;
  Ids_VD_S_VD_S=0.0;
  Ids_VD_S_VS_BP=0.0;
#endif
Ids_VS_BP=0.0;
#if defined(_DERIVATE2)
  Ids_VS_BP_VGP_S=0.0;
  Ids_VS_BP_VD_S=0.0;
  Ids_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Ids=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
xgm_VD_S=(xg_VD_S-x_s_VD_S);
#if defined(_DERIVATE2)
  xgm_VD_S_VD_S=(+xg_VD_S_VD_S-x_s_VD_S_VD_S);
  xgm_VD_S_VGP_S=(+xg_VD_S_VGP_S-x_s_VD_S_VGP_S);
  xgm_VD_S_VS_BP=(+xg_VD_S_VS_BP-x_s_VD_S_VS_BP);
#endif
xgm_VGP_S=(xg_VGP_S-x_s_VGP_S);
#if defined(_DERIVATE2)
  xgm_VGP_S_VD_S=(+xg_VGP_S_VD_S-x_s_VGP_S_VD_S);
  xgm_VGP_S_VGP_S=(+xg_VGP_S_VGP_S-x_s_VGP_S_VGP_S);
  xgm_VGP_S_VS_BP=(+xg_VGP_S_VS_BP-x_s_VGP_S_VS_BP);
#endif
xgm_VS_BP=(xg_VS_BP-x_s_VS_BP);
#if defined(_DERIVATE2)
  xgm_VS_BP_VD_S=(+xg_VS_BP_VD_S-x_s_VS_BP_VD_S);
  xgm_VS_BP_VGP_S=(+xg_VS_BP_VGP_S-x_s_VS_BP_VGP_S);
  xgm_VS_BP_VS_BP=(+xg_VS_BP_VS_BP-x_s_VS_BP_VS_BP);
#endif
#endif
xgm=(pInst->xg-x_s);
EXIT_IF_ISNAN((pInst->xg-x_s))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
Voxm_VD_S=xgm_VD_S*pInst->phit1;
#if defined(_DERIVATE2)
  Voxm_VD_S_VD_S=(+xgm_VD_S_VD_S*pInst->phit1+xgm_VD_S*0.0+xgm_VD_S*0.0+xgm*0.0);
  Voxm_VD_S_VGP_S=(+xgm_VD_S_VGP_S*pInst->phit1+xgm_VD_S*0.0+xgm_VGP_S*0.0+xgm*0.0);
  Voxm_VD_S_VS_BP=(+xgm_VD_S_VS_BP*pInst->phit1+xgm_VD_S*0.0+xgm_VS_BP*0.0+xgm*0.0);
#endif
Voxm_VGP_S=xgm_VGP_S*pInst->phit1;
#if defined(_DERIVATE2)
  Voxm_VGP_S_VD_S=(+xgm_VGP_S_VD_S*pInst->phit1+xgm_VGP_S*0.0+xgm_VD_S*0.0+xgm*0.0);
  Voxm_VGP_S_VGP_S=(+xgm_VGP_S_VGP_S*pInst->phit1+xgm_VGP_S*0.0+xgm_VGP_S*0.0+xgm*0.0);
  Voxm_VGP_S_VS_BP=(+xgm_VGP_S_VS_BP*pInst->phit1+xgm_VGP_S*0.0+xgm_VS_BP*0.0+xgm*0.0);
#endif
Voxm_VS_BP=xgm_VS_BP*pInst->phit1;
#if defined(_DERIVATE2)
  Voxm_VS_BP_VD_S=(+xgm_VS_BP_VD_S*pInst->phit1+xgm_VS_BP*0.0+xgm_VD_S*0.0+xgm*0.0);
  Voxm_VS_BP_VGP_S=(+xgm_VS_BP_VGP_S*pInst->phit1+xgm_VS_BP*0.0+xgm_VGP_S*0.0+xgm*0.0);
  Voxm_VS_BP_VS_BP=(+xgm_VS_BP_VS_BP*pInst->phit1+xgm_VS_BP*0.0+xgm_VS_BP*0.0+xgm*0.0);
#endif
#endif
Voxm=(xgm*pInst->phit1);
EXIT_IF_ISNAN((xgm*pInst->phit1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(BP,GND)V(GP,GND)V(D,GND)V(S,GND) */
qeff_VD_S=Voxm_VD_S;
#if defined(_DERIVATE2)
  qeff_VD_S_VD_S=Voxm_VD_S_VD_S;
  qeff_VD_S_VGP_S=Voxm_VD_S_VGP_S;
  qeff_VD_S_VS_BP=Voxm_VD_S_VS_BP;
#endif
qeff_VGP_S=Voxm_VGP_S;
#if defined(_DERIVATE2)
  qeff_VGP_S_VD_S=Voxm_VGP_S_VD_S;
  qeff_VGP_S_VGP_S=Voxm_VGP_S_VGP_S;
  qeff_VGP_S_VS_BP=Voxm_VGP_S_VS_BP;
#endif
qeff_VS_BP=Voxm_VS_BP;
#if defined(_DERIVATE2)
  qeff_VS_BP_VD_S=Voxm_VS_BP_VD_S;
  qeff_VS_BP_VGP_S=Voxm_VS_BP_VGP_S;
  qeff_VS_BP_VS_BP=Voxm_VS_BP_VS_BP;
#endif
#endif
qeff=Voxm;
EXIT_IF_ISNAN(Voxm)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vdsat_VD_S=0.0;
#if defined(_DERIVATE2)
  Vdsat_VD_S_VD_S=0.0;
  Vdsat_VD_S_VGP_S=0.0;
  Vdsat_VD_S_VS_BP=0.0;
#endif
Vdsat_VGP_S=0.0;
#if defined(_DERIVATE2)
  Vdsat_VGP_S_VD_S=0.0;
  Vdsat_VGP_S_VGP_S=0.0;
  Vdsat_VGP_S_VS_BP=0.0;
#endif
Vdsat_VS_BP=0.0;
#if defined(_DERIVATE2)
  Vdsat_VS_BP_VD_S=0.0;
  Vdsat_VS_BP_VGP_S=0.0;
  Vdsat_VS_BP_VS_BP=0.0;
#endif
#endif
Vdsat=pInst->Vdsat_lim;
EXIT_IF_ISNAN(pInst->Vdsat_lim)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(S,BP)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vdse_VGP_S=0.0;
#if defined(_DERIVATE2)
  Vdse_VGP_S_VGP_S=0.0;
  Vdse_VGP_S_VS_BP=0.0;
  Vdse_VGP_S_VD_S=0.0;
#endif
Vdse_VS_BP=0.0;
#if defined(_DERIVATE2)
  Vdse_VS_BP_VGP_S=0.0;
  Vdse_VS_BP_VS_BP=0.0;
  Vdse_VS_BP_VD_S=0.0;
#endif
Vdse_VD_S=Vds_VD_S;
#if defined(_DERIVATE2)
  Vdse_VD_S_VGP_S=0.0;
  Vdse_VD_S_VS_BP=0.0;
  Vdse_VD_S_VD_S=Vds_VD_S_VD_S;
#endif
#endif
pInst->Vdse=Vds;
EXIT_IF_ISNAN(Vds)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delta_1s_VD_S=0.0;
#if defined(_DERIVATE2)
  delta_1s_VD_S_VD_S=0.0;
  delta_1s_VD_S_VGP_S=0.0;
  delta_1s_VD_S_VS_BP=0.0;
#endif
delta_1s_VGP_S=0.0;
#if defined(_DERIVATE2)
  delta_1s_VGP_S_VD_S=0.0;
  delta_1s_VGP_S_VGP_S=0.0;
  delta_1s_VGP_S_VS_BP=0.0;
#endif
delta_1s_VS_BP=0.0;
#if defined(_DERIVATE2)
  delta_1s_VS_BP_VD_S=0.0;
  delta_1s_VS_BP_VGP_S=0.0;
  delta_1s_VS_BP_VS_BP=0.0;
#endif
#endif
delta_1s=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(2.0+(x_s*x_s))-(0.0*(0.0)+0.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))+1.0*(+0.0+(+0.0*x_s+x_s_VGP_S*0.0+0.0*x_s_VGP_S+x_s*0.0)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(0.0)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VGP_S_VS_BS=(0.0/(2.0+(x_s*x_s))-(0.0*(0.0)+0.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))+1.0*(+0.0+(+0.0*x_s+x_s_VGP_S*0.0+0.0*x_s_VGP_S+x_s*0.0)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(0.0)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VGP_S_VGP_S=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))+0.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))+1.0*(+0.0+(+x_s_VGP_S_VGP_S*x_s+x_s_VGP_S*x_s_VGP_S+x_s_VGP_S*x_s_VGP_S+x_s*x_s_VGP_S_VGP_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VGP_S_VD_S=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))+0.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))+1.0*(+0.0+(+x_s_VGP_S_VD_S*x_s+x_s_VGP_S*x_s_VD_S+x_s_VD_S*x_s_VGP_S+x_s*x_s_VGP_S_VD_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VGP_S_VS_BP=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))+0.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))+1.0*(+0.0+(+x_s_VGP_S_VS_BP*x_s+x_s_VGP_S*x_s_VS_BP+x_s_VS_BP*x_s_VGP_S+x_s*x_s_VGP_S_VS_BP)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
#endif
temp_VD_S=(-((x_s_VD_S*x_s)+(x_s*x_s_VD_S))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(2.0+(x_s*x_s))-(0.0*(0.0)+0.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))+1.0*(+0.0+(+0.0*x_s+x_s_VD_S*0.0+0.0*x_s_VD_S+x_s*0.0)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(0.0)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VD_S_VS_BS=(0.0/(2.0+(x_s*x_s))-(0.0*(0.0)+0.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))+1.0*(+0.0+(+0.0*x_s+x_s_VD_S*0.0+0.0*x_s_VD_S+x_s*0.0)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(0.0)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VD_S_VGP_S=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))+0.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))+1.0*(+0.0+(+x_s_VD_S_VGP_S*x_s+x_s_VD_S*x_s_VGP_S+x_s_VGP_S*x_s_VD_S+x_s*x_s_VD_S_VGP_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VD_S_VD_S=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))+0.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))+1.0*(+0.0+(+x_s_VD_S_VD_S*x_s+x_s_VD_S*x_s_VD_S+x_s_VD_S*x_s_VD_S+x_s*x_s_VD_S_VD_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VD_S_VS_BP=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))+0.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))+1.0*(+0.0+(+x_s_VD_S_VS_BP*x_s+x_s_VD_S*x_s_VS_BP+x_s_VS_BP*x_s_VD_S+x_s*x_s_VD_S_VS_BP)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
#endif
temp_VS_BP=(-((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(2.0+(x_s*x_s))-(0.0*(0.0)+0.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))+1.0*(+0.0+(+0.0*x_s+x_s_VS_BP*0.0+0.0*x_s_VS_BP+x_s*0.0)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(0.0)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VS_BP_VS_BS=(0.0/(2.0+(x_s*x_s))-(0.0*(0.0)+0.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))+1.0*(+0.0+(+0.0*x_s+x_s_VS_BP*0.0+0.0*x_s_VS_BP+x_s*0.0)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(0.0)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VS_BP_VGP_S=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))+0.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))+1.0*(+0.0+(+x_s_VS_BP_VGP_S*x_s+x_s_VS_BP*x_s_VGP_S+x_s_VGP_S*x_s_VS_BP+x_s*x_s_VS_BP_VGP_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VS_BP_VD_S=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))+0.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))+1.0*(+0.0+(+x_s_VS_BP_VD_S*x_s+x_s_VS_BP*x_s_VD_S+x_s_VD_S*x_s_VS_BP+x_s*x_s_VS_BP_VD_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
  temp_VS_BP_VS_BP=(0.0/(2.0+(x_s*x_s))-(0.0*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))+0.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))+1.0*(+0.0+(+x_s_VS_BP_VS_BP*x_s+x_s_VS_BP*x_s_VS_BP+x_s_VS_BP*x_s_VS_BP+x_s*x_s_VS_BP_VS_BP)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))+2*1.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
#endif
#endif
temp=(1.0/(2.0+(x_s*x_s)));
EXIT_IF_ISNAN((1.0/(2.0+(x_s*x_s))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xi0s_VD_S=((((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*temp)+((x_s*x_s)*temp_VD_S));
#if defined(_DERIVATE2)
  xi0s_VD_S_VD_S=(+(+x_s_VD_S_VD_S*x_s+x_s_VD_S*x_s_VD_S+x_s_VD_S*x_s_VD_S+x_s*x_s_VD_S_VD_S)*temp+((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*temp_VD_S+(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*temp_VD_S+(x_s*x_s)*temp_VD_S_VD_S);
  xi0s_VD_S_VGP_S=(+(+x_s_VD_S_VGP_S*x_s+x_s_VD_S*x_s_VGP_S+x_s_VGP_S*x_s_VD_S+x_s*x_s_VD_S_VGP_S)*temp+((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*temp_VGP_S+(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*temp_VD_S+(x_s*x_s)*temp_VD_S_VGP_S);
  xi0s_VD_S_VS_BP=(+(+x_s_VD_S_VS_BP*x_s+x_s_VD_S*x_s_VS_BP+x_s_VS_BP*x_s_VD_S+x_s*x_s_VD_S_VS_BP)*temp+((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*temp_VS_BP+(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*temp_VD_S+(x_s*x_s)*temp_VD_S_VS_BP);
#endif
xi0s_VGP_S=((((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*temp)+((x_s*x_s)*temp_VGP_S));
#if defined(_DERIVATE2)
  xi0s_VGP_S_VD_S=(+(+x_s_VGP_S_VD_S*x_s+x_s_VGP_S*x_s_VD_S+x_s_VD_S*x_s_VGP_S+x_s*x_s_VGP_S_VD_S)*temp+((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*temp_VD_S+(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*temp_VGP_S+(x_s*x_s)*temp_VGP_S_VD_S);
  xi0s_VGP_S_VGP_S=(+(+x_s_VGP_S_VGP_S*x_s+x_s_VGP_S*x_s_VGP_S+x_s_VGP_S*x_s_VGP_S+x_s*x_s_VGP_S_VGP_S)*temp+((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*temp_VGP_S+(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*temp_VGP_S+(x_s*x_s)*temp_VGP_S_VGP_S);
  xi0s_VGP_S_VS_BP=(+(+x_s_VGP_S_VS_BP*x_s+x_s_VGP_S*x_s_VS_BP+x_s_VS_BP*x_s_VGP_S+x_s*x_s_VGP_S_VS_BP)*temp+((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*temp_VS_BP+(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*temp_VGP_S+(x_s*x_s)*temp_VGP_S_VS_BP);
#endif
xi0s_VS_BP=((((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*temp)+((x_s*x_s)*temp_VS_BP));
#if defined(_DERIVATE2)
  xi0s_VS_BP_VD_S=(+(+x_s_VS_BP_VD_S*x_s+x_s_VS_BP*x_s_VD_S+x_s_VD_S*x_s_VS_BP+x_s*x_s_VS_BP_VD_S)*temp+((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*temp_VD_S+(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*temp_VS_BP+(x_s*x_s)*temp_VS_BP_VD_S);
  xi0s_VS_BP_VGP_S=(+(+x_s_VS_BP_VGP_S*x_s+x_s_VS_BP*x_s_VGP_S+x_s_VGP_S*x_s_VS_BP+x_s*x_s_VS_BP_VGP_S)*temp+((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*temp_VGP_S+(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*temp_VS_BP+(x_s*x_s)*temp_VS_BP_VGP_S);
  xi0s_VS_BP_VS_BP=(+(+x_s_VS_BP_VS_BP*x_s+x_s_VS_BP*x_s_VS_BP+x_s_VS_BP*x_s_VS_BP+x_s*x_s_VS_BP_VS_BP)*temp+((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*temp_VS_BP+(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*temp_VS_BP+(x_s*x_s)*temp_VS_BP_VS_BP);
#endif
#endif
xi0s=((x_s*x_s)*temp);
EXIT_IF_ISNAN(((x_s*x_s)*temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xi1s_VD_S=(4.0*((((x_s_VD_S*temp)+(x_s*temp_VD_S))*temp)+((x_s*temp)*temp_VD_S)));
#if defined(_DERIVATE2)
  xi1s_VD_S_VD_S=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VD_S*temp)+(x_s*temp_VD_S)))*temp)+((x_s*temp)*temp_VD_S)))+0.0*((((x_s_VD_S*temp)+(x_s*temp_VD_S))*temp)+((x_s*temp)*temp_VD_S))+4.0*(+(+x_s_VD_S_VD_S*temp+x_s_VD_S*temp_VD_S+x_s_VD_S*temp_VD_S+x_s*temp_VD_S_VD_S)*temp+((x_s_VD_S*temp)+(x_s*temp_VD_S))*temp_VD_S+(((x_s_VD_S*temp)+(x_s*temp_VD_S)))*temp_VD_S+(x_s*temp)*temp_VD_S_VD_S));
  xi1s_VD_S_VGP_S=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))*temp)+((x_s*temp)*temp_VGP_S)))+0.0*((((x_s_VD_S*temp)+(x_s*temp_VD_S))*temp)+((x_s*temp)*temp_VD_S))+4.0*(+(+x_s_VD_S_VGP_S*temp+x_s_VD_S*temp_VGP_S+x_s_VGP_S*temp_VD_S+x_s*temp_VD_S_VGP_S)*temp+((x_s_VD_S*temp)+(x_s*temp_VD_S))*temp_VGP_S+(((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))*temp_VD_S+(x_s*temp)*temp_VD_S_VGP_S));
  xi1s_VD_S_VS_BP=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))*temp)+((x_s*temp)*temp_VS_BP)))+0.0*((((x_s_VD_S*temp)+(x_s*temp_VD_S))*temp)+((x_s*temp)*temp_VD_S))+4.0*(+(+x_s_VD_S_VS_BP*temp+x_s_VD_S*temp_VS_BP+x_s_VS_BP*temp_VD_S+x_s*temp_VD_S_VS_BP)*temp+((x_s_VD_S*temp)+(x_s*temp_VD_S))*temp_VS_BP+(((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))*temp_VD_S+(x_s*temp)*temp_VD_S_VS_BP));
#endif
xi1s_VGP_S=(4.0*((((x_s_VGP_S*temp)+(x_s*temp_VGP_S))*temp)+((x_s*temp)*temp_VGP_S)));
#if defined(_DERIVATE2)
  xi1s_VGP_S_VD_S=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VD_S*temp)+(x_s*temp_VD_S)))*temp)+((x_s*temp)*temp_VD_S)))+0.0*((((x_s_VGP_S*temp)+(x_s*temp_VGP_S))*temp)+((x_s*temp)*temp_VGP_S))+4.0*(+(+x_s_VGP_S_VD_S*temp+x_s_VGP_S*temp_VD_S+x_s_VD_S*temp_VGP_S+x_s*temp_VGP_S_VD_S)*temp+((x_s_VGP_S*temp)+(x_s*temp_VGP_S))*temp_VD_S+(((x_s_VD_S*temp)+(x_s*temp_VD_S)))*temp_VGP_S+(x_s*temp)*temp_VGP_S_VD_S));
  xi1s_VGP_S_VGP_S=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))*temp)+((x_s*temp)*temp_VGP_S)))+0.0*((((x_s_VGP_S*temp)+(x_s*temp_VGP_S))*temp)+((x_s*temp)*temp_VGP_S))+4.0*(+(+x_s_VGP_S_VGP_S*temp+x_s_VGP_S*temp_VGP_S+x_s_VGP_S*temp_VGP_S+x_s*temp_VGP_S_VGP_S)*temp+((x_s_VGP_S*temp)+(x_s*temp_VGP_S))*temp_VGP_S+(((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))*temp_VGP_S+(x_s*temp)*temp_VGP_S_VGP_S));
  xi1s_VGP_S_VS_BP=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))*temp)+((x_s*temp)*temp_VS_BP)))+0.0*((((x_s_VGP_S*temp)+(x_s*temp_VGP_S))*temp)+((x_s*temp)*temp_VGP_S))+4.0*(+(+x_s_VGP_S_VS_BP*temp+x_s_VGP_S*temp_VS_BP+x_s_VS_BP*temp_VGP_S+x_s*temp_VGP_S_VS_BP)*temp+((x_s_VGP_S*temp)+(x_s*temp_VGP_S))*temp_VS_BP+(((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))*temp_VGP_S+(x_s*temp)*temp_VGP_S_VS_BP));
#endif
xi1s_VS_BP=(4.0*((((x_s_VS_BP*temp)+(x_s*temp_VS_BP))*temp)+((x_s*temp)*temp_VS_BP)));
#if defined(_DERIVATE2)
  xi1s_VS_BP_VD_S=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VD_S*temp)+(x_s*temp_VD_S)))*temp)+((x_s*temp)*temp_VD_S)))+0.0*((((x_s_VS_BP*temp)+(x_s*temp_VS_BP))*temp)+((x_s*temp)*temp_VS_BP))+4.0*(+(+x_s_VS_BP_VD_S*temp+x_s_VS_BP*temp_VD_S+x_s_VD_S*temp_VS_BP+x_s*temp_VS_BP_VD_S)*temp+((x_s_VS_BP*temp)+(x_s*temp_VS_BP))*temp_VD_S+(((x_s_VD_S*temp)+(x_s*temp_VD_S)))*temp_VS_BP+(x_s*temp)*temp_VS_BP_VD_S));
  xi1s_VS_BP_VGP_S=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))*temp)+((x_s*temp)*temp_VGP_S)))+0.0*((((x_s_VS_BP*temp)+(x_s*temp_VS_BP))*temp)+((x_s*temp)*temp_VS_BP))+4.0*(+(+x_s_VS_BP_VGP_S*temp+x_s_VS_BP*temp_VGP_S+x_s_VGP_S*temp_VS_BP+x_s*temp_VS_BP_VGP_S)*temp+((x_s_VS_BP*temp)+(x_s*temp_VS_BP))*temp_VGP_S+(((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))*temp_VS_BP+(x_s*temp)*temp_VS_BP_VGP_S));
  xi1s_VS_BP_VS_BP=(+0.0*((x_s*temp)*temp)+0.0*((((((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))*temp)+((x_s*temp)*temp_VS_BP)))+0.0*((((x_s_VS_BP*temp)+(x_s*temp_VS_BP))*temp)+((x_s*temp)*temp_VS_BP))+4.0*(+(+x_s_VS_BP_VS_BP*temp+x_s_VS_BP*temp_VS_BP+x_s_VS_BP*temp_VS_BP+x_s*temp_VS_BP_VS_BP)*temp+((x_s_VS_BP*temp)+(x_s*temp_VS_BP))*temp_VS_BP+(((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))*temp_VS_BP+(x_s*temp)*temp_VS_BP_VS_BP));
#endif
#endif
xi1s=(4.0*((x_s*temp)*temp));
EXIT_IF_ISNAN((4.0*((x_s*temp)*temp)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xi2s_VGP_S=((((((8.0*temp_VGP_S)-(12.0*xi0s_VGP_S))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VGP_S))*temp)+((((8.0*temp)-(12.0*xi0s))*temp)*temp_VGP_S));
#if defined(_DERIVATE2)
  xi2s_VGP_S_VGP_S=(+(+(+(+0.0*temp+0.0*temp_VGP_S+0.0*temp_VGP_S+8.0*temp_VGP_S_VGP_S)-(+0.0*xi0s+0.0*xi0s_VGP_S+0.0*xi0s_VGP_S+12.0*xi0s_VGP_S_VGP_S))*temp+((8.0*temp_VGP_S)-(12.0*xi0s_VGP_S))*temp_VGP_S+(((8.0*temp_VGP_S))-((12.0*xi0s_VGP_S)))*temp_VGP_S+((8.0*temp)-(12.0*xi0s))*temp_VGP_S_VGP_S)*temp+((((8.0*temp_VGP_S)-(12.0*xi0s_VGP_S))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VGP_S))*temp_VGP_S+((((((8.0*temp_VGP_S))-((12.0*xi0s_VGP_S)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VGP_S)))*temp_VGP_S+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VGP_S_VGP_S);
  xi2s_VGP_S_VD_S=(+(+(+(+0.0*temp+0.0*temp_VD_S+0.0*temp_VGP_S+8.0*temp_VGP_S_VD_S)-(+0.0*xi0s+0.0*xi0s_VD_S+0.0*xi0s_VGP_S+12.0*xi0s_VGP_S_VD_S))*temp+((8.0*temp_VGP_S)-(12.0*xi0s_VGP_S))*temp_VD_S+(((8.0*temp_VD_S))-((12.0*xi0s_VD_S)))*temp_VGP_S+((8.0*temp)-(12.0*xi0s))*temp_VGP_S_VD_S)*temp+((((8.0*temp_VGP_S)-(12.0*xi0s_VGP_S))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VGP_S))*temp_VD_S+((((((8.0*temp_VD_S))-((12.0*xi0s_VD_S)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VD_S)))*temp_VGP_S+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VGP_S_VD_S);
  xi2s_VGP_S_VS_BP=(+(+(+(+0.0*temp+0.0*temp_VS_BP+0.0*temp_VGP_S+8.0*temp_VGP_S_VS_BP)-(+0.0*xi0s+0.0*xi0s_VS_BP+0.0*xi0s_VGP_S+12.0*xi0s_VGP_S_VS_BP))*temp+((8.0*temp_VGP_S)-(12.0*xi0s_VGP_S))*temp_VS_BP+(((8.0*temp_VS_BP))-((12.0*xi0s_VS_BP)))*temp_VGP_S+((8.0*temp)-(12.0*xi0s))*temp_VGP_S_VS_BP)*temp+((((8.0*temp_VGP_S)-(12.0*xi0s_VGP_S))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VGP_S))*temp_VS_BP+((((((8.0*temp_VS_BP))-((12.0*xi0s_VS_BP)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VS_BP)))*temp_VGP_S+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VGP_S_VS_BP);
#endif
xi2s_VD_S=((((((8.0*temp_VD_S)-(12.0*xi0s_VD_S))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VD_S))*temp)+((((8.0*temp)-(12.0*xi0s))*temp)*temp_VD_S));
#if defined(_DERIVATE2)
  xi2s_VD_S_VGP_S=(+(+(+(+0.0*temp+0.0*temp_VGP_S+0.0*temp_VD_S+8.0*temp_VD_S_VGP_S)-(+0.0*xi0s+0.0*xi0s_VGP_S+0.0*xi0s_VD_S+12.0*xi0s_VD_S_VGP_S))*temp+((8.0*temp_VD_S)-(12.0*xi0s_VD_S))*temp_VGP_S+(((8.0*temp_VGP_S))-((12.0*xi0s_VGP_S)))*temp_VD_S+((8.0*temp)-(12.0*xi0s))*temp_VD_S_VGP_S)*temp+((((8.0*temp_VD_S)-(12.0*xi0s_VD_S))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VD_S))*temp_VGP_S+((((((8.0*temp_VGP_S))-((12.0*xi0s_VGP_S)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VGP_S)))*temp_VD_S+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VD_S_VGP_S);
  xi2s_VD_S_VD_S=(+(+(+(+0.0*temp+0.0*temp_VD_S+0.0*temp_VD_S+8.0*temp_VD_S_VD_S)-(+0.0*xi0s+0.0*xi0s_VD_S+0.0*xi0s_VD_S+12.0*xi0s_VD_S_VD_S))*temp+((8.0*temp_VD_S)-(12.0*xi0s_VD_S))*temp_VD_S+(((8.0*temp_VD_S))-((12.0*xi0s_VD_S)))*temp_VD_S+((8.0*temp)-(12.0*xi0s))*temp_VD_S_VD_S)*temp+((((8.0*temp_VD_S)-(12.0*xi0s_VD_S))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VD_S))*temp_VD_S+((((((8.0*temp_VD_S))-((12.0*xi0s_VD_S)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VD_S)))*temp_VD_S+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VD_S_VD_S);
  xi2s_VD_S_VS_BP=(+(+(+(+0.0*temp+0.0*temp_VS_BP+0.0*temp_VD_S+8.0*temp_VD_S_VS_BP)-(+0.0*xi0s+0.0*xi0s_VS_BP+0.0*xi0s_VD_S+12.0*xi0s_VD_S_VS_BP))*temp+((8.0*temp_VD_S)-(12.0*xi0s_VD_S))*temp_VS_BP+(((8.0*temp_VS_BP))-((12.0*xi0s_VS_BP)))*temp_VD_S+((8.0*temp)-(12.0*xi0s))*temp_VD_S_VS_BP)*temp+((((8.0*temp_VD_S)-(12.0*xi0s_VD_S))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VD_S))*temp_VS_BP+((((((8.0*temp_VS_BP))-((12.0*xi0s_VS_BP)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VS_BP)))*temp_VD_S+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VD_S_VS_BP);
#endif
xi2s_VS_BP=((((((8.0*temp_VS_BP)-(12.0*xi0s_VS_BP))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VS_BP))*temp)+((((8.0*temp)-(12.0*xi0s))*temp)*temp_VS_BP));
#if defined(_DERIVATE2)
  xi2s_VS_BP_VGP_S=(+(+(+(+0.0*temp+0.0*temp_VGP_S+0.0*temp_VS_BP+8.0*temp_VS_BP_VGP_S)-(+0.0*xi0s+0.0*xi0s_VGP_S+0.0*xi0s_VS_BP+12.0*xi0s_VS_BP_VGP_S))*temp+((8.0*temp_VS_BP)-(12.0*xi0s_VS_BP))*temp_VGP_S+(((8.0*temp_VGP_S))-((12.0*xi0s_VGP_S)))*temp_VS_BP+((8.0*temp)-(12.0*xi0s))*temp_VS_BP_VGP_S)*temp+((((8.0*temp_VS_BP)-(12.0*xi0s_VS_BP))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VS_BP))*temp_VGP_S+((((((8.0*temp_VGP_S))-((12.0*xi0s_VGP_S)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VGP_S)))*temp_VS_BP+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VS_BP_VGP_S);
  xi2s_VS_BP_VD_S=(+(+(+(+0.0*temp+0.0*temp_VD_S+0.0*temp_VS_BP+8.0*temp_VS_BP_VD_S)-(+0.0*xi0s+0.0*xi0s_VD_S+0.0*xi0s_VS_BP+12.0*xi0s_VS_BP_VD_S))*temp+((8.0*temp_VS_BP)-(12.0*xi0s_VS_BP))*temp_VD_S+(((8.0*temp_VD_S))-((12.0*xi0s_VD_S)))*temp_VS_BP+((8.0*temp)-(12.0*xi0s))*temp_VS_BP_VD_S)*temp+((((8.0*temp_VS_BP)-(12.0*xi0s_VS_BP))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VS_BP))*temp_VD_S+((((((8.0*temp_VD_S))-((12.0*xi0s_VD_S)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VD_S)))*temp_VS_BP+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VS_BP_VD_S);
  xi2s_VS_BP_VS_BP=(+(+(+(+0.0*temp+0.0*temp_VS_BP+0.0*temp_VS_BP+8.0*temp_VS_BP_VS_BP)-(+0.0*xi0s+0.0*xi0s_VS_BP+0.0*xi0s_VS_BP+12.0*xi0s_VS_BP_VS_BP))*temp+((8.0*temp_VS_BP)-(12.0*xi0s_VS_BP))*temp_VS_BP+(((8.0*temp_VS_BP))-((12.0*xi0s_VS_BP)))*temp_VS_BP+((8.0*temp)-(12.0*xi0s))*temp_VS_BP_VS_BP)*temp+((((8.0*temp_VS_BP)-(12.0*xi0s_VS_BP))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VS_BP))*temp_VS_BP+((((((8.0*temp_VS_BP))-((12.0*xi0s_VS_BP)))*temp)+(((8.0*temp)-(12.0*xi0s))*temp_VS_BP)))*temp_VS_BP+(((8.0*temp)-(12.0*xi0s))*temp)*temp_VS_BP_VS_BP);
#endif
#endif
xi2s=((((8.0*temp)-(12.0*xi0s))*temp)*temp);
EXIT_IF_ISNAN(((((8.0*temp)-(12.0*xi0s))*temp)*temp))
if
((x_s<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,x_s)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delta_1s_VD_S=x_s_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  delta_1s_VD_S_VD_S=(m20_exp(x_s)*x_s_VD_S*x_s_VD_S+d10_exp0*x_s_VD_S_VD_S);
  delta_1s_VD_S_VGP_S=(m20_exp(x_s)*x_s_VGP_S*x_s_VD_S+d10_exp0*x_s_VD_S_VGP_S);
  delta_1s_VD_S_VS_BP=(m20_exp(x_s)*x_s_VS_BP*x_s_VD_S+d10_exp0*x_s_VD_S_VS_BP);
#endif
delta_1s_VGP_S=x_s_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  delta_1s_VGP_S_VD_S=(m20_exp(x_s)*x_s_VD_S*x_s_VGP_S+d10_exp0*x_s_VGP_S_VD_S);
  delta_1s_VGP_S_VGP_S=(m20_exp(x_s)*x_s_VGP_S*x_s_VGP_S+d10_exp0*x_s_VGP_S_VGP_S);
  delta_1s_VGP_S_VS_BP=(m20_exp(x_s)*x_s_VS_BP*x_s_VGP_S+d10_exp0*x_s_VGP_S_VS_BP);
#endif
delta_1s_VS_BP=x_s_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  delta_1s_VS_BP_VD_S=(m20_exp(x_s)*x_s_VD_S*x_s_VS_BP+d10_exp0*x_s_VS_BP_VD_S);
  delta_1s_VS_BP_VGP_S=(m20_exp(x_s)*x_s_VGP_S*x_s_VS_BP+d10_exp0*x_s_VS_BP_VGP_S);
  delta_1s_VS_BP_VS_BP=(m20_exp(x_s)*x_s_VS_BP*x_s_VS_BP+d10_exp0*x_s_VS_BP_VS_BP);
#endif
#endif
delta_1s=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Es_VD_S=(-delta_1s_VD_S/delta_1s/delta_1s);
#if defined(_DERIVATE2)
  Es_VD_S_VD_S=(0.0/delta_1s-(0.0*delta_1s_VD_S+0.0*delta_1s_VD_S+1.0*delta_1s_VD_S_VD_S)/delta_1s/delta_1s+2*1.0*delta_1s_VD_S*delta_1s_VD_S/delta_1s/delta_1s/delta_1s);
  Es_VD_S_VGP_S=(0.0/delta_1s-(0.0*delta_1s_VGP_S+0.0*delta_1s_VD_S+1.0*delta_1s_VD_S_VGP_S)/delta_1s/delta_1s+2*1.0*delta_1s_VD_S*delta_1s_VGP_S/delta_1s/delta_1s/delta_1s);
  Es_VD_S_VS_BP=(0.0/delta_1s-(0.0*delta_1s_VS_BP+0.0*delta_1s_VD_S+1.0*delta_1s_VD_S_VS_BP)/delta_1s/delta_1s+2*1.0*delta_1s_VD_S*delta_1s_VS_BP/delta_1s/delta_1s/delta_1s);
#endif
Es_VGP_S=(-delta_1s_VGP_S/delta_1s/delta_1s);
#if defined(_DERIVATE2)
  Es_VGP_S_VD_S=(0.0/delta_1s-(0.0*delta_1s_VD_S+0.0*delta_1s_VGP_S+1.0*delta_1s_VGP_S_VD_S)/delta_1s/delta_1s+2*1.0*delta_1s_VGP_S*delta_1s_VD_S/delta_1s/delta_1s/delta_1s);
  Es_VGP_S_VGP_S=(0.0/delta_1s-(0.0*delta_1s_VGP_S+0.0*delta_1s_VGP_S+1.0*delta_1s_VGP_S_VGP_S)/delta_1s/delta_1s+2*1.0*delta_1s_VGP_S*delta_1s_VGP_S/delta_1s/delta_1s/delta_1s);
  Es_VGP_S_VS_BP=(0.0/delta_1s-(0.0*delta_1s_VS_BP+0.0*delta_1s_VGP_S+1.0*delta_1s_VGP_S_VS_BP)/delta_1s/delta_1s+2*1.0*delta_1s_VGP_S*delta_1s_VS_BP/delta_1s/delta_1s/delta_1s);
#endif
Es_VS_BP=(-delta_1s_VS_BP/delta_1s/delta_1s);
#if defined(_DERIVATE2)
  Es_VS_BP_VD_S=(0.0/delta_1s-(0.0*delta_1s_VD_S+0.0*delta_1s_VS_BP+1.0*delta_1s_VS_BP_VD_S)/delta_1s/delta_1s+2*1.0*delta_1s_VS_BP*delta_1s_VD_S/delta_1s/delta_1s/delta_1s);
  Es_VS_BP_VGP_S=(0.0/delta_1s-(0.0*delta_1s_VGP_S+0.0*delta_1s_VS_BP+1.0*delta_1s_VS_BP_VGP_S)/delta_1s/delta_1s+2*1.0*delta_1s_VS_BP*delta_1s_VGP_S/delta_1s/delta_1s/delta_1s);
  Es_VS_BP_VS_BP=(0.0/delta_1s-(0.0*delta_1s_VS_BP+0.0*delta_1s_VS_BP+1.0*delta_1s_VS_BP_VS_BP)/delta_1s/delta_1s+2*1.0*delta_1s_VS_BP*delta_1s_VS_BP/delta_1s/delta_1s/delta_1s);
#endif
#endif
Es=(1.0/delta_1s);
EXIT_IF_ISNAN((1.0/delta_1s))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delta_1s_VD_S=((delta_ns_VD_S*delta_1s)+(delta_ns*delta_1s_VD_S));
#if defined(_DERIVATE2)
  delta_1s_VD_S_VD_S=(+delta_ns_VD_S_VD_S*delta_1s+delta_ns_VD_S*delta_1s_VD_S+delta_ns_VD_S*delta_1s_VD_S+delta_ns*delta_1s_VD_S_VD_S);
  delta_1s_VD_S_VGP_S=(+0.0*delta_1s+delta_ns_VD_S*delta_1s_VGP_S+0.0*delta_1s_VD_S+delta_ns*delta_1s_VD_S_VGP_S);
  delta_1s_VD_S_VS_BP=(+delta_ns_VD_S_VS_BP*delta_1s+delta_ns_VD_S*delta_1s_VS_BP+delta_ns_VS_BP*delta_1s_VD_S+delta_ns*delta_1s_VD_S_VS_BP);
#endif
delta_1s_VGP_S=(delta_ns*delta_1s_VGP_S);
#if defined(_DERIVATE2)
  delta_1s_VGP_S_VD_S=(+0.0*delta_1s+0.0*delta_1s_VD_S+delta_ns_VD_S*delta_1s_VGP_S+delta_ns*delta_1s_VGP_S_VD_S);
  delta_1s_VGP_S_VGP_S=(+0.0*delta_1s+0.0*delta_1s_VGP_S+0.0*delta_1s_VGP_S+delta_ns*delta_1s_VGP_S_VGP_S);
  delta_1s_VGP_S_VS_BP=(+0.0*delta_1s+0.0*delta_1s_VS_BP+delta_ns_VS_BP*delta_1s_VGP_S+delta_ns*delta_1s_VGP_S_VS_BP);
#endif
delta_1s_VS_BP=((delta_ns_VS_BP*delta_1s)+(delta_ns*delta_1s_VS_BP));
#if defined(_DERIVATE2)
  delta_1s_VS_BP_VD_S=(+delta_ns_VS_BP_VD_S*delta_1s+delta_ns_VS_BP*delta_1s_VD_S+delta_ns_VD_S*delta_1s_VS_BP+delta_ns*delta_1s_VS_BP_VD_S);
  delta_1s_VS_BP_VGP_S=(+0.0*delta_1s+delta_ns_VS_BP*delta_1s_VGP_S+0.0*delta_1s_VS_BP+delta_ns*delta_1s_VS_BP_VGP_S);
  delta_1s_VS_BP_VS_BP=(+delta_ns_VS_BP_VS_BP*delta_1s+delta_ns_VS_BP*delta_1s_VS_BP+delta_ns_VS_BP*delta_1s_VS_BP+delta_ns*delta_1s_VS_BP_VS_BP);
#endif
#endif
delta_1s=(delta_ns*delta_1s);
EXIT_IF_ISNAN((delta_ns*delta_1s))
}
else
{
if
((x_s>(xn_s-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(x_s-xn_s))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delta_1s_VD_S=(x_s_VD_S-xn_s_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  delta_1s_VD_S_VD_S=(m20_exp((x_s-xn_s))*(x_s_VD_S-xn_s_VD_S)*(x_s_VD_S-xn_s_VD_S)+d10_exp0*(+x_s_VD_S_VD_S-xn_s_VD_S_VD_S));
  delta_1s_VD_S_VGP_S=(m20_exp((x_s-xn_s))*x_s_VGP_S*(x_s_VD_S-xn_s_VD_S)+d10_exp0*(+x_s_VD_S_VGP_S-0.0));
  delta_1s_VD_S_VS_BP=(m20_exp((x_s-xn_s))*(x_s_VS_BP-xn_s_VS_BP)*(x_s_VD_S-xn_s_VD_S)+d10_exp0*(+x_s_VD_S_VS_BP-xn_s_VD_S_VS_BP));
#endif
delta_1s_VGP_S=x_s_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  delta_1s_VGP_S_VD_S=(m20_exp((x_s-xn_s))*(x_s_VD_S-xn_s_VD_S)*x_s_VGP_S+d10_exp0*(+x_s_VGP_S_VD_S-0.0));
  delta_1s_VGP_S_VGP_S=(m20_exp((x_s-xn_s))*x_s_VGP_S*x_s_VGP_S+d10_exp0*(+x_s_VGP_S_VGP_S-0.0));
  delta_1s_VGP_S_VS_BP=(m20_exp((x_s-xn_s))*(x_s_VS_BP-xn_s_VS_BP)*x_s_VGP_S+d10_exp0*(+x_s_VGP_S_VS_BP-0.0));
#endif
delta_1s_VS_BP=(x_s_VS_BP-xn_s_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  delta_1s_VS_BP_VD_S=(m20_exp((x_s-xn_s))*(x_s_VD_S-xn_s_VD_S)*(x_s_VS_BP-xn_s_VS_BP)+d10_exp0*(+x_s_VS_BP_VD_S-xn_s_VS_BP_VD_S));
  delta_1s_VS_BP_VGP_S=(m20_exp((x_s-xn_s))*x_s_VGP_S*(x_s_VS_BP-xn_s_VS_BP)+d10_exp0*(+x_s_VS_BP_VGP_S-0.0));
  delta_1s_VS_BP_VS_BP=(m20_exp((x_s-xn_s))*(x_s_VS_BP-xn_s_VS_BP)*(x_s_VS_BP-xn_s_VS_BP)+d10_exp0*(+x_s_VS_BP_VS_BP-xn_s_VS_BP_VS_BP));
#endif
#endif
delta_1s=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Es_VD_S=((delta_ns_VD_S*delta_1s-delta_ns*delta_1s_VD_S)/delta_1s/delta_1s);
#if defined(_DERIVATE2)
  Es_VD_S_VD_S=(delta_ns_VD_S_VD_S/delta_1s-(delta_ns_VD_S*delta_1s_VD_S+delta_ns_VD_S*delta_1s_VD_S+delta_ns*delta_1s_VD_S_VD_S)/delta_1s/delta_1s+2*delta_ns*delta_1s_VD_S*delta_1s_VD_S/delta_1s/delta_1s/delta_1s);
  Es_VD_S_VGP_S=(0.0/delta_1s-(delta_ns_VD_S*delta_1s_VGP_S+0.0*delta_1s_VD_S+delta_ns*delta_1s_VD_S_VGP_S)/delta_1s/delta_1s+2*delta_ns*delta_1s_VD_S*delta_1s_VGP_S/delta_1s/delta_1s/delta_1s);
  Es_VD_S_VS_BP=(delta_ns_VD_S_VS_BP/delta_1s-(delta_ns_VD_S*delta_1s_VS_BP+delta_ns_VS_BP*delta_1s_VD_S+delta_ns*delta_1s_VD_S_VS_BP)/delta_1s/delta_1s+2*delta_ns*delta_1s_VD_S*delta_1s_VS_BP/delta_1s/delta_1s/delta_1s);
#endif
Es_VGP_S=(-delta_ns*delta_1s_VGP_S/delta_1s/delta_1s);
#if defined(_DERIVATE2)
  Es_VGP_S_VD_S=(0.0/delta_1s-(0.0*delta_1s_VD_S+delta_ns_VD_S*delta_1s_VGP_S+delta_ns*delta_1s_VGP_S_VD_S)/delta_1s/delta_1s+2*delta_ns*delta_1s_VGP_S*delta_1s_VD_S/delta_1s/delta_1s/delta_1s);
  Es_VGP_S_VGP_S=(0.0/delta_1s-(0.0*delta_1s_VGP_S+0.0*delta_1s_VGP_S+delta_ns*delta_1s_VGP_S_VGP_S)/delta_1s/delta_1s+2*delta_ns*delta_1s_VGP_S*delta_1s_VGP_S/delta_1s/delta_1s/delta_1s);
  Es_VGP_S_VS_BP=(0.0/delta_1s-(0.0*delta_1s_VS_BP+delta_ns_VS_BP*delta_1s_VGP_S+delta_ns*delta_1s_VGP_S_VS_BP)/delta_1s/delta_1s+2*delta_ns*delta_1s_VGP_S*delta_1s_VS_BP/delta_1s/delta_1s/delta_1s);
#endif
Es_VS_BP=((delta_ns_VS_BP*delta_1s-delta_ns*delta_1s_VS_BP)/delta_1s/delta_1s);
#if defined(_DERIVATE2)
  Es_VS_BP_VD_S=(delta_ns_VS_BP_VD_S/delta_1s-(delta_ns_VS_BP*delta_1s_VD_S+delta_ns_VD_S*delta_1s_VS_BP+delta_ns*delta_1s_VS_BP_VD_S)/delta_1s/delta_1s+2*delta_ns*delta_1s_VS_BP*delta_1s_VD_S/delta_1s/delta_1s/delta_1s);
  Es_VS_BP_VGP_S=(0.0/delta_1s-(delta_ns_VS_BP*delta_1s_VGP_S+0.0*delta_1s_VS_BP+delta_ns*delta_1s_VS_BP_VGP_S)/delta_1s/delta_1s+2*delta_ns*delta_1s_VS_BP*delta_1s_VGP_S/delta_1s/delta_1s/delta_1s);
  Es_VS_BP_VS_BP=(delta_ns_VS_BP_VS_BP/delta_1s-(delta_ns_VS_BP*delta_1s_VS_BP+delta_ns_VS_BP*delta_1s_VS_BP+delta_ns*delta_1s_VS_BP_VS_BP)/delta_1s/delta_1s+2*delta_ns*delta_1s_VS_BP*delta_1s_VS_BP/delta_1s/delta_1s/delta_1s);
#endif
#endif
Es=(delta_ns/delta_1s);
EXIT_IF_ISNAN((delta_ns/delta_1s))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delta_1s_VD_S=(-1.0e-100*(((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  delta_1s_VD_S_VD_S=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_s_VD_S_VD_S-x_s_VD_S_VD_S)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VD_S-x_s_VD_S)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))))))+(xn_s_VD_S-x_s_VD_S)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_s_VD_S_VD_S-x_s_VD_S_VD_S)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VD_S-x_s_VD_S)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)+(xn_s_VD_S-x_s_VD_S)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_s_VD_S_VD_S-x_s_VD_S_VD_S)-0.0)*3.3333333333333333e-01+(xn_s_VD_S-x_s_VD_S)*0.0+(xn_s_VD_S-x_s_VD_S)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))*((((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  delta_1s_VD_S_VGP_S=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-x_s_VD_S_VGP_S)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VD_S-x_s_VD_S)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01))))))+(-x_s_VGP_S)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-x_s_VD_S_VGP_S)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VD_S-x_s_VD_S)*((-x_s_VGP_S)*3.3333333333333333e-01)+(-x_s_VGP_S)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-x_s_VD_S_VGP_S)-0.0)*3.3333333333333333e-01+(xn_s_VD_S-x_s_VD_S)*0.0+(-x_s_VGP_S)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))*((((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  delta_1s_VD_S_VS_BP=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_s_VD_S_VS_BP-x_s_VD_S_VS_BP)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VD_S-x_s_VD_S)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))))))+(xn_s_VS_BP-x_s_VS_BP)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_s_VD_S_VS_BP-x_s_VD_S_VS_BP)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VD_S-x_s_VD_S)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)+(xn_s_VS_BP-x_s_VS_BP)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_s_VD_S_VS_BP-x_s_VD_S_VS_BP)-0.0)*3.3333333333333333e-01+(xn_s_VD_S-x_s_VD_S)*0.0+(xn_s_VS_BP-x_s_VS_BP)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
delta_1s_VGP_S=(-1.0e-100*(((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  delta_1s_VGP_S_VD_S=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-x_s_VGP_S_VD_S)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-x_s_VGP_S)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))))))+(xn_s_VD_S-x_s_VD_S)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))))+0.0*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-x_s_VGP_S_VD_S)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-x_s_VGP_S)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)+(xn_s_VD_S-x_s_VD_S)*(-x_s_VGP_S)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-x_s_VGP_S_VD_S)-0.0)*3.3333333333333333e-01+(-x_s_VGP_S)*0.0+(xn_s_VD_S-x_s_VD_S)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))))*((((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  delta_1s_VGP_S_VGP_S=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-x_s_VGP_S_VGP_S)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-x_s_VGP_S)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01))))))+(-x_s_VGP_S)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01))))+0.0*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-x_s_VGP_S_VGP_S)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-x_s_VGP_S)*((-x_s_VGP_S)*3.3333333333333333e-01)+(-x_s_VGP_S)*(-x_s_VGP_S)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-x_s_VGP_S_VGP_S)-0.0)*3.3333333333333333e-01+(-x_s_VGP_S)*0.0+(-x_s_VGP_S)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))))*((((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  delta_1s_VGP_S_VS_BP=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-x_s_VGP_S_VS_BP)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-x_s_VGP_S)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))))))+(xn_s_VS_BP-x_s_VS_BP)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))))+0.0*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-x_s_VGP_S_VS_BP)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-x_s_VGP_S)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)+(xn_s_VS_BP-x_s_VS_BP)*(-x_s_VGP_S)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-x_s_VGP_S_VS_BP)-0.0)*3.3333333333333333e-01+(-x_s_VGP_S)*0.0+(xn_s_VS_BP-x_s_VS_BP)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(-x_s_VGP_S)*3.3333333333333333e-01)))))*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
delta_1s_VS_BP=(-1.0e-100*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  delta_1s_VS_BP_VD_S=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_s_VS_BP_VD_S-x_s_VS_BP_VD_S)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VS_BP-x_s_VS_BP)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))))))+(xn_s_VD_S-x_s_VD_S)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_s_VS_BP_VD_S-x_s_VS_BP_VD_S)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VS_BP-x_s_VS_BP)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)+(xn_s_VD_S-x_s_VD_S)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_s_VS_BP_VD_S-x_s_VS_BP_VD_S)-0.0)*3.3333333333333333e-01+(xn_s_VS_BP-x_s_VS_BP)*0.0+(xn_s_VD_S-x_s_VD_S)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))*((((xn_s_VD_S-x_s_VD_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VD_S-x_s_VD_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VD_S-x_s_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  delta_1s_VS_BP_VGP_S=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-x_s_VS_BP_VGP_S)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VS_BP-x_s_VS_BP)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01))))))+(-x_s_VGP_S)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+0.0-x_s_VS_BP_VGP_S)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VS_BP-x_s_VS_BP)*((-x_s_VGP_S)*3.3333333333333333e-01)+(-x_s_VGP_S)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-x_s_VS_BP_VGP_S)-0.0)*3.3333333333333333e-01+(xn_s_VS_BP-x_s_VS_BP)*0.0+(-x_s_VGP_S)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))*((((-x_s_VGP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((-x_s_VGP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((-x_s_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  delta_1s_VS_BP_VS_BP=(0.0/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_s_VS_BP_VS_BP-x_s_VS_BP_VS_BP)-0.0)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_s_VS_BP-x_s_VS_BP)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))))))+(xn_s_VS_BP-x_s_VS_BP)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_s_VS_BP_VS_BP-x_s_VS_BP_VS_BP)-0.0)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_s_VS_BP-x_s_VS_BP)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)+(xn_s_VS_BP-x_s_VS_BP)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01+((xn_s-x_s)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_s_VS_BP_VS_BP-x_s_VS_BP_VS_BP)-0.0)*3.3333333333333333e-01+(xn_s_VS_BP-x_s_VS_BP)*0.0+(xn_s_VS_BP-x_s_VS_BP)*0.0+((xn_s-x_s)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*(0.5*(((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*(xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_s-x_s)-2.3025850929940458e+02)*((0.5*((((xn_s_VS_BP-x_s_VS_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_s-x_s)-2.3025850929940458e+02)*((xn_s_VS_BP-x_s_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
#endif
delta_1s=(1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Es_VD_S=(-1.0e-100*((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Es_VD_S_VD_S=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VD_S_VD_S-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VD_S*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01))))))+x_s_VD_S*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01))))+0.0*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01))+0.5*(+(+x_s_VD_S_VD_S-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VD_S*(x_s_VD_S*3.3333333333333333e-01)+x_s_VD_S*x_s_VD_S*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VD_S_VD_S-0.0)*3.3333333333333333e-01+x_s_VD_S*0.0+x_s_VD_S*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))))*(((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Es_VD_S_VGP_S=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VD_S_VGP_S-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VD_S*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01))))))+x_s_VGP_S*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01))))+0.0*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01))+0.5*(+(+x_s_VD_S_VGP_S-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VD_S*(x_s_VGP_S*3.3333333333333333e-01)+x_s_VGP_S*x_s_VD_S*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VD_S_VGP_S-0.0)*3.3333333333333333e-01+x_s_VD_S*0.0+x_s_VGP_S*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))))*(((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Es_VD_S_VS_BP=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VD_S_VS_BP-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VD_S*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01))))))+x_s_VS_BP*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01))))+0.0*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01))+0.5*(+(+x_s_VD_S_VS_BP-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VD_S*(x_s_VS_BP*3.3333333333333333e-01)+x_s_VS_BP*x_s_VD_S*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VD_S_VS_BP-0.0)*3.3333333333333333e-01+x_s_VD_S*0.0+x_s_VS_BP*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VD_S*3.3333333333333333e-01)))))*(((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
Es_VGP_S=(-1.0e-100*((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Es_VGP_S_VD_S=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VGP_S_VD_S-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VGP_S*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01))))))+x_s_VD_S*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01))))+0.0*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_s_VGP_S_VD_S-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VGP_S*(x_s_VD_S*3.3333333333333333e-01)+x_s_VD_S*x_s_VGP_S*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VGP_S_VD_S-0.0)*3.3333333333333333e-01+x_s_VGP_S*0.0+x_s_VD_S*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))))*(((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Es_VGP_S_VGP_S=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VGP_S_VGP_S-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VGP_S*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01))))))+x_s_VGP_S*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01))))+0.0*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_s_VGP_S_VGP_S-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VGP_S*(x_s_VGP_S*3.3333333333333333e-01)+x_s_VGP_S*x_s_VGP_S*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+x_s_VGP_S*0.0+x_s_VGP_S*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))))*(((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Es_VGP_S_VS_BP=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VGP_S_VS_BP-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VGP_S*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01))))))+x_s_VS_BP*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01))))+0.0*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_s_VGP_S_VS_BP-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VGP_S*(x_s_VS_BP*3.3333333333333333e-01)+x_s_VS_BP*x_s_VGP_S*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+x_s_VGP_S*0.0+x_s_VS_BP*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VGP_S*3.3333333333333333e-01)))))*(((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
Es_VS_BP=(-1.0e-100*((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Es_VS_BP_VD_S=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VS_BP_VD_S-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VS_BP*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01))))))+x_s_VD_S*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01))))+0.0*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_s_VS_BP_VD_S-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VS_BP*(x_s_VD_S*3.3333333333333333e-01)+x_s_VD_S*x_s_VS_BP*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VS_BP_VD_S-0.0)*3.3333333333333333e-01+x_s_VS_BP*0.0+x_s_VD_S*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))))*(((x_s_VD_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VD_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VD_S*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Es_VS_BP_VGP_S=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VS_BP_VGP_S-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VS_BP*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01))))))+x_s_VGP_S*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01))))+0.0*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_s_VS_BP_VGP_S-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VS_BP*(x_s_VGP_S*3.3333333333333333e-01)+x_s_VGP_S*x_s_VS_BP*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+x_s_VS_BP*0.0+x_s_VGP_S*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))))*(((x_s_VGP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VGP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Es_VS_BP_VS_BP=(0.0/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_s_VS_BP_VS_BP-0.0)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_s_VS_BP*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01))))))+x_s_VS_BP*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))+(x_s-2.3025850929940458e+02)*(+0.0+(+0.0*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01))))+0.0*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_s_VS_BP_VS_BP-0.0)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))+x_s_VS_BP*(x_s_VS_BP*3.3333333333333333e-01)+x_s_VS_BP*x_s_VS_BP*3.3333333333333333e-01+(x_s-2.3025850929940458e+02)*(+0.0+(+(+x_s_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+x_s_VS_BP*0.0+x_s_VS_BP*0.0+(x_s-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*(0.5*((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*x_s_VS_BP*3.3333333333333333e-01)))))*(((x_s_VS_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_s-2.3025850929940458e+02)*((0.5*(((x_s_VS_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_s-2.3025850929940458e+02)*(x_s_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
#endif
Es=(1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ds_VD_S=(delta_1s_VD_S-((delta_ns_VD_S*((x_s+1.0)+xi0s))+(delta_ns*(x_s_VD_S+xi0s_VD_S))));
#if defined(_DERIVATE2)
  Ds_VD_S_VD_S=(+delta_1s_VD_S_VD_S-(+delta_ns_VD_S_VD_S*((x_s+1.0)+xi0s)+delta_ns_VD_S*(x_s_VD_S+xi0s_VD_S)+delta_ns_VD_S*(x_s_VD_S+xi0s_VD_S)+delta_ns*(+(+x_s_VD_S_VD_S+0.0)+xi0s_VD_S_VD_S)));
  Ds_VD_S_VGP_S=(+delta_1s_VD_S_VGP_S-(+0.0*((x_s+1.0)+xi0s)+delta_ns_VD_S*(x_s_VGP_S+xi0s_VGP_S)+0.0*(x_s_VD_S+xi0s_VD_S)+delta_ns*(+(+x_s_VD_S_VGP_S+0.0)+xi0s_VD_S_VGP_S)));
  Ds_VD_S_VS_BP=(+delta_1s_VD_S_VS_BP-(+delta_ns_VD_S_VS_BP*((x_s+1.0)+xi0s)+delta_ns_VD_S*(x_s_VS_BP+xi0s_VS_BP)+delta_ns_VS_BP*(x_s_VD_S+xi0s_VD_S)+delta_ns*(+(+x_s_VD_S_VS_BP+0.0)+xi0s_VD_S_VS_BP)));
#endif
Ds_VGP_S=(delta_1s_VGP_S-(delta_ns*(x_s_VGP_S+xi0s_VGP_S)));
#if defined(_DERIVATE2)
  Ds_VGP_S_VD_S=(+delta_1s_VGP_S_VD_S-(+0.0*((x_s+1.0)+xi0s)+0.0*(x_s_VD_S+xi0s_VD_S)+delta_ns_VD_S*(x_s_VGP_S+xi0s_VGP_S)+delta_ns*(+(+x_s_VGP_S_VD_S+0.0)+xi0s_VGP_S_VD_S)));
  Ds_VGP_S_VGP_S=(+delta_1s_VGP_S_VGP_S-(+0.0*((x_s+1.0)+xi0s)+0.0*(x_s_VGP_S+xi0s_VGP_S)+0.0*(x_s_VGP_S+xi0s_VGP_S)+delta_ns*(+(+x_s_VGP_S_VGP_S+0.0)+xi0s_VGP_S_VGP_S)));
  Ds_VGP_S_VS_BP=(+delta_1s_VGP_S_VS_BP-(+0.0*((x_s+1.0)+xi0s)+0.0*(x_s_VS_BP+xi0s_VS_BP)+delta_ns_VS_BP*(x_s_VGP_S+xi0s_VGP_S)+delta_ns*(+(+x_s_VGP_S_VS_BP+0.0)+xi0s_VGP_S_VS_BP)));
#endif
Ds_VS_BP=(delta_1s_VS_BP-((delta_ns_VS_BP*((x_s+1.0)+xi0s))+(delta_ns*(x_s_VS_BP+xi0s_VS_BP))));
#if defined(_DERIVATE2)
  Ds_VS_BP_VD_S=(+delta_1s_VS_BP_VD_S-(+delta_ns_VS_BP_VD_S*((x_s+1.0)+xi0s)+delta_ns_VS_BP*(x_s_VD_S+xi0s_VD_S)+delta_ns_VD_S*(x_s_VS_BP+xi0s_VS_BP)+delta_ns*(+(+x_s_VS_BP_VD_S+0.0)+xi0s_VS_BP_VD_S)));
  Ds_VS_BP_VGP_S=(+delta_1s_VS_BP_VGP_S-(+0.0*((x_s+1.0)+xi0s)+delta_ns_VS_BP*(x_s_VGP_S+xi0s_VGP_S)+0.0*(x_s_VS_BP+xi0s_VS_BP)+delta_ns*(+(+x_s_VS_BP_VGP_S+0.0)+xi0s_VS_BP_VGP_S)));
  Ds_VS_BP_VS_BP=(+delta_1s_VS_BP_VS_BP-(+delta_ns_VS_BP_VS_BP*((x_s+1.0)+xi0s)+delta_ns_VS_BP*(x_s_VS_BP+xi0s_VS_BP)+delta_ns_VS_BP*(x_s_VS_BP+xi0s_VS_BP)+delta_ns*(+(+x_s_VS_BP_VS_BP+0.0)+xi0s_VS_BP_VS_BP)));
#endif
#endif
Ds=(delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
EXIT_IF_ISNAN((delta_1s-(delta_ns*((x_s+1.0)+xi0s))))
if
((x_s<1.0e-5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Ps_VD_S=(0.5*((((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S)))))))));
#if defined(_DERIVATE2)
  Ps_VD_S_VD_S=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))))))))+0.0*((((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))))+0.5*(+(+x_s_VD_S_VD_S*x_s+x_s_VD_S*x_s_VD_S+x_s_VD_S*x_s_VD_S+x_s*x_s_VD_S_VD_S)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S)))))))))+(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))+0.0*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))+3.3333333333333333e-01*(+x_s_VD_S_VD_S*(1.0-(0.25*x_s))+x_s_VD_S*(-((0.25*x_s_VD_S)))+x_s_VD_S*(-(0.25*x_s_VD_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VD_S+0.25*x_s_VD_S_VD_S)))))));
  Ps_VD_S_VGP_S=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))))))))+0.0*((((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))))+0.5*(+(+x_s_VD_S_VGP_S*x_s+x_s_VD_S*x_s_VGP_S+x_s_VGP_S*x_s_VD_S+x_s*x_s_VD_S_VGP_S)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S)))))))))+(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))+0.0*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))+3.3333333333333333e-01*(+x_s_VD_S_VGP_S*(1.0-(0.25*x_s))+x_s_VD_S*(-((0.25*x_s_VGP_S)))+x_s_VGP_S*(-(0.25*x_s_VD_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VD_S+0.25*x_s_VD_S_VGP_S)))))));
  Ps_VD_S_VS_BP=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))))))))+0.0*((((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))))+0.5*(+(+x_s_VD_S_VS_BP*x_s+x_s_VD_S*x_s_VS_BP+x_s_VS_BP*x_s_VD_S+x_s*x_s_VD_S_VS_BP)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VD_S*x_s)+(x_s*x_s_VD_S))*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP)))))))))+(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))+0.0*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))+3.3333333333333333e-01*(+x_s_VD_S_VS_BP*(1.0-(0.25*x_s))+x_s_VD_S*(-((0.25*x_s_VS_BP)))+x_s_VS_BP*(-(0.25*x_s_VD_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VD_S+0.25*x_s_VD_S_VS_BP)))))));
#endif
Ps_VGP_S=(0.5*((((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S)))))))));
#if defined(_DERIVATE2)
  Ps_VGP_S_VD_S=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))))))))+0.0*((((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))))+0.5*(+(+x_s_VGP_S_VD_S*x_s+x_s_VGP_S*x_s_VD_S+x_s_VD_S*x_s_VGP_S+x_s*x_s_VGP_S_VD_S)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S)))))))))+(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))+0.0*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))+3.3333333333333333e-01*(+x_s_VGP_S_VD_S*(1.0-(0.25*x_s))+x_s_VGP_S*(-((0.25*x_s_VD_S)))+x_s_VD_S*(-(0.25*x_s_VGP_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VGP_S+0.25*x_s_VGP_S_VD_S)))))));
  Ps_VGP_S_VGP_S=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))))))))+0.0*((((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))))+0.5*(+(+x_s_VGP_S_VGP_S*x_s+x_s_VGP_S*x_s_VGP_S+x_s_VGP_S*x_s_VGP_S+x_s*x_s_VGP_S_VGP_S)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S)))))))))+(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))+0.0*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))+3.3333333333333333e-01*(+x_s_VGP_S_VGP_S*(1.0-(0.25*x_s))+x_s_VGP_S*(-((0.25*x_s_VGP_S)))+x_s_VGP_S*(-(0.25*x_s_VGP_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VGP_S+0.25*x_s_VGP_S_VGP_S)))))));
  Ps_VGP_S_VS_BP=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))))))))+0.0*((((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))))+0.5*(+(+x_s_VGP_S_VS_BP*x_s+x_s_VGP_S*x_s_VS_BP+x_s_VS_BP*x_s_VGP_S+x_s*x_s_VGP_S_VS_BP)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP)))))))))+(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))+0.0*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))+3.3333333333333333e-01*(+x_s_VGP_S_VS_BP*(1.0-(0.25*x_s))+x_s_VGP_S*(-((0.25*x_s_VS_BP)))+x_s_VS_BP*(-(0.25*x_s_VGP_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VGP_S+0.25*x_s_VGP_S_VS_BP)))))));
#endif
Ps_VS_BP=(0.5*((((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP)))))))));
#if defined(_DERIVATE2)
  Ps_VS_BP_VD_S=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))))))))+0.0*((((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))))+0.5*(+(+x_s_VS_BP_VD_S*x_s+x_s_VS_BP*x_s_VD_S+x_s_VD_S*x_s_VS_BP+x_s*x_s_VS_BP_VD_S)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S)))))))))+(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))+0.0*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))+3.3333333333333333e-01*(+x_s_VS_BP_VD_S*(1.0-(0.25*x_s))+x_s_VS_BP*(-((0.25*x_s_VD_S)))+x_s_VD_S*(-(0.25*x_s_VS_BP))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VS_BP+0.25*x_s_VS_BP_VD_S)))))));
  Ps_VS_BP_VGP_S=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))))))))+0.0*((((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))))+0.5*(+(+x_s_VS_BP_VGP_S*x_s+x_s_VS_BP*x_s_VGP_S+x_s_VGP_S*x_s_VS_BP+x_s*x_s_VS_BP_VGP_S)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S)))))))))+(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))+0.0*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))+3.3333333333333333e-01*(+x_s_VS_BP_VGP_S*(1.0-(0.25*x_s))+x_s_VS_BP*(-((0.25*x_s_VGP_S)))+x_s_VGP_S*(-(0.25*x_s_VS_BP))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VS_BP+0.25*x_s_VS_BP_VGP_S)))))));
  Ps_VS_BP_VS_BP=(+0.0*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+0.0*((((((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))))))))+0.0*((((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))+((x_s*x_s)*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))))+0.5*(+(+x_s_VS_BP_VS_BP*x_s+x_s_VS_BP*x_s_VS_BP+x_s_VS_BP*x_s_VS_BP+x_s*x_s_VS_BP_VS_BP)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))+((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP)))))))))+(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))+(x_s*x_s)*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))+0.0*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))+3.3333333333333333e-01*(+x_s_VS_BP_VS_BP*(1.0-(0.25*x_s))+x_s_VS_BP*(-((0.25*x_s_VS_BP)))+x_s_VS_BP*(-(0.25*x_s_VS_BP))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VS_BP+0.25*x_s_VS_BP_VS_BP)))))));
#endif
#endif
Ps=(0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));
EXIT_IF_ISNAN((0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ds_VD_S=(1.6666666666666667e-01*((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VD_S))));
#if defined(_DERIVATE2)
  Ds_VD_S_VD_S=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*((((((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VD_S)))))+0.0*((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VD_S)))+1.6666666666666667e-01*(+(+(+(+delta_ns_VD_S_VD_S*x_s+delta_ns_VD_S*x_s_VD_S+delta_ns_VD_S*x_s_VD_S+delta_ns*x_s_VD_S_VD_S)*x_s+((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s_VD_S+(((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s_VD_S+(delta_ns*x_s)*x_s_VD_S_VD_S)*x_s+((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s_VD_S+((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s_VD_S+((delta_ns*x_s)*x_s)*x_s_VD_S_VD_S)*(1.0+(1.75*x_s))+((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S))*((1.75*x_s_VD_S))+(((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S)))*(1.75*x_s_VD_S)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VD_S+1.75*x_s_VD_S_VD_S))));
  Ds_VD_S_VGP_S=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*(((((((((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VGP_S)))))+0.0*((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VD_S)))+1.6666666666666667e-01*(+(+(+(+0.0*x_s+delta_ns_VD_S*x_s_VGP_S+0.0*x_s_VD_S+delta_ns*x_s_VD_S_VGP_S)*x_s+((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s_VGP_S+((delta_ns*x_s_VGP_S))*x_s_VD_S+(delta_ns*x_s)*x_s_VD_S_VGP_S)*x_s+((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s_VGP_S+(((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s_VD_S+((delta_ns*x_s)*x_s)*x_s_VD_S_VGP_S)*(1.0+(1.75*x_s))+((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S))*((1.75*x_s_VGP_S))+((((((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S)))*(1.75*x_s_VD_S)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VD_S+1.75*x_s_VD_S_VGP_S))));
  Ds_VD_S_VS_BP=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*((((((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VS_BP)))))+0.0*((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VD_S)))+1.6666666666666667e-01*(+(+(+(+delta_ns_VD_S_VS_BP*x_s+delta_ns_VD_S*x_s_VS_BP+delta_ns_VS_BP*x_s_VD_S+delta_ns*x_s_VD_S_VS_BP)*x_s+((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s_VS_BP+(((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s_VD_S+(delta_ns*x_s)*x_s_VD_S_VS_BP)*x_s+((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s_VS_BP+((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s_VD_S+((delta_ns*x_s)*x_s)*x_s_VD_S_VS_BP)*(1.0+(1.75*x_s))+((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S))*x_s)+((delta_ns*x_s)*x_s_VD_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S))*((1.75*x_s_VS_BP))+(((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP)))*(1.75*x_s_VD_S)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VD_S+1.75*x_s_VD_S_VS_BP))));
#endif
Ds_VGP_S=(1.6666666666666667e-01*(((((((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VGP_S))));
#if defined(_DERIVATE2)
  Ds_VGP_S_VD_S=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*((((((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VD_S)))))+0.0*(((((((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VGP_S)))+1.6666666666666667e-01*(+(+(+(+0.0*x_s+0.0*x_s_VD_S+delta_ns_VD_S*x_s_VGP_S+delta_ns*x_s_VGP_S_VD_S)*x_s+(delta_ns*x_s_VGP_S)*x_s_VD_S+(((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s_VGP_S+(delta_ns*x_s)*x_s_VGP_S_VD_S)*x_s+(((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s_VD_S+((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s_VGP_S+((delta_ns*x_s)*x_s)*x_s_VGP_S_VD_S)*(1.0+(1.75*x_s))+(((((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S))*((1.75*x_s_VD_S))+(((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S)))*(1.75*x_s_VGP_S)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VGP_S+1.75*x_s_VGP_S_VD_S))));
  Ds_VGP_S_VGP_S=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*(((((((((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VGP_S)))))+0.0*(((((((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VGP_S)))+1.6666666666666667e-01*(+(+(+(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VGP_S+delta_ns*x_s_VGP_S_VGP_S)*x_s+(delta_ns*x_s_VGP_S)*x_s_VGP_S+((delta_ns*x_s_VGP_S))*x_s_VGP_S+(delta_ns*x_s)*x_s_VGP_S_VGP_S)*x_s+(((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s_VGP_S+(((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s_VGP_S+((delta_ns*x_s)*x_s)*x_s_VGP_S_VGP_S)*(1.0+(1.75*x_s))+(((((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S))*((1.75*x_s_VGP_S))+((((((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S)))*(1.75*x_s_VGP_S)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VGP_S+1.75*x_s_VGP_S_VGP_S))));
  Ds_VGP_S_VS_BP=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*((((((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VS_BP)))))+0.0*(((((((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VGP_S)))+1.6666666666666667e-01*(+(+(+(+0.0*x_s+0.0*x_s_VS_BP+delta_ns_VS_BP*x_s_VGP_S+delta_ns*x_s_VGP_S_VS_BP)*x_s+(delta_ns*x_s_VGP_S)*x_s_VS_BP+(((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s_VGP_S+(delta_ns*x_s)*x_s_VGP_S_VS_BP)*x_s+(((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s_VS_BP+((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s_VGP_S+((delta_ns*x_s)*x_s)*x_s_VGP_S_VS_BP)*(1.0+(1.75*x_s))+(((((delta_ns*x_s_VGP_S)*x_s)+((delta_ns*x_s)*x_s_VGP_S))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S))*((1.75*x_s_VS_BP))+(((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP)))*(1.75*x_s_VGP_S)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VGP_S+1.75*x_s_VGP_S_VS_BP))));
#endif
Ds_VS_BP=(1.6666666666666667e-01*((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VS_BP))));
#if defined(_DERIVATE2)
  Ds_VS_BP_VD_S=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*((((((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VD_S)))))+0.0*((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VS_BP)))+1.6666666666666667e-01*(+(+(+(+delta_ns_VS_BP_VD_S*x_s+delta_ns_VS_BP*x_s_VD_S+delta_ns_VD_S*x_s_VS_BP+delta_ns*x_s_VS_BP_VD_S)*x_s+((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s_VD_S+(((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s_VS_BP+(delta_ns*x_s)*x_s_VS_BP_VD_S)*x_s+((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s_VD_S+((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s_VS_BP+((delta_ns*x_s)*x_s)*x_s_VS_BP_VD_S)*(1.0+(1.75*x_s))+((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP))*((1.75*x_s_VD_S))+(((((((((delta_ns_VD_S*x_s)+(delta_ns*x_s_VD_S)))*x_s)+((delta_ns*x_s)*x_s_VD_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VD_S)))*(1.75*x_s_VS_BP)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VS_BP+1.75*x_s_VS_BP_VD_S))));
  Ds_VS_BP_VGP_S=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*(((((((((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VGP_S)))))+0.0*((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VS_BP)))+1.6666666666666667e-01*(+(+(+(+0.0*x_s+delta_ns_VS_BP*x_s_VGP_S+0.0*x_s_VS_BP+delta_ns*x_s_VS_BP_VGP_S)*x_s+((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s_VGP_S+((delta_ns*x_s_VGP_S))*x_s_VS_BP+(delta_ns*x_s)*x_s_VS_BP_VGP_S)*x_s+((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s_VGP_S+(((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s_VS_BP+((delta_ns*x_s)*x_s)*x_s_VS_BP_VGP_S)*(1.0+(1.75*x_s))+((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP))*((1.75*x_s_VGP_S))+((((((((delta_ns*x_s_VGP_S))*x_s)+((delta_ns*x_s)*x_s_VGP_S)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VGP_S)))*(1.75*x_s_VS_BP)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VS_BP+1.75*x_s_VS_BP_VGP_S))));
  Ds_VS_BP_VS_BP=(+0.0*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))+0.0*((((((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP)))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*((1.75*x_s_VS_BP)))))+0.0*((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP))*(1.0+(1.75*x_s)))+((((delta_ns*x_s)*x_s)*x_s)*(1.75*x_s_VS_BP)))+1.6666666666666667e-01*(+(+(+(+delta_ns_VS_BP_VS_BP*x_s+delta_ns_VS_BP*x_s_VS_BP+delta_ns_VS_BP*x_s_VS_BP+delta_ns*x_s_VS_BP_VS_BP)*x_s+((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s_VS_BP+(((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s_VS_BP+(delta_ns*x_s)*x_s_VS_BP_VS_BP)*x_s+((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s_VS_BP+((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s_VS_BP+((delta_ns*x_s)*x_s)*x_s_VS_BP_VS_BP)*(1.0+(1.75*x_s))+((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP))*x_s)+((delta_ns*x_s)*x_s_VS_BP))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP))*((1.75*x_s_VS_BP))+(((((((((delta_ns_VS_BP*x_s)+(delta_ns*x_s_VS_BP)))*x_s)+((delta_ns*x_s)*x_s_VS_BP)))*x_s)+(((delta_ns*x_s)*x_s)*x_s_VS_BP)))*(1.75*x_s_VS_BP)+(((delta_ns*x_s)*x_s)*x_s)*(+0.0+(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VS_BP+1.75*x_s_VS_BP_VS_BP))));
#endif
#endif
Ds=(1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
EXIT_IF_ISNAN((1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)))))
{
double m00_sqrt(d00_sqrt0,(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))*d10_sqrt0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*((x_s*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*((x_s*(-(0.0))))+0.0*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_s))+x_s_VGP_S*(-(0.0))+0.0*(-(0.25*x_s_VGP_S))+x_s*(+0.0-(+0.0*x_s+0.0*0.0+0.0*x_s_VGP_S+0.25*0.0))))));
  temp_VGP_S_VS_BS=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*((x_s*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*((x_s*(-(0.0))))+0.0*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_s))+x_s_VGP_S*(-(0.0))+0.0*(-(0.25*x_s_VGP_S))+x_s*(+0.0-(+0.0*x_s+0.0*0.0+0.0*x_s_VGP_S+0.25*0.0))))));
  temp_VGP_S_VGP_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S)))))))))*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))+0.0*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))+3.3333333333333333e-01*(+x_s_VGP_S_VGP_S*(1.0-(0.25*x_s))+x_s_VGP_S*(-((0.25*x_s_VGP_S)))+x_s_VGP_S*(-(0.25*x_s_VGP_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VGP_S+0.25*x_s_VGP_S_VGP_S))))));
  temp_VGP_S_VD_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S)))))))))*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))+0.0*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))+3.3333333333333333e-01*(+x_s_VGP_S_VD_S*(1.0-(0.25*x_s))+x_s_VGP_S*(-((0.25*x_s_VD_S)))+x_s_VD_S*(-(0.25*x_s_VGP_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VGP_S+0.25*x_s_VGP_S_VD_S))))));
  temp_VGP_S_VS_BP=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP)))))))))*(-(3.3333333333333333e-01*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))+0.0*((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VGP_S))))+3.3333333333333333e-01*(+x_s_VGP_S_VS_BP*(1.0-(0.25*x_s))+x_s_VGP_S*(-((0.25*x_s_VS_BP)))+x_s_VS_BP*(-(0.25*x_s_VGP_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VGP_S+0.25*x_s_VGP_S_VS_BP))))));
#endif
temp_VD_S=(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))*d10_sqrt0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*((x_s*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*((x_s*(-(0.0))))+0.0*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_s))+x_s_VD_S*(-(0.0))+0.0*(-(0.25*x_s_VD_S))+x_s*(+0.0-(+0.0*x_s+0.0*0.0+0.0*x_s_VD_S+0.25*0.0))))));
  temp_VD_S_VS_BS=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*((x_s*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*((x_s*(-(0.0))))+0.0*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_s))+x_s_VD_S*(-(0.0))+0.0*(-(0.25*x_s_VD_S))+x_s*(+0.0-(+0.0*x_s+0.0*0.0+0.0*x_s_VD_S+0.25*0.0))))));
  temp_VD_S_VGP_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S)))))))))*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))+0.0*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))+3.3333333333333333e-01*(+x_s_VD_S_VGP_S*(1.0-(0.25*x_s))+x_s_VD_S*(-((0.25*x_s_VGP_S)))+x_s_VGP_S*(-(0.25*x_s_VD_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VD_S+0.25*x_s_VD_S_VGP_S))))));
  temp_VD_S_VD_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S)))))))))*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))+0.0*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))+3.3333333333333333e-01*(+x_s_VD_S_VD_S*(1.0-(0.25*x_s))+x_s_VD_S*(-((0.25*x_s_VD_S)))+x_s_VD_S*(-(0.25*x_s_VD_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VD_S+0.25*x_s_VD_S_VD_S))))));
  temp_VD_S_VS_BP=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP)))))))))*(-(3.3333333333333333e-01*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))+0.0*((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VD_S))))+3.3333333333333333e-01*(+x_s_VD_S_VS_BP*(1.0-(0.25*x_s))+x_s_VD_S*(-((0.25*x_s_VS_BP)))+x_s_VS_BP*(-(0.25*x_s_VD_S))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VD_S+0.25*x_s_VD_S_VS_BP))))));
#endif
temp_VS_BP=(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))*d10_sqrt0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*((x_s*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*((x_s*(-(0.0))))+0.0*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_s))+x_s_VS_BP*(-(0.0))+0.0*(-(0.25*x_s_VS_BP))+x_s*(+0.0-(+0.0*x_s+0.0*0.0+0.0*x_s_VS_BP+0.25*0.0))))));
  temp_VS_BP_VS_BS=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*((x_s*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*((x_s*(-(0.0))))+0.0*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_s))+x_s_VS_BP*(-(0.0))+0.0*(-(0.25*x_s_VS_BP))+x_s*(+0.0-(+0.0*x_s+0.0*0.0+0.0*x_s_VS_BP+0.25*0.0))))));
  temp_VS_BP_VGP_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S)))))))))*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VGP_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VGP_S))))))+0.0*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))+3.3333333333333333e-01*(+x_s_VS_BP_VGP_S*(1.0-(0.25*x_s))+x_s_VS_BP*(-((0.25*x_s_VGP_S)))+x_s_VGP_S*(-(0.25*x_s_VS_BP))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VS_BP+0.25*x_s_VS_BP_VGP_S))))));
  temp_VS_BP_VD_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S)))))))))*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VD_S*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VD_S))))))+0.0*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))+3.3333333333333333e-01*(+x_s_VS_BP_VD_S*(1.0-(0.25*x_s))+x_s_VS_BP*(-((0.25*x_s_VD_S)))+x_s_VD_S*(-(0.25*x_s_VS_BP))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VS_BP+0.25*x_s_VS_BP_VD_S))))));
  temp_VS_BP_VS_BP=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))))*(-((3.3333333333333333e-01*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP)))))))))*(-(3.3333333333333333e-01*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_s*(1.0-(0.25*x_s)))+0.0*(((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-((0.25*x_s_VS_BP))))))+0.0*((x_s_VS_BP*(1.0-(0.25*x_s)))+(x_s*(-(0.25*x_s_VS_BP))))+3.3333333333333333e-01*(+x_s_VS_BP_VS_BP*(1.0-(0.25*x_s))+x_s_VS_BP*(-((0.25*x_s_VS_BP)))+x_s_VS_BP*(-(0.25*x_s_VS_BP))+x_s*(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VS_BP+0.25*x_s_VS_BP_VS_BP))))));
#endif
#endif
temp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
sqm_VD_S=(7.0710678118654746e-01*((x_s_VD_S*temp)+(x_s*temp_VD_S)));
#if defined(_DERIVATE2)
  sqm_VD_S_VD_S=(+0.0*(x_s*temp)+0.0*(((x_s_VD_S*temp)+(x_s*temp_VD_S)))+0.0*((x_s_VD_S*temp)+(x_s*temp_VD_S))+7.0710678118654746e-01*(+x_s_VD_S_VD_S*temp+x_s_VD_S*temp_VD_S+x_s_VD_S*temp_VD_S+x_s*temp_VD_S_VD_S));
  sqm_VD_S_VGP_S=(+0.0*(x_s*temp)+0.0*(((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))+0.0*((x_s_VD_S*temp)+(x_s*temp_VD_S))+7.0710678118654746e-01*(+x_s_VD_S_VGP_S*temp+x_s_VD_S*temp_VGP_S+x_s_VGP_S*temp_VD_S+x_s*temp_VD_S_VGP_S));
  sqm_VD_S_VS_BP=(+0.0*(x_s*temp)+0.0*(((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))+0.0*((x_s_VD_S*temp)+(x_s*temp_VD_S))+7.0710678118654746e-01*(+x_s_VD_S_VS_BP*temp+x_s_VD_S*temp_VS_BP+x_s_VS_BP*temp_VD_S+x_s*temp_VD_S_VS_BP));
#endif
sqm_VGP_S=(7.0710678118654746e-01*((x_s_VGP_S*temp)+(x_s*temp_VGP_S)));
#if defined(_DERIVATE2)
  sqm_VGP_S_VD_S=(+0.0*(x_s*temp)+0.0*(((x_s_VD_S*temp)+(x_s*temp_VD_S)))+0.0*((x_s_VGP_S*temp)+(x_s*temp_VGP_S))+7.0710678118654746e-01*(+x_s_VGP_S_VD_S*temp+x_s_VGP_S*temp_VD_S+x_s_VD_S*temp_VGP_S+x_s*temp_VGP_S_VD_S));
  sqm_VGP_S_VGP_S=(+0.0*(x_s*temp)+0.0*(((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))+0.0*((x_s_VGP_S*temp)+(x_s*temp_VGP_S))+7.0710678118654746e-01*(+x_s_VGP_S_VGP_S*temp+x_s_VGP_S*temp_VGP_S+x_s_VGP_S*temp_VGP_S+x_s*temp_VGP_S_VGP_S));
  sqm_VGP_S_VS_BP=(+0.0*(x_s*temp)+0.0*(((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))+0.0*((x_s_VGP_S*temp)+(x_s*temp_VGP_S))+7.0710678118654746e-01*(+x_s_VGP_S_VS_BP*temp+x_s_VGP_S*temp_VS_BP+x_s_VS_BP*temp_VGP_S+x_s*temp_VGP_S_VS_BP));
#endif
sqm_VS_BP=(7.0710678118654746e-01*((x_s_VS_BP*temp)+(x_s*temp_VS_BP)));
#if defined(_DERIVATE2)
  sqm_VS_BP_VD_S=(+0.0*(x_s*temp)+0.0*(((x_s_VD_S*temp)+(x_s*temp_VD_S)))+0.0*((x_s_VS_BP*temp)+(x_s*temp_VS_BP))+7.0710678118654746e-01*(+x_s_VS_BP_VD_S*temp+x_s_VS_BP*temp_VD_S+x_s_VD_S*temp_VS_BP+x_s*temp_VS_BP_VD_S));
  sqm_VS_BP_VGP_S=(+0.0*(x_s*temp)+0.0*(((x_s_VGP_S*temp)+(x_s*temp_VGP_S)))+0.0*((x_s_VS_BP*temp)+(x_s*temp_VS_BP))+7.0710678118654746e-01*(+x_s_VS_BP_VGP_S*temp+x_s_VS_BP*temp_VGP_S+x_s_VGP_S*temp_VS_BP+x_s*temp_VS_BP_VGP_S));
  sqm_VS_BP_VS_BP=(+0.0*(x_s*temp)+0.0*(((x_s_VS_BP*temp)+(x_s*temp_VS_BP)))+0.0*((x_s_VS_BP*temp)+(x_s*temp_VS_BP))+7.0710678118654746e-01*(+x_s_VS_BP_VS_BP*temp+x_s_VS_BP*temp_VS_BP+x_s_VS_BP*temp_VS_BP+x_s*temp_VS_BP_VS_BP));
#endif
#endif
sqm=(7.0710678118654746e-01*(x_s*temp));
EXIT_IF_ISNAN((7.0710678118654746e-01*(x_s*temp)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
alpha_VD_S=((((Gf_VD_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VD_S))+(1.6666666666666667e-01*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))))*temp-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VD_S)/temp/temp);
#if defined(_DERIVATE2)
  alpha_VD_S_VD_S=(+0.0+((+(+Gf_VD_S_VD_S*7.0710678118654746e-01+Gf_VD_S*0.0+Gf_VD_S*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VD_S*7.0710678118654746e-01*((-((0.5*x_s_VD_S)))+((1.6666666666666667e-01*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))))+(Gf_VD_S*7.0710678118654746e-01)*((-(0.5*x_s_VD_S))+(1.6666666666666667e-01*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VD_S+0.5*x_s_VD_S_VD_S))+(+0.0*(x_s*x_s)+0.0*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))+0.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))+1.6666666666666667e-01*(+x_s_VD_S_VD_S*x_s+x_s_VD_S*x_s_VD_S+x_s_VD_S*x_s_VD_S+x_s*x_s_VD_S_VD_S))))/temp-(((Gf_VD_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VD_S))+(1.6666666666666667e-01*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))))*temp_VD_S+((((Gf_VD_S*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VD_S)))+((1.6666666666666667e-01*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))))))))*temp_VD_S+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VD_S_VD_S)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VD_S*temp_VD_S/temp/temp/temp));
  alpha_VD_S_VGP_S=(+0.0+((+(+Gf_VD_S_VGP_S*7.0710678118654746e-01+Gf_VD_S*0.0+Gf_VGP_S*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VD_S*7.0710678118654746e-01*((-((0.5*x_s_VGP_S)))+((1.6666666666666667e-01*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))))+(Gf_VGP_S*7.0710678118654746e-01)*((-(0.5*x_s_VD_S))+(1.6666666666666667e-01*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VD_S+0.5*x_s_VD_S_VGP_S))+(+0.0*(x_s*x_s)+0.0*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))+0.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))+1.6666666666666667e-01*(+x_s_VD_S_VGP_S*x_s+x_s_VD_S*x_s_VGP_S+x_s_VGP_S*x_s_VD_S+x_s*x_s_VD_S_VGP_S))))/temp-(((Gf_VD_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VD_S))+(1.6666666666666667e-01*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))))*temp_VGP_S+((((Gf_VGP_S*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VGP_S)))+((1.6666666666666667e-01*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))))))))*temp_VD_S+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VD_S_VGP_S)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VD_S*temp_VGP_S/temp/temp/temp));
  alpha_VD_S_VS_BP=(+0.0+((+(+Gf_VD_S_VS_BP*7.0710678118654746e-01+Gf_VD_S*0.0+Gf_VS_BP*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VD_S*7.0710678118654746e-01*((-((0.5*x_s_VS_BP)))+((1.6666666666666667e-01*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))))+(Gf_VS_BP*7.0710678118654746e-01)*((-(0.5*x_s_VD_S))+(1.6666666666666667e-01*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VD_S+0.5*x_s_VD_S_VS_BP))+(+0.0*(x_s*x_s)+0.0*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))+0.0*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))+1.6666666666666667e-01*(+x_s_VD_S_VS_BP*x_s+x_s_VD_S*x_s_VS_BP+x_s_VS_BP*x_s_VD_S+x_s*x_s_VD_S_VS_BP))))/temp-(((Gf_VD_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VD_S))+(1.6666666666666667e-01*((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))))*temp_VS_BP+((((Gf_VS_BP*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VS_BP)))+((1.6666666666666667e-01*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))))))))*temp_VD_S+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VD_S_VS_BP)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VD_S*temp_VS_BP/temp/temp/temp));
#endif
alpha_VGP_S=((((Gf_VGP_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VGP_S))+(1.6666666666666667e-01*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))))*temp-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VGP_S)/temp/temp);
#if defined(_DERIVATE2)
  alpha_VGP_S_VD_S=(+0.0+((+(+Gf_VGP_S_VD_S*7.0710678118654746e-01+Gf_VGP_S*0.0+Gf_VD_S*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VGP_S*7.0710678118654746e-01*((-((0.5*x_s_VD_S)))+((1.6666666666666667e-01*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))))+(Gf_VD_S*7.0710678118654746e-01)*((-(0.5*x_s_VGP_S))+(1.6666666666666667e-01*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VGP_S+0.5*x_s_VGP_S_VD_S))+(+0.0*(x_s*x_s)+0.0*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))+0.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))+1.6666666666666667e-01*(+x_s_VGP_S_VD_S*x_s+x_s_VGP_S*x_s_VD_S+x_s_VD_S*x_s_VGP_S+x_s*x_s_VGP_S_VD_S))))/temp-(((Gf_VGP_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VGP_S))+(1.6666666666666667e-01*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))))*temp_VD_S+((((Gf_VD_S*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VD_S)))+((1.6666666666666667e-01*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))))))))*temp_VGP_S+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VGP_S_VD_S)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VGP_S*temp_VD_S/temp/temp/temp));
  alpha_VGP_S_VGP_S=(+0.0+((+(+Gf_VGP_S_VGP_S*7.0710678118654746e-01+Gf_VGP_S*0.0+Gf_VGP_S*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VGP_S*7.0710678118654746e-01*((-((0.5*x_s_VGP_S)))+((1.6666666666666667e-01*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))))+(Gf_VGP_S*7.0710678118654746e-01)*((-(0.5*x_s_VGP_S))+(1.6666666666666667e-01*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VGP_S+0.5*x_s_VGP_S_VGP_S))+(+0.0*(x_s*x_s)+0.0*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))+0.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))+1.6666666666666667e-01*(+x_s_VGP_S_VGP_S*x_s+x_s_VGP_S*x_s_VGP_S+x_s_VGP_S*x_s_VGP_S+x_s*x_s_VGP_S_VGP_S))))/temp-(((Gf_VGP_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VGP_S))+(1.6666666666666667e-01*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))))*temp_VGP_S+((((Gf_VGP_S*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VGP_S)))+((1.6666666666666667e-01*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))))))))*temp_VGP_S+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VGP_S_VGP_S)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VGP_S*temp_VGP_S/temp/temp/temp));
  alpha_VGP_S_VS_BP=(+0.0+((+(+Gf_VGP_S_VS_BP*7.0710678118654746e-01+Gf_VGP_S*0.0+Gf_VS_BP*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VGP_S*7.0710678118654746e-01*((-((0.5*x_s_VS_BP)))+((1.6666666666666667e-01*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))))+(Gf_VS_BP*7.0710678118654746e-01)*((-(0.5*x_s_VGP_S))+(1.6666666666666667e-01*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VGP_S+0.5*x_s_VGP_S_VS_BP))+(+0.0*(x_s*x_s)+0.0*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))+0.0*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))+1.6666666666666667e-01*(+x_s_VGP_S_VS_BP*x_s+x_s_VGP_S*x_s_VS_BP+x_s_VS_BP*x_s_VGP_S+x_s*x_s_VGP_S_VS_BP))))/temp-(((Gf_VGP_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VGP_S))+(1.6666666666666667e-01*((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))))*temp_VS_BP+((((Gf_VS_BP*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VS_BP)))+((1.6666666666666667e-01*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))))))))*temp_VGP_S+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VGP_S_VS_BP)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VGP_S*temp_VS_BP/temp/temp/temp));
#endif
alpha_VS_BP=((((Gf_VS_BP*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VS_BP))+(1.6666666666666667e-01*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))))*temp-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VS_BP)/temp/temp);
#if defined(_DERIVATE2)
  alpha_VS_BP_VD_S=(+0.0+((+(+Gf_VS_BP_VD_S*7.0710678118654746e-01+Gf_VS_BP*0.0+Gf_VD_S*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VS_BP*7.0710678118654746e-01*((-((0.5*x_s_VD_S)))+((1.6666666666666667e-01*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S))))))+(Gf_VD_S*7.0710678118654746e-01)*((-(0.5*x_s_VS_BP))+(1.6666666666666667e-01*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VD_S+0.0*x_s_VS_BP+0.5*x_s_VS_BP_VD_S))+(+0.0*(x_s*x_s)+0.0*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))+0.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))+1.6666666666666667e-01*(+x_s_VS_BP_VD_S*x_s+x_s_VS_BP*x_s_VD_S+x_s_VD_S*x_s_VS_BP+x_s*x_s_VS_BP_VD_S))))/temp-(((Gf_VS_BP*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VS_BP))+(1.6666666666666667e-01*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))))*temp_VD_S+((((Gf_VD_S*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VD_S)))+((1.6666666666666667e-01*(((x_s_VD_S*x_s)+(x_s*x_s_VD_S)))))))))*temp_VS_BP+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VS_BP_VD_S)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VS_BP*temp_VD_S/temp/temp/temp));
  alpha_VS_BP_VGP_S=(+0.0+((+(+Gf_VS_BP_VGP_S*7.0710678118654746e-01+Gf_VS_BP*0.0+Gf_VGP_S*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VS_BP*7.0710678118654746e-01*((-((0.5*x_s_VGP_S)))+((1.6666666666666667e-01*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S))))))+(Gf_VGP_S*7.0710678118654746e-01)*((-(0.5*x_s_VS_BP))+(1.6666666666666667e-01*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VGP_S+0.0*x_s_VS_BP+0.5*x_s_VS_BP_VGP_S))+(+0.0*(x_s*x_s)+0.0*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))+0.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))+1.6666666666666667e-01*(+x_s_VS_BP_VGP_S*x_s+x_s_VS_BP*x_s_VGP_S+x_s_VGP_S*x_s_VS_BP+x_s*x_s_VS_BP_VGP_S))))/temp-(((Gf_VS_BP*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VS_BP))+(1.6666666666666667e-01*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))))*temp_VGP_S+((((Gf_VGP_S*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VGP_S)))+((1.6666666666666667e-01*(((x_s_VGP_S*x_s)+(x_s*x_s_VGP_S)))))))))*temp_VS_BP+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VS_BP_VGP_S)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VS_BP*temp_VGP_S/temp/temp/temp));
  alpha_VS_BP_VS_BP=(+0.0+((+(+Gf_VS_BP_VS_BP*7.0710678118654746e-01+Gf_VS_BP*0.0+Gf_VS_BP*0.0+Gf*0.0)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s)))+Gf_VS_BP*7.0710678118654746e-01*((-((0.5*x_s_VS_BP)))+((1.6666666666666667e-01*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))))+(Gf_VS_BP*7.0710678118654746e-01)*((-(0.5*x_s_VS_BP))+(1.6666666666666667e-01*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))+(Gf*7.0710678118654746e-01)*(+(+0.0-(+0.0*x_s+0.0*x_s_VS_BP+0.0*x_s_VS_BP+0.5*x_s_VS_BP_VS_BP))+(+0.0*(x_s*x_s)+0.0*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))+0.0*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))+1.6666666666666667e-01*(+x_s_VS_BP_VS_BP*x_s+x_s_VS_BP*x_s_VS_BP+x_s_VS_BP*x_s_VS_BP+x_s*x_s_VS_BP_VS_BP))))/temp-(((Gf_VS_BP*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-(0.5*x_s_VS_BP))+(1.6666666666666667e-01*((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP))))))*temp_VS_BP+((((Gf_VS_BP*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))+((Gf*7.0710678118654746e-01)*((-((0.5*x_s_VS_BP)))+((1.6666666666666667e-01*(((x_s_VS_BP*x_s)+(x_s*x_s_VS_BP)))))))))*temp_VS_BP+((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VS_BP_VS_BP)/temp/temp+2*((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*temp_VS_BP*temp_VS_BP/temp/temp/temp));
#endif
#endif
pInst->alpha=(1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
EXIT_IF_ISNAN((1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Ps_VD_S=(x_s_VD_S+Es_VD_S);
#if defined(_DERIVATE2)
  Ps_VD_S_VD_S=(+(+x_s_VD_S_VD_S-0.0)+Es_VD_S_VD_S);
  Ps_VD_S_VGP_S=(+(+x_s_VD_S_VGP_S-0.0)+Es_VD_S_VGP_S);
  Ps_VD_S_VS_BP=(+(+x_s_VD_S_VS_BP-0.0)+Es_VD_S_VS_BP);
#endif
Ps_VGP_S=(x_s_VGP_S+Es_VGP_S);
#if defined(_DERIVATE2)
  Ps_VGP_S_VD_S=(+(+x_s_VGP_S_VD_S-0.0)+Es_VGP_S_VD_S);
  Ps_VGP_S_VGP_S=(+(+x_s_VGP_S_VGP_S-0.0)+Es_VGP_S_VGP_S);
  Ps_VGP_S_VS_BP=(+(+x_s_VGP_S_VS_BP-0.0)+Es_VGP_S_VS_BP);
#endif
Ps_VS_BP=(x_s_VS_BP+Es_VS_BP);
#if defined(_DERIVATE2)
  Ps_VS_BP_VD_S=(+(+x_s_VS_BP_VD_S-0.0)+Es_VS_BP_VD_S);
  Ps_VS_BP_VGP_S=(+(+x_s_VS_BP_VGP_S-0.0)+Es_VS_BP_VGP_S);
  Ps_VS_BP_VS_BP=(+(+x_s_VS_BP_VS_BP-0.0)+Es_VS_BP_VS_BP);
#endif
#endif
Ps=((x_s-1.0)+Es);
EXIT_IF_ISNAN(((x_s-1.0)+Es))
{
double m00_sqrt(d00_sqrt0,Ps)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,Ps)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
sqm_VD_S=Ps_VD_S*d10_sqrt0;
#if defined(_DERIVATE2)
  sqm_VD_S_VD_S=(m20_sqrt(Ps)*Ps_VD_S*Ps_VD_S+d10_sqrt0*Ps_VD_S_VD_S);
  sqm_VD_S_VGP_S=(m20_sqrt(Ps)*Ps_VGP_S*Ps_VD_S+d10_sqrt0*Ps_VD_S_VGP_S);
  sqm_VD_S_VS_BP=(m20_sqrt(Ps)*Ps_VS_BP*Ps_VD_S+d10_sqrt0*Ps_VD_S_VS_BP);
#endif
sqm_VGP_S=Ps_VGP_S*d10_sqrt0;
#if defined(_DERIVATE2)
  sqm_VGP_S_VD_S=(m20_sqrt(Ps)*Ps_VD_S*Ps_VGP_S+d10_sqrt0*Ps_VGP_S_VD_S);
  sqm_VGP_S_VGP_S=(m20_sqrt(Ps)*Ps_VGP_S*Ps_VGP_S+d10_sqrt0*Ps_VGP_S_VGP_S);
  sqm_VGP_S_VS_BP=(m20_sqrt(Ps)*Ps_VS_BP*Ps_VGP_S+d10_sqrt0*Ps_VGP_S_VS_BP);
#endif
sqm_VS_BP=Ps_VS_BP*d10_sqrt0;
#if defined(_DERIVATE2)
  sqm_VS_BP_VD_S=(m20_sqrt(Ps)*Ps_VD_S*Ps_VS_BP+d10_sqrt0*Ps_VS_BP_VD_S);
  sqm_VS_BP_VGP_S=(m20_sqrt(Ps)*Ps_VGP_S*Ps_VS_BP+d10_sqrt0*Ps_VS_BP_VGP_S);
  sqm_VS_BP_VS_BP=(m20_sqrt(Ps)*Ps_VS_BP*Ps_VS_BP+d10_sqrt0*Ps_VS_BP_VS_BP);
#endif
#endif
sqm=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
alpha_VD_S=(0.5*((((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S)))*sqm-(Gf*(1.0-Es))*sqm_VD_S)/sqm/sqm));
#if defined(_DERIVATE2)
  alpha_VD_S_VD_S=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S))))*sqm-(Gf*(1.0-Es))*sqm_VD_S)/sqm/sqm)+0.0*((((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S)))*sqm-(Gf*(1.0-Es))*sqm_VD_S)/sqm/sqm)+0.5*((+Gf_VD_S_VD_S*(1.0-Es)+Gf_VD_S*(-Es_VD_S)+Gf_VD_S*(-Es_VD_S)+Gf*(+0.0-Es_VD_S_VD_S))/sqm-(((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S)))*sqm_VD_S+(((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S))))*sqm_VD_S+(Gf*(1.0-Es))*sqm_VD_S_VD_S)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VD_S*sqm_VD_S/sqm/sqm/sqm)));
  alpha_VD_S_VGP_S=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S))))*sqm-(Gf*(1.0-Es))*sqm_VGP_S)/sqm/sqm)+0.0*((((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S)))*sqm-(Gf*(1.0-Es))*sqm_VD_S)/sqm/sqm)+0.5*((+Gf_VD_S_VGP_S*(1.0-Es)+Gf_VD_S*(-Es_VGP_S)+Gf_VGP_S*(-Es_VD_S)+Gf*(+0.0-Es_VD_S_VGP_S))/sqm-(((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S)))*sqm_VGP_S+(((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S))))*sqm_VD_S+(Gf*(1.0-Es))*sqm_VD_S_VGP_S)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VD_S*sqm_VGP_S/sqm/sqm/sqm)));
  alpha_VD_S_VS_BP=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP))))*sqm-(Gf*(1.0-Es))*sqm_VS_BP)/sqm/sqm)+0.0*((((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S)))*sqm-(Gf*(1.0-Es))*sqm_VD_S)/sqm/sqm)+0.5*((+Gf_VD_S_VS_BP*(1.0-Es)+Gf_VD_S*(-Es_VS_BP)+Gf_VS_BP*(-Es_VD_S)+Gf*(+0.0-Es_VD_S_VS_BP))/sqm-(((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S)))*sqm_VS_BP+(((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP))))*sqm_VD_S+(Gf*(1.0-Es))*sqm_VD_S_VS_BP)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VD_S*sqm_VS_BP/sqm/sqm/sqm)));
#endif
alpha_VGP_S=(0.5*((((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S)))*sqm-(Gf*(1.0-Es))*sqm_VGP_S)/sqm/sqm));
#if defined(_DERIVATE2)
  alpha_VGP_S_VD_S=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S))))*sqm-(Gf*(1.0-Es))*sqm_VD_S)/sqm/sqm)+0.0*((((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S)))*sqm-(Gf*(1.0-Es))*sqm_VGP_S)/sqm/sqm)+0.5*((+Gf_VGP_S_VD_S*(1.0-Es)+Gf_VGP_S*(-Es_VD_S)+Gf_VD_S*(-Es_VGP_S)+Gf*(+0.0-Es_VGP_S_VD_S))/sqm-(((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S)))*sqm_VD_S+(((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S))))*sqm_VGP_S+(Gf*(1.0-Es))*sqm_VGP_S_VD_S)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VGP_S*sqm_VD_S/sqm/sqm/sqm)));
  alpha_VGP_S_VGP_S=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S))))*sqm-(Gf*(1.0-Es))*sqm_VGP_S)/sqm/sqm)+0.0*((((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S)))*sqm-(Gf*(1.0-Es))*sqm_VGP_S)/sqm/sqm)+0.5*((+Gf_VGP_S_VGP_S*(1.0-Es)+Gf_VGP_S*(-Es_VGP_S)+Gf_VGP_S*(-Es_VGP_S)+Gf*(+0.0-Es_VGP_S_VGP_S))/sqm-(((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S)))*sqm_VGP_S+(((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S))))*sqm_VGP_S+(Gf*(1.0-Es))*sqm_VGP_S_VGP_S)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VGP_S*sqm_VGP_S/sqm/sqm/sqm)));
  alpha_VGP_S_VS_BP=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP))))*sqm-(Gf*(1.0-Es))*sqm_VS_BP)/sqm/sqm)+0.0*((((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S)))*sqm-(Gf*(1.0-Es))*sqm_VGP_S)/sqm/sqm)+0.5*((+Gf_VGP_S_VS_BP*(1.0-Es)+Gf_VGP_S*(-Es_VS_BP)+Gf_VS_BP*(-Es_VGP_S)+Gf*(+0.0-Es_VGP_S_VS_BP))/sqm-(((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S)))*sqm_VS_BP+(((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP))))*sqm_VGP_S+(Gf*(1.0-Es))*sqm_VGP_S_VS_BP)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VGP_S*sqm_VS_BP/sqm/sqm/sqm)));
#endif
alpha_VS_BP=(0.5*((((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP)))*sqm-(Gf*(1.0-Es))*sqm_VS_BP)/sqm/sqm));
#if defined(_DERIVATE2)
  alpha_VS_BP_VD_S=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S))))*sqm-(Gf*(1.0-Es))*sqm_VD_S)/sqm/sqm)+0.0*((((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP)))*sqm-(Gf*(1.0-Es))*sqm_VS_BP)/sqm/sqm)+0.5*((+Gf_VS_BP_VD_S*(1.0-Es)+Gf_VS_BP*(-Es_VD_S)+Gf_VD_S*(-Es_VS_BP)+Gf*(+0.0-Es_VS_BP_VD_S))/sqm-(((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP)))*sqm_VD_S+(((Gf_VD_S*(1.0-Es))+(Gf*(-Es_VD_S))))*sqm_VS_BP+(Gf*(1.0-Es))*sqm_VS_BP_VD_S)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VS_BP*sqm_VD_S/sqm/sqm/sqm)));
  alpha_VS_BP_VGP_S=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S))))*sqm-(Gf*(1.0-Es))*sqm_VGP_S)/sqm/sqm)+0.0*((((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP)))*sqm-(Gf*(1.0-Es))*sqm_VS_BP)/sqm/sqm)+0.5*((+Gf_VS_BP_VGP_S*(1.0-Es)+Gf_VS_BP*(-Es_VGP_S)+Gf_VGP_S*(-Es_VS_BP)+Gf*(+0.0-Es_VS_BP_VGP_S))/sqm-(((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP)))*sqm_VGP_S+(((Gf_VGP_S*(1.0-Es))+(Gf*(-Es_VGP_S))))*sqm_VS_BP+(Gf*(1.0-Es))*sqm_VS_BP_VGP_S)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VS_BP*sqm_VGP_S/sqm/sqm/sqm)));
  alpha_VS_BP_VS_BP=(+0.0+(+0.0*((Gf*(1.0-Es))/sqm)+0.0*(((((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP))))*sqm-(Gf*(1.0-Es))*sqm_VS_BP)/sqm/sqm)+0.0*((((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP)))*sqm-(Gf*(1.0-Es))*sqm_VS_BP)/sqm/sqm)+0.5*((+Gf_VS_BP_VS_BP*(1.0-Es)+Gf_VS_BP*(-Es_VS_BP)+Gf_VS_BP*(-Es_VS_BP)+Gf*(+0.0-Es_VS_BP_VS_BP))/sqm-(((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP)))*sqm_VS_BP+(((Gf_VS_BP*(1.0-Es))+(Gf*(-Es_VS_BP))))*sqm_VS_BP+(Gf*(1.0-Es))*sqm_VS_BP_VS_BP)/sqm/sqm+2*(Gf*(1.0-Es))*sqm_VS_BP*sqm_VS_BP/sqm/sqm/sqm)));
#endif
#endif
pInst->alpha=(1.0+(0.5*((Gf*(1.0-Es))/sqm)));
EXIT_IF_ISNAN((1.0+(0.5*((Gf*(1.0-Es))/sqm))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Em_VD_S=Es_VD_S;
#if defined(_DERIVATE2)
  Em_VD_S_VD_S=Es_VD_S_VD_S;
  Em_VD_S_VGP_S=Es_VD_S_VGP_S;
  Em_VD_S_VS_BP=Es_VD_S_VS_BP;
#endif
Em_VGP_S=Es_VGP_S;
#if defined(_DERIVATE2)
  Em_VGP_S_VD_S=Es_VGP_S_VD_S;
  Em_VGP_S_VGP_S=Es_VGP_S_VGP_S;
  Em_VGP_S_VS_BP=Es_VGP_S_VS_BP;
#endif
Em_VS_BP=Es_VS_BP;
#if defined(_DERIVATE2)
  Em_VS_BP_VD_S=Es_VS_BP_VD_S;
  Em_VS_BP_VGP_S=Es_VS_BP_VGP_S;
  Em_VS_BP_VS_BP=Es_VS_BP_VS_BP;
#endif
#endif
Em=Es;
EXIT_IF_ISNAN(Es)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ed_VD_S=Em_VD_S;
#if defined(_DERIVATE2)
  Ed_VD_S_VD_S=Em_VD_S_VD_S;
  Ed_VD_S_VGP_S=Em_VD_S_VGP_S;
  Ed_VD_S_VS_BP=Em_VD_S_VS_BP;
#endif
Ed_VGP_S=Em_VGP_S;
#if defined(_DERIVATE2)
  Ed_VGP_S_VD_S=Em_VGP_S_VD_S;
  Ed_VGP_S_VGP_S=Em_VGP_S_VGP_S;
  Ed_VGP_S_VS_BP=Em_VGP_S_VS_BP;
#endif
Ed_VS_BP=Em_VS_BP;
#if defined(_DERIVATE2)
  Ed_VS_BP_VD_S=Em_VS_BP_VD_S;
  Ed_VS_BP_VGP_S=Em_VS_BP_VGP_S;
  Ed_VS_BP_VS_BP=Em_VS_BP_VS_BP;
#endif
#endif
Ed=Em;
EXIT_IF_ISNAN(Em)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Dm_VD_S=Ds_VD_S;
#if defined(_DERIVATE2)
  Dm_VD_S_VD_S=Ds_VD_S_VD_S;
  Dm_VD_S_VGP_S=Ds_VD_S_VGP_S;
  Dm_VD_S_VS_BP=Ds_VD_S_VS_BP;
#endif
Dm_VGP_S=Ds_VGP_S;
#if defined(_DERIVATE2)
  Dm_VGP_S_VD_S=Ds_VGP_S_VD_S;
  Dm_VGP_S_VGP_S=Ds_VGP_S_VGP_S;
  Dm_VGP_S_VS_BP=Ds_VGP_S_VS_BP;
#endif
Dm_VS_BP=Ds_VS_BP;
#if defined(_DERIVATE2)
  Dm_VS_BP_VD_S=Ds_VS_BP_VD_S;
  Dm_VS_BP_VGP_S=Ds_VS_BP_VGP_S;
  Dm_VS_BP_VS_BP=Ds_VS_BP_VS_BP;
#endif
#endif
Dm=Ds;
EXIT_IF_ISNAN(Ds)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dd_VD_S=Dm_VD_S;
#if defined(_DERIVATE2)
  Dd_VD_S_VD_S=Dm_VD_S_VD_S;
  Dd_VD_S_VGP_S=Dm_VD_S_VGP_S;
  Dd_VD_S_VS_BP=Dm_VD_S_VS_BP;
#endif
Dd_VGP_S=Dm_VGP_S;
#if defined(_DERIVATE2)
  Dd_VGP_S_VD_S=Dm_VGP_S_VD_S;
  Dd_VGP_S_VGP_S=Dm_VGP_S_VGP_S;
  Dd_VGP_S_VS_BP=Dm_VGP_S_VS_BP;
#endif
Dd_VS_BP=Dm_VS_BP;
#if defined(_DERIVATE2)
  Dd_VS_BP_VD_S=Dm_VS_BP_VD_S;
  Dd_VS_BP_VGP_S=Dm_VS_BP_VGP_S;
  Dd_VS_BP_VS_BP=Dm_VS_BP_VS_BP;
#endif
#endif
Dd=Dm;
EXIT_IF_ISNAN(Dm)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Rxcor_VD_S=((((0.2*pInst->XCOR_i)*Vsbx_VD_S)*(1.0+(pInst->XCOR_i*Vsbx))-(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(pInst->XCOR_i*Vsbx_VD_S))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx)));
#if defined(_DERIVATE2)
  Rxcor_VD_S_VD_S=((+0.0+(+(+0.0*pInst->XCOR_i+0.0*0.0+0.0*0.0+0.2*0.0)*Vsbx+0.0*Vsbx_VD_S+(0.0)*Vsbx_VD_S+(0.2*pInst->XCOR_i)*Vsbx_VD_S_VD_S))/(1.0+(pInst->XCOR_i*Vsbx))-(((0.2*pInst->XCOR_i)*Vsbx_VD_S)*((pInst->XCOR_i*Vsbx_VD_S))+((((0.0)*Vsbx)+((0.2*pInst->XCOR_i)*Vsbx_VD_S)))*(pInst->XCOR_i*Vsbx_VD_S)+(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(+0.0+(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VD_S+pInst->XCOR_i*Vsbx_VD_S_VD_S)))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))+2*(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(pInst->XCOR_i*Vsbx_VD_S)*((pInst->XCOR_i*Vsbx_VD_S))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx)));
  Rxcor_VD_S_VS_BP=((+0.0+(+(+0.0*pInst->XCOR_i+0.0*0.0+0.0*0.0+0.2*0.0)*Vsbx+0.0*Vsbx_VS_BP+(0.0)*Vsbx_VD_S+(0.2*pInst->XCOR_i)*Vsbx_VD_S_VS_BP))/(1.0+(pInst->XCOR_i*Vsbx))-(((0.2*pInst->XCOR_i)*Vsbx_VD_S)*((pInst->XCOR_i*Vsbx_VS_BP))+((((0.0)*Vsbx)+((0.2*pInst->XCOR_i)*Vsbx_VS_BP)))*(pInst->XCOR_i*Vsbx_VD_S)+(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(+0.0+(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VD_S+pInst->XCOR_i*Vsbx_VD_S_VS_BP)))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))+2*(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(pInst->XCOR_i*Vsbx_VD_S)*((pInst->XCOR_i*Vsbx_VS_BP))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx)));
#endif
Rxcor_VS_BP=((((0.2*pInst->XCOR_i)*Vsbx_VS_BP)*(1.0+(pInst->XCOR_i*Vsbx))-(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(pInst->XCOR_i*Vsbx_VS_BP))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx)));
#if defined(_DERIVATE2)
  Rxcor_VS_BP_VD_S=((+0.0+(+(+0.0*pInst->XCOR_i+0.0*0.0+0.0*0.0+0.2*0.0)*Vsbx+0.0*Vsbx_VD_S+(0.0)*Vsbx_VS_BP+(0.2*pInst->XCOR_i)*Vsbx_VS_BP_VD_S))/(1.0+(pInst->XCOR_i*Vsbx))-(((0.2*pInst->XCOR_i)*Vsbx_VS_BP)*((pInst->XCOR_i*Vsbx_VD_S))+((((0.0)*Vsbx)+((0.2*pInst->XCOR_i)*Vsbx_VD_S)))*(pInst->XCOR_i*Vsbx_VS_BP)+(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(+0.0+(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VS_BP+pInst->XCOR_i*Vsbx_VS_BP_VD_S)))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))+2*(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(pInst->XCOR_i*Vsbx_VS_BP)*((pInst->XCOR_i*Vsbx_VD_S))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx)));
  Rxcor_VS_BP_VS_BP=((+0.0+(+(+0.0*pInst->XCOR_i+0.0*0.0+0.0*0.0+0.2*0.0)*Vsbx+0.0*Vsbx_VS_BP+(0.0)*Vsbx_VS_BP+(0.2*pInst->XCOR_i)*Vsbx_VS_BP_VS_BP))/(1.0+(pInst->XCOR_i*Vsbx))-(((0.2*pInst->XCOR_i)*Vsbx_VS_BP)*((pInst->XCOR_i*Vsbx_VS_BP))+((((0.0)*Vsbx)+((0.2*pInst->XCOR_i)*Vsbx_VS_BP)))*(pInst->XCOR_i*Vsbx_VS_BP)+(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(+0.0+(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VS_BP+pInst->XCOR_i*Vsbx_VS_BP_VS_BP)))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))+2*(1.0+((0.2*pInst->XCOR_i)*Vsbx))*(pInst->XCOR_i*Vsbx_VS_BP)*((pInst->XCOR_i*Vsbx_VS_BP))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx)));
#endif
#endif
Rxcor=((1.0+((0.2*pInst->XCOR_i)*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx)));
EXIT_IF_ISNAN(((1.0+((0.2*pInst->XCOR_i)*Vsbx))/(1.0+(pInst->XCOR_i*Vsbx))))
if
((Ds>1.0e-100))
{
{
double m00_sqrt(d00_sqrt0,(Ps+Ds))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(Ps+Ds))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xgs_VD_S=((Gf_VD_S*d00_sqrt0)+(Gf*(Ps_VD_S+Ds_VD_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgs_VD_S_VD_S=(+Gf_VD_S_VD_S*d00_sqrt0+Gf_VD_S*(Ps_VD_S+Ds_VD_S)*d10_sqrt0+Gf_VD_S*(Ps_VD_S+Ds_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VD_S+Ds_VD_S)*(Ps_VD_S+Ds_VD_S)+d10_sqrt0*(+Ps_VD_S_VD_S+Ds_VD_S_VD_S)));
  xgs_VD_S_VGP_S=(+Gf_VD_S_VGP_S*d00_sqrt0+Gf_VD_S*(Ps_VGP_S+Ds_VGP_S)*d10_sqrt0+Gf_VGP_S*(Ps_VD_S+Ds_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VGP_S+Ds_VGP_S)*(Ps_VD_S+Ds_VD_S)+d10_sqrt0*(+Ps_VD_S_VGP_S+Ds_VD_S_VGP_S)));
  xgs_VD_S_VS_BP=(+Gf_VD_S_VS_BP*d00_sqrt0+Gf_VD_S*(Ps_VS_BP+Ds_VS_BP)*d10_sqrt0+Gf_VS_BP*(Ps_VD_S+Ds_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VS_BP+Ds_VS_BP)*(Ps_VD_S+Ds_VD_S)+d10_sqrt0*(+Ps_VD_S_VS_BP+Ds_VD_S_VS_BP)));
#endif
xgs_VGP_S=((Gf_VGP_S*d00_sqrt0)+(Gf*(Ps_VGP_S+Ds_VGP_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgs_VGP_S_VD_S=(+Gf_VGP_S_VD_S*d00_sqrt0+Gf_VGP_S*(Ps_VD_S+Ds_VD_S)*d10_sqrt0+Gf_VD_S*(Ps_VGP_S+Ds_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VD_S+Ds_VD_S)*(Ps_VGP_S+Ds_VGP_S)+d10_sqrt0*(+Ps_VGP_S_VD_S+Ds_VGP_S_VD_S)));
  xgs_VGP_S_VGP_S=(+Gf_VGP_S_VGP_S*d00_sqrt0+Gf_VGP_S*(Ps_VGP_S+Ds_VGP_S)*d10_sqrt0+Gf_VGP_S*(Ps_VGP_S+Ds_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VGP_S+Ds_VGP_S)*(Ps_VGP_S+Ds_VGP_S)+d10_sqrt0*(+Ps_VGP_S_VGP_S+Ds_VGP_S_VGP_S)));
  xgs_VGP_S_VS_BP=(+Gf_VGP_S_VS_BP*d00_sqrt0+Gf_VGP_S*(Ps_VS_BP+Ds_VS_BP)*d10_sqrt0+Gf_VS_BP*(Ps_VGP_S+Ds_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VS_BP+Ds_VS_BP)*(Ps_VGP_S+Ds_VGP_S)+d10_sqrt0*(+Ps_VGP_S_VS_BP+Ds_VGP_S_VS_BP)));
#endif
xgs_VS_BP=((Gf_VS_BP*d00_sqrt0)+(Gf*(Ps_VS_BP+Ds_VS_BP)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgs_VS_BP_VD_S=(+Gf_VS_BP_VD_S*d00_sqrt0+Gf_VS_BP*(Ps_VD_S+Ds_VD_S)*d10_sqrt0+Gf_VD_S*(Ps_VS_BP+Ds_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VD_S+Ds_VD_S)*(Ps_VS_BP+Ds_VS_BP)+d10_sqrt0*(+Ps_VS_BP_VD_S+Ds_VS_BP_VD_S)));
  xgs_VS_BP_VGP_S=(+Gf_VS_BP_VGP_S*d00_sqrt0+Gf_VS_BP*(Ps_VGP_S+Ds_VGP_S)*d10_sqrt0+Gf_VGP_S*(Ps_VS_BP+Ds_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VGP_S+Ds_VGP_S)*(Ps_VS_BP+Ds_VS_BP)+d10_sqrt0*(+Ps_VS_BP_VGP_S+Ds_VS_BP_VGP_S)));
  xgs_VS_BP_VS_BP=(+Gf_VS_BP_VS_BP*d00_sqrt0+Gf_VS_BP*(Ps_VS_BP+Ds_VS_BP)*d10_sqrt0+Gf_VS_BP*(Ps_VS_BP+Ds_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Ps+Ds))*(Ps_VS_BP+Ds_VS_BP)*(Ps_VS_BP+Ds_VS_BP)+d10_sqrt0*(+Ps_VS_BP_VS_BP+Ds_VS_BP_VS_BP)));
#endif
#endif
xgs=(Gf*d00_sqrt0);
EXIT_IF_ISNAN((Gf*d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
qis_VD_S=((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(xgs+(Gf*sqm))-((Gf2*Ds)*pInst->phit1)*(xgs_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
#if defined(_DERIVATE2)
  qis_VD_S_VD_S=((+(+Gf2_VD_S_VD_S*Ds+Gf2_VD_S*Ds_VD_S+Gf2_VD_S*Ds_VD_S+Gf2*Ds_VD_S_VD_S)*pInst->phit1+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(xgs_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))+((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(xgs_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VD_S_VD_S+(+Gf_VD_S_VD_S*sqm+Gf_VD_S*sqm_VD_S+Gf_VD_S*sqm_VD_S+Gf*sqm_VD_S_VD_S)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))*(xgs_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
  qis_VD_S_VGP_S=((+(+Gf2_VD_S_VGP_S*Ds+Gf2_VD_S*Ds_VGP_S+Gf2_VGP_S*Ds_VD_S+Gf2*Ds_VD_S_VGP_S)*pInst->phit1+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(xgs_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))+((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(xgs_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VD_S_VGP_S+(+Gf_VD_S_VGP_S*sqm+Gf_VD_S*sqm_VGP_S+Gf_VGP_S*sqm_VD_S+Gf*sqm_VD_S_VGP_S)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))*(xgs_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
  qis_VD_S_VS_BP=((+(+Gf2_VD_S_VS_BP*Ds+Gf2_VD_S*Ds_VS_BP+Gf2_VS_BP*Ds_VD_S+Gf2*Ds_VD_S_VS_BP)*pInst->phit1+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(xgs_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))+((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(xgs_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VD_S_VS_BP+(+Gf_VD_S_VS_BP*sqm+Gf_VD_S*sqm_VS_BP+Gf_VS_BP*sqm_VD_S+Gf*sqm_VD_S_VS_BP)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))*(xgs_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
#endif
qis_VGP_S=((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(xgs+(Gf*sqm))-((Gf2*Ds)*pInst->phit1)*(xgs_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
#if defined(_DERIVATE2)
  qis_VGP_S_VD_S=((+(+Gf2_VGP_S_VD_S*Ds+Gf2_VGP_S*Ds_VD_S+Gf2_VD_S*Ds_VGP_S+Gf2*Ds_VGP_S_VD_S)*pInst->phit1+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(xgs_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))+((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(xgs_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VGP_S_VD_S+(+Gf_VGP_S_VD_S*sqm+Gf_VGP_S*sqm_VD_S+Gf_VD_S*sqm_VGP_S+Gf*sqm_VGP_S_VD_S)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))*(xgs_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
  qis_VGP_S_VGP_S=((+(+Gf2_VGP_S_VGP_S*Ds+Gf2_VGP_S*Ds_VGP_S+Gf2_VGP_S*Ds_VGP_S+Gf2*Ds_VGP_S_VGP_S)*pInst->phit1+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(xgs_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))+((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(xgs_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VGP_S_VGP_S+(+Gf_VGP_S_VGP_S*sqm+Gf_VGP_S*sqm_VGP_S+Gf_VGP_S*sqm_VGP_S+Gf*sqm_VGP_S_VGP_S)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))*(xgs_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
  qis_VGP_S_VS_BP=((+(+Gf2_VGP_S_VS_BP*Ds+Gf2_VGP_S*Ds_VS_BP+Gf2_VS_BP*Ds_VGP_S+Gf2*Ds_VGP_S_VS_BP)*pInst->phit1+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(xgs_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))+((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(xgs_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VGP_S_VS_BP+(+Gf_VGP_S_VS_BP*sqm+Gf_VGP_S*sqm_VS_BP+Gf_VS_BP*sqm_VGP_S+Gf*sqm_VGP_S_VS_BP)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))*(xgs_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
#endif
qis_VS_BP=((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(xgs+(Gf*sqm))-((Gf2*Ds)*pInst->phit1)*(xgs_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
#if defined(_DERIVATE2)
  qis_VS_BP_VD_S=((+(+Gf2_VS_BP_VD_S*Ds+Gf2_VS_BP*Ds_VD_S+Gf2_VD_S*Ds_VS_BP+Gf2*Ds_VS_BP_VD_S)*pInst->phit1+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(xgs_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))+((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(xgs_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VS_BP_VD_S+(+Gf_VS_BP_VD_S*sqm+Gf_VS_BP*sqm_VD_S+Gf_VD_S*sqm_VS_BP+Gf*sqm_VS_BP_VD_S)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))*(xgs_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
  qis_VS_BP_VGP_S=((+(+Gf2_VS_BP_VGP_S*Ds+Gf2_VS_BP*Ds_VGP_S+Gf2_VGP_S*Ds_VS_BP+Gf2*Ds_VS_BP_VGP_S)*pInst->phit1+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(xgs_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))+((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(xgs_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VS_BP_VGP_S+(+Gf_VS_BP_VGP_S*sqm+Gf_VS_BP*sqm_VGP_S+Gf_VGP_S*sqm_VS_BP+Gf*sqm_VS_BP_VGP_S)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))*(xgs_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
  qis_VS_BP_VS_BP=((+(+Gf2_VS_BP_VS_BP*Ds+Gf2_VS_BP*Ds_VS_BP+Gf2_VS_BP*Ds_VS_BP+Gf2*Ds_VS_BP_VS_BP)*pInst->phit1+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)/(xgs+(Gf*sqm))-(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(xgs_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))+((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(xgs_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))+((Gf2*Ds)*pInst->phit1)*(+xgs_VS_BP_VS_BP+(+Gf_VS_BP_VS_BP*sqm+Gf_VS_BP*sqm_VS_BP+Gf_VS_BP*sqm_VS_BP+Gf*sqm_VS_BP_VS_BP)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))+2*((Gf2*Ds)*pInst->phit1)*(xgs_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))*(xgs_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
#endif
#endif
qis=(((Gf2*Ds)*pInst->phit1)/(xgs+(Gf*sqm)));
EXIT_IF_ISNAN((((Gf2*Ds)*pInst->phit1)/(xgs+(Gf*sqm))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
qbs_VD_S=((sqm_VD_S*Gf)+(sqm*Gf_VD_S))*pInst->phit1;
#if defined(_DERIVATE2)
  qbs_VD_S_VD_S=(+(+sqm_VD_S_VD_S*Gf+sqm_VD_S*Gf_VD_S+sqm_VD_S*Gf_VD_S+sqm*Gf_VD_S_VD_S)*pInst->phit1+((sqm_VD_S*Gf)+(sqm*Gf_VD_S))*0.0+(((sqm_VD_S*Gf)+(sqm*Gf_VD_S)))*0.0+(sqm*Gf)*0.0);
  qbs_VD_S_VGP_S=(+(+sqm_VD_S_VGP_S*Gf+sqm_VD_S*Gf_VGP_S+sqm_VGP_S*Gf_VD_S+sqm*Gf_VD_S_VGP_S)*pInst->phit1+((sqm_VD_S*Gf)+(sqm*Gf_VD_S))*0.0+(((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S)))*0.0+(sqm*Gf)*0.0);
  qbs_VD_S_VS_BP=(+(+sqm_VD_S_VS_BP*Gf+sqm_VD_S*Gf_VS_BP+sqm_VS_BP*Gf_VD_S+sqm*Gf_VD_S_VS_BP)*pInst->phit1+((sqm_VD_S*Gf)+(sqm*Gf_VD_S))*0.0+(((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP)))*0.0+(sqm*Gf)*0.0);
#endif
qbs_VGP_S=((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S))*pInst->phit1;
#if defined(_DERIVATE2)
  qbs_VGP_S_VD_S=(+(+sqm_VGP_S_VD_S*Gf+sqm_VGP_S*Gf_VD_S+sqm_VD_S*Gf_VGP_S+sqm*Gf_VGP_S_VD_S)*pInst->phit1+((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S))*0.0+(((sqm_VD_S*Gf)+(sqm*Gf_VD_S)))*0.0+(sqm*Gf)*0.0);
  qbs_VGP_S_VGP_S=(+(+sqm_VGP_S_VGP_S*Gf+sqm_VGP_S*Gf_VGP_S+sqm_VGP_S*Gf_VGP_S+sqm*Gf_VGP_S_VGP_S)*pInst->phit1+((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S))*0.0+(((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S)))*0.0+(sqm*Gf)*0.0);
  qbs_VGP_S_VS_BP=(+(+sqm_VGP_S_VS_BP*Gf+sqm_VGP_S*Gf_VS_BP+sqm_VS_BP*Gf_VGP_S+sqm*Gf_VGP_S_VS_BP)*pInst->phit1+((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S))*0.0+(((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP)))*0.0+(sqm*Gf)*0.0);
#endif
qbs_VS_BP=((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP))*pInst->phit1;
#if defined(_DERIVATE2)
  qbs_VS_BP_VD_S=(+(+sqm_VS_BP_VD_S*Gf+sqm_VS_BP*Gf_VD_S+sqm_VD_S*Gf_VS_BP+sqm*Gf_VS_BP_VD_S)*pInst->phit1+((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP))*0.0+(((sqm_VD_S*Gf)+(sqm*Gf_VD_S)))*0.0+(sqm*Gf)*0.0);
  qbs_VS_BP_VGP_S=(+(+sqm_VS_BP_VGP_S*Gf+sqm_VS_BP*Gf_VGP_S+sqm_VGP_S*Gf_VS_BP+sqm*Gf_VS_BP_VGP_S)*pInst->phit1+((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP))*0.0+(((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S)))*0.0+(sqm*Gf)*0.0);
  qbs_VS_BP_VS_BP=(+(+sqm_VS_BP_VS_BP*Gf+sqm_VS_BP*Gf_VS_BP+sqm_VS_BP*Gf_VS_BP+sqm*Gf_VS_BP_VS_BP)*pInst->phit1+((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP))*0.0+(((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP)))*0.0+(sqm*Gf)*0.0);
#endif
#endif
qbs=((sqm*Gf)*pInst->phit1);
EXIT_IF_ISNAN(((sqm*Gf)*pInst->phit1))
if
((pInst->RSB_i<0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
rhob_VD_S=(-(-(pInst->RSB_i*Vsbx_VD_S))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx)));
#if defined(_DERIVATE2)
  rhob_VD_S_VD_S=(0.0/(1.0-(pInst->RSB_i*Vsbx))-(0.0*(-((pInst->RSB_i*Vsbx_VD_S)))+0.0*(-(pInst->RSB_i*Vsbx_VD_S))+1.0*(+0.0-(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VD_S+pInst->RSB_i*Vsbx_VD_S_VD_S)))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx))+2*1.0*(-(pInst->RSB_i*Vsbx_VD_S))*(-((pInst->RSB_i*Vsbx_VD_S)))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx)));
  rhob_VD_S_VS_BP=(0.0/(1.0-(pInst->RSB_i*Vsbx))-(0.0*(-((pInst->RSB_i*Vsbx_VS_BP)))+0.0*(-(pInst->RSB_i*Vsbx_VD_S))+1.0*(+0.0-(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VD_S+pInst->RSB_i*Vsbx_VD_S_VS_BP)))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx))+2*1.0*(-(pInst->RSB_i*Vsbx_VD_S))*(-((pInst->RSB_i*Vsbx_VS_BP)))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx)));
#endif
rhob_VS_BP=(-(-(pInst->RSB_i*Vsbx_VS_BP))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx)));
#if defined(_DERIVATE2)
  rhob_VS_BP_VD_S=(0.0/(1.0-(pInst->RSB_i*Vsbx))-(0.0*(-((pInst->RSB_i*Vsbx_VD_S)))+0.0*(-(pInst->RSB_i*Vsbx_VS_BP))+1.0*(+0.0-(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VS_BP+pInst->RSB_i*Vsbx_VS_BP_VD_S)))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx))+2*1.0*(-(pInst->RSB_i*Vsbx_VS_BP))*(-((pInst->RSB_i*Vsbx_VD_S)))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx)));
  rhob_VS_BP_VS_BP=(0.0/(1.0-(pInst->RSB_i*Vsbx))-(0.0*(-((pInst->RSB_i*Vsbx_VS_BP)))+0.0*(-(pInst->RSB_i*Vsbx_VS_BP))+1.0*(+0.0-(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VS_BP+pInst->RSB_i*Vsbx_VS_BP_VS_BP)))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx))+2*1.0*(-(pInst->RSB_i*Vsbx_VS_BP))*(-((pInst->RSB_i*Vsbx_VS_BP)))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx))/(1.0-(pInst->RSB_i*Vsbx)));
#endif
#endif
rhob=(1.0/(1.0-(pInst->RSB_i*Vsbx)));
EXIT_IF_ISNAN((1.0/(1.0-(pInst->RSB_i*Vsbx))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
rhob_VD_S=(pInst->RSB_i*Vsbx_VD_S);
#if defined(_DERIVATE2)
  rhob_VD_S_VD_S=(+0.0+(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VD_S+pInst->RSB_i*Vsbx_VD_S_VD_S));
  rhob_VD_S_VS_BP=(+0.0+(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VD_S+pInst->RSB_i*Vsbx_VD_S_VS_BP));
#endif
rhob_VS_BP=(pInst->RSB_i*Vsbx_VS_BP);
#if defined(_DERIVATE2)
  rhob_VS_BP_VD_S=(+0.0+(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VS_BP+pInst->RSB_i*Vsbx_VS_BP_VD_S));
  rhob_VS_BP_VS_BP=(+0.0+(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VS_BP+pInst->RSB_i*Vsbx_VS_BP_VS_BP));
#endif
#endif
rhob=(1.0+(pInst->RSB_i*Vsbx));
EXIT_IF_ISNAN((1.0+(pInst->RSB_i*Vsbx)))
}
if
((pInst->RSG_i<0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-(pInst->RSG_i*qis_VGP_S));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0-(+0.0*qis+0.0*0.0+0.0*qis_VGP_S+pInst->RSG_i*0.0));
  temp_VGP_S_VS_BS=(+0.0-(+0.0*qis+0.0*0.0+0.0*qis_VGP_S+pInst->RSG_i*0.0));
  temp_VGP_S_VGP_S=(+0.0-(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VGP_S+pInst->RSG_i*qis_VGP_S_VGP_S));
  temp_VGP_S_VD_S=(+0.0-(+0.0*qis+0.0*qis_VD_S+0.0*qis_VGP_S+pInst->RSG_i*qis_VGP_S_VD_S));
  temp_VGP_S_VS_BP=(+0.0-(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VGP_S+pInst->RSG_i*qis_VGP_S_VS_BP));
#endif
temp_VD_S=(-(pInst->RSG_i*qis_VD_S));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0-(+0.0*qis+0.0*0.0+0.0*qis_VD_S+pInst->RSG_i*0.0));
  temp_VD_S_VS_BS=(+0.0-(+0.0*qis+0.0*0.0+0.0*qis_VD_S+pInst->RSG_i*0.0));
  temp_VD_S_VGP_S=(+0.0-(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VD_S+pInst->RSG_i*qis_VD_S_VGP_S));
  temp_VD_S_VD_S=(+0.0-(+0.0*qis+0.0*qis_VD_S+0.0*qis_VD_S+pInst->RSG_i*qis_VD_S_VD_S));
  temp_VD_S_VS_BP=(+0.0-(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VD_S+pInst->RSG_i*qis_VD_S_VS_BP));
#endif
temp_VS_BP=(-(pInst->RSG_i*qis_VS_BP));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0-(+0.0*qis+0.0*0.0+0.0*qis_VS_BP+pInst->RSG_i*0.0));
  temp_VS_BP_VS_BS=(+0.0-(+0.0*qis+0.0*0.0+0.0*qis_VS_BP+pInst->RSG_i*0.0));
  temp_VS_BP_VGP_S=(+0.0-(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VS_BP+pInst->RSG_i*qis_VS_BP_VGP_S));
  temp_VS_BP_VD_S=(+0.0-(+0.0*qis+0.0*qis_VD_S+0.0*qis_VS_BP+pInst->RSG_i*qis_VS_BP_VD_S));
  temp_VS_BP_VS_BP=(+0.0-(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VS_BP+pInst->RSG_i*qis_VS_BP_VS_BP));
#endif
#endif
temp=(1.0-(pInst->RSG_i*qis));
EXIT_IF_ISNAN((1.0-(pInst->RSG_i*qis)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-(pInst->RSG_i*qis_VGP_S)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*(0.0)+0.0*(pInst->RSG_i*qis_VGP_S)+1.0*(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_VGP_S+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VGP_S)*(0.0)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VGP_S_VS_BS=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*(0.0)+0.0*(pInst->RSG_i*qis_VGP_S)+1.0*(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_VGP_S+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VGP_S)*(0.0)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VGP_S_VGP_S=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VGP_S))+0.0*(pInst->RSG_i*qis_VGP_S)+1.0*(+0.0+(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VGP_S+pInst->RSG_i*qis_VGP_S_VGP_S)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VGP_S)*((pInst->RSG_i*qis_VGP_S))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VGP_S_VD_S=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VD_S))+0.0*(pInst->RSG_i*qis_VGP_S)+1.0*(+0.0+(+0.0*qis+0.0*qis_VD_S+0.0*qis_VGP_S+pInst->RSG_i*qis_VGP_S_VD_S)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VGP_S)*((pInst->RSG_i*qis_VD_S))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VGP_S_VS_BP=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VS_BP))+0.0*(pInst->RSG_i*qis_VGP_S)+1.0*(+0.0+(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VGP_S+pInst->RSG_i*qis_VGP_S_VS_BP)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VGP_S)*((pInst->RSG_i*qis_VS_BP))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
#endif
temp_VD_S=(-(pInst->RSG_i*qis_VD_S)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*(0.0)+0.0*(pInst->RSG_i*qis_VD_S)+1.0*(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_VD_S+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VD_S)*(0.0)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VD_S_VS_BS=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*(0.0)+0.0*(pInst->RSG_i*qis_VD_S)+1.0*(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_VD_S+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VD_S)*(0.0)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VD_S_VGP_S=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VGP_S))+0.0*(pInst->RSG_i*qis_VD_S)+1.0*(+0.0+(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VD_S+pInst->RSG_i*qis_VD_S_VGP_S)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VD_S)*((pInst->RSG_i*qis_VGP_S))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VD_S_VD_S=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VD_S))+0.0*(pInst->RSG_i*qis_VD_S)+1.0*(+0.0+(+0.0*qis+0.0*qis_VD_S+0.0*qis_VD_S+pInst->RSG_i*qis_VD_S_VD_S)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VD_S)*((pInst->RSG_i*qis_VD_S))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VD_S_VS_BP=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VS_BP))+0.0*(pInst->RSG_i*qis_VD_S)+1.0*(+0.0+(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VD_S+pInst->RSG_i*qis_VD_S_VS_BP)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VD_S)*((pInst->RSG_i*qis_VS_BP))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
#endif
temp_VS_BP=(-(pInst->RSG_i*qis_VS_BP)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*(0.0)+0.0*(pInst->RSG_i*qis_VS_BP)+1.0*(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_VS_BP+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VS_BP)*(0.0)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VS_BP_VS_BS=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*(0.0)+0.0*(pInst->RSG_i*qis_VS_BP)+1.0*(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_VS_BP+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VS_BP)*(0.0)/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VS_BP_VGP_S=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VGP_S))+0.0*(pInst->RSG_i*qis_VS_BP)+1.0*(+0.0+(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VS_BP+pInst->RSG_i*qis_VS_BP_VGP_S)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VS_BP)*((pInst->RSG_i*qis_VGP_S))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VS_BP_VD_S=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VD_S))+0.0*(pInst->RSG_i*qis_VS_BP)+1.0*(+0.0+(+0.0*qis+0.0*qis_VD_S+0.0*qis_VS_BP+pInst->RSG_i*qis_VS_BP_VD_S)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VS_BP)*((pInst->RSG_i*qis_VD_S))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
  temp_VS_BP_VS_BP=(0.0/(1.0+(pInst->RSG_i*qis))-(0.0*((pInst->RSG_i*qis_VS_BP))+0.0*(pInst->RSG_i*qis_VS_BP)+1.0*(+0.0+(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VS_BP+pInst->RSG_i*qis_VS_BP_VS_BP)))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))+2*1.0*(pInst->RSG_i*qis_VS_BP)*((pInst->RSG_i*qis_VS_BP))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis))/(1.0+(pInst->RSG_i*qis)));
#endif
#endif
temp=(1.0/(1.0+(pInst->RSG_i*qis)));
EXIT_IF_ISNAN((1.0/(1.0+(pInst->RSG_i*qis))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
GR_VD_S=(pInst->THER_i*((((rhob_VD_S*temp)+(rhob*temp_VD_S))*qis)+((rhob*temp)*qis_VD_S)));
#if defined(_DERIVATE2)
  GR_VD_S_VD_S=(+0.0*((rhob*temp)*qis)+0.0*((((((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qis)+((rhob*temp)*qis_VD_S)))+0.0*((((rhob_VD_S*temp)+(rhob*temp_VD_S))*qis)+((rhob*temp)*qis_VD_S))+pInst->THER_i*(+(+rhob_VD_S_VD_S*temp+rhob_VD_S*temp_VD_S+rhob_VD_S*temp_VD_S+rhob*temp_VD_S_VD_S)*qis+((rhob_VD_S*temp)+(rhob*temp_VD_S))*qis_VD_S+(((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qis_VD_S+(rhob*temp)*qis_VD_S_VD_S));
  GR_VD_S_VS_BP=(+0.0*((rhob*temp)*qis)+0.0*((((((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qis)+((rhob*temp)*qis_VS_BP)))+0.0*((((rhob_VD_S*temp)+(rhob*temp_VD_S))*qis)+((rhob*temp)*qis_VD_S))+pInst->THER_i*(+(+rhob_VD_S_VS_BP*temp+rhob_VD_S*temp_VS_BP+rhob_VS_BP*temp_VD_S+rhob*temp_VD_S_VS_BP)*qis+((rhob_VD_S*temp)+(rhob*temp_VD_S))*qis_VS_BP+(((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qis_VD_S+(rhob*temp)*qis_VD_S_VS_BP));
  GR_VD_S_VGP_S=(+0.0*((rhob*temp)*qis)+0.0*(((((rhob*temp_VGP_S))*qis)+((rhob*temp)*qis_VGP_S)))+0.0*((((rhob_VD_S*temp)+(rhob*temp_VD_S))*qis)+((rhob*temp)*qis_VD_S))+pInst->THER_i*(+(+0.0*temp+rhob_VD_S*temp_VGP_S+0.0*temp_VD_S+rhob*temp_VD_S_VGP_S)*qis+((rhob_VD_S*temp)+(rhob*temp_VD_S))*qis_VGP_S+((rhob*temp_VGP_S))*qis_VD_S+(rhob*temp)*qis_VD_S_VGP_S));
#endif
GR_VS_BP=(pInst->THER_i*((((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qis)+((rhob*temp)*qis_VS_BP)));
#if defined(_DERIVATE2)
  GR_VS_BP_VD_S=(+0.0*((rhob*temp)*qis)+0.0*((((((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qis)+((rhob*temp)*qis_VD_S)))+0.0*((((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qis)+((rhob*temp)*qis_VS_BP))+pInst->THER_i*(+(+rhob_VS_BP_VD_S*temp+rhob_VS_BP*temp_VD_S+rhob_VD_S*temp_VS_BP+rhob*temp_VS_BP_VD_S)*qis+((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qis_VD_S+(((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qis_VS_BP+(rhob*temp)*qis_VS_BP_VD_S));
  GR_VS_BP_VS_BP=(+0.0*((rhob*temp)*qis)+0.0*((((((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qis)+((rhob*temp)*qis_VS_BP)))+0.0*((((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qis)+((rhob*temp)*qis_VS_BP))+pInst->THER_i*(+(+rhob_VS_BP_VS_BP*temp+rhob_VS_BP*temp_VS_BP+rhob_VS_BP*temp_VS_BP+rhob*temp_VS_BP_VS_BP)*qis+((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qis_VS_BP+(((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qis_VS_BP+(rhob*temp)*qis_VS_BP_VS_BP));
  GR_VS_BP_VGP_S=(+0.0*((rhob*temp)*qis)+0.0*(((((rhob*temp_VGP_S))*qis)+((rhob*temp)*qis_VGP_S)))+0.0*((((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qis)+((rhob*temp)*qis_VS_BP))+pInst->THER_i*(+(+0.0*temp+rhob_VS_BP*temp_VGP_S+0.0*temp_VS_BP+rhob*temp_VS_BP_VGP_S)*qis+((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qis_VGP_S+((rhob*temp_VGP_S))*qis_VS_BP+(rhob*temp)*qis_VS_BP_VGP_S));
#endif
GR_VGP_S=(pInst->THER_i*(((rhob*temp_VGP_S)*qis)+((rhob*temp)*qis_VGP_S)));
#if defined(_DERIVATE2)
  GR_VGP_S_VD_S=(+0.0*((rhob*temp)*qis)+0.0*((((((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qis)+((rhob*temp)*qis_VD_S)))+0.0*(((rhob*temp_VGP_S)*qis)+((rhob*temp)*qis_VGP_S))+pInst->THER_i*(+(+0.0*temp+0.0*temp_VD_S+rhob_VD_S*temp_VGP_S+rhob*temp_VGP_S_VD_S)*qis+(rhob*temp_VGP_S)*qis_VD_S+(((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qis_VGP_S+(rhob*temp)*qis_VGP_S_VD_S));
  GR_VGP_S_VS_BP=(+0.0*((rhob*temp)*qis)+0.0*((((((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qis)+((rhob*temp)*qis_VS_BP)))+0.0*(((rhob*temp_VGP_S)*qis)+((rhob*temp)*qis_VGP_S))+pInst->THER_i*(+(+0.0*temp+0.0*temp_VS_BP+rhob_VS_BP*temp_VGP_S+rhob*temp_VGP_S_VS_BP)*qis+(rhob*temp_VGP_S)*qis_VS_BP+(((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qis_VGP_S+(rhob*temp)*qis_VGP_S_VS_BP));
  GR_VGP_S_VGP_S=(+0.0*((rhob*temp)*qis)+0.0*(((((rhob*temp_VGP_S))*qis)+((rhob*temp)*qis_VGP_S)))+0.0*(((rhob*temp_VGP_S)*qis)+((rhob*temp)*qis_VGP_S))+pInst->THER_i*(+(+0.0*temp+0.0*temp_VGP_S+0.0*temp_VGP_S+rhob*temp_VGP_S_VGP_S)*qis+(rhob*temp_VGP_S)*qis_VGP_S+((rhob*temp_VGP_S))*qis_VGP_S+(rhob*temp)*qis_VGP_S_VGP_S));
#endif
#endif
GR=(pInst->THER_i*((rhob*temp)*qis));
EXIT_IF_ISNAN((pInst->THER_i*((rhob*temp)*qis)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Eeffm_VD_S=(pInst->E_eff0*(qbs_VD_S+(pInst->eta_mu*qis_VD_S)));
#if defined(_DERIVATE2)
  Eeffm_VD_S_VD_S=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VD_S+((pInst->eta_mu*qis_VD_S)))+0.0*(qbs_VD_S+(pInst->eta_mu*qis_VD_S))+pInst->E_eff0*(+qbs_VD_S_VD_S+(+0.0*qis+0.0*qis_VD_S+0.0*qis_VD_S+pInst->eta_mu*qis_VD_S_VD_S)));
  Eeffm_VD_S_VGP_S=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VGP_S+((pInst->eta_mu*qis_VGP_S)))+0.0*(qbs_VD_S+(pInst->eta_mu*qis_VD_S))+pInst->E_eff0*(+qbs_VD_S_VGP_S+(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VD_S+pInst->eta_mu*qis_VD_S_VGP_S)));
  Eeffm_VD_S_VS_BP=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VS_BP+((pInst->eta_mu*qis_VS_BP)))+0.0*(qbs_VD_S+(pInst->eta_mu*qis_VD_S))+pInst->E_eff0*(+qbs_VD_S_VS_BP+(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VD_S+pInst->eta_mu*qis_VD_S_VS_BP)));
#endif
Eeffm_VGP_S=(pInst->E_eff0*(qbs_VGP_S+(pInst->eta_mu*qis_VGP_S)));
#if defined(_DERIVATE2)
  Eeffm_VGP_S_VD_S=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VD_S+((pInst->eta_mu*qis_VD_S)))+0.0*(qbs_VGP_S+(pInst->eta_mu*qis_VGP_S))+pInst->E_eff0*(+qbs_VGP_S_VD_S+(+0.0*qis+0.0*qis_VD_S+0.0*qis_VGP_S+pInst->eta_mu*qis_VGP_S_VD_S)));
  Eeffm_VGP_S_VGP_S=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VGP_S+((pInst->eta_mu*qis_VGP_S)))+0.0*(qbs_VGP_S+(pInst->eta_mu*qis_VGP_S))+pInst->E_eff0*(+qbs_VGP_S_VGP_S+(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VGP_S+pInst->eta_mu*qis_VGP_S_VGP_S)));
  Eeffm_VGP_S_VS_BP=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VS_BP+((pInst->eta_mu*qis_VS_BP)))+0.0*(qbs_VGP_S+(pInst->eta_mu*qis_VGP_S))+pInst->E_eff0*(+qbs_VGP_S_VS_BP+(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VGP_S+pInst->eta_mu*qis_VGP_S_VS_BP)));
#endif
Eeffm_VS_BP=(pInst->E_eff0*(qbs_VS_BP+(pInst->eta_mu*qis_VS_BP)));
#if defined(_DERIVATE2)
  Eeffm_VS_BP_VD_S=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VD_S+((pInst->eta_mu*qis_VD_S)))+0.0*(qbs_VS_BP+(pInst->eta_mu*qis_VS_BP))+pInst->E_eff0*(+qbs_VS_BP_VD_S+(+0.0*qis+0.0*qis_VD_S+0.0*qis_VS_BP+pInst->eta_mu*qis_VS_BP_VD_S)));
  Eeffm_VS_BP_VGP_S=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VGP_S+((pInst->eta_mu*qis_VGP_S)))+0.0*(qbs_VS_BP+(pInst->eta_mu*qis_VS_BP))+pInst->E_eff0*(+qbs_VS_BP_VGP_S+(+0.0*qis+0.0*qis_VGP_S+0.0*qis_VS_BP+pInst->eta_mu*qis_VS_BP_VGP_S)));
  Eeffm_VS_BP_VS_BP=(+0.0*(qbs+(pInst->eta_mu*qis))+0.0*(qbs_VS_BP+((pInst->eta_mu*qis_VS_BP)))+0.0*(qbs_VS_BP+(pInst->eta_mu*qis_VS_BP))+pInst->E_eff0*(+qbs_VS_BP_VS_BP+(+0.0*qis+0.0*qis_VS_BP+0.0*qis_VS_BP+pInst->eta_mu*qis_VS_BP_VS_BP)));
#endif
#endif
Eeffm=(pInst->E_eff0*(qbs+(pInst->eta_mu*qis)));
EXIT_IF_ISNAN((pInst->E_eff0*(qbs+(pInst->eta_mu*qis))))
{
double m00_pow(d00_pow0,(Eeffm*pInst->MUE_i),pInst->THEMU_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(Eeffm*pInst->MUE_i),pInst->THEMU_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Mutmp_VD_S=((d10_pow0*Eeffm_VD_S*pInst->MUE_i)+(pInst->CS_i*((Ps_VD_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VD_S+Ds_VD_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
#if defined(_DERIVATE2)
  Mutmp_VD_S_VD_S=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VD_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VD_S+Ds_VD_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VD_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VD_S+Ds_VD_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VD_S_VD_S/((Ps+Ds)+1.0e-14)-(Ps_VD_S*(Ps_VD_S+Ds_VD_S)+Ps_VD_S*(Ps_VD_S+Ds_VD_S)+Ps*(+(+Ps_VD_S_VD_S+Ds_VD_S_VD_S)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VD_S+Ds_VD_S)*(Ps_VD_S+Ds_VD_S)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
  Mutmp_VD_S_VGP_S=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VGP_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VGP_S+Ds_VGP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VD_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VD_S+Ds_VD_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VD_S_VGP_S/((Ps+Ds)+1.0e-14)-(Ps_VD_S*(Ps_VGP_S+Ds_VGP_S)+Ps_VGP_S*(Ps_VD_S+Ds_VD_S)+Ps*(+(+Ps_VD_S_VGP_S+Ds_VD_S_VGP_S)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VD_S+Ds_VD_S)*(Ps_VGP_S+Ds_VGP_S)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
  Mutmp_VD_S_VS_BP=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VS_BP*((Ps+Ds)+1.0e-14)-Ps*(Ps_VS_BP+Ds_VS_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VD_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VD_S+Ds_VD_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VD_S_VS_BP/((Ps+Ds)+1.0e-14)-(Ps_VD_S*(Ps_VS_BP+Ds_VS_BP)+Ps_VS_BP*(Ps_VD_S+Ds_VD_S)+Ps*(+(+Ps_VD_S_VS_BP+Ds_VD_S_VS_BP)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VD_S+Ds_VD_S)*(Ps_VS_BP+Ds_VS_BP)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
#endif
Mutmp_VGP_S=((d10_pow0*Eeffm_VGP_S*pInst->MUE_i)+(pInst->CS_i*((Ps_VGP_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VGP_S+Ds_VGP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
#if defined(_DERIVATE2)
  Mutmp_VGP_S_VD_S=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VD_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VD_S+Ds_VD_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VGP_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VGP_S+Ds_VGP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VGP_S_VD_S/((Ps+Ds)+1.0e-14)-(Ps_VGP_S*(Ps_VD_S+Ds_VD_S)+Ps_VD_S*(Ps_VGP_S+Ds_VGP_S)+Ps*(+(+Ps_VGP_S_VD_S+Ds_VGP_S_VD_S)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VGP_S+Ds_VGP_S)*(Ps_VD_S+Ds_VD_S)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
  Mutmp_VGP_S_VGP_S=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VGP_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VGP_S+Ds_VGP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VGP_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VGP_S+Ds_VGP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VGP_S_VGP_S/((Ps+Ds)+1.0e-14)-(Ps_VGP_S*(Ps_VGP_S+Ds_VGP_S)+Ps_VGP_S*(Ps_VGP_S+Ds_VGP_S)+Ps*(+(+Ps_VGP_S_VGP_S+Ds_VGP_S_VGP_S)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VGP_S+Ds_VGP_S)*(Ps_VGP_S+Ds_VGP_S)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
  Mutmp_VGP_S_VS_BP=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VS_BP*((Ps+Ds)+1.0e-14)-Ps*(Ps_VS_BP+Ds_VS_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VGP_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VGP_S+Ds_VGP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VGP_S_VS_BP/((Ps+Ds)+1.0e-14)-(Ps_VGP_S*(Ps_VS_BP+Ds_VS_BP)+Ps_VS_BP*(Ps_VGP_S+Ds_VGP_S)+Ps*(+(+Ps_VGP_S_VS_BP+Ds_VGP_S_VS_BP)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VGP_S+Ds_VGP_S)*(Ps_VS_BP+Ds_VS_BP)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
#endif
Mutmp_VS_BP=((d10_pow0*Eeffm_VS_BP*pInst->MUE_i)+(pInst->CS_i*((Ps_VS_BP*((Ps+Ds)+1.0e-14)-Ps*(Ps_VS_BP+Ds_VS_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
#if defined(_DERIVATE2)
  Mutmp_VS_BP_VD_S=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VD_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VD_S+Ds_VD_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VS_BP*((Ps+Ds)+1.0e-14)-Ps*(Ps_VS_BP+Ds_VS_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VS_BP_VD_S/((Ps+Ds)+1.0e-14)-(Ps_VS_BP*(Ps_VD_S+Ds_VD_S)+Ps_VD_S*(Ps_VS_BP+Ds_VS_BP)+Ps*(+(+Ps_VS_BP_VD_S+Ds_VS_BP_VD_S)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VS_BP+Ds_VS_BP)*(Ps_VD_S+Ds_VD_S)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
  Mutmp_VS_BP_VGP_S=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VGP_S*((Ps+Ds)+1.0e-14)-Ps*(Ps_VGP_S+Ds_VGP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VS_BP*((Ps+Ds)+1.0e-14)-Ps*(Ps_VS_BP+Ds_VS_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VS_BP_VGP_S/((Ps+Ds)+1.0e-14)-(Ps_VS_BP*(Ps_VGP_S+Ds_VGP_S)+Ps_VGP_S*(Ps_VS_BP+Ds_VS_BP)+Ps*(+(+Ps_VS_BP_VGP_S+Ds_VS_BP_VGP_S)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VS_BP+Ds_VS_BP)*(Ps_VGP_S+Ds_VGP_S)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
  Mutmp_VS_BP_VS_BP=(+fixme+(+0.0*(Ps/((Ps+Ds)+1.0e-14))+0.0*((Ps_VS_BP*((Ps+Ds)+1.0e-14)-Ps*(Ps_VS_BP+Ds_VS_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+0.0*((Ps_VS_BP*((Ps+Ds)+1.0e-14)-Ps*(Ps_VS_BP+Ds_VS_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+pInst->CS_i*(Ps_VS_BP_VS_BP/((Ps+Ds)+1.0e-14)-(Ps_VS_BP*(Ps_VS_BP+Ds_VS_BP)+Ps_VS_BP*(Ps_VS_BP+Ds_VS_BP)+Ps*(+(+Ps_VS_BP_VS_BP+Ds_VS_BP_VS_BP)+0.0))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)+2*Ps*(Ps_VS_BP+Ds_VS_BP)*(Ps_VS_BP+Ds_VS_BP)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))));
#endif
#endif
Mutmp=(d00_pow0+(pInst->CS_i*(Ps/((Ps+Ds)+1.0e-14))));
EXIT_IF_ISNAN((d00_pow0+(pInst->CS_i*(Ps/((Ps+Ds)+1.0e-14)))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Gmob_VD_S=(((Mutmp_VD_S+GR_VD_S)*Rxcor)+(((1.0+Mutmp)+GR)*Rxcor_VD_S));
#if defined(_DERIVATE2)
  Gmob_VD_S_VD_S=(+(+(+0.0+Mutmp_VD_S_VD_S)+GR_VD_S_VD_S)*Rxcor+(Mutmp_VD_S+GR_VD_S)*Rxcor_VD_S+(Mutmp_VD_S+GR_VD_S)*Rxcor_VD_S+((1.0+Mutmp)+GR)*Rxcor_VD_S_VD_S);
  Gmob_VD_S_VGP_S=(+(+(+0.0+Mutmp_VD_S_VGP_S)+GR_VD_S_VGP_S)*Rxcor+(Mutmp_VD_S+GR_VD_S)*0.0+(Mutmp_VGP_S+GR_VGP_S)*Rxcor_VD_S+((1.0+Mutmp)+GR)*0.0);
  Gmob_VD_S_VS_BP=(+(+(+0.0+Mutmp_VD_S_VS_BP)+GR_VD_S_VS_BP)*Rxcor+(Mutmp_VD_S+GR_VD_S)*Rxcor_VS_BP+(Mutmp_VS_BP+GR_VS_BP)*Rxcor_VD_S+((1.0+Mutmp)+GR)*Rxcor_VD_S_VS_BP);
#endif
Gmob_VGP_S=(Mutmp_VGP_S+GR_VGP_S)*Rxcor;
#if defined(_DERIVATE2)
  Gmob_VGP_S_VD_S=(+(+(+0.0+Mutmp_VGP_S_VD_S)+GR_VGP_S_VD_S)*Rxcor+(Mutmp_VGP_S+GR_VGP_S)*Rxcor_VD_S+(Mutmp_VD_S+GR_VD_S)*0.0+((1.0+Mutmp)+GR)*0.0);
  Gmob_VGP_S_VGP_S=(+(+(+0.0+Mutmp_VGP_S_VGP_S)+GR_VGP_S_VGP_S)*Rxcor+(Mutmp_VGP_S+GR_VGP_S)*0.0+(Mutmp_VGP_S+GR_VGP_S)*0.0+((1.0+Mutmp)+GR)*0.0);
  Gmob_VGP_S_VS_BP=(+(+(+0.0+Mutmp_VGP_S_VS_BP)+GR_VGP_S_VS_BP)*Rxcor+(Mutmp_VGP_S+GR_VGP_S)*Rxcor_VS_BP+(Mutmp_VS_BP+GR_VS_BP)*0.0+((1.0+Mutmp)+GR)*0.0);
#endif
Gmob_VS_BP=(((Mutmp_VS_BP+GR_VS_BP)*Rxcor)+(((1.0+Mutmp)+GR)*Rxcor_VS_BP));
#if defined(_DERIVATE2)
  Gmob_VS_BP_VD_S=(+(+(+0.0+Mutmp_VS_BP_VD_S)+GR_VS_BP_VD_S)*Rxcor+(Mutmp_VS_BP+GR_VS_BP)*Rxcor_VD_S+(Mutmp_VD_S+GR_VD_S)*Rxcor_VS_BP+((1.0+Mutmp)+GR)*Rxcor_VS_BP_VD_S);
  Gmob_VS_BP_VGP_S=(+(+(+0.0+Mutmp_VS_BP_VGP_S)+GR_VS_BP_VGP_S)*Rxcor+(Mutmp_VS_BP+GR_VS_BP)*0.0+(Mutmp_VGP_S+GR_VGP_S)*Rxcor_VS_BP+((1.0+Mutmp)+GR)*0.0);
  Gmob_VS_BP_VS_BP=(+(+(+0.0+Mutmp_VS_BP_VS_BP)+GR_VS_BP_VS_BP)*Rxcor+(Mutmp_VS_BP+GR_VS_BP)*Rxcor_VS_BP+(Mutmp_VS_BP+GR_VS_BP)*Rxcor_VS_BP+((1.0+Mutmp)+GR)*Rxcor_VS_BP_VS_BP);
#endif
#endif
pInst->Gmob=(((1.0+Mutmp)+GR)*Rxcor);
EXIT_IF_ISNAN((((1.0+Mutmp)+GR)*Rxcor))
if
((pInst->THESATB_i<0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xitsb_VD_S=(-(-(pInst->THESATB_i*Vsbx_VD_S))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx)));
#if defined(_DERIVATE2)
  xitsb_VD_S_VD_S=(0.0/(1.0-(pInst->THESATB_i*Vsbx))-(0.0*(-((pInst->THESATB_i*Vsbx_VD_S)))+0.0*(-(pInst->THESATB_i*Vsbx_VD_S))+1.0*(+0.0-(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VD_S+pInst->THESATB_i*Vsbx_VD_S_VD_S)))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx))+2*1.0*(-(pInst->THESATB_i*Vsbx_VD_S))*(-((pInst->THESATB_i*Vsbx_VD_S)))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx)));
  xitsb_VD_S_VS_BP=(0.0/(1.0-(pInst->THESATB_i*Vsbx))-(0.0*(-((pInst->THESATB_i*Vsbx_VS_BP)))+0.0*(-(pInst->THESATB_i*Vsbx_VD_S))+1.0*(+0.0-(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VD_S+pInst->THESATB_i*Vsbx_VD_S_VS_BP)))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx))+2*1.0*(-(pInst->THESATB_i*Vsbx_VD_S))*(-((pInst->THESATB_i*Vsbx_VS_BP)))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx)));
#endif
xitsb_VS_BP=(-(-(pInst->THESATB_i*Vsbx_VS_BP))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx)));
#if defined(_DERIVATE2)
  xitsb_VS_BP_VD_S=(0.0/(1.0-(pInst->THESATB_i*Vsbx))-(0.0*(-((pInst->THESATB_i*Vsbx_VD_S)))+0.0*(-(pInst->THESATB_i*Vsbx_VS_BP))+1.0*(+0.0-(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VS_BP+pInst->THESATB_i*Vsbx_VS_BP_VD_S)))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx))+2*1.0*(-(pInst->THESATB_i*Vsbx_VS_BP))*(-((pInst->THESATB_i*Vsbx_VD_S)))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx)));
  xitsb_VS_BP_VS_BP=(0.0/(1.0-(pInst->THESATB_i*Vsbx))-(0.0*(-((pInst->THESATB_i*Vsbx_VS_BP)))+0.0*(-(pInst->THESATB_i*Vsbx_VS_BP))+1.0*(+0.0-(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VS_BP+pInst->THESATB_i*Vsbx_VS_BP_VS_BP)))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx))+2*1.0*(-(pInst->THESATB_i*Vsbx_VS_BP))*(-((pInst->THESATB_i*Vsbx_VS_BP)))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx))/(1.0-(pInst->THESATB_i*Vsbx)));
#endif
#endif
pInst->xitsb=(1.0/(1.0-(pInst->THESATB_i*Vsbx)));
EXIT_IF_ISNAN((1.0/(1.0-(pInst->THESATB_i*Vsbx))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xitsb_VD_S=(pInst->THESATB_i*Vsbx_VD_S);
#if defined(_DERIVATE2)
  xitsb_VD_S_VD_S=(+0.0+(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VD_S+pInst->THESATB_i*Vsbx_VD_S_VD_S));
  xitsb_VD_S_VS_BP=(+0.0+(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VD_S+pInst->THESATB_i*Vsbx_VD_S_VS_BP));
#endif
xitsb_VS_BP=(pInst->THESATB_i*Vsbx_VS_BP);
#if defined(_DERIVATE2)
  xitsb_VS_BP_VD_S=(+0.0+(+0.0*Vsbx+0.0*Vsbx_VD_S+0.0*Vsbx_VS_BP+pInst->THESATB_i*Vsbx_VS_BP_VD_S));
  xitsb_VS_BP_VS_BP=(+0.0+(+0.0*Vsbx+0.0*Vsbx_VS_BP+0.0*Vsbx_VS_BP+pInst->THESATB_i*Vsbx_VS_BP_VS_BP));
#endif
#endif
pInst->xitsb=(1.0+(pInst->THESATB_i*Vsbx));
EXIT_IF_ISNAN((1.0+(pInst->THESATB_i*Vsbx)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp2_VD_S=((qis_VD_S*pInst->xitsb)+(qis*xitsb_VD_S));
#if defined(_DERIVATE2)
  temp2_VD_S_VD_S=(+qis_VD_S_VD_S*pInst->xitsb+qis_VD_S*xitsb_VD_S+qis_VD_S*xitsb_VD_S+qis*xitsb_VD_S_VD_S);
  temp2_VD_S_VGP_S=(+qis_VD_S_VGP_S*pInst->xitsb+qis_VD_S*0.0+qis_VGP_S*xitsb_VD_S+qis*0.0);
  temp2_VD_S_VS_BP=(+qis_VD_S_VS_BP*pInst->xitsb+qis_VD_S*xitsb_VS_BP+qis_VS_BP*xitsb_VD_S+qis*xitsb_VD_S_VS_BP);
#endif
temp2_VGP_S=qis_VGP_S*pInst->xitsb;
#if defined(_DERIVATE2)
  temp2_VGP_S_VD_S=(+qis_VGP_S_VD_S*pInst->xitsb+qis_VGP_S*xitsb_VD_S+qis_VD_S*0.0+qis*0.0);
  temp2_VGP_S_VGP_S=(+qis_VGP_S_VGP_S*pInst->xitsb+qis_VGP_S*0.0+qis_VGP_S*0.0+qis*0.0);
  temp2_VGP_S_VS_BP=(+qis_VGP_S_VS_BP*pInst->xitsb+qis_VGP_S*xitsb_VS_BP+qis_VS_BP*0.0+qis*0.0);
#endif
temp2_VS_BP=((qis_VS_BP*pInst->xitsb)+(qis*xitsb_VS_BP));
#if defined(_DERIVATE2)
  temp2_VS_BP_VD_S=(+qis_VS_BP_VD_S*pInst->xitsb+qis_VS_BP*xitsb_VD_S+qis_VD_S*xitsb_VS_BP+qis*xitsb_VS_BP_VD_S);
  temp2_VS_BP_VGP_S=(+qis_VS_BP_VGP_S*pInst->xitsb+qis_VS_BP*0.0+qis_VGP_S*xitsb_VS_BP+qis*0.0);
  temp2_VS_BP_VS_BP=(+qis_VS_BP_VS_BP*pInst->xitsb+qis_VS_BP*xitsb_VS_BP+qis_VS_BP*xitsb_VS_BP+qis*xitsb_VS_BP_VS_BP);
#endif
#endif
temp2=(qis*pInst->xitsb);
EXIT_IF_ISNAN((qis*pInst->xitsb))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
wsat_VD_S=(100.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2)));
#if defined(_DERIVATE2)
  wsat_VD_S_VD_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VD_S_VD_S/(100.0+temp2)-(temp2_VD_S*temp2_VD_S+temp2_VD_S*temp2_VD_S+temp2*(+0.0+temp2_VD_S_VD_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VD_S*temp2_VD_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VD_S_VGP_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VD_S_VGP_S/(100.0+temp2)-(temp2_VD_S*temp2_VGP_S+temp2_VGP_S*temp2_VD_S+temp2*(+0.0+temp2_VD_S_VGP_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VD_S*temp2_VGP_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VD_S_VS_BP=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VD_S_VS_BP/(100.0+temp2)-(temp2_VD_S*temp2_VS_BP+temp2_VS_BP*temp2_VD_S+temp2*(+0.0+temp2_VD_S_VS_BP))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VD_S*temp2_VS_BP/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
#endif
wsat_VGP_S=(100.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2)));
#if defined(_DERIVATE2)
  wsat_VGP_S_VD_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VGP_S_VD_S/(100.0+temp2)-(temp2_VGP_S*temp2_VD_S+temp2_VD_S*temp2_VGP_S+temp2*(+0.0+temp2_VGP_S_VD_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VGP_S*temp2_VD_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VGP_S_VGP_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VGP_S_VGP_S/(100.0+temp2)-(temp2_VGP_S*temp2_VGP_S+temp2_VGP_S*temp2_VGP_S+temp2*(+0.0+temp2_VGP_S_VGP_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VGP_S*temp2_VGP_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VGP_S_VS_BP=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VGP_S_VS_BP/(100.0+temp2)-(temp2_VGP_S*temp2_VS_BP+temp2_VS_BP*temp2_VGP_S+temp2*(+0.0+temp2_VGP_S_VS_BP))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VGP_S*temp2_VS_BP/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
#endif
wsat_VS_BP=(100.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2)));
#if defined(_DERIVATE2)
  wsat_VS_BP_VD_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VS_BP_VD_S/(100.0+temp2)-(temp2_VS_BP*temp2_VD_S+temp2_VD_S*temp2_VS_BP+temp2*(+0.0+temp2_VS_BP_VD_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VS_BP*temp2_VD_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VS_BP_VGP_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VS_BP_VGP_S/(100.0+temp2)-(temp2_VS_BP*temp2_VGP_S+temp2_VGP_S*temp2_VS_BP+temp2*(+0.0+temp2_VS_BP_VGP_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VS_BP*temp2_VGP_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VS_BP_VS_BP=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VS_BP_VS_BP/(100.0+temp2)-(temp2_VS_BP*temp2_VS_BP+temp2_VS_BP*temp2_VS_BP+temp2*(+0.0+temp2_VS_BP_VS_BP))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VS_BP*temp2_VS_BP/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
#endif
#endif
wsat=(100.0*(temp2/(100.0+temp2)));
EXIT_IF_ISNAN((100.0*(temp2/(100.0+temp2))))
if
((pInst->THESATG_i<0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-1*(-(pInst->THESATG_i*wsat_VGP_S))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VGP_S+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VGP_S_VS_BS=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VGP_S+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VGP_S_VGP_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VGP_S)))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-((pInst->THESATG_i*wsat_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VGP_S_VD_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VD_S)))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-((pInst->THESATG_i*wsat_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VGP_S_VS_BP=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VS_BP)))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-((pInst->THESATG_i*wsat_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#endif
temp_VD_S=(-1*(-(pInst->THESATG_i*wsat_VD_S))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VD_S+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VD_S_VS_BS=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VD_S+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VD_S_VGP_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VGP_S)))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-((pInst->THESATG_i*wsat_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VD_S_VD_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VD_S)))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-((pInst->THESATG_i*wsat_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VD_S_VS_BP=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VS_BP)))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-((pInst->THESATG_i*wsat_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#endif
temp_VS_BP=(-1*(-(pInst->THESATG_i*wsat_VS_BP))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VS_BP+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VS_BP_VS_BS=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VS_BP+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VS_BP_VGP_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VGP_S)))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-((pInst->THESATG_i*wsat_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VS_BP_VD_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VD_S)))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-((pInst->THESATG_i*wsat_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VS_BP_VS_BP=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VS_BP)))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-((pInst->THESATG_i*wsat_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#endif
#endif
temp=(1/(1-(pInst->THESATG_i*wsat)));
EXIT_IF_ISNAN((1/(1-(pInst->THESATG_i*wsat))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(pInst->THESATG_i*wsat_VGP_S);
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VGP_S+pInst->THESATG_i*0.0));
  temp_VGP_S_VS_BS=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VGP_S+pInst->THESATG_i*0.0));
  temp_VGP_S_VGP_S=(+0.0+(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VGP_S));
  temp_VGP_S_VD_S=(+0.0+(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VD_S));
  temp_VGP_S_VS_BP=(+0.0+(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VS_BP));
#endif
temp_VD_S=(pInst->THESATG_i*wsat_VD_S);
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VD_S+pInst->THESATG_i*0.0));
  temp_VD_S_VS_BS=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VD_S+pInst->THESATG_i*0.0));
  temp_VD_S_VGP_S=(+0.0+(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VGP_S));
  temp_VD_S_VD_S=(+0.0+(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VD_S));
  temp_VD_S_VS_BP=(+0.0+(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VS_BP));
#endif
temp_VS_BP=(pInst->THESATG_i*wsat_VS_BP);
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VS_BP+pInst->THESATG_i*0.0));
  temp_VS_BP_VS_BS=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VS_BP+pInst->THESATG_i*0.0));
  temp_VS_BP_VGP_S=(+0.0+(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VGP_S));
  temp_VS_BP_VD_S=(+0.0+(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VD_S));
  temp_VS_BP_VS_BP=(+0.0+(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VS_BP));
#endif
#endif
temp=(1+(pInst->THESATG_i*wsat));
EXIT_IF_ISNAN((1+(pInst->THESATG_i*wsat)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
thesat1_VGP_S=(pInst->THESAT_i*((temp_VGP_S*pInst->Gmob-temp*Gmob_VGP_S)/pInst->Gmob/pInst->Gmob));
#if defined(_DERIVATE2)
  thesat1_VGP_S_VGP_S=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VGP_S*pInst->Gmob-temp*Gmob_VGP_S)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VGP_S*pInst->Gmob-temp*Gmob_VGP_S)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VGP_S_VGP_S/pInst->Gmob-(temp_VGP_S*Gmob_VGP_S+temp_VGP_S*Gmob_VGP_S+temp*Gmob_VGP_S_VGP_S)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VGP_S*Gmob_VGP_S/pInst->Gmob/pInst->Gmob/pInst->Gmob));
  thesat1_VGP_S_VD_S=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VD_S*pInst->Gmob-temp*Gmob_VD_S)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VGP_S*pInst->Gmob-temp*Gmob_VGP_S)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VGP_S_VD_S/pInst->Gmob-(temp_VGP_S*Gmob_VD_S+temp_VD_S*Gmob_VGP_S+temp*Gmob_VGP_S_VD_S)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VGP_S*Gmob_VD_S/pInst->Gmob/pInst->Gmob/pInst->Gmob));
  thesat1_VGP_S_VS_BP=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VS_BP*pInst->Gmob-temp*Gmob_VS_BP)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VGP_S*pInst->Gmob-temp*Gmob_VGP_S)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VGP_S_VS_BP/pInst->Gmob-(temp_VGP_S*Gmob_VS_BP+temp_VS_BP*Gmob_VGP_S+temp*Gmob_VGP_S_VS_BP)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VGP_S*Gmob_VS_BP/pInst->Gmob/pInst->Gmob/pInst->Gmob));
#endif
thesat1_VD_S=(pInst->THESAT_i*((temp_VD_S*pInst->Gmob-temp*Gmob_VD_S)/pInst->Gmob/pInst->Gmob));
#if defined(_DERIVATE2)
  thesat1_VD_S_VGP_S=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VGP_S*pInst->Gmob-temp*Gmob_VGP_S)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VD_S*pInst->Gmob-temp*Gmob_VD_S)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VD_S_VGP_S/pInst->Gmob-(temp_VD_S*Gmob_VGP_S+temp_VGP_S*Gmob_VD_S+temp*Gmob_VD_S_VGP_S)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VD_S*Gmob_VGP_S/pInst->Gmob/pInst->Gmob/pInst->Gmob));
  thesat1_VD_S_VD_S=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VD_S*pInst->Gmob-temp*Gmob_VD_S)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VD_S*pInst->Gmob-temp*Gmob_VD_S)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VD_S_VD_S/pInst->Gmob-(temp_VD_S*Gmob_VD_S+temp_VD_S*Gmob_VD_S+temp*Gmob_VD_S_VD_S)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VD_S*Gmob_VD_S/pInst->Gmob/pInst->Gmob/pInst->Gmob));
  thesat1_VD_S_VS_BP=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VS_BP*pInst->Gmob-temp*Gmob_VS_BP)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VD_S*pInst->Gmob-temp*Gmob_VD_S)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VD_S_VS_BP/pInst->Gmob-(temp_VD_S*Gmob_VS_BP+temp_VS_BP*Gmob_VD_S+temp*Gmob_VD_S_VS_BP)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VD_S*Gmob_VS_BP/pInst->Gmob/pInst->Gmob/pInst->Gmob));
#endif
thesat1_VS_BP=(pInst->THESAT_i*((temp_VS_BP*pInst->Gmob-temp*Gmob_VS_BP)/pInst->Gmob/pInst->Gmob));
#if defined(_DERIVATE2)
  thesat1_VS_BP_VGP_S=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VGP_S*pInst->Gmob-temp*Gmob_VGP_S)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VS_BP*pInst->Gmob-temp*Gmob_VS_BP)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VS_BP_VGP_S/pInst->Gmob-(temp_VS_BP*Gmob_VGP_S+temp_VGP_S*Gmob_VS_BP+temp*Gmob_VS_BP_VGP_S)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VS_BP*Gmob_VGP_S/pInst->Gmob/pInst->Gmob/pInst->Gmob));
  thesat1_VS_BP_VD_S=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VD_S*pInst->Gmob-temp*Gmob_VD_S)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VS_BP*pInst->Gmob-temp*Gmob_VS_BP)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VS_BP_VD_S/pInst->Gmob-(temp_VS_BP*Gmob_VD_S+temp_VD_S*Gmob_VS_BP+temp*Gmob_VS_BP_VD_S)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VS_BP*Gmob_VD_S/pInst->Gmob/pInst->Gmob/pInst->Gmob));
  thesat1_VS_BP_VS_BP=(+0.0*(temp/pInst->Gmob)+0.0*((temp_VS_BP*pInst->Gmob-temp*Gmob_VS_BP)/pInst->Gmob/pInst->Gmob)+0.0*((temp_VS_BP*pInst->Gmob-temp*Gmob_VS_BP)/pInst->Gmob/pInst->Gmob)+pInst->THESAT_i*(temp_VS_BP_VS_BP/pInst->Gmob-(temp_VS_BP*Gmob_VS_BP+temp_VS_BP*Gmob_VS_BP+temp*Gmob_VS_BP_VS_BP)/pInst->Gmob/pInst->Gmob+2*temp*Gmob_VS_BP*Gmob_VS_BP/pInst->Gmob/pInst->Gmob/pInst->Gmob));
#endif
#endif
thesat1=(pInst->THESAT_i*(temp/pInst->Gmob));
EXIT_IF_ISNAN((pInst->THESAT_i*(temp/pInst->Gmob)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
phi_inf_VD_S=((qis_VD_S*pInst->alpha-qis*alpha_VD_S)/pInst->alpha/pInst->alpha);
#if defined(_DERIVATE2)
  phi_inf_VD_S_VD_S=(+(qis_VD_S_VD_S/pInst->alpha-(qis_VD_S*alpha_VD_S+qis_VD_S*alpha_VD_S+qis*alpha_VD_S_VD_S)/pInst->alpha/pInst->alpha+2*qis*alpha_VD_S*alpha_VD_S/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
  phi_inf_VD_S_VGP_S=(+(qis_VD_S_VGP_S/pInst->alpha-(qis_VD_S*alpha_VGP_S+qis_VGP_S*alpha_VD_S+qis*alpha_VD_S_VGP_S)/pInst->alpha/pInst->alpha+2*qis*alpha_VD_S*alpha_VGP_S/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
  phi_inf_VD_S_VS_BP=(+(qis_VD_S_VS_BP/pInst->alpha-(qis_VD_S*alpha_VS_BP+qis_VS_BP*alpha_VD_S+qis*alpha_VD_S_VS_BP)/pInst->alpha/pInst->alpha+2*qis*alpha_VD_S*alpha_VS_BP/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
#endif
phi_inf_VGP_S=((qis_VGP_S*pInst->alpha-qis*alpha_VGP_S)/pInst->alpha/pInst->alpha);
#if defined(_DERIVATE2)
  phi_inf_VGP_S_VD_S=(+(qis_VGP_S_VD_S/pInst->alpha-(qis_VGP_S*alpha_VD_S+qis_VD_S*alpha_VGP_S+qis*alpha_VGP_S_VD_S)/pInst->alpha/pInst->alpha+2*qis*alpha_VGP_S*alpha_VD_S/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
  phi_inf_VGP_S_VGP_S=(+(qis_VGP_S_VGP_S/pInst->alpha-(qis_VGP_S*alpha_VGP_S+qis_VGP_S*alpha_VGP_S+qis*alpha_VGP_S_VGP_S)/pInst->alpha/pInst->alpha+2*qis*alpha_VGP_S*alpha_VGP_S/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
  phi_inf_VGP_S_VS_BP=(+(qis_VGP_S_VS_BP/pInst->alpha-(qis_VGP_S*alpha_VS_BP+qis_VS_BP*alpha_VGP_S+qis*alpha_VGP_S_VS_BP)/pInst->alpha/pInst->alpha+2*qis*alpha_VGP_S*alpha_VS_BP/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
#endif
phi_inf_VS_BP=((qis_VS_BP*pInst->alpha-qis*alpha_VS_BP)/pInst->alpha/pInst->alpha);
#if defined(_DERIVATE2)
  phi_inf_VS_BP_VD_S=(+(qis_VS_BP_VD_S/pInst->alpha-(qis_VS_BP*alpha_VD_S+qis_VD_S*alpha_VS_BP+qis*alpha_VS_BP_VD_S)/pInst->alpha/pInst->alpha+2*qis*alpha_VS_BP*alpha_VD_S/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
  phi_inf_VS_BP_VGP_S=(+(qis_VS_BP_VGP_S/pInst->alpha-(qis_VS_BP*alpha_VGP_S+qis_VGP_S*alpha_VS_BP+qis*alpha_VS_BP_VGP_S)/pInst->alpha/pInst->alpha+2*qis*alpha_VS_BP*alpha_VGP_S/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
  phi_inf_VS_BP_VS_BP=(+(qis_VS_BP_VS_BP/pInst->alpha-(qis_VS_BP*alpha_VS_BP+qis_VS_BP*alpha_VS_BP+qis*alpha_VS_BP_VS_BP)/pInst->alpha/pInst->alpha+2*qis*alpha_VS_BP*alpha_VS_BP/pInst->alpha/pInst->alpha/pInst->alpha)+0.0);
#endif
#endif
phi_inf=((qis/pInst->alpha)+pInst->phit1);
EXIT_IF_ISNAN(((qis/pInst->alpha)+pInst->phit1))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
ysat_VGP_S=((thesat1_VGP_S*phi_inf)+(thesat1*phi_inf_VGP_S))*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  ysat_VGP_S_VGP_S=(+(+thesat1_VGP_S_VGP_S*phi_inf+thesat1_VGP_S*phi_inf_VGP_S+thesat1_VGP_S*phi_inf_VGP_S+thesat1*phi_inf_VGP_S_VGP_S)*7.0710678118654746e-01+((thesat1_VGP_S*phi_inf)+(thesat1*phi_inf_VGP_S))*0.0+(((thesat1_VGP_S*phi_inf)+(thesat1*phi_inf_VGP_S)))*0.0+(thesat1*phi_inf)*0.0);
  ysat_VGP_S_VD_S=(+(+thesat1_VGP_S_VD_S*phi_inf+thesat1_VGP_S*phi_inf_VD_S+thesat1_VD_S*phi_inf_VGP_S+thesat1*phi_inf_VGP_S_VD_S)*7.0710678118654746e-01+((thesat1_VGP_S*phi_inf)+(thesat1*phi_inf_VGP_S))*0.0+(((thesat1_VD_S*phi_inf)+(thesat1*phi_inf_VD_S)))*0.0+(thesat1*phi_inf)*0.0);
  ysat_VGP_S_VS_BP=(+(+thesat1_VGP_S_VS_BP*phi_inf+thesat1_VGP_S*phi_inf_VS_BP+thesat1_VS_BP*phi_inf_VGP_S+thesat1*phi_inf_VGP_S_VS_BP)*7.0710678118654746e-01+((thesat1_VGP_S*phi_inf)+(thesat1*phi_inf_VGP_S))*0.0+(((thesat1_VS_BP*phi_inf)+(thesat1*phi_inf_VS_BP)))*0.0+(thesat1*phi_inf)*0.0);
#endif
ysat_VD_S=((thesat1_VD_S*phi_inf)+(thesat1*phi_inf_VD_S))*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  ysat_VD_S_VGP_S=(+(+thesat1_VD_S_VGP_S*phi_inf+thesat1_VD_S*phi_inf_VGP_S+thesat1_VGP_S*phi_inf_VD_S+thesat1*phi_inf_VD_S_VGP_S)*7.0710678118654746e-01+((thesat1_VD_S*phi_inf)+(thesat1*phi_inf_VD_S))*0.0+(((thesat1_VGP_S*phi_inf)+(thesat1*phi_inf_VGP_S)))*0.0+(thesat1*phi_inf)*0.0);
  ysat_VD_S_VD_S=(+(+thesat1_VD_S_VD_S*phi_inf+thesat1_VD_S*phi_inf_VD_S+thesat1_VD_S*phi_inf_VD_S+thesat1*phi_inf_VD_S_VD_S)*7.0710678118654746e-01+((thesat1_VD_S*phi_inf)+(thesat1*phi_inf_VD_S))*0.0+(((thesat1_VD_S*phi_inf)+(thesat1*phi_inf_VD_S)))*0.0+(thesat1*phi_inf)*0.0);
  ysat_VD_S_VS_BP=(+(+thesat1_VD_S_VS_BP*phi_inf+thesat1_VD_S*phi_inf_VS_BP+thesat1_VS_BP*phi_inf_VD_S+thesat1*phi_inf_VD_S_VS_BP)*7.0710678118654746e-01+((thesat1_VD_S*phi_inf)+(thesat1*phi_inf_VD_S))*0.0+(((thesat1_VS_BP*phi_inf)+(thesat1*phi_inf_VS_BP)))*0.0+(thesat1*phi_inf)*0.0);
#endif
ysat_VS_BP=((thesat1_VS_BP*phi_inf)+(thesat1*phi_inf_VS_BP))*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  ysat_VS_BP_VGP_S=(+(+thesat1_VS_BP_VGP_S*phi_inf+thesat1_VS_BP*phi_inf_VGP_S+thesat1_VGP_S*phi_inf_VS_BP+thesat1*phi_inf_VS_BP_VGP_S)*7.0710678118654746e-01+((thesat1_VS_BP*phi_inf)+(thesat1*phi_inf_VS_BP))*0.0+(((thesat1_VGP_S*phi_inf)+(thesat1*phi_inf_VGP_S)))*0.0+(thesat1*phi_inf)*0.0);
  ysat_VS_BP_VD_S=(+(+thesat1_VS_BP_VD_S*phi_inf+thesat1_VS_BP*phi_inf_VD_S+thesat1_VD_S*phi_inf_VS_BP+thesat1*phi_inf_VS_BP_VD_S)*7.0710678118654746e-01+((thesat1_VS_BP*phi_inf)+(thesat1*phi_inf_VS_BP))*0.0+(((thesat1_VD_S*phi_inf)+(thesat1*phi_inf_VD_S)))*0.0+(thesat1*phi_inf)*0.0);
  ysat_VS_BP_VS_BP=(+(+thesat1_VS_BP_VS_BP*phi_inf+thesat1_VS_BP*phi_inf_VS_BP+thesat1_VS_BP*phi_inf_VS_BP+thesat1*phi_inf_VS_BP_VS_BP)*7.0710678118654746e-01+((thesat1_VS_BP*phi_inf)+(thesat1*phi_inf_VS_BP))*0.0+(((thesat1_VS_BP*phi_inf)+(thesat1*phi_inf_VS_BP)))*0.0+(thesat1*phi_inf)*0.0);
#endif
#endif
ysat=((thesat1*phi_inf)*7.0710678118654746e-01);
EXIT_IF_ISNAN(((thesat1*phi_inf)*7.0710678118654746e-01))
if
((pModel->CHNL_TYPE==(-1)))
{
{
double m00_sqrt(d00_sqrt0,(1.0+ysat))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+ysat))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
ysat_VGP_S=((ysat_VGP_S*d00_sqrt0-ysat*ysat_VGP_S*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  ysat_VGP_S_VGP_S=(ysat_VGP_S_VGP_S/d00_sqrt0-(ysat_VGP_S*ysat_VGP_S*d10_sqrt0+ysat_VGP_S*ysat_VGP_S*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VGP_S*ysat_VGP_S+d10_sqrt0*(+0.0+ysat_VGP_S_VGP_S)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VGP_S*d10_sqrt0*ysat_VGP_S*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  ysat_VGP_S_VD_S=(ysat_VGP_S_VD_S/d00_sqrt0-(ysat_VGP_S*ysat_VD_S*d10_sqrt0+ysat_VD_S*ysat_VGP_S*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VD_S*ysat_VGP_S+d10_sqrt0*(+0.0+ysat_VGP_S_VD_S)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VGP_S*d10_sqrt0*ysat_VD_S*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  ysat_VGP_S_VS_BP=(ysat_VGP_S_VS_BP/d00_sqrt0-(ysat_VGP_S*ysat_VS_BP*d10_sqrt0+ysat_VS_BP*ysat_VGP_S*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VS_BP*ysat_VGP_S+d10_sqrt0*(+0.0+ysat_VGP_S_VS_BP)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VGP_S*d10_sqrt0*ysat_VS_BP*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
ysat_VD_S=((ysat_VD_S*d00_sqrt0-ysat*ysat_VD_S*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  ysat_VD_S_VGP_S=(ysat_VD_S_VGP_S/d00_sqrt0-(ysat_VD_S*ysat_VGP_S*d10_sqrt0+ysat_VGP_S*ysat_VD_S*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VGP_S*ysat_VD_S+d10_sqrt0*(+0.0+ysat_VD_S_VGP_S)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VD_S*d10_sqrt0*ysat_VGP_S*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  ysat_VD_S_VD_S=(ysat_VD_S_VD_S/d00_sqrt0-(ysat_VD_S*ysat_VD_S*d10_sqrt0+ysat_VD_S*ysat_VD_S*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VD_S*ysat_VD_S+d10_sqrt0*(+0.0+ysat_VD_S_VD_S)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VD_S*d10_sqrt0*ysat_VD_S*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  ysat_VD_S_VS_BP=(ysat_VD_S_VS_BP/d00_sqrt0-(ysat_VD_S*ysat_VS_BP*d10_sqrt0+ysat_VS_BP*ysat_VD_S*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VS_BP*ysat_VD_S+d10_sqrt0*(+0.0+ysat_VD_S_VS_BP)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VD_S*d10_sqrt0*ysat_VS_BP*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
ysat_VS_BP=((ysat_VS_BP*d00_sqrt0-ysat*ysat_VS_BP*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  ysat_VS_BP_VGP_S=(ysat_VS_BP_VGP_S/d00_sqrt0-(ysat_VS_BP*ysat_VGP_S*d10_sqrt0+ysat_VGP_S*ysat_VS_BP*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VGP_S*ysat_VS_BP+d10_sqrt0*(+0.0+ysat_VS_BP_VGP_S)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VS_BP*d10_sqrt0*ysat_VGP_S*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  ysat_VS_BP_VD_S=(ysat_VS_BP_VD_S/d00_sqrt0-(ysat_VS_BP*ysat_VD_S*d10_sqrt0+ysat_VD_S*ysat_VS_BP*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VD_S*ysat_VS_BP+d10_sqrt0*(+0.0+ysat_VS_BP_VD_S)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VS_BP*d10_sqrt0*ysat_VD_S*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  ysat_VS_BP_VS_BP=(ysat_VS_BP_VS_BP/d00_sqrt0-(ysat_VS_BP*ysat_VS_BP*d10_sqrt0+ysat_VS_BP*ysat_VS_BP*d10_sqrt0+ysat*(m20_sqrt((1.0+ysat))*ysat_VS_BP*ysat_VS_BP+d10_sqrt0*(+0.0+ysat_VS_BP_VS_BP)))/d00_sqrt0/d00_sqrt0+2*ysat*ysat_VS_BP*d10_sqrt0*ysat_VS_BP*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
ysat=(ysat/d00_sqrt0);
EXIT_IF_ISNAN((ysat/d00_sqrt0))
}
}
{
double m00_sqrt(d00_sqrt0,(1.0+(4.0*ysat)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(4.0*ysat)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
za_VGP_S=(-2.0*(4.0*ysat_VGP_S)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  za_VGP_S_VGP_S=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VGP_S))*d10_sqrt0+0.0*(4.0*ysat_VGP_S)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VGP_S))*(4.0*ysat_VGP_S)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VGP_S+0.0*ysat_VGP_S+4.0*ysat_VGP_S_VGP_S)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VGP_S)*d10_sqrt0*((4.0*ysat_VGP_S))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  za_VGP_S_VD_S=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VD_S))*d10_sqrt0+0.0*(4.0*ysat_VGP_S)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VD_S))*(4.0*ysat_VGP_S)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VD_S+0.0*ysat_VGP_S+4.0*ysat_VGP_S_VD_S)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VGP_S)*d10_sqrt0*((4.0*ysat_VD_S))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  za_VGP_S_VS_BP=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VS_BP))*d10_sqrt0+0.0*(4.0*ysat_VGP_S)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VS_BP))*(4.0*ysat_VGP_S)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VS_BP+0.0*ysat_VGP_S+4.0*ysat_VGP_S_VS_BP)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VGP_S)*d10_sqrt0*((4.0*ysat_VS_BP))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
za_VD_S=(-2.0*(4.0*ysat_VD_S)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  za_VD_S_VGP_S=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VGP_S))*d10_sqrt0+0.0*(4.0*ysat_VD_S)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VGP_S))*(4.0*ysat_VD_S)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VGP_S+0.0*ysat_VD_S+4.0*ysat_VD_S_VGP_S)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VD_S)*d10_sqrt0*((4.0*ysat_VGP_S))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  za_VD_S_VD_S=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VD_S))*d10_sqrt0+0.0*(4.0*ysat_VD_S)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VD_S))*(4.0*ysat_VD_S)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VD_S+0.0*ysat_VD_S+4.0*ysat_VD_S_VD_S)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VD_S)*d10_sqrt0*((4.0*ysat_VD_S))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  za_VD_S_VS_BP=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VS_BP))*d10_sqrt0+0.0*(4.0*ysat_VD_S)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VS_BP))*(4.0*ysat_VD_S)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VS_BP+0.0*ysat_VD_S+4.0*ysat_VD_S_VS_BP)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VD_S)*d10_sqrt0*((4.0*ysat_VS_BP))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
za_VS_BP=(-2.0*(4.0*ysat_VS_BP)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  za_VS_BP_VGP_S=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VGP_S))*d10_sqrt0+0.0*(4.0*ysat_VS_BP)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VGP_S))*(4.0*ysat_VS_BP)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VGP_S+0.0*ysat_VS_BP+4.0*ysat_VS_BP_VGP_S)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VS_BP)*d10_sqrt0*((4.0*ysat_VGP_S))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  za_VS_BP_VD_S=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VD_S))*d10_sqrt0+0.0*(4.0*ysat_VS_BP)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VD_S))*(4.0*ysat_VS_BP)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VD_S+0.0*ysat_VS_BP+4.0*ysat_VS_BP_VD_S)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VS_BP)*d10_sqrt0*((4.0*ysat_VD_S))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  za_VS_BP_VS_BP=(0.0/(1.0+d00_sqrt0)-(0.0*((4.0*ysat_VS_BP))*d10_sqrt0+0.0*(4.0*ysat_VS_BP)*d10_sqrt0+2.0*(+0.0+(m20_sqrt((1.0+(4.0*ysat)))*((4.0*ysat_VS_BP))*(4.0*ysat_VS_BP)+d10_sqrt0*(+0.0+(+0.0*ysat+0.0*ysat_VS_BP+0.0*ysat_VS_BP+4.0*ysat_VS_BP_VS_BP)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*2.0*(4.0*ysat_VS_BP)*d10_sqrt0*((4.0*ysat_VS_BP))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#endif
za=(2.0/(1.0+d00_sqrt0));
EXIT_IF_ISNAN((2.0/(1.0+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp1_VGP_S=((za_VGP_S*ysat)+(za*ysat_VGP_S));
#if defined(_DERIVATE2)
  temp1_VGP_S_VGP_S=(+za_VGP_S_VGP_S*ysat+za_VGP_S*ysat_VGP_S+za_VGP_S*ysat_VGP_S+za*ysat_VGP_S_VGP_S);
  temp1_VGP_S_VD_S=(+za_VGP_S_VD_S*ysat+za_VGP_S*ysat_VD_S+za_VD_S*ysat_VGP_S+za*ysat_VGP_S_VD_S);
  temp1_VGP_S_VS_BP=(+za_VGP_S_VS_BP*ysat+za_VGP_S*ysat_VS_BP+za_VS_BP*ysat_VGP_S+za*ysat_VGP_S_VS_BP);
#endif
temp1_VD_S=((za_VD_S*ysat)+(za*ysat_VD_S));
#if defined(_DERIVATE2)
  temp1_VD_S_VGP_S=(+za_VD_S_VGP_S*ysat+za_VD_S*ysat_VGP_S+za_VGP_S*ysat_VD_S+za*ysat_VD_S_VGP_S);
  temp1_VD_S_VD_S=(+za_VD_S_VD_S*ysat+za_VD_S*ysat_VD_S+za_VD_S*ysat_VD_S+za*ysat_VD_S_VD_S);
  temp1_VD_S_VS_BP=(+za_VD_S_VS_BP*ysat+za_VD_S*ysat_VS_BP+za_VS_BP*ysat_VD_S+za*ysat_VD_S_VS_BP);
#endif
temp1_VS_BP=((za_VS_BP*ysat)+(za*ysat_VS_BP));
#if defined(_DERIVATE2)
  temp1_VS_BP_VGP_S=(+za_VS_BP_VGP_S*ysat+za_VS_BP*ysat_VGP_S+za_VGP_S*ysat_VS_BP+za*ysat_VS_BP_VGP_S);
  temp1_VS_BP_VD_S=(+za_VS_BP_VD_S*ysat+za_VS_BP*ysat_VD_S+za_VD_S*ysat_VS_BP+za*ysat_VS_BP_VD_S);
  temp1_VS_BP_VS_BP=(+za_VS_BP_VS_BP*ysat+za_VS_BP*ysat_VS_BP+za_VS_BP*ysat_VS_BP+za*ysat_VS_BP_VS_BP);
#endif
#endif
temp1=(za*ysat);
EXIT_IF_ISNAN((za*ysat))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Phi_0_VD_S=((((phi_inf_VD_S*za)+(phi_inf*za_VD_S))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))))+((phi_inf*za)*(0.86*((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
#if defined(_DERIVATE2)
  Phi_0_VD_S_VD_S=(+(+phi_inf_VD_S_VD_S*za+phi_inf_VD_S*za_VD_S+phi_inf_VD_S*za_VD_S+phi_inf*za_VD_S_VD_S)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VD_S*za)+(phi_inf*za_VD_S))*((0.86*(((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VD_S*za)+(phi_inf*za_VD_S)))*(0.86*((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VD_S_VD_S*(1.0-(temp1*za))+temp1_VD_S*(-(((temp1_VD_S*za)+(temp1*za_VD_S))))+temp1_VD_S*(-((temp1_VD_S*za)+(temp1*za_VD_S)))+temp1*(+0.0-(+temp1_VD_S_VD_S*za+temp1_VD_S*za_VD_S+temp1_VD_S*za_VD_S+temp1*za_VD_S_VD_S)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))))+(((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))+0.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))+4.0*(+(+temp1_VD_S_VD_S*temp1+temp1_VD_S*temp1_VD_S+temp1_VD_S*temp1_VD_S+temp1*temp1_VD_S_VD_S)*za+((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za_VD_S+(((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za_VD_S+(temp1*temp1)*za_VD_S_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
  Phi_0_VD_S_VGP_S=(+(+phi_inf_VD_S_VGP_S*za+phi_inf_VD_S*za_VGP_S+phi_inf_VGP_S*za_VD_S+phi_inf*za_VD_S_VGP_S)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VD_S*za)+(phi_inf*za_VD_S))*((0.86*(((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VGP_S*za)+(phi_inf*za_VGP_S)))*(0.86*((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VD_S_VGP_S*(1.0-(temp1*za))+temp1_VD_S*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S))))+temp1_VGP_S*(-((temp1_VD_S*za)+(temp1*za_VD_S)))+temp1*(+0.0-(+temp1_VD_S_VGP_S*za+temp1_VD_S*za_VGP_S+temp1_VGP_S*za_VD_S+temp1*za_VD_S_VGP_S)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))))+(((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))+0.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))+4.0*(+(+temp1_VD_S_VGP_S*temp1+temp1_VD_S*temp1_VGP_S+temp1_VGP_S*temp1_VD_S+temp1*temp1_VD_S_VGP_S)*za+((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za_VGP_S+(((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za_VD_S+(temp1*temp1)*za_VD_S_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
  Phi_0_VD_S_VS_BP=(+(+phi_inf_VD_S_VS_BP*za+phi_inf_VD_S*za_VS_BP+phi_inf_VS_BP*za_VD_S+phi_inf*za_VD_S_VS_BP)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VD_S*za)+(phi_inf*za_VD_S))*((0.86*(((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VS_BP*za)+(phi_inf*za_VS_BP)))*(0.86*((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VD_S_VS_BP*(1.0-(temp1*za))+temp1_VD_S*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP))))+temp1_VS_BP*(-((temp1_VD_S*za)+(temp1*za_VD_S)))+temp1*(+0.0-(+temp1_VD_S_VS_BP*za+temp1_VD_S*za_VS_BP+temp1_VS_BP*za_VD_S+temp1*za_VD_S_VS_BP)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VD_S*za)+(temp1*za_VD_S)))))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))))+(((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))+0.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S))+4.0*(+(+temp1_VD_S_VS_BP*temp1+temp1_VD_S*temp1_VS_BP+temp1_VS_BP*temp1_VD_S+temp1*temp1_VD_S_VS_BP)*za+((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za_VS_BP+(((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za_VD_S+(temp1*temp1)*za_VD_S_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VD_S*temp1)+(temp1*temp1_VD_S))*za)+((temp1*temp1)*za_VD_S)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
#endif
Phi_0_VGP_S=((((phi_inf_VGP_S*za)+(phi_inf*za_VGP_S))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))))+((phi_inf*za)*(0.86*((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
#if defined(_DERIVATE2)
  Phi_0_VGP_S_VD_S=(+(+phi_inf_VGP_S_VD_S*za+phi_inf_VGP_S*za_VD_S+phi_inf_VD_S*za_VGP_S+phi_inf*za_VGP_S_VD_S)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VGP_S*za)+(phi_inf*za_VGP_S))*((0.86*(((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VD_S*za)+(phi_inf*za_VD_S)))*(0.86*((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VGP_S_VD_S*(1.0-(temp1*za))+temp1_VGP_S*(-(((temp1_VD_S*za)+(temp1*za_VD_S))))+temp1_VD_S*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))+temp1*(+0.0-(+temp1_VGP_S_VD_S*za+temp1_VGP_S*za_VD_S+temp1_VD_S*za_VGP_S+temp1*za_VGP_S_VD_S)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))))+(((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))+0.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))+4.0*(+(+temp1_VGP_S_VD_S*temp1+temp1_VGP_S*temp1_VD_S+temp1_VD_S*temp1_VGP_S+temp1*temp1_VGP_S_VD_S)*za+((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za_VD_S+(((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za_VGP_S+(temp1*temp1)*za_VGP_S_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
  Phi_0_VGP_S_VGP_S=(+(+phi_inf_VGP_S_VGP_S*za+phi_inf_VGP_S*za_VGP_S+phi_inf_VGP_S*za_VGP_S+phi_inf*za_VGP_S_VGP_S)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VGP_S*za)+(phi_inf*za_VGP_S))*((0.86*(((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VGP_S*za)+(phi_inf*za_VGP_S)))*(0.86*((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VGP_S_VGP_S*(1.0-(temp1*za))+temp1_VGP_S*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S))))+temp1_VGP_S*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))+temp1*(+0.0-(+temp1_VGP_S_VGP_S*za+temp1_VGP_S*za_VGP_S+temp1_VGP_S*za_VGP_S+temp1*za_VGP_S_VGP_S)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))))+(((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))+0.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))+4.0*(+(+temp1_VGP_S_VGP_S*temp1+temp1_VGP_S*temp1_VGP_S+temp1_VGP_S*temp1_VGP_S+temp1*temp1_VGP_S_VGP_S)*za+((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za_VGP_S+(((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za_VGP_S+(temp1*temp1)*za_VGP_S_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
  Phi_0_VGP_S_VS_BP=(+(+phi_inf_VGP_S_VS_BP*za+phi_inf_VGP_S*za_VS_BP+phi_inf_VS_BP*za_VGP_S+phi_inf*za_VGP_S_VS_BP)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VGP_S*za)+(phi_inf*za_VGP_S))*((0.86*(((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VS_BP*za)+(phi_inf*za_VS_BP)))*(0.86*((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VGP_S_VS_BP*(1.0-(temp1*za))+temp1_VGP_S*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP))))+temp1_VS_BP*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))+temp1*(+0.0-(+temp1_VGP_S_VS_BP*za+temp1_VGP_S*za_VS_BP+temp1_VS_BP*za_VGP_S+temp1*za_VGP_S_VS_BP)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-((temp1_VGP_S*za)+(temp1*za_VGP_S)))))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))))+(((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))+0.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S))+4.0*(+(+temp1_VGP_S_VS_BP*temp1+temp1_VGP_S*temp1_VS_BP+temp1_VS_BP*temp1_VGP_S+temp1*temp1_VGP_S_VS_BP)*za+((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za_VS_BP+(((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za_VGP_S+(temp1*temp1)*za_VGP_S_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S))*za)+((temp1*temp1)*za_VGP_S)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
#endif
Phi_0_VS_BP=((((phi_inf_VS_BP*za)+(phi_inf*za_VS_BP))*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))))+((phi_inf*za)*(0.86*((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
#if defined(_DERIVATE2)
  Phi_0_VS_BP_VD_S=(+(+phi_inf_VS_BP_VD_S*za+phi_inf_VS_BP*za_VD_S+phi_inf_VD_S*za_VS_BP+phi_inf*za_VS_BP_VD_S)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VS_BP*za)+(phi_inf*za_VS_BP))*((0.86*(((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VD_S*za)+(phi_inf*za_VD_S)))*(0.86*((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VS_BP_VD_S*(1.0-(temp1*za))+temp1_VS_BP*(-(((temp1_VD_S*za)+(temp1*za_VD_S))))+temp1_VD_S*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))+temp1*(+0.0-(+temp1_VS_BP_VD_S*za+temp1_VS_BP*za_VD_S+temp1_VD_S*za_VS_BP+temp1*za_VS_BP_VD_S)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))))+(((temp1_VD_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VD_S*za)+(temp1*za_VD_S)))))))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))+0.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))+4.0*(+(+temp1_VS_BP_VD_S*temp1+temp1_VS_BP*temp1_VD_S+temp1_VD_S*temp1_VS_BP+temp1*temp1_VS_BP_VD_S)*za+((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za_VD_S+(((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za_VS_BP+(temp1*temp1)*za_VS_BP_VD_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP)))*((4.0*((((((temp1_VD_S*temp1)+(temp1*temp1_VD_S)))*za)+((temp1*temp1)*za_VD_S)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
  Phi_0_VS_BP_VGP_S=(+(+phi_inf_VS_BP_VGP_S*za+phi_inf_VS_BP*za_VGP_S+phi_inf_VGP_S*za_VS_BP+phi_inf*za_VS_BP_VGP_S)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VS_BP*za)+(phi_inf*za_VS_BP))*((0.86*(((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VGP_S*za)+(phi_inf*za_VGP_S)))*(0.86*((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VS_BP_VGP_S*(1.0-(temp1*za))+temp1_VS_BP*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S))))+temp1_VGP_S*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))+temp1*(+0.0-(+temp1_VS_BP_VGP_S*za+temp1_VS_BP*za_VGP_S+temp1_VGP_S*za_VS_BP+temp1*za_VS_BP_VGP_S)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))))+(((temp1_VGP_S*(1.0-(temp1*za)))+(temp1*(-(((temp1_VGP_S*za)+(temp1*za_VGP_S)))))))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))+0.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))+4.0*(+(+temp1_VS_BP_VGP_S*temp1+temp1_VS_BP*temp1_VGP_S+temp1_VGP_S*temp1_VS_BP+temp1*temp1_VS_BP_VGP_S)*za+((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za_VGP_S+(((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za_VS_BP+(temp1*temp1)*za_VS_BP_VGP_S))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP)))*((4.0*((((((temp1_VGP_S*temp1)+(temp1*temp1_VGP_S)))*za)+((temp1*temp1)*za_VGP_S)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
  Phi_0_VS_BP_VS_BP=(+(+phi_inf_VS_BP_VS_BP*za+phi_inf_VS_BP*za_VS_BP+phi_inf_VS_BP*za_VS_BP+phi_inf*za_VS_BP_VS_BP)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+((phi_inf_VS_BP*za)+(phi_inf*za_VS_BP))*((0.86*(((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))))+(((phi_inf_VS_BP*za)+(phi_inf*za_VS_BP)))*(0.86*((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))+(phi_inf*za)*(+0.0+(+0.0*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*(((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP))))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.0*((((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*(1.0+(4.0*((temp1*temp1)*za)))-(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+0.86*((+temp1_VS_BP_VS_BP*(1.0-(temp1*za))+temp1_VS_BP*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP))))+temp1_VS_BP*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))+temp1*(+0.0-(+temp1_VS_BP_VS_BP*za+temp1_VS_BP*za_VS_BP+temp1_VS_BP*za_VS_BP+temp1*za_VS_BP_VS_BP)))/(1.0+(4.0*((temp1*temp1)*za)))-(((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-((temp1_VS_BP*za)+(temp1*za_VS_BP)))))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))))+(((temp1_VS_BP*(1.0-(temp1*za)))+(temp1*(-(((temp1_VS_BP*za)+(temp1*za_VS_BP)))))))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP)))+(temp1*(1.0-(temp1*za)))*(+0.0+(+0.0*((temp1*temp1)*za)+0.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))+0.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP))+4.0*(+(+temp1_VS_BP_VS_BP*temp1+temp1_VS_BP*temp1_VS_BP+temp1_VS_BP*temp1_VS_BP+temp1*temp1_VS_BP_VS_BP)*za+((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za_VS_BP+(((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za_VS_BP+(temp1*temp1)*za_VS_BP_VS_BP))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))+2*(temp1*(1.0-(temp1*za)))*(4.0*((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP))*za)+((temp1*temp1)*za_VS_BP)))*((4.0*((((((temp1_VS_BP*temp1)+(temp1*temp1_VS_BP)))*za)+((temp1*temp1)*za_VS_BP)))))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
#endif
#endif
Phi_0=((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
EXIT_IF_ISNAN(((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
asat_VD_S=(xgs_VD_S+(0.5*Gf2_VD_S));
#if defined(_DERIVATE2)
  asat_VD_S_VD_S=(+xgs_VD_S_VD_S+(+0.0*Gf2+0.0*Gf2_VD_S+0.0*Gf2_VD_S+0.5*Gf2_VD_S_VD_S));
  asat_VD_S_VGP_S=(+xgs_VD_S_VGP_S+(+0.0*Gf2+0.0*Gf2_VGP_S+0.0*Gf2_VD_S+0.5*Gf2_VD_S_VGP_S));
  asat_VD_S_VS_BP=(+xgs_VD_S_VS_BP+(+0.0*Gf2+0.0*Gf2_VS_BP+0.0*Gf2_VD_S+0.5*Gf2_VD_S_VS_BP));
#endif
asat_VGP_S=(xgs_VGP_S+(0.5*Gf2_VGP_S));
#if defined(_DERIVATE2)
  asat_VGP_S_VD_S=(+xgs_VGP_S_VD_S+(+0.0*Gf2+0.0*Gf2_VD_S+0.0*Gf2_VGP_S+0.5*Gf2_VGP_S_VD_S));
  asat_VGP_S_VGP_S=(+xgs_VGP_S_VGP_S+(+0.0*Gf2+0.0*Gf2_VGP_S+0.0*Gf2_VGP_S+0.5*Gf2_VGP_S_VGP_S));
  asat_VGP_S_VS_BP=(+xgs_VGP_S_VS_BP+(+0.0*Gf2+0.0*Gf2_VS_BP+0.0*Gf2_VGP_S+0.5*Gf2_VGP_S_VS_BP));
#endif
asat_VS_BP=(xgs_VS_BP+(0.5*Gf2_VS_BP));
#if defined(_DERIVATE2)
  asat_VS_BP_VD_S=(+xgs_VS_BP_VD_S+(+0.0*Gf2+0.0*Gf2_VD_S+0.0*Gf2_VS_BP+0.5*Gf2_VS_BP_VD_S));
  asat_VS_BP_VGP_S=(+xgs_VS_BP_VGP_S+(+0.0*Gf2+0.0*Gf2_VGP_S+0.0*Gf2_VS_BP+0.5*Gf2_VS_BP_VGP_S));
  asat_VS_BP_VS_BP=(+xgs_VS_BP_VS_BP+(+0.0*Gf2+0.0*Gf2_VS_BP+0.0*Gf2_VS_BP+0.5*Gf2_VS_BP_VS_BP));
#endif
#endif
asat=(xgs+(0.5*Gf2));
EXIT_IF_ISNAN((xgs+(0.5*Gf2)))
{
double m00_sqrt(d00_sqrt0,((asat*asat)-((Gf2*Ds)*0.98)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((asat*asat)-((Gf2*Ds)*0.98)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Phi_2_VD_S=(0.98*((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
#if defined(_DERIVATE2)
  Phi_2_VD_S_VD_S=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VD_S_VD_S*Ds+Gf2_VD_S*Ds_VD_S+Gf2_VD_S*Ds_VD_S+Gf2*Ds_VD_S_VD_S)*pInst->phit1+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0)+((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VD_S_VD_S+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)+d10_sqrt0*(+(+asat_VD_S_VD_S*asat+asat_VD_S*asat_VD_S+asat_VD_S*asat_VD_S+asat*asat_VD_S_VD_S)-(+(+Gf2_VD_S_VD_S*Ds+Gf2_VD_S*Ds_VD_S+Gf2_VD_S*Ds_VD_S+Gf2*Ds_VD_S_VD_S)*0.98+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0)*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
  Phi_2_VD_S_VGP_S=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VD_S_VGP_S*Ds+Gf2_VD_S*Ds_VGP_S+Gf2_VGP_S*Ds_VD_S+Gf2*Ds_VD_S_VGP_S)*pInst->phit1+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0)+((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VD_S_VGP_S+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)+d10_sqrt0*(+(+asat_VD_S_VGP_S*asat+asat_VD_S*asat_VGP_S+asat_VGP_S*asat_VD_S+asat*asat_VD_S_VGP_S)-(+(+Gf2_VD_S_VGP_S*Ds+Gf2_VD_S*Ds_VGP_S+Gf2_VGP_S*Ds_VD_S+Gf2*Ds_VD_S_VGP_S)*0.98+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0)*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
  Phi_2_VD_S_VS_BP=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VD_S_VS_BP*Ds+Gf2_VD_S*Ds_VS_BP+Gf2_VS_BP*Ds_VD_S+Gf2*Ds_VD_S_VS_BP)*pInst->phit1+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*pInst->phit1*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0)+((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VD_S_VS_BP+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)+d10_sqrt0*(+(+asat_VD_S_VS_BP*asat+asat_VD_S*asat_VS_BP+asat_VS_BP*asat_VD_S+asat*asat_VD_S_VS_BP)-(+(+Gf2_VD_S_VS_BP*Ds+Gf2_VD_S*Ds_VS_BP+Gf2_VS_BP*Ds_VD_S+Gf2*Ds_VD_S_VS_BP)*0.98+((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VD_S+(((asat_VD_S*asat)+(asat*asat_VD_S))-((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S))*0.98)*d10_sqrt0)*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
#endif
Phi_2_VGP_S=(0.98*((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
#if defined(_DERIVATE2)
  Phi_2_VGP_S_VD_S=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VGP_S_VD_S*Ds+Gf2_VGP_S*Ds_VD_S+Gf2_VD_S*Ds_VGP_S+Gf2*Ds_VGP_S_VD_S)*pInst->phit1+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0)+((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VGP_S_VD_S+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)+d10_sqrt0*(+(+asat_VGP_S_VD_S*asat+asat_VGP_S*asat_VD_S+asat_VD_S*asat_VGP_S+asat*asat_VGP_S_VD_S)-(+(+Gf2_VGP_S_VD_S*Ds+Gf2_VGP_S*Ds_VD_S+Gf2_VD_S*Ds_VGP_S+Gf2*Ds_VGP_S_VD_S)*0.98+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0)*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
  Phi_2_VGP_S_VGP_S=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VGP_S_VGP_S*Ds+Gf2_VGP_S*Ds_VGP_S+Gf2_VGP_S*Ds_VGP_S+Gf2*Ds_VGP_S_VGP_S)*pInst->phit1+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0)+((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VGP_S_VGP_S+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)+d10_sqrt0*(+(+asat_VGP_S_VGP_S*asat+asat_VGP_S*asat_VGP_S+asat_VGP_S*asat_VGP_S+asat*asat_VGP_S_VGP_S)-(+(+Gf2_VGP_S_VGP_S*Ds+Gf2_VGP_S*Ds_VGP_S+Gf2_VGP_S*Ds_VGP_S+Gf2*Ds_VGP_S_VGP_S)*0.98+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0)*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
  Phi_2_VGP_S_VS_BP=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VGP_S_VS_BP*Ds+Gf2_VGP_S*Ds_VS_BP+Gf2_VS_BP*Ds_VGP_S+Gf2*Ds_VGP_S_VS_BP)*pInst->phit1+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*pInst->phit1*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0)+((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VGP_S_VS_BP+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)+d10_sqrt0*(+(+asat_VGP_S_VS_BP*asat+asat_VGP_S*asat_VS_BP+asat_VS_BP*asat_VGP_S+asat*asat_VGP_S_VS_BP)-(+(+Gf2_VGP_S_VS_BP*Ds+Gf2_VGP_S*Ds_VS_BP+Gf2_VS_BP*Ds_VGP_S+Gf2*Ds_VGP_S_VS_BP)*0.98+((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+(((asat_VGP_S*asat)+(asat*asat_VGP_S))-((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S))*0.98)*d10_sqrt0)*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
#endif
Phi_2_VS_BP=(0.98*((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
#if defined(_DERIVATE2)
  Phi_2_VS_BP_VD_S=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VS_BP_VD_S*Ds+Gf2_VS_BP*Ds_VD_S+Gf2_VD_S*Ds_VS_BP+Gf2*Ds_VS_BP_VD_S)*pInst->phit1+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0)+((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VS_BP_VD_S+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)+d10_sqrt0*(+(+asat_VS_BP_VD_S*asat+asat_VS_BP*asat_VD_S+asat_VD_S*asat_VS_BP+asat*asat_VS_BP_VD_S)-(+(+Gf2_VS_BP_VD_S*Ds+Gf2_VS_BP*Ds_VD_S+Gf2_VD_S*Ds_VS_BP+Gf2*Ds_VS_BP_VD_S)*0.98+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0)*(asat_VD_S+((((asat_VD_S*asat)+(asat*asat_VD_S)))-((((Gf2_VD_S*Ds)+(Gf2*Ds_VD_S)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
  Phi_2_VS_BP_VGP_S=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VS_BP_VGP_S*Ds+Gf2_VS_BP*Ds_VGP_S+Gf2_VGP_S*Ds_VS_BP+Gf2*Ds_VS_BP_VGP_S)*pInst->phit1+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0)+((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VS_BP_VGP_S+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)+d10_sqrt0*(+(+asat_VS_BP_VGP_S*asat+asat_VS_BP*asat_VGP_S+asat_VGP_S*asat_VS_BP+asat*asat_VS_BP_VGP_S)-(+(+Gf2_VS_BP_VGP_S*Ds+Gf2_VS_BP*Ds_VGP_S+Gf2_VGP_S*Ds_VS_BP+Gf2*Ds_VS_BP_VGP_S)*0.98+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0)*(asat_VGP_S+((((asat_VGP_S*asat)+(asat*asat_VGP_S)))-((((Gf2_VGP_S*Ds)+(Gf2*Ds_VGP_S)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
  Phi_2_VS_BP_VS_BP=(+0.0*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))+0.0*((((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.0*((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(asat+d00_sqrt0)-((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0))/(asat+d00_sqrt0)/(asat+d00_sqrt0))+0.98*((+(+Gf2_VS_BP_VS_BP*Ds+Gf2_VS_BP*Ds_VS_BP+Gf2_VS_BP*Ds_VS_BP+Gf2*Ds_VS_BP_VS_BP)*pInst->phit1+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)/(asat+d00_sqrt0)-(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*pInst->phit1*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0)+((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0)+((Gf2*Ds)*pInst->phit1)*(+asat_VS_BP_VS_BP+(m20_sqrt(((asat*asat)-((Gf2*Ds)*0.98)))*((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)+d10_sqrt0*(+(+asat_VS_BP_VS_BP*asat+asat_VS_BP*asat_VS_BP+asat_VS_BP*asat_VS_BP+asat*asat_VS_BP_VS_BP)-(+(+Gf2_VS_BP_VS_BP*Ds+Gf2_VS_BP*Ds_VS_BP+Gf2_VS_BP*Ds_VS_BP+Gf2*Ds_VS_BP_VS_BP)*0.98+((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.0+(((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.0+(Gf2*Ds)*0.0)))))/(asat+d00_sqrt0)/(asat+d00_sqrt0)+2*((Gf2*Ds)*pInst->phit1)*(asat_VS_BP+(((asat_VS_BP*asat)+(asat*asat_VS_BP))-((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP))*0.98)*d10_sqrt0)*(asat_VS_BP+((((asat_VS_BP*asat)+(asat*asat_VS_BP)))-((((Gf2_VS_BP*Ds)+(Gf2*Ds_VS_BP)))*0.98))*d10_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)/(asat+d00_sqrt0)));
#endif
#endif
Phi_2=(0.98*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0)));
EXIT_IF_ISNAN((0.98*(((Gf2*Ds)*pInst->phit1)/(asat+d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Phi_0_2_VD_S=(Phi_0_VD_S+Phi_2_VD_S);
#if defined(_DERIVATE2)
  Phi_0_2_VD_S_VD_S=(+Phi_0_VD_S_VD_S+Phi_2_VD_S_VD_S);
  Phi_0_2_VD_S_VGP_S=(+Phi_0_VD_S_VGP_S+Phi_2_VD_S_VGP_S);
  Phi_0_2_VD_S_VS_BP=(+Phi_0_VD_S_VS_BP+Phi_2_VD_S_VS_BP);
#endif
Phi_0_2_VGP_S=(Phi_0_VGP_S+Phi_2_VGP_S);
#if defined(_DERIVATE2)
  Phi_0_2_VGP_S_VD_S=(+Phi_0_VGP_S_VD_S+Phi_2_VGP_S_VD_S);
  Phi_0_2_VGP_S_VGP_S=(+Phi_0_VGP_S_VGP_S+Phi_2_VGP_S_VGP_S);
  Phi_0_2_VGP_S_VS_BP=(+Phi_0_VGP_S_VS_BP+Phi_2_VGP_S_VS_BP);
#endif
Phi_0_2_VS_BP=(Phi_0_VS_BP+Phi_2_VS_BP);
#if defined(_DERIVATE2)
  Phi_0_2_VS_BP_VD_S=(+Phi_0_VS_BP_VD_S+Phi_2_VS_BP_VD_S);
  Phi_0_2_VS_BP_VGP_S=(+Phi_0_VS_BP_VGP_S+Phi_2_VS_BP_VGP_S);
  Phi_0_2_VS_BP_VS_BP=(+Phi_0_VS_BP_VS_BP+Phi_2_VS_BP_VS_BP);
#endif
#endif
Phi_0_2=(Phi_0+Phi_2);
EXIT_IF_ISNAN((Phi_0+Phi_2))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Phi0_Phi2_VD_S=(2.0*((Phi_0_VD_S*Phi_2)+(Phi_0*Phi_2_VD_S)));
#if defined(_DERIVATE2)
  Phi0_Phi2_VD_S_VD_S=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VD_S*Phi_2)+(Phi_0*Phi_2_VD_S)))+0.0*((Phi_0_VD_S*Phi_2)+(Phi_0*Phi_2_VD_S))+2.0*(+Phi_0_VD_S_VD_S*Phi_2+Phi_0_VD_S*Phi_2_VD_S+Phi_0_VD_S*Phi_2_VD_S+Phi_0*Phi_2_VD_S_VD_S));
  Phi0_Phi2_VD_S_VGP_S=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VGP_S*Phi_2)+(Phi_0*Phi_2_VGP_S)))+0.0*((Phi_0_VD_S*Phi_2)+(Phi_0*Phi_2_VD_S))+2.0*(+Phi_0_VD_S_VGP_S*Phi_2+Phi_0_VD_S*Phi_2_VGP_S+Phi_0_VGP_S*Phi_2_VD_S+Phi_0*Phi_2_VD_S_VGP_S));
  Phi0_Phi2_VD_S_VS_BP=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VS_BP*Phi_2)+(Phi_0*Phi_2_VS_BP)))+0.0*((Phi_0_VD_S*Phi_2)+(Phi_0*Phi_2_VD_S))+2.0*(+Phi_0_VD_S_VS_BP*Phi_2+Phi_0_VD_S*Phi_2_VS_BP+Phi_0_VS_BP*Phi_2_VD_S+Phi_0*Phi_2_VD_S_VS_BP));
#endif
Phi0_Phi2_VGP_S=(2.0*((Phi_0_VGP_S*Phi_2)+(Phi_0*Phi_2_VGP_S)));
#if defined(_DERIVATE2)
  Phi0_Phi2_VGP_S_VD_S=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VD_S*Phi_2)+(Phi_0*Phi_2_VD_S)))+0.0*((Phi_0_VGP_S*Phi_2)+(Phi_0*Phi_2_VGP_S))+2.0*(+Phi_0_VGP_S_VD_S*Phi_2+Phi_0_VGP_S*Phi_2_VD_S+Phi_0_VD_S*Phi_2_VGP_S+Phi_0*Phi_2_VGP_S_VD_S));
  Phi0_Phi2_VGP_S_VGP_S=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VGP_S*Phi_2)+(Phi_0*Phi_2_VGP_S)))+0.0*((Phi_0_VGP_S*Phi_2)+(Phi_0*Phi_2_VGP_S))+2.0*(+Phi_0_VGP_S_VGP_S*Phi_2+Phi_0_VGP_S*Phi_2_VGP_S+Phi_0_VGP_S*Phi_2_VGP_S+Phi_0*Phi_2_VGP_S_VGP_S));
  Phi0_Phi2_VGP_S_VS_BP=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VS_BP*Phi_2)+(Phi_0*Phi_2_VS_BP)))+0.0*((Phi_0_VGP_S*Phi_2)+(Phi_0*Phi_2_VGP_S))+2.0*(+Phi_0_VGP_S_VS_BP*Phi_2+Phi_0_VGP_S*Phi_2_VS_BP+Phi_0_VS_BP*Phi_2_VGP_S+Phi_0*Phi_2_VGP_S_VS_BP));
#endif
Phi0_Phi2_VS_BP=(2.0*((Phi_0_VS_BP*Phi_2)+(Phi_0*Phi_2_VS_BP)));
#if defined(_DERIVATE2)
  Phi0_Phi2_VS_BP_VD_S=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VD_S*Phi_2)+(Phi_0*Phi_2_VD_S)))+0.0*((Phi_0_VS_BP*Phi_2)+(Phi_0*Phi_2_VS_BP))+2.0*(+Phi_0_VS_BP_VD_S*Phi_2+Phi_0_VS_BP*Phi_2_VD_S+Phi_0_VD_S*Phi_2_VS_BP+Phi_0*Phi_2_VS_BP_VD_S));
  Phi0_Phi2_VS_BP_VGP_S=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VGP_S*Phi_2)+(Phi_0*Phi_2_VGP_S)))+0.0*((Phi_0_VS_BP*Phi_2)+(Phi_0*Phi_2_VS_BP))+2.0*(+Phi_0_VS_BP_VGP_S*Phi_2+Phi_0_VS_BP*Phi_2_VGP_S+Phi_0_VGP_S*Phi_2_VS_BP+Phi_0*Phi_2_VS_BP_VGP_S));
  Phi0_Phi2_VS_BP_VS_BP=(+0.0*(Phi_0*Phi_2)+0.0*(((Phi_0_VS_BP*Phi_2)+(Phi_0*Phi_2_VS_BP)))+0.0*((Phi_0_VS_BP*Phi_2)+(Phi_0*Phi_2_VS_BP))+2.0*(+Phi_0_VS_BP_VS_BP*Phi_2+Phi_0_VS_BP*Phi_2_VS_BP+Phi_0_VS_BP*Phi_2_VS_BP+Phi_0*Phi_2_VS_BP_VS_BP));
#endif
#endif
Phi0_Phi2=(2.0*(Phi_0*Phi_2));
EXIT_IF_ISNAN((2.0*(Phi_0*Phi_2)))
{
double m00_sqrt(d00_sqrt0,((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Phi_sat_VD_S=((Phi0_Phi2_VD_S*(Phi_0_2+d00_sqrt0)-Phi0_Phi2*(Phi_0_2_VD_S+(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))*d10_sqrt0))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
#if defined(_DERIVATE2)
  Phi_sat_VD_S_VD_S=(Phi0_Phi2_VD_S_VD_S/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VD_S*(Phi_0_2_VD_S+((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*d10_sqrt0)+Phi0_Phi2_VD_S*(Phi_0_2_VD_S+(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VD_S_VD_S+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))+d10_sqrt0*(+(+Phi_0_2_VD_S_VD_S*Phi_0_2+Phi_0_2_VD_S*Phi_0_2_VD_S+Phi_0_2_VD_S*Phi_0_2_VD_S+Phi_0_2*Phi_0_2_VD_S_VD_S)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VD_S+0.0*Phi0_Phi2_VD_S+1.98*Phi0_Phi2_VD_S_VD_S)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VD_S+(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))*d10_sqrt0)*(Phi_0_2_VD_S+((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
  Phi_sat_VD_S_VGP_S=(Phi0_Phi2_VD_S_VGP_S/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VD_S*(Phi_0_2_VGP_S+((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*d10_sqrt0)+Phi0_Phi2_VGP_S*(Phi_0_2_VD_S+(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VD_S_VGP_S+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))+d10_sqrt0*(+(+Phi_0_2_VD_S_VGP_S*Phi_0_2+Phi_0_2_VD_S*Phi_0_2_VGP_S+Phi_0_2_VGP_S*Phi_0_2_VD_S+Phi_0_2*Phi_0_2_VD_S_VGP_S)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VGP_S+0.0*Phi0_Phi2_VD_S+1.98*Phi0_Phi2_VD_S_VGP_S)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VD_S+(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))*d10_sqrt0)*(Phi_0_2_VGP_S+((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
  Phi_sat_VD_S_VS_BP=(Phi0_Phi2_VD_S_VS_BP/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VD_S*(Phi_0_2_VS_BP+((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*d10_sqrt0)+Phi0_Phi2_VS_BP*(Phi_0_2_VD_S+(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VD_S_VS_BP+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))+d10_sqrt0*(+(+Phi_0_2_VD_S_VS_BP*Phi_0_2+Phi_0_2_VD_S*Phi_0_2_VS_BP+Phi_0_2_VS_BP*Phi_0_2_VD_S+Phi_0_2*Phi_0_2_VD_S_VS_BP)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VS_BP+0.0*Phi0_Phi2_VD_S+1.98*Phi0_Phi2_VD_S_VS_BP)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VD_S+(((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S))-(1.98*Phi0_Phi2_VD_S))*d10_sqrt0)*(Phi_0_2_VS_BP+((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
#endif
Phi_sat_VGP_S=((Phi0_Phi2_VGP_S*(Phi_0_2+d00_sqrt0)-Phi0_Phi2*(Phi_0_2_VGP_S+(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))*d10_sqrt0))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
#if defined(_DERIVATE2)
  Phi_sat_VGP_S_VD_S=(Phi0_Phi2_VGP_S_VD_S/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VGP_S*(Phi_0_2_VD_S+((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*d10_sqrt0)+Phi0_Phi2_VD_S*(Phi_0_2_VGP_S+(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VGP_S_VD_S+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))+d10_sqrt0*(+(+Phi_0_2_VGP_S_VD_S*Phi_0_2+Phi_0_2_VGP_S*Phi_0_2_VD_S+Phi_0_2_VD_S*Phi_0_2_VGP_S+Phi_0_2*Phi_0_2_VGP_S_VD_S)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VD_S+0.0*Phi0_Phi2_VGP_S+1.98*Phi0_Phi2_VGP_S_VD_S)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VGP_S+(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))*d10_sqrt0)*(Phi_0_2_VD_S+((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
  Phi_sat_VGP_S_VGP_S=(Phi0_Phi2_VGP_S_VGP_S/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VGP_S*(Phi_0_2_VGP_S+((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*d10_sqrt0)+Phi0_Phi2_VGP_S*(Phi_0_2_VGP_S+(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VGP_S_VGP_S+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))+d10_sqrt0*(+(+Phi_0_2_VGP_S_VGP_S*Phi_0_2+Phi_0_2_VGP_S*Phi_0_2_VGP_S+Phi_0_2_VGP_S*Phi_0_2_VGP_S+Phi_0_2*Phi_0_2_VGP_S_VGP_S)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VGP_S+0.0*Phi0_Phi2_VGP_S+1.98*Phi0_Phi2_VGP_S_VGP_S)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VGP_S+(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))*d10_sqrt0)*(Phi_0_2_VGP_S+((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
  Phi_sat_VGP_S_VS_BP=(Phi0_Phi2_VGP_S_VS_BP/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VGP_S*(Phi_0_2_VS_BP+((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*d10_sqrt0)+Phi0_Phi2_VS_BP*(Phi_0_2_VGP_S+(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VGP_S_VS_BP+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))+d10_sqrt0*(+(+Phi_0_2_VGP_S_VS_BP*Phi_0_2+Phi_0_2_VGP_S*Phi_0_2_VS_BP+Phi_0_2_VS_BP*Phi_0_2_VGP_S+Phi_0_2*Phi_0_2_VGP_S_VS_BP)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VS_BP+0.0*Phi0_Phi2_VGP_S+1.98*Phi0_Phi2_VGP_S_VS_BP)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VGP_S+(((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S))-(1.98*Phi0_Phi2_VGP_S))*d10_sqrt0)*(Phi_0_2_VS_BP+((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
#endif
Phi_sat_VS_BP=((Phi0_Phi2_VS_BP*(Phi_0_2+d00_sqrt0)-Phi0_Phi2*(Phi_0_2_VS_BP+(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))*d10_sqrt0))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
#if defined(_DERIVATE2)
  Phi_sat_VS_BP_VD_S=(Phi0_Phi2_VS_BP_VD_S/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VS_BP*(Phi_0_2_VD_S+((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*d10_sqrt0)+Phi0_Phi2_VD_S*(Phi_0_2_VS_BP+(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VS_BP_VD_S+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))+d10_sqrt0*(+(+Phi_0_2_VS_BP_VD_S*Phi_0_2+Phi_0_2_VS_BP*Phi_0_2_VD_S+Phi_0_2_VD_S*Phi_0_2_VS_BP+Phi_0_2*Phi_0_2_VS_BP_VD_S)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VD_S+0.0*Phi0_Phi2_VS_BP+1.98*Phi0_Phi2_VS_BP_VD_S)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VS_BP+(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))*d10_sqrt0)*(Phi_0_2_VD_S+((((Phi_0_2_VD_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VD_S)))-((1.98*Phi0_Phi2_VD_S)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
  Phi_sat_VS_BP_VGP_S=(Phi0_Phi2_VS_BP_VGP_S/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VS_BP*(Phi_0_2_VGP_S+((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*d10_sqrt0)+Phi0_Phi2_VGP_S*(Phi_0_2_VS_BP+(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VS_BP_VGP_S+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))+d10_sqrt0*(+(+Phi_0_2_VS_BP_VGP_S*Phi_0_2+Phi_0_2_VS_BP*Phi_0_2_VGP_S+Phi_0_2_VGP_S*Phi_0_2_VS_BP+Phi_0_2*Phi_0_2_VS_BP_VGP_S)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VGP_S+0.0*Phi0_Phi2_VS_BP+1.98*Phi0_Phi2_VS_BP_VGP_S)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VS_BP+(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))*d10_sqrt0)*(Phi_0_2_VGP_S+((((Phi_0_2_VGP_S*Phi_0_2)+(Phi_0_2*Phi_0_2_VGP_S)))-((1.98*Phi0_Phi2_VGP_S)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
  Phi_sat_VS_BP_VS_BP=(Phi0_Phi2_VS_BP_VS_BP/(Phi_0_2+d00_sqrt0)-(Phi0_Phi2_VS_BP*(Phi_0_2_VS_BP+((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*d10_sqrt0)+Phi0_Phi2_VS_BP*(Phi_0_2_VS_BP+(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))*d10_sqrt0)+Phi0_Phi2*(+Phi_0_2_VS_BP_VS_BP+(m20_sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)))*((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))+d10_sqrt0*(+(+Phi_0_2_VS_BP_VS_BP*Phi_0_2+Phi_0_2_VS_BP*Phi_0_2_VS_BP+Phi_0_2_VS_BP*Phi_0_2_VS_BP+Phi_0_2*Phi_0_2_VS_BP_VS_BP)-(+0.0*Phi0_Phi2+0.0*Phi0_Phi2_VS_BP+0.0*Phi0_Phi2_VS_BP+1.98*Phi0_Phi2_VS_BP_VS_BP)))))/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)+2*Phi0_Phi2*(Phi_0_2_VS_BP+(((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP))-(1.98*Phi0_Phi2_VS_BP))*d10_sqrt0)*(Phi_0_2_VS_BP+((((Phi_0_2_VS_BP*Phi_0_2)+(Phi_0_2*Phi_0_2_VS_BP)))-((1.98*Phi0_Phi2_VS_BP)))*d10_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0)/(Phi_0_2+d00_sqrt0));
#endif
#endif
Phi_sat=(Phi0_Phi2/(Phi_0_2+d00_sqrt0));
EXIT_IF_ISNAN((Phi0_Phi2/(Phi_0_2+d00_sqrt0)))
}
{
double m00_logE(d00_logE0,(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vdsat_VD_S=(Phi_sat_VD_S-(pInst->phit1*((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0));
#if defined(_DERIVATE2)
  Vdsat_VD_S_VD_S=(+Phi_sat_VD_S_VD_S-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VD_S_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VD_S*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1))+Phi_sat_VD_S*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)+Phi_sat*(+Phi_sat_VD_S_VD_S-(+(+0.0*asat+0.0*asat_VD_S+0.0*asat_VD_S+2.0*asat_VD_S_VD_S)*pInst->phit1+(2.0*asat_VD_S)*0.0+((2.0*asat_VD_S))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2_VD_S+(((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2_VD_S+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S_VD_S)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S)))+((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds_VD_S)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VD_S+(0.0)*Ds_VD_S+(pInst->phit1*pInst->phit1)*Ds_VD_S_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
  Vdsat_VD_S_VGP_S=(+Phi_sat_VD_S_VGP_S-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VD_S_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VD_S*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1))+Phi_sat_VGP_S*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)+Phi_sat*(+Phi_sat_VD_S_VGP_S-(+(+0.0*asat+0.0*asat_VGP_S+0.0*asat_VD_S+2.0*asat_VD_S_VGP_S)*pInst->phit1+(2.0*asat_VD_S)*0.0+((2.0*asat_VGP_S))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2_VGP_S+(((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2_VD_S+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S_VGP_S)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S)))+((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds_VD_S)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VGP_S+(0.0)*Ds_VD_S+(pInst->phit1*pInst->phit1)*Ds_VD_S_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
  Vdsat_VD_S_VS_BP=(+Phi_sat_VD_S_VS_BP-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VD_S_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VD_S*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1))+Phi_sat_VS_BP*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)+Phi_sat*(+Phi_sat_VD_S_VS_BP-(+(+0.0*asat+0.0*asat_VS_BP+0.0*asat_VD_S+2.0*asat_VD_S_VS_BP)*pInst->phit1+(2.0*asat_VD_S)*0.0+((2.0*asat_VS_BP))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2_VS_BP+(((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2_VD_S+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S_VS_BP)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(2.0*asat_VD_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP)))+((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds_VD_S)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VS_BP+(0.0)*Ds_VD_S+(pInst->phit1*pInst->phit1)*Ds_VD_S_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VD_S)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
#endif
Vdsat_VGP_S=(Phi_sat_VGP_S-(pInst->phit1*((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0));
#if defined(_DERIVATE2)
  Vdsat_VGP_S_VD_S=(+Phi_sat_VGP_S_VD_S-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VGP_S_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VGP_S*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1))+Phi_sat_VD_S*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)+Phi_sat*(+Phi_sat_VGP_S_VD_S-(+(+0.0*asat+0.0*asat_VD_S+0.0*asat_VGP_S+2.0*asat_VGP_S_VD_S)*pInst->phit1+(2.0*asat_VGP_S)*0.0+((2.0*asat_VD_S))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2_VD_S+(((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2_VGP_S+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S_VD_S)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S)))+((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds_VGP_S)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VD_S+(0.0)*Ds_VGP_S+(pInst->phit1*pInst->phit1)*Ds_VGP_S_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
  Vdsat_VGP_S_VGP_S=(+Phi_sat_VGP_S_VGP_S-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VGP_S_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VGP_S*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1))+Phi_sat_VGP_S*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)+Phi_sat*(+Phi_sat_VGP_S_VGP_S-(+(+0.0*asat+0.0*asat_VGP_S+0.0*asat_VGP_S+2.0*asat_VGP_S_VGP_S)*pInst->phit1+(2.0*asat_VGP_S)*0.0+((2.0*asat_VGP_S))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2_VGP_S+(((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2_VGP_S+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S_VGP_S)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S)))+((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds_VGP_S)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VGP_S+(0.0)*Ds_VGP_S+(pInst->phit1*pInst->phit1)*Ds_VGP_S_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
  Vdsat_VGP_S_VS_BP=(+Phi_sat_VGP_S_VS_BP-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VGP_S_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VGP_S*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1))+Phi_sat_VS_BP*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)+Phi_sat*(+Phi_sat_VGP_S_VS_BP-(+(+0.0*asat+0.0*asat_VS_BP+0.0*asat_VGP_S+2.0*asat_VGP_S_VS_BP)*pInst->phit1+(2.0*asat_VGP_S)*0.0+((2.0*asat_VS_BP))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2_VS_BP+(((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2_VGP_S+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S_VS_BP)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(2.0*asat_VGP_S)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP)))+((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds_VGP_S)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VS_BP+(0.0)*Ds_VGP_S+(pInst->phit1*pInst->phit1)*Ds_VGP_S_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VGP_S)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
#endif
Vdsat_VS_BP=(Phi_sat_VS_BP-(pInst->phit1*((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0));
#if defined(_DERIVATE2)
  Vdsat_VS_BP_VD_S=(+Phi_sat_VS_BP_VD_S-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VS_BP_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VS_BP*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1))+Phi_sat_VD_S*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)+Phi_sat*(+Phi_sat_VS_BP_VD_S-(+(+0.0*asat+0.0*asat_VD_S+0.0*asat_VS_BP+2.0*asat_VS_BP_VD_S)*pInst->phit1+(2.0*asat_VS_BP)*0.0+((2.0*asat_VD_S))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2_VD_S+(((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2_VS_BP+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP_VD_S)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S)))+((((((Phi_sat_VD_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VD_S-(((2.0*asat_VD_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VD_S)))*((pInst->phit1*pInst->phit1)*Ds_VS_BP)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VD_S+(0.0)*Ds_VS_BP+(pInst->phit1*pInst->phit1)*Ds_VS_BP_VD_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VD_S)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
  Vdsat_VS_BP_VGP_S=(+Phi_sat_VS_BP_VGP_S-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VS_BP_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VS_BP*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1))+Phi_sat_VGP_S*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)+Phi_sat*(+Phi_sat_VS_BP_VGP_S-(+(+0.0*asat+0.0*asat_VGP_S+0.0*asat_VS_BP+2.0*asat_VS_BP_VGP_S)*pInst->phit1+(2.0*asat_VS_BP)*0.0+((2.0*asat_VGP_S))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2_VGP_S+(((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2_VS_BP+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP_VGP_S)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S)))+((((((Phi_sat_VGP_S*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VGP_S-(((2.0*asat_VGP_S))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VGP_S)))*((pInst->phit1*pInst->phit1)*Ds_VS_BP)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VGP_S+(0.0)*Ds_VS_BP+(pInst->phit1*pInst->phit1)*Ds_VS_BP_VGP_S))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VGP_S)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
  Vdsat_VS_BP_VS_BP=(+Phi_sat_VS_BP_VS_BP-(+0.0*d00_logE0+0.0*((((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+0.0*((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*d10_logE0+pInst->phit1*(m20_logE((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)/((pInst->phit1*pInst->phit1)*Ds))))*((((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP))))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))*((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((pInst->phit1*pInst->phit1)*Ds)-((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))+d10_logE0*(+0.0+((+(+Phi_sat_VS_BP_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1))+Phi_sat_VS_BP*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1))+Phi_sat_VS_BP*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)+Phi_sat*(+Phi_sat_VS_BP_VS_BP-(+(+0.0*asat+0.0*asat_VS_BP+0.0*asat_VS_BP+2.0*asat_VS_BP_VS_BP)*pInst->phit1+(2.0*asat_VS_BP)*0.0+((2.0*asat_VS_BP))*0.0+(2.0*asat)*0.0)))*inv_Gf2+((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2_VS_BP+(((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2_VS_BP+(Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP_VS_BP)/((pInst->phit1*pInst->phit1)*Ds)-(((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(2.0*asat_VS_BP)*pInst->phit1)))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP))*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP)))+((((((Phi_sat_VS_BP*(Phi_sat-((2.0*asat)*pInst->phit1)))+(Phi_sat*(Phi_sat_VS_BP-(((2.0*asat_VS_BP))*pInst->phit1)))))*inv_Gf2)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2_VS_BP)))*((pInst->phit1*pInst->phit1)*Ds_VS_BP)+((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*(+(+0.0*pInst->phit1+0.0*0.0+0.0*0.0+pInst->phit1*0.0)*Ds+0.0*Ds_VS_BP+(0.0)*Ds_VS_BP+(pInst->phit1*pInst->phit1)*Ds_VS_BP_VS_BP))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)+2*((Phi_sat*(Phi_sat-((2.0*asat)*pInst->phit1)))*inv_Gf2)*((pInst->phit1*pInst->phit1)*Ds_VS_BP)*((((0.0)*Ds)+((pInst->phit1*pInst->phit1)*Ds_VS_BP)))/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds)/((pInst->phit1*pInst->phit1)*Ds))))));
#endif
#endif
Vdsat=(Phi_sat-(pInst->phit1*d00_logE0));
EXIT_IF_ISNAN((Phi_sat-(pInst->phit1*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vdsat_VD_S=0.0;
#if defined(_DERIVATE2)
  Vdsat_VD_S_VD_S=0.0;
  Vdsat_VD_S_VGP_S=0.0;
  Vdsat_VD_S_VS_BP=0.0;
#endif
Vdsat_VGP_S=0.0;
#if defined(_DERIVATE2)
  Vdsat_VGP_S_VD_S=0.0;
  Vdsat_VGP_S_VGP_S=0.0;
  Vdsat_VGP_S_VS_BP=0.0;
#endif
Vdsat_VS_BP=0.0;
#if defined(_DERIVATE2)
  Vdsat_VS_BP_VD_S=0.0;
  Vdsat_VS_BP_VGP_S=0.0;
  Vdsat_VS_BP_VS_BP=0.0;
#endif
#endif
Vdsat=pInst->Vdsat_lim;
EXIT_IF_ISNAN(pInst->Vdsat_lim)
}
{
double m00_pow(d00_pow0,(Vds/Vdsat),pInst->AX_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(Vds/Vdsat),pInst->AX_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(d10_pow0*(-Vds*Vdsat_VGP_S/Vdsat/Vdsat));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=fixme;
  temp_VGP_S_VS_BS=fixme;
  temp_VGP_S_VGP_S=fixme;
  temp_VGP_S_VD_S=fixme;
  temp_VGP_S_VS_BP=fixme;
#endif
temp_VD_S=(d10_pow0*((Vds_VD_S*Vdsat-Vds*Vdsat_VD_S)/Vdsat/Vdsat));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=fixme;
  temp_VD_S_VS_BS=fixme;
  temp_VD_S_VGP_S=fixme;
  temp_VD_S_VD_S=fixme;
  temp_VD_S_VS_BP=fixme;
#endif
temp_VS_BP=(d10_pow0*(-Vds*Vdsat_VS_BP/Vdsat/Vdsat));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=fixme;
  temp_VS_BP_VS_BS=fixme;
  temp_VS_BP_VGP_S=fixme;
  temp_VS_BP_VD_S=fixme;
  temp_VS_BP_VS_BP=fixme;
#endif
#endif
temp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(1.0+temp),(-pInst->inv_AX))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0+temp),(-pInst->inv_AX))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(S,BP)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Vdse_VGP_S=(Vds*(d10_pow0*temp_VGP_S));
#if defined(_DERIVATE2)
  Vdse_VGP_S_VGP_S=(+0.0*d00_pow0+0.0*(d10_pow0*temp_VGP_S)+0.0*(d10_pow0*temp_VGP_S)+Vds*fixme);
  Vdse_VGP_S_VS_BP=(+0.0*d00_pow0+0.0*(d10_pow0*temp_VS_BP)+0.0*(d10_pow0*temp_VGP_S)+Vds*fixme);
  Vdse_VGP_S_VD_S=(+0.0*d00_pow0+0.0*(d10_pow0*temp_VD_S)+Vds_VD_S*(d10_pow0*temp_VGP_S)+Vds*fixme);
#endif
Vdse_VS_BP=(Vds*(d10_pow0*temp_VS_BP));
#if defined(_DERIVATE2)
  Vdse_VS_BP_VGP_S=(+0.0*d00_pow0+0.0*(d10_pow0*temp_VGP_S)+0.0*(d10_pow0*temp_VS_BP)+Vds*fixme);
  Vdse_VS_BP_VS_BP=(+0.0*d00_pow0+0.0*(d10_pow0*temp_VS_BP)+0.0*(d10_pow0*temp_VS_BP)+Vds*fixme);
  Vdse_VS_BP_VD_S=(+0.0*d00_pow0+0.0*(d10_pow0*temp_VD_S)+Vds_VD_S*(d10_pow0*temp_VS_BP)+Vds*fixme);
#endif
Vdse_VD_S=((Vds_VD_S*d00_pow0)+(Vds*(d10_pow0*temp_VD_S)));
#if defined(_DERIVATE2)
  Vdse_VD_S_VGP_S=(+0.0*d00_pow0+Vds_VD_S*(d10_pow0*temp_VGP_S)+0.0*(d10_pow0*temp_VD_S)+Vds*fixme);
  Vdse_VD_S_VS_BP=(+0.0*d00_pow0+Vds_VD_S*(d10_pow0*temp_VS_BP)+0.0*(d10_pow0*temp_VD_S)+Vds*fixme);
  Vdse_VD_S_VD_S=(+Vds_VD_S_VD_S*d00_pow0+Vds_VD_S*(d10_pow0*temp_VD_S)+Vds_VD_S*(d10_pow0*temp_VD_S)+Vds*fixme);
#endif
#endif
pInst->Vdse=(Vds*d00_pow0);
EXIT_IF_ISNAN((Vds*d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(S,BP)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Udse_VGP_S=Vdse_VGP_S*pInst->inv_phit1;
#if defined(_DERIVATE2)
  Udse_VGP_S_VGP_S=(+Vdse_VGP_S_VGP_S*pInst->inv_phit1+Vdse_VGP_S*0.0+Vdse_VGP_S*0.0+pInst->Vdse*0.0);
  Udse_VGP_S_VS_BP=(+Vdse_VGP_S_VS_BP*pInst->inv_phit1+Vdse_VGP_S*0.0+Vdse_VS_BP*0.0+pInst->Vdse*0.0);
  Udse_VGP_S_VD_S=(+Vdse_VGP_S_VD_S*pInst->inv_phit1+Vdse_VGP_S*0.0+Vdse_VD_S*0.0+pInst->Vdse*0.0);
#endif
Udse_VS_BP=Vdse_VS_BP*pInst->inv_phit1;
#if defined(_DERIVATE2)
  Udse_VS_BP_VGP_S=(+Vdse_VS_BP_VGP_S*pInst->inv_phit1+Vdse_VS_BP*0.0+Vdse_VGP_S*0.0+pInst->Vdse*0.0);
  Udse_VS_BP_VS_BP=(+Vdse_VS_BP_VS_BP*pInst->inv_phit1+Vdse_VS_BP*0.0+Vdse_VS_BP*0.0+pInst->Vdse*0.0);
  Udse_VS_BP_VD_S=(+Vdse_VS_BP_VD_S*pInst->inv_phit1+Vdse_VS_BP*0.0+Vdse_VD_S*0.0+pInst->Vdse*0.0);
#endif
Udse_VD_S=Vdse_VD_S*pInst->inv_phit1;
#if defined(_DERIVATE2)
  Udse_VD_S_VGP_S=(+Vdse_VD_S_VGP_S*pInst->inv_phit1+Vdse_VD_S*0.0+Vdse_VGP_S*0.0+pInst->Vdse*0.0);
  Udse_VD_S_VS_BP=(+Vdse_VD_S_VS_BP*pInst->inv_phit1+Vdse_VD_S*0.0+Vdse_VS_BP*0.0+pInst->Vdse*0.0);
  Udse_VD_S_VD_S=(+Vdse_VD_S_VD_S*pInst->inv_phit1+Vdse_VD_S*0.0+Vdse_VD_S*0.0+pInst->Vdse*0.0);
#endif
#endif
Udse=(pInst->Vdse*pInst->inv_phit1);
EXIT_IF_ISNAN((pInst->Vdse*pInst->inv_phit1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xn_d_VD_S=(xn_s_VD_S+Udse_VD_S);
#if defined(_DERIVATE2)
  xn_d_VD_S_VD_S=(+xn_s_VD_S_VD_S+Udse_VD_S_VD_S);
  xn_d_VD_S_VS_BP=(+xn_s_VD_S_VS_BP+Udse_VD_S_VS_BP);
  xn_d_VD_S_VGP_S=(+0.0+Udse_VD_S_VGP_S);
#endif
xn_d_VS_BP=(xn_s_VS_BP+Udse_VS_BP);
#if defined(_DERIVATE2)
  xn_d_VS_BP_VD_S=(+xn_s_VS_BP_VD_S+Udse_VS_BP_VD_S);
  xn_d_VS_BP_VS_BP=(+xn_s_VS_BP_VS_BP+Udse_VS_BP_VS_BP);
  xn_d_VS_BP_VGP_S=(+0.0+Udse_VS_BP_VGP_S);
#endif
xn_d_VGP_S=Udse_VGP_S;
#if defined(_DERIVATE2)
  xn_d_VGP_S_VD_S=(+0.0+Udse_VGP_S_VD_S);
  xn_d_VGP_S_VS_BP=(+0.0+Udse_VGP_S_VS_BP);
  xn_d_VGP_S_VGP_S=(+0.0+Udse_VGP_S_VGP_S);
#endif
#endif
xn_d=(xn_s+Udse);
EXIT_IF_ISNAN((xn_s+Udse))
if
((Udse<4.6051701859880916e+02))
{
{
double m00_exp(d00_exp0,(-Udse))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(S,BP)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
k_ds_VGP_S=(-Udse_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  k_ds_VGP_S_VGP_S=(m20_exp((-Udse))*(-Udse_VGP_S)*(-Udse_VGP_S)+d10_exp0*0.0);
  k_ds_VGP_S_VS_BP=(m20_exp((-Udse))*(-Udse_VS_BP)*(-Udse_VGP_S)+d10_exp0*0.0);
  k_ds_VGP_S_VD_S=(m20_exp((-Udse))*(-Udse_VD_S)*(-Udse_VGP_S)+d10_exp0*0.0);
#endif
k_ds_VS_BP=(-Udse_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  k_ds_VS_BP_VGP_S=(m20_exp((-Udse))*(-Udse_VGP_S)*(-Udse_VS_BP)+d10_exp0*0.0);
  k_ds_VS_BP_VS_BP=(m20_exp((-Udse))*(-Udse_VS_BP)*(-Udse_VS_BP)+d10_exp0*0.0);
  k_ds_VS_BP_VD_S=(m20_exp((-Udse))*(-Udse_VD_S)*(-Udse_VS_BP)+d10_exp0*0.0);
#endif
k_ds_VD_S=(-Udse_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  k_ds_VD_S_VGP_S=(m20_exp((-Udse))*(-Udse_VGP_S)*(-Udse_VD_S)+d10_exp0*0.0);
  k_ds_VD_S_VS_BP=(m20_exp((-Udse))*(-Udse_VS_BP)*(-Udse_VD_S)+d10_exp0*0.0);
  k_ds_VD_S_VD_S=(m20_exp((-Udse))*(-Udse_VD_S)*(-Udse_VD_S)+d10_exp0*0.0);
#endif
#endif
k_ds=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(S,BP)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
k_ds_VGP_S=(-1.0e-200*((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  k_ds_VGP_S_VGP_S=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01)))))))))+0.0*((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VGP_S_VGP_S-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VGP_S*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01))))))+Udse_VGP_S*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01))))+0.0*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01))+0.5*(+(+Udse_VGP_S_VGP_S-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VGP_S*(Udse_VGP_S*3.3333333333333333e-01)+Udse_VGP_S*Udse_VGP_S*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+Udse_VGP_S*0.0+Udse_VGP_S*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))))*(((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
  k_ds_VGP_S_VS_BP=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01)))))))))+0.0*((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VGP_S_VS_BP-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VGP_S*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01))))))+Udse_VS_BP*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01))))+0.0*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01))+0.5*(+(+Udse_VGP_S_VS_BP-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VGP_S*(Udse_VS_BP*3.3333333333333333e-01)+Udse_VS_BP*Udse_VGP_S*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+Udse_VGP_S*0.0+Udse_VS_BP*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))))*(((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
  k_ds_VGP_S_VD_S=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01)))))))))+0.0*((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VGP_S_VD_S-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VGP_S*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01))))))+Udse_VD_S*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01))))+0.0*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01))+0.5*(+(+Udse_VGP_S_VD_S-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VGP_S*(Udse_VD_S*3.3333333333333333e-01)+Udse_VD_S*Udse_VGP_S*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VGP_S_VD_S-0.0)*3.3333333333333333e-01+Udse_VGP_S*0.0+Udse_VD_S*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VGP_S*3.3333333333333333e-01)))))*(((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#endif
k_ds_VS_BP=(-1.0e-200*((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  k_ds_VS_BP_VGP_S=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01)))))))))+0.0*((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VS_BP_VGP_S-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VS_BP*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01))))))+Udse_VGP_S*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01))))+0.0*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01))+0.5*(+(+Udse_VS_BP_VGP_S-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VS_BP*(Udse_VGP_S*3.3333333333333333e-01)+Udse_VGP_S*Udse_VS_BP*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+Udse_VS_BP*0.0+Udse_VGP_S*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))))*(((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
  k_ds_VS_BP_VS_BP=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01)))))))))+0.0*((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VS_BP_VS_BP-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VS_BP*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01))))))+Udse_VS_BP*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01))))+0.0*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01))+0.5*(+(+Udse_VS_BP_VS_BP-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VS_BP*(Udse_VS_BP*3.3333333333333333e-01)+Udse_VS_BP*Udse_VS_BP*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+Udse_VS_BP*0.0+Udse_VS_BP*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))))*(((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
  k_ds_VS_BP_VD_S=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01)))))))))+0.0*((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VS_BP_VD_S-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VS_BP*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01))))))+Udse_VD_S*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01))))+0.0*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01))+0.5*(+(+Udse_VS_BP_VD_S-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VS_BP*(Udse_VD_S*3.3333333333333333e-01)+Udse_VD_S*Udse_VS_BP*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VS_BP_VD_S-0.0)*3.3333333333333333e-01+Udse_VS_BP*0.0+Udse_VD_S*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VS_BP*3.3333333333333333e-01)))))*(((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#endif
k_ds_VD_S=(-1.0e-200*((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  k_ds_VD_S_VGP_S=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01)))))))))+0.0*((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VD_S_VGP_S-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VD_S*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01))))))+Udse_VGP_S*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01))))+0.0*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01))+0.5*(+(+Udse_VD_S_VGP_S-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VD_S*(Udse_VGP_S*3.3333333333333333e-01)+Udse_VGP_S*Udse_VD_S*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VD_S_VGP_S-0.0)*3.3333333333333333e-01+Udse_VD_S*0.0+Udse_VGP_S*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))))*(((Udse_VGP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VGP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
  k_ds_VD_S_VS_BP=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01)))))))))+0.0*((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VD_S_VS_BP-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VD_S*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01))))))+Udse_VS_BP*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01))))+0.0*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01))+0.5*(+(+Udse_VD_S_VS_BP-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VD_S*(Udse_VS_BP*3.3333333333333333e-01)+Udse_VS_BP*Udse_VD_S*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VD_S_VS_BP-0.0)*3.3333333333333333e-01+Udse_VD_S*0.0+Udse_VS_BP*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))))*(((Udse_VS_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VS_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
  k_ds_VD_S_VD_S=(0.0/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))-(0.0*(((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01)))))))))+0.0*((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))))+1.0e-200*(+0.0+(+(+Udse_VD_S_VD_S-0.0)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))+Udse_VD_S*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01))))))+Udse_VD_S*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))+(Udse-4.6051701859880916e+02)*(+0.0+(+0.0*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+0.0*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01))))+0.0*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01))+0.5*(+(+Udse_VD_S_VD_S-0.0)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))+Udse_VD_S*(Udse_VD_S*3.3333333333333333e-01)+Udse_VD_S*Udse_VD_S*3.3333333333333333e-01+(Udse-4.6051701859880916e+02)*(+0.0+(+(+Udse_VD_S_VD_S-0.0)*3.3333333333333333e-01+Udse_VD_S*0.0+Udse_VD_S*0.0+(Udse-4.6051701859880916e+02)*0.0))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))+2*1.0e-200*((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*(0.5*((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*Udse_VD_S*3.3333333333333333e-01)))))*(((Udse_VD_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))+((Udse-4.6051701859880916e+02)*((0.5*(((Udse_VD_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+((Udse-4.6051701859880916e+02)*(Udse_VD_S*3.3333333333333333e-01)))))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
#endif
#endif
k_ds=(1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
delta_nd_VD_S=((delta_ns_VD_S*k_ds)+(delta_ns*k_ds_VD_S));
#if defined(_DERIVATE2)
  delta_nd_VD_S_VD_S=(+delta_ns_VD_S_VD_S*k_ds+delta_ns_VD_S*k_ds_VD_S+delta_ns_VD_S*k_ds_VD_S+delta_ns*k_ds_VD_S_VD_S);
  delta_nd_VD_S_VS_BP=(+delta_ns_VD_S_VS_BP*k_ds+delta_ns_VD_S*k_ds_VS_BP+delta_ns_VS_BP*k_ds_VD_S+delta_ns*k_ds_VD_S_VS_BP);
  delta_nd_VD_S_VGP_S=(+0.0*k_ds+delta_ns_VD_S*k_ds_VGP_S+0.0*k_ds_VD_S+delta_ns*k_ds_VD_S_VGP_S);
#endif
delta_nd_VS_BP=((delta_ns_VS_BP*k_ds)+(delta_ns*k_ds_VS_BP));
#if defined(_DERIVATE2)
  delta_nd_VS_BP_VD_S=(+delta_ns_VS_BP_VD_S*k_ds+delta_ns_VS_BP*k_ds_VD_S+delta_ns_VD_S*k_ds_VS_BP+delta_ns*k_ds_VS_BP_VD_S);
  delta_nd_VS_BP_VS_BP=(+delta_ns_VS_BP_VS_BP*k_ds+delta_ns_VS_BP*k_ds_VS_BP+delta_ns_VS_BP*k_ds_VS_BP+delta_ns*k_ds_VS_BP_VS_BP);
  delta_nd_VS_BP_VGP_S=(+0.0*k_ds+delta_ns_VS_BP*k_ds_VGP_S+0.0*k_ds_VS_BP+delta_ns*k_ds_VS_BP_VGP_S);
#endif
delta_nd_VGP_S=(delta_ns*k_ds_VGP_S);
#if defined(_DERIVATE2)
  delta_nd_VGP_S_VD_S=(+0.0*k_ds+0.0*k_ds_VD_S+delta_ns_VD_S*k_ds_VGP_S+delta_ns*k_ds_VGP_S_VD_S);
  delta_nd_VGP_S_VS_BP=(+0.0*k_ds+0.0*k_ds_VS_BP+delta_ns_VS_BP*k_ds_VGP_S+delta_ns*k_ds_VGP_S_VS_BP);
  delta_nd_VGP_S_VGP_S=(+0.0*k_ds+0.0*k_ds_VGP_S+0.0*k_ds_VGP_S+delta_ns*k_ds_VGP_S_VGP_S);
#endif
#endif
delta_nd=(delta_ns*k_ds);
EXIT_IF_ISNAN((delta_ns*k_ds))
{
double m00_fabs(d00_fabs0,pInst->xg)
if
((d00_fabs0<=margin))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp1_VD_S=((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*1.6666666666666667e-01*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  SP_S_temp1_VD_S_VD_S=(+(+(+inv_xi_VD_S_VD_S*inv_xi+inv_xi_VD_S*inv_xi_VD_S+inv_xi_VD_S*inv_xi_VD_S+inv_xi*inv_xi_VD_S_VD_S)*1.6666666666666667e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*0.0+(((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*1.6666666666666667e-01*0.0+((((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VD_S_VGP_S=(+(+(+inv_xi_VD_S_VGP_S*inv_xi+inv_xi_VD_S*inv_xi_VGP_S+inv_xi_VGP_S*inv_xi_VD_S+inv_xi*inv_xi_VD_S_VGP_S)*1.6666666666666667e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*0.0+(((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*1.6666666666666667e-01*0.0+((((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VD_S_VS_BP=(+(+(+inv_xi_VD_S_VS_BP*inv_xi+inv_xi_VD_S*inv_xi_VS_BP+inv_xi_VS_BP*inv_xi_VD_S+inv_xi*inv_xi_VD_S_VS_BP)*1.6666666666666667e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*0.0+(((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S))*1.6666666666666667e-01*0.0+((((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
#endif
SP_S_temp1_VGP_S=((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*1.6666666666666667e-01*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  SP_S_temp1_VGP_S_VD_S=(+(+(+inv_xi_VGP_S_VD_S*inv_xi+inv_xi_VGP_S*inv_xi_VD_S+inv_xi_VD_S*inv_xi_VGP_S+inv_xi*inv_xi_VGP_S_VD_S)*1.6666666666666667e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*0.0+(((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*1.6666666666666667e-01*0.0+((((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VGP_S_VGP_S=(+(+(+inv_xi_VGP_S_VGP_S*inv_xi+inv_xi_VGP_S*inv_xi_VGP_S+inv_xi_VGP_S*inv_xi_VGP_S+inv_xi*inv_xi_VGP_S_VGP_S)*1.6666666666666667e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*0.0+(((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*1.6666666666666667e-01*0.0+((((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VGP_S_VS_BP=(+(+(+inv_xi_VGP_S_VS_BP*inv_xi+inv_xi_VGP_S*inv_xi_VS_BP+inv_xi_VS_BP*inv_xi_VGP_S+inv_xi*inv_xi_VGP_S_VS_BP)*1.6666666666666667e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*0.0+(((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S))*1.6666666666666667e-01*0.0+((((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
#endif
SP_S_temp1_VS_BP=((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*1.6666666666666667e-01*7.0710678118654746e-01;
#if defined(_DERIVATE2)
  SP_S_temp1_VS_BP_VD_S=(+(+(+inv_xi_VS_BP_VD_S*inv_xi+inv_xi_VS_BP*inv_xi_VD_S+inv_xi_VD_S*inv_xi_VS_BP+inv_xi*inv_xi_VS_BP_VD_S)*1.6666666666666667e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*0.0+(((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*1.6666666666666667e-01*0.0+((((inv_xi_VD_S*inv_xi)+(inv_xi*inv_xi_VD_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VS_BP_VGP_S=(+(+(+inv_xi_VS_BP_VGP_S*inv_xi+inv_xi_VS_BP*inv_xi_VGP_S+inv_xi_VGP_S*inv_xi_VS_BP+inv_xi*inv_xi_VS_BP_VGP_S)*1.6666666666666667e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*0.0+(((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*1.6666666666666667e-01*0.0+((((inv_xi_VGP_S*inv_xi)+(inv_xi*inv_xi_VGP_S)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
  SP_S_temp1_VS_BP_VS_BP=(+(+(+inv_xi_VS_BP_VS_BP*inv_xi+inv_xi_VS_BP*inv_xi_VS_BP+inv_xi_VS_BP*inv_xi_VS_BP+inv_xi*inv_xi_VS_BP_VS_BP)*1.6666666666666667e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*0.0+(((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*0.0+(inv_xi*inv_xi)*0.0)*7.0710678118654746e-01+((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP))*1.6666666666666667e-01*0.0+((((inv_xi_VS_BP*inv_xi)+(inv_xi*inv_xi_VS_BP)))*1.6666666666666667e-01)*0.0+((inv_xi*inv_xi)*1.6666666666666667e-01)*0.0);
#endif
#endif
SP_S_temp1=(((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
EXIT_IF_ISNAN((((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_d_VD_S=((((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1)))+((pInst->xg*inv_xi)*((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S))));
#if defined(_DERIVATE2)
  x_d_VD_S_VD_S=(+(+xg_VD_S_VD_S*inv_xi+xg_VD_S*inv_xi_VD_S+xg_VD_S*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VD_S)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VD_S_VD_S*(1.0-delta_nd)+xg_VD_S*(-delta_nd_VD_S)+xg_VD_S*(-delta_nd_VD_S)+pInst->xg*(+0.0-delta_nd_VD_S_VD_S))*Gf+((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf_VD_S+(((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf_VD_S+(pInst->xg*(1.0-delta_nd))*Gf_VD_S_VD_S)*SP_S_temp1+((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S))*SP_S_temp1_VD_S+((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S)))*SP_S_temp1_VD_S+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S_VD_S)));
  x_d_VD_S_VGP_S=(+(+xg_VD_S_VGP_S*inv_xi+xg_VD_S*inv_xi_VGP_S+xg_VGP_S*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VGP_S)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VD_S_VGP_S*(1.0-delta_nd)+xg_VD_S*(-delta_nd_VGP_S)+xg_VGP_S*(-delta_nd_VD_S)+pInst->xg*(+0.0-delta_nd_VD_S_VGP_S))*Gf+((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf_VGP_S+(((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf_VD_S+(pInst->xg*(1.0-delta_nd))*Gf_VD_S_VGP_S)*SP_S_temp1+((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S))*SP_S_temp1_VGP_S+((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S)))*SP_S_temp1_VD_S+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S_VGP_S)));
  x_d_VD_S_VS_BP=(+(+xg_VD_S_VS_BP*inv_xi+xg_VD_S*inv_xi_VS_BP+xg_VS_BP*inv_xi_VD_S+pInst->xg*inv_xi_VD_S_VS_BP)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S))*(((((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VD_S_VS_BP*(1.0-delta_nd)+xg_VD_S*(-delta_nd_VS_BP)+xg_VS_BP*(-delta_nd_VD_S)+pInst->xg*(+0.0-delta_nd_VD_S_VS_BP))*Gf+((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf_VS_BP+(((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf_VD_S+(pInst->xg*(1.0-delta_nd))*Gf_VD_S_VS_BP)*SP_S_temp1+((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S))*SP_S_temp1_VS_BP+((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP)))*SP_S_temp1_VD_S+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S_VS_BP)));
#endif
x_d_VGP_S=((((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1)))+((pInst->xg*inv_xi)*((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S))));
#if defined(_DERIVATE2)
  x_d_VGP_S_VD_S=(+(+xg_VGP_S_VD_S*inv_xi+xg_VGP_S*inv_xi_VD_S+xg_VD_S*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VD_S)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VGP_S_VD_S*(1.0-delta_nd)+xg_VGP_S*(-delta_nd_VD_S)+xg_VD_S*(-delta_nd_VGP_S)+pInst->xg*(+0.0-delta_nd_VGP_S_VD_S))*Gf+((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf_VD_S+(((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf_VGP_S+(pInst->xg*(1.0-delta_nd))*Gf_VGP_S_VD_S)*SP_S_temp1+((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S))*SP_S_temp1_VD_S+((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S)))*SP_S_temp1_VGP_S+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S_VD_S)));
  x_d_VGP_S_VGP_S=(+(+xg_VGP_S_VGP_S*inv_xi+xg_VGP_S*inv_xi_VGP_S+xg_VGP_S*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VGP_S)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VGP_S_VGP_S*(1.0-delta_nd)+xg_VGP_S*(-delta_nd_VGP_S)+xg_VGP_S*(-delta_nd_VGP_S)+pInst->xg*(+0.0-delta_nd_VGP_S_VGP_S))*Gf+((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf_VGP_S+(((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf_VGP_S+(pInst->xg*(1.0-delta_nd))*Gf_VGP_S_VGP_S)*SP_S_temp1+((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S))*SP_S_temp1_VGP_S+((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S)))*SP_S_temp1_VGP_S+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S_VGP_S)));
  x_d_VGP_S_VS_BP=(+(+xg_VGP_S_VS_BP*inv_xi+xg_VGP_S*inv_xi_VS_BP+xg_VS_BP*inv_xi_VGP_S+pInst->xg*inv_xi_VGP_S_VS_BP)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S))*(((((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VGP_S_VS_BP*(1.0-delta_nd)+xg_VGP_S*(-delta_nd_VS_BP)+xg_VS_BP*(-delta_nd_VGP_S)+pInst->xg*(+0.0-delta_nd_VGP_S_VS_BP))*Gf+((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf_VS_BP+(((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf_VGP_S+(pInst->xg*(1.0-delta_nd))*Gf_VGP_S_VS_BP)*SP_S_temp1+((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S))*SP_S_temp1_VS_BP+((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP)))*SP_S_temp1_VGP_S+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S_VS_BP)));
#endif
x_d_VS_BP=((((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1)))+((pInst->xg*inv_xi)*((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP))));
#if defined(_DERIVATE2)
  x_d_VS_BP_VD_S=(+(+xg_VS_BP_VD_S*inv_xi+xg_VS_BP*inv_xi_VD_S+xg_VD_S*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VD_S)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VD_S)))+(((xg_VD_S*inv_xi)+(pInst->xg*inv_xi_VD_S)))*((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VS_BP_VD_S*(1.0-delta_nd)+xg_VS_BP*(-delta_nd_VD_S)+xg_VD_S*(-delta_nd_VS_BP)+pInst->xg*(+0.0-delta_nd_VS_BP_VD_S))*Gf+((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf_VD_S+(((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf_VS_BP+(pInst->xg*(1.0-delta_nd))*Gf_VS_BP_VD_S)*SP_S_temp1+((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP))*SP_S_temp1_VD_S+((((((xg_VD_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VD_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VD_S)))*SP_S_temp1_VS_BP+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP_VD_S)));
  x_d_VS_BP_VGP_S=(+(+xg_VS_BP_VGP_S*inv_xi+xg_VS_BP*inv_xi_VGP_S+xg_VGP_S*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VGP_S)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VGP_S)))+(((xg_VGP_S*inv_xi)+(pInst->xg*inv_xi_VGP_S)))*((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VS_BP_VGP_S*(1.0-delta_nd)+xg_VS_BP*(-delta_nd_VGP_S)+xg_VGP_S*(-delta_nd_VS_BP)+pInst->xg*(+0.0-delta_nd_VS_BP_VGP_S))*Gf+((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf_VGP_S+(((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf_VS_BP+(pInst->xg*(1.0-delta_nd))*Gf_VS_BP_VGP_S)*SP_S_temp1+((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP))*SP_S_temp1_VGP_S+((((((xg_VGP_S*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VGP_S))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VGP_S)))*SP_S_temp1_VS_BP+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP_VGP_S)));
  x_d_VS_BP_VS_BP=(+(+xg_VS_BP_VS_BP*inv_xi+xg_VS_BP*inv_xi_VS_BP+xg_VS_BP*inv_xi_VS_BP+pInst->xg*inv_xi_VS_BP_VS_BP)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))+((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP))*(((((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP)))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP)))+(((xg_VS_BP*inv_xi)+(pInst->xg*inv_xi_VS_BP)))*((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP))*SP_S_temp1)+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP))+(pInst->xg*inv_xi)*(+0.0+(+(+(+xg_VS_BP_VS_BP*(1.0-delta_nd)+xg_VS_BP*(-delta_nd_VS_BP)+xg_VS_BP*(-delta_nd_VS_BP)+pInst->xg*(+0.0-delta_nd_VS_BP_VS_BP))*Gf+((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf_VS_BP+(((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf_VS_BP+(pInst->xg*(1.0-delta_nd))*Gf_VS_BP_VS_BP)*SP_S_temp1+((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP)))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP))*SP_S_temp1_VS_BP+((((((xg_VS_BP*(1.0-delta_nd))+(pInst->xg*(-delta_nd_VS_BP))))*Gf)+((pInst->xg*(1.0-delta_nd))*Gf_VS_BP)))*SP_S_temp1_VS_BP+((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1_VS_BP_VS_BP)));
#endif
#endif
x_d=((pInst->xg*inv_xi)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
EXIT_IF_ISNAN(((pInst->xg*inv_xi)*(1.0+(((pInst->xg*(1.0-delta_nd))*Gf)*SP_S_temp1))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_bx_VGP_S=xn_d_VGP_S;
#if defined(_DERIVATE2)
  SP_S_bx_VGP_S_VGP_S=(+xn_d_VGP_S_VGP_S+0.0);
  SP_S_bx_VGP_S_VD_S=(+xn_d_VGP_S_VD_S+0.0);
  SP_S_bx_VGP_S_VS_BP=(+xn_d_VGP_S_VS_BP+0.0);
#endif
SP_S_bx_VD_S=xn_d_VD_S;
#if defined(_DERIVATE2)
  SP_S_bx_VD_S_VGP_S=(+xn_d_VD_S_VGP_S+0.0);
  SP_S_bx_VD_S_VD_S=(+xn_d_VD_S_VD_S+0.0);
  SP_S_bx_VD_S_VS_BP=(+xn_d_VD_S_VS_BP+0.0);
#endif
SP_S_bx_VS_BP=xn_d_VS_BP;
#if defined(_DERIVATE2)
  SP_S_bx_VS_BP_VGP_S=(+xn_d_VS_BP_VGP_S+0.0);
  SP_S_bx_VS_BP_VD_S=(+xn_d_VS_BP_VD_S+0.0);
  SP_S_bx_VS_BP_VS_BP=(+xn_d_VS_BP_VS_BP+0.0);
#endif
#endif
SP_S_bx=(xn_d+3);
EXIT_IF_ISNAN((xn_d+3))
{
double m00_sqrt(d00_sqrt0,(((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))
double m00_sqrt(d00_sqrt1,((SP_S_bx*SP_S_bx)+5.0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))
double m10_sqrt(d10_sqrt1,d00_sqrt1,((SP_S_bx*SP_S_bx)+5.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_eta_VD_S=((0.5*((SP_S_x1_VD_S+SP_S_bx_VD_S)-(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))*d10_sqrt0))-(0.5*(SP_S_bx_VD_S-((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))*d10_sqrt1)));
#if defined(_DERIVATE2)
  SP_S_eta_VD_S_VD_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*d10_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VD_S_VD_S+SP_S_bx_VD_S_VD_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))+d10_sqrt0*(+(+(+SP_S_x1_VD_S_VD_S-SP_S_bx_VD_S_VD_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VD_S_VD_S-SP_S_bx_VD_S_VD_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VD_S-(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*d10_sqrt1)+0.0*(SP_S_bx_VD_S-((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))*d10_sqrt1)+0.5*(+SP_S_bx_VD_S_VD_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))+d10_sqrt1*(+(+SP_S_bx_VD_S_VD_S*SP_S_bx+SP_S_bx_VD_S*SP_S_bx_VD_S+SP_S_bx_VD_S*SP_S_bx_VD_S+SP_S_bx*SP_S_bx_VD_S_VD_S)+0.0)))));
  SP_S_eta_VD_S_VGP_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*d10_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VD_S_VGP_S+SP_S_bx_VD_S_VGP_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))+d10_sqrt0*(+(+(+SP_S_x1_VD_S_VGP_S-SP_S_bx_VD_S_VGP_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VD_S_VGP_S-SP_S_bx_VD_S_VGP_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VGP_S-(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*d10_sqrt1)+0.0*(SP_S_bx_VD_S-((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))*d10_sqrt1)+0.5*(+SP_S_bx_VD_S_VGP_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))+d10_sqrt1*(+(+SP_S_bx_VD_S_VGP_S*SP_S_bx+SP_S_bx_VD_S*SP_S_bx_VGP_S+SP_S_bx_VGP_S*SP_S_bx_VD_S+SP_S_bx*SP_S_bx_VD_S_VGP_S)+0.0)))));
  SP_S_eta_VD_S_VS_BP=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*d10_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VD_S_VS_BP+SP_S_bx_VD_S_VS_BP)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*(((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S)))+d10_sqrt0*(+(+(+SP_S_x1_VD_S_VS_BP-SP_S_bx_VD_S_VS_BP)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VD_S_VS_BP-SP_S_bx_VD_S_VS_BP))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VS_BP-(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*d10_sqrt1)+0.0*(SP_S_bx_VD_S-((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))*d10_sqrt1)+0.5*(+SP_S_bx_VD_S_VS_BP-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S))+d10_sqrt1*(+(+SP_S_bx_VD_S_VS_BP*SP_S_bx+SP_S_bx_VD_S*SP_S_bx_VS_BP+SP_S_bx_VS_BP*SP_S_bx_VD_S+SP_S_bx*SP_S_bx_VD_S_VS_BP)+0.0)))));
#endif
SP_S_eta_VGP_S=((0.5*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))*d10_sqrt0))-(0.5*(SP_S_bx_VGP_S-((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))*d10_sqrt1)));
#if defined(_DERIVATE2)
  SP_S_eta_VGP_S_VD_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*d10_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VGP_S_VD_S+SP_S_bx_VGP_S_VD_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))+d10_sqrt0*(+(+(+SP_S_x1_VGP_S_VD_S-SP_S_bx_VGP_S_VD_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VGP_S_VD_S-SP_S_bx_VGP_S_VD_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VD_S-(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*d10_sqrt1)+0.0*(SP_S_bx_VGP_S-((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))*d10_sqrt1)+0.5*(+SP_S_bx_VGP_S_VD_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))+d10_sqrt1*(+(+SP_S_bx_VGP_S_VD_S*SP_S_bx+SP_S_bx_VGP_S*SP_S_bx_VD_S+SP_S_bx_VD_S*SP_S_bx_VGP_S+SP_S_bx*SP_S_bx_VGP_S_VD_S)+0.0)))));
  SP_S_eta_VGP_S_VGP_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*d10_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VGP_S_VGP_S+SP_S_bx_VGP_S_VGP_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))+d10_sqrt0*(+(+(+SP_S_x1_VGP_S_VGP_S-SP_S_bx_VGP_S_VGP_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VGP_S_VGP_S-SP_S_bx_VGP_S_VGP_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VGP_S-(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*d10_sqrt1)+0.0*(SP_S_bx_VGP_S-((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))*d10_sqrt1)+0.5*(+SP_S_bx_VGP_S_VGP_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))+d10_sqrt1*(+(+SP_S_bx_VGP_S_VGP_S*SP_S_bx+SP_S_bx_VGP_S*SP_S_bx_VGP_S+SP_S_bx_VGP_S*SP_S_bx_VGP_S+SP_S_bx*SP_S_bx_VGP_S_VGP_S)+0.0)))));
  SP_S_eta_VGP_S_VS_BP=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*d10_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VGP_S_VS_BP+SP_S_bx_VGP_S_VS_BP)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*(((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)))+d10_sqrt0*(+(+(+SP_S_x1_VGP_S_VS_BP-SP_S_bx_VGP_S_VS_BP)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VGP_S_VS_BP-SP_S_bx_VGP_S_VS_BP))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VS_BP-(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*d10_sqrt1)+0.0*(SP_S_bx_VGP_S-((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))*d10_sqrt1)+0.5*(+SP_S_bx_VGP_S_VS_BP-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S))+d10_sqrt1*(+(+SP_S_bx_VGP_S_VS_BP*SP_S_bx+SP_S_bx_VGP_S*SP_S_bx_VS_BP+SP_S_bx_VS_BP*SP_S_bx_VGP_S+SP_S_bx*SP_S_bx_VGP_S_VS_BP)+0.0)))));
#endif
SP_S_eta_VS_BP=((0.5*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))*d10_sqrt0))-(0.5*(SP_S_bx_VS_BP-((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))*d10_sqrt1)));
#if defined(_DERIVATE2)
  SP_S_eta_VS_BP_VD_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VD_S+SP_S_bx_VD_S)-((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*d10_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VS_BP_VD_S+SP_S_bx_VS_BP_VD_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VD_S-SP_S_bx_VD_S))))*(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))+d10_sqrt0*(+(+(+SP_S_x1_VS_BP_VD_S-SP_S_bx_VS_BP_VD_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VD_S-SP_S_bx_VD_S)+(SP_S_x1_VD_S-SP_S_bx_VD_S)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VS_BP_VD_S-SP_S_bx_VS_BP_VD_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VD_S-(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*d10_sqrt1)+0.0*(SP_S_bx_VS_BP-((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))*d10_sqrt1)+0.5*(+SP_S_bx_VS_BP_VD_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VD_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VD_S)))*((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))+d10_sqrt1*(+(+SP_S_bx_VS_BP_VD_S*SP_S_bx+SP_S_bx_VS_BP*SP_S_bx_VD_S+SP_S_bx_VD_S*SP_S_bx_VS_BP+SP_S_bx*SP_S_bx_VS_BP_VD_S)+0.0)))));
  SP_S_eta_VS_BP_VGP_S=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VGP_S+SP_S_bx_VGP_S)-((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*d10_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VS_BP_VGP_S+SP_S_bx_VS_BP_VGP_S)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S))))*(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))+d10_sqrt0*(+(+(+SP_S_x1_VS_BP_VGP_S-SP_S_bx_VS_BP_VGP_S)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VGP_S-SP_S_bx_VGP_S)+(SP_S_x1_VGP_S-SP_S_bx_VGP_S)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VS_BP_VGP_S-SP_S_bx_VS_BP_VGP_S))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VGP_S-(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*d10_sqrt1)+0.0*(SP_S_bx_VS_BP-((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))*d10_sqrt1)+0.5*(+SP_S_bx_VS_BP_VGP_S-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VGP_S*SP_S_bx)+(SP_S_bx*SP_S_bx_VGP_S)))*((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))+d10_sqrt1*(+(+SP_S_bx_VS_BP_VGP_S*SP_S_bx+SP_S_bx_VS_BP*SP_S_bx_VGP_S+SP_S_bx_VGP_S*SP_S_bx_VS_BP+SP_S_bx*SP_S_bx_VS_BP_VGP_S)+0.0)))));
  SP_S_eta_VS_BP_VS_BP=(+(+0.0*((SP_S_x1+SP_S_bx)-d00_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*d10_sqrt0)+0.0*((SP_S_x1_VS_BP+SP_S_bx_VS_BP)-(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))*d10_sqrt0)+0.5*(+(+SP_S_x1_VS_BP_VS_BP+SP_S_bx_VS_BP_VS_BP)-(m20_sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0))*((((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP))))*(((SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1-SP_S_bx))+((SP_S_x1-SP_S_bx)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)))+d10_sqrt0*(+(+(+SP_S_x1_VS_BP_VS_BP-SP_S_bx_VS_BP_VS_BP)*(SP_S_x1-SP_S_bx)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1_VS_BP-SP_S_bx_VS_BP)*(SP_S_x1_VS_BP-SP_S_bx_VS_BP)+(SP_S_x1-SP_S_bx)*(+SP_S_x1_VS_BP_VS_BP-SP_S_bx_VS_BP_VS_BP))+0.0))))-(+0.0*(SP_S_bx-d00_sqrt1)+0.0*(SP_S_bx_VS_BP-(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*d10_sqrt1)+0.0*(SP_S_bx_VS_BP-((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))*d10_sqrt1)+0.5*(+SP_S_bx_VS_BP_VS_BP-(m20_sqrt(((SP_S_bx*SP_S_bx)+5.0))*(((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP)))*((SP_S_bx_VS_BP*SP_S_bx)+(SP_S_bx*SP_S_bx_VS_BP))+d10_sqrt1*(+(+SP_S_bx_VS_BP_VS_BP*SP_S_bx+SP_S_bx_VS_BP*SP_S_bx_VS_BP+SP_S_bx_VS_BP*SP_S_bx_VS_BP+SP_S_bx*SP_S_bx_VS_BP_VS_BP)+0.0)))));
#endif
#endif
SP_S_eta=((0.5*((SP_S_x1+SP_S_bx)-d00_sqrt0))-(0.5*(SP_S_bx-d00_sqrt1)));
EXIT_IF_ISNAN(((0.5*((SP_S_x1+SP_S_bx)-d00_sqrt0))-(0.5*(SP_S_bx-d00_sqrt1))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(xg_VD_S-SP_S_eta_VD_S);
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+xg_VD_S_VD_S-SP_S_eta_VD_S_VD_S);
  SP_S_temp_VD_S_VGP_S=(+xg_VD_S_VGP_S-SP_S_eta_VD_S_VGP_S);
  SP_S_temp_VD_S_VS_BP=(+xg_VD_S_VS_BP-SP_S_eta_VD_S_VS_BP);
#endif
SP_S_temp_VGP_S=(xg_VGP_S-SP_S_eta_VGP_S);
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+xg_VGP_S_VD_S-SP_S_eta_VGP_S_VD_S);
  SP_S_temp_VGP_S_VGP_S=(+xg_VGP_S_VGP_S-SP_S_eta_VGP_S_VGP_S);
  SP_S_temp_VGP_S_VS_BP=(+xg_VGP_S_VS_BP-SP_S_eta_VGP_S_VS_BP);
#endif
SP_S_temp_VS_BP=(xg_VS_BP-SP_S_eta_VS_BP);
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+xg_VS_BP_VD_S-SP_S_eta_VS_BP_VD_S);
  SP_S_temp_VS_BP_VGP_S=(+xg_VS_BP_VGP_S-SP_S_eta_VS_BP_VGP_S);
  SP_S_temp_VS_BP_VS_BP=(+xg_VS_BP_VS_BP-SP_S_eta_VS_BP_VS_BP);
#endif
#endif
SP_S_temp=(pInst->xg-SP_S_eta);
EXIT_IF_ISNAN((pInst->xg-SP_S_eta))
{
double m00_exp(d00_exp0,(-SP_S_eta))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp1_VD_S=(-SP_S_eta_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp1_VD_S_VD_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VD_S)*(-SP_S_eta_VD_S)+d10_exp0*0.0);
  SP_S_temp1_VD_S_VGP_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VGP_S)*(-SP_S_eta_VD_S)+d10_exp0*0.0);
  SP_S_temp1_VD_S_VS_BP=(m20_exp((-SP_S_eta))*(-SP_S_eta_VS_BP)*(-SP_S_eta_VD_S)+d10_exp0*0.0);
#endif
SP_S_temp1_VGP_S=(-SP_S_eta_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp1_VGP_S_VD_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VD_S)*(-SP_S_eta_VGP_S)+d10_exp0*0.0);
  SP_S_temp1_VGP_S_VGP_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VGP_S)*(-SP_S_eta_VGP_S)+d10_exp0*0.0);
  SP_S_temp1_VGP_S_VS_BP=(m20_exp((-SP_S_eta))*(-SP_S_eta_VS_BP)*(-SP_S_eta_VGP_S)+d10_exp0*0.0);
#endif
SP_S_temp1_VS_BP=(-SP_S_eta_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_temp1_VS_BP_VD_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VD_S)*(-SP_S_eta_VS_BP)+d10_exp0*0.0);
  SP_S_temp1_VS_BP_VGP_S=(m20_exp((-SP_S_eta))*(-SP_S_eta_VGP_S)*(-SP_S_eta_VS_BP)+d10_exp0*0.0);
  SP_S_temp1_VS_BP_VS_BP=(m20_exp((-SP_S_eta))*(-SP_S_eta_VS_BP)*(-SP_S_eta_VS_BP)+d10_exp0*0.0);
#endif
#endif
SP_S_temp1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp2_VD_S=(-((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#if defined(_DERIVATE2)
  SP_S_temp2_VD_S_VD_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))+0.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))+1.0*(+0.0+(+SP_S_eta_VD_S_VD_S*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VD_S_VGP_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))+0.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))+1.0*(+0.0+(+SP_S_eta_VD_S_VGP_S*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VD_S_VS_BP=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))+0.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))+1.0*(+0.0+(+SP_S_eta_VD_S_VS_BP*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#endif
SP_S_temp2_VGP_S=(-((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#if defined(_DERIVATE2)
  SP_S_temp2_VGP_S_VD_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))+0.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))+1.0*(+0.0+(+SP_S_eta_VGP_S_VD_S*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VGP_S_VGP_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))+0.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))+1.0*(+0.0+(+SP_S_eta_VGP_S_VGP_S*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VGP_S_VS_BP=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))+0.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))+1.0*(+0.0+(+SP_S_eta_VGP_S_VS_BP*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#endif
SP_S_temp2_VS_BP=(-((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#if defined(_DERIVATE2)
  SP_S_temp2_VS_BP_VD_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))+0.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))+1.0*(+0.0+(+SP_S_eta_VS_BP_VD_S*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VS_BP_VGP_S=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))+0.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))+1.0*(+0.0+(+SP_S_eta_VS_BP_VGP_S*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
  SP_S_temp2_VS_BP_VS_BP=(0.0/(2.0+(SP_S_eta*SP_S_eta))-(0.0*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))+0.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))+1.0*(+0.0+(+SP_S_eta_VS_BP_VS_BP*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))+2*1.0*((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
#endif
#endif
SP_S_temp2=(1.0/(2.0+(SP_S_eta*SP_S_eta)));
EXIT_IF_ISNAN((1.0/(2.0+(SP_S_eta*SP_S_eta))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi0_VD_S=((((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_eta)*SP_S_temp2_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VD_S_VD_S=(+(+SP_S_eta_VD_S_VD_S*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VD_S)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VD_S_VD_S);
  SP_S_xi0_VD_S_VGP_S=(+(+SP_S_eta_VD_S_VGP_S*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VGP_S)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VD_S_VGP_S);
  SP_S_xi0_VD_S_VS_BP=(+(+SP_S_eta_VD_S_VS_BP*SP_S_eta+SP_S_eta_VD_S*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VD_S+SP_S_eta*SP_S_eta_VD_S_VS_BP)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VD_S_VS_BP);
#endif
SP_S_xi0_VGP_S=((((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_eta)*SP_S_temp2_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VGP_S_VD_S=(+(+SP_S_eta_VGP_S_VD_S*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VD_S)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VGP_S_VD_S);
  SP_S_xi0_VGP_S_VGP_S=(+(+SP_S_eta_VGP_S_VGP_S*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VGP_S)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VGP_S_VGP_S);
  SP_S_xi0_VGP_S_VS_BP=(+(+SP_S_eta_VGP_S_VS_BP*SP_S_eta+SP_S_eta_VGP_S*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VGP_S+SP_S_eta*SP_S_eta_VGP_S_VS_BP)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_eta)*SP_S_temp2_VGP_S_VS_BP);
#endif
SP_S_xi0_VS_BP=((((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_eta)*SP_S_temp2_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi0_VS_BP_VD_S=(+(+SP_S_eta_VS_BP_VD_S*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VD_S+SP_S_eta_VD_S*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VD_S)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VD_S)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_eta)*SP_S_temp2_VS_BP_VD_S);
  SP_S_xi0_VS_BP_VGP_S=(+(+SP_S_eta_VS_BP_VGP_S*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VGP_S+SP_S_eta_VGP_S*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VGP_S)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_eta)+(SP_S_eta*SP_S_eta_VGP_S)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_eta)*SP_S_temp2_VS_BP_VGP_S);
  SP_S_xi0_VS_BP_VS_BP=(+(+SP_S_eta_VS_BP_VS_BP*SP_S_eta+SP_S_eta_VS_BP*SP_S_eta_VS_BP+SP_S_eta_VS_BP*SP_S_eta_VS_BP+SP_S_eta*SP_S_eta_VS_BP_VS_BP)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_eta)+(SP_S_eta*SP_S_eta_VS_BP)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_eta)*SP_S_temp2_VS_BP_VS_BP);
#endif
#endif
SP_S_xi0=((SP_S_eta*SP_S_eta)*SP_S_temp2);
EXIT_IF_ISNAN(((SP_S_eta*SP_S_eta)*SP_S_temp2))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi1_VD_S=(4.0*((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VD_S_VD_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S)))+0.0*((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S))+4.0*(+(+SP_S_eta_VD_S_VD_S*SP_S_temp2+SP_S_eta_VD_S*SP_S_temp2_VD_S+SP_S_eta_VD_S*SP_S_temp2_VD_S+SP_S_eta*SP_S_temp2_VD_S_VD_S)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S_VD_S));
  SP_S_xi1_VD_S_VGP_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S)))+0.0*((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S))+4.0*(+(+SP_S_eta_VD_S_VGP_S*SP_S_temp2+SP_S_eta_VD_S*SP_S_temp2_VGP_S+SP_S_eta_VGP_S*SP_S_temp2_VD_S+SP_S_eta*SP_S_temp2_VD_S_VGP_S)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S_VGP_S));
  SP_S_xi1_VD_S_VS_BP=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP)))+0.0*((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S))+4.0*(+(+SP_S_eta_VD_S_VS_BP*SP_S_temp2+SP_S_eta_VD_S*SP_S_temp2_VS_BP+SP_S_eta_VS_BP*SP_S_temp2_VD_S+SP_S_eta*SP_S_temp2_VD_S_VS_BP)*SP_S_temp2+((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2_VD_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S_VS_BP));
#endif
SP_S_xi1_VGP_S=(4.0*((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VGP_S_VD_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S)))+0.0*((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S))+4.0*(+(+SP_S_eta_VGP_S_VD_S*SP_S_temp2+SP_S_eta_VGP_S*SP_S_temp2_VD_S+SP_S_eta_VD_S*SP_S_temp2_VGP_S+SP_S_eta*SP_S_temp2_VGP_S_VD_S)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S_VD_S));
  SP_S_xi1_VGP_S_VGP_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S)))+0.0*((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S))+4.0*(+(+SP_S_eta_VGP_S_VGP_S*SP_S_temp2+SP_S_eta_VGP_S*SP_S_temp2_VGP_S+SP_S_eta_VGP_S*SP_S_temp2_VGP_S+SP_S_eta*SP_S_temp2_VGP_S_VGP_S)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S_VGP_S));
  SP_S_xi1_VGP_S_VS_BP=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP)))+0.0*((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S))+4.0*(+(+SP_S_eta_VGP_S_VS_BP*SP_S_temp2+SP_S_eta_VGP_S*SP_S_temp2_VS_BP+SP_S_eta_VS_BP*SP_S_temp2_VGP_S+SP_S_eta*SP_S_temp2_VGP_S_VS_BP)*SP_S_temp2+((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2_VGP_S+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S_VS_BP));
#endif
SP_S_xi1_VS_BP=(4.0*((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP)));
#if defined(_DERIVATE2)
  SP_S_xi1_VS_BP_VD_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VD_S)))+0.0*((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP))+4.0*(+(+SP_S_eta_VS_BP_VD_S*SP_S_temp2+SP_S_eta_VS_BP*SP_S_temp2_VD_S+SP_S_eta_VD_S*SP_S_temp2_VS_BP+SP_S_eta*SP_S_temp2_VS_BP_VD_S)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2_VD_S+(((SP_S_eta_VD_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VD_S)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP_VD_S));
  SP_S_xi1_VS_BP_VGP_S=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VGP_S)))+0.0*((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP))+4.0*(+(+SP_S_eta_VS_BP_VGP_S*SP_S_temp2+SP_S_eta_VS_BP*SP_S_temp2_VGP_S+SP_S_eta_VGP_S*SP_S_temp2_VS_BP+SP_S_eta*SP_S_temp2_VS_BP_VGP_S)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2_VGP_S+(((SP_S_eta_VGP_S*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VGP_S)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP_VGP_S));
  SP_S_xi1_VS_BP_VS_BP=(+0.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)+0.0*((((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP)))+0.0*((((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2)+((SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP))+4.0*(+(+SP_S_eta_VS_BP_VS_BP*SP_S_temp2+SP_S_eta_VS_BP*SP_S_temp2_VS_BP+SP_S_eta_VS_BP*SP_S_temp2_VS_BP+SP_S_eta*SP_S_temp2_VS_BP_VS_BP)*SP_S_temp2+((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP))*SP_S_temp2_VS_BP+(((SP_S_eta_VS_BP*SP_S_temp2)+(SP_S_eta*SP_S_temp2_VS_BP)))*SP_S_temp2_VS_BP+(SP_S_eta*SP_S_temp2)*SP_S_temp2_VS_BP_VS_BP));
#endif
#endif
SP_S_xi1=(4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
EXIT_IF_ISNAN((4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi2_VD_S=((((((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S))*SP_S_temp2)+((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VD_S_VD_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VD_S+0.0*SP_S_temp2_VD_S+8.0*SP_S_temp2_VD_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VD_S))*SP_S_temp2+((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2_VD_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S_VD_S)*SP_S_temp2+((((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S))*SP_S_temp2_VD_S+((((((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S)))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VD_S_VD_S);
  SP_S_xi2_VD_S_VGP_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VGP_S+0.0*SP_S_temp2_VD_S+8.0*SP_S_temp2_VD_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VGP_S))*SP_S_temp2+((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2_VD_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S_VGP_S)*SP_S_temp2+((((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S))*SP_S_temp2_VGP_S+((((((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S)))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VD_S_VGP_S);
  SP_S_xi2_VD_S_VS_BP=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VS_BP+0.0*SP_S_temp2_VD_S+8.0*SP_S_temp2_VD_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VS_BP))*SP_S_temp2+((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2_VD_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S_VS_BP)*SP_S_temp2+((((8.0*SP_S_temp2_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S))*SP_S_temp2_VS_BP+((((((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP)))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VD_S_VS_BP);
#endif
SP_S_xi2_VGP_S=((((((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S))*SP_S_temp2)+((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VGP_S_VD_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VD_S+0.0*SP_S_temp2_VGP_S+8.0*SP_S_temp2_VGP_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VD_S))*SP_S_temp2+((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2_VGP_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S_VD_S)*SP_S_temp2+((((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S))*SP_S_temp2_VD_S+((((((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S)))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VGP_S_VD_S);
  SP_S_xi2_VGP_S_VGP_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VGP_S+0.0*SP_S_temp2_VGP_S+8.0*SP_S_temp2_VGP_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VGP_S))*SP_S_temp2+((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2_VGP_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S_VGP_S)*SP_S_temp2+((((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S))*SP_S_temp2_VGP_S+((((((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S)))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VGP_S_VGP_S);
  SP_S_xi2_VGP_S_VS_BP=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VS_BP+0.0*SP_S_temp2_VGP_S+8.0*SP_S_temp2_VGP_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VS_BP))*SP_S_temp2+((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2_VGP_S+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S_VS_BP)*SP_S_temp2+((((8.0*SP_S_temp2_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S))*SP_S_temp2_VS_BP+((((((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP)))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VGP_S_VS_BP);
#endif
SP_S_xi2_VS_BP=((((((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP))*SP_S_temp2)+((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi2_VS_BP_VD_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VD_S+0.0*SP_S_temp2_VS_BP+8.0*SP_S_temp2_VS_BP_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VD_S))*SP_S_temp2+((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2_VD_S+(((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2_VS_BP+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP_VD_S)*SP_S_temp2+((((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP))*SP_S_temp2_VD_S+((((((8.0*SP_S_temp2_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VD_S)))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VS_BP_VD_S);
  SP_S_xi2_VS_BP_VGP_S=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VGP_S+0.0*SP_S_temp2_VS_BP+8.0*SP_S_temp2_VS_BP_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VGP_S))*SP_S_temp2+((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2_VGP_S+(((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2_VS_BP+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP_VGP_S)*SP_S_temp2+((((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP))*SP_S_temp2_VGP_S+((((((8.0*SP_S_temp2_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VGP_S)))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VS_BP_VGP_S);
  SP_S_xi2_VS_BP_VS_BP=(+(+(+(+0.0*SP_S_temp2+0.0*SP_S_temp2_VS_BP+0.0*SP_S_temp2_VS_BP+8.0*SP_S_temp2_VS_BP_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VS_BP))*SP_S_temp2+((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2_VS_BP+((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP_VS_BP)*SP_S_temp2+((((8.0*SP_S_temp2_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP))*SP_S_temp2_VS_BP+((((((8.0*SP_S_temp2_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp2)+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2_VS_BP)))*SP_S_temp2_VS_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2_VS_BP_VS_BP);
#endif
#endif
SP_S_xi2=((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
EXIT_IF_ISNAN(((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2))
{
double m00_max(d00_max0,1.0e-40,((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))
#if defined(_DERIVATEFORDDX)
double m11_max(d11_max0,d00_max0,1.0e-40,((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_a_VD_S=(d11_max0*(((SP_S_temp_VD_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VD_S))-((Gf2_VD_S*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))+(Gf2*((SP_S_temp1_VD_S+SP_S_eta_VD_S)-((delta_nd_VD_S*((SP_S_eta+1.0)+SP_S_xi0))+(delta_nd*(SP_S_eta_VD_S+SP_S_xi0_VD_S))))))));
#if defined(_DERIVATE2)
  SP_S_a_VD_S_VD_S=fixme;
  SP_S_a_VD_S_VGP_S=fixme;
  SP_S_a_VD_S_VS_BP=fixme;
#endif
SP_S_a_VGP_S=(d11_max0*(((SP_S_temp_VGP_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VGP_S))-((Gf2_VGP_S*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))+(Gf2*((SP_S_temp1_VGP_S+SP_S_eta_VGP_S)-((delta_nd_VGP_S*((SP_S_eta+1.0)+SP_S_xi0))+(delta_nd*(SP_S_eta_VGP_S+SP_S_xi0_VGP_S))))))));
#if defined(_DERIVATE2)
  SP_S_a_VGP_S_VD_S=fixme;
  SP_S_a_VGP_S_VGP_S=fixme;
  SP_S_a_VGP_S_VS_BP=fixme;
#endif
SP_S_a_VS_BP=(d11_max0*(((SP_S_temp_VS_BP*SP_S_temp)+(SP_S_temp*SP_S_temp_VS_BP))-((Gf2_VS_BP*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))+(Gf2*((SP_S_temp1_VS_BP+SP_S_eta_VS_BP)-((delta_nd_VS_BP*((SP_S_eta+1.0)+SP_S_xi0))+(delta_nd*(SP_S_eta_VS_BP+SP_S_xi0_VS_BP))))))));
#if defined(_DERIVATE2)
  SP_S_a_VS_BP_VD_S=fixme;
  SP_S_a_VS_BP_VGP_S=fixme;
  SP_S_a_VS_BP_VS_BP=fixme;
#endif
#endif
SP_S_a=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_b_VD_S=(-(0.5*((Gf2_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))))));
#if defined(_DERIVATE2)
  SP_S_b_VD_S_VD_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))))))+0.0*((Gf2_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))))+0.5*(+Gf2_VD_S_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VD_S*(SP_S_temp1_VD_S-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S))))+Gf2_VD_S*(SP_S_temp1_VD_S-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))+Gf2*(+SP_S_temp1_VD_S_VD_S-(+delta_nd_VD_S_VD_S*SP_S_xi2+delta_nd_VD_S*SP_S_xi2_VD_S+delta_nd_VD_S*SP_S_xi2_VD_S+delta_nd*SP_S_xi2_VD_S_VD_S)))));
  SP_S_b_VD_S_VGP_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))))))+0.0*((Gf2_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))))+0.5*(+Gf2_VD_S_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VD_S*(SP_S_temp1_VGP_S-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S))))+Gf2_VGP_S*(SP_S_temp1_VD_S-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))+Gf2*(+SP_S_temp1_VD_S_VGP_S-(+delta_nd_VD_S_VGP_S*SP_S_xi2+delta_nd_VD_S*SP_S_xi2_VGP_S+delta_nd_VGP_S*SP_S_xi2_VD_S+delta_nd*SP_S_xi2_VD_S_VGP_S)))));
  SP_S_b_VD_S_VS_BP=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))))))+0.0*((Gf2_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))))+0.5*(+Gf2_VD_S_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VD_S*(SP_S_temp1_VS_BP-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP))))+Gf2_VS_BP*(SP_S_temp1_VD_S-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))+Gf2*(+SP_S_temp1_VD_S_VS_BP-(+delta_nd_VD_S_VS_BP*SP_S_xi2+delta_nd_VD_S*SP_S_xi2_VS_BP+delta_nd_VS_BP*SP_S_xi2_VD_S+delta_nd*SP_S_xi2_VD_S_VS_BP)))));
#endif
SP_S_b_VGP_S=(-(0.5*((Gf2_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))))));
#if defined(_DERIVATE2)
  SP_S_b_VGP_S_VD_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))))))+0.0*((Gf2_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))))+0.5*(+Gf2_VGP_S_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VGP_S*(SP_S_temp1_VD_S-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S))))+Gf2_VD_S*(SP_S_temp1_VGP_S-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))+Gf2*(+SP_S_temp1_VGP_S_VD_S-(+delta_nd_VGP_S_VD_S*SP_S_xi2+delta_nd_VGP_S*SP_S_xi2_VD_S+delta_nd_VD_S*SP_S_xi2_VGP_S+delta_nd*SP_S_xi2_VGP_S_VD_S)))));
  SP_S_b_VGP_S_VGP_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))))))+0.0*((Gf2_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))))+0.5*(+Gf2_VGP_S_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VGP_S*(SP_S_temp1_VGP_S-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S))))+Gf2_VGP_S*(SP_S_temp1_VGP_S-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))+Gf2*(+SP_S_temp1_VGP_S_VGP_S-(+delta_nd_VGP_S_VGP_S*SP_S_xi2+delta_nd_VGP_S*SP_S_xi2_VGP_S+delta_nd_VGP_S*SP_S_xi2_VGP_S+delta_nd*SP_S_xi2_VGP_S_VGP_S)))));
  SP_S_b_VGP_S_VS_BP=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))))))+0.0*((Gf2_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))))+0.5*(+Gf2_VGP_S_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VGP_S*(SP_S_temp1_VS_BP-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP))))+Gf2_VS_BP*(SP_S_temp1_VGP_S-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))+Gf2*(+SP_S_temp1_VGP_S_VS_BP-(+delta_nd_VGP_S_VS_BP*SP_S_xi2+delta_nd_VGP_S*SP_S_xi2_VS_BP+delta_nd_VS_BP*SP_S_xi2_VGP_S+delta_nd*SP_S_xi2_VGP_S_VS_BP)))));
#endif
SP_S_b_VS_BP=(-(0.5*((Gf2_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))))));
#if defined(_DERIVATE2)
  SP_S_b_VS_BP_VD_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VD_S-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))))))+0.0*((Gf2_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))))+0.5*(+Gf2_VS_BP_VD_S*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VS_BP*(SP_S_temp1_VD_S-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S))))+Gf2_VD_S*(SP_S_temp1_VS_BP-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))+Gf2*(+SP_S_temp1_VS_BP_VD_S-(+delta_nd_VS_BP_VD_S*SP_S_xi2+delta_nd_VS_BP*SP_S_xi2_VD_S+delta_nd_VD_S*SP_S_xi2_VS_BP+delta_nd*SP_S_xi2_VS_BP_VD_S)))));
  SP_S_b_VS_BP_VGP_S=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VGP_S-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))))))+0.0*((Gf2_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))))+0.5*(+Gf2_VS_BP_VGP_S*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VS_BP*(SP_S_temp1_VGP_S-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S))))+Gf2_VGP_S*(SP_S_temp1_VS_BP-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))+Gf2*(+SP_S_temp1_VS_BP_VGP_S-(+delta_nd_VS_BP_VGP_S*SP_S_xi2+delta_nd_VS_BP*SP_S_xi2_VGP_S+delta_nd_VGP_S*SP_S_xi2_VS_BP+delta_nd*SP_S_xi2_VS_BP_VGP_S)))));
  SP_S_b_VS_BP_VS_BP=(+0.0-(+0.0*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))+0.0*(((Gf2_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))))))+0.0*((Gf2_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2)))+(Gf2*(SP_S_temp1_VS_BP-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))))+0.5*(+Gf2_VS_BP_VS_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))+Gf2_VS_BP*(SP_S_temp1_VS_BP-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP))))+Gf2_VS_BP*(SP_S_temp1_VS_BP-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))+Gf2*(+SP_S_temp1_VS_BP_VS_BP-(+delta_nd_VS_BP_VS_BP*SP_S_xi2+delta_nd_VS_BP*SP_S_xi2_VS_BP+delta_nd_VS_BP*SP_S_xi2_VS_BP+delta_nd*SP_S_xi2_VS_BP_VS_BP)))));
#endif
#endif
SP_S_b=(1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));
EXIT_IF_ISNAN((1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_c_VD_S=((2.0*SP_S_temp_VD_S)+((Gf2_VD_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))+(Gf2*((-SP_S_temp1_VD_S)-((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S))))));
#if defined(_DERIVATE2)
  SP_S_c_VD_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VD_S)+(+Gf2_VD_S_VD_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VD_S*((-SP_S_temp1_VD_S)-(((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S))))+Gf2_VD_S*((-SP_S_temp1_VD_S)-((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S)))+Gf2*(+(+0.0-SP_S_temp1_VD_S_VD_S)-(+delta_nd_VD_S_VD_S*(1.0+SP_S_xi1)+delta_nd_VD_S*SP_S_xi1_VD_S+delta_nd_VD_S*SP_S_xi1_VD_S+delta_nd*(+0.0+SP_S_xi1_VD_S_VD_S)))));
  SP_S_c_VD_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VGP_S)+(+Gf2_VD_S_VGP_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VD_S*((-SP_S_temp1_VGP_S)-(((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S))))+Gf2_VGP_S*((-SP_S_temp1_VD_S)-((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S)))+Gf2*(+(+0.0-SP_S_temp1_VD_S_VGP_S)-(+delta_nd_VD_S_VGP_S*(1.0+SP_S_xi1)+delta_nd_VD_S*SP_S_xi1_VGP_S+delta_nd_VGP_S*SP_S_xi1_VD_S+delta_nd*(+0.0+SP_S_xi1_VD_S_VGP_S)))));
  SP_S_c_VD_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VS_BP)+(+Gf2_VD_S_VS_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VD_S*((-SP_S_temp1_VS_BP)-(((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP))))+Gf2_VS_BP*((-SP_S_temp1_VD_S)-((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S)))+Gf2*(+(+0.0-SP_S_temp1_VD_S_VS_BP)-(+delta_nd_VD_S_VS_BP*(1.0+SP_S_xi1)+delta_nd_VD_S*SP_S_xi1_VS_BP+delta_nd_VS_BP*SP_S_xi1_VD_S+delta_nd*(+0.0+SP_S_xi1_VD_S_VS_BP)))));
#endif
SP_S_c_VGP_S=((2.0*SP_S_temp_VGP_S)+((Gf2_VGP_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))+(Gf2*((-SP_S_temp1_VGP_S)-((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S))))));
#if defined(_DERIVATE2)
  SP_S_c_VGP_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VD_S)+(+Gf2_VGP_S_VD_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VGP_S*((-SP_S_temp1_VD_S)-(((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S))))+Gf2_VD_S*((-SP_S_temp1_VGP_S)-((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S)))+Gf2*(+(+0.0-SP_S_temp1_VGP_S_VD_S)-(+delta_nd_VGP_S_VD_S*(1.0+SP_S_xi1)+delta_nd_VGP_S*SP_S_xi1_VD_S+delta_nd_VD_S*SP_S_xi1_VGP_S+delta_nd*(+0.0+SP_S_xi1_VGP_S_VD_S)))));
  SP_S_c_VGP_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VGP_S)+(+Gf2_VGP_S_VGP_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VGP_S*((-SP_S_temp1_VGP_S)-(((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S))))+Gf2_VGP_S*((-SP_S_temp1_VGP_S)-((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S)))+Gf2*(+(+0.0-SP_S_temp1_VGP_S_VGP_S)-(+delta_nd_VGP_S_VGP_S*(1.0+SP_S_xi1)+delta_nd_VGP_S*SP_S_xi1_VGP_S+delta_nd_VGP_S*SP_S_xi1_VGP_S+delta_nd*(+0.0+SP_S_xi1_VGP_S_VGP_S)))));
  SP_S_c_VGP_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VS_BP)+(+Gf2_VGP_S_VS_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VGP_S*((-SP_S_temp1_VS_BP)-(((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP))))+Gf2_VS_BP*((-SP_S_temp1_VGP_S)-((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S)))+Gf2*(+(+0.0-SP_S_temp1_VGP_S_VS_BP)-(+delta_nd_VGP_S_VS_BP*(1.0+SP_S_xi1)+delta_nd_VGP_S*SP_S_xi1_VS_BP+delta_nd_VS_BP*SP_S_xi1_VGP_S+delta_nd*(+0.0+SP_S_xi1_VGP_S_VS_BP)))));
#endif
SP_S_c_VS_BP=((2.0*SP_S_temp_VS_BP)+((Gf2_VS_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))+(Gf2*((-SP_S_temp1_VS_BP)-((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP))))));
#if defined(_DERIVATE2)
  SP_S_c_VS_BP_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VD_S)+(+Gf2_VS_BP_VD_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VS_BP*((-SP_S_temp1_VD_S)-(((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S))))+Gf2_VD_S*((-SP_S_temp1_VS_BP)-((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP)))+Gf2*(+(+0.0-SP_S_temp1_VS_BP_VD_S)-(+delta_nd_VS_BP_VD_S*(1.0+SP_S_xi1)+delta_nd_VS_BP*SP_S_xi1_VD_S+delta_nd_VD_S*SP_S_xi1_VS_BP+delta_nd*(+0.0+SP_S_xi1_VS_BP_VD_S)))));
  SP_S_c_VS_BP_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VGP_S)+(+Gf2_VS_BP_VGP_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VS_BP*((-SP_S_temp1_VGP_S)-(((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S))))+Gf2_VGP_S*((-SP_S_temp1_VS_BP)-((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP)))+Gf2*(+(+0.0-SP_S_temp1_VS_BP_VGP_S)-(+delta_nd_VS_BP_VGP_S*(1.0+SP_S_xi1)+delta_nd_VS_BP*SP_S_xi1_VGP_S+delta_nd_VGP_S*SP_S_xi1_VS_BP+delta_nd*(+0.0+SP_S_xi1_VS_BP_VGP_S)))));
  SP_S_c_VS_BP_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VS_BP)+(+Gf2_VS_BP_VS_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VS_BP*((-SP_S_temp1_VS_BP)-(((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP))))+Gf2_VS_BP*((-SP_S_temp1_VS_BP)-((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP)))+Gf2*(+(+0.0-SP_S_temp1_VS_BP_VS_BP)-(+delta_nd_VS_BP_VS_BP*(1.0+SP_S_xi1)+delta_nd_VS_BP*SP_S_xi1_VS_BP+delta_nd_VS_BP*SP_S_xi1_VS_BP+delta_nd*(+0.0+SP_S_xi1_VS_BP_VS_BP)))));
#endif
#endif
SP_S_c=((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
EXIT_IF_ISNAN(((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1))))))
{
double m00_logE(d00_logE0,(SP_S_a/Gf2))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(SP_S_a/Gf2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_tau_VD_S=((xn_d_VD_S-SP_S_eta_VD_S)+((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VD_S_VD_S=(+(+xn_d_VD_S_VD_S-SP_S_eta_VD_S_VD_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VD_S_VD_S/Gf2-(SP_S_a_VD_S*Gf2_VD_S+SP_S_a_VD_S*Gf2_VD_S+SP_S_a*Gf2_VD_S_VD_S)/Gf2/Gf2+2*SP_S_a*Gf2_VD_S*Gf2_VD_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VD_S_VGP_S=(+(+xn_d_VD_S_VGP_S-SP_S_eta_VD_S_VGP_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VD_S_VGP_S/Gf2-(SP_S_a_VD_S*Gf2_VGP_S+SP_S_a_VGP_S*Gf2_VD_S+SP_S_a*Gf2_VD_S_VGP_S)/Gf2/Gf2+2*SP_S_a*Gf2_VD_S*Gf2_VGP_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VD_S_VS_BP=(+(+xn_d_VD_S_VS_BP-SP_S_eta_VD_S_VS_BP)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VD_S_VS_BP/Gf2-(SP_S_a_VD_S*Gf2_VS_BP+SP_S_a_VS_BP*Gf2_VD_S+SP_S_a*Gf2_VD_S_VS_BP)/Gf2/Gf2+2*SP_S_a*Gf2_VD_S*Gf2_VS_BP/Gf2/Gf2/Gf2)));
#endif
SP_S_tau_VGP_S=((xn_d_VGP_S-SP_S_eta_VGP_S)+((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VGP_S_VD_S=(+(+xn_d_VGP_S_VD_S-SP_S_eta_VGP_S_VD_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VGP_S_VD_S/Gf2-(SP_S_a_VGP_S*Gf2_VD_S+SP_S_a_VD_S*Gf2_VGP_S+SP_S_a*Gf2_VGP_S_VD_S)/Gf2/Gf2+2*SP_S_a*Gf2_VGP_S*Gf2_VD_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VGP_S_VGP_S=(+(+xn_d_VGP_S_VGP_S-SP_S_eta_VGP_S_VGP_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VGP_S_VGP_S/Gf2-(SP_S_a_VGP_S*Gf2_VGP_S+SP_S_a_VGP_S*Gf2_VGP_S+SP_S_a*Gf2_VGP_S_VGP_S)/Gf2/Gf2+2*SP_S_a*Gf2_VGP_S*Gf2_VGP_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VGP_S_VS_BP=(+(+xn_d_VGP_S_VS_BP-SP_S_eta_VGP_S_VS_BP)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)+d10_logE0*(SP_S_a_VGP_S_VS_BP/Gf2-(SP_S_a_VGP_S*Gf2_VS_BP+SP_S_a_VS_BP*Gf2_VGP_S+SP_S_a*Gf2_VGP_S_VS_BP)/Gf2/Gf2+2*SP_S_a*Gf2_VGP_S*Gf2_VS_BP/Gf2/Gf2/Gf2)));
#endif
SP_S_tau_VS_BP=((xn_d_VS_BP-SP_S_eta_VS_BP)+((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)*d10_logE0);
#if defined(_DERIVATE2)
  SP_S_tau_VS_BP_VD_S=(+(+xn_d_VS_BP_VD_S-SP_S_eta_VS_BP_VD_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VD_S*Gf2-SP_S_a*Gf2_VD_S)/Gf2/Gf2)*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)+d10_logE0*(SP_S_a_VS_BP_VD_S/Gf2-(SP_S_a_VS_BP*Gf2_VD_S+SP_S_a_VD_S*Gf2_VS_BP+SP_S_a*Gf2_VS_BP_VD_S)/Gf2/Gf2+2*SP_S_a*Gf2_VS_BP*Gf2_VD_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VS_BP_VGP_S=(+(+xn_d_VS_BP_VGP_S-SP_S_eta_VS_BP_VGP_S)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VGP_S*Gf2-SP_S_a*Gf2_VGP_S)/Gf2/Gf2)*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)+d10_logE0*(SP_S_a_VS_BP_VGP_S/Gf2-(SP_S_a_VS_BP*Gf2_VGP_S+SP_S_a_VGP_S*Gf2_VS_BP+SP_S_a*Gf2_VS_BP_VGP_S)/Gf2/Gf2+2*SP_S_a*Gf2_VS_BP*Gf2_VGP_S/Gf2/Gf2/Gf2)));
  SP_S_tau_VS_BP_VS_BP=(+(+xn_d_VS_BP_VS_BP-SP_S_eta_VS_BP_VS_BP)+(m20_logE((SP_S_a/Gf2))*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)*((SP_S_a_VS_BP*Gf2-SP_S_a*Gf2_VS_BP)/Gf2/Gf2)+d10_logE0*(SP_S_a_VS_BP_VS_BP/Gf2-(SP_S_a_VS_BP*Gf2_VS_BP+SP_S_a_VS_BP*Gf2_VS_BP+SP_S_a*Gf2_VS_BP_VS_BP)/Gf2/Gf2+2*SP_S_a*Gf2_VS_BP*Gf2_VS_BP/Gf2/Gf2/Gf2)));
#endif
#endif
SP_S_tau=((xn_d-SP_S_eta)+d00_logE0);
EXIT_IF_ISNAN(((xn_d-SP_S_eta)+d00_logE0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
nu_VD_S=(SP_S_a_VD_S+SP_S_c_VD_S);
#if defined(_DERIVATE2)
  nu_VD_S_VD_S=(+SP_S_a_VD_S_VD_S+SP_S_c_VD_S_VD_S);
  nu_VD_S_VGP_S=(+SP_S_a_VD_S_VGP_S+SP_S_c_VD_S_VGP_S);
  nu_VD_S_VS_BP=(+SP_S_a_VD_S_VS_BP+SP_S_c_VD_S_VS_BP);
#endif
nu_VGP_S=(SP_S_a_VGP_S+SP_S_c_VGP_S);
#if defined(_DERIVATE2)
  nu_VGP_S_VD_S=(+SP_S_a_VGP_S_VD_S+SP_S_c_VGP_S_VD_S);
  nu_VGP_S_VGP_S=(+SP_S_a_VGP_S_VGP_S+SP_S_c_VGP_S_VGP_S);
  nu_VGP_S_VS_BP=(+SP_S_a_VGP_S_VS_BP+SP_S_c_VGP_S_VS_BP);
#endif
nu_VS_BP=(SP_S_a_VS_BP+SP_S_c_VS_BP);
#if defined(_DERIVATE2)
  nu_VS_BP_VD_S=(+SP_S_a_VS_BP_VD_S+SP_S_c_VS_BP_VD_S);
  nu_VS_BP_VGP_S=(+SP_S_a_VS_BP_VGP_S+SP_S_c_VS_BP_VGP_S);
  nu_VS_BP_VS_BP=(+SP_S_a_VS_BP_VS_BP+SP_S_c_VS_BP_VS_BP);
#endif
#endif
nu=(SP_S_a+SP_S_c);
EXIT_IF_ISNAN((SP_S_a+SP_S_c))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
mutau_VD_S=(((nu_VD_S*nu)+(nu*nu_VD_S))+((SP_S_tau_VD_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))+(SP_S_tau*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))));
#if defined(_DERIVATE2)
  mutau_VD_S_VD_S=(+(+nu_VD_S_VD_S*nu+nu_VD_S*nu_VD_S+nu_VD_S*nu_VD_S+nu*nu_VD_S_VD_S)+(+SP_S_tau_VD_S_VD_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+SP_S_tau_VD_S*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VD_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VD_S))-(+SP_S_a_VD_S_VD_S*SP_S_b+SP_S_a_VD_S*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VD_S))));
  mutau_VD_S_VGP_S=(+(+nu_VD_S_VGP_S*nu+nu_VD_S*nu_VGP_S+nu_VGP_S*nu_VD_S+nu*nu_VD_S_VGP_S)+(+SP_S_tau_VD_S_VGP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+SP_S_tau_VGP_S*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VGP_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VGP_S))-(+SP_S_a_VD_S_VGP_S*SP_S_b+SP_S_a_VD_S*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VGP_S))));
  mutau_VD_S_VS_BP=(+(+nu_VD_S_VS_BP*nu+nu_VD_S*nu_VS_BP+nu_VS_BP*nu_VD_S+nu*nu_VD_S_VS_BP)+(+SP_S_tau_VD_S_VS_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VD_S*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+SP_S_tau_VS_BP*((0.5*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))+0.5*(+SP_S_c_VD_S_VS_BP*SP_S_c+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VS_BP))-(+SP_S_a_VD_S_VS_BP*SP_S_b+SP_S_a_VD_S*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VS_BP))));
#endif
mutau_VGP_S=(((nu_VGP_S*nu)+(nu*nu_VGP_S))+((SP_S_tau_VGP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))+(SP_S_tau*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))));
#if defined(_DERIVATE2)
  mutau_VGP_S_VD_S=(+(+nu_VGP_S_VD_S*nu+nu_VGP_S*nu_VD_S+nu_VD_S*nu_VGP_S+nu*nu_VGP_S_VD_S)+(+SP_S_tau_VGP_S_VD_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+SP_S_tau_VD_S*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VD_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VD_S))-(+SP_S_a_VGP_S_VD_S*SP_S_b+SP_S_a_VGP_S*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VD_S))));
  mutau_VGP_S_VGP_S=(+(+nu_VGP_S_VGP_S*nu+nu_VGP_S*nu_VGP_S+nu_VGP_S*nu_VGP_S+nu*nu_VGP_S_VGP_S)+(+SP_S_tau_VGP_S_VGP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+SP_S_tau_VGP_S*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VGP_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VGP_S))-(+SP_S_a_VGP_S_VGP_S*SP_S_b+SP_S_a_VGP_S*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VGP_S))));
  mutau_VGP_S_VS_BP=(+(+nu_VGP_S_VS_BP*nu+nu_VGP_S*nu_VS_BP+nu_VS_BP*nu_VGP_S+nu*nu_VGP_S_VS_BP)+(+SP_S_tau_VGP_S_VS_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VGP_S*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+SP_S_tau_VS_BP*((0.5*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))+0.5*(+SP_S_c_VGP_S_VS_BP*SP_S_c+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VS_BP))-(+SP_S_a_VGP_S_VS_BP*SP_S_b+SP_S_a_VGP_S*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VS_BP))));
#endif
mutau_VS_BP=(((nu_VS_BP*nu)+(nu*nu_VS_BP))+((SP_S_tau_VS_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))+(SP_S_tau*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))));
#if defined(_DERIVATE2)
  mutau_VS_BP_VD_S=(+(+nu_VS_BP_VD_S*nu+nu_VS_BP*nu_VD_S+nu_VD_S*nu_VS_BP+nu*nu_VS_BP_VD_S)+(+SP_S_tau_VS_BP_VD_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))))-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+SP_S_tau_VD_S*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VD_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VD_S))-(+SP_S_a_VS_BP_VD_S*SP_S_b+SP_S_a_VS_BP*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VD_S))));
  mutau_VS_BP_VGP_S=(+(+nu_VS_BP_VGP_S*nu+nu_VS_BP*nu_VGP_S+nu_VGP_S*nu_VS_BP+nu*nu_VS_BP_VGP_S)+(+SP_S_tau_VS_BP_VGP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))))-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+SP_S_tau_VGP_S*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VGP_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VGP_S))-(+SP_S_a_VS_BP_VGP_S*SP_S_b+SP_S_a_VS_BP*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VGP_S))));
  mutau_VS_BP_VS_BP=(+(+nu_VS_BP_VS_BP*nu+nu_VS_BP*nu_VS_BP+nu_VS_BP*nu_VS_BP+nu*nu_VS_BP_VS_BP)+(+SP_S_tau_VS_BP_VS_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))+SP_S_tau_VS_BP*(((0.5*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))))-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+SP_S_tau_VS_BP*((0.5*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+SP_S_tau*(+(+0.0*(SP_S_c*SP_S_c)+0.0*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))+0.0*((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))+0.5*(+SP_S_c_VS_BP_VS_BP*SP_S_c+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VS_BP))-(+SP_S_a_VS_BP_VS_BP*SP_S_b+SP_S_a_VS_BP*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VS_BP))));
#endif
#endif
mutau=((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
EXIT_IF_ISNAN(((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b)))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_x0_VD_S=(SP_S_eta_VD_S+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#if defined(_DERIVATE2)
  SP_S_x0_VD_S_VD_S=(+SP_S_eta_VD_S_VD_S+((+(+SP_S_a_VD_S_VD_S*nu+SP_S_a_VD_S*nu_VD_S+SP_S_a_VD_S*nu_VD_S+SP_S_a*nu_VD_S_VD_S)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VD_S+(+(+(+(+(nu_VD_S_VD_S/mutau-(nu_VD_S*mutau_VD_S+nu_VD_S*mutau_VD_S+nu*mutau_VD_S_VD_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VD_S)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VD_S)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VD_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VD_S)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VD_S_VD_S*SP_S_b+SP_S_a_VD_S*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VD_S_VGP_S=(+SP_S_eta_VD_S_VGP_S+((+(+SP_S_a_VD_S_VGP_S*nu+SP_S_a_VD_S*nu_VGP_S+SP_S_a_VGP_S*nu_VD_S+SP_S_a*nu_VD_S_VGP_S)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VGP_S+(+(+(+(+(nu_VD_S_VGP_S/mutau-(nu_VD_S*mutau_VGP_S+nu_VGP_S*mutau_VD_S+nu*mutau_VD_S_VGP_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VGP_S)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VGP_S)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VGP_S*SP_S_c+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VGP_S)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VD_S_VGP_S*SP_S_b+SP_S_a_VD_S*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VD_S_VS_BP=(+SP_S_eta_VD_S_VS_BP+((+(+SP_S_a_VD_S_VS_BP*nu+SP_S_a_VD_S*nu_VS_BP+SP_S_a_VS_BP*nu_VD_S+SP_S_a*nu_VD_S_VS_BP)*SP_S_tau+((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VD_S+(SP_S_a*nu)*SP_S_tau_VD_S_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VD_S_VS_BP+(+(+(+(+(nu_VD_S_VS_BP/mutau-(nu_VD_S*mutau_VS_BP+nu_VS_BP*mutau_VD_S+nu*mutau_VD_S_VS_BP)/mutau/mutau+2*nu*mutau_VD_S*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VD_S+(nu/mutau)*SP_S_tau_VD_S_VS_BP)*SP_S_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VD_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S_VS_BP)*SP_S_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VD_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VD_S_VS_BP*SP_S_c+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c*SP_S_c_VD_S_VS_BP)*3.3333333333333333e-01+((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VD_S_VS_BP*SP_S_b+SP_S_a_VD_S*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VD_S+SP_S_a*SP_S_b_VD_S_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S))*3.3333333333333333e-01-((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#endif
SP_S_x0_VGP_S=(SP_S_eta_VGP_S+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#if defined(_DERIVATE2)
  SP_S_x0_VGP_S_VD_S=(+SP_S_eta_VGP_S_VD_S+((+(+SP_S_a_VGP_S_VD_S*nu+SP_S_a_VGP_S*nu_VD_S+SP_S_a_VD_S*nu_VGP_S+SP_S_a*nu_VGP_S_VD_S)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VD_S+(+(+(+(+(nu_VGP_S_VD_S/mutau-(nu_VGP_S*mutau_VD_S+nu_VD_S*mutau_VGP_S+nu*mutau_VGP_S_VD_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VD_S)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VD_S)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VD_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VD_S)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VGP_S_VD_S*SP_S_b+SP_S_a_VGP_S*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VGP_S_VGP_S=(+SP_S_eta_VGP_S_VGP_S+((+(+SP_S_a_VGP_S_VGP_S*nu+SP_S_a_VGP_S*nu_VGP_S+SP_S_a_VGP_S*nu_VGP_S+SP_S_a*nu_VGP_S_VGP_S)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VGP_S+(+(+(+(+(nu_VGP_S_VGP_S/mutau-(nu_VGP_S*mutau_VGP_S+nu_VGP_S*mutau_VGP_S+nu*mutau_VGP_S_VGP_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VGP_S)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VGP_S)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VGP_S*SP_S_c+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VGP_S)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VGP_S_VGP_S*SP_S_b+SP_S_a_VGP_S*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VGP_S_VS_BP=(+SP_S_eta_VGP_S_VS_BP+((+(+SP_S_a_VGP_S_VS_BP*nu+SP_S_a_VGP_S*nu_VS_BP+SP_S_a_VS_BP*nu_VGP_S+SP_S_a*nu_VGP_S_VS_BP)*SP_S_tau+((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VGP_S+(SP_S_a*nu)*SP_S_tau_VGP_S_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VGP_S_VS_BP+(+(+(+(+(nu_VGP_S_VS_BP/mutau-(nu_VGP_S*mutau_VS_BP+nu_VS_BP*mutau_VGP_S+nu*mutau_VGP_S_VS_BP)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VGP_S+(nu/mutau)*SP_S_tau_VGP_S_VS_BP)*SP_S_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VGP_S+((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S_VS_BP)*SP_S_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VGP_S+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VGP_S_VS_BP*SP_S_c+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c*SP_S_c_VGP_S_VS_BP)*3.3333333333333333e-01+((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VGP_S_VS_BP*SP_S_b+SP_S_a_VGP_S*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VGP_S+SP_S_a*SP_S_b_VGP_S_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S))*3.3333333333333333e-01-((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#endif
SP_S_x0_VS_BP=(SP_S_eta_VS_BP+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#if defined(_DERIVATE2)
  SP_S_x0_VS_BP_VD_S=(+SP_S_eta_VS_BP_VD_S+((+(+SP_S_a_VS_BP_VD_S*nu+SP_S_a_VS_BP*nu_VD_S+SP_S_a_VD_S*nu_VS_BP+SP_S_a*nu_VS_BP_VD_S)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VD_S+(((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VD_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))+((((((SP_S_a_VD_S*nu)+(SP_S_a*nu_VD_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VD_S)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VD_S+(+(+(+(+(nu_VS_BP_VD_S/mutau-(nu_VS_BP*mutau_VD_S+nu_VD_S*mutau_VS_BP+nu*mutau_VS_BP_VD_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VD_S/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VD_S)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VD_S)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VD_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VD_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VD_S+SP_S_c_VD_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VD_S)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VS_BP_VD_S*SP_S_b+SP_S_a_VS_BP*SP_S_b_VD_S+SP_S_a_VD_S*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VD_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VD_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VD_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VD_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VD_S*SP_S_c)+(SP_S_c*SP_S_c_VD_S)))*3.3333333333333333e-01)-(((SP_S_a_VD_S*SP_S_b)+(SP_S_a*SP_S_b_VD_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VS_BP_VGP_S=(+SP_S_eta_VS_BP_VGP_S+((+(+SP_S_a_VS_BP_VGP_S*nu+SP_S_a_VS_BP*nu_VGP_S+SP_S_a_VGP_S*nu_VS_BP+SP_S_a*nu_VS_BP_VGP_S)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VGP_S+(((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VGP_S)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))+((((((SP_S_a_VGP_S*nu)+(SP_S_a*nu_VGP_S)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VGP_S)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VGP_S+(+(+(+(+(nu_VS_BP_VGP_S/mutau-(nu_VS_BP*mutau_VGP_S+nu_VGP_S*mutau_VS_BP+nu*mutau_VS_BP_VGP_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VGP_S/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VGP_S)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VGP_S)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VGP_S)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VGP_S*SP_S_c+SP_S_c_VS_BP*SP_S_c_VGP_S+SP_S_c_VGP_S*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VGP_S)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VS_BP_VGP_S*SP_S_b+SP_S_a_VS_BP*SP_S_b_VGP_S+SP_S_a_VGP_S*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VGP_S)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VGP_S)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VGP_S)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VGP_S)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VGP_S*SP_S_c)+(SP_S_c*SP_S_c_VGP_S)))*3.3333333333333333e-01)-(((SP_S_a_VGP_S*SP_S_b)+(SP_S_a*SP_S_b_VGP_S))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
  SP_S_x0_VS_BP_VS_BP=(+SP_S_eta_VS_BP_VS_BP+((+(+SP_S_a_VS_BP_VS_BP*nu+SP_S_a_VS_BP*nu_VS_BP+SP_S_a_VS_BP*nu_VS_BP+SP_S_a*nu_VS_BP_VS_BP)*SP_S_tau+((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau_VS_BP+(((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau_VS_BP+(SP_S_a*nu)*SP_S_tau_VS_BP_VS_BP)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))-(((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))+((((((SP_S_a_VS_BP*nu)+(SP_S_a*nu_VS_BP)))*SP_S_tau)+((SP_S_a*nu)*SP_S_tau_VS_BP)))*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))+((SP_S_a*nu)*SP_S_tau)*(+mutau_VS_BP_VS_BP+(+(+(+(+(nu_VS_BP_VS_BP/mutau-(nu_VS_BP*mutau_VS_BP+nu_VS_BP*mutau_VS_BP+nu*mutau_VS_BP_VS_BP)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VS_BP/mutau/mutau/mutau)*SP_S_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau_VS_BP+(nu/mutau)*SP_S_tau_VS_BP_VS_BP)*SP_S_tau+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau_VS_BP+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau_VS_BP+((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP_VS_BP)*SP_S_c+((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c_VS_BP+(((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP_VS_BP)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))+(((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP)))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(+(+(+SP_S_c_VS_BP_VS_BP*SP_S_c+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c_VS_BP*SP_S_c_VS_BP+SP_S_c*SP_S_c_VS_BP_VS_BP)*3.3333333333333333e-01+((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*0.0+(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*0.0+(SP_S_c*SP_S_c)*0.0)-(+SP_S_a_VS_BP_VS_BP*SP_S_b+SP_S_a_VS_BP*SP_S_b_VS_BP+SP_S_a_VS_BP*SP_S_b_VS_BP+SP_S_a*SP_S_b_VS_BP_VS_BP)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))+2*((SP_S_a*nu)*SP_S_tau)*(mutau_VS_BP+((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP))*3.3333333333333333e-01-((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))*(mutau_VS_BP+((((((((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_S_tau)+((nu/mutau)*SP_S_tau_VS_BP)))*SP_S_tau)+(((nu/mutau)*SP_S_tau)*SP_S_tau_VS_BP)))*SP_S_c)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c_VS_BP)))*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((((SP_S_c_VS_BP*SP_S_c)+(SP_S_c*SP_S_c_VS_BP)))*3.3333333333333333e-01)-(((SP_S_a_VS_BP*SP_S_b)+(SP_S_a*SP_S_b_VS_BP))))))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
#endif
#endif
SP_S_x0=(SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
EXIT_IF_ISNAN((SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))))
if
((SP_S_x0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,SP_S_x0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=SP_S_x0_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(m20_exp(SP_S_x0)*SP_S_x0_VD_S*SP_S_x0_VD_S+d10_exp0*SP_S_x0_VD_S_VD_S);
  SP_S_delta0_VD_S_VGP_S=(m20_exp(SP_S_x0)*SP_S_x0_VGP_S*SP_S_x0_VD_S+d10_exp0*SP_S_x0_VD_S_VGP_S);
  SP_S_delta0_VD_S_VS_BP=(m20_exp(SP_S_x0)*SP_S_x0_VS_BP*SP_S_x0_VD_S+d10_exp0*SP_S_x0_VD_S_VS_BP);
#endif
SP_S_delta0_VGP_S=SP_S_x0_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(m20_exp(SP_S_x0)*SP_S_x0_VD_S*SP_S_x0_VGP_S+d10_exp0*SP_S_x0_VGP_S_VD_S);
  SP_S_delta0_VGP_S_VGP_S=(m20_exp(SP_S_x0)*SP_S_x0_VGP_S*SP_S_x0_VGP_S+d10_exp0*SP_S_x0_VGP_S_VGP_S);
  SP_S_delta0_VGP_S_VS_BP=(m20_exp(SP_S_x0)*SP_S_x0_VS_BP*SP_S_x0_VGP_S+d10_exp0*SP_S_x0_VGP_S_VS_BP);
#endif
SP_S_delta0_VS_BP=SP_S_x0_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(m20_exp(SP_S_x0)*SP_S_x0_VD_S*SP_S_x0_VS_BP+d10_exp0*SP_S_x0_VS_BP_VD_S);
  SP_S_delta0_VS_BP_VGP_S=(m20_exp(SP_S_x0)*SP_S_x0_VGP_S*SP_S_x0_VS_BP+d10_exp0*SP_S_x0_VS_BP_VGP_S);
  SP_S_delta0_VS_BP_VS_BP=(m20_exp(SP_S_x0)*SP_S_x0_VS_BP*SP_S_x0_VS_BP+d10_exp0*SP_S_x0_VS_BP_VS_BP);
#endif
#endif
SP_S_delta0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta1_VD_S=(-SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VD_S_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VD_S+1.0*SP_S_delta0_VD_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VD_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VGP_S=(-SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VGP_S_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VGP_S+1.0*SP_S_delta0_VGP_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VGP_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VS_BP=(-SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VS_BP_VD_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VD_S+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VD_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VGP_S=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VGP_S+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VGP_S)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VS_BP=(0.0/SP_S_delta0-(0.0*SP_S_delta0_VS_BP+0.0*SP_S_delta0_VS_BP+1.0*SP_S_delta0_VS_BP_VS_BP)/SP_S_delta0/SP_S_delta0+2*1.0*SP_S_delta0_VS_BP*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
#endif
SP_S_delta1=(1.0/SP_S_delta0);
EXIT_IF_ISNAN((1.0/SP_S_delta0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=((delta_nd_VD_S*SP_S_delta0)+(delta_nd*SP_S_delta0_VD_S));
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(+delta_nd_VD_S_VD_S*SP_S_delta0+delta_nd_VD_S*SP_S_delta0_VD_S+delta_nd_VD_S*SP_S_delta0_VD_S+delta_nd*SP_S_delta0_VD_S_VD_S);
  SP_S_delta0_VD_S_VGP_S=(+delta_nd_VD_S_VGP_S*SP_S_delta0+delta_nd_VD_S*SP_S_delta0_VGP_S+delta_nd_VGP_S*SP_S_delta0_VD_S+delta_nd*SP_S_delta0_VD_S_VGP_S);
  SP_S_delta0_VD_S_VS_BP=(+delta_nd_VD_S_VS_BP*SP_S_delta0+delta_nd_VD_S*SP_S_delta0_VS_BP+delta_nd_VS_BP*SP_S_delta0_VD_S+delta_nd*SP_S_delta0_VD_S_VS_BP);
#endif
SP_S_delta0_VGP_S=((delta_nd_VGP_S*SP_S_delta0)+(delta_nd*SP_S_delta0_VGP_S));
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(+delta_nd_VGP_S_VD_S*SP_S_delta0+delta_nd_VGP_S*SP_S_delta0_VD_S+delta_nd_VD_S*SP_S_delta0_VGP_S+delta_nd*SP_S_delta0_VGP_S_VD_S);
  SP_S_delta0_VGP_S_VGP_S=(+delta_nd_VGP_S_VGP_S*SP_S_delta0+delta_nd_VGP_S*SP_S_delta0_VGP_S+delta_nd_VGP_S*SP_S_delta0_VGP_S+delta_nd*SP_S_delta0_VGP_S_VGP_S);
  SP_S_delta0_VGP_S_VS_BP=(+delta_nd_VGP_S_VS_BP*SP_S_delta0+delta_nd_VGP_S*SP_S_delta0_VS_BP+delta_nd_VS_BP*SP_S_delta0_VGP_S+delta_nd*SP_S_delta0_VGP_S_VS_BP);
#endif
SP_S_delta0_VS_BP=((delta_nd_VS_BP*SP_S_delta0)+(delta_nd*SP_S_delta0_VS_BP));
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(+delta_nd_VS_BP_VD_S*SP_S_delta0+delta_nd_VS_BP*SP_S_delta0_VD_S+delta_nd_VD_S*SP_S_delta0_VS_BP+delta_nd*SP_S_delta0_VS_BP_VD_S);
  SP_S_delta0_VS_BP_VGP_S=(+delta_nd_VS_BP_VGP_S*SP_S_delta0+delta_nd_VS_BP*SP_S_delta0_VGP_S+delta_nd_VGP_S*SP_S_delta0_VS_BP+delta_nd*SP_S_delta0_VS_BP_VGP_S);
  SP_S_delta0_VS_BP_VS_BP=(+delta_nd_VS_BP_VS_BP*SP_S_delta0+delta_nd_VS_BP*SP_S_delta0_VS_BP+delta_nd_VS_BP*SP_S_delta0_VS_BP+delta_nd*SP_S_delta0_VS_BP_VS_BP);
#endif
#endif
SP_S_delta0=(delta_nd*SP_S_delta0);
EXIT_IF_ISNAN((delta_nd*SP_S_delta0))
}
else
{
if
((SP_S_x0>(xn_d-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(SP_S_x0-xn_d))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=(SP_S_x0_VD_S-xn_d_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VD_S-xn_d_VD_S)*(SP_S_x0_VD_S-xn_d_VD_S)+d10_exp0*(+SP_S_x0_VD_S_VD_S-xn_d_VD_S_VD_S));
  SP_S_delta0_VD_S_VGP_S=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VGP_S-xn_d_VGP_S)*(SP_S_x0_VD_S-xn_d_VD_S)+d10_exp0*(+SP_S_x0_VD_S_VGP_S-xn_d_VD_S_VGP_S));
  SP_S_delta0_VD_S_VS_BP=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VS_BP-xn_d_VS_BP)*(SP_S_x0_VD_S-xn_d_VD_S)+d10_exp0*(+SP_S_x0_VD_S_VS_BP-xn_d_VD_S_VS_BP));
#endif
SP_S_delta0_VGP_S=(SP_S_x0_VGP_S-xn_d_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VD_S-xn_d_VD_S)*(SP_S_x0_VGP_S-xn_d_VGP_S)+d10_exp0*(+SP_S_x0_VGP_S_VD_S-xn_d_VGP_S_VD_S));
  SP_S_delta0_VGP_S_VGP_S=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VGP_S-xn_d_VGP_S)*(SP_S_x0_VGP_S-xn_d_VGP_S)+d10_exp0*(+SP_S_x0_VGP_S_VGP_S-xn_d_VGP_S_VGP_S));
  SP_S_delta0_VGP_S_VS_BP=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VS_BP-xn_d_VS_BP)*(SP_S_x0_VGP_S-xn_d_VGP_S)+d10_exp0*(+SP_S_x0_VGP_S_VS_BP-xn_d_VGP_S_VS_BP));
#endif
SP_S_delta0_VS_BP=(SP_S_x0_VS_BP-xn_d_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VD_S-xn_d_VD_S)*(SP_S_x0_VS_BP-xn_d_VS_BP)+d10_exp0*(+SP_S_x0_VS_BP_VD_S-xn_d_VS_BP_VD_S));
  SP_S_delta0_VS_BP_VGP_S=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VGP_S-xn_d_VGP_S)*(SP_S_x0_VS_BP-xn_d_VS_BP)+d10_exp0*(+SP_S_x0_VS_BP_VGP_S-xn_d_VS_BP_VGP_S));
  SP_S_delta0_VS_BP_VS_BP=(m20_exp((SP_S_x0-xn_d))*(SP_S_x0_VS_BP-xn_d_VS_BP)*(SP_S_x0_VS_BP-xn_d_VS_BP)+d10_exp0*(+SP_S_x0_VS_BP_VS_BP-xn_d_VS_BP_VS_BP));
#endif
#endif
SP_S_delta0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta1_VD_S=((delta_nd_VD_S*SP_S_delta0-delta_nd*SP_S_delta0_VD_S)/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VD_S_VD_S=(delta_nd_VD_S_VD_S/SP_S_delta0-(delta_nd_VD_S*SP_S_delta0_VD_S+delta_nd_VD_S*SP_S_delta0_VD_S+delta_nd*SP_S_delta0_VD_S_VD_S)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VD_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VGP_S=(delta_nd_VD_S_VGP_S/SP_S_delta0-(delta_nd_VD_S*SP_S_delta0_VGP_S+delta_nd_VGP_S*SP_S_delta0_VD_S+delta_nd*SP_S_delta0_VD_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VD_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VD_S_VS_BP=(delta_nd_VD_S_VS_BP/SP_S_delta0-(delta_nd_VD_S*SP_S_delta0_VS_BP+delta_nd_VS_BP*SP_S_delta0_VD_S+delta_nd*SP_S_delta0_VD_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VD_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VGP_S=((delta_nd_VGP_S*SP_S_delta0-delta_nd*SP_S_delta0_VGP_S)/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VGP_S_VD_S=(delta_nd_VGP_S_VD_S/SP_S_delta0-(delta_nd_VGP_S*SP_S_delta0_VD_S+delta_nd_VD_S*SP_S_delta0_VGP_S+delta_nd*SP_S_delta0_VGP_S_VD_S)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VGP_S*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VGP_S=(delta_nd_VGP_S_VGP_S/SP_S_delta0-(delta_nd_VGP_S*SP_S_delta0_VGP_S+delta_nd_VGP_S*SP_S_delta0_VGP_S+delta_nd*SP_S_delta0_VGP_S_VGP_S)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VGP_S*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VGP_S_VS_BP=(delta_nd_VGP_S_VS_BP/SP_S_delta0-(delta_nd_VGP_S*SP_S_delta0_VS_BP+delta_nd_VS_BP*SP_S_delta0_VGP_S+delta_nd*SP_S_delta0_VGP_S_VS_BP)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VGP_S*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
SP_S_delta1_VS_BP=((delta_nd_VS_BP*SP_S_delta0-delta_nd*SP_S_delta0_VS_BP)/SP_S_delta0/SP_S_delta0);
#if defined(_DERIVATE2)
  SP_S_delta1_VS_BP_VD_S=(delta_nd_VS_BP_VD_S/SP_S_delta0-(delta_nd_VS_BP*SP_S_delta0_VD_S+delta_nd_VD_S*SP_S_delta0_VS_BP+delta_nd*SP_S_delta0_VS_BP_VD_S)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VS_BP*SP_S_delta0_VD_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VGP_S=(delta_nd_VS_BP_VGP_S/SP_S_delta0-(delta_nd_VS_BP*SP_S_delta0_VGP_S+delta_nd_VGP_S*SP_S_delta0_VS_BP+delta_nd*SP_S_delta0_VS_BP_VGP_S)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VS_BP*SP_S_delta0_VGP_S/SP_S_delta0/SP_S_delta0/SP_S_delta0);
  SP_S_delta1_VS_BP_VS_BP=(delta_nd_VS_BP_VS_BP/SP_S_delta0-(delta_nd_VS_BP*SP_S_delta0_VS_BP+delta_nd_VS_BP*SP_S_delta0_VS_BP+delta_nd*SP_S_delta0_VS_BP_VS_BP)/SP_S_delta0/SP_S_delta0+2*delta_nd*SP_S_delta0_VS_BP*SP_S_delta0_VS_BP/SP_S_delta0/SP_S_delta0/SP_S_delta0);
#endif
#endif
SP_S_delta1=(delta_nd/SP_S_delta0);
EXIT_IF_ISNAN((delta_nd/SP_S_delta0))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta0_VD_S=(-1.0e-100*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VD_S_VD_S=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VD_S_VD_S-SP_S_x0_VD_S_VD_S)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VD_S-SP_S_x0_VD_S)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))))+(xn_d_VD_S-SP_S_x0_VD_S)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VD_S_VD_S-SP_S_x0_VD_S_VD_S)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VD_S-SP_S_x0_VD_S)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)+(xn_d_VD_S-SP_S_x0_VD_S)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VD_S_VD_S-SP_S_x0_VD_S_VD_S)-0.0)*3.3333333333333333e-01+(xn_d_VD_S-SP_S_x0_VD_S)*0.0+(xn_d_VD_S-SP_S_x0_VD_S)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VD_S_VGP_S=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VD_S_VGP_S-SP_S_x0_VD_S_VGP_S)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VD_S-SP_S_x0_VD_S)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))))))+(xn_d_VGP_S-SP_S_x0_VGP_S)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VD_S_VGP_S-SP_S_x0_VD_S_VGP_S)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VD_S-SP_S_x0_VD_S)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)+(xn_d_VGP_S-SP_S_x0_VGP_S)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VD_S_VGP_S-SP_S_x0_VD_S_VGP_S)-0.0)*3.3333333333333333e-01+(xn_d_VD_S-SP_S_x0_VD_S)*0.0+(xn_d_VGP_S-SP_S_x0_VGP_S)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VD_S_VS_BP=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VD_S_VS_BP-SP_S_x0_VD_S_VS_BP)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VD_S-SP_S_x0_VD_S)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))))+(xn_d_VS_BP-SP_S_x0_VS_BP)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VD_S_VS_BP-SP_S_x0_VD_S_VS_BP)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VD_S-SP_S_x0_VD_S)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)+(xn_d_VS_BP-SP_S_x0_VS_BP)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VD_S_VS_BP-SP_S_x0_VD_S_VS_BP)-0.0)*3.3333333333333333e-01+(xn_d_VD_S-SP_S_x0_VD_S)*0.0+(xn_d_VS_BP-SP_S_x0_VS_BP)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
SP_S_delta0_VGP_S=(-1.0e-100*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VGP_S_VD_S=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VGP_S_VD_S-SP_S_x0_VGP_S_VD_S)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VGP_S-SP_S_x0_VGP_S)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))))+(xn_d_VD_S-SP_S_x0_VD_S)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VGP_S_VD_S-SP_S_x0_VGP_S_VD_S)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VGP_S-SP_S_x0_VGP_S)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)+(xn_d_VD_S-SP_S_x0_VD_S)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VGP_S_VD_S-SP_S_x0_VGP_S_VD_S)-0.0)*3.3333333333333333e-01+(xn_d_VGP_S-SP_S_x0_VGP_S)*0.0+(xn_d_VD_S-SP_S_x0_VD_S)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VGP_S_VGP_S=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VGP_S_VGP_S-SP_S_x0_VGP_S_VGP_S)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VGP_S-SP_S_x0_VGP_S)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))))))+(xn_d_VGP_S-SP_S_x0_VGP_S)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VGP_S_VGP_S-SP_S_x0_VGP_S_VGP_S)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VGP_S-SP_S_x0_VGP_S)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)+(xn_d_VGP_S-SP_S_x0_VGP_S)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VGP_S_VGP_S-SP_S_x0_VGP_S_VGP_S)-0.0)*3.3333333333333333e-01+(xn_d_VGP_S-SP_S_x0_VGP_S)*0.0+(xn_d_VGP_S-SP_S_x0_VGP_S)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VGP_S_VS_BP=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VGP_S_VS_BP-SP_S_x0_VGP_S_VS_BP)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VGP_S-SP_S_x0_VGP_S)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))))+(xn_d_VS_BP-SP_S_x0_VS_BP)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VGP_S_VS_BP-SP_S_x0_VGP_S_VS_BP)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VGP_S-SP_S_x0_VGP_S)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)+(xn_d_VS_BP-SP_S_x0_VS_BP)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VGP_S_VS_BP-SP_S_x0_VGP_S_VS_BP)-0.0)*3.3333333333333333e-01+(xn_d_VGP_S-SP_S_x0_VGP_S)*0.0+(xn_d_VS_BP-SP_S_x0_VS_BP)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
SP_S_delta0_VS_BP=(-1.0e-100*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta0_VS_BP_VD_S=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VS_BP_VD_S-SP_S_x0_VS_BP_VD_S)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VS_BP-SP_S_x0_VS_BP)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))))+(xn_d_VD_S-SP_S_x0_VD_S)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VS_BP_VD_S-SP_S_x0_VS_BP_VD_S)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VS_BP-SP_S_x0_VS_BP)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)+(xn_d_VD_S-SP_S_x0_VD_S)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VS_BP_VD_S-SP_S_x0_VS_BP_VD_S)-0.0)*3.3333333333333333e-01+(xn_d_VS_BP-SP_S_x0_VS_BP)*0.0+(xn_d_VD_S-SP_S_x0_VD_S)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-SP_S_x0_VD_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VD_S-SP_S_x0_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VS_BP_VGP_S=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VS_BP_VGP_S-SP_S_x0_VS_BP_VGP_S)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VS_BP-SP_S_x0_VS_BP)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))))))+(xn_d_VGP_S-SP_S_x0_VGP_S)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VS_BP_VGP_S-SP_S_x0_VS_BP_VGP_S)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VS_BP-SP_S_x0_VS_BP)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)+(xn_d_VGP_S-SP_S_x0_VGP_S)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VS_BP_VGP_S-SP_S_x0_VS_BP_VGP_S)-0.0)*3.3333333333333333e-01+(xn_d_VS_BP-SP_S_x0_VS_BP)*0.0+(xn_d_VGP_S-SP_S_x0_VGP_S)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-SP_S_x0_VGP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VGP_S-SP_S_x0_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta0_VS_BP_VS_BP=(0.0/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VS_BP_VS_BP-SP_S_x0_VS_BP_VS_BP)-0.0)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VS_BP-SP_S_x0_VS_BP)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))))+(xn_d_VS_BP-SP_S_x0_VS_BP)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VS_BP_VS_BP-SP_S_x0_VS_BP_VS_BP)-0.0)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VS_BP-SP_S_x0_VS_BP)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)+(xn_d_VS_BP-SP_S_x0_VS_BP)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01+((xn_d-SP_S_x0)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VS_BP_VS_BP-SP_S_x0_VS_BP_VS_BP)-0.0)*3.3333333333333333e-01+(xn_d_VS_BP-SP_S_x0_VS_BP)*0.0+(xn_d_VS_BP-SP_S_x0_VS_BP)*0.0+((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-SP_S_x0_VS_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*((xn_d_VS_BP-SP_S_x0_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
#endif
SP_S_delta0=(1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_delta1_VD_S=(-1.0e-100*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta1_VD_S_VD_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VD_S_VD_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VD_S*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))))+SP_S_x0_VD_S*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VD_S_VD_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VD_S*(SP_S_x0_VD_S*3.3333333333333333e-01)+SP_S_x0_VD_S*SP_S_x0_VD_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VD_S_VD_S-0.0)*3.3333333333333333e-01+SP_S_x0_VD_S*0.0+SP_S_x0_VD_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VD_S_VGP_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VD_S_VGP_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VD_S*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))))+SP_S_x0_VGP_S*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VD_S_VGP_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VD_S*(SP_S_x0_VGP_S*3.3333333333333333e-01)+SP_S_x0_VGP_S*SP_S_x0_VD_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VD_S_VGP_S-0.0)*3.3333333333333333e-01+SP_S_x0_VD_S*0.0+SP_S_x0_VGP_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VD_S_VS_BP=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VD_S_VS_BP-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VD_S*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))))+SP_S_x0_VS_BP*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VD_S_VS_BP-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VD_S*(SP_S_x0_VS_BP*3.3333333333333333e-01)+SP_S_x0_VS_BP*SP_S_x0_VD_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VD_S_VS_BP-0.0)*3.3333333333333333e-01+SP_S_x0_VD_S*0.0+SP_S_x0_VS_BP*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VD_S*3.3333333333333333e-01)))))*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
SP_S_delta1_VGP_S=(-1.0e-100*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta1_VGP_S_VD_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VGP_S_VD_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VGP_S*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))))+SP_S_x0_VD_S*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VGP_S_VD_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VGP_S*(SP_S_x0_VD_S*3.3333333333333333e-01)+SP_S_x0_VD_S*SP_S_x0_VGP_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VGP_S_VD_S-0.0)*3.3333333333333333e-01+SP_S_x0_VGP_S*0.0+SP_S_x0_VD_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VGP_S_VGP_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VGP_S_VGP_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VGP_S*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))))+SP_S_x0_VGP_S*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VGP_S_VGP_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VGP_S*(SP_S_x0_VGP_S*3.3333333333333333e-01)+SP_S_x0_VGP_S*SP_S_x0_VGP_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+SP_S_x0_VGP_S*0.0+SP_S_x0_VGP_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VGP_S_VS_BP=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VGP_S_VS_BP-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VGP_S*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))))+SP_S_x0_VS_BP*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VGP_S_VS_BP-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VGP_S*(SP_S_x0_VS_BP*3.3333333333333333e-01)+SP_S_x0_VS_BP*SP_S_x0_VGP_S*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+SP_S_x0_VGP_S*0.0+SP_S_x0_VS_BP*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VGP_S*3.3333333333333333e-01)))))*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
SP_S_delta1_VS_BP=(-1.0e-100*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_S_delta1_VS_BP_VD_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VS_BP_VD_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VS_BP*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))))+SP_S_x0_VD_S*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VS_BP_VD_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VS_BP*(SP_S_x0_VD_S*3.3333333333333333e-01)+SP_S_x0_VD_S*SP_S_x0_VS_BP*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VS_BP_VD_S-0.0)*3.3333333333333333e-01+SP_S_x0_VS_BP*0.0+SP_S_x0_VD_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))*(((SP_S_x0_VD_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VD_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VD_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VS_BP_VGP_S=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VS_BP_VGP_S-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VS_BP*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))))+SP_S_x0_VGP_S*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01))))+0.0*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VS_BP_VGP_S-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VS_BP*(SP_S_x0_VGP_S*3.3333333333333333e-01)+SP_S_x0_VGP_S*SP_S_x0_VS_BP*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+SP_S_x0_VS_BP*0.0+SP_S_x0_VGP_S*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))*(((SP_S_x0_VGP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VGP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  SP_S_delta1_VS_BP_VS_BP=(0.0/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))+0.0*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+SP_S_x0_VS_BP_VS_BP-0.0)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))+SP_S_x0_VS_BP*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))))+SP_S_x0_VS_BP*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+0.0*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01))))+0.0*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01))+0.5*(+(+SP_S_x0_VS_BP_VS_BP-0.0)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))+SP_S_x0_VS_BP*(SP_S_x0_VS_BP*3.3333333333333333e-01)+SP_S_x0_VS_BP*SP_S_x0_VS_BP*3.3333333333333333e-01+(SP_S_x0-2.3025850929940458e+02)*(+0.0+(+(+SP_S_x0_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+SP_S_x0_VS_BP*0.0+SP_S_x0_VS_BP*0.0+(SP_S_x0-2.3025850929940458e+02)*0.0))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*(0.5*((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*SP_S_x0_VS_BP*3.3333333333333333e-01)))))*(((SP_S_x0_VS_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((SP_S_x0-2.3025850929940458e+02)*((0.5*(((SP_S_x0_VS_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+((SP_S_x0-2.3025850929940458e+02)*(SP_S_x0_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
#endif
SP_S_delta1=(1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(-((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))+0.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))+1.0*(+0.0+(+SP_S_x0_VD_S_VD_S*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VD_S_VGP_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))+0.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))+1.0*(+0.0+(+SP_S_x0_VD_S_VGP_S*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VD_S_VS_BP=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))+0.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))+1.0*(+0.0+(+SP_S_x0_VD_S_VS_BP*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#endif
SP_S_temp_VGP_S=(-((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))+0.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))+1.0*(+0.0+(+SP_S_x0_VGP_S_VD_S*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VGP_S_VGP_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))+0.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))+1.0*(+0.0+(+SP_S_x0_VGP_S_VGP_S*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VGP_S_VS_BP=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))+0.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))+1.0*(+0.0+(+SP_S_x0_VGP_S_VS_BP*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#endif
SP_S_temp_VS_BP=(-((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))+0.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))+1.0*(+0.0+(+SP_S_x0_VS_BP_VD_S*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VS_BP_VGP_S=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))+0.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))+1.0*(+0.0+(+SP_S_x0_VS_BP_VGP_S*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
  SP_S_temp_VS_BP_VS_BP=(0.0/(2.0+(SP_S_x0*SP_S_x0))-(0.0*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))+0.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))+1.0*(+0.0+(+SP_S_x0_VS_BP_VS_BP*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))+2*1.0*((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
#endif
#endif
SP_S_temp=(1.0/(2.0+(SP_S_x0*SP_S_x0)));
EXIT_IF_ISNAN((1.0/(2.0+(SP_S_x0*SP_S_x0))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi0_VD_S=((((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_x0)*SP_S_temp_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VD_S_VD_S=(+(+SP_S_x0_VD_S_VD_S*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VD_S)*SP_S_temp+((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VD_S_VD_S);
  SP_S_xi0_VD_S_VGP_S=(+(+SP_S_x0_VD_S_VGP_S*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VGP_S)*SP_S_temp+((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VD_S_VGP_S);
  SP_S_xi0_VD_S_VS_BP=(+(+SP_S_x0_VD_S_VS_BP*SP_S_x0+SP_S_x0_VD_S*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VD_S+SP_S_x0*SP_S_x0_VD_S_VS_BP)*SP_S_temp+((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VD_S_VS_BP);
#endif
SP_S_xi0_VGP_S=((((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_x0)*SP_S_temp_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi0_VGP_S_VD_S=(+(+SP_S_x0_VGP_S_VD_S*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VD_S)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VGP_S_VD_S);
  SP_S_xi0_VGP_S_VGP_S=(+(+SP_S_x0_VGP_S_VGP_S*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VGP_S)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VGP_S_VGP_S);
  SP_S_xi0_VGP_S_VS_BP=(+(+SP_S_x0_VGP_S_VS_BP*SP_S_x0+SP_S_x0_VGP_S*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VGP_S+SP_S_x0*SP_S_x0_VGP_S_VS_BP)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_x0)*SP_S_temp_VGP_S_VS_BP);
#endif
SP_S_xi0_VS_BP=((((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_x0)*SP_S_temp_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi0_VS_BP_VD_S=(+(+SP_S_x0_VS_BP_VD_S*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VD_S+SP_S_x0_VD_S*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VD_S)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VD_S)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_x0)*SP_S_temp_VS_BP_VD_S);
  SP_S_xi0_VS_BP_VGP_S=(+(+SP_S_x0_VS_BP_VGP_S*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VGP_S+SP_S_x0_VGP_S*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VGP_S)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_x0)+(SP_S_x0*SP_S_x0_VGP_S)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_x0)*SP_S_temp_VS_BP_VGP_S);
  SP_S_xi0_VS_BP_VS_BP=(+(+SP_S_x0_VS_BP_VS_BP*SP_S_x0+SP_S_x0_VS_BP*SP_S_x0_VS_BP+SP_S_x0_VS_BP*SP_S_x0_VS_BP+SP_S_x0*SP_S_x0_VS_BP_VS_BP)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_x0)+(SP_S_x0*SP_S_x0_VS_BP)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_x0)*SP_S_temp_VS_BP_VS_BP);
#endif
#endif
SP_S_xi0=((SP_S_x0*SP_S_x0)*SP_S_temp);
EXIT_IF_ISNAN(((SP_S_x0*SP_S_x0)*SP_S_temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi1_VD_S=(4.0*((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VD_S_VD_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_x0_VD_S_VD_S*SP_S_temp+SP_S_x0_VD_S*SP_S_temp_VD_S+SP_S_x0_VD_S*SP_S_temp_VD_S+SP_S_x0*SP_S_temp_VD_S_VD_S)*SP_S_temp+((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VD_S_VD_S));
  SP_S_xi1_VD_S_VGP_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_x0_VD_S_VGP_S*SP_S_temp+SP_S_x0_VD_S*SP_S_temp_VGP_S+SP_S_x0_VGP_S*SP_S_temp_VD_S+SP_S_x0*SP_S_temp_VD_S_VGP_S)*SP_S_temp+((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VD_S_VGP_S));
  SP_S_xi1_VD_S_VS_BP=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S))+4.0*(+(+SP_S_x0_VD_S_VS_BP*SP_S_temp+SP_S_x0_VD_S*SP_S_temp_VS_BP+SP_S_x0_VS_BP*SP_S_temp_VD_S+SP_S_x0*SP_S_temp_VD_S_VS_BP)*SP_S_temp+((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp_VD_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VD_S_VS_BP));
#endif
SP_S_xi1_VGP_S=(4.0*((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S)));
#if defined(_DERIVATE2)
  SP_S_xi1_VGP_S_VD_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_x0_VGP_S_VD_S*SP_S_temp+SP_S_x0_VGP_S*SP_S_temp_VD_S+SP_S_x0_VD_S*SP_S_temp_VGP_S+SP_S_x0*SP_S_temp_VGP_S_VD_S)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S_VD_S));
  SP_S_xi1_VGP_S_VGP_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_x0_VGP_S_VGP_S*SP_S_temp+SP_S_x0_VGP_S*SP_S_temp_VGP_S+SP_S_x0_VGP_S*SP_S_temp_VGP_S+SP_S_x0*SP_S_temp_VGP_S_VGP_S)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S_VGP_S));
  SP_S_xi1_VGP_S_VS_BP=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S))+4.0*(+(+SP_S_x0_VGP_S_VS_BP*SP_S_temp+SP_S_x0_VGP_S*SP_S_temp_VS_BP+SP_S_x0_VS_BP*SP_S_temp_VGP_S+SP_S_x0*SP_S_temp_VGP_S_VS_BP)*SP_S_temp+((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp_VGP_S+(SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S_VS_BP));
#endif
SP_S_xi1_VS_BP=(4.0*((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP)));
#if defined(_DERIVATE2)
  SP_S_xi1_VS_BP_VD_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VD_S)))+0.0*((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_x0_VS_BP_VD_S*SP_S_temp+SP_S_x0_VS_BP*SP_S_temp_VD_S+SP_S_x0_VD_S*SP_S_temp_VS_BP+SP_S_x0*SP_S_temp_VS_BP_VD_S)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp_VD_S+(((SP_S_x0_VD_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VD_S)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP_VD_S));
  SP_S_xi1_VS_BP_VGP_S=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VGP_S)))+0.0*((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_x0_VS_BP_VGP_S*SP_S_temp+SP_S_x0_VS_BP*SP_S_temp_VGP_S+SP_S_x0_VGP_S*SP_S_temp_VS_BP+SP_S_x0*SP_S_temp_VS_BP_VGP_S)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp_VGP_S+(((SP_S_x0_VGP_S*SP_S_temp)+(SP_S_x0*SP_S_temp_VGP_S)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP_VGP_S));
  SP_S_xi1_VS_BP_VS_BP=(+0.0*((SP_S_x0*SP_S_temp)*SP_S_temp)+0.0*((((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP)))+0.0*((((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp)+((SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP))+4.0*(+(+SP_S_x0_VS_BP_VS_BP*SP_S_temp+SP_S_x0_VS_BP*SP_S_temp_VS_BP+SP_S_x0_VS_BP*SP_S_temp_VS_BP+SP_S_x0*SP_S_temp_VS_BP_VS_BP)*SP_S_temp+((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP))*SP_S_temp_VS_BP+(((SP_S_x0_VS_BP*SP_S_temp)+(SP_S_x0*SP_S_temp_VS_BP)))*SP_S_temp_VS_BP+(SP_S_x0*SP_S_temp)*SP_S_temp_VS_BP_VS_BP));
#endif
#endif
SP_S_xi1=(4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
EXIT_IF_ISNAN((4.0*((SP_S_x0*SP_S_temp)*SP_S_temp)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_S_xi2_VD_S=((((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VD_S_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VD_S))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VD_S);
  SP_S_xi2_VD_S_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VGP_S);
  SP_S_xi2_VD_S_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+8.0*SP_S_temp_VD_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VD_S+12.0*SP_S_xi0_VD_S_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VD_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VD_S)-(12.0*SP_S_xi0_VD_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VD_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VD_S_VS_BP);
#endif
SP_S_xi2_VGP_S=((((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S));
#if defined(_DERIVATE2)
  SP_S_xi2_VGP_S_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VD_S))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VD_S);
  SP_S_xi2_VGP_S_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VGP_S);
  SP_S_xi2_VGP_S_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+8.0*SP_S_temp_VGP_S_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VGP_S+12.0*SP_S_xi0_VGP_S_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VGP_S+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VGP_S)-(12.0*SP_S_xi0_VGP_S))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VGP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VGP_S_VS_BP);
#endif
SP_S_xi2_VS_BP=((((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp)+((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP));
#if defined(_DERIVATE2)
  SP_S_xi2_VS_BP_VD_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VD_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VD_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VD_S))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VD_S+(((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VD_S)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VD_S+((((((8.0*SP_S_temp_VD_S))-((12.0*SP_S_xi0_VD_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VD_S)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VD_S);
  SP_S_xi2_VS_BP_VGP_S=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VGP_S)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VGP_S+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VGP_S))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VGP_S+(((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VGP_S)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VGP_S+((((((8.0*SP_S_temp_VGP_S))-((12.0*SP_S_xi0_VGP_S)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VGP_S)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VGP_S);
  SP_S_xi2_VS_BP_VS_BP=(+(+(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+8.0*SP_S_temp_VS_BP_VS_BP)-(+0.0*SP_S_xi0+0.0*SP_S_xi0_VS_BP+0.0*SP_S_xi0_VS_BP+12.0*SP_S_xi0_VS_BP_VS_BP))*SP_S_temp+((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp_VS_BP+(((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp_VS_BP+((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP_VS_BP)*SP_S_temp+((((8.0*SP_S_temp_VS_BP)-(12.0*SP_S_xi0_VS_BP))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP))*SP_S_temp_VS_BP+((((((8.0*SP_S_temp_VS_BP))-((12.0*SP_S_xi0_VS_BP)))*SP_S_temp)+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp_VS_BP)))*SP_S_temp_VS_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp_VS_BP_VS_BP);
#endif
#endif
SP_S_xi2=((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
EXIT_IF_ISNAN(((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(xg_VD_S-SP_S_x0_VD_S);
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+xg_VD_S_VD_S-SP_S_x0_VD_S_VD_S);
  SP_S_temp_VD_S_VGP_S=(+xg_VD_S_VGP_S-SP_S_x0_VD_S_VGP_S);
  SP_S_temp_VD_S_VS_BP=(+xg_VD_S_VS_BP-SP_S_x0_VD_S_VS_BP);
#endif
SP_S_temp_VGP_S=(xg_VGP_S-SP_S_x0_VGP_S);
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+xg_VGP_S_VD_S-SP_S_x0_VGP_S_VD_S);
  SP_S_temp_VGP_S_VGP_S=(+xg_VGP_S_VGP_S-SP_S_x0_VGP_S_VGP_S);
  SP_S_temp_VGP_S_VS_BP=(+xg_VGP_S_VS_BP-SP_S_x0_VGP_S_VS_BP);
#endif
SP_S_temp_VS_BP=(xg_VS_BP-SP_S_x0_VS_BP);
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+xg_VS_BP_VD_S-SP_S_x0_VS_BP_VD_S);
  SP_S_temp_VS_BP_VGP_S=(+xg_VS_BP_VGP_S-SP_S_x0_VS_BP_VGP_S);
  SP_S_temp_VS_BP_VS_BP=(+xg_VS_BP_VS_BP-SP_S_x0_VS_BP_VS_BP);
#endif
#endif
SP_S_temp=(pInst->xg-SP_S_x0);
EXIT_IF_ISNAN((pInst->xg-SP_S_x0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_pC_VD_S=((2.0*SP_S_temp_VD_S)+((Gf2_VD_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))+(Gf2*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S))))));
#if defined(_DERIVATE2)
  SP_S_pC_VD_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VD_S)+(+Gf2_VD_S_VD_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VD_S*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-(((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S))))+Gf2_VD_S*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VD_S_VD_S)+SP_S_delta0_VD_S_VD_S)-(+delta_nd_VD_S_VD_S*(1.0+SP_S_xi1)+delta_nd_VD_S*SP_S_xi1_VD_S+delta_nd_VD_S*SP_S_xi1_VD_S+delta_nd*(+0.0+SP_S_xi1_VD_S_VD_S)))));
  SP_S_pC_VD_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VGP_S)+(+Gf2_VD_S_VGP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VD_S*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S))))+Gf2_VGP_S*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VD_S_VGP_S)+SP_S_delta0_VD_S_VGP_S)-(+delta_nd_VD_S_VGP_S*(1.0+SP_S_xi1)+delta_nd_VD_S*SP_S_xi1_VGP_S+delta_nd_VGP_S*SP_S_xi1_VD_S+delta_nd*(+0.0+SP_S_xi1_VD_S_VGP_S)))));
  SP_S_pC_VD_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VD_S+2.0*SP_S_temp_VD_S_VS_BP)+(+Gf2_VD_S_VS_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VD_S*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP))))+Gf2_VS_BP*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VD_S_VS_BP)+SP_S_delta0_VD_S_VS_BP)-(+delta_nd_VD_S_VS_BP*(1.0+SP_S_xi1)+delta_nd_VD_S*SP_S_xi1_VS_BP+delta_nd_VS_BP*SP_S_xi1_VD_S+delta_nd*(+0.0+SP_S_xi1_VD_S_VS_BP)))));
#endif
SP_S_pC_VGP_S=((2.0*SP_S_temp_VGP_S)+((Gf2_VGP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))+(Gf2*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S))))));
#if defined(_DERIVATE2)
  SP_S_pC_VGP_S_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VD_S)+(+Gf2_VGP_S_VD_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VGP_S*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-(((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S))))+Gf2_VD_S*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VGP_S_VD_S)+SP_S_delta0_VGP_S_VD_S)-(+delta_nd_VGP_S_VD_S*(1.0+SP_S_xi1)+delta_nd_VGP_S*SP_S_xi1_VD_S+delta_nd_VD_S*SP_S_xi1_VGP_S+delta_nd*(+0.0+SP_S_xi1_VGP_S_VD_S)))));
  SP_S_pC_VGP_S_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VGP_S)+(+Gf2_VGP_S_VGP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VGP_S*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S))))+Gf2_VGP_S*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VGP_S_VGP_S)+SP_S_delta0_VGP_S_VGP_S)-(+delta_nd_VGP_S_VGP_S*(1.0+SP_S_xi1)+delta_nd_VGP_S*SP_S_xi1_VGP_S+delta_nd_VGP_S*SP_S_xi1_VGP_S+delta_nd*(+0.0+SP_S_xi1_VGP_S_VGP_S)))));
  SP_S_pC_VGP_S_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VGP_S+2.0*SP_S_temp_VGP_S_VS_BP)+(+Gf2_VGP_S_VS_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VGP_S*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP))))+Gf2_VS_BP*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S)))+Gf2*(+(+(+0.0-SP_S_delta1_VGP_S_VS_BP)+SP_S_delta0_VGP_S_VS_BP)-(+delta_nd_VGP_S_VS_BP*(1.0+SP_S_xi1)+delta_nd_VGP_S*SP_S_xi1_VS_BP+delta_nd_VS_BP*SP_S_xi1_VGP_S+delta_nd*(+0.0+SP_S_xi1_VGP_S_VS_BP)))));
#endif
SP_S_pC_VS_BP=((2.0*SP_S_temp_VS_BP)+((Gf2_VS_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))+(Gf2*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP))))));
#if defined(_DERIVATE2)
  SP_S_pC_VS_BP_VD_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VD_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VD_S)+(+Gf2_VS_BP_VD_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VS_BP*(((-SP_S_delta1_VD_S)+SP_S_delta0_VD_S)-(((delta_nd_VD_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VD_S))))+Gf2_VD_S*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP)))+Gf2*(+(+(+0.0-SP_S_delta1_VS_BP_VD_S)+SP_S_delta0_VS_BP_VD_S)-(+delta_nd_VS_BP_VD_S*(1.0+SP_S_xi1)+delta_nd_VS_BP*SP_S_xi1_VD_S+delta_nd_VD_S*SP_S_xi1_VS_BP+delta_nd*(+0.0+SP_S_xi1_VS_BP_VD_S)))));
  SP_S_pC_VS_BP_VGP_S=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VGP_S+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VGP_S)+(+Gf2_VS_BP_VGP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VS_BP*(((-SP_S_delta1_VGP_S)+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VGP_S))))+Gf2_VGP_S*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP)))+Gf2*(+(+(+0.0-SP_S_delta1_VS_BP_VGP_S)+SP_S_delta0_VS_BP_VGP_S)-(+delta_nd_VS_BP_VGP_S*(1.0+SP_S_xi1)+delta_nd_VS_BP*SP_S_xi1_VGP_S+delta_nd_VGP_S*SP_S_xi1_VS_BP+delta_nd*(+0.0+SP_S_xi1_VS_BP_VGP_S)))));
  SP_S_pC_VS_BP_VS_BP=(+(+0.0*SP_S_temp+0.0*SP_S_temp_VS_BP+0.0*SP_S_temp_VS_BP+2.0*SP_S_temp_VS_BP_VS_BP)+(+Gf2_VS_BP_VS_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))+Gf2_VS_BP*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP))))+Gf2_VS_BP*(((-SP_S_delta1_VS_BP)+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*(1.0+SP_S_xi1))+(delta_nd*SP_S_xi1_VS_BP)))+Gf2*(+(+(+0.0-SP_S_delta1_VS_BP_VS_BP)+SP_S_delta0_VS_BP_VS_BP)-(+delta_nd_VS_BP_VS_BP*(1.0+SP_S_xi1)+delta_nd_VS_BP*SP_S_xi1_VS_BP+delta_nd_VS_BP*SP_S_xi1_VS_BP+delta_nd*(+0.0+SP_S_xi1_VS_BP_VS_BP)))));
#endif
#endif
SP_S_pC=((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
EXIT_IF_ISNAN(((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_qC_VD_S=(((SP_S_temp_VD_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VD_S))-((Gf2_VD_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))+(Gf2*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-((delta_nd_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VD_S+SP_S_xi0_VD_S)))))));
#if defined(_DERIVATE2)
  SP_S_qC_VD_S_VD_S=(+(+SP_S_temp_VD_S_VD_S*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VD_S)-(+Gf2_VD_S_VD_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-(((delta_nd_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VD_S+SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-((delta_nd_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VD_S+SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta1_VD_S_VD_S+SP_S_x0_VD_S_VD_S)-0.0)+SP_S_delta0_VD_S_VD_S)-(+delta_nd_VD_S_VD_S*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VD_S*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_nd_VD_S*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_nd*(+(+SP_S_x0_VD_S_VD_S+0.0)+SP_S_xi0_VD_S_VD_S)))));
  SP_S_qC_VD_S_VGP_S=(+(+SP_S_temp_VD_S_VGP_S*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VGP_S)-(+Gf2_VD_S_VGP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)))))+Gf2_VGP_S*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-((delta_nd_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VD_S+SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta1_VD_S_VGP_S+SP_S_x0_VD_S_VGP_S)-0.0)+SP_S_delta0_VD_S_VGP_S)-(+delta_nd_VD_S_VGP_S*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VD_S*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_nd_VGP_S*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_nd*(+(+SP_S_x0_VD_S_VGP_S+0.0)+SP_S_xi0_VD_S_VGP_S)))));
  SP_S_qC_VD_S_VS_BP=(+(+SP_S_temp_VD_S_VS_BP*SP_S_temp+SP_S_temp_VD_S*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VD_S+SP_S_temp*SP_S_temp_VD_S_VS_BP)-(+Gf2_VD_S_VS_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VD_S*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-((delta_nd_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VD_S+SP_S_xi0_VD_S))))+Gf2*(+(+(+(+SP_S_delta1_VD_S_VS_BP+SP_S_x0_VD_S_VS_BP)-0.0)+SP_S_delta0_VD_S_VS_BP)-(+delta_nd_VD_S_VS_BP*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VD_S*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_nd_VS_BP*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_nd*(+(+SP_S_x0_VD_S_VS_BP+0.0)+SP_S_xi0_VD_S_VS_BP)))));
#endif
SP_S_qC_VGP_S=(((SP_S_temp_VGP_S*SP_S_temp)+(SP_S_temp*SP_S_temp_VGP_S))-((Gf2_VGP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))+(Gf2*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)))))));
#if defined(_DERIVATE2)
  SP_S_qC_VGP_S_VD_S=(+(+SP_S_temp_VGP_S_VD_S*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VD_S)-(+Gf2_VGP_S_VD_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-(((delta_nd_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VD_S+SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S))))+Gf2*(+(+(+(+SP_S_delta1_VGP_S_VD_S+SP_S_x0_VGP_S_VD_S)-0.0)+SP_S_delta0_VGP_S_VD_S)-(+delta_nd_VGP_S_VD_S*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VGP_S*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_nd_VD_S*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_nd*(+(+SP_S_x0_VGP_S_VD_S+0.0)+SP_S_xi0_VGP_S_VD_S)))));
  SP_S_qC_VGP_S_VGP_S=(+(+SP_S_temp_VGP_S_VGP_S*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VGP_S)-(+Gf2_VGP_S_VGP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)))))+Gf2_VGP_S*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S))))+Gf2*(+(+(+(+SP_S_delta1_VGP_S_VGP_S+SP_S_x0_VGP_S_VGP_S)-0.0)+SP_S_delta0_VGP_S_VGP_S)-(+delta_nd_VGP_S_VGP_S*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VGP_S*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_nd_VGP_S*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_nd*(+(+SP_S_x0_VGP_S_VGP_S+0.0)+SP_S_xi0_VGP_S_VGP_S)))));
  SP_S_qC_VGP_S_VS_BP=(+(+SP_S_temp_VGP_S_VS_BP*SP_S_temp+SP_S_temp_VGP_S*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VGP_S+SP_S_temp*SP_S_temp_VGP_S_VS_BP)-(+Gf2_VGP_S_VS_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VGP_S*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S))))+Gf2*(+(+(+(+SP_S_delta1_VGP_S_VS_BP+SP_S_x0_VGP_S_VS_BP)-0.0)+SP_S_delta0_VGP_S_VS_BP)-(+delta_nd_VGP_S_VS_BP*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VGP_S*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_nd_VS_BP*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_nd*(+(+SP_S_x0_VGP_S_VS_BP+0.0)+SP_S_xi0_VGP_S_VS_BP)))));
#endif
SP_S_qC_VS_BP=(((SP_S_temp_VS_BP*SP_S_temp)+(SP_S_temp*SP_S_temp_VS_BP))-((Gf2_VS_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))+(Gf2*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)))))));
#if defined(_DERIVATE2)
  SP_S_qC_VS_BP_VD_S=(+(+SP_S_temp_VS_BP_VD_S*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VD_S+SP_S_temp_VD_S*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VD_S)-(+Gf2_VS_BP_VD_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta1_VD_S+SP_S_x0_VD_S)+SP_S_delta0_VD_S)-(((delta_nd_VD_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VD_S+SP_S_xi0_VD_S)))))+Gf2_VD_S*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta1_VS_BP_VD_S+SP_S_x0_VS_BP_VD_S)-0.0)+SP_S_delta0_VS_BP_VD_S)-(+delta_nd_VS_BP_VD_S*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VS_BP*(SP_S_x0_VD_S+SP_S_xi0_VD_S)+delta_nd_VD_S*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_nd*(+(+SP_S_x0_VS_BP_VD_S+0.0)+SP_S_xi0_VS_BP_VD_S)))));
  SP_S_qC_VS_BP_VGP_S=(+(+SP_S_temp_VS_BP_VGP_S*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VGP_S+SP_S_temp_VGP_S*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VGP_S)-(+Gf2_VS_BP_VGP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta1_VGP_S+SP_S_x0_VGP_S)+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)))))+Gf2_VGP_S*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta1_VS_BP_VGP_S+SP_S_x0_VS_BP_VGP_S)-0.0)+SP_S_delta0_VS_BP_VGP_S)-(+delta_nd_VS_BP_VGP_S*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VS_BP*(SP_S_x0_VGP_S+SP_S_xi0_VGP_S)+delta_nd_VGP_S*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_nd*(+(+SP_S_x0_VS_BP_VGP_S+0.0)+SP_S_xi0_VS_BP_VGP_S)))));
  SP_S_qC_VS_BP_VS_BP=(+(+SP_S_temp_VS_BP_VS_BP*SP_S_temp+SP_S_temp_VS_BP*SP_S_temp_VS_BP+SP_S_temp_VS_BP*SP_S_temp_VS_BP+SP_S_temp*SP_S_temp_VS_BP_VS_BP)-(+Gf2_VS_BP_VS_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))+Gf2_VS_BP*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)))))+Gf2_VS_BP*(((SP_S_delta1_VS_BP+SP_S_x0_VS_BP)+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*((SP_S_x0+1.0)+SP_S_xi0))+(delta_nd*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP))))+Gf2*(+(+(+(+SP_S_delta1_VS_BP_VS_BP+SP_S_x0_VS_BP_VS_BP)-0.0)+SP_S_delta0_VS_BP_VS_BP)-(+delta_nd_VS_BP_VS_BP*((SP_S_x0+1.0)+SP_S_xi0)+delta_nd_VS_BP*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_nd_VS_BP*(SP_S_x0_VS_BP+SP_S_xi0_VS_BP)+delta_nd*(+(+SP_S_x0_VS_BP_VS_BP+0.0)+SP_S_xi0_VS_BP_VS_BP)))));
#endif
#endif
SP_S_qC=((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
EXIT_IF_ISNAN(((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(-((Gf2_VD_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))+(Gf2*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S))))));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+0.0-(+Gf2_VD_S_VD_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VD_S*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta1_VD_S_VD_S+SP_S_delta0_VD_S_VD_S)-(+delta_nd_VD_S_VD_S*SP_S_xi2+delta_nd_VD_S*SP_S_xi2_VD_S+delta_nd_VD_S*SP_S_xi2_VD_S+delta_nd*SP_S_xi2_VD_S_VD_S))));
  SP_S_temp_VD_S_VGP_S=(+0.0-(+Gf2_VD_S_VGP_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VD_S*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S))))+Gf2_VGP_S*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta1_VD_S_VGP_S+SP_S_delta0_VD_S_VGP_S)-(+delta_nd_VD_S_VGP_S*SP_S_xi2+delta_nd_VD_S*SP_S_xi2_VGP_S+delta_nd_VGP_S*SP_S_xi2_VD_S+delta_nd*SP_S_xi2_VD_S_VGP_S))));
  SP_S_temp_VD_S_VS_BP=(+0.0-(+Gf2_VD_S_VS_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VD_S*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S)))+Gf2*(+(+SP_S_delta1_VD_S_VS_BP+SP_S_delta0_VD_S_VS_BP)-(+delta_nd_VD_S_VS_BP*SP_S_xi2+delta_nd_VD_S*SP_S_xi2_VS_BP+delta_nd_VS_BP*SP_S_xi2_VD_S+delta_nd*SP_S_xi2_VD_S_VS_BP))));
#endif
SP_S_temp_VGP_S=(-((Gf2_VGP_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))+(Gf2*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S))))));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+0.0-(+Gf2_VGP_S_VD_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))+Gf2*(+(+SP_S_delta1_VGP_S_VD_S+SP_S_delta0_VGP_S_VD_S)-(+delta_nd_VGP_S_VD_S*SP_S_xi2+delta_nd_VGP_S*SP_S_xi2_VD_S+delta_nd_VD_S*SP_S_xi2_VGP_S+delta_nd*SP_S_xi2_VGP_S_VD_S))));
  SP_S_temp_VGP_S_VGP_S=(+0.0-(+Gf2_VGP_S_VGP_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S))))+Gf2_VGP_S*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))+Gf2*(+(+SP_S_delta1_VGP_S_VGP_S+SP_S_delta0_VGP_S_VGP_S)-(+delta_nd_VGP_S_VGP_S*SP_S_xi2+delta_nd_VGP_S*SP_S_xi2_VGP_S+delta_nd_VGP_S*SP_S_xi2_VGP_S+delta_nd*SP_S_xi2_VGP_S_VGP_S))));
  SP_S_temp_VGP_S_VS_BP=(+0.0-(+Gf2_VGP_S_VS_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VGP_S*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S)))+Gf2*(+(+SP_S_delta1_VGP_S_VS_BP+SP_S_delta0_VGP_S_VS_BP)-(+delta_nd_VGP_S_VS_BP*SP_S_xi2+delta_nd_VGP_S*SP_S_xi2_VS_BP+delta_nd_VS_BP*SP_S_xi2_VGP_S+delta_nd*SP_S_xi2_VGP_S_VS_BP))));
#endif
SP_S_temp_VS_BP=(-((Gf2_VS_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))+(Gf2*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP))))));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+0.0-(+Gf2_VS_BP_VD_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta1_VD_S+SP_S_delta0_VD_S)-(((delta_nd_VD_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VD_S))))+Gf2_VD_S*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta1_VS_BP_VD_S+SP_S_delta0_VS_BP_VD_S)-(+delta_nd_VS_BP_VD_S*SP_S_xi2+delta_nd_VS_BP*SP_S_xi2_VD_S+delta_nd_VD_S*SP_S_xi2_VS_BP+delta_nd*SP_S_xi2_VS_BP_VD_S))));
  SP_S_temp_VS_BP_VGP_S=(+0.0-(+Gf2_VS_BP_VGP_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta1_VGP_S+SP_S_delta0_VGP_S)-(((delta_nd_VGP_S*SP_S_xi2)+(delta_nd*SP_S_xi2_VGP_S))))+Gf2_VGP_S*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta1_VS_BP_VGP_S+SP_S_delta0_VS_BP_VGP_S)-(+delta_nd_VS_BP_VGP_S*SP_S_xi2+delta_nd_VS_BP*SP_S_xi2_VGP_S+delta_nd_VGP_S*SP_S_xi2_VS_BP+delta_nd*SP_S_xi2_VS_BP_VGP_S))));
  SP_S_temp_VS_BP_VS_BP=(+0.0-(+Gf2_VS_BP_VS_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))+Gf2_VS_BP*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-(((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP))))+Gf2_VS_BP*((SP_S_delta1_VS_BP+SP_S_delta0_VS_BP)-((delta_nd_VS_BP*SP_S_xi2)+(delta_nd*SP_S_xi2_VS_BP)))+Gf2*(+(+SP_S_delta1_VS_BP_VS_BP+SP_S_delta0_VS_BP_VS_BP)-(+delta_nd_VS_BP_VS_BP*SP_S_xi2+delta_nd_VS_BP*SP_S_xi2_VS_BP+delta_nd_VS_BP*SP_S_xi2_VS_BP+delta_nd*SP_S_xi2_VS_BP_VS_BP))));
#endif
#endif
SP_S_temp=(2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
EXIT_IF_ISNAN((2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2)))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_S_temp_VD_S=(((SP_S_pC_VD_S*SP_S_pC)+(SP_S_pC*SP_S_pC_VD_S))-(2.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))));
#if defined(_DERIVATE2)
  SP_S_temp_VD_S_VD_S=(+(+SP_S_pC_VD_S_VD_S*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VD_S*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VD_S)));
  SP_S_temp_VD_S_VGP_S=(+(+SP_S_pC_VD_S_VGP_S*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VGP_S*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VGP_S)));
  SP_S_temp_VD_S_VS_BP=(+(+SP_S_pC_VD_S_VS_BP*SP_S_pC+SP_S_pC_VD_S*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VD_S+SP_S_pC*SP_S_pC_VD_S_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S))+2.0*(+SP_S_qC_VD_S_VS_BP*SP_S_temp+SP_S_qC_VD_S*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VD_S+SP_S_qC*SP_S_temp_VD_S_VS_BP)));
#endif
SP_S_temp_VGP_S=(((SP_S_pC_VGP_S*SP_S_pC)+(SP_S_pC*SP_S_pC_VGP_S))-(2.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))));
#if defined(_DERIVATE2)
  SP_S_temp_VGP_S_VD_S=(+(+SP_S_pC_VGP_S_VD_S*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VD_S*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VD_S)));
  SP_S_temp_VGP_S_VGP_S=(+(+SP_S_pC_VGP_S_VGP_S*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VGP_S*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VGP_S)));
  SP_S_temp_VGP_S_VS_BP=(+(+SP_S_pC_VGP_S_VS_BP*SP_S_pC+SP_S_pC_VGP_S*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VGP_S+SP_S_pC*SP_S_pC_VGP_S_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S))+2.0*(+SP_S_qC_VGP_S_VS_BP*SP_S_temp+SP_S_qC_VGP_S*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VGP_S+SP_S_qC*SP_S_temp_VGP_S_VS_BP)));
#endif
SP_S_temp_VS_BP=(((SP_S_pC_VS_BP*SP_S_pC)+(SP_S_pC*SP_S_pC_VS_BP))-(2.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))));
#if defined(_DERIVATE2)
  SP_S_temp_VS_BP_VD_S=(+(+SP_S_pC_VS_BP_VD_S*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VD_S+SP_S_pC_VD_S*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VD_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VD_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VD_S)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VD_S*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VD_S+SP_S_qC_VD_S*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VD_S)));
  SP_S_temp_VS_BP_VGP_S=(+(+SP_S_pC_VS_BP_VGP_S*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VGP_S+SP_S_pC_VGP_S*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VGP_S)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VGP_S*SP_S_temp)+(SP_S_qC*SP_S_temp_VGP_S)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VGP_S*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VGP_S+SP_S_qC_VGP_S*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VGP_S)));
  SP_S_temp_VS_BP_VS_BP=(+(+SP_S_pC_VS_BP_VS_BP*SP_S_pC+SP_S_pC_VS_BP*SP_S_pC_VS_BP+SP_S_pC_VS_BP*SP_S_pC_VS_BP+SP_S_pC*SP_S_pC_VS_BP_VS_BP)-(+0.0*(SP_S_qC*SP_S_temp)+0.0*(((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP)))+0.0*((SP_S_qC_VS_BP*SP_S_temp)+(SP_S_qC*SP_S_temp_VS_BP))+2.0*(+SP_S_qC_VS_BP_VS_BP*SP_S_temp+SP_S_qC_VS_BP*SP_S_temp_VS_BP+SP_S_qC_VS_BP*SP_S_temp_VS_BP+SP_S_qC*SP_S_temp_VS_BP_VS_BP)));
#endif
#endif
SP_S_temp=((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
EXIT_IF_ISNAN(((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp))))
{
double m00_sqrt(d00_sqrt0,SP_S_temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,SP_S_temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_d_VD_S=(SP_S_x0_VD_S+(2.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_d_VD_S_VD_S=(+SP_S_x0_VD_S_VD_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_d_VD_S_VGP_S=(+SP_S_x0_VD_S_VGP_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_d_VD_S_VS_BP=(+SP_S_x0_VD_S_VS_BP+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VD_S_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VD_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VD_S_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VD_S+d10_sqrt0*SP_S_temp_VD_S_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
x_d_VGP_S=(SP_S_x0_VGP_S+(2.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_d_VGP_S_VD_S=(+SP_S_x0_VGP_S_VD_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_d_VGP_S_VGP_S=(+SP_S_x0_VGP_S_VGP_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_d_VGP_S_VS_BP=(+SP_S_x0_VGP_S_VS_BP+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VGP_S_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VGP_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VGP_S_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VGP_S+d10_sqrt0*SP_S_temp_VGP_S_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
x_d_VS_BP=(SP_S_x0_VS_BP+(2.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#if defined(_DERIVATE2)
  x_d_VS_BP_VD_S=(+SP_S_x0_VS_BP_VD_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VD_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VD_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)+SP_S_qC_VD_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VD_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VD_S*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VD_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VD_S+SP_S_temp_VD_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_d_VS_BP_VGP_S=(+SP_S_x0_VS_BP_VGP_S+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VGP_S*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VGP_S/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)+SP_S_qC_VGP_S*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VGP_S+(m20_sqrt(SP_S_temp)*SP_S_temp_VGP_S*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VGP_S)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VGP_S+SP_S_temp_VGP_S*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
  x_d_VS_BP_VS_BP=(+SP_S_x0_VS_BP_VS_BP+(+0.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+0.0*((SP_S_qC_VS_BP*(SP_S_pC+d00_sqrt0)-SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))+2.0*(SP_S_qC_VS_BP_VS_BP/(SP_S_pC+d00_sqrt0)-(SP_S_qC_VS_BP*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC_VS_BP*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)+SP_S_qC*(+SP_S_pC_VS_BP_VS_BP+(m20_sqrt(SP_S_temp)*SP_S_temp_VS_BP*SP_S_temp_VS_BP+d10_sqrt0*SP_S_temp_VS_BP_VS_BP)))/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)+2*SP_S_qC*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)*(SP_S_pC_VS_BP+SP_S_temp_VS_BP*d10_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0)/(SP_S_pC+d00_sqrt0))));
#endif
#endif
x_d=(SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+d00_sqrt0))));
EXIT_IF_ISNAN((SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+d00_sqrt0)))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_ds_VD_S=(x_d_VD_S-x_s_VD_S);
#if defined(_DERIVATE2)
  x_ds_VD_S_VD_S=(+x_d_VD_S_VD_S-x_s_VD_S_VD_S);
  x_ds_VD_S_VGP_S=(+x_d_VD_S_VGP_S-x_s_VD_S_VGP_S);
  x_ds_VD_S_VS_BP=(+x_d_VD_S_VS_BP-x_s_VD_S_VS_BP);
#endif
x_ds_VGP_S=(x_d_VGP_S-x_s_VGP_S);
#if defined(_DERIVATE2)
  x_ds_VGP_S_VD_S=(+x_d_VGP_S_VD_S-x_s_VGP_S_VD_S);
  x_ds_VGP_S_VGP_S=(+x_d_VGP_S_VGP_S-x_s_VGP_S_VGP_S);
  x_ds_VGP_S_VS_BP=(+x_d_VGP_S_VS_BP-x_s_VGP_S_VS_BP);
#endif
x_ds_VS_BP=(x_d_VS_BP-x_s_VS_BP);
#if defined(_DERIVATE2)
  x_ds_VS_BP_VD_S=(+x_d_VS_BP_VD_S-x_s_VS_BP_VD_S);
  x_ds_VS_BP_VGP_S=(+x_d_VS_BP_VGP_S-x_s_VS_BP_VGP_S);
  x_ds_VS_BP_VS_BP=(+x_d_VS_BP_VS_BP-x_s_VS_BP_VS_BP);
#endif
#endif
x_ds=(x_d-x_s);
EXIT_IF_ISNAN((x_d-x_s))
if
((x_ds<1.0E-10))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
pC_VD_S=((2.0*(xg_VD_S-x_s_VD_S))+((Gf2_VD_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))+(Gf2*(((-Es_VD_S)+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*(1.0+xi1s))+(delta_nd*xi1s_VD_S))))));
#if defined(_DERIVATE2)
  pC_VD_S_VD_S=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VD_S-x_s_VD_S)+0.0*(xg_VD_S-x_s_VD_S)+2.0*(+xg_VD_S_VD_S-x_s_VD_S_VD_S))+(+Gf2_VD_S_VD_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VD_S*(((-Es_VD_S)+(((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S))))-(((delta_nd_VD_S*(1.0+xi1s))+(delta_nd*xi1s_VD_S))))+Gf2_VD_S*(((-Es_VD_S)+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*(1.0+xi1s))+(delta_nd*xi1s_VD_S)))+Gf2*(+(+(+0.0-Es_VD_S_VD_S)+(+delta_1s_VD_S_VD_S*k_ds+delta_1s_VD_S*k_ds_VD_S+delta_1s_VD_S*k_ds_VD_S+delta_1s*k_ds_VD_S_VD_S))-(+delta_nd_VD_S_VD_S*(1.0+xi1s)+delta_nd_VD_S*xi1s_VD_S+delta_nd_VD_S*xi1s_VD_S+delta_nd*(+0.0+xi1s_VD_S_VD_S)))));
  pC_VD_S_VGP_S=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VGP_S-x_s_VGP_S)+0.0*(xg_VD_S-x_s_VD_S)+2.0*(+xg_VD_S_VGP_S-x_s_VD_S_VGP_S))+(+Gf2_VD_S_VGP_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VD_S*(((-Es_VGP_S)+(((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S))))-(((delta_nd_VGP_S*(1.0+xi1s))+(delta_nd*xi1s_VGP_S))))+Gf2_VGP_S*(((-Es_VD_S)+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*(1.0+xi1s))+(delta_nd*xi1s_VD_S)))+Gf2*(+(+(+0.0-Es_VD_S_VGP_S)+(+delta_1s_VD_S_VGP_S*k_ds+delta_1s_VD_S*k_ds_VGP_S+delta_1s_VGP_S*k_ds_VD_S+delta_1s*k_ds_VD_S_VGP_S))-(+delta_nd_VD_S_VGP_S*(1.0+xi1s)+delta_nd_VD_S*xi1s_VGP_S+delta_nd_VGP_S*xi1s_VD_S+delta_nd*(+0.0+xi1s_VD_S_VGP_S)))));
  pC_VD_S_VS_BP=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VS_BP-x_s_VS_BP)+0.0*(xg_VD_S-x_s_VD_S)+2.0*(+xg_VD_S_VS_BP-x_s_VD_S_VS_BP))+(+Gf2_VD_S_VS_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VD_S*(((-Es_VS_BP)+(((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP))))-(((delta_nd_VS_BP*(1.0+xi1s))+(delta_nd*xi1s_VS_BP))))+Gf2_VS_BP*(((-Es_VD_S)+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*(1.0+xi1s))+(delta_nd*xi1s_VD_S)))+Gf2*(+(+(+0.0-Es_VD_S_VS_BP)+(+delta_1s_VD_S_VS_BP*k_ds+delta_1s_VD_S*k_ds_VS_BP+delta_1s_VS_BP*k_ds_VD_S+delta_1s*k_ds_VD_S_VS_BP))-(+delta_nd_VD_S_VS_BP*(1.0+xi1s)+delta_nd_VD_S*xi1s_VS_BP+delta_nd_VS_BP*xi1s_VD_S+delta_nd*(+0.0+xi1s_VD_S_VS_BP)))));
#endif
pC_VGP_S=((2.0*(xg_VGP_S-x_s_VGP_S))+((Gf2_VGP_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))+(Gf2*(((-Es_VGP_S)+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*(1.0+xi1s))+(delta_nd*xi1s_VGP_S))))));
#if defined(_DERIVATE2)
  pC_VGP_S_VD_S=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VD_S-x_s_VD_S)+0.0*(xg_VGP_S-x_s_VGP_S)+2.0*(+xg_VGP_S_VD_S-x_s_VGP_S_VD_S))+(+Gf2_VGP_S_VD_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VGP_S*(((-Es_VD_S)+(((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S))))-(((delta_nd_VD_S*(1.0+xi1s))+(delta_nd*xi1s_VD_S))))+Gf2_VD_S*(((-Es_VGP_S)+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*(1.0+xi1s))+(delta_nd*xi1s_VGP_S)))+Gf2*(+(+(+0.0-Es_VGP_S_VD_S)+(+delta_1s_VGP_S_VD_S*k_ds+delta_1s_VGP_S*k_ds_VD_S+delta_1s_VD_S*k_ds_VGP_S+delta_1s*k_ds_VGP_S_VD_S))-(+delta_nd_VGP_S_VD_S*(1.0+xi1s)+delta_nd_VGP_S*xi1s_VD_S+delta_nd_VD_S*xi1s_VGP_S+delta_nd*(+0.0+xi1s_VGP_S_VD_S)))));
  pC_VGP_S_VGP_S=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VGP_S-x_s_VGP_S)+0.0*(xg_VGP_S-x_s_VGP_S)+2.0*(+xg_VGP_S_VGP_S-x_s_VGP_S_VGP_S))+(+Gf2_VGP_S_VGP_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VGP_S*(((-Es_VGP_S)+(((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S))))-(((delta_nd_VGP_S*(1.0+xi1s))+(delta_nd*xi1s_VGP_S))))+Gf2_VGP_S*(((-Es_VGP_S)+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*(1.0+xi1s))+(delta_nd*xi1s_VGP_S)))+Gf2*(+(+(+0.0-Es_VGP_S_VGP_S)+(+delta_1s_VGP_S_VGP_S*k_ds+delta_1s_VGP_S*k_ds_VGP_S+delta_1s_VGP_S*k_ds_VGP_S+delta_1s*k_ds_VGP_S_VGP_S))-(+delta_nd_VGP_S_VGP_S*(1.0+xi1s)+delta_nd_VGP_S*xi1s_VGP_S+delta_nd_VGP_S*xi1s_VGP_S+delta_nd*(+0.0+xi1s_VGP_S_VGP_S)))));
  pC_VGP_S_VS_BP=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VS_BP-x_s_VS_BP)+0.0*(xg_VGP_S-x_s_VGP_S)+2.0*(+xg_VGP_S_VS_BP-x_s_VGP_S_VS_BP))+(+Gf2_VGP_S_VS_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VGP_S*(((-Es_VS_BP)+(((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP))))-(((delta_nd_VS_BP*(1.0+xi1s))+(delta_nd*xi1s_VS_BP))))+Gf2_VS_BP*(((-Es_VGP_S)+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*(1.0+xi1s))+(delta_nd*xi1s_VGP_S)))+Gf2*(+(+(+0.0-Es_VGP_S_VS_BP)+(+delta_1s_VGP_S_VS_BP*k_ds+delta_1s_VGP_S*k_ds_VS_BP+delta_1s_VS_BP*k_ds_VGP_S+delta_1s*k_ds_VGP_S_VS_BP))-(+delta_nd_VGP_S_VS_BP*(1.0+xi1s)+delta_nd_VGP_S*xi1s_VS_BP+delta_nd_VS_BP*xi1s_VGP_S+delta_nd*(+0.0+xi1s_VGP_S_VS_BP)))));
#endif
pC_VS_BP=((2.0*(xg_VS_BP-x_s_VS_BP))+((Gf2_VS_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))+(Gf2*(((-Es_VS_BP)+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*(1.0+xi1s))+(delta_nd*xi1s_VS_BP))))));
#if defined(_DERIVATE2)
  pC_VS_BP_VD_S=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VD_S-x_s_VD_S)+0.0*(xg_VS_BP-x_s_VS_BP)+2.0*(+xg_VS_BP_VD_S-x_s_VS_BP_VD_S))+(+Gf2_VS_BP_VD_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VS_BP*(((-Es_VD_S)+(((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S))))-(((delta_nd_VD_S*(1.0+xi1s))+(delta_nd*xi1s_VD_S))))+Gf2_VD_S*(((-Es_VS_BP)+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*(1.0+xi1s))+(delta_nd*xi1s_VS_BP)))+Gf2*(+(+(+0.0-Es_VS_BP_VD_S)+(+delta_1s_VS_BP_VD_S*k_ds+delta_1s_VS_BP*k_ds_VD_S+delta_1s_VD_S*k_ds_VS_BP+delta_1s*k_ds_VS_BP_VD_S))-(+delta_nd_VS_BP_VD_S*(1.0+xi1s)+delta_nd_VS_BP*xi1s_VD_S+delta_nd_VD_S*xi1s_VS_BP+delta_nd*(+0.0+xi1s_VS_BP_VD_S)))));
  pC_VS_BP_VGP_S=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VGP_S-x_s_VGP_S)+0.0*(xg_VS_BP-x_s_VS_BP)+2.0*(+xg_VS_BP_VGP_S-x_s_VS_BP_VGP_S))+(+Gf2_VS_BP_VGP_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VS_BP*(((-Es_VGP_S)+(((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S))))-(((delta_nd_VGP_S*(1.0+xi1s))+(delta_nd*xi1s_VGP_S))))+Gf2_VGP_S*(((-Es_VS_BP)+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*(1.0+xi1s))+(delta_nd*xi1s_VS_BP)))+Gf2*(+(+(+0.0-Es_VS_BP_VGP_S)+(+delta_1s_VS_BP_VGP_S*k_ds+delta_1s_VS_BP*k_ds_VGP_S+delta_1s_VGP_S*k_ds_VS_BP+delta_1s*k_ds_VS_BP_VGP_S))-(+delta_nd_VS_BP_VGP_S*(1.0+xi1s)+delta_nd_VS_BP*xi1s_VGP_S+delta_nd_VGP_S*xi1s_VS_BP+delta_nd*(+0.0+xi1s_VS_BP_VGP_S)))));
  pC_VS_BP_VS_BP=(+(+0.0*(pInst->xg-x_s)+0.0*(xg_VS_BP-x_s_VS_BP)+0.0*(xg_VS_BP-x_s_VS_BP)+2.0*(+xg_VS_BP_VS_BP-x_s_VS_BP_VS_BP))+(+Gf2_VS_BP_VS_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))+Gf2_VS_BP*(((-Es_VS_BP)+(((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP))))-(((delta_nd_VS_BP*(1.0+xi1s))+(delta_nd*xi1s_VS_BP))))+Gf2_VS_BP*(((-Es_VS_BP)+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*(1.0+xi1s))+(delta_nd*xi1s_VS_BP)))+Gf2*(+(+(+0.0-Es_VS_BP_VS_BP)+(+delta_1s_VS_BP_VS_BP*k_ds+delta_1s_VS_BP*k_ds_VS_BP+delta_1s_VS_BP*k_ds_VS_BP+delta_1s*k_ds_VS_BP_VS_BP))-(+delta_nd_VS_BP_VS_BP*(1.0+xi1s)+delta_nd_VS_BP*xi1s_VS_BP+delta_nd_VS_BP*xi1s_VS_BP+delta_nd*(+0.0+xi1s_VS_BP_VS_BP)))));
#endif
#endif
pC=((2.0*(pInst->xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
EXIT_IF_ISNAN(((2.0*(pInst->xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
qC_VD_S=((((Gf2_VD_S*(1.0-k_ds))+(Gf2*(-k_ds_VD_S)))*Ds)+((Gf2*(1.0-k_ds))*Ds_VD_S));
#if defined(_DERIVATE2)
  qC_VD_S_VD_S=(+(+Gf2_VD_S_VD_S*(1.0-k_ds)+Gf2_VD_S*(-k_ds_VD_S)+Gf2_VD_S*(-k_ds_VD_S)+Gf2*(+0.0-k_ds_VD_S_VD_S))*Ds+((Gf2_VD_S*(1.0-k_ds))+(Gf2*(-k_ds_VD_S)))*Ds_VD_S+(((Gf2_VD_S*(1.0-k_ds))+(Gf2*(-k_ds_VD_S))))*Ds_VD_S+(Gf2*(1.0-k_ds))*Ds_VD_S_VD_S);
  qC_VD_S_VGP_S=(+(+Gf2_VD_S_VGP_S*(1.0-k_ds)+Gf2_VD_S*(-k_ds_VGP_S)+Gf2_VGP_S*(-k_ds_VD_S)+Gf2*(+0.0-k_ds_VD_S_VGP_S))*Ds+((Gf2_VD_S*(1.0-k_ds))+(Gf2*(-k_ds_VD_S)))*Ds_VGP_S+(((Gf2_VGP_S*(1.0-k_ds))+(Gf2*(-k_ds_VGP_S))))*Ds_VD_S+(Gf2*(1.0-k_ds))*Ds_VD_S_VGP_S);
  qC_VD_S_VS_BP=(+(+Gf2_VD_S_VS_BP*(1.0-k_ds)+Gf2_VD_S*(-k_ds_VS_BP)+Gf2_VS_BP*(-k_ds_VD_S)+Gf2*(+0.0-k_ds_VD_S_VS_BP))*Ds+((Gf2_VD_S*(1.0-k_ds))+(Gf2*(-k_ds_VD_S)))*Ds_VS_BP+(((Gf2_VS_BP*(1.0-k_ds))+(Gf2*(-k_ds_VS_BP))))*Ds_VD_S+(Gf2*(1.0-k_ds))*Ds_VD_S_VS_BP);
#endif
qC_VGP_S=((((Gf2_VGP_S*(1.0-k_ds))+(Gf2*(-k_ds_VGP_S)))*Ds)+((Gf2*(1.0-k_ds))*Ds_VGP_S));
#if defined(_DERIVATE2)
  qC_VGP_S_VD_S=(+(+Gf2_VGP_S_VD_S*(1.0-k_ds)+Gf2_VGP_S*(-k_ds_VD_S)+Gf2_VD_S*(-k_ds_VGP_S)+Gf2*(+0.0-k_ds_VGP_S_VD_S))*Ds+((Gf2_VGP_S*(1.0-k_ds))+(Gf2*(-k_ds_VGP_S)))*Ds_VD_S+(((Gf2_VD_S*(1.0-k_ds))+(Gf2*(-k_ds_VD_S))))*Ds_VGP_S+(Gf2*(1.0-k_ds))*Ds_VGP_S_VD_S);
  qC_VGP_S_VGP_S=(+(+Gf2_VGP_S_VGP_S*(1.0-k_ds)+Gf2_VGP_S*(-k_ds_VGP_S)+Gf2_VGP_S*(-k_ds_VGP_S)+Gf2*(+0.0-k_ds_VGP_S_VGP_S))*Ds+((Gf2_VGP_S*(1.0-k_ds))+(Gf2*(-k_ds_VGP_S)))*Ds_VGP_S+(((Gf2_VGP_S*(1.0-k_ds))+(Gf2*(-k_ds_VGP_S))))*Ds_VGP_S+(Gf2*(1.0-k_ds))*Ds_VGP_S_VGP_S);
  qC_VGP_S_VS_BP=(+(+Gf2_VGP_S_VS_BP*(1.0-k_ds)+Gf2_VGP_S*(-k_ds_VS_BP)+Gf2_VS_BP*(-k_ds_VGP_S)+Gf2*(+0.0-k_ds_VGP_S_VS_BP))*Ds+((Gf2_VGP_S*(1.0-k_ds))+(Gf2*(-k_ds_VGP_S)))*Ds_VS_BP+(((Gf2_VS_BP*(1.0-k_ds))+(Gf2*(-k_ds_VS_BP))))*Ds_VGP_S+(Gf2*(1.0-k_ds))*Ds_VGP_S_VS_BP);
#endif
qC_VS_BP=((((Gf2_VS_BP*(1.0-k_ds))+(Gf2*(-k_ds_VS_BP)))*Ds)+((Gf2*(1.0-k_ds))*Ds_VS_BP));
#if defined(_DERIVATE2)
  qC_VS_BP_VD_S=(+(+Gf2_VS_BP_VD_S*(1.0-k_ds)+Gf2_VS_BP*(-k_ds_VD_S)+Gf2_VD_S*(-k_ds_VS_BP)+Gf2*(+0.0-k_ds_VS_BP_VD_S))*Ds+((Gf2_VS_BP*(1.0-k_ds))+(Gf2*(-k_ds_VS_BP)))*Ds_VD_S+(((Gf2_VD_S*(1.0-k_ds))+(Gf2*(-k_ds_VD_S))))*Ds_VS_BP+(Gf2*(1.0-k_ds))*Ds_VS_BP_VD_S);
  qC_VS_BP_VGP_S=(+(+Gf2_VS_BP_VGP_S*(1.0-k_ds)+Gf2_VS_BP*(-k_ds_VGP_S)+Gf2_VGP_S*(-k_ds_VS_BP)+Gf2*(+0.0-k_ds_VS_BP_VGP_S))*Ds+((Gf2_VS_BP*(1.0-k_ds))+(Gf2*(-k_ds_VS_BP)))*Ds_VGP_S+(((Gf2_VGP_S*(1.0-k_ds))+(Gf2*(-k_ds_VGP_S))))*Ds_VS_BP+(Gf2*(1.0-k_ds))*Ds_VS_BP_VGP_S);
  qC_VS_BP_VS_BP=(+(+Gf2_VS_BP_VS_BP*(1.0-k_ds)+Gf2_VS_BP*(-k_ds_VS_BP)+Gf2_VS_BP*(-k_ds_VS_BP)+Gf2*(+0.0-k_ds_VS_BP_VS_BP))*Ds+((Gf2_VS_BP*(1.0-k_ds))+(Gf2*(-k_ds_VS_BP)))*Ds_VS_BP+(((Gf2_VS_BP*(1.0-k_ds))+(Gf2*(-k_ds_VS_BP))))*Ds_VS_BP+(Gf2*(1.0-k_ds))*Ds_VS_BP_VS_BP);
#endif
#endif
qC=((Gf2*(1.0-k_ds))*Ds);
EXIT_IF_ISNAN(((Gf2*(1.0-k_ds))*Ds))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-((Gf2_VGP_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))+(Gf2*((Es_VGP_S+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0-(+0.0*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VGP_S*((0.0)-(0.0))+0.0*((Es_VGP_S+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S)))+Gf2*(+(+0.0+(+0.0*k_ds+delta_1s_VGP_S*0.0+0.0*k_ds_VGP_S+delta_1s*0.0))-(+0.0*xi2s+delta_nd_VGP_S*0.0+0.0*xi2s_VGP_S+delta_nd*0.0))));
  temp_VGP_S_VS_BS=(+0.0-(+0.0*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VGP_S*((0.0)-(0.0))+0.0*((Es_VGP_S+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S)))+Gf2*(+(+0.0+(+0.0*k_ds+delta_1s_VGP_S*0.0+0.0*k_ds_VGP_S+delta_1s*0.0))-(+0.0*xi2s+delta_nd_VGP_S*0.0+0.0*xi2s_VGP_S+delta_nd*0.0))));
  temp_VGP_S_VGP_S=(+0.0-(+Gf2_VGP_S_VGP_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VGP_S*((Es_VGP_S+(((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S))))-(((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S))))+Gf2_VGP_S*((Es_VGP_S+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S)))+Gf2*(+(+Es_VGP_S_VGP_S+(+delta_1s_VGP_S_VGP_S*k_ds+delta_1s_VGP_S*k_ds_VGP_S+delta_1s_VGP_S*k_ds_VGP_S+delta_1s*k_ds_VGP_S_VGP_S))-(+delta_nd_VGP_S_VGP_S*xi2s+delta_nd_VGP_S*xi2s_VGP_S+delta_nd_VGP_S*xi2s_VGP_S+delta_nd*xi2s_VGP_S_VGP_S))));
  temp_VGP_S_VD_S=(+0.0-(+Gf2_VGP_S_VD_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VGP_S*((Es_VD_S+(((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S))))-(((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S))))+Gf2_VD_S*((Es_VGP_S+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S)))+Gf2*(+(+Es_VGP_S_VD_S+(+delta_1s_VGP_S_VD_S*k_ds+delta_1s_VGP_S*k_ds_VD_S+delta_1s_VD_S*k_ds_VGP_S+delta_1s*k_ds_VGP_S_VD_S))-(+delta_nd_VGP_S_VD_S*xi2s+delta_nd_VGP_S*xi2s_VD_S+delta_nd_VD_S*xi2s_VGP_S+delta_nd*xi2s_VGP_S_VD_S))));
  temp_VGP_S_VS_BP=(+0.0-(+Gf2_VGP_S_VS_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VGP_S*((Es_VS_BP+(((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP))))-(((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP))))+Gf2_VS_BP*((Es_VGP_S+((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S)))-((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S)))+Gf2*(+(+Es_VGP_S_VS_BP+(+delta_1s_VGP_S_VS_BP*k_ds+delta_1s_VGP_S*k_ds_VS_BP+delta_1s_VS_BP*k_ds_VGP_S+delta_1s*k_ds_VGP_S_VS_BP))-(+delta_nd_VGP_S_VS_BP*xi2s+delta_nd_VGP_S*xi2s_VS_BP+delta_nd_VS_BP*xi2s_VGP_S+delta_nd*xi2s_VGP_S_VS_BP))));
#endif
temp_VD_S=(-((Gf2_VD_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))+(Gf2*((Es_VD_S+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0-(+0.0*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VD_S*((0.0)-(0.0))+0.0*((Es_VD_S+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S)))+Gf2*(+(+0.0+(+0.0*k_ds+delta_1s_VD_S*0.0+0.0*k_ds_VD_S+delta_1s*0.0))-(+0.0*xi2s+delta_nd_VD_S*0.0+0.0*xi2s_VD_S+delta_nd*0.0))));
  temp_VD_S_VS_BS=(+0.0-(+0.0*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VD_S*((0.0)-(0.0))+0.0*((Es_VD_S+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S)))+Gf2*(+(+0.0+(+0.0*k_ds+delta_1s_VD_S*0.0+0.0*k_ds_VD_S+delta_1s*0.0))-(+0.0*xi2s+delta_nd_VD_S*0.0+0.0*xi2s_VD_S+delta_nd*0.0))));
  temp_VD_S_VGP_S=(+0.0-(+Gf2_VD_S_VGP_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VD_S*((Es_VGP_S+(((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S))))-(((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S))))+Gf2_VGP_S*((Es_VD_S+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S)))+Gf2*(+(+Es_VD_S_VGP_S+(+delta_1s_VD_S_VGP_S*k_ds+delta_1s_VD_S*k_ds_VGP_S+delta_1s_VGP_S*k_ds_VD_S+delta_1s*k_ds_VD_S_VGP_S))-(+delta_nd_VD_S_VGP_S*xi2s+delta_nd_VD_S*xi2s_VGP_S+delta_nd_VGP_S*xi2s_VD_S+delta_nd*xi2s_VD_S_VGP_S))));
  temp_VD_S_VD_S=(+0.0-(+Gf2_VD_S_VD_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VD_S*((Es_VD_S+(((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S))))-(((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S))))+Gf2_VD_S*((Es_VD_S+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S)))+Gf2*(+(+Es_VD_S_VD_S+(+delta_1s_VD_S_VD_S*k_ds+delta_1s_VD_S*k_ds_VD_S+delta_1s_VD_S*k_ds_VD_S+delta_1s*k_ds_VD_S_VD_S))-(+delta_nd_VD_S_VD_S*xi2s+delta_nd_VD_S*xi2s_VD_S+delta_nd_VD_S*xi2s_VD_S+delta_nd*xi2s_VD_S_VD_S))));
  temp_VD_S_VS_BP=(+0.0-(+Gf2_VD_S_VS_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VD_S*((Es_VS_BP+(((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP))))-(((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP))))+Gf2_VS_BP*((Es_VD_S+((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S)))-((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S)))+Gf2*(+(+Es_VD_S_VS_BP+(+delta_1s_VD_S_VS_BP*k_ds+delta_1s_VD_S*k_ds_VS_BP+delta_1s_VS_BP*k_ds_VD_S+delta_1s*k_ds_VD_S_VS_BP))-(+delta_nd_VD_S_VS_BP*xi2s+delta_nd_VD_S*xi2s_VS_BP+delta_nd_VS_BP*xi2s_VD_S+delta_nd*xi2s_VD_S_VS_BP))));
#endif
temp_VS_BP=(-((Gf2_VS_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))+(Gf2*((Es_VS_BP+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0-(+0.0*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VS_BP*((0.0)-(0.0))+0.0*((Es_VS_BP+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP)))+Gf2*(+(+0.0+(+0.0*k_ds+delta_1s_VS_BP*0.0+0.0*k_ds_VS_BP+delta_1s*0.0))-(+0.0*xi2s+delta_nd_VS_BP*0.0+0.0*xi2s_VS_BP+delta_nd*0.0))));
  temp_VS_BP_VS_BS=(+0.0-(+0.0*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VS_BP*((0.0)-(0.0))+0.0*((Es_VS_BP+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP)))+Gf2*(+(+0.0+(+0.0*k_ds+delta_1s_VS_BP*0.0+0.0*k_ds_VS_BP+delta_1s*0.0))-(+0.0*xi2s+delta_nd_VS_BP*0.0+0.0*xi2s_VS_BP+delta_nd*0.0))));
  temp_VS_BP_VGP_S=(+0.0-(+Gf2_VS_BP_VGP_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VS_BP*((Es_VGP_S+(((delta_1s_VGP_S*k_ds)+(delta_1s*k_ds_VGP_S))))-(((delta_nd_VGP_S*xi2s)+(delta_nd*xi2s_VGP_S))))+Gf2_VGP_S*((Es_VS_BP+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP)))+Gf2*(+(+Es_VS_BP_VGP_S+(+delta_1s_VS_BP_VGP_S*k_ds+delta_1s_VS_BP*k_ds_VGP_S+delta_1s_VGP_S*k_ds_VS_BP+delta_1s*k_ds_VS_BP_VGP_S))-(+delta_nd_VS_BP_VGP_S*xi2s+delta_nd_VS_BP*xi2s_VGP_S+delta_nd_VGP_S*xi2s_VS_BP+delta_nd*xi2s_VS_BP_VGP_S))));
  temp_VS_BP_VD_S=(+0.0-(+Gf2_VS_BP_VD_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VS_BP*((Es_VD_S+(((delta_1s_VD_S*k_ds)+(delta_1s*k_ds_VD_S))))-(((delta_nd_VD_S*xi2s)+(delta_nd*xi2s_VD_S))))+Gf2_VD_S*((Es_VS_BP+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP)))+Gf2*(+(+Es_VS_BP_VD_S+(+delta_1s_VS_BP_VD_S*k_ds+delta_1s_VS_BP*k_ds_VD_S+delta_1s_VD_S*k_ds_VS_BP+delta_1s*k_ds_VS_BP_VD_S))-(+delta_nd_VS_BP_VD_S*xi2s+delta_nd_VS_BP*xi2s_VD_S+delta_nd_VD_S*xi2s_VS_BP+delta_nd*xi2s_VS_BP_VD_S))));
  temp_VS_BP_VS_BP=(+0.0-(+Gf2_VS_BP_VS_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))+Gf2_VS_BP*((Es_VS_BP+(((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP))))-(((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP))))+Gf2_VS_BP*((Es_VS_BP+((delta_1s_VS_BP*k_ds)+(delta_1s*k_ds_VS_BP)))-((delta_nd_VS_BP*xi2s)+(delta_nd*xi2s_VS_BP)))+Gf2*(+(+Es_VS_BP_VS_BP+(+delta_1s_VS_BP_VS_BP*k_ds+delta_1s_VS_BP*k_ds_VS_BP+delta_1s_VS_BP*k_ds_VS_BP+delta_1s*k_ds_VS_BP_VS_BP))-(+delta_nd_VS_BP_VS_BP*xi2s+delta_nd_VS_BP*xi2s_VS_BP+delta_nd_VS_BP*xi2s_VS_BP+delta_nd*xi2s_VS_BP_VS_BP))));
#endif
#endif
temp=(2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
EXIT_IF_ISNAN((2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s)))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(((pC_VGP_S*pC)+(pC*pC_VGP_S))-(2.0*((temp_VGP_S*qC)+(temp*qC_VGP_S))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+(+0.0*pC+pC_VGP_S*0.0+0.0*pC_VGP_S+pC*0.0)-(+0.0*(temp*qC)+0.0*(temp_VD_BD*qC)+0.0*((temp_VGP_S*qC)+(temp*qC_VGP_S))+2.0*(+temp_VGP_S_VD_BD*qC+temp_VGP_S*0.0+temp_VD_BD*qC_VGP_S+temp*0.0)));
  temp_VGP_S_VS_BS=(+(+0.0*pC+pC_VGP_S*0.0+0.0*pC_VGP_S+pC*0.0)-(+0.0*(temp*qC)+0.0*(temp_VS_BS*qC)+0.0*((temp_VGP_S*qC)+(temp*qC_VGP_S))+2.0*(+temp_VGP_S_VS_BS*qC+temp_VGP_S*0.0+temp_VS_BS*qC_VGP_S+temp*0.0)));
  temp_VGP_S_VGP_S=(+(+pC_VGP_S_VGP_S*pC+pC_VGP_S*pC_VGP_S+pC_VGP_S*pC_VGP_S+pC*pC_VGP_S_VGP_S)-(+0.0*(temp*qC)+0.0*(((temp_VGP_S*qC)+(temp*qC_VGP_S)))+0.0*((temp_VGP_S*qC)+(temp*qC_VGP_S))+2.0*(+temp_VGP_S_VGP_S*qC+temp_VGP_S*qC_VGP_S+temp_VGP_S*qC_VGP_S+temp*qC_VGP_S_VGP_S)));
  temp_VGP_S_VD_S=(+(+pC_VGP_S_VD_S*pC+pC_VGP_S*pC_VD_S+pC_VD_S*pC_VGP_S+pC*pC_VGP_S_VD_S)-(+0.0*(temp*qC)+0.0*(((temp_VD_S*qC)+(temp*qC_VD_S)))+0.0*((temp_VGP_S*qC)+(temp*qC_VGP_S))+2.0*(+temp_VGP_S_VD_S*qC+temp_VGP_S*qC_VD_S+temp_VD_S*qC_VGP_S+temp*qC_VGP_S_VD_S)));
  temp_VGP_S_VS_BP=(+(+pC_VGP_S_VS_BP*pC+pC_VGP_S*pC_VS_BP+pC_VS_BP*pC_VGP_S+pC*pC_VGP_S_VS_BP)-(+0.0*(temp*qC)+0.0*(((temp_VS_BP*qC)+(temp*qC_VS_BP)))+0.0*((temp_VGP_S*qC)+(temp*qC_VGP_S))+2.0*(+temp_VGP_S_VS_BP*qC+temp_VGP_S*qC_VS_BP+temp_VS_BP*qC_VGP_S+temp*qC_VGP_S_VS_BP)));
#endif
temp_VD_S=(((pC_VD_S*pC)+(pC*pC_VD_S))-(2.0*((temp_VD_S*qC)+(temp*qC_VD_S))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+(+0.0*pC+pC_VD_S*0.0+0.0*pC_VD_S+pC*0.0)-(+0.0*(temp*qC)+0.0*(temp_VD_BD*qC)+0.0*((temp_VD_S*qC)+(temp*qC_VD_S))+2.0*(+temp_VD_S_VD_BD*qC+temp_VD_S*0.0+temp_VD_BD*qC_VD_S+temp*0.0)));
  temp_VD_S_VS_BS=(+(+0.0*pC+pC_VD_S*0.0+0.0*pC_VD_S+pC*0.0)-(+0.0*(temp*qC)+0.0*(temp_VS_BS*qC)+0.0*((temp_VD_S*qC)+(temp*qC_VD_S))+2.0*(+temp_VD_S_VS_BS*qC+temp_VD_S*0.0+temp_VS_BS*qC_VD_S+temp*0.0)));
  temp_VD_S_VGP_S=(+(+pC_VD_S_VGP_S*pC+pC_VD_S*pC_VGP_S+pC_VGP_S*pC_VD_S+pC*pC_VD_S_VGP_S)-(+0.0*(temp*qC)+0.0*(((temp_VGP_S*qC)+(temp*qC_VGP_S)))+0.0*((temp_VD_S*qC)+(temp*qC_VD_S))+2.0*(+temp_VD_S_VGP_S*qC+temp_VD_S*qC_VGP_S+temp_VGP_S*qC_VD_S+temp*qC_VD_S_VGP_S)));
  temp_VD_S_VD_S=(+(+pC_VD_S_VD_S*pC+pC_VD_S*pC_VD_S+pC_VD_S*pC_VD_S+pC*pC_VD_S_VD_S)-(+0.0*(temp*qC)+0.0*(((temp_VD_S*qC)+(temp*qC_VD_S)))+0.0*((temp_VD_S*qC)+(temp*qC_VD_S))+2.0*(+temp_VD_S_VD_S*qC+temp_VD_S*qC_VD_S+temp_VD_S*qC_VD_S+temp*qC_VD_S_VD_S)));
  temp_VD_S_VS_BP=(+(+pC_VD_S_VS_BP*pC+pC_VD_S*pC_VS_BP+pC_VS_BP*pC_VD_S+pC*pC_VD_S_VS_BP)-(+0.0*(temp*qC)+0.0*(((temp_VS_BP*qC)+(temp*qC_VS_BP)))+0.0*((temp_VD_S*qC)+(temp*qC_VD_S))+2.0*(+temp_VD_S_VS_BP*qC+temp_VD_S*qC_VS_BP+temp_VS_BP*qC_VD_S+temp*qC_VD_S_VS_BP)));
#endif
temp_VS_BP=(((pC_VS_BP*pC)+(pC*pC_VS_BP))-(2.0*((temp_VS_BP*qC)+(temp*qC_VS_BP))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+(+0.0*pC+pC_VS_BP*0.0+0.0*pC_VS_BP+pC*0.0)-(+0.0*(temp*qC)+0.0*(temp_VD_BD*qC)+0.0*((temp_VS_BP*qC)+(temp*qC_VS_BP))+2.0*(+temp_VS_BP_VD_BD*qC+temp_VS_BP*0.0+temp_VD_BD*qC_VS_BP+temp*0.0)));
  temp_VS_BP_VS_BS=(+(+0.0*pC+pC_VS_BP*0.0+0.0*pC_VS_BP+pC*0.0)-(+0.0*(temp*qC)+0.0*(temp_VS_BS*qC)+0.0*((temp_VS_BP*qC)+(temp*qC_VS_BP))+2.0*(+temp_VS_BP_VS_BS*qC+temp_VS_BP*0.0+temp_VS_BS*qC_VS_BP+temp*0.0)));
  temp_VS_BP_VGP_S=(+(+pC_VS_BP_VGP_S*pC+pC_VS_BP*pC_VGP_S+pC_VGP_S*pC_VS_BP+pC*pC_VS_BP_VGP_S)-(+0.0*(temp*qC)+0.0*(((temp_VGP_S*qC)+(temp*qC_VGP_S)))+0.0*((temp_VS_BP*qC)+(temp*qC_VS_BP))+2.0*(+temp_VS_BP_VGP_S*qC+temp_VS_BP*qC_VGP_S+temp_VGP_S*qC_VS_BP+temp*qC_VS_BP_VGP_S)));
  temp_VS_BP_VD_S=(+(+pC_VS_BP_VD_S*pC+pC_VS_BP*pC_VD_S+pC_VD_S*pC_VS_BP+pC*pC_VS_BP_VD_S)-(+0.0*(temp*qC)+0.0*(((temp_VD_S*qC)+(temp*qC_VD_S)))+0.0*((temp_VS_BP*qC)+(temp*qC_VS_BP))+2.0*(+temp_VS_BP_VD_S*qC+temp_VS_BP*qC_VD_S+temp_VD_S*qC_VS_BP+temp*qC_VS_BP_VD_S)));
  temp_VS_BP_VS_BP=(+(+pC_VS_BP_VS_BP*pC+pC_VS_BP*pC_VS_BP+pC_VS_BP*pC_VS_BP+pC*pC_VS_BP_VS_BP)-(+0.0*(temp*qC)+0.0*(((temp_VS_BP*qC)+(temp*qC_VS_BP)))+0.0*((temp_VS_BP*qC)+(temp*qC_VS_BP))+2.0*(+temp_VS_BP_VS_BP*qC+temp_VS_BP*qC_VS_BP+temp_VS_BP*qC_VS_BP+temp*qC_VS_BP_VS_BP)));
#endif
#endif
temp=((pC*pC)-(2.0*(temp*qC)));
EXIT_IF_ISNAN(((pC*pC)-(2.0*(temp*qC))))
{
double m00_sqrt(d00_sqrt0,temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_ds_VD_S=(2.0*((qC_VD_S*(pC+d00_sqrt0)-qC*(pC_VD_S+temp_VD_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
#if defined(_DERIVATE2)
  x_ds_VD_S_VD_S=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VD_S*(pC+d00_sqrt0)-qC*(pC_VD_S+temp_VD_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VD_S*(pC+d00_sqrt0)-qC*(pC_VD_S+temp_VD_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VD_S_VD_S/(pC+d00_sqrt0)-(qC_VD_S*(pC_VD_S+temp_VD_S*d10_sqrt0)+qC_VD_S*(pC_VD_S+temp_VD_S*d10_sqrt0)+qC*(+pC_VD_S_VD_S+(m20_sqrt(temp)*temp_VD_S*temp_VD_S+d10_sqrt0*temp_VD_S_VD_S)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VD_S+temp_VD_S*d10_sqrt0)*(pC_VD_S+temp_VD_S*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
  x_ds_VD_S_VGP_S=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VGP_S*(pC+d00_sqrt0)-qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VD_S*(pC+d00_sqrt0)-qC*(pC_VD_S+temp_VD_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VD_S_VGP_S/(pC+d00_sqrt0)-(qC_VD_S*(pC_VGP_S+temp_VGP_S*d10_sqrt0)+qC_VGP_S*(pC_VD_S+temp_VD_S*d10_sqrt0)+qC*(+pC_VD_S_VGP_S+(m20_sqrt(temp)*temp_VGP_S*temp_VD_S+d10_sqrt0*temp_VD_S_VGP_S)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VD_S+temp_VD_S*d10_sqrt0)*(pC_VGP_S+temp_VGP_S*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
  x_ds_VD_S_VS_BP=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VS_BP*(pC+d00_sqrt0)-qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VD_S*(pC+d00_sqrt0)-qC*(pC_VD_S+temp_VD_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VD_S_VS_BP/(pC+d00_sqrt0)-(qC_VD_S*(pC_VS_BP+temp_VS_BP*d10_sqrt0)+qC_VS_BP*(pC_VD_S+temp_VD_S*d10_sqrt0)+qC*(+pC_VD_S_VS_BP+(m20_sqrt(temp)*temp_VS_BP*temp_VD_S+d10_sqrt0*temp_VD_S_VS_BP)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VD_S+temp_VD_S*d10_sqrt0)*(pC_VS_BP+temp_VS_BP*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
#endif
x_ds_VGP_S=(2.0*((qC_VGP_S*(pC+d00_sqrt0)-qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
#if defined(_DERIVATE2)
  x_ds_VGP_S_VD_S=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VD_S*(pC+d00_sqrt0)-qC*(pC_VD_S+temp_VD_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VGP_S*(pC+d00_sqrt0)-qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VGP_S_VD_S/(pC+d00_sqrt0)-(qC_VGP_S*(pC_VD_S+temp_VD_S*d10_sqrt0)+qC_VD_S*(pC_VGP_S+temp_VGP_S*d10_sqrt0)+qC*(+pC_VGP_S_VD_S+(m20_sqrt(temp)*temp_VD_S*temp_VGP_S+d10_sqrt0*temp_VGP_S_VD_S)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0)*(pC_VD_S+temp_VD_S*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
  x_ds_VGP_S_VGP_S=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VGP_S*(pC+d00_sqrt0)-qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VGP_S*(pC+d00_sqrt0)-qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VGP_S_VGP_S/(pC+d00_sqrt0)-(qC_VGP_S*(pC_VGP_S+temp_VGP_S*d10_sqrt0)+qC_VGP_S*(pC_VGP_S+temp_VGP_S*d10_sqrt0)+qC*(+pC_VGP_S_VGP_S+(m20_sqrt(temp)*temp_VGP_S*temp_VGP_S+d10_sqrt0*temp_VGP_S_VGP_S)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0)*(pC_VGP_S+temp_VGP_S*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
  x_ds_VGP_S_VS_BP=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VS_BP*(pC+d00_sqrt0)-qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VGP_S*(pC+d00_sqrt0)-qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VGP_S_VS_BP/(pC+d00_sqrt0)-(qC_VGP_S*(pC_VS_BP+temp_VS_BP*d10_sqrt0)+qC_VS_BP*(pC_VGP_S+temp_VGP_S*d10_sqrt0)+qC*(+pC_VGP_S_VS_BP+(m20_sqrt(temp)*temp_VS_BP*temp_VGP_S+d10_sqrt0*temp_VGP_S_VS_BP)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0)*(pC_VS_BP+temp_VS_BP*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
#endif
x_ds_VS_BP=(2.0*((qC_VS_BP*(pC+d00_sqrt0)-qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
#if defined(_DERIVATE2)
  x_ds_VS_BP_VD_S=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VD_S*(pC+d00_sqrt0)-qC*(pC_VD_S+temp_VD_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VS_BP*(pC+d00_sqrt0)-qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VS_BP_VD_S/(pC+d00_sqrt0)-(qC_VS_BP*(pC_VD_S+temp_VD_S*d10_sqrt0)+qC_VD_S*(pC_VS_BP+temp_VS_BP*d10_sqrt0)+qC*(+pC_VS_BP_VD_S+(m20_sqrt(temp)*temp_VD_S*temp_VS_BP+d10_sqrt0*temp_VS_BP_VD_S)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0)*(pC_VD_S+temp_VD_S*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
  x_ds_VS_BP_VGP_S=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VGP_S*(pC+d00_sqrt0)-qC*(pC_VGP_S+temp_VGP_S*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VS_BP*(pC+d00_sqrt0)-qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VS_BP_VGP_S/(pC+d00_sqrt0)-(qC_VS_BP*(pC_VGP_S+temp_VGP_S*d10_sqrt0)+qC_VGP_S*(pC_VS_BP+temp_VS_BP*d10_sqrt0)+qC*(+pC_VS_BP_VGP_S+(m20_sqrt(temp)*temp_VGP_S*temp_VS_BP+d10_sqrt0*temp_VS_BP_VGP_S)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0)*(pC_VGP_S+temp_VGP_S*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
  x_ds_VS_BP_VS_BP=(+0.0*(qC/(pC+d00_sqrt0))+0.0*((qC_VS_BP*(pC+d00_sqrt0)-qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+0.0*((qC_VS_BP*(pC+d00_sqrt0)-qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0))/(pC+d00_sqrt0)/(pC+d00_sqrt0))+2.0*(qC_VS_BP_VS_BP/(pC+d00_sqrt0)-(qC_VS_BP*(pC_VS_BP+temp_VS_BP*d10_sqrt0)+qC_VS_BP*(pC_VS_BP+temp_VS_BP*d10_sqrt0)+qC*(+pC_VS_BP_VS_BP+(m20_sqrt(temp)*temp_VS_BP*temp_VS_BP+d10_sqrt0*temp_VS_BP_VS_BP)))/(pC+d00_sqrt0)/(pC+d00_sqrt0)+2*qC*(pC_VS_BP+temp_VS_BP*d10_sqrt0)*(pC_VS_BP+temp_VS_BP*d10_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)/(pC+d00_sqrt0)));
#endif
#endif
x_ds=(2.0*(qC/(pC+d00_sqrt0)));
EXIT_IF_ISNAN((2.0*(qC/(pC+d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_d_VD_S=(x_s_VD_S+x_ds_VD_S);
#if defined(_DERIVATE2)
  x_d_VD_S_VD_S=(+x_s_VD_S_VD_S+x_ds_VD_S_VD_S);
  x_d_VD_S_VGP_S=(+x_s_VD_S_VGP_S+x_ds_VD_S_VGP_S);
  x_d_VD_S_VS_BP=(+x_s_VD_S_VS_BP+x_ds_VD_S_VS_BP);
#endif
x_d_VGP_S=(x_s_VGP_S+x_ds_VGP_S);
#if defined(_DERIVATE2)
  x_d_VGP_S_VD_S=(+x_s_VGP_S_VD_S+x_ds_VGP_S_VD_S);
  x_d_VGP_S_VGP_S=(+x_s_VGP_S_VGP_S+x_ds_VGP_S_VGP_S);
  x_d_VGP_S_VS_BP=(+x_s_VGP_S_VS_BP+x_ds_VGP_S_VS_BP);
#endif
x_d_VS_BP=(x_s_VS_BP+x_ds_VS_BP);
#if defined(_DERIVATE2)
  x_d_VS_BP_VD_S=(+x_s_VS_BP_VD_S+x_ds_VS_BP_VD_S);
  x_d_VS_BP_VGP_S=(+x_s_VS_BP_VGP_S+x_ds_VS_BP_VGP_S);
  x_d_VS_BP_VS_BP=(+x_s_VS_BP_VS_BP+x_ds_VS_BP_VS_BP);
#endif
#endif
x_d=(x_s+x_ds);
EXIT_IF_ISNAN((x_s+x_ds))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
dps_VD_S=x_ds_VD_S*pInst->phit1;
#if defined(_DERIVATE2)
  dps_VD_S_VD_S=(+x_ds_VD_S_VD_S*pInst->phit1+x_ds_VD_S*0.0+x_ds_VD_S*0.0+x_ds*0.0);
  dps_VD_S_VGP_S=(+x_ds_VD_S_VGP_S*pInst->phit1+x_ds_VD_S*0.0+x_ds_VGP_S*0.0+x_ds*0.0);
  dps_VD_S_VS_BP=(+x_ds_VD_S_VS_BP*pInst->phit1+x_ds_VD_S*0.0+x_ds_VS_BP*0.0+x_ds*0.0);
#endif
dps_VGP_S=x_ds_VGP_S*pInst->phit1;
#if defined(_DERIVATE2)
  dps_VGP_S_VD_S=(+x_ds_VGP_S_VD_S*pInst->phit1+x_ds_VGP_S*0.0+x_ds_VD_S*0.0+x_ds*0.0);
  dps_VGP_S_VGP_S=(+x_ds_VGP_S_VGP_S*pInst->phit1+x_ds_VGP_S*0.0+x_ds_VGP_S*0.0+x_ds*0.0);
  dps_VGP_S_VS_BP=(+x_ds_VGP_S_VS_BP*pInst->phit1+x_ds_VGP_S*0.0+x_ds_VS_BP*0.0+x_ds*0.0);
#endif
dps_VS_BP=x_ds_VS_BP*pInst->phit1;
#if defined(_DERIVATE2)
  dps_VS_BP_VD_S=(+x_ds_VS_BP_VD_S*pInst->phit1+x_ds_VS_BP*0.0+x_ds_VD_S*0.0+x_ds*0.0);
  dps_VS_BP_VGP_S=(+x_ds_VS_BP_VGP_S*pInst->phit1+x_ds_VS_BP*0.0+x_ds_VGP_S*0.0+x_ds*0.0);
  dps_VS_BP_VS_BP=(+x_ds_VS_BP_VS_BP*pInst->phit1+x_ds_VS_BP*0.0+x_ds_VS_BP*0.0+x_ds*0.0);
#endif
#endif
pInst->dps=(x_ds*pInst->phit1);
EXIT_IF_ISNAN((x_ds*pInst->phit1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xi0d_VD_S=((((x_d_VD_S*x_d)+(x_d*x_d_VD_S))*(2.0+(x_d*x_d))-(x_d*x_d)*((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
#if defined(_DERIVATE2)
  xi0d_VD_S_VD_S=((+x_d_VD_S_VD_S*x_d+x_d_VD_S*x_d_VD_S+x_d_VD_S*x_d_VD_S+x_d*x_d_VD_S_VD_S)/(2.0+(x_d*x_d))-(((x_d_VD_S*x_d)+(x_d*x_d_VD_S))*(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))+(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))*((x_d_VD_S*x_d)+(x_d*x_d_VD_S))+(x_d*x_d)*(+0.0+(+x_d_VD_S_VD_S*x_d+x_d_VD_S*x_d_VD_S+x_d_VD_S*x_d_VD_S+x_d*x_d_VD_S_VD_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VD_S*x_d)+(x_d*x_d_VD_S))*(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
  xi0d_VD_S_VGP_S=((+x_d_VD_S_VGP_S*x_d+x_d_VD_S*x_d_VGP_S+x_d_VGP_S*x_d_VD_S+x_d*x_d_VD_S_VGP_S)/(2.0+(x_d*x_d))-(((x_d_VD_S*x_d)+(x_d*x_d_VD_S))*(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))+(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))*((x_d_VD_S*x_d)+(x_d*x_d_VD_S))+(x_d*x_d)*(+0.0+(+x_d_VD_S_VGP_S*x_d+x_d_VD_S*x_d_VGP_S+x_d_VGP_S*x_d_VD_S+x_d*x_d_VD_S_VGP_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VD_S*x_d)+(x_d*x_d_VD_S))*(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
  xi0d_VD_S_VS_BP=((+x_d_VD_S_VS_BP*x_d+x_d_VD_S*x_d_VS_BP+x_d_VS_BP*x_d_VD_S+x_d*x_d_VD_S_VS_BP)/(2.0+(x_d*x_d))-(((x_d_VD_S*x_d)+(x_d*x_d_VD_S))*(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))+(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))*((x_d_VD_S*x_d)+(x_d*x_d_VD_S))+(x_d*x_d)*(+0.0+(+x_d_VD_S_VS_BP*x_d+x_d_VD_S*x_d_VS_BP+x_d_VS_BP*x_d_VD_S+x_d*x_d_VD_S_VS_BP)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VD_S*x_d)+(x_d*x_d_VD_S))*(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
#endif
xi0d_VGP_S=((((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))*(2.0+(x_d*x_d))-(x_d*x_d)*((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
#if defined(_DERIVATE2)
  xi0d_VGP_S_VD_S=((+x_d_VGP_S_VD_S*x_d+x_d_VGP_S*x_d_VD_S+x_d_VD_S*x_d_VGP_S+x_d*x_d_VGP_S_VD_S)/(2.0+(x_d*x_d))-(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))*(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))+(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))*((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))+(x_d*x_d)*(+0.0+(+x_d_VGP_S_VD_S*x_d+x_d_VGP_S*x_d_VD_S+x_d_VD_S*x_d_VGP_S+x_d*x_d_VGP_S_VD_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))*(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
  xi0d_VGP_S_VGP_S=((+x_d_VGP_S_VGP_S*x_d+x_d_VGP_S*x_d_VGP_S+x_d_VGP_S*x_d_VGP_S+x_d*x_d_VGP_S_VGP_S)/(2.0+(x_d*x_d))-(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))*(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))+(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))*((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))+(x_d*x_d)*(+0.0+(+x_d_VGP_S_VGP_S*x_d+x_d_VGP_S*x_d_VGP_S+x_d_VGP_S*x_d_VGP_S+x_d*x_d_VGP_S_VGP_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))*(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
  xi0d_VGP_S_VS_BP=((+x_d_VGP_S_VS_BP*x_d+x_d_VGP_S*x_d_VS_BP+x_d_VS_BP*x_d_VGP_S+x_d*x_d_VGP_S_VS_BP)/(2.0+(x_d*x_d))-(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))*(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))+(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))*((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))+(x_d*x_d)*(+0.0+(+x_d_VGP_S_VS_BP*x_d+x_d_VGP_S*x_d_VS_BP+x_d_VS_BP*x_d_VGP_S+x_d*x_d_VGP_S_VS_BP)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S))*(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
#endif
xi0d_VS_BP=((((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))*(2.0+(x_d*x_d))-(x_d*x_d)*((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
#if defined(_DERIVATE2)
  xi0d_VS_BP_VD_S=((+x_d_VS_BP_VD_S*x_d+x_d_VS_BP*x_d_VD_S+x_d_VD_S*x_d_VS_BP+x_d*x_d_VS_BP_VD_S)/(2.0+(x_d*x_d))-(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))*(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))+(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))*((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))+(x_d*x_d)*(+0.0+(+x_d_VS_BP_VD_S*x_d+x_d_VS_BP*x_d_VD_S+x_d_VD_S*x_d_VS_BP+x_d*x_d_VS_BP_VD_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))*(((x_d_VD_S*x_d)+(x_d*x_d_VD_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
  xi0d_VS_BP_VGP_S=((+x_d_VS_BP_VGP_S*x_d+x_d_VS_BP*x_d_VGP_S+x_d_VGP_S*x_d_VS_BP+x_d*x_d_VS_BP_VGP_S)/(2.0+(x_d*x_d))-(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))*(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))+(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))*((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))+(x_d*x_d)*(+0.0+(+x_d_VS_BP_VGP_S*x_d+x_d_VS_BP*x_d_VGP_S+x_d_VGP_S*x_d_VS_BP+x_d*x_d_VS_BP_VGP_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))*(((x_d_VGP_S*x_d)+(x_d*x_d_VGP_S)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
  xi0d_VS_BP_VS_BP=((+x_d_VS_BP_VS_BP*x_d+x_d_VS_BP*x_d_VS_BP+x_d_VS_BP*x_d_VS_BP+x_d*x_d_VS_BP_VS_BP)/(2.0+(x_d*x_d))-(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))*(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))+(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))*((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))+(x_d*x_d)*(+0.0+(+x_d_VS_BP_VS_BP*x_d+x_d_VS_BP*x_d_VS_BP+x_d_VS_BP*x_d_VS_BP+x_d*x_d_VS_BP_VS_BP)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))+2*(x_d*x_d)*((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP))*(((x_d_VS_BP*x_d)+(x_d*x_d_VS_BP)))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
#endif
#endif
xi0d=((x_d*x_d)/(2.0+(x_d*x_d)));
EXIT_IF_ISNAN(((x_d*x_d)/(2.0+(x_d*x_d))))
if
((x_d<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,(-x_d))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ed_VD_S=(-x_d_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  Ed_VD_S_VD_S=(m20_exp((-x_d))*(-x_d_VD_S)*(-x_d_VD_S)+d10_exp0*0.0);
  Ed_VD_S_VGP_S=(m20_exp((-x_d))*(-x_d_VGP_S)*(-x_d_VD_S)+d10_exp0*0.0);
  Ed_VD_S_VS_BP=(m20_exp((-x_d))*(-x_d_VS_BP)*(-x_d_VD_S)+d10_exp0*0.0);
#endif
Ed_VGP_S=(-x_d_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  Ed_VGP_S_VD_S=(m20_exp((-x_d))*(-x_d_VD_S)*(-x_d_VGP_S)+d10_exp0*0.0);
  Ed_VGP_S_VGP_S=(m20_exp((-x_d))*(-x_d_VGP_S)*(-x_d_VGP_S)+d10_exp0*0.0);
  Ed_VGP_S_VS_BP=(m20_exp((-x_d))*(-x_d_VS_BP)*(-x_d_VGP_S)+d10_exp0*0.0);
#endif
Ed_VS_BP=(-x_d_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  Ed_VS_BP_VD_S=(m20_exp((-x_d))*(-x_d_VD_S)*(-x_d_VS_BP)+d10_exp0*0.0);
  Ed_VS_BP_VGP_S=(m20_exp((-x_d))*(-x_d_VGP_S)*(-x_d_VS_BP)+d10_exp0*0.0);
  Ed_VS_BP_VS_BP=(m20_exp((-x_d))*(-x_d_VS_BP)*(-x_d_VS_BP)+d10_exp0*0.0);
#endif
#endif
Ed=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
if
((x_d<1.0e-5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dd_VD_S=(((((((((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S))*(1.0+(1.75*x_d)))+(((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*x_d_VD_S)));
#if defined(_DERIVATE2)
  Dd_VD_S_VD_S=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VD_S+0.0*delta_nd_VD_S+1.6666666666666667e-01*delta_nd_VD_S_VD_S)*x_d+(1.6666666666666667e-01*delta_nd_VD_S)*x_d_VD_S+((1.6666666666666667e-01*delta_nd_VD_S))*x_d_VD_S+(1.6666666666666667e-01*delta_nd)*x_d_VD_S_VD_S)*x_d+(((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d_VD_S+(((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d_VD_S+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S_VD_S)*x_d+(((((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S))*x_d_VD_S+((((((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S)))*x_d_VD_S+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S_VD_S)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S))*((1.75*x_d_VD_S))+(((((((((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S)))*(1.75*x_d_VD_S)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VD_S+0.0*x_d_VD_S+1.75*x_d_VD_S_VD_S)));
  Dd_VD_S_VGP_S=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VGP_S+0.0*delta_nd_VD_S+1.6666666666666667e-01*delta_nd_VD_S_VGP_S)*x_d+(1.6666666666666667e-01*delta_nd_VD_S)*x_d_VGP_S+((1.6666666666666667e-01*delta_nd_VGP_S))*x_d_VD_S+(1.6666666666666667e-01*delta_nd)*x_d_VD_S_VGP_S)*x_d+(((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d_VGP_S+(((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d_VD_S+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S_VGP_S)*x_d+(((((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S))*x_d_VGP_S+((((((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S)))*x_d_VD_S+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S_VGP_S)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S))*((1.75*x_d_VGP_S))+(((((((((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S)))*(1.75*x_d_VD_S)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VGP_S+0.0*x_d_VD_S+1.75*x_d_VD_S_VGP_S)));
  Dd_VD_S_VS_BP=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VS_BP+0.0*delta_nd_VD_S+1.6666666666666667e-01*delta_nd_VD_S_VS_BP)*x_d+(1.6666666666666667e-01*delta_nd_VD_S)*x_d_VS_BP+((1.6666666666666667e-01*delta_nd_VS_BP))*x_d_VD_S+(1.6666666666666667e-01*delta_nd)*x_d_VD_S_VS_BP)*x_d+(((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d_VS_BP+(((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d_VD_S+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S_VS_BP)*x_d+(((((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S))*x_d_VS_BP+((((((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP)))*x_d_VD_S+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S_VS_BP)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VD_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S))*((1.75*x_d_VS_BP))+(((((((((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP)))*(1.75*x_d_VD_S)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VS_BP+0.0*x_d_VD_S+1.75*x_d_VD_S_VS_BP)));
#endif
Dd_VGP_S=(((((((((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S))*(1.0+(1.75*x_d)))+(((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*x_d_VGP_S)));
#if defined(_DERIVATE2)
  Dd_VGP_S_VD_S=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VD_S+0.0*delta_nd_VGP_S+1.6666666666666667e-01*delta_nd_VGP_S_VD_S)*x_d+(1.6666666666666667e-01*delta_nd_VGP_S)*x_d_VD_S+((1.6666666666666667e-01*delta_nd_VD_S))*x_d_VGP_S+(1.6666666666666667e-01*delta_nd)*x_d_VGP_S_VD_S)*x_d+(((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d_VD_S+(((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d_VGP_S+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S_VD_S)*x_d+(((((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S))*x_d_VD_S+((((((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S)))*x_d_VGP_S+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S_VD_S)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S))*((1.75*x_d_VD_S))+(((((((((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S)))*(1.75*x_d_VGP_S)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VD_S+0.0*x_d_VGP_S+1.75*x_d_VGP_S_VD_S)));
  Dd_VGP_S_VGP_S=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VGP_S+0.0*delta_nd_VGP_S+1.6666666666666667e-01*delta_nd_VGP_S_VGP_S)*x_d+(1.6666666666666667e-01*delta_nd_VGP_S)*x_d_VGP_S+((1.6666666666666667e-01*delta_nd_VGP_S))*x_d_VGP_S+(1.6666666666666667e-01*delta_nd)*x_d_VGP_S_VGP_S)*x_d+(((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d_VGP_S+(((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d_VGP_S+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S_VGP_S)*x_d+(((((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S))*x_d_VGP_S+((((((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S)))*x_d_VGP_S+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S_VGP_S)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S))*((1.75*x_d_VGP_S))+(((((((((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S)))*(1.75*x_d_VGP_S)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VGP_S+0.0*x_d_VGP_S+1.75*x_d_VGP_S_VGP_S)));
  Dd_VGP_S_VS_BP=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VS_BP+0.0*delta_nd_VGP_S+1.6666666666666667e-01*delta_nd_VGP_S_VS_BP)*x_d+(1.6666666666666667e-01*delta_nd_VGP_S)*x_d_VS_BP+((1.6666666666666667e-01*delta_nd_VS_BP))*x_d_VGP_S+(1.6666666666666667e-01*delta_nd)*x_d_VGP_S_VS_BP)*x_d+(((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d_VS_BP+(((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d_VGP_S+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S_VS_BP)*x_d+(((((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S))*x_d_VS_BP+((((((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP)))*x_d_VGP_S+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S_VS_BP)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VGP_S)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S))*((1.75*x_d_VS_BP))+(((((((((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP)))*(1.75*x_d_VGP_S)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VS_BP+0.0*x_d_VGP_S+1.75*x_d_VGP_S_VS_BP)));
#endif
Dd_VS_BP=(((((((((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP))*(1.0+(1.75*x_d)))+(((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.75*x_d_VS_BP)));
#if defined(_DERIVATE2)
  Dd_VS_BP_VD_S=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VD_S+0.0*delta_nd_VS_BP+1.6666666666666667e-01*delta_nd_VS_BP_VD_S)*x_d+(1.6666666666666667e-01*delta_nd_VS_BP)*x_d_VD_S+((1.6666666666666667e-01*delta_nd_VD_S))*x_d_VS_BP+(1.6666666666666667e-01*delta_nd)*x_d_VS_BP_VD_S)*x_d+(((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d_VD_S+(((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d_VS_BP+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP_VD_S)*x_d+(((((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP))*x_d_VD_S+((((((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S)))*x_d_VS_BP+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP_VD_S)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP))*((1.75*x_d_VD_S))+(((((((((((1.6666666666666667e-01*delta_nd_VD_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VD_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VD_S)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VD_S)))*(1.75*x_d_VS_BP)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VD_S+0.0*x_d_VS_BP+1.75*x_d_VS_BP_VD_S)));
  Dd_VS_BP_VGP_S=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VGP_S+0.0*delta_nd_VS_BP+1.6666666666666667e-01*delta_nd_VS_BP_VGP_S)*x_d+(1.6666666666666667e-01*delta_nd_VS_BP)*x_d_VGP_S+((1.6666666666666667e-01*delta_nd_VGP_S))*x_d_VS_BP+(1.6666666666666667e-01*delta_nd)*x_d_VS_BP_VGP_S)*x_d+(((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d_VGP_S+(((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d_VS_BP+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP_VGP_S)*x_d+(((((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP))*x_d_VGP_S+((((((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S)))*x_d_VS_BP+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP_VGP_S)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP))*((1.75*x_d_VGP_S))+(((((((((((1.6666666666666667e-01*delta_nd_VGP_S))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VGP_S)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VGP_S)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VGP_S)))*(1.75*x_d_VS_BP)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VGP_S+0.0*x_d_VS_BP+1.75*x_d_VS_BP_VGP_S)));
  Dd_VS_BP_VS_BP=(+(+(+(+(+0.0*delta_nd+0.0*delta_nd_VS_BP+0.0*delta_nd_VS_BP+1.6666666666666667e-01*delta_nd_VS_BP_VS_BP)*x_d+(1.6666666666666667e-01*delta_nd_VS_BP)*x_d_VS_BP+((1.6666666666666667e-01*delta_nd_VS_BP))*x_d_VS_BP+(1.6666666666666667e-01*delta_nd)*x_d_VS_BP_VS_BP)*x_d+(((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d_VS_BP+(((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d_VS_BP+((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP_VS_BP)*x_d+(((((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP))*x_d_VS_BP+((((((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP)))*x_d_VS_BP+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP_VS_BP)*(1.0+(1.75*x_d))+(((((((1.6666666666666667e-01*delta_nd_VS_BP)*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP))*((1.75*x_d_VS_BP))+(((((((((((1.6666666666666667e-01*delta_nd_VS_BP))*x_d)+((1.6666666666666667e-01*delta_nd)*x_d_VS_BP)))*x_d)+(((1.6666666666666667e-01*delta_nd)*x_d)*x_d_VS_BP)))*x_d)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d_VS_BP)))*(1.75*x_d_VS_BP)+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(+0.0+(+0.0*x_d+0.0*x_d_VS_BP+0.0*x_d_VS_BP+1.75*x_d_VS_BP_VS_BP)));
#endif
#endif
Dd=(((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
EXIT_IF_ISNAN((((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dd_VD_S=((delta_nd_VD_S*((((1.0/Ed)-x_d)-1.0)-xi0d))+(delta_nd*(((-Ed_VD_S/Ed/Ed)-x_d_VD_S)-xi0d_VD_S)));
#if defined(_DERIVATE2)
  Dd_VD_S_VD_S=(+delta_nd_VD_S_VD_S*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VD_S*(((-Ed_VD_S/Ed/Ed)-x_d_VD_S)-xi0d_VD_S)+delta_nd_VD_S*(((-Ed_VD_S/Ed/Ed)-x_d_VD_S)-xi0d_VD_S)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VD_S+0.0*Ed_VD_S+1.0*Ed_VD_S_VD_S)/Ed/Ed+2*1.0*Ed_VD_S*Ed_VD_S/Ed/Ed/Ed)-x_d_VD_S_VD_S)-0.0)-xi0d_VD_S_VD_S));
  Dd_VD_S_VGP_S=(+delta_nd_VD_S_VGP_S*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VD_S*(((-Ed_VGP_S/Ed/Ed)-x_d_VGP_S)-xi0d_VGP_S)+delta_nd_VGP_S*(((-Ed_VD_S/Ed/Ed)-x_d_VD_S)-xi0d_VD_S)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VGP_S+0.0*Ed_VD_S+1.0*Ed_VD_S_VGP_S)/Ed/Ed+2*1.0*Ed_VD_S*Ed_VGP_S/Ed/Ed/Ed)-x_d_VD_S_VGP_S)-0.0)-xi0d_VD_S_VGP_S));
  Dd_VD_S_VS_BP=(+delta_nd_VD_S_VS_BP*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VD_S*(((-Ed_VS_BP/Ed/Ed)-x_d_VS_BP)-xi0d_VS_BP)+delta_nd_VS_BP*(((-Ed_VD_S/Ed/Ed)-x_d_VD_S)-xi0d_VD_S)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VS_BP+0.0*Ed_VD_S+1.0*Ed_VD_S_VS_BP)/Ed/Ed+2*1.0*Ed_VD_S*Ed_VS_BP/Ed/Ed/Ed)-x_d_VD_S_VS_BP)-0.0)-xi0d_VD_S_VS_BP));
#endif
Dd_VGP_S=((delta_nd_VGP_S*((((1.0/Ed)-x_d)-1.0)-xi0d))+(delta_nd*(((-Ed_VGP_S/Ed/Ed)-x_d_VGP_S)-xi0d_VGP_S)));
#if defined(_DERIVATE2)
  Dd_VGP_S_VD_S=(+delta_nd_VGP_S_VD_S*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VGP_S*(((-Ed_VD_S/Ed/Ed)-x_d_VD_S)-xi0d_VD_S)+delta_nd_VD_S*(((-Ed_VGP_S/Ed/Ed)-x_d_VGP_S)-xi0d_VGP_S)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VD_S+0.0*Ed_VGP_S+1.0*Ed_VGP_S_VD_S)/Ed/Ed+2*1.0*Ed_VGP_S*Ed_VD_S/Ed/Ed/Ed)-x_d_VGP_S_VD_S)-0.0)-xi0d_VGP_S_VD_S));
  Dd_VGP_S_VGP_S=(+delta_nd_VGP_S_VGP_S*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VGP_S*(((-Ed_VGP_S/Ed/Ed)-x_d_VGP_S)-xi0d_VGP_S)+delta_nd_VGP_S*(((-Ed_VGP_S/Ed/Ed)-x_d_VGP_S)-xi0d_VGP_S)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VGP_S+0.0*Ed_VGP_S+1.0*Ed_VGP_S_VGP_S)/Ed/Ed+2*1.0*Ed_VGP_S*Ed_VGP_S/Ed/Ed/Ed)-x_d_VGP_S_VGP_S)-0.0)-xi0d_VGP_S_VGP_S));
  Dd_VGP_S_VS_BP=(+delta_nd_VGP_S_VS_BP*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VGP_S*(((-Ed_VS_BP/Ed/Ed)-x_d_VS_BP)-xi0d_VS_BP)+delta_nd_VS_BP*(((-Ed_VGP_S/Ed/Ed)-x_d_VGP_S)-xi0d_VGP_S)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VS_BP+0.0*Ed_VGP_S+1.0*Ed_VGP_S_VS_BP)/Ed/Ed+2*1.0*Ed_VGP_S*Ed_VS_BP/Ed/Ed/Ed)-x_d_VGP_S_VS_BP)-0.0)-xi0d_VGP_S_VS_BP));
#endif
Dd_VS_BP=((delta_nd_VS_BP*((((1.0/Ed)-x_d)-1.0)-xi0d))+(delta_nd*(((-Ed_VS_BP/Ed/Ed)-x_d_VS_BP)-xi0d_VS_BP)));
#if defined(_DERIVATE2)
  Dd_VS_BP_VD_S=(+delta_nd_VS_BP_VD_S*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VS_BP*(((-Ed_VD_S/Ed/Ed)-x_d_VD_S)-xi0d_VD_S)+delta_nd_VD_S*(((-Ed_VS_BP/Ed/Ed)-x_d_VS_BP)-xi0d_VS_BP)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VD_S+0.0*Ed_VS_BP+1.0*Ed_VS_BP_VD_S)/Ed/Ed+2*1.0*Ed_VS_BP*Ed_VD_S/Ed/Ed/Ed)-x_d_VS_BP_VD_S)-0.0)-xi0d_VS_BP_VD_S));
  Dd_VS_BP_VGP_S=(+delta_nd_VS_BP_VGP_S*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VS_BP*(((-Ed_VGP_S/Ed/Ed)-x_d_VGP_S)-xi0d_VGP_S)+delta_nd_VGP_S*(((-Ed_VS_BP/Ed/Ed)-x_d_VS_BP)-xi0d_VS_BP)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VGP_S+0.0*Ed_VS_BP+1.0*Ed_VS_BP_VGP_S)/Ed/Ed+2*1.0*Ed_VS_BP*Ed_VGP_S/Ed/Ed/Ed)-x_d_VS_BP_VGP_S)-0.0)-xi0d_VS_BP_VGP_S));
  Dd_VS_BP_VS_BP=(+delta_nd_VS_BP_VS_BP*((((1.0/Ed)-x_d)-1.0)-xi0d)+delta_nd_VS_BP*(((-Ed_VS_BP/Ed/Ed)-x_d_VS_BP)-xi0d_VS_BP)+delta_nd_VS_BP*(((-Ed_VS_BP/Ed/Ed)-x_d_VS_BP)-xi0d_VS_BP)+delta_nd*(+(+(+(0.0/Ed-(0.0*Ed_VS_BP+0.0*Ed_VS_BP+1.0*Ed_VS_BP_VS_BP)/Ed/Ed+2*1.0*Ed_VS_BP*Ed_VS_BP/Ed/Ed/Ed)-x_d_VS_BP_VS_BP)-0.0)-xi0d_VS_BP_VS_BP));
#endif
#endif
Dd=(delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
EXIT_IF_ISNAN((delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d)))
}
}
else
{
if
((x_d>(xn_d-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(x_d-xn_d))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(x_d_VGP_S-xn_d_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=(m20_exp((x_d-xn_d))*(x_d_VGP_S-xn_d_VGP_S)*(x_d_VGP_S-xn_d_VGP_S)+d10_exp0*(+x_d_VGP_S_VGP_S-xn_d_VGP_S_VGP_S));
  temp_VGP_S_VD_S=(m20_exp((x_d-xn_d))*(x_d_VD_S-xn_d_VD_S)*(x_d_VGP_S-xn_d_VGP_S)+d10_exp0*(+x_d_VGP_S_VD_S-xn_d_VGP_S_VD_S));
  temp_VGP_S_VS_BP=(m20_exp((x_d-xn_d))*(x_d_VS_BP-xn_d_VS_BP)*(x_d_VGP_S-xn_d_VGP_S)+d10_exp0*(+x_d_VGP_S_VS_BP-xn_d_VGP_S_VS_BP));
#endif
temp_VD_S=(x_d_VD_S-xn_d_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=0.0;
  temp_VD_S_VS_BS=0.0;
  temp_VD_S_VGP_S=(m20_exp((x_d-xn_d))*(x_d_VGP_S-xn_d_VGP_S)*(x_d_VD_S-xn_d_VD_S)+d10_exp0*(+x_d_VD_S_VGP_S-xn_d_VD_S_VGP_S));
  temp_VD_S_VD_S=(m20_exp((x_d-xn_d))*(x_d_VD_S-xn_d_VD_S)*(x_d_VD_S-xn_d_VD_S)+d10_exp0*(+x_d_VD_S_VD_S-xn_d_VD_S_VD_S));
  temp_VD_S_VS_BP=(m20_exp((x_d-xn_d))*(x_d_VS_BP-xn_d_VS_BP)*(x_d_VD_S-xn_d_VD_S)+d10_exp0*(+x_d_VD_S_VS_BP-xn_d_VD_S_VS_BP));
#endif
temp_VS_BP=(x_d_VS_BP-xn_d_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=0.0;
  temp_VS_BP_VS_BS=0.0;
  temp_VS_BP_VGP_S=(m20_exp((x_d-xn_d))*(x_d_VGP_S-xn_d_VGP_S)*(x_d_VS_BP-xn_d_VS_BP)+d10_exp0*(+x_d_VS_BP_VGP_S-xn_d_VS_BP_VGP_S));
  temp_VS_BP_VD_S=(m20_exp((x_d-xn_d))*(x_d_VD_S-xn_d_VD_S)*(x_d_VS_BP-xn_d_VS_BP)+d10_exp0*(+x_d_VS_BP_VD_S-xn_d_VS_BP_VD_S));
  temp_VS_BP_VS_BP=(m20_exp((x_d-xn_d))*(x_d_VS_BP-xn_d_VS_BP)*(x_d_VS_BP-xn_d_VS_BP)+d10_exp0*(+x_d_VS_BP_VS_BP-xn_d_VS_BP_VS_BP));
#endif
#endif
temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ed_VD_S=((delta_nd_VD_S*temp-delta_nd*temp_VD_S)/temp/temp);
#if defined(_DERIVATE2)
  Ed_VD_S_VD_S=(delta_nd_VD_S_VD_S/temp-(delta_nd_VD_S*temp_VD_S+delta_nd_VD_S*temp_VD_S+delta_nd*temp_VD_S_VD_S)/temp/temp+2*delta_nd*temp_VD_S*temp_VD_S/temp/temp/temp);
  Ed_VD_S_VGP_S=(delta_nd_VD_S_VGP_S/temp-(delta_nd_VD_S*temp_VGP_S+delta_nd_VGP_S*temp_VD_S+delta_nd*temp_VD_S_VGP_S)/temp/temp+2*delta_nd*temp_VD_S*temp_VGP_S/temp/temp/temp);
  Ed_VD_S_VS_BP=(delta_nd_VD_S_VS_BP/temp-(delta_nd_VD_S*temp_VS_BP+delta_nd_VS_BP*temp_VD_S+delta_nd*temp_VD_S_VS_BP)/temp/temp+2*delta_nd*temp_VD_S*temp_VS_BP/temp/temp/temp);
#endif
Ed_VGP_S=((delta_nd_VGP_S*temp-delta_nd*temp_VGP_S)/temp/temp);
#if defined(_DERIVATE2)
  Ed_VGP_S_VD_S=(delta_nd_VGP_S_VD_S/temp-(delta_nd_VGP_S*temp_VD_S+delta_nd_VD_S*temp_VGP_S+delta_nd*temp_VGP_S_VD_S)/temp/temp+2*delta_nd*temp_VGP_S*temp_VD_S/temp/temp/temp);
  Ed_VGP_S_VGP_S=(delta_nd_VGP_S_VGP_S/temp-(delta_nd_VGP_S*temp_VGP_S+delta_nd_VGP_S*temp_VGP_S+delta_nd*temp_VGP_S_VGP_S)/temp/temp+2*delta_nd*temp_VGP_S*temp_VGP_S/temp/temp/temp);
  Ed_VGP_S_VS_BP=(delta_nd_VGP_S_VS_BP/temp-(delta_nd_VGP_S*temp_VS_BP+delta_nd_VS_BP*temp_VGP_S+delta_nd*temp_VGP_S_VS_BP)/temp/temp+2*delta_nd*temp_VGP_S*temp_VS_BP/temp/temp/temp);
#endif
Ed_VS_BP=((delta_nd_VS_BP*temp-delta_nd*temp_VS_BP)/temp/temp);
#if defined(_DERIVATE2)
  Ed_VS_BP_VD_S=(delta_nd_VS_BP_VD_S/temp-(delta_nd_VS_BP*temp_VD_S+delta_nd_VD_S*temp_VS_BP+delta_nd*temp_VS_BP_VD_S)/temp/temp+2*delta_nd*temp_VS_BP*temp_VD_S/temp/temp/temp);
  Ed_VS_BP_VGP_S=(delta_nd_VS_BP_VGP_S/temp-(delta_nd_VS_BP*temp_VGP_S+delta_nd_VGP_S*temp_VS_BP+delta_nd*temp_VS_BP_VGP_S)/temp/temp+2*delta_nd*temp_VS_BP*temp_VGP_S/temp/temp/temp);
  Ed_VS_BP_VS_BP=(delta_nd_VS_BP_VS_BP/temp-(delta_nd_VS_BP*temp_VS_BP+delta_nd_VS_BP*temp_VS_BP+delta_nd*temp_VS_BP_VS_BP)/temp/temp+2*delta_nd*temp_VS_BP*temp_VS_BP/temp/temp/temp);
#endif
#endif
Ed=(delta_nd/temp);
EXIT_IF_ISNAN((delta_nd/temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dd_VD_S=(temp_VD_S-((delta_nd_VD_S*((x_d+1.0)+xi0d))+(delta_nd*(x_d_VD_S+xi0d_VD_S))));
#if defined(_DERIVATE2)
  Dd_VD_S_VD_S=(+temp_VD_S_VD_S-(+delta_nd_VD_S_VD_S*((x_d+1.0)+xi0d)+delta_nd_VD_S*(x_d_VD_S+xi0d_VD_S)+delta_nd_VD_S*(x_d_VD_S+xi0d_VD_S)+delta_nd*(+(+x_d_VD_S_VD_S+0.0)+xi0d_VD_S_VD_S)));
  Dd_VD_S_VGP_S=(+temp_VD_S_VGP_S-(+delta_nd_VD_S_VGP_S*((x_d+1.0)+xi0d)+delta_nd_VD_S*(x_d_VGP_S+xi0d_VGP_S)+delta_nd_VGP_S*(x_d_VD_S+xi0d_VD_S)+delta_nd*(+(+x_d_VD_S_VGP_S+0.0)+xi0d_VD_S_VGP_S)));
  Dd_VD_S_VS_BP=(+temp_VD_S_VS_BP-(+delta_nd_VD_S_VS_BP*((x_d+1.0)+xi0d)+delta_nd_VD_S*(x_d_VS_BP+xi0d_VS_BP)+delta_nd_VS_BP*(x_d_VD_S+xi0d_VD_S)+delta_nd*(+(+x_d_VD_S_VS_BP+0.0)+xi0d_VD_S_VS_BP)));
#endif
Dd_VGP_S=(temp_VGP_S-((delta_nd_VGP_S*((x_d+1.0)+xi0d))+(delta_nd*(x_d_VGP_S+xi0d_VGP_S))));
#if defined(_DERIVATE2)
  Dd_VGP_S_VD_S=(+temp_VGP_S_VD_S-(+delta_nd_VGP_S_VD_S*((x_d+1.0)+xi0d)+delta_nd_VGP_S*(x_d_VD_S+xi0d_VD_S)+delta_nd_VD_S*(x_d_VGP_S+xi0d_VGP_S)+delta_nd*(+(+x_d_VGP_S_VD_S+0.0)+xi0d_VGP_S_VD_S)));
  Dd_VGP_S_VGP_S=(+temp_VGP_S_VGP_S-(+delta_nd_VGP_S_VGP_S*((x_d+1.0)+xi0d)+delta_nd_VGP_S*(x_d_VGP_S+xi0d_VGP_S)+delta_nd_VGP_S*(x_d_VGP_S+xi0d_VGP_S)+delta_nd*(+(+x_d_VGP_S_VGP_S+0.0)+xi0d_VGP_S_VGP_S)));
  Dd_VGP_S_VS_BP=(+temp_VGP_S_VS_BP-(+delta_nd_VGP_S_VS_BP*((x_d+1.0)+xi0d)+delta_nd_VGP_S*(x_d_VS_BP+xi0d_VS_BP)+delta_nd_VS_BP*(x_d_VGP_S+xi0d_VGP_S)+delta_nd*(+(+x_d_VGP_S_VS_BP+0.0)+xi0d_VGP_S_VS_BP)));
#endif
Dd_VS_BP=(temp_VS_BP-((delta_nd_VS_BP*((x_d+1.0)+xi0d))+(delta_nd*(x_d_VS_BP+xi0d_VS_BP))));
#if defined(_DERIVATE2)
  Dd_VS_BP_VD_S=(+temp_VS_BP_VD_S-(+delta_nd_VS_BP_VD_S*((x_d+1.0)+xi0d)+delta_nd_VS_BP*(x_d_VD_S+xi0d_VD_S)+delta_nd_VD_S*(x_d_VS_BP+xi0d_VS_BP)+delta_nd*(+(+x_d_VS_BP_VD_S+0.0)+xi0d_VS_BP_VD_S)));
  Dd_VS_BP_VGP_S=(+temp_VS_BP_VGP_S-(+delta_nd_VS_BP_VGP_S*((x_d+1.0)+xi0d)+delta_nd_VS_BP*(x_d_VGP_S+xi0d_VGP_S)+delta_nd_VGP_S*(x_d_VS_BP+xi0d_VS_BP)+delta_nd*(+(+x_d_VS_BP_VGP_S+0.0)+xi0d_VS_BP_VGP_S)));
  Dd_VS_BP_VS_BP=(+temp_VS_BP_VS_BP-(+delta_nd_VS_BP_VS_BP*((x_d+1.0)+xi0d)+delta_nd_VS_BP*(x_d_VS_BP+xi0d_VS_BP)+delta_nd_VS_BP*(x_d_VS_BP+xi0d_VS_BP)+delta_nd*(+(+x_d_VS_BP_VS_BP+0.0)+xi0d_VS_BP_VS_BP)));
#endif
#endif
Dd=(temp-(delta_nd*((x_d+1.0)+xi0d)));
EXIT_IF_ISNAN((temp-(delta_nd*((x_d+1.0)+xi0d))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ed_VD_S=(-1.0e-100*((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Ed_VD_S_VD_S=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VD_S_VD_S-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VD_S*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01))))))+x_d_VD_S*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01))))+0.0*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01))+0.5*(+(+x_d_VD_S_VD_S-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VD_S*(x_d_VD_S*3.3333333333333333e-01)+x_d_VD_S*x_d_VD_S*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VD_S_VD_S-0.0)*3.3333333333333333e-01+x_d_VD_S*0.0+x_d_VD_S*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))))*(((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Ed_VD_S_VGP_S=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VD_S_VGP_S-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VD_S*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01))))))+x_d_VGP_S*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01))))+0.0*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01))+0.5*(+(+x_d_VD_S_VGP_S-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VD_S*(x_d_VGP_S*3.3333333333333333e-01)+x_d_VGP_S*x_d_VD_S*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VD_S_VGP_S-0.0)*3.3333333333333333e-01+x_d_VD_S*0.0+x_d_VGP_S*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))))*(((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Ed_VD_S_VS_BP=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VD_S_VS_BP-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VD_S*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01))))))+x_d_VS_BP*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01))))+0.0*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01))+0.5*(+(+x_d_VD_S_VS_BP-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VD_S*(x_d_VS_BP*3.3333333333333333e-01)+x_d_VS_BP*x_d_VD_S*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VD_S_VS_BP-0.0)*3.3333333333333333e-01+x_d_VD_S*0.0+x_d_VS_BP*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VD_S*3.3333333333333333e-01)))))*(((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
Ed_VGP_S=(-1.0e-100*((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Ed_VGP_S_VD_S=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VGP_S_VD_S-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VGP_S*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01))))))+x_d_VD_S*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01))))+0.0*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_d_VGP_S_VD_S-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VGP_S*(x_d_VD_S*3.3333333333333333e-01)+x_d_VD_S*x_d_VGP_S*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VGP_S_VD_S-0.0)*3.3333333333333333e-01+x_d_VGP_S*0.0+x_d_VD_S*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))))*(((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Ed_VGP_S_VGP_S=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VGP_S_VGP_S-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VGP_S*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01))))))+x_d_VGP_S*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01))))+0.0*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_d_VGP_S_VGP_S-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VGP_S*(x_d_VGP_S*3.3333333333333333e-01)+x_d_VGP_S*x_d_VGP_S*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+x_d_VGP_S*0.0+x_d_VGP_S*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))))*(((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Ed_VGP_S_VS_BP=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VGP_S_VS_BP-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VGP_S*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01))))))+x_d_VS_BP*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01))))+0.0*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_d_VGP_S_VS_BP-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VGP_S*(x_d_VS_BP*3.3333333333333333e-01)+x_d_VS_BP*x_d_VGP_S*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+x_d_VGP_S*0.0+x_d_VS_BP*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VGP_S*3.3333333333333333e-01)))))*(((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
Ed_VS_BP=(-1.0e-100*((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Ed_VS_BP_VD_S=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VS_BP_VD_S-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VS_BP*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01))))))+x_d_VD_S*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01))))+0.0*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_d_VS_BP_VD_S-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VS_BP*(x_d_VD_S*3.3333333333333333e-01)+x_d_VD_S*x_d_VS_BP*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VS_BP_VD_S-0.0)*3.3333333333333333e-01+x_d_VS_BP*0.0+x_d_VD_S*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))))*(((x_d_VD_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VD_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VD_S*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Ed_VS_BP_VGP_S=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VS_BP_VGP_S-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VS_BP*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01))))))+x_d_VGP_S*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01))))+0.0*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_d_VS_BP_VGP_S-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VS_BP*(x_d_VGP_S*3.3333333333333333e-01)+x_d_VGP_S*x_d_VS_BP*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+x_d_VS_BP*0.0+x_d_VGP_S*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))))*(((x_d_VGP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VGP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VGP_S*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  Ed_VS_BP_VS_BP=(0.0/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*(((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+x_d_VS_BP_VS_BP-0.0)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_d_VS_BP*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01))))))+x_d_VS_BP*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))+(x_d-2.3025850929940458e+02)*(+0.0+(+0.0*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01))))+0.0*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_d_VS_BP_VS_BP-0.0)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))+x_d_VS_BP*(x_d_VS_BP*3.3333333333333333e-01)+x_d_VS_BP*x_d_VS_BP*3.3333333333333333e-01+(x_d-2.3025850929940458e+02)*(+0.0+(+(+x_d_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+x_d_VS_BP*0.0+x_d_VS_BP*0.0+(x_d-2.3025850929940458e+02)*0.0))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*(0.5*((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*x_d_VS_BP*3.3333333333333333e-01)))))*(((x_d_VS_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x_d-2.3025850929940458e+02)*((0.5*(((x_d_VS_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x_d-2.3025850929940458e+02)*(x_d_VS_BP*3.3333333333333333e-01)))))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
#endif
Ed=(1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-1.0e-100*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-0.0)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VGP_S-x_d_VGP_S)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-0.0)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VGP_S-x_d_VGP_S)*(0.0)+0.0*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-0.0)-0.0)*3.3333333333333333e-01+(xn_d_VGP_S-x_d_VGP_S)*0.0+0.0*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BS=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-0.0)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VGP_S-x_d_VGP_S)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-0.0)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VGP_S-x_d_VGP_S)*(0.0)+0.0*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-0.0)-0.0)*3.3333333333333333e-01+(xn_d_VGP_S-x_d_VGP_S)*0.0+0.0*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VGP_S_VGP_S=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VGP_S_VGP_S-x_d_VGP_S_VGP_S)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VGP_S-x_d_VGP_S)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))))))+(xn_d_VGP_S-x_d_VGP_S)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VGP_S_VGP_S-x_d_VGP_S_VGP_S)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VGP_S-x_d_VGP_S)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)+(xn_d_VGP_S-x_d_VGP_S)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VGP_S_VGP_S-x_d_VGP_S_VGP_S)-0.0)*3.3333333333333333e-01+(xn_d_VGP_S-x_d_VGP_S)*0.0+(xn_d_VGP_S-x_d_VGP_S)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VGP_S_VD_S=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VGP_S_VD_S-x_d_VGP_S_VD_S)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VGP_S-x_d_VGP_S)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))))))+(xn_d_VD_S-x_d_VD_S)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VGP_S_VD_S-x_d_VGP_S_VD_S)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VGP_S-x_d_VGP_S)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)+(xn_d_VD_S-x_d_VD_S)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VGP_S_VD_S-x_d_VGP_S_VD_S)-0.0)*3.3333333333333333e-01+(xn_d_VGP_S-x_d_VGP_S)*0.0+(xn_d_VD_S-x_d_VD_S)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))*((((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BP=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VGP_S_VS_BP-x_d_VGP_S_VS_BP)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VGP_S-x_d_VGP_S)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))))))+(xn_d_VS_BP-x_d_VS_BP)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VGP_S_VS_BP-x_d_VGP_S_VS_BP)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VGP_S-x_d_VGP_S)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)+(xn_d_VS_BP-x_d_VS_BP)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VGP_S_VS_BP-x_d_VGP_S_VS_BP)-0.0)*3.3333333333333333e-01+(xn_d_VGP_S-x_d_VGP_S)*0.0+(xn_d_VS_BP-x_d_VS_BP)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
temp_VD_S=(-1.0e-100*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-0.0)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VD_S-x_d_VD_S)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-0.0)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VD_S-x_d_VD_S)*(0.0)+0.0*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-0.0)-0.0)*3.3333333333333333e-01+(xn_d_VD_S-x_d_VD_S)*0.0+0.0*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BS=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-0.0)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VD_S-x_d_VD_S)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+0.0-0.0)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VD_S-x_d_VD_S)*(0.0)+0.0*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-0.0)-0.0)*3.3333333333333333e-01+(xn_d_VD_S-x_d_VD_S)*0.0+0.0*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VD_S_VGP_S=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VD_S_VGP_S-x_d_VD_S_VGP_S)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VD_S-x_d_VD_S)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))))))+(xn_d_VGP_S-x_d_VGP_S)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VD_S_VGP_S-x_d_VD_S_VGP_S)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VD_S-x_d_VD_S)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)+(xn_d_VGP_S-x_d_VGP_S)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VD_S_VGP_S-x_d_VD_S_VGP_S)-0.0)*3.3333333333333333e-01+(xn_d_VD_S-x_d_VD_S)*0.0+(xn_d_VGP_S-x_d_VGP_S)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VD_S_VD_S=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VD_S_VD_S-x_d_VD_S_VD_S)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VD_S-x_d_VD_S)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))))))+(xn_d_VD_S-x_d_VD_S)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VD_S_VD_S-x_d_VD_S_VD_S)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VD_S-x_d_VD_S)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)+(xn_d_VD_S-x_d_VD_S)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VD_S_VD_S-x_d_VD_S_VD_S)-0.0)*3.3333333333333333e-01+(xn_d_VD_S-x_d_VD_S)*0.0+(xn_d_VD_S-x_d_VD_S)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))*((((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BP=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VD_S_VS_BP-x_d_VD_S_VS_BP)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VD_S-x_d_VD_S)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))))))+(xn_d_VS_BP-x_d_VS_BP)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VD_S_VS_BP-x_d_VD_S_VS_BP)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VD_S-x_d_VD_S)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)+(xn_d_VS_BP-x_d_VS_BP)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VD_S_VS_BP-x_d_VD_S_VS_BP)-0.0)*3.3333333333333333e-01+(xn_d_VD_S-x_d_VD_S)*0.0+(xn_d_VS_BP-x_d_VS_BP)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
temp_VS_BP=(-1.0e-100*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-0.0)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VS_BP-x_d_VS_BP)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+0.0-0.0)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VS_BP-x_d_VS_BP)*(0.0)+0.0*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-0.0)-0.0)*3.3333333333333333e-01+(xn_d_VS_BP-x_d_VS_BP)*0.0+0.0*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BS=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+0.0-0.0)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VS_BP-x_d_VS_BP)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+0.0-0.0)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VS_BP-x_d_VS_BP)*(0.0)+0.0*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+0.0-0.0)-0.0)*3.3333333333333333e-01+(xn_d_VS_BP-x_d_VS_BP)*0.0+0.0*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))*((((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d-x_d)-2.3025850929940458e+02)*(0.0)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VS_BP_VGP_S=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VS_BP_VGP_S-x_d_VS_BP_VGP_S)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VS_BP-x_d_VS_BP)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))))))+(xn_d_VGP_S-x_d_VGP_S)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VS_BP_VGP_S-x_d_VS_BP_VGP_S)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VS_BP-x_d_VS_BP)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)+(xn_d_VGP_S-x_d_VGP_S)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VS_BP_VGP_S-x_d_VS_BP_VGP_S)-0.0)*3.3333333333333333e-01+(xn_d_VS_BP-x_d_VS_BP)*0.0+(xn_d_VGP_S-x_d_VGP_S)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VGP_S-x_d_VGP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VGP_S-x_d_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VS_BP_VD_S=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VS_BP_VD_S-x_d_VS_BP_VD_S)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VS_BP-x_d_VS_BP)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))))))+(xn_d_VD_S-x_d_VD_S)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01))))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VS_BP_VD_S-x_d_VS_BP_VD_S)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VS_BP-x_d_VS_BP)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)+(xn_d_VD_S-x_d_VD_S)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VS_BP_VD_S-x_d_VS_BP_VD_S)-0.0)*3.3333333333333333e-01+(xn_d_VS_BP-x_d_VS_BP)*0.0+(xn_d_VD_S-x_d_VD_S)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))*((((xn_d_VD_S-x_d_VD_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VD_S-x_d_VD_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VD_S-x_d_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BP=(0.0/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))-(0.0*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+(+xn_d_VS_BP_VS_BP-x_d_VS_BP_VS_BP)-0.0)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(xn_d_VS_BP-x_d_VS_BP)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))))))+(xn_d_VS_BP-x_d_VS_BP)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+0.0*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))))+0.0*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01))+0.5*(+(+(+xn_d_VS_BP_VS_BP-x_d_VS_BP_VS_BP)-0.0)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))+(xn_d_VS_BP-x_d_VS_BP)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)+(xn_d_VS_BP-x_d_VS_BP)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01+((xn_d-x_d)-2.3025850929940458e+02)*(+0.0+(+(+(+xn_d_VS_BP_VS_BP-x_d_VS_BP_VS_BP)-0.0)*3.3333333333333333e-01+(xn_d_VS_BP-x_d_VS_BP)*0.0+(xn_d_VS_BP-x_d_VS_BP)*0.0+((xn_d-x_d)-2.3025850929940458e+02)*0.0))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+2*1.0e-100*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*(0.5*(((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*(xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((xn_d-x_d)-2.3025850929940458e+02)*((0.5*((((xn_d_VS_BP-x_d_VS_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((xn_d-x_d)-2.3025850929940458e+02)*((xn_d_VS_BP-x_d_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
#endif
#endif
temp=(1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dd_VD_S=(temp_VD_S-((delta_nd_VD_S*((x_d+1.0)+xi0d))+(delta_nd*(x_d_VD_S+xi0d_VD_S))));
#if defined(_DERIVATE2)
  Dd_VD_S_VD_S=(+temp_VD_S_VD_S-(+delta_nd_VD_S_VD_S*((x_d+1.0)+xi0d)+delta_nd_VD_S*(x_d_VD_S+xi0d_VD_S)+delta_nd_VD_S*(x_d_VD_S+xi0d_VD_S)+delta_nd*(+(+x_d_VD_S_VD_S+0.0)+xi0d_VD_S_VD_S)));
  Dd_VD_S_VGP_S=(+temp_VD_S_VGP_S-(+delta_nd_VD_S_VGP_S*((x_d+1.0)+xi0d)+delta_nd_VD_S*(x_d_VGP_S+xi0d_VGP_S)+delta_nd_VGP_S*(x_d_VD_S+xi0d_VD_S)+delta_nd*(+(+x_d_VD_S_VGP_S+0.0)+xi0d_VD_S_VGP_S)));
  Dd_VD_S_VS_BP=(+temp_VD_S_VS_BP-(+delta_nd_VD_S_VS_BP*((x_d+1.0)+xi0d)+delta_nd_VD_S*(x_d_VS_BP+xi0d_VS_BP)+delta_nd_VS_BP*(x_d_VD_S+xi0d_VD_S)+delta_nd*(+(+x_d_VD_S_VS_BP+0.0)+xi0d_VD_S_VS_BP)));
#endif
Dd_VGP_S=(temp_VGP_S-((delta_nd_VGP_S*((x_d+1.0)+xi0d))+(delta_nd*(x_d_VGP_S+xi0d_VGP_S))));
#if defined(_DERIVATE2)
  Dd_VGP_S_VD_S=(+temp_VGP_S_VD_S-(+delta_nd_VGP_S_VD_S*((x_d+1.0)+xi0d)+delta_nd_VGP_S*(x_d_VD_S+xi0d_VD_S)+delta_nd_VD_S*(x_d_VGP_S+xi0d_VGP_S)+delta_nd*(+(+x_d_VGP_S_VD_S+0.0)+xi0d_VGP_S_VD_S)));
  Dd_VGP_S_VGP_S=(+temp_VGP_S_VGP_S-(+delta_nd_VGP_S_VGP_S*((x_d+1.0)+xi0d)+delta_nd_VGP_S*(x_d_VGP_S+xi0d_VGP_S)+delta_nd_VGP_S*(x_d_VGP_S+xi0d_VGP_S)+delta_nd*(+(+x_d_VGP_S_VGP_S+0.0)+xi0d_VGP_S_VGP_S)));
  Dd_VGP_S_VS_BP=(+temp_VGP_S_VS_BP-(+delta_nd_VGP_S_VS_BP*((x_d+1.0)+xi0d)+delta_nd_VGP_S*(x_d_VS_BP+xi0d_VS_BP)+delta_nd_VS_BP*(x_d_VGP_S+xi0d_VGP_S)+delta_nd*(+(+x_d_VGP_S_VS_BP+0.0)+xi0d_VGP_S_VS_BP)));
#endif
Dd_VS_BP=(temp_VS_BP-((delta_nd_VS_BP*((x_d+1.0)+xi0d))+(delta_nd*(x_d_VS_BP+xi0d_VS_BP))));
#if defined(_DERIVATE2)
  Dd_VS_BP_VD_S=(+temp_VS_BP_VD_S-(+delta_nd_VS_BP_VD_S*((x_d+1.0)+xi0d)+delta_nd_VS_BP*(x_d_VD_S+xi0d_VD_S)+delta_nd_VD_S*(x_d_VS_BP+xi0d_VS_BP)+delta_nd*(+(+x_d_VS_BP_VD_S+0.0)+xi0d_VS_BP_VD_S)));
  Dd_VS_BP_VGP_S=(+temp_VS_BP_VGP_S-(+delta_nd_VS_BP_VGP_S*((x_d+1.0)+xi0d)+delta_nd_VS_BP*(x_d_VGP_S+xi0d_VGP_S)+delta_nd_VGP_S*(x_d_VS_BP+xi0d_VS_BP)+delta_nd*(+(+x_d_VS_BP_VGP_S+0.0)+xi0d_VS_BP_VGP_S)));
  Dd_VS_BP_VS_BP=(+temp_VS_BP_VS_BP-(+delta_nd_VS_BP_VS_BP*((x_d+1.0)+xi0d)+delta_nd_VS_BP*(x_d_VS_BP+xi0d_VS_BP)+delta_nd_VS_BP*(x_d_VS_BP+xi0d_VS_BP)+delta_nd*(+(+x_d_VS_BP_VS_BP+0.0)+xi0d_VS_BP_VS_BP)));
#endif
#endif
Dd=(temp-(delta_nd*((x_d+1.0)+xi0d)));
EXIT_IF_ISNAN((temp-(delta_nd*((x_d+1.0)+xi0d))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
x_m_VD_S=(0.5*(x_s_VD_S+x_d_VD_S));
#if defined(_DERIVATE2)
  x_m_VD_S_VD_S=(+0.0*(x_s+x_d)+0.0*(x_s_VD_S+x_d_VD_S)+0.0*(x_s_VD_S+x_d_VD_S)+0.5*(+x_s_VD_S_VD_S+x_d_VD_S_VD_S));
  x_m_VD_S_VGP_S=(+0.0*(x_s+x_d)+0.0*(x_s_VGP_S+x_d_VGP_S)+0.0*(x_s_VD_S+x_d_VD_S)+0.5*(+x_s_VD_S_VGP_S+x_d_VD_S_VGP_S));
  x_m_VD_S_VS_BP=(+0.0*(x_s+x_d)+0.0*(x_s_VS_BP+x_d_VS_BP)+0.0*(x_s_VD_S+x_d_VD_S)+0.5*(+x_s_VD_S_VS_BP+x_d_VD_S_VS_BP));
#endif
x_m_VGP_S=(0.5*(x_s_VGP_S+x_d_VGP_S));
#if defined(_DERIVATE2)
  x_m_VGP_S_VD_S=(+0.0*(x_s+x_d)+0.0*(x_s_VD_S+x_d_VD_S)+0.0*(x_s_VGP_S+x_d_VGP_S)+0.5*(+x_s_VGP_S_VD_S+x_d_VGP_S_VD_S));
  x_m_VGP_S_VGP_S=(+0.0*(x_s+x_d)+0.0*(x_s_VGP_S+x_d_VGP_S)+0.0*(x_s_VGP_S+x_d_VGP_S)+0.5*(+x_s_VGP_S_VGP_S+x_d_VGP_S_VGP_S));
  x_m_VGP_S_VS_BP=(+0.0*(x_s+x_d)+0.0*(x_s_VS_BP+x_d_VS_BP)+0.0*(x_s_VGP_S+x_d_VGP_S)+0.5*(+x_s_VGP_S_VS_BP+x_d_VGP_S_VS_BP));
#endif
x_m_VS_BP=(0.5*(x_s_VS_BP+x_d_VS_BP));
#if defined(_DERIVATE2)
  x_m_VS_BP_VD_S=(+0.0*(x_s+x_d)+0.0*(x_s_VD_S+x_d_VD_S)+0.0*(x_s_VS_BP+x_d_VS_BP)+0.5*(+x_s_VS_BP_VD_S+x_d_VS_BP_VD_S));
  x_m_VS_BP_VGP_S=(+0.0*(x_s+x_d)+0.0*(x_s_VGP_S+x_d_VGP_S)+0.0*(x_s_VS_BP+x_d_VS_BP)+0.5*(+x_s_VS_BP_VGP_S+x_d_VS_BP_VGP_S));
  x_m_VS_BP_VS_BP=(+0.0*(x_s+x_d)+0.0*(x_s_VS_BP+x_d_VS_BP)+0.0*(x_s_VS_BP+x_d_VS_BP)+0.5*(+x_s_VS_BP_VS_BP+x_d_VS_BP_VS_BP));
#endif
#endif
x_m=(0.5*(x_s+x_d));
EXIT_IF_ISNAN((0.5*(x_s+x_d)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Em_VD_S=0.0;
#if defined(_DERIVATE2)
  Em_VD_S_VD_S=0.0;
  Em_VD_S_VGP_S=0.0;
  Em_VD_S_VS_BP=0.0;
#endif
Em_VGP_S=0.0;
#if defined(_DERIVATE2)
  Em_VGP_S_VD_S=0.0;
  Em_VGP_S_VGP_S=0.0;
  Em_VGP_S_VS_BP=0.0;
#endif
Em_VS_BP=0.0;
#if defined(_DERIVATE2)
  Em_VS_BP_VD_S=0.0;
  Em_VS_BP_VGP_S=0.0;
  Em_VS_BP_VS_BP=0.0;
#endif
#endif
Em=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=((Ed_VGP_S*Es)+(Ed*Es_VGP_S));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*Es+Ed_VGP_S*0.0+0.0*Es_VGP_S+Ed*0.0);
  temp_VGP_S_VS_BS=(+0.0*Es+Ed_VGP_S*0.0+0.0*Es_VGP_S+Ed*0.0);
  temp_VGP_S_VGP_S=(+Ed_VGP_S_VGP_S*Es+Ed_VGP_S*Es_VGP_S+Ed_VGP_S*Es_VGP_S+Ed*Es_VGP_S_VGP_S);
  temp_VGP_S_VD_S=(+Ed_VGP_S_VD_S*Es+Ed_VGP_S*Es_VD_S+Ed_VD_S*Es_VGP_S+Ed*Es_VGP_S_VD_S);
  temp_VGP_S_VS_BP=(+Ed_VGP_S_VS_BP*Es+Ed_VGP_S*Es_VS_BP+Ed_VS_BP*Es_VGP_S+Ed*Es_VGP_S_VS_BP);
#endif
temp_VD_S=((Ed_VD_S*Es)+(Ed*Es_VD_S));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*Es+Ed_VD_S*0.0+0.0*Es_VD_S+Ed*0.0);
  temp_VD_S_VS_BS=(+0.0*Es+Ed_VD_S*0.0+0.0*Es_VD_S+Ed*0.0);
  temp_VD_S_VGP_S=(+Ed_VD_S_VGP_S*Es+Ed_VD_S*Es_VGP_S+Ed_VGP_S*Es_VD_S+Ed*Es_VD_S_VGP_S);
  temp_VD_S_VD_S=(+Ed_VD_S_VD_S*Es+Ed_VD_S*Es_VD_S+Ed_VD_S*Es_VD_S+Ed*Es_VD_S_VD_S);
  temp_VD_S_VS_BP=(+Ed_VD_S_VS_BP*Es+Ed_VD_S*Es_VS_BP+Ed_VS_BP*Es_VD_S+Ed*Es_VD_S_VS_BP);
#endif
temp_VS_BP=((Ed_VS_BP*Es)+(Ed*Es_VS_BP));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*Es+Ed_VS_BP*0.0+0.0*Es_VS_BP+Ed*0.0);
  temp_VS_BP_VS_BS=(+0.0*Es+Ed_VS_BP*0.0+0.0*Es_VS_BP+Ed*0.0);
  temp_VS_BP_VGP_S=(+Ed_VS_BP_VGP_S*Es+Ed_VS_BP*Es_VGP_S+Ed_VGP_S*Es_VS_BP+Ed*Es_VS_BP_VGP_S);
  temp_VS_BP_VD_S=(+Ed_VS_BP_VD_S*Es+Ed_VS_BP*Es_VD_S+Ed_VD_S*Es_VS_BP+Ed*Es_VS_BP_VD_S);
  temp_VS_BP_VS_BP=(+Ed_VS_BP_VS_BP*Es+Ed_VS_BP*Es_VS_BP+Ed_VS_BP*Es_VS_BP+Ed*Es_VS_BP_VS_BP);
#endif
#endif
temp=(Ed*Es);
EXIT_IF_ISNAN((Ed*Es))
if
((temp>0.0))
{
{
double m00_sqrt(d00_sqrt0,temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Em_VD_S=temp_VD_S*d10_sqrt0;
#if defined(_DERIVATE2)
  Em_VD_S_VD_S=(m20_sqrt(temp)*temp_VD_S*temp_VD_S+d10_sqrt0*temp_VD_S_VD_S);
  Em_VD_S_VGP_S=(m20_sqrt(temp)*temp_VGP_S*temp_VD_S+d10_sqrt0*temp_VD_S_VGP_S);
  Em_VD_S_VS_BP=(m20_sqrt(temp)*temp_VS_BP*temp_VD_S+d10_sqrt0*temp_VD_S_VS_BP);
#endif
Em_VGP_S=temp_VGP_S*d10_sqrt0;
#if defined(_DERIVATE2)
  Em_VGP_S_VD_S=(m20_sqrt(temp)*temp_VD_S*temp_VGP_S+d10_sqrt0*temp_VGP_S_VD_S);
  Em_VGP_S_VGP_S=(m20_sqrt(temp)*temp_VGP_S*temp_VGP_S+d10_sqrt0*temp_VGP_S_VGP_S);
  Em_VGP_S_VS_BP=(m20_sqrt(temp)*temp_VS_BP*temp_VGP_S+d10_sqrt0*temp_VGP_S_VS_BP);
#endif
Em_VS_BP=temp_VS_BP*d10_sqrt0;
#if defined(_DERIVATE2)
  Em_VS_BP_VD_S=(m20_sqrt(temp)*temp_VD_S*temp_VS_BP+d10_sqrt0*temp_VS_BP_VD_S);
  Em_VS_BP_VGP_S=(m20_sqrt(temp)*temp_VGP_S*temp_VS_BP+d10_sqrt0*temp_VS_BP_VGP_S);
  Em_VS_BP_VS_BP=(m20_sqrt(temp)*temp_VS_BP*temp_VS_BP+d10_sqrt0*temp_VS_BP_VS_BP);
#endif
#endif
Em=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
D_bar_VD_S=(0.5*(Ds_VD_S+Dd_VD_S));
#if defined(_DERIVATE2)
  D_bar_VD_S_VD_S=(+0.0*(Ds+Dd)+0.0*(Ds_VD_S+Dd_VD_S)+0.0*(Ds_VD_S+Dd_VD_S)+0.5*(+Ds_VD_S_VD_S+Dd_VD_S_VD_S));
  D_bar_VD_S_VGP_S=(+0.0*(Ds+Dd)+0.0*(Ds_VGP_S+Dd_VGP_S)+0.0*(Ds_VD_S+Dd_VD_S)+0.5*(+Ds_VD_S_VGP_S+Dd_VD_S_VGP_S));
  D_bar_VD_S_VS_BP=(+0.0*(Ds+Dd)+0.0*(Ds_VS_BP+Dd_VS_BP)+0.0*(Ds_VD_S+Dd_VD_S)+0.5*(+Ds_VD_S_VS_BP+Dd_VD_S_VS_BP));
#endif
D_bar_VGP_S=(0.5*(Ds_VGP_S+Dd_VGP_S));
#if defined(_DERIVATE2)
  D_bar_VGP_S_VD_S=(+0.0*(Ds+Dd)+0.0*(Ds_VD_S+Dd_VD_S)+0.0*(Ds_VGP_S+Dd_VGP_S)+0.5*(+Ds_VGP_S_VD_S+Dd_VGP_S_VD_S));
  D_bar_VGP_S_VGP_S=(+0.0*(Ds+Dd)+0.0*(Ds_VGP_S+Dd_VGP_S)+0.0*(Ds_VGP_S+Dd_VGP_S)+0.5*(+Ds_VGP_S_VGP_S+Dd_VGP_S_VGP_S));
  D_bar_VGP_S_VS_BP=(+0.0*(Ds+Dd)+0.0*(Ds_VS_BP+Dd_VS_BP)+0.0*(Ds_VGP_S+Dd_VGP_S)+0.5*(+Ds_VGP_S_VS_BP+Dd_VGP_S_VS_BP));
#endif
D_bar_VS_BP=(0.5*(Ds_VS_BP+Dd_VS_BP));
#if defined(_DERIVATE2)
  D_bar_VS_BP_VD_S=(+0.0*(Ds+Dd)+0.0*(Ds_VD_S+Dd_VD_S)+0.0*(Ds_VS_BP+Dd_VS_BP)+0.5*(+Ds_VS_BP_VD_S+Dd_VS_BP_VD_S));
  D_bar_VS_BP_VGP_S=(+0.0*(Ds+Dd)+0.0*(Ds_VGP_S+Dd_VGP_S)+0.0*(Ds_VS_BP+Dd_VS_BP)+0.5*(+Ds_VS_BP_VGP_S+Dd_VS_BP_VGP_S));
  D_bar_VS_BP_VS_BP=(+0.0*(Ds+Dd)+0.0*(Ds_VS_BP+Dd_VS_BP)+0.0*(Ds_VS_BP+Dd_VS_BP)+0.5*(+Ds_VS_BP_VS_BP+Dd_VS_BP_VS_BP));
#endif
#endif
D_bar=(0.5*(Ds+Dd));
EXIT_IF_ISNAN((0.5*(Ds+Dd)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Dm_VD_S=(D_bar_VD_S+(0.125*((((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VD_S-(2.0*inv_Gf2_VD_S))))));
#if defined(_DERIVATE2)
  Dm_VD_S_VD_S=(+D_bar_VD_S_VD_S+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VD_S-((2.0*inv_Gf2_VD_S))))))+0.0*((((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VD_S-(2.0*inv_Gf2_VD_S))))+0.125*(+(+x_ds_VD_S_VD_S*x_ds+x_ds_VD_S*x_ds_VD_S+x_ds_VD_S*x_ds_VD_S+x_ds*x_ds_VD_S_VD_S)*(Em-(2.0*inv_Gf2))+((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S))*(Em_VD_S-((2.0*inv_Gf2_VD_S)))+(((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S)))*(Em_VD_S-(2.0*inv_Gf2_VD_S))+(x_ds*x_ds)*(+Em_VD_S_VD_S-(+0.0*inv_Gf2+0.0*inv_Gf2_VD_S+0.0*inv_Gf2_VD_S+2.0*inv_Gf2_VD_S_VD_S)))));
  Dm_VD_S_VGP_S=(+D_bar_VD_S_VGP_S+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VGP_S-((2.0*inv_Gf2_VGP_S))))))+0.0*((((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VD_S-(2.0*inv_Gf2_VD_S))))+0.125*(+(+x_ds_VD_S_VGP_S*x_ds+x_ds_VD_S*x_ds_VGP_S+x_ds_VGP_S*x_ds_VD_S+x_ds*x_ds_VD_S_VGP_S)*(Em-(2.0*inv_Gf2))+((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S))*(Em_VGP_S-((2.0*inv_Gf2_VGP_S)))+(((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S)))*(Em_VD_S-(2.0*inv_Gf2_VD_S))+(x_ds*x_ds)*(+Em_VD_S_VGP_S-(+0.0*inv_Gf2+0.0*inv_Gf2_VGP_S+0.0*inv_Gf2_VD_S+2.0*inv_Gf2_VD_S_VGP_S)))));
  Dm_VD_S_VS_BP=(+D_bar_VD_S_VS_BP+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VS_BP-((2.0*inv_Gf2_VS_BP))))))+0.0*((((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VD_S-(2.0*inv_Gf2_VD_S))))+0.125*(+(+x_ds_VD_S_VS_BP*x_ds+x_ds_VD_S*x_ds_VS_BP+x_ds_VS_BP*x_ds_VD_S+x_ds*x_ds_VD_S_VS_BP)*(Em-(2.0*inv_Gf2))+((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S))*(Em_VS_BP-((2.0*inv_Gf2_VS_BP)))+(((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP)))*(Em_VD_S-(2.0*inv_Gf2_VD_S))+(x_ds*x_ds)*(+Em_VD_S_VS_BP-(+0.0*inv_Gf2+0.0*inv_Gf2_VS_BP+0.0*inv_Gf2_VD_S+2.0*inv_Gf2_VD_S_VS_BP)))));
#endif
Dm_VGP_S=(D_bar_VGP_S+(0.125*((((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VGP_S-(2.0*inv_Gf2_VGP_S))))));
#if defined(_DERIVATE2)
  Dm_VGP_S_VD_S=(+D_bar_VGP_S_VD_S+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VD_S-((2.0*inv_Gf2_VD_S))))))+0.0*((((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VGP_S-(2.0*inv_Gf2_VGP_S))))+0.125*(+(+x_ds_VGP_S_VD_S*x_ds+x_ds_VGP_S*x_ds_VD_S+x_ds_VD_S*x_ds_VGP_S+x_ds*x_ds_VGP_S_VD_S)*(Em-(2.0*inv_Gf2))+((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S))*(Em_VD_S-((2.0*inv_Gf2_VD_S)))+(((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S)))*(Em_VGP_S-(2.0*inv_Gf2_VGP_S))+(x_ds*x_ds)*(+Em_VGP_S_VD_S-(+0.0*inv_Gf2+0.0*inv_Gf2_VD_S+0.0*inv_Gf2_VGP_S+2.0*inv_Gf2_VGP_S_VD_S)))));
  Dm_VGP_S_VGP_S=(+D_bar_VGP_S_VGP_S+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VGP_S-((2.0*inv_Gf2_VGP_S))))))+0.0*((((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VGP_S-(2.0*inv_Gf2_VGP_S))))+0.125*(+(+x_ds_VGP_S_VGP_S*x_ds+x_ds_VGP_S*x_ds_VGP_S+x_ds_VGP_S*x_ds_VGP_S+x_ds*x_ds_VGP_S_VGP_S)*(Em-(2.0*inv_Gf2))+((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S))*(Em_VGP_S-((2.0*inv_Gf2_VGP_S)))+(((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S)))*(Em_VGP_S-(2.0*inv_Gf2_VGP_S))+(x_ds*x_ds)*(+Em_VGP_S_VGP_S-(+0.0*inv_Gf2+0.0*inv_Gf2_VGP_S+0.0*inv_Gf2_VGP_S+2.0*inv_Gf2_VGP_S_VGP_S)))));
  Dm_VGP_S_VS_BP=(+D_bar_VGP_S_VS_BP+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VS_BP-((2.0*inv_Gf2_VS_BP))))))+0.0*((((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VGP_S-(2.0*inv_Gf2_VGP_S))))+0.125*(+(+x_ds_VGP_S_VS_BP*x_ds+x_ds_VGP_S*x_ds_VS_BP+x_ds_VS_BP*x_ds_VGP_S+x_ds*x_ds_VGP_S_VS_BP)*(Em-(2.0*inv_Gf2))+((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S))*(Em_VS_BP-((2.0*inv_Gf2_VS_BP)))+(((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP)))*(Em_VGP_S-(2.0*inv_Gf2_VGP_S))+(x_ds*x_ds)*(+Em_VGP_S_VS_BP-(+0.0*inv_Gf2+0.0*inv_Gf2_VS_BP+0.0*inv_Gf2_VGP_S+2.0*inv_Gf2_VGP_S_VS_BP)))));
#endif
Dm_VS_BP=(D_bar_VS_BP+(0.125*((((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VS_BP-(2.0*inv_Gf2_VS_BP))))));
#if defined(_DERIVATE2)
  Dm_VS_BP_VD_S=(+D_bar_VS_BP_VD_S+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VD_S-((2.0*inv_Gf2_VD_S))))))+0.0*((((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VS_BP-(2.0*inv_Gf2_VS_BP))))+0.125*(+(+x_ds_VS_BP_VD_S*x_ds+x_ds_VS_BP*x_ds_VD_S+x_ds_VD_S*x_ds_VS_BP+x_ds*x_ds_VS_BP_VD_S)*(Em-(2.0*inv_Gf2))+((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP))*(Em_VD_S-((2.0*inv_Gf2_VD_S)))+(((x_ds_VD_S*x_ds)+(x_ds*x_ds_VD_S)))*(Em_VS_BP-(2.0*inv_Gf2_VS_BP))+(x_ds*x_ds)*(+Em_VS_BP_VD_S-(+0.0*inv_Gf2+0.0*inv_Gf2_VD_S+0.0*inv_Gf2_VS_BP+2.0*inv_Gf2_VS_BP_VD_S)))));
  Dm_VS_BP_VGP_S=(+D_bar_VS_BP_VGP_S+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VGP_S-((2.0*inv_Gf2_VGP_S))))))+0.0*((((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VS_BP-(2.0*inv_Gf2_VS_BP))))+0.125*(+(+x_ds_VS_BP_VGP_S*x_ds+x_ds_VS_BP*x_ds_VGP_S+x_ds_VGP_S*x_ds_VS_BP+x_ds*x_ds_VS_BP_VGP_S)*(Em-(2.0*inv_Gf2))+((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP))*(Em_VGP_S-((2.0*inv_Gf2_VGP_S)))+(((x_ds_VGP_S*x_ds)+(x_ds*x_ds_VGP_S)))*(Em_VS_BP-(2.0*inv_Gf2_VS_BP))+(x_ds*x_ds)*(+Em_VS_BP_VGP_S-(+0.0*inv_Gf2+0.0*inv_Gf2_VGP_S+0.0*inv_Gf2_VS_BP+2.0*inv_Gf2_VS_BP_VGP_S)))));
  Dm_VS_BP_VS_BP=(+D_bar_VS_BP_VS_BP+(+0.0*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))+0.0*((((((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP)))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VS_BP-((2.0*inv_Gf2_VS_BP))))))+0.0*((((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP))*(Em-(2.0*inv_Gf2)))+((x_ds*x_ds)*(Em_VS_BP-(2.0*inv_Gf2_VS_BP))))+0.125*(+(+x_ds_VS_BP_VS_BP*x_ds+x_ds_VS_BP*x_ds_VS_BP+x_ds_VS_BP*x_ds_VS_BP+x_ds*x_ds_VS_BP_VS_BP)*(Em-(2.0*inv_Gf2))+((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP))*(Em_VS_BP-((2.0*inv_Gf2_VS_BP)))+(((x_ds_VS_BP*x_ds)+(x_ds*x_ds_VS_BP)))*(Em_VS_BP-(2.0*inv_Gf2_VS_BP))+(x_ds*x_ds)*(+Em_VS_BP_VS_BP-(+0.0*inv_Gf2+0.0*inv_Gf2_VS_BP+0.0*inv_Gf2_VS_BP+2.0*inv_Gf2_VS_BP_VS_BP)))));
#endif
#endif
Dm=(D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
EXIT_IF_ISNAN((D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2))))))
if
((x_m<1.0e-5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Pm_VD_S=(0.5*((((x_m_VD_S*x_m)+(x_m*x_m_VD_S))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S)))))))));
#if defined(_DERIVATE2)
  Pm_VD_S_VD_S=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))))))))+0.0*((((x_m_VD_S*x_m)+(x_m*x_m_VD_S))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))))+0.5*(+(+x_m_VD_S_VD_S*x_m+x_m_VD_S*x_m_VD_S+x_m_VD_S*x_m_VD_S+x_m*x_m_VD_S_VD_S)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VD_S*x_m)+(x_m*x_m_VD_S))*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S)))))))))+(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))+0.0*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))+3.3333333333333333e-01*(+x_m_VD_S_VD_S*(1.0-(0.25*x_m))+x_m_VD_S*(-((0.25*x_m_VD_S)))+x_m_VD_S*(-(0.25*x_m_VD_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VD_S+0.25*x_m_VD_S_VD_S)))))));
  Pm_VD_S_VGP_S=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))))))))+0.0*((((x_m_VD_S*x_m)+(x_m*x_m_VD_S))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))))+0.5*(+(+x_m_VD_S_VGP_S*x_m+x_m_VD_S*x_m_VGP_S+x_m_VGP_S*x_m_VD_S+x_m*x_m_VD_S_VGP_S)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VD_S*x_m)+(x_m*x_m_VD_S))*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S)))))))))+(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))+0.0*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))+3.3333333333333333e-01*(+x_m_VD_S_VGP_S*(1.0-(0.25*x_m))+x_m_VD_S*(-((0.25*x_m_VGP_S)))+x_m_VGP_S*(-(0.25*x_m_VD_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VD_S+0.25*x_m_VD_S_VGP_S)))))));
  Pm_VD_S_VS_BP=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))))))))+0.0*((((x_m_VD_S*x_m)+(x_m*x_m_VD_S))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))))+0.5*(+(+x_m_VD_S_VS_BP*x_m+x_m_VD_S*x_m_VS_BP+x_m_VS_BP*x_m_VD_S+x_m*x_m_VD_S_VS_BP)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VD_S*x_m)+(x_m*x_m_VD_S))*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP)))))))))+(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))+0.0*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))+3.3333333333333333e-01*(+x_m_VD_S_VS_BP*(1.0-(0.25*x_m))+x_m_VD_S*(-((0.25*x_m_VS_BP)))+x_m_VS_BP*(-(0.25*x_m_VD_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VD_S+0.25*x_m_VD_S_VS_BP)))))));
#endif
Pm_VGP_S=(0.5*((((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S)))))))));
#if defined(_DERIVATE2)
  Pm_VGP_S_VD_S=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))))))))+0.0*((((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))))+0.5*(+(+x_m_VGP_S_VD_S*x_m+x_m_VGP_S*x_m_VD_S+x_m_VD_S*x_m_VGP_S+x_m*x_m_VGP_S_VD_S)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S)))))))))+(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))+0.0*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))+3.3333333333333333e-01*(+x_m_VGP_S_VD_S*(1.0-(0.25*x_m))+x_m_VGP_S*(-((0.25*x_m_VD_S)))+x_m_VD_S*(-(0.25*x_m_VGP_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VGP_S+0.25*x_m_VGP_S_VD_S)))))));
  Pm_VGP_S_VGP_S=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))))))))+0.0*((((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))))+0.5*(+(+x_m_VGP_S_VGP_S*x_m+x_m_VGP_S*x_m_VGP_S+x_m_VGP_S*x_m_VGP_S+x_m*x_m_VGP_S_VGP_S)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S)))))))))+(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))+0.0*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))+3.3333333333333333e-01*(+x_m_VGP_S_VGP_S*(1.0-(0.25*x_m))+x_m_VGP_S*(-((0.25*x_m_VGP_S)))+x_m_VGP_S*(-(0.25*x_m_VGP_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VGP_S+0.25*x_m_VGP_S_VGP_S)))))));
  Pm_VGP_S_VS_BP=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))))))))+0.0*((((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))))+0.5*(+(+x_m_VGP_S_VS_BP*x_m+x_m_VGP_S*x_m_VS_BP+x_m_VS_BP*x_m_VGP_S+x_m*x_m_VGP_S_VS_BP)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP)))))))))+(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))+0.0*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))+3.3333333333333333e-01*(+x_m_VGP_S_VS_BP*(1.0-(0.25*x_m))+x_m_VGP_S*(-((0.25*x_m_VS_BP)))+x_m_VS_BP*(-(0.25*x_m_VGP_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VGP_S+0.25*x_m_VGP_S_VS_BP)))))));
#endif
Pm_VS_BP=(0.5*((((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP)))))))));
#if defined(_DERIVATE2)
  Pm_VS_BP_VD_S=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))))))))+0.0*((((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))))+0.5*(+(+x_m_VS_BP_VD_S*x_m+x_m_VS_BP*x_m_VD_S+x_m_VD_S*x_m_VS_BP+x_m*x_m_VS_BP_VD_S)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S)))))))))+(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))+0.0*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))+3.3333333333333333e-01*(+x_m_VS_BP_VD_S*(1.0-(0.25*x_m))+x_m_VS_BP*(-((0.25*x_m_VD_S)))+x_m_VD_S*(-(0.25*x_m_VS_BP))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VS_BP+0.25*x_m_VS_BP_VD_S)))))));
  Pm_VS_BP_VGP_S=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))))))))+0.0*((((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))))+0.5*(+(+x_m_VS_BP_VGP_S*x_m+x_m_VS_BP*x_m_VGP_S+x_m_VGP_S*x_m_VS_BP+x_m*x_m_VS_BP_VGP_S)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S)))))))))+(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))+0.0*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))+3.3333333333333333e-01*(+x_m_VS_BP_VGP_S*(1.0-(0.25*x_m))+x_m_VS_BP*(-((0.25*x_m_VGP_S)))+x_m_VGP_S*(-(0.25*x_m_VS_BP))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VS_BP+0.25*x_m_VS_BP_VGP_S)))))));
  Pm_VS_BP_VS_BP=(+0.0*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+0.0*((((((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))))))))+0.0*((((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))+((x_m*x_m)*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))))+0.5*(+(+x_m_VS_BP_VS_BP*x_m+x_m_VS_BP*x_m_VS_BP+x_m_VS_BP*x_m_VS_BP+x_m*x_m_VS_BP_VS_BP)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))+((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP)))))))))+(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))+(x_m*x_m)*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))+0.0*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))+3.3333333333333333e-01*(+x_m_VS_BP_VS_BP*(1.0-(0.25*x_m))+x_m_VS_BP*(-((0.25*x_m_VS_BP)))+x_m_VS_BP*(-(0.25*x_m_VS_BP))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VS_BP+0.25*x_m_VS_BP_VS_BP)))))));
#endif
#endif
Pm=(0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
EXIT_IF_ISNAN((0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))))
{
double m00_sqrt(d00_sqrt0,(Dm+Pm))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(Dm+Pm))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
xgm_VD_S=((Gf_VD_S*d00_sqrt0)+(Gf*(Dm_VD_S+Pm_VD_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VD_S_VD_S=(+Gf_VD_S_VD_S*d00_sqrt0+Gf_VD_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VD_S+Pm_VD_S_VD_S)));
  xgm_VD_S_VGP_S=(+Gf_VD_S_VGP_S*d00_sqrt0+Gf_VD_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VGP_S+Pm_VD_S_VGP_S)));
  xgm_VD_S_VS_BP=(+Gf_VD_S_VS_BP*d00_sqrt0+Gf_VD_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VS_BP+Pm_VD_S_VS_BP)));
#endif
xgm_VGP_S=((Gf_VGP_S*d00_sqrt0)+(Gf*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VGP_S_VD_S=(+Gf_VGP_S_VD_S*d00_sqrt0+Gf_VGP_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VD_S+Pm_VGP_S_VD_S)));
  xgm_VGP_S_VGP_S=(+Gf_VGP_S_VGP_S*d00_sqrt0+Gf_VGP_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VGP_S+Pm_VGP_S_VGP_S)));
  xgm_VGP_S_VS_BP=(+Gf_VGP_S_VS_BP*d00_sqrt0+Gf_VGP_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VS_BP+Pm_VGP_S_VS_BP)));
#endif
xgm_VS_BP=((Gf_VS_BP*d00_sqrt0)+(Gf*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VS_BP_VD_S=(+Gf_VS_BP_VD_S*d00_sqrt0+Gf_VS_BP*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VD_S+Pm_VS_BP_VD_S)));
  xgm_VS_BP_VGP_S=(+Gf_VS_BP_VGP_S*d00_sqrt0+Gf_VS_BP*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VGP_S+Pm_VS_BP_VGP_S)));
  xgm_VS_BP_VS_BP=(+Gf_VS_BP_VS_BP*d00_sqrt0+Gf_VS_BP*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VS_BP+Pm_VS_BP_VS_BP)));
#endif
#endif
xgm=(Gf*d00_sqrt0);
EXIT_IF_ISNAN((Gf*d00_sqrt0))
}
if
((pInst->kp>0.0))
{
{
double m00_sqrt(d00_sqrt0,(1.0+(pInst->kp*xgm)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(pInst->kp*xgm)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
eta_p_VD_S=(-(pInst->kp*xgm_VD_S)*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  eta_p_VD_S_VD_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VD_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VD_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VD_S))*(pInst->kp*xgm_VD_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VD_S+pInst->kp*xgm_VD_S_VD_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VD_S)*d10_sqrt0*((pInst->kp*xgm_VD_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VD_S_VGP_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VGP_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VD_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VGP_S))*(pInst->kp*xgm_VD_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VD_S+pInst->kp*xgm_VD_S_VGP_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VD_S)*d10_sqrt0*((pInst->kp*xgm_VGP_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VD_S_VS_BP=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VS_BP))*d10_sqrt0+0.0*(pInst->kp*xgm_VD_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VS_BP))*(pInst->kp*xgm_VD_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VD_S+pInst->kp*xgm_VD_S_VS_BP))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VD_S)*d10_sqrt0*((pInst->kp*xgm_VS_BP))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
eta_p_VGP_S=(-(pInst->kp*xgm_VGP_S)*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  eta_p_VGP_S_VD_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VD_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VD_S))*(pInst->kp*xgm_VGP_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VGP_S+pInst->kp*xgm_VGP_S_VD_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0*((pInst->kp*xgm_VD_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VGP_S_VGP_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VGP_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VGP_S))*(pInst->kp*xgm_VGP_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VGP_S+pInst->kp*xgm_VGP_S_VGP_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0*((pInst->kp*xgm_VGP_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VGP_S_VS_BP=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VS_BP))*d10_sqrt0+0.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VS_BP))*(pInst->kp*xgm_VGP_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VGP_S+pInst->kp*xgm_VGP_S_VS_BP))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0*((pInst->kp*xgm_VS_BP))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
eta_p_VS_BP=(-(pInst->kp*xgm_VS_BP)*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  eta_p_VS_BP_VD_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VD_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VD_S))*(pInst->kp*xgm_VS_BP)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VS_BP+pInst->kp*xgm_VS_BP_VD_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0*((pInst->kp*xgm_VD_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VS_BP_VGP_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VGP_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VGP_S))*(pInst->kp*xgm_VS_BP)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VS_BP+pInst->kp*xgm_VS_BP_VGP_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0*((pInst->kp*xgm_VGP_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VS_BP_VS_BP=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VS_BP))*d10_sqrt0+0.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VS_BP))*(pInst->kp*xgm_VS_BP)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VS_BP+pInst->kp*xgm_VS_BP_VS_BP))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0*((pInst->kp*xgm_VS_BP))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
pInst->eta_p=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
}
{
double m00_sqrt(d00_sqrt0,(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))*d10_sqrt0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*((x_m*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*((x_m*(-(0.0))))+0.0*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_m))+x_m_VGP_S*(-(0.0))+0.0*(-(0.25*x_m_VGP_S))+x_m*(+0.0-(+0.0*x_m+0.0*0.0+0.0*x_m_VGP_S+0.25*0.0))))));
  temp_VGP_S_VS_BS=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*((x_m*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*((x_m*(-(0.0))))+0.0*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_m))+x_m_VGP_S*(-(0.0))+0.0*(-(0.25*x_m_VGP_S))+x_m*(+0.0-(+0.0*x_m+0.0*0.0+0.0*x_m_VGP_S+0.25*0.0))))));
  temp_VGP_S_VGP_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S)))))))))*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))+0.0*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))+3.3333333333333333e-01*(+x_m_VGP_S_VGP_S*(1.0-(0.25*x_m))+x_m_VGP_S*(-((0.25*x_m_VGP_S)))+x_m_VGP_S*(-(0.25*x_m_VGP_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VGP_S+0.25*x_m_VGP_S_VGP_S))))));
  temp_VGP_S_VD_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S)))))))))*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))+0.0*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))+3.3333333333333333e-01*(+x_m_VGP_S_VD_S*(1.0-(0.25*x_m))+x_m_VGP_S*(-((0.25*x_m_VD_S)))+x_m_VD_S*(-(0.25*x_m_VGP_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VGP_S+0.25*x_m_VGP_S_VD_S))))));
  temp_VGP_S_VS_BP=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP)))))))))*(-(3.3333333333333333e-01*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))+0.0*((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VGP_S))))+3.3333333333333333e-01*(+x_m_VGP_S_VS_BP*(1.0-(0.25*x_m))+x_m_VGP_S*(-((0.25*x_m_VS_BP)))+x_m_VS_BP*(-(0.25*x_m_VGP_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VGP_S+0.25*x_m_VGP_S_VS_BP))))));
#endif
temp_VD_S=(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))*d10_sqrt0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*((x_m*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*((x_m*(-(0.0))))+0.0*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_m))+x_m_VD_S*(-(0.0))+0.0*(-(0.25*x_m_VD_S))+x_m*(+0.0-(+0.0*x_m+0.0*0.0+0.0*x_m_VD_S+0.25*0.0))))));
  temp_VD_S_VS_BS=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*((x_m*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*((x_m*(-(0.0))))+0.0*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_m))+x_m_VD_S*(-(0.0))+0.0*(-(0.25*x_m_VD_S))+x_m*(+0.0-(+0.0*x_m+0.0*0.0+0.0*x_m_VD_S+0.25*0.0))))));
  temp_VD_S_VGP_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S)))))))))*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))+0.0*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))+3.3333333333333333e-01*(+x_m_VD_S_VGP_S*(1.0-(0.25*x_m))+x_m_VD_S*(-((0.25*x_m_VGP_S)))+x_m_VGP_S*(-(0.25*x_m_VD_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VD_S+0.25*x_m_VD_S_VGP_S))))));
  temp_VD_S_VD_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S)))))))))*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))+0.0*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))+3.3333333333333333e-01*(+x_m_VD_S_VD_S*(1.0-(0.25*x_m))+x_m_VD_S*(-((0.25*x_m_VD_S)))+x_m_VD_S*(-(0.25*x_m_VD_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VD_S+0.25*x_m_VD_S_VD_S))))));
  temp_VD_S_VS_BP=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP)))))))))*(-(3.3333333333333333e-01*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))+0.0*((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VD_S))))+3.3333333333333333e-01*(+x_m_VD_S_VS_BP*(1.0-(0.25*x_m))+x_m_VD_S*(-((0.25*x_m_VS_BP)))+x_m_VS_BP*(-(0.25*x_m_VD_S))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VD_S+0.25*x_m_VD_S_VS_BP))))));
#endif
temp_VS_BP=(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))*d10_sqrt0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*((x_m*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*((x_m*(-(0.0))))+0.0*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_m))+x_m_VS_BP*(-(0.0))+0.0*(-(0.25*x_m_VS_BP))+x_m*(+0.0-(+0.0*x_m+0.0*0.0+0.0*x_m_VS_BP+0.25*0.0))))));
  temp_VS_BP_VS_BS=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*((x_m*(-(0.0)))))))*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*((x_m*(-(0.0))))+0.0*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))+3.3333333333333333e-01*(+0.0*(1.0-(0.25*x_m))+x_m_VS_BP*(-(0.0))+0.0*(-(0.25*x_m_VS_BP))+x_m*(+0.0-(+0.0*x_m+0.0*0.0+0.0*x_m_VS_BP+0.25*0.0))))));
  temp_VS_BP_VGP_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S)))))))))*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VGP_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VGP_S))))))+0.0*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))+3.3333333333333333e-01*(+x_m_VS_BP_VGP_S*(1.0-(0.25*x_m))+x_m_VS_BP*(-((0.25*x_m_VGP_S)))+x_m_VGP_S*(-(0.25*x_m_VS_BP))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VS_BP+0.25*x_m_VS_BP_VGP_S))))));
  temp_VS_BP_VD_S=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S)))))))))*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VD_S*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VD_S))))))+0.0*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))+3.3333333333333333e-01*(+x_m_VS_BP_VD_S*(1.0-(0.25*x_m))+x_m_VS_BP*(-((0.25*x_m_VD_S)))+x_m_VD_S*(-(0.25*x_m_VS_BP))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VS_BP+0.25*x_m_VS_BP_VD_S))))));
  temp_VS_BP_VS_BP=(m20_sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))))*(-((3.3333333333333333e-01*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP)))))))))*(-(3.3333333333333333e-01*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))))+d10_sqrt0*(+0.0-(+0.0*(x_m*(1.0-(0.25*x_m)))+0.0*(((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-((0.25*x_m_VS_BP))))))+0.0*((x_m_VS_BP*(1.0-(0.25*x_m)))+(x_m*(-(0.25*x_m_VS_BP))))+3.3333333333333333e-01*(+x_m_VS_BP_VS_BP*(1.0-(0.25*x_m))+x_m_VS_BP*(-((0.25*x_m_VS_BP)))+x_m_VS_BP*(-(0.25*x_m_VS_BP))+x_m*(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VS_BP+0.25*x_m_VS_BP_VS_BP))))));
#endif
#endif
temp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
sqm_VD_S=(7.0710678118654746e-01*((x_m_VD_S*temp)+(x_m*temp_VD_S)));
#if defined(_DERIVATE2)
  sqm_VD_S_VD_S=(+0.0*(x_m*temp)+0.0*(((x_m_VD_S*temp)+(x_m*temp_VD_S)))+0.0*((x_m_VD_S*temp)+(x_m*temp_VD_S))+7.0710678118654746e-01*(+x_m_VD_S_VD_S*temp+x_m_VD_S*temp_VD_S+x_m_VD_S*temp_VD_S+x_m*temp_VD_S_VD_S));
  sqm_VD_S_VGP_S=(+0.0*(x_m*temp)+0.0*(((x_m_VGP_S*temp)+(x_m*temp_VGP_S)))+0.0*((x_m_VD_S*temp)+(x_m*temp_VD_S))+7.0710678118654746e-01*(+x_m_VD_S_VGP_S*temp+x_m_VD_S*temp_VGP_S+x_m_VGP_S*temp_VD_S+x_m*temp_VD_S_VGP_S));
  sqm_VD_S_VS_BP=(+0.0*(x_m*temp)+0.0*(((x_m_VS_BP*temp)+(x_m*temp_VS_BP)))+0.0*((x_m_VD_S*temp)+(x_m*temp_VD_S))+7.0710678118654746e-01*(+x_m_VD_S_VS_BP*temp+x_m_VD_S*temp_VS_BP+x_m_VS_BP*temp_VD_S+x_m*temp_VD_S_VS_BP));
#endif
sqm_VGP_S=(7.0710678118654746e-01*((x_m_VGP_S*temp)+(x_m*temp_VGP_S)));
#if defined(_DERIVATE2)
  sqm_VGP_S_VD_S=(+0.0*(x_m*temp)+0.0*(((x_m_VD_S*temp)+(x_m*temp_VD_S)))+0.0*((x_m_VGP_S*temp)+(x_m*temp_VGP_S))+7.0710678118654746e-01*(+x_m_VGP_S_VD_S*temp+x_m_VGP_S*temp_VD_S+x_m_VD_S*temp_VGP_S+x_m*temp_VGP_S_VD_S));
  sqm_VGP_S_VGP_S=(+0.0*(x_m*temp)+0.0*(((x_m_VGP_S*temp)+(x_m*temp_VGP_S)))+0.0*((x_m_VGP_S*temp)+(x_m*temp_VGP_S))+7.0710678118654746e-01*(+x_m_VGP_S_VGP_S*temp+x_m_VGP_S*temp_VGP_S+x_m_VGP_S*temp_VGP_S+x_m*temp_VGP_S_VGP_S));
  sqm_VGP_S_VS_BP=(+0.0*(x_m*temp)+0.0*(((x_m_VS_BP*temp)+(x_m*temp_VS_BP)))+0.0*((x_m_VGP_S*temp)+(x_m*temp_VGP_S))+7.0710678118654746e-01*(+x_m_VGP_S_VS_BP*temp+x_m_VGP_S*temp_VS_BP+x_m_VS_BP*temp_VGP_S+x_m*temp_VGP_S_VS_BP));
#endif
sqm_VS_BP=(7.0710678118654746e-01*((x_m_VS_BP*temp)+(x_m*temp_VS_BP)));
#if defined(_DERIVATE2)
  sqm_VS_BP_VD_S=(+0.0*(x_m*temp)+0.0*(((x_m_VD_S*temp)+(x_m*temp_VD_S)))+0.0*((x_m_VS_BP*temp)+(x_m*temp_VS_BP))+7.0710678118654746e-01*(+x_m_VS_BP_VD_S*temp+x_m_VS_BP*temp_VD_S+x_m_VD_S*temp_VS_BP+x_m*temp_VS_BP_VD_S));
  sqm_VS_BP_VGP_S=(+0.0*(x_m*temp)+0.0*(((x_m_VGP_S*temp)+(x_m*temp_VGP_S)))+0.0*((x_m_VS_BP*temp)+(x_m*temp_VS_BP))+7.0710678118654746e-01*(+x_m_VS_BP_VGP_S*temp+x_m_VS_BP*temp_VGP_S+x_m_VGP_S*temp_VS_BP+x_m*temp_VS_BP_VGP_S));
  sqm_VS_BP_VS_BP=(+0.0*(x_m*temp)+0.0*(((x_m_VS_BP*temp)+(x_m*temp_VS_BP)))+0.0*((x_m_VS_BP*temp)+(x_m*temp_VS_BP))+7.0710678118654746e-01*(+x_m_VS_BP_VS_BP*temp+x_m_VS_BP*temp_VS_BP+x_m_VS_BP*temp_VS_BP+x_m*temp_VS_BP_VS_BP));
#endif
#endif
sqm=(7.0710678118654746e-01*(x_m*temp));
EXIT_IF_ISNAN((7.0710678118654746e-01*(x_m*temp)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
alpha_VD_S=(eta_p_VD_S+(7.0710678118654746e-01*((((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S)/temp/temp)));
#if defined(_DERIVATE2)
  alpha_VD_S_VD_S=(+eta_p_VD_S_VD_S+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S)/temp/temp)+0.0*((((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S)/temp/temp)+7.0710678118654746e-01*((+Gf_VD_S_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VD_S*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))+Gf_VD_S*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VD_S+0.5*x_m_VD_S_VD_S))+(+0.0*(x_m*x_m)+0.0*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))+0.0*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))+1.6666666666666667e-01*(+x_m_VD_S_VD_S*x_m+x_m_VD_S*x_m_VD_S+x_m_VD_S*x_m_VD_S+x_m*x_m_VD_S_VD_S))))/temp-(((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))*temp_VD_S+(((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))))))))*temp_VD_S+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S_VD_S)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S*temp_VD_S/temp/temp/temp)));
  alpha_VD_S_VGP_S=(+eta_p_VD_S_VGP_S+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S)/temp/temp)+0.0*((((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S)/temp/temp)+7.0710678118654746e-01*((+Gf_VD_S_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VD_S*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))+Gf_VGP_S*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VD_S+0.5*x_m_VD_S_VGP_S))+(+0.0*(x_m*x_m)+0.0*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))+0.0*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))+1.6666666666666667e-01*(+x_m_VD_S_VGP_S*x_m+x_m_VD_S*x_m_VGP_S+x_m_VGP_S*x_m_VD_S+x_m*x_m_VD_S_VGP_S))))/temp-(((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))*temp_VGP_S+(((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))))))))*temp_VD_S+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S_VGP_S)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S*temp_VGP_S/temp/temp/temp)));
  alpha_VD_S_VS_BP=(+eta_p_VD_S_VS_BP+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP)/temp/temp)+0.0*((((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S)/temp/temp)+7.0710678118654746e-01*((+Gf_VD_S_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VD_S*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))+Gf_VS_BP*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VD_S+0.5*x_m_VD_S_VS_BP))+(+0.0*(x_m*x_m)+0.0*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))+0.0*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))+1.6666666666666667e-01*(+x_m_VD_S_VS_BP*x_m+x_m_VD_S*x_m_VS_BP+x_m_VS_BP*x_m_VD_S+x_m*x_m_VD_S_VS_BP))))/temp-(((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VD_S))+(1.6666666666666667e-01*((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))*temp_VS_BP+(((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))))))))*temp_VD_S+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S_VS_BP)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S*temp_VS_BP/temp/temp/temp)));
#endif
alpha_VGP_S=(eta_p_VGP_S+(7.0710678118654746e-01*((((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S)/temp/temp)));
#if defined(_DERIVATE2)
  alpha_VGP_S_VD_S=(+eta_p_VGP_S_VD_S+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S)/temp/temp)+0.0*((((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S)/temp/temp)+7.0710678118654746e-01*((+Gf_VGP_S_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VGP_S*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))+Gf_VD_S*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VGP_S+0.5*x_m_VGP_S_VD_S))+(+0.0*(x_m*x_m)+0.0*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))+0.0*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))+1.6666666666666667e-01*(+x_m_VGP_S_VD_S*x_m+x_m_VGP_S*x_m_VD_S+x_m_VD_S*x_m_VGP_S+x_m*x_m_VGP_S_VD_S))))/temp-(((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))*temp_VD_S+(((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))))))))*temp_VGP_S+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S_VD_S)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S*temp_VD_S/temp/temp/temp)));
  alpha_VGP_S_VGP_S=(+eta_p_VGP_S_VGP_S+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S)/temp/temp)+0.0*((((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S)/temp/temp)+7.0710678118654746e-01*((+Gf_VGP_S_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VGP_S*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))+Gf_VGP_S*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VGP_S+0.5*x_m_VGP_S_VGP_S))+(+0.0*(x_m*x_m)+0.0*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))+0.0*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))+1.6666666666666667e-01*(+x_m_VGP_S_VGP_S*x_m+x_m_VGP_S*x_m_VGP_S+x_m_VGP_S*x_m_VGP_S+x_m*x_m_VGP_S_VGP_S))))/temp-(((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))*temp_VGP_S+(((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))))))))*temp_VGP_S+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S_VGP_S)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S*temp_VGP_S/temp/temp/temp)));
  alpha_VGP_S_VS_BP=(+eta_p_VGP_S_VS_BP+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP)/temp/temp)+0.0*((((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S)/temp/temp)+7.0710678118654746e-01*((+Gf_VGP_S_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VGP_S*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))+Gf_VS_BP*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VGP_S+0.5*x_m_VGP_S_VS_BP))+(+0.0*(x_m*x_m)+0.0*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))+0.0*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))+1.6666666666666667e-01*(+x_m_VGP_S_VS_BP*x_m+x_m_VGP_S*x_m_VS_BP+x_m_VS_BP*x_m_VGP_S+x_m*x_m_VGP_S_VS_BP))))/temp-(((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VGP_S))+(1.6666666666666667e-01*((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))*temp_VS_BP+(((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))))))))*temp_VGP_S+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S_VS_BP)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S*temp_VS_BP/temp/temp/temp)));
#endif
alpha_VS_BP=(eta_p_VS_BP+(7.0710678118654746e-01*((((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP)/temp/temp)));
#if defined(_DERIVATE2)
  alpha_VS_BP_VD_S=(+eta_p_VS_BP_VD_S+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VD_S)/temp/temp)+0.0*((((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP)/temp/temp)+7.0710678118654746e-01*((+Gf_VS_BP_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VS_BP*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S))))))+Gf_VD_S*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VD_S+0.0*x_m_VS_BP+0.5*x_m_VS_BP_VD_S))+(+0.0*(x_m*x_m)+0.0*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))+0.0*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))+1.6666666666666667e-01*(+x_m_VS_BP_VD_S*x_m+x_m_VS_BP*x_m_VD_S+x_m_VD_S*x_m_VS_BP+x_m*x_m_VS_BP_VD_S))))/temp-(((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))*temp_VD_S+(((Gf_VD_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VD_S)))+((1.6666666666666667e-01*(((x_m_VD_S*x_m)+(x_m*x_m_VD_S)))))))))*temp_VS_BP+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP_VD_S)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP*temp_VD_S/temp/temp/temp)));
  alpha_VS_BP_VGP_S=(+eta_p_VS_BP_VGP_S+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VGP_S)/temp/temp)+0.0*((((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP)/temp/temp)+7.0710678118654746e-01*((+Gf_VS_BP_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VS_BP*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S))))))+Gf_VGP_S*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VGP_S+0.0*x_m_VS_BP+0.5*x_m_VS_BP_VGP_S))+(+0.0*(x_m*x_m)+0.0*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))+0.0*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))+1.6666666666666667e-01*(+x_m_VS_BP_VGP_S*x_m+x_m_VS_BP*x_m_VGP_S+x_m_VGP_S*x_m_VS_BP+x_m*x_m_VS_BP_VGP_S))))/temp-(((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))*temp_VGP_S+(((Gf_VGP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VGP_S)))+((1.6666666666666667e-01*(((x_m_VGP_S*x_m)+(x_m*x_m_VGP_S)))))))))*temp_VS_BP+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP_VGP_S)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP*temp_VGP_S/temp/temp/temp)));
  alpha_VS_BP_VS_BP=(+eta_p_VS_BP_VS_BP+(+0.0*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)+0.0*(((((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP)/temp/temp)+0.0*((((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))*temp-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP)/temp/temp)+7.0710678118654746e-01*((+Gf_VS_BP_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m)))+Gf_VS_BP*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))+Gf_VS_BP*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))+Gf*(+(+0.0-(+0.0*x_m+0.0*x_m_VS_BP+0.0*x_m_VS_BP+0.5*x_m_VS_BP_VS_BP))+(+0.0*(x_m*x_m)+0.0*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))+0.0*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))+1.6666666666666667e-01*(+x_m_VS_BP_VS_BP*x_m+x_m_VS_BP*x_m_VS_BP+x_m_VS_BP*x_m_VS_BP+x_m*x_m_VS_BP_VS_BP))))/temp-(((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-(0.5*x_m_VS_BP))+(1.6666666666666667e-01*((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP))))))*temp_VS_BP+(((Gf_VS_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))+(Gf*((-((0.5*x_m_VS_BP)))+((1.6666666666666667e-01*(((x_m_VS_BP*x_m)+(x_m*x_m_VS_BP)))))))))*temp_VS_BP+(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP_VS_BP)/temp/temp+2*(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*temp_VS_BP*temp_VS_BP/temp/temp/temp)));
#endif
#endif
pInst->alpha=(pInst->eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
EXIT_IF_ISNAN((pInst->eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Pm_VD_S=(x_m_VD_S+Em_VD_S);
#if defined(_DERIVATE2)
  Pm_VD_S_VD_S=(+(+x_m_VD_S_VD_S-0.0)+Em_VD_S_VD_S);
  Pm_VD_S_VGP_S=(+(+x_m_VD_S_VGP_S-0.0)+Em_VD_S_VGP_S);
  Pm_VD_S_VS_BP=(+(+x_m_VD_S_VS_BP-0.0)+Em_VD_S_VS_BP);
#endif
Pm_VGP_S=(x_m_VGP_S+Em_VGP_S);
#if defined(_DERIVATE2)
  Pm_VGP_S_VD_S=(+(+x_m_VGP_S_VD_S-0.0)+Em_VGP_S_VD_S);
  Pm_VGP_S_VGP_S=(+(+x_m_VGP_S_VGP_S-0.0)+Em_VGP_S_VGP_S);
  Pm_VGP_S_VS_BP=(+(+x_m_VGP_S_VS_BP-0.0)+Em_VGP_S_VS_BP);
#endif
Pm_VS_BP=(x_m_VS_BP+Em_VS_BP);
#if defined(_DERIVATE2)
  Pm_VS_BP_VD_S=(+(+x_m_VS_BP_VD_S-0.0)+Em_VS_BP_VD_S);
  Pm_VS_BP_VGP_S=(+(+x_m_VS_BP_VGP_S-0.0)+Em_VS_BP_VGP_S);
  Pm_VS_BP_VS_BP=(+(+x_m_VS_BP_VS_BP-0.0)+Em_VS_BP_VS_BP);
#endif
#endif
Pm=((x_m-1.0)+Em);
EXIT_IF_ISNAN(((x_m-1.0)+Em))
{
double m00_sqrt(d00_sqrt0,(Dm+Pm))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(Dm+Pm))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
xgm_VD_S=((Gf_VD_S*d00_sqrt0)+(Gf*(Dm_VD_S+Pm_VD_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VD_S_VD_S=(+Gf_VD_S_VD_S*d00_sqrt0+Gf_VD_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VD_S+Pm_VD_S_VD_S)));
  xgm_VD_S_VGP_S=(+Gf_VD_S_VGP_S*d00_sqrt0+Gf_VD_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VGP_S+Pm_VD_S_VGP_S)));
  xgm_VD_S_VS_BP=(+Gf_VD_S_VS_BP*d00_sqrt0+Gf_VD_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VS_BP+Pm_VD_S_VS_BP)));
#endif
xgm_VGP_S=((Gf_VGP_S*d00_sqrt0)+(Gf*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VGP_S_VD_S=(+Gf_VGP_S_VD_S*d00_sqrt0+Gf_VGP_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VD_S+Pm_VGP_S_VD_S)));
  xgm_VGP_S_VGP_S=(+Gf_VGP_S_VGP_S*d00_sqrt0+Gf_VGP_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VGP_S+Pm_VGP_S_VGP_S)));
  xgm_VGP_S_VS_BP=(+Gf_VGP_S_VS_BP*d00_sqrt0+Gf_VGP_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VS_BP+Pm_VGP_S_VS_BP)));
#endif
xgm_VS_BP=((Gf_VS_BP*d00_sqrt0)+(Gf*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VS_BP_VD_S=(+Gf_VS_BP_VD_S*d00_sqrt0+Gf_VS_BP*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VD_S+Pm_VS_BP_VD_S)));
  xgm_VS_BP_VGP_S=(+Gf_VS_BP_VGP_S*d00_sqrt0+Gf_VS_BP*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VGP_S+Pm_VS_BP_VGP_S)));
  xgm_VS_BP_VS_BP=(+Gf_VS_BP_VS_BP*d00_sqrt0+Gf_VS_BP*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VS_BP+Pm_VS_BP_VS_BP)));
#endif
#endif
xgm=(Gf*d00_sqrt0);
EXIT_IF_ISNAN((Gf*d00_sqrt0))
}
if
((pInst->kp>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
d0_VD_S=((-Em_VD_S)+(2.0*((xgm_VD_S*inv_Gf2)+(xgm*inv_Gf2_VD_S))));
#if defined(_DERIVATE2)
  d0_VD_S_VD_S=(+(+0.0-Em_VD_S_VD_S)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VD_S*inv_Gf2)+(xgm*inv_Gf2_VD_S)))+0.0*((xgm_VD_S*inv_Gf2)+(xgm*inv_Gf2_VD_S))+2.0*(+xgm_VD_S_VD_S*inv_Gf2+xgm_VD_S*inv_Gf2_VD_S+xgm_VD_S*inv_Gf2_VD_S+xgm*inv_Gf2_VD_S_VD_S)));
  d0_VD_S_VGP_S=(+(+0.0-Em_VD_S_VGP_S)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VGP_S*inv_Gf2)+(xgm*inv_Gf2_VGP_S)))+0.0*((xgm_VD_S*inv_Gf2)+(xgm*inv_Gf2_VD_S))+2.0*(+xgm_VD_S_VGP_S*inv_Gf2+xgm_VD_S*inv_Gf2_VGP_S+xgm_VGP_S*inv_Gf2_VD_S+xgm*inv_Gf2_VD_S_VGP_S)));
  d0_VD_S_VS_BP=(+(+0.0-Em_VD_S_VS_BP)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VS_BP*inv_Gf2)+(xgm*inv_Gf2_VS_BP)))+0.0*((xgm_VD_S*inv_Gf2)+(xgm*inv_Gf2_VD_S))+2.0*(+xgm_VD_S_VS_BP*inv_Gf2+xgm_VD_S*inv_Gf2_VS_BP+xgm_VS_BP*inv_Gf2_VD_S+xgm*inv_Gf2_VD_S_VS_BP)));
#endif
d0_VGP_S=((-Em_VGP_S)+(2.0*((xgm_VGP_S*inv_Gf2)+(xgm*inv_Gf2_VGP_S))));
#if defined(_DERIVATE2)
  d0_VGP_S_VD_S=(+(+0.0-Em_VGP_S_VD_S)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VD_S*inv_Gf2)+(xgm*inv_Gf2_VD_S)))+0.0*((xgm_VGP_S*inv_Gf2)+(xgm*inv_Gf2_VGP_S))+2.0*(+xgm_VGP_S_VD_S*inv_Gf2+xgm_VGP_S*inv_Gf2_VD_S+xgm_VD_S*inv_Gf2_VGP_S+xgm*inv_Gf2_VGP_S_VD_S)));
  d0_VGP_S_VGP_S=(+(+0.0-Em_VGP_S_VGP_S)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VGP_S*inv_Gf2)+(xgm*inv_Gf2_VGP_S)))+0.0*((xgm_VGP_S*inv_Gf2)+(xgm*inv_Gf2_VGP_S))+2.0*(+xgm_VGP_S_VGP_S*inv_Gf2+xgm_VGP_S*inv_Gf2_VGP_S+xgm_VGP_S*inv_Gf2_VGP_S+xgm*inv_Gf2_VGP_S_VGP_S)));
  d0_VGP_S_VS_BP=(+(+0.0-Em_VGP_S_VS_BP)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VS_BP*inv_Gf2)+(xgm*inv_Gf2_VS_BP)))+0.0*((xgm_VGP_S*inv_Gf2)+(xgm*inv_Gf2_VGP_S))+2.0*(+xgm_VGP_S_VS_BP*inv_Gf2+xgm_VGP_S*inv_Gf2_VS_BP+xgm_VS_BP*inv_Gf2_VGP_S+xgm*inv_Gf2_VGP_S_VS_BP)));
#endif
d0_VS_BP=((-Em_VS_BP)+(2.0*((xgm_VS_BP*inv_Gf2)+(xgm*inv_Gf2_VS_BP))));
#if defined(_DERIVATE2)
  d0_VS_BP_VD_S=(+(+0.0-Em_VS_BP_VD_S)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VD_S*inv_Gf2)+(xgm*inv_Gf2_VD_S)))+0.0*((xgm_VS_BP*inv_Gf2)+(xgm*inv_Gf2_VS_BP))+2.0*(+xgm_VS_BP_VD_S*inv_Gf2+xgm_VS_BP*inv_Gf2_VD_S+xgm_VD_S*inv_Gf2_VS_BP+xgm*inv_Gf2_VS_BP_VD_S)));
  d0_VS_BP_VGP_S=(+(+0.0-Em_VS_BP_VGP_S)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VGP_S*inv_Gf2)+(xgm*inv_Gf2_VGP_S)))+0.0*((xgm_VS_BP*inv_Gf2)+(xgm*inv_Gf2_VS_BP))+2.0*(+xgm_VS_BP_VGP_S*inv_Gf2+xgm_VS_BP*inv_Gf2_VGP_S+xgm_VGP_S*inv_Gf2_VS_BP+xgm*inv_Gf2_VS_BP_VGP_S)));
  d0_VS_BP_VS_BP=(+(+0.0-Em_VS_BP_VS_BP)+(+0.0*(xgm*inv_Gf2)+0.0*(((xgm_VS_BP*inv_Gf2)+(xgm*inv_Gf2_VS_BP)))+0.0*((xgm_VS_BP*inv_Gf2)+(xgm*inv_Gf2_VS_BP))+2.0*(+xgm_VS_BP_VS_BP*inv_Gf2+xgm_VS_BP*inv_Gf2_VS_BP+xgm_VS_BP*inv_Gf2_VS_BP+xgm*inv_Gf2_VS_BP_VS_BP)));
#endif
#endif
d0=((1.0-Em)+(2.0*(xgm*inv_Gf2)));
EXIT_IF_ISNAN(((1.0-Em)+(2.0*(xgm*inv_Gf2))))
{
double m00_sqrt(d00_sqrt0,(1.0+(pInst->kp*xgm)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(pInst->kp*xgm)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
eta_p_VD_S=(-(pInst->kp*xgm_VD_S)*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  eta_p_VD_S_VD_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VD_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VD_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VD_S))*(pInst->kp*xgm_VD_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VD_S+pInst->kp*xgm_VD_S_VD_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VD_S)*d10_sqrt0*((pInst->kp*xgm_VD_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VD_S_VGP_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VGP_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VD_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VGP_S))*(pInst->kp*xgm_VD_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VD_S+pInst->kp*xgm_VD_S_VGP_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VD_S)*d10_sqrt0*((pInst->kp*xgm_VGP_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VD_S_VS_BP=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VS_BP))*d10_sqrt0+0.0*(pInst->kp*xgm_VD_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VS_BP))*(pInst->kp*xgm_VD_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VD_S+pInst->kp*xgm_VD_S_VS_BP))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VD_S)*d10_sqrt0*((pInst->kp*xgm_VS_BP))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
eta_p_VGP_S=(-(pInst->kp*xgm_VGP_S)*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  eta_p_VGP_S_VD_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VD_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VD_S))*(pInst->kp*xgm_VGP_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VGP_S+pInst->kp*xgm_VGP_S_VD_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0*((pInst->kp*xgm_VD_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VGP_S_VGP_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VGP_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VGP_S))*(pInst->kp*xgm_VGP_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VGP_S+pInst->kp*xgm_VGP_S_VGP_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0*((pInst->kp*xgm_VGP_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VGP_S_VS_BP=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VS_BP))*d10_sqrt0+0.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VS_BP))*(pInst->kp*xgm_VGP_S)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VGP_S+pInst->kp*xgm_VGP_S_VS_BP))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VGP_S)*d10_sqrt0*((pInst->kp*xgm_VS_BP))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
eta_p_VS_BP=(-(pInst->kp*xgm_VS_BP)*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  eta_p_VS_BP_VD_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VD_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VD_S))*(pInst->kp*xgm_VS_BP)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VS_BP+pInst->kp*xgm_VS_BP_VD_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0*((pInst->kp*xgm_VD_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VS_BP_VGP_S=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VGP_S))*d10_sqrt0+0.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VGP_S))*(pInst->kp*xgm_VS_BP)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VS_BP+pInst->kp*xgm_VS_BP_VGP_S))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0*((pInst->kp*xgm_VGP_S))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  eta_p_VS_BP_VS_BP=(0.0/d00_sqrt0-(0.0*((pInst->kp*xgm_VS_BP))*d10_sqrt0+0.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0+1.0*(m20_sqrt((1.0+(pInst->kp*xgm)))*((pInst->kp*xgm_VS_BP))*(pInst->kp*xgm_VS_BP)+d10_sqrt0*(+0.0+(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VS_BP+pInst->kp*xgm_VS_BP_VS_BP))))/d00_sqrt0/d00_sqrt0+2*1.0*(pInst->kp*xgm_VS_BP)*d10_sqrt0*((pInst->kp*xgm_VS_BP))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
pInst->eta_p=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=((eta_p_VGP_S*(pInst->eta_p+1.0)-pInst->eta_p*eta_p_VGP_S)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(pInst->eta_p+1.0)-(eta_p_VGP_S*0.0+0.0*eta_p_VGP_S+pInst->eta_p*(+0.0+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VGP_S*0.0/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VGP_S_VS_BS=(0.0/(pInst->eta_p+1.0)-(eta_p_VGP_S*0.0+0.0*eta_p_VGP_S+pInst->eta_p*(+0.0+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VGP_S*0.0/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VGP_S_VGP_S=(eta_p_VGP_S_VGP_S/(pInst->eta_p+1.0)-(eta_p_VGP_S*eta_p_VGP_S+eta_p_VGP_S*eta_p_VGP_S+pInst->eta_p*(+eta_p_VGP_S_VGP_S+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VGP_S*eta_p_VGP_S/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VGP_S_VD_S=(eta_p_VGP_S_VD_S/(pInst->eta_p+1.0)-(eta_p_VGP_S*eta_p_VD_S+eta_p_VD_S*eta_p_VGP_S+pInst->eta_p*(+eta_p_VGP_S_VD_S+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VGP_S*eta_p_VD_S/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VGP_S_VS_BP=(eta_p_VGP_S_VS_BP/(pInst->eta_p+1.0)-(eta_p_VGP_S*eta_p_VS_BP+eta_p_VS_BP*eta_p_VGP_S+pInst->eta_p*(+eta_p_VGP_S_VS_BP+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VGP_S*eta_p_VS_BP/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
#endif
temp_VD_S=((eta_p_VD_S*(pInst->eta_p+1.0)-pInst->eta_p*eta_p_VD_S)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(pInst->eta_p+1.0)-(eta_p_VD_S*0.0+0.0*eta_p_VD_S+pInst->eta_p*(+0.0+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VD_S*0.0/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VD_S_VS_BS=(0.0/(pInst->eta_p+1.0)-(eta_p_VD_S*0.0+0.0*eta_p_VD_S+pInst->eta_p*(+0.0+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VD_S*0.0/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VD_S_VGP_S=(eta_p_VD_S_VGP_S/(pInst->eta_p+1.0)-(eta_p_VD_S*eta_p_VGP_S+eta_p_VGP_S*eta_p_VD_S+pInst->eta_p*(+eta_p_VD_S_VGP_S+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VD_S*eta_p_VGP_S/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VD_S_VD_S=(eta_p_VD_S_VD_S/(pInst->eta_p+1.0)-(eta_p_VD_S*eta_p_VD_S+eta_p_VD_S*eta_p_VD_S+pInst->eta_p*(+eta_p_VD_S_VD_S+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VD_S*eta_p_VD_S/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VD_S_VS_BP=(eta_p_VD_S_VS_BP/(pInst->eta_p+1.0)-(eta_p_VD_S*eta_p_VS_BP+eta_p_VS_BP*eta_p_VD_S+pInst->eta_p*(+eta_p_VD_S_VS_BP+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VD_S*eta_p_VS_BP/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
#endif
temp_VS_BP=((eta_p_VS_BP*(pInst->eta_p+1.0)-pInst->eta_p*eta_p_VS_BP)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(pInst->eta_p+1.0)-(eta_p_VS_BP*0.0+0.0*eta_p_VS_BP+pInst->eta_p*(+0.0+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VS_BP*0.0/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VS_BP_VS_BS=(0.0/(pInst->eta_p+1.0)-(eta_p_VS_BP*0.0+0.0*eta_p_VS_BP+pInst->eta_p*(+0.0+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VS_BP*0.0/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VS_BP_VGP_S=(eta_p_VS_BP_VGP_S/(pInst->eta_p+1.0)-(eta_p_VS_BP*eta_p_VGP_S+eta_p_VGP_S*eta_p_VS_BP+pInst->eta_p*(+eta_p_VS_BP_VGP_S+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VS_BP*eta_p_VGP_S/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VS_BP_VD_S=(eta_p_VS_BP_VD_S/(pInst->eta_p+1.0)-(eta_p_VS_BP*eta_p_VD_S+eta_p_VD_S*eta_p_VS_BP+pInst->eta_p*(+eta_p_VS_BP_VD_S+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VS_BP*eta_p_VD_S/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
  temp_VS_BP_VS_BP=(eta_p_VS_BP_VS_BP/(pInst->eta_p+1.0)-(eta_p_VS_BP*eta_p_VS_BP+eta_p_VS_BP*eta_p_VS_BP+pInst->eta_p*(+eta_p_VS_BP_VS_BP+0.0))/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)+2*pInst->eta_p*eta_p_VS_BP*eta_p_VS_BP/(pInst->eta_p+1.0)/(pInst->eta_p+1.0)/(pInst->eta_p+1.0));
#endif
#endif
temp=(pInst->eta_p/(pInst->eta_p+1.0));
EXIT_IF_ISNAN((pInst->eta_p/(pInst->eta_p+1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_pm_VGP_S=(pInst->kp*((((((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2)+((temp*temp)*Gf2_VGP_S))*Dm)+(((temp*temp)*Gf2)*Dm_VGP_S)));
#if defined(_DERIVATE2)
  x_pm_VGP_S_VGP_S=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2)+((temp*temp)*Gf2_VGP_S)))*Dm)+(((temp*temp)*Gf2)*Dm_VGP_S)))+0.0*((((((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2)+((temp*temp)*Gf2_VGP_S))*Dm)+(((temp*temp)*Gf2)*Dm_VGP_S))+pInst->kp*(+(+(+temp_VGP_S_VGP_S*temp+temp_VGP_S*temp_VGP_S+temp_VGP_S*temp_VGP_S+temp*temp_VGP_S_VGP_S)*Gf2+((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2_VGP_S+(((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2_VGP_S+(temp*temp)*Gf2_VGP_S_VGP_S)*Dm+((((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2)+((temp*temp)*Gf2_VGP_S))*Dm_VGP_S+((((((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2)+((temp*temp)*Gf2_VGP_S)))*Dm_VGP_S+((temp*temp)*Gf2)*Dm_VGP_S_VGP_S));
  x_pm_VGP_S_VD_S=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2)+((temp*temp)*Gf2_VD_S)))*Dm)+(((temp*temp)*Gf2)*Dm_VD_S)))+0.0*((((((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2)+((temp*temp)*Gf2_VGP_S))*Dm)+(((temp*temp)*Gf2)*Dm_VGP_S))+pInst->kp*(+(+(+temp_VGP_S_VD_S*temp+temp_VGP_S*temp_VD_S+temp_VD_S*temp_VGP_S+temp*temp_VGP_S_VD_S)*Gf2+((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2_VD_S+(((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2_VGP_S+(temp*temp)*Gf2_VGP_S_VD_S)*Dm+((((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2)+((temp*temp)*Gf2_VGP_S))*Dm_VD_S+((((((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2)+((temp*temp)*Gf2_VD_S)))*Dm_VGP_S+((temp*temp)*Gf2)*Dm_VGP_S_VD_S));
  x_pm_VGP_S_VS_BP=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2)+((temp*temp)*Gf2_VS_BP)))*Dm)+(((temp*temp)*Gf2)*Dm_VS_BP)))+0.0*((((((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2)+((temp*temp)*Gf2_VGP_S))*Dm)+(((temp*temp)*Gf2)*Dm_VGP_S))+pInst->kp*(+(+(+temp_VGP_S_VS_BP*temp+temp_VGP_S*temp_VS_BP+temp_VS_BP*temp_VGP_S+temp*temp_VGP_S_VS_BP)*Gf2+((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2_VS_BP+(((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2_VGP_S+(temp*temp)*Gf2_VGP_S_VS_BP)*Dm+((((temp_VGP_S*temp)+(temp*temp_VGP_S))*Gf2)+((temp*temp)*Gf2_VGP_S))*Dm_VS_BP+((((((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2)+((temp*temp)*Gf2_VS_BP)))*Dm_VGP_S+((temp*temp)*Gf2)*Dm_VGP_S_VS_BP));
#endif
x_pm_VD_S=(pInst->kp*((((((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2)+((temp*temp)*Gf2_VD_S))*Dm)+(((temp*temp)*Gf2)*Dm_VD_S)));
#if defined(_DERIVATE2)
  x_pm_VD_S_VGP_S=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2)+((temp*temp)*Gf2_VGP_S)))*Dm)+(((temp*temp)*Gf2)*Dm_VGP_S)))+0.0*((((((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2)+((temp*temp)*Gf2_VD_S))*Dm)+(((temp*temp)*Gf2)*Dm_VD_S))+pInst->kp*(+(+(+temp_VD_S_VGP_S*temp+temp_VD_S*temp_VGP_S+temp_VGP_S*temp_VD_S+temp*temp_VD_S_VGP_S)*Gf2+((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2_VGP_S+(((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2_VD_S+(temp*temp)*Gf2_VD_S_VGP_S)*Dm+((((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2)+((temp*temp)*Gf2_VD_S))*Dm_VGP_S+((((((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2)+((temp*temp)*Gf2_VGP_S)))*Dm_VD_S+((temp*temp)*Gf2)*Dm_VD_S_VGP_S));
  x_pm_VD_S_VD_S=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2)+((temp*temp)*Gf2_VD_S)))*Dm)+(((temp*temp)*Gf2)*Dm_VD_S)))+0.0*((((((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2)+((temp*temp)*Gf2_VD_S))*Dm)+(((temp*temp)*Gf2)*Dm_VD_S))+pInst->kp*(+(+(+temp_VD_S_VD_S*temp+temp_VD_S*temp_VD_S+temp_VD_S*temp_VD_S+temp*temp_VD_S_VD_S)*Gf2+((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2_VD_S+(((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2_VD_S+(temp*temp)*Gf2_VD_S_VD_S)*Dm+((((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2)+((temp*temp)*Gf2_VD_S))*Dm_VD_S+((((((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2)+((temp*temp)*Gf2_VD_S)))*Dm_VD_S+((temp*temp)*Gf2)*Dm_VD_S_VD_S));
  x_pm_VD_S_VS_BP=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2)+((temp*temp)*Gf2_VS_BP)))*Dm)+(((temp*temp)*Gf2)*Dm_VS_BP)))+0.0*((((((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2)+((temp*temp)*Gf2_VD_S))*Dm)+(((temp*temp)*Gf2)*Dm_VD_S))+pInst->kp*(+(+(+temp_VD_S_VS_BP*temp+temp_VD_S*temp_VS_BP+temp_VS_BP*temp_VD_S+temp*temp_VD_S_VS_BP)*Gf2+((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2_VS_BP+(((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2_VD_S+(temp*temp)*Gf2_VD_S_VS_BP)*Dm+((((temp_VD_S*temp)+(temp*temp_VD_S))*Gf2)+((temp*temp)*Gf2_VD_S))*Dm_VS_BP+((((((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2)+((temp*temp)*Gf2_VS_BP)))*Dm_VD_S+((temp*temp)*Gf2)*Dm_VD_S_VS_BP));
#endif
x_pm_VS_BP=(pInst->kp*((((((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2)+((temp*temp)*Gf2_VS_BP))*Dm)+(((temp*temp)*Gf2)*Dm_VS_BP)));
#if defined(_DERIVATE2)
  x_pm_VS_BP_VGP_S=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2)+((temp*temp)*Gf2_VGP_S)))*Dm)+(((temp*temp)*Gf2)*Dm_VGP_S)))+0.0*((((((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2)+((temp*temp)*Gf2_VS_BP))*Dm)+(((temp*temp)*Gf2)*Dm_VS_BP))+pInst->kp*(+(+(+temp_VS_BP_VGP_S*temp+temp_VS_BP*temp_VGP_S+temp_VGP_S*temp_VS_BP+temp*temp_VS_BP_VGP_S)*Gf2+((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2_VGP_S+(((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2_VS_BP+(temp*temp)*Gf2_VS_BP_VGP_S)*Dm+((((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2)+((temp*temp)*Gf2_VS_BP))*Dm_VGP_S+((((((temp_VGP_S*temp)+(temp*temp_VGP_S)))*Gf2)+((temp*temp)*Gf2_VGP_S)))*Dm_VS_BP+((temp*temp)*Gf2)*Dm_VS_BP_VGP_S));
  x_pm_VS_BP_VD_S=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2)+((temp*temp)*Gf2_VD_S)))*Dm)+(((temp*temp)*Gf2)*Dm_VD_S)))+0.0*((((((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2)+((temp*temp)*Gf2_VS_BP))*Dm)+(((temp*temp)*Gf2)*Dm_VS_BP))+pInst->kp*(+(+(+temp_VS_BP_VD_S*temp+temp_VS_BP*temp_VD_S+temp_VD_S*temp_VS_BP+temp*temp_VS_BP_VD_S)*Gf2+((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2_VD_S+(((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2_VS_BP+(temp*temp)*Gf2_VS_BP_VD_S)*Dm+((((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2)+((temp*temp)*Gf2_VS_BP))*Dm_VD_S+((((((temp_VD_S*temp)+(temp*temp_VD_S)))*Gf2)+((temp*temp)*Gf2_VD_S)))*Dm_VS_BP+((temp*temp)*Gf2)*Dm_VS_BP_VD_S));
  x_pm_VS_BP_VS_BP=(+0.0*(((temp*temp)*Gf2)*Dm)+0.0*(((((((((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2)+((temp*temp)*Gf2_VS_BP)))*Dm)+(((temp*temp)*Gf2)*Dm_VS_BP)))+0.0*((((((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2)+((temp*temp)*Gf2_VS_BP))*Dm)+(((temp*temp)*Gf2)*Dm_VS_BP))+pInst->kp*(+(+(+temp_VS_BP_VS_BP*temp+temp_VS_BP*temp_VS_BP+temp_VS_BP*temp_VS_BP+temp*temp_VS_BP_VS_BP)*Gf2+((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2_VS_BP+(((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2_VS_BP+(temp*temp)*Gf2_VS_BP_VS_BP)*Dm+((((temp_VS_BP*temp)+(temp*temp_VS_BP))*Gf2)+((temp*temp)*Gf2_VS_BP))*Dm_VS_BP+((((((temp_VS_BP*temp)+(temp*temp_VS_BP)))*Gf2)+((temp*temp)*Gf2_VS_BP)))*Dm_VS_BP+((temp*temp)*Gf2)*Dm_VS_BP_VS_BP));
#endif
#endif
x_pm=(pInst->kp*(((temp*temp)*Gf2)*Dm));
EXIT_IF_ISNAN((pInst->kp*(((temp*temp)*Gf2)*Dm)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
p_pd_VD_S=((2.0*(xgm_VD_S-x_pm_VD_S))+((Gf2_VD_S*((1.0-Em)+Dm))+(Gf2*((-Em_VD_S)+Dm_VD_S))));
#if defined(_DERIVATE2)
  p_pd_VD_S_VD_S=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VD_S-x_pm_VD_S)+0.0*(xgm_VD_S-x_pm_VD_S)+2.0*(+xgm_VD_S_VD_S-x_pm_VD_S_VD_S))+(+Gf2_VD_S_VD_S*((1.0-Em)+Dm)+Gf2_VD_S*((-Em_VD_S)+Dm_VD_S)+Gf2_VD_S*((-Em_VD_S)+Dm_VD_S)+Gf2*(+(+0.0-Em_VD_S_VD_S)+Dm_VD_S_VD_S)));
  p_pd_VD_S_VGP_S=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VGP_S-x_pm_VGP_S)+0.0*(xgm_VD_S-x_pm_VD_S)+2.0*(+xgm_VD_S_VGP_S-x_pm_VD_S_VGP_S))+(+Gf2_VD_S_VGP_S*((1.0-Em)+Dm)+Gf2_VD_S*((-Em_VGP_S)+Dm_VGP_S)+Gf2_VGP_S*((-Em_VD_S)+Dm_VD_S)+Gf2*(+(+0.0-Em_VD_S_VGP_S)+Dm_VD_S_VGP_S)));
  p_pd_VD_S_VS_BP=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VS_BP-x_pm_VS_BP)+0.0*(xgm_VD_S-x_pm_VD_S)+2.0*(+xgm_VD_S_VS_BP-x_pm_VD_S_VS_BP))+(+Gf2_VD_S_VS_BP*((1.0-Em)+Dm)+Gf2_VD_S*((-Em_VS_BP)+Dm_VS_BP)+Gf2_VS_BP*((-Em_VD_S)+Dm_VD_S)+Gf2*(+(+0.0-Em_VD_S_VS_BP)+Dm_VD_S_VS_BP)));
#endif
p_pd_VGP_S=((2.0*(xgm_VGP_S-x_pm_VGP_S))+((Gf2_VGP_S*((1.0-Em)+Dm))+(Gf2*((-Em_VGP_S)+Dm_VGP_S))));
#if defined(_DERIVATE2)
  p_pd_VGP_S_VD_S=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VD_S-x_pm_VD_S)+0.0*(xgm_VGP_S-x_pm_VGP_S)+2.0*(+xgm_VGP_S_VD_S-x_pm_VGP_S_VD_S))+(+Gf2_VGP_S_VD_S*((1.0-Em)+Dm)+Gf2_VGP_S*((-Em_VD_S)+Dm_VD_S)+Gf2_VD_S*((-Em_VGP_S)+Dm_VGP_S)+Gf2*(+(+0.0-Em_VGP_S_VD_S)+Dm_VGP_S_VD_S)));
  p_pd_VGP_S_VGP_S=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VGP_S-x_pm_VGP_S)+0.0*(xgm_VGP_S-x_pm_VGP_S)+2.0*(+xgm_VGP_S_VGP_S-x_pm_VGP_S_VGP_S))+(+Gf2_VGP_S_VGP_S*((1.0-Em)+Dm)+Gf2_VGP_S*((-Em_VGP_S)+Dm_VGP_S)+Gf2_VGP_S*((-Em_VGP_S)+Dm_VGP_S)+Gf2*(+(+0.0-Em_VGP_S_VGP_S)+Dm_VGP_S_VGP_S)));
  p_pd_VGP_S_VS_BP=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VS_BP-x_pm_VS_BP)+0.0*(xgm_VGP_S-x_pm_VGP_S)+2.0*(+xgm_VGP_S_VS_BP-x_pm_VGP_S_VS_BP))+(+Gf2_VGP_S_VS_BP*((1.0-Em)+Dm)+Gf2_VGP_S*((-Em_VS_BP)+Dm_VS_BP)+Gf2_VS_BP*((-Em_VGP_S)+Dm_VGP_S)+Gf2*(+(+0.0-Em_VGP_S_VS_BP)+Dm_VGP_S_VS_BP)));
#endif
p_pd_VS_BP=((2.0*(xgm_VS_BP-x_pm_VS_BP))+((Gf2_VS_BP*((1.0-Em)+Dm))+(Gf2*((-Em_VS_BP)+Dm_VS_BP))));
#if defined(_DERIVATE2)
  p_pd_VS_BP_VD_S=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VD_S-x_pm_VD_S)+0.0*(xgm_VS_BP-x_pm_VS_BP)+2.0*(+xgm_VS_BP_VD_S-x_pm_VS_BP_VD_S))+(+Gf2_VS_BP_VD_S*((1.0-Em)+Dm)+Gf2_VS_BP*((-Em_VD_S)+Dm_VD_S)+Gf2_VD_S*((-Em_VS_BP)+Dm_VS_BP)+Gf2*(+(+0.0-Em_VS_BP_VD_S)+Dm_VS_BP_VD_S)));
  p_pd_VS_BP_VGP_S=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VGP_S-x_pm_VGP_S)+0.0*(xgm_VS_BP-x_pm_VS_BP)+2.0*(+xgm_VS_BP_VGP_S-x_pm_VS_BP_VGP_S))+(+Gf2_VS_BP_VGP_S*((1.0-Em)+Dm)+Gf2_VS_BP*((-Em_VGP_S)+Dm_VGP_S)+Gf2_VGP_S*((-Em_VS_BP)+Dm_VS_BP)+Gf2*(+(+0.0-Em_VS_BP_VGP_S)+Dm_VS_BP_VGP_S)));
  p_pd_VS_BP_VS_BP=(+(+0.0*(xgm-x_pm)+0.0*(xgm_VS_BP-x_pm_VS_BP)+0.0*(xgm_VS_BP-x_pm_VS_BP)+2.0*(+xgm_VS_BP_VS_BP-x_pm_VS_BP_VS_BP))+(+Gf2_VS_BP_VS_BP*((1.0-Em)+Dm)+Gf2_VS_BP*((-Em_VS_BP)+Dm_VS_BP)+Gf2_VS_BP*((-Em_VS_BP)+Dm_VS_BP)+Gf2*(+(+0.0-Em_VS_BP_VS_BP)+Dm_VS_BP_VS_BP)));
#endif
#endif
p_pd=((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));
EXIT_IF_ISNAN(((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
q_pd_VGP_S=((x_pm_VGP_S*(x_pm-(2.0*xgm)))+(x_pm*(x_pm_VGP_S-(2.0*xgm_VGP_S))));
#if defined(_DERIVATE2)
  q_pd_VGP_S_VGP_S=(+x_pm_VGP_S_VGP_S*(x_pm-(2.0*xgm))+x_pm_VGP_S*(x_pm_VGP_S-((2.0*xgm_VGP_S)))+x_pm_VGP_S*(x_pm_VGP_S-(2.0*xgm_VGP_S))+x_pm*(+x_pm_VGP_S_VGP_S-(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VGP_S+2.0*xgm_VGP_S_VGP_S)));
  q_pd_VGP_S_VD_S=(+x_pm_VGP_S_VD_S*(x_pm-(2.0*xgm))+x_pm_VGP_S*(x_pm_VD_S-((2.0*xgm_VD_S)))+x_pm_VD_S*(x_pm_VGP_S-(2.0*xgm_VGP_S))+x_pm*(+x_pm_VGP_S_VD_S-(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VGP_S+2.0*xgm_VGP_S_VD_S)));
  q_pd_VGP_S_VS_BP=(+x_pm_VGP_S_VS_BP*(x_pm-(2.0*xgm))+x_pm_VGP_S*(x_pm_VS_BP-((2.0*xgm_VS_BP)))+x_pm_VS_BP*(x_pm_VGP_S-(2.0*xgm_VGP_S))+x_pm*(+x_pm_VGP_S_VS_BP-(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VGP_S+2.0*xgm_VGP_S_VS_BP)));
#endif
q_pd_VD_S=((x_pm_VD_S*(x_pm-(2.0*xgm)))+(x_pm*(x_pm_VD_S-(2.0*xgm_VD_S))));
#if defined(_DERIVATE2)
  q_pd_VD_S_VGP_S=(+x_pm_VD_S_VGP_S*(x_pm-(2.0*xgm))+x_pm_VD_S*(x_pm_VGP_S-((2.0*xgm_VGP_S)))+x_pm_VGP_S*(x_pm_VD_S-(2.0*xgm_VD_S))+x_pm*(+x_pm_VD_S_VGP_S-(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VD_S+2.0*xgm_VD_S_VGP_S)));
  q_pd_VD_S_VD_S=(+x_pm_VD_S_VD_S*(x_pm-(2.0*xgm))+x_pm_VD_S*(x_pm_VD_S-((2.0*xgm_VD_S)))+x_pm_VD_S*(x_pm_VD_S-(2.0*xgm_VD_S))+x_pm*(+x_pm_VD_S_VD_S-(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VD_S+2.0*xgm_VD_S_VD_S)));
  q_pd_VD_S_VS_BP=(+x_pm_VD_S_VS_BP*(x_pm-(2.0*xgm))+x_pm_VD_S*(x_pm_VS_BP-((2.0*xgm_VS_BP)))+x_pm_VS_BP*(x_pm_VD_S-(2.0*xgm_VD_S))+x_pm*(+x_pm_VD_S_VS_BP-(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VD_S+2.0*xgm_VD_S_VS_BP)));
#endif
q_pd_VS_BP=((x_pm_VS_BP*(x_pm-(2.0*xgm)))+(x_pm*(x_pm_VS_BP-(2.0*xgm_VS_BP))));
#if defined(_DERIVATE2)
  q_pd_VS_BP_VGP_S=(+x_pm_VS_BP_VGP_S*(x_pm-(2.0*xgm))+x_pm_VS_BP*(x_pm_VGP_S-((2.0*xgm_VGP_S)))+x_pm_VGP_S*(x_pm_VS_BP-(2.0*xgm_VS_BP))+x_pm*(+x_pm_VS_BP_VGP_S-(+0.0*xgm+0.0*xgm_VGP_S+0.0*xgm_VS_BP+2.0*xgm_VS_BP_VGP_S)));
  q_pd_VS_BP_VD_S=(+x_pm_VS_BP_VD_S*(x_pm-(2.0*xgm))+x_pm_VS_BP*(x_pm_VD_S-((2.0*xgm_VD_S)))+x_pm_VD_S*(x_pm_VS_BP-(2.0*xgm_VS_BP))+x_pm*(+x_pm_VS_BP_VD_S-(+0.0*xgm+0.0*xgm_VD_S+0.0*xgm_VS_BP+2.0*xgm_VS_BP_VD_S)));
  q_pd_VS_BP_VS_BP=(+x_pm_VS_BP_VS_BP*(x_pm-(2.0*xgm))+x_pm_VS_BP*(x_pm_VS_BP-((2.0*xgm_VS_BP)))+x_pm_VS_BP*(x_pm_VS_BP-(2.0*xgm_VS_BP))+x_pm*(+x_pm_VS_BP_VS_BP-(+0.0*xgm+0.0*xgm_VS_BP+0.0*xgm_VS_BP+2.0*xgm_VS_BP_VS_BP)));
#endif
#endif
q_pd=(x_pm*(x_pm-(2.0*xgm)));
EXIT_IF_ISNAN((x_pm*(x_pm-(2.0*xgm))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xi_pd_VD_S=(-(0.5*((Gf2_VD_S*(Em+Dm))+(Gf2*(Em_VD_S+Dm_VD_S)))));
#if defined(_DERIVATE2)
  xi_pd_VD_S_VD_S=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VD_S*(Em+Dm))+(Gf2*(Em_VD_S+Dm_VD_S))))+0.0*((Gf2_VD_S*(Em+Dm))+(Gf2*(Em_VD_S+Dm_VD_S)))+0.5*(+Gf2_VD_S_VD_S*(Em+Dm)+Gf2_VD_S*(Em_VD_S+Dm_VD_S)+Gf2_VD_S*(Em_VD_S+Dm_VD_S)+Gf2*(+Em_VD_S_VD_S+Dm_VD_S_VD_S))));
  xi_pd_VD_S_VGP_S=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VGP_S*(Em+Dm))+(Gf2*(Em_VGP_S+Dm_VGP_S))))+0.0*((Gf2_VD_S*(Em+Dm))+(Gf2*(Em_VD_S+Dm_VD_S)))+0.5*(+Gf2_VD_S_VGP_S*(Em+Dm)+Gf2_VD_S*(Em_VGP_S+Dm_VGP_S)+Gf2_VGP_S*(Em_VD_S+Dm_VD_S)+Gf2*(+Em_VD_S_VGP_S+Dm_VD_S_VGP_S))));
  xi_pd_VD_S_VS_BP=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VS_BP*(Em+Dm))+(Gf2*(Em_VS_BP+Dm_VS_BP))))+0.0*((Gf2_VD_S*(Em+Dm))+(Gf2*(Em_VD_S+Dm_VD_S)))+0.5*(+Gf2_VD_S_VS_BP*(Em+Dm)+Gf2_VD_S*(Em_VS_BP+Dm_VS_BP)+Gf2_VS_BP*(Em_VD_S+Dm_VD_S)+Gf2*(+Em_VD_S_VS_BP+Dm_VD_S_VS_BP))));
#endif
xi_pd_VGP_S=(-(0.5*((Gf2_VGP_S*(Em+Dm))+(Gf2*(Em_VGP_S+Dm_VGP_S)))));
#if defined(_DERIVATE2)
  xi_pd_VGP_S_VD_S=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VD_S*(Em+Dm))+(Gf2*(Em_VD_S+Dm_VD_S))))+0.0*((Gf2_VGP_S*(Em+Dm))+(Gf2*(Em_VGP_S+Dm_VGP_S)))+0.5*(+Gf2_VGP_S_VD_S*(Em+Dm)+Gf2_VGP_S*(Em_VD_S+Dm_VD_S)+Gf2_VD_S*(Em_VGP_S+Dm_VGP_S)+Gf2*(+Em_VGP_S_VD_S+Dm_VGP_S_VD_S))));
  xi_pd_VGP_S_VGP_S=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VGP_S*(Em+Dm))+(Gf2*(Em_VGP_S+Dm_VGP_S))))+0.0*((Gf2_VGP_S*(Em+Dm))+(Gf2*(Em_VGP_S+Dm_VGP_S)))+0.5*(+Gf2_VGP_S_VGP_S*(Em+Dm)+Gf2_VGP_S*(Em_VGP_S+Dm_VGP_S)+Gf2_VGP_S*(Em_VGP_S+Dm_VGP_S)+Gf2*(+Em_VGP_S_VGP_S+Dm_VGP_S_VGP_S))));
  xi_pd_VGP_S_VS_BP=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VS_BP*(Em+Dm))+(Gf2*(Em_VS_BP+Dm_VS_BP))))+0.0*((Gf2_VGP_S*(Em+Dm))+(Gf2*(Em_VGP_S+Dm_VGP_S)))+0.5*(+Gf2_VGP_S_VS_BP*(Em+Dm)+Gf2_VGP_S*(Em_VS_BP+Dm_VS_BP)+Gf2_VS_BP*(Em_VGP_S+Dm_VGP_S)+Gf2*(+Em_VGP_S_VS_BP+Dm_VGP_S_VS_BP))));
#endif
xi_pd_VS_BP=(-(0.5*((Gf2_VS_BP*(Em+Dm))+(Gf2*(Em_VS_BP+Dm_VS_BP)))));
#if defined(_DERIVATE2)
  xi_pd_VS_BP_VD_S=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VD_S*(Em+Dm))+(Gf2*(Em_VD_S+Dm_VD_S))))+0.0*((Gf2_VS_BP*(Em+Dm))+(Gf2*(Em_VS_BP+Dm_VS_BP)))+0.5*(+Gf2_VS_BP_VD_S*(Em+Dm)+Gf2_VS_BP*(Em_VD_S+Dm_VD_S)+Gf2_VD_S*(Em_VS_BP+Dm_VS_BP)+Gf2*(+Em_VS_BP_VD_S+Dm_VS_BP_VD_S))));
  xi_pd_VS_BP_VGP_S=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VGP_S*(Em+Dm))+(Gf2*(Em_VGP_S+Dm_VGP_S))))+0.0*((Gf2_VS_BP*(Em+Dm))+(Gf2*(Em_VS_BP+Dm_VS_BP)))+0.5*(+Gf2_VS_BP_VGP_S*(Em+Dm)+Gf2_VS_BP*(Em_VGP_S+Dm_VGP_S)+Gf2_VGP_S*(Em_VS_BP+Dm_VS_BP)+Gf2*(+Em_VS_BP_VGP_S+Dm_VS_BP_VGP_S))));
  xi_pd_VS_BP_VS_BP=(+0.0-(+0.0*(Gf2*(Em+Dm))+0.0*(((Gf2_VS_BP*(Em+Dm))+(Gf2*(Em_VS_BP+Dm_VS_BP))))+0.0*((Gf2_VS_BP*(Em+Dm))+(Gf2*(Em_VS_BP+Dm_VS_BP)))+0.5*(+Gf2_VS_BP_VS_BP*(Em+Dm)+Gf2_VS_BP*(Em_VS_BP+Dm_VS_BP)+Gf2_VS_BP*(Em_VS_BP+Dm_VS_BP)+Gf2*(+Em_VS_BP_VS_BP+Dm_VS_BP_VS_BP))));
#endif
#endif
xi_pd=(1.0-(0.5*(Gf2*(Em+Dm))));
EXIT_IF_ISNAN((1.0-(0.5*(Gf2*(Em+Dm)))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
u_pd_VGP_S=((((q_pd_VGP_S*p_pd)+(q_pd*p_pd_VGP_S))*((p_pd*p_pd)-(xi_pd*q_pd))-(q_pd*p_pd)*(((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S))-((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
#if defined(_DERIVATE2)
  u_pd_VGP_S_VGP_S=((+q_pd_VGP_S_VGP_S*p_pd+q_pd_VGP_S*p_pd_VGP_S+q_pd_VGP_S*p_pd_VGP_S+q_pd*p_pd_VGP_S_VGP_S)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VGP_S*p_pd)+(q_pd*p_pd_VGP_S))*((((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S)))-(((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S))))+(((q_pd_VGP_S*p_pd)+(q_pd*p_pd_VGP_S)))*(((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S))-((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S)))+(q_pd*p_pd)*(+(+p_pd_VGP_S_VGP_S*p_pd+p_pd_VGP_S*p_pd_VGP_S+p_pd_VGP_S*p_pd_VGP_S+p_pd*p_pd_VGP_S_VGP_S)-(+xi_pd_VGP_S_VGP_S*q_pd+xi_pd_VGP_S*q_pd_VGP_S+xi_pd_VGP_S*q_pd_VGP_S+xi_pd*q_pd_VGP_S_VGP_S)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S))-((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S)))*((((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S)))-(((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
  u_pd_VGP_S_VD_S=((+q_pd_VGP_S_VD_S*p_pd+q_pd_VGP_S*p_pd_VD_S+q_pd_VD_S*p_pd_VGP_S+q_pd*p_pd_VGP_S_VD_S)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VGP_S*p_pd)+(q_pd*p_pd_VGP_S))*((((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S)))-(((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S))))+(((q_pd_VD_S*p_pd)+(q_pd*p_pd_VD_S)))*(((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S))-((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S)))+(q_pd*p_pd)*(+(+p_pd_VGP_S_VD_S*p_pd+p_pd_VGP_S*p_pd_VD_S+p_pd_VD_S*p_pd_VGP_S+p_pd*p_pd_VGP_S_VD_S)-(+xi_pd_VGP_S_VD_S*q_pd+xi_pd_VGP_S*q_pd_VD_S+xi_pd_VD_S*q_pd_VGP_S+xi_pd*q_pd_VGP_S_VD_S)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S))-((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S)))*((((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S)))-(((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
  u_pd_VGP_S_VS_BP=((+q_pd_VGP_S_VS_BP*p_pd+q_pd_VGP_S*p_pd_VS_BP+q_pd_VS_BP*p_pd_VGP_S+q_pd*p_pd_VGP_S_VS_BP)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VGP_S*p_pd)+(q_pd*p_pd_VGP_S))*((((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP)))-(((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP))))+(((q_pd_VS_BP*p_pd)+(q_pd*p_pd_VS_BP)))*(((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S))-((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S)))+(q_pd*p_pd)*(+(+p_pd_VGP_S_VS_BP*p_pd+p_pd_VGP_S*p_pd_VS_BP+p_pd_VS_BP*p_pd_VGP_S+p_pd*p_pd_VGP_S_VS_BP)-(+xi_pd_VGP_S_VS_BP*q_pd+xi_pd_VGP_S*q_pd_VS_BP+xi_pd_VS_BP*q_pd_VGP_S+xi_pd*q_pd_VGP_S_VS_BP)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S))-((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S)))*((((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP)))-(((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
#endif
u_pd_VD_S=((((q_pd_VD_S*p_pd)+(q_pd*p_pd_VD_S))*((p_pd*p_pd)-(xi_pd*q_pd))-(q_pd*p_pd)*(((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S))-((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
#if defined(_DERIVATE2)
  u_pd_VD_S_VGP_S=((+q_pd_VD_S_VGP_S*p_pd+q_pd_VD_S*p_pd_VGP_S+q_pd_VGP_S*p_pd_VD_S+q_pd*p_pd_VD_S_VGP_S)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VD_S*p_pd)+(q_pd*p_pd_VD_S))*((((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S)))-(((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S))))+(((q_pd_VGP_S*p_pd)+(q_pd*p_pd_VGP_S)))*(((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S))-((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S)))+(q_pd*p_pd)*(+(+p_pd_VD_S_VGP_S*p_pd+p_pd_VD_S*p_pd_VGP_S+p_pd_VGP_S*p_pd_VD_S+p_pd*p_pd_VD_S_VGP_S)-(+xi_pd_VD_S_VGP_S*q_pd+xi_pd_VD_S*q_pd_VGP_S+xi_pd_VGP_S*q_pd_VD_S+xi_pd*q_pd_VD_S_VGP_S)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S))-((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S)))*((((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S)))-(((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
  u_pd_VD_S_VD_S=((+q_pd_VD_S_VD_S*p_pd+q_pd_VD_S*p_pd_VD_S+q_pd_VD_S*p_pd_VD_S+q_pd*p_pd_VD_S_VD_S)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VD_S*p_pd)+(q_pd*p_pd_VD_S))*((((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S)))-(((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S))))+(((q_pd_VD_S*p_pd)+(q_pd*p_pd_VD_S)))*(((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S))-((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S)))+(q_pd*p_pd)*(+(+p_pd_VD_S_VD_S*p_pd+p_pd_VD_S*p_pd_VD_S+p_pd_VD_S*p_pd_VD_S+p_pd*p_pd_VD_S_VD_S)-(+xi_pd_VD_S_VD_S*q_pd+xi_pd_VD_S*q_pd_VD_S+xi_pd_VD_S*q_pd_VD_S+xi_pd*q_pd_VD_S_VD_S)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S))-((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S)))*((((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S)))-(((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
  u_pd_VD_S_VS_BP=((+q_pd_VD_S_VS_BP*p_pd+q_pd_VD_S*p_pd_VS_BP+q_pd_VS_BP*p_pd_VD_S+q_pd*p_pd_VD_S_VS_BP)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VD_S*p_pd)+(q_pd*p_pd_VD_S))*((((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP)))-(((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP))))+(((q_pd_VS_BP*p_pd)+(q_pd*p_pd_VS_BP)))*(((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S))-((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S)))+(q_pd*p_pd)*(+(+p_pd_VD_S_VS_BP*p_pd+p_pd_VD_S*p_pd_VS_BP+p_pd_VS_BP*p_pd_VD_S+p_pd*p_pd_VD_S_VS_BP)-(+xi_pd_VD_S_VS_BP*q_pd+xi_pd_VD_S*q_pd_VS_BP+xi_pd_VS_BP*q_pd_VD_S+xi_pd*q_pd_VD_S_VS_BP)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S))-((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S)))*((((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP)))-(((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
#endif
u_pd_VS_BP=((((q_pd_VS_BP*p_pd)+(q_pd*p_pd_VS_BP))*((p_pd*p_pd)-(xi_pd*q_pd))-(q_pd*p_pd)*(((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP))-((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
#if defined(_DERIVATE2)
  u_pd_VS_BP_VGP_S=((+q_pd_VS_BP_VGP_S*p_pd+q_pd_VS_BP*p_pd_VGP_S+q_pd_VGP_S*p_pd_VS_BP+q_pd*p_pd_VS_BP_VGP_S)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VS_BP*p_pd)+(q_pd*p_pd_VS_BP))*((((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S)))-(((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S))))+(((q_pd_VGP_S*p_pd)+(q_pd*p_pd_VGP_S)))*(((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP))-((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP)))+(q_pd*p_pd)*(+(+p_pd_VS_BP_VGP_S*p_pd+p_pd_VS_BP*p_pd_VGP_S+p_pd_VGP_S*p_pd_VS_BP+p_pd*p_pd_VS_BP_VGP_S)-(+xi_pd_VS_BP_VGP_S*q_pd+xi_pd_VS_BP*q_pd_VGP_S+xi_pd_VGP_S*q_pd_VS_BP+xi_pd*q_pd_VS_BP_VGP_S)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP))-((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP)))*((((p_pd_VGP_S*p_pd)+(p_pd*p_pd_VGP_S)))-(((xi_pd_VGP_S*q_pd)+(xi_pd*q_pd_VGP_S))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
  u_pd_VS_BP_VD_S=((+q_pd_VS_BP_VD_S*p_pd+q_pd_VS_BP*p_pd_VD_S+q_pd_VD_S*p_pd_VS_BP+q_pd*p_pd_VS_BP_VD_S)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VS_BP*p_pd)+(q_pd*p_pd_VS_BP))*((((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S)))-(((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S))))+(((q_pd_VD_S*p_pd)+(q_pd*p_pd_VD_S)))*(((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP))-((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP)))+(q_pd*p_pd)*(+(+p_pd_VS_BP_VD_S*p_pd+p_pd_VS_BP*p_pd_VD_S+p_pd_VD_S*p_pd_VS_BP+p_pd*p_pd_VS_BP_VD_S)-(+xi_pd_VS_BP_VD_S*q_pd+xi_pd_VS_BP*q_pd_VD_S+xi_pd_VD_S*q_pd_VS_BP+xi_pd*q_pd_VS_BP_VD_S)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP))-((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP)))*((((p_pd_VD_S*p_pd)+(p_pd*p_pd_VD_S)))-(((xi_pd_VD_S*q_pd)+(xi_pd*q_pd_VD_S))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
  u_pd_VS_BP_VS_BP=((+q_pd_VS_BP_VS_BP*p_pd+q_pd_VS_BP*p_pd_VS_BP+q_pd_VS_BP*p_pd_VS_BP+q_pd*p_pd_VS_BP_VS_BP)/((p_pd*p_pd)-(xi_pd*q_pd))-(((q_pd_VS_BP*p_pd)+(q_pd*p_pd_VS_BP))*((((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP)))-(((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP))))+(((q_pd_VS_BP*p_pd)+(q_pd*p_pd_VS_BP)))*(((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP))-((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP)))+(q_pd*p_pd)*(+(+p_pd_VS_BP_VS_BP*p_pd+p_pd_VS_BP*p_pd_VS_BP+p_pd_VS_BP*p_pd_VS_BP+p_pd*p_pd_VS_BP_VS_BP)-(+xi_pd_VS_BP_VS_BP*q_pd+xi_pd_VS_BP*q_pd_VS_BP+xi_pd_VS_BP*q_pd_VS_BP+xi_pd*q_pd_VS_BP_VS_BP)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))+2*(q_pd*p_pd)*(((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP))-((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP)))*((((p_pd_VS_BP*p_pd)+(p_pd*p_pd_VS_BP)))-(((xi_pd_VS_BP*q_pd)+(xi_pd*q_pd_VS_BP))))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
#endif
#endif
u_pd=((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));
EXIT_IF_ISNAN(((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
x_m_VD_S=(x_m_VD_S+u_pd_VD_S);
#if defined(_DERIVATE2)
  x_m_VD_S_VD_S=(+x_m_VD_S_VD_S+u_pd_VD_S_VD_S);
  x_m_VD_S_VGP_S=(+x_m_VD_S_VGP_S+u_pd_VD_S_VGP_S);
  x_m_VD_S_VS_BP=(+x_m_VD_S_VS_BP+u_pd_VD_S_VS_BP);
#endif
x_m_VGP_S=(x_m_VGP_S+u_pd_VGP_S);
#if defined(_DERIVATE2)
  x_m_VGP_S_VD_S=(+x_m_VGP_S_VD_S+u_pd_VGP_S_VD_S);
  x_m_VGP_S_VGP_S=(+x_m_VGP_S_VGP_S+u_pd_VGP_S_VGP_S);
  x_m_VGP_S_VS_BP=(+x_m_VGP_S_VS_BP+u_pd_VGP_S_VS_BP);
#endif
x_m_VS_BP=(x_m_VS_BP+u_pd_VS_BP);
#if defined(_DERIVATE2)
  x_m_VS_BP_VD_S=(+x_m_VS_BP_VD_S+u_pd_VS_BP_VD_S);
  x_m_VS_BP_VGP_S=(+x_m_VS_BP_VGP_S+u_pd_VS_BP_VGP_S);
  x_m_VS_BP_VS_BP=(+x_m_VS_BP_VS_BP+u_pd_VS_BP_VS_BP);
#endif
#endif
x_m=(x_m+u_pd);
EXIT_IF_ISNAN((x_m+u_pd))
{
double m00_exp(d00_exp0,u_pd)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
km_VGP_S=u_pd_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  km_VGP_S_VGP_S=(m20_exp(u_pd)*u_pd_VGP_S*u_pd_VGP_S+d10_exp0*u_pd_VGP_S_VGP_S);
  km_VGP_S_VD_S=(m20_exp(u_pd)*u_pd_VD_S*u_pd_VGP_S+d10_exp0*u_pd_VGP_S_VD_S);
  km_VGP_S_VS_BP=(m20_exp(u_pd)*u_pd_VS_BP*u_pd_VGP_S+d10_exp0*u_pd_VGP_S_VS_BP);
#endif
km_VD_S=u_pd_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  km_VD_S_VGP_S=(m20_exp(u_pd)*u_pd_VGP_S*u_pd_VD_S+d10_exp0*u_pd_VD_S_VGP_S);
  km_VD_S_VD_S=(m20_exp(u_pd)*u_pd_VD_S*u_pd_VD_S+d10_exp0*u_pd_VD_S_VD_S);
  km_VD_S_VS_BP=(m20_exp(u_pd)*u_pd_VS_BP*u_pd_VD_S+d10_exp0*u_pd_VD_S_VS_BP);
#endif
km_VS_BP=u_pd_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  km_VS_BP_VGP_S=(m20_exp(u_pd)*u_pd_VGP_S*u_pd_VS_BP+d10_exp0*u_pd_VS_BP_VGP_S);
  km_VS_BP_VD_S=(m20_exp(u_pd)*u_pd_VD_S*u_pd_VS_BP+d10_exp0*u_pd_VS_BP_VD_S);
  km_VS_BP_VS_BP=(m20_exp(u_pd)*u_pd_VS_BP*u_pd_VS_BP+d10_exp0*u_pd_VS_BP_VS_BP);
#endif
#endif
km=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Em_VD_S=((Em_VD_S*km-Em*km_VD_S)/km/km);
#if defined(_DERIVATE2)
  Em_VD_S_VD_S=(Em_VD_S_VD_S/km-(Em_VD_S*km_VD_S+Em_VD_S*km_VD_S+Em*km_VD_S_VD_S)/km/km+2*Em*km_VD_S*km_VD_S/km/km/km);
  Em_VD_S_VGP_S=(Em_VD_S_VGP_S/km-(Em_VD_S*km_VGP_S+Em_VGP_S*km_VD_S+Em*km_VD_S_VGP_S)/km/km+2*Em*km_VD_S*km_VGP_S/km/km/km);
  Em_VD_S_VS_BP=(Em_VD_S_VS_BP/km-(Em_VD_S*km_VS_BP+Em_VS_BP*km_VD_S+Em*km_VD_S_VS_BP)/km/km+2*Em*km_VD_S*km_VS_BP/km/km/km);
#endif
Em_VGP_S=((Em_VGP_S*km-Em*km_VGP_S)/km/km);
#if defined(_DERIVATE2)
  Em_VGP_S_VD_S=(Em_VGP_S_VD_S/km-(Em_VGP_S*km_VD_S+Em_VD_S*km_VGP_S+Em*km_VGP_S_VD_S)/km/km+2*Em*km_VGP_S*km_VD_S/km/km/km);
  Em_VGP_S_VGP_S=(Em_VGP_S_VGP_S/km-(Em_VGP_S*km_VGP_S+Em_VGP_S*km_VGP_S+Em*km_VGP_S_VGP_S)/km/km+2*Em*km_VGP_S*km_VGP_S/km/km/km);
  Em_VGP_S_VS_BP=(Em_VGP_S_VS_BP/km-(Em_VGP_S*km_VS_BP+Em_VS_BP*km_VGP_S+Em*km_VGP_S_VS_BP)/km/km+2*Em*km_VGP_S*km_VS_BP/km/km/km);
#endif
Em_VS_BP=((Em_VS_BP*km-Em*km_VS_BP)/km/km);
#if defined(_DERIVATE2)
  Em_VS_BP_VD_S=(Em_VS_BP_VD_S/km-(Em_VS_BP*km_VD_S+Em_VD_S*km_VS_BP+Em*km_VS_BP_VD_S)/km/km+2*Em*km_VS_BP*km_VD_S/km/km/km);
  Em_VS_BP_VGP_S=(Em_VS_BP_VGP_S/km-(Em_VS_BP*km_VGP_S+Em_VGP_S*km_VS_BP+Em*km_VS_BP_VGP_S)/km/km+2*Em*km_VS_BP*km_VGP_S/km/km/km);
  Em_VS_BP_VS_BP=(Em_VS_BP_VS_BP/km-(Em_VS_BP*km_VS_BP+Em_VS_BP*km_VS_BP+Em*km_VS_BP_VS_BP)/km/km+2*Em*km_VS_BP*km_VS_BP/km/km/km);
#endif
#endif
Em=(Em/km);
EXIT_IF_ISNAN((Em/km))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Dm_VD_S=((Dm_VD_S*km)+(Dm*km_VD_S));
#if defined(_DERIVATE2)
  Dm_VD_S_VD_S=(+Dm_VD_S_VD_S*km+Dm_VD_S*km_VD_S+Dm_VD_S*km_VD_S+Dm*km_VD_S_VD_S);
  Dm_VD_S_VGP_S=(+Dm_VD_S_VGP_S*km+Dm_VD_S*km_VGP_S+Dm_VGP_S*km_VD_S+Dm*km_VD_S_VGP_S);
  Dm_VD_S_VS_BP=(+Dm_VD_S_VS_BP*km+Dm_VD_S*km_VS_BP+Dm_VS_BP*km_VD_S+Dm*km_VD_S_VS_BP);
#endif
Dm_VGP_S=((Dm_VGP_S*km)+(Dm*km_VGP_S));
#if defined(_DERIVATE2)
  Dm_VGP_S_VD_S=(+Dm_VGP_S_VD_S*km+Dm_VGP_S*km_VD_S+Dm_VD_S*km_VGP_S+Dm*km_VGP_S_VD_S);
  Dm_VGP_S_VGP_S=(+Dm_VGP_S_VGP_S*km+Dm_VGP_S*km_VGP_S+Dm_VGP_S*km_VGP_S+Dm*km_VGP_S_VGP_S);
  Dm_VGP_S_VS_BP=(+Dm_VGP_S_VS_BP*km+Dm_VGP_S*km_VS_BP+Dm_VS_BP*km_VGP_S+Dm*km_VGP_S_VS_BP);
#endif
Dm_VS_BP=((Dm_VS_BP*km)+(Dm*km_VS_BP));
#if defined(_DERIVATE2)
  Dm_VS_BP_VD_S=(+Dm_VS_BP_VD_S*km+Dm_VS_BP*km_VD_S+Dm_VD_S*km_VS_BP+Dm*km_VS_BP_VD_S);
  Dm_VS_BP_VGP_S=(+Dm_VS_BP_VGP_S*km+Dm_VS_BP*km_VGP_S+Dm_VGP_S*km_VS_BP+Dm*km_VS_BP_VGP_S);
  Dm_VS_BP_VS_BP=(+Dm_VS_BP_VS_BP*km+Dm_VS_BP*km_VS_BP+Dm_VS_BP*km_VS_BP+Dm*km_VS_BP_VS_BP);
#endif
#endif
Dm=(Dm*km);
EXIT_IF_ISNAN((Dm*km))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Pm_VD_S=(x_m_VD_S+Em_VD_S);
#if defined(_DERIVATE2)
  Pm_VD_S_VD_S=(+(+x_m_VD_S_VD_S-0.0)+Em_VD_S_VD_S);
  Pm_VD_S_VGP_S=(+(+x_m_VD_S_VGP_S-0.0)+Em_VD_S_VGP_S);
  Pm_VD_S_VS_BP=(+(+x_m_VD_S_VS_BP-0.0)+Em_VD_S_VS_BP);
#endif
Pm_VGP_S=(x_m_VGP_S+Em_VGP_S);
#if defined(_DERIVATE2)
  Pm_VGP_S_VD_S=(+(+x_m_VGP_S_VD_S-0.0)+Em_VGP_S_VD_S);
  Pm_VGP_S_VGP_S=(+(+x_m_VGP_S_VGP_S-0.0)+Em_VGP_S_VGP_S);
  Pm_VGP_S_VS_BP=(+(+x_m_VGP_S_VS_BP-0.0)+Em_VGP_S_VS_BP);
#endif
Pm_VS_BP=(x_m_VS_BP+Em_VS_BP);
#if defined(_DERIVATE2)
  Pm_VS_BP_VD_S=(+(+x_m_VS_BP_VD_S-0.0)+Em_VS_BP_VD_S);
  Pm_VS_BP_VGP_S=(+(+x_m_VS_BP_VGP_S-0.0)+Em_VS_BP_VGP_S);
  Pm_VS_BP_VS_BP=(+(+x_m_VS_BP_VS_BP-0.0)+Em_VS_BP_VS_BP);
#endif
#endif
Pm=((x_m-1.0)+Em);
EXIT_IF_ISNAN(((x_m-1.0)+Em))
{
double m00_sqrt(d00_sqrt0,(Dm+Pm))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(Dm+Pm))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
xgm_VD_S=((Gf_VD_S*d00_sqrt0)+(Gf*(Dm_VD_S+Pm_VD_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VD_S_VD_S=(+Gf_VD_S_VD_S*d00_sqrt0+Gf_VD_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VD_S+Pm_VD_S_VD_S)));
  xgm_VD_S_VGP_S=(+Gf_VD_S_VGP_S*d00_sqrt0+Gf_VD_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VGP_S+Pm_VD_S_VGP_S)));
  xgm_VD_S_VS_BP=(+Gf_VD_S_VS_BP*d00_sqrt0+Gf_VD_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VD_S+Pm_VD_S)+d10_sqrt0*(+Dm_VD_S_VS_BP+Pm_VD_S_VS_BP)));
#endif
xgm_VGP_S=((Gf_VGP_S*d00_sqrt0)+(Gf*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VGP_S_VD_S=(+Gf_VGP_S_VD_S*d00_sqrt0+Gf_VGP_S*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VD_S+Pm_VGP_S_VD_S)));
  xgm_VGP_S_VGP_S=(+Gf_VGP_S_VGP_S*d00_sqrt0+Gf_VGP_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VGP_S+Pm_VGP_S_VGP_S)));
  xgm_VGP_S_VS_BP=(+Gf_VGP_S_VS_BP*d00_sqrt0+Gf_VGP_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VGP_S+Pm_VGP_S)+d10_sqrt0*(+Dm_VGP_S_VS_BP+Pm_VGP_S_VS_BP)));
#endif
xgm_VS_BP=((Gf_VS_BP*d00_sqrt0)+(Gf*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0));
#if defined(_DERIVATE2)
  xgm_VS_BP_VD_S=(+Gf_VS_BP_VD_S*d00_sqrt0+Gf_VS_BP*(Dm_VD_S+Pm_VD_S)*d10_sqrt0+Gf_VD_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VD_S+Pm_VD_S)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VD_S+Pm_VS_BP_VD_S)));
  xgm_VS_BP_VGP_S=(+Gf_VS_BP_VGP_S*d00_sqrt0+Gf_VS_BP*(Dm_VGP_S+Pm_VGP_S)*d10_sqrt0+Gf_VGP_S*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VGP_S+Pm_VGP_S)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VGP_S+Pm_VS_BP_VGP_S)));
  xgm_VS_BP_VS_BP=(+Gf_VS_BP_VS_BP*d00_sqrt0+Gf_VS_BP*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf_VS_BP*(Dm_VS_BP+Pm_VS_BP)*d10_sqrt0+Gf*(m20_sqrt((Dm+Pm))*(Dm_VS_BP+Pm_VS_BP)*(Dm_VS_BP+Pm_VS_BP)+d10_sqrt0*(+Dm_VS_BP_VS_BP+Pm_VS_BP_VS_BP)));
#endif
#endif
xgm=(Gf*d00_sqrt0);
EXIT_IF_ISNAN((Gf*d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
help_VD_S=((-Em_VD_S)+(2.0*((((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VD_S))));
#if defined(_DERIVATE2)
  help_VD_S_VD_S=(+(+0.0-Em_VD_S_VD_S)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VD_S)))+0.0*((((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VD_S))+2.0*(+(+xgm_VD_S_VD_S*pInst->eta_p+xgm_VD_S*eta_p_VD_S+xgm_VD_S*eta_p_VD_S+xgm*eta_p_VD_S_VD_S)*inv_Gf2+((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S))*inv_Gf2_VD_S+(((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S)))*inv_Gf2_VD_S+(xgm*pInst->eta_p)*inv_Gf2_VD_S_VD_S)));
  help_VD_S_VGP_S=(+(+0.0-Em_VD_S_VGP_S)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VGP_S)))+0.0*((((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VD_S))+2.0*(+(+xgm_VD_S_VGP_S*pInst->eta_p+xgm_VD_S*eta_p_VGP_S+xgm_VGP_S*eta_p_VD_S+xgm*eta_p_VD_S_VGP_S)*inv_Gf2+((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S))*inv_Gf2_VGP_S+(((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S)))*inv_Gf2_VD_S+(xgm*pInst->eta_p)*inv_Gf2_VD_S_VGP_S)));
  help_VD_S_VS_BP=(+(+0.0-Em_VD_S_VS_BP)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VS_BP)))+0.0*((((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VD_S))+2.0*(+(+xgm_VD_S_VS_BP*pInst->eta_p+xgm_VD_S*eta_p_VS_BP+xgm_VS_BP*eta_p_VD_S+xgm*eta_p_VD_S_VS_BP)*inv_Gf2+((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S))*inv_Gf2_VS_BP+(((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP)))*inv_Gf2_VD_S+(xgm*pInst->eta_p)*inv_Gf2_VD_S_VS_BP)));
#endif
help_VGP_S=((-Em_VGP_S)+(2.0*((((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VGP_S))));
#if defined(_DERIVATE2)
  help_VGP_S_VD_S=(+(+0.0-Em_VGP_S_VD_S)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VD_S)))+0.0*((((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VGP_S))+2.0*(+(+xgm_VGP_S_VD_S*pInst->eta_p+xgm_VGP_S*eta_p_VD_S+xgm_VD_S*eta_p_VGP_S+xgm*eta_p_VGP_S_VD_S)*inv_Gf2+((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S))*inv_Gf2_VD_S+(((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S)))*inv_Gf2_VGP_S+(xgm*pInst->eta_p)*inv_Gf2_VGP_S_VD_S)));
  help_VGP_S_VGP_S=(+(+0.0-Em_VGP_S_VGP_S)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VGP_S)))+0.0*((((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VGP_S))+2.0*(+(+xgm_VGP_S_VGP_S*pInst->eta_p+xgm_VGP_S*eta_p_VGP_S+xgm_VGP_S*eta_p_VGP_S+xgm*eta_p_VGP_S_VGP_S)*inv_Gf2+((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S))*inv_Gf2_VGP_S+(((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S)))*inv_Gf2_VGP_S+(xgm*pInst->eta_p)*inv_Gf2_VGP_S_VGP_S)));
  help_VGP_S_VS_BP=(+(+0.0-Em_VGP_S_VS_BP)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VS_BP)))+0.0*((((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VGP_S))+2.0*(+(+xgm_VGP_S_VS_BP*pInst->eta_p+xgm_VGP_S*eta_p_VS_BP+xgm_VS_BP*eta_p_VGP_S+xgm*eta_p_VGP_S_VS_BP)*inv_Gf2+((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S))*inv_Gf2_VS_BP+(((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP)))*inv_Gf2_VGP_S+(xgm*pInst->eta_p)*inv_Gf2_VGP_S_VS_BP)));
#endif
help_VS_BP=((-Em_VS_BP)+(2.0*((((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VS_BP))));
#if defined(_DERIVATE2)
  help_VS_BP_VD_S=(+(+0.0-Em_VS_BP_VD_S)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VD_S)))+0.0*((((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VS_BP))+2.0*(+(+xgm_VS_BP_VD_S*pInst->eta_p+xgm_VS_BP*eta_p_VD_S+xgm_VD_S*eta_p_VS_BP+xgm*eta_p_VS_BP_VD_S)*inv_Gf2+((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP))*inv_Gf2_VD_S+(((xgm_VD_S*pInst->eta_p)+(xgm*eta_p_VD_S)))*inv_Gf2_VS_BP+(xgm*pInst->eta_p)*inv_Gf2_VS_BP_VD_S)));
  help_VS_BP_VGP_S=(+(+0.0-Em_VS_BP_VGP_S)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VGP_S)))+0.0*((((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VS_BP))+2.0*(+(+xgm_VS_BP_VGP_S*pInst->eta_p+xgm_VS_BP*eta_p_VGP_S+xgm_VGP_S*eta_p_VS_BP+xgm*eta_p_VS_BP_VGP_S)*inv_Gf2+((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP))*inv_Gf2_VGP_S+(((xgm_VGP_S*pInst->eta_p)+(xgm*eta_p_VGP_S)))*inv_Gf2_VS_BP+(xgm*pInst->eta_p)*inv_Gf2_VS_BP_VGP_S)));
  help_VS_BP_VS_BP=(+(+0.0-Em_VS_BP_VS_BP)+(+0.0*((xgm*pInst->eta_p)*inv_Gf2)+0.0*((((((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP)))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VS_BP)))+0.0*((((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP))*inv_Gf2)+((xgm*pInst->eta_p)*inv_Gf2_VS_BP))+2.0*(+(+xgm_VS_BP_VS_BP*pInst->eta_p+xgm_VS_BP*eta_p_VS_BP+xgm_VS_BP*eta_p_VS_BP+xgm*eta_p_VS_BP_VS_BP)*inv_Gf2+((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP))*inv_Gf2_VS_BP+(((xgm_VS_BP*pInst->eta_p)+(xgm*eta_p_VS_BP)))*inv_Gf2_VS_BP+(xgm*pInst->eta_p)*inv_Gf2_VS_BP_VS_BP)));
#endif
#endif
help=((1.0-Em)+(2.0*((xgm*pInst->eta_p)*inv_Gf2)));
EXIT_IF_ISNAN(((1.0-Em)+(2.0*((xgm*pInst->eta_p)*inv_Gf2))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
x_ds_VD_S=((((((x_ds_VD_S*km)+(x_ds*km_VD_S))*(d0+D_bar))+((x_ds*km)*(d0_VD_S+D_bar_VD_S)))*(help+(km*D_bar))-((x_ds*km)*(d0+D_bar))*(help_VD_S+((km_VD_S*D_bar)+(km*D_bar_VD_S))))/(help+(km*D_bar))/(help+(km*D_bar)));
#if defined(_DERIVATE2)
  x_ds_VD_S_VD_S=((+(+x_ds_VD_S_VD_S*km+x_ds_VD_S*km_VD_S+x_ds_VD_S*km_VD_S+x_ds*km_VD_S_VD_S)*(d0+D_bar)+((x_ds_VD_S*km)+(x_ds*km_VD_S))*(d0_VD_S+D_bar_VD_S)+(((x_ds_VD_S*km)+(x_ds*km_VD_S)))*(d0_VD_S+D_bar_VD_S)+(x_ds*km)*(+d0_VD_S_VD_S+D_bar_VD_S_VD_S))/(help+(km*D_bar))-(((((x_ds_VD_S*km)+(x_ds*km_VD_S))*(d0+D_bar))+((x_ds*km)*(d0_VD_S+D_bar_VD_S)))*(help_VD_S+(((km_VD_S*D_bar)+(km*D_bar_VD_S))))+((((((x_ds_VD_S*km)+(x_ds*km_VD_S)))*(d0+D_bar))+((x_ds*km)*(d0_VD_S+D_bar_VD_S))))*(help_VD_S+((km_VD_S*D_bar)+(km*D_bar_VD_S)))+((x_ds*km)*(d0+D_bar))*(+help_VD_S_VD_S+(+km_VD_S_VD_S*D_bar+km_VD_S*D_bar_VD_S+km_VD_S*D_bar_VD_S+km*D_bar_VD_S_VD_S)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VD_S+((km_VD_S*D_bar)+(km*D_bar_VD_S)))*(help_VD_S+(((km_VD_S*D_bar)+(km*D_bar_VD_S))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
  x_ds_VD_S_VGP_S=((+(+x_ds_VD_S_VGP_S*km+x_ds_VD_S*km_VGP_S+x_ds_VGP_S*km_VD_S+x_ds*km_VD_S_VGP_S)*(d0+D_bar)+((x_ds_VD_S*km)+(x_ds*km_VD_S))*(d0_VGP_S+D_bar_VGP_S)+(((x_ds_VGP_S*km)+(x_ds*km_VGP_S)))*(d0_VD_S+D_bar_VD_S)+(x_ds*km)*(+d0_VD_S_VGP_S+D_bar_VD_S_VGP_S))/(help+(km*D_bar))-(((((x_ds_VD_S*km)+(x_ds*km_VD_S))*(d0+D_bar))+((x_ds*km)*(d0_VD_S+D_bar_VD_S)))*(help_VGP_S+(((km_VGP_S*D_bar)+(km*D_bar_VGP_S))))+((((((x_ds_VGP_S*km)+(x_ds*km_VGP_S)))*(d0+D_bar))+((x_ds*km)*(d0_VGP_S+D_bar_VGP_S))))*(help_VD_S+((km_VD_S*D_bar)+(km*D_bar_VD_S)))+((x_ds*km)*(d0+D_bar))*(+help_VD_S_VGP_S+(+km_VD_S_VGP_S*D_bar+km_VD_S*D_bar_VGP_S+km_VGP_S*D_bar_VD_S+km*D_bar_VD_S_VGP_S)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VD_S+((km_VD_S*D_bar)+(km*D_bar_VD_S)))*(help_VGP_S+(((km_VGP_S*D_bar)+(km*D_bar_VGP_S))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
  x_ds_VD_S_VS_BP=((+(+x_ds_VD_S_VS_BP*km+x_ds_VD_S*km_VS_BP+x_ds_VS_BP*km_VD_S+x_ds*km_VD_S_VS_BP)*(d0+D_bar)+((x_ds_VD_S*km)+(x_ds*km_VD_S))*(d0_VS_BP+D_bar_VS_BP)+(((x_ds_VS_BP*km)+(x_ds*km_VS_BP)))*(d0_VD_S+D_bar_VD_S)+(x_ds*km)*(+d0_VD_S_VS_BP+D_bar_VD_S_VS_BP))/(help+(km*D_bar))-(((((x_ds_VD_S*km)+(x_ds*km_VD_S))*(d0+D_bar))+((x_ds*km)*(d0_VD_S+D_bar_VD_S)))*(help_VS_BP+(((km_VS_BP*D_bar)+(km*D_bar_VS_BP))))+((((((x_ds_VS_BP*km)+(x_ds*km_VS_BP)))*(d0+D_bar))+((x_ds*km)*(d0_VS_BP+D_bar_VS_BP))))*(help_VD_S+((km_VD_S*D_bar)+(km*D_bar_VD_S)))+((x_ds*km)*(d0+D_bar))*(+help_VD_S_VS_BP+(+km_VD_S_VS_BP*D_bar+km_VD_S*D_bar_VS_BP+km_VS_BP*D_bar_VD_S+km*D_bar_VD_S_VS_BP)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VD_S+((km_VD_S*D_bar)+(km*D_bar_VD_S)))*(help_VS_BP+(((km_VS_BP*D_bar)+(km*D_bar_VS_BP))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
#endif
x_ds_VGP_S=((((((x_ds_VGP_S*km)+(x_ds*km_VGP_S))*(d0+D_bar))+((x_ds*km)*(d0_VGP_S+D_bar_VGP_S)))*(help+(km*D_bar))-((x_ds*km)*(d0+D_bar))*(help_VGP_S+((km_VGP_S*D_bar)+(km*D_bar_VGP_S))))/(help+(km*D_bar))/(help+(km*D_bar)));
#if defined(_DERIVATE2)
  x_ds_VGP_S_VD_S=((+(+x_ds_VGP_S_VD_S*km+x_ds_VGP_S*km_VD_S+x_ds_VD_S*km_VGP_S+x_ds*km_VGP_S_VD_S)*(d0+D_bar)+((x_ds_VGP_S*km)+(x_ds*km_VGP_S))*(d0_VD_S+D_bar_VD_S)+(((x_ds_VD_S*km)+(x_ds*km_VD_S)))*(d0_VGP_S+D_bar_VGP_S)+(x_ds*km)*(+d0_VGP_S_VD_S+D_bar_VGP_S_VD_S))/(help+(km*D_bar))-(((((x_ds_VGP_S*km)+(x_ds*km_VGP_S))*(d0+D_bar))+((x_ds*km)*(d0_VGP_S+D_bar_VGP_S)))*(help_VD_S+(((km_VD_S*D_bar)+(km*D_bar_VD_S))))+((((((x_ds_VD_S*km)+(x_ds*km_VD_S)))*(d0+D_bar))+((x_ds*km)*(d0_VD_S+D_bar_VD_S))))*(help_VGP_S+((km_VGP_S*D_bar)+(km*D_bar_VGP_S)))+((x_ds*km)*(d0+D_bar))*(+help_VGP_S_VD_S+(+km_VGP_S_VD_S*D_bar+km_VGP_S*D_bar_VD_S+km_VD_S*D_bar_VGP_S+km*D_bar_VGP_S_VD_S)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VGP_S+((km_VGP_S*D_bar)+(km*D_bar_VGP_S)))*(help_VD_S+(((km_VD_S*D_bar)+(km*D_bar_VD_S))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
  x_ds_VGP_S_VGP_S=((+(+x_ds_VGP_S_VGP_S*km+x_ds_VGP_S*km_VGP_S+x_ds_VGP_S*km_VGP_S+x_ds*km_VGP_S_VGP_S)*(d0+D_bar)+((x_ds_VGP_S*km)+(x_ds*km_VGP_S))*(d0_VGP_S+D_bar_VGP_S)+(((x_ds_VGP_S*km)+(x_ds*km_VGP_S)))*(d0_VGP_S+D_bar_VGP_S)+(x_ds*km)*(+d0_VGP_S_VGP_S+D_bar_VGP_S_VGP_S))/(help+(km*D_bar))-(((((x_ds_VGP_S*km)+(x_ds*km_VGP_S))*(d0+D_bar))+((x_ds*km)*(d0_VGP_S+D_bar_VGP_S)))*(help_VGP_S+(((km_VGP_S*D_bar)+(km*D_bar_VGP_S))))+((((((x_ds_VGP_S*km)+(x_ds*km_VGP_S)))*(d0+D_bar))+((x_ds*km)*(d0_VGP_S+D_bar_VGP_S))))*(help_VGP_S+((km_VGP_S*D_bar)+(km*D_bar_VGP_S)))+((x_ds*km)*(d0+D_bar))*(+help_VGP_S_VGP_S+(+km_VGP_S_VGP_S*D_bar+km_VGP_S*D_bar_VGP_S+km_VGP_S*D_bar_VGP_S+km*D_bar_VGP_S_VGP_S)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VGP_S+((km_VGP_S*D_bar)+(km*D_bar_VGP_S)))*(help_VGP_S+(((km_VGP_S*D_bar)+(km*D_bar_VGP_S))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
  x_ds_VGP_S_VS_BP=((+(+x_ds_VGP_S_VS_BP*km+x_ds_VGP_S*km_VS_BP+x_ds_VS_BP*km_VGP_S+x_ds*km_VGP_S_VS_BP)*(d0+D_bar)+((x_ds_VGP_S*km)+(x_ds*km_VGP_S))*(d0_VS_BP+D_bar_VS_BP)+(((x_ds_VS_BP*km)+(x_ds*km_VS_BP)))*(d0_VGP_S+D_bar_VGP_S)+(x_ds*km)*(+d0_VGP_S_VS_BP+D_bar_VGP_S_VS_BP))/(help+(km*D_bar))-(((((x_ds_VGP_S*km)+(x_ds*km_VGP_S))*(d0+D_bar))+((x_ds*km)*(d0_VGP_S+D_bar_VGP_S)))*(help_VS_BP+(((km_VS_BP*D_bar)+(km*D_bar_VS_BP))))+((((((x_ds_VS_BP*km)+(x_ds*km_VS_BP)))*(d0+D_bar))+((x_ds*km)*(d0_VS_BP+D_bar_VS_BP))))*(help_VGP_S+((km_VGP_S*D_bar)+(km*D_bar_VGP_S)))+((x_ds*km)*(d0+D_bar))*(+help_VGP_S_VS_BP+(+km_VGP_S_VS_BP*D_bar+km_VGP_S*D_bar_VS_BP+km_VS_BP*D_bar_VGP_S+km*D_bar_VGP_S_VS_BP)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VGP_S+((km_VGP_S*D_bar)+(km*D_bar_VGP_S)))*(help_VS_BP+(((km_VS_BP*D_bar)+(km*D_bar_VS_BP))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
#endif
x_ds_VS_BP=((((((x_ds_VS_BP*km)+(x_ds*km_VS_BP))*(d0+D_bar))+((x_ds*km)*(d0_VS_BP+D_bar_VS_BP)))*(help+(km*D_bar))-((x_ds*km)*(d0+D_bar))*(help_VS_BP+((km_VS_BP*D_bar)+(km*D_bar_VS_BP))))/(help+(km*D_bar))/(help+(km*D_bar)));
#if defined(_DERIVATE2)
  x_ds_VS_BP_VD_S=((+(+x_ds_VS_BP_VD_S*km+x_ds_VS_BP*km_VD_S+x_ds_VD_S*km_VS_BP+x_ds*km_VS_BP_VD_S)*(d0+D_bar)+((x_ds_VS_BP*km)+(x_ds*km_VS_BP))*(d0_VD_S+D_bar_VD_S)+(((x_ds_VD_S*km)+(x_ds*km_VD_S)))*(d0_VS_BP+D_bar_VS_BP)+(x_ds*km)*(+d0_VS_BP_VD_S+D_bar_VS_BP_VD_S))/(help+(km*D_bar))-(((((x_ds_VS_BP*km)+(x_ds*km_VS_BP))*(d0+D_bar))+((x_ds*km)*(d0_VS_BP+D_bar_VS_BP)))*(help_VD_S+(((km_VD_S*D_bar)+(km*D_bar_VD_S))))+((((((x_ds_VD_S*km)+(x_ds*km_VD_S)))*(d0+D_bar))+((x_ds*km)*(d0_VD_S+D_bar_VD_S))))*(help_VS_BP+((km_VS_BP*D_bar)+(km*D_bar_VS_BP)))+((x_ds*km)*(d0+D_bar))*(+help_VS_BP_VD_S+(+km_VS_BP_VD_S*D_bar+km_VS_BP*D_bar_VD_S+km_VD_S*D_bar_VS_BP+km*D_bar_VS_BP_VD_S)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VS_BP+((km_VS_BP*D_bar)+(km*D_bar_VS_BP)))*(help_VD_S+(((km_VD_S*D_bar)+(km*D_bar_VD_S))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
  x_ds_VS_BP_VGP_S=((+(+x_ds_VS_BP_VGP_S*km+x_ds_VS_BP*km_VGP_S+x_ds_VGP_S*km_VS_BP+x_ds*km_VS_BP_VGP_S)*(d0+D_bar)+((x_ds_VS_BP*km)+(x_ds*km_VS_BP))*(d0_VGP_S+D_bar_VGP_S)+(((x_ds_VGP_S*km)+(x_ds*km_VGP_S)))*(d0_VS_BP+D_bar_VS_BP)+(x_ds*km)*(+d0_VS_BP_VGP_S+D_bar_VS_BP_VGP_S))/(help+(km*D_bar))-(((((x_ds_VS_BP*km)+(x_ds*km_VS_BP))*(d0+D_bar))+((x_ds*km)*(d0_VS_BP+D_bar_VS_BP)))*(help_VGP_S+(((km_VGP_S*D_bar)+(km*D_bar_VGP_S))))+((((((x_ds_VGP_S*km)+(x_ds*km_VGP_S)))*(d0+D_bar))+((x_ds*km)*(d0_VGP_S+D_bar_VGP_S))))*(help_VS_BP+((km_VS_BP*D_bar)+(km*D_bar_VS_BP)))+((x_ds*km)*(d0+D_bar))*(+help_VS_BP_VGP_S+(+km_VS_BP_VGP_S*D_bar+km_VS_BP*D_bar_VGP_S+km_VGP_S*D_bar_VS_BP+km*D_bar_VS_BP_VGP_S)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VS_BP+((km_VS_BP*D_bar)+(km*D_bar_VS_BP)))*(help_VGP_S+(((km_VGP_S*D_bar)+(km*D_bar_VGP_S))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
  x_ds_VS_BP_VS_BP=((+(+x_ds_VS_BP_VS_BP*km+x_ds_VS_BP*km_VS_BP+x_ds_VS_BP*km_VS_BP+x_ds*km_VS_BP_VS_BP)*(d0+D_bar)+((x_ds_VS_BP*km)+(x_ds*km_VS_BP))*(d0_VS_BP+D_bar_VS_BP)+(((x_ds_VS_BP*km)+(x_ds*km_VS_BP)))*(d0_VS_BP+D_bar_VS_BP)+(x_ds*km)*(+d0_VS_BP_VS_BP+D_bar_VS_BP_VS_BP))/(help+(km*D_bar))-(((((x_ds_VS_BP*km)+(x_ds*km_VS_BP))*(d0+D_bar))+((x_ds*km)*(d0_VS_BP+D_bar_VS_BP)))*(help_VS_BP+(((km_VS_BP*D_bar)+(km*D_bar_VS_BP))))+((((((x_ds_VS_BP*km)+(x_ds*km_VS_BP)))*(d0+D_bar))+((x_ds*km)*(d0_VS_BP+D_bar_VS_BP))))*(help_VS_BP+((km_VS_BP*D_bar)+(km*D_bar_VS_BP)))+((x_ds*km)*(d0+D_bar))*(+help_VS_BP_VS_BP+(+km_VS_BP_VS_BP*D_bar+km_VS_BP*D_bar_VS_BP+km_VS_BP*D_bar_VS_BP+km*D_bar_VS_BP_VS_BP)))/(help+(km*D_bar))/(help+(km*D_bar))+2*((x_ds*km)*(d0+D_bar))*(help_VS_BP+((km_VS_BP*D_bar)+(km*D_bar_VS_BP)))*(help_VS_BP+(((km_VS_BP*D_bar)+(km*D_bar_VS_BP))))/(help+(km*D_bar))/(help+(km*D_bar))/(help+(km*D_bar)));
#endif
#endif
x_ds=(((x_ds*km)*(d0+D_bar))/(help+(km*D_bar)));
EXIT_IF_ISNAN((((x_ds*km)*(d0+D_bar))/(help+(km*D_bar))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
dps_VD_S=x_ds_VD_S*pInst->phit1;
#if defined(_DERIVATE2)
  dps_VD_S_VD_S=(+x_ds_VD_S_VD_S*pInst->phit1+x_ds_VD_S*0.0+x_ds_VD_S*0.0+x_ds*0.0);
  dps_VD_S_VGP_S=(+x_ds_VD_S_VGP_S*pInst->phit1+x_ds_VD_S*0.0+x_ds_VGP_S*0.0+x_ds*0.0);
  dps_VD_S_VS_BP=(+x_ds_VD_S_VS_BP*pInst->phit1+x_ds_VD_S*0.0+x_ds_VS_BP*0.0+x_ds*0.0);
#endif
dps_VGP_S=x_ds_VGP_S*pInst->phit1;
#if defined(_DERIVATE2)
  dps_VGP_S_VD_S=(+x_ds_VGP_S_VD_S*pInst->phit1+x_ds_VGP_S*0.0+x_ds_VD_S*0.0+x_ds*0.0);
  dps_VGP_S_VGP_S=(+x_ds_VGP_S_VGP_S*pInst->phit1+x_ds_VGP_S*0.0+x_ds_VGP_S*0.0+x_ds*0.0);
  dps_VGP_S_VS_BP=(+x_ds_VGP_S_VS_BP*pInst->phit1+x_ds_VGP_S*0.0+x_ds_VS_BP*0.0+x_ds*0.0);
#endif
dps_VS_BP=x_ds_VS_BP*pInst->phit1;
#if defined(_DERIVATE2)
  dps_VS_BP_VD_S=(+x_ds_VS_BP_VD_S*pInst->phit1+x_ds_VS_BP*0.0+x_ds_VD_S*0.0+x_ds*0.0);
  dps_VS_BP_VGP_S=(+x_ds_VS_BP_VGP_S*pInst->phit1+x_ds_VS_BP*0.0+x_ds_VGP_S*0.0+x_ds*0.0);
  dps_VS_BP_VS_BP=(+x_ds_VS_BP_VS_BP*pInst->phit1+x_ds_VS_BP*0.0+x_ds_VS_BP*0.0+x_ds*0.0);
#endif
#endif
pInst->dps=(x_ds*pInst->phit1);
EXIT_IF_ISNAN((x_ds*pInst->phit1))
}
{
double m00_sqrt(d00_sqrt0,Pm)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,Pm)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
sqm_VD_S=Pm_VD_S*d10_sqrt0;
#if defined(_DERIVATE2)
  sqm_VD_S_VD_S=(m20_sqrt(Pm)*Pm_VD_S*Pm_VD_S+d10_sqrt0*Pm_VD_S_VD_S);
  sqm_VD_S_VGP_S=(m20_sqrt(Pm)*Pm_VGP_S*Pm_VD_S+d10_sqrt0*Pm_VD_S_VGP_S);
  sqm_VD_S_VS_BP=(m20_sqrt(Pm)*Pm_VS_BP*Pm_VD_S+d10_sqrt0*Pm_VD_S_VS_BP);
#endif
sqm_VGP_S=Pm_VGP_S*d10_sqrt0;
#if defined(_DERIVATE2)
  sqm_VGP_S_VD_S=(m20_sqrt(Pm)*Pm_VD_S*Pm_VGP_S+d10_sqrt0*Pm_VGP_S_VD_S);
  sqm_VGP_S_VGP_S=(m20_sqrt(Pm)*Pm_VGP_S*Pm_VGP_S+d10_sqrt0*Pm_VGP_S_VGP_S);
  sqm_VGP_S_VS_BP=(m20_sqrt(Pm)*Pm_VS_BP*Pm_VGP_S+d10_sqrt0*Pm_VGP_S_VS_BP);
#endif
sqm_VS_BP=Pm_VS_BP*d10_sqrt0;
#if defined(_DERIVATE2)
  sqm_VS_BP_VD_S=(m20_sqrt(Pm)*Pm_VD_S*Pm_VS_BP+d10_sqrt0*Pm_VS_BP_VD_S);
  sqm_VS_BP_VGP_S=(m20_sqrt(Pm)*Pm_VGP_S*Pm_VS_BP+d10_sqrt0*Pm_VS_BP_VGP_S);
  sqm_VS_BP_VS_BP=(m20_sqrt(Pm)*Pm_VS_BP*Pm_VS_BP+d10_sqrt0*Pm_VS_BP_VS_BP);
#endif
#endif
sqm=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
alpha_VD_S=(eta_p_VD_S+(0.5*((((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S)))*sqm-(Gf*(1.0-Em))*sqm_VD_S)/sqm/sqm)));
#if defined(_DERIVATE2)
  alpha_VD_S_VD_S=(+eta_p_VD_S_VD_S+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S))))*sqm-(Gf*(1.0-Em))*sqm_VD_S)/sqm/sqm)+0.0*((((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S)))*sqm-(Gf*(1.0-Em))*sqm_VD_S)/sqm/sqm)+0.5*((+Gf_VD_S_VD_S*(1.0-Em)+Gf_VD_S*(-Em_VD_S)+Gf_VD_S*(-Em_VD_S)+Gf*(+0.0-Em_VD_S_VD_S))/sqm-(((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S)))*sqm_VD_S+(((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S))))*sqm_VD_S+(Gf*(1.0-Em))*sqm_VD_S_VD_S)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VD_S*sqm_VD_S/sqm/sqm/sqm)));
  alpha_VD_S_VGP_S=(+eta_p_VD_S_VGP_S+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S))))*sqm-(Gf*(1.0-Em))*sqm_VGP_S)/sqm/sqm)+0.0*((((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S)))*sqm-(Gf*(1.0-Em))*sqm_VD_S)/sqm/sqm)+0.5*((+Gf_VD_S_VGP_S*(1.0-Em)+Gf_VD_S*(-Em_VGP_S)+Gf_VGP_S*(-Em_VD_S)+Gf*(+0.0-Em_VD_S_VGP_S))/sqm-(((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S)))*sqm_VGP_S+(((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S))))*sqm_VD_S+(Gf*(1.0-Em))*sqm_VD_S_VGP_S)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VD_S*sqm_VGP_S/sqm/sqm/sqm)));
  alpha_VD_S_VS_BP=(+eta_p_VD_S_VS_BP+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP))))*sqm-(Gf*(1.0-Em))*sqm_VS_BP)/sqm/sqm)+0.0*((((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S)))*sqm-(Gf*(1.0-Em))*sqm_VD_S)/sqm/sqm)+0.5*((+Gf_VD_S_VS_BP*(1.0-Em)+Gf_VD_S*(-Em_VS_BP)+Gf_VS_BP*(-Em_VD_S)+Gf*(+0.0-Em_VD_S_VS_BP))/sqm-(((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S)))*sqm_VS_BP+(((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP))))*sqm_VD_S+(Gf*(1.0-Em))*sqm_VD_S_VS_BP)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VD_S*sqm_VS_BP/sqm/sqm/sqm)));
#endif
alpha_VGP_S=(eta_p_VGP_S+(0.5*((((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S)))*sqm-(Gf*(1.0-Em))*sqm_VGP_S)/sqm/sqm)));
#if defined(_DERIVATE2)
  alpha_VGP_S_VD_S=(+eta_p_VGP_S_VD_S+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S))))*sqm-(Gf*(1.0-Em))*sqm_VD_S)/sqm/sqm)+0.0*((((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S)))*sqm-(Gf*(1.0-Em))*sqm_VGP_S)/sqm/sqm)+0.5*((+Gf_VGP_S_VD_S*(1.0-Em)+Gf_VGP_S*(-Em_VD_S)+Gf_VD_S*(-Em_VGP_S)+Gf*(+0.0-Em_VGP_S_VD_S))/sqm-(((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S)))*sqm_VD_S+(((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S))))*sqm_VGP_S+(Gf*(1.0-Em))*sqm_VGP_S_VD_S)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VGP_S*sqm_VD_S/sqm/sqm/sqm)));
  alpha_VGP_S_VGP_S=(+eta_p_VGP_S_VGP_S+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S))))*sqm-(Gf*(1.0-Em))*sqm_VGP_S)/sqm/sqm)+0.0*((((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S)))*sqm-(Gf*(1.0-Em))*sqm_VGP_S)/sqm/sqm)+0.5*((+Gf_VGP_S_VGP_S*(1.0-Em)+Gf_VGP_S*(-Em_VGP_S)+Gf_VGP_S*(-Em_VGP_S)+Gf*(+0.0-Em_VGP_S_VGP_S))/sqm-(((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S)))*sqm_VGP_S+(((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S))))*sqm_VGP_S+(Gf*(1.0-Em))*sqm_VGP_S_VGP_S)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VGP_S*sqm_VGP_S/sqm/sqm/sqm)));
  alpha_VGP_S_VS_BP=(+eta_p_VGP_S_VS_BP+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP))))*sqm-(Gf*(1.0-Em))*sqm_VS_BP)/sqm/sqm)+0.0*((((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S)))*sqm-(Gf*(1.0-Em))*sqm_VGP_S)/sqm/sqm)+0.5*((+Gf_VGP_S_VS_BP*(1.0-Em)+Gf_VGP_S*(-Em_VS_BP)+Gf_VS_BP*(-Em_VGP_S)+Gf*(+0.0-Em_VGP_S_VS_BP))/sqm-(((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S)))*sqm_VS_BP+(((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP))))*sqm_VGP_S+(Gf*(1.0-Em))*sqm_VGP_S_VS_BP)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VGP_S*sqm_VS_BP/sqm/sqm/sqm)));
#endif
alpha_VS_BP=(eta_p_VS_BP+(0.5*((((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP)))*sqm-(Gf*(1.0-Em))*sqm_VS_BP)/sqm/sqm)));
#if defined(_DERIVATE2)
  alpha_VS_BP_VD_S=(+eta_p_VS_BP_VD_S+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S))))*sqm-(Gf*(1.0-Em))*sqm_VD_S)/sqm/sqm)+0.0*((((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP)))*sqm-(Gf*(1.0-Em))*sqm_VS_BP)/sqm/sqm)+0.5*((+Gf_VS_BP_VD_S*(1.0-Em)+Gf_VS_BP*(-Em_VD_S)+Gf_VD_S*(-Em_VS_BP)+Gf*(+0.0-Em_VS_BP_VD_S))/sqm-(((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP)))*sqm_VD_S+(((Gf_VD_S*(1.0-Em))+(Gf*(-Em_VD_S))))*sqm_VS_BP+(Gf*(1.0-Em))*sqm_VS_BP_VD_S)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VS_BP*sqm_VD_S/sqm/sqm/sqm)));
  alpha_VS_BP_VGP_S=(+eta_p_VS_BP_VGP_S+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S))))*sqm-(Gf*(1.0-Em))*sqm_VGP_S)/sqm/sqm)+0.0*((((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP)))*sqm-(Gf*(1.0-Em))*sqm_VS_BP)/sqm/sqm)+0.5*((+Gf_VS_BP_VGP_S*(1.0-Em)+Gf_VS_BP*(-Em_VGP_S)+Gf_VGP_S*(-Em_VS_BP)+Gf*(+0.0-Em_VS_BP_VGP_S))/sqm-(((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP)))*sqm_VGP_S+(((Gf_VGP_S*(1.0-Em))+(Gf*(-Em_VGP_S))))*sqm_VS_BP+(Gf*(1.0-Em))*sqm_VS_BP_VGP_S)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VS_BP*sqm_VGP_S/sqm/sqm/sqm)));
  alpha_VS_BP_VS_BP=(+eta_p_VS_BP_VS_BP+(+0.0*((Gf*(1.0-Em))/sqm)+0.0*(((((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP))))*sqm-(Gf*(1.0-Em))*sqm_VS_BP)/sqm/sqm)+0.0*((((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP)))*sqm-(Gf*(1.0-Em))*sqm_VS_BP)/sqm/sqm)+0.5*((+Gf_VS_BP_VS_BP*(1.0-Em)+Gf_VS_BP*(-Em_VS_BP)+Gf_VS_BP*(-Em_VS_BP)+Gf*(+0.0-Em_VS_BP_VS_BP))/sqm-(((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP)))*sqm_VS_BP+(((Gf_VS_BP*(1.0-Em))+(Gf*(-Em_VS_BP))))*sqm_VS_BP+(Gf*(1.0-Em))*sqm_VS_BP_VS_BP)/sqm/sqm+2*(Gf*(1.0-Em))*sqm_VS_BP*sqm_VS_BP/sqm/sqm/sqm)));
#endif
#endif
pInst->alpha=(pInst->eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
EXIT_IF_ISNAN((pInst->eta_p+(0.5*((Gf*(1.0-Em))/sqm))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
qim_VD_S=(pInst->phit1*((((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
#if defined(_DERIVATE2)
  qim_VD_S_VD_S=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VD_S_VD_S*Dm+Gf2_VD_S*Dm_VD_S+Gf2_VD_S*Dm_VD_S+Gf2*Dm_VD_S_VD_S)/(xgm+(Gf*sqm))-(((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S))*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))+(((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S)))*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))+(Gf2*Dm)*(+xgm_VD_S_VD_S+(+Gf_VD_S_VD_S*sqm+Gf_VD_S*sqm_VD_S+Gf_VD_S*sqm_VD_S+Gf*sqm_VD_S_VD_S)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
  qim_VD_S_VGP_S=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VD_S_VGP_S*Dm+Gf2_VD_S*Dm_VGP_S+Gf2_VGP_S*Dm_VD_S+Gf2*Dm_VD_S_VGP_S)/(xgm+(Gf*sqm))-(((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S))*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))+(((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S)))*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))+(Gf2*Dm)*(+xgm_VD_S_VGP_S+(+Gf_VD_S_VGP_S*sqm+Gf_VD_S*sqm_VGP_S+Gf_VGP_S*sqm_VD_S+Gf*sqm_VD_S_VGP_S)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
  qim_VD_S_VS_BP=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VD_S_VS_BP*Dm+Gf2_VD_S*Dm_VS_BP+Gf2_VS_BP*Dm_VD_S+Gf2*Dm_VD_S_VS_BP)/(xgm+(Gf*sqm))-(((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S))*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))+(((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP)))*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))+(Gf2*Dm)*(+xgm_VD_S_VS_BP+(+Gf_VD_S_VS_BP*sqm+Gf_VD_S*sqm_VS_BP+Gf_VS_BP*sqm_VD_S+Gf*sqm_VD_S_VS_BP)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VD_S+((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
#endif
qim_VGP_S=(pInst->phit1*((((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
#if defined(_DERIVATE2)
  qim_VGP_S_VD_S=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VGP_S_VD_S*Dm+Gf2_VGP_S*Dm_VD_S+Gf2_VD_S*Dm_VGP_S+Gf2*Dm_VGP_S_VD_S)/(xgm+(Gf*sqm))-(((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S))*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))+(((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S)))*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))+(Gf2*Dm)*(+xgm_VGP_S_VD_S+(+Gf_VGP_S_VD_S*sqm+Gf_VGP_S*sqm_VD_S+Gf_VD_S*sqm_VGP_S+Gf*sqm_VGP_S_VD_S)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
  qim_VGP_S_VGP_S=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VGP_S_VGP_S*Dm+Gf2_VGP_S*Dm_VGP_S+Gf2_VGP_S*Dm_VGP_S+Gf2*Dm_VGP_S_VGP_S)/(xgm+(Gf*sqm))-(((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S))*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))+(((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S)))*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))+(Gf2*Dm)*(+xgm_VGP_S_VGP_S+(+Gf_VGP_S_VGP_S*sqm+Gf_VGP_S*sqm_VGP_S+Gf_VGP_S*sqm_VGP_S+Gf*sqm_VGP_S_VGP_S)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
  qim_VGP_S_VS_BP=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VGP_S_VS_BP*Dm+Gf2_VGP_S*Dm_VS_BP+Gf2_VS_BP*Dm_VGP_S+Gf2*Dm_VGP_S_VS_BP)/(xgm+(Gf*sqm))-(((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S))*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))+(((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP)))*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))+(Gf2*Dm)*(+xgm_VGP_S_VS_BP+(+Gf_VGP_S_VS_BP*sqm+Gf_VGP_S*sqm_VS_BP+Gf_VS_BP*sqm_VGP_S+Gf*sqm_VGP_S_VS_BP)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VGP_S+((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
#endif
qim_VS_BP=(pInst->phit1*((((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
#if defined(_DERIVATE2)
  qim_VS_BP_VD_S=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VS_BP_VD_S*Dm+Gf2_VS_BP*Dm_VD_S+Gf2_VD_S*Dm_VS_BP+Gf2*Dm_VS_BP_VD_S)/(xgm+(Gf*sqm))-(((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP))*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))+(((Gf2_VD_S*Dm)+(Gf2*Dm_VD_S)))*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))+(Gf2*Dm)*(+xgm_VS_BP_VD_S+(+Gf_VS_BP_VD_S*sqm+Gf_VS_BP*sqm_VD_S+Gf_VD_S*sqm_VS_BP+Gf*sqm_VS_BP_VD_S)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))*(xgm_VD_S+(((Gf_VD_S*sqm)+(Gf*sqm_VD_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
  qim_VS_BP_VGP_S=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VS_BP_VGP_S*Dm+Gf2_VS_BP*Dm_VGP_S+Gf2_VGP_S*Dm_VS_BP+Gf2*Dm_VS_BP_VGP_S)/(xgm+(Gf*sqm))-(((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP))*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))+(((Gf2_VGP_S*Dm)+(Gf2*Dm_VGP_S)))*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))+(Gf2*Dm)*(+xgm_VS_BP_VGP_S+(+Gf_VS_BP_VGP_S*sqm+Gf_VS_BP*sqm_VGP_S+Gf_VGP_S*sqm_VS_BP+Gf*sqm_VS_BP_VGP_S)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))*(xgm_VGP_S+(((Gf_VGP_S*sqm)+(Gf*sqm_VGP_S))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
  qim_VS_BP_VS_BP=(+0.0*((Gf2*Dm)/(xgm+(Gf*sqm)))+0.0*(((((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP)))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+0.0*((((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP))*(xgm+(Gf*sqm))-(Gf2*Dm)*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+pInst->phit1*((+Gf2_VS_BP_VS_BP*Dm+Gf2_VS_BP*Dm_VS_BP+Gf2_VS_BP*Dm_VS_BP+Gf2*Dm_VS_BP_VS_BP)/(xgm+(Gf*sqm))-(((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP))*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))+(((Gf2_VS_BP*Dm)+(Gf2*Dm_VS_BP)))*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))+(Gf2*Dm)*(+xgm_VS_BP_VS_BP+(+Gf_VS_BP_VS_BP*sqm+Gf_VS_BP*sqm_VS_BP+Gf_VS_BP*sqm_VS_BP+Gf*sqm_VS_BP_VS_BP)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))+2*(Gf2*Dm)*(xgm_VS_BP+((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP)))*(xgm_VS_BP+(((Gf_VS_BP*sqm)+(Gf*sqm_VS_BP))))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm))));
#endif
#endif
pInst->qim=(pInst->phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));
EXIT_IF_ISNAN((pInst->phit1*((Gf2*Dm)/(xgm+(Gf*sqm)))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
qim1_VD_S=(qim_VD_S+(pInst->phit1*alpha_VD_S));
#if defined(_DERIVATE2)
  qim1_VD_S_VD_S=(+qim_VD_S_VD_S+(+0.0*pInst->alpha+0.0*alpha_VD_S+0.0*alpha_VD_S+pInst->phit1*alpha_VD_S_VD_S));
  qim1_VD_S_VGP_S=(+qim_VD_S_VGP_S+(+0.0*pInst->alpha+0.0*alpha_VGP_S+0.0*alpha_VD_S+pInst->phit1*alpha_VD_S_VGP_S));
  qim1_VD_S_VS_BP=(+qim_VD_S_VS_BP+(+0.0*pInst->alpha+0.0*alpha_VS_BP+0.0*alpha_VD_S+pInst->phit1*alpha_VD_S_VS_BP));
#endif
qim1_VGP_S=(qim_VGP_S+(pInst->phit1*alpha_VGP_S));
#if defined(_DERIVATE2)
  qim1_VGP_S_VD_S=(+qim_VGP_S_VD_S+(+0.0*pInst->alpha+0.0*alpha_VD_S+0.0*alpha_VGP_S+pInst->phit1*alpha_VGP_S_VD_S));
  qim1_VGP_S_VGP_S=(+qim_VGP_S_VGP_S+(+0.0*pInst->alpha+0.0*alpha_VGP_S+0.0*alpha_VGP_S+pInst->phit1*alpha_VGP_S_VGP_S));
  qim1_VGP_S_VS_BP=(+qim_VGP_S_VS_BP+(+0.0*pInst->alpha+0.0*alpha_VS_BP+0.0*alpha_VGP_S+pInst->phit1*alpha_VGP_S_VS_BP));
#endif
qim1_VS_BP=(qim_VS_BP+(pInst->phit1*alpha_VS_BP));
#if defined(_DERIVATE2)
  qim1_VS_BP_VD_S=(+qim_VS_BP_VD_S+(+0.0*pInst->alpha+0.0*alpha_VD_S+0.0*alpha_VS_BP+pInst->phit1*alpha_VS_BP_VD_S));
  qim1_VS_BP_VGP_S=(+qim_VS_BP_VGP_S+(+0.0*pInst->alpha+0.0*alpha_VGP_S+0.0*alpha_VS_BP+pInst->phit1*alpha_VS_BP_VGP_S));
  qim1_VS_BP_VS_BP=(+qim_VS_BP_VS_BP+(+0.0*pInst->alpha+0.0*alpha_VS_BP+0.0*alpha_VS_BP+pInst->phit1*alpha_VS_BP_VS_BP));
#endif
#endif
pInst->qim1=(pInst->qim+(pInst->phit1*pInst->alpha));
EXIT_IF_ISNAN((pInst->qim+(pInst->phit1*pInst->alpha)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
qim1_1_VD_S=(-qim1_VD_S/pInst->qim1/pInst->qim1);
#if defined(_DERIVATE2)
  qim1_1_VD_S_VD_S=(0.0/pInst->qim1-(0.0*qim1_VD_S+0.0*qim1_VD_S+1.0*qim1_VD_S_VD_S)/pInst->qim1/pInst->qim1+2*1.0*qim1_VD_S*qim1_VD_S/pInst->qim1/pInst->qim1/pInst->qim1);
  qim1_1_VD_S_VGP_S=(0.0/pInst->qim1-(0.0*qim1_VGP_S+0.0*qim1_VD_S+1.0*qim1_VD_S_VGP_S)/pInst->qim1/pInst->qim1+2*1.0*qim1_VD_S*qim1_VGP_S/pInst->qim1/pInst->qim1/pInst->qim1);
  qim1_1_VD_S_VS_BP=(0.0/pInst->qim1-(0.0*qim1_VS_BP+0.0*qim1_VD_S+1.0*qim1_VD_S_VS_BP)/pInst->qim1/pInst->qim1+2*1.0*qim1_VD_S*qim1_VS_BP/pInst->qim1/pInst->qim1/pInst->qim1);
#endif
qim1_1_VGP_S=(-qim1_VGP_S/pInst->qim1/pInst->qim1);
#if defined(_DERIVATE2)
  qim1_1_VGP_S_VD_S=(0.0/pInst->qim1-(0.0*qim1_VD_S+0.0*qim1_VGP_S+1.0*qim1_VGP_S_VD_S)/pInst->qim1/pInst->qim1+2*1.0*qim1_VGP_S*qim1_VD_S/pInst->qim1/pInst->qim1/pInst->qim1);
  qim1_1_VGP_S_VGP_S=(0.0/pInst->qim1-(0.0*qim1_VGP_S+0.0*qim1_VGP_S+1.0*qim1_VGP_S_VGP_S)/pInst->qim1/pInst->qim1+2*1.0*qim1_VGP_S*qim1_VGP_S/pInst->qim1/pInst->qim1/pInst->qim1);
  qim1_1_VGP_S_VS_BP=(0.0/pInst->qim1-(0.0*qim1_VS_BP+0.0*qim1_VGP_S+1.0*qim1_VGP_S_VS_BP)/pInst->qim1/pInst->qim1+2*1.0*qim1_VGP_S*qim1_VS_BP/pInst->qim1/pInst->qim1/pInst->qim1);
#endif
qim1_1_VS_BP=(-qim1_VS_BP/pInst->qim1/pInst->qim1);
#if defined(_DERIVATE2)
  qim1_1_VS_BP_VD_S=(0.0/pInst->qim1-(0.0*qim1_VD_S+0.0*qim1_VS_BP+1.0*qim1_VS_BP_VD_S)/pInst->qim1/pInst->qim1+2*1.0*qim1_VS_BP*qim1_VD_S/pInst->qim1/pInst->qim1/pInst->qim1);
  qim1_1_VS_BP_VGP_S=(0.0/pInst->qim1-(0.0*qim1_VGP_S+0.0*qim1_VS_BP+1.0*qim1_VS_BP_VGP_S)/pInst->qim1/pInst->qim1+2*1.0*qim1_VS_BP*qim1_VGP_S/pInst->qim1/pInst->qim1/pInst->qim1);
  qim1_1_VS_BP_VS_BP=(0.0/pInst->qim1-(0.0*qim1_VS_BP+0.0*qim1_VS_BP+1.0*qim1_VS_BP_VS_BP)/pInst->qim1/pInst->qim1+2*1.0*qim1_VS_BP*qim1_VS_BP/pInst->qim1/pInst->qim1/pInst->qim1);
#endif
#endif
qim1_1=(1.0/pInst->qim1);
EXIT_IF_ISNAN((1.0/pInst->qim1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
qbm_VD_S=((sqm_VD_S*Gf)+(sqm*Gf_VD_S))*pInst->phit1;
#if defined(_DERIVATE2)
  qbm_VD_S_VD_S=(+(+sqm_VD_S_VD_S*Gf+sqm_VD_S*Gf_VD_S+sqm_VD_S*Gf_VD_S+sqm*Gf_VD_S_VD_S)*pInst->phit1+((sqm_VD_S*Gf)+(sqm*Gf_VD_S))*0.0+(((sqm_VD_S*Gf)+(sqm*Gf_VD_S)))*0.0+(sqm*Gf)*0.0);
  qbm_VD_S_VGP_S=(+(+sqm_VD_S_VGP_S*Gf+sqm_VD_S*Gf_VGP_S+sqm_VGP_S*Gf_VD_S+sqm*Gf_VD_S_VGP_S)*pInst->phit1+((sqm_VD_S*Gf)+(sqm*Gf_VD_S))*0.0+(((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S)))*0.0+(sqm*Gf)*0.0);
  qbm_VD_S_VS_BP=(+(+sqm_VD_S_VS_BP*Gf+sqm_VD_S*Gf_VS_BP+sqm_VS_BP*Gf_VD_S+sqm*Gf_VD_S_VS_BP)*pInst->phit1+((sqm_VD_S*Gf)+(sqm*Gf_VD_S))*0.0+(((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP)))*0.0+(sqm*Gf)*0.0);
#endif
qbm_VGP_S=((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S))*pInst->phit1;
#if defined(_DERIVATE2)
  qbm_VGP_S_VD_S=(+(+sqm_VGP_S_VD_S*Gf+sqm_VGP_S*Gf_VD_S+sqm_VD_S*Gf_VGP_S+sqm*Gf_VGP_S_VD_S)*pInst->phit1+((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S))*0.0+(((sqm_VD_S*Gf)+(sqm*Gf_VD_S)))*0.0+(sqm*Gf)*0.0);
  qbm_VGP_S_VGP_S=(+(+sqm_VGP_S_VGP_S*Gf+sqm_VGP_S*Gf_VGP_S+sqm_VGP_S*Gf_VGP_S+sqm*Gf_VGP_S_VGP_S)*pInst->phit1+((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S))*0.0+(((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S)))*0.0+(sqm*Gf)*0.0);
  qbm_VGP_S_VS_BP=(+(+sqm_VGP_S_VS_BP*Gf+sqm_VGP_S*Gf_VS_BP+sqm_VS_BP*Gf_VGP_S+sqm*Gf_VGP_S_VS_BP)*pInst->phit1+((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S))*0.0+(((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP)))*0.0+(sqm*Gf)*0.0);
#endif
qbm_VS_BP=((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP))*pInst->phit1;
#if defined(_DERIVATE2)
  qbm_VS_BP_VD_S=(+(+sqm_VS_BP_VD_S*Gf+sqm_VS_BP*Gf_VD_S+sqm_VD_S*Gf_VS_BP+sqm*Gf_VS_BP_VD_S)*pInst->phit1+((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP))*0.0+(((sqm_VD_S*Gf)+(sqm*Gf_VD_S)))*0.0+(sqm*Gf)*0.0);
  qbm_VS_BP_VGP_S=(+(+sqm_VS_BP_VGP_S*Gf+sqm_VS_BP*Gf_VGP_S+sqm_VGP_S*Gf_VS_BP+sqm*Gf_VS_BP_VGP_S)*pInst->phit1+((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP))*0.0+(((sqm_VGP_S*Gf)+(sqm*Gf_VGP_S)))*0.0+(sqm*Gf)*0.0);
  qbm_VS_BP_VS_BP=(+(+sqm_VS_BP_VS_BP*Gf+sqm_VS_BP*Gf_VS_BP+sqm_VS_BP*Gf_VS_BP+sqm*Gf_VS_BP_VS_BP)*pInst->phit1+((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP))*0.0+(((sqm_VS_BP*Gf)+(sqm*Gf_VS_BP)))*0.0+(sqm*Gf)*0.0);
#endif
#endif
qbm=((sqm*Gf)*pInst->phit1);
EXIT_IF_ISNAN(((sqm*Gf)*pInst->phit1))
if
((pInst->RSG_i<0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-(pInst->RSG_i*qim_VGP_S));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0-(+0.0*pInst->qim+0.0*0.0+0.0*qim_VGP_S+pInst->RSG_i*0.0));
  temp_VGP_S_VS_BS=(+0.0-(+0.0*pInst->qim+0.0*0.0+0.0*qim_VGP_S+pInst->RSG_i*0.0));
  temp_VGP_S_VGP_S=(+0.0-(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VGP_S+pInst->RSG_i*qim_VGP_S_VGP_S));
  temp_VGP_S_VD_S=(+0.0-(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VGP_S+pInst->RSG_i*qim_VGP_S_VD_S));
  temp_VGP_S_VS_BP=(+0.0-(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VGP_S+pInst->RSG_i*qim_VGP_S_VS_BP));
#endif
temp_VD_S=(-(pInst->RSG_i*qim_VD_S));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0-(+0.0*pInst->qim+0.0*0.0+0.0*qim_VD_S+pInst->RSG_i*0.0));
  temp_VD_S_VS_BS=(+0.0-(+0.0*pInst->qim+0.0*0.0+0.0*qim_VD_S+pInst->RSG_i*0.0));
  temp_VD_S_VGP_S=(+0.0-(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VD_S+pInst->RSG_i*qim_VD_S_VGP_S));
  temp_VD_S_VD_S=(+0.0-(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VD_S+pInst->RSG_i*qim_VD_S_VD_S));
  temp_VD_S_VS_BP=(+0.0-(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VD_S+pInst->RSG_i*qim_VD_S_VS_BP));
#endif
temp_VS_BP=(-(pInst->RSG_i*qim_VS_BP));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0-(+0.0*pInst->qim+0.0*0.0+0.0*qim_VS_BP+pInst->RSG_i*0.0));
  temp_VS_BP_VS_BS=(+0.0-(+0.0*pInst->qim+0.0*0.0+0.0*qim_VS_BP+pInst->RSG_i*0.0));
  temp_VS_BP_VGP_S=(+0.0-(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VS_BP+pInst->RSG_i*qim_VS_BP_VGP_S));
  temp_VS_BP_VD_S=(+0.0-(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VS_BP+pInst->RSG_i*qim_VS_BP_VD_S));
  temp_VS_BP_VS_BP=(+0.0-(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VS_BP+pInst->RSG_i*qim_VS_BP_VS_BP));
#endif
#endif
temp=(1.0-(pInst->RSG_i*pInst->qim));
EXIT_IF_ISNAN((1.0-(pInst->RSG_i*pInst->qim)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-(pInst->RSG_i*qim_VGP_S)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*(0.0)+0.0*(pInst->RSG_i*qim_VGP_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*0.0+0.0*qim_VGP_S+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VGP_S)*(0.0)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VGP_S_VS_BS=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*(0.0)+0.0*(pInst->RSG_i*qim_VGP_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*0.0+0.0*qim_VGP_S+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VGP_S)*(0.0)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VGP_S_VGP_S=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VGP_S))+0.0*(pInst->RSG_i*qim_VGP_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VGP_S+pInst->RSG_i*qim_VGP_S_VGP_S)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VGP_S)*((pInst->RSG_i*qim_VGP_S))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VGP_S_VD_S=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VD_S))+0.0*(pInst->RSG_i*qim_VGP_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VGP_S+pInst->RSG_i*qim_VGP_S_VD_S)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VGP_S)*((pInst->RSG_i*qim_VD_S))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VGP_S_VS_BP=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VS_BP))+0.0*(pInst->RSG_i*qim_VGP_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VGP_S+pInst->RSG_i*qim_VGP_S_VS_BP)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VGP_S)*((pInst->RSG_i*qim_VS_BP))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
#endif
temp_VD_S=(-(pInst->RSG_i*qim_VD_S)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*(0.0)+0.0*(pInst->RSG_i*qim_VD_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*0.0+0.0*qim_VD_S+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VD_S)*(0.0)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VD_S_VS_BS=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*(0.0)+0.0*(pInst->RSG_i*qim_VD_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*0.0+0.0*qim_VD_S+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VD_S)*(0.0)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VD_S_VGP_S=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VGP_S))+0.0*(pInst->RSG_i*qim_VD_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VD_S+pInst->RSG_i*qim_VD_S_VGP_S)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VD_S)*((pInst->RSG_i*qim_VGP_S))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VD_S_VD_S=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VD_S))+0.0*(pInst->RSG_i*qim_VD_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VD_S+pInst->RSG_i*qim_VD_S_VD_S)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VD_S)*((pInst->RSG_i*qim_VD_S))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VD_S_VS_BP=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VS_BP))+0.0*(pInst->RSG_i*qim_VD_S)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VD_S+pInst->RSG_i*qim_VD_S_VS_BP)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VD_S)*((pInst->RSG_i*qim_VS_BP))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
#endif
temp_VS_BP=(-(pInst->RSG_i*qim_VS_BP)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*(0.0)+0.0*(pInst->RSG_i*qim_VS_BP)+1.0*(+0.0+(+0.0*pInst->qim+0.0*0.0+0.0*qim_VS_BP+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VS_BP)*(0.0)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VS_BP_VS_BS=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*(0.0)+0.0*(pInst->RSG_i*qim_VS_BP)+1.0*(+0.0+(+0.0*pInst->qim+0.0*0.0+0.0*qim_VS_BP+pInst->RSG_i*0.0)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VS_BP)*(0.0)/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VS_BP_VGP_S=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VGP_S))+0.0*(pInst->RSG_i*qim_VS_BP)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VS_BP+pInst->RSG_i*qim_VS_BP_VGP_S)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VS_BP)*((pInst->RSG_i*qim_VGP_S))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VS_BP_VD_S=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VD_S))+0.0*(pInst->RSG_i*qim_VS_BP)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VS_BP+pInst->RSG_i*qim_VS_BP_VD_S)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VS_BP)*((pInst->RSG_i*qim_VD_S))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
  temp_VS_BP_VS_BP=(0.0/(1.0+(pInst->RSG_i*pInst->qim))-(0.0*((pInst->RSG_i*qim_VS_BP))+0.0*(pInst->RSG_i*qim_VS_BP)+1.0*(+0.0+(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VS_BP+pInst->RSG_i*qim_VS_BP_VS_BP)))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))+2*1.0*(pInst->RSG_i*qim_VS_BP)*((pInst->RSG_i*qim_VS_BP))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim))/(1.0+(pInst->RSG_i*pInst->qim)));
#endif
#endif
temp=(1.0/(1.0+(pInst->RSG_i*pInst->qim)));
EXIT_IF_ISNAN((1.0/(1.0+(pInst->RSG_i*pInst->qim))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
GR_VD_S=(pInst->THER_i*((((rhob_VD_S*temp)+(rhob*temp_VD_S))*pInst->qim)+((rhob*temp)*qim_VD_S)));
#if defined(_DERIVATE2)
  GR_VD_S_VD_S=(+0.0*((rhob*temp)*pInst->qim)+0.0*((((((rhob_VD_S*temp)+(rhob*temp_VD_S)))*pInst->qim)+((rhob*temp)*qim_VD_S)))+0.0*((((rhob_VD_S*temp)+(rhob*temp_VD_S))*pInst->qim)+((rhob*temp)*qim_VD_S))+pInst->THER_i*(+(+rhob_VD_S_VD_S*temp+rhob_VD_S*temp_VD_S+rhob_VD_S*temp_VD_S+rhob*temp_VD_S_VD_S)*pInst->qim+((rhob_VD_S*temp)+(rhob*temp_VD_S))*qim_VD_S+(((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qim_VD_S+(rhob*temp)*qim_VD_S_VD_S));
  GR_VD_S_VS_BP=(+0.0*((rhob*temp)*pInst->qim)+0.0*((((((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*pInst->qim)+((rhob*temp)*qim_VS_BP)))+0.0*((((rhob_VD_S*temp)+(rhob*temp_VD_S))*pInst->qim)+((rhob*temp)*qim_VD_S))+pInst->THER_i*(+(+rhob_VD_S_VS_BP*temp+rhob_VD_S*temp_VS_BP+rhob_VS_BP*temp_VD_S+rhob*temp_VD_S_VS_BP)*pInst->qim+((rhob_VD_S*temp)+(rhob*temp_VD_S))*qim_VS_BP+(((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qim_VD_S+(rhob*temp)*qim_VD_S_VS_BP));
  GR_VD_S_VGP_S=(+0.0*((rhob*temp)*pInst->qim)+0.0*(((((rhob*temp_VGP_S))*pInst->qim)+((rhob*temp)*qim_VGP_S)))+0.0*((((rhob_VD_S*temp)+(rhob*temp_VD_S))*pInst->qim)+((rhob*temp)*qim_VD_S))+pInst->THER_i*(+(+0.0*temp+rhob_VD_S*temp_VGP_S+0.0*temp_VD_S+rhob*temp_VD_S_VGP_S)*pInst->qim+((rhob_VD_S*temp)+(rhob*temp_VD_S))*qim_VGP_S+((rhob*temp_VGP_S))*qim_VD_S+(rhob*temp)*qim_VD_S_VGP_S));
#endif
GR_VS_BP=(pInst->THER_i*((((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*pInst->qim)+((rhob*temp)*qim_VS_BP)));
#if defined(_DERIVATE2)
  GR_VS_BP_VD_S=(+0.0*((rhob*temp)*pInst->qim)+0.0*((((((rhob_VD_S*temp)+(rhob*temp_VD_S)))*pInst->qim)+((rhob*temp)*qim_VD_S)))+0.0*((((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*pInst->qim)+((rhob*temp)*qim_VS_BP))+pInst->THER_i*(+(+rhob_VS_BP_VD_S*temp+rhob_VS_BP*temp_VD_S+rhob_VD_S*temp_VS_BP+rhob*temp_VS_BP_VD_S)*pInst->qim+((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qim_VD_S+(((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qim_VS_BP+(rhob*temp)*qim_VS_BP_VD_S));
  GR_VS_BP_VS_BP=(+0.0*((rhob*temp)*pInst->qim)+0.0*((((((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*pInst->qim)+((rhob*temp)*qim_VS_BP)))+0.0*((((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*pInst->qim)+((rhob*temp)*qim_VS_BP))+pInst->THER_i*(+(+rhob_VS_BP_VS_BP*temp+rhob_VS_BP*temp_VS_BP+rhob_VS_BP*temp_VS_BP+rhob*temp_VS_BP_VS_BP)*pInst->qim+((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qim_VS_BP+(((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qim_VS_BP+(rhob*temp)*qim_VS_BP_VS_BP));
  GR_VS_BP_VGP_S=(+0.0*((rhob*temp)*pInst->qim)+0.0*(((((rhob*temp_VGP_S))*pInst->qim)+((rhob*temp)*qim_VGP_S)))+0.0*((((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*pInst->qim)+((rhob*temp)*qim_VS_BP))+pInst->THER_i*(+(+0.0*temp+rhob_VS_BP*temp_VGP_S+0.0*temp_VS_BP+rhob*temp_VS_BP_VGP_S)*pInst->qim+((rhob_VS_BP*temp)+(rhob*temp_VS_BP))*qim_VGP_S+((rhob*temp_VGP_S))*qim_VS_BP+(rhob*temp)*qim_VS_BP_VGP_S));
#endif
GR_VGP_S=(pInst->THER_i*(((rhob*temp_VGP_S)*pInst->qim)+((rhob*temp)*qim_VGP_S)));
#if defined(_DERIVATE2)
  GR_VGP_S_VD_S=(+0.0*((rhob*temp)*pInst->qim)+0.0*((((((rhob_VD_S*temp)+(rhob*temp_VD_S)))*pInst->qim)+((rhob*temp)*qim_VD_S)))+0.0*(((rhob*temp_VGP_S)*pInst->qim)+((rhob*temp)*qim_VGP_S))+pInst->THER_i*(+(+0.0*temp+0.0*temp_VD_S+rhob_VD_S*temp_VGP_S+rhob*temp_VGP_S_VD_S)*pInst->qim+(rhob*temp_VGP_S)*qim_VD_S+(((rhob_VD_S*temp)+(rhob*temp_VD_S)))*qim_VGP_S+(rhob*temp)*qim_VGP_S_VD_S));
  GR_VGP_S_VS_BP=(+0.0*((rhob*temp)*pInst->qim)+0.0*((((((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*pInst->qim)+((rhob*temp)*qim_VS_BP)))+0.0*(((rhob*temp_VGP_S)*pInst->qim)+((rhob*temp)*qim_VGP_S))+pInst->THER_i*(+(+0.0*temp+0.0*temp_VS_BP+rhob_VS_BP*temp_VGP_S+rhob*temp_VGP_S_VS_BP)*pInst->qim+(rhob*temp_VGP_S)*qim_VS_BP+(((rhob_VS_BP*temp)+(rhob*temp_VS_BP)))*qim_VGP_S+(rhob*temp)*qim_VGP_S_VS_BP));
  GR_VGP_S_VGP_S=(+0.0*((rhob*temp)*pInst->qim)+0.0*(((((rhob*temp_VGP_S))*pInst->qim)+((rhob*temp)*qim_VGP_S)))+0.0*(((rhob*temp_VGP_S)*pInst->qim)+((rhob*temp)*qim_VGP_S))+pInst->THER_i*(+(+0.0*temp+0.0*temp_VGP_S+0.0*temp_VGP_S+rhob*temp_VGP_S_VGP_S)*pInst->qim+(rhob*temp_VGP_S)*qim_VGP_S+((rhob*temp_VGP_S))*qim_VGP_S+(rhob*temp)*qim_VGP_S_VGP_S));
#endif
#endif
GR=(pInst->THER_i*((rhob*temp)*pInst->qim));
EXIT_IF_ISNAN((pInst->THER_i*((rhob*temp)*pInst->qim)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(BP,GND)V(GP,GND)V(D,GND)V(S,GND) */
qeff_VD_S=(qbm_VD_S+(pInst->eta_mu*qim_VD_S));
#if defined(_DERIVATE2)
  qeff_VD_S_VD_S=(+qbm_VD_S_VD_S+(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VD_S+pInst->eta_mu*qim_VD_S_VD_S));
  qeff_VD_S_VGP_S=(+qbm_VD_S_VGP_S+(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VD_S+pInst->eta_mu*qim_VD_S_VGP_S));
  qeff_VD_S_VS_BP=(+qbm_VD_S_VS_BP+(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VD_S+pInst->eta_mu*qim_VD_S_VS_BP));
#endif
qeff_VGP_S=(qbm_VGP_S+(pInst->eta_mu*qim_VGP_S));
#if defined(_DERIVATE2)
  qeff_VGP_S_VD_S=(+qbm_VGP_S_VD_S+(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VGP_S+pInst->eta_mu*qim_VGP_S_VD_S));
  qeff_VGP_S_VGP_S=(+qbm_VGP_S_VGP_S+(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VGP_S+pInst->eta_mu*qim_VGP_S_VGP_S));
  qeff_VGP_S_VS_BP=(+qbm_VGP_S_VS_BP+(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VGP_S+pInst->eta_mu*qim_VGP_S_VS_BP));
#endif
qeff_VS_BP=(qbm_VS_BP+(pInst->eta_mu*qim_VS_BP));
#if defined(_DERIVATE2)
  qeff_VS_BP_VD_S=(+qbm_VS_BP_VD_S+(+0.0*pInst->qim+0.0*qim_VD_S+0.0*qim_VS_BP+pInst->eta_mu*qim_VS_BP_VD_S));
  qeff_VS_BP_VGP_S=(+qbm_VS_BP_VGP_S+(+0.0*pInst->qim+0.0*qim_VGP_S+0.0*qim_VS_BP+pInst->eta_mu*qim_VS_BP_VGP_S));
  qeff_VS_BP_VS_BP=(+qbm_VS_BP_VS_BP+(+0.0*pInst->qim+0.0*qim_VS_BP+0.0*qim_VS_BP+pInst->eta_mu*qim_VS_BP_VS_BP));
#endif
#endif
qeff=(qbm+(pInst->eta_mu*pInst->qim));
EXIT_IF_ISNAN((qbm+(pInst->eta_mu*pInst->qim)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Eeffm_VD_S=(pInst->E_eff0*qeff_VD_S);
#if defined(_DERIVATE2)
  Eeffm_VD_S_VD_S=(+0.0*qeff+0.0*qeff_VD_S+0.0*qeff_VD_S+pInst->E_eff0*qeff_VD_S_VD_S);
  Eeffm_VD_S_VGP_S=(+0.0*qeff+0.0*qeff_VGP_S+0.0*qeff_VD_S+pInst->E_eff0*qeff_VD_S_VGP_S);
  Eeffm_VD_S_VS_BP=(+0.0*qeff+0.0*qeff_VS_BP+0.0*qeff_VD_S+pInst->E_eff0*qeff_VD_S_VS_BP);
#endif
Eeffm_VGP_S=(pInst->E_eff0*qeff_VGP_S);
#if defined(_DERIVATE2)
  Eeffm_VGP_S_VD_S=(+0.0*qeff+0.0*qeff_VD_S+0.0*qeff_VGP_S+pInst->E_eff0*qeff_VGP_S_VD_S);
  Eeffm_VGP_S_VGP_S=(+0.0*qeff+0.0*qeff_VGP_S+0.0*qeff_VGP_S+pInst->E_eff0*qeff_VGP_S_VGP_S);
  Eeffm_VGP_S_VS_BP=(+0.0*qeff+0.0*qeff_VS_BP+0.0*qeff_VGP_S+pInst->E_eff0*qeff_VGP_S_VS_BP);
#endif
Eeffm_VS_BP=(pInst->E_eff0*qeff_VS_BP);
#if defined(_DERIVATE2)
  Eeffm_VS_BP_VD_S=(+0.0*qeff+0.0*qeff_VD_S+0.0*qeff_VS_BP+pInst->E_eff0*qeff_VS_BP_VD_S);
  Eeffm_VS_BP_VGP_S=(+0.0*qeff+0.0*qeff_VGP_S+0.0*qeff_VS_BP+pInst->E_eff0*qeff_VS_BP_VGP_S);
  Eeffm_VS_BP_VS_BP=(+0.0*qeff+0.0*qeff_VS_BP+0.0*qeff_VS_BP+pInst->E_eff0*qeff_VS_BP_VS_BP);
#endif
#endif
Eeffm=(pInst->E_eff0*qeff);
EXIT_IF_ISNAN((pInst->E_eff0*qeff))
{
double m00_pow(d00_pow0,(Eeffm*pInst->MUE_i),pInst->THEMU_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(Eeffm*pInst->MUE_i),pInst->THEMU_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Mutmp_VD_S=((d10_pow0*Eeffm_VD_S*pInst->MUE_i)+(pInst->CS_i*((Pm_VD_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VD_S+Dm_VD_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
#if defined(_DERIVATE2)
  Mutmp_VD_S_VD_S=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VD_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VD_S+Dm_VD_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VD_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VD_S+Dm_VD_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VD_S_VD_S/((Pm+Dm)+1.0e-14)-(Pm_VD_S*(Pm_VD_S+Dm_VD_S)+Pm_VD_S*(Pm_VD_S+Dm_VD_S)+Pm*(+(+Pm_VD_S_VD_S+Dm_VD_S_VD_S)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VD_S+Dm_VD_S)*(Pm_VD_S+Dm_VD_S)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
  Mutmp_VD_S_VGP_S=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VGP_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VGP_S+Dm_VGP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VD_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VD_S+Dm_VD_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VD_S_VGP_S/((Pm+Dm)+1.0e-14)-(Pm_VD_S*(Pm_VGP_S+Dm_VGP_S)+Pm_VGP_S*(Pm_VD_S+Dm_VD_S)+Pm*(+(+Pm_VD_S_VGP_S+Dm_VD_S_VGP_S)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VD_S+Dm_VD_S)*(Pm_VGP_S+Dm_VGP_S)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
  Mutmp_VD_S_VS_BP=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VS_BP*((Pm+Dm)+1.0e-14)-Pm*(Pm_VS_BP+Dm_VS_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VD_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VD_S+Dm_VD_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VD_S_VS_BP/((Pm+Dm)+1.0e-14)-(Pm_VD_S*(Pm_VS_BP+Dm_VS_BP)+Pm_VS_BP*(Pm_VD_S+Dm_VD_S)+Pm*(+(+Pm_VD_S_VS_BP+Dm_VD_S_VS_BP)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VD_S+Dm_VD_S)*(Pm_VS_BP+Dm_VS_BP)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
#endif
Mutmp_VGP_S=((d10_pow0*Eeffm_VGP_S*pInst->MUE_i)+(pInst->CS_i*((Pm_VGP_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VGP_S+Dm_VGP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
#if defined(_DERIVATE2)
  Mutmp_VGP_S_VD_S=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VD_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VD_S+Dm_VD_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VGP_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VGP_S+Dm_VGP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VGP_S_VD_S/((Pm+Dm)+1.0e-14)-(Pm_VGP_S*(Pm_VD_S+Dm_VD_S)+Pm_VD_S*(Pm_VGP_S+Dm_VGP_S)+Pm*(+(+Pm_VGP_S_VD_S+Dm_VGP_S_VD_S)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VGP_S+Dm_VGP_S)*(Pm_VD_S+Dm_VD_S)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
  Mutmp_VGP_S_VGP_S=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VGP_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VGP_S+Dm_VGP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VGP_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VGP_S+Dm_VGP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VGP_S_VGP_S/((Pm+Dm)+1.0e-14)-(Pm_VGP_S*(Pm_VGP_S+Dm_VGP_S)+Pm_VGP_S*(Pm_VGP_S+Dm_VGP_S)+Pm*(+(+Pm_VGP_S_VGP_S+Dm_VGP_S_VGP_S)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VGP_S+Dm_VGP_S)*(Pm_VGP_S+Dm_VGP_S)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
  Mutmp_VGP_S_VS_BP=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VS_BP*((Pm+Dm)+1.0e-14)-Pm*(Pm_VS_BP+Dm_VS_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VGP_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VGP_S+Dm_VGP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VGP_S_VS_BP/((Pm+Dm)+1.0e-14)-(Pm_VGP_S*(Pm_VS_BP+Dm_VS_BP)+Pm_VS_BP*(Pm_VGP_S+Dm_VGP_S)+Pm*(+(+Pm_VGP_S_VS_BP+Dm_VGP_S_VS_BP)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VGP_S+Dm_VGP_S)*(Pm_VS_BP+Dm_VS_BP)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
#endif
Mutmp_VS_BP=((d10_pow0*Eeffm_VS_BP*pInst->MUE_i)+(pInst->CS_i*((Pm_VS_BP*((Pm+Dm)+1.0e-14)-Pm*(Pm_VS_BP+Dm_VS_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
#if defined(_DERIVATE2)
  Mutmp_VS_BP_VD_S=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VD_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VD_S+Dm_VD_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VS_BP*((Pm+Dm)+1.0e-14)-Pm*(Pm_VS_BP+Dm_VS_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VS_BP_VD_S/((Pm+Dm)+1.0e-14)-(Pm_VS_BP*(Pm_VD_S+Dm_VD_S)+Pm_VD_S*(Pm_VS_BP+Dm_VS_BP)+Pm*(+(+Pm_VS_BP_VD_S+Dm_VS_BP_VD_S)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VS_BP+Dm_VS_BP)*(Pm_VD_S+Dm_VD_S)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
  Mutmp_VS_BP_VGP_S=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VGP_S*((Pm+Dm)+1.0e-14)-Pm*(Pm_VGP_S+Dm_VGP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VS_BP*((Pm+Dm)+1.0e-14)-Pm*(Pm_VS_BP+Dm_VS_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VS_BP_VGP_S/((Pm+Dm)+1.0e-14)-(Pm_VS_BP*(Pm_VGP_S+Dm_VGP_S)+Pm_VGP_S*(Pm_VS_BP+Dm_VS_BP)+Pm*(+(+Pm_VS_BP_VGP_S+Dm_VS_BP_VGP_S)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VS_BP+Dm_VS_BP)*(Pm_VGP_S+Dm_VGP_S)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
  Mutmp_VS_BP_VS_BP=(+fixme+(+0.0*(Pm/((Pm+Dm)+1.0e-14))+0.0*((Pm_VS_BP*((Pm+Dm)+1.0e-14)-Pm*(Pm_VS_BP+Dm_VS_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+0.0*((Pm_VS_BP*((Pm+Dm)+1.0e-14)-Pm*(Pm_VS_BP+Dm_VS_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+pInst->CS_i*(Pm_VS_BP_VS_BP/((Pm+Dm)+1.0e-14)-(Pm_VS_BP*(Pm_VS_BP+Dm_VS_BP)+Pm_VS_BP*(Pm_VS_BP+Dm_VS_BP)+Pm*(+(+Pm_VS_BP_VS_BP+Dm_VS_BP_VS_BP)+0.0))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)+2*Pm*(Pm_VS_BP+Dm_VS_BP)*(Pm_VS_BP+Dm_VS_BP)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))));
#endif
#endif
Mutmp=(d00_pow0+(pInst->CS_i*(Pm/((Pm+Dm)+1.0e-14))));
EXIT_IF_ISNAN((d00_pow0+(pInst->CS_i*(Pm/((Pm+Dm)+1.0e-14)))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Gmob_VD_S=(((Mutmp_VD_S+GR_VD_S)*Rxcor)+(((1.0+Mutmp)+GR)*Rxcor_VD_S));
#if defined(_DERIVATE2)
  Gmob_VD_S_VD_S=(+(+(+0.0+Mutmp_VD_S_VD_S)+GR_VD_S_VD_S)*Rxcor+(Mutmp_VD_S+GR_VD_S)*Rxcor_VD_S+(Mutmp_VD_S+GR_VD_S)*Rxcor_VD_S+((1.0+Mutmp)+GR)*Rxcor_VD_S_VD_S);
  Gmob_VD_S_VGP_S=(+(+(+0.0+Mutmp_VD_S_VGP_S)+GR_VD_S_VGP_S)*Rxcor+(Mutmp_VD_S+GR_VD_S)*0.0+(Mutmp_VGP_S+GR_VGP_S)*Rxcor_VD_S+((1.0+Mutmp)+GR)*0.0);
  Gmob_VD_S_VS_BP=(+(+(+0.0+Mutmp_VD_S_VS_BP)+GR_VD_S_VS_BP)*Rxcor+(Mutmp_VD_S+GR_VD_S)*Rxcor_VS_BP+(Mutmp_VS_BP+GR_VS_BP)*Rxcor_VD_S+((1.0+Mutmp)+GR)*Rxcor_VD_S_VS_BP);
#endif
Gmob_VGP_S=(Mutmp_VGP_S+GR_VGP_S)*Rxcor;
#if defined(_DERIVATE2)
  Gmob_VGP_S_VD_S=(+(+(+0.0+Mutmp_VGP_S_VD_S)+GR_VGP_S_VD_S)*Rxcor+(Mutmp_VGP_S+GR_VGP_S)*Rxcor_VD_S+(Mutmp_VD_S+GR_VD_S)*0.0+((1.0+Mutmp)+GR)*0.0);
  Gmob_VGP_S_VGP_S=(+(+(+0.0+Mutmp_VGP_S_VGP_S)+GR_VGP_S_VGP_S)*Rxcor+(Mutmp_VGP_S+GR_VGP_S)*0.0+(Mutmp_VGP_S+GR_VGP_S)*0.0+((1.0+Mutmp)+GR)*0.0);
  Gmob_VGP_S_VS_BP=(+(+(+0.0+Mutmp_VGP_S_VS_BP)+GR_VGP_S_VS_BP)*Rxcor+(Mutmp_VGP_S+GR_VGP_S)*Rxcor_VS_BP+(Mutmp_VS_BP+GR_VS_BP)*0.0+((1.0+Mutmp)+GR)*0.0);
#endif
Gmob_VS_BP=(((Mutmp_VS_BP+GR_VS_BP)*Rxcor)+(((1.0+Mutmp)+GR)*Rxcor_VS_BP));
#if defined(_DERIVATE2)
  Gmob_VS_BP_VD_S=(+(+(+0.0+Mutmp_VS_BP_VD_S)+GR_VS_BP_VD_S)*Rxcor+(Mutmp_VS_BP+GR_VS_BP)*Rxcor_VD_S+(Mutmp_VD_S+GR_VD_S)*Rxcor_VS_BP+((1.0+Mutmp)+GR)*Rxcor_VS_BP_VD_S);
  Gmob_VS_BP_VGP_S=(+(+(+0.0+Mutmp_VS_BP_VGP_S)+GR_VS_BP_VGP_S)*Rxcor+(Mutmp_VS_BP+GR_VS_BP)*0.0+(Mutmp_VGP_S+GR_VGP_S)*Rxcor_VS_BP+((1.0+Mutmp)+GR)*0.0);
  Gmob_VS_BP_VS_BP=(+(+(+0.0+Mutmp_VS_BP_VS_BP)+GR_VS_BP_VS_BP)*Rxcor+(Mutmp_VS_BP+GR_VS_BP)*Rxcor_VS_BP+(Mutmp_VS_BP+GR_VS_BP)*Rxcor_VS_BP+((1.0+Mutmp)+GR)*Rxcor_VS_BP_VS_BP);
#endif
#endif
pInst->Gmob=(((1.0+Mutmp)+GR)*Rxcor);
EXIT_IF_ISNAN((((1.0+Mutmp)+GR)*Rxcor))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
r1_VD_S=((qim_VD_S*qim1_1)+(pInst->qim*qim1_1_VD_S));
#if defined(_DERIVATE2)
  r1_VD_S_VD_S=(+qim_VD_S_VD_S*qim1_1+qim_VD_S*qim1_1_VD_S+qim_VD_S*qim1_1_VD_S+pInst->qim*qim1_1_VD_S_VD_S);
  r1_VD_S_VGP_S=(+qim_VD_S_VGP_S*qim1_1+qim_VD_S*qim1_1_VGP_S+qim_VGP_S*qim1_1_VD_S+pInst->qim*qim1_1_VD_S_VGP_S);
  r1_VD_S_VS_BP=(+qim_VD_S_VS_BP*qim1_1+qim_VD_S*qim1_1_VS_BP+qim_VS_BP*qim1_1_VD_S+pInst->qim*qim1_1_VD_S_VS_BP);
#endif
r1_VGP_S=((qim_VGP_S*qim1_1)+(pInst->qim*qim1_1_VGP_S));
#if defined(_DERIVATE2)
  r1_VGP_S_VD_S=(+qim_VGP_S_VD_S*qim1_1+qim_VGP_S*qim1_1_VD_S+qim_VD_S*qim1_1_VGP_S+pInst->qim*qim1_1_VGP_S_VD_S);
  r1_VGP_S_VGP_S=(+qim_VGP_S_VGP_S*qim1_1+qim_VGP_S*qim1_1_VGP_S+qim_VGP_S*qim1_1_VGP_S+pInst->qim*qim1_1_VGP_S_VGP_S);
  r1_VGP_S_VS_BP=(+qim_VGP_S_VS_BP*qim1_1+qim_VGP_S*qim1_1_VS_BP+qim_VS_BP*qim1_1_VGP_S+pInst->qim*qim1_1_VGP_S_VS_BP);
#endif
r1_VS_BP=((qim_VS_BP*qim1_1)+(pInst->qim*qim1_1_VS_BP));
#if defined(_DERIVATE2)
  r1_VS_BP_VD_S=(+qim_VS_BP_VD_S*qim1_1+qim_VS_BP*qim1_1_VD_S+qim_VD_S*qim1_1_VS_BP+pInst->qim*qim1_1_VS_BP_VD_S);
  r1_VS_BP_VGP_S=(+qim_VS_BP_VGP_S*qim1_1+qim_VS_BP*qim1_1_VGP_S+qim_VGP_S*qim1_1_VS_BP+pInst->qim*qim1_1_VS_BP_VGP_S);
  r1_VS_BP_VS_BP=(+qim_VS_BP_VS_BP*qim1_1+qim_VS_BP*qim1_1_VS_BP+qim_VS_BP*qim1_1_VS_BP+pInst->qim*qim1_1_VS_BP_VS_BP);
#endif
#endif
r1=(pInst->qim*qim1_1);
EXIT_IF_ISNAN((pInst->qim*qim1_1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
r2_VD_S=(pInst->phit1*((alpha_VD_S*qim1_1)+(pInst->alpha*qim1_1_VD_S)));
#if defined(_DERIVATE2)
  r2_VD_S_VD_S=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VD_S*qim1_1)+(pInst->alpha*qim1_1_VD_S)))+0.0*((alpha_VD_S*qim1_1)+(pInst->alpha*qim1_1_VD_S))+pInst->phit1*(+alpha_VD_S_VD_S*qim1_1+alpha_VD_S*qim1_1_VD_S+alpha_VD_S*qim1_1_VD_S+pInst->alpha*qim1_1_VD_S_VD_S));
  r2_VD_S_VGP_S=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VGP_S*qim1_1)+(pInst->alpha*qim1_1_VGP_S)))+0.0*((alpha_VD_S*qim1_1)+(pInst->alpha*qim1_1_VD_S))+pInst->phit1*(+alpha_VD_S_VGP_S*qim1_1+alpha_VD_S*qim1_1_VGP_S+alpha_VGP_S*qim1_1_VD_S+pInst->alpha*qim1_1_VD_S_VGP_S));
  r2_VD_S_VS_BP=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VS_BP*qim1_1)+(pInst->alpha*qim1_1_VS_BP)))+0.0*((alpha_VD_S*qim1_1)+(pInst->alpha*qim1_1_VD_S))+pInst->phit1*(+alpha_VD_S_VS_BP*qim1_1+alpha_VD_S*qim1_1_VS_BP+alpha_VS_BP*qim1_1_VD_S+pInst->alpha*qim1_1_VD_S_VS_BP));
#endif
r2_VGP_S=(pInst->phit1*((alpha_VGP_S*qim1_1)+(pInst->alpha*qim1_1_VGP_S)));
#if defined(_DERIVATE2)
  r2_VGP_S_VD_S=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VD_S*qim1_1)+(pInst->alpha*qim1_1_VD_S)))+0.0*((alpha_VGP_S*qim1_1)+(pInst->alpha*qim1_1_VGP_S))+pInst->phit1*(+alpha_VGP_S_VD_S*qim1_1+alpha_VGP_S*qim1_1_VD_S+alpha_VD_S*qim1_1_VGP_S+pInst->alpha*qim1_1_VGP_S_VD_S));
  r2_VGP_S_VGP_S=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VGP_S*qim1_1)+(pInst->alpha*qim1_1_VGP_S)))+0.0*((alpha_VGP_S*qim1_1)+(pInst->alpha*qim1_1_VGP_S))+pInst->phit1*(+alpha_VGP_S_VGP_S*qim1_1+alpha_VGP_S*qim1_1_VGP_S+alpha_VGP_S*qim1_1_VGP_S+pInst->alpha*qim1_1_VGP_S_VGP_S));
  r2_VGP_S_VS_BP=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VS_BP*qim1_1)+(pInst->alpha*qim1_1_VS_BP)))+0.0*((alpha_VGP_S*qim1_1)+(pInst->alpha*qim1_1_VGP_S))+pInst->phit1*(+alpha_VGP_S_VS_BP*qim1_1+alpha_VGP_S*qim1_1_VS_BP+alpha_VS_BP*qim1_1_VGP_S+pInst->alpha*qim1_1_VGP_S_VS_BP));
#endif
r2_VS_BP=(pInst->phit1*((alpha_VS_BP*qim1_1)+(pInst->alpha*qim1_1_VS_BP)));
#if defined(_DERIVATE2)
  r2_VS_BP_VD_S=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VD_S*qim1_1)+(pInst->alpha*qim1_1_VD_S)))+0.0*((alpha_VS_BP*qim1_1)+(pInst->alpha*qim1_1_VS_BP))+pInst->phit1*(+alpha_VS_BP_VD_S*qim1_1+alpha_VS_BP*qim1_1_VD_S+alpha_VD_S*qim1_1_VS_BP+pInst->alpha*qim1_1_VS_BP_VD_S));
  r2_VS_BP_VGP_S=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VGP_S*qim1_1)+(pInst->alpha*qim1_1_VGP_S)))+0.0*((alpha_VS_BP*qim1_1)+(pInst->alpha*qim1_1_VS_BP))+pInst->phit1*(+alpha_VS_BP_VGP_S*qim1_1+alpha_VS_BP*qim1_1_VGP_S+alpha_VGP_S*qim1_1_VS_BP+pInst->alpha*qim1_1_VS_BP_VGP_S));
  r2_VS_BP_VS_BP=(+0.0*(pInst->alpha*qim1_1)+0.0*(((alpha_VS_BP*qim1_1)+(pInst->alpha*qim1_1_VS_BP)))+0.0*((alpha_VS_BP*qim1_1)+(pInst->alpha*qim1_1_VS_BP))+pInst->phit1*(+alpha_VS_BP_VS_BP*qim1_1+alpha_VS_BP*qim1_1_VS_BP+alpha_VS_BP*qim1_1_VS_BP+pInst->alpha*qim1_1_VS_BP_VS_BP));
#endif
#endif
r2=(pInst->phit1*(pInst->alpha*qim1_1));
EXIT_IF_ISNAN((pInst->phit1*(pInst->alpha*qim1_1)))
{
double m00_logE(d00_logE0,((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(((-dps_VGP_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*d10_logE0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*(((0.0)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VGP_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-0.0)*pInst->inv_VP+(-dps_VGP_S)*0.0+0.0*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VGP_S)*pInst->inv_VP*(0.0)+(0.0)*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+0.0-0.0)*pInst->inv_VP+(Vdse_VGP_S-dps_VGP_S)*0.0+0.0*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP*(0.0)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VGP_S_VS_BS=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*(((0.0)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VGP_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-0.0)*pInst->inv_VP+(-dps_VGP_S)*0.0+0.0*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VGP_S)*pInst->inv_VP*(0.0)+(0.0)*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+0.0-0.0)*pInst->inv_VP+(Vdse_VGP_S-dps_VGP_S)*0.0+0.0*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP*(0.0)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VGP_S_VGP_S=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((-dps_VGP_S)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VGP_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-dps_VGP_S_VGP_S)*pInst->inv_VP+(-dps_VGP_S)*0.0+(-dps_VGP_S)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VGP_S)*pInst->inv_VP*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)+((-dps_VGP_S)*pInst->inv_VP)*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VGP_S_VGP_S-dps_VGP_S_VGP_S)*pInst->inv_VP+(Vdse_VGP_S-dps_VGP_S)*0.0+(Vdse_VGP_S-dps_VGP_S)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VGP_S_VD_S=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((Vds_VD_S-dps_VD_S)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VGP_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-dps_VGP_S_VD_S)*pInst->inv_VP+(-dps_VGP_S)*0.0+(Vds_VD_S-dps_VD_S)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VGP_S)*pInst->inv_VP*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP)+((Vds_VD_S-dps_VD_S)*pInst->inv_VP)*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VGP_S_VD_S-dps_VGP_S_VD_S)*pInst->inv_VP+(Vdse_VGP_S-dps_VGP_S)*0.0+(Vdse_VD_S-dps_VD_S)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VGP_S_VS_BP=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((-dps_VS_BP)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VGP_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-dps_VGP_S_VS_BP)*pInst->inv_VP+(-dps_VGP_S)*0.0+(-dps_VS_BP)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VGP_S)*pInst->inv_VP*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)+((-dps_VS_BP)*pInst->inv_VP)*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VGP_S_VS_BP-dps_VGP_S_VS_BP)*pInst->inv_VP+(Vdse_VGP_S-dps_VGP_S)*0.0+(Vdse_VS_BP-dps_VS_BP)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
#endif
temp_VD_S=(((Vds_VD_S-dps_VD_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*d10_logE0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*(((0.0)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((Vds_VD_S-dps_VD_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-0.0)*pInst->inv_VP+(Vds_VD_S-dps_VD_S)*0.0+0.0*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((Vds_VD_S-dps_VD_S)*pInst->inv_VP*(0.0)+(0.0)*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+0.0-0.0)*pInst->inv_VP+(Vdse_VD_S-dps_VD_S)*0.0+0.0*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP*(0.0)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VD_S_VS_BS=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*(((0.0)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((Vds_VD_S-dps_VD_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-0.0)*pInst->inv_VP+(Vds_VD_S-dps_VD_S)*0.0+0.0*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((Vds_VD_S-dps_VD_S)*pInst->inv_VP*(0.0)+(0.0)*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+0.0-0.0)*pInst->inv_VP+(Vdse_VD_S-dps_VD_S)*0.0+0.0*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP*(0.0)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VD_S_VGP_S=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((-dps_VGP_S)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((Vds_VD_S-dps_VD_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-dps_VD_S_VGP_S)*pInst->inv_VP+(Vds_VD_S-dps_VD_S)*0.0+(-dps_VGP_S)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((Vds_VD_S-dps_VD_S)*pInst->inv_VP*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)+((-dps_VGP_S)*pInst->inv_VP)*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VD_S_VGP_S-dps_VD_S_VGP_S)*pInst->inv_VP+(Vdse_VD_S-dps_VD_S)*0.0+(Vdse_VGP_S-dps_VGP_S)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VD_S_VD_S=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((Vds_VD_S-dps_VD_S)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((Vds_VD_S-dps_VD_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+Vds_VD_S_VD_S-dps_VD_S_VD_S)*pInst->inv_VP+(Vds_VD_S-dps_VD_S)*0.0+(Vds_VD_S-dps_VD_S)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((Vds_VD_S-dps_VD_S)*pInst->inv_VP*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP)+((Vds_VD_S-dps_VD_S)*pInst->inv_VP)*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VD_S_VD_S-dps_VD_S_VD_S)*pInst->inv_VP+(Vdse_VD_S-dps_VD_S)*0.0+(Vdse_VD_S-dps_VD_S)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VD_S_VS_BP=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((-dps_VS_BP)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((Vds_VD_S-dps_VD_S)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-dps_VD_S_VS_BP)*pInst->inv_VP+(Vds_VD_S-dps_VD_S)*0.0+(-dps_VS_BP)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((Vds_VD_S-dps_VD_S)*pInst->inv_VP*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)+((-dps_VS_BP)*pInst->inv_VP)*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VD_S_VS_BP-dps_VD_S_VS_BP)*pInst->inv_VP+(Vdse_VD_S-dps_VD_S)*0.0+(Vdse_VS_BP-dps_VS_BP)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VD_S-dps_VD_S)*pInst->inv_VP*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
#endif
temp_VS_BP=(((-dps_VS_BP)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*d10_logE0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*(((0.0)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VS_BP)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-0.0)*pInst->inv_VP+(-dps_VS_BP)*0.0+0.0*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VS_BP)*pInst->inv_VP*(0.0)+(0.0)*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+0.0-0.0)*pInst->inv_VP+(Vdse_VS_BP-dps_VS_BP)*0.0+0.0*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP*(0.0)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VS_BP_VS_BS=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*(((0.0)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VS_BP)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-0.0)*pInst->inv_VP+(-dps_VS_BP)*0.0+0.0*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VS_BP)*pInst->inv_VP*(0.0)+(0.0)*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+0.0-0.0)*pInst->inv_VP+(Vdse_VS_BP-dps_VS_BP)*0.0+0.0*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP*(0.0)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VS_BP_VGP_S=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((-dps_VGP_S)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VS_BP)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-dps_VS_BP_VGP_S)*pInst->inv_VP+(-dps_VS_BP)*0.0+(-dps_VGP_S)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VS_BP)*pInst->inv_VP*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)+((-dps_VGP_S)*pInst->inv_VP)*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VS_BP_VGP_S-dps_VS_BP_VGP_S)*pInst->inv_VP+(Vdse_VS_BP-dps_VS_BP)*0.0+(Vdse_VGP_S-dps_VGP_S)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP*((Vdse_VGP_S-dps_VGP_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VS_BP_VD_S=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((Vds_VD_S-dps_VD_S)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VS_BP)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-dps_VS_BP_VD_S)*pInst->inv_VP+(-dps_VS_BP)*0.0+(Vds_VD_S-dps_VD_S)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VS_BP)*pInst->inv_VP*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP)+((Vds_VD_S-dps_VD_S)*pInst->inv_VP)*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VS_BP_VD_S-dps_VS_BP_VD_S)*pInst->inv_VP+(Vdse_VS_BP-dps_VS_BP)*0.0+(Vdse_VD_S-dps_VD_S)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP*((Vdse_VD_S-dps_VD_S)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
  temp_VS_BP_VS_BP=(m20_logE(((1.0+((Vds-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))))*((((-dps_VS_BP)*pInst->inv_VP)*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))*(((-dps_VS_BP)*pInst->inv_VP*(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP)))+d10_logE0*((+0.0+(+(+0.0-dps_VS_BP_VS_BP)*pInst->inv_VP+(-dps_VS_BP)*0.0+(-dps_VS_BP)*0.0+(Vds-pInst->dps)*0.0))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))-((-dps_VS_BP)*pInst->inv_VP*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)+((-dps_VS_BP)*pInst->inv_VP)*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP+(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(+0.0+(+(+Vdse_VS_BP_VS_BP-dps_VS_BP_VS_BP)*pInst->inv_VP+(Vdse_VS_BP-dps_VS_BP)*0.0+(Vdse_VS_BP-dps_VS_BP)*0.0+(pInst->Vdse-pInst->dps)*0.0)))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))+2*(1.0+((Vds-pInst->dps)*pInst->inv_VP))*(Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP*((Vdse_VS_BP-dps_VS_BP)*pInst->inv_VP)/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))/(1.0+((pInst->Vdse-pInst->dps)*pInst->inv_VP))));
#endif
#endif
temp=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_logE(d00_logE0,(1.0+(Vdsx*pInst->inv_VP)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0+(Vdsx*pInst->inv_VP)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp1_VGP_S=0.0;
#if defined(_DERIVATE2)
  temp1_VGP_S_VGP_S=0.0;
  temp1_VGP_S_VD_S=0.0;
  temp1_VGP_S_VS_BP=0.0;
#endif
temp1_VD_S=Vdsx_VD_S*pInst->inv_VP*d10_logE0;
#if defined(_DERIVATE2)
  temp1_VD_S_VGP_S=(m20_logE((1.0+(Vdsx*pInst->inv_VP)))*(0.0)*Vdsx_VD_S*pInst->inv_VP+d10_logE0*(+0.0+(+0.0*pInst->inv_VP+Vdsx_VD_S*0.0+0.0*0.0+Vdsx*0.0)));
  temp1_VD_S_VD_S=(m20_logE((1.0+(Vdsx*pInst->inv_VP)))*(Vdsx_VD_S*pInst->inv_VP)*Vdsx_VD_S*pInst->inv_VP+d10_logE0*(+0.0+(+Vdsx_VD_S_VD_S*pInst->inv_VP+Vdsx_VD_S*0.0+Vdsx_VD_S*0.0+Vdsx*0.0)));
  temp1_VD_S_VS_BP=(m20_logE((1.0+(Vdsx*pInst->inv_VP)))*(0.0)*Vdsx_VD_S*pInst->inv_VP+d10_logE0*(+0.0+(+0.0*pInst->inv_VP+Vdsx_VD_S*0.0+0.0*0.0+Vdsx*0.0)));
#endif
temp1_VS_BP=0.0;
#if defined(_DERIVATE2)
  temp1_VS_BP_VGP_S=0.0;
  temp1_VS_BP_VD_S=0.0;
  temp1_VS_BP_VS_BP=0.0;
#endif
#endif
temp1=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dL_VGP_S=(pInst->ALP_i*temp_VGP_S);
#if defined(_DERIVATE2)
  dL_VGP_S_VGP_S=(+0.0*temp+0.0*temp_VGP_S+0.0*temp_VGP_S+pInst->ALP_i*temp_VGP_S_VGP_S);
  dL_VGP_S_VD_S=(+0.0*temp+0.0*temp_VD_S+0.0*temp_VGP_S+pInst->ALP_i*temp_VGP_S_VD_S);
  dL_VGP_S_VS_BP=(+0.0*temp+0.0*temp_VS_BP+0.0*temp_VGP_S+pInst->ALP_i*temp_VGP_S_VS_BP);
#endif
dL_VD_S=(pInst->ALP_i*temp_VD_S);
#if defined(_DERIVATE2)
  dL_VD_S_VGP_S=(+0.0*temp+0.0*temp_VGP_S+0.0*temp_VD_S+pInst->ALP_i*temp_VD_S_VGP_S);
  dL_VD_S_VD_S=(+0.0*temp+0.0*temp_VD_S+0.0*temp_VD_S+pInst->ALP_i*temp_VD_S_VD_S);
  dL_VD_S_VS_BP=(+0.0*temp+0.0*temp_VS_BP+0.0*temp_VD_S+pInst->ALP_i*temp_VD_S_VS_BP);
#endif
dL_VS_BP=(pInst->ALP_i*temp_VS_BP);
#if defined(_DERIVATE2)
  dL_VS_BP_VGP_S=(+0.0*temp+0.0*temp_VGP_S+0.0*temp_VS_BP+pInst->ALP_i*temp_VS_BP_VGP_S);
  dL_VS_BP_VD_S=(+0.0*temp+0.0*temp_VD_S+0.0*temp_VS_BP+pInst->ALP_i*temp_VS_BP_VD_S);
  dL_VS_BP_VS_BP=(+0.0*temp+0.0*temp_VS_BP+0.0*temp_VS_BP+pInst->ALP_i*temp_VS_BP_VS_BP);
#endif
#endif
dL=(pInst->ALP_i*temp);
EXIT_IF_ISNAN((pInst->ALP_i*temp))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
GdL_VGP_S=(-(dL_VGP_S+((dL_VGP_S*dL)+(dL*dL_VGP_S)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
#if defined(_DERIVATE2)
  GdL_VGP_S_VGP_S=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VGP_S+(((dL_VGP_S*dL)+(dL*dL_VGP_S))))+0.0*(dL_VGP_S+((dL_VGP_S*dL)+(dL*dL_VGP_S)))+1.0*(+(+0.0+dL_VGP_S_VGP_S)+(+dL_VGP_S_VGP_S*dL+dL_VGP_S*dL_VGP_S+dL_VGP_S*dL_VGP_S+dL*dL_VGP_S_VGP_S)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VGP_S+((dL_VGP_S*dL)+(dL*dL_VGP_S)))*(dL_VGP_S+(((dL_VGP_S*dL)+(dL*dL_VGP_S))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
  GdL_VGP_S_VD_S=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VD_S+(((dL_VD_S*dL)+(dL*dL_VD_S))))+0.0*(dL_VGP_S+((dL_VGP_S*dL)+(dL*dL_VGP_S)))+1.0*(+(+0.0+dL_VGP_S_VD_S)+(+dL_VGP_S_VD_S*dL+dL_VGP_S*dL_VD_S+dL_VD_S*dL_VGP_S+dL*dL_VGP_S_VD_S)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VGP_S+((dL_VGP_S*dL)+(dL*dL_VGP_S)))*(dL_VD_S+(((dL_VD_S*dL)+(dL*dL_VD_S))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
  GdL_VGP_S_VS_BP=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VS_BP+(((dL_VS_BP*dL)+(dL*dL_VS_BP))))+0.0*(dL_VGP_S+((dL_VGP_S*dL)+(dL*dL_VGP_S)))+1.0*(+(+0.0+dL_VGP_S_VS_BP)+(+dL_VGP_S_VS_BP*dL+dL_VGP_S*dL_VS_BP+dL_VS_BP*dL_VGP_S+dL*dL_VGP_S_VS_BP)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VGP_S+((dL_VGP_S*dL)+(dL*dL_VGP_S)))*(dL_VS_BP+(((dL_VS_BP*dL)+(dL*dL_VS_BP))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
#endif
GdL_VD_S=(-(dL_VD_S+((dL_VD_S*dL)+(dL*dL_VD_S)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
#if defined(_DERIVATE2)
  GdL_VD_S_VGP_S=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VGP_S+(((dL_VGP_S*dL)+(dL*dL_VGP_S))))+0.0*(dL_VD_S+((dL_VD_S*dL)+(dL*dL_VD_S)))+1.0*(+(+0.0+dL_VD_S_VGP_S)+(+dL_VD_S_VGP_S*dL+dL_VD_S*dL_VGP_S+dL_VGP_S*dL_VD_S+dL*dL_VD_S_VGP_S)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VD_S+((dL_VD_S*dL)+(dL*dL_VD_S)))*(dL_VGP_S+(((dL_VGP_S*dL)+(dL*dL_VGP_S))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
  GdL_VD_S_VD_S=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VD_S+(((dL_VD_S*dL)+(dL*dL_VD_S))))+0.0*(dL_VD_S+((dL_VD_S*dL)+(dL*dL_VD_S)))+1.0*(+(+0.0+dL_VD_S_VD_S)+(+dL_VD_S_VD_S*dL+dL_VD_S*dL_VD_S+dL_VD_S*dL_VD_S+dL*dL_VD_S_VD_S)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VD_S+((dL_VD_S*dL)+(dL*dL_VD_S)))*(dL_VD_S+(((dL_VD_S*dL)+(dL*dL_VD_S))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
  GdL_VD_S_VS_BP=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VS_BP+(((dL_VS_BP*dL)+(dL*dL_VS_BP))))+0.0*(dL_VD_S+((dL_VD_S*dL)+(dL*dL_VD_S)))+1.0*(+(+0.0+dL_VD_S_VS_BP)+(+dL_VD_S_VS_BP*dL+dL_VD_S*dL_VS_BP+dL_VS_BP*dL_VD_S+dL*dL_VD_S_VS_BP)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VD_S+((dL_VD_S*dL)+(dL*dL_VD_S)))*(dL_VS_BP+(((dL_VS_BP*dL)+(dL*dL_VS_BP))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
#endif
GdL_VS_BP=(-(dL_VS_BP+((dL_VS_BP*dL)+(dL*dL_VS_BP)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
#if defined(_DERIVATE2)
  GdL_VS_BP_VGP_S=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VGP_S+(((dL_VGP_S*dL)+(dL*dL_VGP_S))))+0.0*(dL_VS_BP+((dL_VS_BP*dL)+(dL*dL_VS_BP)))+1.0*(+(+0.0+dL_VS_BP_VGP_S)+(+dL_VS_BP_VGP_S*dL+dL_VS_BP*dL_VGP_S+dL_VGP_S*dL_VS_BP+dL*dL_VS_BP_VGP_S)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VS_BP+((dL_VS_BP*dL)+(dL*dL_VS_BP)))*(dL_VGP_S+(((dL_VGP_S*dL)+(dL*dL_VGP_S))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
  GdL_VS_BP_VD_S=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VD_S+(((dL_VD_S*dL)+(dL*dL_VD_S))))+0.0*(dL_VS_BP+((dL_VS_BP*dL)+(dL*dL_VS_BP)))+1.0*(+(+0.0+dL_VS_BP_VD_S)+(+dL_VS_BP_VD_S*dL+dL_VS_BP*dL_VD_S+dL_VD_S*dL_VS_BP+dL*dL_VS_BP_VD_S)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VS_BP+((dL_VS_BP*dL)+(dL*dL_VS_BP)))*(dL_VD_S+(((dL_VD_S*dL)+(dL*dL_VD_S))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
  GdL_VS_BP_VS_BP=(0.0/((1.0+dL)+(dL*dL))-(0.0*(dL_VS_BP+(((dL_VS_BP*dL)+(dL*dL_VS_BP))))+0.0*(dL_VS_BP+((dL_VS_BP*dL)+(dL*dL_VS_BP)))+1.0*(+(+0.0+dL_VS_BP_VS_BP)+(+dL_VS_BP_VS_BP*dL+dL_VS_BP*dL_VS_BP+dL_VS_BP*dL_VS_BP+dL*dL_VS_BP_VS_BP)))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))+2*1.0*(dL_VS_BP+((dL_VS_BP*dL)+(dL*dL_VS_BP)))*(dL_VS_BP+(((dL_VS_BP*dL)+(dL*dL_VS_BP))))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
#endif
#endif
GdL=(1.0/((1.0+dL)+(dL*dL)));
EXIT_IF_ISNAN((1.0/((1.0+dL)+(dL*dL))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
dL1_VGP_S=((dL_VGP_S+(pInst->ALP1_i*((((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S))*temp)+((qim1_1*r1)*temp_VGP_S))))+(pInst->ALP2_i*((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2)+((qbm*r2)*r2_VGP_S))*temp1)+(((qbm*r2)*r2)*temp1_VGP_S))));
#if defined(_DERIVATE2)
  dL1_VGP_S_VGP_S=(+(+dL_VGP_S_VGP_S+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S)))*temp)+((qim1_1*r1)*temp_VGP_S)))+0.0*((((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S))*temp)+((qim1_1*r1)*temp_VGP_S))+pInst->ALP1_i*(+(+qim1_1_VGP_S_VGP_S*r1+qim1_1_VGP_S*r1_VGP_S+qim1_1_VGP_S*r1_VGP_S+qim1_1*r1_VGP_S_VGP_S)*temp+((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S))*temp_VGP_S+(((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S)))*temp_VGP_S+(qim1_1*r1)*temp_VGP_S_VGP_S)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2)+((qbm*r2)*r2_VGP_S)))*temp1)+(((qbm*r2)*r2)*temp1_VGP_S)))+0.0*((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2)+((qbm*r2)*r2_VGP_S))*temp1)+(((qbm*r2)*r2)*temp1_VGP_S))+pInst->ALP2_i*(+(+(+qbm_VGP_S_VGP_S*r2+qbm_VGP_S*r2_VGP_S+qbm_VGP_S*r2_VGP_S+qbm*r2_VGP_S_VGP_S)*r2+((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2_VGP_S+(((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2_VGP_S+(qbm*r2)*r2_VGP_S_VGP_S)*temp1+((((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2)+((qbm*r2)*r2_VGP_S))*temp1_VGP_S+((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2)+((qbm*r2)*r2_VGP_S)))*temp1_VGP_S+((qbm*r2)*r2)*temp1_VGP_S_VGP_S)));
  dL1_VGP_S_VD_S=(+(+dL_VGP_S_VD_S+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S)))*temp)+((qim1_1*r1)*temp_VD_S)))+0.0*((((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S))*temp)+((qim1_1*r1)*temp_VGP_S))+pInst->ALP1_i*(+(+qim1_1_VGP_S_VD_S*r1+qim1_1_VGP_S*r1_VD_S+qim1_1_VD_S*r1_VGP_S+qim1_1*r1_VGP_S_VD_S)*temp+((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S))*temp_VD_S+(((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S)))*temp_VGP_S+(qim1_1*r1)*temp_VGP_S_VD_S)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2)+((qbm*r2)*r2_VD_S)))*temp1)+(((qbm*r2)*r2)*temp1_VD_S)))+0.0*((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2)+((qbm*r2)*r2_VGP_S))*temp1)+(((qbm*r2)*r2)*temp1_VGP_S))+pInst->ALP2_i*(+(+(+qbm_VGP_S_VD_S*r2+qbm_VGP_S*r2_VD_S+qbm_VD_S*r2_VGP_S+qbm*r2_VGP_S_VD_S)*r2+((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2_VD_S+(((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2_VGP_S+(qbm*r2)*r2_VGP_S_VD_S)*temp1+((((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2)+((qbm*r2)*r2_VGP_S))*temp1_VD_S+((((((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2)+((qbm*r2)*r2_VD_S)))*temp1_VGP_S+((qbm*r2)*r2)*temp1_VGP_S_VD_S)));
  dL1_VGP_S_VS_BP=(+(+dL_VGP_S_VS_BP+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP)))*temp)+((qim1_1*r1)*temp_VS_BP)))+0.0*((((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S))*temp)+((qim1_1*r1)*temp_VGP_S))+pInst->ALP1_i*(+(+qim1_1_VGP_S_VS_BP*r1+qim1_1_VGP_S*r1_VS_BP+qim1_1_VS_BP*r1_VGP_S+qim1_1*r1_VGP_S_VS_BP)*temp+((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S))*temp_VS_BP+(((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP)))*temp_VGP_S+(qim1_1*r1)*temp_VGP_S_VS_BP)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2)+((qbm*r2)*r2_VS_BP)))*temp1)+(((qbm*r2)*r2)*temp1_VS_BP)))+0.0*((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2)+((qbm*r2)*r2_VGP_S))*temp1)+(((qbm*r2)*r2)*temp1_VGP_S))+pInst->ALP2_i*(+(+(+qbm_VGP_S_VS_BP*r2+qbm_VGP_S*r2_VS_BP+qbm_VS_BP*r2_VGP_S+qbm*r2_VGP_S_VS_BP)*r2+((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2_VS_BP+(((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2_VGP_S+(qbm*r2)*r2_VGP_S_VS_BP)*temp1+((((qbm_VGP_S*r2)+(qbm*r2_VGP_S))*r2)+((qbm*r2)*r2_VGP_S))*temp1_VS_BP+((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2)+((qbm*r2)*r2_VS_BP)))*temp1_VGP_S+((qbm*r2)*r2)*temp1_VGP_S_VS_BP)));
#endif
dL1_VD_S=((dL_VD_S+(pInst->ALP1_i*((((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S))*temp)+((qim1_1*r1)*temp_VD_S))))+(pInst->ALP2_i*((((((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2)+((qbm*r2)*r2_VD_S))*temp1)+(((qbm*r2)*r2)*temp1_VD_S))));
#if defined(_DERIVATE2)
  dL1_VD_S_VGP_S=(+(+dL_VD_S_VGP_S+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S)))*temp)+((qim1_1*r1)*temp_VGP_S)))+0.0*((((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S))*temp)+((qim1_1*r1)*temp_VD_S))+pInst->ALP1_i*(+(+qim1_1_VD_S_VGP_S*r1+qim1_1_VD_S*r1_VGP_S+qim1_1_VGP_S*r1_VD_S+qim1_1*r1_VD_S_VGP_S)*temp+((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S))*temp_VGP_S+(((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S)))*temp_VD_S+(qim1_1*r1)*temp_VD_S_VGP_S)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2)+((qbm*r2)*r2_VGP_S)))*temp1)+(((qbm*r2)*r2)*temp1_VGP_S)))+0.0*((((((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2)+((qbm*r2)*r2_VD_S))*temp1)+(((qbm*r2)*r2)*temp1_VD_S))+pInst->ALP2_i*(+(+(+qbm_VD_S_VGP_S*r2+qbm_VD_S*r2_VGP_S+qbm_VGP_S*r2_VD_S+qbm*r2_VD_S_VGP_S)*r2+((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2_VGP_S+(((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2_VD_S+(qbm*r2)*r2_VD_S_VGP_S)*temp1+((((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2)+((qbm*r2)*r2_VD_S))*temp1_VGP_S+((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2)+((qbm*r2)*r2_VGP_S)))*temp1_VD_S+((qbm*r2)*r2)*temp1_VD_S_VGP_S)));
  dL1_VD_S_VD_S=(+(+dL_VD_S_VD_S+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S)))*temp)+((qim1_1*r1)*temp_VD_S)))+0.0*((((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S))*temp)+((qim1_1*r1)*temp_VD_S))+pInst->ALP1_i*(+(+qim1_1_VD_S_VD_S*r1+qim1_1_VD_S*r1_VD_S+qim1_1_VD_S*r1_VD_S+qim1_1*r1_VD_S_VD_S)*temp+((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S))*temp_VD_S+(((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S)))*temp_VD_S+(qim1_1*r1)*temp_VD_S_VD_S)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2)+((qbm*r2)*r2_VD_S)))*temp1)+(((qbm*r2)*r2)*temp1_VD_S)))+0.0*((((((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2)+((qbm*r2)*r2_VD_S))*temp1)+(((qbm*r2)*r2)*temp1_VD_S))+pInst->ALP2_i*(+(+(+qbm_VD_S_VD_S*r2+qbm_VD_S*r2_VD_S+qbm_VD_S*r2_VD_S+qbm*r2_VD_S_VD_S)*r2+((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2_VD_S+(((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2_VD_S+(qbm*r2)*r2_VD_S_VD_S)*temp1+((((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2)+((qbm*r2)*r2_VD_S))*temp1_VD_S+((((((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2)+((qbm*r2)*r2_VD_S)))*temp1_VD_S+((qbm*r2)*r2)*temp1_VD_S_VD_S)));
  dL1_VD_S_VS_BP=(+(+dL_VD_S_VS_BP+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP)))*temp)+((qim1_1*r1)*temp_VS_BP)))+0.0*((((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S))*temp)+((qim1_1*r1)*temp_VD_S))+pInst->ALP1_i*(+(+qim1_1_VD_S_VS_BP*r1+qim1_1_VD_S*r1_VS_BP+qim1_1_VS_BP*r1_VD_S+qim1_1*r1_VD_S_VS_BP)*temp+((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S))*temp_VS_BP+(((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP)))*temp_VD_S+(qim1_1*r1)*temp_VD_S_VS_BP)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2)+((qbm*r2)*r2_VS_BP)))*temp1)+(((qbm*r2)*r2)*temp1_VS_BP)))+0.0*((((((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2)+((qbm*r2)*r2_VD_S))*temp1)+(((qbm*r2)*r2)*temp1_VD_S))+pInst->ALP2_i*(+(+(+qbm_VD_S_VS_BP*r2+qbm_VD_S*r2_VS_BP+qbm_VS_BP*r2_VD_S+qbm*r2_VD_S_VS_BP)*r2+((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2_VS_BP+(((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2_VD_S+(qbm*r2)*r2_VD_S_VS_BP)*temp1+((((qbm_VD_S*r2)+(qbm*r2_VD_S))*r2)+((qbm*r2)*r2_VD_S))*temp1_VS_BP+((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2)+((qbm*r2)*r2_VS_BP)))*temp1_VD_S+((qbm*r2)*r2)*temp1_VD_S_VS_BP)));
#endif
dL1_VS_BP=((dL_VS_BP+(pInst->ALP1_i*((((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP))*temp)+((qim1_1*r1)*temp_VS_BP))))+(pInst->ALP2_i*((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2)+((qbm*r2)*r2_VS_BP))*temp1)+(((qbm*r2)*r2)*temp1_VS_BP))));
#if defined(_DERIVATE2)
  dL1_VS_BP_VGP_S=(+(+dL_VS_BP_VGP_S+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S)))*temp)+((qim1_1*r1)*temp_VGP_S)))+0.0*((((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP))*temp)+((qim1_1*r1)*temp_VS_BP))+pInst->ALP1_i*(+(+qim1_1_VS_BP_VGP_S*r1+qim1_1_VS_BP*r1_VGP_S+qim1_1_VGP_S*r1_VS_BP+qim1_1*r1_VS_BP_VGP_S)*temp+((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP))*temp_VGP_S+(((qim1_1_VGP_S*r1)+(qim1_1*r1_VGP_S)))*temp_VS_BP+(qim1_1*r1)*temp_VS_BP_VGP_S)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2)+((qbm*r2)*r2_VGP_S)))*temp1)+(((qbm*r2)*r2)*temp1_VGP_S)))+0.0*((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2)+((qbm*r2)*r2_VS_BP))*temp1)+(((qbm*r2)*r2)*temp1_VS_BP))+pInst->ALP2_i*(+(+(+qbm_VS_BP_VGP_S*r2+qbm_VS_BP*r2_VGP_S+qbm_VGP_S*r2_VS_BP+qbm*r2_VS_BP_VGP_S)*r2+((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2_VGP_S+(((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2_VS_BP+(qbm*r2)*r2_VS_BP_VGP_S)*temp1+((((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2)+((qbm*r2)*r2_VS_BP))*temp1_VGP_S+((((((qbm_VGP_S*r2)+(qbm*r2_VGP_S)))*r2)+((qbm*r2)*r2_VGP_S)))*temp1_VS_BP+((qbm*r2)*r2)*temp1_VS_BP_VGP_S)));
  dL1_VS_BP_VD_S=(+(+dL_VS_BP_VD_S+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S)))*temp)+((qim1_1*r1)*temp_VD_S)))+0.0*((((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP))*temp)+((qim1_1*r1)*temp_VS_BP))+pInst->ALP1_i*(+(+qim1_1_VS_BP_VD_S*r1+qim1_1_VS_BP*r1_VD_S+qim1_1_VD_S*r1_VS_BP+qim1_1*r1_VS_BP_VD_S)*temp+((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP))*temp_VD_S+(((qim1_1_VD_S*r1)+(qim1_1*r1_VD_S)))*temp_VS_BP+(qim1_1*r1)*temp_VS_BP_VD_S)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2)+((qbm*r2)*r2_VD_S)))*temp1)+(((qbm*r2)*r2)*temp1_VD_S)))+0.0*((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2)+((qbm*r2)*r2_VS_BP))*temp1)+(((qbm*r2)*r2)*temp1_VS_BP))+pInst->ALP2_i*(+(+(+qbm_VS_BP_VD_S*r2+qbm_VS_BP*r2_VD_S+qbm_VD_S*r2_VS_BP+qbm*r2_VS_BP_VD_S)*r2+((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2_VD_S+(((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2_VS_BP+(qbm*r2)*r2_VS_BP_VD_S)*temp1+((((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2)+((qbm*r2)*r2_VS_BP))*temp1_VD_S+((((((qbm_VD_S*r2)+(qbm*r2_VD_S)))*r2)+((qbm*r2)*r2_VD_S)))*temp1_VS_BP+((qbm*r2)*r2)*temp1_VS_BP_VD_S)));
  dL1_VS_BP_VS_BP=(+(+dL_VS_BP_VS_BP+(+0.0*((qim1_1*r1)*temp)+0.0*((((((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP)))*temp)+((qim1_1*r1)*temp_VS_BP)))+0.0*((((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP))*temp)+((qim1_1*r1)*temp_VS_BP))+pInst->ALP1_i*(+(+qim1_1_VS_BP_VS_BP*r1+qim1_1_VS_BP*r1_VS_BP+qim1_1_VS_BP*r1_VS_BP+qim1_1*r1_VS_BP_VS_BP)*temp+((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP))*temp_VS_BP+(((qim1_1_VS_BP*r1)+(qim1_1*r1_VS_BP)))*temp_VS_BP+(qim1_1*r1)*temp_VS_BP_VS_BP)))+(+0.0*(((qbm*r2)*r2)*temp1)+0.0*(((((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2)+((qbm*r2)*r2_VS_BP)))*temp1)+(((qbm*r2)*r2)*temp1_VS_BP)))+0.0*((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2)+((qbm*r2)*r2_VS_BP))*temp1)+(((qbm*r2)*r2)*temp1_VS_BP))+pInst->ALP2_i*(+(+(+qbm_VS_BP_VS_BP*r2+qbm_VS_BP*r2_VS_BP+qbm_VS_BP*r2_VS_BP+qbm*r2_VS_BP_VS_BP)*r2+((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2_VS_BP+(((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2_VS_BP+(qbm*r2)*r2_VS_BP_VS_BP)*temp1+((((qbm_VS_BP*r2)+(qbm*r2_VS_BP))*r2)+((qbm*r2)*r2_VS_BP))*temp1_VS_BP+((((((qbm_VS_BP*r2)+(qbm*r2_VS_BP)))*r2)+((qbm*r2)*r2_VS_BP)))*temp1_VS_BP+((qbm*r2)*r2)*temp1_VS_BP_VS_BP)));
#endif
#endif
dL1=((dL+(pInst->ALP1_i*((qim1_1*r1)*temp)))+(pInst->ALP2_i*(((qbm*r2)*r2)*temp1)));
EXIT_IF_ISNAN(((dL+(pInst->ALP1_i*((qim1_1*r1)*temp)))+(pInst->ALP2_i*(((qbm*r2)*r2)*temp1))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
FdL_VGP_S=(((dL1_VGP_S+((dL1_VGP_S*dL1)+(dL1*dL1_VGP_S)))*GdL)+(((1.0+dL1)+(dL1*dL1))*GdL_VGP_S));
#if defined(_DERIVATE2)
  FdL_VGP_S_VGP_S=(+(+(+0.0+dL1_VGP_S_VGP_S)+(+dL1_VGP_S_VGP_S*dL1+dL1_VGP_S*dL1_VGP_S+dL1_VGP_S*dL1_VGP_S+dL1*dL1_VGP_S_VGP_S))*GdL+(dL1_VGP_S+((dL1_VGP_S*dL1)+(dL1*dL1_VGP_S)))*GdL_VGP_S+(dL1_VGP_S+(((dL1_VGP_S*dL1)+(dL1*dL1_VGP_S))))*GdL_VGP_S+((1.0+dL1)+(dL1*dL1))*GdL_VGP_S_VGP_S);
  FdL_VGP_S_VD_S=(+(+(+0.0+dL1_VGP_S_VD_S)+(+dL1_VGP_S_VD_S*dL1+dL1_VGP_S*dL1_VD_S+dL1_VD_S*dL1_VGP_S+dL1*dL1_VGP_S_VD_S))*GdL+(dL1_VGP_S+((dL1_VGP_S*dL1)+(dL1*dL1_VGP_S)))*GdL_VD_S+(dL1_VD_S+(((dL1_VD_S*dL1)+(dL1*dL1_VD_S))))*GdL_VGP_S+((1.0+dL1)+(dL1*dL1))*GdL_VGP_S_VD_S);
  FdL_VGP_S_VS_BP=(+(+(+0.0+dL1_VGP_S_VS_BP)+(+dL1_VGP_S_VS_BP*dL1+dL1_VGP_S*dL1_VS_BP+dL1_VS_BP*dL1_VGP_S+dL1*dL1_VGP_S_VS_BP))*GdL+(dL1_VGP_S+((dL1_VGP_S*dL1)+(dL1*dL1_VGP_S)))*GdL_VS_BP+(dL1_VS_BP+(((dL1_VS_BP*dL1)+(dL1*dL1_VS_BP))))*GdL_VGP_S+((1.0+dL1)+(dL1*dL1))*GdL_VGP_S_VS_BP);
#endif
FdL_VD_S=(((dL1_VD_S+((dL1_VD_S*dL1)+(dL1*dL1_VD_S)))*GdL)+(((1.0+dL1)+(dL1*dL1))*GdL_VD_S));
#if defined(_DERIVATE2)
  FdL_VD_S_VGP_S=(+(+(+0.0+dL1_VD_S_VGP_S)+(+dL1_VD_S_VGP_S*dL1+dL1_VD_S*dL1_VGP_S+dL1_VGP_S*dL1_VD_S+dL1*dL1_VD_S_VGP_S))*GdL+(dL1_VD_S+((dL1_VD_S*dL1)+(dL1*dL1_VD_S)))*GdL_VGP_S+(dL1_VGP_S+(((dL1_VGP_S*dL1)+(dL1*dL1_VGP_S))))*GdL_VD_S+((1.0+dL1)+(dL1*dL1))*GdL_VD_S_VGP_S);
  FdL_VD_S_VD_S=(+(+(+0.0+dL1_VD_S_VD_S)+(+dL1_VD_S_VD_S*dL1+dL1_VD_S*dL1_VD_S+dL1_VD_S*dL1_VD_S+dL1*dL1_VD_S_VD_S))*GdL+(dL1_VD_S+((dL1_VD_S*dL1)+(dL1*dL1_VD_S)))*GdL_VD_S+(dL1_VD_S+(((dL1_VD_S*dL1)+(dL1*dL1_VD_S))))*GdL_VD_S+((1.0+dL1)+(dL1*dL1))*GdL_VD_S_VD_S);
  FdL_VD_S_VS_BP=(+(+(+0.0+dL1_VD_S_VS_BP)+(+dL1_VD_S_VS_BP*dL1+dL1_VD_S*dL1_VS_BP+dL1_VS_BP*dL1_VD_S+dL1*dL1_VD_S_VS_BP))*GdL+(dL1_VD_S+((dL1_VD_S*dL1)+(dL1*dL1_VD_S)))*GdL_VS_BP+(dL1_VS_BP+(((dL1_VS_BP*dL1)+(dL1*dL1_VS_BP))))*GdL_VD_S+((1.0+dL1)+(dL1*dL1))*GdL_VD_S_VS_BP);
#endif
FdL_VS_BP=(((dL1_VS_BP+((dL1_VS_BP*dL1)+(dL1*dL1_VS_BP)))*GdL)+(((1.0+dL1)+(dL1*dL1))*GdL_VS_BP));
#if defined(_DERIVATE2)
  FdL_VS_BP_VGP_S=(+(+(+0.0+dL1_VS_BP_VGP_S)+(+dL1_VS_BP_VGP_S*dL1+dL1_VS_BP*dL1_VGP_S+dL1_VGP_S*dL1_VS_BP+dL1*dL1_VS_BP_VGP_S))*GdL+(dL1_VS_BP+((dL1_VS_BP*dL1)+(dL1*dL1_VS_BP)))*GdL_VGP_S+(dL1_VGP_S+(((dL1_VGP_S*dL1)+(dL1*dL1_VGP_S))))*GdL_VS_BP+((1.0+dL1)+(dL1*dL1))*GdL_VS_BP_VGP_S);
  FdL_VS_BP_VD_S=(+(+(+0.0+dL1_VS_BP_VD_S)+(+dL1_VS_BP_VD_S*dL1+dL1_VS_BP*dL1_VD_S+dL1_VD_S*dL1_VS_BP+dL1*dL1_VS_BP_VD_S))*GdL+(dL1_VS_BP+((dL1_VS_BP*dL1)+(dL1*dL1_VS_BP)))*GdL_VD_S+(dL1_VD_S+(((dL1_VD_S*dL1)+(dL1*dL1_VD_S))))*GdL_VS_BP+((1.0+dL1)+(dL1*dL1))*GdL_VS_BP_VD_S);
  FdL_VS_BP_VS_BP=(+(+(+0.0+dL1_VS_BP_VS_BP)+(+dL1_VS_BP_VS_BP*dL1+dL1_VS_BP*dL1_VS_BP+dL1_VS_BP*dL1_VS_BP+dL1*dL1_VS_BP_VS_BP))*GdL+(dL1_VS_BP+((dL1_VS_BP*dL1)+(dL1*dL1_VS_BP)))*GdL_VS_BP+(dL1_VS_BP+(((dL1_VS_BP*dL1)+(dL1*dL1_VS_BP))))*GdL_VS_BP+((1.0+dL1)+(dL1*dL1))*GdL_VS_BP_VS_BP);
#endif
#endif
pInst->FdL=(((1.0+dL1)+(dL1*dL1))*GdL);
EXIT_IF_ISNAN((((1.0+dL1)+(dL1*dL1))*GdL))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp2_VD_S=((qim_VD_S*pInst->xitsb)+(pInst->qim*xitsb_VD_S));
#if defined(_DERIVATE2)
  temp2_VD_S_VD_S=(+qim_VD_S_VD_S*pInst->xitsb+qim_VD_S*xitsb_VD_S+qim_VD_S*xitsb_VD_S+pInst->qim*xitsb_VD_S_VD_S);
  temp2_VD_S_VGP_S=(+qim_VD_S_VGP_S*pInst->xitsb+qim_VD_S*0.0+qim_VGP_S*xitsb_VD_S+pInst->qim*0.0);
  temp2_VD_S_VS_BP=(+qim_VD_S_VS_BP*pInst->xitsb+qim_VD_S*xitsb_VS_BP+qim_VS_BP*xitsb_VD_S+pInst->qim*xitsb_VD_S_VS_BP);
#endif
temp2_VGP_S=qim_VGP_S*pInst->xitsb;
#if defined(_DERIVATE2)
  temp2_VGP_S_VD_S=(+qim_VGP_S_VD_S*pInst->xitsb+qim_VGP_S*xitsb_VD_S+qim_VD_S*0.0+pInst->qim*0.0);
  temp2_VGP_S_VGP_S=(+qim_VGP_S_VGP_S*pInst->xitsb+qim_VGP_S*0.0+qim_VGP_S*0.0+pInst->qim*0.0);
  temp2_VGP_S_VS_BP=(+qim_VGP_S_VS_BP*pInst->xitsb+qim_VGP_S*xitsb_VS_BP+qim_VS_BP*0.0+pInst->qim*0.0);
#endif
temp2_VS_BP=((qim_VS_BP*pInst->xitsb)+(pInst->qim*xitsb_VS_BP));
#if defined(_DERIVATE2)
  temp2_VS_BP_VD_S=(+qim_VS_BP_VD_S*pInst->xitsb+qim_VS_BP*xitsb_VD_S+qim_VD_S*xitsb_VS_BP+pInst->qim*xitsb_VS_BP_VD_S);
  temp2_VS_BP_VGP_S=(+qim_VS_BP_VGP_S*pInst->xitsb+qim_VS_BP*0.0+qim_VGP_S*xitsb_VS_BP+pInst->qim*0.0);
  temp2_VS_BP_VS_BP=(+qim_VS_BP_VS_BP*pInst->xitsb+qim_VS_BP*xitsb_VS_BP+qim_VS_BP*xitsb_VS_BP+pInst->qim*xitsb_VS_BP_VS_BP);
#endif
#endif
temp2=(pInst->qim*pInst->xitsb);
EXIT_IF_ISNAN((pInst->qim*pInst->xitsb))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
wsat_VD_S=(100.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2)));
#if defined(_DERIVATE2)
  wsat_VD_S_VD_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VD_S_VD_S/(100.0+temp2)-(temp2_VD_S*temp2_VD_S+temp2_VD_S*temp2_VD_S+temp2*(+0.0+temp2_VD_S_VD_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VD_S*temp2_VD_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VD_S_VGP_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VD_S_VGP_S/(100.0+temp2)-(temp2_VD_S*temp2_VGP_S+temp2_VGP_S*temp2_VD_S+temp2*(+0.0+temp2_VD_S_VGP_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VD_S*temp2_VGP_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VD_S_VS_BP=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VD_S_VS_BP/(100.0+temp2)-(temp2_VD_S*temp2_VS_BP+temp2_VS_BP*temp2_VD_S+temp2*(+0.0+temp2_VD_S_VS_BP))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VD_S*temp2_VS_BP/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
#endif
wsat_VGP_S=(100.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2)));
#if defined(_DERIVATE2)
  wsat_VGP_S_VD_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VGP_S_VD_S/(100.0+temp2)-(temp2_VGP_S*temp2_VD_S+temp2_VD_S*temp2_VGP_S+temp2*(+0.0+temp2_VGP_S_VD_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VGP_S*temp2_VD_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VGP_S_VGP_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VGP_S_VGP_S/(100.0+temp2)-(temp2_VGP_S*temp2_VGP_S+temp2_VGP_S*temp2_VGP_S+temp2*(+0.0+temp2_VGP_S_VGP_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VGP_S*temp2_VGP_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VGP_S_VS_BP=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VGP_S_VS_BP/(100.0+temp2)-(temp2_VGP_S*temp2_VS_BP+temp2_VS_BP*temp2_VGP_S+temp2*(+0.0+temp2_VGP_S_VS_BP))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VGP_S*temp2_VS_BP/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
#endif
wsat_VS_BP=(100.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2)));
#if defined(_DERIVATE2)
  wsat_VS_BP_VD_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VD_S*(100.0+temp2)-temp2*temp2_VD_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VS_BP_VD_S/(100.0+temp2)-(temp2_VS_BP*temp2_VD_S+temp2_VD_S*temp2_VS_BP+temp2*(+0.0+temp2_VS_BP_VD_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VS_BP*temp2_VD_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VS_BP_VGP_S=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VGP_S*(100.0+temp2)-temp2*temp2_VGP_S)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VS_BP_VGP_S/(100.0+temp2)-(temp2_VS_BP*temp2_VGP_S+temp2_VGP_S*temp2_VS_BP+temp2*(+0.0+temp2_VS_BP_VGP_S))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VS_BP*temp2_VGP_S/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
  wsat_VS_BP_VS_BP=(+0.0*(temp2/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+0.0*((temp2_VS_BP*(100.0+temp2)-temp2*temp2_VS_BP)/(100.0+temp2)/(100.0+temp2))+100.0*(temp2_VS_BP_VS_BP/(100.0+temp2)-(temp2_VS_BP*temp2_VS_BP+temp2_VS_BP*temp2_VS_BP+temp2*(+0.0+temp2_VS_BP_VS_BP))/(100.0+temp2)/(100.0+temp2)+2*temp2*temp2_VS_BP*temp2_VS_BP/(100.0+temp2)/(100.0+temp2)/(100.0+temp2)));
#endif
#endif
wsat=(100.0*(temp2/(100.0+temp2)));
EXIT_IF_ISNAN((100.0*(temp2/(100.0+temp2))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Gmob_dL_VD_S=((Gmob_VD_S*GdL)+(pInst->Gmob*GdL_VD_S));
#if defined(_DERIVATE2)
  Gmob_dL_VD_S_VD_S=(+Gmob_VD_S_VD_S*GdL+Gmob_VD_S*GdL_VD_S+Gmob_VD_S*GdL_VD_S+pInst->Gmob*GdL_VD_S_VD_S);
  Gmob_dL_VD_S_VGP_S=(+Gmob_VD_S_VGP_S*GdL+Gmob_VD_S*GdL_VGP_S+Gmob_VGP_S*GdL_VD_S+pInst->Gmob*GdL_VD_S_VGP_S);
  Gmob_dL_VD_S_VS_BP=(+Gmob_VD_S_VS_BP*GdL+Gmob_VD_S*GdL_VS_BP+Gmob_VS_BP*GdL_VD_S+pInst->Gmob*GdL_VD_S_VS_BP);
#endif
Gmob_dL_VGP_S=((Gmob_VGP_S*GdL)+(pInst->Gmob*GdL_VGP_S));
#if defined(_DERIVATE2)
  Gmob_dL_VGP_S_VD_S=(+Gmob_VGP_S_VD_S*GdL+Gmob_VGP_S*GdL_VD_S+Gmob_VD_S*GdL_VGP_S+pInst->Gmob*GdL_VGP_S_VD_S);
  Gmob_dL_VGP_S_VGP_S=(+Gmob_VGP_S_VGP_S*GdL+Gmob_VGP_S*GdL_VGP_S+Gmob_VGP_S*GdL_VGP_S+pInst->Gmob*GdL_VGP_S_VGP_S);
  Gmob_dL_VGP_S_VS_BP=(+Gmob_VGP_S_VS_BP*GdL+Gmob_VGP_S*GdL_VS_BP+Gmob_VS_BP*GdL_VGP_S+pInst->Gmob*GdL_VGP_S_VS_BP);
#endif
Gmob_dL_VS_BP=((Gmob_VS_BP*GdL)+(pInst->Gmob*GdL_VS_BP));
#if defined(_DERIVATE2)
  Gmob_dL_VS_BP_VD_S=(+Gmob_VS_BP_VD_S*GdL+Gmob_VS_BP*GdL_VD_S+Gmob_VD_S*GdL_VS_BP+pInst->Gmob*GdL_VS_BP_VD_S);
  Gmob_dL_VS_BP_VGP_S=(+Gmob_VS_BP_VGP_S*GdL+Gmob_VS_BP*GdL_VGP_S+Gmob_VGP_S*GdL_VS_BP+pInst->Gmob*GdL_VS_BP_VGP_S);
  Gmob_dL_VS_BP_VS_BP=(+Gmob_VS_BP_VS_BP*GdL+Gmob_VS_BP*GdL_VS_BP+Gmob_VS_BP*GdL_VS_BP+pInst->Gmob*GdL_VS_BP_VS_BP);
#endif
#endif
pInst->Gmob_dL=(pInst->Gmob*GdL);
EXIT_IF_ISNAN((pInst->Gmob*GdL))
if
((pInst->THESATG_i<0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-1*(-(pInst->THESATG_i*wsat_VGP_S))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VGP_S+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VGP_S_VS_BS=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VGP_S+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VGP_S_VGP_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VGP_S)))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-((pInst->THESATG_i*wsat_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VGP_S_VD_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VD_S)))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-((pInst->THESATG_i*wsat_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VGP_S_VS_BP=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VS_BP)))+0.0*(-(pInst->THESATG_i*wsat_VGP_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VGP_S))*(-((pInst->THESATG_i*wsat_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#endif
temp_VD_S=(-1*(-(pInst->THESATG_i*wsat_VD_S))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VD_S+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VD_S_VS_BS=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VD_S+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VD_S_VGP_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VGP_S)))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-((pInst->THESATG_i*wsat_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VD_S_VD_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VD_S)))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-((pInst->THESATG_i*wsat_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VD_S_VS_BP=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VS_BP)))+0.0*(-(pInst->THESATG_i*wsat_VD_S))+1*(+0.0-(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VD_S))*(-((pInst->THESATG_i*wsat_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#endif
temp_VS_BP=(-1*(-(pInst->THESATG_i*wsat_VS_BP))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VS_BP+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VS_BP_VS_BS=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-(0.0))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*0.0+0.0*wsat_VS_BP+pInst->THESATG_i*0.0)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-(0.0))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VS_BP_VGP_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VGP_S)))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-((pInst->THESATG_i*wsat_VGP_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VS_BP_VD_S=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VD_S)))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-((pInst->THESATG_i*wsat_VD_S)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
  temp_VS_BP_VS_BP=(0.0/(1-(pInst->THESATG_i*wsat))-(0.0*(-((pInst->THESATG_i*wsat_VS_BP)))+0.0*(-(pInst->THESATG_i*wsat_VS_BP))+1*(+0.0-(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))+2*1*(-(pInst->THESATG_i*wsat_VS_BP))*(-((pInst->THESATG_i*wsat_VS_BP)))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat))/(1-(pInst->THESATG_i*wsat)));
#endif
#endif
temp=(1/(1-(pInst->THESATG_i*wsat)));
EXIT_IF_ISNAN((1/(1-(pInst->THESATG_i*wsat))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(pInst->THESATG_i*wsat_VGP_S);
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VGP_S+pInst->THESATG_i*0.0));
  temp_VGP_S_VS_BS=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VGP_S+pInst->THESATG_i*0.0));
  temp_VGP_S_VGP_S=(+0.0+(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VGP_S));
  temp_VGP_S_VD_S=(+0.0+(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VD_S));
  temp_VGP_S_VS_BP=(+0.0+(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VGP_S+pInst->THESATG_i*wsat_VGP_S_VS_BP));
#endif
temp_VD_S=(pInst->THESATG_i*wsat_VD_S);
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VD_S+pInst->THESATG_i*0.0));
  temp_VD_S_VS_BS=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VD_S+pInst->THESATG_i*0.0));
  temp_VD_S_VGP_S=(+0.0+(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VGP_S));
  temp_VD_S_VD_S=(+0.0+(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VD_S));
  temp_VD_S_VS_BP=(+0.0+(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VD_S+pInst->THESATG_i*wsat_VD_S_VS_BP));
#endif
temp_VS_BP=(pInst->THESATG_i*wsat_VS_BP);
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VS_BP+pInst->THESATG_i*0.0));
  temp_VS_BP_VS_BS=(+0.0+(+0.0*wsat+0.0*0.0+0.0*wsat_VS_BP+pInst->THESATG_i*0.0));
  temp_VS_BP_VGP_S=(+0.0+(+0.0*wsat+0.0*wsat_VGP_S+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VGP_S));
  temp_VS_BP_VD_S=(+0.0+(+0.0*wsat+0.0*wsat_VD_S+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VD_S));
  temp_VS_BP_VS_BP=(+0.0+(+0.0*wsat+0.0*wsat_VS_BP+0.0*wsat_VS_BP+pInst->THESATG_i*wsat_VS_BP_VS_BP));
#endif
#endif
temp=(1+(pInst->THESATG_i*wsat));
EXIT_IF_ISNAN((1+(pInst->THESATG_i*wsat)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
thesat1_VGP_S=(pInst->THESAT_i*((temp_VGP_S*pInst->Gmob_dL-temp*Gmob_dL_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL));
#if defined(_DERIVATE2)
  thesat1_VGP_S_VGP_S=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VGP_S*pInst->Gmob_dL-temp*Gmob_dL_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VGP_S*pInst->Gmob_dL-temp*Gmob_dL_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VGP_S_VGP_S/pInst->Gmob_dL-(temp_VGP_S*Gmob_dL_VGP_S+temp_VGP_S*Gmob_dL_VGP_S+temp*Gmob_dL_VGP_S_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VGP_S*Gmob_dL_VGP_S/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
  thesat1_VGP_S_VD_S=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VD_S*pInst->Gmob_dL-temp*Gmob_dL_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VGP_S*pInst->Gmob_dL-temp*Gmob_dL_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VGP_S_VD_S/pInst->Gmob_dL-(temp_VGP_S*Gmob_dL_VD_S+temp_VD_S*Gmob_dL_VGP_S+temp*Gmob_dL_VGP_S_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VGP_S*Gmob_dL_VD_S/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
  thesat1_VGP_S_VS_BP=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VS_BP*pInst->Gmob_dL-temp*Gmob_dL_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VGP_S*pInst->Gmob_dL-temp*Gmob_dL_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VGP_S_VS_BP/pInst->Gmob_dL-(temp_VGP_S*Gmob_dL_VS_BP+temp_VS_BP*Gmob_dL_VGP_S+temp*Gmob_dL_VGP_S_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VGP_S*Gmob_dL_VS_BP/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
#endif
thesat1_VD_S=(pInst->THESAT_i*((temp_VD_S*pInst->Gmob_dL-temp*Gmob_dL_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL));
#if defined(_DERIVATE2)
  thesat1_VD_S_VGP_S=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VGP_S*pInst->Gmob_dL-temp*Gmob_dL_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VD_S*pInst->Gmob_dL-temp*Gmob_dL_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VD_S_VGP_S/pInst->Gmob_dL-(temp_VD_S*Gmob_dL_VGP_S+temp_VGP_S*Gmob_dL_VD_S+temp*Gmob_dL_VD_S_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VD_S*Gmob_dL_VGP_S/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
  thesat1_VD_S_VD_S=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VD_S*pInst->Gmob_dL-temp*Gmob_dL_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VD_S*pInst->Gmob_dL-temp*Gmob_dL_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VD_S_VD_S/pInst->Gmob_dL-(temp_VD_S*Gmob_dL_VD_S+temp_VD_S*Gmob_dL_VD_S+temp*Gmob_dL_VD_S_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VD_S*Gmob_dL_VD_S/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
  thesat1_VD_S_VS_BP=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VS_BP*pInst->Gmob_dL-temp*Gmob_dL_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VD_S*pInst->Gmob_dL-temp*Gmob_dL_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VD_S_VS_BP/pInst->Gmob_dL-(temp_VD_S*Gmob_dL_VS_BP+temp_VS_BP*Gmob_dL_VD_S+temp*Gmob_dL_VD_S_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VD_S*Gmob_dL_VS_BP/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
#endif
thesat1_VS_BP=(pInst->THESAT_i*((temp_VS_BP*pInst->Gmob_dL-temp*Gmob_dL_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL));
#if defined(_DERIVATE2)
  thesat1_VS_BP_VGP_S=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VGP_S*pInst->Gmob_dL-temp*Gmob_dL_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VS_BP*pInst->Gmob_dL-temp*Gmob_dL_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VS_BP_VGP_S/pInst->Gmob_dL-(temp_VS_BP*Gmob_dL_VGP_S+temp_VGP_S*Gmob_dL_VS_BP+temp*Gmob_dL_VS_BP_VGP_S)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VS_BP*Gmob_dL_VGP_S/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
  thesat1_VS_BP_VD_S=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VD_S*pInst->Gmob_dL-temp*Gmob_dL_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VS_BP*pInst->Gmob_dL-temp*Gmob_dL_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VS_BP_VD_S/pInst->Gmob_dL-(temp_VS_BP*Gmob_dL_VD_S+temp_VD_S*Gmob_dL_VS_BP+temp*Gmob_dL_VS_BP_VD_S)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VS_BP*Gmob_dL_VD_S/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
  thesat1_VS_BP_VS_BP=(+0.0*(temp/pInst->Gmob_dL)+0.0*((temp_VS_BP*pInst->Gmob_dL-temp*Gmob_dL_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL)+0.0*((temp_VS_BP*pInst->Gmob_dL-temp*Gmob_dL_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL)+pInst->THESAT_i*(temp_VS_BP_VS_BP/pInst->Gmob_dL-(temp_VS_BP*Gmob_dL_VS_BP+temp_VS_BP*Gmob_dL_VS_BP+temp*Gmob_dL_VS_BP_VS_BP)/pInst->Gmob_dL/pInst->Gmob_dL+2*temp*Gmob_dL_VS_BP*Gmob_dL_VS_BP/pInst->Gmob_dL/pInst->Gmob_dL/pInst->Gmob_dL));
#endif
#endif
thesat1=(pInst->THESAT_i*(temp/pInst->Gmob_dL));
EXIT_IF_ISNAN((pInst->THESAT_i*(temp/pInst->Gmob_dL)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
zsat_VGP_S=((((((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S))*pInst->dps)+((thesat1*thesat1)*dps_VGP_S))*pInst->dps)+(((thesat1*thesat1)*pInst->dps)*dps_VGP_S));
#if defined(_DERIVATE2)
  zsat_VGP_S_VGP_S=(+(+(+thesat1_VGP_S_VGP_S*thesat1+thesat1_VGP_S*thesat1_VGP_S+thesat1_VGP_S*thesat1_VGP_S+thesat1*thesat1_VGP_S_VGP_S)*pInst->dps+((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S))*dps_VGP_S+(((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S)))*dps_VGP_S+(thesat1*thesat1)*dps_VGP_S_VGP_S)*pInst->dps+((((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S))*pInst->dps)+((thesat1*thesat1)*dps_VGP_S))*dps_VGP_S+((((((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S)))*pInst->dps)+((thesat1*thesat1)*dps_VGP_S)))*dps_VGP_S+((thesat1*thesat1)*pInst->dps)*dps_VGP_S_VGP_S);
  zsat_VGP_S_VD_S=(+(+(+thesat1_VGP_S_VD_S*thesat1+thesat1_VGP_S*thesat1_VD_S+thesat1_VD_S*thesat1_VGP_S+thesat1*thesat1_VGP_S_VD_S)*pInst->dps+((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S))*dps_VD_S+(((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S)))*dps_VGP_S+(thesat1*thesat1)*dps_VGP_S_VD_S)*pInst->dps+((((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S))*pInst->dps)+((thesat1*thesat1)*dps_VGP_S))*dps_VD_S+((((((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S)))*pInst->dps)+((thesat1*thesat1)*dps_VD_S)))*dps_VGP_S+((thesat1*thesat1)*pInst->dps)*dps_VGP_S_VD_S);
  zsat_VGP_S_VS_BP=(+(+(+thesat1_VGP_S_VS_BP*thesat1+thesat1_VGP_S*thesat1_VS_BP+thesat1_VS_BP*thesat1_VGP_S+thesat1*thesat1_VGP_S_VS_BP)*pInst->dps+((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S))*dps_VS_BP+(((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP)))*dps_VGP_S+(thesat1*thesat1)*dps_VGP_S_VS_BP)*pInst->dps+((((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S))*pInst->dps)+((thesat1*thesat1)*dps_VGP_S))*dps_VS_BP+((((((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP)))*pInst->dps)+((thesat1*thesat1)*dps_VS_BP)))*dps_VGP_S+((thesat1*thesat1)*pInst->dps)*dps_VGP_S_VS_BP);
#endif
zsat_VD_S=((((((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S))*pInst->dps)+((thesat1*thesat1)*dps_VD_S))*pInst->dps)+(((thesat1*thesat1)*pInst->dps)*dps_VD_S));
#if defined(_DERIVATE2)
  zsat_VD_S_VGP_S=(+(+(+thesat1_VD_S_VGP_S*thesat1+thesat1_VD_S*thesat1_VGP_S+thesat1_VGP_S*thesat1_VD_S+thesat1*thesat1_VD_S_VGP_S)*pInst->dps+((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S))*dps_VGP_S+(((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S)))*dps_VD_S+(thesat1*thesat1)*dps_VD_S_VGP_S)*pInst->dps+((((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S))*pInst->dps)+((thesat1*thesat1)*dps_VD_S))*dps_VGP_S+((((((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S)))*pInst->dps)+((thesat1*thesat1)*dps_VGP_S)))*dps_VD_S+((thesat1*thesat1)*pInst->dps)*dps_VD_S_VGP_S);
  zsat_VD_S_VD_S=(+(+(+thesat1_VD_S_VD_S*thesat1+thesat1_VD_S*thesat1_VD_S+thesat1_VD_S*thesat1_VD_S+thesat1*thesat1_VD_S_VD_S)*pInst->dps+((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S))*dps_VD_S+(((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S)))*dps_VD_S+(thesat1*thesat1)*dps_VD_S_VD_S)*pInst->dps+((((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S))*pInst->dps)+((thesat1*thesat1)*dps_VD_S))*dps_VD_S+((((((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S)))*pInst->dps)+((thesat1*thesat1)*dps_VD_S)))*dps_VD_S+((thesat1*thesat1)*pInst->dps)*dps_VD_S_VD_S);
  zsat_VD_S_VS_BP=(+(+(+thesat1_VD_S_VS_BP*thesat1+thesat1_VD_S*thesat1_VS_BP+thesat1_VS_BP*thesat1_VD_S+thesat1*thesat1_VD_S_VS_BP)*pInst->dps+((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S))*dps_VS_BP+(((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP)))*dps_VD_S+(thesat1*thesat1)*dps_VD_S_VS_BP)*pInst->dps+((((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S))*pInst->dps)+((thesat1*thesat1)*dps_VD_S))*dps_VS_BP+((((((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP)))*pInst->dps)+((thesat1*thesat1)*dps_VS_BP)))*dps_VD_S+((thesat1*thesat1)*pInst->dps)*dps_VD_S_VS_BP);
#endif
zsat_VS_BP=((((((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP))*pInst->dps)+((thesat1*thesat1)*dps_VS_BP))*pInst->dps)+(((thesat1*thesat1)*pInst->dps)*dps_VS_BP));
#if defined(_DERIVATE2)
  zsat_VS_BP_VGP_S=(+(+(+thesat1_VS_BP_VGP_S*thesat1+thesat1_VS_BP*thesat1_VGP_S+thesat1_VGP_S*thesat1_VS_BP+thesat1*thesat1_VS_BP_VGP_S)*pInst->dps+((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP))*dps_VGP_S+(((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S)))*dps_VS_BP+(thesat1*thesat1)*dps_VS_BP_VGP_S)*pInst->dps+((((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP))*pInst->dps)+((thesat1*thesat1)*dps_VS_BP))*dps_VGP_S+((((((thesat1_VGP_S*thesat1)+(thesat1*thesat1_VGP_S)))*pInst->dps)+((thesat1*thesat1)*dps_VGP_S)))*dps_VS_BP+((thesat1*thesat1)*pInst->dps)*dps_VS_BP_VGP_S);
  zsat_VS_BP_VD_S=(+(+(+thesat1_VS_BP_VD_S*thesat1+thesat1_VS_BP*thesat1_VD_S+thesat1_VD_S*thesat1_VS_BP+thesat1*thesat1_VS_BP_VD_S)*pInst->dps+((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP))*dps_VD_S+(((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S)))*dps_VS_BP+(thesat1*thesat1)*dps_VS_BP_VD_S)*pInst->dps+((((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP))*pInst->dps)+((thesat1*thesat1)*dps_VS_BP))*dps_VD_S+((((((thesat1_VD_S*thesat1)+(thesat1*thesat1_VD_S)))*pInst->dps)+((thesat1*thesat1)*dps_VD_S)))*dps_VS_BP+((thesat1*thesat1)*pInst->dps)*dps_VS_BP_VD_S);
  zsat_VS_BP_VS_BP=(+(+(+thesat1_VS_BP_VS_BP*thesat1+thesat1_VS_BP*thesat1_VS_BP+thesat1_VS_BP*thesat1_VS_BP+thesat1*thesat1_VS_BP_VS_BP)*pInst->dps+((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP))*dps_VS_BP+(((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP)))*dps_VS_BP+(thesat1*thesat1)*dps_VS_BP_VS_BP)*pInst->dps+((((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP))*pInst->dps)+((thesat1*thesat1)*dps_VS_BP))*dps_VS_BP+((((((thesat1_VS_BP*thesat1)+(thesat1*thesat1_VS_BP)))*pInst->dps)+((thesat1*thesat1)*dps_VS_BP)))*dps_VS_BP+((thesat1*thesat1)*pInst->dps)*dps_VS_BP_VS_BP);
#endif
#endif
zsat=(((thesat1*thesat1)*pInst->dps)*pInst->dps);
EXIT_IF_ISNAN((((thesat1*thesat1)*pInst->dps)*pInst->dps))
if
((pModel->CHNL_TYPE==(-1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
zsat_VGP_S=((zsat_VGP_S*(1.0+(thesat1*pInst->dps))-zsat*((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
#if defined(_DERIVATE2)
  zsat_VGP_S_VGP_S=(zsat_VGP_S_VGP_S/(1.0+(thesat1*pInst->dps))-(zsat_VGP_S*(((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S)))+zsat_VGP_S*((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S))+zsat*(+0.0+(+thesat1_VGP_S_VGP_S*pInst->dps+thesat1_VGP_S*dps_VGP_S+thesat1_VGP_S*dps_VGP_S+thesat1*dps_VGP_S_VGP_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S))*(((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
  zsat_VGP_S_VD_S=(zsat_VGP_S_VD_S/(1.0+(thesat1*pInst->dps))-(zsat_VGP_S*(((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S)))+zsat_VD_S*((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S))+zsat*(+0.0+(+thesat1_VGP_S_VD_S*pInst->dps+thesat1_VGP_S*dps_VD_S+thesat1_VD_S*dps_VGP_S+thesat1*dps_VGP_S_VD_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S))*(((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
  zsat_VGP_S_VS_BP=(zsat_VGP_S_VS_BP/(1.0+(thesat1*pInst->dps))-(zsat_VGP_S*(((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP)))+zsat_VS_BP*((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S))+zsat*(+0.0+(+thesat1_VGP_S_VS_BP*pInst->dps+thesat1_VGP_S*dps_VS_BP+thesat1_VS_BP*dps_VGP_S+thesat1*dps_VGP_S_VS_BP)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S))*(((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
#endif
zsat_VD_S=((zsat_VD_S*(1.0+(thesat1*pInst->dps))-zsat*((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
#if defined(_DERIVATE2)
  zsat_VD_S_VGP_S=(zsat_VD_S_VGP_S/(1.0+(thesat1*pInst->dps))-(zsat_VD_S*(((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S)))+zsat_VGP_S*((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S))+zsat*(+0.0+(+thesat1_VD_S_VGP_S*pInst->dps+thesat1_VD_S*dps_VGP_S+thesat1_VGP_S*dps_VD_S+thesat1*dps_VD_S_VGP_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S))*(((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
  zsat_VD_S_VD_S=(zsat_VD_S_VD_S/(1.0+(thesat1*pInst->dps))-(zsat_VD_S*(((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S)))+zsat_VD_S*((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S))+zsat*(+0.0+(+thesat1_VD_S_VD_S*pInst->dps+thesat1_VD_S*dps_VD_S+thesat1_VD_S*dps_VD_S+thesat1*dps_VD_S_VD_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S))*(((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
  zsat_VD_S_VS_BP=(zsat_VD_S_VS_BP/(1.0+(thesat1*pInst->dps))-(zsat_VD_S*(((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP)))+zsat_VS_BP*((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S))+zsat*(+0.0+(+thesat1_VD_S_VS_BP*pInst->dps+thesat1_VD_S*dps_VS_BP+thesat1_VS_BP*dps_VD_S+thesat1*dps_VD_S_VS_BP)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S))*(((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
#endif
zsat_VS_BP=((zsat_VS_BP*(1.0+(thesat1*pInst->dps))-zsat*((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
#if defined(_DERIVATE2)
  zsat_VS_BP_VGP_S=(zsat_VS_BP_VGP_S/(1.0+(thesat1*pInst->dps))-(zsat_VS_BP*(((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S)))+zsat_VGP_S*((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP))+zsat*(+0.0+(+thesat1_VS_BP_VGP_S*pInst->dps+thesat1_VS_BP*dps_VGP_S+thesat1_VGP_S*dps_VS_BP+thesat1*dps_VS_BP_VGP_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP))*(((thesat1_VGP_S*pInst->dps)+(thesat1*dps_VGP_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
  zsat_VS_BP_VD_S=(zsat_VS_BP_VD_S/(1.0+(thesat1*pInst->dps))-(zsat_VS_BP*(((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S)))+zsat_VD_S*((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP))+zsat*(+0.0+(+thesat1_VS_BP_VD_S*pInst->dps+thesat1_VS_BP*dps_VD_S+thesat1_VD_S*dps_VS_BP+thesat1*dps_VS_BP_VD_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP))*(((thesat1_VD_S*pInst->dps)+(thesat1*dps_VD_S)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
  zsat_VS_BP_VS_BP=(zsat_VS_BP_VS_BP/(1.0+(thesat1*pInst->dps))-(zsat_VS_BP*(((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP)))+zsat_VS_BP*((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP))+zsat*(+0.0+(+thesat1_VS_BP_VS_BP*pInst->dps+thesat1_VS_BP*dps_VS_BP+thesat1_VS_BP*dps_VS_BP+thesat1*dps_VS_BP_VS_BP)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))+2*zsat*((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP))*(((thesat1_VS_BP*pInst->dps)+(thesat1*dps_VS_BP)))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps))/(1.0+(thesat1*pInst->dps)));
#endif
#endif
zsat=(zsat/(1.0+(thesat1*pInst->dps)));
EXIT_IF_ISNAN((zsat/(1.0+(thesat1*pInst->dps))))
}
{
double m00_sqrt(d00_sqrt0,(1.0+(2.0*zsat)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(2.0*zsat)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Gvsat_VD_S=(0.5*((Gmob_dL_VD_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VD_S)*d10_sqrt0)));
#if defined(_DERIVATE2)
  Gvsat_VD_S_VD_S=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VD_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VD_S))*d10_sqrt0)))+0.0*((Gmob_dL_VD_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VD_S)*d10_sqrt0))+0.5*(+Gmob_dL_VD_S_VD_S*(1.0+d00_sqrt0)+Gmob_dL_VD_S*((2.0*zsat_VD_S))*d10_sqrt0+Gmob_dL_VD_S*(2.0*zsat_VD_S)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VD_S))*(2.0*zsat_VD_S)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VD_S+0.0*zsat_VD_S+2.0*zsat_VD_S_VD_S))))));
  Gvsat_VD_S_VGP_S=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VGP_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VGP_S))*d10_sqrt0)))+0.0*((Gmob_dL_VD_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VD_S)*d10_sqrt0))+0.5*(+Gmob_dL_VD_S_VGP_S*(1.0+d00_sqrt0)+Gmob_dL_VD_S*((2.0*zsat_VGP_S))*d10_sqrt0+Gmob_dL_VGP_S*(2.0*zsat_VD_S)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VGP_S))*(2.0*zsat_VD_S)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VGP_S+0.0*zsat_VD_S+2.0*zsat_VD_S_VGP_S))))));
  Gvsat_VD_S_VS_BP=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VS_BP*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VS_BP))*d10_sqrt0)))+0.0*((Gmob_dL_VD_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VD_S)*d10_sqrt0))+0.5*(+Gmob_dL_VD_S_VS_BP*(1.0+d00_sqrt0)+Gmob_dL_VD_S*((2.0*zsat_VS_BP))*d10_sqrt0+Gmob_dL_VS_BP*(2.0*zsat_VD_S)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VS_BP))*(2.0*zsat_VD_S)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VS_BP+0.0*zsat_VD_S+2.0*zsat_VD_S_VS_BP))))));
#endif
Gvsat_VGP_S=(0.5*((Gmob_dL_VGP_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VGP_S)*d10_sqrt0)));
#if defined(_DERIVATE2)
  Gvsat_VGP_S_VD_S=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VD_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VD_S))*d10_sqrt0)))+0.0*((Gmob_dL_VGP_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VGP_S)*d10_sqrt0))+0.5*(+Gmob_dL_VGP_S_VD_S*(1.0+d00_sqrt0)+Gmob_dL_VGP_S*((2.0*zsat_VD_S))*d10_sqrt0+Gmob_dL_VD_S*(2.0*zsat_VGP_S)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VD_S))*(2.0*zsat_VGP_S)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VD_S+0.0*zsat_VGP_S+2.0*zsat_VGP_S_VD_S))))));
  Gvsat_VGP_S_VGP_S=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VGP_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VGP_S))*d10_sqrt0)))+0.0*((Gmob_dL_VGP_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VGP_S)*d10_sqrt0))+0.5*(+Gmob_dL_VGP_S_VGP_S*(1.0+d00_sqrt0)+Gmob_dL_VGP_S*((2.0*zsat_VGP_S))*d10_sqrt0+Gmob_dL_VGP_S*(2.0*zsat_VGP_S)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VGP_S))*(2.0*zsat_VGP_S)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VGP_S+0.0*zsat_VGP_S+2.0*zsat_VGP_S_VGP_S))))));
  Gvsat_VGP_S_VS_BP=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VS_BP*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VS_BP))*d10_sqrt0)))+0.0*((Gmob_dL_VGP_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VGP_S)*d10_sqrt0))+0.5*(+Gmob_dL_VGP_S_VS_BP*(1.0+d00_sqrt0)+Gmob_dL_VGP_S*((2.0*zsat_VS_BP))*d10_sqrt0+Gmob_dL_VS_BP*(2.0*zsat_VGP_S)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VS_BP))*(2.0*zsat_VGP_S)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VS_BP+0.0*zsat_VGP_S+2.0*zsat_VGP_S_VS_BP))))));
#endif
Gvsat_VS_BP=(0.5*((Gmob_dL_VS_BP*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VS_BP)*d10_sqrt0)));
#if defined(_DERIVATE2)
  Gvsat_VS_BP_VD_S=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VD_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VD_S))*d10_sqrt0)))+0.0*((Gmob_dL_VS_BP*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VS_BP)*d10_sqrt0))+0.5*(+Gmob_dL_VS_BP_VD_S*(1.0+d00_sqrt0)+Gmob_dL_VS_BP*((2.0*zsat_VD_S))*d10_sqrt0+Gmob_dL_VD_S*(2.0*zsat_VS_BP)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VD_S))*(2.0*zsat_VS_BP)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VD_S+0.0*zsat_VS_BP+2.0*zsat_VS_BP_VD_S))))));
  Gvsat_VS_BP_VGP_S=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VGP_S*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VGP_S))*d10_sqrt0)))+0.0*((Gmob_dL_VS_BP*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VS_BP)*d10_sqrt0))+0.5*(+Gmob_dL_VS_BP_VGP_S*(1.0+d00_sqrt0)+Gmob_dL_VS_BP*((2.0*zsat_VGP_S))*d10_sqrt0+Gmob_dL_VGP_S*(2.0*zsat_VS_BP)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VGP_S))*(2.0*zsat_VS_BP)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VGP_S+0.0*zsat_VS_BP+2.0*zsat_VS_BP_VGP_S))))));
  Gvsat_VS_BP_VS_BP=(+0.0*(pInst->Gmob_dL*(1.0+d00_sqrt0))+0.0*(((Gmob_dL_VS_BP*(1.0+d00_sqrt0))+(pInst->Gmob_dL*((2.0*zsat_VS_BP))*d10_sqrt0)))+0.0*((Gmob_dL_VS_BP*(1.0+d00_sqrt0))+(pInst->Gmob_dL*(2.0*zsat_VS_BP)*d10_sqrt0))+0.5*(+Gmob_dL_VS_BP_VS_BP*(1.0+d00_sqrt0)+Gmob_dL_VS_BP*((2.0*zsat_VS_BP))*d10_sqrt0+Gmob_dL_VS_BP*(2.0*zsat_VS_BP)*d10_sqrt0+pInst->Gmob_dL*(+0.0+(m20_sqrt((1.0+(2.0*zsat)))*((2.0*zsat_VS_BP))*(2.0*zsat_VS_BP)+d10_sqrt0*(+0.0+(+0.0*zsat+0.0*zsat_VS_BP+0.0*zsat_VS_BP+2.0*zsat_VS_BP_VS_BP))))));
#endif
#endif
pInst->Gvsat=(0.5*(pInst->Gmob_dL*(1.0+d00_sqrt0)));
EXIT_IF_ISNAN((0.5*(pInst->Gmob_dL*(1.0+d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Gvsatinv_VD_S=(-Gvsat_VD_S/pInst->Gvsat/pInst->Gvsat);
#if defined(_DERIVATE2)
  Gvsatinv_VD_S_VD_S=(0.0/pInst->Gvsat-(0.0*Gvsat_VD_S+0.0*Gvsat_VD_S+1.0*Gvsat_VD_S_VD_S)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VD_S*Gvsat_VD_S/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
  Gvsatinv_VD_S_VGP_S=(0.0/pInst->Gvsat-(0.0*Gvsat_VGP_S+0.0*Gvsat_VD_S+1.0*Gvsat_VD_S_VGP_S)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VD_S*Gvsat_VGP_S/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
  Gvsatinv_VD_S_VS_BP=(0.0/pInst->Gvsat-(0.0*Gvsat_VS_BP+0.0*Gvsat_VD_S+1.0*Gvsat_VD_S_VS_BP)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VD_S*Gvsat_VS_BP/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
#endif
Gvsatinv_VGP_S=(-Gvsat_VGP_S/pInst->Gvsat/pInst->Gvsat);
#if defined(_DERIVATE2)
  Gvsatinv_VGP_S_VD_S=(0.0/pInst->Gvsat-(0.0*Gvsat_VD_S+0.0*Gvsat_VGP_S+1.0*Gvsat_VGP_S_VD_S)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VGP_S*Gvsat_VD_S/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
  Gvsatinv_VGP_S_VGP_S=(0.0/pInst->Gvsat-(0.0*Gvsat_VGP_S+0.0*Gvsat_VGP_S+1.0*Gvsat_VGP_S_VGP_S)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VGP_S*Gvsat_VGP_S/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
  Gvsatinv_VGP_S_VS_BP=(0.0/pInst->Gvsat-(0.0*Gvsat_VS_BP+0.0*Gvsat_VGP_S+1.0*Gvsat_VGP_S_VS_BP)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VGP_S*Gvsat_VS_BP/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
#endif
Gvsatinv_VS_BP=(-Gvsat_VS_BP/pInst->Gvsat/pInst->Gvsat);
#if defined(_DERIVATE2)
  Gvsatinv_VS_BP_VD_S=(0.0/pInst->Gvsat-(0.0*Gvsat_VD_S+0.0*Gvsat_VS_BP+1.0*Gvsat_VS_BP_VD_S)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VS_BP*Gvsat_VD_S/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
  Gvsatinv_VS_BP_VGP_S=(0.0/pInst->Gvsat-(0.0*Gvsat_VGP_S+0.0*Gvsat_VS_BP+1.0*Gvsat_VS_BP_VGP_S)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VS_BP*Gvsat_VGP_S/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
  Gvsatinv_VS_BP_VS_BP=(0.0/pInst->Gvsat-(0.0*Gvsat_VS_BP+0.0*Gvsat_VS_BP+1.0*Gvsat_VS_BP_VS_BP)/pInst->Gvsat/pInst->Gvsat+2*1.0*Gvsat_VS_BP*Gvsat_VS_BP/pInst->Gvsat/pInst->Gvsat/pInst->Gvsat);
#endif
#endif
pInst->Gvsatinv=(1.0/pInst->Gvsat);
EXIT_IF_ISNAN((1.0/pInst->Gvsat))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ids_VGP_S=(pInst->BET_i*((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S)));
#if defined(_DERIVATE2)
  Ids_VGP_S_VGP_S=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S)))+0.0*((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S))+pInst->BET_i*(+(+(+FdL_VGP_S_VGP_S*pInst->qim1+FdL_VGP_S*qim1_VGP_S+FdL_VGP_S*qim1_VGP_S+pInst->FdL*qim1_VGP_S_VGP_S)*pInst->dps+((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*dps_VGP_S+(((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*dps_VGP_S+(pInst->FdL*pInst->qim1)*dps_VGP_S_VGP_S)*pInst->Gvsatinv+((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S))*Gvsatinv_VGP_S+((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S)))*Gvsatinv_VGP_S+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S_VGP_S));
  Ids_VGP_S_VD_S=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S)))+0.0*((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S))+pInst->BET_i*(+(+(+FdL_VGP_S_VD_S*pInst->qim1+FdL_VGP_S*qim1_VD_S+FdL_VD_S*qim1_VGP_S+pInst->FdL*qim1_VGP_S_VD_S)*pInst->dps+((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*dps_VD_S+(((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*dps_VGP_S+(pInst->FdL*pInst->qim1)*dps_VGP_S_VD_S)*pInst->Gvsatinv+((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S))*Gvsatinv_VD_S+((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S)))*Gvsatinv_VGP_S+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S_VD_S));
  Ids_VGP_S_VS_BP=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP)))+0.0*((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S))+pInst->BET_i*(+(+(+FdL_VGP_S_VS_BP*pInst->qim1+FdL_VGP_S*qim1_VS_BP+FdL_VS_BP*qim1_VGP_S+pInst->FdL*qim1_VGP_S_VS_BP)*pInst->dps+((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*dps_VS_BP+(((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*dps_VGP_S+(pInst->FdL*pInst->qim1)*dps_VGP_S_VS_BP)*pInst->Gvsatinv+((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S))*Gvsatinv_VS_BP+((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP)))*Gvsatinv_VGP_S+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S_VS_BP));
#endif
Ids_VD_S=(pInst->BET_i*((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S)));
#if defined(_DERIVATE2)
  Ids_VD_S_VGP_S=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S)))+0.0*((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S))+pInst->BET_i*(+(+(+FdL_VD_S_VGP_S*pInst->qim1+FdL_VD_S*qim1_VGP_S+FdL_VGP_S*qim1_VD_S+pInst->FdL*qim1_VD_S_VGP_S)*pInst->dps+((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*dps_VGP_S+(((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*dps_VD_S+(pInst->FdL*pInst->qim1)*dps_VD_S_VGP_S)*pInst->Gvsatinv+((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S))*Gvsatinv_VGP_S+((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S)))*Gvsatinv_VD_S+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S_VGP_S));
  Ids_VD_S_VD_S=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S)))+0.0*((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S))+pInst->BET_i*(+(+(+FdL_VD_S_VD_S*pInst->qim1+FdL_VD_S*qim1_VD_S+FdL_VD_S*qim1_VD_S+pInst->FdL*qim1_VD_S_VD_S)*pInst->dps+((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*dps_VD_S+(((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*dps_VD_S+(pInst->FdL*pInst->qim1)*dps_VD_S_VD_S)*pInst->Gvsatinv+((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S))*Gvsatinv_VD_S+((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S)))*Gvsatinv_VD_S+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S_VD_S));
  Ids_VD_S_VS_BP=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP)))+0.0*((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S))+pInst->BET_i*(+(+(+FdL_VD_S_VS_BP*pInst->qim1+FdL_VD_S*qim1_VS_BP+FdL_VS_BP*qim1_VD_S+pInst->FdL*qim1_VD_S_VS_BP)*pInst->dps+((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*dps_VS_BP+(((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*dps_VD_S+(pInst->FdL*pInst->qim1)*dps_VD_S_VS_BP)*pInst->Gvsatinv+((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S))*Gvsatinv_VS_BP+((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP)))*Gvsatinv_VD_S+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S_VS_BP));
#endif
Ids_VS_BP=(pInst->BET_i*((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP)));
#if defined(_DERIVATE2)
  Ids_VS_BP_VGP_S=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VGP_S)))+0.0*((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP))+pInst->BET_i*(+(+(+FdL_VS_BP_VGP_S*pInst->qim1+FdL_VS_BP*qim1_VGP_S+FdL_VGP_S*qim1_VS_BP+pInst->FdL*qim1_VS_BP_VGP_S)*pInst->dps+((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*dps_VGP_S+(((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*dps_VS_BP+(pInst->FdL*pInst->qim1)*dps_VS_BP_VGP_S)*pInst->Gvsatinv+((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP))*Gvsatinv_VGP_S+((((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VGP_S)))*Gvsatinv_VS_BP+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP_VGP_S));
  Ids_VS_BP_VD_S=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VD_S)))+0.0*((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP))+pInst->BET_i*(+(+(+FdL_VS_BP_VD_S*pInst->qim1+FdL_VS_BP*qim1_VD_S+FdL_VD_S*qim1_VS_BP+pInst->FdL*qim1_VS_BP_VD_S)*pInst->dps+((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*dps_VD_S+(((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*dps_VS_BP+(pInst->FdL*pInst->qim1)*dps_VS_BP_VD_S)*pInst->Gvsatinv+((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP))*Gvsatinv_VD_S+((((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VD_S)))*Gvsatinv_VS_BP+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP_VD_S));
  Ids_VS_BP_VS_BP=(+0.0*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)+0.0*(((((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP)))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP)))+0.0*((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP))*pInst->Gvsatinv)+(((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP))+pInst->BET_i*(+(+(+FdL_VS_BP_VS_BP*pInst->qim1+FdL_VS_BP*qim1_VS_BP+FdL_VS_BP*qim1_VS_BP+pInst->FdL*qim1_VS_BP_VS_BP)*pInst->dps+((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*dps_VS_BP+(((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*dps_VS_BP+(pInst->FdL*pInst->qim1)*dps_VS_BP_VS_BP)*pInst->Gvsatinv+((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP))*Gvsatinv_VS_BP+((((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP)))*pInst->dps)+((pInst->FdL*pInst->qim1)*dps_VS_BP)))*Gvsatinv_VS_BP+((pInst->FdL*pInst->qim1)*pInst->dps)*Gvsatinv_VS_BP_VS_BP));
#endif
#endif
pInst->Ids=(pInst->BET_i*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv));
EXIT_IF_ISNAN((pInst->BET_i*(((pInst->FdL*pInst->qim1)*pInst->dps)*pInst->Gvsatinv)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
Voxm_VD_S=xgm_VD_S*pInst->phit1;
#if defined(_DERIVATE2)
  Voxm_VD_S_VD_S=(+xgm_VD_S_VD_S*pInst->phit1+xgm_VD_S*0.0+xgm_VD_S*0.0+xgm*0.0);
  Voxm_VD_S_VGP_S=(+xgm_VD_S_VGP_S*pInst->phit1+xgm_VD_S*0.0+xgm_VGP_S*0.0+xgm*0.0);
  Voxm_VD_S_VS_BP=(+xgm_VD_S_VS_BP*pInst->phit1+xgm_VD_S*0.0+xgm_VS_BP*0.0+xgm*0.0);
#endif
Voxm_VGP_S=xgm_VGP_S*pInst->phit1;
#if defined(_DERIVATE2)
  Voxm_VGP_S_VD_S=(+xgm_VGP_S_VD_S*pInst->phit1+xgm_VGP_S*0.0+xgm_VD_S*0.0+xgm*0.0);
  Voxm_VGP_S_VGP_S=(+xgm_VGP_S_VGP_S*pInst->phit1+xgm_VGP_S*0.0+xgm_VGP_S*0.0+xgm*0.0);
  Voxm_VGP_S_VS_BP=(+xgm_VGP_S_VS_BP*pInst->phit1+xgm_VGP_S*0.0+xgm_VS_BP*0.0+xgm*0.0);
#endif
Voxm_VS_BP=xgm_VS_BP*pInst->phit1;
#if defined(_DERIVATE2)
  Voxm_VS_BP_VD_S=(+xgm_VS_BP_VD_S*pInst->phit1+xgm_VS_BP*0.0+xgm_VD_S*0.0+xgm*0.0);
  Voxm_VS_BP_VGP_S=(+xgm_VS_BP_VGP_S*pInst->phit1+xgm_VS_BP*0.0+xgm_VGP_S*0.0+xgm*0.0);
  Voxm_VS_BP_VS_BP=(+xgm_VS_BP_VS_BP*pInst->phit1+xgm_VS_BP*0.0+xgm_VS_BP*0.0+xgm*0.0);
#endif
#endif
Voxm=(xgm*pInst->phit1);
EXIT_IF_ISNAN((xgm*pInst->phit1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=((Gmob_dL_VGP_S*pInst->Gvsatinv)+(pInst->Gmob_dL*Gvsatinv_VGP_S));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*pInst->Gvsatinv+Gmob_dL_VGP_S*0.0+0.0*Gvsatinv_VGP_S+pInst->Gmob_dL*0.0);
  temp_VGP_S_VS_BS=(+0.0*pInst->Gvsatinv+Gmob_dL_VGP_S*0.0+0.0*Gvsatinv_VGP_S+pInst->Gmob_dL*0.0);
  temp_VGP_S_VGP_S=(+Gmob_dL_VGP_S_VGP_S*pInst->Gvsatinv+Gmob_dL_VGP_S*Gvsatinv_VGP_S+Gmob_dL_VGP_S*Gvsatinv_VGP_S+pInst->Gmob_dL*Gvsatinv_VGP_S_VGP_S);
  temp_VGP_S_VD_S=(+Gmob_dL_VGP_S_VD_S*pInst->Gvsatinv+Gmob_dL_VGP_S*Gvsatinv_VD_S+Gmob_dL_VD_S*Gvsatinv_VGP_S+pInst->Gmob_dL*Gvsatinv_VGP_S_VD_S);
  temp_VGP_S_VS_BP=(+Gmob_dL_VGP_S_VS_BP*pInst->Gvsatinv+Gmob_dL_VGP_S*Gvsatinv_VS_BP+Gmob_dL_VS_BP*Gvsatinv_VGP_S+pInst->Gmob_dL*Gvsatinv_VGP_S_VS_BP);
#endif
temp_VD_S=((Gmob_dL_VD_S*pInst->Gvsatinv)+(pInst->Gmob_dL*Gvsatinv_VD_S));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*pInst->Gvsatinv+Gmob_dL_VD_S*0.0+0.0*Gvsatinv_VD_S+pInst->Gmob_dL*0.0);
  temp_VD_S_VS_BS=(+0.0*pInst->Gvsatinv+Gmob_dL_VD_S*0.0+0.0*Gvsatinv_VD_S+pInst->Gmob_dL*0.0);
  temp_VD_S_VGP_S=(+Gmob_dL_VD_S_VGP_S*pInst->Gvsatinv+Gmob_dL_VD_S*Gvsatinv_VGP_S+Gmob_dL_VGP_S*Gvsatinv_VD_S+pInst->Gmob_dL*Gvsatinv_VD_S_VGP_S);
  temp_VD_S_VD_S=(+Gmob_dL_VD_S_VD_S*pInst->Gvsatinv+Gmob_dL_VD_S*Gvsatinv_VD_S+Gmob_dL_VD_S*Gvsatinv_VD_S+pInst->Gmob_dL*Gvsatinv_VD_S_VD_S);
  temp_VD_S_VS_BP=(+Gmob_dL_VD_S_VS_BP*pInst->Gvsatinv+Gmob_dL_VD_S*Gvsatinv_VS_BP+Gmob_dL_VS_BP*Gvsatinv_VD_S+pInst->Gmob_dL*Gvsatinv_VD_S_VS_BP);
#endif
temp_VS_BP=((Gmob_dL_VS_BP*pInst->Gvsatinv)+(pInst->Gmob_dL*Gvsatinv_VS_BP));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*pInst->Gvsatinv+Gmob_dL_VS_BP*0.0+0.0*Gvsatinv_VS_BP+pInst->Gmob_dL*0.0);
  temp_VS_BP_VS_BS=(+0.0*pInst->Gvsatinv+Gmob_dL_VS_BP*0.0+0.0*Gvsatinv_VS_BP+pInst->Gmob_dL*0.0);
  temp_VS_BP_VGP_S=(+Gmob_dL_VS_BP_VGP_S*pInst->Gvsatinv+Gmob_dL_VS_BP*Gvsatinv_VGP_S+Gmob_dL_VGP_S*Gvsatinv_VS_BP+pInst->Gmob_dL*Gvsatinv_VS_BP_VGP_S);
  temp_VS_BP_VD_S=(+Gmob_dL_VS_BP_VD_S*pInst->Gvsatinv+Gmob_dL_VS_BP*Gvsatinv_VD_S+Gmob_dL_VD_S*Gvsatinv_VS_BP+pInst->Gmob_dL*Gvsatinv_VS_BP_VD_S);
  temp_VS_BP_VS_BP=(+Gmob_dL_VS_BP_VS_BP*pInst->Gvsatinv+Gmob_dL_VS_BP*Gvsatinv_VS_BP+Gmob_dL_VS_BP*Gvsatinv_VS_BP+pInst->Gmob_dL*Gvsatinv_VS_BP_VS_BP);
#endif
#endif
temp=(pInst->Gmob_dL*pInst->Gvsatinv);
EXIT_IF_ISNAN((pInst->Gmob_dL*pInst->Gvsatinv))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
alpha1_VD_S=((alpha_VD_S*(1.0+(0.5*((zsat*temp)*temp))))+(pInst->alpha*(0.5*((((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp)+((zsat*temp)*temp_VD_S)))));
#if defined(_DERIVATE2)
  alpha1_VD_S_VD_S=(+alpha_VD_S_VD_S*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VD_S*((0.5*((((((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp)+((zsat*temp)*temp_VD_S)))))+alpha_VD_S*(0.5*((((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp)+((zsat*temp)*temp_VD_S)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp)+((zsat*temp)*temp_VD_S)))+0.0*((((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp)+((zsat*temp)*temp_VD_S))+0.5*(+(+zsat_VD_S_VD_S*temp+zsat_VD_S*temp_VD_S+zsat_VD_S*temp_VD_S+zsat*temp_VD_S_VD_S)*temp+((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp_VD_S+(((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp_VD_S+(zsat*temp)*temp_VD_S_VD_S))));
  alpha1_VD_S_VGP_S=(+alpha_VD_S_VGP_S*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VD_S*((0.5*((((((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp)+((zsat*temp)*temp_VGP_S)))))+alpha_VGP_S*(0.5*((((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp)+((zsat*temp)*temp_VD_S)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp)+((zsat*temp)*temp_VGP_S)))+0.0*((((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp)+((zsat*temp)*temp_VD_S))+0.5*(+(+zsat_VD_S_VGP_S*temp+zsat_VD_S*temp_VGP_S+zsat_VGP_S*temp_VD_S+zsat*temp_VD_S_VGP_S)*temp+((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp_VGP_S+(((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp_VD_S+(zsat*temp)*temp_VD_S_VGP_S))));
  alpha1_VD_S_VS_BP=(+alpha_VD_S_VS_BP*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VD_S*((0.5*((((((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp)+((zsat*temp)*temp_VS_BP)))))+alpha_VS_BP*(0.5*((((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp)+((zsat*temp)*temp_VD_S)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp)+((zsat*temp)*temp_VS_BP)))+0.0*((((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp)+((zsat*temp)*temp_VD_S))+0.5*(+(+zsat_VD_S_VS_BP*temp+zsat_VD_S*temp_VS_BP+zsat_VS_BP*temp_VD_S+zsat*temp_VD_S_VS_BP)*temp+((zsat_VD_S*temp)+(zsat*temp_VD_S))*temp_VS_BP+(((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp_VD_S+(zsat*temp)*temp_VD_S_VS_BP))));
#endif
alpha1_VGP_S=((alpha_VGP_S*(1.0+(0.5*((zsat*temp)*temp))))+(pInst->alpha*(0.5*((((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp)+((zsat*temp)*temp_VGP_S)))));
#if defined(_DERIVATE2)
  alpha1_VGP_S_VD_S=(+alpha_VGP_S_VD_S*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VGP_S*((0.5*((((((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp)+((zsat*temp)*temp_VD_S)))))+alpha_VD_S*(0.5*((((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp)+((zsat*temp)*temp_VGP_S)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp)+((zsat*temp)*temp_VD_S)))+0.0*((((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp)+((zsat*temp)*temp_VGP_S))+0.5*(+(+zsat_VGP_S_VD_S*temp+zsat_VGP_S*temp_VD_S+zsat_VD_S*temp_VGP_S+zsat*temp_VGP_S_VD_S)*temp+((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp_VD_S+(((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp_VGP_S+(zsat*temp)*temp_VGP_S_VD_S))));
  alpha1_VGP_S_VGP_S=(+alpha_VGP_S_VGP_S*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VGP_S*((0.5*((((((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp)+((zsat*temp)*temp_VGP_S)))))+alpha_VGP_S*(0.5*((((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp)+((zsat*temp)*temp_VGP_S)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp)+((zsat*temp)*temp_VGP_S)))+0.0*((((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp)+((zsat*temp)*temp_VGP_S))+0.5*(+(+zsat_VGP_S_VGP_S*temp+zsat_VGP_S*temp_VGP_S+zsat_VGP_S*temp_VGP_S+zsat*temp_VGP_S_VGP_S)*temp+((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp_VGP_S+(((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp_VGP_S+(zsat*temp)*temp_VGP_S_VGP_S))));
  alpha1_VGP_S_VS_BP=(+alpha_VGP_S_VS_BP*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VGP_S*((0.5*((((((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp)+((zsat*temp)*temp_VS_BP)))))+alpha_VS_BP*(0.5*((((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp)+((zsat*temp)*temp_VGP_S)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp)+((zsat*temp)*temp_VS_BP)))+0.0*((((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp)+((zsat*temp)*temp_VGP_S))+0.5*(+(+zsat_VGP_S_VS_BP*temp+zsat_VGP_S*temp_VS_BP+zsat_VS_BP*temp_VGP_S+zsat*temp_VGP_S_VS_BP)*temp+((zsat_VGP_S*temp)+(zsat*temp_VGP_S))*temp_VS_BP+(((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp_VGP_S+(zsat*temp)*temp_VGP_S_VS_BP))));
#endif
alpha1_VS_BP=((alpha_VS_BP*(1.0+(0.5*((zsat*temp)*temp))))+(pInst->alpha*(0.5*((((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp)+((zsat*temp)*temp_VS_BP)))));
#if defined(_DERIVATE2)
  alpha1_VS_BP_VD_S=(+alpha_VS_BP_VD_S*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VS_BP*((0.5*((((((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp)+((zsat*temp)*temp_VD_S)))))+alpha_VD_S*(0.5*((((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp)+((zsat*temp)*temp_VS_BP)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp)+((zsat*temp)*temp_VD_S)))+0.0*((((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp)+((zsat*temp)*temp_VS_BP))+0.5*(+(+zsat_VS_BP_VD_S*temp+zsat_VS_BP*temp_VD_S+zsat_VD_S*temp_VS_BP+zsat*temp_VS_BP_VD_S)*temp+((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp_VD_S+(((zsat_VD_S*temp)+(zsat*temp_VD_S)))*temp_VS_BP+(zsat*temp)*temp_VS_BP_VD_S))));
  alpha1_VS_BP_VGP_S=(+alpha_VS_BP_VGP_S*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VS_BP*((0.5*((((((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp)+((zsat*temp)*temp_VGP_S)))))+alpha_VGP_S*(0.5*((((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp)+((zsat*temp)*temp_VS_BP)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp)+((zsat*temp)*temp_VGP_S)))+0.0*((((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp)+((zsat*temp)*temp_VS_BP))+0.5*(+(+zsat_VS_BP_VGP_S*temp+zsat_VS_BP*temp_VGP_S+zsat_VGP_S*temp_VS_BP+zsat*temp_VS_BP_VGP_S)*temp+((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp_VGP_S+(((zsat_VGP_S*temp)+(zsat*temp_VGP_S)))*temp_VS_BP+(zsat*temp)*temp_VS_BP_VGP_S))));
  alpha1_VS_BP_VS_BP=(+alpha_VS_BP_VS_BP*(1.0+(0.5*((zsat*temp)*temp)))+alpha_VS_BP*((0.5*((((((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp)+((zsat*temp)*temp_VS_BP)))))+alpha_VS_BP*(0.5*((((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp)+((zsat*temp)*temp_VS_BP)))+pInst->alpha*(+0.0+(+0.0*((zsat*temp)*temp)+0.0*((((((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp)+((zsat*temp)*temp_VS_BP)))+0.0*((((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp)+((zsat*temp)*temp_VS_BP))+0.5*(+(+zsat_VS_BP_VS_BP*temp+zsat_VS_BP*temp_VS_BP+zsat_VS_BP*temp_VS_BP+zsat*temp_VS_BP_VS_BP)*temp+((zsat_VS_BP*temp)+(zsat*temp_VS_BP))*temp_VS_BP+(((zsat_VS_BP*temp)+(zsat*temp_VS_BP)))*temp_VS_BP+(zsat*temp)*temp_VS_BP_VS_BP))));
#endif
#endif
alpha1=(pInst->alpha*(1.0+(0.5*((zsat*temp)*temp))));
EXIT_IF_ISNAN((pInst->alpha*(1.0+(0.5*((zsat*temp)*temp)))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
H_VGP_S=((((temp_VGP_S*pInst->qim1)+(temp*qim1_VGP_S))*alpha1-(temp*pInst->qim1)*alpha1_VGP_S)/alpha1/alpha1);
#if defined(_DERIVATE2)
  H_VGP_S_VGP_S=((+temp_VGP_S_VGP_S*pInst->qim1+temp_VGP_S*qim1_VGP_S+temp_VGP_S*qim1_VGP_S+temp*qim1_VGP_S_VGP_S)/alpha1-(((temp_VGP_S*pInst->qim1)+(temp*qim1_VGP_S))*alpha1_VGP_S+(((temp_VGP_S*pInst->qim1)+(temp*qim1_VGP_S)))*alpha1_VGP_S+(temp*pInst->qim1)*alpha1_VGP_S_VGP_S)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VGP_S*alpha1_VGP_S/alpha1/alpha1/alpha1);
  H_VGP_S_VD_S=((+temp_VGP_S_VD_S*pInst->qim1+temp_VGP_S*qim1_VD_S+temp_VD_S*qim1_VGP_S+temp*qim1_VGP_S_VD_S)/alpha1-(((temp_VGP_S*pInst->qim1)+(temp*qim1_VGP_S))*alpha1_VD_S+(((temp_VD_S*pInst->qim1)+(temp*qim1_VD_S)))*alpha1_VGP_S+(temp*pInst->qim1)*alpha1_VGP_S_VD_S)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VGP_S*alpha1_VD_S/alpha1/alpha1/alpha1);
  H_VGP_S_VS_BP=((+temp_VGP_S_VS_BP*pInst->qim1+temp_VGP_S*qim1_VS_BP+temp_VS_BP*qim1_VGP_S+temp*qim1_VGP_S_VS_BP)/alpha1-(((temp_VGP_S*pInst->qim1)+(temp*qim1_VGP_S))*alpha1_VS_BP+(((temp_VS_BP*pInst->qim1)+(temp*qim1_VS_BP)))*alpha1_VGP_S+(temp*pInst->qim1)*alpha1_VGP_S_VS_BP)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VGP_S*alpha1_VS_BP/alpha1/alpha1/alpha1);
#endif
H_VD_S=((((temp_VD_S*pInst->qim1)+(temp*qim1_VD_S))*alpha1-(temp*pInst->qim1)*alpha1_VD_S)/alpha1/alpha1);
#if defined(_DERIVATE2)
  H_VD_S_VGP_S=((+temp_VD_S_VGP_S*pInst->qim1+temp_VD_S*qim1_VGP_S+temp_VGP_S*qim1_VD_S+temp*qim1_VD_S_VGP_S)/alpha1-(((temp_VD_S*pInst->qim1)+(temp*qim1_VD_S))*alpha1_VGP_S+(((temp_VGP_S*pInst->qim1)+(temp*qim1_VGP_S)))*alpha1_VD_S+(temp*pInst->qim1)*alpha1_VD_S_VGP_S)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VD_S*alpha1_VGP_S/alpha1/alpha1/alpha1);
  H_VD_S_VD_S=((+temp_VD_S_VD_S*pInst->qim1+temp_VD_S*qim1_VD_S+temp_VD_S*qim1_VD_S+temp*qim1_VD_S_VD_S)/alpha1-(((temp_VD_S*pInst->qim1)+(temp*qim1_VD_S))*alpha1_VD_S+(((temp_VD_S*pInst->qim1)+(temp*qim1_VD_S)))*alpha1_VD_S+(temp*pInst->qim1)*alpha1_VD_S_VD_S)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VD_S*alpha1_VD_S/alpha1/alpha1/alpha1);
  H_VD_S_VS_BP=((+temp_VD_S_VS_BP*pInst->qim1+temp_VD_S*qim1_VS_BP+temp_VS_BP*qim1_VD_S+temp*qim1_VD_S_VS_BP)/alpha1-(((temp_VD_S*pInst->qim1)+(temp*qim1_VD_S))*alpha1_VS_BP+(((temp_VS_BP*pInst->qim1)+(temp*qim1_VS_BP)))*alpha1_VD_S+(temp*pInst->qim1)*alpha1_VD_S_VS_BP)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VD_S*alpha1_VS_BP/alpha1/alpha1/alpha1);
#endif
H_VS_BP=((((temp_VS_BP*pInst->qim1)+(temp*qim1_VS_BP))*alpha1-(temp*pInst->qim1)*alpha1_VS_BP)/alpha1/alpha1);
#if defined(_DERIVATE2)
  H_VS_BP_VGP_S=((+temp_VS_BP_VGP_S*pInst->qim1+temp_VS_BP*qim1_VGP_S+temp_VGP_S*qim1_VS_BP+temp*qim1_VS_BP_VGP_S)/alpha1-(((temp_VS_BP*pInst->qim1)+(temp*qim1_VS_BP))*alpha1_VGP_S+(((temp_VGP_S*pInst->qim1)+(temp*qim1_VGP_S)))*alpha1_VS_BP+(temp*pInst->qim1)*alpha1_VS_BP_VGP_S)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VS_BP*alpha1_VGP_S/alpha1/alpha1/alpha1);
  H_VS_BP_VD_S=((+temp_VS_BP_VD_S*pInst->qim1+temp_VS_BP*qim1_VD_S+temp_VD_S*qim1_VS_BP+temp*qim1_VS_BP_VD_S)/alpha1-(((temp_VS_BP*pInst->qim1)+(temp*qim1_VS_BP))*alpha1_VD_S+(((temp_VD_S*pInst->qim1)+(temp*qim1_VD_S)))*alpha1_VS_BP+(temp*pInst->qim1)*alpha1_VS_BP_VD_S)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VS_BP*alpha1_VD_S/alpha1/alpha1/alpha1);
  H_VS_BP_VS_BP=((+temp_VS_BP_VS_BP*pInst->qim1+temp_VS_BP*qim1_VS_BP+temp_VS_BP*qim1_VS_BP+temp*qim1_VS_BP_VS_BP)/alpha1-(((temp_VS_BP*pInst->qim1)+(temp*qim1_VS_BP))*alpha1_VS_BP+(((temp_VS_BP*pInst->qim1)+(temp*qim1_VS_BP)))*alpha1_VS_BP+(temp*pInst->qim1)*alpha1_VS_BP_VS_BP)/alpha1/alpha1+2*(temp*pInst->qim1)*alpha1_VS_BP*alpha1_VS_BP/alpha1/alpha1/alpha1);
#endif
#endif
pInst->H=((temp*pInst->qim1)/alpha1);
EXIT_IF_ISNAN(((temp*pInst->qim1)/alpha1))
if
((pModel->SWIMPACT!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
delVsat_VD_S=(Vds_VD_S-(pInst->A3_i*dps_VD_S));
#if defined(_DERIVATE2)
  delVsat_VD_S_VD_S=(+Vds_VD_S_VD_S-(+0.0*pInst->dps+0.0*dps_VD_S+0.0*dps_VD_S+pInst->A3_i*dps_VD_S_VD_S));
  delVsat_VD_S_VGP_S=(+0.0-(+0.0*pInst->dps+0.0*dps_VGP_S+0.0*dps_VD_S+pInst->A3_i*dps_VD_S_VGP_S));
  delVsat_VD_S_VS_BP=(+0.0-(+0.0*pInst->dps+0.0*dps_VS_BP+0.0*dps_VD_S+pInst->A3_i*dps_VD_S_VS_BP));
#endif
delVsat_VGP_S=(-(pInst->A3_i*dps_VGP_S));
#if defined(_DERIVATE2)
  delVsat_VGP_S_VD_S=(+0.0-(+0.0*pInst->dps+0.0*dps_VD_S+0.0*dps_VGP_S+pInst->A3_i*dps_VGP_S_VD_S));
  delVsat_VGP_S_VGP_S=(+0.0-(+0.0*pInst->dps+0.0*dps_VGP_S+0.0*dps_VGP_S+pInst->A3_i*dps_VGP_S_VGP_S));
  delVsat_VGP_S_VS_BP=(+0.0-(+0.0*pInst->dps+0.0*dps_VS_BP+0.0*dps_VGP_S+pInst->A3_i*dps_VGP_S_VS_BP));
#endif
delVsat_VS_BP=(-(pInst->A3_i*dps_VS_BP));
#if defined(_DERIVATE2)
  delVsat_VS_BP_VD_S=(+0.0-(+0.0*pInst->dps+0.0*dps_VD_S+0.0*dps_VS_BP+pInst->A3_i*dps_VS_BP_VD_S));
  delVsat_VS_BP_VGP_S=(+0.0-(+0.0*pInst->dps+0.0*dps_VGP_S+0.0*dps_VS_BP+pInst->A3_i*dps_VS_BP_VGP_S));
  delVsat_VS_BP_VS_BP=(+0.0-(+0.0*pInst->dps+0.0*dps_VS_BP+0.0*dps_VS_BP+pInst->A3_i*dps_VS_BP_VS_BP));
#endif
#endif
delVsat=(Vds-(pInst->A3_i*pInst->dps));
EXIT_IF_ISNAN((Vds-(pInst->A3_i*pInst->dps)))
if
((delVsat>0))
{
{
double m00_sqrt(d00_sqrt0,(pInst->phib+Vsbstar))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->phib+Vsbstar))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp2_VD_S=(pInst->A2_i*(((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S)/(delVsat+1e-30)/(delVsat+1e-30)));
#if defined(_DERIVATE2)
  temp2_VD_S_VD_S=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*((((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0))*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S)/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*Vsbstar_VD_S*d10_sqrt0+0.0*Vsbstar_VD_S*d10_sqrt0+pInst->A4_i*(+(m20_sqrt((pInst->phib+Vsbstar))*Vsbstar_VD_S*Vsbstar_VD_S+d10_sqrt0*(+0.0+Vsbstar_VD_S_VD_S))-0.0)))/(delVsat+1e-30)-((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0)*delVsat_VD_S+((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0))*delVsat_VD_S+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VD_S_VD_S+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S*delVsat_VD_S/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
  temp2_VD_S_VGP_S=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*(((0.0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S)/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*0.0+0.0*Vsbstar_VD_S*d10_sqrt0+pInst->A4_i*(+0.0-0.0)))/(delVsat+1e-30)-((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0)*delVsat_VGP_S+(0.0)*delVsat_VD_S+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VD_S_VGP_S+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S*delVsat_VGP_S/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
  temp2_VD_S_VS_BP=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*((((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0))*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S)/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*Vsbstar_VS_BP*d10_sqrt0+0.0*Vsbstar_VD_S*d10_sqrt0+pInst->A4_i*(+(m20_sqrt((pInst->phib+Vsbstar))*Vsbstar_VS_BP*Vsbstar_VD_S+d10_sqrt0*(+0.0+Vsbstar_VD_S_VS_BP))-0.0)))/(delVsat+1e-30)-((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0)*delVsat_VS_BP+((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0))*delVsat_VD_S+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VD_S_VS_BP+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S*delVsat_VS_BP/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
#endif
temp2_VGP_S=(pInst->A2_i*(-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S/(delVsat+1e-30)/(delVsat+1e-30)));
#if defined(_DERIVATE2)
  temp2_VGP_S_VD_S=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*((((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0))*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*Vsbstar_VD_S*d10_sqrt0+0.0*0.0+pInst->A4_i*(+0.0-0.0)))/(delVsat+1e-30)-(0.0*delVsat_VD_S+((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0))*delVsat_VGP_S+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VGP_S_VD_S+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S*delVsat_VD_S/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
  temp2_VGP_S_VGP_S=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*(((0.0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*0.0+0.0*0.0+pInst->A4_i*(+0.0-0.0)))/(delVsat+1e-30)-(0.0*delVsat_VGP_S+(0.0)*delVsat_VGP_S+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VGP_S_VGP_S+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S*delVsat_VGP_S/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
  temp2_VGP_S_VS_BP=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*((((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0))*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*Vsbstar_VS_BP*d10_sqrt0+0.0*0.0+pInst->A4_i*(+0.0-0.0)))/(delVsat+1e-30)-(0.0*delVsat_VS_BP+((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0))*delVsat_VGP_S+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VGP_S_VS_BP+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S*delVsat_VS_BP/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
#endif
temp2_VS_BP=(pInst->A2_i*(((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP)/(delVsat+1e-30)/(delVsat+1e-30)));
#if defined(_DERIVATE2)
  temp2_VS_BP_VD_S=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*((((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0))*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VD_S)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP)/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*Vsbstar_VD_S*d10_sqrt0+0.0*Vsbstar_VS_BP*d10_sqrt0+pInst->A4_i*(+(m20_sqrt((pInst->phib+Vsbstar))*Vsbstar_VD_S*Vsbstar_VS_BP+d10_sqrt0*(+0.0+Vsbstar_VS_BP_VD_S))-0.0)))/(delVsat+1e-30)-((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0)*delVsat_VD_S+((pInst->A4_i*Vsbstar_VD_S*d10_sqrt0))*delVsat_VS_BP+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VS_BP_VD_S+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP*delVsat_VD_S/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
  temp2_VS_BP_VGP_S=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*(((0.0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VGP_S)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP)/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*0.0+0.0*Vsbstar_VS_BP*d10_sqrt0+pInst->A4_i*(+0.0-0.0)))/(delVsat+1e-30)-((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0)*delVsat_VGP_S+(0.0)*delVsat_VS_BP+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VS_BP_VGP_S+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP*delVsat_VGP_S/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
  temp2_VS_BP_VS_BP=(+0.0*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))+0.0*((((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0))*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP)/(delVsat+1e-30)/(delVsat+1e-30))+0.0*(((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0)*(delVsat+1e-30)-(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP)/(delVsat+1e-30)/(delVsat+1e-30))+pInst->A2_i*((+0.0+(+0.0*(d00_sqrt0-pInst->sqrt_phib)+0.0*Vsbstar_VS_BP*d10_sqrt0+0.0*Vsbstar_VS_BP*d10_sqrt0+pInst->A4_i*(+(m20_sqrt((pInst->phib+Vsbstar))*Vsbstar_VS_BP*Vsbstar_VS_BP+d10_sqrt0*(+0.0+Vsbstar_VS_BP_VS_BP))-0.0)))/(delVsat+1e-30)-((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0)*delVsat_VS_BP+((pInst->A4_i*Vsbstar_VS_BP*d10_sqrt0))*delVsat_VS_BP+(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*(+delVsat_VS_BP_VS_BP+0.0))/(delVsat+1e-30)/(delVsat+1e-30)+2*(1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))*delVsat_VS_BP*delVsat_VS_BP/(delVsat+1e-30)/(delVsat+1e-30)/(delVsat+1e-30)));
#endif
#endif
temp2=(pInst->A2_i*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30)));
EXIT_IF_ISNAN((pInst->A2_i*((1.0+(pInst->A4_i*(d00_sqrt0-pInst->sqrt_phib)))/(delVsat+1e-30))))
}
{
double m00_fabs(d00_fabs0,(-temp2))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,(-temp2))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-temp2_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=(m20_exp((-temp2))*(-temp2_VGP_S)*(-temp2_VGP_S)+d10_exp0*0.0);
  temp_VGP_S_VD_S=(m20_exp((-temp2))*(-temp2_VD_S)*(-temp2_VGP_S)+d10_exp0*0.0);
  temp_VGP_S_VS_BP=(m20_exp((-temp2))*(-temp2_VS_BP)*(-temp2_VGP_S)+d10_exp0*0.0);
#endif
temp_VD_S=(-temp2_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=0.0;
  temp_VD_S_VS_BS=0.0;
  temp_VD_S_VGP_S=(m20_exp((-temp2))*(-temp2_VGP_S)*(-temp2_VD_S)+d10_exp0*0.0);
  temp_VD_S_VD_S=(m20_exp((-temp2))*(-temp2_VD_S)*(-temp2_VD_S)+d10_exp0*0.0);
  temp_VD_S_VS_BP=(m20_exp((-temp2))*(-temp2_VS_BP)*(-temp2_VD_S)+d10_exp0*0.0);
#endif
temp_VS_BP=(-temp2_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=0.0;
  temp_VS_BP_VS_BS=0.0;
  temp_VS_BP_VGP_S=(m20_exp((-temp2))*(-temp2_VGP_S)*(-temp2_VS_BP)+d10_exp0*0.0);
  temp_VS_BP_VD_S=(m20_exp((-temp2))*(-temp2_VD_S)*(-temp2_VS_BP)+d10_exp0*0.0);
  temp_VS_BP_VS_BP=(m20_exp((-temp2))*(-temp2_VS_BP)*(-temp2_VS_BP)+d10_exp0*0.0);
#endif
#endif
temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
(((-temp2)<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-1.0e-100*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))+0.0*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VGP_S))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))+0.0*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))+0.0*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VGP_S))*(0.0)+0.0*(-(-temp2_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VGP_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))+0.0*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VGP_S))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))+0.0*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))+0.0*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VGP_S))*(0.0)+0.0*(-(-temp2_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VGP_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VGP_S))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01))))))+(-(-temp2_VGP_S))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VGP_S))*((-(-temp2_VGP_S))*3.3333333333333333e-01)+(-(-temp2_VGP_S))*(-(-temp2_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VGP_S))*0.0+(-(-temp2_VGP_S))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))*((((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VGP_S))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01))))))+(-(-temp2_VD_S))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VGP_S))*((-(-temp2_VD_S))*3.3333333333333333e-01)+(-(-temp2_VD_S))*(-(-temp2_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VGP_S))*0.0+(-(-temp2_VD_S))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))*((((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VGP_S))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01))))))+(-(-temp2_VS_BP))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VGP_S))*((-(-temp2_VS_BP))*3.3333333333333333e-01)+(-(-temp2_VS_BP))*(-(-temp2_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VGP_S))*0.0+(-(-temp2_VS_BP))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VGP_S))*3.3333333333333333e-01)))))*((((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
#endif
temp_VD_S=(-1.0e-100*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))+0.0*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VD_S))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))+0.0*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))+0.0*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VD_S))*(0.0)+0.0*(-(-temp2_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VD_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))+0.0*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VD_S))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))+0.0*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))+0.0*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VD_S))*(0.0)+0.0*(-(-temp2_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VD_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VD_S))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01))))))+(-(-temp2_VGP_S))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VD_S))*((-(-temp2_VGP_S))*3.3333333333333333e-01)+(-(-temp2_VGP_S))*(-(-temp2_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VD_S))*0.0+(-(-temp2_VGP_S))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))*((((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VD_S))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01))))))+(-(-temp2_VD_S))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VD_S))*((-(-temp2_VD_S))*3.3333333333333333e-01)+(-(-temp2_VD_S))*(-(-temp2_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VD_S))*0.0+(-(-temp2_VD_S))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))*((((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VD_S))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01))))))+(-(-temp2_VS_BP))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VD_S))*((-(-temp2_VS_BP))*3.3333333333333333e-01)+(-(-temp2_VS_BP))*(-(-temp2_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VD_S))*0.0+(-(-temp2_VS_BP))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VD_S))*3.3333333333333333e-01)))))*((((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
#endif
temp_VS_BP=(-1.0e-100*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))+0.0*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VS_BP))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))+0.0*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))+0.0*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VS_BP))*(0.0)+0.0*(-(-temp2_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VS_BP))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))+0.0*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VS_BP))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))+0.0*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))+0.0*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VS_BP))*(0.0)+0.0*(-(-temp2_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VS_BP))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-2.3025850929940458e+02)-(-temp2))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VS_BP))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01))))))+(-(-temp2_VGP_S))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VS_BP))*((-(-temp2_VGP_S))*3.3333333333333333e-01)+(-(-temp2_VGP_S))*(-(-temp2_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VS_BP))*0.0+(-(-temp2_VGP_S))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))*((((-(-temp2_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VS_BP))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01))))))+(-(-temp2_VD_S))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VS_BP))*((-(-temp2_VD_S))*3.3333333333333333e-01)+(-(-temp2_VD_S))*(-(-temp2_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VS_BP))*0.0+(-(-temp2_VD_S))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))*((((-(-temp2_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))-(0.0*((((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))+(-(-temp2_VS_BP))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01))))))+(-(-temp2_VS_BP))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+0.0*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))+(-(-temp2_VS_BP))*((-(-temp2_VS_BP))*3.3333333333333333e-01)+(-(-temp2_VS_BP))*(-(-temp2_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-temp2))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-temp2_VS_BP))*0.0+(-(-temp2_VS_BP))*0.0+((-2.3025850929940458e+02)-(-temp2))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*(0.5*(((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*(-(-temp2_VS_BP))*3.3333333333333333e-01)))))*((((-(-temp2_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-temp2))*((0.5*((((-(-temp2_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-temp2))*((-(-temp2_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
#endif
#endif
temp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(1.0e100*(((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VGP_S)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2)-2.3025850929940458e+02)*(0.0)))+0.0*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VGP_S)*(0.0)+0.0*(-temp2_VGP_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VGP_S)*0.0+0.0*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VS_BS=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VGP_S)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2)-2.3025850929940458e+02)*(0.0)))+0.0*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VGP_S)*(0.0)+0.0*(-temp2_VGP_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VGP_S)*0.0+0.0*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VGP_S=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VGP_S)*((0.5*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01))))))+(-temp2_VGP_S)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VGP_S)*((-temp2_VGP_S)*3.3333333333333333e-01)+(-temp2_VGP_S)*(-temp2_VGP_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VGP_S)*0.0+(-temp2_VGP_S)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VD_S=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VGP_S)*((0.5*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01))))))+(-temp2_VD_S)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VGP_S)*((-temp2_VD_S)*3.3333333333333333e-01)+(-temp2_VD_S)*(-temp2_VGP_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VGP_S)*0.0+(-temp2_VD_S)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VS_BP=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VGP_S)*((0.5*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01))))))+(-temp2_VS_BP)*(0.5*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VGP_S)*((-temp2_VS_BP)*3.3333333333333333e-01)+(-temp2_VS_BP)*(-temp2_VGP_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VGP_S)*0.0+(-temp2_VS_BP)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
#endif
temp_VD_S=(1.0e100*(((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VD_S)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2)-2.3025850929940458e+02)*(0.0)))+0.0*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VD_S)*(0.0)+0.0*(-temp2_VD_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VD_S)*0.0+0.0*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VS_BS=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VD_S)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2)-2.3025850929940458e+02)*(0.0)))+0.0*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VD_S)*(0.0)+0.0*(-temp2_VD_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VD_S)*0.0+0.0*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VGP_S=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VD_S)*((0.5*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01))))))+(-temp2_VGP_S)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VD_S)*((-temp2_VGP_S)*3.3333333333333333e-01)+(-temp2_VGP_S)*(-temp2_VD_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VD_S)*0.0+(-temp2_VGP_S)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VD_S=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VD_S)*((0.5*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01))))))+(-temp2_VD_S)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VD_S)*((-temp2_VD_S)*3.3333333333333333e-01)+(-temp2_VD_S)*(-temp2_VD_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VD_S)*0.0+(-temp2_VD_S)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VS_BP=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VD_S)*((0.5*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01))))))+(-temp2_VS_BP)*(0.5*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VD_S)*((-temp2_VS_BP)*3.3333333333333333e-01)+(-temp2_VS_BP)*(-temp2_VD_S)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VD_S)*0.0+(-temp2_VS_BP)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
#endif
temp_VS_BP=(1.0e100*(((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VS_BP)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2)-2.3025850929940458e+02)*(0.0)))+0.0*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VS_BP)*(0.0)+0.0*(-temp2_VS_BP)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VS_BP)*0.0+0.0*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VS_BS=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))))+0.0*(((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VS_BP)*((0.5*((((-temp2)-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2)-2.3025850929940458e+02)*(0.0)))+0.0*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VS_BP)*(0.0)+0.0*(-temp2_VS_BP)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VS_BP)*0.0+0.0*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VGP_S=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VGP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VS_BP)*((0.5*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01))))))+(-temp2_VGP_S)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VGP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VS_BP)*((-temp2_VGP_S)*3.3333333333333333e-01)+(-temp2_VGP_S)*(-temp2_VS_BP)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VS_BP)*0.0+(-temp2_VGP_S)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VD_S=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VD_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VS_BP)*((0.5*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01))))))+(-temp2_VD_S)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VD_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VS_BP)*((-temp2_VD_S)*3.3333333333333333e-01)+(-temp2_VD_S)*(-temp2_VS_BP)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VS_BP)*0.0+(-temp2_VD_S)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VS_BP=(+0.0*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*((0.5*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp2_VS_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((-temp2)-2.3025850929940458e+02)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-temp2_VS_BP)*((0.5*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01))))))+(-temp2_VS_BP)*(0.5*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01)))+((-temp2)-2.3025850929940458e+02)*(+0.0+(+0.0*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*((-temp2_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp2_VS_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((-temp2)-2.3025850929940458e+02)*(-temp2_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-temp2_VS_BP)*((-temp2_VS_BP)*3.3333333333333333e-01)+(-temp2_VS_BP)*(-temp2_VS_BP)*3.3333333333333333e-01+((-temp2)-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-temp2_VS_BP)*0.0+(-temp2_VS_BP)*0.0+((-temp2)-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
temp=(1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
mavl_VD_S=(pInst->A1_i*((delVsat_VD_S*temp)+(delVsat*temp_VD_S)));
#if defined(_DERIVATE2)
  mavl_VD_S_VD_S=(+0.0*(delVsat*temp)+0.0*(((delVsat_VD_S*temp)+(delVsat*temp_VD_S)))+0.0*((delVsat_VD_S*temp)+(delVsat*temp_VD_S))+pInst->A1_i*(+delVsat_VD_S_VD_S*temp+delVsat_VD_S*temp_VD_S+delVsat_VD_S*temp_VD_S+delVsat*temp_VD_S_VD_S));
  mavl_VD_S_VGP_S=(+0.0*(delVsat*temp)+0.0*(((delVsat_VGP_S*temp)+(delVsat*temp_VGP_S)))+0.0*((delVsat_VD_S*temp)+(delVsat*temp_VD_S))+pInst->A1_i*(+delVsat_VD_S_VGP_S*temp+delVsat_VD_S*temp_VGP_S+delVsat_VGP_S*temp_VD_S+delVsat*temp_VD_S_VGP_S));
  mavl_VD_S_VS_BP=(+0.0*(delVsat*temp)+0.0*(((delVsat_VS_BP*temp)+(delVsat*temp_VS_BP)))+0.0*((delVsat_VD_S*temp)+(delVsat*temp_VD_S))+pInst->A1_i*(+delVsat_VD_S_VS_BP*temp+delVsat_VD_S*temp_VS_BP+delVsat_VS_BP*temp_VD_S+delVsat*temp_VD_S_VS_BP));
#endif
mavl_VGP_S=(pInst->A1_i*((delVsat_VGP_S*temp)+(delVsat*temp_VGP_S)));
#if defined(_DERIVATE2)
  mavl_VGP_S_VD_S=(+0.0*(delVsat*temp)+0.0*(((delVsat_VD_S*temp)+(delVsat*temp_VD_S)))+0.0*((delVsat_VGP_S*temp)+(delVsat*temp_VGP_S))+pInst->A1_i*(+delVsat_VGP_S_VD_S*temp+delVsat_VGP_S*temp_VD_S+delVsat_VD_S*temp_VGP_S+delVsat*temp_VGP_S_VD_S));
  mavl_VGP_S_VGP_S=(+0.0*(delVsat*temp)+0.0*(((delVsat_VGP_S*temp)+(delVsat*temp_VGP_S)))+0.0*((delVsat_VGP_S*temp)+(delVsat*temp_VGP_S))+pInst->A1_i*(+delVsat_VGP_S_VGP_S*temp+delVsat_VGP_S*temp_VGP_S+delVsat_VGP_S*temp_VGP_S+delVsat*temp_VGP_S_VGP_S));
  mavl_VGP_S_VS_BP=(+0.0*(delVsat*temp)+0.0*(((delVsat_VS_BP*temp)+(delVsat*temp_VS_BP)))+0.0*((delVsat_VGP_S*temp)+(delVsat*temp_VGP_S))+pInst->A1_i*(+delVsat_VGP_S_VS_BP*temp+delVsat_VGP_S*temp_VS_BP+delVsat_VS_BP*temp_VGP_S+delVsat*temp_VGP_S_VS_BP));
#endif
mavl_VS_BP=(pInst->A1_i*((delVsat_VS_BP*temp)+(delVsat*temp_VS_BP)));
#if defined(_DERIVATE2)
  mavl_VS_BP_VD_S=(+0.0*(delVsat*temp)+0.0*(((delVsat_VD_S*temp)+(delVsat*temp_VD_S)))+0.0*((delVsat_VS_BP*temp)+(delVsat*temp_VS_BP))+pInst->A1_i*(+delVsat_VS_BP_VD_S*temp+delVsat_VS_BP*temp_VD_S+delVsat_VD_S*temp_VS_BP+delVsat*temp_VS_BP_VD_S));
  mavl_VS_BP_VGP_S=(+0.0*(delVsat*temp)+0.0*(((delVsat_VGP_S*temp)+(delVsat*temp_VGP_S)))+0.0*((delVsat_VS_BP*temp)+(delVsat*temp_VS_BP))+pInst->A1_i*(+delVsat_VS_BP_VGP_S*temp+delVsat_VS_BP*temp_VGP_S+delVsat_VGP_S*temp_VS_BP+delVsat*temp_VS_BP_VGP_S));
  mavl_VS_BP_VS_BP=(+0.0*(delVsat*temp)+0.0*(((delVsat_VS_BP*temp)+(delVsat*temp_VS_BP)))+0.0*((delVsat_VS_BP*temp)+(delVsat*temp_VS_BP))+pInst->A1_i*(+delVsat_VS_BP_VS_BP*temp+delVsat_VS_BP*temp_VS_BP+delVsat_VS_BP*temp_VS_BP+delVsat*temp_VS_BP_VS_BP));
#endif
#endif
pInst->mavl=(pInst->A1_i*(delVsat*temp));
EXIT_IF_ISNAN((pInst->A1_i*(delVsat*temp)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Iimpact_VGP_S=((Ids_VGP_S*pInst->mavl)+(pInst->Ids*mavl_VGP_S));
#if defined(_DERIVATE2)
  Iimpact_VGP_S_VGP_S=(+Ids_VGP_S_VGP_S*pInst->mavl+Ids_VGP_S*mavl_VGP_S+Ids_VGP_S*mavl_VGP_S+pInst->Ids*mavl_VGP_S_VGP_S);
  Iimpact_VGP_S_VD_S=(+Ids_VGP_S_VD_S*pInst->mavl+Ids_VGP_S*mavl_VD_S+Ids_VD_S*mavl_VGP_S+pInst->Ids*mavl_VGP_S_VD_S);
  Iimpact_VGP_S_VS_BP=(+Ids_VGP_S_VS_BP*pInst->mavl+Ids_VGP_S*mavl_VS_BP+Ids_VS_BP*mavl_VGP_S+pInst->Ids*mavl_VGP_S_VS_BP);
#endif
Iimpact_VD_S=((Ids_VD_S*pInst->mavl)+(pInst->Ids*mavl_VD_S));
#if defined(_DERIVATE2)
  Iimpact_VD_S_VGP_S=(+Ids_VD_S_VGP_S*pInst->mavl+Ids_VD_S*mavl_VGP_S+Ids_VGP_S*mavl_VD_S+pInst->Ids*mavl_VD_S_VGP_S);
  Iimpact_VD_S_VD_S=(+Ids_VD_S_VD_S*pInst->mavl+Ids_VD_S*mavl_VD_S+Ids_VD_S*mavl_VD_S+pInst->Ids*mavl_VD_S_VD_S);
  Iimpact_VD_S_VS_BP=(+Ids_VD_S_VS_BP*pInst->mavl+Ids_VD_S*mavl_VS_BP+Ids_VS_BP*mavl_VD_S+pInst->Ids*mavl_VD_S_VS_BP);
#endif
Iimpact_VS_BP=((Ids_VS_BP*pInst->mavl)+(pInst->Ids*mavl_VS_BP));
#if defined(_DERIVATE2)
  Iimpact_VS_BP_VGP_S=(+Ids_VS_BP_VGP_S*pInst->mavl+Ids_VS_BP*mavl_VGP_S+Ids_VGP_S*mavl_VS_BP+pInst->Ids*mavl_VS_BP_VGP_S);
  Iimpact_VS_BP_VD_S=(+Ids_VS_BP_VD_S*pInst->mavl+Ids_VS_BP*mavl_VD_S+Ids_VD_S*mavl_VS_BP+pInst->Ids*mavl_VS_BP_VD_S);
  Iimpact_VS_BP_VS_BP=(+Ids_VS_BP_VS_BP*pInst->mavl+Ids_VS_BP*mavl_VS_BP+Ids_VS_BP*mavl_VS_BP+pInst->Ids*mavl_VS_BP_VS_BP);
#endif
#endif
pInst->Iimpact=(pInst->Ids*pInst->mavl);
EXIT_IF_ISNAN((pInst->Ids*pInst->mavl))
}
}
}
if
((((((pModel->SWIGATE!=0)&&((pInst->IGOV_i>0)||(pInst->IGOVD_i>0)))||((pModel->SWGIDL!=0)&&((pInst->AGIDL_i>0)||(pInst->AGIDLD_i>0))))||(pInst->CGOV_i>0))||(pInst->CGOVD_i>0)))
{
GOV=pInst->GOV_s;
EXIT_IF_ISNAN(pInst->GOV_s)
GOV2=pInst->GOV2_s;
EXIT_IF_ISNAN(pInst->GOV2_s)
xi_ov=pInst->xi_ov_s;
EXIT_IF_ISNAN(pInst->xi_ov_s)
inv_xi_ov=pInst->inv_xi_ov_s;
EXIT_IF_ISNAN(pInst->inv_xi_ov_s)
x_mrg_ov=pInst->x_mrg_ov_s;
EXIT_IF_ISNAN(pInst->x_mrg_ov_s)
inv_xg1=pInst->inv_xg1_s;
EXIT_IF_ISNAN(pInst->inv_xg1_s)
{
double m00_fabs(d00_fabs0,xgs_ov)
if
((d00_fabs0<=x_mrg_ov))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xs_ov_VD_S=0.0;
#if defined(_DERIVATE2)
  xs_ov_VD_S_VD_S=0.0;
  xs_ov_VD_S_VS_BP=0.0;
  xs_ov_VD_S_VGP_S=0.0;
#endif
xs_ov_VS_BP=0.0;
#if defined(_DERIVATE2)
  xs_ov_VS_BP_VD_S=0.0;
  xs_ov_VS_BP_VS_BP=0.0;
  xs_ov_VS_BP_VGP_S=0.0;
#endif
xs_ov_VGP_S=(-xgs_ov_VGP_S)*inv_xi_ov;
#if defined(_DERIVATE2)
  xs_ov_VGP_S_VD_S=(+0.0*inv_xi_ov+(-xgs_ov_VGP_S)*0.0+0.0*0.0+(-xgs_ov)*0.0);
  xs_ov_VGP_S_VS_BP=(+0.0*inv_xi_ov+(-xgs_ov_VGP_S)*0.0+0.0*0.0+(-xgs_ov)*0.0);
  xs_ov_VGP_S_VGP_S=(+0.0*inv_xi_ov+(-xgs_ov_VGP_S)*0.0+(-xgs_ov_VGP_S)*0.0+(-xgs_ov)*0.0);
#endif
#endif
xs_ov=((-xgs_ov)*inv_xi_ov);
EXIT_IF_ISNAN(((-xgs_ov)*inv_xi_ov))
}
else
{
if
((xgs_ov<(-x_mrg_ov)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_yg_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_yg_VD_S_VD_S=0.0;
  SP_OV_yg_VD_S_VGP_S=0.0;
#endif
SP_OV_yg_VGP_S=(-xgs_ov_VGP_S);
#if defined(_DERIVATE2)
  SP_OV_yg_VGP_S_VD_S=0.0;
  SP_OV_yg_VGP_S_VGP_S=0.0;
#endif
#endif
SP_OV_yg=(-xgs_ov);
EXIT_IF_ISNAN((-xgs_ov))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_z_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_z_VD_S_VD_S=0.0;
  SP_OV_z_VD_S_VGP_S=0.0;
#endif
SP_OV_z_VGP_S=(pInst->x1*SP_OV_yg_VGP_S)*inv_xi_ov;
#if defined(_DERIVATE2)
  SP_OV_z_VGP_S_VD_S=(+(+0.0*SP_OV_yg+0.0*SP_OV_yg_VD_S+0.0*SP_OV_yg_VGP_S+pInst->x1*SP_OV_yg_VGP_S_VD_S)*inv_xi_ov+(pInst->x1*SP_OV_yg_VGP_S)*0.0+((pInst->x1*SP_OV_yg_VD_S))*0.0+(pInst->x1*SP_OV_yg)*0.0);
  SP_OV_z_VGP_S_VGP_S=(+(+0.0*SP_OV_yg+0.0*SP_OV_yg_VGP_S+0.0*SP_OV_yg_VGP_S+pInst->x1*SP_OV_yg_VGP_S_VGP_S)*inv_xi_ov+(pInst->x1*SP_OV_yg_VGP_S)*0.0+((pInst->x1*SP_OV_yg_VGP_S))*0.0+(pInst->x1*SP_OV_yg)*0.0);
#endif
#endif
SP_OV_z=((pInst->x1*SP_OV_yg)*inv_xi_ov);
EXIT_IF_ISNAN(((pInst->x1*SP_OV_yg)*inv_xi_ov))
{
double m00_sqrt(d00_sqrt0,(((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_eta_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_eta_VD_S_VD_S=0.0;
  SP_OV_eta_VD_S_VGP_S=0.0;
#endif
SP_OV_eta_VGP_S=(0.5*(SP_OV_z_VGP_S-((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_eta_VGP_S_VD_S=(+0.0*((SP_OV_z+10.0)-d00_sqrt0)+0.0*(SP_OV_z_VD_S-(((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S)))*d10_sqrt0)+0.0*(SP_OV_z_VGP_S-((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))*d10_sqrt0)+0.5*(+(+SP_OV_z_VGP_S_VD_S+0.0)-(m20_sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))*(((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S)))*((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))+d10_sqrt0*(+(+(+SP_OV_z_VGP_S_VD_S-0.0)*(SP_OV_z-6.0)+SP_OV_z_VGP_S*SP_OV_z_VD_S+SP_OV_z_VD_S*SP_OV_z_VGP_S+(SP_OV_z-6.0)*(+SP_OV_z_VGP_S_VD_S-0.0))+0.0))));
  SP_OV_eta_VGP_S_VGP_S=(+0.0*((SP_OV_z+10.0)-d00_sqrt0)+0.0*(SP_OV_z_VGP_S-(((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S)))*d10_sqrt0)+0.0*(SP_OV_z_VGP_S-((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))*d10_sqrt0)+0.5*(+(+SP_OV_z_VGP_S_VGP_S+0.0)-(m20_sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))*(((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S)))*((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))+d10_sqrt0*(+(+(+SP_OV_z_VGP_S_VGP_S-0.0)*(SP_OV_z-6.0)+SP_OV_z_VGP_S*SP_OV_z_VGP_S+SP_OV_z_VGP_S*SP_OV_z_VGP_S+(SP_OV_z-6.0)*(+SP_OV_z_VGP_S_VGP_S-0.0))+0.0))));
#endif
#endif
SP_OV_eta=(0.5*((SP_OV_z+10.0)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((SP_OV_z+10.0)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_a_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_a_VD_S_VD_S=0.0;
  SP_OV_a_VD_S_VGP_S=0.0;
#endif
SP_OV_a_VGP_S=((((SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg-SP_OV_eta))+((SP_OV_yg-SP_OV_eta)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)))+(GOV2*SP_OV_eta_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_a_VGP_S_VD_S=(+(+(+SP_OV_yg_VGP_S_VD_S-SP_OV_eta_VGP_S_VD_S)*(SP_OV_yg-SP_OV_eta)+(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+(SP_OV_yg_VD_S-SP_OV_eta_VD_S)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+(SP_OV_yg-SP_OV_eta)*(+SP_OV_yg_VGP_S_VD_S-SP_OV_eta_VGP_S_VD_S))+(+0.0*(SP_OV_eta+1.0)+0.0*SP_OV_eta_VD_S+0.0*SP_OV_eta_VGP_S+GOV2*(+SP_OV_eta_VGP_S_VD_S+0.0)));
  SP_OV_a_VGP_S_VGP_S=(+(+(+SP_OV_yg_VGP_S_VGP_S-SP_OV_eta_VGP_S_VGP_S)*(SP_OV_yg-SP_OV_eta)+(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+(SP_OV_yg-SP_OV_eta)*(+SP_OV_yg_VGP_S_VGP_S-SP_OV_eta_VGP_S_VGP_S))+(+0.0*(SP_OV_eta+1.0)+0.0*SP_OV_eta_VGP_S+0.0*SP_OV_eta_VGP_S+GOV2*(+SP_OV_eta_VGP_S_VGP_S+0.0)));
#endif
#endif
SP_OV_a=(((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
EXIT_IF_ISNAN((((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_c_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_c_VD_S_VD_S=0.0;
  SP_OV_c_VD_S_VGP_S=0.0;
#endif
SP_OV_c_VGP_S=(2.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_c_VGP_S_VD_S=(+(+0.0*(SP_OV_yg-SP_OV_eta)+0.0*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+0.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+2.0*(+SP_OV_yg_VGP_S_VD_S-SP_OV_eta_VGP_S_VD_S))-0.0);
  SP_OV_c_VGP_S_VGP_S=(+(+0.0*(SP_OV_yg-SP_OV_eta)+0.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+0.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+2.0*(+SP_OV_yg_VGP_S_VGP_S-SP_OV_eta_VGP_S_VGP_S))-0.0);
#endif
#endif
SP_OV_c=((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
EXIT_IF_ISNAN(((2.0*(SP_OV_yg-SP_OV_eta))-GOV2))
{
double m00_logE(d00_logE0,(SP_OV_a/GOV2))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(SP_OV_a/GOV2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_tau_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_tau_VD_S_VD_S=0.0;
  SP_OV_tau_VD_S_VGP_S=0.0;
#endif
SP_OV_tau_VGP_S=((SP_OV_a_VGP_S/GOV2)*d10_logE0-SP_OV_eta_VGP_S);
#if defined(_DERIVATE2)
  SP_OV_tau_VGP_S_VD_S=(+(m20_logE((SP_OV_a/GOV2))*(SP_OV_a_VD_S/GOV2)*(SP_OV_a_VGP_S/GOV2)+d10_logE0*(SP_OV_a_VGP_S_VD_S/GOV2-(SP_OV_a_VGP_S*0.0+SP_OV_a_VD_S*0.0+SP_OV_a*0.0)/GOV2/GOV2+2*SP_OV_a*0.0*0.0/GOV2/GOV2/GOV2))-SP_OV_eta_VGP_S_VD_S);
  SP_OV_tau_VGP_S_VGP_S=(+(m20_logE((SP_OV_a/GOV2))*(SP_OV_a_VGP_S/GOV2)*(SP_OV_a_VGP_S/GOV2)+d10_logE0*(SP_OV_a_VGP_S_VGP_S/GOV2-(SP_OV_a_VGP_S*0.0+SP_OV_a_VGP_S*0.0+SP_OV_a*0.0)/GOV2/GOV2+2*SP_OV_a*0.0*0.0/GOV2/GOV2/GOV2))-SP_OV_eta_VGP_S_VGP_S);
#endif
#endif
SP_OV_tau=(d00_logE0-SP_OV_eta);
EXIT_IF_ISNAN((d00_logE0-SP_OV_eta))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
nu_VD_S=0.0;
#if defined(_DERIVATE2)
  nu_VD_S_VD_S=0.0;
  nu_VD_S_VGP_S=0.0;
  nu_VD_S_VS_BP=0.0;
#endif
nu_VGP_S=(SP_OV_a_VGP_S+SP_OV_c_VGP_S);
#if defined(_DERIVATE2)
  nu_VGP_S_VD_S=(+SP_OV_a_VGP_S_VD_S+SP_OV_c_VGP_S_VD_S);
  nu_VGP_S_VGP_S=(+SP_OV_a_VGP_S_VGP_S+SP_OV_c_VGP_S_VGP_S);
  nu_VGP_S_VS_BP=(+0.0+0.0);
#endif
nu_VS_BP=0.0;
#if defined(_DERIVATE2)
  nu_VS_BP_VD_S=0.0;
  nu_VS_BP_VGP_S=0.0;
  nu_VS_BP_VS_BP=0.0;
#endif
#endif
nu=(SP_OV_a+SP_OV_c);
EXIT_IF_ISNAN((SP_OV_a+SP_OV_c))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
mutau_VD_S=(((nu_VD_S*nu)+(nu*nu_VD_S))+((SP_OV_tau_VD_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))+(SP_OV_tau*((0.5*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))-SP_OV_a_VD_S))));
#if defined(_DERIVATE2)
  mutau_VD_S_VD_S=(+(+nu_VD_S_VD_S*nu+nu_VD_S*nu_VD_S+nu_VD_S*nu_VD_S+nu*nu_VD_S_VD_S)+(+SP_OV_tau_VD_S_VD_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VD_S*(((0.5*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))))-SP_OV_a_VD_S)+SP_OV_tau_VD_S*((0.5*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))-SP_OV_a_VD_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))+0.0*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))+0.5*(+SP_OV_c_VD_S_VD_S*SP_OV_c+SP_OV_c_VD_S*SP_OV_c_VD_S+SP_OV_c_VD_S*SP_OV_c_VD_S+SP_OV_c*SP_OV_c_VD_S_VD_S))-SP_OV_a_VD_S_VD_S)));
  mutau_VD_S_VGP_S=(+(+nu_VD_S_VGP_S*nu+nu_VD_S*nu_VGP_S+nu_VGP_S*nu_VD_S+nu*nu_VD_S_VGP_S)+(+SP_OV_tau_VD_S_VGP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VD_S*(((0.5*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))))-SP_OV_a_VGP_S)+SP_OV_tau_VGP_S*((0.5*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))-SP_OV_a_VD_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))+0.0*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))+0.5*(+SP_OV_c_VD_S_VGP_S*SP_OV_c+SP_OV_c_VD_S*SP_OV_c_VGP_S+SP_OV_c_VGP_S*SP_OV_c_VD_S+SP_OV_c*SP_OV_c_VD_S_VGP_S))-SP_OV_a_VD_S_VGP_S)));
  mutau_VD_S_VS_BP=(+(+nu_VD_S_VS_BP*nu+nu_VD_S*nu_VS_BP+nu_VS_BP*nu_VD_S+nu*nu_VD_S_VS_BP)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VD_S*((0.5*(0.0)))+0.0*((0.5*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))-SP_OV_a_VD_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(0.0)+0.0*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))+0.5*(+0.0*SP_OV_c+SP_OV_c_VD_S*0.0+0.0*SP_OV_c_VD_S+SP_OV_c*0.0))-0.0)));
#endif
mutau_VGP_S=(((nu_VGP_S*nu)+(nu*nu_VGP_S))+((SP_OV_tau_VGP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))+(SP_OV_tau*((0.5*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))-SP_OV_a_VGP_S))));
#if defined(_DERIVATE2)
  mutau_VGP_S_VD_S=(+(+nu_VGP_S_VD_S*nu+nu_VGP_S*nu_VD_S+nu_VD_S*nu_VGP_S+nu*nu_VGP_S_VD_S)+(+SP_OV_tau_VGP_S_VD_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VGP_S*(((0.5*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))))-SP_OV_a_VD_S)+SP_OV_tau_VD_S*((0.5*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))-SP_OV_a_VGP_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))+0.0*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))+0.5*(+SP_OV_c_VGP_S_VD_S*SP_OV_c+SP_OV_c_VGP_S*SP_OV_c_VD_S+SP_OV_c_VD_S*SP_OV_c_VGP_S+SP_OV_c*SP_OV_c_VGP_S_VD_S))-SP_OV_a_VGP_S_VD_S)));
  mutau_VGP_S_VGP_S=(+(+nu_VGP_S_VGP_S*nu+nu_VGP_S*nu_VGP_S+nu_VGP_S*nu_VGP_S+nu*nu_VGP_S_VGP_S)+(+SP_OV_tau_VGP_S_VGP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VGP_S*(((0.5*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))))-SP_OV_a_VGP_S)+SP_OV_tau_VGP_S*((0.5*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))-SP_OV_a_VGP_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))+0.0*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))+0.5*(+SP_OV_c_VGP_S_VGP_S*SP_OV_c+SP_OV_c_VGP_S*SP_OV_c_VGP_S+SP_OV_c_VGP_S*SP_OV_c_VGP_S+SP_OV_c*SP_OV_c_VGP_S_VGP_S))-SP_OV_a_VGP_S_VGP_S)));
  mutau_VGP_S_VS_BP=(+(+nu_VGP_S_VS_BP*nu+nu_VGP_S*nu_VS_BP+nu_VS_BP*nu_VGP_S+nu*nu_VGP_S_VS_BP)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VGP_S*((0.5*(0.0)))+0.0*((0.5*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))-SP_OV_a_VGP_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(0.0)+0.0*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))+0.5*(+0.0*SP_OV_c+SP_OV_c_VGP_S*0.0+0.0*SP_OV_c_VGP_S+SP_OV_c*0.0))-0.0)));
#endif
mutau_VS_BP=((nu_VS_BP*nu)+(nu*nu_VS_BP));
#if defined(_DERIVATE2)
  mutau_VS_BP_VD_S=(+(+nu_VS_BP_VD_S*nu+nu_VS_BP*nu_VD_S+nu_VD_S*nu_VS_BP+nu*nu_VS_BP_VD_S)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+0.0*(((0.5*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))))-SP_OV_a_VD_S)+SP_OV_tau_VD_S*0.0+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))+0.0*0.0+0.5*(+0.0*SP_OV_c+0.0*SP_OV_c_VD_S+SP_OV_c_VD_S*0.0+SP_OV_c*0.0))-0.0)));
  mutau_VS_BP_VGP_S=(+(+nu_VS_BP_VGP_S*nu+nu_VS_BP*nu_VGP_S+nu_VGP_S*nu_VS_BP+nu*nu_VS_BP_VGP_S)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+0.0*(((0.5*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))))-SP_OV_a_VGP_S)+SP_OV_tau_VGP_S*0.0+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))+0.0*0.0+0.5*(+0.0*SP_OV_c+0.0*SP_OV_c_VGP_S+SP_OV_c_VGP_S*0.0+SP_OV_c*0.0))-0.0)));
  mutau_VS_BP_VS_BP=(+(+nu_VS_BP_VS_BP*nu+nu_VS_BP*nu_VS_BP+nu_VS_BP*nu_VS_BP+nu*nu_VS_BP_VS_BP)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+0.0*((0.5*(0.0)))+0.0*0.0+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(0.0)+0.0*0.0+0.5*(+0.0*SP_OV_c+0.0*0.0+0.0*0.0+SP_OV_c*0.0))-0.0)));
#endif
#endif
mutau=((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
EXIT_IF_ISNAN(((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_y0_VGP_S=(SP_OV_eta_VGP_S+((((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S))*(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu)*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#if defined(_DERIVATE2)
  SP_OV_y0_VGP_S_VGP_S=(+SP_OV_eta_VGP_S_VGP_S+((+(+SP_OV_a_VGP_S_VGP_S*nu+SP_OV_a_VGP_S*nu_VGP_S+SP_OV_a_VGP_S*nu_VGP_S+SP_OV_a*nu_VGP_S_VGP_S)*SP_OV_tau+((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau_VGP_S+(((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau_VGP_S+(SP_OV_a*nu)*SP_OV_tau_VGP_S_VGP_S)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))+((((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VGP_S_VGP_S+(+(+(+(+(nu_VGP_S_VGP_S/mutau-(nu_VGP_S*mutau_VGP_S+nu_VGP_S*mutau_VGP_S+nu*mutau_VGP_S_VGP_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VGP_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau_VGP_S+(nu/mutau)*SP_OV_tau_VGP_S_VGP_S)*SP_OV_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau_VGP_S+((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S_VGP_S)*SP_OV_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c_VGP_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S_VGP_S)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+SP_OV_c_VGP_S_VGP_S*SP_OV_c+SP_OV_c_VGP_S*SP_OV_c_VGP_S+SP_OV_c_VGP_S*SP_OV_c_VGP_S+SP_OV_c*SP_OV_c_VGP_S_VGP_S)*3.3333333333333333e-01+((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*0.0+(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-SP_OV_a_VGP_S_VGP_S))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VGP_S_VD_S=(+SP_OV_eta_VGP_S_VD_S+((+(+SP_OV_a_VGP_S_VD_S*nu+SP_OV_a_VGP_S*nu_VD_S+SP_OV_a_VD_S*nu_VGP_S+SP_OV_a*nu_VGP_S_VD_S)*SP_OV_tau+((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau_VD_S+(((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau_VGP_S+(SP_OV_a*nu)*SP_OV_tau_VGP_S_VD_S)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))+((((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VGP_S_VD_S+(+(+(+(+(nu_VGP_S_VD_S/mutau-(nu_VGP_S*mutau_VD_S+nu_VD_S*mutau_VGP_S+nu*mutau_VGP_S_VD_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VD_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau_VGP_S+(nu/mutau)*SP_OV_tau_VGP_S_VD_S)*SP_OV_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau_VGP_S+((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S_VD_S)*SP_OV_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c_VGP_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S_VD_S)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+SP_OV_c_VGP_S_VD_S*SP_OV_c+SP_OV_c_VGP_S*SP_OV_c_VD_S+SP_OV_c_VD_S*SP_OV_c_VGP_S+SP_OV_c*SP_OV_c_VGP_S_VD_S)*3.3333333333333333e-01+((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*0.0+(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-SP_OV_a_VGP_S_VD_S))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VGP_S_VS_BP=(+0.0+((+(+0.0*nu+SP_OV_a_VGP_S*nu_VS_BP+0.0*nu_VGP_S+SP_OV_a*nu_VGP_S_VS_BP)*SP_OV_tau+((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*0.0+((SP_OV_a*nu_VS_BP))*SP_OV_tau_VGP_S+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))+(((SP_OV_a*nu_VS_BP))*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VGP_S_VS_BP+(+(+(+(+(nu_VGP_S_VS_BP/mutau-(nu_VGP_S*mutau_VS_BP+nu_VS_BP*mutau_VGP_S+nu*mutau_VGP_S_VS_BP)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VS_BP/mutau/mutau/mutau)*SP_OV_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*0.0+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau_VGP_S+(nu/mutau)*0.0)*SP_OV_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*0.0+(((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*0.0+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*((0.0)*3.3333333333333333e-01)+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+SP_OV_c_VGP_S*0.0+0.0*SP_OV_c_VGP_S+SP_OV_c*0.0)*3.3333333333333333e-01+((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*0.0+(0.0)*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#endif
SP_OV_y0_VD_S=(SP_OV_eta_VD_S+((((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S))*(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu)*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#if defined(_DERIVATE2)
  SP_OV_y0_VD_S_VGP_S=(+SP_OV_eta_VD_S_VGP_S+((+(+SP_OV_a_VD_S_VGP_S*nu+SP_OV_a_VD_S*nu_VGP_S+SP_OV_a_VGP_S*nu_VD_S+SP_OV_a*nu_VD_S_VGP_S)*SP_OV_tau+((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau_VGP_S+(((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau_VD_S+(SP_OV_a*nu)*SP_OV_tau_VD_S_VGP_S)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))+((((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VD_S_VGP_S+(+(+(+(+(nu_VD_S_VGP_S/mutau-(nu_VD_S*mutau_VGP_S+nu_VGP_S*mutau_VD_S+nu*mutau_VD_S_VGP_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VGP_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau_VD_S+(nu/mutau)*SP_OV_tau_VD_S_VGP_S)*SP_OV_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau_VD_S+((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S_VGP_S)*SP_OV_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c_VD_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S_VGP_S)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+SP_OV_c_VD_S_VGP_S*SP_OV_c+SP_OV_c_VD_S*SP_OV_c_VGP_S+SP_OV_c_VGP_S*SP_OV_c_VD_S+SP_OV_c*SP_OV_c_VD_S_VGP_S)*3.3333333333333333e-01+((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*0.0+(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-SP_OV_a_VD_S_VGP_S))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VD_S_VD_S=(+SP_OV_eta_VD_S_VD_S+((+(+SP_OV_a_VD_S_VD_S*nu+SP_OV_a_VD_S*nu_VD_S+SP_OV_a_VD_S*nu_VD_S+SP_OV_a*nu_VD_S_VD_S)*SP_OV_tau+((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau_VD_S+(((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau_VD_S+(SP_OV_a*nu)*SP_OV_tau_VD_S_VD_S)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))+((((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VD_S_VD_S+(+(+(+(+(nu_VD_S_VD_S/mutau-(nu_VD_S*mutau_VD_S+nu_VD_S*mutau_VD_S+nu*mutau_VD_S_VD_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VD_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau_VD_S+(nu/mutau)*SP_OV_tau_VD_S_VD_S)*SP_OV_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau_VD_S+((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S_VD_S)*SP_OV_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c_VD_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S_VD_S)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+SP_OV_c_VD_S_VD_S*SP_OV_c+SP_OV_c_VD_S*SP_OV_c_VD_S+SP_OV_c_VD_S*SP_OV_c_VD_S+SP_OV_c*SP_OV_c_VD_S_VD_S)*3.3333333333333333e-01+((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*0.0+(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-SP_OV_a_VD_S_VD_S))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VD_S_VS_BP=(+0.0+((+(+0.0*nu+SP_OV_a_VD_S*nu_VS_BP+0.0*nu_VD_S+SP_OV_a*nu_VD_S_VS_BP)*SP_OV_tau+((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*0.0+((SP_OV_a*nu_VS_BP))*SP_OV_tau_VD_S+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))+(((SP_OV_a*nu_VS_BP))*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VD_S_VS_BP+(+(+(+(+(nu_VD_S_VS_BP/mutau-(nu_VD_S*mutau_VS_BP+nu_VS_BP*mutau_VD_S+nu*mutau_VD_S_VS_BP)/mutau/mutau+2*nu*mutau_VD_S*mutau_VS_BP/mutau/mutau/mutau)*SP_OV_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*0.0+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau_VD_S+(nu/mutau)*0.0)*SP_OV_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*0.0+(((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau_VD_S+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*0.0+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*((0.0)*3.3333333333333333e-01)+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+SP_OV_c_VD_S*0.0+0.0*SP_OV_c_VD_S+SP_OV_c*0.0)*3.3333333333333333e-01+((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*0.0+(0.0)*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#endif
SP_OV_y0_VS_BP=(((SP_OV_a*nu_VS_BP)*SP_OV_tau*(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu)*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))));
#if defined(_DERIVATE2)
  SP_OV_y0_VS_BP_VGP_S=(+0.0+((+(+0.0*nu+0.0*nu_VGP_S+SP_OV_a_VGP_S*nu_VS_BP+SP_OV_a*nu_VS_BP_VGP_S)*SP_OV_tau+(SP_OV_a*nu_VS_BP)*SP_OV_tau_VGP_S+(((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*0.0+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu_VS_BP)*SP_OV_tau*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))+((((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S)))*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VS_BP_VGP_S+(+(+(+(+(nu_VS_BP_VGP_S/mutau-(nu_VS_BP*mutau_VGP_S+nu_VGP_S*mutau_VS_BP+nu*mutau_VS_BP_VGP_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VGP_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*0.0+(nu/mutau)*0.0)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*0.0+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*0.0+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*0.0+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+0.0*SP_OV_c_VGP_S+SP_OV_c_VGP_S*0.0+SP_OV_c*0.0)*3.3333333333333333e-01+0.0*0.0+(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VS_BP_VD_S=(+0.0+((+(+0.0*nu+0.0*nu_VD_S+SP_OV_a_VD_S*nu_VS_BP+SP_OV_a*nu_VS_BP_VD_S)*SP_OV_tau+(SP_OV_a*nu_VS_BP)*SP_OV_tau_VD_S+(((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*0.0+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu_VS_BP)*SP_OV_tau*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))+((((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S)))*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VS_BP_VD_S+(+(+(+(+(nu_VS_BP_VD_S/mutau-(nu_VS_BP*mutau_VD_S+nu_VD_S*mutau_VS_BP+nu*mutau_VS_BP_VD_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VD_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*0.0+(nu/mutau)*0.0)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*0.0+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*0.0+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*0.0+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+0.0*SP_OV_c_VD_S+SP_OV_c_VD_S*0.0+SP_OV_c*0.0)*3.3333333333333333e-01+0.0*0.0+(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VS_BP_VS_BP=(+0.0+((+(+0.0*nu+0.0*nu_VS_BP+0.0*nu_VS_BP+SP_OV_a*nu_VS_BP_VS_BP)*SP_OV_tau+(SP_OV_a*nu_VS_BP)*0.0+((SP_OV_a*nu_VS_BP))*0.0+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu_VS_BP)*SP_OV_tau*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))+(((SP_OV_a*nu_VS_BP))*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VS_BP_VS_BP+(+(+(+(+(nu_VS_BP_VS_BP/mutau-(nu_VS_BP*mutau_VS_BP+nu_VS_BP*mutau_VS_BP+nu*mutau_VS_BP_VS_BP)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VS_BP/mutau/mutau/mutau)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*0.0+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*0.0+(nu/mutau)*0.0)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*0.0+(((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*0.0+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*0.0+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*0.0+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*((0.0)*3.3333333333333333e-01)+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*0.0+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+0.0*0.0+0.0*0.0+SP_OV_c*0.0)*3.3333333333333333e-01+0.0*0.0+(0.0)*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#endif
#endif
SP_OV_y0=(SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
EXIT_IF_ISNAN((SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))))
{
double m00_exp(d00_exp0,SP_OV_y0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_D0_VGP_S=SP_OV_y0_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VGP_S_VGP_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VGP_S*SP_OV_y0_VGP_S+d10_exp0*SP_OV_y0_VGP_S_VGP_S);
  SP_OV_D0_VGP_S_VD_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VD_S*SP_OV_y0_VGP_S+d10_exp0*SP_OV_y0_VGP_S_VD_S);
  SP_OV_D0_VGP_S_VS_BP=(m20_exp(SP_OV_y0)*SP_OV_y0_VS_BP*SP_OV_y0_VGP_S+d10_exp0*SP_OV_y0_VGP_S_VS_BP);
#endif
SP_OV_D0_VD_S=SP_OV_y0_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VD_S_VGP_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VGP_S*SP_OV_y0_VD_S+d10_exp0*SP_OV_y0_VD_S_VGP_S);
  SP_OV_D0_VD_S_VD_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VD_S*SP_OV_y0_VD_S+d10_exp0*SP_OV_y0_VD_S_VD_S);
  SP_OV_D0_VD_S_VS_BP=(m20_exp(SP_OV_y0)*SP_OV_y0_VS_BP*SP_OV_y0_VD_S+d10_exp0*SP_OV_y0_VD_S_VS_BP);
#endif
SP_OV_D0_VS_BP=SP_OV_y0_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VS_BP_VGP_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VGP_S*SP_OV_y0_VS_BP+d10_exp0*SP_OV_y0_VS_BP_VGP_S);
  SP_OV_D0_VS_BP_VD_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VD_S*SP_OV_y0_VS_BP+d10_exp0*SP_OV_y0_VS_BP_VD_S);
  SP_OV_D0_VS_BP_VS_BP=(m20_exp(SP_OV_y0)*SP_OV_y0_VS_BP*SP_OV_y0_VS_BP+d10_exp0*SP_OV_y0_VS_BP_VS_BP);
#endif
#endif
SP_OV_D0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(SP_OV_yg_VGP_S-SP_OV_y0_VGP_S);
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(+SP_OV_yg_VGP_S_VGP_S-SP_OV_y0_VGP_S_VGP_S);
  SP_OV_temp_VGP_S_VD_S=(+SP_OV_yg_VGP_S_VD_S-SP_OV_y0_VGP_S_VD_S);
  SP_OV_temp_VGP_S_VS_BP=(+0.0-SP_OV_y0_VGP_S_VS_BP);
#endif
SP_OV_temp_VD_S=(SP_OV_yg_VD_S-SP_OV_y0_VD_S);
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=(+SP_OV_yg_VD_S_VGP_S-SP_OV_y0_VD_S_VGP_S);
  SP_OV_temp_VD_S_VD_S=(+SP_OV_yg_VD_S_VD_S-SP_OV_y0_VD_S_VD_S);
  SP_OV_temp_VD_S_VS_BP=(+0.0-SP_OV_y0_VD_S_VS_BP);
#endif
SP_OV_temp_VS_BP=(-SP_OV_y0_VS_BP);
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=(+0.0-SP_OV_y0_VS_BP_VGP_S);
  SP_OV_temp_VS_BP_VD_S=(+0.0-SP_OV_y0_VS_BP_VD_S);
  SP_OV_temp_VS_BP_VS_BP=(+0.0-SP_OV_y0_VS_BP_VS_BP);
#endif
#endif
SP_OV_temp=(SP_OV_yg-SP_OV_y0);
EXIT_IF_ISNAN((SP_OV_yg-SP_OV_y0))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_p_VGP_S=((2.0*SP_OV_temp_VGP_S)+(GOV2*SP_OV_D0_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_p_VGP_S_VGP_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VGP_S+0.0*SP_OV_temp_VGP_S+2.0*SP_OV_temp_VGP_S_VGP_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VGP_S+0.0*SP_OV_D0_VGP_S+GOV2*(+SP_OV_D0_VGP_S_VGP_S-0.0)));
  SP_OV_p_VGP_S_VD_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VD_S+0.0*SP_OV_temp_VGP_S+2.0*SP_OV_temp_VGP_S_VD_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VD_S+0.0*SP_OV_D0_VGP_S+GOV2*(+SP_OV_D0_VGP_S_VD_S-0.0)));
  SP_OV_p_VGP_S_VS_BP=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VS_BP+0.0*SP_OV_temp_VGP_S+2.0*SP_OV_temp_VGP_S_VS_BP)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VS_BP+0.0*SP_OV_D0_VGP_S+GOV2*(+SP_OV_D0_VGP_S_VS_BP-0.0)));
#endif
SP_OV_p_VD_S=((2.0*SP_OV_temp_VD_S)+(GOV2*SP_OV_D0_VD_S));
#if defined(_DERIVATE2)
  SP_OV_p_VD_S_VGP_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VGP_S+0.0*SP_OV_temp_VD_S+2.0*SP_OV_temp_VD_S_VGP_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VGP_S+0.0*SP_OV_D0_VD_S+GOV2*(+SP_OV_D0_VD_S_VGP_S-0.0)));
  SP_OV_p_VD_S_VD_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VD_S+0.0*SP_OV_temp_VD_S+2.0*SP_OV_temp_VD_S_VD_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VD_S+0.0*SP_OV_D0_VD_S+GOV2*(+SP_OV_D0_VD_S_VD_S-0.0)));
  SP_OV_p_VD_S_VS_BP=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VS_BP+0.0*SP_OV_temp_VD_S+2.0*SP_OV_temp_VD_S_VS_BP)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VS_BP+0.0*SP_OV_D0_VD_S+GOV2*(+SP_OV_D0_VD_S_VS_BP-0.0)));
#endif
SP_OV_p_VS_BP=((2.0*SP_OV_temp_VS_BP)+(GOV2*SP_OV_D0_VS_BP));
#if defined(_DERIVATE2)
  SP_OV_p_VS_BP_VGP_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VGP_S+0.0*SP_OV_temp_VS_BP+2.0*SP_OV_temp_VS_BP_VGP_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VGP_S+0.0*SP_OV_D0_VS_BP+GOV2*(+SP_OV_D0_VS_BP_VGP_S-0.0)));
  SP_OV_p_VS_BP_VD_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VD_S+0.0*SP_OV_temp_VS_BP+2.0*SP_OV_temp_VS_BP_VD_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VD_S+0.0*SP_OV_D0_VS_BP+GOV2*(+SP_OV_D0_VS_BP_VD_S-0.0)));
  SP_OV_p_VS_BP_VS_BP=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VS_BP+0.0*SP_OV_temp_VS_BP+2.0*SP_OV_temp_VS_BP_VS_BP)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VS_BP+0.0*SP_OV_D0_VS_BP+GOV2*(+SP_OV_D0_VS_BP_VS_BP-0.0)));
#endif
#endif
SP_OV_p=((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
EXIT_IF_ISNAN(((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_q_VGP_S=(((SP_OV_temp_VGP_S*SP_OV_temp)+(SP_OV_temp*SP_OV_temp_VGP_S))+(GOV2*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)));
#if defined(_DERIVATE2)
  SP_OV_q_VGP_S_VGP_S=(+(+SP_OV_temp_VGP_S_VGP_S*SP_OV_temp+SP_OV_temp_VGP_S*SP_OV_temp_VGP_S+SP_OV_temp_VGP_S*SP_OV_temp_VGP_S+SP_OV_temp*SP_OV_temp_VGP_S_VGP_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_y0_VGP_S_VGP_S+0.0)-SP_OV_D0_VGP_S_VGP_S)));
  SP_OV_q_VGP_S_VD_S=(+(+SP_OV_temp_VGP_S_VD_S*SP_OV_temp+SP_OV_temp_VGP_S*SP_OV_temp_VD_S+SP_OV_temp_VD_S*SP_OV_temp_VGP_S+SP_OV_temp*SP_OV_temp_VGP_S_VD_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_y0_VGP_S_VD_S+0.0)-SP_OV_D0_VGP_S_VD_S)));
  SP_OV_q_VGP_S_VS_BP=(+(+SP_OV_temp_VGP_S_VS_BP*SP_OV_temp+SP_OV_temp_VGP_S*SP_OV_temp_VS_BP+SP_OV_temp_VS_BP*SP_OV_temp_VGP_S+SP_OV_temp*SP_OV_temp_VGP_S_VS_BP)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_y0_VGP_S_VS_BP+0.0)-SP_OV_D0_VGP_S_VS_BP)));
#endif
SP_OV_q_VD_S=(((SP_OV_temp_VD_S*SP_OV_temp)+(SP_OV_temp*SP_OV_temp_VD_S))+(GOV2*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)));
#if defined(_DERIVATE2)
  SP_OV_q_VD_S_VGP_S=(+(+SP_OV_temp_VD_S_VGP_S*SP_OV_temp+SP_OV_temp_VD_S*SP_OV_temp_VGP_S+SP_OV_temp_VGP_S*SP_OV_temp_VD_S+SP_OV_temp*SP_OV_temp_VD_S_VGP_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_y0_VD_S_VGP_S+0.0)-SP_OV_D0_VD_S_VGP_S)));
  SP_OV_q_VD_S_VD_S=(+(+SP_OV_temp_VD_S_VD_S*SP_OV_temp+SP_OV_temp_VD_S*SP_OV_temp_VD_S+SP_OV_temp_VD_S*SP_OV_temp_VD_S+SP_OV_temp*SP_OV_temp_VD_S_VD_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_y0_VD_S_VD_S+0.0)-SP_OV_D0_VD_S_VD_S)));
  SP_OV_q_VD_S_VS_BP=(+(+SP_OV_temp_VD_S_VS_BP*SP_OV_temp+SP_OV_temp_VD_S*SP_OV_temp_VS_BP+SP_OV_temp_VS_BP*SP_OV_temp_VD_S+SP_OV_temp*SP_OV_temp_VD_S_VS_BP)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_y0_VD_S_VS_BP+0.0)-SP_OV_D0_VD_S_VS_BP)));
#endif
SP_OV_q_VS_BP=(((SP_OV_temp_VS_BP*SP_OV_temp)+(SP_OV_temp*SP_OV_temp_VS_BP))+(GOV2*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)));
#if defined(_DERIVATE2)
  SP_OV_q_VS_BP_VGP_S=(+(+SP_OV_temp_VS_BP_VGP_S*SP_OV_temp+SP_OV_temp_VS_BP*SP_OV_temp_VGP_S+SP_OV_temp_VGP_S*SP_OV_temp_VS_BP+SP_OV_temp*SP_OV_temp_VS_BP_VGP_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_y0_VS_BP_VGP_S+0.0)-SP_OV_D0_VS_BP_VGP_S)));
  SP_OV_q_VS_BP_VD_S=(+(+SP_OV_temp_VS_BP_VD_S*SP_OV_temp+SP_OV_temp_VS_BP*SP_OV_temp_VD_S+SP_OV_temp_VD_S*SP_OV_temp_VS_BP+SP_OV_temp*SP_OV_temp_VS_BP_VD_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_y0_VS_BP_VD_S+0.0)-SP_OV_D0_VS_BP_VD_S)));
  SP_OV_q_VS_BP_VS_BP=(+(+SP_OV_temp_VS_BP_VS_BP*SP_OV_temp+SP_OV_temp_VS_BP*SP_OV_temp_VS_BP+SP_OV_temp_VS_BP*SP_OV_temp_VS_BP+SP_OV_temp*SP_OV_temp_VS_BP_VS_BP)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_y0_VS_BP_VS_BP+0.0)-SP_OV_D0_VS_BP_VS_BP)));
#endif
#endif
SP_OV_q=((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
EXIT_IF_ISNAN(((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_xi_VGP_S=(-((GOV2*0.5)*SP_OV_D0_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_xi_VGP_S_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VGP_S));
  SP_OV_xi_VGP_S_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VD_S));
  SP_OV_xi_VGP_S_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VS_BP));
#endif
SP_OV_xi_VD_S=(-((GOV2*0.5)*SP_OV_D0_VD_S));
#if defined(_DERIVATE2)
  SP_OV_xi_VD_S_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VGP_S));
  SP_OV_xi_VD_S_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VD_S));
  SP_OV_xi_VD_S_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VS_BP));
#endif
SP_OV_xi_VS_BP=(-((GOV2*0.5)*SP_OV_D0_VS_BP));
#if defined(_DERIVATE2)
  SP_OV_xi_VS_BP_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VGP_S));
  SP_OV_xi_VS_BP_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VD_S));
  SP_OV_xi_VS_BP_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VS_BP));
#endif
#endif
SP_OV_xi=(1.0-((GOV2*0.5)*SP_OV_D0));
EXIT_IF_ISNAN((1.0-((GOV2*0.5)*SP_OV_D0)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(((SP_OV_p_VGP_S*SP_OV_p)+(SP_OV_p*SP_OV_p_VGP_S))-(4.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))));
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(+(+SP_OV_p_VGP_S_VGP_S*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VGP_S*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VGP_S)));
  SP_OV_temp_VGP_S_VD_S=(+(+SP_OV_p_VGP_S_VD_S*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VD_S*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VD_S)));
  SP_OV_temp_VGP_S_VS_BP=(+(+SP_OV_p_VGP_S_VS_BP*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VS_BP*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VS_BP)));
#endif
SP_OV_temp_VD_S=(((SP_OV_p_VD_S*SP_OV_p)+(SP_OV_p*SP_OV_p_VD_S))-(4.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))));
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=(+(+SP_OV_p_VD_S_VGP_S*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VGP_S*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VGP_S)));
  SP_OV_temp_VD_S_VD_S=(+(+SP_OV_p_VD_S_VD_S*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VD_S*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VD_S)));
  SP_OV_temp_VD_S_VS_BP=(+(+SP_OV_p_VD_S_VS_BP*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VS_BP*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VS_BP)));
#endif
SP_OV_temp_VS_BP=(((SP_OV_p_VS_BP*SP_OV_p)+(SP_OV_p*SP_OV_p_VS_BP))-(4.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))));
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=(+(+SP_OV_p_VS_BP_VGP_S*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VGP_S*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VGP_S)));
  SP_OV_temp_VS_BP_VD_S=(+(+SP_OV_p_VS_BP_VD_S*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VD_S*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VD_S)));
  SP_OV_temp_VS_BP_VS_BP=(+(+SP_OV_p_VS_BP_VS_BP*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VS_BP*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VS_BP)));
#endif
#endif
SP_OV_temp=((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
EXIT_IF_ISNAN(((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q))))
{
double m00_sqrt(d00_sqrt0,SP_OV_temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,SP_OV_temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_w_VGP_S=(2.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_w_VGP_S_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VGP_S_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VGP_S_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
SP_OV_w_VD_S=(2.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_w_VD_S_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VD_S_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VD_S_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
SP_OV_w_VS_BP=(2.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_w_VS_BP_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VS_BP_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VS_BP_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
#endif
SP_OV_w=(2.0*(SP_OV_q/(SP_OV_p+d00_sqrt0)));
EXIT_IF_ISNAN((2.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xs_ov_VD_S=(-(SP_OV_y0_VD_S+SP_OV_w_VD_S));
#if defined(_DERIVATE2)
  xs_ov_VD_S_VD_S=0.0;
  xs_ov_VD_S_VS_BP=0.0;
  xs_ov_VD_S_VGP_S=0.0;
#endif
xs_ov_VS_BP=(-(SP_OV_y0_VS_BP+SP_OV_w_VS_BP));
#if defined(_DERIVATE2)
  xs_ov_VS_BP_VD_S=0.0;
  xs_ov_VS_BP_VS_BP=0.0;
  xs_ov_VS_BP_VGP_S=0.0;
#endif
xs_ov_VGP_S=(-(SP_OV_y0_VGP_S+SP_OV_w_VGP_S));
#if defined(_DERIVATE2)
  xs_ov_VGP_S_VD_S=0.0;
  xs_ov_VGP_S_VS_BP=0.0;
  xs_ov_VGP_S_VGP_S=0.0;
#endif
#endif
xs_ov=(-(SP_OV_y0+SP_OV_w));
EXIT_IF_ISNAN((-(SP_OV_y0+SP_OV_w)))
}
else
{
SP_OV_Afac=((((xi_ov*pInst->x1)*inv_xg1)-1.0)*inv_xg1);
EXIT_IF_ISNAN(((((xi_ov*pInst->x1)*inv_xg1)-1.0)*inv_xg1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_xbar_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_xbar_VD_S_VD_S=0.0;
  SP_OV_xbar_VD_S_VGP_S=0.0;
#endif
SP_OV_xbar_VGP_S=((xgs_ov_VGP_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgs_ov)))+((xgs_ov*inv_xi_ov)*(SP_OV_Afac*xgs_ov_VGP_S)));
#if defined(_DERIVATE2)
  SP_OV_xbar_VGP_S_VD_S=(+(+0.0*inv_xi_ov+xgs_ov_VGP_S*0.0+0.0*0.0+xgs_ov*0.0)*(1.0+(SP_OV_Afac*xgs_ov))+xgs_ov_VGP_S*inv_xi_ov*(0.0)+(0.0)*(SP_OV_Afac*xgs_ov_VGP_S)+(xgs_ov*inv_xi_ov)*(+0.0+(+0.0*xgs_ov+0.0*0.0+0.0*xgs_ov_VGP_S+SP_OV_Afac*0.0)));
  SP_OV_xbar_VGP_S_VGP_S=(+(+xgs_ov_VGP_S_VGP_S*inv_xi_ov+xgs_ov_VGP_S*0.0+xgs_ov_VGP_S*0.0+xgs_ov*0.0)*(1.0+(SP_OV_Afac*xgs_ov))+xgs_ov_VGP_S*inv_xi_ov*((SP_OV_Afac*xgs_ov_VGP_S))+(xgs_ov_VGP_S*inv_xi_ov)*(SP_OV_Afac*xgs_ov_VGP_S)+(xgs_ov*inv_xi_ov)*(+0.0+(+0.0*xgs_ov+0.0*xgs_ov_VGP_S+0.0*xgs_ov_VGP_S+SP_OV_Afac*xgs_ov_VGP_S_VGP_S)));
#endif
#endif
SP_OV_xbar=((xgs_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
EXIT_IF_ISNAN(((xgs_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov))))
if
(((-SP_OV_xbar)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(-SP_OV_xbar))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(-SP_OV_xbar_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(m20_exp((-SP_OV_xbar))*(-SP_OV_xbar_VGP_S)*(-SP_OV_xbar_VGP_S)+d10_exp0*0.0);
  SP_OV_temp_VGP_S_VD_S=(m20_exp((-SP_OV_xbar))*(-SP_OV_xbar_VD_S)*(-SP_OV_xbar_VGP_S)+d10_exp0*0.0);
  SP_OV_temp_VGP_S_VS_BP=0.0;
#endif
SP_OV_temp_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=0.0;
  SP_OV_temp_VD_S_VD_S=0.0;
  SP_OV_temp_VD_S_VS_BP=0.0;
#endif
SP_OV_temp_VS_BP=0.0;
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=0.0;
  SP_OV_temp_VS_BP_VD_S=0.0;
  SP_OV_temp_VS_BP_VS_BP=0.0;
#endif
#endif
SP_OV_temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(-1.0e-100*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VGP_S))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_xbar_VGP_S))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VGP_S))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_xbar_VGP_S))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VGP_S))*0.0+(-(-SP_OV_xbar_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
  SP_OV_temp_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VGP_S))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_xbar_VD_S))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VGP_S))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_xbar_VD_S))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VGP_S))*0.0+(-(-SP_OV_xbar_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
  SP_OV_temp_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VGP_S))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))+0.0*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VGP_S))*(0.0)+0.0*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VGP_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
#endif
SP_OV_temp_VD_S=0.0;
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=0.0;
  SP_OV_temp_VD_S_VD_S=0.0;
  SP_OV_temp_VD_S_VS_BP=0.0;
#endif
SP_OV_temp_VS_BP=0.0;
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=0.0;
  SP_OV_temp_VS_BP_VD_S=0.0;
  SP_OV_temp_VS_BP_VS_BP=0.0;
#endif
#endif
SP_OV_temp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_w_VGP_S=(-SP_OV_temp_VGP_S);
#if defined(_DERIVATE2)
  SP_OV_w_VGP_S_VGP_S=(+0.0-SP_OV_temp_VGP_S_VGP_S);
  SP_OV_w_VGP_S_VD_S=(+0.0-SP_OV_temp_VGP_S_VD_S);
  SP_OV_w_VGP_S_VS_BP=(+0.0-SP_OV_temp_VGP_S_VS_BP);
#endif
SP_OV_w_VD_S=(-SP_OV_temp_VD_S);
#if defined(_DERIVATE2)
  SP_OV_w_VD_S_VGP_S=(+0.0-SP_OV_temp_VD_S_VGP_S);
  SP_OV_w_VD_S_VD_S=(+0.0-SP_OV_temp_VD_S_VD_S);
  SP_OV_w_VD_S_VS_BP=(+0.0-SP_OV_temp_VD_S_VS_BP);
#endif
SP_OV_w_VS_BP=(-SP_OV_temp_VS_BP);
#if defined(_DERIVATE2)
  SP_OV_w_VS_BP_VGP_S=(+0.0-SP_OV_temp_VS_BP_VGP_S);
  SP_OV_w_VS_BP_VD_S=(+0.0-SP_OV_temp_VS_BP_VD_S);
  SP_OV_w_VS_BP_VS_BP=(+0.0-SP_OV_temp_VS_BP_VS_BP);
#endif
#endif
SP_OV_w=(1.0-SP_OV_temp);
EXIT_IF_ISNAN((1.0-SP_OV_temp))
{
double m00_sqrt(d00_sqrt0,((xgs_ov+(GOV2*0.25))-SP_OV_w))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xgs_ov+(GOV2*0.25))-SP_OV_w))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_x0_VGP_S=(xgs_ov_VGP_S-(GOV*(xgs_ov_VGP_S-SP_OV_w_VGP_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_x0_VGP_S_VGP_S=(+(+xgs_ov_VGP_S_VGP_S+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgs_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*d10_sqrt0+0.0*(xgs_ov_VGP_S-SP_OV_w_VGP_S)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((xgs_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*(xgs_ov_VGP_S-SP_OV_w_VGP_S)+d10_sqrt0*(+(+xgs_ov_VGP_S_VGP_S+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VGP_S_VGP_S))));
  SP_OV_x0_VGP_S_VD_S=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VD_S)*d10_sqrt0+0.0*(xgs_ov_VGP_S-SP_OV_w_VGP_S)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VD_S)*(xgs_ov_VGP_S-SP_OV_w_VGP_S)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VGP_S_VD_S))));
  SP_OV_x0_VGP_S_VS_BP=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VS_BP)*d10_sqrt0+0.0*(xgs_ov_VGP_S-SP_OV_w_VGP_S)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VS_BP)*(xgs_ov_VGP_S-SP_OV_w_VGP_S)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VGP_S_VS_BP))));
#endif
SP_OV_x0_VD_S=(-(GOV*(-SP_OV_w_VD_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_x0_VD_S_VGP_S=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgs_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*d10_sqrt0+0.0*(-SP_OV_w_VD_S)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((xgs_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*(-SP_OV_w_VD_S)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VD_S_VGP_S))));
  SP_OV_x0_VD_S_VD_S=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VD_S)*d10_sqrt0+0.0*(-SP_OV_w_VD_S)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VD_S)*(-SP_OV_w_VD_S)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VD_S_VD_S))));
  SP_OV_x0_VD_S_VS_BP=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VS_BP)*d10_sqrt0+0.0*(-SP_OV_w_VD_S)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VS_BP)*(-SP_OV_w_VD_S)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VD_S_VS_BP))));
#endif
SP_OV_x0_VS_BP=(-(GOV*(-SP_OV_w_VS_BP)*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_x0_VS_BP_VGP_S=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgs_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*d10_sqrt0+0.0*(-SP_OV_w_VS_BP)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((xgs_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*(-SP_OV_w_VS_BP)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VS_BP_VGP_S))));
  SP_OV_x0_VS_BP_VD_S=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VD_S)*d10_sqrt0+0.0*(-SP_OV_w_VS_BP)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VD_S)*(-SP_OV_w_VS_BP)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VS_BP_VD_S))));
  SP_OV_x0_VS_BP_VS_BP=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VS_BP)*d10_sqrt0+0.0*(-SP_OV_w_VS_BP)*d10_sqrt0+GOV*(m20_sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VS_BP)*(-SP_OV_w_VS_BP)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VS_BP_VS_BP))));
#endif
#endif
SP_OV_x0=((xgs_ov+(GOV2*0.5))-(GOV*d00_sqrt0));
EXIT_IF_ISNAN(((xgs_ov+(GOV2*0.5))-(GOV*d00_sqrt0)))
}
if
(((-SP_OV_x0)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(-SP_OV_x0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_D0_VGP_S=(-SP_OV_x0_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VGP_S_VGP_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VGP_S)*(-SP_OV_x0_VGP_S)+d10_exp0*0.0);
  SP_OV_D0_VGP_S_VD_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VD_S)*(-SP_OV_x0_VGP_S)+d10_exp0*0.0);
  SP_OV_D0_VGP_S_VS_BP=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VGP_S)+d10_exp0*0.0);
#endif
SP_OV_D0_VD_S=(-SP_OV_x0_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VD_S_VGP_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VGP_S)*(-SP_OV_x0_VD_S)+d10_exp0*0.0);
  SP_OV_D0_VD_S_VD_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VD_S)*(-SP_OV_x0_VD_S)+d10_exp0*0.0);
  SP_OV_D0_VD_S_VS_BP=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VD_S)+d10_exp0*0.0);
#endif
SP_OV_D0_VS_BP=(-SP_OV_x0_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VS_BP_VGP_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VGP_S)*(-SP_OV_x0_VS_BP)+d10_exp0*0.0);
  SP_OV_D0_VS_BP_VD_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VD_S)*(-SP_OV_x0_VS_BP)+d10_exp0*0.0);
  SP_OV_D0_VS_BP_VS_BP=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VS_BP)+d10_exp0*0.0);
#endif
#endif
SP_OV_D0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_D0_VGP_S=(-1.0e-100*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_D0_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VGP_S))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VGP_S))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VGP_S))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VGP_S))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VGP_S))*0.0+(-(-SP_OV_x0_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VGP_S))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VD_S))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VGP_S))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VD_S))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VGP_S))*0.0+(-(-SP_OV_x0_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VGP_S))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VS_BP))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VGP_S))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)+(-(-SP_OV_x0_VS_BP))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VGP_S))*0.0+(-(-SP_OV_x0_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#endif
SP_OV_D0_VD_S=(-1.0e-100*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_D0_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VD_S))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VGP_S))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VD_S))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VGP_S))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VD_S))*0.0+(-(-SP_OV_x0_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VD_S))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VD_S))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VD_S))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VD_S))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VD_S))*0.0+(-(-SP_OV_x0_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VD_S))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VS_BP))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VD_S))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)+(-(-SP_OV_x0_VS_BP))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VD_S))*0.0+(-(-SP_OV_x0_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#endif
SP_OV_D0_VS_BP=(-1.0e-100*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_D0_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VS_BP))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VGP_S))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VS_BP))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VGP_S))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VS_BP))*0.0+(-(-SP_OV_x0_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VS_BP))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VD_S))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VS_BP))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VD_S))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VS_BP))*0.0+(-(-SP_OV_x0_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VS_BP))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VS_BP))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VS_BP))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)+(-(-SP_OV_x0_VS_BP))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VS_BP))*0.0+(-(-SP_OV_x0_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#endif
#endif
SP_OV_D0=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_p_VGP_S=((2.0*(xgs_ov_VGP_S-SP_OV_x0_VGP_S))+(GOV2*(-SP_OV_D0_VGP_S)));
#if defined(_DERIVATE2)
  SP_OV_p_VGP_S_VGP_S=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+0.0*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+2.0*(+xgs_ov_VGP_S_VGP_S-SP_OV_x0_VGP_S_VGP_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VGP_S)+0.0*(-SP_OV_D0_VGP_S)+GOV2*(+0.0-SP_OV_D0_VGP_S_VGP_S)));
  SP_OV_p_VGP_S_VD_S=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VD_S)+0.0*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+2.0*(+0.0-SP_OV_x0_VGP_S_VD_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VD_S)+0.0*(-SP_OV_D0_VGP_S)+GOV2*(+0.0-SP_OV_D0_VGP_S_VD_S)));
  SP_OV_p_VGP_S_VS_BP=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VS_BP)+0.0*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+2.0*(+0.0-SP_OV_x0_VGP_S_VS_BP))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VS_BP)+0.0*(-SP_OV_D0_VGP_S)+GOV2*(+0.0-SP_OV_D0_VGP_S_VS_BP)));
#endif
SP_OV_p_VD_S=((2.0*(-SP_OV_x0_VD_S))+(GOV2*(-SP_OV_D0_VD_S)));
#if defined(_DERIVATE2)
  SP_OV_p_VD_S_VGP_S=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+0.0*(-SP_OV_x0_VD_S)+2.0*(+0.0-SP_OV_x0_VD_S_VGP_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VGP_S)+0.0*(-SP_OV_D0_VD_S)+GOV2*(+0.0-SP_OV_D0_VD_S_VGP_S)));
  SP_OV_p_VD_S_VD_S=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VD_S)+0.0*(-SP_OV_x0_VD_S)+2.0*(+0.0-SP_OV_x0_VD_S_VD_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VD_S)+0.0*(-SP_OV_D0_VD_S)+GOV2*(+0.0-SP_OV_D0_VD_S_VD_S)));
  SP_OV_p_VD_S_VS_BP=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VS_BP)+0.0*(-SP_OV_x0_VD_S)+2.0*(+0.0-SP_OV_x0_VD_S_VS_BP))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VS_BP)+0.0*(-SP_OV_D0_VD_S)+GOV2*(+0.0-SP_OV_D0_VD_S_VS_BP)));
#endif
SP_OV_p_VS_BP=((2.0*(-SP_OV_x0_VS_BP))+(GOV2*(-SP_OV_D0_VS_BP)));
#if defined(_DERIVATE2)
  SP_OV_p_VS_BP_VGP_S=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+0.0*(-SP_OV_x0_VS_BP)+2.0*(+0.0-SP_OV_x0_VS_BP_VGP_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VGP_S)+0.0*(-SP_OV_D0_VS_BP)+GOV2*(+0.0-SP_OV_D0_VS_BP_VGP_S)));
  SP_OV_p_VS_BP_VD_S=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VD_S)+0.0*(-SP_OV_x0_VS_BP)+2.0*(+0.0-SP_OV_x0_VS_BP_VD_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VD_S)+0.0*(-SP_OV_D0_VS_BP)+GOV2*(+0.0-SP_OV_D0_VS_BP_VD_S)));
  SP_OV_p_VS_BP_VS_BP=(+(+0.0*(xgs_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VS_BP)+0.0*(-SP_OV_x0_VS_BP)+2.0*(+0.0-SP_OV_x0_VS_BP_VS_BP))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VS_BP)+0.0*(-SP_OV_D0_VS_BP)+GOV2*(+0.0-SP_OV_D0_VS_BP_VS_BP)));
#endif
#endif
SP_OV_p=((2.0*(xgs_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
EXIT_IF_ISNAN(((2.0*(xgs_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_q_VGP_S=((((xgs_ov_VGP_S-SP_OV_x0_VGP_S)*(xgs_ov-SP_OV_x0))+((xgs_ov-SP_OV_x0)*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)))-(GOV2*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)));
#if defined(_DERIVATE2)
  SP_OV_q_VGP_S_VGP_S=(+(+(+xgs_ov_VGP_S_VGP_S-SP_OV_x0_VGP_S_VGP_S)*(xgs_ov-SP_OV_x0)+(xgs_ov_VGP_S-SP_OV_x0_VGP_S)*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+(xgs_ov_VGP_S-SP_OV_x0_VGP_S)*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+(xgs_ov-SP_OV_x0)*(+xgs_ov_VGP_S_VGP_S-SP_OV_x0_VGP_S_VGP_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_x0_VGP_S_VGP_S-0.0)+SP_OV_D0_VGP_S_VGP_S)));
  SP_OV_q_VGP_S_VD_S=(+(+(+0.0-SP_OV_x0_VGP_S_VD_S)*(xgs_ov-SP_OV_x0)+(xgs_ov_VGP_S-SP_OV_x0_VGP_S)*(-SP_OV_x0_VD_S)+(-SP_OV_x0_VD_S)*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+(xgs_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VGP_S_VD_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_x0_VGP_S_VD_S-0.0)+SP_OV_D0_VGP_S_VD_S)));
  SP_OV_q_VGP_S_VS_BP=(+(+(+0.0-SP_OV_x0_VGP_S_VS_BP)*(xgs_ov-SP_OV_x0)+(xgs_ov_VGP_S-SP_OV_x0_VGP_S)*(-SP_OV_x0_VS_BP)+(-SP_OV_x0_VS_BP)*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+(xgs_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VGP_S_VS_BP))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_x0_VGP_S_VS_BP-0.0)+SP_OV_D0_VGP_S_VS_BP)));
#endif
SP_OV_q_VD_S=((((-SP_OV_x0_VD_S)*(xgs_ov-SP_OV_x0))+((xgs_ov-SP_OV_x0)*(-SP_OV_x0_VD_S)))-(GOV2*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)));
#if defined(_DERIVATE2)
  SP_OV_q_VD_S_VGP_S=(+(+(+0.0-SP_OV_x0_VD_S_VGP_S)*(xgs_ov-SP_OV_x0)+(-SP_OV_x0_VD_S)*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+(xgs_ov_VGP_S-SP_OV_x0_VGP_S)*(-SP_OV_x0_VD_S)+(xgs_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VD_S_VGP_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_x0_VD_S_VGP_S-0.0)+SP_OV_D0_VD_S_VGP_S)));
  SP_OV_q_VD_S_VD_S=(+(+(+0.0-SP_OV_x0_VD_S_VD_S)*(xgs_ov-SP_OV_x0)+(-SP_OV_x0_VD_S)*(-SP_OV_x0_VD_S)+(-SP_OV_x0_VD_S)*(-SP_OV_x0_VD_S)+(xgs_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VD_S_VD_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_x0_VD_S_VD_S-0.0)+SP_OV_D0_VD_S_VD_S)));
  SP_OV_q_VD_S_VS_BP=(+(+(+0.0-SP_OV_x0_VD_S_VS_BP)*(xgs_ov-SP_OV_x0)+(-SP_OV_x0_VD_S)*(-SP_OV_x0_VS_BP)+(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VD_S)+(xgs_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VD_S_VS_BP))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_x0_VD_S_VS_BP-0.0)+SP_OV_D0_VD_S_VS_BP)));
#endif
SP_OV_q_VS_BP=((((-SP_OV_x0_VS_BP)*(xgs_ov-SP_OV_x0))+((xgs_ov-SP_OV_x0)*(-SP_OV_x0_VS_BP)))-(GOV2*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)));
#if defined(_DERIVATE2)
  SP_OV_q_VS_BP_VGP_S=(+(+(+0.0-SP_OV_x0_VS_BP_VGP_S)*(xgs_ov-SP_OV_x0)+(-SP_OV_x0_VS_BP)*(xgs_ov_VGP_S-SP_OV_x0_VGP_S)+(xgs_ov_VGP_S-SP_OV_x0_VGP_S)*(-SP_OV_x0_VS_BP)+(xgs_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VS_BP_VGP_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_x0_VS_BP_VGP_S-0.0)+SP_OV_D0_VS_BP_VGP_S)));
  SP_OV_q_VS_BP_VD_S=(+(+(+0.0-SP_OV_x0_VS_BP_VD_S)*(xgs_ov-SP_OV_x0)+(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VD_S)+(-SP_OV_x0_VD_S)*(-SP_OV_x0_VS_BP)+(xgs_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VS_BP_VD_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_x0_VS_BP_VD_S-0.0)+SP_OV_D0_VS_BP_VD_S)));
  SP_OV_q_VS_BP_VS_BP=(+(+(+0.0-SP_OV_x0_VS_BP_VS_BP)*(xgs_ov-SP_OV_x0)+(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VS_BP)+(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VS_BP)+(xgs_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VS_BP_VS_BP))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_x0_VS_BP_VS_BP-0.0)+SP_OV_D0_VS_BP_VS_BP)));
#endif
#endif
SP_OV_q=(((xgs_ov-SP_OV_x0)*(xgs_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
EXIT_IF_ISNAN((((xgs_ov-SP_OV_x0)*(xgs_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_xi_VGP_S=(-((GOV2*0.5)*SP_OV_D0_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_xi_VGP_S_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VGP_S));
  SP_OV_xi_VGP_S_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VD_S));
  SP_OV_xi_VGP_S_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VS_BP));
#endif
SP_OV_xi_VD_S=(-((GOV2*0.5)*SP_OV_D0_VD_S));
#if defined(_DERIVATE2)
  SP_OV_xi_VD_S_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VGP_S));
  SP_OV_xi_VD_S_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VD_S));
  SP_OV_xi_VD_S_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VS_BP));
#endif
SP_OV_xi_VS_BP=(-((GOV2*0.5)*SP_OV_D0_VS_BP));
#if defined(_DERIVATE2)
  SP_OV_xi_VS_BP_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VGP_S));
  SP_OV_xi_VS_BP_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VD_S));
  SP_OV_xi_VS_BP_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VS_BP));
#endif
#endif
SP_OV_xi=(1.0-((GOV2*0.5)*SP_OV_D0));
EXIT_IF_ISNAN((1.0-((GOV2*0.5)*SP_OV_D0)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(((SP_OV_p_VGP_S*SP_OV_p)+(SP_OV_p*SP_OV_p_VGP_S))-(4.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))));
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(+(+SP_OV_p_VGP_S_VGP_S*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VGP_S*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VGP_S)));
  SP_OV_temp_VGP_S_VD_S=(+(+SP_OV_p_VGP_S_VD_S*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VD_S*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VD_S)));
  SP_OV_temp_VGP_S_VS_BP=(+(+SP_OV_p_VGP_S_VS_BP*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VS_BP*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VS_BP)));
#endif
SP_OV_temp_VD_S=(((SP_OV_p_VD_S*SP_OV_p)+(SP_OV_p*SP_OV_p_VD_S))-(4.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))));
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=(+(+SP_OV_p_VD_S_VGP_S*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VGP_S*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VGP_S)));
  SP_OV_temp_VD_S_VD_S=(+(+SP_OV_p_VD_S_VD_S*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VD_S*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VD_S)));
  SP_OV_temp_VD_S_VS_BP=(+(+SP_OV_p_VD_S_VS_BP*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VS_BP*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VS_BP)));
#endif
SP_OV_temp_VS_BP=(((SP_OV_p_VS_BP*SP_OV_p)+(SP_OV_p*SP_OV_p_VS_BP))-(4.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))));
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=(+(+SP_OV_p_VS_BP_VGP_S*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VGP_S*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VGP_S)));
  SP_OV_temp_VS_BP_VD_S=(+(+SP_OV_p_VS_BP_VD_S*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VD_S*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VD_S)));
  SP_OV_temp_VS_BP_VS_BP=(+(+SP_OV_p_VS_BP_VS_BP*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VS_BP*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VS_BP)));
#endif
#endif
SP_OV_temp=((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
EXIT_IF_ISNAN(((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q))))
{
double m00_sqrt(d00_sqrt0,SP_OV_temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,SP_OV_temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_u_VGP_S=(2.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_u_VGP_S_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VGP_S_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VGP_S_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
SP_OV_u_VD_S=(2.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_u_VD_S_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VD_S_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VD_S_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
SP_OV_u_VS_BP=(2.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_u_VS_BP_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VS_BP_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VS_BP_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
#endif
SP_OV_u=(2.0*(SP_OV_q/(SP_OV_p+d00_sqrt0)));
EXIT_IF_ISNAN((2.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xs_ov_VD_S=(SP_OV_x0_VD_S+SP_OV_u_VD_S);
#if defined(_DERIVATE2)
  xs_ov_VD_S_VD_S=(+SP_OV_x0_VD_S_VD_S+SP_OV_u_VD_S_VD_S);
  xs_ov_VD_S_VS_BP=(+SP_OV_x0_VD_S_VS_BP+SP_OV_u_VD_S_VS_BP);
  xs_ov_VD_S_VGP_S=(+SP_OV_x0_VD_S_VGP_S+SP_OV_u_VD_S_VGP_S);
#endif
xs_ov_VS_BP=(SP_OV_x0_VS_BP+SP_OV_u_VS_BP);
#if defined(_DERIVATE2)
  xs_ov_VS_BP_VD_S=(+SP_OV_x0_VS_BP_VD_S+SP_OV_u_VS_BP_VD_S);
  xs_ov_VS_BP_VS_BP=(+SP_OV_x0_VS_BP_VS_BP+SP_OV_u_VS_BP_VS_BP);
  xs_ov_VS_BP_VGP_S=(+SP_OV_x0_VS_BP_VGP_S+SP_OV_u_VS_BP_VGP_S);
#endif
xs_ov_VGP_S=(SP_OV_x0_VGP_S+SP_OV_u_VGP_S);
#if defined(_DERIVATE2)
  xs_ov_VGP_S_VD_S=(+SP_OV_x0_VGP_S_VD_S+SP_OV_u_VGP_S_VD_S);
  xs_ov_VGP_S_VS_BP=(+SP_OV_x0_VGP_S_VS_BP+SP_OV_u_VGP_S_VS_BP);
  xs_ov_VGP_S_VGP_S=(+SP_OV_x0_VGP_S_VGP_S+SP_OV_u_VGP_S_VGP_S);
#endif
#endif
xs_ov=(SP_OV_x0+SP_OV_u);
EXIT_IF_ISNAN((SP_OV_x0+SP_OV_u))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xs_ov_VD_S=(-xs_ov_VD_S);
#if defined(_DERIVATE2)
  xs_ov_VD_S_VD_S=0.0;
  xs_ov_VD_S_VS_BP=0.0;
  xs_ov_VD_S_VGP_S=0.0;
#endif
xs_ov_VS_BP=(-xs_ov_VS_BP);
#if defined(_DERIVATE2)
  xs_ov_VS_BP_VD_S=0.0;
  xs_ov_VS_BP_VS_BP=0.0;
  xs_ov_VS_BP_VGP_S=0.0;
#endif
xs_ov_VGP_S=(-xs_ov_VGP_S);
#if defined(_DERIVATE2)
  xs_ov_VGP_S_VD_S=0.0;
  xs_ov_VGP_S_VS_BP=0.0;
  xs_ov_VGP_S_VGP_S=0.0;
#endif
#endif
xs_ov=(-xs_ov);
EXIT_IF_ISNAN((-xs_ov))
}
}
GOV=pInst->GOV_d;
EXIT_IF_ISNAN(pInst->GOV_d)
GOV2=pInst->GOV2_d;
EXIT_IF_ISNAN(pInst->GOV2_d)
xi_ov=pInst->xi_ov_d;
EXIT_IF_ISNAN(pInst->xi_ov_d)
inv_xi_ov=pInst->inv_xi_ov_d;
EXIT_IF_ISNAN(pInst->inv_xi_ov_d)
x_mrg_ov=pInst->x_mrg_ov_d;
EXIT_IF_ISNAN(pInst->x_mrg_ov_d)
inv_xg1=pInst->inv_xg1_d;
EXIT_IF_ISNAN(pInst->inv_xg1_d)
{
double m00_fabs(d00_fabs0,xgd_ov)
if
((d00_fabs0<=x_mrg_ov))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xd_ov_VS_BP=0.0;
#if defined(_DERIVATE2)
  xd_ov_VS_BP_VS_BP=0.0;
  xd_ov_VS_BP_VGP_S=0.0;
  xd_ov_VS_BP_VD_S=0.0;
#endif
xd_ov_VGP_S=(-xgd_ov_VGP_S)*inv_xi_ov;
#if defined(_DERIVATE2)
  xd_ov_VGP_S_VS_BP=(+0.0*inv_xi_ov+(-xgd_ov_VGP_S)*0.0+0.0*0.0+(-xgd_ov)*0.0);
  xd_ov_VGP_S_VGP_S=(+0.0*inv_xi_ov+(-xgd_ov_VGP_S)*0.0+(-xgd_ov_VGP_S)*0.0+(-xgd_ov)*0.0);
  xd_ov_VGP_S_VD_S=(+0.0*inv_xi_ov+(-xgd_ov_VGP_S)*0.0+(-xgd_ov_VD_S)*0.0+(-xgd_ov)*0.0);
#endif
xd_ov_VD_S=(-xgd_ov_VD_S)*inv_xi_ov;
#if defined(_DERIVATE2)
  xd_ov_VD_S_VS_BP=(+0.0*inv_xi_ov+(-xgd_ov_VD_S)*0.0+0.0*0.0+(-xgd_ov)*0.0);
  xd_ov_VD_S_VGP_S=(+0.0*inv_xi_ov+(-xgd_ov_VD_S)*0.0+(-xgd_ov_VGP_S)*0.0+(-xgd_ov)*0.0);
  xd_ov_VD_S_VD_S=(+0.0*inv_xi_ov+(-xgd_ov_VD_S)*0.0+(-xgd_ov_VD_S)*0.0+(-xgd_ov)*0.0);
#endif
#endif
xd_ov=((-xgd_ov)*inv_xi_ov);
EXIT_IF_ISNAN(((-xgd_ov)*inv_xi_ov))
}
else
{
if
((xgd_ov<(-x_mrg_ov)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_yg_VD_S=(-xgd_ov_VD_S);
#if defined(_DERIVATE2)
  SP_OV_yg_VD_S_VD_S=0.0;
  SP_OV_yg_VD_S_VGP_S=0.0;
#endif
SP_OV_yg_VGP_S=(-xgd_ov_VGP_S);
#if defined(_DERIVATE2)
  SP_OV_yg_VGP_S_VD_S=0.0;
  SP_OV_yg_VGP_S_VGP_S=0.0;
#endif
#endif
SP_OV_yg=(-xgd_ov);
EXIT_IF_ISNAN((-xgd_ov))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_z_VD_S=(pInst->x1*SP_OV_yg_VD_S)*inv_xi_ov;
#if defined(_DERIVATE2)
  SP_OV_z_VD_S_VD_S=(+(+0.0*SP_OV_yg+0.0*SP_OV_yg_VD_S+0.0*SP_OV_yg_VD_S+pInst->x1*SP_OV_yg_VD_S_VD_S)*inv_xi_ov+(pInst->x1*SP_OV_yg_VD_S)*0.0+((pInst->x1*SP_OV_yg_VD_S))*0.0+(pInst->x1*SP_OV_yg)*0.0);
  SP_OV_z_VD_S_VGP_S=(+(+0.0*SP_OV_yg+0.0*SP_OV_yg_VGP_S+0.0*SP_OV_yg_VD_S+pInst->x1*SP_OV_yg_VD_S_VGP_S)*inv_xi_ov+(pInst->x1*SP_OV_yg_VD_S)*0.0+((pInst->x1*SP_OV_yg_VGP_S))*0.0+(pInst->x1*SP_OV_yg)*0.0);
#endif
SP_OV_z_VGP_S=(pInst->x1*SP_OV_yg_VGP_S)*inv_xi_ov;
#if defined(_DERIVATE2)
  SP_OV_z_VGP_S_VD_S=(+(+0.0*SP_OV_yg+0.0*SP_OV_yg_VD_S+0.0*SP_OV_yg_VGP_S+pInst->x1*SP_OV_yg_VGP_S_VD_S)*inv_xi_ov+(pInst->x1*SP_OV_yg_VGP_S)*0.0+((pInst->x1*SP_OV_yg_VD_S))*0.0+(pInst->x1*SP_OV_yg)*0.0);
  SP_OV_z_VGP_S_VGP_S=(+(+0.0*SP_OV_yg+0.0*SP_OV_yg_VGP_S+0.0*SP_OV_yg_VGP_S+pInst->x1*SP_OV_yg_VGP_S_VGP_S)*inv_xi_ov+(pInst->x1*SP_OV_yg_VGP_S)*0.0+((pInst->x1*SP_OV_yg_VGP_S))*0.0+(pInst->x1*SP_OV_yg)*0.0);
#endif
#endif
SP_OV_z=((pInst->x1*SP_OV_yg)*inv_xi_ov);
EXIT_IF_ISNAN(((pInst->x1*SP_OV_yg)*inv_xi_ov))
{
double m00_sqrt(d00_sqrt0,(((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_eta_VD_S=(0.5*(SP_OV_z_VD_S-((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_eta_VD_S_VD_S=(+0.0*((SP_OV_z+10.0)-d00_sqrt0)+0.0*(SP_OV_z_VD_S-(((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S)))*d10_sqrt0)+0.0*(SP_OV_z_VD_S-((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S))*d10_sqrt0)+0.5*(+(+SP_OV_z_VD_S_VD_S+0.0)-(m20_sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))*(((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S)))*((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S))+d10_sqrt0*(+(+(+SP_OV_z_VD_S_VD_S-0.0)*(SP_OV_z-6.0)+SP_OV_z_VD_S*SP_OV_z_VD_S+SP_OV_z_VD_S*SP_OV_z_VD_S+(SP_OV_z-6.0)*(+SP_OV_z_VD_S_VD_S-0.0))+0.0))));
  SP_OV_eta_VD_S_VGP_S=(+0.0*((SP_OV_z+10.0)-d00_sqrt0)+0.0*(SP_OV_z_VGP_S-(((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S)))*d10_sqrt0)+0.0*(SP_OV_z_VD_S-((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S))*d10_sqrt0)+0.5*(+(+SP_OV_z_VD_S_VGP_S+0.0)-(m20_sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))*(((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S)))*((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S))+d10_sqrt0*(+(+(+SP_OV_z_VD_S_VGP_S-0.0)*(SP_OV_z-6.0)+SP_OV_z_VD_S*SP_OV_z_VGP_S+SP_OV_z_VGP_S*SP_OV_z_VD_S+(SP_OV_z-6.0)*(+SP_OV_z_VD_S_VGP_S-0.0))+0.0))));
#endif
SP_OV_eta_VGP_S=(0.5*(SP_OV_z_VGP_S-((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_eta_VGP_S_VD_S=(+0.0*((SP_OV_z+10.0)-d00_sqrt0)+0.0*(SP_OV_z_VD_S-(((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S)))*d10_sqrt0)+0.0*(SP_OV_z_VGP_S-((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))*d10_sqrt0)+0.5*(+(+SP_OV_z_VGP_S_VD_S+0.0)-(m20_sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))*(((SP_OV_z_VD_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VD_S)))*((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))+d10_sqrt0*(+(+(+SP_OV_z_VGP_S_VD_S-0.0)*(SP_OV_z-6.0)+SP_OV_z_VGP_S*SP_OV_z_VD_S+SP_OV_z_VD_S*SP_OV_z_VGP_S+(SP_OV_z-6.0)*(+SP_OV_z_VGP_S_VD_S-0.0))+0.0))));
  SP_OV_eta_VGP_S_VGP_S=(+0.0*((SP_OV_z+10.0)-d00_sqrt0)+0.0*(SP_OV_z_VGP_S-(((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S)))*d10_sqrt0)+0.0*(SP_OV_z_VGP_S-((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))*d10_sqrt0)+0.5*(+(+SP_OV_z_VGP_S_VGP_S+0.0)-(m20_sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0))*(((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S)))*((SP_OV_z_VGP_S*(SP_OV_z-6.0))+((SP_OV_z-6.0)*SP_OV_z_VGP_S))+d10_sqrt0*(+(+(+SP_OV_z_VGP_S_VGP_S-0.0)*(SP_OV_z-6.0)+SP_OV_z_VGP_S*SP_OV_z_VGP_S+SP_OV_z_VGP_S*SP_OV_z_VGP_S+(SP_OV_z-6.0)*(+SP_OV_z_VGP_S_VGP_S-0.0))+0.0))));
#endif
#endif
SP_OV_eta=(0.5*((SP_OV_z+10.0)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((SP_OV_z+10.0)-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_a_VD_S=((((SP_OV_yg_VD_S-SP_OV_eta_VD_S)*(SP_OV_yg-SP_OV_eta))+((SP_OV_yg-SP_OV_eta)*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)))+(GOV2*SP_OV_eta_VD_S));
#if defined(_DERIVATE2)
  SP_OV_a_VD_S_VD_S=(+(+(+SP_OV_yg_VD_S_VD_S-SP_OV_eta_VD_S_VD_S)*(SP_OV_yg-SP_OV_eta)+(SP_OV_yg_VD_S-SP_OV_eta_VD_S)*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+(SP_OV_yg_VD_S-SP_OV_eta_VD_S)*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+(SP_OV_yg-SP_OV_eta)*(+SP_OV_yg_VD_S_VD_S-SP_OV_eta_VD_S_VD_S))+(+0.0*(SP_OV_eta+1.0)+0.0*SP_OV_eta_VD_S+0.0*SP_OV_eta_VD_S+GOV2*(+SP_OV_eta_VD_S_VD_S+0.0)));
  SP_OV_a_VD_S_VGP_S=(+(+(+SP_OV_yg_VD_S_VGP_S-SP_OV_eta_VD_S_VGP_S)*(SP_OV_yg-SP_OV_eta)+(SP_OV_yg_VD_S-SP_OV_eta_VD_S)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+(SP_OV_yg-SP_OV_eta)*(+SP_OV_yg_VD_S_VGP_S-SP_OV_eta_VD_S_VGP_S))+(+0.0*(SP_OV_eta+1.0)+0.0*SP_OV_eta_VGP_S+0.0*SP_OV_eta_VD_S+GOV2*(+SP_OV_eta_VD_S_VGP_S+0.0)));
#endif
SP_OV_a_VGP_S=((((SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg-SP_OV_eta))+((SP_OV_yg-SP_OV_eta)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)))+(GOV2*SP_OV_eta_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_a_VGP_S_VD_S=(+(+(+SP_OV_yg_VGP_S_VD_S-SP_OV_eta_VGP_S_VD_S)*(SP_OV_yg-SP_OV_eta)+(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+(SP_OV_yg_VD_S-SP_OV_eta_VD_S)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+(SP_OV_yg-SP_OV_eta)*(+SP_OV_yg_VGP_S_VD_S-SP_OV_eta_VGP_S_VD_S))+(+0.0*(SP_OV_eta+1.0)+0.0*SP_OV_eta_VD_S+0.0*SP_OV_eta_VGP_S+GOV2*(+SP_OV_eta_VGP_S_VD_S+0.0)));
  SP_OV_a_VGP_S_VGP_S=(+(+(+SP_OV_yg_VGP_S_VGP_S-SP_OV_eta_VGP_S_VGP_S)*(SP_OV_yg-SP_OV_eta)+(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+(SP_OV_yg-SP_OV_eta)*(+SP_OV_yg_VGP_S_VGP_S-SP_OV_eta_VGP_S_VGP_S))+(+0.0*(SP_OV_eta+1.0)+0.0*SP_OV_eta_VGP_S+0.0*SP_OV_eta_VGP_S+GOV2*(+SP_OV_eta_VGP_S_VGP_S+0.0)));
#endif
#endif
SP_OV_a=(((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
EXIT_IF_ISNAN((((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_c_VD_S=(2.0*(SP_OV_yg_VD_S-SP_OV_eta_VD_S));
#if defined(_DERIVATE2)
  SP_OV_c_VD_S_VD_S=(+(+0.0*(SP_OV_yg-SP_OV_eta)+0.0*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+0.0*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+2.0*(+SP_OV_yg_VD_S_VD_S-SP_OV_eta_VD_S_VD_S))-0.0);
  SP_OV_c_VD_S_VGP_S=(+(+0.0*(SP_OV_yg-SP_OV_eta)+0.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+0.0*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+2.0*(+SP_OV_yg_VD_S_VGP_S-SP_OV_eta_VD_S_VGP_S))-0.0);
#endif
SP_OV_c_VGP_S=(2.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_c_VGP_S_VD_S=(+(+0.0*(SP_OV_yg-SP_OV_eta)+0.0*(SP_OV_yg_VD_S-SP_OV_eta_VD_S)+0.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+2.0*(+SP_OV_yg_VGP_S_VD_S-SP_OV_eta_VGP_S_VD_S))-0.0);
  SP_OV_c_VGP_S_VGP_S=(+(+0.0*(SP_OV_yg-SP_OV_eta)+0.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+0.0*(SP_OV_yg_VGP_S-SP_OV_eta_VGP_S)+2.0*(+SP_OV_yg_VGP_S_VGP_S-SP_OV_eta_VGP_S_VGP_S))-0.0);
#endif
#endif
SP_OV_c=((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
EXIT_IF_ISNAN(((2.0*(SP_OV_yg-SP_OV_eta))-GOV2))
{
double m00_logE(d00_logE0,(SP_OV_a/GOV2))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(SP_OV_a/GOV2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_tau_VD_S=((SP_OV_a_VD_S/GOV2)*d10_logE0-SP_OV_eta_VD_S);
#if defined(_DERIVATE2)
  SP_OV_tau_VD_S_VD_S=(+(m20_logE((SP_OV_a/GOV2))*(SP_OV_a_VD_S/GOV2)*(SP_OV_a_VD_S/GOV2)+d10_logE0*(SP_OV_a_VD_S_VD_S/GOV2-(SP_OV_a_VD_S*0.0+SP_OV_a_VD_S*0.0+SP_OV_a*0.0)/GOV2/GOV2+2*SP_OV_a*0.0*0.0/GOV2/GOV2/GOV2))-SP_OV_eta_VD_S_VD_S);
  SP_OV_tau_VD_S_VGP_S=(+(m20_logE((SP_OV_a/GOV2))*(SP_OV_a_VGP_S/GOV2)*(SP_OV_a_VD_S/GOV2)+d10_logE0*(SP_OV_a_VD_S_VGP_S/GOV2-(SP_OV_a_VD_S*0.0+SP_OV_a_VGP_S*0.0+SP_OV_a*0.0)/GOV2/GOV2+2*SP_OV_a*0.0*0.0/GOV2/GOV2/GOV2))-SP_OV_eta_VD_S_VGP_S);
#endif
SP_OV_tau_VGP_S=((SP_OV_a_VGP_S/GOV2)*d10_logE0-SP_OV_eta_VGP_S);
#if defined(_DERIVATE2)
  SP_OV_tau_VGP_S_VD_S=(+(m20_logE((SP_OV_a/GOV2))*(SP_OV_a_VD_S/GOV2)*(SP_OV_a_VGP_S/GOV2)+d10_logE0*(SP_OV_a_VGP_S_VD_S/GOV2-(SP_OV_a_VGP_S*0.0+SP_OV_a_VD_S*0.0+SP_OV_a*0.0)/GOV2/GOV2+2*SP_OV_a*0.0*0.0/GOV2/GOV2/GOV2))-SP_OV_eta_VGP_S_VD_S);
  SP_OV_tau_VGP_S_VGP_S=(+(m20_logE((SP_OV_a/GOV2))*(SP_OV_a_VGP_S/GOV2)*(SP_OV_a_VGP_S/GOV2)+d10_logE0*(SP_OV_a_VGP_S_VGP_S/GOV2-(SP_OV_a_VGP_S*0.0+SP_OV_a_VGP_S*0.0+SP_OV_a*0.0)/GOV2/GOV2+2*SP_OV_a*0.0*0.0/GOV2/GOV2/GOV2))-SP_OV_eta_VGP_S_VGP_S);
#endif
#endif
SP_OV_tau=(d00_logE0-SP_OV_eta);
EXIT_IF_ISNAN((d00_logE0-SP_OV_eta))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
nu_VD_S=(SP_OV_a_VD_S+SP_OV_c_VD_S);
#if defined(_DERIVATE2)
  nu_VD_S_VD_S=(+SP_OV_a_VD_S_VD_S+SP_OV_c_VD_S_VD_S);
  nu_VD_S_VGP_S=(+SP_OV_a_VD_S_VGP_S+SP_OV_c_VD_S_VGP_S);
  nu_VD_S_VS_BP=(+0.0+0.0);
#endif
nu_VGP_S=(SP_OV_a_VGP_S+SP_OV_c_VGP_S);
#if defined(_DERIVATE2)
  nu_VGP_S_VD_S=(+SP_OV_a_VGP_S_VD_S+SP_OV_c_VGP_S_VD_S);
  nu_VGP_S_VGP_S=(+SP_OV_a_VGP_S_VGP_S+SP_OV_c_VGP_S_VGP_S);
  nu_VGP_S_VS_BP=(+0.0+0.0);
#endif
nu_VS_BP=0.0;
#if defined(_DERIVATE2)
  nu_VS_BP_VD_S=0.0;
  nu_VS_BP_VGP_S=0.0;
  nu_VS_BP_VS_BP=0.0;
#endif
#endif
nu=(SP_OV_a+SP_OV_c);
EXIT_IF_ISNAN((SP_OV_a+SP_OV_c))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
mutau_VD_S=(((nu_VD_S*nu)+(nu*nu_VD_S))+((SP_OV_tau_VD_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))+(SP_OV_tau*((0.5*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))-SP_OV_a_VD_S))));
#if defined(_DERIVATE2)
  mutau_VD_S_VD_S=(+(+nu_VD_S_VD_S*nu+nu_VD_S*nu_VD_S+nu_VD_S*nu_VD_S+nu*nu_VD_S_VD_S)+(+SP_OV_tau_VD_S_VD_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VD_S*(((0.5*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))))-SP_OV_a_VD_S)+SP_OV_tau_VD_S*((0.5*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))-SP_OV_a_VD_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))+0.0*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))+0.5*(+SP_OV_c_VD_S_VD_S*SP_OV_c+SP_OV_c_VD_S*SP_OV_c_VD_S+SP_OV_c_VD_S*SP_OV_c_VD_S+SP_OV_c*SP_OV_c_VD_S_VD_S))-SP_OV_a_VD_S_VD_S)));
  mutau_VD_S_VGP_S=(+(+nu_VD_S_VGP_S*nu+nu_VD_S*nu_VGP_S+nu_VGP_S*nu_VD_S+nu*nu_VD_S_VGP_S)+(+SP_OV_tau_VD_S_VGP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VD_S*(((0.5*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))))-SP_OV_a_VGP_S)+SP_OV_tau_VGP_S*((0.5*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))-SP_OV_a_VD_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))+0.0*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))+0.5*(+SP_OV_c_VD_S_VGP_S*SP_OV_c+SP_OV_c_VD_S*SP_OV_c_VGP_S+SP_OV_c_VGP_S*SP_OV_c_VD_S+SP_OV_c*SP_OV_c_VD_S_VGP_S))-SP_OV_a_VD_S_VGP_S)));
  mutau_VD_S_VS_BP=(+(+nu_VD_S_VS_BP*nu+nu_VD_S*nu_VS_BP+nu_VS_BP*nu_VD_S+nu*nu_VD_S_VS_BP)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VD_S*((0.5*(0.0)))+0.0*((0.5*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))-SP_OV_a_VD_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(0.0)+0.0*((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))+0.5*(+0.0*SP_OV_c+SP_OV_c_VD_S*0.0+0.0*SP_OV_c_VD_S+SP_OV_c*0.0))-0.0)));
#endif
mutau_VGP_S=(((nu_VGP_S*nu)+(nu*nu_VGP_S))+((SP_OV_tau_VGP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))+(SP_OV_tau*((0.5*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))-SP_OV_a_VGP_S))));
#if defined(_DERIVATE2)
  mutau_VGP_S_VD_S=(+(+nu_VGP_S_VD_S*nu+nu_VGP_S*nu_VD_S+nu_VD_S*nu_VGP_S+nu*nu_VGP_S_VD_S)+(+SP_OV_tau_VGP_S_VD_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VGP_S*(((0.5*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))))-SP_OV_a_VD_S)+SP_OV_tau_VD_S*((0.5*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))-SP_OV_a_VGP_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))+0.0*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))+0.5*(+SP_OV_c_VGP_S_VD_S*SP_OV_c+SP_OV_c_VGP_S*SP_OV_c_VD_S+SP_OV_c_VD_S*SP_OV_c_VGP_S+SP_OV_c*SP_OV_c_VGP_S_VD_S))-SP_OV_a_VGP_S_VD_S)));
  mutau_VGP_S_VGP_S=(+(+nu_VGP_S_VGP_S*nu+nu_VGP_S*nu_VGP_S+nu_VGP_S*nu_VGP_S+nu*nu_VGP_S_VGP_S)+(+SP_OV_tau_VGP_S_VGP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VGP_S*(((0.5*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))))-SP_OV_a_VGP_S)+SP_OV_tau_VGP_S*((0.5*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))-SP_OV_a_VGP_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))+0.0*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))+0.5*(+SP_OV_c_VGP_S_VGP_S*SP_OV_c+SP_OV_c_VGP_S*SP_OV_c_VGP_S+SP_OV_c_VGP_S*SP_OV_c_VGP_S+SP_OV_c*SP_OV_c_VGP_S_VGP_S))-SP_OV_a_VGP_S_VGP_S)));
  mutau_VGP_S_VS_BP=(+(+nu_VGP_S_VS_BP*nu+nu_VGP_S*nu_VS_BP+nu_VS_BP*nu_VGP_S+nu*nu_VGP_S_VS_BP)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+SP_OV_tau_VGP_S*((0.5*(0.0)))+0.0*((0.5*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))-SP_OV_a_VGP_S)+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(0.0)+0.0*((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))+0.5*(+0.0*SP_OV_c+SP_OV_c_VGP_S*0.0+0.0*SP_OV_c_VGP_S+SP_OV_c*0.0))-0.0)));
#endif
mutau_VS_BP=((nu_VS_BP*nu)+(nu*nu_VS_BP));
#if defined(_DERIVATE2)
  mutau_VS_BP_VD_S=(+(+nu_VS_BP_VD_S*nu+nu_VS_BP*nu_VD_S+nu_VD_S*nu_VS_BP+nu*nu_VS_BP_VD_S)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+0.0*(((0.5*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))))-SP_OV_a_VD_S)+SP_OV_tau_VD_S*0.0+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))+0.0*0.0+0.5*(+0.0*SP_OV_c+0.0*SP_OV_c_VD_S+SP_OV_c_VD_S*0.0+SP_OV_c*0.0))-0.0)));
  mutau_VS_BP_VGP_S=(+(+nu_VS_BP_VGP_S*nu+nu_VS_BP*nu_VGP_S+nu_VGP_S*nu_VS_BP+nu*nu_VS_BP_VGP_S)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+0.0*(((0.5*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))))-SP_OV_a_VGP_S)+SP_OV_tau_VGP_S*0.0+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))+0.0*0.0+0.5*(+0.0*SP_OV_c+0.0*SP_OV_c_VGP_S+SP_OV_c_VGP_S*0.0+SP_OV_c*0.0))-0.0)));
  mutau_VS_BP_VS_BP=(+(+nu_VS_BP_VS_BP*nu+nu_VS_BP*nu_VS_BP+nu_VS_BP*nu_VS_BP+nu*nu_VS_BP_VS_BP)+(+0.0*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)+0.0*((0.5*(0.0)))+0.0*0.0+SP_OV_tau*(+(+0.0*(SP_OV_c*SP_OV_c)+0.0*(0.0)+0.0*0.0+0.5*(+0.0*SP_OV_c+0.0*0.0+0.0*0.0+SP_OV_c*0.0))-0.0)));
#endif
#endif
mutau=((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
EXIT_IF_ISNAN(((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_y0_VGP_S=(SP_OV_eta_VGP_S+((((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S))*(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu)*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#if defined(_DERIVATE2)
  SP_OV_y0_VGP_S_VGP_S=(+SP_OV_eta_VGP_S_VGP_S+((+(+SP_OV_a_VGP_S_VGP_S*nu+SP_OV_a_VGP_S*nu_VGP_S+SP_OV_a_VGP_S*nu_VGP_S+SP_OV_a*nu_VGP_S_VGP_S)*SP_OV_tau+((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau_VGP_S+(((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau_VGP_S+(SP_OV_a*nu)*SP_OV_tau_VGP_S_VGP_S)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))+((((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VGP_S_VGP_S+(+(+(+(+(nu_VGP_S_VGP_S/mutau-(nu_VGP_S*mutau_VGP_S+nu_VGP_S*mutau_VGP_S+nu*mutau_VGP_S_VGP_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VGP_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau_VGP_S+(nu/mutau)*SP_OV_tau_VGP_S_VGP_S)*SP_OV_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau_VGP_S+((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S_VGP_S)*SP_OV_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c_VGP_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S_VGP_S)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+SP_OV_c_VGP_S_VGP_S*SP_OV_c+SP_OV_c_VGP_S*SP_OV_c_VGP_S+SP_OV_c_VGP_S*SP_OV_c_VGP_S+SP_OV_c*SP_OV_c_VGP_S_VGP_S)*3.3333333333333333e-01+((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*0.0+(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-SP_OV_a_VGP_S_VGP_S))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VGP_S_VD_S=(+SP_OV_eta_VGP_S_VD_S+((+(+SP_OV_a_VGP_S_VD_S*nu+SP_OV_a_VGP_S*nu_VD_S+SP_OV_a_VD_S*nu_VGP_S+SP_OV_a*nu_VGP_S_VD_S)*SP_OV_tau+((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau_VD_S+(((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau_VGP_S+(SP_OV_a*nu)*SP_OV_tau_VGP_S_VD_S)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))+((((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S)))*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VGP_S_VD_S+(+(+(+(+(nu_VGP_S_VD_S/mutau-(nu_VGP_S*mutau_VD_S+nu_VD_S*mutau_VGP_S+nu*mutau_VGP_S_VD_S)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VD_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau_VGP_S+(nu/mutau)*SP_OV_tau_VGP_S_VD_S)*SP_OV_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau_VGP_S+((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S_VD_S)*SP_OV_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c_VGP_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S_VD_S)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+SP_OV_c_VGP_S_VD_S*SP_OV_c+SP_OV_c_VGP_S*SP_OV_c_VD_S+SP_OV_c_VD_S*SP_OV_c_VGP_S+SP_OV_c*SP_OV_c_VGP_S_VD_S)*3.3333333333333333e-01+((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*0.0+(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-SP_OV_a_VGP_S_VD_S))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VGP_S_VS_BP=(+0.0+((+(+0.0*nu+SP_OV_a_VGP_S*nu_VS_BP+0.0*nu_VGP_S+SP_OV_a*nu_VGP_S_VS_BP)*SP_OV_tau+((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*0.0+((SP_OV_a*nu_VS_BP))*SP_OV_tau_VGP_S+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))+(((SP_OV_a*nu_VS_BP))*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VGP_S_VS_BP+(+(+(+(+(nu_VGP_S_VS_BP/mutau-(nu_VGP_S*mutau_VS_BP+nu_VS_BP*mutau_VGP_S+nu*mutau_VGP_S_VS_BP)/mutau/mutau+2*nu*mutau_VGP_S*mutau_VS_BP/mutau/mutau/mutau)*SP_OV_tau+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*0.0+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau_VGP_S+(nu/mutau)*0.0)*SP_OV_tau+((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*0.0+(((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*0.0+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*((0.0)*3.3333333333333333e-01)+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+SP_OV_c_VGP_S*0.0+0.0*SP_OV_c_VGP_S+SP_OV_c*0.0)*3.3333333333333333e-01+((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*0.0+(0.0)*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VGP_S+((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S))*3.3333333333333333e-01-SP_OV_a_VGP_S))))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#endif
SP_OV_y0_VD_S=(SP_OV_eta_VD_S+((((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S))*(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu)*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#if defined(_DERIVATE2)
  SP_OV_y0_VD_S_VGP_S=(+SP_OV_eta_VD_S_VGP_S+((+(+SP_OV_a_VD_S_VGP_S*nu+SP_OV_a_VD_S*nu_VGP_S+SP_OV_a_VGP_S*nu_VD_S+SP_OV_a*nu_VD_S_VGP_S)*SP_OV_tau+((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau_VGP_S+(((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau_VD_S+(SP_OV_a*nu)*SP_OV_tau_VD_S_VGP_S)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))+((((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VD_S_VGP_S+(+(+(+(+(nu_VD_S_VGP_S/mutau-(nu_VD_S*mutau_VGP_S+nu_VGP_S*mutau_VD_S+nu*mutau_VD_S_VGP_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VGP_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau_VD_S+(nu/mutau)*SP_OV_tau_VD_S_VGP_S)*SP_OV_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau_VD_S+((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S_VGP_S)*SP_OV_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c_VD_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S_VGP_S)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+SP_OV_c_VD_S_VGP_S*SP_OV_c+SP_OV_c_VD_S*SP_OV_c_VGP_S+SP_OV_c_VGP_S*SP_OV_c_VD_S+SP_OV_c*SP_OV_c_VD_S_VGP_S)*3.3333333333333333e-01+((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*0.0+(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-SP_OV_a_VD_S_VGP_S))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VD_S_VD_S=(+SP_OV_eta_VD_S_VD_S+((+(+SP_OV_a_VD_S_VD_S*nu+SP_OV_a_VD_S*nu_VD_S+SP_OV_a_VD_S*nu_VD_S+SP_OV_a*nu_VD_S_VD_S)*SP_OV_tau+((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau_VD_S+(((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau_VD_S+(SP_OV_a*nu)*SP_OV_tau_VD_S_VD_S)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))+((((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S)))*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VD_S_VD_S+(+(+(+(+(nu_VD_S_VD_S/mutau-(nu_VD_S*mutau_VD_S+nu_VD_S*mutau_VD_S+nu*mutau_VD_S_VD_S)/mutau/mutau+2*nu*mutau_VD_S*mutau_VD_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau_VD_S+(nu/mutau)*SP_OV_tau_VD_S_VD_S)*SP_OV_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau_VD_S+((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S_VD_S)*SP_OV_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c_VD_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S_VD_S)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+SP_OV_c_VD_S_VD_S*SP_OV_c+SP_OV_c_VD_S*SP_OV_c_VD_S+SP_OV_c_VD_S*SP_OV_c_VD_S+SP_OV_c*SP_OV_c_VD_S_VD_S)*3.3333333333333333e-01+((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*0.0+(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-SP_OV_a_VD_S_VD_S))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VD_S_VS_BP=(+0.0+((+(+0.0*nu+SP_OV_a_VD_S*nu_VS_BP+0.0*nu_VD_S+SP_OV_a*nu_VD_S_VS_BP)*SP_OV_tau+((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*0.0+((SP_OV_a*nu_VS_BP))*SP_OV_tau_VD_S+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-(((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))+(((SP_OV_a*nu_VS_BP))*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VD_S_VS_BP+(+(+(+(+(nu_VD_S_VS_BP/mutau-(nu_VD_S*mutau_VS_BP+nu_VS_BP*mutau_VD_S+nu*mutau_VD_S_VS_BP)/mutau/mutau+2*nu*mutau_VD_S*mutau_VS_BP/mutau/mutau/mutau)*SP_OV_tau+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*0.0+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau_VD_S+(nu/mutau)*0.0)*SP_OV_tau+((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*0.0+(((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau_VD_S+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*0.0+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*((0.0)*3.3333333333333333e-01)+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+SP_OV_c_VD_S*0.0+0.0*SP_OV_c_VD_S+SP_OV_c*0.0)*3.3333333333333333e-01+((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*0.0+(0.0)*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VD_S+((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S))*3.3333333333333333e-01-SP_OV_a_VD_S))))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#endif
SP_OV_y0_VS_BP=(((SP_OV_a*nu_VS_BP)*SP_OV_tau*(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu)*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))));
#if defined(_DERIVATE2)
  SP_OV_y0_VS_BP_VGP_S=(+0.0+((+(+0.0*nu+0.0*nu_VGP_S+SP_OV_a_VGP_S*nu_VS_BP+SP_OV_a*nu_VS_BP_VGP_S)*SP_OV_tau+(SP_OV_a*nu_VS_BP)*SP_OV_tau_VGP_S+(((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*0.0+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu_VS_BP)*SP_OV_tau*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))+((((((SP_OV_a_VGP_S*nu)+(SP_OV_a*nu_VGP_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VGP_S)))*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VS_BP_VGP_S+(+(+(+(+(nu_VS_BP_VGP_S/mutau-(nu_VS_BP*mutau_VGP_S+nu_VGP_S*mutau_VS_BP+nu*mutau_VS_BP_VGP_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VGP_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau_VGP_S+((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*0.0+(nu/mutau)*0.0)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau_VGP_S+(((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*0.0+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c_VGP_S+((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*0.0+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)+(((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*0.0+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+0.0*SP_OV_c_VGP_S+SP_OV_c_VGP_S*0.0+SP_OV_c*0.0)*3.3333333333333333e-01+0.0*0.0+(((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))*(mutau_VGP_S+((((((((((((((nu_VGP_S*mutau-nu*mutau_VGP_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VGP_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VGP_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VGP_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VGP_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VGP_S)))*3.3333333333333333e-01)-SP_OV_a_VGP_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VS_BP_VD_S=(+0.0+((+(+0.0*nu+0.0*nu_VD_S+SP_OV_a_VD_S*nu_VS_BP+SP_OV_a*nu_VS_BP_VD_S)*SP_OV_tau+(SP_OV_a*nu_VS_BP)*SP_OV_tau_VD_S+(((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*0.0+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu_VS_BP)*SP_OV_tau*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))+((((((SP_OV_a_VD_S*nu)+(SP_OV_a*nu_VD_S)))*SP_OV_tau)+((SP_OV_a*nu)*SP_OV_tau_VD_S)))*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VS_BP_VD_S+(+(+(+(+(nu_VS_BP_VD_S/mutau-(nu_VS_BP*mutau_VD_S+nu_VD_S*mutau_VS_BP+nu*mutau_VS_BP_VD_S)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VD_S/mutau/mutau/mutau)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau_VD_S+((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*0.0+(nu/mutau)*0.0)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau_VD_S+(((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*0.0+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c_VD_S+((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*0.0+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)+(((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*0.0+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+0.0*SP_OV_c_VD_S+SP_OV_c_VD_S*0.0+SP_OV_c*0.0)*3.3333333333333333e-01+0.0*0.0+(((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))*(mutau_VD_S+((((((((((((((nu_VD_S*mutau-nu*mutau_VD_S)/mutau/mutau)*SP_OV_tau)+((nu/mutau)*SP_OV_tau_VD_S)))*SP_OV_tau)+(((nu/mutau)*SP_OV_tau)*SP_OV_tau_VD_S)))*SP_OV_c)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c_VD_S)))*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((((SP_OV_c_VD_S*SP_OV_c)+(SP_OV_c*SP_OV_c_VD_S)))*3.3333333333333333e-01)-SP_OV_a_VD_S)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
  SP_OV_y0_VS_BP_VS_BP=(+0.0+((+(+0.0*nu+0.0*nu_VS_BP+0.0*nu_VS_BP+SP_OV_a*nu_VS_BP_VS_BP)*SP_OV_tau+(SP_OV_a*nu_VS_BP)*0.0+((SP_OV_a*nu_VS_BP))*0.0+(SP_OV_a*nu)*0.0)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))-((SP_OV_a*nu_VS_BP)*SP_OV_tau*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))+(((SP_OV_a*nu_VS_BP))*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+((SP_OV_a*nu)*SP_OV_tau)*(+mutau_VS_BP_VS_BP+(+(+(+(+(nu_VS_BP_VS_BP/mutau-(nu_VS_BP*mutau_VS_BP+nu_VS_BP*mutau_VS_BP+nu*mutau_VS_BP_VS_BP)/mutau/mutau+2*nu*mutau_VS_BP*mutau_VS_BP/mutau/mutau/mutau)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*0.0+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*0.0+(nu/mutau)*0.0)*SP_OV_tau+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*0.0+(((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*0.0+((nu/mutau)*SP_OV_tau)*0.0)*SP_OV_c+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*0.0+((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*0.0+(((nu/mutau)*SP_OV_tau)*SP_OV_tau)*0.0)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*((0.0)*3.3333333333333333e-01)+(((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*0.0+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(+(+(+0.0*SP_OV_c+0.0*0.0+0.0*0.0+SP_OV_c*0.0)*3.3333333333333333e-01+0.0*0.0+(0.0)*0.0+(SP_OV_c*SP_OV_c)*0.0)-0.0))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))+2*((SP_OV_a*nu)*SP_OV_tau)*(mutau_VS_BP+((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))*(mutau_VS_BP+((((((((nu_VS_BP*mutau-nu*mutau_VS_BP)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((0.0)*3.3333333333333333e-01)))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
#endif
#endif
SP_OV_y0=(SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
EXIT_IF_ISNAN((SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))))
{
double m00_exp(d00_exp0,SP_OV_y0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_D0_VGP_S=SP_OV_y0_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VGP_S_VGP_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VGP_S*SP_OV_y0_VGP_S+d10_exp0*SP_OV_y0_VGP_S_VGP_S);
  SP_OV_D0_VGP_S_VD_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VD_S*SP_OV_y0_VGP_S+d10_exp0*SP_OV_y0_VGP_S_VD_S);
  SP_OV_D0_VGP_S_VS_BP=(m20_exp(SP_OV_y0)*SP_OV_y0_VS_BP*SP_OV_y0_VGP_S+d10_exp0*SP_OV_y0_VGP_S_VS_BP);
#endif
SP_OV_D0_VD_S=SP_OV_y0_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VD_S_VGP_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VGP_S*SP_OV_y0_VD_S+d10_exp0*SP_OV_y0_VD_S_VGP_S);
  SP_OV_D0_VD_S_VD_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VD_S*SP_OV_y0_VD_S+d10_exp0*SP_OV_y0_VD_S_VD_S);
  SP_OV_D0_VD_S_VS_BP=(m20_exp(SP_OV_y0)*SP_OV_y0_VS_BP*SP_OV_y0_VD_S+d10_exp0*SP_OV_y0_VD_S_VS_BP);
#endif
SP_OV_D0_VS_BP=SP_OV_y0_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VS_BP_VGP_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VGP_S*SP_OV_y0_VS_BP+d10_exp0*SP_OV_y0_VS_BP_VGP_S);
  SP_OV_D0_VS_BP_VD_S=(m20_exp(SP_OV_y0)*SP_OV_y0_VD_S*SP_OV_y0_VS_BP+d10_exp0*SP_OV_y0_VS_BP_VD_S);
  SP_OV_D0_VS_BP_VS_BP=(m20_exp(SP_OV_y0)*SP_OV_y0_VS_BP*SP_OV_y0_VS_BP+d10_exp0*SP_OV_y0_VS_BP_VS_BP);
#endif
#endif
SP_OV_D0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(SP_OV_yg_VGP_S-SP_OV_y0_VGP_S);
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(+SP_OV_yg_VGP_S_VGP_S-SP_OV_y0_VGP_S_VGP_S);
  SP_OV_temp_VGP_S_VD_S=(+SP_OV_yg_VGP_S_VD_S-SP_OV_y0_VGP_S_VD_S);
  SP_OV_temp_VGP_S_VS_BP=(+0.0-SP_OV_y0_VGP_S_VS_BP);
#endif
SP_OV_temp_VD_S=(SP_OV_yg_VD_S-SP_OV_y0_VD_S);
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=(+SP_OV_yg_VD_S_VGP_S-SP_OV_y0_VD_S_VGP_S);
  SP_OV_temp_VD_S_VD_S=(+SP_OV_yg_VD_S_VD_S-SP_OV_y0_VD_S_VD_S);
  SP_OV_temp_VD_S_VS_BP=(+0.0-SP_OV_y0_VD_S_VS_BP);
#endif
SP_OV_temp_VS_BP=(-SP_OV_y0_VS_BP);
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=(+0.0-SP_OV_y0_VS_BP_VGP_S);
  SP_OV_temp_VS_BP_VD_S=(+0.0-SP_OV_y0_VS_BP_VD_S);
  SP_OV_temp_VS_BP_VS_BP=(+0.0-SP_OV_y0_VS_BP_VS_BP);
#endif
#endif
SP_OV_temp=(SP_OV_yg-SP_OV_y0);
EXIT_IF_ISNAN((SP_OV_yg-SP_OV_y0))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_p_VGP_S=((2.0*SP_OV_temp_VGP_S)+(GOV2*SP_OV_D0_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_p_VGP_S_VGP_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VGP_S+0.0*SP_OV_temp_VGP_S+2.0*SP_OV_temp_VGP_S_VGP_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VGP_S+0.0*SP_OV_D0_VGP_S+GOV2*(+SP_OV_D0_VGP_S_VGP_S-0.0)));
  SP_OV_p_VGP_S_VD_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VD_S+0.0*SP_OV_temp_VGP_S+2.0*SP_OV_temp_VGP_S_VD_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VD_S+0.0*SP_OV_D0_VGP_S+GOV2*(+SP_OV_D0_VGP_S_VD_S-0.0)));
  SP_OV_p_VGP_S_VS_BP=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VS_BP+0.0*SP_OV_temp_VGP_S+2.0*SP_OV_temp_VGP_S_VS_BP)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VS_BP+0.0*SP_OV_D0_VGP_S+GOV2*(+SP_OV_D0_VGP_S_VS_BP-0.0)));
#endif
SP_OV_p_VD_S=((2.0*SP_OV_temp_VD_S)+(GOV2*SP_OV_D0_VD_S));
#if defined(_DERIVATE2)
  SP_OV_p_VD_S_VGP_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VGP_S+0.0*SP_OV_temp_VD_S+2.0*SP_OV_temp_VD_S_VGP_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VGP_S+0.0*SP_OV_D0_VD_S+GOV2*(+SP_OV_D0_VD_S_VGP_S-0.0)));
  SP_OV_p_VD_S_VD_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VD_S+0.0*SP_OV_temp_VD_S+2.0*SP_OV_temp_VD_S_VD_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VD_S+0.0*SP_OV_D0_VD_S+GOV2*(+SP_OV_D0_VD_S_VD_S-0.0)));
  SP_OV_p_VD_S_VS_BP=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VS_BP+0.0*SP_OV_temp_VD_S+2.0*SP_OV_temp_VD_S_VS_BP)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VS_BP+0.0*SP_OV_D0_VD_S+GOV2*(+SP_OV_D0_VD_S_VS_BP-0.0)));
#endif
SP_OV_p_VS_BP=((2.0*SP_OV_temp_VS_BP)+(GOV2*SP_OV_D0_VS_BP));
#if defined(_DERIVATE2)
  SP_OV_p_VS_BP_VGP_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VGP_S+0.0*SP_OV_temp_VS_BP+2.0*SP_OV_temp_VS_BP_VGP_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VGP_S+0.0*SP_OV_D0_VS_BP+GOV2*(+SP_OV_D0_VS_BP_VGP_S-0.0)));
  SP_OV_p_VS_BP_VD_S=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VD_S+0.0*SP_OV_temp_VS_BP+2.0*SP_OV_temp_VS_BP_VD_S)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VD_S+0.0*SP_OV_D0_VS_BP+GOV2*(+SP_OV_D0_VS_BP_VD_S-0.0)));
  SP_OV_p_VS_BP_VS_BP=(+(+0.0*SP_OV_temp+0.0*SP_OV_temp_VS_BP+0.0*SP_OV_temp_VS_BP+2.0*SP_OV_temp_VS_BP_VS_BP)+(+0.0*(SP_OV_D0-1.0)+0.0*SP_OV_D0_VS_BP+0.0*SP_OV_D0_VS_BP+GOV2*(+SP_OV_D0_VS_BP_VS_BP-0.0)));
#endif
#endif
SP_OV_p=((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
EXIT_IF_ISNAN(((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_q_VGP_S=(((SP_OV_temp_VGP_S*SP_OV_temp)+(SP_OV_temp*SP_OV_temp_VGP_S))+(GOV2*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)));
#if defined(_DERIVATE2)
  SP_OV_q_VGP_S_VGP_S=(+(+SP_OV_temp_VGP_S_VGP_S*SP_OV_temp+SP_OV_temp_VGP_S*SP_OV_temp_VGP_S+SP_OV_temp_VGP_S*SP_OV_temp_VGP_S+SP_OV_temp*SP_OV_temp_VGP_S_VGP_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_y0_VGP_S_VGP_S+0.0)-SP_OV_D0_VGP_S_VGP_S)));
  SP_OV_q_VGP_S_VD_S=(+(+SP_OV_temp_VGP_S_VD_S*SP_OV_temp+SP_OV_temp_VGP_S*SP_OV_temp_VD_S+SP_OV_temp_VD_S*SP_OV_temp_VGP_S+SP_OV_temp*SP_OV_temp_VGP_S_VD_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_y0_VGP_S_VD_S+0.0)-SP_OV_D0_VGP_S_VD_S)));
  SP_OV_q_VGP_S_VS_BP=(+(+SP_OV_temp_VGP_S_VS_BP*SP_OV_temp+SP_OV_temp_VGP_S*SP_OV_temp_VS_BP+SP_OV_temp_VS_BP*SP_OV_temp_VGP_S+SP_OV_temp*SP_OV_temp_VGP_S_VS_BP)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_y0_VGP_S_VS_BP+0.0)-SP_OV_D0_VGP_S_VS_BP)));
#endif
SP_OV_q_VD_S=(((SP_OV_temp_VD_S*SP_OV_temp)+(SP_OV_temp*SP_OV_temp_VD_S))+(GOV2*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)));
#if defined(_DERIVATE2)
  SP_OV_q_VD_S_VGP_S=(+(+SP_OV_temp_VD_S_VGP_S*SP_OV_temp+SP_OV_temp_VD_S*SP_OV_temp_VGP_S+SP_OV_temp_VGP_S*SP_OV_temp_VD_S+SP_OV_temp*SP_OV_temp_VD_S_VGP_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_y0_VD_S_VGP_S+0.0)-SP_OV_D0_VD_S_VGP_S)));
  SP_OV_q_VD_S_VD_S=(+(+SP_OV_temp_VD_S_VD_S*SP_OV_temp+SP_OV_temp_VD_S*SP_OV_temp_VD_S+SP_OV_temp_VD_S*SP_OV_temp_VD_S+SP_OV_temp*SP_OV_temp_VD_S_VD_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_y0_VD_S_VD_S+0.0)-SP_OV_D0_VD_S_VD_S)));
  SP_OV_q_VD_S_VS_BP=(+(+SP_OV_temp_VD_S_VS_BP*SP_OV_temp+SP_OV_temp_VD_S*SP_OV_temp_VS_BP+SP_OV_temp_VS_BP*SP_OV_temp_VD_S+SP_OV_temp*SP_OV_temp_VD_S_VS_BP)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_y0_VD_S_VS_BP+0.0)-SP_OV_D0_VD_S_VS_BP)));
#endif
SP_OV_q_VS_BP=(((SP_OV_temp_VS_BP*SP_OV_temp)+(SP_OV_temp*SP_OV_temp_VS_BP))+(GOV2*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)));
#if defined(_DERIVATE2)
  SP_OV_q_VS_BP_VGP_S=(+(+SP_OV_temp_VS_BP_VGP_S*SP_OV_temp+SP_OV_temp_VS_BP*SP_OV_temp_VGP_S+SP_OV_temp_VGP_S*SP_OV_temp_VS_BP+SP_OV_temp*SP_OV_temp_VS_BP_VGP_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VGP_S-SP_OV_D0_VGP_S)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_y0_VS_BP_VGP_S+0.0)-SP_OV_D0_VS_BP_VGP_S)));
  SP_OV_q_VS_BP_VD_S=(+(+SP_OV_temp_VS_BP_VD_S*SP_OV_temp+SP_OV_temp_VS_BP*SP_OV_temp_VD_S+SP_OV_temp_VD_S*SP_OV_temp_VS_BP+SP_OV_temp*SP_OV_temp_VS_BP_VD_S)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VD_S-SP_OV_D0_VD_S)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_y0_VS_BP_VD_S+0.0)-SP_OV_D0_VS_BP_VD_S)));
  SP_OV_q_VS_BP_VS_BP=(+(+SP_OV_temp_VS_BP_VS_BP*SP_OV_temp+SP_OV_temp_VS_BP*SP_OV_temp_VS_BP+SP_OV_temp_VS_BP*SP_OV_temp_VS_BP+SP_OV_temp*SP_OV_temp_VS_BP_VS_BP)+(+0.0*((SP_OV_y0+1.0)-SP_OV_D0)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+0.0*(SP_OV_y0_VS_BP-SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_y0_VS_BP_VS_BP+0.0)-SP_OV_D0_VS_BP_VS_BP)));
#endif
#endif
SP_OV_q=((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
EXIT_IF_ISNAN(((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_xi_VGP_S=(-((GOV2*0.5)*SP_OV_D0_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_xi_VGP_S_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VGP_S));
  SP_OV_xi_VGP_S_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VD_S));
  SP_OV_xi_VGP_S_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VS_BP));
#endif
SP_OV_xi_VD_S=(-((GOV2*0.5)*SP_OV_D0_VD_S));
#if defined(_DERIVATE2)
  SP_OV_xi_VD_S_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VGP_S));
  SP_OV_xi_VD_S_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VD_S));
  SP_OV_xi_VD_S_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VS_BP));
#endif
SP_OV_xi_VS_BP=(-((GOV2*0.5)*SP_OV_D0_VS_BP));
#if defined(_DERIVATE2)
  SP_OV_xi_VS_BP_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VGP_S));
  SP_OV_xi_VS_BP_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VD_S));
  SP_OV_xi_VS_BP_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VS_BP));
#endif
#endif
SP_OV_xi=(1.0-((GOV2*0.5)*SP_OV_D0));
EXIT_IF_ISNAN((1.0-((GOV2*0.5)*SP_OV_D0)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(((SP_OV_p_VGP_S*SP_OV_p)+(SP_OV_p*SP_OV_p_VGP_S))-(4.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))));
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(+(+SP_OV_p_VGP_S_VGP_S*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VGP_S*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VGP_S)));
  SP_OV_temp_VGP_S_VD_S=(+(+SP_OV_p_VGP_S_VD_S*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VD_S*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VD_S)));
  SP_OV_temp_VGP_S_VS_BP=(+(+SP_OV_p_VGP_S_VS_BP*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VS_BP*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VS_BP)));
#endif
SP_OV_temp_VD_S=(((SP_OV_p_VD_S*SP_OV_p)+(SP_OV_p*SP_OV_p_VD_S))-(4.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))));
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=(+(+SP_OV_p_VD_S_VGP_S*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VGP_S*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VGP_S)));
  SP_OV_temp_VD_S_VD_S=(+(+SP_OV_p_VD_S_VD_S*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VD_S*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VD_S)));
  SP_OV_temp_VD_S_VS_BP=(+(+SP_OV_p_VD_S_VS_BP*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VS_BP*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VS_BP)));
#endif
SP_OV_temp_VS_BP=(((SP_OV_p_VS_BP*SP_OV_p)+(SP_OV_p*SP_OV_p_VS_BP))-(4.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))));
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=(+(+SP_OV_p_VS_BP_VGP_S*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VGP_S*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VGP_S)));
  SP_OV_temp_VS_BP_VD_S=(+(+SP_OV_p_VS_BP_VD_S*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VD_S*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VD_S)));
  SP_OV_temp_VS_BP_VS_BP=(+(+SP_OV_p_VS_BP_VS_BP*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VS_BP*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VS_BP)));
#endif
#endif
SP_OV_temp=((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
EXIT_IF_ISNAN(((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q))))
{
double m00_sqrt(d00_sqrt0,SP_OV_temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,SP_OV_temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_w_VGP_S=(2.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_w_VGP_S_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VGP_S_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VGP_S_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
SP_OV_w_VD_S=(2.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_w_VD_S_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VD_S_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VD_S_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
SP_OV_w_VS_BP=(2.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_w_VS_BP_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VS_BP_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_w_VS_BP_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
#endif
SP_OV_w=(2.0*(SP_OV_q/(SP_OV_p+d00_sqrt0)));
EXIT_IF_ISNAN((2.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xd_ov_VS_BP=(-(SP_OV_y0_VS_BP+SP_OV_w_VS_BP));
#if defined(_DERIVATE2)
  xd_ov_VS_BP_VS_BP=0.0;
  xd_ov_VS_BP_VGP_S=0.0;
  xd_ov_VS_BP_VD_S=0.0;
#endif
xd_ov_VGP_S=(-(SP_OV_y0_VGP_S+SP_OV_w_VGP_S));
#if defined(_DERIVATE2)
  xd_ov_VGP_S_VS_BP=0.0;
  xd_ov_VGP_S_VGP_S=0.0;
  xd_ov_VGP_S_VD_S=0.0;
#endif
xd_ov_VD_S=(-(SP_OV_y0_VD_S+SP_OV_w_VD_S));
#if defined(_DERIVATE2)
  xd_ov_VD_S_VS_BP=0.0;
  xd_ov_VD_S_VGP_S=0.0;
  xd_ov_VD_S_VD_S=0.0;
#endif
#endif
xd_ov=(-(SP_OV_y0+SP_OV_w));
EXIT_IF_ISNAN((-(SP_OV_y0+SP_OV_w)))
}
else
{
SP_OV_Afac=((((xi_ov*pInst->x1)*inv_xg1)-1.0)*inv_xg1);
EXIT_IF_ISNAN(((((xi_ov*pInst->x1)*inv_xg1)-1.0)*inv_xg1))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_xbar_VD_S=((xgd_ov_VD_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgd_ov)))+((xgd_ov*inv_xi_ov)*(SP_OV_Afac*xgd_ov_VD_S)));
#if defined(_DERIVATE2)
  SP_OV_xbar_VD_S_VD_S=(+(+xgd_ov_VD_S_VD_S*inv_xi_ov+xgd_ov_VD_S*0.0+xgd_ov_VD_S*0.0+xgd_ov*0.0)*(1.0+(SP_OV_Afac*xgd_ov))+xgd_ov_VD_S*inv_xi_ov*((SP_OV_Afac*xgd_ov_VD_S))+(xgd_ov_VD_S*inv_xi_ov)*(SP_OV_Afac*xgd_ov_VD_S)+(xgd_ov*inv_xi_ov)*(+0.0+(+0.0*xgd_ov+0.0*xgd_ov_VD_S+0.0*xgd_ov_VD_S+SP_OV_Afac*xgd_ov_VD_S_VD_S)));
  SP_OV_xbar_VD_S_VGP_S=(+(+xgd_ov_VD_S_VGP_S*inv_xi_ov+xgd_ov_VD_S*0.0+xgd_ov_VGP_S*0.0+xgd_ov*0.0)*(1.0+(SP_OV_Afac*xgd_ov))+xgd_ov_VD_S*inv_xi_ov*((SP_OV_Afac*xgd_ov_VGP_S))+(xgd_ov_VGP_S*inv_xi_ov)*(SP_OV_Afac*xgd_ov_VD_S)+(xgd_ov*inv_xi_ov)*(+0.0+(+0.0*xgd_ov+0.0*xgd_ov_VGP_S+0.0*xgd_ov_VD_S+SP_OV_Afac*xgd_ov_VD_S_VGP_S)));
#endif
SP_OV_xbar_VGP_S=((xgd_ov_VGP_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgd_ov)))+((xgd_ov*inv_xi_ov)*(SP_OV_Afac*xgd_ov_VGP_S)));
#if defined(_DERIVATE2)
  SP_OV_xbar_VGP_S_VD_S=(+(+xgd_ov_VGP_S_VD_S*inv_xi_ov+xgd_ov_VGP_S*0.0+xgd_ov_VD_S*0.0+xgd_ov*0.0)*(1.0+(SP_OV_Afac*xgd_ov))+xgd_ov_VGP_S*inv_xi_ov*((SP_OV_Afac*xgd_ov_VD_S))+(xgd_ov_VD_S*inv_xi_ov)*(SP_OV_Afac*xgd_ov_VGP_S)+(xgd_ov*inv_xi_ov)*(+0.0+(+0.0*xgd_ov+0.0*xgd_ov_VD_S+0.0*xgd_ov_VGP_S+SP_OV_Afac*xgd_ov_VGP_S_VD_S)));
  SP_OV_xbar_VGP_S_VGP_S=(+(+xgd_ov_VGP_S_VGP_S*inv_xi_ov+xgd_ov_VGP_S*0.0+xgd_ov_VGP_S*0.0+xgd_ov*0.0)*(1.0+(SP_OV_Afac*xgd_ov))+xgd_ov_VGP_S*inv_xi_ov*((SP_OV_Afac*xgd_ov_VGP_S))+(xgd_ov_VGP_S*inv_xi_ov)*(SP_OV_Afac*xgd_ov_VGP_S)+(xgd_ov*inv_xi_ov)*(+0.0+(+0.0*xgd_ov+0.0*xgd_ov_VGP_S+0.0*xgd_ov_VGP_S+SP_OV_Afac*xgd_ov_VGP_S_VGP_S)));
#endif
#endif
SP_OV_xbar=((xgd_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
EXIT_IF_ISNAN(((xgd_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov))))
if
(((-SP_OV_xbar)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(-SP_OV_xbar))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(-SP_OV_xbar_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(m20_exp((-SP_OV_xbar))*(-SP_OV_xbar_VGP_S)*(-SP_OV_xbar_VGP_S)+d10_exp0*0.0);
  SP_OV_temp_VGP_S_VD_S=(m20_exp((-SP_OV_xbar))*(-SP_OV_xbar_VD_S)*(-SP_OV_xbar_VGP_S)+d10_exp0*0.0);
  SP_OV_temp_VGP_S_VS_BP=0.0;
#endif
SP_OV_temp_VD_S=(-SP_OV_xbar_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=(m20_exp((-SP_OV_xbar))*(-SP_OV_xbar_VGP_S)*(-SP_OV_xbar_VD_S)+d10_exp0*0.0);
  SP_OV_temp_VD_S_VD_S=(m20_exp((-SP_OV_xbar))*(-SP_OV_xbar_VD_S)*(-SP_OV_xbar_VD_S)+d10_exp0*0.0);
  SP_OV_temp_VD_S_VS_BP=0.0;
#endif
SP_OV_temp_VS_BP=0.0;
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=0.0;
  SP_OV_temp_VS_BP_VD_S=0.0;
  SP_OV_temp_VS_BP_VS_BP=0.0;
#endif
#endif
SP_OV_temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(-1.0e-100*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VGP_S))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_xbar_VGP_S))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VGP_S))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_xbar_VGP_S))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VGP_S))*0.0+(-(-SP_OV_xbar_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
  SP_OV_temp_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VGP_S))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_xbar_VD_S))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VGP_S))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_xbar_VD_S))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VGP_S))*0.0+(-(-SP_OV_xbar_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
  SP_OV_temp_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VGP_S))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))+0.0*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))+0.0*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VGP_S))*(0.0)+0.0*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VGP_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
#endif
SP_OV_temp_VD_S=(-1.0e-100*(((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VD_S))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_xbar_VGP_S))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VD_S))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_xbar_VGP_S))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VD_S))*0.0+(-(-SP_OV_xbar_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_xbar_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
  SP_OV_temp_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VD_S))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_xbar_VD_S))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VD_S))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_xbar_VD_S))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VD_S))*0.0+(-(-SP_OV_xbar_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*((-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
  SP_OV_temp_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))))+0.0*(((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))+(-(-SP_OV_xbar_VD_S))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))+0.0*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))+0.0*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))+(-(-SP_OV_xbar_VD_S))*(0.0)+0.0*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_xbar))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_xbar_VD_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_xbar_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.5*(((-(-SP_OV_xbar_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-SP_OV_xbar_VD_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*((0.5*((((-2.3025850929940458e+02)-(-SP_OV_xbar))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
#endif
SP_OV_temp_VS_BP=0.0;
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=0.0;
  SP_OV_temp_VS_BP_VD_S=0.0;
  SP_OV_temp_VS_BP_VS_BP=0.0;
#endif
#endif
SP_OV_temp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_w_VGP_S=(-SP_OV_temp_VGP_S);
#if defined(_DERIVATE2)
  SP_OV_w_VGP_S_VGP_S=(+0.0-SP_OV_temp_VGP_S_VGP_S);
  SP_OV_w_VGP_S_VD_S=(+0.0-SP_OV_temp_VGP_S_VD_S);
  SP_OV_w_VGP_S_VS_BP=(+0.0-SP_OV_temp_VGP_S_VS_BP);
#endif
SP_OV_w_VD_S=(-SP_OV_temp_VD_S);
#if defined(_DERIVATE2)
  SP_OV_w_VD_S_VGP_S=(+0.0-SP_OV_temp_VD_S_VGP_S);
  SP_OV_w_VD_S_VD_S=(+0.0-SP_OV_temp_VD_S_VD_S);
  SP_OV_w_VD_S_VS_BP=(+0.0-SP_OV_temp_VD_S_VS_BP);
#endif
SP_OV_w_VS_BP=(-SP_OV_temp_VS_BP);
#if defined(_DERIVATE2)
  SP_OV_w_VS_BP_VGP_S=(+0.0-SP_OV_temp_VS_BP_VGP_S);
  SP_OV_w_VS_BP_VD_S=(+0.0-SP_OV_temp_VS_BP_VD_S);
  SP_OV_w_VS_BP_VS_BP=(+0.0-SP_OV_temp_VS_BP_VS_BP);
#endif
#endif
SP_OV_w=(1.0-SP_OV_temp);
EXIT_IF_ISNAN((1.0-SP_OV_temp))
{
double m00_sqrt(d00_sqrt0,((xgd_ov+(GOV2*0.25))-SP_OV_w))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xgd_ov+(GOV2*0.25))-SP_OV_w))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_x0_VGP_S=(xgd_ov_VGP_S-(GOV*(xgd_ov_VGP_S-SP_OV_w_VGP_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_x0_VGP_S_VGP_S=(+(+xgd_ov_VGP_S_VGP_S+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgd_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*d10_sqrt0+0.0*(xgd_ov_VGP_S-SP_OV_w_VGP_S)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((xgd_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*(xgd_ov_VGP_S-SP_OV_w_VGP_S)+d10_sqrt0*(+(+xgd_ov_VGP_S_VGP_S+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VGP_S_VGP_S))));
  SP_OV_x0_VGP_S_VD_S=(+(+xgd_ov_VGP_S_VD_S+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgd_ov_VD_S+(0.0))-SP_OV_w_VD_S)*d10_sqrt0+0.0*(xgd_ov_VGP_S-SP_OV_w_VGP_S)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((xgd_ov_VD_S+(0.0))-SP_OV_w_VD_S)*(xgd_ov_VGP_S-SP_OV_w_VGP_S)+d10_sqrt0*(+(+xgd_ov_VGP_S_VD_S+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VGP_S_VD_S))));
  SP_OV_x0_VGP_S_VS_BP=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VS_BP)*d10_sqrt0+0.0*(xgd_ov_VGP_S-SP_OV_w_VGP_S)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VS_BP)*(xgd_ov_VGP_S-SP_OV_w_VGP_S)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VGP_S_VS_BP))));
#endif
SP_OV_x0_VD_S=(xgd_ov_VD_S-(GOV*(xgd_ov_VD_S-SP_OV_w_VD_S)*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_x0_VD_S_VGP_S=(+(+xgd_ov_VD_S_VGP_S+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgd_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*d10_sqrt0+0.0*(xgd_ov_VD_S-SP_OV_w_VD_S)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((xgd_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*(xgd_ov_VD_S-SP_OV_w_VD_S)+d10_sqrt0*(+(+xgd_ov_VD_S_VGP_S+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VD_S_VGP_S))));
  SP_OV_x0_VD_S_VD_S=(+(+xgd_ov_VD_S_VD_S+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgd_ov_VD_S+(0.0))-SP_OV_w_VD_S)*d10_sqrt0+0.0*(xgd_ov_VD_S-SP_OV_w_VD_S)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((xgd_ov_VD_S+(0.0))-SP_OV_w_VD_S)*(xgd_ov_VD_S-SP_OV_w_VD_S)+d10_sqrt0*(+(+xgd_ov_VD_S_VD_S+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VD_S_VD_S))));
  SP_OV_x0_VD_S_VS_BP=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VS_BP)*d10_sqrt0+0.0*(xgd_ov_VD_S-SP_OV_w_VD_S)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VS_BP)*(xgd_ov_VD_S-SP_OV_w_VD_S)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VD_S_VS_BP))));
#endif
SP_OV_x0_VS_BP=(-(GOV*(-SP_OV_w_VS_BP)*d10_sqrt0));
#if defined(_DERIVATE2)
  SP_OV_x0_VS_BP_VGP_S=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgd_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*d10_sqrt0+0.0*(-SP_OV_w_VS_BP)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((xgd_ov_VGP_S+(0.0))-SP_OV_w_VGP_S)*(-SP_OV_w_VS_BP)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VS_BP_VGP_S))));
  SP_OV_x0_VS_BP_VD_S=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((xgd_ov_VD_S+(0.0))-SP_OV_w_VD_S)*d10_sqrt0+0.0*(-SP_OV_w_VS_BP)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((xgd_ov_VD_S+(0.0))-SP_OV_w_VD_S)*(-SP_OV_w_VS_BP)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VS_BP_VD_S))));
  SP_OV_x0_VS_BP_VS_BP=(+(+0.0+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0))-(+0.0*d00_sqrt0+0.0*((0.0)-SP_OV_w_VS_BP)*d10_sqrt0+0.0*(-SP_OV_w_VS_BP)*d10_sqrt0+GOV*(m20_sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w))*((0.0)-SP_OV_w_VS_BP)*(-SP_OV_w_VS_BP)+d10_sqrt0*(+(+0.0+(+0.0*0.25+0.0*0.0+0.0*0.0+GOV2*0.0))-SP_OV_w_VS_BP_VS_BP))));
#endif
#endif
SP_OV_x0=((xgd_ov+(GOV2*0.5))-(GOV*d00_sqrt0));
EXIT_IF_ISNAN(((xgd_ov+(GOV2*0.5))-(GOV*d00_sqrt0)))
}
if
(((-SP_OV_x0)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(-SP_OV_x0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_D0_VGP_S=(-SP_OV_x0_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VGP_S_VGP_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VGP_S)*(-SP_OV_x0_VGP_S)+d10_exp0*0.0);
  SP_OV_D0_VGP_S_VD_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VD_S)*(-SP_OV_x0_VGP_S)+d10_exp0*0.0);
  SP_OV_D0_VGP_S_VS_BP=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VGP_S)+d10_exp0*0.0);
#endif
SP_OV_D0_VD_S=(-SP_OV_x0_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VD_S_VGP_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VGP_S)*(-SP_OV_x0_VD_S)+d10_exp0*0.0);
  SP_OV_D0_VD_S_VD_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VD_S)*(-SP_OV_x0_VD_S)+d10_exp0*0.0);
  SP_OV_D0_VD_S_VS_BP=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VD_S)+d10_exp0*0.0);
#endif
SP_OV_D0_VS_BP=(-SP_OV_x0_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  SP_OV_D0_VS_BP_VGP_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VGP_S)*(-SP_OV_x0_VS_BP)+d10_exp0*0.0);
  SP_OV_D0_VS_BP_VD_S=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VD_S)*(-SP_OV_x0_VS_BP)+d10_exp0*0.0);
  SP_OV_D0_VS_BP_VS_BP=(m20_exp((-SP_OV_x0))*(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VS_BP)+d10_exp0*0.0);
#endif
#endif
SP_OV_D0=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_D0_VGP_S=(-1.0e-100*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_D0_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VGP_S))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VGP_S))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VGP_S))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VGP_S))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VGP_S))*0.0+(-(-SP_OV_x0_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VGP_S))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VD_S))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VGP_S))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VD_S))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VGP_S))*0.0+(-(-SP_OV_x0_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VGP_S))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VS_BP))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VGP_S))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)+(-(-SP_OV_x0_VS_BP))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VGP_S))*0.0+(-(-SP_OV_x0_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#endif
SP_OV_D0_VD_S=(-1.0e-100*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_D0_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VD_S))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VGP_S))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VD_S))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VGP_S))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VD_S))*0.0+(-(-SP_OV_x0_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VD_S))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VD_S))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VD_S))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VD_S))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VD_S))*0.0+(-(-SP_OV_x0_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VD_S))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VS_BP))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VD_S))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)+(-(-SP_OV_x0_VS_BP))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VD_S))*0.0+(-(-SP_OV_x0_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#endif
SP_OV_D0_VS_BP=(-1.0e-100*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  SP_OV_D0_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VS_BP))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VGP_S))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VS_BP))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VGP_S))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VS_BP))*0.0+(-(-SP_OV_x0_VGP_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VS_BP))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VD_S))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VS_BP))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)+(-(-SP_OV_x0_VD_S))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VS_BP))*0.0+(-(-SP_OV_x0_VD_S))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VD_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
  SP_OV_D0_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))-(0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))+(-(-SP_OV_x0_VS_BP))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))))+(-(-SP_OV_x0_VS_BP))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+0.0*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))+(-(-SP_OV_x0_VS_BP))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)+(-(-SP_OV_x0_VS_BP))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(-SP_OV_x0))*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-(-SP_OV_x0_VS_BP))*0.0+(-(-SP_OV_x0_VS_BP))*0.0+((-2.3025850929940458e+02)-(-SP_OV_x0))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(0.5*(((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))*((((-(-SP_OV_x0_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((0.5*((((-(-SP_OV_x0_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(-SP_OV_x0))*((-(-SP_OV_x0_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
#endif
#endif
SP_OV_D0=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_p_VGP_S=((2.0*(xgd_ov_VGP_S-SP_OV_x0_VGP_S))+(GOV2*(-SP_OV_D0_VGP_S)));
#if defined(_DERIVATE2)
  SP_OV_p_VGP_S_VGP_S=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+0.0*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+2.0*(+xgd_ov_VGP_S_VGP_S-SP_OV_x0_VGP_S_VGP_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VGP_S)+0.0*(-SP_OV_D0_VGP_S)+GOV2*(+0.0-SP_OV_D0_VGP_S_VGP_S)));
  SP_OV_p_VGP_S_VD_S=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(xgd_ov_VD_S-SP_OV_x0_VD_S)+0.0*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+2.0*(+xgd_ov_VGP_S_VD_S-SP_OV_x0_VGP_S_VD_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VD_S)+0.0*(-SP_OV_D0_VGP_S)+GOV2*(+0.0-SP_OV_D0_VGP_S_VD_S)));
  SP_OV_p_VGP_S_VS_BP=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VS_BP)+0.0*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+2.0*(+0.0-SP_OV_x0_VGP_S_VS_BP))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VS_BP)+0.0*(-SP_OV_D0_VGP_S)+GOV2*(+0.0-SP_OV_D0_VGP_S_VS_BP)));
#endif
SP_OV_p_VD_S=((2.0*(xgd_ov_VD_S-SP_OV_x0_VD_S))+(GOV2*(-SP_OV_D0_VD_S)));
#if defined(_DERIVATE2)
  SP_OV_p_VD_S_VGP_S=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+0.0*(xgd_ov_VD_S-SP_OV_x0_VD_S)+2.0*(+xgd_ov_VD_S_VGP_S-SP_OV_x0_VD_S_VGP_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VGP_S)+0.0*(-SP_OV_D0_VD_S)+GOV2*(+0.0-SP_OV_D0_VD_S_VGP_S)));
  SP_OV_p_VD_S_VD_S=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(xgd_ov_VD_S-SP_OV_x0_VD_S)+0.0*(xgd_ov_VD_S-SP_OV_x0_VD_S)+2.0*(+xgd_ov_VD_S_VD_S-SP_OV_x0_VD_S_VD_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VD_S)+0.0*(-SP_OV_D0_VD_S)+GOV2*(+0.0-SP_OV_D0_VD_S_VD_S)));
  SP_OV_p_VD_S_VS_BP=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VS_BP)+0.0*(xgd_ov_VD_S-SP_OV_x0_VD_S)+2.0*(+0.0-SP_OV_x0_VD_S_VS_BP))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VS_BP)+0.0*(-SP_OV_D0_VD_S)+GOV2*(+0.0-SP_OV_D0_VD_S_VS_BP)));
#endif
SP_OV_p_VS_BP=((2.0*(-SP_OV_x0_VS_BP))+(GOV2*(-SP_OV_D0_VS_BP)));
#if defined(_DERIVATE2)
  SP_OV_p_VS_BP_VGP_S=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+0.0*(-SP_OV_x0_VS_BP)+2.0*(+0.0-SP_OV_x0_VS_BP_VGP_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VGP_S)+0.0*(-SP_OV_D0_VS_BP)+GOV2*(+0.0-SP_OV_D0_VS_BP_VGP_S)));
  SP_OV_p_VS_BP_VD_S=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(xgd_ov_VD_S-SP_OV_x0_VD_S)+0.0*(-SP_OV_x0_VS_BP)+2.0*(+0.0-SP_OV_x0_VS_BP_VD_S))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VD_S)+0.0*(-SP_OV_D0_VS_BP)+GOV2*(+0.0-SP_OV_D0_VS_BP_VD_S)));
  SP_OV_p_VS_BP_VS_BP=(+(+0.0*(xgd_ov-SP_OV_x0)+0.0*(-SP_OV_x0_VS_BP)+0.0*(-SP_OV_x0_VS_BP)+2.0*(+0.0-SP_OV_x0_VS_BP_VS_BP))+(+0.0*(1-SP_OV_D0)+0.0*(-SP_OV_D0_VS_BP)+0.0*(-SP_OV_D0_VS_BP)+GOV2*(+0.0-SP_OV_D0_VS_BP_VS_BP)));
#endif
#endif
SP_OV_p=((2.0*(xgd_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
EXIT_IF_ISNAN(((2.0*(xgd_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_q_VGP_S=((((xgd_ov_VGP_S-SP_OV_x0_VGP_S)*(xgd_ov-SP_OV_x0))+((xgd_ov-SP_OV_x0)*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)))-(GOV2*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)));
#if defined(_DERIVATE2)
  SP_OV_q_VGP_S_VGP_S=(+(+(+xgd_ov_VGP_S_VGP_S-SP_OV_x0_VGP_S_VGP_S)*(xgd_ov-SP_OV_x0)+(xgd_ov_VGP_S-SP_OV_x0_VGP_S)*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+(xgd_ov_VGP_S-SP_OV_x0_VGP_S)*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+(xgd_ov-SP_OV_x0)*(+xgd_ov_VGP_S_VGP_S-SP_OV_x0_VGP_S_VGP_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_x0_VGP_S_VGP_S-0.0)+SP_OV_D0_VGP_S_VGP_S)));
  SP_OV_q_VGP_S_VD_S=(+(+(+xgd_ov_VGP_S_VD_S-SP_OV_x0_VGP_S_VD_S)*(xgd_ov-SP_OV_x0)+(xgd_ov_VGP_S-SP_OV_x0_VGP_S)*(xgd_ov_VD_S-SP_OV_x0_VD_S)+(xgd_ov_VD_S-SP_OV_x0_VD_S)*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+(xgd_ov-SP_OV_x0)*(+xgd_ov_VGP_S_VD_S-SP_OV_x0_VGP_S_VD_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_x0_VGP_S_VD_S-0.0)+SP_OV_D0_VGP_S_VD_S)));
  SP_OV_q_VGP_S_VS_BP=(+(+(+0.0-SP_OV_x0_VGP_S_VS_BP)*(xgd_ov-SP_OV_x0)+(xgd_ov_VGP_S-SP_OV_x0_VGP_S)*(-SP_OV_x0_VS_BP)+(-SP_OV_x0_VS_BP)*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+(xgd_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VGP_S_VS_BP))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+GOV2*(+(+SP_OV_x0_VGP_S_VS_BP-0.0)+SP_OV_D0_VGP_S_VS_BP)));
#endif
SP_OV_q_VD_S=((((xgd_ov_VD_S-SP_OV_x0_VD_S)*(xgd_ov-SP_OV_x0))+((xgd_ov-SP_OV_x0)*(xgd_ov_VD_S-SP_OV_x0_VD_S)))-(GOV2*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)));
#if defined(_DERIVATE2)
  SP_OV_q_VD_S_VGP_S=(+(+(+xgd_ov_VD_S_VGP_S-SP_OV_x0_VD_S_VGP_S)*(xgd_ov-SP_OV_x0)+(xgd_ov_VD_S-SP_OV_x0_VD_S)*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+(xgd_ov_VGP_S-SP_OV_x0_VGP_S)*(xgd_ov_VD_S-SP_OV_x0_VD_S)+(xgd_ov-SP_OV_x0)*(+xgd_ov_VD_S_VGP_S-SP_OV_x0_VD_S_VGP_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_x0_VD_S_VGP_S-0.0)+SP_OV_D0_VD_S_VGP_S)));
  SP_OV_q_VD_S_VD_S=(+(+(+xgd_ov_VD_S_VD_S-SP_OV_x0_VD_S_VD_S)*(xgd_ov-SP_OV_x0)+(xgd_ov_VD_S-SP_OV_x0_VD_S)*(xgd_ov_VD_S-SP_OV_x0_VD_S)+(xgd_ov_VD_S-SP_OV_x0_VD_S)*(xgd_ov_VD_S-SP_OV_x0_VD_S)+(xgd_ov-SP_OV_x0)*(+xgd_ov_VD_S_VD_S-SP_OV_x0_VD_S_VD_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_x0_VD_S_VD_S-0.0)+SP_OV_D0_VD_S_VD_S)));
  SP_OV_q_VD_S_VS_BP=(+(+(+0.0-SP_OV_x0_VD_S_VS_BP)*(xgd_ov-SP_OV_x0)+(xgd_ov_VD_S-SP_OV_x0_VD_S)*(-SP_OV_x0_VS_BP)+(-SP_OV_x0_VS_BP)*(xgd_ov_VD_S-SP_OV_x0_VD_S)+(xgd_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VD_S_VS_BP))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+GOV2*(+(+SP_OV_x0_VD_S_VS_BP-0.0)+SP_OV_D0_VD_S_VS_BP)));
#endif
SP_OV_q_VS_BP=((((-SP_OV_x0_VS_BP)*(xgd_ov-SP_OV_x0))+((xgd_ov-SP_OV_x0)*(-SP_OV_x0_VS_BP)))-(GOV2*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)));
#if defined(_DERIVATE2)
  SP_OV_q_VS_BP_VGP_S=(+(+(+0.0-SP_OV_x0_VS_BP_VGP_S)*(xgd_ov-SP_OV_x0)+(-SP_OV_x0_VS_BP)*(xgd_ov_VGP_S-SP_OV_x0_VGP_S)+(xgd_ov_VGP_S-SP_OV_x0_VGP_S)*(-SP_OV_x0_VS_BP)+(xgd_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VS_BP_VGP_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VGP_S+SP_OV_D0_VGP_S)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_x0_VS_BP_VGP_S-0.0)+SP_OV_D0_VS_BP_VGP_S)));
  SP_OV_q_VS_BP_VD_S=(+(+(+0.0-SP_OV_x0_VS_BP_VD_S)*(xgd_ov-SP_OV_x0)+(-SP_OV_x0_VS_BP)*(xgd_ov_VD_S-SP_OV_x0_VD_S)+(xgd_ov_VD_S-SP_OV_x0_VD_S)*(-SP_OV_x0_VS_BP)+(xgd_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VS_BP_VD_S))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VD_S+SP_OV_D0_VD_S)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_x0_VS_BP_VD_S-0.0)+SP_OV_D0_VS_BP_VD_S)));
  SP_OV_q_VS_BP_VS_BP=(+(+(+0.0-SP_OV_x0_VS_BP_VS_BP)*(xgd_ov-SP_OV_x0)+(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VS_BP)+(-SP_OV_x0_VS_BP)*(-SP_OV_x0_VS_BP)+(xgd_ov-SP_OV_x0)*(+0.0-SP_OV_x0_VS_BP_VS_BP))-(+0.0*((SP_OV_x0-1.0)+SP_OV_D0)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+0.0*(SP_OV_x0_VS_BP+SP_OV_D0_VS_BP)+GOV2*(+(+SP_OV_x0_VS_BP_VS_BP-0.0)+SP_OV_D0_VS_BP_VS_BP)));
#endif
#endif
SP_OV_q=(((xgd_ov-SP_OV_x0)*(xgd_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
EXIT_IF_ISNAN((((xgd_ov-SP_OV_x0)*(xgd_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0))))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_xi_VGP_S=(-((GOV2*0.5)*SP_OV_D0_VGP_S));
#if defined(_DERIVATE2)
  SP_OV_xi_VGP_S_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VGP_S));
  SP_OV_xi_VGP_S_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VD_S));
  SP_OV_xi_VGP_S_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VGP_S+(GOV2*0.5)*SP_OV_D0_VGP_S_VS_BP));
#endif
SP_OV_xi_VD_S=(-((GOV2*0.5)*SP_OV_D0_VD_S));
#if defined(_DERIVATE2)
  SP_OV_xi_VD_S_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VGP_S));
  SP_OV_xi_VD_S_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VD_S));
  SP_OV_xi_VD_S_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VD_S+(GOV2*0.5)*SP_OV_D0_VD_S_VS_BP));
#endif
SP_OV_xi_VS_BP=(-((GOV2*0.5)*SP_OV_D0_VS_BP));
#if defined(_DERIVATE2)
  SP_OV_xi_VS_BP_VGP_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VGP_S+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VGP_S));
  SP_OV_xi_VS_BP_VD_S=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VD_S+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VD_S));
  SP_OV_xi_VS_BP_VS_BP=(+0.0-(+(+0.0*0.5+0.0*0.0+0.0*0.0+GOV2*0.0)*SP_OV_D0+0.0*SP_OV_D0_VS_BP+(0.0)*SP_OV_D0_VS_BP+(GOV2*0.5)*SP_OV_D0_VS_BP_VS_BP));
#endif
#endif
SP_OV_xi=(1.0-((GOV2*0.5)*SP_OV_D0));
EXIT_IF_ISNAN((1.0-((GOV2*0.5)*SP_OV_D0)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
SP_OV_temp_VGP_S=(((SP_OV_p_VGP_S*SP_OV_p)+(SP_OV_p*SP_OV_p_VGP_S))-(4.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))));
#if defined(_DERIVATE2)
  SP_OV_temp_VGP_S_VGP_S=(+(+SP_OV_p_VGP_S_VGP_S*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VGP_S*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VGP_S)));
  SP_OV_temp_VGP_S_VD_S=(+(+SP_OV_p_VGP_S_VD_S*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VD_S*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VD_S)));
  SP_OV_temp_VGP_S_VS_BP=(+(+SP_OV_p_VGP_S_VS_BP*SP_OV_p+SP_OV_p_VGP_S*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VGP_S+SP_OV_p*SP_OV_p_VGP_S_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S))+4.0*(+SP_OV_xi_VGP_S_VS_BP*SP_OV_q+SP_OV_xi_VGP_S*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VGP_S+SP_OV_xi*SP_OV_q_VGP_S_VS_BP)));
#endif
SP_OV_temp_VD_S=(((SP_OV_p_VD_S*SP_OV_p)+(SP_OV_p*SP_OV_p_VD_S))-(4.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))));
#if defined(_DERIVATE2)
  SP_OV_temp_VD_S_VGP_S=(+(+SP_OV_p_VD_S_VGP_S*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VGP_S*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VGP_S)));
  SP_OV_temp_VD_S_VD_S=(+(+SP_OV_p_VD_S_VD_S*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VD_S*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VD_S)));
  SP_OV_temp_VD_S_VS_BP=(+(+SP_OV_p_VD_S_VS_BP*SP_OV_p+SP_OV_p_VD_S*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VD_S+SP_OV_p*SP_OV_p_VD_S_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S))+4.0*(+SP_OV_xi_VD_S_VS_BP*SP_OV_q+SP_OV_xi_VD_S*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VD_S+SP_OV_xi*SP_OV_q_VD_S_VS_BP)));
#endif
SP_OV_temp_VS_BP=(((SP_OV_p_VS_BP*SP_OV_p)+(SP_OV_p*SP_OV_p_VS_BP))-(4.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))));
#if defined(_DERIVATE2)
  SP_OV_temp_VS_BP_VGP_S=(+(+SP_OV_p_VS_BP_VGP_S*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VGP_S+SP_OV_p_VGP_S*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VGP_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VGP_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VGP_S)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VGP_S*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VGP_S+SP_OV_xi_VGP_S*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VGP_S)));
  SP_OV_temp_VS_BP_VD_S=(+(+SP_OV_p_VS_BP_VD_S*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VD_S+SP_OV_p_VD_S*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VD_S)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VD_S*SP_OV_q)+(SP_OV_xi*SP_OV_q_VD_S)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VD_S*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VD_S+SP_OV_xi_VD_S*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VD_S)));
  SP_OV_temp_VS_BP_VS_BP=(+(+SP_OV_p_VS_BP_VS_BP*SP_OV_p+SP_OV_p_VS_BP*SP_OV_p_VS_BP+SP_OV_p_VS_BP*SP_OV_p_VS_BP+SP_OV_p*SP_OV_p_VS_BP_VS_BP)-(+0.0*(SP_OV_xi*SP_OV_q)+0.0*(((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP)))+0.0*((SP_OV_xi_VS_BP*SP_OV_q)+(SP_OV_xi*SP_OV_q_VS_BP))+4.0*(+SP_OV_xi_VS_BP_VS_BP*SP_OV_q+SP_OV_xi_VS_BP*SP_OV_q_VS_BP+SP_OV_xi_VS_BP*SP_OV_q_VS_BP+SP_OV_xi*SP_OV_q_VS_BP_VS_BP)));
#endif
#endif
SP_OV_temp=((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
EXIT_IF_ISNAN(((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q))))
{
double m00_sqrt(d00_sqrt0,SP_OV_temp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,SP_OV_temp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
SP_OV_u_VGP_S=(2.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_u_VGP_S_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VGP_S_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VGP_S_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VGP_S_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VGP_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VGP_S_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VGP_S+d10_sqrt0*SP_OV_temp_VGP_S_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
SP_OV_u_VD_S=(2.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_u_VD_S_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VD_S_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VD_S_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VD_S_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VD_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VD_S_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VD_S+d10_sqrt0*SP_OV_temp_VD_S_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
SP_OV_u_VS_BP=(2.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#if defined(_DERIVATE2)
  SP_OV_u_VS_BP_VGP_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VGP_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VGP_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)+SP_OV_q_VGP_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VGP_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VGP_S*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VGP_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VGP_S+SP_OV_temp_VGP_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VS_BP_VD_S=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VD_S*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VD_S/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)+SP_OV_q_VD_S*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VD_S+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VD_S*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VD_S)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VD_S+SP_OV_temp_VD_S*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
  SP_OV_u_VS_BP_VS_BP=(+0.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+0.0*((SP_OV_q_VS_BP*(SP_OV_p+d00_sqrt0)-SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0))+2.0*(SP_OV_q_VS_BP_VS_BP/(SP_OV_p+d00_sqrt0)-(SP_OV_q_VS_BP*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q_VS_BP*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)+SP_OV_q*(+SP_OV_p_VS_BP_VS_BP+(m20_sqrt(SP_OV_temp)*SP_OV_temp_VS_BP*SP_OV_temp_VS_BP+d10_sqrt0*SP_OV_temp_VS_BP_VS_BP)))/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)+2*SP_OV_q*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)*(SP_OV_p_VS_BP+SP_OV_temp_VS_BP*d10_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)/(SP_OV_p+d00_sqrt0)));
#endif
#endif
SP_OV_u=(2.0*(SP_OV_q/(SP_OV_p+d00_sqrt0)));
EXIT_IF_ISNAN((2.0*(SP_OV_q/(SP_OV_p+d00_sqrt0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xd_ov_VS_BP=(SP_OV_x0_VS_BP+SP_OV_u_VS_BP);
#if defined(_DERIVATE2)
  xd_ov_VS_BP_VS_BP=(+SP_OV_x0_VS_BP_VS_BP+SP_OV_u_VS_BP_VS_BP);
  xd_ov_VS_BP_VGP_S=(+SP_OV_x0_VS_BP_VGP_S+SP_OV_u_VS_BP_VGP_S);
  xd_ov_VS_BP_VD_S=(+SP_OV_x0_VS_BP_VD_S+SP_OV_u_VS_BP_VD_S);
#endif
xd_ov_VGP_S=(SP_OV_x0_VGP_S+SP_OV_u_VGP_S);
#if defined(_DERIVATE2)
  xd_ov_VGP_S_VS_BP=(+SP_OV_x0_VGP_S_VS_BP+SP_OV_u_VGP_S_VS_BP);
  xd_ov_VGP_S_VGP_S=(+SP_OV_x0_VGP_S_VGP_S+SP_OV_u_VGP_S_VGP_S);
  xd_ov_VGP_S_VD_S=(+SP_OV_x0_VGP_S_VD_S+SP_OV_u_VGP_S_VD_S);
#endif
xd_ov_VD_S=(SP_OV_x0_VD_S+SP_OV_u_VD_S);
#if defined(_DERIVATE2)
  xd_ov_VD_S_VS_BP=(+SP_OV_x0_VD_S_VS_BP+SP_OV_u_VD_S_VS_BP);
  xd_ov_VD_S_VGP_S=(+SP_OV_x0_VD_S_VGP_S+SP_OV_u_VD_S_VGP_S);
  xd_ov_VD_S_VD_S=(+SP_OV_x0_VD_S_VD_S+SP_OV_u_VD_S_VD_S);
#endif
#endif
xd_ov=(SP_OV_x0+SP_OV_u);
EXIT_IF_ISNAN((SP_OV_x0+SP_OV_u))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xd_ov_VS_BP=(-xd_ov_VS_BP);
#if defined(_DERIVATE2)
  xd_ov_VS_BP_VS_BP=0.0;
  xd_ov_VS_BP_VGP_S=0.0;
  xd_ov_VS_BP_VD_S=0.0;
#endif
xd_ov_VGP_S=(-xd_ov_VGP_S);
#if defined(_DERIVATE2)
  xd_ov_VGP_S_VS_BP=0.0;
  xd_ov_VGP_S_VGP_S=0.0;
  xd_ov_VGP_S_VD_S=0.0;
#endif
xd_ov_VD_S=(-xd_ov_VD_S);
#if defined(_DERIVATE2)
  xd_ov_VD_S_VS_BP=0.0;
  xd_ov_VD_S_VGP_S=0.0;
  xd_ov_VD_S_VD_S=0.0;
#endif
#endif
xd_ov=(-xd_ov);
EXIT_IF_ISNAN((-xd_ov))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vovs_VGP_S=((-pModel->phit)*(xgs_ov_VGP_S+xs_ov_VGP_S));
#if defined(_DERIVATE2)
  Vovs_VGP_S_VGP_S=(+0.0*(xgs_ov+xs_ov)+0.0*(xgs_ov_VGP_S+xs_ov_VGP_S)+0.0*(xgs_ov_VGP_S+xs_ov_VGP_S)+(-pModel->phit)*(+xgs_ov_VGP_S_VGP_S+xs_ov_VGP_S_VGP_S));
  Vovs_VGP_S_VD_S=(+0.0*(xgs_ov+xs_ov)+0.0*xs_ov_VD_S+0.0*(xgs_ov_VGP_S+xs_ov_VGP_S)+(-pModel->phit)*(+0.0+xs_ov_VGP_S_VD_S));
  Vovs_VGP_S_VS_BP=(+0.0*(xgs_ov+xs_ov)+0.0*xs_ov_VS_BP+0.0*(xgs_ov_VGP_S+xs_ov_VGP_S)+(-pModel->phit)*(+0.0+xs_ov_VGP_S_VS_BP));
#endif
Vovs_VD_S=((-pModel->phit)*xs_ov_VD_S);
#if defined(_DERIVATE2)
  Vovs_VD_S_VGP_S=(+0.0*(xgs_ov+xs_ov)+0.0*(xgs_ov_VGP_S+xs_ov_VGP_S)+0.0*xs_ov_VD_S+(-pModel->phit)*(+0.0+xs_ov_VD_S_VGP_S));
  Vovs_VD_S_VD_S=(+0.0*(xgs_ov+xs_ov)+0.0*xs_ov_VD_S+0.0*xs_ov_VD_S+(-pModel->phit)*(+0.0+xs_ov_VD_S_VD_S));
  Vovs_VD_S_VS_BP=(+0.0*(xgs_ov+xs_ov)+0.0*xs_ov_VS_BP+0.0*xs_ov_VD_S+(-pModel->phit)*(+0.0+xs_ov_VD_S_VS_BP));
#endif
Vovs_VS_BP=((-pModel->phit)*xs_ov_VS_BP);
#if defined(_DERIVATE2)
  Vovs_VS_BP_VGP_S=(+0.0*(xgs_ov+xs_ov)+0.0*(xgs_ov_VGP_S+xs_ov_VGP_S)+0.0*xs_ov_VS_BP+(-pModel->phit)*(+0.0+xs_ov_VS_BP_VGP_S));
  Vovs_VS_BP_VD_S=(+0.0*(xgs_ov+xs_ov)+0.0*xs_ov_VD_S+0.0*xs_ov_VS_BP+(-pModel->phit)*(+0.0+xs_ov_VS_BP_VD_S));
  Vovs_VS_BP_VS_BP=(+0.0*(xgs_ov+xs_ov)+0.0*xs_ov_VS_BP+0.0*xs_ov_VS_BP+(-pModel->phit)*(+0.0+xs_ov_VS_BP_VS_BP));
#endif
#endif
Vovs=((-pModel->phit)*(xgs_ov+xs_ov));
EXIT_IF_ISNAN(((-pModel->phit)*(xgs_ov+xs_ov)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vovd_VGP_S=((-pModel->phit)*(xgd_ov_VGP_S+xd_ov_VGP_S));
#if defined(_DERIVATE2)
  Vovd_VGP_S_VGP_S=(+0.0*(xgd_ov+xd_ov)+0.0*(xgd_ov_VGP_S+xd_ov_VGP_S)+0.0*(xgd_ov_VGP_S+xd_ov_VGP_S)+(-pModel->phit)*(+xgd_ov_VGP_S_VGP_S+xd_ov_VGP_S_VGP_S));
  Vovd_VGP_S_VD_S=(+0.0*(xgd_ov+xd_ov)+0.0*(xgd_ov_VD_S+xd_ov_VD_S)+0.0*(xgd_ov_VGP_S+xd_ov_VGP_S)+(-pModel->phit)*(+xgd_ov_VGP_S_VD_S+xd_ov_VGP_S_VD_S));
  Vovd_VGP_S_VS_BP=(+0.0*(xgd_ov+xd_ov)+0.0*xd_ov_VS_BP+0.0*(xgd_ov_VGP_S+xd_ov_VGP_S)+(-pModel->phit)*(+0.0+xd_ov_VGP_S_VS_BP));
#endif
Vovd_VD_S=((-pModel->phit)*(xgd_ov_VD_S+xd_ov_VD_S));
#if defined(_DERIVATE2)
  Vovd_VD_S_VGP_S=(+0.0*(xgd_ov+xd_ov)+0.0*(xgd_ov_VGP_S+xd_ov_VGP_S)+0.0*(xgd_ov_VD_S+xd_ov_VD_S)+(-pModel->phit)*(+xgd_ov_VD_S_VGP_S+xd_ov_VD_S_VGP_S));
  Vovd_VD_S_VD_S=(+0.0*(xgd_ov+xd_ov)+0.0*(xgd_ov_VD_S+xd_ov_VD_S)+0.0*(xgd_ov_VD_S+xd_ov_VD_S)+(-pModel->phit)*(+xgd_ov_VD_S_VD_S+xd_ov_VD_S_VD_S));
  Vovd_VD_S_VS_BP=(+0.0*(xgd_ov+xd_ov)+0.0*xd_ov_VS_BP+0.0*(xgd_ov_VD_S+xd_ov_VD_S)+(-pModel->phit)*(+0.0+xd_ov_VD_S_VS_BP));
#endif
Vovd_VS_BP=((-pModel->phit)*xd_ov_VS_BP);
#if defined(_DERIVATE2)
  Vovd_VS_BP_VGP_S=(+0.0*(xgd_ov+xd_ov)+0.0*(xgd_ov_VGP_S+xd_ov_VGP_S)+0.0*xd_ov_VS_BP+(-pModel->phit)*(+0.0+xd_ov_VS_BP_VGP_S));
  Vovd_VS_BP_VD_S=(+0.0*(xgd_ov+xd_ov)+0.0*(xgd_ov_VD_S+xd_ov_VD_S)+0.0*xd_ov_VS_BP+(-pModel->phit)*(+0.0+xd_ov_VS_BP_VD_S));
  Vovd_VS_BP_VS_BP=(+0.0*(xgd_ov+xd_ov)+0.0*xd_ov_VS_BP+0.0*xd_ov_VS_BP+(-pModel->phit)*(+0.0+xd_ov_VS_BP_VS_BP));
#endif
#endif
Vovd=((-pModel->phit)*(xgd_ov+xd_ov));
EXIT_IF_ISNAN(((-pModel->phit)*(xgd_ov+xd_ov)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igsov_VGP_S=0.0;
#if defined(_DERIVATE2)
  Igsov_VGP_S_VGP_S=0.0;
  Igsov_VGP_S_VD_S=0.0;
  Igsov_VGP_S_VS_BP=0.0;
#endif
Igsov_VD_S=0.0;
#if defined(_DERIVATE2)
  Igsov_VD_S_VGP_S=0.0;
  Igsov_VD_S_VD_S=0.0;
  Igsov_VD_S_VS_BP=0.0;
#endif
Igsov_VS_BP=0.0;
#if defined(_DERIVATE2)
  Igsov_VS_BP_VGP_S=0.0;
  Igsov_VS_BP_VD_S=0.0;
  Igsov_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Igsov=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igdov_VGP_S=0.0;
#if defined(_DERIVATE2)
  Igdov_VGP_S_VGP_S=0.0;
  Igdov_VGP_S_VD_S=0.0;
  Igdov_VGP_S_VS_BP=0.0;
#endif
Igdov_VD_S=0.0;
#if defined(_DERIVATE2)
  Igdov_VD_S_VGP_S=0.0;
  Igdov_VD_S_VD_S=0.0;
  Igdov_VD_S_VS_BP=0.0;
#endif
Igdov_VS_BP=0.0;
#if defined(_DERIVATE2)
  Igdov_VS_BP_VGP_S=0.0;
  Igdov_VS_BP_VD_S=0.0;
  Igdov_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Igdov=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
Igc_VGP_S=0.0;
Igc_VD_S=0.0;
Igc_VS_BP=0.0;
#endif
Igc=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
Igb_VGP_S=0.0;
Igb_VD_S=0.0;
Igb_VS_BP=0.0;
#endif
Igb=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
Igcs_VGP_S=0.0;
Igcs_VD_S=0.0;
Igcs_VS_BP=0.0;
#endif
pInst->Igcs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igcd_VGP_S=0.0;
#if defined(_DERIVATE2)
  Igcd_VGP_S_VGP_S=0.0;
  Igcd_VGP_S_VD_S=0.0;
  Igcd_VGP_S_VS_BP=0.0;
#endif
Igcd_VD_S=0.0;
#if defined(_DERIVATE2)
  Igcd_VD_S_VGP_S=0.0;
  Igcd_VD_S_VD_S=0.0;
  Igcd_VD_S_VS_BP=0.0;
#endif
Igcd_VS_BP=0.0;
#if defined(_DERIVATE2)
  Igcd_VS_BP_VGP_S=0.0;
  Igcd_VS_BP_VD_S=0.0;
  Igcd_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->Igcd=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->SWIGATE!=0))
{
if
((pInst->IGOV_i>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg2mina_VGP_S=Vovs_VGP_S;
#if defined(_DERIVATE2)
  arg2mina_VGP_S_VGP_S=(+Vovs_VGP_S_VGP_S+0.0);
  arg2mina_VGP_S_VD_S=(+Vovs_VGP_S_VD_S+0.0);
  arg2mina_VGP_S_VS_BP=(+Vovs_VGP_S_VS_BP+0.0);
#endif
arg2mina_VD_S=Vovs_VD_S;
#if defined(_DERIVATE2)
  arg2mina_VD_S_VGP_S=(+Vovs_VD_S_VGP_S+0.0);
  arg2mina_VD_S_VD_S=(+Vovs_VD_S_VD_S+0.0);
  arg2mina_VD_S_VS_BP=(+Vovs_VD_S_VS_BP+0.0);
#endif
arg2mina_VS_BP=Vovs_VS_BP;
#if defined(_DERIVATE2)
  arg2mina_VS_BP_VGP_S=(+Vovs_VS_BP_VGP_S+0.0);
  arg2mina_VS_BP_VD_S=(+Vovs_VS_BP_VD_S+0.0);
  arg2mina_VS_BP_VS_BP=(+Vovs_VS_BP_VS_BP+0.0);
#endif
#endif
arg2mina=(Vovs+pInst->Dov);
EXIT_IF_ISNAN((Vovs+pInst->Dov))
{
double m00_sqrt(d00_sqrt0,(((-arg2mina)*(-arg2mina))+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((-arg2mina)*(-arg2mina))+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
psi_t_VGP_S=(0.5*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VGP_S_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VGP_S)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VGP_S))+0.0))));
  psi_t_VGP_S_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VD_S)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VD_S))+0.0))));
  psi_t_VGP_S_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VS_BP)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VS_BP))+0.0))));
#endif
psi_t_VD_S=(0.5*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VD_S_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VGP_S)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VGP_S))+0.0))));
  psi_t_VD_S_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VD_S)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VD_S))+0.0))));
  psi_t_VD_S_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VS_BP)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VS_BP))+0.0))));
#endif
psi_t_VS_BP=(0.5*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VS_BP_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VGP_S)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VGP_S))+0.0))));
  psi_t_VS_BP_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VD_S)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VD_S))+0.0))));
  psi_t_VS_BP_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VS_BP)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VS_BP))+0.0))));
#endif
#endif
psi_t=(0.5*((+arg2mina)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((+arg2mina)-d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,((Vovs*Vovs)+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Vovs*Vovs)+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
zg_VGP_S=((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VGP_S_VGP_S=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))*((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))+d10_sqrt0*(+(+Vovs_VGP_S_VGP_S*Vovs+Vovs_VGP_S*Vovs_VGP_S+Vovs_VGP_S*Vovs_VGP_S+Vovs*Vovs_VGP_S_VGP_S)+0.0))*pInst->inv_CHIB+((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))*d10_sqrt0*0.0+(((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VGP_S_VD_S=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))*((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))+d10_sqrt0*(+(+Vovs_VGP_S_VD_S*Vovs+Vovs_VGP_S*Vovs_VD_S+Vovs_VD_S*Vovs_VGP_S+Vovs*Vovs_VGP_S_VD_S)+0.0))*pInst->inv_CHIB+((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))*d10_sqrt0*0.0+(((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VGP_S_VS_BP=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))*((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))+d10_sqrt0*(+(+Vovs_VGP_S_VS_BP*Vovs+Vovs_VGP_S*Vovs_VS_BP+Vovs_VS_BP*Vovs_VGP_S+Vovs*Vovs_VGP_S_VS_BP)+0.0))*pInst->inv_CHIB+((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))*d10_sqrt0*0.0+(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
zg_VD_S=((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VD_S_VGP_S=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))*((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))+d10_sqrt0*(+(+Vovs_VD_S_VGP_S*Vovs+Vovs_VD_S*Vovs_VGP_S+Vovs_VGP_S*Vovs_VD_S+Vovs*Vovs_VD_S_VGP_S)+0.0))*pInst->inv_CHIB+((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))*d10_sqrt0*0.0+(((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VD_S_VD_S=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))*((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))+d10_sqrt0*(+(+Vovs_VD_S_VD_S*Vovs+Vovs_VD_S*Vovs_VD_S+Vovs_VD_S*Vovs_VD_S+Vovs*Vovs_VD_S_VD_S)+0.0))*pInst->inv_CHIB+((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))*d10_sqrt0*0.0+(((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VD_S_VS_BP=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))*((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))+d10_sqrt0*(+(+Vovs_VD_S_VS_BP*Vovs+Vovs_VD_S*Vovs_VS_BP+Vovs_VS_BP*Vovs_VD_S+Vovs*Vovs_VD_S_VS_BP)+0.0))*pInst->inv_CHIB+((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))*d10_sqrt0*0.0+(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
zg_VS_BP=((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VS_BP_VGP_S=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))*((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))+d10_sqrt0*(+(+Vovs_VS_BP_VGP_S*Vovs+Vovs_VS_BP*Vovs_VGP_S+Vovs_VGP_S*Vovs_VS_BP+Vovs*Vovs_VS_BP_VGP_S)+0.0))*pInst->inv_CHIB+((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))*d10_sqrt0*0.0+(((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VS_BP_VD_S=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))*((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))+d10_sqrt0*(+(+Vovs_VS_BP_VD_S*Vovs+Vovs_VS_BP*Vovs_VD_S+Vovs_VD_S*Vovs_VS_BP+Vovs*Vovs_VS_BP_VD_S)+0.0))*pInst->inv_CHIB+((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))*d10_sqrt0*0.0+(((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VS_BP_VS_BP=(+(m20_sqrt(((Vovs*Vovs)+1.0e-6))*(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))*((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))+d10_sqrt0*(+(+Vovs_VS_BP_VS_BP*Vovs+Vovs_VS_BP*Vovs_VS_BP+Vovs_VS_BP*Vovs_VS_BP+Vovs*Vovs_VS_BP_VS_BP)+0.0))*pInst->inv_CHIB+((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))*d10_sqrt0*0.0+(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
#endif
zg=(d00_sqrt0*pInst->inv_CHIB);
EXIT_IF_ISNAN((d00_sqrt0*pInst->inv_CHIB))
}
if
((pInst->GC3_i<0))
{
{
double m00_sqrt(d00_sqrt0,(((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
zg_VGP_S=(0.5*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VGP_S_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VGP_S+zg_VGP_S*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VGP_S-0.0))+0.0))));
  zg_VGP_S_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VD_S-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VD_S+zg_VD_S*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VD_S-0.0))+0.0))));
  zg_VGP_S_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VS_BP+zg_VS_BP*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VS_BP-0.0))+0.0))));
#endif
zg_VD_S=(0.5*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VD_S_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VGP_S+zg_VGP_S*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VGP_S-0.0))+0.0))));
  zg_VD_S_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VD_S-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VD_S+zg_VD_S*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VD_S-0.0))+0.0))));
  zg_VD_S_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VS_BP+zg_VS_BP*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VS_BP-0.0))+0.0))));
#endif
zg_VS_BP=(0.5*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VS_BP_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VGP_S+zg_VGP_S*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VGP_S-0.0))+0.0))));
  zg_VS_BP_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VD_S-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VD_S+zg_VD_S*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VD_S-0.0))+0.0))));
  zg_VS_BP_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VS_BP+zg_VS_BP*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VS_BP-0.0))+0.0))));
#endif
#endif
zg=(0.5*((zg+pInst->GCQ)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((zg+pInst->GCQ)-d00_sqrt0)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg1_VD_S=(xs_ov_VD_S+psi_t_VD_S*pModel->inv_phit);
#if defined(_DERIVATE2)
  arg1_VD_S_VD_S=(+(+0.0+xs_ov_VD_S_VD_S)+(+psi_t_VD_S_VD_S*pModel->inv_phit+psi_t_VD_S*0.0+psi_t_VD_S*0.0+psi_t*0.0));
  arg1_VD_S_VS_BP=(+(+0.0+xs_ov_VD_S_VS_BP)+(+psi_t_VD_S_VS_BP*pModel->inv_phit+psi_t_VD_S*0.0+psi_t_VS_BP*0.0+psi_t*0.0));
  arg1_VD_S_VGP_S=(+(+0.0+xs_ov_VD_S_VGP_S)+(+psi_t_VD_S_VGP_S*pModel->inv_phit+psi_t_VD_S*0.0+psi_t_VGP_S*0.0+psi_t*0.0));
#endif
arg1_VS_BP=(xs_ov_VS_BP+psi_t_VS_BP*pModel->inv_phit);
#if defined(_DERIVATE2)
  arg1_VS_BP_VD_S=(+(+0.0+xs_ov_VS_BP_VD_S)+(+psi_t_VS_BP_VD_S*pModel->inv_phit+psi_t_VS_BP*0.0+psi_t_VD_S*0.0+psi_t*0.0));
  arg1_VS_BP_VS_BP=(+(+0.0+xs_ov_VS_BP_VS_BP)+(+psi_t_VS_BP_VS_BP*pModel->inv_phit+psi_t_VS_BP*0.0+psi_t_VS_BP*0.0+psi_t*0.0));
  arg1_VS_BP_VGP_S=(+(+0.0+xs_ov_VS_BP_VGP_S)+(+psi_t_VS_BP_VGP_S*pModel->inv_phit+psi_t_VS_BP*0.0+psi_t_VGP_S*0.0+psi_t*0.0));
#endif
arg1_VGP_S=(xs_ov_VGP_S+psi_t_VGP_S*pModel->inv_phit);
#if defined(_DERIVATE2)
  arg1_VGP_S_VD_S=(+(+0.0+xs_ov_VGP_S_VD_S)+(+psi_t_VGP_S_VD_S*pModel->inv_phit+psi_t_VGP_S*0.0+psi_t_VD_S*0.0+psi_t*0.0));
  arg1_VGP_S_VS_BP=(+(+0.0+xs_ov_VGP_S_VS_BP)+(+psi_t_VGP_S_VS_BP*pModel->inv_phit+psi_t_VGP_S*0.0+psi_t_VS_BP*0.0+psi_t*0.0));
  arg1_VGP_S_VGP_S=(+(+0.0+xs_ov_VGP_S_VGP_S)+(+psi_t_VGP_S_VGP_S*pModel->inv_phit+psi_t_VGP_S*0.0+psi_t_VGP_S*0.0+psi_t*0.0));
#endif
#endif
arg1=((3.0+xs_ov)+(psi_t*pModel->inv_phit));
EXIT_IF_ISNAN(((3.0+xs_ov)+(psi_t*pModel->inv_phit)))
{
double m00_fabs(d00_fabs0,arg1)
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,arg1)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=arg1_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VD_S+d10_exp0*arg1_VD_S_VD_S);
  Dsi_VD_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VD_S+d10_exp0*arg1_VD_S_VS_BP);
  Dsi_VD_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VD_S+d10_exp0*arg1_VD_S_VGP_S);
#endif
Dsi_VS_BP=arg1_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VD_S);
  Dsi_VS_BP_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VS_BP+d10_exp0*arg1_VS_BP_VS_BP);
  Dsi_VS_BP_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VGP_S);
#endif
Dsi_VGP_S=arg1_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VD_S);
  Dsi_VGP_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VGP_S+d10_exp0*arg1_VGP_S_VS_BP);
  Dsi_VGP_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VGP_S);
#endif
#endif
Dsi=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((arg1<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=(-1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
Dsi_VS_BP=(-1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
Dsi_VGP_S=(-1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
#endif
Dsi=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=(1.0e100*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VD_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VD_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
Dsi_VS_BP=(1.0e100*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VS_BP_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VS_BP_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
Dsi_VGP_S=(1.0e100*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VGP_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VGP_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
Dsi=(1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg1_VD_S=0.0;
#if defined(_DERIVATE2)
  arg1_VD_S_VD_S=0.0;
  arg1_VD_S_VS_BP=0.0;
  arg1_VD_S_VGP_S=0.0;
#endif
arg1_VS_BP=0.0;
#if defined(_DERIVATE2)
  arg1_VS_BP_VD_S=0.0;
  arg1_VS_BP_VS_BP=0.0;
  arg1_VS_BP_VGP_S=0.0;
#endif
arg1_VGP_S=(-VgsPrime_VGP_S)*pModel->inv_phit;
#if defined(_DERIVATE2)
  arg1_VGP_S_VD_S=(+0.0*pModel->inv_phit+(-VgsPrime_VGP_S)*0.0+0.0*0.0+(-VgsPrime)*0.0);
  arg1_VGP_S_VS_BP=(+0.0*pModel->inv_phit+(-VgsPrime_VGP_S)*0.0+0.0*0.0+(-VgsPrime)*0.0);
  arg1_VGP_S_VGP_S=(+0.0*pModel->inv_phit+(-VgsPrime_VGP_S)*0.0+(-VgsPrime_VGP_S)*0.0+(-VgsPrime)*0.0);
#endif
#endif
arg1=((-VgsPrime)*pModel->inv_phit);
EXIT_IF_ISNAN(((-VgsPrime)*pModel->inv_phit))
{
double m00_fabs(d00_fabs0,arg1)
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,arg1)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=arg1_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VGP_S);
  temp_VGP_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VD_S);
  temp_VGP_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VGP_S+d10_exp0*arg1_VGP_S_VS_BP);
#endif
temp_VD_S=arg1_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=0.0;
  temp_VD_S_VS_BS=0.0;
  temp_VD_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VD_S+d10_exp0*arg1_VD_S_VGP_S);
  temp_VD_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VD_S+d10_exp0*arg1_VD_S_VD_S);
  temp_VD_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VD_S+d10_exp0*arg1_VD_S_VS_BP);
#endif
temp_VS_BP=arg1_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=0.0;
  temp_VS_BP_VS_BS=0.0;
  temp_VS_BP_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VGP_S);
  temp_VS_BP_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VD_S);
  temp_VS_BP_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VS_BP+d10_exp0*arg1_VS_BP_VS_BP);
#endif
#endif
temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((arg1<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*(0.0)+0.0*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*(0.0)+0.0*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
temp_VD_S=(-1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*(0.0)+0.0*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*(0.0)+0.0*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
temp_VS_BP=(-1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*(0.0)+0.0*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*(0.0)+0.0*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
#endif
temp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(1.0e100*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(0.0)+0.0*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(0.0)+0.0*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
temp_VD_S=(1.0e100*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(0.0)+0.0*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(0.0)+0.0*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
temp_VS_BP=(1.0e100*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(0.0)+0.0*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(0.0)+0.0*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
temp=(1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dgate_VD_S=((Dsi_VD_S*temp)+(Dsi*temp_VD_S));
#if defined(_DERIVATE2)
  Dgate_VD_S_VD_S=(+Dsi_VD_S_VD_S*temp+Dsi_VD_S*temp_VD_S+Dsi_VD_S*temp_VD_S+Dsi*temp_VD_S_VD_S);
  Dgate_VD_S_VS_BP=(+Dsi_VD_S_VS_BP*temp+Dsi_VD_S*temp_VS_BP+Dsi_VS_BP*temp_VD_S+Dsi*temp_VD_S_VS_BP);
  Dgate_VD_S_VGP_S=(+Dsi_VD_S_VGP_S*temp+Dsi_VD_S*temp_VGP_S+Dsi_VGP_S*temp_VD_S+Dsi*temp_VD_S_VGP_S);
#endif
Dgate_VS_BP=((Dsi_VS_BP*temp)+(Dsi*temp_VS_BP));
#if defined(_DERIVATE2)
  Dgate_VS_BP_VD_S=(+Dsi_VS_BP_VD_S*temp+Dsi_VS_BP*temp_VD_S+Dsi_VD_S*temp_VS_BP+Dsi*temp_VS_BP_VD_S);
  Dgate_VS_BP_VS_BP=(+Dsi_VS_BP_VS_BP*temp+Dsi_VS_BP*temp_VS_BP+Dsi_VS_BP*temp_VS_BP+Dsi*temp_VS_BP_VS_BP);
  Dgate_VS_BP_VGP_S=(+Dsi_VS_BP_VGP_S*temp+Dsi_VS_BP*temp_VGP_S+Dsi_VGP_S*temp_VS_BP+Dsi*temp_VS_BP_VGP_S);
#endif
Dgate_VGP_S=((Dsi_VGP_S*temp)+(Dsi*temp_VGP_S));
#if defined(_DERIVATE2)
  Dgate_VGP_S_VD_S=(+Dsi_VGP_S_VD_S*temp+Dsi_VGP_S*temp_VD_S+Dsi_VD_S*temp_VGP_S+Dsi*temp_VGP_S_VD_S);
  Dgate_VGP_S_VS_BP=(+Dsi_VGP_S_VS_BP*temp+Dsi_VGP_S*temp_VS_BP+Dsi_VS_BP*temp_VGP_S+Dsi*temp_VGP_S_VS_BP);
  Dgate_VGP_S_VGP_S=(+Dsi_VGP_S_VGP_S*temp+Dsi_VGP_S*temp_VGP_S+Dsi_VGP_S*temp_VGP_S+Dsi*temp_VGP_S_VGP_S);
#endif
#endif
Dgate=(Dsi*temp);
EXIT_IF_ISNAN((Dsi*temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(pInst->BOV*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*(0.0)+0.0*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VGP_S+pInst->GC3_i*0.0)))));
  temp_VGP_S_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*(0.0)+0.0*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VGP_S+pInst->GC3_i*0.0)))));
  temp_VGP_S_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV*(+0.0+(+zg_VGP_S_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VGP_S)))));
  temp_VGP_S_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV*(+0.0+(+zg_VGP_S_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VD_S)))));
  temp_VGP_S_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV*(+0.0+(+zg_VGP_S_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VS_BP)))));
#endif
temp_VD_S=(pInst->BOV*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*(0.0)+0.0*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VD_S+pInst->GC3_i*0.0)))));
  temp_VD_S_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*(0.0)+0.0*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VD_S+pInst->GC3_i*0.0)))));
  temp_VD_S_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV*(+0.0+(+zg_VD_S_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VGP_S)))));
  temp_VD_S_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV*(+0.0+(+zg_VD_S_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VD_S)))));
  temp_VD_S_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV*(+0.0+(+zg_VD_S_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VS_BP)))));
#endif
temp_VS_BP=(pInst->BOV*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*(0.0)+0.0*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VS_BP+pInst->GC3_i*0.0)))));
  temp_VS_BP_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*(0.0)+0.0*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VS_BP+pInst->GC3_i*0.0)))));
  temp_VS_BP_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV*(+0.0+(+zg_VS_BP_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VGP_S)))));
  temp_VS_BP_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV*(+0.0+(+zg_VS_BP_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VD_S)))));
  temp_VS_BP_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV*(+0.0+(+zg_VS_BP_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VS_BP)))));
#endif
#endif
temp=(pInst->BOV*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg)))));
EXIT_IF_ISNAN((pInst->BOV*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))))
if
((temp>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=((temp_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(+0.0+(+temp_VGP_S_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VGP_S*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VGP_S_VD_S=(+0.0+(+temp_VGP_S_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VD_S*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VGP_S_VS_BP=(+0.0+(+temp_VGP_S_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VS_BP*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
TP_VD_S=((temp_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(+0.0+(+temp_VD_S_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VGP_S*3.3333333333333333e-01+temp_VD_S*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VD_S_VD_S=(+0.0+(+temp_VD_S_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VD_S*3.3333333333333333e-01+temp_VD_S*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VD_S_VS_BP=(+0.0+(+temp_VD_S_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VS_BP*3.3333333333333333e-01+temp_VD_S*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
TP_VS_BP=((temp_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(+0.0+(+temp_VS_BP_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VGP_S*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VS_BP_VD_S=(+0.0+(+temp_VS_BP_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VD_S*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VS_BP_VS_BP=(+0.0+(+temp_VS_BP_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VS_BP*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
#endif
TP=(1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
EXIT_IF_ISNAN((1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))))
}
else
{
if
((temp>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,temp)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=temp_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VGP_S+d10_exp0*temp_VGP_S_VGP_S);
  TP_VGP_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VGP_S+d10_exp0*temp_VGP_S_VD_S);
  TP_VGP_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VGP_S+d10_exp0*temp_VGP_S_VS_BP);
#endif
TP_VD_S=temp_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VD_S+d10_exp0*temp_VD_S_VGP_S);
  TP_VD_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VD_S+d10_exp0*temp_VD_S_VD_S);
  TP_VD_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VD_S+d10_exp0*temp_VD_S_VS_BP);
#endif
TP_VS_BP=temp_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VS_BP+d10_exp0*temp_VS_BP_VGP_S);
  TP_VS_BP_VD_S=(m20_exp(temp)*temp_VD_S*temp_VS_BP+d10_exp0*temp_VS_BP_VD_S);
  TP_VS_BP_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VS_BP+d10_exp0*temp_VS_BP_VS_BP);
#endif
#endif
TP=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=(-1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
TP_VD_S=(-1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VD_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
TP_VS_BP=(-1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
#endif
TP=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))))
}
}
{
double m00_logE(d00_logE0,((1.0+Dsi)/(1.0+Dgate)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((1.0+Dsi)/(1.0+Dgate)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igsov_VGP_S=(pInst->IGOV_i*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igsov_VGP_S_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VGP_S_VGP_S*d00_logE0+TP_VGP_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VGP_S)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VGP_S+Dsi_VGP_S*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igsov_VGP_S_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VGP_S_VD_S*d00_logE0+TP_VGP_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VD_S)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VD_S+Dsi_VD_S*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igsov_VGP_S_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VGP_S_VS_BP*d00_logE0+TP_VGP_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VS_BP)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VS_BP+Dsi_VS_BP*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
Igsov_VD_S=(pInst->IGOV_i*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igsov_VD_S_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VD_S_VGP_S*d00_logE0+TP_VD_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VGP_S)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VGP_S+Dsi_VGP_S*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igsov_VD_S_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VD_S_VD_S*d00_logE0+TP_VD_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VD_S)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VD_S+Dsi_VD_S*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igsov_VD_S_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VD_S_VS_BP*d00_logE0+TP_VD_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VS_BP)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VS_BP+Dsi_VS_BP*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
Igsov_VS_BP=(pInst->IGOV_i*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igsov_VS_BP_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VS_BP_VGP_S*d00_logE0+TP_VS_BP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VGP_S)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VGP_S+Dsi_VGP_S*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igsov_VS_BP_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VS_BP_VD_S*d00_logE0+TP_VS_BP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VD_S)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VD_S+Dsi_VD_S*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igsov_VS_BP_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOV_i*(+TP_VS_BP_VS_BP*d00_logE0+TP_VS_BP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VS_BP)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VS_BP+Dsi_VS_BP*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
#endif
pInst->Igsov=(pInst->IGOV_i*(TP*d00_logE0));
EXIT_IF_ISNAN((pInst->IGOV_i*(TP*d00_logE0)))
}
}
if
((pInst->IGOVD_i>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg2mina_VGP_S=Vovd_VGP_S;
#if defined(_DERIVATE2)
  arg2mina_VGP_S_VGP_S=(+Vovd_VGP_S_VGP_S+0.0);
  arg2mina_VGP_S_VD_S=(+Vovd_VGP_S_VD_S+0.0);
  arg2mina_VGP_S_VS_BP=(+Vovd_VGP_S_VS_BP+0.0);
#endif
arg2mina_VD_S=Vovd_VD_S;
#if defined(_DERIVATE2)
  arg2mina_VD_S_VGP_S=(+Vovd_VD_S_VGP_S+0.0);
  arg2mina_VD_S_VD_S=(+Vovd_VD_S_VD_S+0.0);
  arg2mina_VD_S_VS_BP=(+Vovd_VD_S_VS_BP+0.0);
#endif
arg2mina_VS_BP=Vovd_VS_BP;
#if defined(_DERIVATE2)
  arg2mina_VS_BP_VGP_S=(+Vovd_VS_BP_VGP_S+0.0);
  arg2mina_VS_BP_VD_S=(+Vovd_VS_BP_VD_S+0.0);
  arg2mina_VS_BP_VS_BP=(+Vovd_VS_BP_VS_BP+0.0);
#endif
#endif
arg2mina=(Vovd+pInst->Dov);
EXIT_IF_ISNAN((Vovd+pInst->Dov))
{
double m00_sqrt(d00_sqrt0,(((-arg2mina)*(-arg2mina))+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((-arg2mina)*(-arg2mina))+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
psi_t_VGP_S=(0.5*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VGP_S_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VGP_S)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VGP_S))+0.0))));
  psi_t_VGP_S_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VD_S)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VD_S))+0.0))));
  psi_t_VGP_S_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VS_BP)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VS_BP))+0.0))));
#endif
psi_t_VD_S=(0.5*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VD_S_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VGP_S)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VGP_S))+0.0))));
  psi_t_VD_S_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VD_S)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VD_S))+0.0))));
  psi_t_VD_S_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VS_BP)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VS_BP))+0.0))));
#endif
psi_t_VS_BP=(0.5*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VS_BP_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VGP_S)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VGP_S))+0.0))));
  psi_t_VS_BP_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VD_S)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VD_S))+0.0))));
  psi_t_VS_BP_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VS_BP)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VS_BP))+0.0))));
#endif
#endif
psi_t=(0.5*((+arg2mina)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((+arg2mina)-d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,((Vovd*Vovd)+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Vovd*Vovd)+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
zg_VGP_S=((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VGP_S_VGP_S=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))*((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))+d10_sqrt0*(+(+Vovd_VGP_S_VGP_S*Vovd+Vovd_VGP_S*Vovd_VGP_S+Vovd_VGP_S*Vovd_VGP_S+Vovd*Vovd_VGP_S_VGP_S)+0.0))*pInst->inv_CHIB+((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))*d10_sqrt0*0.0+(((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VGP_S_VD_S=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))*((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))+d10_sqrt0*(+(+Vovd_VGP_S_VD_S*Vovd+Vovd_VGP_S*Vovd_VD_S+Vovd_VD_S*Vovd_VGP_S+Vovd*Vovd_VGP_S_VD_S)+0.0))*pInst->inv_CHIB+((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))*d10_sqrt0*0.0+(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VGP_S_VS_BP=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))*((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))+d10_sqrt0*(+(+Vovd_VGP_S_VS_BP*Vovd+Vovd_VGP_S*Vovd_VS_BP+Vovd_VS_BP*Vovd_VGP_S+Vovd*Vovd_VGP_S_VS_BP)+0.0))*pInst->inv_CHIB+((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))*d10_sqrt0*0.0+(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
zg_VD_S=((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VD_S_VGP_S=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))*((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))+d10_sqrt0*(+(+Vovd_VD_S_VGP_S*Vovd+Vovd_VD_S*Vovd_VGP_S+Vovd_VGP_S*Vovd_VD_S+Vovd*Vovd_VD_S_VGP_S)+0.0))*pInst->inv_CHIB+((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))*d10_sqrt0*0.0+(((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VD_S_VD_S=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))*((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))+d10_sqrt0*(+(+Vovd_VD_S_VD_S*Vovd+Vovd_VD_S*Vovd_VD_S+Vovd_VD_S*Vovd_VD_S+Vovd*Vovd_VD_S_VD_S)+0.0))*pInst->inv_CHIB+((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))*d10_sqrt0*0.0+(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VD_S_VS_BP=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))*((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))+d10_sqrt0*(+(+Vovd_VD_S_VS_BP*Vovd+Vovd_VD_S*Vovd_VS_BP+Vovd_VS_BP*Vovd_VD_S+Vovd*Vovd_VD_S_VS_BP)+0.0))*pInst->inv_CHIB+((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))*d10_sqrt0*0.0+(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
zg_VS_BP=((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VS_BP_VGP_S=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))*((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))+d10_sqrt0*(+(+Vovd_VS_BP_VGP_S*Vovd+Vovd_VS_BP*Vovd_VGP_S+Vovd_VGP_S*Vovd_VS_BP+Vovd*Vovd_VS_BP_VGP_S)+0.0))*pInst->inv_CHIB+((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))*d10_sqrt0*0.0+(((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VS_BP_VD_S=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))*((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))+d10_sqrt0*(+(+Vovd_VS_BP_VD_S*Vovd+Vovd_VS_BP*Vovd_VD_S+Vovd_VD_S*Vovd_VS_BP+Vovd*Vovd_VS_BP_VD_S)+0.0))*pInst->inv_CHIB+((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))*d10_sqrt0*0.0+(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VS_BP_VS_BP=(+(m20_sqrt(((Vovd*Vovd)+1.0e-6))*(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))*((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))+d10_sqrt0*(+(+Vovd_VS_BP_VS_BP*Vovd+Vovd_VS_BP*Vovd_VS_BP+Vovd_VS_BP*Vovd_VS_BP+Vovd*Vovd_VS_BP_VS_BP)+0.0))*pInst->inv_CHIB+((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))*d10_sqrt0*0.0+(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
#endif
zg=(d00_sqrt0*pInst->inv_CHIB);
EXIT_IF_ISNAN((d00_sqrt0*pInst->inv_CHIB))
}
if
((pInst->GC3_i<0))
{
{
double m00_sqrt(d00_sqrt0,(((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
zg_VGP_S=(0.5*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VGP_S_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VGP_S+zg_VGP_S*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VGP_S-0.0))+0.0))));
  zg_VGP_S_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VD_S-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VD_S+zg_VD_S*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VD_S-0.0))+0.0))));
  zg_VGP_S_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VS_BP+zg_VS_BP*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VS_BP-0.0))+0.0))));
#endif
zg_VD_S=(0.5*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VD_S_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VGP_S+zg_VGP_S*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VGP_S-0.0))+0.0))));
  zg_VD_S_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VD_S-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VD_S+zg_VD_S*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VD_S-0.0))+0.0))));
  zg_VD_S_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VS_BP+zg_VS_BP*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VS_BP-0.0))+0.0))));
#endif
zg_VS_BP=(0.5*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VS_BP_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VGP_S+zg_VGP_S*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VGP_S-0.0))+0.0))));
  zg_VS_BP_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VD_S-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VD_S+zg_VD_S*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VD_S-0.0))+0.0))));
  zg_VS_BP_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-6))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VS_BP+zg_VS_BP*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VS_BP-0.0))+0.0))));
#endif
#endif
zg=(0.5*((zg+pInst->GCQ)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((zg+pInst->GCQ)-d00_sqrt0)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg1_VD_S=(xd_ov_VD_S+psi_t_VD_S*pModel->inv_phit);
#if defined(_DERIVATE2)
  arg1_VD_S_VD_S=(+(+0.0+xd_ov_VD_S_VD_S)+(+psi_t_VD_S_VD_S*pModel->inv_phit+psi_t_VD_S*0.0+psi_t_VD_S*0.0+psi_t*0.0));
  arg1_VD_S_VS_BP=(+(+0.0+xd_ov_VD_S_VS_BP)+(+psi_t_VD_S_VS_BP*pModel->inv_phit+psi_t_VD_S*0.0+psi_t_VS_BP*0.0+psi_t*0.0));
  arg1_VD_S_VGP_S=(+(+0.0+xd_ov_VD_S_VGP_S)+(+psi_t_VD_S_VGP_S*pModel->inv_phit+psi_t_VD_S*0.0+psi_t_VGP_S*0.0+psi_t*0.0));
#endif
arg1_VS_BP=(xd_ov_VS_BP+psi_t_VS_BP*pModel->inv_phit);
#if defined(_DERIVATE2)
  arg1_VS_BP_VD_S=(+(+0.0+xd_ov_VS_BP_VD_S)+(+psi_t_VS_BP_VD_S*pModel->inv_phit+psi_t_VS_BP*0.0+psi_t_VD_S*0.0+psi_t*0.0));
  arg1_VS_BP_VS_BP=(+(+0.0+xd_ov_VS_BP_VS_BP)+(+psi_t_VS_BP_VS_BP*pModel->inv_phit+psi_t_VS_BP*0.0+psi_t_VS_BP*0.0+psi_t*0.0));
  arg1_VS_BP_VGP_S=(+(+0.0+xd_ov_VS_BP_VGP_S)+(+psi_t_VS_BP_VGP_S*pModel->inv_phit+psi_t_VS_BP*0.0+psi_t_VGP_S*0.0+psi_t*0.0));
#endif
arg1_VGP_S=(xd_ov_VGP_S+psi_t_VGP_S*pModel->inv_phit);
#if defined(_DERIVATE2)
  arg1_VGP_S_VD_S=(+(+0.0+xd_ov_VGP_S_VD_S)+(+psi_t_VGP_S_VD_S*pModel->inv_phit+psi_t_VGP_S*0.0+psi_t_VD_S*0.0+psi_t*0.0));
  arg1_VGP_S_VS_BP=(+(+0.0+xd_ov_VGP_S_VS_BP)+(+psi_t_VGP_S_VS_BP*pModel->inv_phit+psi_t_VGP_S*0.0+psi_t_VS_BP*0.0+psi_t*0.0));
  arg1_VGP_S_VGP_S=(+(+0.0+xd_ov_VGP_S_VGP_S)+(+psi_t_VGP_S_VGP_S*pModel->inv_phit+psi_t_VGP_S*0.0+psi_t_VGP_S*0.0+psi_t*0.0));
#endif
#endif
arg1=((3.0+xd_ov)+(psi_t*pModel->inv_phit));
EXIT_IF_ISNAN(((3.0+xd_ov)+(psi_t*pModel->inv_phit)))
{
double m00_fabs(d00_fabs0,arg1)
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,arg1)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=arg1_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VD_S+d10_exp0*arg1_VD_S_VD_S);
  Dsi_VD_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VD_S+d10_exp0*arg1_VD_S_VS_BP);
  Dsi_VD_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VD_S+d10_exp0*arg1_VD_S_VGP_S);
#endif
Dsi_VS_BP=arg1_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VD_S);
  Dsi_VS_BP_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VS_BP+d10_exp0*arg1_VS_BP_VS_BP);
  Dsi_VS_BP_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VGP_S);
#endif
Dsi_VGP_S=arg1_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VD_S);
  Dsi_VGP_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VGP_S+d10_exp0*arg1_VGP_S_VS_BP);
  Dsi_VGP_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VGP_S);
#endif
#endif
Dsi=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((arg1<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=(-1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
Dsi_VS_BP=(-1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
Dsi_VGP_S=(-1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
#endif
Dsi=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=(1.0e100*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VD_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VD_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
Dsi_VS_BP=(1.0e100*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VS_BP_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VS_BP_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
Dsi_VGP_S=(1.0e100*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VGP_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VGP_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
Dsi=(1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg1_VD_S=(-VgdPrime_VD_S)*pModel->inv_phit;
#if defined(_DERIVATE2)
  arg1_VD_S_VD_S=(+0.0*pModel->inv_phit+(-VgdPrime_VD_S)*0.0+(-VgdPrime_VD_S)*0.0+(-VgdPrime)*0.0);
  arg1_VD_S_VS_BP=(+0.0*pModel->inv_phit+(-VgdPrime_VD_S)*0.0+0.0*0.0+(-VgdPrime)*0.0);
  arg1_VD_S_VGP_S=(+0.0*pModel->inv_phit+(-VgdPrime_VD_S)*0.0+(-VgdPrime_VGP_S)*0.0+(-VgdPrime)*0.0);
#endif
arg1_VS_BP=0.0;
#if defined(_DERIVATE2)
  arg1_VS_BP_VD_S=0.0;
  arg1_VS_BP_VS_BP=0.0;
  arg1_VS_BP_VGP_S=0.0;
#endif
arg1_VGP_S=(-VgdPrime_VGP_S)*pModel->inv_phit;
#if defined(_DERIVATE2)
  arg1_VGP_S_VD_S=(+0.0*pModel->inv_phit+(-VgdPrime_VGP_S)*0.0+(-VgdPrime_VD_S)*0.0+(-VgdPrime)*0.0);
  arg1_VGP_S_VS_BP=(+0.0*pModel->inv_phit+(-VgdPrime_VGP_S)*0.0+0.0*0.0+(-VgdPrime)*0.0);
  arg1_VGP_S_VGP_S=(+0.0*pModel->inv_phit+(-VgdPrime_VGP_S)*0.0+(-VgdPrime_VGP_S)*0.0+(-VgdPrime)*0.0);
#endif
#endif
arg1=((-VgdPrime)*pModel->inv_phit);
EXIT_IF_ISNAN(((-VgdPrime)*pModel->inv_phit))
{
double m00_fabs(d00_fabs0,arg1)
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,arg1)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=arg1_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VGP_S);
  temp_VGP_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VD_S);
  temp_VGP_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VGP_S+d10_exp0*arg1_VGP_S_VS_BP);
#endif
temp_VD_S=arg1_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=0.0;
  temp_VD_S_VS_BS=0.0;
  temp_VD_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VD_S+d10_exp0*arg1_VD_S_VGP_S);
  temp_VD_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VD_S+d10_exp0*arg1_VD_S_VD_S);
  temp_VD_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VD_S+d10_exp0*arg1_VD_S_VS_BP);
#endif
temp_VS_BP=arg1_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=0.0;
  temp_VS_BP_VS_BS=0.0;
  temp_VS_BP_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VGP_S);
  temp_VS_BP_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VD_S);
  temp_VS_BP_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VS_BP+d10_exp0*arg1_VS_BP_VS_BP);
#endif
#endif
temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((arg1<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*(0.0)+0.0*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*(0.0)+0.0*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
temp_VD_S=(-1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*(0.0)+0.0*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*(0.0)+0.0*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
temp_VS_BP=(-1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*(0.0)+0.0*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*(0.0)+0.0*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
#endif
temp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(1.0e100*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(0.0)+0.0*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(0.0)+0.0*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
temp_VD_S=(1.0e100*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(0.0)+0.0*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(0.0)+0.0*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
temp_VS_BP=(1.0e100*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(0.0)+0.0*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(0.0)+0.0*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
temp=(1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dgate_VD_S=((Dsi_VD_S*temp)+(Dsi*temp_VD_S));
#if defined(_DERIVATE2)
  Dgate_VD_S_VD_S=(+Dsi_VD_S_VD_S*temp+Dsi_VD_S*temp_VD_S+Dsi_VD_S*temp_VD_S+Dsi*temp_VD_S_VD_S);
  Dgate_VD_S_VS_BP=(+Dsi_VD_S_VS_BP*temp+Dsi_VD_S*temp_VS_BP+Dsi_VS_BP*temp_VD_S+Dsi*temp_VD_S_VS_BP);
  Dgate_VD_S_VGP_S=(+Dsi_VD_S_VGP_S*temp+Dsi_VD_S*temp_VGP_S+Dsi_VGP_S*temp_VD_S+Dsi*temp_VD_S_VGP_S);
#endif
Dgate_VS_BP=((Dsi_VS_BP*temp)+(Dsi*temp_VS_BP));
#if defined(_DERIVATE2)
  Dgate_VS_BP_VD_S=(+Dsi_VS_BP_VD_S*temp+Dsi_VS_BP*temp_VD_S+Dsi_VD_S*temp_VS_BP+Dsi*temp_VS_BP_VD_S);
  Dgate_VS_BP_VS_BP=(+Dsi_VS_BP_VS_BP*temp+Dsi_VS_BP*temp_VS_BP+Dsi_VS_BP*temp_VS_BP+Dsi*temp_VS_BP_VS_BP);
  Dgate_VS_BP_VGP_S=(+Dsi_VS_BP_VGP_S*temp+Dsi_VS_BP*temp_VGP_S+Dsi_VGP_S*temp_VS_BP+Dsi*temp_VS_BP_VGP_S);
#endif
Dgate_VGP_S=((Dsi_VGP_S*temp)+(Dsi*temp_VGP_S));
#if defined(_DERIVATE2)
  Dgate_VGP_S_VD_S=(+Dsi_VGP_S_VD_S*temp+Dsi_VGP_S*temp_VD_S+Dsi_VD_S*temp_VGP_S+Dsi*temp_VGP_S_VD_S);
  Dgate_VGP_S_VS_BP=(+Dsi_VGP_S_VS_BP*temp+Dsi_VGP_S*temp_VS_BP+Dsi_VS_BP*temp_VGP_S+Dsi*temp_VGP_S_VS_BP);
  Dgate_VGP_S_VGP_S=(+Dsi_VGP_S_VGP_S*temp+Dsi_VGP_S*temp_VGP_S+Dsi_VGP_S*temp_VGP_S+Dsi*temp_VGP_S_VGP_S);
#endif
#endif
Dgate=(Dsi*temp);
EXIT_IF_ISNAN((Dsi*temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(pInst->BOV_d*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV_d*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*(0.0)+0.0*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VGP_S+pInst->GC3_i*0.0)))));
  temp_VGP_S_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV_d*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*(0.0)+0.0*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VGP_S+pInst->GC3_i*0.0)))));
  temp_VGP_S_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV_d*(+0.0+(+zg_VGP_S_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VGP_S)))));
  temp_VGP_S_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV_d*(+0.0+(+zg_VGP_S_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VD_S)))));
  temp_VGP_S_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BOV_d*(+0.0+(+zg_VGP_S_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VS_BP)))));
#endif
temp_VD_S=(pInst->BOV_d*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV_d*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*(0.0)+0.0*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VD_S+pInst->GC3_i*0.0)))));
  temp_VD_S_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV_d*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*(0.0)+0.0*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VD_S+pInst->GC3_i*0.0)))));
  temp_VD_S_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV_d*(+0.0+(+zg_VD_S_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VGP_S)))));
  temp_VD_S_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV_d*(+0.0+(+zg_VD_S_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VD_S)))));
  temp_VD_S_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BOV_d*(+0.0+(+zg_VD_S_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VS_BP)))));
#endif
temp_VS_BP=(pInst->BOV_d*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV_d*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*(0.0)+0.0*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VS_BP+pInst->GC3_i*0.0)))));
  temp_VS_BP_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV_d*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*(0.0)+0.0*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VS_BP+pInst->GC3_i*0.0)))));
  temp_VS_BP_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV_d*(+0.0+(+zg_VS_BP_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VGP_S)))));
  temp_VS_BP_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV_d*(+0.0+(+zg_VS_BP_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VD_S)))));
  temp_VS_BP_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BOV_d*(+0.0+(+zg_VS_BP_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VS_BP)))));
#endif
#endif
temp=(pInst->BOV_d*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg)))));
EXIT_IF_ISNAN((pInst->BOV_d*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))))
if
((temp>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=((temp_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(+0.0+(+temp_VGP_S_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VGP_S*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VGP_S_VD_S=(+0.0+(+temp_VGP_S_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VD_S*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VGP_S_VS_BP=(+0.0+(+temp_VGP_S_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VS_BP*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
TP_VD_S=((temp_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(+0.0+(+temp_VD_S_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VGP_S*3.3333333333333333e-01+temp_VD_S*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VD_S_VD_S=(+0.0+(+temp_VD_S_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VD_S*3.3333333333333333e-01+temp_VD_S*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VD_S_VS_BP=(+0.0+(+temp_VD_S_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VS_BP*3.3333333333333333e-01+temp_VD_S*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
TP_VS_BP=((temp_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(+0.0+(+temp_VS_BP_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VGP_S*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VS_BP_VD_S=(+0.0+(+temp_VS_BP_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VD_S*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VS_BP_VS_BP=(+0.0+(+temp_VS_BP_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VS_BP*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
#endif
TP=(1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
EXIT_IF_ISNAN((1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))))
}
else
{
if
((temp>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,temp)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=temp_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VGP_S+d10_exp0*temp_VGP_S_VGP_S);
  TP_VGP_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VGP_S+d10_exp0*temp_VGP_S_VD_S);
  TP_VGP_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VGP_S+d10_exp0*temp_VGP_S_VS_BP);
#endif
TP_VD_S=temp_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VD_S+d10_exp0*temp_VD_S_VGP_S);
  TP_VD_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VD_S+d10_exp0*temp_VD_S_VD_S);
  TP_VD_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VD_S+d10_exp0*temp_VD_S_VS_BP);
#endif
TP_VS_BP=temp_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VS_BP+d10_exp0*temp_VS_BP_VGP_S);
  TP_VS_BP_VD_S=(m20_exp(temp)*temp_VD_S*temp_VS_BP+d10_exp0*temp_VS_BP_VD_S);
  TP_VS_BP_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VS_BP+d10_exp0*temp_VS_BP_VS_BP);
#endif
#endif
TP=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=(-1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
TP_VD_S=(-1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VD_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
TP_VS_BP=(-1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
#endif
TP=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))))
}
}
{
double m00_logE(d00_logE0,((1.0+Dsi)/(1.0+Dgate)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((1.0+Dsi)/(1.0+Dgate)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igdov_VGP_S=(pInst->IGOVD_i*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igdov_VGP_S_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VGP_S_VGP_S*d00_logE0+TP_VGP_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VGP_S)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VGP_S+Dsi_VGP_S*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igdov_VGP_S_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VGP_S_VD_S*d00_logE0+TP_VGP_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VD_S)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VD_S+Dsi_VD_S*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igdov_VGP_S_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VGP_S_VS_BP*d00_logE0+TP_VGP_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VS_BP)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VS_BP+Dsi_VS_BP*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
Igdov_VD_S=(pInst->IGOVD_i*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igdov_VD_S_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VD_S_VGP_S*d00_logE0+TP_VD_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VGP_S)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VGP_S+Dsi_VGP_S*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igdov_VD_S_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VD_S_VD_S*d00_logE0+TP_VD_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VD_S)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VD_S+Dsi_VD_S*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igdov_VD_S_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VD_S_VS_BP*d00_logE0+TP_VD_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VS_BP)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VS_BP+Dsi_VS_BP*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
Igdov_VS_BP=(pInst->IGOVD_i*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igdov_VS_BP_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VS_BP_VGP_S*d00_logE0+TP_VS_BP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VGP_S)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VGP_S+Dsi_VGP_S*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igdov_VS_BP_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VS_BP_VD_S*d00_logE0+TP_VS_BP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VD_S)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VD_S+Dsi_VD_S*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igdov_VS_BP_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGOVD_i*(+TP_VS_BP_VS_BP*d00_logE0+TP_VS_BP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VS_BP)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VS_BP+Dsi_VS_BP*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
#endif
pInst->Igdov=(pInst->IGOVD_i*(TP*d00_logE0));
EXIT_IF_ISNAN((pInst->IGOVD_i*(TP*d00_logE0)))
}
}
if
((pInst->IGINV_i>0))
{
if
((pInst->xg<=0.0))
{
{
double m00_pow(d00_pow0,(Vds/pInst->Vdsat_lim),pInst->AX_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(Vds/pInst->Vdsat_lim),pInst->AX_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=0.0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=0.0;
  temp_VGP_S_VD_S=0.0;
  temp_VGP_S_VS_BP=0.0;
#endif
temp_VD_S=(d10_pow0*(Vds_VD_S/pInst->Vdsat_lim));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=fixme;
  temp_VD_S_VS_BS=fixme;
  temp_VD_S_VGP_S=fixme;
  temp_VD_S_VD_S=fixme;
  temp_VD_S_VS_BP=fixme;
#endif
temp_VS_BP=0.0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=0.0;
  temp_VS_BP_VS_BS=0.0;
  temp_VS_BP_VGP_S=0.0;
  temp_VS_BP_VD_S=0.0;
  temp_VS_BP_VS_BP=0.0;
#endif
#endif
temp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(1.0+temp),(-pInst->inv_AX))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0+temp),(-pInst->inv_AX))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(S,BP)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Udse_VGP_S=(Vds*(d10_pow0*temp_VGP_S))*pInst->inv_phit1;
#if defined(_DERIVATE2)
  Udse_VGP_S_VGP_S=(+(+0.0*d00_pow0+0.0*(d10_pow0*temp_VGP_S)+0.0*(d10_pow0*temp_VGP_S)+Vds*fixme)*pInst->inv_phit1+(Vds*(d10_pow0*temp_VGP_S))*0.0+((Vds*(d10_pow0*temp_VGP_S)))*0.0+(Vds*d00_pow0)*0.0);
  Udse_VGP_S_VS_BP=(+(+0.0*d00_pow0+0.0*(d10_pow0*temp_VS_BP)+0.0*(d10_pow0*temp_VGP_S)+Vds*fixme)*pInst->inv_phit1+(Vds*(d10_pow0*temp_VGP_S))*0.0+((Vds*(d10_pow0*temp_VS_BP)))*0.0+(Vds*d00_pow0)*0.0);
  Udse_VGP_S_VD_S=(+(+0.0*d00_pow0+0.0*(d10_pow0*temp_VD_S)+Vds_VD_S*(d10_pow0*temp_VGP_S)+Vds*fixme)*pInst->inv_phit1+(Vds*(d10_pow0*temp_VGP_S))*0.0+(((Vds_VD_S*d00_pow0)+(Vds*(d10_pow0*temp_VD_S))))*0.0+(Vds*d00_pow0)*0.0);
#endif
Udse_VS_BP=(Vds*(d10_pow0*temp_VS_BP))*pInst->inv_phit1;
#if defined(_DERIVATE2)
  Udse_VS_BP_VGP_S=(+(+0.0*d00_pow0+0.0*(d10_pow0*temp_VGP_S)+0.0*(d10_pow0*temp_VS_BP)+Vds*fixme)*pInst->inv_phit1+(Vds*(d10_pow0*temp_VS_BP))*0.0+((Vds*(d10_pow0*temp_VGP_S)))*0.0+(Vds*d00_pow0)*0.0);
  Udse_VS_BP_VS_BP=(+(+0.0*d00_pow0+0.0*(d10_pow0*temp_VS_BP)+0.0*(d10_pow0*temp_VS_BP)+Vds*fixme)*pInst->inv_phit1+(Vds*(d10_pow0*temp_VS_BP))*0.0+((Vds*(d10_pow0*temp_VS_BP)))*0.0+(Vds*d00_pow0)*0.0);
  Udse_VS_BP_VD_S=(+(+0.0*d00_pow0+0.0*(d10_pow0*temp_VD_S)+Vds_VD_S*(d10_pow0*temp_VS_BP)+Vds*fixme)*pInst->inv_phit1+(Vds*(d10_pow0*temp_VS_BP))*0.0+(((Vds_VD_S*d00_pow0)+(Vds*(d10_pow0*temp_VD_S))))*0.0+(Vds*d00_pow0)*0.0);
#endif
Udse_VD_S=((Vds_VD_S*d00_pow0)+(Vds*(d10_pow0*temp_VD_S)))*pInst->inv_phit1;
#if defined(_DERIVATE2)
  Udse_VD_S_VGP_S=(+(+0.0*d00_pow0+Vds_VD_S*(d10_pow0*temp_VGP_S)+0.0*(d10_pow0*temp_VD_S)+Vds*fixme)*pInst->inv_phit1+((Vds_VD_S*d00_pow0)+(Vds*(d10_pow0*temp_VD_S)))*0.0+((Vds*(d10_pow0*temp_VGP_S)))*0.0+(Vds*d00_pow0)*0.0);
  Udse_VD_S_VS_BP=(+(+0.0*d00_pow0+Vds_VD_S*(d10_pow0*temp_VS_BP)+0.0*(d10_pow0*temp_VD_S)+Vds*fixme)*pInst->inv_phit1+((Vds_VD_S*d00_pow0)+(Vds*(d10_pow0*temp_VD_S)))*0.0+((Vds*(d10_pow0*temp_VS_BP)))*0.0+(Vds*d00_pow0)*0.0);
  Udse_VD_S_VD_S=(+(+Vds_VD_S_VD_S*d00_pow0+Vds_VD_S*(d10_pow0*temp_VD_S)+Vds_VD_S*(d10_pow0*temp_VD_S)+Vds*fixme)*pInst->inv_phit1+((Vds_VD_S*d00_pow0)+(Vds*(d10_pow0*temp_VD_S)))*0.0+(((Vds_VD_S*d00_pow0)+(Vds*(d10_pow0*temp_VD_S))))*0.0+(Vds*d00_pow0)*0.0);
#endif
#endif
Udse=((Vds*d00_pow0)*pInst->inv_phit1);
EXIT_IF_ISNAN(((Vds*d00_pow0)*pInst->inv_phit1))
}
}
if
(((x_ds-Udse)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,(x_ds-Udse))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(x_ds_VGP_S-Udse_VGP_S)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=(m20_exp((x_ds-Udse))*(x_ds_VGP_S-Udse_VGP_S)*(x_ds_VGP_S-Udse_VGP_S)+d10_exp0*(+x_ds_VGP_S_VGP_S-Udse_VGP_S_VGP_S));
  temp_VGP_S_VD_S=(m20_exp((x_ds-Udse))*(x_ds_VD_S-Udse_VD_S)*(x_ds_VGP_S-Udse_VGP_S)+d10_exp0*(+x_ds_VGP_S_VD_S-Udse_VGP_S_VD_S));
  temp_VGP_S_VS_BP=(m20_exp((x_ds-Udse))*(x_ds_VS_BP-Udse_VS_BP)*(x_ds_VGP_S-Udse_VGP_S)+d10_exp0*(+x_ds_VGP_S_VS_BP-Udse_VGP_S_VS_BP));
#endif
temp_VD_S=(x_ds_VD_S-Udse_VD_S)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=0.0;
  temp_VD_S_VS_BS=0.0;
  temp_VD_S_VGP_S=(m20_exp((x_ds-Udse))*(x_ds_VGP_S-Udse_VGP_S)*(x_ds_VD_S-Udse_VD_S)+d10_exp0*(+x_ds_VD_S_VGP_S-Udse_VD_S_VGP_S));
  temp_VD_S_VD_S=(m20_exp((x_ds-Udse))*(x_ds_VD_S-Udse_VD_S)*(x_ds_VD_S-Udse_VD_S)+d10_exp0*(+x_ds_VD_S_VD_S-Udse_VD_S_VD_S));
  temp_VD_S_VS_BP=(m20_exp((x_ds-Udse))*(x_ds_VS_BP-Udse_VS_BP)*(x_ds_VD_S-Udse_VD_S)+d10_exp0*(+x_ds_VD_S_VS_BP-Udse_VD_S_VS_BP));
#endif
temp_VS_BP=(x_ds_VS_BP-Udse_VS_BP)*d10_exp0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=0.0;
  temp_VS_BP_VS_BS=0.0;
  temp_VS_BP_VGP_S=(m20_exp((x_ds-Udse))*(x_ds_VGP_S-Udse_VGP_S)*(x_ds_VS_BP-Udse_VS_BP)+d10_exp0*(+x_ds_VS_BP_VGP_S-Udse_VS_BP_VGP_S));
  temp_VS_BP_VD_S=(m20_exp((x_ds-Udse))*(x_ds_VD_S-Udse_VD_S)*(x_ds_VS_BP-Udse_VS_BP)+d10_exp0*(+x_ds_VS_BP_VD_S-Udse_VS_BP_VD_S));
  temp_VS_BP_VS_BP=(m20_exp((x_ds-Udse))*(x_ds_VS_BP-Udse_VS_BP)*(x_ds_VS_BP-Udse_VS_BP)+d10_exp0*(+x_ds_VS_BP_VS_BP-Udse_VS_BP_VS_BP));
#endif
#endif
temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-1.0e-100*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0-0.0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VGP_S-Udse_VGP_S))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))+0.0*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0-0.0))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VGP_S-Udse_VGP_S))*(0.0)+0.0*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+0.0-0.0))*3.3333333333333333e-01+(-(x_ds_VGP_S-Udse_VGP_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0-0.0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VGP_S-Udse_VGP_S))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))+0.0*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0-0.0))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VGP_S-Udse_VGP_S))*(0.0)+0.0*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+0.0-0.0))*3.3333333333333333e-01+(-(x_ds_VGP_S-Udse_VGP_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VGP_S_VGP_S-Udse_VGP_S_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VGP_S-Udse_VGP_S))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))))))+(-(x_ds_VGP_S-Udse_VGP_S))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VGP_S_VGP_S-Udse_VGP_S_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VGP_S-Udse_VGP_S))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)+(-(x_ds_VGP_S-Udse_VGP_S))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VGP_S_VGP_S-Udse_VGP_S_VGP_S))*3.3333333333333333e-01+(-(x_ds_VGP_S-Udse_VGP_S))*0.0+(-(x_ds_VGP_S-Udse_VGP_S))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VGP_S_VD_S-Udse_VGP_S_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VGP_S-Udse_VGP_S))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))))))+(-(x_ds_VD_S-Udse_VD_S))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VGP_S_VD_S-Udse_VGP_S_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VGP_S-Udse_VGP_S))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)+(-(x_ds_VD_S-Udse_VD_S))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VGP_S_VD_S-Udse_VGP_S_VD_S))*3.3333333333333333e-01+(-(x_ds_VGP_S-Udse_VGP_S))*0.0+(-(x_ds_VD_S-Udse_VD_S))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VGP_S_VS_BP-Udse_VGP_S_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VGP_S-Udse_VGP_S))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))))))+(-(x_ds_VS_BP-Udse_VS_BP))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VGP_S_VS_BP-Udse_VGP_S_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VGP_S-Udse_VGP_S))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)+(-(x_ds_VS_BP-Udse_VS_BP))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VGP_S_VS_BP-Udse_VGP_S_VS_BP))*3.3333333333333333e-01+(-(x_ds_VGP_S-Udse_VGP_S))*0.0+(-(x_ds_VS_BP-Udse_VS_BP))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
#endif
temp_VD_S=(-1.0e-100*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0-0.0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VD_S-Udse_VD_S))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))+0.0*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0-0.0))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VD_S-Udse_VD_S))*(0.0)+0.0*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+0.0-0.0))*3.3333333333333333e-01+(-(x_ds_VD_S-Udse_VD_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0-0.0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VD_S-Udse_VD_S))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))+0.0*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0-0.0))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VD_S-Udse_VD_S))*(0.0)+0.0*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+0.0-0.0))*3.3333333333333333e-01+(-(x_ds_VD_S-Udse_VD_S))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VD_S_VGP_S-Udse_VD_S_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VD_S-Udse_VD_S))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))))))+(-(x_ds_VGP_S-Udse_VGP_S))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VD_S_VGP_S-Udse_VD_S_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VD_S-Udse_VD_S))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)+(-(x_ds_VGP_S-Udse_VGP_S))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VD_S_VGP_S-Udse_VD_S_VGP_S))*3.3333333333333333e-01+(-(x_ds_VD_S-Udse_VD_S))*0.0+(-(x_ds_VGP_S-Udse_VGP_S))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VD_S_VD_S-Udse_VD_S_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VD_S-Udse_VD_S))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))))))+(-(x_ds_VD_S-Udse_VD_S))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VD_S_VD_S-Udse_VD_S_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VD_S-Udse_VD_S))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)+(-(x_ds_VD_S-Udse_VD_S))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VD_S_VD_S-Udse_VD_S_VD_S))*3.3333333333333333e-01+(-(x_ds_VD_S-Udse_VD_S))*0.0+(-(x_ds_VD_S-Udse_VD_S))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VD_S_VS_BP-Udse_VD_S_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VD_S-Udse_VD_S))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))))))+(-(x_ds_VS_BP-Udse_VS_BP))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VD_S_VS_BP-Udse_VD_S_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VD_S-Udse_VD_S))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)+(-(x_ds_VS_BP-Udse_VS_BP))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VD_S_VS_BP-Udse_VD_S_VS_BP))*3.3333333333333333e-01+(-(x_ds_VD_S-Udse_VD_S))*0.0+(-(x_ds_VS_BP-Udse_VS_BP))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
#endif
temp_VS_BP=(-1.0e-100*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0-0.0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VS_BP-Udse_VS_BP))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))+0.0*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0-0.0))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VS_BP-Udse_VS_BP))*(0.0)+0.0*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+0.0-0.0))*3.3333333333333333e-01+(-(x_ds_VS_BP-Udse_VS_BP))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0-0.0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VS_BP-Udse_VS_BP))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))+0.0*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0-0.0))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VS_BP-Udse_VS_BP))*(0.0)+0.0*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+0.0-0.0))*3.3333333333333333e-01+(-(x_ds_VS_BP-Udse_VS_BP))*0.0+0.0*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-2.3025850929940458e+02)-(x_ds-Udse))*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VS_BP_VGP_S-Udse_VS_BP_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VS_BP-Udse_VS_BP))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))))))+(-(x_ds_VGP_S-Udse_VGP_S))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VS_BP_VGP_S-Udse_VS_BP_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VS_BP-Udse_VS_BP))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)+(-(x_ds_VGP_S-Udse_VGP_S))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VS_BP_VGP_S-Udse_VS_BP_VGP_S))*3.3333333333333333e-01+(-(x_ds_VS_BP-Udse_VS_BP))*0.0+(-(x_ds_VGP_S-Udse_VGP_S))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VGP_S-Udse_VGP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VGP_S-Udse_VGP_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VS_BP_VD_S-Udse_VS_BP_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VS_BP-Udse_VS_BP))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))))))+(-(x_ds_VD_S-Udse_VD_S))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VS_BP_VD_S-Udse_VS_BP_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VS_BP-Udse_VS_BP))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)+(-(x_ds_VD_S-Udse_VD_S))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VS_BP_VD_S-Udse_VS_BP_VD_S))*3.3333333333333333e-01+(-(x_ds_VS_BP-Udse_VS_BP))*0.0+(-(x_ds_VD_S-Udse_VD_S))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VD_S-Udse_VD_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VD_S-Udse_VD_S))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))-(0.0*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))))))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+x_ds_VS_BP_VS_BP-Udse_VS_BP_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))+(-(x_ds_VS_BP-Udse_VS_BP))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))))))+(-(x_ds_VS_BP-Udse_VS_BP))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+0.0*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))))+0.0*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01))+0.5*(+(+0.0-(+x_ds_VS_BP_VS_BP-Udse_VS_BP_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))+(-(x_ds_VS_BP-Udse_VS_BP))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)+(-(x_ds_VS_BP-Udse_VS_BP))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(x_ds-Udse))*(+0.0+(+(+0.0-(+x_ds_VS_BP_VS_BP-Udse_VS_BP_VS_BP))*3.3333333333333333e-01+(-(x_ds_VS_BP-Udse_VS_BP))*0.0+(-(x_ds_VS_BP-Udse_VS_BP))*0.0+((-2.3025850929940458e+02)-(x_ds-Udse))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(0.5*(((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((0.5*((((-(x_ds_VS_BP-Udse_VS_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(x_ds-Udse))*((-(x_ds_VS_BP-Udse_VS_BP))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
#endif
#endif
temp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))))
}
{
double m00_logE(d00_logE0,(0.5*(1.0+temp)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(0.5*(1.0+temp)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vm_VD_S=(Vsbstar_VD_S+(pInst->phit1*((0.5*x_ds_VD_S)-(0.5*temp_VD_S)*d10_logE0)));
#if defined(_DERIVATE2)
  Vm_VD_S_VD_S=(+Vsbstar_VD_S_VD_S+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VD_S))-((0.5*temp_VD_S))*d10_logE0)+0.0*((0.5*x_ds_VD_S)-(0.5*temp_VD_S)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VD_S+0.0*x_ds_VD_S+0.5*x_ds_VD_S_VD_S)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VD_S))*(0.5*temp_VD_S)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VD_S+0.0*temp_VD_S+0.5*(+0.0+temp_VD_S_VD_S))))));
  Vm_VD_S_VS_BP=(+Vsbstar_VD_S_VS_BP+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VS_BP))-((0.5*temp_VS_BP))*d10_logE0)+0.0*((0.5*x_ds_VD_S)-(0.5*temp_VD_S)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VS_BP+0.0*x_ds_VD_S+0.5*x_ds_VD_S_VS_BP)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VS_BP))*(0.5*temp_VD_S)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VS_BP+0.0*temp_VD_S+0.5*(+0.0+temp_VD_S_VS_BP))))));
  Vm_VD_S_VGP_S=(+0.0+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VGP_S))-((0.5*temp_VGP_S))*d10_logE0)+0.0*((0.5*x_ds_VD_S)-(0.5*temp_VD_S)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VGP_S+0.0*x_ds_VD_S+0.5*x_ds_VD_S_VGP_S)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VGP_S))*(0.5*temp_VD_S)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VGP_S+0.0*temp_VD_S+0.5*(+0.0+temp_VD_S_VGP_S))))));
#endif
Vm_VS_BP=(Vsbstar_VS_BP+(pInst->phit1*((0.5*x_ds_VS_BP)-(0.5*temp_VS_BP)*d10_logE0)));
#if defined(_DERIVATE2)
  Vm_VS_BP_VD_S=(+Vsbstar_VS_BP_VD_S+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VD_S))-((0.5*temp_VD_S))*d10_logE0)+0.0*((0.5*x_ds_VS_BP)-(0.5*temp_VS_BP)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VD_S+0.0*x_ds_VS_BP+0.5*x_ds_VS_BP_VD_S)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VD_S))*(0.5*temp_VS_BP)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VD_S+0.0*temp_VS_BP+0.5*(+0.0+temp_VS_BP_VD_S))))));
  Vm_VS_BP_VS_BP=(+Vsbstar_VS_BP_VS_BP+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VS_BP))-((0.5*temp_VS_BP))*d10_logE0)+0.0*((0.5*x_ds_VS_BP)-(0.5*temp_VS_BP)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VS_BP+0.0*x_ds_VS_BP+0.5*x_ds_VS_BP_VS_BP)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VS_BP))*(0.5*temp_VS_BP)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VS_BP+0.0*temp_VS_BP+0.5*(+0.0+temp_VS_BP_VS_BP))))));
  Vm_VS_BP_VGP_S=(+0.0+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VGP_S))-((0.5*temp_VGP_S))*d10_logE0)+0.0*((0.5*x_ds_VS_BP)-(0.5*temp_VS_BP)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VGP_S+0.0*x_ds_VS_BP+0.5*x_ds_VS_BP_VGP_S)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VGP_S))*(0.5*temp_VS_BP)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VGP_S+0.0*temp_VS_BP+0.5*(+0.0+temp_VS_BP_VGP_S))))));
#endif
Vm_VGP_S=(pInst->phit1*((0.5*x_ds_VGP_S)-(0.5*temp_VGP_S)*d10_logE0));
#if defined(_DERIVATE2)
  Vm_VGP_S_VD_S=(+0.0+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VD_S))-((0.5*temp_VD_S))*d10_logE0)+0.0*((0.5*x_ds_VGP_S)-(0.5*temp_VGP_S)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VD_S+0.0*x_ds_VGP_S+0.5*x_ds_VGP_S_VD_S)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VD_S))*(0.5*temp_VGP_S)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VD_S+0.0*temp_VGP_S+0.5*(+0.0+temp_VGP_S_VD_S))))));
  Vm_VGP_S_VS_BP=(+0.0+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VS_BP))-((0.5*temp_VS_BP))*d10_logE0)+0.0*((0.5*x_ds_VGP_S)-(0.5*temp_VGP_S)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VS_BP+0.0*x_ds_VGP_S+0.5*x_ds_VGP_S_VS_BP)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VS_BP))*(0.5*temp_VGP_S)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VS_BP+0.0*temp_VGP_S+0.5*(+0.0+temp_VGP_S_VS_BP))))));
  Vm_VGP_S_VGP_S=(+0.0+(+0.0*((0.5*x_ds)-d00_logE0)+0.0*(((0.5*x_ds_VGP_S))-((0.5*temp_VGP_S))*d10_logE0)+0.0*((0.5*x_ds_VGP_S)-(0.5*temp_VGP_S)*d10_logE0)+pInst->phit1*(+(+0.0*x_ds+0.0*x_ds_VGP_S+0.0*x_ds_VGP_S+0.5*x_ds_VGP_S_VGP_S)-(m20_logE((0.5*(1.0+temp)))*((0.5*temp_VGP_S))*(0.5*temp_VGP_S)+d10_logE0*(+0.0*(1.0+temp)+0.0*temp_VGP_S+0.0*temp_VGP_S+0.5*(+0.0+temp_VGP_S_VGP_S))))));
#endif
#endif
Vm=(Vsbstar+(pInst->phit1*((0.5*x_ds)-d00_logE0)));
EXIT_IF_ISNAN((Vsbstar+(pInst->phit1*((0.5*x_ds)-d00_logE0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg2mina_VGP_S=Voxm_VGP_S;
#if defined(_DERIVATE2)
  arg2mina_VGP_S_VGP_S=(+Voxm_VGP_S_VGP_S+0.0);
  arg2mina_VGP_S_VD_S=(+Voxm_VGP_S_VD_S+0.0);
  arg2mina_VGP_S_VS_BP=(+Voxm_VGP_S_VS_BP+0.0);
#endif
arg2mina_VD_S=Voxm_VD_S;
#if defined(_DERIVATE2)
  arg2mina_VD_S_VGP_S=(+Voxm_VD_S_VGP_S+0.0);
  arg2mina_VD_S_VD_S=(+Voxm_VD_S_VD_S+0.0);
  arg2mina_VD_S_VS_BP=(+Voxm_VD_S_VS_BP+0.0);
#endif
arg2mina_VS_BP=Voxm_VS_BP;
#if defined(_DERIVATE2)
  arg2mina_VS_BP_VGP_S=(+Voxm_VS_BP_VGP_S+0.0);
  arg2mina_VS_BP_VD_S=(+Voxm_VS_BP_VD_S+0.0);
  arg2mina_VS_BP_VS_BP=(+Voxm_VS_BP_VS_BP+0.0);
#endif
#endif
arg2mina=(Voxm+pInst->Dch);
EXIT_IF_ISNAN((Voxm+pInst->Dch))
{
double m00_sqrt(d00_sqrt0,(((-arg2mina)*(-arg2mina))+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((-arg2mina)*(-arg2mina))+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
psi_t_VGP_S=(0.5*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VGP_S_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VGP_S)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VGP_S))+0.0))));
  psi_t_VGP_S_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VD_S)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VD_S))+0.0))));
  psi_t_VGP_S_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VGP_S-(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VGP_S_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VGP_S_VS_BP)*(-arg2mina)+(-arg2mina_VGP_S)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VGP_S)+(-arg2mina)*(+0.0-arg2mina_VGP_S_VS_BP))+0.0))));
#endif
psi_t_VD_S=(0.5*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VD_S_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VGP_S)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VGP_S))+0.0))));
  psi_t_VD_S_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VD_S)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VD_S))+0.0))));
  psi_t_VD_S_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VD_S-(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VD_S_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S)))+d10_sqrt0*(+(+(+0.0-arg2mina_VD_S_VS_BP)*(-arg2mina)+(-arg2mina_VD_S)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VD_S)+(-arg2mina)*(+0.0-arg2mina_VD_S_VS_BP))+0.0))));
#endif
psi_t_VS_BP=(0.5*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0));
#if defined(_DERIVATE2)
  psi_t_VS_BP_VGP_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VGP_S-((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VGP_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VGP_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VGP_S))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VGP_S)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VGP_S)+(-arg2mina_VGP_S)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VGP_S))+0.0))));
  psi_t_VS_BP_VD_S=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VD_S-((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VD_S)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VD_S)*(-arg2mina))+((-arg2mina)*(-arg2mina_VD_S))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VD_S)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VD_S)+(-arg2mina_VD_S)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VD_S))+0.0))));
  psi_t_VS_BP_VS_BP=(+0.0*((+arg2mina)-d00_sqrt0)+0.0*(arg2mina_VS_BP-((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*d10_sqrt0)+0.0*(arg2mina_VS_BP-(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))*d10_sqrt0)+0.5*(+(+0.0+arg2mina_VS_BP_VS_BP)-(m20_sqrt((((-arg2mina)*(-arg2mina))+0.01))*((((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP))))*(((-arg2mina_VS_BP)*(-arg2mina))+((-arg2mina)*(-arg2mina_VS_BP)))+d10_sqrt0*(+(+(+0.0-arg2mina_VS_BP_VS_BP)*(-arg2mina)+(-arg2mina_VS_BP)*(-arg2mina_VS_BP)+(-arg2mina_VS_BP)*(-arg2mina_VS_BP)+(-arg2mina)*(+0.0-arg2mina_VS_BP_VS_BP))+0.0))));
#endif
#endif
psi_t=(0.5*((+arg2mina)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((+arg2mina)-d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,((Voxm*Voxm)+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Voxm*Voxm)+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
zg_VGP_S=((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VGP_S_VGP_S=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S)))*((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S))+d10_sqrt0*(+(+Voxm_VGP_S_VGP_S*Voxm+Voxm_VGP_S*Voxm_VGP_S+Voxm_VGP_S*Voxm_VGP_S+Voxm*Voxm_VGP_S_VGP_S)+0.0))*pInst->inv_CHIB+((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S))*d10_sqrt0*0.0+(((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VGP_S_VD_S=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S)))*((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S))+d10_sqrt0*(+(+Voxm_VGP_S_VD_S*Voxm+Voxm_VGP_S*Voxm_VD_S+Voxm_VD_S*Voxm_VGP_S+Voxm*Voxm_VGP_S_VD_S)+0.0))*pInst->inv_CHIB+((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S))*d10_sqrt0*0.0+(((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VGP_S_VS_BP=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP)))*((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S))+d10_sqrt0*(+(+Voxm_VGP_S_VS_BP*Voxm+Voxm_VGP_S*Voxm_VS_BP+Voxm_VS_BP*Voxm_VGP_S+Voxm*Voxm_VGP_S_VS_BP)+0.0))*pInst->inv_CHIB+((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S))*d10_sqrt0*0.0+(((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
zg_VD_S=((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VD_S_VGP_S=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S)))*((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S))+d10_sqrt0*(+(+Voxm_VD_S_VGP_S*Voxm+Voxm_VD_S*Voxm_VGP_S+Voxm_VGP_S*Voxm_VD_S+Voxm*Voxm_VD_S_VGP_S)+0.0))*pInst->inv_CHIB+((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S))*d10_sqrt0*0.0+(((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VD_S_VD_S=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S)))*((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S))+d10_sqrt0*(+(+Voxm_VD_S_VD_S*Voxm+Voxm_VD_S*Voxm_VD_S+Voxm_VD_S*Voxm_VD_S+Voxm*Voxm_VD_S_VD_S)+0.0))*pInst->inv_CHIB+((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S))*d10_sqrt0*0.0+(((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VD_S_VS_BP=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP)))*((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S))+d10_sqrt0*(+(+Voxm_VD_S_VS_BP*Voxm+Voxm_VD_S*Voxm_VS_BP+Voxm_VS_BP*Voxm_VD_S+Voxm*Voxm_VD_S_VS_BP)+0.0))*pInst->inv_CHIB+((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S))*d10_sqrt0*0.0+(((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
zg_VS_BP=((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP))*d10_sqrt0*pInst->inv_CHIB;
#if defined(_DERIVATE2)
  zg_VS_BP_VGP_S=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S)))*((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP))+d10_sqrt0*(+(+Voxm_VS_BP_VGP_S*Voxm+Voxm_VS_BP*Voxm_VGP_S+Voxm_VGP_S*Voxm_VS_BP+Voxm*Voxm_VS_BP_VGP_S)+0.0))*pInst->inv_CHIB+((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP))*d10_sqrt0*0.0+(((Voxm_VGP_S*Voxm)+(Voxm*Voxm_VGP_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VS_BP_VD_S=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S)))*((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP))+d10_sqrt0*(+(+Voxm_VS_BP_VD_S*Voxm+Voxm_VS_BP*Voxm_VD_S+Voxm_VD_S*Voxm_VS_BP+Voxm*Voxm_VS_BP_VD_S)+0.0))*pInst->inv_CHIB+((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP))*d10_sqrt0*0.0+(((Voxm_VD_S*Voxm)+(Voxm*Voxm_VD_S)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
  zg_VS_BP_VS_BP=(+(m20_sqrt(((Voxm*Voxm)+1.0e-6))*(((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP)))*((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP))+d10_sqrt0*(+(+Voxm_VS_BP_VS_BP*Voxm+Voxm_VS_BP*Voxm_VS_BP+Voxm_VS_BP*Voxm_VS_BP+Voxm*Voxm_VS_BP_VS_BP)+0.0))*pInst->inv_CHIB+((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP))*d10_sqrt0*0.0+(((Voxm_VS_BP*Voxm)+(Voxm*Voxm_VS_BP)))*d10_sqrt0*0.0+d00_sqrt0*0.0);
#endif
#endif
zg=(d00_sqrt0*pInst->inv_CHIB);
EXIT_IF_ISNAN((d00_sqrt0*pInst->inv_CHIB))
}
if
((pInst->GC3_i<0))
{
{
double m00_sqrt(d00_sqrt0,(((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
zg_VGP_S=(0.5*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VGP_S_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VGP_S+zg_VGP_S*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VGP_S-0.0))+0.0))));
  zg_VGP_S_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VD_S-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VD_S+zg_VD_S*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VD_S-0.0))+0.0))));
  zg_VGP_S_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VGP_S-((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))*d10_sqrt0)+0.5*(+(+zg_VGP_S_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S))+d10_sqrt0*(+(+(+zg_VGP_S_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VGP_S*zg_VS_BP+zg_VS_BP*zg_VGP_S+(zg-pInst->GCQ)*(+zg_VGP_S_VS_BP-0.0))+0.0))));
#endif
zg_VD_S=(0.5*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VD_S_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VGP_S+zg_VGP_S*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VGP_S-0.0))+0.0))));
  zg_VD_S_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VD_S-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VD_S+zg_VD_S*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VD_S-0.0))+0.0))));
  zg_VD_S_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VD_S-((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))*d10_sqrt0)+0.5*(+(+zg_VD_S_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S))+d10_sqrt0*(+(+(+zg_VD_S_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VD_S*zg_VS_BP+zg_VS_BP*zg_VD_S+(zg-pInst->GCQ)*(+zg_VD_S_VS_BP-0.0))+0.0))));
#endif
zg_VS_BP=(0.5*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0));
#if defined(_DERIVATE2)
  zg_VS_BP_VGP_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VGP_S-(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VGP_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VGP_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VGP_S)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VGP_S-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VGP_S+zg_VGP_S*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VGP_S-0.0))+0.0))));
  zg_VS_BP_VD_S=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VD_S-(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VD_S+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VD_S*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VD_S)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VD_S-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VD_S+zg_VD_S*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VD_S-0.0))+0.0))));
  zg_VS_BP_VS_BP=(+0.0*((zg+pInst->GCQ)-d00_sqrt0)+0.0*(zg_VS_BP-(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*d10_sqrt0)+0.0*(zg_VS_BP-((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))*d10_sqrt0)+0.5*(+(+zg_VS_BP_VS_BP+0.0)-(m20_sqrt((((zg-pInst->GCQ)*(zg-pInst->GCQ))+1.0e-06))*(((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP)))*((zg_VS_BP*(zg-pInst->GCQ))+((zg-pInst->GCQ)*zg_VS_BP))+d10_sqrt0*(+(+(+zg_VS_BP_VS_BP-0.0)*(zg-pInst->GCQ)+zg_VS_BP*zg_VS_BP+zg_VS_BP*zg_VS_BP+(zg-pInst->GCQ)*(+zg_VS_BP_VS_BP-0.0))+0.0))));
#endif
#endif
zg=(0.5*((zg+pInst->GCQ)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((zg+pInst->GCQ)-d00_sqrt0)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg1_VD_S=(x_m_VD_S+(psi_t_VD_S-Vm_VD_S)*pInst->inv_phit1);
#if defined(_DERIVATE2)
  arg1_VD_S_VD_S=(+x_m_VD_S_VD_S+(+(+(+psi_t_VD_S_VD_S-0.0)-Vm_VD_S_VD_S)*pInst->inv_phit1+(psi_t_VD_S-Vm_VD_S)*0.0+(psi_t_VD_S-Vm_VD_S)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
  arg1_VD_S_VS_BP=(+x_m_VD_S_VS_BP+(+(+(+psi_t_VD_S_VS_BP-0.0)-Vm_VD_S_VS_BP)*pInst->inv_phit1+(psi_t_VD_S-Vm_VD_S)*0.0+(psi_t_VS_BP-Vm_VS_BP)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
  arg1_VD_S_VGP_S=(+x_m_VD_S_VGP_S+(+(+(+psi_t_VD_S_VGP_S-0.0)-Vm_VD_S_VGP_S)*pInst->inv_phit1+(psi_t_VD_S-Vm_VD_S)*0.0+(psi_t_VGP_S-Vm_VGP_S)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
#endif
arg1_VS_BP=(x_m_VS_BP+(psi_t_VS_BP-Vm_VS_BP)*pInst->inv_phit1);
#if defined(_DERIVATE2)
  arg1_VS_BP_VD_S=(+x_m_VS_BP_VD_S+(+(+(+psi_t_VS_BP_VD_S-0.0)-Vm_VS_BP_VD_S)*pInst->inv_phit1+(psi_t_VS_BP-Vm_VS_BP)*0.0+(psi_t_VD_S-Vm_VD_S)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
  arg1_VS_BP_VS_BP=(+x_m_VS_BP_VS_BP+(+(+(+psi_t_VS_BP_VS_BP-0.0)-Vm_VS_BP_VS_BP)*pInst->inv_phit1+(psi_t_VS_BP-Vm_VS_BP)*0.0+(psi_t_VS_BP-Vm_VS_BP)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
  arg1_VS_BP_VGP_S=(+x_m_VS_BP_VGP_S+(+(+(+psi_t_VS_BP_VGP_S-0.0)-Vm_VS_BP_VGP_S)*pInst->inv_phit1+(psi_t_VS_BP-Vm_VS_BP)*0.0+(psi_t_VGP_S-Vm_VGP_S)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
#endif
arg1_VGP_S=(x_m_VGP_S+(psi_t_VGP_S-Vm_VGP_S)*pInst->inv_phit1);
#if defined(_DERIVATE2)
  arg1_VGP_S_VD_S=(+x_m_VGP_S_VD_S+(+(+(+psi_t_VGP_S_VD_S-0.0)-Vm_VGP_S_VD_S)*pInst->inv_phit1+(psi_t_VGP_S-Vm_VGP_S)*0.0+(psi_t_VD_S-Vm_VD_S)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
  arg1_VGP_S_VS_BP=(+x_m_VGP_S_VS_BP+(+(+(+psi_t_VGP_S_VS_BP-0.0)-Vm_VGP_S_VS_BP)*pInst->inv_phit1+(psi_t_VGP_S-Vm_VGP_S)*0.0+(psi_t_VS_BP-Vm_VS_BP)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
  arg1_VGP_S_VGP_S=(+x_m_VGP_S_VGP_S+(+(+(+psi_t_VGP_S_VGP_S-0.0)-Vm_VGP_S_VGP_S)*pInst->inv_phit1+(psi_t_VGP_S-Vm_VGP_S)*0.0+(psi_t_VGP_S-Vm_VGP_S)*0.0+((psi_t-pInst->alpha_b)-Vm)*0.0));
#endif
#endif
arg1=(x_m+(((psi_t-pInst->alpha_b)-Vm)*pInst->inv_phit1));
EXIT_IF_ISNAN((x_m+(((psi_t-pInst->alpha_b)-Vm)*pInst->inv_phit1)))
{
double m00_fabs(d00_fabs0,arg1)
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,arg1)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=arg1_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VD_S+d10_exp0*arg1_VD_S_VD_S);
  Dsi_VD_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VD_S+d10_exp0*arg1_VD_S_VS_BP);
  Dsi_VD_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VD_S+d10_exp0*arg1_VD_S_VGP_S);
#endif
Dsi_VS_BP=arg1_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VD_S);
  Dsi_VS_BP_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VS_BP+d10_exp0*arg1_VS_BP_VS_BP);
  Dsi_VS_BP_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VGP_S);
#endif
Dsi_VGP_S=arg1_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VD_S);
  Dsi_VGP_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VGP_S+d10_exp0*arg1_VGP_S_VS_BP);
  Dsi_VGP_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VGP_S);
#endif
#endif
Dsi=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((arg1<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=(-1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
Dsi_VS_BP=(-1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
Dsi_VGP_S=(-1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  Dsi_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
#endif
Dsi=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dsi_VD_S=(1.0e100*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VD_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VD_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VD_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
Dsi_VS_BP=(1.0e100*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VS_BP_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VS_BP_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VS_BP_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
Dsi_VGP_S=(1.0e100*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  Dsi_VGP_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VGP_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  Dsi_VGP_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
Dsi=(1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
arg1_VD_S=(-((Vgs_VD_S+Vsbstar_VD_S)-Vm_VD_S))*pInst->inv_phit1;
#if defined(_DERIVATE2)
  arg1_VD_S_VD_S=(+0.0*pInst->inv_phit1+(-((Vgs_VD_S+Vsbstar_VD_S)-Vm_VD_S))*0.0+(-((Vgs_VD_S+Vsbstar_VD_S)-Vm_VD_S))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
  arg1_VD_S_VS_BP=(+0.0*pInst->inv_phit1+(-((Vgs_VD_S+Vsbstar_VD_S)-Vm_VD_S))*0.0+(-(Vsbstar_VS_BP-Vm_VS_BP))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
  arg1_VD_S_VGP_S=(+0.0*pInst->inv_phit1+(-((Vgs_VD_S+Vsbstar_VD_S)-Vm_VD_S))*0.0+(-(Vgs_VGP_S-Vm_VGP_S))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
#endif
arg1_VS_BP=(-(Vsbstar_VS_BP-Vm_VS_BP))*pInst->inv_phit1;
#if defined(_DERIVATE2)
  arg1_VS_BP_VD_S=(+0.0*pInst->inv_phit1+(-(Vsbstar_VS_BP-Vm_VS_BP))*0.0+(-((Vgs_VD_S+Vsbstar_VD_S)-Vm_VD_S))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
  arg1_VS_BP_VS_BP=(+0.0*pInst->inv_phit1+(-(Vsbstar_VS_BP-Vm_VS_BP))*0.0+(-(Vsbstar_VS_BP-Vm_VS_BP))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
  arg1_VS_BP_VGP_S=(+0.0*pInst->inv_phit1+(-(Vsbstar_VS_BP-Vm_VS_BP))*0.0+(-(Vgs_VGP_S-Vm_VGP_S))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
#endif
arg1_VGP_S=(-(Vgs_VGP_S-Vm_VGP_S))*pInst->inv_phit1;
#if defined(_DERIVATE2)
  arg1_VGP_S_VD_S=(+0.0*pInst->inv_phit1+(-(Vgs_VGP_S-Vm_VGP_S))*0.0+(-((Vgs_VD_S+Vsbstar_VD_S)-Vm_VD_S))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
  arg1_VGP_S_VS_BP=(+0.0*pInst->inv_phit1+(-(Vgs_VGP_S-Vm_VGP_S))*0.0+(-(Vsbstar_VS_BP-Vm_VS_BP))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
  arg1_VGP_S_VGP_S=(+0.0*pInst->inv_phit1+(-(Vgs_VGP_S-Vm_VGP_S))*0.0+(-(Vgs_VGP_S-Vm_VGP_S))*0.0+(-((Vgs+Vsbstar)-Vm))*0.0);
#endif
#endif
arg1=((-((Vgs+Vsbstar)-Vm))*pInst->inv_phit1);
EXIT_IF_ISNAN(((-((Vgs+Vsbstar)-Vm))*pInst->inv_phit1))
{
double m00_fabs(d00_fabs0,arg1)
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,arg1)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=arg1_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VGP_S);
  temp_VGP_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VGP_S+d10_exp0*arg1_VGP_S_VD_S);
  temp_VGP_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VGP_S+d10_exp0*arg1_VGP_S_VS_BP);
#endif
temp_VD_S=arg1_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=0.0;
  temp_VD_S_VS_BS=0.0;
  temp_VD_S_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VD_S+d10_exp0*arg1_VD_S_VGP_S);
  temp_VD_S_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VD_S+d10_exp0*arg1_VD_S_VD_S);
  temp_VD_S_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VD_S+d10_exp0*arg1_VD_S_VS_BP);
#endif
temp_VS_BP=arg1_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=0.0;
  temp_VS_BP_VS_BS=0.0;
  temp_VS_BP_VGP_S=(m20_exp(arg1)*arg1_VGP_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VGP_S);
  temp_VS_BP_VD_S=(m20_exp(arg1)*arg1_VD_S*arg1_VS_BP+d10_exp0*arg1_VS_BP_VD_S);
  temp_VS_BP_VS_BP=(m20_exp(arg1)*arg1_VS_BP*arg1_VS_BP+d10_exp0*arg1_VS_BP_VS_BP);
#endif
#endif
temp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((arg1<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*(0.0)+0.0*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*(0.0)+0.0*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VGP_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VD_S)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VGP_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VGP_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VGP_S_VS_BP)*3.3333333333333333e-01+(-arg1_VGP_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VGP_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
temp_VD_S=(-1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*(0.0)+0.0*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*(0.0)+0.0*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VGP_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VD_S)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VD_S)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VD_S)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VD_S_VS_BP)*3.3333333333333333e-01+(-arg1_VD_S)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VD_S)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
temp_VS_BP=(-1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*(0.0)+0.0*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))+0.0*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-2.3025850929940458e+02)-arg1)*(0.0)))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*(0.0)+0.0*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+0.0*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-2.3025850929940458e+02)-arg1)*((0.5*((((-2.3025850929940458e+02)-arg1)*(0.0)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))))+(-arg1_VGP_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VGP_S)*3.3333333333333333e-01)+(-arg1_VGP_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VGP_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VGP_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VGP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))))+(-arg1_VD_S)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VD_S)*3.3333333333333333e-01)+(-arg1_VD_S)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VD_S)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VD_S)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VD_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
  temp_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))-(0.0*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))+(-arg1_VS_BP)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))))+(-arg1_VS_BP)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-arg1)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+0.0*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01))))+0.0*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-arg1_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))+(-arg1_VS_BP)*((-arg1_VS_BP)*3.3333333333333333e-01)+(-arg1_VS_BP)*(-arg1_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-arg1)*(+0.0+(+(+0.0-arg1_VS_BP_VS_BP)*3.3333333333333333e-01+(-arg1_VS_BP)*0.0+(-arg1_VS_BP)*0.0+((-2.3025850929940458e+02)-arg1)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*(0.5*(((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*(-arg1_VS_BP)*3.3333333333333333e-01)))))*((((-arg1_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-arg1)*((0.5*((((-arg1_VS_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-arg1)*((-arg1_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
#endif
#endif
temp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(1.0e100*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(0.0)+0.0*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(0.0)+0.0*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VGP_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VGP_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VGP_S*3.3333333333333333e-01))+0.5*(+(+arg1_VGP_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VGP_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VGP_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VGP_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
temp_VD_S=(1.0e100*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(0.0)+0.0*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(0.0)+0.0*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VGP_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VD_S-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VD_S_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VD_S*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VD_S*3.3333333333333333e-01))+0.5*(+(+arg1_VD_S_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VD_S*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VD_S*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VD_S_VS_BP-0.0)*3.3333333333333333e-01+arg1_VD_S*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
temp_VS_BP=(1.0e100*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(0.0)+0.0*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VS_BS=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1-2.3025850929940458e+02)*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+0.0-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1-2.3025850929940458e+02)*(0.0)))))+0.0*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1-2.3025850929940458e+02)*(0.0)))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+0.0-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(0.0)+0.0*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+0.0-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+0.0*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VGP_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VGP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))))+arg1_VGP_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VGP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VGP_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VGP_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VGP_S*3.3333333333333333e-01)+arg1_VGP_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VGP_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VD_S=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VD_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))))+arg1_VD_S*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VD_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VD_S*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VD_S-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VD_S*3.3333333333333333e-01)+arg1_VD_S*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VD_S-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VD_S*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
  temp_VS_BP_VS_BP=(+0.0*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01)))))))))+0.0*((arg1_VS_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((arg1-2.3025850929940458e+02)*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))+arg1_VS_BP*((0.5*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))))+arg1_VS_BP*(0.5*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01)))+(arg1-2.3025850929940458e+02)*(+0.0+(+0.0*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*(arg1_VS_BP*3.3333333333333333e-01))))+0.0*((arg1_VS_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+((arg1-2.3025850929940458e+02)*arg1_VS_BP*3.3333333333333333e-01))+0.5*(+(+arg1_VS_BP_VS_BP-0.0)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))+arg1_VS_BP*(arg1_VS_BP*3.3333333333333333e-01)+arg1_VS_BP*arg1_VS_BP*3.3333333333333333e-01+(arg1-2.3025850929940458e+02)*(+0.0+(+(+arg1_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+arg1_VS_BP*0.0+arg1_VS_BP*0.0+(arg1-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
temp=(1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Dgate_VD_S=((Dsi_VD_S*temp)+(Dsi*temp_VD_S));
#if defined(_DERIVATE2)
  Dgate_VD_S_VD_S=(+Dsi_VD_S_VD_S*temp+Dsi_VD_S*temp_VD_S+Dsi_VD_S*temp_VD_S+Dsi*temp_VD_S_VD_S);
  Dgate_VD_S_VS_BP=(+Dsi_VD_S_VS_BP*temp+Dsi_VD_S*temp_VS_BP+Dsi_VS_BP*temp_VD_S+Dsi*temp_VD_S_VS_BP);
  Dgate_VD_S_VGP_S=(+Dsi_VD_S_VGP_S*temp+Dsi_VD_S*temp_VGP_S+Dsi_VGP_S*temp_VD_S+Dsi*temp_VD_S_VGP_S);
#endif
Dgate_VS_BP=((Dsi_VS_BP*temp)+(Dsi*temp_VS_BP));
#if defined(_DERIVATE2)
  Dgate_VS_BP_VD_S=(+Dsi_VS_BP_VD_S*temp+Dsi_VS_BP*temp_VD_S+Dsi_VD_S*temp_VS_BP+Dsi*temp_VS_BP_VD_S);
  Dgate_VS_BP_VS_BP=(+Dsi_VS_BP_VS_BP*temp+Dsi_VS_BP*temp_VS_BP+Dsi_VS_BP*temp_VS_BP+Dsi*temp_VS_BP_VS_BP);
  Dgate_VS_BP_VGP_S=(+Dsi_VS_BP_VGP_S*temp+Dsi_VS_BP*temp_VGP_S+Dsi_VGP_S*temp_VS_BP+Dsi*temp_VS_BP_VGP_S);
#endif
Dgate_VGP_S=((Dsi_VGP_S*temp)+(Dsi*temp_VGP_S));
#if defined(_DERIVATE2)
  Dgate_VGP_S_VD_S=(+Dsi_VGP_S_VD_S*temp+Dsi_VGP_S*temp_VD_S+Dsi_VD_S*temp_VGP_S+Dsi*temp_VGP_S_VD_S);
  Dgate_VGP_S_VS_BP=(+Dsi_VGP_S_VS_BP*temp+Dsi_VGP_S*temp_VS_BP+Dsi_VS_BP*temp_VGP_S+Dsi*temp_VGP_S_VS_BP);
  Dgate_VGP_S_VGP_S=(+Dsi_VGP_S_VGP_S*temp+Dsi_VGP_S*temp_VGP_S+Dsi_VGP_S*temp_VGP_S+Dsi*temp_VGP_S_VGP_S);
#endif
#endif
Dgate=(Dsi*temp);
EXIT_IF_ISNAN((Dsi*temp))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(pInst->BCH*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S))));
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BCH*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*(0.0)+0.0*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VGP_S+pInst->GC3_i*0.0)))));
  temp_VGP_S_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BCH*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*(0.0)+0.0*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VGP_S+pInst->GC3_i*0.0)))));
  temp_VGP_S_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BCH*(+0.0+(+zg_VGP_S_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VGP_S)))));
  temp_VGP_S_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BCH*(+0.0+(+zg_VGP_S_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VD_S)))));
  temp_VGP_S_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VGP_S)))+pInst->BCH*(+0.0+(+zg_VGP_S_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VGP_S*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VGP_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VGP_S+pInst->GC3_i*zg_VGP_S_VS_BP)))));
#endif
temp_VD_S=(pInst->BCH*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S))));
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BCH*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*(0.0)+0.0*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VD_S+pInst->GC3_i*0.0)))));
  temp_VD_S_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BCH*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*(0.0)+0.0*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VD_S+pInst->GC3_i*0.0)))));
  temp_VD_S_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BCH*(+0.0+(+zg_VD_S_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VGP_S)))));
  temp_VD_S_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BCH*(+0.0+(+zg_VD_S_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VD_S)))));
  temp_VD_S_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VD_S)))+pInst->BCH*(+0.0+(+zg_VD_S_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VD_S*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VD_S)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VD_S+pInst->GC3_i*zg_VD_S_VS_BP)))));
#endif
temp_VS_BP=(pInst->BCH*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP))));
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BCH*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*(0.0)+0.0*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VS_BP+pInst->GC3_i*0.0)))));
  temp_VS_BP_VS_BS=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*((zg*(0.0)))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BCH*(+0.0+(+0.0*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*(0.0)+0.0*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*0.0+0.0*zg_VS_BP+pInst->GC3_i*0.0)))));
  temp_VS_BP_VGP_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VGP_S)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BCH*(+0.0+(+zg_VS_BP_VGP_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VGP_S))+zg_VGP_S*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VGP_S+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VGP_S)))));
  temp_VS_BP_VD_S=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VD_S)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BCH*(+0.0+(+zg_VS_BP_VD_S*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VD_S))+zg_VD_S*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VD_S+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VD_S)))));
  temp_VS_BP_VS_BP=(+0.0*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))+0.0*(((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*((pInst->GC3_i*zg_VS_BP)))))+0.0*((zg_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg)))+(zg*(pInst->GC3_i*zg_VS_BP)))+pInst->BCH*(+0.0+(+zg_VS_BP_VS_BP*(pInst->GC2_i+(pInst->GC3_i*zg))+zg_VS_BP*((pInst->GC3_i*zg_VS_BP))+zg_VS_BP*(pInst->GC3_i*zg_VS_BP)+zg*(+0.0+(+0.0*zg+0.0*zg_VS_BP+0.0*zg_VS_BP+pInst->GC3_i*zg_VS_BP_VS_BP)))));
#endif
#endif
temp=(pInst->BCH*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg)))));
EXIT_IF_ISNAN((pInst->BCH*((-1.5)+(zg*(pInst->GC2_i+(pInst->GC3_i*zg))))))
if
((temp>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=((temp_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(+0.0+(+temp_VGP_S_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VGP_S*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VGP_S_VD_S=(+0.0+(+temp_VGP_S_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VD_S*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VGP_S_VS_BP=(+0.0+(+temp_VGP_S_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VGP_S*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VGP_S*3.3333333333333333e-01))+0.5*(+temp_VGP_S_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VGP_S*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VGP_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VGP_S_VS_BP*3.3333333333333333e-01+temp_VGP_S*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
TP_VD_S=((temp_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(+0.0+(+temp_VD_S_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VGP_S*3.3333333333333333e-01+temp_VD_S*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VD_S_VD_S=(+0.0+(+temp_VD_S_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VD_S*3.3333333333333333e-01+temp_VD_S*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VD_S_VS_BP=(+0.0+(+temp_VD_S_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VD_S*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VD_S*3.3333333333333333e-01))+0.5*(+temp_VD_S_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VD_S*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VD_S*3.3333333333333333e-01+temp*(+0.0+(+temp_VD_S_VS_BP*3.3333333333333333e-01+temp_VD_S*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
TP_VS_BP=((temp_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))+(temp*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))));
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(+0.0+(+temp_VS_BP_VGP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))))+temp_VGP_S*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VGP_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VGP_S*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VGP_S*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VGP_S*3.3333333333333333e-01)+temp_VGP_S*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VGP_S*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VGP_S*0.0+temp*0.0)))))));
  TP_VS_BP_VD_S=(+0.0+(+temp_VS_BP_VD_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))))+temp_VD_S*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VD_S*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VD_S*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VD_S*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VD_S*3.3333333333333333e-01)+temp_VD_S*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VD_S*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VD_S*0.0+temp*0.0)))))));
  TP_VS_BP_VS_BP=(+0.0+(+temp_VS_BP_VS_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))+temp_VS_BP*((0.5*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))))+temp_VS_BP*(0.5*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01)))+temp*(+0.0+(+0.0*(temp*(1.0+(temp*3.3333333333333333e-01)))+0.0*(((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*(temp_VS_BP*3.3333333333333333e-01))))+0.0*((temp_VS_BP*(1.0+(temp*3.3333333333333333e-01)))+(temp*temp_VS_BP*3.3333333333333333e-01))+0.5*(+temp_VS_BP_VS_BP*(1.0+(temp*3.3333333333333333e-01))+temp_VS_BP*(temp_VS_BP*3.3333333333333333e-01)+temp_VS_BP*temp_VS_BP*3.3333333333333333e-01+temp*(+0.0+(+temp_VS_BP_VS_BP*3.3333333333333333e-01+temp_VS_BP*0.0+temp_VS_BP*0.0+temp*0.0)))))));
#endif
#endif
TP=(1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
EXIT_IF_ISNAN((1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))))))
}
else
{
if
((temp>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,temp)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=temp_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VGP_S+d10_exp0*temp_VGP_S_VGP_S);
  TP_VGP_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VGP_S+d10_exp0*temp_VGP_S_VD_S);
  TP_VGP_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VGP_S+d10_exp0*temp_VGP_S_VS_BP);
#endif
TP_VD_S=temp_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VD_S+d10_exp0*temp_VD_S_VGP_S);
  TP_VD_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VD_S+d10_exp0*temp_VD_S_VD_S);
  TP_VD_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VD_S+d10_exp0*temp_VD_S_VS_BP);
#endif
TP_VS_BP=temp_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VS_BP+d10_exp0*temp_VS_BP_VGP_S);
  TP_VS_BP_VD_S=(m20_exp(temp)*temp_VD_S*temp_VS_BP+d10_exp0*temp_VS_BP_VD_S);
  TP_VS_BP_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VS_BP+d10_exp0*temp_VS_BP_VS_BP);
#endif
#endif
TP=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
TP_VGP_S=(-1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
TP_VD_S=(-1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VD_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
TP_VS_BP=(-1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  TP_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  TP_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
#endif
TP=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))))
}
}
{
double m00_logE(d00_logE0,((1.0+Dsi)/(1.0+Dgate)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((1.0+Dsi)/(1.0+Dgate)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Igc0_VGP_S=(pInst->IGINV_i*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igc0_VGP_S_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VGP_S_VGP_S*d00_logE0+TP_VGP_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VGP_S)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VGP_S+Dsi_VGP_S*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igc0_VGP_S_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VGP_S_VD_S*d00_logE0+TP_VGP_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VD_S)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VD_S+Dsi_VD_S*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igc0_VGP_S_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VGP_S_VS_BP*d00_logE0+TP_VGP_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VGP_S_VS_BP)/(1.0+Dgate)-(Dsi_VGP_S*Dgate_VS_BP+Dsi_VS_BP*Dgate_VGP_S+(1.0+Dsi)*(+0.0+Dgate_VGP_S_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VGP_S*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
Igc0_VD_S=(pInst->IGINV_i*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igc0_VD_S_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VD_S_VGP_S*d00_logE0+TP_VD_S*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VGP_S)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VGP_S+Dsi_VGP_S*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igc0_VD_S_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VD_S_VD_S*d00_logE0+TP_VD_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VD_S)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VD_S+Dsi_VD_S*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igc0_VD_S_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VD_S_VS_BP*d00_logE0+TP_VD_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VD_S_VS_BP)/(1.0+Dgate)-(Dsi_VD_S*Dgate_VS_BP+Dsi_VS_BP*Dgate_VD_S+(1.0+Dsi)*(+0.0+Dgate_VD_S_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VD_S*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
Igc0_VS_BP=(pInst->IGINV_i*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)));
#if defined(_DERIVATE2)
  Igc0_VS_BP_VGP_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VGP_S*d00_logE0)+(TP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VS_BP_VGP_S*d00_logE0+TP_VS_BP*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VGP_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VGP_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VGP_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VGP_S)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VGP_S+Dsi_VGP_S*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VGP_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VGP_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igc0_VS_BP_VD_S=(+0.0*(TP*d00_logE0)+0.0*(((TP_VD_S*d00_logE0)+(TP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VS_BP_VD_S*d00_logE0+TP_VS_BP*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VD_S*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VD_S*(1.0+Dgate)-(1.0+Dsi)*Dgate_VD_S)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VD_S)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VD_S+Dsi_VD_S*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VD_S))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VD_S/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
  Igc0_VS_BP_VS_BP=(+0.0*(TP*d00_logE0)+0.0*(((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0)))+0.0*((TP_VS_BP*d00_logE0)+(TP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0))+pInst->IGINV_i*(+TP_VS_BP_VS_BP*d00_logE0+TP_VS_BP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP_VS_BP*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*d10_logE0+TP*(m20_logE(((1.0+Dsi)/(1.0+Dgate)))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))*((Dsi_VS_BP*(1.0+Dgate)-(1.0+Dsi)*Dgate_VS_BP)/(1.0+Dgate)/(1.0+Dgate))+d10_logE0*((+0.0+Dsi_VS_BP_VS_BP)/(1.0+Dgate)-(Dsi_VS_BP*Dgate_VS_BP+Dsi_VS_BP*Dgate_VS_BP+(1.0+Dsi)*(+0.0+Dgate_VS_BP_VS_BP))/(1.0+Dgate)/(1.0+Dgate)+2*(1.0+Dsi)*Dgate_VS_BP*Dgate_VS_BP/(1.0+Dgate)/(1.0+Dgate)/(1.0+Dgate)))));
#endif
#endif
Igc0=(pInst->IGINV_i*(TP*d00_logE0));
EXIT_IF_ISNAN((pInst->IGINV_i*(TP*d00_logE0)))
}
if
(((pInst->xg<=0)||((pInst->GC2_i==0)&&(pInst->GC3_i==0))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
igc_VD_S=0.0;
#if defined(_DERIVATE2)
  igc_VD_S_VD_S=0.0;
  igc_VD_S_VGP_S=0.0;
  igc_VD_S_VS_BP=0.0;
#endif
igc_VGP_S=0.0;
#if defined(_DERIVATE2)
  igc_VGP_S_VD_S=0.0;
  igc_VGP_S_VGP_S=0.0;
  igc_VGP_S_VS_BP=0.0;
#endif
igc_VS_BP=0.0;
#if defined(_DERIVATE2)
  igc_VS_BP_VD_S=0.0;
  igc_VS_BP_VGP_S=0.0;
  igc_VS_BP_VS_BP=0.0;
#endif
#endif
igc=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
igcd_h_VD_S=0.0;
#if defined(_DERIVATE2)
  igcd_h_VD_S_VD_S=0.0;
  igcd_h_VD_S_VGP_S=0.0;
  igcd_h_VD_S_VS_BP=0.0;
#endif
igcd_h_VGP_S=0.0;
#if defined(_DERIVATE2)
  igcd_h_VGP_S_VD_S=0.0;
  igcd_h_VGP_S_VGP_S=0.0;
  igcd_h_VGP_S_VS_BP=0.0;
#endif
igcd_h_VS_BP=0.0;
#if defined(_DERIVATE2)
  igcd_h_VS_BP_VD_S=0.0;
  igcd_h_VS_BP_VGP_S=0.0;
  igcd_h_VS_BP_VS_BP=0.0;
#endif
#endif
igcd_h=0.5;
EXIT_IF_ISNAN(0.5)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=((2.0*pInst->GC3_i)*zg_VGP_S);
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*0.0+(0.0)*zg_VGP_S+(2.0*pInst->GC3_i)*0.0));
  temp_VGP_S_VS_BS=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*0.0+(0.0)*zg_VGP_S+(2.0*pInst->GC3_i)*0.0));
  temp_VGP_S_VGP_S=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VGP_S+(0.0)*zg_VGP_S+(2.0*pInst->GC3_i)*zg_VGP_S_VGP_S));
  temp_VGP_S_VD_S=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VD_S+(0.0)*zg_VGP_S+(2.0*pInst->GC3_i)*zg_VGP_S_VD_S));
  temp_VGP_S_VS_BP=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VS_BP+(0.0)*zg_VGP_S+(2.0*pInst->GC3_i)*zg_VGP_S_VS_BP));
#endif
temp_VD_S=((2.0*pInst->GC3_i)*zg_VD_S);
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*0.0+(0.0)*zg_VD_S+(2.0*pInst->GC3_i)*0.0));
  temp_VD_S_VS_BS=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*0.0+(0.0)*zg_VD_S+(2.0*pInst->GC3_i)*0.0));
  temp_VD_S_VGP_S=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VGP_S+(0.0)*zg_VD_S+(2.0*pInst->GC3_i)*zg_VD_S_VGP_S));
  temp_VD_S_VD_S=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VD_S+(0.0)*zg_VD_S+(2.0*pInst->GC3_i)*zg_VD_S_VD_S));
  temp_VD_S_VS_BP=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VS_BP+(0.0)*zg_VD_S+(2.0*pInst->GC3_i)*zg_VD_S_VS_BP));
#endif
temp_VS_BP=((2.0*pInst->GC3_i)*zg_VS_BP);
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*0.0+(0.0)*zg_VS_BP+(2.0*pInst->GC3_i)*0.0));
  temp_VS_BP_VS_BS=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*0.0+(0.0)*zg_VS_BP+(2.0*pInst->GC3_i)*0.0));
  temp_VS_BP_VGP_S=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VGP_S+(0.0)*zg_VS_BP+(2.0*pInst->GC3_i)*zg_VS_BP_VGP_S));
  temp_VS_BP_VD_S=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VD_S+(0.0)*zg_VS_BP+(2.0*pInst->GC3_i)*zg_VS_BP_VD_S));
  temp_VS_BP_VS_BP=(+0.0+(+(+0.0*pInst->GC3_i+0.0*0.0+0.0*0.0+2.0*0.0)*zg+0.0*zg_VS_BP+(0.0)*zg_VS_BP+(2.0*pInst->GC3_i)*zg_VS_BP_VS_BP));
#endif
#endif
temp=(pInst->GC2_i+((2.0*pInst->GC3_i)*zg));
EXIT_IF_ISNAN((pInst->GC2_i+((2.0*pInst->GC3_i)*zg)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
u0_VGP_S=(-pInst->CHIB_i*temp_VGP_S*pInst->BCH/(temp*pInst->BCH)/(temp*pInst->BCH));
#if defined(_DERIVATE2)
  u0_VGP_S_VGP_S=(0.0/(temp*pInst->BCH)-(0.0*(temp_VGP_S*pInst->BCH)+0.0*temp_VGP_S*pInst->BCH+pInst->CHIB_i*(+temp_VGP_S_VGP_S*pInst->BCH+temp_VGP_S*0.0+temp_VGP_S*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VGP_S*pInst->BCH*(temp_VGP_S*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
  u0_VGP_S_VD_S=(0.0/(temp*pInst->BCH)-(0.0*(temp_VD_S*pInst->BCH)+0.0*temp_VGP_S*pInst->BCH+pInst->CHIB_i*(+temp_VGP_S_VD_S*pInst->BCH+temp_VGP_S*0.0+temp_VD_S*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VGP_S*pInst->BCH*(temp_VD_S*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
  u0_VGP_S_VS_BP=(0.0/(temp*pInst->BCH)-(0.0*(temp_VS_BP*pInst->BCH)+0.0*temp_VGP_S*pInst->BCH+pInst->CHIB_i*(+temp_VGP_S_VS_BP*pInst->BCH+temp_VGP_S*0.0+temp_VS_BP*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VGP_S*pInst->BCH*(temp_VS_BP*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
#endif
u0_VD_S=(-pInst->CHIB_i*temp_VD_S*pInst->BCH/(temp*pInst->BCH)/(temp*pInst->BCH));
#if defined(_DERIVATE2)
  u0_VD_S_VGP_S=(0.0/(temp*pInst->BCH)-(0.0*(temp_VGP_S*pInst->BCH)+0.0*temp_VD_S*pInst->BCH+pInst->CHIB_i*(+temp_VD_S_VGP_S*pInst->BCH+temp_VD_S*0.0+temp_VGP_S*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VD_S*pInst->BCH*(temp_VGP_S*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
  u0_VD_S_VD_S=(0.0/(temp*pInst->BCH)-(0.0*(temp_VD_S*pInst->BCH)+0.0*temp_VD_S*pInst->BCH+pInst->CHIB_i*(+temp_VD_S_VD_S*pInst->BCH+temp_VD_S*0.0+temp_VD_S*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VD_S*pInst->BCH*(temp_VD_S*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
  u0_VD_S_VS_BP=(0.0/(temp*pInst->BCH)-(0.0*(temp_VS_BP*pInst->BCH)+0.0*temp_VD_S*pInst->BCH+pInst->CHIB_i*(+temp_VD_S_VS_BP*pInst->BCH+temp_VD_S*0.0+temp_VS_BP*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VD_S*pInst->BCH*(temp_VS_BP*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
#endif
u0_VS_BP=(-pInst->CHIB_i*temp_VS_BP*pInst->BCH/(temp*pInst->BCH)/(temp*pInst->BCH));
#if defined(_DERIVATE2)
  u0_VS_BP_VGP_S=(0.0/(temp*pInst->BCH)-(0.0*(temp_VGP_S*pInst->BCH)+0.0*temp_VS_BP*pInst->BCH+pInst->CHIB_i*(+temp_VS_BP_VGP_S*pInst->BCH+temp_VS_BP*0.0+temp_VGP_S*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VS_BP*pInst->BCH*(temp_VGP_S*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
  u0_VS_BP_VD_S=(0.0/(temp*pInst->BCH)-(0.0*(temp_VD_S*pInst->BCH)+0.0*temp_VS_BP*pInst->BCH+pInst->CHIB_i*(+temp_VS_BP_VD_S*pInst->BCH+temp_VS_BP*0.0+temp_VD_S*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VS_BP*pInst->BCH*(temp_VD_S*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
  u0_VS_BP_VS_BP=(0.0/(temp*pInst->BCH)-(0.0*(temp_VS_BP*pInst->BCH)+0.0*temp_VS_BP*pInst->BCH+pInst->CHIB_i*(+temp_VS_BP_VS_BP*pInst->BCH+temp_VS_BP*0.0+temp_VS_BP*0.0+temp*0.0))/(temp*pInst->BCH)/(temp*pInst->BCH)+2*pInst->CHIB_i*temp_VS_BP*pInst->BCH*(temp_VS_BP*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH)/(temp*pInst->BCH));
#endif
#endif
u0=(pInst->CHIB_i/(temp*pInst->BCH));
EXIT_IF_ISNAN((pInst->CHIB_i/(temp*pInst->BCH)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
x_VD_S=(0.5*((dps_VD_S*u0-pInst->dps*u0_VD_S)/u0/u0));
#if defined(_DERIVATE2)
  x_VD_S_VD_S=(+0.0*(pInst->dps/u0)+0.0*((dps_VD_S*u0-pInst->dps*u0_VD_S)/u0/u0)+0.0*((dps_VD_S*u0-pInst->dps*u0_VD_S)/u0/u0)+0.5*(dps_VD_S_VD_S/u0-(dps_VD_S*u0_VD_S+dps_VD_S*u0_VD_S+pInst->dps*u0_VD_S_VD_S)/u0/u0+2*pInst->dps*u0_VD_S*u0_VD_S/u0/u0/u0));
  x_VD_S_VGP_S=(+0.0*(pInst->dps/u0)+0.0*((dps_VGP_S*u0-pInst->dps*u0_VGP_S)/u0/u0)+0.0*((dps_VD_S*u0-pInst->dps*u0_VD_S)/u0/u0)+0.5*(dps_VD_S_VGP_S/u0-(dps_VD_S*u0_VGP_S+dps_VGP_S*u0_VD_S+pInst->dps*u0_VD_S_VGP_S)/u0/u0+2*pInst->dps*u0_VD_S*u0_VGP_S/u0/u0/u0));
  x_VD_S_VS_BP=(+0.0*(pInst->dps/u0)+0.0*((dps_VS_BP*u0-pInst->dps*u0_VS_BP)/u0/u0)+0.0*((dps_VD_S*u0-pInst->dps*u0_VD_S)/u0/u0)+0.5*(dps_VD_S_VS_BP/u0-(dps_VD_S*u0_VS_BP+dps_VS_BP*u0_VD_S+pInst->dps*u0_VD_S_VS_BP)/u0/u0+2*pInst->dps*u0_VD_S*u0_VS_BP/u0/u0/u0));
#endif
x_VGP_S=(0.5*((dps_VGP_S*u0-pInst->dps*u0_VGP_S)/u0/u0));
#if defined(_DERIVATE2)
  x_VGP_S_VD_S=(+0.0*(pInst->dps/u0)+0.0*((dps_VD_S*u0-pInst->dps*u0_VD_S)/u0/u0)+0.0*((dps_VGP_S*u0-pInst->dps*u0_VGP_S)/u0/u0)+0.5*(dps_VGP_S_VD_S/u0-(dps_VGP_S*u0_VD_S+dps_VD_S*u0_VGP_S+pInst->dps*u0_VGP_S_VD_S)/u0/u0+2*pInst->dps*u0_VGP_S*u0_VD_S/u0/u0/u0));
  x_VGP_S_VGP_S=(+0.0*(pInst->dps/u0)+0.0*((dps_VGP_S*u0-pInst->dps*u0_VGP_S)/u0/u0)+0.0*((dps_VGP_S*u0-pInst->dps*u0_VGP_S)/u0/u0)+0.5*(dps_VGP_S_VGP_S/u0-(dps_VGP_S*u0_VGP_S+dps_VGP_S*u0_VGP_S+pInst->dps*u0_VGP_S_VGP_S)/u0/u0+2*pInst->dps*u0_VGP_S*u0_VGP_S/u0/u0/u0));
  x_VGP_S_VS_BP=(+0.0*(pInst->dps/u0)+0.0*((dps_VS_BP*u0-pInst->dps*u0_VS_BP)/u0/u0)+0.0*((dps_VGP_S*u0-pInst->dps*u0_VGP_S)/u0/u0)+0.5*(dps_VGP_S_VS_BP/u0-(dps_VGP_S*u0_VS_BP+dps_VS_BP*u0_VGP_S+pInst->dps*u0_VGP_S_VS_BP)/u0/u0+2*pInst->dps*u0_VGP_S*u0_VS_BP/u0/u0/u0));
#endif
x_VS_BP=(0.5*((dps_VS_BP*u0-pInst->dps*u0_VS_BP)/u0/u0));
#if defined(_DERIVATE2)
  x_VS_BP_VD_S=(+0.0*(pInst->dps/u0)+0.0*((dps_VD_S*u0-pInst->dps*u0_VD_S)/u0/u0)+0.0*((dps_VS_BP*u0-pInst->dps*u0_VS_BP)/u0/u0)+0.5*(dps_VS_BP_VD_S/u0-(dps_VS_BP*u0_VD_S+dps_VD_S*u0_VS_BP+pInst->dps*u0_VS_BP_VD_S)/u0/u0+2*pInst->dps*u0_VS_BP*u0_VD_S/u0/u0/u0));
  x_VS_BP_VGP_S=(+0.0*(pInst->dps/u0)+0.0*((dps_VGP_S*u0-pInst->dps*u0_VGP_S)/u0/u0)+0.0*((dps_VS_BP*u0-pInst->dps*u0_VS_BP)/u0/u0)+0.5*(dps_VS_BP_VGP_S/u0-(dps_VS_BP*u0_VGP_S+dps_VGP_S*u0_VS_BP+pInst->dps*u0_VS_BP_VGP_S)/u0/u0+2*pInst->dps*u0_VS_BP*u0_VGP_S/u0/u0/u0));
  x_VS_BP_VS_BP=(+0.0*(pInst->dps/u0)+0.0*((dps_VS_BP*u0-pInst->dps*u0_VS_BP)/u0/u0)+0.0*((dps_VS_BP*u0-pInst->dps*u0_VS_BP)/u0/u0)+0.5*(dps_VS_BP_VS_BP/u0-(dps_VS_BP*u0_VS_BP+dps_VS_BP*u0_VS_BP+pInst->dps*u0_VS_BP_VS_BP)/u0/u0+2*pInst->dps*u0_VS_BP*u0_VS_BP/u0/u0/u0));
#endif
#endif
x=(0.5*(pInst->dps/u0));
EXIT_IF_ISNAN((0.5*(pInst->dps/u0)))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
u0_div_H_VGP_S=((u0_VGP_S*pInst->H-u0*H_VGP_S)/pInst->H/pInst->H);
#if defined(_DERIVATE2)
  u0_div_H_VGP_S_VGP_S=(u0_VGP_S_VGP_S/pInst->H-(u0_VGP_S*H_VGP_S+u0_VGP_S*H_VGP_S+u0*H_VGP_S_VGP_S)/pInst->H/pInst->H+2*u0*H_VGP_S*H_VGP_S/pInst->H/pInst->H/pInst->H);
  u0_div_H_VGP_S_VD_S=(u0_VGP_S_VD_S/pInst->H-(u0_VGP_S*H_VD_S+u0_VD_S*H_VGP_S+u0*H_VGP_S_VD_S)/pInst->H/pInst->H+2*u0*H_VGP_S*H_VD_S/pInst->H/pInst->H/pInst->H);
  u0_div_H_VGP_S_VS_BP=(u0_VGP_S_VS_BP/pInst->H-(u0_VGP_S*H_VS_BP+u0_VS_BP*H_VGP_S+u0*H_VGP_S_VS_BP)/pInst->H/pInst->H+2*u0*H_VGP_S*H_VS_BP/pInst->H/pInst->H/pInst->H);
#endif
u0_div_H_VD_S=((u0_VD_S*pInst->H-u0*H_VD_S)/pInst->H/pInst->H);
#if defined(_DERIVATE2)
  u0_div_H_VD_S_VGP_S=(u0_VD_S_VGP_S/pInst->H-(u0_VD_S*H_VGP_S+u0_VGP_S*H_VD_S+u0*H_VD_S_VGP_S)/pInst->H/pInst->H+2*u0*H_VD_S*H_VGP_S/pInst->H/pInst->H/pInst->H);
  u0_div_H_VD_S_VD_S=(u0_VD_S_VD_S/pInst->H-(u0_VD_S*H_VD_S+u0_VD_S*H_VD_S+u0*H_VD_S_VD_S)/pInst->H/pInst->H+2*u0*H_VD_S*H_VD_S/pInst->H/pInst->H/pInst->H);
  u0_div_H_VD_S_VS_BP=(u0_VD_S_VS_BP/pInst->H-(u0_VD_S*H_VS_BP+u0_VS_BP*H_VD_S+u0*H_VD_S_VS_BP)/pInst->H/pInst->H+2*u0*H_VD_S*H_VS_BP/pInst->H/pInst->H/pInst->H);
#endif
u0_div_H_VS_BP=((u0_VS_BP*pInst->H-u0*H_VS_BP)/pInst->H/pInst->H);
#if defined(_DERIVATE2)
  u0_div_H_VS_BP_VGP_S=(u0_VS_BP_VGP_S/pInst->H-(u0_VS_BP*H_VGP_S+u0_VGP_S*H_VS_BP+u0*H_VS_BP_VGP_S)/pInst->H/pInst->H+2*u0*H_VS_BP*H_VGP_S/pInst->H/pInst->H/pInst->H);
  u0_div_H_VS_BP_VD_S=(u0_VS_BP_VD_S/pInst->H-(u0_VS_BP*H_VD_S+u0_VD_S*H_VS_BP+u0*H_VS_BP_VD_S)/pInst->H/pInst->H+2*u0*H_VS_BP*H_VD_S/pInst->H/pInst->H/pInst->H);
  u0_div_H_VS_BP_VS_BP=(u0_VS_BP_VS_BP/pInst->H-(u0_VS_BP*H_VS_BP+u0_VS_BP*H_VS_BP+u0*H_VS_BP_VS_BP)/pInst->H/pInst->H+2*u0*H_VS_BP*H_VS_BP/pInst->H/pInst->H/pInst->H);
#endif
#endif
u0_div_H=(u0/pInst->H);
EXIT_IF_ISNAN((u0/pInst->H))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Bg_VGP_S=((u0_div_H_VGP_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VGP_S)))*0.5;
#if defined(_DERIVATE2)
  Bg_VGP_S_VGP_S=(+(+u0_div_H_VGP_S_VGP_S*(1.0-u0_div_H)+u0_div_H_VGP_S*(-u0_div_H_VGP_S)+u0_div_H_VGP_S*(-u0_div_H_VGP_S)+u0_div_H*(+0.0-u0_div_H_VGP_S_VGP_S))*0.5+((u0_div_H_VGP_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VGP_S)))*0.0+(((u0_div_H_VGP_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VGP_S))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
  Bg_VGP_S_VD_S=(+(+u0_div_H_VGP_S_VD_S*(1.0-u0_div_H)+u0_div_H_VGP_S*(-u0_div_H_VD_S)+u0_div_H_VD_S*(-u0_div_H_VGP_S)+u0_div_H*(+0.0-u0_div_H_VGP_S_VD_S))*0.5+((u0_div_H_VGP_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VGP_S)))*0.0+(((u0_div_H_VD_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VD_S))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
  Bg_VGP_S_VS_BP=(+(+u0_div_H_VGP_S_VS_BP*(1.0-u0_div_H)+u0_div_H_VGP_S*(-u0_div_H_VS_BP)+u0_div_H_VS_BP*(-u0_div_H_VGP_S)+u0_div_H*(+0.0-u0_div_H_VGP_S_VS_BP))*0.5+((u0_div_H_VGP_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VGP_S)))*0.0+(((u0_div_H_VS_BP*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VS_BP))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
#endif
Bg_VD_S=((u0_div_H_VD_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VD_S)))*0.5;
#if defined(_DERIVATE2)
  Bg_VD_S_VGP_S=(+(+u0_div_H_VD_S_VGP_S*(1.0-u0_div_H)+u0_div_H_VD_S*(-u0_div_H_VGP_S)+u0_div_H_VGP_S*(-u0_div_H_VD_S)+u0_div_H*(+0.0-u0_div_H_VD_S_VGP_S))*0.5+((u0_div_H_VD_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VD_S)))*0.0+(((u0_div_H_VGP_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VGP_S))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
  Bg_VD_S_VD_S=(+(+u0_div_H_VD_S_VD_S*(1.0-u0_div_H)+u0_div_H_VD_S*(-u0_div_H_VD_S)+u0_div_H_VD_S*(-u0_div_H_VD_S)+u0_div_H*(+0.0-u0_div_H_VD_S_VD_S))*0.5+((u0_div_H_VD_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VD_S)))*0.0+(((u0_div_H_VD_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VD_S))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
  Bg_VD_S_VS_BP=(+(+u0_div_H_VD_S_VS_BP*(1.0-u0_div_H)+u0_div_H_VD_S*(-u0_div_H_VS_BP)+u0_div_H_VS_BP*(-u0_div_H_VD_S)+u0_div_H*(+0.0-u0_div_H_VD_S_VS_BP))*0.5+((u0_div_H_VD_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VD_S)))*0.0+(((u0_div_H_VS_BP*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VS_BP))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
#endif
Bg_VS_BP=((u0_div_H_VS_BP*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VS_BP)))*0.5;
#if defined(_DERIVATE2)
  Bg_VS_BP_VGP_S=(+(+u0_div_H_VS_BP_VGP_S*(1.0-u0_div_H)+u0_div_H_VS_BP*(-u0_div_H_VGP_S)+u0_div_H_VGP_S*(-u0_div_H_VS_BP)+u0_div_H*(+0.0-u0_div_H_VS_BP_VGP_S))*0.5+((u0_div_H_VS_BP*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VS_BP)))*0.0+(((u0_div_H_VGP_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VGP_S))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
  Bg_VS_BP_VD_S=(+(+u0_div_H_VS_BP_VD_S*(1.0-u0_div_H)+u0_div_H_VS_BP*(-u0_div_H_VD_S)+u0_div_H_VD_S*(-u0_div_H_VS_BP)+u0_div_H*(+0.0-u0_div_H_VS_BP_VD_S))*0.5+((u0_div_H_VS_BP*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VS_BP)))*0.0+(((u0_div_H_VD_S*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VD_S))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
  Bg_VS_BP_VS_BP=(+(+u0_div_H_VS_BP_VS_BP*(1.0-u0_div_H)+u0_div_H_VS_BP*(-u0_div_H_VS_BP)+u0_div_H_VS_BP*(-u0_div_H_VS_BP)+u0_div_H*(+0.0-u0_div_H_VS_BP_VS_BP))*0.5+((u0_div_H_VS_BP*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VS_BP)))*0.0+(((u0_div_H_VS_BP*(1.0-u0_div_H))+(u0_div_H*(-u0_div_H_VS_BP))))*0.0+(u0_div_H*(1.0-u0_div_H))*0.0);
#endif
#endif
Bg=((u0_div_H*(1.0-u0_div_H))*0.5);
EXIT_IF_ISNAN(((u0_div_H*(1.0-u0_div_H))*0.5))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Ag_VGP_S=(-(3.0*Bg_VGP_S));
#if defined(_DERIVATE2)
  Ag_VGP_S_VGP_S=(+0.0-(+0.0*Bg+0.0*Bg_VGP_S+0.0*Bg_VGP_S+3.0*Bg_VGP_S_VGP_S));
  Ag_VGP_S_VD_S=(+0.0-(+0.0*Bg+0.0*Bg_VD_S+0.0*Bg_VGP_S+3.0*Bg_VGP_S_VD_S));
  Ag_VGP_S_VS_BP=(+0.0-(+0.0*Bg+0.0*Bg_VS_BP+0.0*Bg_VGP_S+3.0*Bg_VGP_S_VS_BP));
#endif
Ag_VD_S=(-(3.0*Bg_VD_S));
#if defined(_DERIVATE2)
  Ag_VD_S_VGP_S=(+0.0-(+0.0*Bg+0.0*Bg_VGP_S+0.0*Bg_VD_S+3.0*Bg_VD_S_VGP_S));
  Ag_VD_S_VD_S=(+0.0-(+0.0*Bg+0.0*Bg_VD_S+0.0*Bg_VD_S+3.0*Bg_VD_S_VD_S));
  Ag_VD_S_VS_BP=(+0.0-(+0.0*Bg+0.0*Bg_VS_BP+0.0*Bg_VD_S+3.0*Bg_VD_S_VS_BP));
#endif
Ag_VS_BP=(-(3.0*Bg_VS_BP));
#if defined(_DERIVATE2)
  Ag_VS_BP_VGP_S=(+0.0-(+0.0*Bg+0.0*Bg_VGP_S+0.0*Bg_VS_BP+3.0*Bg_VS_BP_VGP_S));
  Ag_VS_BP_VD_S=(+0.0-(+0.0*Bg+0.0*Bg_VD_S+0.0*Bg_VS_BP+3.0*Bg_VS_BP_VD_S));
  Ag_VS_BP_VS_BP=(+0.0-(+0.0*Bg+0.0*Bg_VS_BP+0.0*Bg_VS_BP+3.0*Bg_VS_BP_VS_BP));
#endif
#endif
Ag=(0.5-(3.0*Bg));
EXIT_IF_ISNAN((0.5-(3.0*Bg)))
if
((x<1.0e-3))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
xsq_VD_S=((x_VD_S*x)+(x*x_VD_S));
#if defined(_DERIVATE2)
  xsq_VD_S_VD_S=(+x_VD_S_VD_S*x+x_VD_S*x_VD_S+x_VD_S*x_VD_S+x*x_VD_S_VD_S);
  xsq_VD_S_VGP_S=(+x_VD_S_VGP_S*x+x_VD_S*x_VGP_S+x_VGP_S*x_VD_S+x*x_VD_S_VGP_S);
  xsq_VD_S_VS_BP=(+x_VD_S_VS_BP*x+x_VD_S*x_VS_BP+x_VS_BP*x_VD_S+x*x_VD_S_VS_BP);
#endif
xsq_VGP_S=((x_VGP_S*x)+(x*x_VGP_S));
#if defined(_DERIVATE2)
  xsq_VGP_S_VD_S=(+x_VGP_S_VD_S*x+x_VGP_S*x_VD_S+x_VD_S*x_VGP_S+x*x_VGP_S_VD_S);
  xsq_VGP_S_VGP_S=(+x_VGP_S_VGP_S*x+x_VGP_S*x_VGP_S+x_VGP_S*x_VGP_S+x*x_VGP_S_VGP_S);
  xsq_VGP_S_VS_BP=(+x_VGP_S_VS_BP*x+x_VGP_S*x_VS_BP+x_VS_BP*x_VGP_S+x*x_VGP_S_VS_BP);
#endif
xsq_VS_BP=((x_VS_BP*x)+(x*x_VS_BP));
#if defined(_DERIVATE2)
  xsq_VS_BP_VD_S=(+x_VS_BP_VD_S*x+x_VS_BP*x_VD_S+x_VD_S*x_VS_BP+x*x_VS_BP_VD_S);
  xsq_VS_BP_VGP_S=(+x_VS_BP_VGP_S*x+x_VS_BP*x_VGP_S+x_VGP_S*x_VS_BP+x*x_VS_BP_VGP_S);
  xsq_VS_BP_VS_BP=(+x_VS_BP_VS_BP*x+x_VS_BP*x_VS_BP+x_VS_BP*x_VS_BP+x*x_VS_BP_VS_BP);
#endif
#endif
xsq=(x*x);
EXIT_IF_ISNAN((x*x))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
igc_VD_S=((xsq_VD_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))))+(xsq*(u0_div_H_VD_S*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VD_S)))))));
#if defined(_DERIVATE2)
  igc_VD_S_VD_S=(+0.0+(+xsq_VD_S_VD_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VD_S*((u0_div_H_VD_S*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VD_S))))))))+xsq_VD_S*(u0_div_H_VD_S*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VD_S)))))+xsq*(+(+0.0+(+u0_div_H_VD_S_VD_S*3.3333333333333333e-01+u0_div_H_VD_S*0.0+u0_div_H_VD_S*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VD_S)))))+0.0*((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VD_S)))+1.6666666666666667e-01*(+xsq_VD_S_VD_S*(0.05+(0.2*u0_div_H))+xsq_VD_S*((0.2*u0_div_H_VD_S))+xsq_VD_S*(0.2*u0_div_H_VD_S)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VD_S+0.0*u0_div_H_VD_S+0.2*u0_div_H_VD_S_VD_S)))))));
  igc_VD_S_VGP_S=(+0.0+(+xsq_VD_S_VGP_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VD_S*((u0_div_H_VGP_S*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VGP_S))))))))+xsq_VGP_S*(u0_div_H_VD_S*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VD_S)))))+xsq*(+(+0.0+(+u0_div_H_VD_S_VGP_S*3.3333333333333333e-01+u0_div_H_VD_S*0.0+u0_div_H_VGP_S*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VGP_S)))))+0.0*((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VD_S)))+1.6666666666666667e-01*(+xsq_VD_S_VGP_S*(0.05+(0.2*u0_div_H))+xsq_VD_S*((0.2*u0_div_H_VGP_S))+xsq_VGP_S*(0.2*u0_div_H_VD_S)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VGP_S+0.0*u0_div_H_VD_S+0.2*u0_div_H_VD_S_VGP_S)))))));
  igc_VD_S_VS_BP=(+0.0+(+xsq_VD_S_VS_BP*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VD_S*((u0_div_H_VS_BP*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VS_BP))))))))+xsq_VS_BP*(u0_div_H_VD_S*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VD_S)))))+xsq*(+(+0.0+(+u0_div_H_VD_S_VS_BP*3.3333333333333333e-01+u0_div_H_VD_S*0.0+u0_div_H_VS_BP*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VS_BP)))))+0.0*((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VD_S)))+1.6666666666666667e-01*(+xsq_VD_S_VS_BP*(0.05+(0.2*u0_div_H))+xsq_VD_S*((0.2*u0_div_H_VS_BP))+xsq_VS_BP*(0.2*u0_div_H_VD_S)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VS_BP+0.0*u0_div_H_VD_S+0.2*u0_div_H_VD_S_VS_BP)))))));
#endif
igc_VGP_S=((xsq_VGP_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))))+(xsq*(u0_div_H_VGP_S*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VGP_S)))))));
#if defined(_DERIVATE2)
  igc_VGP_S_VD_S=(+0.0+(+xsq_VGP_S_VD_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VGP_S*((u0_div_H_VD_S*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VD_S))))))))+xsq_VD_S*(u0_div_H_VGP_S*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VGP_S)))))+xsq*(+(+0.0+(+u0_div_H_VGP_S_VD_S*3.3333333333333333e-01+u0_div_H_VGP_S*0.0+u0_div_H_VD_S*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VD_S)))))+0.0*((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VGP_S)))+1.6666666666666667e-01*(+xsq_VGP_S_VD_S*(0.05+(0.2*u0_div_H))+xsq_VGP_S*((0.2*u0_div_H_VD_S))+xsq_VD_S*(0.2*u0_div_H_VGP_S)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VD_S+0.0*u0_div_H_VGP_S+0.2*u0_div_H_VGP_S_VD_S)))))));
  igc_VGP_S_VGP_S=(+0.0+(+xsq_VGP_S_VGP_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VGP_S*((u0_div_H_VGP_S*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VGP_S))))))))+xsq_VGP_S*(u0_div_H_VGP_S*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VGP_S)))))+xsq*(+(+0.0+(+u0_div_H_VGP_S_VGP_S*3.3333333333333333e-01+u0_div_H_VGP_S*0.0+u0_div_H_VGP_S*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VGP_S)))))+0.0*((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VGP_S)))+1.6666666666666667e-01*(+xsq_VGP_S_VGP_S*(0.05+(0.2*u0_div_H))+xsq_VGP_S*((0.2*u0_div_H_VGP_S))+xsq_VGP_S*(0.2*u0_div_H_VGP_S)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VGP_S+0.0*u0_div_H_VGP_S+0.2*u0_div_H_VGP_S_VGP_S)))))));
  igc_VGP_S_VS_BP=(+0.0+(+xsq_VGP_S_VS_BP*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VGP_S*((u0_div_H_VS_BP*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VS_BP))))))))+xsq_VS_BP*(u0_div_H_VGP_S*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VGP_S)))))+xsq*(+(+0.0+(+u0_div_H_VGP_S_VS_BP*3.3333333333333333e-01+u0_div_H_VGP_S*0.0+u0_div_H_VS_BP*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VS_BP)))))+0.0*((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VGP_S)))+1.6666666666666667e-01*(+xsq_VGP_S_VS_BP*(0.05+(0.2*u0_div_H))+xsq_VGP_S*((0.2*u0_div_H_VS_BP))+xsq_VS_BP*(0.2*u0_div_H_VGP_S)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VS_BP+0.0*u0_div_H_VGP_S+0.2*u0_div_H_VGP_S_VS_BP)))))));
#endif
igc_VS_BP=((xsq_VS_BP*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))))+(xsq*(u0_div_H_VS_BP*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VS_BP)))))));
#if defined(_DERIVATE2)
  igc_VS_BP_VD_S=(+0.0+(+xsq_VS_BP_VD_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VS_BP*((u0_div_H_VD_S*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VD_S))))))))+xsq_VD_S*(u0_div_H_VS_BP*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VS_BP)))))+xsq*(+(+0.0+(+u0_div_H_VS_BP_VD_S*3.3333333333333333e-01+u0_div_H_VS_BP*0.0+u0_div_H_VD_S*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VD_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VD_S)))))+0.0*((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VS_BP)))+1.6666666666666667e-01*(+xsq_VS_BP_VD_S*(0.05+(0.2*u0_div_H))+xsq_VS_BP*((0.2*u0_div_H_VD_S))+xsq_VD_S*(0.2*u0_div_H_VS_BP)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VD_S+0.0*u0_div_H_VS_BP+0.2*u0_div_H_VS_BP_VD_S)))))));
  igc_VS_BP_VGP_S=(+0.0+(+xsq_VS_BP_VGP_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VS_BP*((u0_div_H_VGP_S*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VGP_S))))))))+xsq_VGP_S*(u0_div_H_VS_BP*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VS_BP)))))+xsq*(+(+0.0+(+u0_div_H_VS_BP_VGP_S*3.3333333333333333e-01+u0_div_H_VS_BP*0.0+u0_div_H_VGP_S*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VGP_S*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VGP_S)))))+0.0*((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VS_BP)))+1.6666666666666667e-01*(+xsq_VS_BP_VGP_S*(0.05+(0.2*u0_div_H))+xsq_VS_BP*((0.2*u0_div_H_VGP_S))+xsq_VGP_S*(0.2*u0_div_H_VS_BP)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VGP_S+0.0*u0_div_H_VS_BP+0.2*u0_div_H_VS_BP_VGP_S)))))));
  igc_VS_BP_VS_BP=(+0.0+(+xsq_VS_BP_VS_BP*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))+xsq_VS_BP*((u0_div_H_VS_BP*3.3333333333333333e-01)+((1.6666666666666667e-01*(((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VS_BP))))))))+xsq_VS_BP*(u0_div_H_VS_BP*3.3333333333333333e-01+(1.6666666666666667e-01*((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VS_BP)))))+xsq*(+(+0.0+(+u0_div_H_VS_BP_VS_BP*3.3333333333333333e-01+u0_div_H_VS_BP*0.0+u0_div_H_VS_BP*0.0+u0_div_H*0.0))+(+0.0*(xsq*(0.05+(0.2*u0_div_H)))+0.0*(((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*((0.2*u0_div_H_VS_BP)))))+0.0*((xsq_VS_BP*(0.05+(0.2*u0_div_H)))+(xsq*(0.2*u0_div_H_VS_BP)))+1.6666666666666667e-01*(+xsq_VS_BP_VS_BP*(0.05+(0.2*u0_div_H))+xsq_VS_BP*((0.2*u0_div_H_VS_BP))+xsq_VS_BP*(0.2*u0_div_H_VS_BP)+xsq*(+0.0+(+0.0*u0_div_H+0.0*u0_div_H_VS_BP+0.0*u0_div_H_VS_BP+0.2*u0_div_H_VS_BP_VS_BP)))))));
#endif
#endif
igc=(1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
EXIT_IF_ISNAN((1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
igcd_h_VD_S=((0.5*igc_VD_S)-(1.6666666666666667e-01*((x_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))))));
#if defined(_DERIVATE2)
  igcd_h_VD_S_VD_S=(+(+0.0*igc+0.0*igc_VD_S+0.0*igc_VD_S+0.5*igc_VD_S_VD_S)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))))))))+0.0*((x_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))))+1.6666666666666667e-01*(+x_VD_S_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VD_S*(((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S)))))))))+x_VD_S*((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))+x*(+0.0+(+xsq_VD_S_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VD_S*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))+xsq_VD_S*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VD_S+0.0*Bg_VD_S+0.4*(+Bg_VD_S_VD_S+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S)))+0.0*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))+0.0285714285714*(+xsq_VD_S_VD_S*(0.125+Bg)+xsq_VD_S*Bg_VD_S+xsq_VD_S*Bg_VD_S+xsq*(+0.0+Bg_VD_S_VD_S)))))))));
  igcd_h_VD_S_VGP_S=(+(+0.0*igc+0.0*igc_VGP_S+0.0*igc_VD_S+0.5*igc_VD_S_VGP_S)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))))))))+0.0*((x_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))))+1.6666666666666667e-01*(+x_VD_S_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VD_S*(((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S)))))))))+x_VGP_S*((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))+x*(+0.0+(+xsq_VD_S_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VD_S*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))+xsq_VGP_S*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VGP_S+0.0*Bg_VD_S+0.4*(+Bg_VD_S_VGP_S+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S)))+0.0*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))+0.0285714285714*(+xsq_VD_S_VGP_S*(0.125+Bg)+xsq_VD_S*Bg_VGP_S+xsq_VGP_S*Bg_VD_S+xsq*(+0.0+Bg_VD_S_VGP_S)))))))));
  igcd_h_VD_S_VS_BP=(+(+0.0*igc+0.0*igc_VS_BP+0.0*igc_VD_S+0.5*igc_VD_S_VS_BP)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))))))))+0.0*((x_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))))+1.6666666666666667e-01*(+x_VD_S_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VD_S*(((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP)))))))))+x_VS_BP*((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))+x*(+0.0+(+xsq_VD_S_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VD_S*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))+xsq_VS_BP*((0.4*Bg_VD_S)+(0.0285714285714*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VS_BP+0.0*Bg_VD_S+0.4*(+Bg_VD_S_VS_BP+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP)))+0.0*((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))+0.0285714285714*(+xsq_VD_S_VS_BP*(0.125+Bg)+xsq_VD_S*Bg_VS_BP+xsq_VS_BP*Bg_VD_S+xsq*(+0.0+Bg_VD_S_VS_BP)))))))));
#endif
igcd_h_VGP_S=((0.5*igc_VGP_S)-(1.6666666666666667e-01*((x_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))))));
#if defined(_DERIVATE2)
  igcd_h_VGP_S_VD_S=(+(+0.0*igc+0.0*igc_VD_S+0.0*igc_VGP_S+0.5*igc_VGP_S_VD_S)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))))))))+0.0*((x_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))))+1.6666666666666667e-01*(+x_VGP_S_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VGP_S*(((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S)))))))))+x_VD_S*((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))+x*(+0.0+(+xsq_VGP_S_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VGP_S*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))+xsq_VD_S*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VD_S+0.0*Bg_VGP_S+0.4*(+Bg_VGP_S_VD_S+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S)))+0.0*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))+0.0285714285714*(+xsq_VGP_S_VD_S*(0.125+Bg)+xsq_VGP_S*Bg_VD_S+xsq_VD_S*Bg_VGP_S+xsq*(+0.0+Bg_VGP_S_VD_S)))))))));
  igcd_h_VGP_S_VGP_S=(+(+0.0*igc+0.0*igc_VGP_S+0.0*igc_VGP_S+0.5*igc_VGP_S_VGP_S)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))))))))+0.0*((x_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))))+1.6666666666666667e-01*(+x_VGP_S_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VGP_S*(((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S)))))))))+x_VGP_S*((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))+x*(+0.0+(+xsq_VGP_S_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VGP_S*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))+xsq_VGP_S*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VGP_S+0.0*Bg_VGP_S+0.4*(+Bg_VGP_S_VGP_S+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S)))+0.0*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))+0.0285714285714*(+xsq_VGP_S_VGP_S*(0.125+Bg)+xsq_VGP_S*Bg_VGP_S+xsq_VGP_S*Bg_VGP_S+xsq*(+0.0+Bg_VGP_S_VGP_S)))))))));
  igcd_h_VGP_S_VS_BP=(+(+0.0*igc+0.0*igc_VS_BP+0.0*igc_VGP_S+0.5*igc_VGP_S_VS_BP)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))))))))+0.0*((x_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))))+1.6666666666666667e-01*(+x_VGP_S_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VGP_S*(((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP)))))))))+x_VS_BP*((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))+x*(+0.0+(+xsq_VGP_S_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VGP_S*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))+xsq_VS_BP*((0.4*Bg_VGP_S)+(0.0285714285714*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VS_BP+0.0*Bg_VGP_S+0.4*(+Bg_VGP_S_VS_BP+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP)))+0.0*((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))+0.0285714285714*(+xsq_VGP_S_VS_BP*(0.125+Bg)+xsq_VGP_S*Bg_VS_BP+xsq_VS_BP*Bg_VGP_S+xsq*(+0.0+Bg_VGP_S_VS_BP)))))))));
#endif
igcd_h_VS_BP=((0.5*igc_VS_BP)-(1.6666666666666667e-01*((x_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))))));
#if defined(_DERIVATE2)
  igcd_h_VS_BP_VD_S=(+(+0.0*igc+0.0*igc_VD_S+0.0*igc_VS_BP+0.5*igc_VS_BP_VD_S)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))))))))+0.0*((x_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))))+1.6666666666666667e-01*(+x_VS_BP_VD_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VS_BP*(((xsq_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S)))))))))+x_VD_S*((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))+x*(+0.0+(+xsq_VS_BP_VD_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VS_BP*(((0.4*Bg_VD_S))+((0.0285714285714*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S))))))+xsq_VD_S*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VD_S+0.0*Bg_VS_BP+0.4*(+Bg_VS_BP_VD_S+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VD_S*(0.125+Bg))+(xsq*Bg_VD_S)))+0.0*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))+0.0285714285714*(+xsq_VS_BP_VD_S*(0.125+Bg)+xsq_VS_BP*Bg_VD_S+xsq_VD_S*Bg_VS_BP+xsq*(+0.0+Bg_VS_BP_VD_S)))))))));
  igcd_h_VS_BP_VGP_S=(+(+0.0*igc+0.0*igc_VGP_S+0.0*igc_VS_BP+0.5*igc_VS_BP_VGP_S)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))))))))+0.0*((x_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))))+1.6666666666666667e-01*(+x_VS_BP_VGP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VS_BP*(((xsq_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S)))))))))+x_VGP_S*((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))+x*(+0.0+(+xsq_VS_BP_VGP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VS_BP*(((0.4*Bg_VGP_S))+((0.0285714285714*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S))))))+xsq_VGP_S*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VGP_S+0.0*Bg_VS_BP+0.4*(+Bg_VS_BP_VGP_S+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VGP_S*(0.125+Bg))+(xsq*Bg_VGP_S)))+0.0*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))+0.0285714285714*(+xsq_VS_BP_VGP_S*(0.125+Bg)+xsq_VS_BP*Bg_VGP_S+xsq_VGP_S*Bg_VS_BP+xsq*(+0.0+Bg_VS_BP_VGP_S)))))))));
  igcd_h_VS_BP_VS_BP=(+(+0.0*igc+0.0*igc_VS_BP+0.0*igc_VS_BP+0.5*igc_VS_BP_VS_BP)-(+0.0*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+0.0*(((x_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*(((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))))))))+0.0*((x_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))+(x*((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))))+1.6666666666666667e-01*(+x_VS_BP_VS_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))+x_VS_BP*(((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP)))))))))+x_VS_BP*((xsq_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+(xsq*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))+x*(+0.0+(+xsq_VS_BP_VS_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))+xsq_VS_BP*(((0.4*Bg_VS_BP))+((0.0285714285714*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))))+xsq_VS_BP*((0.4*Bg_VS_BP)+(0.0285714285714*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))))+xsq*(+(+0.0*(Bg+0.25)+0.0*Bg_VS_BP+0.0*Bg_VS_BP+0.4*(+Bg_VS_BP_VS_BP+0.0))+(+0.0*(xsq*(0.125+Bg))+0.0*(((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP)))+0.0*((xsq_VS_BP*(0.125+Bg))+(xsq*Bg_VS_BP))+0.0285714285714*(+xsq_VS_BP_VS_BP*(0.125+Bg)+xsq_VS_BP*Bg_VS_BP+xsq_VS_BP*Bg_VS_BP+xsq*(+0.0+Bg_VS_BP_VS_BP)))))))));
#endif
#endif
igcd_h=((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
EXIT_IF_ISNAN(((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
inv_x_VD_S=(-x_VD_S/x/x);
#if defined(_DERIVATE2)
  inv_x_VD_S_VD_S=(0.0/x-(0.0*x_VD_S+0.0*x_VD_S+1.0*x_VD_S_VD_S)/x/x+2*1.0*x_VD_S*x_VD_S/x/x/x);
  inv_x_VD_S_VGP_S=(0.0/x-(0.0*x_VGP_S+0.0*x_VD_S+1.0*x_VD_S_VGP_S)/x/x+2*1.0*x_VD_S*x_VGP_S/x/x/x);
  inv_x_VD_S_VS_BP=(0.0/x-(0.0*x_VS_BP+0.0*x_VD_S+1.0*x_VD_S_VS_BP)/x/x+2*1.0*x_VD_S*x_VS_BP/x/x/x);
#endif
inv_x_VGP_S=(-x_VGP_S/x/x);
#if defined(_DERIVATE2)
  inv_x_VGP_S_VD_S=(0.0/x-(0.0*x_VD_S+0.0*x_VGP_S+1.0*x_VGP_S_VD_S)/x/x+2*1.0*x_VGP_S*x_VD_S/x/x/x);
  inv_x_VGP_S_VGP_S=(0.0/x-(0.0*x_VGP_S+0.0*x_VGP_S+1.0*x_VGP_S_VGP_S)/x/x+2*1.0*x_VGP_S*x_VGP_S/x/x/x);
  inv_x_VGP_S_VS_BP=(0.0/x-(0.0*x_VS_BP+0.0*x_VGP_S+1.0*x_VGP_S_VS_BP)/x/x+2*1.0*x_VGP_S*x_VS_BP/x/x/x);
#endif
inv_x_VS_BP=(-x_VS_BP/x/x);
#if defined(_DERIVATE2)
  inv_x_VS_BP_VD_S=(0.0/x-(0.0*x_VD_S+0.0*x_VS_BP+1.0*x_VS_BP_VD_S)/x/x+2*1.0*x_VS_BP*x_VD_S/x/x/x);
  inv_x_VS_BP_VGP_S=(0.0/x-(0.0*x_VGP_S+0.0*x_VS_BP+1.0*x_VS_BP_VGP_S)/x/x+2*1.0*x_VS_BP*x_VGP_S/x/x/x);
  inv_x_VS_BP_VS_BP=(0.0/x-(0.0*x_VS_BP+0.0*x_VS_BP+1.0*x_VS_BP_VS_BP)/x/x+2*1.0*x_VS_BP*x_VS_BP/x/x/x);
#endif
#endif
inv_x=(1.0/x);
EXIT_IF_ISNAN((1.0/x))
{
double m00_fabs(d00_fabs0,x)
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,x)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
ex_VD_S=x_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  ex_VD_S_VD_S=(m20_exp(x)*x_VD_S*x_VD_S+d10_exp0*x_VD_S_VD_S);
  ex_VD_S_VGP_S=(m20_exp(x)*x_VGP_S*x_VD_S+d10_exp0*x_VD_S_VGP_S);
  ex_VD_S_VS_BP=(m20_exp(x)*x_VS_BP*x_VD_S+d10_exp0*x_VD_S_VS_BP);
#endif
ex_VGP_S=x_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  ex_VGP_S_VD_S=(m20_exp(x)*x_VD_S*x_VGP_S+d10_exp0*x_VGP_S_VD_S);
  ex_VGP_S_VGP_S=(m20_exp(x)*x_VGP_S*x_VGP_S+d10_exp0*x_VGP_S_VGP_S);
  ex_VGP_S_VS_BP=(m20_exp(x)*x_VS_BP*x_VGP_S+d10_exp0*x_VGP_S_VS_BP);
#endif
ex_VS_BP=x_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  ex_VS_BP_VD_S=(m20_exp(x)*x_VD_S*x_VS_BP+d10_exp0*x_VS_BP_VD_S);
  ex_VS_BP_VGP_S=(m20_exp(x)*x_VGP_S*x_VS_BP+d10_exp0*x_VS_BP_VGP_S);
  ex_VS_BP_VS_BP=(m20_exp(x)*x_VS_BP*x_VS_BP+d10_exp0*x_VS_BP_VS_BP);
#endif
#endif
ex=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((x<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
ex_VD_S=(-1.0e-100*(((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  ex_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VD_S)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01))))))+(-x_VD_S)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01))))+0.0*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VD_S)*((-x_VD_S)*3.3333333333333333e-01)+(-x_VD_S)*(-x_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VD_S_VD_S)*3.3333333333333333e-01+(-x_VD_S)*0.0+(-x_VD_S)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))))*((((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
  ex_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VD_S)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01))))))+(-x_VGP_S)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01))))+0.0*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VD_S)*((-x_VGP_S)*3.3333333333333333e-01)+(-x_VGP_S)*(-x_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VD_S_VGP_S)*3.3333333333333333e-01+(-x_VD_S)*0.0+(-x_VGP_S)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))))*((((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
  ex_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VD_S)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01))))))+(-x_VS_BP)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01))))+0.0*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VD_S)*((-x_VS_BP)*3.3333333333333333e-01)+(-x_VS_BP)*(-x_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VD_S_VS_BP)*3.3333333333333333e-01+(-x_VD_S)*0.0+(-x_VS_BP)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VD_S)*3.3333333333333333e-01)))))*((((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
#endif
ex_VGP_S=(-1.0e-100*(((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  ex_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VGP_S)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01))))))+(-x_VD_S)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01))))+0.0*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VGP_S)*((-x_VD_S)*3.3333333333333333e-01)+(-x_VD_S)*(-x_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VGP_S_VD_S)*3.3333333333333333e-01+(-x_VGP_S)*0.0+(-x_VD_S)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))))*((((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
  ex_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VGP_S)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01))))))+(-x_VGP_S)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01))))+0.0*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VGP_S)*((-x_VGP_S)*3.3333333333333333e-01)+(-x_VGP_S)*(-x_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VGP_S_VGP_S)*3.3333333333333333e-01+(-x_VGP_S)*0.0+(-x_VGP_S)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))))*((((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
  ex_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VGP_S)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01))))))+(-x_VS_BP)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01))))+0.0*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VGP_S)*((-x_VS_BP)*3.3333333333333333e-01)+(-x_VS_BP)*(-x_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VGP_S_VS_BP)*3.3333333333333333e-01+(-x_VGP_S)*0.0+(-x_VS_BP)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VGP_S)*3.3333333333333333e-01)))))*((((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
#endif
ex_VS_BP=(-1.0e-100*(((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  ex_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VS_BP)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01))))))+(-x_VD_S)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01))))+0.0*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VS_BP)*((-x_VD_S)*3.3333333333333333e-01)+(-x_VD_S)*(-x_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VS_BP_VD_S)*3.3333333333333333e-01+(-x_VS_BP)*0.0+(-x_VD_S)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))))*((((-x_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VD_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
  ex_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VS_BP)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01))))))+(-x_VGP_S)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01))))+0.0*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VS_BP)*((-x_VGP_S)*3.3333333333333333e-01)+(-x_VGP_S)*(-x_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VS_BP_VGP_S)*3.3333333333333333e-01+(-x_VS_BP)*0.0+(-x_VGP_S)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))))*((((-x_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VGP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
  ex_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))-(0.0*((((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-x_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))+(-x_VS_BP)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01))))))+(-x_VS_BP)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-x)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+0.0*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01))))+0.0*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-x_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))+(-x_VS_BP)*((-x_VS_BP)*3.3333333333333333e-01)+(-x_VS_BP)*(-x_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-x)*(+0.0+(+(+0.0-x_VS_BP_VS_BP)*3.3333333333333333e-01+(-x_VS_BP)*0.0+(-x_VS_BP)*0.0+((-2.3025850929940458e+02)-x)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*(0.5*(((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*(-x_VS_BP)*3.3333333333333333e-01)))))*((((-x_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-x)*((0.5*((((-x_VS_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-x)*((-x_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
#endif
#endif
ex=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
ex_VD_S=(1.0e100*((x_VD_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  ex_VD_S_VD_S=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VD_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_VD_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VD_S_VD_S-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VD_S*((0.5*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01))))))+x_VD_S*(0.5*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01))))+0.0*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01))+0.5*(+(+x_VD_S_VD_S-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VD_S*(x_VD_S*3.3333333333333333e-01)+x_VD_S*x_VD_S*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VD_S_VD_S-0.0)*3.3333333333333333e-01+x_VD_S*0.0+x_VD_S*0.0+(x-2.3025850929940458e+02)*0.0))))))));
  ex_VD_S_VGP_S=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VGP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_VD_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VD_S_VGP_S-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VD_S*((0.5*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01))))))+x_VGP_S*(0.5*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01))))+0.0*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01))+0.5*(+(+x_VD_S_VGP_S-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VD_S*(x_VGP_S*3.3333333333333333e-01)+x_VGP_S*x_VD_S*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VD_S_VGP_S-0.0)*3.3333333333333333e-01+x_VD_S*0.0+x_VGP_S*0.0+(x-2.3025850929940458e+02)*0.0))))))));
  ex_VD_S_VS_BP=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VS_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_VD_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VD_S_VS_BP-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VD_S*((0.5*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01))))))+x_VS_BP*(0.5*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01))))+0.0*((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VD_S*3.3333333333333333e-01))+0.5*(+(+x_VD_S_VS_BP-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VD_S*(x_VS_BP*3.3333333333333333e-01)+x_VS_BP*x_VD_S*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VD_S_VS_BP-0.0)*3.3333333333333333e-01+x_VD_S*0.0+x_VS_BP*0.0+(x-2.3025850929940458e+02)*0.0))))))));
#endif
ex_VGP_S=(1.0e100*((x_VGP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  ex_VGP_S_VD_S=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VD_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_VGP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VGP_S_VD_S-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VGP_S*((0.5*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01))))))+x_VD_S*(0.5*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01))))+0.0*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_VGP_S_VD_S-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VGP_S*(x_VD_S*3.3333333333333333e-01)+x_VD_S*x_VGP_S*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VGP_S_VD_S-0.0)*3.3333333333333333e-01+x_VGP_S*0.0+x_VD_S*0.0+(x-2.3025850929940458e+02)*0.0))))))));
  ex_VGP_S_VGP_S=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VGP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_VGP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VGP_S_VGP_S-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VGP_S*((0.5*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01))))))+x_VGP_S*(0.5*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01))))+0.0*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_VGP_S_VGP_S-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VGP_S*(x_VGP_S*3.3333333333333333e-01)+x_VGP_S*x_VGP_S*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VGP_S_VGP_S-0.0)*3.3333333333333333e-01+x_VGP_S*0.0+x_VGP_S*0.0+(x-2.3025850929940458e+02)*0.0))))))));
  ex_VGP_S_VS_BP=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VS_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_VGP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VGP_S_VS_BP-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VGP_S*((0.5*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01))))))+x_VS_BP*(0.5*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01))))+0.0*((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VGP_S*3.3333333333333333e-01))+0.5*(+(+x_VGP_S_VS_BP-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VGP_S*(x_VS_BP*3.3333333333333333e-01)+x_VS_BP*x_VGP_S*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VGP_S_VS_BP-0.0)*3.3333333333333333e-01+x_VGP_S*0.0+x_VS_BP*0.0+(x-2.3025850929940458e+02)*0.0))))))));
#endif
ex_VS_BP=(1.0e100*((x_VS_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  ex_VS_BP_VD_S=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VD_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01)))))))))+0.0*((x_VS_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VS_BP_VD_S-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VS_BP*((0.5*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01))))))+x_VD_S*(0.5*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VD_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VD_S*3.3333333333333333e-01))))+0.0*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_VS_BP_VD_S-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VS_BP*(x_VD_S*3.3333333333333333e-01)+x_VD_S*x_VS_BP*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VS_BP_VD_S-0.0)*3.3333333333333333e-01+x_VS_BP*0.0+x_VD_S*0.0+(x-2.3025850929940458e+02)*0.0))))))));
  ex_VS_BP_VGP_S=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VGP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01)))))))))+0.0*((x_VS_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VS_BP_VGP_S-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VS_BP*((0.5*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01))))))+x_VGP_S*(0.5*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VGP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VGP_S*3.3333333333333333e-01))))+0.0*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_VS_BP_VGP_S-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VS_BP*(x_VGP_S*3.3333333333333333e-01)+x_VGP_S*x_VS_BP*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VS_BP_VGP_S-0.0)*3.3333333333333333e-01+x_VS_BP*0.0+x_VGP_S*0.0+(x-2.3025850929940458e+02)*0.0))))))));
  ex_VS_BP_VS_BP=(+0.0*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((x_VS_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*((0.5*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01)))))))))+0.0*((x_VS_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((x-2.3025850929940458e+02)*(0.5*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+x_VS_BP_VS_BP-0.0)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))+x_VS_BP*((0.5*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01))))))+x_VS_BP*(0.5*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01)))+(x-2.3025850929940458e+02)*(+0.0+(+0.0*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*(x_VS_BP*3.3333333333333333e-01))))+0.0*((x_VS_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+((x-2.3025850929940458e+02)*x_VS_BP*3.3333333333333333e-01))+0.5*(+(+x_VS_BP_VS_BP-0.0)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))+x_VS_BP*(x_VS_BP*3.3333333333333333e-01)+x_VS_BP*x_VS_BP*3.3333333333333333e-01+(x-2.3025850929940458e+02)*(+0.0+(+(+x_VS_BP_VS_BP-0.0)*3.3333333333333333e-01+x_VS_BP*0.0+x_VS_BP*0.0+(x-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
ex=(1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
inv_ex_VD_S=(-ex_VD_S/ex/ex);
#if defined(_DERIVATE2)
  inv_ex_VD_S_VD_S=(0.0/ex-(0.0*ex_VD_S+0.0*ex_VD_S+1.0*ex_VD_S_VD_S)/ex/ex+2*1.0*ex_VD_S*ex_VD_S/ex/ex/ex);
  inv_ex_VD_S_VGP_S=(0.0/ex-(0.0*ex_VGP_S+0.0*ex_VD_S+1.0*ex_VD_S_VGP_S)/ex/ex+2*1.0*ex_VD_S*ex_VGP_S/ex/ex/ex);
  inv_ex_VD_S_VS_BP=(0.0/ex-(0.0*ex_VS_BP+0.0*ex_VD_S+1.0*ex_VD_S_VS_BP)/ex/ex+2*1.0*ex_VD_S*ex_VS_BP/ex/ex/ex);
#endif
inv_ex_VGP_S=(-ex_VGP_S/ex/ex);
#if defined(_DERIVATE2)
  inv_ex_VGP_S_VD_S=(0.0/ex-(0.0*ex_VD_S+0.0*ex_VGP_S+1.0*ex_VGP_S_VD_S)/ex/ex+2*1.0*ex_VGP_S*ex_VD_S/ex/ex/ex);
  inv_ex_VGP_S_VGP_S=(0.0/ex-(0.0*ex_VGP_S+0.0*ex_VGP_S+1.0*ex_VGP_S_VGP_S)/ex/ex+2*1.0*ex_VGP_S*ex_VGP_S/ex/ex/ex);
  inv_ex_VGP_S_VS_BP=(0.0/ex-(0.0*ex_VS_BP+0.0*ex_VGP_S+1.0*ex_VGP_S_VS_BP)/ex/ex+2*1.0*ex_VGP_S*ex_VS_BP/ex/ex/ex);
#endif
inv_ex_VS_BP=(-ex_VS_BP/ex/ex);
#if defined(_DERIVATE2)
  inv_ex_VS_BP_VD_S=(0.0/ex-(0.0*ex_VD_S+0.0*ex_VS_BP+1.0*ex_VS_BP_VD_S)/ex/ex+2*1.0*ex_VS_BP*ex_VD_S/ex/ex/ex);
  inv_ex_VS_BP_VGP_S=(0.0/ex-(0.0*ex_VGP_S+0.0*ex_VS_BP+1.0*ex_VS_BP_VGP_S)/ex/ex+2*1.0*ex_VS_BP*ex_VGP_S/ex/ex/ex);
  inv_ex_VS_BP_VS_BP=(0.0/ex-(0.0*ex_VS_BP+0.0*ex_VS_BP+1.0*ex_VS_BP_VS_BP)/ex/ex+2*1.0*ex_VS_BP*ex_VS_BP/ex/ex/ex);
#endif
#endif
inv_ex=(1.0/ex);
EXIT_IF_ISNAN((1.0/ex))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(ex_VGP_S-inv_ex_VGP_S);
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+0.0-0.0);
  temp_VGP_S_VS_BS=(+0.0-0.0);
  temp_VGP_S_VGP_S=(+ex_VGP_S_VGP_S-inv_ex_VGP_S_VGP_S);
  temp_VGP_S_VD_S=(+ex_VGP_S_VD_S-inv_ex_VGP_S_VD_S);
  temp_VGP_S_VS_BP=(+ex_VGP_S_VS_BP-inv_ex_VGP_S_VS_BP);
#endif
temp_VD_S=(ex_VD_S-inv_ex_VD_S);
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+0.0-0.0);
  temp_VD_S_VS_BS=(+0.0-0.0);
  temp_VD_S_VGP_S=(+ex_VD_S_VGP_S-inv_ex_VD_S_VGP_S);
  temp_VD_S_VD_S=(+ex_VD_S_VD_S-inv_ex_VD_S_VD_S);
  temp_VD_S_VS_BP=(+ex_VD_S_VS_BP-inv_ex_VD_S_VS_BP);
#endif
temp_VS_BP=(ex_VS_BP-inv_ex_VS_BP);
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+0.0-0.0);
  temp_VS_BP_VS_BS=(+0.0-0.0);
  temp_VS_BP_VGP_S=(+ex_VS_BP_VGP_S-inv_ex_VS_BP_VGP_S);
  temp_VS_BP_VD_S=(+ex_VS_BP_VD_S-inv_ex_VS_BP_VD_S);
  temp_VS_BP_VS_BP=(+ex_VS_BP_VS_BP-inv_ex_VS_BP_VS_BP);
#endif
#endif
temp=(ex-inv_ex);
EXIT_IF_ISNAN((ex-inv_ex))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp2_VD_S=(ex_VD_S+inv_ex_VD_S);
#if defined(_DERIVATE2)
  temp2_VD_S_VD_S=(+ex_VD_S_VD_S+inv_ex_VD_S_VD_S);
  temp2_VD_S_VGP_S=(+ex_VD_S_VGP_S+inv_ex_VD_S_VGP_S);
  temp2_VD_S_VS_BP=(+ex_VD_S_VS_BP+inv_ex_VD_S_VS_BP);
#endif
temp2_VGP_S=(ex_VGP_S+inv_ex_VGP_S);
#if defined(_DERIVATE2)
  temp2_VGP_S_VD_S=(+ex_VGP_S_VD_S+inv_ex_VGP_S_VD_S);
  temp2_VGP_S_VGP_S=(+ex_VGP_S_VGP_S+inv_ex_VGP_S_VGP_S);
  temp2_VGP_S_VS_BP=(+ex_VGP_S_VS_BP+inv_ex_VGP_S_VS_BP);
#endif
temp2_VS_BP=(ex_VS_BP+inv_ex_VS_BP);
#if defined(_DERIVATE2)
  temp2_VS_BP_VD_S=(+ex_VS_BP_VD_S+inv_ex_VS_BP_VD_S);
  temp2_VS_BP_VGP_S=(+ex_VS_BP_VGP_S+inv_ex_VS_BP_VGP_S);
  temp2_VS_BP_VS_BP=(+ex_VS_BP_VS_BP+inv_ex_VS_BP_VS_BP);
#endif
#endif
temp2=(ex+inv_ex);
EXIT_IF_ISNAN((ex+inv_ex))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
igc_VD_S=(0.5*((((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VD_S))+((u0_div_H_VD_S*temp2)+(u0_div_H*temp2_VD_S))));
#if defined(_DERIVATE2)
  igc_VD_S_VD_S=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VD_S)))+(((u0_div_H_VD_S*temp2)+(u0_div_H*temp2_VD_S))))+0.0*((((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VD_S))+((u0_div_H_VD_S*temp2)+(u0_div_H*temp2_VD_S)))+0.5*(+(+(+(+0.0-u0_div_H_VD_S_VD_S)*temp+(-u0_div_H_VD_S)*temp_VD_S+(-u0_div_H_VD_S)*temp_VD_S+(1.0-u0_div_H)*temp_VD_S_VD_S)*inv_x+(((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S))*inv_x_VD_S+((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S)))*inv_x_VD_S+((1.0-u0_div_H)*temp)*inv_x_VD_S_VD_S)+(+u0_div_H_VD_S_VD_S*temp2+u0_div_H_VD_S*temp2_VD_S+u0_div_H_VD_S*temp2_VD_S+u0_div_H*temp2_VD_S_VD_S)));
  igc_VD_S_VGP_S=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VGP_S)))+(((u0_div_H_VGP_S*temp2)+(u0_div_H*temp2_VGP_S))))+0.0*((((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VD_S))+((u0_div_H_VD_S*temp2)+(u0_div_H*temp2_VD_S)))+0.5*(+(+(+(+0.0-u0_div_H_VD_S_VGP_S)*temp+(-u0_div_H_VD_S)*temp_VGP_S+(-u0_div_H_VGP_S)*temp_VD_S+(1.0-u0_div_H)*temp_VD_S_VGP_S)*inv_x+(((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S))*inv_x_VGP_S+((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S)))*inv_x_VD_S+((1.0-u0_div_H)*temp)*inv_x_VD_S_VGP_S)+(+u0_div_H_VD_S_VGP_S*temp2+u0_div_H_VD_S*temp2_VGP_S+u0_div_H_VGP_S*temp2_VD_S+u0_div_H*temp2_VD_S_VGP_S)));
  igc_VD_S_VS_BP=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VS_BP)))+(((u0_div_H_VS_BP*temp2)+(u0_div_H*temp2_VS_BP))))+0.0*((((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VD_S))+((u0_div_H_VD_S*temp2)+(u0_div_H*temp2_VD_S)))+0.5*(+(+(+(+0.0-u0_div_H_VD_S_VS_BP)*temp+(-u0_div_H_VD_S)*temp_VS_BP+(-u0_div_H_VS_BP)*temp_VD_S+(1.0-u0_div_H)*temp_VD_S_VS_BP)*inv_x+(((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S))*inv_x_VS_BP+((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP)))*inv_x_VD_S+((1.0-u0_div_H)*temp)*inv_x_VD_S_VS_BP)+(+u0_div_H_VD_S_VS_BP*temp2+u0_div_H_VD_S*temp2_VS_BP+u0_div_H_VS_BP*temp2_VD_S+u0_div_H*temp2_VD_S_VS_BP)));
#endif
igc_VGP_S=(0.5*((((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VGP_S))+((u0_div_H_VGP_S*temp2)+(u0_div_H*temp2_VGP_S))));
#if defined(_DERIVATE2)
  igc_VGP_S_VD_S=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VD_S)))+(((u0_div_H_VD_S*temp2)+(u0_div_H*temp2_VD_S))))+0.0*((((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VGP_S))+((u0_div_H_VGP_S*temp2)+(u0_div_H*temp2_VGP_S)))+0.5*(+(+(+(+0.0-u0_div_H_VGP_S_VD_S)*temp+(-u0_div_H_VGP_S)*temp_VD_S+(-u0_div_H_VD_S)*temp_VGP_S+(1.0-u0_div_H)*temp_VGP_S_VD_S)*inv_x+(((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S))*inv_x_VD_S+((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S)))*inv_x_VGP_S+((1.0-u0_div_H)*temp)*inv_x_VGP_S_VD_S)+(+u0_div_H_VGP_S_VD_S*temp2+u0_div_H_VGP_S*temp2_VD_S+u0_div_H_VD_S*temp2_VGP_S+u0_div_H*temp2_VGP_S_VD_S)));
  igc_VGP_S_VGP_S=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VGP_S)))+(((u0_div_H_VGP_S*temp2)+(u0_div_H*temp2_VGP_S))))+0.0*((((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VGP_S))+((u0_div_H_VGP_S*temp2)+(u0_div_H*temp2_VGP_S)))+0.5*(+(+(+(+0.0-u0_div_H_VGP_S_VGP_S)*temp+(-u0_div_H_VGP_S)*temp_VGP_S+(-u0_div_H_VGP_S)*temp_VGP_S+(1.0-u0_div_H)*temp_VGP_S_VGP_S)*inv_x+(((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S))*inv_x_VGP_S+((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S)))*inv_x_VGP_S+((1.0-u0_div_H)*temp)*inv_x_VGP_S_VGP_S)+(+u0_div_H_VGP_S_VGP_S*temp2+u0_div_H_VGP_S*temp2_VGP_S+u0_div_H_VGP_S*temp2_VGP_S+u0_div_H*temp2_VGP_S_VGP_S)));
  igc_VGP_S_VS_BP=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VS_BP)))+(((u0_div_H_VS_BP*temp2)+(u0_div_H*temp2_VS_BP))))+0.0*((((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VGP_S))+((u0_div_H_VGP_S*temp2)+(u0_div_H*temp2_VGP_S)))+0.5*(+(+(+(+0.0-u0_div_H_VGP_S_VS_BP)*temp+(-u0_div_H_VGP_S)*temp_VS_BP+(-u0_div_H_VS_BP)*temp_VGP_S+(1.0-u0_div_H)*temp_VGP_S_VS_BP)*inv_x+(((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S))*inv_x_VS_BP+((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP)))*inv_x_VGP_S+((1.0-u0_div_H)*temp)*inv_x_VGP_S_VS_BP)+(+u0_div_H_VGP_S_VS_BP*temp2+u0_div_H_VGP_S*temp2_VS_BP+u0_div_H_VS_BP*temp2_VGP_S+u0_div_H*temp2_VGP_S_VS_BP)));
#endif
igc_VS_BP=(0.5*((((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VS_BP))+((u0_div_H_VS_BP*temp2)+(u0_div_H*temp2_VS_BP))));
#if defined(_DERIVATE2)
  igc_VS_BP_VD_S=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VD_S)))+(((u0_div_H_VD_S*temp2)+(u0_div_H*temp2_VD_S))))+0.0*((((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VS_BP))+((u0_div_H_VS_BP*temp2)+(u0_div_H*temp2_VS_BP)))+0.5*(+(+(+(+0.0-u0_div_H_VS_BP_VD_S)*temp+(-u0_div_H_VS_BP)*temp_VD_S+(-u0_div_H_VD_S)*temp_VS_BP+(1.0-u0_div_H)*temp_VS_BP_VD_S)*inv_x+(((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP))*inv_x_VD_S+((((-u0_div_H_VD_S)*temp)+((1.0-u0_div_H)*temp_VD_S)))*inv_x_VS_BP+((1.0-u0_div_H)*temp)*inv_x_VS_BP_VD_S)+(+u0_div_H_VS_BP_VD_S*temp2+u0_div_H_VS_BP*temp2_VD_S+u0_div_H_VD_S*temp2_VS_BP+u0_div_H*temp2_VS_BP_VD_S)));
  igc_VS_BP_VGP_S=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VGP_S)))+(((u0_div_H_VGP_S*temp2)+(u0_div_H*temp2_VGP_S))))+0.0*((((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VS_BP))+((u0_div_H_VS_BP*temp2)+(u0_div_H*temp2_VS_BP)))+0.5*(+(+(+(+0.0-u0_div_H_VS_BP_VGP_S)*temp+(-u0_div_H_VS_BP)*temp_VGP_S+(-u0_div_H_VGP_S)*temp_VS_BP+(1.0-u0_div_H)*temp_VS_BP_VGP_S)*inv_x+(((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP))*inv_x_VGP_S+((((-u0_div_H_VGP_S)*temp)+((1.0-u0_div_H)*temp_VGP_S)))*inv_x_VS_BP+((1.0-u0_div_H)*temp)*inv_x_VS_BP_VGP_S)+(+u0_div_H_VS_BP_VGP_S*temp2+u0_div_H_VS_BP*temp2_VGP_S+u0_div_H_VGP_S*temp2_VS_BP+u0_div_H*temp2_VS_BP_VGP_S)));
  igc_VS_BP_VS_BP=(+0.0*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))+0.0*((((((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP)))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VS_BP)))+(((u0_div_H_VS_BP*temp2)+(u0_div_H*temp2_VS_BP))))+0.0*((((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP))*inv_x)+(((1.0-u0_div_H)*temp)*inv_x_VS_BP))+((u0_div_H_VS_BP*temp2)+(u0_div_H*temp2_VS_BP)))+0.5*(+(+(+(+0.0-u0_div_H_VS_BP_VS_BP)*temp+(-u0_div_H_VS_BP)*temp_VS_BP+(-u0_div_H_VS_BP)*temp_VS_BP+(1.0-u0_div_H)*temp_VS_BP_VS_BP)*inv_x+(((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP))*inv_x_VS_BP+((((-u0_div_H_VS_BP)*temp)+((1.0-u0_div_H)*temp_VS_BP)))*inv_x_VS_BP+((1.0-u0_div_H)*temp)*inv_x_VS_BP_VS_BP)+(+u0_div_H_VS_BP_VS_BP*temp2+u0_div_H_VS_BP*temp2_VS_BP+u0_div_H_VS_BP*temp2_VS_BP+u0_div_H*temp2_VS_BP_VS_BP)));
#endif
#endif
igc=(0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));
EXIT_IF_ISNAN((0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2))))
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
igcd_h_VD_S=(0.5*((igc_VD_S-((temp_VD_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VD_S-((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))))-((((Ag_VD_S*temp2)+(Ag*temp2_VD_S))*inv_x)+((Ag*temp2)*inv_x_VD_S))));
#if defined(_DERIVATE2)
  igcd_h_VD_S_VD_S=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VD_S-(((temp_VD_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VD_S-((((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))))))-((((((Ag_VD_S*temp2)+(Ag*temp2_VD_S)))*inv_x)+((Ag*temp2)*inv_x_VD_S))))+0.0*((igc_VD_S-((temp_VD_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VD_S-((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))))-((((Ag_VD_S*temp2)+(Ag*temp2_VD_S))*inv_x)+((Ag*temp2)*inv_x_VD_S)))+0.5*(+(+igc_VD_S_VD_S-(+temp_VD_S_VD_S*(Bg-((Ag*inv_x)*inv_x))+temp_VD_S*(Bg_VD_S-((((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))+temp_VD_S*(Bg_VD_S-((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x)+((Ag*inv_x)*inv_x_VD_S)))+temp*(+Bg_VD_S_VD_S-(+(+Ag_VD_S_VD_S*inv_x+Ag_VD_S*inv_x_VD_S+Ag_VD_S*inv_x_VD_S+Ag*inv_x_VD_S_VD_S)*inv_x+((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x_VD_S+(((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x_VD_S+(Ag*inv_x)*inv_x_VD_S_VD_S))))-(+(+Ag_VD_S_VD_S*temp2+Ag_VD_S*temp2_VD_S+Ag_VD_S*temp2_VD_S+Ag*temp2_VD_S_VD_S)*inv_x+((Ag_VD_S*temp2)+(Ag*temp2_VD_S))*inv_x_VD_S+(((Ag_VD_S*temp2)+(Ag*temp2_VD_S)))*inv_x_VD_S+(Ag*temp2)*inv_x_VD_S_VD_S)));
  igcd_h_VD_S_VGP_S=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VGP_S-(((temp_VGP_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VGP_S-((((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))))))-((((((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S)))*inv_x)+((Ag*temp2)*inv_x_VGP_S))))+0.0*((igc_VD_S-((temp_VD_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VD_S-((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))))-((((Ag_VD_S*temp2)+(Ag*temp2_VD_S))*inv_x)+((Ag*temp2)*inv_x_VD_S)))+0.5*(+(+igc_VD_S_VGP_S-(+temp_VD_S_VGP_S*(Bg-((Ag*inv_x)*inv_x))+temp_VD_S*(Bg_VGP_S-((((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))+temp_VGP_S*(Bg_VD_S-((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x)+((Ag*inv_x)*inv_x_VD_S)))+temp*(+Bg_VD_S_VGP_S-(+(+Ag_VD_S_VGP_S*inv_x+Ag_VD_S*inv_x_VGP_S+Ag_VGP_S*inv_x_VD_S+Ag*inv_x_VD_S_VGP_S)*inv_x+((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x_VGP_S+(((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x_VD_S+(Ag*inv_x)*inv_x_VD_S_VGP_S))))-(+(+Ag_VD_S_VGP_S*temp2+Ag_VD_S*temp2_VGP_S+Ag_VGP_S*temp2_VD_S+Ag*temp2_VD_S_VGP_S)*inv_x+((Ag_VD_S*temp2)+(Ag*temp2_VD_S))*inv_x_VGP_S+(((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S)))*inv_x_VD_S+(Ag*temp2)*inv_x_VD_S_VGP_S)));
  igcd_h_VD_S_VS_BP=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VS_BP-(((temp_VS_BP*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VS_BP-((((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))))))-((((((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP)))*inv_x)+((Ag*temp2)*inv_x_VS_BP))))+0.0*((igc_VD_S-((temp_VD_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VD_S-((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))))-((((Ag_VD_S*temp2)+(Ag*temp2_VD_S))*inv_x)+((Ag*temp2)*inv_x_VD_S)))+0.5*(+(+igc_VD_S_VS_BP-(+temp_VD_S_VS_BP*(Bg-((Ag*inv_x)*inv_x))+temp_VD_S*(Bg_VS_BP-((((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))+temp_VS_BP*(Bg_VD_S-((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x)+((Ag*inv_x)*inv_x_VD_S)))+temp*(+Bg_VD_S_VS_BP-(+(+Ag_VD_S_VS_BP*inv_x+Ag_VD_S*inv_x_VS_BP+Ag_VS_BP*inv_x_VD_S+Ag*inv_x_VD_S_VS_BP)*inv_x+((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S))*inv_x_VS_BP+(((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x_VD_S+(Ag*inv_x)*inv_x_VD_S_VS_BP))))-(+(+Ag_VD_S_VS_BP*temp2+Ag_VD_S*temp2_VS_BP+Ag_VS_BP*temp2_VD_S+Ag*temp2_VD_S_VS_BP)*inv_x+((Ag_VD_S*temp2)+(Ag*temp2_VD_S))*inv_x_VS_BP+(((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP)))*inv_x_VD_S+(Ag*temp2)*inv_x_VD_S_VS_BP)));
#endif
igcd_h_VGP_S=(0.5*((igc_VGP_S-((temp_VGP_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VGP_S-((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))))-((((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S))*inv_x)+((Ag*temp2)*inv_x_VGP_S))));
#if defined(_DERIVATE2)
  igcd_h_VGP_S_VD_S=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VD_S-(((temp_VD_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VD_S-((((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))))))-((((((Ag_VD_S*temp2)+(Ag*temp2_VD_S)))*inv_x)+((Ag*temp2)*inv_x_VD_S))))+0.0*((igc_VGP_S-((temp_VGP_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VGP_S-((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))))-((((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S))*inv_x)+((Ag*temp2)*inv_x_VGP_S)))+0.5*(+(+igc_VGP_S_VD_S-(+temp_VGP_S_VD_S*(Bg-((Ag*inv_x)*inv_x))+temp_VGP_S*(Bg_VD_S-((((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))+temp_VD_S*(Bg_VGP_S-((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x)+((Ag*inv_x)*inv_x_VGP_S)))+temp*(+Bg_VGP_S_VD_S-(+(+Ag_VGP_S_VD_S*inv_x+Ag_VGP_S*inv_x_VD_S+Ag_VD_S*inv_x_VGP_S+Ag*inv_x_VGP_S_VD_S)*inv_x+((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x_VD_S+(((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x_VGP_S+(Ag*inv_x)*inv_x_VGP_S_VD_S))))-(+(+Ag_VGP_S_VD_S*temp2+Ag_VGP_S*temp2_VD_S+Ag_VD_S*temp2_VGP_S+Ag*temp2_VGP_S_VD_S)*inv_x+((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S))*inv_x_VD_S+(((Ag_VD_S*temp2)+(Ag*temp2_VD_S)))*inv_x_VGP_S+(Ag*temp2)*inv_x_VGP_S_VD_S)));
  igcd_h_VGP_S_VGP_S=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VGP_S-(((temp_VGP_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VGP_S-((((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))))))-((((((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S)))*inv_x)+((Ag*temp2)*inv_x_VGP_S))))+0.0*((igc_VGP_S-((temp_VGP_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VGP_S-((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))))-((((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S))*inv_x)+((Ag*temp2)*inv_x_VGP_S)))+0.5*(+(+igc_VGP_S_VGP_S-(+temp_VGP_S_VGP_S*(Bg-((Ag*inv_x)*inv_x))+temp_VGP_S*(Bg_VGP_S-((((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))+temp_VGP_S*(Bg_VGP_S-((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x)+((Ag*inv_x)*inv_x_VGP_S)))+temp*(+Bg_VGP_S_VGP_S-(+(+Ag_VGP_S_VGP_S*inv_x+Ag_VGP_S*inv_x_VGP_S+Ag_VGP_S*inv_x_VGP_S+Ag*inv_x_VGP_S_VGP_S)*inv_x+((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x_VGP_S+(((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x_VGP_S+(Ag*inv_x)*inv_x_VGP_S_VGP_S))))-(+(+Ag_VGP_S_VGP_S*temp2+Ag_VGP_S*temp2_VGP_S+Ag_VGP_S*temp2_VGP_S+Ag*temp2_VGP_S_VGP_S)*inv_x+((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S))*inv_x_VGP_S+(((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S)))*inv_x_VGP_S+(Ag*temp2)*inv_x_VGP_S_VGP_S)));
  igcd_h_VGP_S_VS_BP=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VS_BP-(((temp_VS_BP*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VS_BP-((((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))))))-((((((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP)))*inv_x)+((Ag*temp2)*inv_x_VS_BP))))+0.0*((igc_VGP_S-((temp_VGP_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VGP_S-((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))))-((((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S))*inv_x)+((Ag*temp2)*inv_x_VGP_S)))+0.5*(+(+igc_VGP_S_VS_BP-(+temp_VGP_S_VS_BP*(Bg-((Ag*inv_x)*inv_x))+temp_VGP_S*(Bg_VS_BP-((((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))+temp_VS_BP*(Bg_VGP_S-((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x)+((Ag*inv_x)*inv_x_VGP_S)))+temp*(+Bg_VGP_S_VS_BP-(+(+Ag_VGP_S_VS_BP*inv_x+Ag_VGP_S*inv_x_VS_BP+Ag_VS_BP*inv_x_VGP_S+Ag*inv_x_VGP_S_VS_BP)*inv_x+((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S))*inv_x_VS_BP+(((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x_VGP_S+(Ag*inv_x)*inv_x_VGP_S_VS_BP))))-(+(+Ag_VGP_S_VS_BP*temp2+Ag_VGP_S*temp2_VS_BP+Ag_VS_BP*temp2_VGP_S+Ag*temp2_VGP_S_VS_BP)*inv_x+((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S))*inv_x_VS_BP+(((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP)))*inv_x_VGP_S+(Ag*temp2)*inv_x_VGP_S_VS_BP)));
#endif
igcd_h_VS_BP=(0.5*((igc_VS_BP-((temp_VS_BP*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VS_BP-((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))))-((((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP))*inv_x)+((Ag*temp2)*inv_x_VS_BP))));
#if defined(_DERIVATE2)
  igcd_h_VS_BP_VD_S=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VD_S-(((temp_VD_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VD_S-((((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))))))-((((((Ag_VD_S*temp2)+(Ag*temp2_VD_S)))*inv_x)+((Ag*temp2)*inv_x_VD_S))))+0.0*((igc_VS_BP-((temp_VS_BP*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VS_BP-((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))))-((((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP))*inv_x)+((Ag*temp2)*inv_x_VS_BP)))+0.5*(+(+igc_VS_BP_VD_S-(+temp_VS_BP_VD_S*(Bg-((Ag*inv_x)*inv_x))+temp_VS_BP*(Bg_VD_S-((((((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x)+((Ag*inv_x)*inv_x_VD_S))))+temp_VD_S*(Bg_VS_BP-((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x)+((Ag*inv_x)*inv_x_VS_BP)))+temp*(+Bg_VS_BP_VD_S-(+(+Ag_VS_BP_VD_S*inv_x+Ag_VS_BP*inv_x_VD_S+Ag_VD_S*inv_x_VS_BP+Ag*inv_x_VS_BP_VD_S)*inv_x+((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x_VD_S+(((Ag_VD_S*inv_x)+(Ag*inv_x_VD_S)))*inv_x_VS_BP+(Ag*inv_x)*inv_x_VS_BP_VD_S))))-(+(+Ag_VS_BP_VD_S*temp2+Ag_VS_BP*temp2_VD_S+Ag_VD_S*temp2_VS_BP+Ag*temp2_VS_BP_VD_S)*inv_x+((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP))*inv_x_VD_S+(((Ag_VD_S*temp2)+(Ag*temp2_VD_S)))*inv_x_VS_BP+(Ag*temp2)*inv_x_VS_BP_VD_S)));
  igcd_h_VS_BP_VGP_S=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VGP_S-(((temp_VGP_S*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VGP_S-((((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))))))-((((((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S)))*inv_x)+((Ag*temp2)*inv_x_VGP_S))))+0.0*((igc_VS_BP-((temp_VS_BP*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VS_BP-((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))))-((((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP))*inv_x)+((Ag*temp2)*inv_x_VS_BP)))+0.5*(+(+igc_VS_BP_VGP_S-(+temp_VS_BP_VGP_S*(Bg-((Ag*inv_x)*inv_x))+temp_VS_BP*(Bg_VGP_S-((((((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x)+((Ag*inv_x)*inv_x_VGP_S))))+temp_VGP_S*(Bg_VS_BP-((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x)+((Ag*inv_x)*inv_x_VS_BP)))+temp*(+Bg_VS_BP_VGP_S-(+(+Ag_VS_BP_VGP_S*inv_x+Ag_VS_BP*inv_x_VGP_S+Ag_VGP_S*inv_x_VS_BP+Ag*inv_x_VS_BP_VGP_S)*inv_x+((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x_VGP_S+(((Ag_VGP_S*inv_x)+(Ag*inv_x_VGP_S)))*inv_x_VS_BP+(Ag*inv_x)*inv_x_VS_BP_VGP_S))))-(+(+Ag_VS_BP_VGP_S*temp2+Ag_VS_BP*temp2_VGP_S+Ag_VGP_S*temp2_VS_BP+Ag*temp2_VS_BP_VGP_S)*inv_x+((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP))*inv_x_VGP_S+(((Ag_VGP_S*temp2)+(Ag*temp2_VGP_S)))*inv_x_VS_BP+(Ag*temp2)*inv_x_VS_BP_VGP_S)));
  igcd_h_VS_BP_VS_BP=(+0.0*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))+0.0*((igc_VS_BP-(((temp_VS_BP*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VS_BP-((((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))))))-((((((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP)))*inv_x)+((Ag*temp2)*inv_x_VS_BP))))+0.0*((igc_VS_BP-((temp_VS_BP*(Bg-((Ag*inv_x)*inv_x)))+(temp*(Bg_VS_BP-((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))))-((((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP))*inv_x)+((Ag*temp2)*inv_x_VS_BP)))+0.5*(+(+igc_VS_BP_VS_BP-(+temp_VS_BP_VS_BP*(Bg-((Ag*inv_x)*inv_x))+temp_VS_BP*(Bg_VS_BP-((((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x)+((Ag*inv_x)*inv_x_VS_BP))))+temp_VS_BP*(Bg_VS_BP-((((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x)+((Ag*inv_x)*inv_x_VS_BP)))+temp*(+Bg_VS_BP_VS_BP-(+(+Ag_VS_BP_VS_BP*inv_x+Ag_VS_BP*inv_x_VS_BP+Ag_VS_BP*inv_x_VS_BP+Ag*inv_x_VS_BP_VS_BP)*inv_x+((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP))*inv_x_VS_BP+(((Ag_VS_BP*inv_x)+(Ag*inv_x_VS_BP)))*inv_x_VS_BP+(Ag*inv_x)*inv_x_VS_BP_VS_BP))))-(+(+Ag_VS_BP_VS_BP*temp2+Ag_VS_BP*temp2_VS_BP+Ag_VS_BP*temp2_VS_BP+Ag*temp2_VS_BP_VS_BP)*inv_x+((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP))*inv_x_VS_BP+(((Ag_VS_BP*temp2)+(Ag*temp2_VS_BP)))*inv_x_VS_BP+(Ag*temp2)*inv_x_VS_BP_VS_BP)));
#endif
#endif
igcd_h=(0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
EXIT_IF_ISNAN((0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x))))
}
}
{
double m00_sqrt(d00_sqrt0,((pInst->xg*pInst->xg)+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->xg*pInst->xg)+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Sg_VD_S=(0.5*((xg_VD_S*d00_sqrt0-pInst->xg*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0)/d00_sqrt0/d00_sqrt0));
#if defined(_DERIVATE2)
  Sg_VD_S_VD_S=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VD_S*d00_sqrt0-pInst->xg*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VD_S*d00_sqrt0-pInst->xg*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VD_S_VD_S/d00_sqrt0-(xg_VD_S*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0+xg_VD_S*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))+d10_sqrt0*(+(+xg_VD_S_VD_S*pInst->xg+xg_VD_S*xg_VD_S+xg_VD_S*xg_VD_S+pInst->xg*xg_VD_S_VD_S)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
  Sg_VD_S_VGP_S=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VGP_S*d00_sqrt0-pInst->xg*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VD_S*d00_sqrt0-pInst->xg*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VD_S_VGP_S/d00_sqrt0-(xg_VD_S*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0+xg_VGP_S*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))+d10_sqrt0*(+(+xg_VD_S_VGP_S*pInst->xg+xg_VD_S*xg_VGP_S+xg_VGP_S*xg_VD_S+pInst->xg*xg_VD_S_VGP_S)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
  Sg_VD_S_VS_BP=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VS_BP*d00_sqrt0-pInst->xg*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VD_S*d00_sqrt0-pInst->xg*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VD_S_VS_BP/d00_sqrt0-(xg_VD_S*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0+xg_VS_BP*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))+d10_sqrt0*(+(+xg_VD_S_VS_BP*pInst->xg+xg_VD_S*xg_VS_BP+xg_VS_BP*xg_VD_S+pInst->xg*xg_VD_S_VS_BP)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S))*d10_sqrt0*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
#endif
Sg_VGP_S=(0.5*((xg_VGP_S*d00_sqrt0-pInst->xg*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0)/d00_sqrt0/d00_sqrt0));
#if defined(_DERIVATE2)
  Sg_VGP_S_VD_S=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VD_S*d00_sqrt0-pInst->xg*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VGP_S*d00_sqrt0-pInst->xg*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VGP_S_VD_S/d00_sqrt0-(xg_VGP_S*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0+xg_VD_S*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))+d10_sqrt0*(+(+xg_VGP_S_VD_S*pInst->xg+xg_VGP_S*xg_VD_S+xg_VD_S*xg_VGP_S+pInst->xg*xg_VGP_S_VD_S)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
  Sg_VGP_S_VGP_S=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VGP_S*d00_sqrt0-pInst->xg*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VGP_S*d00_sqrt0-pInst->xg*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VGP_S_VGP_S/d00_sqrt0-(xg_VGP_S*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0+xg_VGP_S*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))+d10_sqrt0*(+(+xg_VGP_S_VGP_S*pInst->xg+xg_VGP_S*xg_VGP_S+xg_VGP_S*xg_VGP_S+pInst->xg*xg_VGP_S_VGP_S)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
  Sg_VGP_S_VS_BP=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VS_BP*d00_sqrt0-pInst->xg*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VGP_S*d00_sqrt0-pInst->xg*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VGP_S_VS_BP/d00_sqrt0-(xg_VGP_S*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0+xg_VS_BP*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))+d10_sqrt0*(+(+xg_VGP_S_VS_BP*pInst->xg+xg_VGP_S*xg_VS_BP+xg_VS_BP*xg_VGP_S+pInst->xg*xg_VGP_S_VS_BP)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S))*d10_sqrt0*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
#endif
Sg_VS_BP=(0.5*((xg_VS_BP*d00_sqrt0-pInst->xg*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0)/d00_sqrt0/d00_sqrt0));
#if defined(_DERIVATE2)
  Sg_VS_BP_VD_S=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VD_S*d00_sqrt0-pInst->xg*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VS_BP*d00_sqrt0-pInst->xg*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VS_BP_VD_S/d00_sqrt0-(xg_VS_BP*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0+xg_VD_S*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))+d10_sqrt0*(+(+xg_VS_BP_VD_S*pInst->xg+xg_VS_BP*xg_VD_S+xg_VD_S*xg_VS_BP+pInst->xg*xg_VS_BP_VD_S)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0*(((xg_VD_S*pInst->xg)+(pInst->xg*xg_VD_S)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
  Sg_VS_BP_VGP_S=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VGP_S*d00_sqrt0-pInst->xg*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VS_BP*d00_sqrt0-pInst->xg*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VS_BP_VGP_S/d00_sqrt0-(xg_VS_BP*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0+xg_VGP_S*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))+d10_sqrt0*(+(+xg_VS_BP_VGP_S*pInst->xg+xg_VS_BP*xg_VGP_S+xg_VGP_S*xg_VS_BP+pInst->xg*xg_VS_BP_VGP_S)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0*(((xg_VGP_S*pInst->xg)+(pInst->xg*xg_VGP_S)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
  Sg_VS_BP_VS_BP=(+0.0*(1.0+(pInst->xg/d00_sqrt0))+0.0*((xg_VS_BP*d00_sqrt0-pInst->xg*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.0*((xg_VS_BP*d00_sqrt0-pInst->xg*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)+0.5*(+0.0+(xg_VS_BP_VS_BP/d00_sqrt0-(xg_VS_BP*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0+xg_VS_BP*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0+pInst->xg*(m20_sqrt(((pInst->xg*pInst->xg)+1.0e-6))*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))+d10_sqrt0*(+(+xg_VS_BP_VS_BP*pInst->xg+xg_VS_BP*xg_VS_BP+xg_VS_BP*xg_VS_BP+pInst->xg*xg_VS_BP_VS_BP)+0.0)))/d00_sqrt0/d00_sqrt0+2*pInst->xg*((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP))*d10_sqrt0*(((xg_VS_BP*pInst->xg)+(pInst->xg*xg_VS_BP)))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0)));
#endif
#endif
Sg=(0.5*(1.0+(pInst->xg/d00_sqrt0)));
EXIT_IF_ISNAN((0.5*(1.0+(pInst->xg/d00_sqrt0))))
}
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
Igc_VGP_S=((((Igc0_VGP_S*igc)+(Igc0*igc_VGP_S))*Sg)+((Igc0*igc)*Sg_VGP_S));
Igc_VD_S=((((Igc0_VD_S*igc)+(Igc0*igc_VD_S))*Sg)+((Igc0*igc)*Sg_VD_S));
Igc_VS_BP=((((Igc0_VS_BP*igc)+(Igc0*igc_VS_BP))*Sg)+((Igc0*igc)*Sg_VS_BP));
#endif
Igc=((Igc0*igc)*Sg);
EXIT_IF_ISNAN(((Igc0*igc)*Sg))
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igcd_VGP_S=((((Igc0_VGP_S*igcd_h)+(Igc0*igcd_h_VGP_S))*Sg)+((Igc0*igcd_h)*Sg_VGP_S));
#if defined(_DERIVATE2)
  Igcd_VGP_S_VGP_S=(+(+Igc0_VGP_S_VGP_S*igcd_h+Igc0_VGP_S*igcd_h_VGP_S+Igc0_VGP_S*igcd_h_VGP_S+Igc0*igcd_h_VGP_S_VGP_S)*Sg+((Igc0_VGP_S*igcd_h)+(Igc0*igcd_h_VGP_S))*Sg_VGP_S+(((Igc0_VGP_S*igcd_h)+(Igc0*igcd_h_VGP_S)))*Sg_VGP_S+(Igc0*igcd_h)*Sg_VGP_S_VGP_S);
  Igcd_VGP_S_VD_S=(+(+Igc0_VGP_S_VD_S*igcd_h+Igc0_VGP_S*igcd_h_VD_S+Igc0_VD_S*igcd_h_VGP_S+Igc0*igcd_h_VGP_S_VD_S)*Sg+((Igc0_VGP_S*igcd_h)+(Igc0*igcd_h_VGP_S))*Sg_VD_S+(((Igc0_VD_S*igcd_h)+(Igc0*igcd_h_VD_S)))*Sg_VGP_S+(Igc0*igcd_h)*Sg_VGP_S_VD_S);
  Igcd_VGP_S_VS_BP=(+(+Igc0_VGP_S_VS_BP*igcd_h+Igc0_VGP_S*igcd_h_VS_BP+Igc0_VS_BP*igcd_h_VGP_S+Igc0*igcd_h_VGP_S_VS_BP)*Sg+((Igc0_VGP_S*igcd_h)+(Igc0*igcd_h_VGP_S))*Sg_VS_BP+(((Igc0_VS_BP*igcd_h)+(Igc0*igcd_h_VS_BP)))*Sg_VGP_S+(Igc0*igcd_h)*Sg_VGP_S_VS_BP);
#endif
Igcd_VD_S=((((Igc0_VD_S*igcd_h)+(Igc0*igcd_h_VD_S))*Sg)+((Igc0*igcd_h)*Sg_VD_S));
#if defined(_DERIVATE2)
  Igcd_VD_S_VGP_S=(+(+Igc0_VD_S_VGP_S*igcd_h+Igc0_VD_S*igcd_h_VGP_S+Igc0_VGP_S*igcd_h_VD_S+Igc0*igcd_h_VD_S_VGP_S)*Sg+((Igc0_VD_S*igcd_h)+(Igc0*igcd_h_VD_S))*Sg_VGP_S+(((Igc0_VGP_S*igcd_h)+(Igc0*igcd_h_VGP_S)))*Sg_VD_S+(Igc0*igcd_h)*Sg_VD_S_VGP_S);
  Igcd_VD_S_VD_S=(+(+Igc0_VD_S_VD_S*igcd_h+Igc0_VD_S*igcd_h_VD_S+Igc0_VD_S*igcd_h_VD_S+Igc0*igcd_h_VD_S_VD_S)*Sg+((Igc0_VD_S*igcd_h)+(Igc0*igcd_h_VD_S))*Sg_VD_S+(((Igc0_VD_S*igcd_h)+(Igc0*igcd_h_VD_S)))*Sg_VD_S+(Igc0*igcd_h)*Sg_VD_S_VD_S);
  Igcd_VD_S_VS_BP=(+(+Igc0_VD_S_VS_BP*igcd_h+Igc0_VD_S*igcd_h_VS_BP+Igc0_VS_BP*igcd_h_VD_S+Igc0*igcd_h_VD_S_VS_BP)*Sg+((Igc0_VD_S*igcd_h)+(Igc0*igcd_h_VD_S))*Sg_VS_BP+(((Igc0_VS_BP*igcd_h)+(Igc0*igcd_h_VS_BP)))*Sg_VD_S+(Igc0*igcd_h)*Sg_VD_S_VS_BP);
#endif
Igcd_VS_BP=((((Igc0_VS_BP*igcd_h)+(Igc0*igcd_h_VS_BP))*Sg)+((Igc0*igcd_h)*Sg_VS_BP));
#if defined(_DERIVATE2)
  Igcd_VS_BP_VGP_S=(+(+Igc0_VS_BP_VGP_S*igcd_h+Igc0_VS_BP*igcd_h_VGP_S+Igc0_VGP_S*igcd_h_VS_BP+Igc0*igcd_h_VS_BP_VGP_S)*Sg+((Igc0_VS_BP*igcd_h)+(Igc0*igcd_h_VS_BP))*Sg_VGP_S+(((Igc0_VGP_S*igcd_h)+(Igc0*igcd_h_VGP_S)))*Sg_VS_BP+(Igc0*igcd_h)*Sg_VS_BP_VGP_S);
  Igcd_VS_BP_VD_S=(+(+Igc0_VS_BP_VD_S*igcd_h+Igc0_VS_BP*igcd_h_VD_S+Igc0_VD_S*igcd_h_VS_BP+Igc0*igcd_h_VS_BP_VD_S)*Sg+((Igc0_VS_BP*igcd_h)+(Igc0*igcd_h_VS_BP))*Sg_VD_S+(((Igc0_VD_S*igcd_h)+(Igc0*igcd_h_VD_S)))*Sg_VS_BP+(Igc0*igcd_h)*Sg_VS_BP_VD_S);
  Igcd_VS_BP_VS_BP=(+(+Igc0_VS_BP_VS_BP*igcd_h+Igc0_VS_BP*igcd_h_VS_BP+Igc0_VS_BP*igcd_h_VS_BP+Igc0*igcd_h_VS_BP_VS_BP)*Sg+((Igc0_VS_BP*igcd_h)+(Igc0*igcd_h_VS_BP))*Sg_VS_BP+(((Igc0_VS_BP*igcd_h)+(Igc0*igcd_h_VS_BP)))*Sg_VS_BP+(Igc0*igcd_h)*Sg_VS_BP_VS_BP);
#endif
#endif
pInst->Igcd=((Igc0*igcd_h)*Sg);
EXIT_IF_ISNAN(((Igc0*igcd_h)*Sg))
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
Igcs_VGP_S=(Igc_VGP_S-Igcd_VGP_S);
Igcs_VD_S=(Igc_VD_S-Igcd_VD_S);
Igcs_VS_BP=(Igc_VS_BP-Igcd_VS_BP);
#endif
pInst->Igcs=(Igc-pInst->Igcd);
EXIT_IF_ISNAN((Igc-pInst->Igcd))
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
Igb_VGP_S=((((Igc0_VGP_S*igc)+(Igc0*igc_VGP_S))*(1.0-Sg))+((Igc0*igc)*(-Sg_VGP_S)));
Igb_VD_S=((((Igc0_VD_S*igc)+(Igc0*igc_VD_S))*(1.0-Sg))+((Igc0*igc)*(-Sg_VD_S)));
Igb_VS_BP=((((Igc0_VS_BP*igc)+(Igc0*igc_VS_BP))*(1.0-Sg))+((Igc0*igc)*(-Sg_VS_BP)));
#endif
Igb=((Igc0*igc)*(1.0-Sg));
EXIT_IF_ISNAN(((Igc0*igc)*(1.0-Sg)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igidl_VD_S=0.0;
#if defined(_DERIVATE2)
  Igidl_VD_S_VD_S=0.0;
  Igidl_VD_S_VS_BP=0.0;
  Igidl_VD_S_VGP_S=0.0;
#endif
Igidl_VS_BP=0.0;
#if defined(_DERIVATE2)
  Igidl_VS_BP_VD_S=0.0;
  Igidl_VS_BP_VS_BP=0.0;
  Igidl_VS_BP_VGP_S=0.0;
#endif
Igidl_VGP_S=0.0;
#if defined(_DERIVATE2)
  Igidl_VGP_S_VD_S=0.0;
  Igidl_VGP_S_VS_BP=0.0;
  Igidl_VGP_S_VGP_S=0.0;
#endif
#endif
Igidl=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igisl_VS_BP=0.0;
#if defined(_DERIVATE2)
  Igisl_VS_BP_VS_BP=0.0;
  Igisl_VS_BP_VGP_S=0.0;
  Igisl_VS_BP_VD_S=0.0;
#endif
Igisl_VGP_S=0.0;
#if defined(_DERIVATE2)
  Igisl_VGP_S_VS_BP=0.0;
  Igisl_VGP_S_VGP_S=0.0;
  Igisl_VGP_S_VD_S=0.0;
#endif
Igisl_VD_S=0.0;
#if defined(_DERIVATE2)
  Igisl_VD_S_VS_BP=0.0;
  Igisl_VD_S_VGP_S=0.0;
  Igisl_VD_S_VD_S=0.0;
#endif
#endif
Igisl=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->SWGIDL!=0))
{
if
(((pInst->AGIDLD_i>0)&&(Vovd<0)))
{
{
double m00_sqrt(d00_sqrt0,(((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vtovd_VGP_S=((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vtovd_VGP_S_VGP_S=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(0.0)))))*((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))+d10_sqrt0*(+(+(+Vovd_VGP_S_VGP_S*Vovd+Vovd_VGP_S*Vovd_VGP_S+Vovd_VGP_S*Vovd_VGP_S+Vovd*Vovd_VGP_S_VGP_S)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(0.0)+(0.0)*0.0+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+0.0*VdbPrime+0.0*0.0+0.0*0.0+VdbPrime*0.0)))+0.0));
  Vtovd_VGP_S_VD_S=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S)))))))*((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))+d10_sqrt0*(+(+(+Vovd_VGP_S_VD_S*Vovd+Vovd_VGP_S*Vovd_VD_S+Vovd_VD_S*Vovd_VGP_S+Vovd*Vovd_VGP_S_VD_S)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S)))+(0.0)*0.0+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+0.0*VdbPrime+0.0*VdbPrime_VD_S+VdbPrime_VD_S*0.0+VdbPrime*0.0)))+0.0));
  Vtovd_VGP_S_VS_BP=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP)))))))*((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S))+d10_sqrt0*(+(+(+Vovd_VGP_S_VS_BP*Vovd+Vovd_VGP_S*Vovd_VS_BP+Vovd_VS_BP*Vovd_VGP_S+Vovd*Vovd_VGP_S_VS_BP)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP)))+(0.0)*0.0+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+0.0*VdbPrime+0.0*VdbPrime_VS_BP+VdbPrime_VS_BP*0.0+VdbPrime*0.0)))+0.0));
#endif
Vtovd_VD_S=(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S))))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vtovd_VD_S_VGP_S=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(0.0)))))*(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S))))+d10_sqrt0*(+(+(+Vovd_VD_S_VGP_S*Vovd+Vovd_VD_S*Vovd_VGP_S+Vovd_VGP_S*Vovd_VD_S+Vovd*Vovd_VD_S_VGP_S)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(0.0)+(0.0)*((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S))+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+0.0*VdbPrime+VdbPrime_VD_S*0.0+0.0*VdbPrime_VD_S+VdbPrime*0.0)))+0.0));
  Vtovd_VD_S_VD_S=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S)))))))*(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S))))+d10_sqrt0*(+(+(+Vovd_VD_S_VD_S*Vovd+Vovd_VD_S*Vovd_VD_S+Vovd_VD_S*Vovd_VD_S+Vovd*Vovd_VD_S_VD_S)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S)))+(0.0)*((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S))+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+VdbPrime_VD_S_VD_S*VdbPrime+VdbPrime_VD_S*VdbPrime_VD_S+VdbPrime_VD_S*VdbPrime_VD_S+VdbPrime*VdbPrime_VD_S_VD_S)))+0.0));
  Vtovd_VD_S_VS_BP=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP)))))))*(((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S))))+d10_sqrt0*(+(+(+Vovd_VD_S_VS_BP*Vovd+Vovd_VD_S*Vovd_VS_BP+Vovd_VS_BP*Vovd_VD_S+Vovd*Vovd_VD_S_VS_BP)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP)))+(0.0)*((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S))+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+VdbPrime_VD_S_VS_BP*VdbPrime+VdbPrime_VD_S*VdbPrime_VS_BP+VdbPrime_VS_BP*VdbPrime_VD_S+VdbPrime*VdbPrime_VD_S_VS_BP)))+0.0));
#endif
Vtovd_VS_BP=(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP))))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vtovd_VS_BP_VGP_S=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VGP_S*Vovd)+(Vovd*Vovd_VGP_S)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(0.0)))))*(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP))))+d10_sqrt0*(+(+(+Vovd_VS_BP_VGP_S*Vovd+Vovd_VS_BP*Vovd_VGP_S+Vovd_VGP_S*Vovd_VS_BP+Vovd*Vovd_VS_BP_VGP_S)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(0.0)+(0.0)*((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP))+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+0.0*VdbPrime+VdbPrime_VS_BP*0.0+0.0*VdbPrime_VS_BP+VdbPrime*0.0)))+0.0));
  Vtovd_VS_BP_VD_S=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VD_S*Vovd)+(Vovd*Vovd_VD_S)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S)))))))*(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP))))+d10_sqrt0*(+(+(+Vovd_VS_BP_VD_S*Vovd+Vovd_VS_BP*Vovd_VD_S+Vovd_VD_S*Vovd_VS_BP+Vovd*Vovd_VS_BP_VD_S)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(((VdbPrime_VD_S*VdbPrime)+(VdbPrime*VdbPrime_VD_S)))+(0.0)*((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP))+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+VdbPrime_VS_BP_VD_S*VdbPrime+VdbPrime_VS_BP*VdbPrime_VD_S+VdbPrime_VD_S*VdbPrime_VS_BP+VdbPrime*VdbPrime_VS_BP_VD_S)))+0.0));
  Vtovd_VS_BP_VS_BP=(m20_sqrt((((Vovd*Vovd)+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6))*((((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP)))+((((0.0)*(VdbPrime*VdbPrime))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*(((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP)))))))*(((Vovd_VS_BP*Vovd)+(Vovd*Vovd_VS_BP))+((pInst->CGIDLD_i*pInst->CGIDLD_i)*((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP))))+d10_sqrt0*(+(+(+Vovd_VS_BP_VS_BP*Vovd+Vovd_VS_BP*Vovd_VS_BP+Vovd_VS_BP*Vovd_VS_BP+Vovd*Vovd_VS_BP_VS_BP)+(+(+0.0*pInst->CGIDLD_i+0.0*0.0+0.0*0.0+pInst->CGIDLD_i*0.0)*(VdbPrime*VdbPrime)+0.0*(((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP)))+(0.0)*((VdbPrime_VS_BP*VdbPrime)+(VdbPrime*VdbPrime_VS_BP))+(pInst->CGIDLD_i*pInst->CGIDLD_i)*(+VdbPrime_VS_BP_VS_BP*VdbPrime+VdbPrime_VS_BP*VdbPrime_VS_BP+VdbPrime_VS_BP*VdbPrime_VS_BP+VdbPrime*VdbPrime_VS_BP_VS_BP)))+0.0));
#endif
#endif
Vtovd=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-(-pInst->BGIDLDs)*Vtovd_VGP_S/Vtovd/Vtovd);
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/Vtovd-(0.0*0.0+0.0*Vtovd_VGP_S+(-pInst->BGIDLDs)*0.0)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VGP_S*0.0/Vtovd/Vtovd/Vtovd);
  temp_VGP_S_VS_BS=(0.0/Vtovd-(0.0*0.0+0.0*Vtovd_VGP_S+(-pInst->BGIDLDs)*0.0)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VGP_S*0.0/Vtovd/Vtovd/Vtovd);
  temp_VGP_S_VGP_S=(0.0/Vtovd-(0.0*Vtovd_VGP_S+0.0*Vtovd_VGP_S+(-pInst->BGIDLDs)*Vtovd_VGP_S_VGP_S)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VGP_S*Vtovd_VGP_S/Vtovd/Vtovd/Vtovd);
  temp_VGP_S_VD_S=(0.0/Vtovd-(0.0*Vtovd_VD_S+0.0*Vtovd_VGP_S+(-pInst->BGIDLDs)*Vtovd_VGP_S_VD_S)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VGP_S*Vtovd_VD_S/Vtovd/Vtovd/Vtovd);
  temp_VGP_S_VS_BP=(0.0/Vtovd-(0.0*Vtovd_VS_BP+0.0*Vtovd_VGP_S+(-pInst->BGIDLDs)*Vtovd_VGP_S_VS_BP)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VGP_S*Vtovd_VS_BP/Vtovd/Vtovd/Vtovd);
#endif
temp_VD_S=(-(-pInst->BGIDLDs)*Vtovd_VD_S/Vtovd/Vtovd);
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/Vtovd-(0.0*0.0+0.0*Vtovd_VD_S+(-pInst->BGIDLDs)*0.0)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VD_S*0.0/Vtovd/Vtovd/Vtovd);
  temp_VD_S_VS_BS=(0.0/Vtovd-(0.0*0.0+0.0*Vtovd_VD_S+(-pInst->BGIDLDs)*0.0)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VD_S*0.0/Vtovd/Vtovd/Vtovd);
  temp_VD_S_VGP_S=(0.0/Vtovd-(0.0*Vtovd_VGP_S+0.0*Vtovd_VD_S+(-pInst->BGIDLDs)*Vtovd_VD_S_VGP_S)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VD_S*Vtovd_VGP_S/Vtovd/Vtovd/Vtovd);
  temp_VD_S_VD_S=(0.0/Vtovd-(0.0*Vtovd_VD_S+0.0*Vtovd_VD_S+(-pInst->BGIDLDs)*Vtovd_VD_S_VD_S)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VD_S*Vtovd_VD_S/Vtovd/Vtovd/Vtovd);
  temp_VD_S_VS_BP=(0.0/Vtovd-(0.0*Vtovd_VS_BP+0.0*Vtovd_VD_S+(-pInst->BGIDLDs)*Vtovd_VD_S_VS_BP)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VD_S*Vtovd_VS_BP/Vtovd/Vtovd/Vtovd);
#endif
temp_VS_BP=(-(-pInst->BGIDLDs)*Vtovd_VS_BP/Vtovd/Vtovd);
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/Vtovd-(0.0*0.0+0.0*Vtovd_VS_BP+(-pInst->BGIDLDs)*0.0)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VS_BP*0.0/Vtovd/Vtovd/Vtovd);
  temp_VS_BP_VS_BS=(0.0/Vtovd-(0.0*0.0+0.0*Vtovd_VS_BP+(-pInst->BGIDLDs)*0.0)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VS_BP*0.0/Vtovd/Vtovd/Vtovd);
  temp_VS_BP_VGP_S=(0.0/Vtovd-(0.0*Vtovd_VGP_S+0.0*Vtovd_VS_BP+(-pInst->BGIDLDs)*Vtovd_VS_BP_VGP_S)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VS_BP*Vtovd_VGP_S/Vtovd/Vtovd/Vtovd);
  temp_VS_BP_VD_S=(0.0/Vtovd-(0.0*Vtovd_VD_S+0.0*Vtovd_VS_BP+(-pInst->BGIDLDs)*Vtovd_VS_BP_VD_S)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VS_BP*Vtovd_VD_S/Vtovd/Vtovd/Vtovd);
  temp_VS_BP_VS_BP=(0.0/Vtovd-(0.0*Vtovd_VS_BP+0.0*Vtovd_VS_BP+(-pInst->BGIDLDs)*Vtovd_VS_BP_VS_BP)/Vtovd/Vtovd+2*(-pInst->BGIDLDs)*Vtovd_VS_BP*Vtovd_VS_BP/Vtovd/Vtovd/Vtovd);
#endif
#endif
temp=((-pInst->BGIDLDs)/Vtovd);
EXIT_IF_ISNAN(((-pInst->BGIDLDs)/Vtovd))
if
((temp>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,temp)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp2_VD_S=temp_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  temp2_VD_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VD_S+d10_exp0*temp_VD_S_VD_S);
  temp2_VD_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VD_S+d10_exp0*temp_VD_S_VGP_S);
  temp2_VD_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VD_S+d10_exp0*temp_VD_S_VS_BP);
#endif
temp2_VGP_S=temp_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  temp2_VGP_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VGP_S+d10_exp0*temp_VGP_S_VD_S);
  temp2_VGP_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VGP_S+d10_exp0*temp_VGP_S_VGP_S);
  temp2_VGP_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VGP_S+d10_exp0*temp_VGP_S_VS_BP);
#endif
temp2_VS_BP=temp_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  temp2_VS_BP_VD_S=(m20_exp(temp)*temp_VD_S*temp_VS_BP+d10_exp0*temp_VS_BP_VD_S);
  temp2_VS_BP_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VS_BP+d10_exp0*temp_VS_BP_VGP_S);
  temp2_VS_BP_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VS_BP+d10_exp0*temp_VS_BP_VS_BP);
#endif
#endif
temp2=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp2_VD_S=(-1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp2_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VD_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
temp2_VGP_S=(-1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp2_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
temp2_VS_BP=(-1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp2_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
#endif
temp2=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igidl_VD_S=((-pInst->AGIDLDs)*((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VD_S)));
#if defined(_DERIVATE2)
  Igidl_VD_S_VD_S=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*(((((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VD_S)))+0.0*((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VD_S))+(-pInst->AGIDLDs)*(+(+(+VdbPrime_VD_S_VD_S*Vovd+VdbPrime_VD_S*Vovd_VD_S+VdbPrime_VD_S*Vovd_VD_S+VdbPrime*Vovd_VD_S_VD_S)*Vtovd+((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd_VD_S+(((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd_VD_S+(VdbPrime*Vovd)*Vtovd_VD_S_VD_S)*temp2+((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S))*temp2_VD_S+((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S)))*temp2_VD_S+((VdbPrime*Vovd)*Vtovd)*temp2_VD_S_VD_S));
  Igidl_VD_S_VS_BP=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*(((((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP)))+0.0*((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VD_S))+(-pInst->AGIDLDs)*(+(+(+VdbPrime_VD_S_VS_BP*Vovd+VdbPrime_VD_S*Vovd_VS_BP+VdbPrime_VS_BP*Vovd_VD_S+VdbPrime*Vovd_VD_S_VS_BP)*Vtovd+((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd_VS_BP+(((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd_VD_S+(VdbPrime*Vovd)*Vtovd_VD_S_VS_BP)*temp2+((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S))*temp2_VS_BP+((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP)))*temp2_VD_S+((VdbPrime*Vovd)*Vtovd)*temp2_VD_S_VS_BP));
  Igidl_VD_S_VGP_S=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*((((((((VdbPrime*Vovd_VGP_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S)))+0.0*((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VD_S))+(-pInst->AGIDLDs)*(+(+(+0.0*Vovd+VdbPrime_VD_S*Vovd_VGP_S+0.0*Vovd_VD_S+VdbPrime*Vovd_VD_S_VGP_S)*Vtovd+((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd_VGP_S+((VdbPrime*Vovd_VGP_S))*Vtovd_VD_S+(VdbPrime*Vovd)*Vtovd_VD_S_VGP_S)*temp2+((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S))*temp2_VGP_S+(((((VdbPrime*Vovd_VGP_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S)))*temp2_VD_S+((VdbPrime*Vovd)*Vtovd)*temp2_VD_S_VGP_S));
#endif
Igidl_VS_BP=((-pInst->AGIDLDs)*((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP)));
#if defined(_DERIVATE2)
  Igidl_VS_BP_VD_S=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*(((((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VD_S)))+0.0*((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP))+(-pInst->AGIDLDs)*(+(+(+VdbPrime_VS_BP_VD_S*Vovd+VdbPrime_VS_BP*Vovd_VD_S+VdbPrime_VD_S*Vovd_VS_BP+VdbPrime*Vovd_VS_BP_VD_S)*Vtovd+((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd_VD_S+(((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd_VS_BP+(VdbPrime*Vovd)*Vtovd_VS_BP_VD_S)*temp2+((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP))*temp2_VD_S+((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S)))*temp2_VS_BP+((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP_VD_S));
  Igidl_VS_BP_VS_BP=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*(((((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP)))+0.0*((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP))+(-pInst->AGIDLDs)*(+(+(+VdbPrime_VS_BP_VS_BP*Vovd+VdbPrime_VS_BP*Vovd_VS_BP+VdbPrime_VS_BP*Vovd_VS_BP+VdbPrime*Vovd_VS_BP_VS_BP)*Vtovd+((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd_VS_BP+(((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd_VS_BP+(VdbPrime*Vovd)*Vtovd_VS_BP_VS_BP)*temp2+((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP))*temp2_VS_BP+((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP)))*temp2_VS_BP+((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP_VS_BP));
  Igidl_VS_BP_VGP_S=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*((((((((VdbPrime*Vovd_VGP_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S)))+0.0*((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP))+(-pInst->AGIDLDs)*(+(+(+0.0*Vovd+VdbPrime_VS_BP*Vovd_VGP_S+0.0*Vovd_VS_BP+VdbPrime*Vovd_VS_BP_VGP_S)*Vtovd+((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd_VGP_S+((VdbPrime*Vovd_VGP_S))*Vtovd_VS_BP+(VdbPrime*Vovd)*Vtovd_VS_BP_VGP_S)*temp2+((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP))*temp2_VGP_S+(((((VdbPrime*Vovd_VGP_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S)))*temp2_VS_BP+((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP_VGP_S));
#endif
Igidl_VGP_S=((-pInst->AGIDLDs)*(((((VdbPrime*Vovd_VGP_S)*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S)));
#if defined(_DERIVATE2)
  Igidl_VGP_S_VD_S=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*(((((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VD_S)))+0.0*(((((VdbPrime*Vovd_VGP_S)*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S))+(-pInst->AGIDLDs)*(+(+(+0.0*Vovd+0.0*Vovd_VD_S+VdbPrime_VD_S*Vovd_VGP_S+VdbPrime*Vovd_VGP_S_VD_S)*Vtovd+(VdbPrime*Vovd_VGP_S)*Vtovd_VD_S+(((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd_VGP_S+(VdbPrime*Vovd)*Vtovd_VGP_S_VD_S)*temp2+(((VdbPrime*Vovd_VGP_S)*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S))*temp2_VD_S+((((((VdbPrime_VD_S*Vovd)+(VdbPrime*Vovd_VD_S)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VD_S)))*temp2_VGP_S+((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S_VD_S));
  Igidl_VGP_S_VS_BP=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*(((((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VS_BP)))+0.0*(((((VdbPrime*Vovd_VGP_S)*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S))+(-pInst->AGIDLDs)*(+(+(+0.0*Vovd+0.0*Vovd_VS_BP+VdbPrime_VS_BP*Vovd_VGP_S+VdbPrime*Vovd_VGP_S_VS_BP)*Vtovd+(VdbPrime*Vovd_VGP_S)*Vtovd_VS_BP+(((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd_VGP_S+(VdbPrime*Vovd)*Vtovd_VGP_S_VS_BP)*temp2+(((VdbPrime*Vovd_VGP_S)*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S))*temp2_VS_BP+((((((VdbPrime_VS_BP*Vovd)+(VdbPrime*Vovd_VS_BP)))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VS_BP)))*temp2_VGP_S+((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S_VS_BP));
  Igidl_VGP_S_VGP_S=(+0.0*(((VdbPrime*Vovd)*Vtovd)*temp2)+0.0*((((((((VdbPrime*Vovd_VGP_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S)))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S)))+0.0*(((((VdbPrime*Vovd_VGP_S)*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S))*temp2)+(((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S))+(-pInst->AGIDLDs)*(+(+(+0.0*Vovd+0.0*Vovd_VGP_S+0.0*Vovd_VGP_S+VdbPrime*Vovd_VGP_S_VGP_S)*Vtovd+(VdbPrime*Vovd_VGP_S)*Vtovd_VGP_S+((VdbPrime*Vovd_VGP_S))*Vtovd_VGP_S+(VdbPrime*Vovd)*Vtovd_VGP_S_VGP_S)*temp2+(((VdbPrime*Vovd_VGP_S)*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S))*temp2_VGP_S+(((((VdbPrime*Vovd_VGP_S))*Vtovd)+((VdbPrime*Vovd)*Vtovd_VGP_S)))*temp2_VGP_S+((VdbPrime*Vovd)*Vtovd)*temp2_VGP_S_VGP_S));
#endif
#endif
Igidl=((-pInst->AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
EXIT_IF_ISNAN(((-pInst->AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2)))
}
if
(((pInst->AGIDL_i>0)&&(Vovs<0)))
{
{
double m00_sqrt(d00_sqrt0,(((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Vtovs_VGP_S=((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vtovs_VGP_S_VGP_S=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(0.0)))))*((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))+d10_sqrt0*(+(+(+Vovs_VGP_S_VGP_S*Vovs+Vovs_VGP_S*Vovs_VGP_S+Vovs_VGP_S*Vovs_VGP_S+Vovs*Vovs_VGP_S_VGP_S)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(0.0)+(0.0)*0.0+(pInst->CGIDL_i*pInst->CGIDL_i)*(+0.0*VsbPrime+0.0*0.0+0.0*0.0+VsbPrime*0.0)))+0.0));
  Vtovs_VGP_S_VD_S=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(0.0)))))*((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))+d10_sqrt0*(+(+(+Vovs_VGP_S_VD_S*Vovs+Vovs_VGP_S*Vovs_VD_S+Vovs_VD_S*Vovs_VGP_S+Vovs*Vovs_VGP_S_VD_S)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(0.0)+(0.0)*0.0+(pInst->CGIDL_i*pInst->CGIDL_i)*(+0.0*VsbPrime+0.0*0.0+0.0*0.0+VsbPrime*0.0)))+0.0));
  Vtovs_VGP_S_VS_BP=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP)))))))*((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S))+d10_sqrt0*(+(+(+Vovs_VGP_S_VS_BP*Vovs+Vovs_VGP_S*Vovs_VS_BP+Vovs_VS_BP*Vovs_VGP_S+Vovs*Vovs_VGP_S_VS_BP)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP)))+(0.0)*0.0+(pInst->CGIDL_i*pInst->CGIDL_i)*(+0.0*VsbPrime+0.0*VsbPrime_VS_BP+VsbPrime_VS_BP*0.0+VsbPrime*0.0)))+0.0));
#endif
Vtovs_VD_S=((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vtovs_VD_S_VGP_S=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(0.0)))))*((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))+d10_sqrt0*(+(+(+Vovs_VD_S_VGP_S*Vovs+Vovs_VD_S*Vovs_VGP_S+Vovs_VGP_S*Vovs_VD_S+Vovs*Vovs_VD_S_VGP_S)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(0.0)+(0.0)*0.0+(pInst->CGIDL_i*pInst->CGIDL_i)*(+0.0*VsbPrime+0.0*0.0+0.0*0.0+VsbPrime*0.0)))+0.0));
  Vtovs_VD_S_VD_S=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(0.0)))))*((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))+d10_sqrt0*(+(+(+Vovs_VD_S_VD_S*Vovs+Vovs_VD_S*Vovs_VD_S+Vovs_VD_S*Vovs_VD_S+Vovs*Vovs_VD_S_VD_S)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(0.0)+(0.0)*0.0+(pInst->CGIDL_i*pInst->CGIDL_i)*(+0.0*VsbPrime+0.0*0.0+0.0*0.0+VsbPrime*0.0)))+0.0));
  Vtovs_VD_S_VS_BP=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP)))))))*((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S))+d10_sqrt0*(+(+(+Vovs_VD_S_VS_BP*Vovs+Vovs_VD_S*Vovs_VS_BP+Vovs_VS_BP*Vovs_VD_S+Vovs*Vovs_VD_S_VS_BP)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP)))+(0.0)*0.0+(pInst->CGIDL_i*pInst->CGIDL_i)*(+0.0*VsbPrime+0.0*VsbPrime_VS_BP+VsbPrime_VS_BP*0.0+VsbPrime*0.0)))+0.0));
#endif
Vtovs_VS_BP=(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))+((pInst->CGIDL_i*pInst->CGIDL_i)*((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP))))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vtovs_VS_BP_VGP_S=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VGP_S*Vovs)+(Vovs*Vovs_VGP_S)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(0.0)))))*(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))+((pInst->CGIDL_i*pInst->CGIDL_i)*((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP))))+d10_sqrt0*(+(+(+Vovs_VS_BP_VGP_S*Vovs+Vovs_VS_BP*Vovs_VGP_S+Vovs_VGP_S*Vovs_VS_BP+Vovs*Vovs_VS_BP_VGP_S)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(0.0)+(0.0)*((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP))+(pInst->CGIDL_i*pInst->CGIDL_i)*(+0.0*VsbPrime+VsbPrime_VS_BP*0.0+0.0*VsbPrime_VS_BP+VsbPrime*0.0)))+0.0));
  Vtovs_VS_BP_VD_S=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VD_S*Vovs)+(Vovs*Vovs_VD_S)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(0.0)))))*(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))+((pInst->CGIDL_i*pInst->CGIDL_i)*((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP))))+d10_sqrt0*(+(+(+Vovs_VS_BP_VD_S*Vovs+Vovs_VS_BP*Vovs_VD_S+Vovs_VD_S*Vovs_VS_BP+Vovs*Vovs_VS_BP_VD_S)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(0.0)+(0.0)*((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP))+(pInst->CGIDL_i*pInst->CGIDL_i)*(+0.0*VsbPrime+VsbPrime_VS_BP*0.0+0.0*VsbPrime_VS_BP+VsbPrime*0.0)))+0.0));
  Vtovs_VS_BP_VS_BP=(m20_sqrt((((Vovs*Vovs)+((pInst->CGIDL_i*pInst->CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6))*((((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP)))+((((0.0)*(VsbPrime*VsbPrime))+((pInst->CGIDL_i*pInst->CGIDL_i)*(((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP)))))))*(((Vovs_VS_BP*Vovs)+(Vovs*Vovs_VS_BP))+((pInst->CGIDL_i*pInst->CGIDL_i)*((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP))))+d10_sqrt0*(+(+(+Vovs_VS_BP_VS_BP*Vovs+Vovs_VS_BP*Vovs_VS_BP+Vovs_VS_BP*Vovs_VS_BP+Vovs*Vovs_VS_BP_VS_BP)+(+(+0.0*pInst->CGIDL_i+0.0*0.0+0.0*0.0+pInst->CGIDL_i*0.0)*(VsbPrime*VsbPrime)+0.0*(((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP)))+(0.0)*((VsbPrime_VS_BP*VsbPrime)+(VsbPrime*VsbPrime_VS_BP))+(pInst->CGIDL_i*pInst->CGIDL_i)*(+VsbPrime_VS_BP_VS_BP*VsbPrime+VsbPrime_VS_BP*VsbPrime_VS_BP+VsbPrime_VS_BP*VsbPrime_VS_BP+VsbPrime*VsbPrime_VS_BP_VS_BP)))+0.0));
#endif
#endif
Vtovs=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=(-(-pInst->BGIDLs)*Vtovs_VGP_S/Vtovs/Vtovs);
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(0.0/Vtovs-(0.0*0.0+0.0*Vtovs_VGP_S+(-pInst->BGIDLs)*0.0)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VGP_S*0.0/Vtovs/Vtovs/Vtovs);
  temp_VGP_S_VS_BS=(0.0/Vtovs-(0.0*0.0+0.0*Vtovs_VGP_S+(-pInst->BGIDLs)*0.0)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VGP_S*0.0/Vtovs/Vtovs/Vtovs);
  temp_VGP_S_VGP_S=(0.0/Vtovs-(0.0*Vtovs_VGP_S+0.0*Vtovs_VGP_S+(-pInst->BGIDLs)*Vtovs_VGP_S_VGP_S)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VGP_S*Vtovs_VGP_S/Vtovs/Vtovs/Vtovs);
  temp_VGP_S_VD_S=(0.0/Vtovs-(0.0*Vtovs_VD_S+0.0*Vtovs_VGP_S+(-pInst->BGIDLs)*Vtovs_VGP_S_VD_S)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VGP_S*Vtovs_VD_S/Vtovs/Vtovs/Vtovs);
  temp_VGP_S_VS_BP=(0.0/Vtovs-(0.0*Vtovs_VS_BP+0.0*Vtovs_VGP_S+(-pInst->BGIDLs)*Vtovs_VGP_S_VS_BP)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VGP_S*Vtovs_VS_BP/Vtovs/Vtovs/Vtovs);
#endif
temp_VD_S=(-(-pInst->BGIDLs)*Vtovs_VD_S/Vtovs/Vtovs);
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(0.0/Vtovs-(0.0*0.0+0.0*Vtovs_VD_S+(-pInst->BGIDLs)*0.0)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VD_S*0.0/Vtovs/Vtovs/Vtovs);
  temp_VD_S_VS_BS=(0.0/Vtovs-(0.0*0.0+0.0*Vtovs_VD_S+(-pInst->BGIDLs)*0.0)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VD_S*0.0/Vtovs/Vtovs/Vtovs);
  temp_VD_S_VGP_S=(0.0/Vtovs-(0.0*Vtovs_VGP_S+0.0*Vtovs_VD_S+(-pInst->BGIDLs)*Vtovs_VD_S_VGP_S)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VD_S*Vtovs_VGP_S/Vtovs/Vtovs/Vtovs);
  temp_VD_S_VD_S=(0.0/Vtovs-(0.0*Vtovs_VD_S+0.0*Vtovs_VD_S+(-pInst->BGIDLs)*Vtovs_VD_S_VD_S)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VD_S*Vtovs_VD_S/Vtovs/Vtovs/Vtovs);
  temp_VD_S_VS_BP=(0.0/Vtovs-(0.0*Vtovs_VS_BP+0.0*Vtovs_VD_S+(-pInst->BGIDLs)*Vtovs_VD_S_VS_BP)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VD_S*Vtovs_VS_BP/Vtovs/Vtovs/Vtovs);
#endif
temp_VS_BP=(-(-pInst->BGIDLs)*Vtovs_VS_BP/Vtovs/Vtovs);
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(0.0/Vtovs-(0.0*0.0+0.0*Vtovs_VS_BP+(-pInst->BGIDLs)*0.0)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VS_BP*0.0/Vtovs/Vtovs/Vtovs);
  temp_VS_BP_VS_BS=(0.0/Vtovs-(0.0*0.0+0.0*Vtovs_VS_BP+(-pInst->BGIDLs)*0.0)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VS_BP*0.0/Vtovs/Vtovs/Vtovs);
  temp_VS_BP_VGP_S=(0.0/Vtovs-(0.0*Vtovs_VGP_S+0.0*Vtovs_VS_BP+(-pInst->BGIDLs)*Vtovs_VS_BP_VGP_S)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VS_BP*Vtovs_VGP_S/Vtovs/Vtovs/Vtovs);
  temp_VS_BP_VD_S=(0.0/Vtovs-(0.0*Vtovs_VD_S+0.0*Vtovs_VS_BP+(-pInst->BGIDLs)*Vtovs_VS_BP_VD_S)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VS_BP*Vtovs_VD_S/Vtovs/Vtovs/Vtovs);
  temp_VS_BP_VS_BP=(0.0/Vtovs-(0.0*Vtovs_VS_BP+0.0*Vtovs_VS_BP+(-pInst->BGIDLs)*Vtovs_VS_BP_VS_BP)/Vtovs/Vtovs+2*(-pInst->BGIDLs)*Vtovs_VS_BP*Vtovs_VS_BP/Vtovs/Vtovs/Vtovs);
#endif
#endif
temp=((-pInst->BGIDLs)/Vtovs);
EXIT_IF_ISNAN(((-pInst->BGIDLs)/Vtovs))
if
((temp>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,temp)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp2_VD_S=temp_VD_S*d10_exp0;
#if defined(_DERIVATE2)
  temp2_VD_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VD_S+d10_exp0*temp_VD_S_VD_S);
  temp2_VD_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VD_S+d10_exp0*temp_VD_S_VGP_S);
  temp2_VD_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VD_S+d10_exp0*temp_VD_S_VS_BP);
#endif
temp2_VGP_S=temp_VGP_S*d10_exp0;
#if defined(_DERIVATE2)
  temp2_VGP_S_VD_S=(m20_exp(temp)*temp_VD_S*temp_VGP_S+d10_exp0*temp_VGP_S_VD_S);
  temp2_VGP_S_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VGP_S+d10_exp0*temp_VGP_S_VGP_S);
  temp2_VGP_S_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VGP_S+d10_exp0*temp_VGP_S_VS_BP);
#endif
temp2_VS_BP=temp_VS_BP*d10_exp0;
#if defined(_DERIVATE2)
  temp2_VS_BP_VD_S=(m20_exp(temp)*temp_VD_S*temp_VS_BP+d10_exp0*temp_VS_BP_VD_S);
  temp2_VS_BP_VGP_S=(m20_exp(temp)*temp_VGP_S*temp_VS_BP+d10_exp0*temp_VS_BP_VGP_S);
  temp2_VS_BP_VS_BP=(m20_exp(temp)*temp_VS_BP*temp_VS_BP+d10_exp0*temp_VS_BP_VS_BP);
#endif
#endif
temp2=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp2_VD_S=(-1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp2_VD_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VD_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VD_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VGP_S)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VD_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VD_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VD_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VD_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VD_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VD_S_VS_BP)*3.3333333333333333e-01+(-temp_VD_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VD_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
temp2_VGP_S=(-1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp2_VGP_S_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VD_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VGP_S_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VGP_S)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VGP_S_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VGP_S)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VGP_S_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VGP_S)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VGP_S)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VGP_S_VS_BP)*3.3333333333333333e-01+(-temp_VGP_S)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VGP_S)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
temp2_VS_BP=(-1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  temp2_VS_BP_VD_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))))+(-temp_VD_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VD_S)*3.3333333333333333e-01)+(-temp_VD_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VD_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VD_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VD_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VD_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VD_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VS_BP_VGP_S=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))))+(-temp_VGP_S)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VGP_S)*3.3333333333333333e-01)+(-temp_VGP_S)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VGP_S)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VGP_S)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VGP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VGP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VGP_S)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
  temp2_VS_BP_VS_BP=(0.0/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))-(0.0*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))+0.0*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))+(-temp_VS_BP)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))))+(-temp_VS_BP)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-temp)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+0.0*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01))))+0.0*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01))+0.5*(+(+0.0-temp_VS_BP_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))+(-temp_VS_BP)*((-temp_VS_BP)*3.3333333333333333e-01)+(-temp_VS_BP)*(-temp_VS_BP)*3.3333333333333333e-01+((-2.3025850929940458e+02)-temp)*(+0.0+(+(+0.0-temp_VS_BP_VS_BP)*3.3333333333333333e-01+(-temp_VS_BP)*0.0+(-temp_VS_BP)*0.0+((-2.3025850929940458e+02)-temp)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*(0.5*(((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*(-temp_VS_BP)*3.3333333333333333e-01)))))*((((-temp_VS_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-temp)*((0.5*((((-temp_VS_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-temp)*((-temp_VS_BP)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
#endif
#endif
temp2=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND) */
Igisl_VS_BP=((-pInst->AGIDLs)*((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP)));
#if defined(_DERIVATE2)
  Igisl_VS_BP_VS_BP=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*(((((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP)))+0.0*((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP))+(-pInst->AGIDLs)*(+(+(+VsbPrime_VS_BP_VS_BP*Vovs+VsbPrime_VS_BP*Vovs_VS_BP+VsbPrime_VS_BP*Vovs_VS_BP+VsbPrime*Vovs_VS_BP_VS_BP)*Vtovs+((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs_VS_BP+(((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs_VS_BP+(VsbPrime*Vovs)*Vtovs_VS_BP_VS_BP)*temp2+((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP))*temp2_VS_BP+((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP)))*temp2_VS_BP+((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP_VS_BP));
  Igisl_VS_BP_VGP_S=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*((((((((VsbPrime*Vovs_VGP_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S)))+0.0*((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP))+(-pInst->AGIDLs)*(+(+(+0.0*Vovs+VsbPrime_VS_BP*Vovs_VGP_S+0.0*Vovs_VS_BP+VsbPrime*Vovs_VS_BP_VGP_S)*Vtovs+((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs_VGP_S+((VsbPrime*Vovs_VGP_S))*Vtovs_VS_BP+(VsbPrime*Vovs)*Vtovs_VS_BP_VGP_S)*temp2+((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP))*temp2_VGP_S+(((((VsbPrime*Vovs_VGP_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S)))*temp2_VS_BP+((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP_VGP_S));
  Igisl_VS_BP_VD_S=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*((((((((VsbPrime*Vovs_VD_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VD_S)))+0.0*((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP))+(-pInst->AGIDLs)*(+(+(+0.0*Vovs+VsbPrime_VS_BP*Vovs_VD_S+0.0*Vovs_VS_BP+VsbPrime*Vovs_VS_BP_VD_S)*Vtovs+((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs_VD_S+((VsbPrime*Vovs_VD_S))*Vtovs_VS_BP+(VsbPrime*Vovs)*Vtovs_VS_BP_VD_S)*temp2+((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP))*temp2_VD_S+(((((VsbPrime*Vovs_VD_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S)))*temp2_VS_BP+((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP_VD_S));
#endif
Igisl_VGP_S=((-pInst->AGIDLs)*(((((VsbPrime*Vovs_VGP_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S)));
#if defined(_DERIVATE2)
  Igisl_VGP_S_VS_BP=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*(((((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP)))+0.0*(((((VsbPrime*Vovs_VGP_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S))+(-pInst->AGIDLs)*(+(+(+0.0*Vovs+0.0*Vovs_VS_BP+VsbPrime_VS_BP*Vovs_VGP_S+VsbPrime*Vovs_VGP_S_VS_BP)*Vtovs+(VsbPrime*Vovs_VGP_S)*Vtovs_VS_BP+(((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs_VGP_S+(VsbPrime*Vovs)*Vtovs_VGP_S_VS_BP)*temp2+(((VsbPrime*Vovs_VGP_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S))*temp2_VS_BP+((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP)))*temp2_VGP_S+((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S_VS_BP));
  Igisl_VGP_S_VGP_S=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*((((((((VsbPrime*Vovs_VGP_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S)))+0.0*(((((VsbPrime*Vovs_VGP_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S))+(-pInst->AGIDLs)*(+(+(+0.0*Vovs+0.0*Vovs_VGP_S+0.0*Vovs_VGP_S+VsbPrime*Vovs_VGP_S_VGP_S)*Vtovs+(VsbPrime*Vovs_VGP_S)*Vtovs_VGP_S+((VsbPrime*Vovs_VGP_S))*Vtovs_VGP_S+(VsbPrime*Vovs)*Vtovs_VGP_S_VGP_S)*temp2+(((VsbPrime*Vovs_VGP_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S))*temp2_VGP_S+(((((VsbPrime*Vovs_VGP_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S)))*temp2_VGP_S+((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S_VGP_S));
  Igisl_VGP_S_VD_S=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*((((((((VsbPrime*Vovs_VD_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VD_S)))+0.0*(((((VsbPrime*Vovs_VGP_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S))+(-pInst->AGIDLs)*(+(+(+0.0*Vovs+0.0*Vovs_VD_S+0.0*Vovs_VGP_S+VsbPrime*Vovs_VGP_S_VD_S)*Vtovs+(VsbPrime*Vovs_VGP_S)*Vtovs_VD_S+((VsbPrime*Vovs_VD_S))*Vtovs_VGP_S+(VsbPrime*Vovs)*Vtovs_VGP_S_VD_S)*temp2+(((VsbPrime*Vovs_VGP_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S))*temp2_VD_S+(((((VsbPrime*Vovs_VD_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S)))*temp2_VGP_S+((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S_VD_S));
#endif
Igisl_VD_S=((-pInst->AGIDLs)*(((((VsbPrime*Vovs_VD_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VD_S)));
#if defined(_DERIVATE2)
  Igisl_VD_S_VS_BP=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*(((((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VS_BP)))+0.0*(((((VsbPrime*Vovs_VD_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VD_S))+(-pInst->AGIDLs)*(+(+(+0.0*Vovs+0.0*Vovs_VS_BP+VsbPrime_VS_BP*Vovs_VD_S+VsbPrime*Vovs_VD_S_VS_BP)*Vtovs+(VsbPrime*Vovs_VD_S)*Vtovs_VS_BP+(((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs_VD_S+(VsbPrime*Vovs)*Vtovs_VD_S_VS_BP)*temp2+(((VsbPrime*Vovs_VD_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S))*temp2_VS_BP+((((((VsbPrime_VS_BP*Vovs)+(VsbPrime*Vovs_VS_BP)))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VS_BP)))*temp2_VD_S+((VsbPrime*Vovs)*Vtovs)*temp2_VD_S_VS_BP));
  Igisl_VD_S_VGP_S=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*((((((((VsbPrime*Vovs_VGP_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VGP_S)))+0.0*(((((VsbPrime*Vovs_VD_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VD_S))+(-pInst->AGIDLs)*(+(+(+0.0*Vovs+0.0*Vovs_VGP_S+0.0*Vovs_VD_S+VsbPrime*Vovs_VD_S_VGP_S)*Vtovs+(VsbPrime*Vovs_VD_S)*Vtovs_VGP_S+((VsbPrime*Vovs_VGP_S))*Vtovs_VD_S+(VsbPrime*Vovs)*Vtovs_VD_S_VGP_S)*temp2+(((VsbPrime*Vovs_VD_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S))*temp2_VGP_S+(((((VsbPrime*Vovs_VGP_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VGP_S)))*temp2_VD_S+((VsbPrime*Vovs)*Vtovs)*temp2_VD_S_VGP_S));
  Igisl_VD_S_VD_S=(+0.0*(((VsbPrime*Vovs)*Vtovs)*temp2)+0.0*((((((((VsbPrime*Vovs_VD_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S)))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VD_S)))+0.0*(((((VsbPrime*Vovs_VD_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S))*temp2)+(((VsbPrime*Vovs)*Vtovs)*temp2_VD_S))+(-pInst->AGIDLs)*(+(+(+0.0*Vovs+0.0*Vovs_VD_S+0.0*Vovs_VD_S+VsbPrime*Vovs_VD_S_VD_S)*Vtovs+(VsbPrime*Vovs_VD_S)*Vtovs_VD_S+((VsbPrime*Vovs_VD_S))*Vtovs_VD_S+(VsbPrime*Vovs)*Vtovs_VD_S_VD_S)*temp2+(((VsbPrime*Vovs_VD_S)*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S))*temp2_VD_S+(((((VsbPrime*Vovs_VD_S))*Vtovs)+((VsbPrime*Vovs)*Vtovs_VD_S)))*temp2_VD_S+((VsbPrime*Vovs)*Vtovs)*temp2_VD_S_VD_S));
#endif
#endif
Igisl=((-pInst->AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
EXIT_IF_ISNAN(((-pInst->AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2)))
}
}
#if defined(_DYNAMIC)
P_D=(1+(0.25*(Gf*pInst->kp)));
EXIT_IF_ISNAN((1+(0.25*(Gf*pInst->kp))))
#endif
#if defined(_DYNAMIC)
facvsb0=(pInst->phib+(2*pInst->phit1));
EXIT_IF_ISNAN((pInst->phib+(2*pInst->phit1)))
#endif
#if defined(_DYNAMIC)
facvsb=(Vsbstar+facvsb0);
EXIT_IF_ISNAN((Vsbstar+facvsb0))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(pInst->phit1*facvsb))
vts_i=(((pInst->VFB_i+(P_D*facvsb))-Vsbstar)+(Gf*d00_sqrt0));
EXIT_IF_ISNAN((((pInst->VFB_i+(P_D*facvsb))-Vsbstar)+(Gf*d00_sqrt0)))
}
#endif
#if defined(_DYNAMIC)
vth_i=(vts_i-delVg);
EXIT_IF_ISNAN((vts_i-delVg))
#endif
}
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Vgb_VD_S=(Vgs_VD_S+Vsb_VD_S);
Vgb_VGP_S=Vgs_VGP_S;
Vgb_VS_BP=Vsb_VS_BP;
#endif
Vgb=(Vgs+Vsb);
EXIT_IF_ISNAN((Vgs+Vsb))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(D,GND)V(GP,GND)V(BP,GND) */
COX_qm_VD_S=0.0;
#if defined(_DERIVATE2)
  COX_qm_VD_S_VD_S=0.0;
  COX_qm_VD_S_VGP_S=0.0;
  COX_qm_VD_S_VS_BP=0.0;
#endif
COX_qm_VGP_S=0.0;
#if defined(_DERIVATE2)
  COX_qm_VGP_S_VD_S=0.0;
  COX_qm_VGP_S_VGP_S=0.0;
  COX_qm_VGP_S_VS_BP=0.0;
#endif
COX_qm_VS_BP=0.0;
#if defined(_DERIVATE2)
  COX_qm_VS_BP_VD_S=0.0;
  COX_qm_VS_BP_VGP_S=0.0;
  COX_qm_VS_BP_VS_BP=0.0;
#endif
#endif
pInst->COX_qm=pInst->COX_i;
EXIT_IF_ISNAN(pInst->COX_i)
if
((pInst->qq>0.0))
{
{
double m00_pow(d00_pow0,((qeff*qeff)+pInst->qlim2),((-1.0)*1.6666666666666667e-01))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,((qeff*qeff)+pInst->qlim2),((-1.0)*1.6666666666666667e-01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(D,GND)V(GP,GND)V(BP,GND) */
COX_qm_VD_S=(-pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
#if defined(_DERIVATE2)
  COX_qm_VD_S_VD_S=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S))))*((pInst->qq*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
  COX_qm_VD_S_VGP_S=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S))))*((pInst->qq*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
  COX_qm_VD_S_VS_BP=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VD_S*qeff)+(qeff*qeff_VD_S))))*((pInst->qq*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
#endif
COX_qm_VGP_S=(-pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
#if defined(_DERIVATE2)
  COX_qm_VGP_S_VD_S=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S))))*((pInst->qq*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
  COX_qm_VGP_S_VGP_S=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S))))*((pInst->qq*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
  COX_qm_VGP_S_VS_BP=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S))))*((pInst->qq*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
#endif
COX_qm_VS_BP=(-pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
#if defined(_DERIVATE2)
  COX_qm_VS_BP_VD_S=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP))))*((pInst->qq*(d10_pow0*(((qeff_VD_S*qeff)+(qeff*qeff_VD_S)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
  COX_qm_VS_BP_VGP_S=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP))))*((pInst->qq*(d10_pow0*(((qeff_VGP_S*qeff)+(qeff*qeff_VGP_S)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
  COX_qm_VS_BP_VS_BP=(0.0/(1.0+(pInst->qq*d00_pow0))-(0.0*((pInst->qq*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))))+0.0*(pInst->qq*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP))))+pInst->COX_i*(+0.0+(+0.0*d00_pow0+0.0*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))+0.0*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+pInst->qq*fixme)))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))+2*pInst->COX_i*(pInst->qq*(d10_pow0*((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP))))*((pInst->qq*(d10_pow0*(((qeff_VS_BP*qeff)+(qeff*qeff_VS_BP)))+d11_pow0*(0.0))))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0))/(1.0+(pInst->qq*d00_pow0)));
#endif
#endif
pInst->COX_qm=(pInst->COX_i/(1.0+(pInst->qq*d00_pow0)));
EXIT_IF_ISNAN((pInst->COX_i/(1.0+(pInst->qq*d00_pow0))))
}
}
#ifdef _DYNAMIC
if
((pInst->xg<=0.0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND) */
QG_VD_S=Voxm_VD_S;
#if defined(_DERIVATE2)
  QG_VD_S_VD_S=Voxm_VD_S_VD_S;
  QG_VD_S_VGP_S=Voxm_VD_S_VGP_S;
  QG_VD_S_VS_BP=Voxm_VD_S_VS_BP;
#endif
QG_VGP_S=Voxm_VGP_S;
#if defined(_DERIVATE2)
  QG_VGP_S_VD_S=Voxm_VGP_S_VD_S;
  QG_VGP_S_VGP_S=Voxm_VGP_S_VGP_S;
  QG_VGP_S_VS_BP=Voxm_VGP_S_VS_BP;
#endif
QG_VS_BP=Voxm_VS_BP;
#if defined(_DERIVATE2)
  QG_VS_BP_VD_S=Voxm_VS_BP_VD_S;
  QG_VS_BP_VGP_S=Voxm_VS_BP_VGP_S;
  QG_VS_BP_VS_BP=Voxm_VS_BP_VS_BP;
#endif
#endif
QG=Voxm;
EXIT_IF_ISNAN(Voxm)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(BP,GND)V(GP,GND)V(D,GND) */
QI_VGP_S=0.0;
#if defined(_DERIVATE2)
  QI_VGP_S_VGP_S=0.0;
  QI_VGP_S_VD_S=0.0;
  QI_VGP_S_VS_BP=0.0;
#endif
QI_VD_S=0.0;
#if defined(_DERIVATE2)
  QI_VD_S_VGP_S=0.0;
  QI_VD_S_VD_S=0.0;
  QI_VD_S_VS_BP=0.0;
#endif
QI_VS_BP=0.0;
#if defined(_DERIVATE2)
  QI_VS_BP_VGP_S=0.0;
  QI_VS_BP_VD_S=0.0;
  QI_VS_BP_VS_BP=0.0;
#endif
#endif
QI=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
QD_VGP_S=0.0;
#if defined(_DERIVATE2)
  QD_VGP_S_VGP_S=0.0;
  QD_VGP_S_VD_S=0.0;
  QD_VGP_S_VS_BP=0.0;
#endif
QD_VD_S=0.0;
#if defined(_DERIVATE2)
  QD_VD_S_VGP_S=0.0;
  QD_VD_S_VD_S=0.0;
  QD_VD_S_VS_BP=0.0;
#endif
QD_VS_BP=0.0;
#if defined(_DERIVATE2)
  QD_VS_BP_VGP_S=0.0;
  QD_VS_BP_VD_S=0.0;
  QD_VS_BP_VS_BP=0.0;
#endif
#endif
QD=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND) */
QB_VD_S=QG_VD_S;
#if defined(_DERIVATE2)
  QB_VD_S_VD_S=QG_VD_S_VD_S;
  QB_VD_S_VGP_S=QG_VD_S_VGP_S;
  QB_VD_S_VS_BP=QG_VD_S_VS_BP;
#endif
QB_VGP_S=QG_VGP_S;
#if defined(_DERIVATE2)
  QB_VGP_S_VD_S=QG_VGP_S_VD_S;
  QB_VGP_S_VGP_S=QG_VGP_S_VGP_S;
  QB_VGP_S_VS_BP=QG_VGP_S_VS_BP;
#endif
QB_VS_BP=QG_VS_BP;
#if defined(_DERIVATE2)
  QB_VS_BP_VD_S=QG_VS_BP_VD_S;
  QB_VS_BP_VGP_S=QG_VS_BP_VGP_S;
  QB_VS_BP_VS_BP=QG_VS_BP_VS_BP;
#endif
#endif
QB=QG;
EXIT_IF_ISNAN(QG)
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
Fj_VD_S=(0.5*((dps_VD_S*pInst->H-pInst->dps*H_VD_S)/pInst->H/pInst->H));
#if defined(_DERIVATE2)
  Fj_VD_S_VD_S=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VD_S*pInst->H-pInst->dps*H_VD_S)/pInst->H/pInst->H)+0.0*((dps_VD_S*pInst->H-pInst->dps*H_VD_S)/pInst->H/pInst->H)+0.5*(dps_VD_S_VD_S/pInst->H-(dps_VD_S*H_VD_S+dps_VD_S*H_VD_S+pInst->dps*H_VD_S_VD_S)/pInst->H/pInst->H+2*pInst->dps*H_VD_S*H_VD_S/pInst->H/pInst->H/pInst->H));
  Fj_VD_S_VGP_S=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VGP_S*pInst->H-pInst->dps*H_VGP_S)/pInst->H/pInst->H)+0.0*((dps_VD_S*pInst->H-pInst->dps*H_VD_S)/pInst->H/pInst->H)+0.5*(dps_VD_S_VGP_S/pInst->H-(dps_VD_S*H_VGP_S+dps_VGP_S*H_VD_S+pInst->dps*H_VD_S_VGP_S)/pInst->H/pInst->H+2*pInst->dps*H_VD_S*H_VGP_S/pInst->H/pInst->H/pInst->H));
  Fj_VD_S_VS_BP=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VS_BP*pInst->H-pInst->dps*H_VS_BP)/pInst->H/pInst->H)+0.0*((dps_VD_S*pInst->H-pInst->dps*H_VD_S)/pInst->H/pInst->H)+0.5*(dps_VD_S_VS_BP/pInst->H-(dps_VD_S*H_VS_BP+dps_VS_BP*H_VD_S+pInst->dps*H_VD_S_VS_BP)/pInst->H/pInst->H+2*pInst->dps*H_VD_S*H_VS_BP/pInst->H/pInst->H/pInst->H));
#endif
Fj_VGP_S=(0.5*((dps_VGP_S*pInst->H-pInst->dps*H_VGP_S)/pInst->H/pInst->H));
#if defined(_DERIVATE2)
  Fj_VGP_S_VD_S=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VD_S*pInst->H-pInst->dps*H_VD_S)/pInst->H/pInst->H)+0.0*((dps_VGP_S*pInst->H-pInst->dps*H_VGP_S)/pInst->H/pInst->H)+0.5*(dps_VGP_S_VD_S/pInst->H-(dps_VGP_S*H_VD_S+dps_VD_S*H_VGP_S+pInst->dps*H_VGP_S_VD_S)/pInst->H/pInst->H+2*pInst->dps*H_VGP_S*H_VD_S/pInst->H/pInst->H/pInst->H));
  Fj_VGP_S_VGP_S=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VGP_S*pInst->H-pInst->dps*H_VGP_S)/pInst->H/pInst->H)+0.0*((dps_VGP_S*pInst->H-pInst->dps*H_VGP_S)/pInst->H/pInst->H)+0.5*(dps_VGP_S_VGP_S/pInst->H-(dps_VGP_S*H_VGP_S+dps_VGP_S*H_VGP_S+pInst->dps*H_VGP_S_VGP_S)/pInst->H/pInst->H+2*pInst->dps*H_VGP_S*H_VGP_S/pInst->H/pInst->H/pInst->H));
  Fj_VGP_S_VS_BP=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VS_BP*pInst->H-pInst->dps*H_VS_BP)/pInst->H/pInst->H)+0.0*((dps_VGP_S*pInst->H-pInst->dps*H_VGP_S)/pInst->H/pInst->H)+0.5*(dps_VGP_S_VS_BP/pInst->H-(dps_VGP_S*H_VS_BP+dps_VS_BP*H_VGP_S+pInst->dps*H_VGP_S_VS_BP)/pInst->H/pInst->H+2*pInst->dps*H_VGP_S*H_VS_BP/pInst->H/pInst->H/pInst->H));
#endif
Fj_VS_BP=(0.5*((dps_VS_BP*pInst->H-pInst->dps*H_VS_BP)/pInst->H/pInst->H));
#if defined(_DERIVATE2)
  Fj_VS_BP_VD_S=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VD_S*pInst->H-pInst->dps*H_VD_S)/pInst->H/pInst->H)+0.0*((dps_VS_BP*pInst->H-pInst->dps*H_VS_BP)/pInst->H/pInst->H)+0.5*(dps_VS_BP_VD_S/pInst->H-(dps_VS_BP*H_VD_S+dps_VD_S*H_VS_BP+pInst->dps*H_VS_BP_VD_S)/pInst->H/pInst->H+2*pInst->dps*H_VS_BP*H_VD_S/pInst->H/pInst->H/pInst->H));
  Fj_VS_BP_VGP_S=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VGP_S*pInst->H-pInst->dps*H_VGP_S)/pInst->H/pInst->H)+0.0*((dps_VS_BP*pInst->H-pInst->dps*H_VS_BP)/pInst->H/pInst->H)+0.5*(dps_VS_BP_VGP_S/pInst->H-(dps_VS_BP*H_VGP_S+dps_VGP_S*H_VS_BP+pInst->dps*H_VS_BP_VGP_S)/pInst->H/pInst->H+2*pInst->dps*H_VS_BP*H_VGP_S/pInst->H/pInst->H/pInst->H));
  Fj_VS_BP_VS_BP=(+0.0*(pInst->dps/pInst->H)+0.0*((dps_VS_BP*pInst->H-pInst->dps*H_VS_BP)/pInst->H/pInst->H)+0.0*((dps_VS_BP*pInst->H-pInst->dps*H_VS_BP)/pInst->H/pInst->H)+0.5*(dps_VS_BP_VS_BP/pInst->H-(dps_VS_BP*H_VS_BP+dps_VS_BP*H_VS_BP+pInst->dps*H_VS_BP_VS_BP)/pInst->H/pInst->H+2*pInst->dps*H_VS_BP*H_VS_BP/pInst->H/pInst->H/pInst->H));
#endif
#endif
Fj=(0.5*(pInst->dps/pInst->H));
EXIT_IF_ISNAN((0.5*(pInst->dps/pInst->H)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
Fj2_VD_S=((Fj_VD_S*Fj)+(Fj*Fj_VD_S));
#if defined(_DERIVATE2)
  Fj2_VD_S_VD_S=(+Fj_VD_S_VD_S*Fj+Fj_VD_S*Fj_VD_S+Fj_VD_S*Fj_VD_S+Fj*Fj_VD_S_VD_S);
  Fj2_VD_S_VGP_S=(+Fj_VD_S_VGP_S*Fj+Fj_VD_S*Fj_VGP_S+Fj_VGP_S*Fj_VD_S+Fj*Fj_VD_S_VGP_S);
  Fj2_VD_S_VS_BP=(+Fj_VD_S_VS_BP*Fj+Fj_VD_S*Fj_VS_BP+Fj_VS_BP*Fj_VD_S+Fj*Fj_VD_S_VS_BP);
#endif
Fj2_VGP_S=((Fj_VGP_S*Fj)+(Fj*Fj_VGP_S));
#if defined(_DERIVATE2)
  Fj2_VGP_S_VD_S=(+Fj_VGP_S_VD_S*Fj+Fj_VGP_S*Fj_VD_S+Fj_VD_S*Fj_VGP_S+Fj*Fj_VGP_S_VD_S);
  Fj2_VGP_S_VGP_S=(+Fj_VGP_S_VGP_S*Fj+Fj_VGP_S*Fj_VGP_S+Fj_VGP_S*Fj_VGP_S+Fj*Fj_VGP_S_VGP_S);
  Fj2_VGP_S_VS_BP=(+Fj_VGP_S_VS_BP*Fj+Fj_VGP_S*Fj_VS_BP+Fj_VS_BP*Fj_VGP_S+Fj*Fj_VGP_S_VS_BP);
#endif
Fj2_VS_BP=((Fj_VS_BP*Fj)+(Fj*Fj_VS_BP));
#if defined(_DERIVATE2)
  Fj2_VS_BP_VD_S=(+Fj_VS_BP_VD_S*Fj+Fj_VS_BP*Fj_VD_S+Fj_VD_S*Fj_VS_BP+Fj*Fj_VS_BP_VD_S);
  Fj2_VS_BP_VGP_S=(+Fj_VS_BP_VGP_S*Fj+Fj_VS_BP*Fj_VGP_S+Fj_VGP_S*Fj_VS_BP+Fj*Fj_VS_BP_VGP_S);
  Fj2_VS_BP_VS_BP=(+Fj_VS_BP_VS_BP*Fj+Fj_VS_BP*Fj_VS_BP+Fj_VS_BP*Fj_VS_BP+Fj*Fj_VS_BP_VS_BP);
#endif
#endif
Fj2=(Fj*Fj);
EXIT_IF_ISNAN((Fj*Fj))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
QCLM_VGP_S=(((-GdL_VGP_S)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps))))+((1.0-GdL)*(qim_VGP_S-(0.5*((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))))));
#if defined(_DERIVATE2)
  QCLM_VGP_S_VGP_S=(+(+0.0-GdL_VGP_S_VGP_S)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VGP_S)*(qim_VGP_S-((0.5*(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))))))+(-GdL_VGP_S)*(qim_VGP_S-(0.5*((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))))+(1.0-GdL)*(+qim_VGP_S_VGP_S-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S)))+0.0*((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))+0.5*(+alpha_VGP_S_VGP_S*pInst->dps+alpha_VGP_S*dps_VGP_S+alpha_VGP_S*dps_VGP_S+pInst->alpha*dps_VGP_S_VGP_S))));
  QCLM_VGP_S_VD_S=(+(+0.0-GdL_VGP_S_VD_S)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VGP_S)*(qim_VD_S-((0.5*(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))))))+(-GdL_VD_S)*(qim_VGP_S-(0.5*((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))))+(1.0-GdL)*(+qim_VGP_S_VD_S-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S)))+0.0*((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))+0.5*(+alpha_VGP_S_VD_S*pInst->dps+alpha_VGP_S*dps_VD_S+alpha_VD_S*dps_VGP_S+pInst->alpha*dps_VGP_S_VD_S))));
  QCLM_VGP_S_VS_BP=(+(+0.0-GdL_VGP_S_VS_BP)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VGP_S)*(qim_VS_BP-((0.5*(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))))))+(-GdL_VS_BP)*(qim_VGP_S-(0.5*((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))))+(1.0-GdL)*(+qim_VGP_S_VS_BP-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP)))+0.0*((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))+0.5*(+alpha_VGP_S_VS_BP*pInst->dps+alpha_VGP_S*dps_VS_BP+alpha_VS_BP*dps_VGP_S+pInst->alpha*dps_VGP_S_VS_BP))));
#endif
QCLM_VD_S=(((-GdL_VD_S)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps))))+((1.0-GdL)*(qim_VD_S-(0.5*((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))))));
#if defined(_DERIVATE2)
  QCLM_VD_S_VGP_S=(+(+0.0-GdL_VD_S_VGP_S)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VD_S)*(qim_VGP_S-((0.5*(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))))))+(-GdL_VGP_S)*(qim_VD_S-(0.5*((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))))+(1.0-GdL)*(+qim_VD_S_VGP_S-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S)))+0.0*((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))+0.5*(+alpha_VD_S_VGP_S*pInst->dps+alpha_VD_S*dps_VGP_S+alpha_VGP_S*dps_VD_S+pInst->alpha*dps_VD_S_VGP_S))));
  QCLM_VD_S_VD_S=(+(+0.0-GdL_VD_S_VD_S)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VD_S)*(qim_VD_S-((0.5*(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))))))+(-GdL_VD_S)*(qim_VD_S-(0.5*((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))))+(1.0-GdL)*(+qim_VD_S_VD_S-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S)))+0.0*((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))+0.5*(+alpha_VD_S_VD_S*pInst->dps+alpha_VD_S*dps_VD_S+alpha_VD_S*dps_VD_S+pInst->alpha*dps_VD_S_VD_S))));
  QCLM_VD_S_VS_BP=(+(+0.0-GdL_VD_S_VS_BP)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VD_S)*(qim_VS_BP-((0.5*(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))))))+(-GdL_VS_BP)*(qim_VD_S-(0.5*((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))))+(1.0-GdL)*(+qim_VD_S_VS_BP-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP)))+0.0*((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))+0.5*(+alpha_VD_S_VS_BP*pInst->dps+alpha_VD_S*dps_VS_BP+alpha_VS_BP*dps_VD_S+pInst->alpha*dps_VD_S_VS_BP))));
#endif
QCLM_VS_BP=(((-GdL_VS_BP)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps))))+((1.0-GdL)*(qim_VS_BP-(0.5*((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))))));
#if defined(_DERIVATE2)
  QCLM_VS_BP_VGP_S=(+(+0.0-GdL_VS_BP_VGP_S)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VS_BP)*(qim_VGP_S-((0.5*(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))))))+(-GdL_VGP_S)*(qim_VS_BP-(0.5*((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))))+(1.0-GdL)*(+qim_VS_BP_VGP_S-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S)))+0.0*((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))+0.5*(+alpha_VS_BP_VGP_S*pInst->dps+alpha_VS_BP*dps_VGP_S+alpha_VGP_S*dps_VS_BP+pInst->alpha*dps_VS_BP_VGP_S))));
  QCLM_VS_BP_VD_S=(+(+0.0-GdL_VS_BP_VD_S)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VS_BP)*(qim_VD_S-((0.5*(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))))))+(-GdL_VD_S)*(qim_VS_BP-(0.5*((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))))+(1.0-GdL)*(+qim_VS_BP_VD_S-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S)))+0.0*((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))+0.5*(+alpha_VS_BP_VD_S*pInst->dps+alpha_VS_BP*dps_VD_S+alpha_VD_S*dps_VS_BP+pInst->alpha*dps_VS_BP_VD_S))));
  QCLM_VS_BP_VS_BP=(+(+0.0-GdL_VS_BP_VS_BP)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))+(-GdL_VS_BP)*(qim_VS_BP-((0.5*(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))))))+(-GdL_VS_BP)*(qim_VS_BP-(0.5*((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))))+(1.0-GdL)*(+qim_VS_BP_VS_BP-(+0.0*(pInst->alpha*pInst->dps)+0.0*(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP)))+0.0*((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))+0.5*(+alpha_VS_BP_VS_BP*pInst->dps+alpha_VS_BP*dps_VS_BP+alpha_VS_BP*dps_VS_BP+pInst->alpha*dps_VS_BP_VS_BP))));
#endif
#endif
QCLM=((1.0-GdL)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps))));
EXIT_IF_ISNAN(((1.0-GdL)*(pInst->qim-(0.5*(pInst->alpha*pInst->dps)))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND) */
QG_VD_S=(Voxm_VD_S+(0.5*((((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*3.3333333333333333e-01+GdL_VD_S)))));
#if defined(_DERIVATE2)
  QG_VD_S_VD_S=(+Voxm_VD_S_VD_S+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*3.3333333333333333e-01)+GdL_VD_S))))+0.0*((((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*3.3333333333333333e-01+GdL_VD_S)))+0.5*(+(+eta_p_VD_S_VD_S*pInst->dps+eta_p_VD_S*dps_VD_S+eta_p_VD_S*dps_VD_S+pInst->eta_p*dps_VD_S_VD_S)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S))*(((((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*3.3333333333333333e-01)+GdL_VD_S)+(((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S)))*(((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*3.3333333333333333e-01+GdL_VD_S)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VD_S_VD_S*GdL+Fj_VD_S*GdL_VD_S+Fj_VD_S*GdL_VD_S+Fj*GdL_VD_S_VD_S)*3.3333333333333333e-01+((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*0.0+(((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VD_S_VD_S))));
  QG_VD_S_VGP_S=(+Voxm_VD_S_VGP_S+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*3.3333333333333333e-01)+GdL_VGP_S))))+0.0*((((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*3.3333333333333333e-01+GdL_VD_S)))+0.5*(+(+eta_p_VD_S_VGP_S*pInst->dps+eta_p_VD_S*dps_VGP_S+eta_p_VGP_S*dps_VD_S+pInst->eta_p*dps_VD_S_VGP_S)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S))*(((((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*3.3333333333333333e-01)+GdL_VGP_S)+(((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S)))*(((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*3.3333333333333333e-01+GdL_VD_S)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VD_S_VGP_S*GdL+Fj_VD_S*GdL_VGP_S+Fj_VGP_S*GdL_VD_S+Fj*GdL_VD_S_VGP_S)*3.3333333333333333e-01+((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*0.0+(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VD_S_VGP_S))));
  QG_VD_S_VS_BP=(+Voxm_VD_S_VS_BP+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*3.3333333333333333e-01)+GdL_VS_BP))))+0.0*((((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*3.3333333333333333e-01+GdL_VD_S)))+0.5*(+(+eta_p_VD_S_VS_BP*pInst->dps+eta_p_VD_S*dps_VS_BP+eta_p_VS_BP*dps_VD_S+pInst->eta_p*dps_VD_S_VS_BP)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S))*(((((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*3.3333333333333333e-01)+GdL_VS_BP)+(((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP)))*(((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*3.3333333333333333e-01+GdL_VD_S)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VD_S_VS_BP*GdL+Fj_VD_S*GdL_VS_BP+Fj_VS_BP*GdL_VD_S+Fj*GdL_VD_S_VS_BP)*3.3333333333333333e-01+((Fj_VD_S*GdL)+(Fj*GdL_VD_S))*0.0+(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VD_S_VS_BP))));
#endif
QG_VGP_S=(Voxm_VGP_S+(0.5*((((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*3.3333333333333333e-01+GdL_VGP_S)))));
#if defined(_DERIVATE2)
  QG_VGP_S_VD_S=(+Voxm_VGP_S_VD_S+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*3.3333333333333333e-01)+GdL_VD_S))))+0.0*((((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*3.3333333333333333e-01+GdL_VGP_S)))+0.5*(+(+eta_p_VGP_S_VD_S*pInst->dps+eta_p_VGP_S*dps_VD_S+eta_p_VD_S*dps_VGP_S+pInst->eta_p*dps_VGP_S_VD_S)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S))*(((((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*3.3333333333333333e-01)+GdL_VD_S)+(((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S)))*(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*3.3333333333333333e-01+GdL_VGP_S)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VGP_S_VD_S*GdL+Fj_VGP_S*GdL_VD_S+Fj_VD_S*GdL_VGP_S+Fj*GdL_VGP_S_VD_S)*3.3333333333333333e-01+((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*0.0+(((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VGP_S_VD_S))));
  QG_VGP_S_VGP_S=(+Voxm_VGP_S_VGP_S+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*3.3333333333333333e-01)+GdL_VGP_S))))+0.0*((((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*3.3333333333333333e-01+GdL_VGP_S)))+0.5*(+(+eta_p_VGP_S_VGP_S*pInst->dps+eta_p_VGP_S*dps_VGP_S+eta_p_VGP_S*dps_VGP_S+pInst->eta_p*dps_VGP_S_VGP_S)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S))*(((((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*3.3333333333333333e-01)+GdL_VGP_S)+(((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S)))*(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*3.3333333333333333e-01+GdL_VGP_S)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VGP_S_VGP_S*GdL+Fj_VGP_S*GdL_VGP_S+Fj_VGP_S*GdL_VGP_S+Fj*GdL_VGP_S_VGP_S)*3.3333333333333333e-01+((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*0.0+(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VGP_S_VGP_S))));
  QG_VGP_S_VS_BP=(+Voxm_VGP_S_VS_BP+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*3.3333333333333333e-01)+GdL_VS_BP))))+0.0*((((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*3.3333333333333333e-01+GdL_VGP_S)))+0.5*(+(+eta_p_VGP_S_VS_BP*pInst->dps+eta_p_VGP_S*dps_VS_BP+eta_p_VS_BP*dps_VGP_S+pInst->eta_p*dps_VGP_S_VS_BP)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S))*(((((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*3.3333333333333333e-01)+GdL_VS_BP)+(((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP)))*(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*3.3333333333333333e-01+GdL_VGP_S)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VGP_S_VS_BP*GdL+Fj_VGP_S*GdL_VS_BP+Fj_VS_BP*GdL_VGP_S+Fj*GdL_VGP_S_VS_BP)*3.3333333333333333e-01+((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S))*0.0+(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VGP_S_VS_BP))));
#endif
QG_VS_BP=(Voxm_VS_BP+(0.5*((((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*3.3333333333333333e-01+GdL_VS_BP)))));
#if defined(_DERIVATE2)
  QG_VS_BP_VD_S=(+Voxm_VS_BP_VD_S+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*3.3333333333333333e-01)+GdL_VD_S))))+0.0*((((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*3.3333333333333333e-01+GdL_VS_BP)))+0.5*(+(+eta_p_VS_BP_VD_S*pInst->dps+eta_p_VS_BP*dps_VD_S+eta_p_VD_S*dps_VS_BP+pInst->eta_p*dps_VS_BP_VD_S)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP))*(((((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*3.3333333333333333e-01)+GdL_VD_S)+(((eta_p_VD_S*pInst->dps)+(pInst->eta_p*dps_VD_S)))*(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*3.3333333333333333e-01+GdL_VS_BP)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VS_BP_VD_S*GdL+Fj_VS_BP*GdL_VD_S+Fj_VD_S*GdL_VS_BP+Fj*GdL_VS_BP_VD_S)*3.3333333333333333e-01+((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*0.0+(((Fj_VD_S*GdL)+(Fj*GdL_VD_S)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VS_BP_VD_S))));
  QG_VS_BP_VGP_S=(+Voxm_VS_BP_VGP_S+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*3.3333333333333333e-01)+GdL_VGP_S))))+0.0*((((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*3.3333333333333333e-01+GdL_VS_BP)))+0.5*(+(+eta_p_VS_BP_VGP_S*pInst->dps+eta_p_VS_BP*dps_VGP_S+eta_p_VGP_S*dps_VS_BP+pInst->eta_p*dps_VS_BP_VGP_S)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP))*(((((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*3.3333333333333333e-01)+GdL_VGP_S)+(((eta_p_VGP_S*pInst->dps)+(pInst->eta_p*dps_VGP_S)))*(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*3.3333333333333333e-01+GdL_VS_BP)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VS_BP_VGP_S*GdL+Fj_VS_BP*GdL_VGP_S+Fj_VGP_S*GdL_VS_BP+Fj*GdL_VS_BP_VGP_S)*3.3333333333333333e-01+((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*0.0+(((Fj_VGP_S*GdL)+(Fj*GdL_VGP_S)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VS_BP_VGP_S))));
  QG_VS_BP_VS_BP=(+Voxm_VS_BP_VS_BP+(+0.0*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+0.0*((((((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP)))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*3.3333333333333333e-01)+GdL_VS_BP))))+0.0*((((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP))*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))+((pInst->eta_p*pInst->dps)*(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*3.3333333333333333e-01+GdL_VS_BP)))+0.5*(+(+eta_p_VS_BP_VS_BP*pInst->dps+eta_p_VS_BP*dps_VS_BP+eta_p_VS_BP*dps_VS_BP+pInst->eta_p*dps_VS_BP_VS_BP)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)+((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP))*(((((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*3.3333333333333333e-01)+GdL_VS_BP)+(((eta_p_VS_BP*pInst->dps)+(pInst->eta_p*dps_VS_BP)))*(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*3.3333333333333333e-01+GdL_VS_BP)+(pInst->eta_p*pInst->dps)*(+(+(+(+Fj_VS_BP_VS_BP*GdL+Fj_VS_BP*GdL_VS_BP+Fj_VS_BP*GdL_VS_BP+Fj*GdL_VS_BP_VS_BP)*3.3333333333333333e-01+((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP))*0.0+(((Fj_VS_BP*GdL)+(Fj*GdL_VS_BP)))*0.0+(Fj*GdL)*0.0)-0.0)+GdL_VS_BP_VS_BP))));
#endif
#endif
QG=(Voxm+(0.5*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))));
EXIT_IF_ISNAN((Voxm+(0.5*((pInst->eta_p*pInst->dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))*1.6666666666666667e-01;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+(+0.0*pInst->dps+alpha_VGP_S*0.0+0.0*dps_VGP_S+pInst->alpha*0.0)*1.6666666666666667e-01+((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))*0.0+(0.0)*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VGP_S_VS_BS=(+(+0.0*pInst->dps+alpha_VGP_S*0.0+0.0*dps_VGP_S+pInst->alpha*0.0)*1.6666666666666667e-01+((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))*0.0+(0.0)*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VGP_S_VGP_S=(+(+alpha_VGP_S_VGP_S*pInst->dps+alpha_VGP_S*dps_VGP_S+alpha_VGP_S*dps_VGP_S+pInst->alpha*dps_VGP_S_VGP_S)*1.6666666666666667e-01+((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))*0.0+(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S)))*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VGP_S_VD_S=(+(+alpha_VGP_S_VD_S*pInst->dps+alpha_VGP_S*dps_VD_S+alpha_VD_S*dps_VGP_S+pInst->alpha*dps_VGP_S_VD_S)*1.6666666666666667e-01+((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))*0.0+(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S)))*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VGP_S_VS_BP=(+(+alpha_VGP_S_VS_BP*pInst->dps+alpha_VGP_S*dps_VS_BP+alpha_VS_BP*dps_VGP_S+pInst->alpha*dps_VGP_S_VS_BP)*1.6666666666666667e-01+((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S))*0.0+(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP)))*0.0+(pInst->alpha*pInst->dps)*0.0);
#endif
temp_VD_S=((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))*1.6666666666666667e-01;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+(+0.0*pInst->dps+alpha_VD_S*0.0+0.0*dps_VD_S+pInst->alpha*0.0)*1.6666666666666667e-01+((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))*0.0+(0.0)*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VD_S_VS_BS=(+(+0.0*pInst->dps+alpha_VD_S*0.0+0.0*dps_VD_S+pInst->alpha*0.0)*1.6666666666666667e-01+((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))*0.0+(0.0)*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VD_S_VGP_S=(+(+alpha_VD_S_VGP_S*pInst->dps+alpha_VD_S*dps_VGP_S+alpha_VGP_S*dps_VD_S+pInst->alpha*dps_VD_S_VGP_S)*1.6666666666666667e-01+((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))*0.0+(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S)))*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VD_S_VD_S=(+(+alpha_VD_S_VD_S*pInst->dps+alpha_VD_S*dps_VD_S+alpha_VD_S*dps_VD_S+pInst->alpha*dps_VD_S_VD_S)*1.6666666666666667e-01+((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))*0.0+(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S)))*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VD_S_VS_BP=(+(+alpha_VD_S_VS_BP*pInst->dps+alpha_VD_S*dps_VS_BP+alpha_VS_BP*dps_VD_S+pInst->alpha*dps_VD_S_VS_BP)*1.6666666666666667e-01+((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S))*0.0+(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP)))*0.0+(pInst->alpha*pInst->dps)*0.0);
#endif
temp_VS_BP=((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))*1.6666666666666667e-01;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+(+0.0*pInst->dps+alpha_VS_BP*0.0+0.0*dps_VS_BP+pInst->alpha*0.0)*1.6666666666666667e-01+((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))*0.0+(0.0)*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VS_BP_VS_BS=(+(+0.0*pInst->dps+alpha_VS_BP*0.0+0.0*dps_VS_BP+pInst->alpha*0.0)*1.6666666666666667e-01+((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))*0.0+(0.0)*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VS_BP_VGP_S=(+(+alpha_VS_BP_VGP_S*pInst->dps+alpha_VS_BP*dps_VGP_S+alpha_VGP_S*dps_VS_BP+pInst->alpha*dps_VS_BP_VGP_S)*1.6666666666666667e-01+((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))*0.0+(((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S)))*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VS_BP_VD_S=(+(+alpha_VS_BP_VD_S*pInst->dps+alpha_VS_BP*dps_VD_S+alpha_VD_S*dps_VS_BP+pInst->alpha*dps_VS_BP_VD_S)*1.6666666666666667e-01+((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))*0.0+(((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S)))*0.0+(pInst->alpha*pInst->dps)*0.0);
  temp_VS_BP_VS_BP=(+(+alpha_VS_BP_VS_BP*pInst->dps+alpha_VS_BP*dps_VS_BP+alpha_VS_BP*dps_VS_BP+pInst->alpha*dps_VS_BP_VS_BP)*1.6666666666666667e-01+((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP))*0.0+(((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP)))*0.0+(pInst->alpha*pInst->dps)*0.0);
#endif
#endif
temp=((pInst->alpha*pInst->dps)*1.6666666666666667e-01);
EXIT_IF_ISNAN(((pInst->alpha*pInst->dps)*1.6666666666666667e-01))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(BP,GND)V(GP,GND)V(D,GND) */
QI_VGP_S=(((GdL_VGP_S*(pInst->qim+(temp*Fj)))+(GdL*(qim_VGP_S+((temp_VGP_S*Fj)+(temp*Fj_VGP_S)))))+QCLM_VGP_S);
#if defined(_DERIVATE2)
  QI_VGP_S_VGP_S=(+(+GdL_VGP_S_VGP_S*(pInst->qim+(temp*Fj))+GdL_VGP_S*(qim_VGP_S+(((temp_VGP_S*Fj)+(temp*Fj_VGP_S))))+GdL_VGP_S*(qim_VGP_S+((temp_VGP_S*Fj)+(temp*Fj_VGP_S)))+GdL*(+qim_VGP_S_VGP_S+(+temp_VGP_S_VGP_S*Fj+temp_VGP_S*Fj_VGP_S+temp_VGP_S*Fj_VGP_S+temp*Fj_VGP_S_VGP_S)))+QCLM_VGP_S_VGP_S);
  QI_VGP_S_VD_S=(+(+GdL_VGP_S_VD_S*(pInst->qim+(temp*Fj))+GdL_VGP_S*(qim_VD_S+(((temp_VD_S*Fj)+(temp*Fj_VD_S))))+GdL_VD_S*(qim_VGP_S+((temp_VGP_S*Fj)+(temp*Fj_VGP_S)))+GdL*(+qim_VGP_S_VD_S+(+temp_VGP_S_VD_S*Fj+temp_VGP_S*Fj_VD_S+temp_VD_S*Fj_VGP_S+temp*Fj_VGP_S_VD_S)))+QCLM_VGP_S_VD_S);
  QI_VGP_S_VS_BP=(+(+GdL_VGP_S_VS_BP*(pInst->qim+(temp*Fj))+GdL_VGP_S*(qim_VS_BP+(((temp_VS_BP*Fj)+(temp*Fj_VS_BP))))+GdL_VS_BP*(qim_VGP_S+((temp_VGP_S*Fj)+(temp*Fj_VGP_S)))+GdL*(+qim_VGP_S_VS_BP+(+temp_VGP_S_VS_BP*Fj+temp_VGP_S*Fj_VS_BP+temp_VS_BP*Fj_VGP_S+temp*Fj_VGP_S_VS_BP)))+QCLM_VGP_S_VS_BP);
#endif
QI_VD_S=(((GdL_VD_S*(pInst->qim+(temp*Fj)))+(GdL*(qim_VD_S+((temp_VD_S*Fj)+(temp*Fj_VD_S)))))+QCLM_VD_S);
#if defined(_DERIVATE2)
  QI_VD_S_VGP_S=(+(+GdL_VD_S_VGP_S*(pInst->qim+(temp*Fj))+GdL_VD_S*(qim_VGP_S+(((temp_VGP_S*Fj)+(temp*Fj_VGP_S))))+GdL_VGP_S*(qim_VD_S+((temp_VD_S*Fj)+(temp*Fj_VD_S)))+GdL*(+qim_VD_S_VGP_S+(+temp_VD_S_VGP_S*Fj+temp_VD_S*Fj_VGP_S+temp_VGP_S*Fj_VD_S+temp*Fj_VD_S_VGP_S)))+QCLM_VD_S_VGP_S);
  QI_VD_S_VD_S=(+(+GdL_VD_S_VD_S*(pInst->qim+(temp*Fj))+GdL_VD_S*(qim_VD_S+(((temp_VD_S*Fj)+(temp*Fj_VD_S))))+GdL_VD_S*(qim_VD_S+((temp_VD_S*Fj)+(temp*Fj_VD_S)))+GdL*(+qim_VD_S_VD_S+(+temp_VD_S_VD_S*Fj+temp_VD_S*Fj_VD_S+temp_VD_S*Fj_VD_S+temp*Fj_VD_S_VD_S)))+QCLM_VD_S_VD_S);
  QI_VD_S_VS_BP=(+(+GdL_VD_S_VS_BP*(pInst->qim+(temp*Fj))+GdL_VD_S*(qim_VS_BP+(((temp_VS_BP*Fj)+(temp*Fj_VS_BP))))+GdL_VS_BP*(qim_VD_S+((temp_VD_S*Fj)+(temp*Fj_VD_S)))+GdL*(+qim_VD_S_VS_BP+(+temp_VD_S_VS_BP*Fj+temp_VD_S*Fj_VS_BP+temp_VS_BP*Fj_VD_S+temp*Fj_VD_S_VS_BP)))+QCLM_VD_S_VS_BP);
#endif
QI_VS_BP=(((GdL_VS_BP*(pInst->qim+(temp*Fj)))+(GdL*(qim_VS_BP+((temp_VS_BP*Fj)+(temp*Fj_VS_BP)))))+QCLM_VS_BP);
#if defined(_DERIVATE2)
  QI_VS_BP_VGP_S=(+(+GdL_VS_BP_VGP_S*(pInst->qim+(temp*Fj))+GdL_VS_BP*(qim_VGP_S+(((temp_VGP_S*Fj)+(temp*Fj_VGP_S))))+GdL_VGP_S*(qim_VS_BP+((temp_VS_BP*Fj)+(temp*Fj_VS_BP)))+GdL*(+qim_VS_BP_VGP_S+(+temp_VS_BP_VGP_S*Fj+temp_VS_BP*Fj_VGP_S+temp_VGP_S*Fj_VS_BP+temp*Fj_VS_BP_VGP_S)))+QCLM_VS_BP_VGP_S);
  QI_VS_BP_VD_S=(+(+GdL_VS_BP_VD_S*(pInst->qim+(temp*Fj))+GdL_VS_BP*(qim_VD_S+(((temp_VD_S*Fj)+(temp*Fj_VD_S))))+GdL_VD_S*(qim_VS_BP+((temp_VS_BP*Fj)+(temp*Fj_VS_BP)))+GdL*(+qim_VS_BP_VD_S+(+temp_VS_BP_VD_S*Fj+temp_VS_BP*Fj_VD_S+temp_VD_S*Fj_VS_BP+temp*Fj_VS_BP_VD_S)))+QCLM_VS_BP_VD_S);
  QI_VS_BP_VS_BP=(+(+GdL_VS_BP_VS_BP*(pInst->qim+(temp*Fj))+GdL_VS_BP*(qim_VS_BP+(((temp_VS_BP*Fj)+(temp*Fj_VS_BP))))+GdL_VS_BP*(qim_VS_BP+((temp_VS_BP*Fj)+(temp*Fj_VS_BP)))+GdL*(+qim_VS_BP_VS_BP+(+temp_VS_BP_VS_BP*Fj+temp_VS_BP*Fj_VS_BP+temp_VS_BP*Fj_VS_BP+temp*Fj_VS_BP_VS_BP)))+QCLM_VS_BP_VS_BP);
#endif
#endif
QI=((GdL*(pInst->qim+(temp*Fj)))+QCLM);
EXIT_IF_ISNAN(((GdL*(pInst->qim+(temp*Fj)))+QCLM))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND)V(S,GND) */
QD_VGP_S=(0.5*(((((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VGP_S-((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-(0.2*Fj2_VGP_S)))))))+((QCLM_VGP_S*(1.0+GdL))+(QCLM*GdL_VGP_S))));
#if defined(_DERIVATE2)
  QD_VGP_S_VGP_S=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VGP_S-(((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-((0.2*Fj2_VGP_S))))))))))+(((QCLM_VGP_S*(1.0+GdL))+(QCLM*GdL_VGP_S))))+0.0*(((((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VGP_S-((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-(0.2*Fj2_VGP_S)))))))+((QCLM_VGP_S*(1.0+GdL))+(QCLM*GdL_VGP_S)))+0.5*(+(+(+GdL_VGP_S_VGP_S*GdL+GdL_VGP_S*GdL_VGP_S+GdL_VGP_S*GdL_VGP_S+GdL*GdL_VGP_S_VGP_S)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S))*(qim_VGP_S-(((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-((0.2*Fj2_VGP_S)))))))+(((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S)))*(qim_VGP_S-((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-(0.2*Fj2_VGP_S)))))+(GdL*GdL)*(+qim_VGP_S_VGP_S-(+temp_VGP_S_VGP_S*((1.0-Fj)-(0.2*Fj2))+temp_VGP_S*((-Fj_VGP_S)-((0.2*Fj2_VGP_S)))+temp_VGP_S*((-Fj_VGP_S)-(0.2*Fj2_VGP_S))+temp*(+(+0.0-Fj_VGP_S_VGP_S)-(+0.0*Fj2+0.0*Fj2_VGP_S+0.0*Fj2_VGP_S+0.2*Fj2_VGP_S_VGP_S)))))+(+QCLM_VGP_S_VGP_S*(1.0+GdL)+QCLM_VGP_S*GdL_VGP_S+QCLM_VGP_S*GdL_VGP_S+QCLM*(+0.0+GdL_VGP_S_VGP_S))));
  QD_VGP_S_VD_S=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VD_S*GdL)+(GdL*GdL_VD_S)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VD_S-(((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-((0.2*Fj2_VD_S))))))))))+(((QCLM_VD_S*(1.0+GdL))+(QCLM*GdL_VD_S))))+0.0*(((((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VGP_S-((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-(0.2*Fj2_VGP_S)))))))+((QCLM_VGP_S*(1.0+GdL))+(QCLM*GdL_VGP_S)))+0.5*(+(+(+GdL_VGP_S_VD_S*GdL+GdL_VGP_S*GdL_VD_S+GdL_VD_S*GdL_VGP_S+GdL*GdL_VGP_S_VD_S)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S))*(qim_VD_S-(((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-((0.2*Fj2_VD_S)))))))+(((GdL_VD_S*GdL)+(GdL*GdL_VD_S)))*(qim_VGP_S-((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-(0.2*Fj2_VGP_S)))))+(GdL*GdL)*(+qim_VGP_S_VD_S-(+temp_VGP_S_VD_S*((1.0-Fj)-(0.2*Fj2))+temp_VGP_S*((-Fj_VD_S)-((0.2*Fj2_VD_S)))+temp_VD_S*((-Fj_VGP_S)-(0.2*Fj2_VGP_S))+temp*(+(+0.0-Fj_VGP_S_VD_S)-(+0.0*Fj2+0.0*Fj2_VD_S+0.0*Fj2_VGP_S+0.2*Fj2_VGP_S_VD_S)))))+(+QCLM_VGP_S_VD_S*(1.0+GdL)+QCLM_VGP_S*GdL_VD_S+QCLM_VD_S*GdL_VGP_S+QCLM*(+0.0+GdL_VGP_S_VD_S))));
  QD_VGP_S_VS_BP=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VS_BP-(((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-((0.2*Fj2_VS_BP))))))))))+(((QCLM_VS_BP*(1.0+GdL))+(QCLM*GdL_VS_BP))))+0.0*(((((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VGP_S-((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-(0.2*Fj2_VGP_S)))))))+((QCLM_VGP_S*(1.0+GdL))+(QCLM*GdL_VGP_S)))+0.5*(+(+(+GdL_VGP_S_VS_BP*GdL+GdL_VGP_S*GdL_VS_BP+GdL_VS_BP*GdL_VGP_S+GdL*GdL_VGP_S_VS_BP)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S))*(qim_VS_BP-(((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-((0.2*Fj2_VS_BP)))))))+(((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP)))*(qim_VGP_S-((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-(0.2*Fj2_VGP_S)))))+(GdL*GdL)*(+qim_VGP_S_VS_BP-(+temp_VGP_S_VS_BP*((1.0-Fj)-(0.2*Fj2))+temp_VGP_S*((-Fj_VS_BP)-((0.2*Fj2_VS_BP)))+temp_VS_BP*((-Fj_VGP_S)-(0.2*Fj2_VGP_S))+temp*(+(+0.0-Fj_VGP_S_VS_BP)-(+0.0*Fj2+0.0*Fj2_VS_BP+0.0*Fj2_VGP_S+0.2*Fj2_VGP_S_VS_BP)))))+(+QCLM_VGP_S_VS_BP*(1.0+GdL)+QCLM_VGP_S*GdL_VS_BP+QCLM_VS_BP*GdL_VGP_S+QCLM*(+0.0+GdL_VGP_S_VS_BP))));
#endif
QD_VD_S=(0.5*(((((GdL_VD_S*GdL)+(GdL*GdL_VD_S))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VD_S-((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-(0.2*Fj2_VD_S)))))))+((QCLM_VD_S*(1.0+GdL))+(QCLM*GdL_VD_S))));
#if defined(_DERIVATE2)
  QD_VD_S_VGP_S=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VGP_S-(((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-((0.2*Fj2_VGP_S))))))))))+(((QCLM_VGP_S*(1.0+GdL))+(QCLM*GdL_VGP_S))))+0.0*(((((GdL_VD_S*GdL)+(GdL*GdL_VD_S))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VD_S-((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-(0.2*Fj2_VD_S)))))))+((QCLM_VD_S*(1.0+GdL))+(QCLM*GdL_VD_S)))+0.5*(+(+(+GdL_VD_S_VGP_S*GdL+GdL_VD_S*GdL_VGP_S+GdL_VGP_S*GdL_VD_S+GdL*GdL_VD_S_VGP_S)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VD_S*GdL)+(GdL*GdL_VD_S))*(qim_VGP_S-(((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-((0.2*Fj2_VGP_S)))))))+(((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S)))*(qim_VD_S-((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-(0.2*Fj2_VD_S)))))+(GdL*GdL)*(+qim_VD_S_VGP_S-(+temp_VD_S_VGP_S*((1.0-Fj)-(0.2*Fj2))+temp_VD_S*((-Fj_VGP_S)-((0.2*Fj2_VGP_S)))+temp_VGP_S*((-Fj_VD_S)-(0.2*Fj2_VD_S))+temp*(+(+0.0-Fj_VD_S_VGP_S)-(+0.0*Fj2+0.0*Fj2_VGP_S+0.0*Fj2_VD_S+0.2*Fj2_VD_S_VGP_S)))))+(+QCLM_VD_S_VGP_S*(1.0+GdL)+QCLM_VD_S*GdL_VGP_S+QCLM_VGP_S*GdL_VD_S+QCLM*(+0.0+GdL_VD_S_VGP_S))));
  QD_VD_S_VD_S=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VD_S*GdL)+(GdL*GdL_VD_S)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VD_S-(((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-((0.2*Fj2_VD_S))))))))))+(((QCLM_VD_S*(1.0+GdL))+(QCLM*GdL_VD_S))))+0.0*(((((GdL_VD_S*GdL)+(GdL*GdL_VD_S))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VD_S-((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-(0.2*Fj2_VD_S)))))))+((QCLM_VD_S*(1.0+GdL))+(QCLM*GdL_VD_S)))+0.5*(+(+(+GdL_VD_S_VD_S*GdL+GdL_VD_S*GdL_VD_S+GdL_VD_S*GdL_VD_S+GdL*GdL_VD_S_VD_S)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VD_S*GdL)+(GdL*GdL_VD_S))*(qim_VD_S-(((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-((0.2*Fj2_VD_S)))))))+(((GdL_VD_S*GdL)+(GdL*GdL_VD_S)))*(qim_VD_S-((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-(0.2*Fj2_VD_S)))))+(GdL*GdL)*(+qim_VD_S_VD_S-(+temp_VD_S_VD_S*((1.0-Fj)-(0.2*Fj2))+temp_VD_S*((-Fj_VD_S)-((0.2*Fj2_VD_S)))+temp_VD_S*((-Fj_VD_S)-(0.2*Fj2_VD_S))+temp*(+(+0.0-Fj_VD_S_VD_S)-(+0.0*Fj2+0.0*Fj2_VD_S+0.0*Fj2_VD_S+0.2*Fj2_VD_S_VD_S)))))+(+QCLM_VD_S_VD_S*(1.0+GdL)+QCLM_VD_S*GdL_VD_S+QCLM_VD_S*GdL_VD_S+QCLM*(+0.0+GdL_VD_S_VD_S))));
  QD_VD_S_VS_BP=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VS_BP-(((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-((0.2*Fj2_VS_BP))))))))))+(((QCLM_VS_BP*(1.0+GdL))+(QCLM*GdL_VS_BP))))+0.0*(((((GdL_VD_S*GdL)+(GdL*GdL_VD_S))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VD_S-((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-(0.2*Fj2_VD_S)))))))+((QCLM_VD_S*(1.0+GdL))+(QCLM*GdL_VD_S)))+0.5*(+(+(+GdL_VD_S_VS_BP*GdL+GdL_VD_S*GdL_VS_BP+GdL_VS_BP*GdL_VD_S+GdL*GdL_VD_S_VS_BP)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VD_S*GdL)+(GdL*GdL_VD_S))*(qim_VS_BP-(((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-((0.2*Fj2_VS_BP)))))))+(((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP)))*(qim_VD_S-((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-(0.2*Fj2_VD_S)))))+(GdL*GdL)*(+qim_VD_S_VS_BP-(+temp_VD_S_VS_BP*((1.0-Fj)-(0.2*Fj2))+temp_VD_S*((-Fj_VS_BP)-((0.2*Fj2_VS_BP)))+temp_VS_BP*((-Fj_VD_S)-(0.2*Fj2_VD_S))+temp*(+(+0.0-Fj_VD_S_VS_BP)-(+0.0*Fj2+0.0*Fj2_VS_BP+0.0*Fj2_VD_S+0.2*Fj2_VD_S_VS_BP)))))+(+QCLM_VD_S_VS_BP*(1.0+GdL)+QCLM_VD_S*GdL_VS_BP+QCLM_VS_BP*GdL_VD_S+QCLM*(+0.0+GdL_VD_S_VS_BP))));
#endif
QD_VS_BP=(0.5*(((((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VS_BP-((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-(0.2*Fj2_VS_BP)))))))+((QCLM_VS_BP*(1.0+GdL))+(QCLM*GdL_VS_BP))));
#if defined(_DERIVATE2)
  QD_VS_BP_VGP_S=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VGP_S-(((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-((0.2*Fj2_VGP_S))))))))))+(((QCLM_VGP_S*(1.0+GdL))+(QCLM*GdL_VGP_S))))+0.0*(((((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VS_BP-((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-(0.2*Fj2_VS_BP)))))))+((QCLM_VS_BP*(1.0+GdL))+(QCLM*GdL_VS_BP)))+0.5*(+(+(+GdL_VS_BP_VGP_S*GdL+GdL_VS_BP*GdL_VGP_S+GdL_VGP_S*GdL_VS_BP+GdL*GdL_VS_BP_VGP_S)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP))*(qim_VGP_S-(((temp_VGP_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VGP_S)-((0.2*Fj2_VGP_S)))))))+(((GdL_VGP_S*GdL)+(GdL*GdL_VGP_S)))*(qim_VS_BP-((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-(0.2*Fj2_VS_BP)))))+(GdL*GdL)*(+qim_VS_BP_VGP_S-(+temp_VS_BP_VGP_S*((1.0-Fj)-(0.2*Fj2))+temp_VS_BP*((-Fj_VGP_S)-((0.2*Fj2_VGP_S)))+temp_VGP_S*((-Fj_VS_BP)-(0.2*Fj2_VS_BP))+temp*(+(+0.0-Fj_VS_BP_VGP_S)-(+0.0*Fj2+0.0*Fj2_VGP_S+0.0*Fj2_VS_BP+0.2*Fj2_VS_BP_VGP_S)))))+(+QCLM_VS_BP_VGP_S*(1.0+GdL)+QCLM_VS_BP*GdL_VGP_S+QCLM_VGP_S*GdL_VS_BP+QCLM*(+0.0+GdL_VS_BP_VGP_S))));
  QD_VS_BP_VD_S=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VD_S*GdL)+(GdL*GdL_VD_S)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VD_S-(((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-((0.2*Fj2_VD_S))))))))))+(((QCLM_VD_S*(1.0+GdL))+(QCLM*GdL_VD_S))))+0.0*(((((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VS_BP-((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-(0.2*Fj2_VS_BP)))))))+((QCLM_VS_BP*(1.0+GdL))+(QCLM*GdL_VS_BP)))+0.5*(+(+(+GdL_VS_BP_VD_S*GdL+GdL_VS_BP*GdL_VD_S+GdL_VD_S*GdL_VS_BP+GdL*GdL_VS_BP_VD_S)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP))*(qim_VD_S-(((temp_VD_S*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VD_S)-((0.2*Fj2_VD_S)))))))+(((GdL_VD_S*GdL)+(GdL*GdL_VD_S)))*(qim_VS_BP-((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-(0.2*Fj2_VS_BP)))))+(GdL*GdL)*(+qim_VS_BP_VD_S-(+temp_VS_BP_VD_S*((1.0-Fj)-(0.2*Fj2))+temp_VS_BP*((-Fj_VD_S)-((0.2*Fj2_VD_S)))+temp_VD_S*((-Fj_VS_BP)-(0.2*Fj2_VS_BP))+temp*(+(+0.0-Fj_VS_BP_VD_S)-(+0.0*Fj2+0.0*Fj2_VD_S+0.0*Fj2_VS_BP+0.2*Fj2_VS_BP_VD_S)))))+(+QCLM_VS_BP_VD_S*(1.0+GdL)+QCLM_VS_BP*GdL_VD_S+QCLM_VD_S*GdL_VS_BP+QCLM*(+0.0+GdL_VS_BP_VD_S))));
  QD_VS_BP_VS_BP=(+0.0*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))+0.0*(((((((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP)))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VS_BP-(((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-((0.2*Fj2_VS_BP))))))))))+(((QCLM_VS_BP*(1.0+GdL))+(QCLM*GdL_VS_BP))))+0.0*(((((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP))*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+((GdL*GdL)*(qim_VS_BP-((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-(0.2*Fj2_VS_BP)))))))+((QCLM_VS_BP*(1.0+GdL))+(QCLM*GdL_VS_BP)))+0.5*(+(+(+GdL_VS_BP_VS_BP*GdL+GdL_VS_BP*GdL_VS_BP+GdL_VS_BP*GdL_VS_BP+GdL*GdL_VS_BP_VS_BP)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2))))+((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP))*(qim_VS_BP-(((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-((0.2*Fj2_VS_BP)))))))+(((GdL_VS_BP*GdL)+(GdL*GdL_VS_BP)))*(qim_VS_BP-((temp_VS_BP*((1.0-Fj)-(0.2*Fj2)))+(temp*((-Fj_VS_BP)-(0.2*Fj2_VS_BP)))))+(GdL*GdL)*(+qim_VS_BP_VS_BP-(+temp_VS_BP_VS_BP*((1.0-Fj)-(0.2*Fj2))+temp_VS_BP*((-Fj_VS_BP)-((0.2*Fj2_VS_BP)))+temp_VS_BP*((-Fj_VS_BP)-(0.2*Fj2_VS_BP))+temp*(+(+0.0-Fj_VS_BP_VS_BP)-(+0.0*Fj2+0.0*Fj2_VS_BP+0.0*Fj2_VS_BP+0.2*Fj2_VS_BP_VS_BP)))))+(+QCLM_VS_BP_VS_BP*(1.0+GdL)+QCLM_VS_BP*GdL_VS_BP+QCLM_VS_BP*GdL_VS_BP+QCLM*(+0.0+GdL_VS_BP_VS_BP))));
#endif
#endif
QD=(0.5*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL))));
EXIT_IF_ISNAN((0.5*(((GdL*GdL)*(pInst->qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL)))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(D,GND)V(GP,GND)V(BP,GND) */
QB_VD_S=(QG_VD_S-QI_VD_S);
#if defined(_DERIVATE2)
  QB_VD_S_VD_S=(+QG_VD_S_VD_S-QI_VD_S_VD_S);
  QB_VD_S_VGP_S=(+QG_VD_S_VGP_S-QI_VD_S_VGP_S);
  QB_VD_S_VS_BP=(+QG_VD_S_VS_BP-QI_VD_S_VS_BP);
#endif
QB_VGP_S=(QG_VGP_S-QI_VGP_S);
#if defined(_DERIVATE2)
  QB_VGP_S_VD_S=(+QG_VGP_S_VD_S-QI_VGP_S_VD_S);
  QB_VGP_S_VGP_S=(+QG_VGP_S_VGP_S-QI_VGP_S_VGP_S);
  QB_VGP_S_VS_BP=(+QG_VGP_S_VS_BP-QI_VGP_S_VS_BP);
#endif
QB_VS_BP=(QG_VS_BP-QI_VS_BP);
#if defined(_DERIVATE2)
  QB_VS_BP_VD_S=(+QG_VS_BP_VD_S-QI_VS_BP_VD_S);
  QB_VS_BP_VGP_S=(+QG_VS_BP_VGP_S-QI_VS_BP_VGP_S);
  QB_VS_BP_VS_BP=(+QG_VS_BP_VS_BP-QI_VS_BP_VS_BP);
#endif
#endif
QB=(QG-QI);
EXIT_IF_ISNAN((QG-QI))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(BP,GND)V(GP,GND)V(D,GND) */
Qg_VD_S=((QG_VD_S*pInst->COX_qm)+(QG*COX_qm_VD_S));
#if defined(_DERIVATE2)
  Qg_VD_S_VD_S=(+QG_VD_S_VD_S*pInst->COX_qm+QG_VD_S*COX_qm_VD_S+QG_VD_S*COX_qm_VD_S+QG*COX_qm_VD_S_VD_S);
  Qg_VD_S_VGP_S=(+QG_VD_S_VGP_S*pInst->COX_qm+QG_VD_S*COX_qm_VGP_S+QG_VGP_S*COX_qm_VD_S+QG*COX_qm_VD_S_VGP_S);
  Qg_VD_S_VS_BP=(+QG_VD_S_VS_BP*pInst->COX_qm+QG_VD_S*COX_qm_VS_BP+QG_VS_BP*COX_qm_VD_S+QG*COX_qm_VD_S_VS_BP);
#endif
Qg_VGP_S=((QG_VGP_S*pInst->COX_qm)+(QG*COX_qm_VGP_S));
#if defined(_DERIVATE2)
  Qg_VGP_S_VD_S=(+QG_VGP_S_VD_S*pInst->COX_qm+QG_VGP_S*COX_qm_VD_S+QG_VD_S*COX_qm_VGP_S+QG*COX_qm_VGP_S_VD_S);
  Qg_VGP_S_VGP_S=(+QG_VGP_S_VGP_S*pInst->COX_qm+QG_VGP_S*COX_qm_VGP_S+QG_VGP_S*COX_qm_VGP_S+QG*COX_qm_VGP_S_VGP_S);
  Qg_VGP_S_VS_BP=(+QG_VGP_S_VS_BP*pInst->COX_qm+QG_VGP_S*COX_qm_VS_BP+QG_VS_BP*COX_qm_VGP_S+QG*COX_qm_VGP_S_VS_BP);
#endif
Qg_VS_BP=((QG_VS_BP*pInst->COX_qm)+(QG*COX_qm_VS_BP));
#if defined(_DERIVATE2)
  Qg_VS_BP_VD_S=(+QG_VS_BP_VD_S*pInst->COX_qm+QG_VS_BP*COX_qm_VD_S+QG_VD_S*COX_qm_VS_BP+QG*COX_qm_VS_BP_VD_S);
  Qg_VS_BP_VGP_S=(+QG_VS_BP_VGP_S*pInst->COX_qm+QG_VS_BP*COX_qm_VGP_S+QG_VGP_S*COX_qm_VS_BP+QG*COX_qm_VS_BP_VGP_S);
  Qg_VS_BP_VS_BP=(+QG_VS_BP_VS_BP*pInst->COX_qm+QG_VS_BP*COX_qm_VS_BP+QG_VS_BP*COX_qm_VS_BP+QG*COX_qm_VS_BP_VS_BP);
#endif
#endif
Qg=(QG*pInst->COX_qm);
EXIT_IF_ISNAN((QG*pInst->COX_qm))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
Qd_VGP_S=(((-QD_VGP_S)*pInst->COX_qm)+((-QD)*COX_qm_VGP_S));
#if defined(_DERIVATE2)
  Qd_VGP_S_VGP_S=(+0.0*pInst->COX_qm+(-QD_VGP_S)*COX_qm_VGP_S+(-QD_VGP_S)*COX_qm_VGP_S+(-QD)*COX_qm_VGP_S_VGP_S);
  Qd_VGP_S_VD_S=(+0.0*pInst->COX_qm+(-QD_VGP_S)*COX_qm_VD_S+(-QD_VD_S)*COX_qm_VGP_S+(-QD)*COX_qm_VGP_S_VD_S);
  Qd_VGP_S_VS_BP=(+0.0*pInst->COX_qm+(-QD_VGP_S)*COX_qm_VS_BP+(-QD_VS_BP)*COX_qm_VGP_S+(-QD)*COX_qm_VGP_S_VS_BP);
#endif
Qd_VD_S=(((-QD_VD_S)*pInst->COX_qm)+((-QD)*COX_qm_VD_S));
#if defined(_DERIVATE2)
  Qd_VD_S_VGP_S=(+0.0*pInst->COX_qm+(-QD_VD_S)*COX_qm_VGP_S+(-QD_VGP_S)*COX_qm_VD_S+(-QD)*COX_qm_VD_S_VGP_S);
  Qd_VD_S_VD_S=(+0.0*pInst->COX_qm+(-QD_VD_S)*COX_qm_VD_S+(-QD_VD_S)*COX_qm_VD_S+(-QD)*COX_qm_VD_S_VD_S);
  Qd_VD_S_VS_BP=(+0.0*pInst->COX_qm+(-QD_VD_S)*COX_qm_VS_BP+(-QD_VS_BP)*COX_qm_VD_S+(-QD)*COX_qm_VD_S_VS_BP);
#endif
Qd_VS_BP=(((-QD_VS_BP)*pInst->COX_qm)+((-QD)*COX_qm_VS_BP));
#if defined(_DERIVATE2)
  Qd_VS_BP_VGP_S=(+0.0*pInst->COX_qm+(-QD_VS_BP)*COX_qm_VGP_S+(-QD_VGP_S)*COX_qm_VS_BP+(-QD)*COX_qm_VS_BP_VGP_S);
  Qd_VS_BP_VD_S=(+0.0*pInst->COX_qm+(-QD_VS_BP)*COX_qm_VD_S+(-QD_VD_S)*COX_qm_VS_BP+(-QD)*COX_qm_VS_BP_VD_S);
  Qd_VS_BP_VS_BP=(+0.0*pInst->COX_qm+(-QD_VS_BP)*COX_qm_VS_BP+(-QD_VS_BP)*COX_qm_VS_BP+(-QD)*COX_qm_VS_BP_VS_BP);
#endif
#endif
Qd=((-QD)*pInst->COX_qm);
EXIT_IF_ISNAN(((-QD)*pInst->COX_qm))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(BP,GND)V(GP,GND)V(D,GND) */
Qb_VD_S=(((-QB_VD_S)*pInst->COX_qm)+((-QB)*COX_qm_VD_S));
#if defined(_DERIVATE2)
  Qb_VD_S_VD_S=(+0.0*pInst->COX_qm+(-QB_VD_S)*COX_qm_VD_S+(-QB_VD_S)*COX_qm_VD_S+(-QB)*COX_qm_VD_S_VD_S);
  Qb_VD_S_VGP_S=(+0.0*pInst->COX_qm+(-QB_VD_S)*COX_qm_VGP_S+(-QB_VGP_S)*COX_qm_VD_S+(-QB)*COX_qm_VD_S_VGP_S);
  Qb_VD_S_VS_BP=(+0.0*pInst->COX_qm+(-QB_VD_S)*COX_qm_VS_BP+(-QB_VS_BP)*COX_qm_VD_S+(-QB)*COX_qm_VD_S_VS_BP);
#endif
Qb_VGP_S=(((-QB_VGP_S)*pInst->COX_qm)+((-QB)*COX_qm_VGP_S));
#if defined(_DERIVATE2)
  Qb_VGP_S_VD_S=(+0.0*pInst->COX_qm+(-QB_VGP_S)*COX_qm_VD_S+(-QB_VD_S)*COX_qm_VGP_S+(-QB)*COX_qm_VGP_S_VD_S);
  Qb_VGP_S_VGP_S=(+0.0*pInst->COX_qm+(-QB_VGP_S)*COX_qm_VGP_S+(-QB_VGP_S)*COX_qm_VGP_S+(-QB)*COX_qm_VGP_S_VGP_S);
  Qb_VGP_S_VS_BP=(+0.0*pInst->COX_qm+(-QB_VGP_S)*COX_qm_VS_BP+(-QB_VS_BP)*COX_qm_VGP_S+(-QB)*COX_qm_VGP_S_VS_BP);
#endif
Qb_VS_BP=(((-QB_VS_BP)*pInst->COX_qm)+((-QB)*COX_qm_VS_BP));
#if defined(_DERIVATE2)
  Qb_VS_BP_VD_S=(+0.0*pInst->COX_qm+(-QB_VS_BP)*COX_qm_VD_S+(-QB_VD_S)*COX_qm_VS_BP+(-QB)*COX_qm_VS_BP_VD_S);
  Qb_VS_BP_VGP_S=(+0.0*pInst->COX_qm+(-QB_VS_BP)*COX_qm_VGP_S+(-QB_VGP_S)*COX_qm_VS_BP+(-QB)*COX_qm_VS_BP_VGP_S);
  Qb_VS_BP_VS_BP=(+0.0*pInst->COX_qm+(-QB_VS_BP)*COX_qm_VS_BP+(-QB_VS_BP)*COX_qm_VS_BP+(-QB)*COX_qm_VS_BP_VS_BP);
#endif
#endif
Qb=((-QB)*pInst->COX_qm);
EXIT_IF_ISNAN(((-QB)*pInst->COX_qm))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND) */
Qgs_ov_VGP_S=(pInst->CGOV_i*Vovs_VGP_S);
#if defined(_DERIVATE2)
  Qgs_ov_VGP_S_VGP_S=(+0.0*Vovs+0.0*Vovs_VGP_S+0.0*Vovs_VGP_S+pInst->CGOV_i*Vovs_VGP_S_VGP_S);
  Qgs_ov_VGP_S_VD_S=(+0.0*Vovs+0.0*Vovs_VD_S+0.0*Vovs_VGP_S+pInst->CGOV_i*Vovs_VGP_S_VD_S);
  Qgs_ov_VGP_S_VS_BP=(+0.0*Vovs+0.0*Vovs_VS_BP+0.0*Vovs_VGP_S+pInst->CGOV_i*Vovs_VGP_S_VS_BP);
#endif
#if defined(_DERIVATE)
Qgs_ov_VD_S=(pInst->CGOV_i*Vovs_VD_S);
#endif
#if defined(_DERIVATE)
Qgs_ov_VS_BP=(pInst->CGOV_i*Vovs_VS_BP);
#endif
#endif
Qgs_ov=(pInst->CGOV_i*Vovs);
EXIT_IF_ISNAN((pInst->CGOV_i*Vovs))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(GP,GND) */
Qgd_ov_VGP_S=(pInst->CGOVD_i*Vovd_VGP_S);
#if defined(_DERIVATE2)
  Qgd_ov_VGP_S_VGP_S=(+0.0*Vovd+0.0*Vovd_VGP_S+0.0*Vovd_VGP_S+pInst->CGOVD_i*Vovd_VGP_S_VGP_S);
  Qgd_ov_VGP_S_VD_S=(+0.0*Vovd+0.0*Vovd_VD_S+0.0*Vovd_VGP_S+pInst->CGOVD_i*Vovd_VGP_S_VD_S);
  Qgd_ov_VGP_S_VS_BP=(+0.0*Vovd+0.0*Vovd_VS_BP+0.0*Vovd_VGP_S+pInst->CGOVD_i*Vovd_VGP_S_VS_BP);
#endif
#if defined(_DERIVATE)
Qgd_ov_VD_S=(pInst->CGOVD_i*Vovd_VD_S);
#endif
#if defined(_DERIVATE)
Qgd_ov_VS_BP=(pInst->CGOVD_i*Vovd_VS_BP);
#endif
#endif
Qgd_ov=(pInst->CGOVD_i*Vovd);
EXIT_IF_ISNAN((pInst->CGOVD_i*Vovd))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Qgb_ov_VD_S=(pInst->CGBOV_i*Vgb_VD_S);
Qgb_ov_VGP_S=(pInst->CGBOV_i*Vgb_VGP_S);
Qgb_ov_VS_BP=(pInst->CGBOV_i*Vgb_VS_BP);
#endif
Qgb_ov=(pInst->CGBOV_i*Vgb);
EXIT_IF_ISNAN((pInst->CGBOV_i*Vgb))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND) */
#if defined(_DERIVATE)
Qfgs_VD_S=0.0;
#endif
#if defined(_DERIVATE)
Qfgs_VS_BP=0.0;
#endif
Qfgs_VGP_S=(pInst->CFR_i*VgsPrime_VGP_S);
#if defined(_DERIVATE2)
  Qfgs_VGP_S_VD_S=(+0.0*VgsPrime+0.0*0.0+0.0*VgsPrime_VGP_S+pInst->CFR_i*0.0);
  Qfgs_VGP_S_VS_BP=(+0.0*VgsPrime+0.0*0.0+0.0*VgsPrime_VGP_S+pInst->CFR_i*0.0);
  Qfgs_VGP_S_VGP_S=(+0.0*VgsPrime+0.0*VgsPrime_VGP_S+0.0*VgsPrime_VGP_S+pInst->CFR_i*VgsPrime_VGP_S_VGP_S);
#endif
#endif
Qfgs=(pInst->CFR_i*VgsPrime);
EXIT_IF_ISNAN((pInst->CFR_i*VgsPrime))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(GP,GND) */
#if defined(_DERIVATE)
Qfgd_VS_BP=0.0;
#endif
Qfgd_VGP_S=(pInst->CFRD_i*VgdPrime_VGP_S);
#if defined(_DERIVATE2)
  Qfgd_VGP_S_VS_BP=(+0.0*VgdPrime+0.0*0.0+0.0*VgdPrime_VGP_S+pInst->CFRD_i*0.0);
  Qfgd_VGP_S_VGP_S=(+0.0*VgdPrime+0.0*VgdPrime_VGP_S+0.0*VgdPrime_VGP_S+pInst->CFRD_i*VgdPrime_VGP_S_VGP_S);
  Qfgd_VGP_S_VD_S=(+0.0*VgdPrime+0.0*VgdPrime_VD_S+0.0*VgdPrime_VGP_S+pInst->CFRD_i*VgdPrime_VGP_S_VD_S);
#endif
#if defined(_DERIVATE)
Qfgd_VD_S=(pInst->CFRD_i*VgdPrime_VD_S);
#endif
#endif
Qfgd=(pInst->CFRD_i*VgdPrime);
EXIT_IF_ISNAN((pInst->CFRD_i*VgdPrime))
#endif
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(GP,GND)V(BP,GND)V(D,GND)V(S,GND)V(BS,GND) */
ijun_s_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijun_s_VD_BD_VD_BD=0.0;
  ijun_s_VD_BD_VS_BS=0.0;
#endif
ijun_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijun_s_VS_BS_VD_BD=0.0;
  ijun_s_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->ijun_s=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijunbot_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunbot_s_VS_BS_VS_BS=0.0;
  ijunbot_s_VS_BS_VD_BD=0.0;
#endif
ijunbot_s_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunbot_s_VD_BD_VS_BS=0.0;
  ijunbot_s_VD_BD_VD_BD=0.0;
#endif
#endif
ijunbot_s=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijunsti_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunsti_s_VS_BS_VS_BS=0.0;
  ijunsti_s_VS_BS_VD_BD=0.0;
#endif
ijunsti_s_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunsti_s_VD_BD_VS_BS=0.0;
  ijunsti_s_VD_BD_VD_BD=0.0;
#endif
#endif
ijunsti_s=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijungat_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijungat_s_VS_BS_VS_BS=0.0;
  ijungat_s_VS_BS_VD_BD=0.0;
#endif
ijungat_s_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijungat_s_VD_BD_VS_BS=0.0;
  ijungat_s_VD_BD_VD_BD=0.0;
#endif
#endif
ijungat_s=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ijun_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijun_d_VD_BD_VD_BD=0.0;
  ijun_d_VD_BD_VS_BS=0.0;
#endif
ijun_d_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijun_d_VS_BS_VD_BD=0.0;
  ijun_d_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->ijun_d=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunbot_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunbot_d_VD_BD_VD_BD=0.0;
  ijunbot_d_VD_BD_VS_BS=0.0;
#endif
ijunbot_d_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunbot_d_VS_BS_VD_BD=0.0;
  ijunbot_d_VS_BS_VS_BS=0.0;
#endif
#endif
ijunbot_d=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunsti_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunsti_d_VD_BD_VD_BD=0.0;
  ijunsti_d_VD_BD_VS_BS=0.0;
#endif
ijunsti_d_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunsti_d_VS_BS_VD_BD=0.0;
  ijunsti_d_VS_BS_VS_BS=0.0;
#endif
#endif
ijunsti_d=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijungat_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijungat_d_VD_BD_VD_BD=0.0;
  ijungat_d_VD_BD_VS_BS=0.0;
#endif
ijungat_d_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijungat_d_VS_BS_VD_BD=0.0;
  ijungat_d_VS_BS_VS_BS=0.0;
#endif
#endif
ijungat_d=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(D,BD)V(S,BS) ddxprobe= */
qjun_s_VD_BD=0.0;
qjun_s_VS_BS=0.0;
#endif
qjun_s=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjunbot_s_VD_BD=0.0;
#endif
qjunbot_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  qjunbot_s_VS_BS_VD_BD=0.0;
  qjunbot_s_VS_BS_VS_BS=0.0;
#endif
#endif
qjunbot_s=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjunsti_s_VD_BD=0.0;
#endif
qjunsti_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  qjunsti_s_VS_BS_VD_BD=0.0;
  qjunsti_s_VS_BS_VS_BS=0.0;
#endif
#endif
qjunsti_s=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjungat_s_VD_BD=0.0;
#endif
qjungat_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  qjungat_s_VS_BS_VD_BD=0.0;
  qjungat_s_VS_BS_VS_BS=0.0;
#endif
#endif
qjungat_s=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(D,BD)V(S,BS) ddxprobe= */
qjun_d_VD_BD=0.0;
qjun_d_VS_BS=0.0;
#endif
qjun_d=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjunbot_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  qjunbot_d_VD_BD_VD_BD=0.0;
  qjunbot_d_VD_BD_VS_BS=0.0;
#endif
#if defined(_DERIVATE)
qjunbot_d_VS_BS=0.0;
#endif
#endif
qjunbot_d=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjunsti_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  qjunsti_d_VD_BD_VD_BD=0.0;
  qjunsti_d_VD_BD_VS_BS=0.0;
#endif
#if defined(_DERIVATE)
qjunsti_d_VS_BS=0.0;
#endif
#endif
qjunsti_d=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjungat_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  qjungat_d_VD_BD_VD_BD=0.0;
  qjungat_d_VD_BD_VS_BS=0.0;
#endif
#if defined(_DERIVATE)
qjungat_d_VS_BS=0.0;
#endif
#endif
qjungat_d=0.0;
EXIT_IF_ISNAN(0.0)
#endif
{
if
((pModel->SWJUNCAP>0.0))
{
if
((pModel->SWJUNEXP_i==1.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tm0_VD_BD=0.0;
#if defined(_DERIVATE2)
  tm0_VD_BD_VD_BD=0.0;
  tm0_VD_BD_VS_BS=0.0;
#endif
tm0_VS_BS=Vjun_s_VS_BS*pModel->phitdinv*pInst->MFOR1_s;
#if defined(_DERIVATE2)
  tm0_VS_BS_VD_BD=(+(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)*pInst->MFOR1_s+Vjun_s_VS_BS*pModel->phitdinv*0.0+(0.0)*0.0+(Vjun_s*pModel->phitdinv)*0.0);
  tm0_VS_BS_VS_BS=(+(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)*pInst->MFOR1_s+Vjun_s_VS_BS*pModel->phitdinv*0.0+(Vjun_s_VS_BS*pModel->phitdinv)*0.0+(Vjun_s*pModel->phitdinv)*0.0);
#endif
#endif
tm0=((Vjun_s*pModel->phitdinv)*pInst->MFOR1_s);
EXIT_IF_ISNAN(((Vjun_s*pModel->phitdinv)*pInst->MFOR1_s))
{
double m00_exp(d00_exp0,tm0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
tm1_VD_BD=0.0;
#if defined(_DERIVATE2)
  tm1_VD_BD_VD_BD=0.0;
  tm1_VD_BD_VS_BS=0.0;
#endif
tm1_VS_BS=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VS_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf1_s)?(pInst->expxhf1_s*tm0_VS_BS):tm0_VS_BS*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VS_BS_VD_BD=fixme;
  tm1_VS_BS_VS_BS=fixme;
#endif
#endif
tm1=((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf1_s)?(pInst->expxhf1_s*((tm0-pInst->xhighf1_s)+1)):d00_exp0));
EXIT_IF_ISNAN(((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf1_s)?(pInst->expxhf1_s*((tm0-pInst->xhighf1_s)+1)):d00_exp0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunfor1_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunfor1_VD_BD_VD_BD=0.0;
  ijunfor1_VD_BD_VS_BS=0.0;
#endif
ijunfor1_VS_BS=(pInst->ISATFOR1_s*tm1_VS_BS);
#if defined(_DERIVATE2)
  ijunfor1_VS_BS_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VS_BS+pInst->ISATFOR1_s*(+tm1_VS_BS_VD_BD-0.0));
  ijunfor1_VS_BS_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VS_BS+pInst->ISATFOR1_s*(+tm1_VS_BS_VS_BS-0.0));
#endif
#endif
ijunfor1=(pInst->ISATFOR1_s*(tm1-1.0));
EXIT_IF_ISNAN((pInst->ISATFOR1_s*(tm1-1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tm0_VD_BD=0.0;
#if defined(_DERIVATE2)
  tm0_VD_BD_VD_BD=0.0;
  tm0_VD_BD_VS_BS=0.0;
#endif
tm0_VS_BS=Vjun_s_VS_BS*pModel->phitdinv*pInst->MFOR2_s;
#if defined(_DERIVATE2)
  tm0_VS_BS_VD_BD=(+(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)*pInst->MFOR2_s+Vjun_s_VS_BS*pModel->phitdinv*0.0+(0.0)*0.0+(Vjun_s*pModel->phitdinv)*0.0);
  tm0_VS_BS_VS_BS=(+(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)*pInst->MFOR2_s+Vjun_s_VS_BS*pModel->phitdinv*0.0+(Vjun_s_VS_BS*pModel->phitdinv)*0.0+(Vjun_s*pModel->phitdinv)*0.0);
#endif
#endif
tm0=((Vjun_s*pModel->phitdinv)*pInst->MFOR2_s);
EXIT_IF_ISNAN(((Vjun_s*pModel->phitdinv)*pInst->MFOR2_s))
{
double m00_exp(d00_exp0,tm0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
tm1_VD_BD=0.0;
#if defined(_DERIVATE2)
  tm1_VD_BD_VD_BD=0.0;
  tm1_VD_BD_VS_BS=0.0;
#endif
tm1_VS_BS=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VS_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf2_s)?(pInst->expxhf2_s*tm0_VS_BS):tm0_VS_BS*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VS_BS_VD_BD=fixme;
  tm1_VS_BS_VS_BS=fixme;
#endif
#endif
tm1=((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf2_s)?(pInst->expxhf2_s*((tm0-pInst->xhighf2_s)+1)):d00_exp0));
EXIT_IF_ISNAN(((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf2_s)?(pInst->expxhf2_s*((tm0-pInst->xhighf2_s)+1)):d00_exp0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunfor2_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunfor2_VD_BD_VD_BD=0.0;
  ijunfor2_VD_BD_VS_BS=0.0;
#endif
ijunfor2_VS_BS=(pInst->ISATFOR2_s*tm1_VS_BS);
#if defined(_DERIVATE2)
  ijunfor2_VS_BS_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VS_BS+pInst->ISATFOR2_s*(+tm1_VS_BS_VD_BD-0.0));
  ijunfor2_VS_BS_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VS_BS+pInst->ISATFOR2_s*(+tm1_VS_BS_VS_BS-0.0));
#endif
#endif
ijunfor2=(pInst->ISATFOR2_s*(tm1-1.0));
EXIT_IF_ISNAN((pInst->ISATFOR2_s*(tm1-1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunrev_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunrev_VD_BD_VD_BD=0.0;
  ijunrev_VD_BD_VS_BS=0.0;
#endif
ijunrev_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunrev_VS_BS_VD_BD=0.0;
  ijunrev_VS_BS_VS_BS=0.0;
#endif
#endif
ijunrev=0.0;
EXIT_IF_ISNAN(0.0)
if
((pInst->m0flag_s>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunrev_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunrev_VD_BD_VD_BD=0.0;
  ijunrev_VD_BD_VS_BS=0.0;
#endif
ijunrev_VS_BS=((Vjun_s_VS_BS*(pInst->ISATREV_s+(Vjun_s*pInst->MREV_s)))+(Vjun_s*Vjun_s_VS_BS*pInst->MREV_s));
#if defined(_DERIVATE2)
  ijunrev_VS_BS_VD_BD=(+0.0*(pInst->ISATREV_s+(Vjun_s*pInst->MREV_s))+Vjun_s_VS_BS*(0.0)+0.0*Vjun_s_VS_BS*pInst->MREV_s+Vjun_s*(+0.0+(+0.0*pInst->MREV_s+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)));
  ijunrev_VS_BS_VS_BS=(+Vjun_s_VS_BS_VS_BS*(pInst->ISATREV_s+(Vjun_s*pInst->MREV_s))+Vjun_s_VS_BS*(Vjun_s_VS_BS*pInst->MREV_s)+Vjun_s_VS_BS*Vjun_s_VS_BS*pInst->MREV_s+Vjun_s*(+0.0+(+Vjun_s_VS_BS_VS_BS*pInst->MREV_s+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)));
#endif
#endif
ijunrev=(Vjun_s*(pInst->ISATREV_s+(Vjun_s*pInst->MREV_s)));
EXIT_IF_ISNAN((Vjun_s*(pInst->ISATREV_s+(Vjun_s*pInst->MREV_s))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tm0_VD_BD=0.0;
#if defined(_DERIVATE2)
  tm0_VD_BD_VD_BD=0.0;
  tm0_VD_BD_VS_BS=0.0;
#endif
tm0_VS_BS=(-Vjun_s_VS_BS)*pModel->phitdinv*pInst->MREV_s;
#if defined(_DERIVATE2)
  tm0_VS_BS_VD_BD=(+(+0.0*pModel->phitdinv+(-Vjun_s_VS_BS)*0.0+0.0*0.0+(-Vjun_s)*0.0)*pInst->MREV_s+(-Vjun_s_VS_BS)*pModel->phitdinv*0.0+(0.0)*0.0+((-Vjun_s)*pModel->phitdinv)*0.0);
  tm0_VS_BS_VS_BS=(+(+0.0*pModel->phitdinv+(-Vjun_s_VS_BS)*0.0+(-Vjun_s_VS_BS)*0.0+(-Vjun_s)*0.0)*pInst->MREV_s+(-Vjun_s_VS_BS)*pModel->phitdinv*0.0+((-Vjun_s_VS_BS)*pModel->phitdinv)*0.0+((-Vjun_s)*pModel->phitdinv)*0.0);
#endif
#endif
tm0=(((-Vjun_s)*pModel->phitdinv)*pInst->MREV_s);
EXIT_IF_ISNAN((((-Vjun_s)*pModel->phitdinv)*pInst->MREV_s))
{
double m00_exp(d00_exp0,tm0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
tm1_VD_BD=0.0;
#if defined(_DERIVATE2)
  tm1_VD_BD_VD_BD=0.0;
  tm1_VD_BD_VS_BS=0.0;
#endif
tm1_VS_BS=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VS_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighr_s)?(pInst->expxhr_s*tm0_VS_BS):tm0_VS_BS*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VS_BS_VD_BD=fixme;
  tm1_VS_BS_VS_BS=fixme;
#endif
#endif
tm1=((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighr_s)?(pInst->expxhr_s*((tm0-pInst->xhighr_s)+1)):d00_exp0));
EXIT_IF_ISNAN(((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighr_s)?(pInst->expxhr_s*((tm0-pInst->xhighr_s)+1)):d00_exp0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunrev_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunrev_VD_BD_VD_BD=0.0;
  ijunrev_VD_BD_VS_BS=0.0;
#endif
ijunrev_VS_BS=((-pInst->ISATREV_s)*tm1_VS_BS);
#if defined(_DERIVATE2)
  ijunrev_VS_BS_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VS_BS+(-pInst->ISATREV_s)*(+tm1_VS_BS_VD_BD-0.0));
  ijunrev_VS_BS_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VS_BS+(-pInst->ISATREV_s)*(+tm1_VS_BS_VS_BS-0.0));
#endif
#endif
ijunrev=((-pInst->ISATREV_s)*(tm1-1.0));
EXIT_IF_ISNAN(((-pInst->ISATREV_s)*(tm1-1.0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(GP,GND)V(BP,GND)V(D,GND)V(S,GND)V(BS,GND) */
ijun_s_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijun_s_VD_BD_VD_BD=0.0;
  ijun_s_VD_BD_VS_BS=0.0;
#endif
ijun_s_VS_BS=((ijunfor1_VS_BS+ijunfor2_VS_BS)+ijunrev_VS_BS);
#if defined(_DERIVATE2)
  ijun_s_VS_BS_VD_BD=(+(+ijunfor1_VS_BS_VD_BD+ijunfor2_VS_BS_VD_BD)+ijunrev_VS_BS_VD_BD);
  ijun_s_VS_BS_VS_BS=(+(+ijunfor1_VS_BS_VS_BS+ijunfor2_VS_BS_VS_BS)+ijunrev_VS_BS_VS_BS);
#endif
#endif
pInst->ijun_s=((ijunfor1+ijunfor2)+ijunrev);
EXIT_IF_ISNAN(((ijunfor1+ijunfor2)+ijunrev))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tm0_VD_BD=Vjun_d_VD_BD*pModel->phitdinv*pInst->MFOR1_d;
#if defined(_DERIVATE2)
  tm0_VD_BD_VD_BD=(+(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)*pInst->MFOR1_d+Vjun_d_VD_BD*pModel->phitdinv*0.0+(Vjun_d_VD_BD*pModel->phitdinv)*0.0+(Vjun_d*pModel->phitdinv)*0.0);
  tm0_VD_BD_VS_BS=(+(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)*pInst->MFOR1_d+Vjun_d_VD_BD*pModel->phitdinv*0.0+(0.0)*0.0+(Vjun_d*pModel->phitdinv)*0.0);
#endif
tm0_VS_BS=0.0;
#if defined(_DERIVATE2)
  tm0_VS_BS_VD_BD=0.0;
  tm0_VS_BS_VS_BS=0.0;
#endif
#endif
tm0=((Vjun_d*pModel->phitdinv)*pInst->MFOR1_d);
EXIT_IF_ISNAN(((Vjun_d*pModel->phitdinv)*pInst->MFOR1_d))
{
double m00_exp(d00_exp0,tm0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
tm1_VD_BD=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VD_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf1_d)?(pInst->expxhf1_d*tm0_VD_BD):tm0_VD_BD*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VD_BD_VD_BD=fixme;
  tm1_VD_BD_VS_BS=fixme;
#endif
tm1_VS_BS=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VS_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf1_d)?(pInst->expxhf1_d*tm0_VS_BS):tm0_VS_BS*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VS_BS_VD_BD=fixme;
  tm1_VS_BS_VS_BS=fixme;
#endif
#endif
tm1=((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf1_d)?(pInst->expxhf1_d*((tm0-pInst->xhighf1_d)+1)):d00_exp0));
EXIT_IF_ISNAN(((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf1_d)?(pInst->expxhf1_d*((tm0-pInst->xhighf1_d)+1)):d00_exp0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunfor1_VD_BD=(pInst->ISATFOR1_d*tm1_VD_BD);
#if defined(_DERIVATE2)
  ijunfor1_VD_BD_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VD_BD+pInst->ISATFOR1_d*(+tm1_VD_BD_VD_BD-0.0));
  ijunfor1_VD_BD_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VD_BD+pInst->ISATFOR1_d*(+tm1_VD_BD_VS_BS-0.0));
#endif
ijunfor1_VS_BS=(pInst->ISATFOR1_d*tm1_VS_BS);
#if defined(_DERIVATE2)
  ijunfor1_VS_BS_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VS_BS+pInst->ISATFOR1_d*(+tm1_VS_BS_VD_BD-0.0));
  ijunfor1_VS_BS_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VS_BS+pInst->ISATFOR1_d*(+tm1_VS_BS_VS_BS-0.0));
#endif
#endif
ijunfor1=(pInst->ISATFOR1_d*(tm1-1.0));
EXIT_IF_ISNAN((pInst->ISATFOR1_d*(tm1-1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tm0_VD_BD=Vjun_d_VD_BD*pModel->phitdinv*pInst->MFOR2_d;
#if defined(_DERIVATE2)
  tm0_VD_BD_VD_BD=(+(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)*pInst->MFOR2_d+Vjun_d_VD_BD*pModel->phitdinv*0.0+(Vjun_d_VD_BD*pModel->phitdinv)*0.0+(Vjun_d*pModel->phitdinv)*0.0);
  tm0_VD_BD_VS_BS=(+(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)*pInst->MFOR2_d+Vjun_d_VD_BD*pModel->phitdinv*0.0+(0.0)*0.0+(Vjun_d*pModel->phitdinv)*0.0);
#endif
tm0_VS_BS=0.0;
#if defined(_DERIVATE2)
  tm0_VS_BS_VD_BD=0.0;
  tm0_VS_BS_VS_BS=0.0;
#endif
#endif
tm0=((Vjun_d*pModel->phitdinv)*pInst->MFOR2_d);
EXIT_IF_ISNAN(((Vjun_d*pModel->phitdinv)*pInst->MFOR2_d))
{
double m00_exp(d00_exp0,tm0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
tm1_VD_BD=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VD_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf2_d)?(pInst->expxhf2_d*tm0_VD_BD):tm0_VD_BD*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VD_BD_VD_BD=fixme;
  tm1_VD_BD_VS_BS=fixme;
#endif
tm1_VS_BS=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VS_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf2_d)?(pInst->expxhf2_d*tm0_VS_BS):tm0_VS_BS*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VS_BS_VD_BD=fixme;
  tm1_VS_BS_VS_BS=fixme;
#endif
#endif
tm1=((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf2_d)?(pInst->expxhf2_d*((tm0-pInst->xhighf2_d)+1)):d00_exp0));
EXIT_IF_ISNAN(((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighf2_d)?(pInst->expxhf2_d*((tm0-pInst->xhighf2_d)+1)):d00_exp0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunfor2_VD_BD=(pInst->ISATFOR2_d*tm1_VD_BD);
#if defined(_DERIVATE2)
  ijunfor2_VD_BD_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VD_BD+pInst->ISATFOR2_d*(+tm1_VD_BD_VD_BD-0.0));
  ijunfor2_VD_BD_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VD_BD+pInst->ISATFOR2_d*(+tm1_VD_BD_VS_BS-0.0));
#endif
ijunfor2_VS_BS=(pInst->ISATFOR2_d*tm1_VS_BS);
#if defined(_DERIVATE2)
  ijunfor2_VS_BS_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VS_BS+pInst->ISATFOR2_d*(+tm1_VS_BS_VD_BD-0.0));
  ijunfor2_VS_BS_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VS_BS+pInst->ISATFOR2_d*(+tm1_VS_BS_VS_BS-0.0));
#endif
#endif
ijunfor2=(pInst->ISATFOR2_d*(tm1-1.0));
EXIT_IF_ISNAN((pInst->ISATFOR2_d*(tm1-1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunrev_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunrev_VD_BD_VD_BD=0.0;
  ijunrev_VD_BD_VS_BS=0.0;
#endif
ijunrev_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunrev_VS_BS_VD_BD=0.0;
  ijunrev_VS_BS_VS_BS=0.0;
#endif
#endif
ijunrev=0.0;
EXIT_IF_ISNAN(0.0)
if
((pInst->m0flag_d>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunrev_VD_BD=((Vjun_d_VD_BD*(pInst->ISATREV_d+(Vjun_d*pInst->MREV_d)))+(Vjun_d*Vjun_d_VD_BD*pInst->MREV_d));
#if defined(_DERIVATE2)
  ijunrev_VD_BD_VD_BD=(+Vjun_d_VD_BD_VD_BD*(pInst->ISATREV_d+(Vjun_d*pInst->MREV_d))+Vjun_d_VD_BD*(Vjun_d_VD_BD*pInst->MREV_d)+Vjun_d_VD_BD*Vjun_d_VD_BD*pInst->MREV_d+Vjun_d*(+0.0+(+Vjun_d_VD_BD_VD_BD*pInst->MREV_d+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)));
  ijunrev_VD_BD_VS_BS=(+0.0*(pInst->ISATREV_d+(Vjun_d*pInst->MREV_d))+Vjun_d_VD_BD*(0.0)+0.0*Vjun_d_VD_BD*pInst->MREV_d+Vjun_d*(+0.0+(+0.0*pInst->MREV_d+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)));
#endif
ijunrev_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunrev_VS_BS_VD_BD=0.0;
  ijunrev_VS_BS_VS_BS=0.0;
#endif
#endif
ijunrev=(Vjun_d*(pInst->ISATREV_d+(Vjun_d*pInst->MREV_d)));
EXIT_IF_ISNAN((Vjun_d*(pInst->ISATREV_d+(Vjun_d*pInst->MREV_d))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tm0_VD_BD=(-Vjun_d_VD_BD)*pModel->phitdinv*pInst->MREV_d;
#if defined(_DERIVATE2)
  tm0_VD_BD_VD_BD=(+(+0.0*pModel->phitdinv+(-Vjun_d_VD_BD)*0.0+(-Vjun_d_VD_BD)*0.0+(-Vjun_d)*0.0)*pInst->MREV_d+(-Vjun_d_VD_BD)*pModel->phitdinv*0.0+((-Vjun_d_VD_BD)*pModel->phitdinv)*0.0+((-Vjun_d)*pModel->phitdinv)*0.0);
  tm0_VD_BD_VS_BS=(+(+0.0*pModel->phitdinv+(-Vjun_d_VD_BD)*0.0+0.0*0.0+(-Vjun_d)*0.0)*pInst->MREV_d+(-Vjun_d_VD_BD)*pModel->phitdinv*0.0+(0.0)*0.0+((-Vjun_d)*pModel->phitdinv)*0.0);
#endif
tm0_VS_BS=0.0;
#if defined(_DERIVATE2)
  tm0_VS_BS_VD_BD=0.0;
  tm0_VS_BS_VS_BS=0.0;
#endif
#endif
tm0=(((-Vjun_d)*pModel->phitdinv)*pInst->MREV_d);
EXIT_IF_ISNAN((((-Vjun_d)*pModel->phitdinv)*pInst->MREV_d))
{
double m00_exp(d00_exp0,tm0)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
tm1_VD_BD=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VD_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighr_d)?(pInst->expxhr_d*tm0_VD_BD):tm0_VD_BD*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VD_BD_VD_BD=fixme;
  tm1_VD_BD_VS_BS=fixme;
#endif
tm1_VS_BS=((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-tm0_VS_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighr_d)?(pInst->expxhr_d*tm0_VS_BS):tm0_VS_BS*d10_exp0));
#if defined(_DERIVATE2)
  tm1_VS_BS_VD_BD=fixme;
  tm1_VS_BS_VS_BS=fixme;
#endif
#endif
tm1=((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighr_d)?(pInst->expxhr_d*((tm0-pInst->xhighr_d)+1)):d00_exp0));
EXIT_IF_ISNAN(((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>pInst->xhighr_d)?(pInst->expxhr_d*((tm0-pInst->xhighr_d)+1)):d00_exp0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunrev_VD_BD=((-pInst->ISATREV_d)*tm1_VD_BD);
#if defined(_DERIVATE2)
  ijunrev_VD_BD_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VD_BD+(-pInst->ISATREV_d)*(+tm1_VD_BD_VD_BD-0.0));
  ijunrev_VD_BD_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VD_BD+(-pInst->ISATREV_d)*(+tm1_VD_BD_VS_BS-0.0));
#endif
ijunrev_VS_BS=((-pInst->ISATREV_d)*tm1_VS_BS);
#if defined(_DERIVATE2)
  ijunrev_VS_BS_VD_BD=(+0.0*(tm1-1.0)+0.0*tm1_VD_BD+0.0*tm1_VS_BS+(-pInst->ISATREV_d)*(+tm1_VS_BS_VD_BD-0.0));
  ijunrev_VS_BS_VS_BS=(+0.0*(tm1-1.0)+0.0*tm1_VS_BS+0.0*tm1_VS_BS+(-pInst->ISATREV_d)*(+tm1_VS_BS_VS_BS-0.0));
#endif
#endif
ijunrev=((-pInst->ISATREV_d)*(tm1-1.0));
EXIT_IF_ISNAN(((-pInst->ISATREV_d)*(tm1-1.0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ijun_d_VD_BD=((ijunfor1_VD_BD+ijunfor2_VD_BD)+ijunrev_VD_BD);
#if defined(_DERIVATE2)
  ijun_d_VD_BD_VD_BD=(+(+ijunfor1_VD_BD_VD_BD+ijunfor2_VD_BD_VD_BD)+ijunrev_VD_BD_VD_BD);
  ijun_d_VD_BD_VS_BS=(+(+ijunfor1_VD_BD_VS_BS+ijunfor2_VD_BD_VS_BS)+ijunrev_VD_BD_VS_BS);
#endif
ijun_d_VS_BS=((ijunfor1_VS_BS+ijunfor2_VS_BS)+ijunrev_VS_BS);
#if defined(_DERIVATE2)
  ijun_d_VS_BS_VD_BD=(+(+ijunfor1_VS_BS_VD_BD+ijunfor2_VS_BS_VD_BD)+ijunrev_VS_BS_VD_BD);
  ijun_d_VS_BS_VS_BS=(+(+ijunfor1_VS_BS_VS_BS+ijunfor2_VS_BS_VS_BS)+ijunrev_VS_BS_VS_BS);
#endif
#endif
pInst->ijun_d=((ijunfor1+ijunfor2)+ijunrev);
EXIT_IF_ISNAN(((ijunfor1+ijunfor2)+ijunrev))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=0.0;
  tmpv_VD_BD_VS_BS=0.0;
#endif
tmpv_VS_BS=0.0;
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=0.0;
  tmpv_VS_BS_VS_BS=0.0;
#endif
#endif
tmpv=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
vjv_VD_BD=0.0;
#if defined(_DERIVATE2)
  vjv_VD_BD_VD_BD=0.0;
  vjv_VD_BD_VS_BS=0.0;
#endif
vjv_VS_BS=0.0;
#if defined(_DERIVATE2)
  vjv_VS_BS_VD_BD=0.0;
  vjv_VS_BS_VS_BS=0.0;
#endif
#endif
vjv=0.0;
EXIT_IF_ISNAN(0.0)
#endif
pInst->h1=((4.0*pInst->vch_s)*pInst->vch_s);
EXIT_IF_ISNAN(((4.0*pInst->vch_s)*pInst->vch_s))
pInst->h2=(pInst->vch_s/pInst->vfmin_s);
EXIT_IF_ISNAN((pInst->vch_s/pInst->vfmin_s))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h2d_VD_BD=0.0;
#if defined(_DERIVATE2)
  h2d_VD_BD_VD_BD=0.0;
  h2d_VD_BD_VS_BS=0.0;
#endif
h2d_VS_BS=Vjun_s_VS_BS;
#if defined(_DERIVATE2)
  h2d_VS_BS_VD_BD=(+0.0+(+0.0*pInst->h2+0.0*0.0+0.0*0.0+pInst->vch_s*0.0));
  h2d_VS_BS_VS_BS=(+Vjun_s_VS_BS_VS_BS+(+0.0*pInst->h2+0.0*0.0+0.0*0.0+pInst->vch_s*0.0));
#endif
#endif
pInst->h2d=(Vjun_s+(pInst->vch_s*pInst->h2));
EXIT_IF_ISNAN((Vjun_s+(pInst->vch_s*pInst->h2)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h3_VD_BD=0.0;
#if defined(_DERIVATE2)
  h3_VD_BD_VD_BD=0.0;
  h3_VD_BD_VS_BS=0.0;
#endif
h3_VS_BS=h2d_VS_BS;
#if defined(_DERIVATE2)
  h3_VS_BS_VD_BD=(+0.0+h2d_VS_BS_VD_BD);
  h3_VS_BS_VS_BS=(+0.0+h2d_VS_BS_VS_BS);
#endif
#endif
pInst->h3=(pInst->vfmin_s+pInst->h2d);
EXIT_IF_ISNAN((pInst->vfmin_s+pInst->h2d))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(BD,GND)V(D,GND) */
h4_VD_BD=0.0;
#if defined(_DERIVATE2)
  h4_VD_BD_VD_BD=0.0;
  h4_VD_BD_VS_BS=0.0;
#endif
h4_VS_BS=(-h2d_VS_BS);
#if defined(_DERIVATE2)
  h4_VS_BS_VD_BD=(+0.0-h2d_VS_BS_VD_BD);
  h4_VS_BS_VS_BS=(+0.0-h2d_VS_BS_VS_BS);
#endif
#endif
pInst->h4=(pInst->vfmin_s-pInst->h2d);
EXIT_IF_ISNAN((pInst->vfmin_s-pInst->h2d))
{
double m00_sqrt(d00_sqrt0,((pInst->h4*pInst->h4)+pInst->h1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->h4*pInst->h4)+pInst->h1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h5_VD_BD=0.0;
#if defined(_DERIVATE2)
  h5_VD_BD_VD_BD=0.0;
  h5_VD_BD_VS_BS=0.0;
#endif
h5_VS_BS=((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))*d10_sqrt0;
#if defined(_DERIVATE2)
  h5_VS_BS_VD_BD=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD)))*((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))+d10_sqrt0*(+(+h4_VS_BS_VD_BD*pInst->h4+h4_VS_BS*h4_VD_BD+h4_VD_BD*h4_VS_BS+pInst->h4*h4_VS_BS_VD_BD)+0.0));
  h5_VS_BS_VS_BS=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS)))*((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))+d10_sqrt0*(+(+h4_VS_BS_VS_BS*pInst->h4+h4_VS_BS*h4_VS_BS+h4_VS_BS*h4_VS_BS+pInst->h4*h4_VS_BS_VS_BS)+0.0));
#endif
#endif
pInst->h5=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
vjv_VD_BD=0.0;
#if defined(_DERIVATE2)
  vjv_VD_BD_VD_BD=0.0;
  vjv_VD_BD_VS_BS=0.0;
#endif
vjv_VS_BS=(2.0*((Vjun_s_VS_BS*pInst->vfmin_s*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#if defined(_DERIVATE2)
  vjv_VS_BS_VD_BD=(+0.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5))+0.0*(((0.0)*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*((Vjun_s_VS_BS*pInst->vfmin_s*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_s+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)/(pInst->h3+pInst->h5)-(Vjun_s_VS_BS*pInst->vfmin_s*(h3_VD_BD+h5_VD_BD)+(0.0)*(h3_VS_BS+h5_VS_BS)+(Vjun_s*pInst->vfmin_s)*(+h3_VS_BS_VD_BD+h5_VS_BS_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
  vjv_VS_BS_VS_BS=(+0.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5))+0.0*(((Vjun_s_VS_BS*pInst->vfmin_s)*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*((Vjun_s_VS_BS*pInst->vfmin_s*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+Vjun_s_VS_BS_VS_BS*pInst->vfmin_s+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)/(pInst->h3+pInst->h5)-(Vjun_s_VS_BS*pInst->vfmin_s*(h3_VS_BS+h5_VS_BS)+(Vjun_s_VS_BS*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS)+(Vjun_s*pInst->vfmin_s)*(+h3_VS_BS_VS_BS+h5_VS_BS_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#endif
#endif
vjv=(2.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5)));
EXIT_IF_ISNAN((2.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5))))
#endif
#ifdef _DYNAMIC
if
((pInst->zflagbot_s>0.5))
{
#ifdef _DYNAMIC
if
((pModel->one_minus_PBOT==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1-(vjv*pModel->vbiinvbot)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(vjv*pModel->vbiinvbot)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=0.0;
  tmpv_VD_BD_VS_BS=0.0;
#endif
tmpv_VS_BS=(-vjv_VS_BS*pModel->vbiinvbot)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvbot)))*(-(vjv_VD_BD*pModel->vbiinvbot))*(-vjv_VS_BS*pModel->vbiinvbot)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VD_BD*pModel->vbiinvbot+vjv_VS_BS*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VS_BS_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvbot)))*(-(vjv_VS_BS*pModel->vbiinvbot))*(-vjv_VS_BS*pModel->vbiinvbot)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VS_BS*pModel->vbiinvbot+vjv_VS_BS*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
#endif
tmpv=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1-(vjv*pModel->vbiinvbot)),pModel->one_minus_PBOT)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(vjv*pModel->vbiinvbot)),pModel->one_minus_PBOT)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=0.0;
  tmpv_VD_BD_VS_BS=0.0;
#endif
tmpv_VS_BS=(d10_pow0*(-vjv_VS_BS*pModel->vbiinvbot));
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=fixme;
  tmpv_VS_BS_VS_BS=fixme;
#endif
#endif
tmpv=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjunbot_s_VD_BD=0.0;
#endif
qjunbot_s_VS_BS=((pModel->qprefbot*(-tmpv_VS_BS))+(pModel->qpref2bot*(Vjun_s_VS_BS-vjv_VS_BS)));
#if defined(_DERIVATE2)
  qjunbot_s_VS_BS_VD_BD=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VD_BD)+0.0*(-tmpv_VS_BS)+pModel->qprefbot*(+0.0-tmpv_VS_BS_VD_BD))+(+0.0*(Vjun_s-vjv)+0.0*(-vjv_VD_BD)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+pModel->qpref2bot*(+0.0-vjv_VS_BS_VD_BD)));
  qjunbot_s_VS_BS_VS_BS=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VS_BS)+0.0*(-tmpv_VS_BS)+pModel->qprefbot*(+0.0-tmpv_VS_BS_VS_BS))+(+0.0*(Vjun_s-vjv)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+pModel->qpref2bot*(+Vjun_s_VS_BS_VS_BS-vjv_VS_BS_VS_BS)));
#endif
#endif
qjunbot_s=((pModel->qprefbot*(1-tmpv))+(pModel->qpref2bot*(Vjun_s-vjv)));
EXIT_IF_ISNAN(((pModel->qprefbot*(1-tmpv))+(pModel->qpref2bot*(Vjun_s-vjv))))
#endif
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pInst->zflagsti_s>0.5))
{
#ifdef _DYNAMIC
if
((pModel->one_minus_PSTI==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1-(vjv*pModel->vbiinvsti)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(vjv*pModel->vbiinvsti)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=0.0;
  tmpv_VD_BD_VS_BS=0.0;
#endif
tmpv_VS_BS=(-vjv_VS_BS*pModel->vbiinvsti)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvsti)))*(-(vjv_VD_BD*pModel->vbiinvsti))*(-vjv_VS_BS*pModel->vbiinvsti)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VD_BD*pModel->vbiinvsti+vjv_VS_BS*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VS_BS_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvsti)))*(-(vjv_VS_BS*pModel->vbiinvsti))*(-vjv_VS_BS*pModel->vbiinvsti)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VS_BS*pModel->vbiinvsti+vjv_VS_BS*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
#endif
tmpv=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1-(vjv*pModel->vbiinvsti)),pModel->one_minus_PSTI)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(vjv*pModel->vbiinvsti)),pModel->one_minus_PSTI)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=0.0;
  tmpv_VD_BD_VS_BS=0.0;
#endif
tmpv_VS_BS=(d10_pow0*(-vjv_VS_BS*pModel->vbiinvsti));
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=fixme;
  tmpv_VS_BS_VS_BS=fixme;
#endif
#endif
tmpv=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjunsti_s_VD_BD=0.0;
#endif
qjunsti_s_VS_BS=((pModel->qprefsti*(-tmpv_VS_BS))+(pModel->qpref2sti*(Vjun_s_VS_BS-vjv_VS_BS)));
#if defined(_DERIVATE2)
  qjunsti_s_VS_BS_VD_BD=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VD_BD)+0.0*(-tmpv_VS_BS)+pModel->qprefsti*(+0.0-tmpv_VS_BS_VD_BD))+(+0.0*(Vjun_s-vjv)+0.0*(-vjv_VD_BD)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+pModel->qpref2sti*(+0.0-vjv_VS_BS_VD_BD)));
  qjunsti_s_VS_BS_VS_BS=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VS_BS)+0.0*(-tmpv_VS_BS)+pModel->qprefsti*(+0.0-tmpv_VS_BS_VS_BS))+(+0.0*(Vjun_s-vjv)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+pModel->qpref2sti*(+Vjun_s_VS_BS_VS_BS-vjv_VS_BS_VS_BS)));
#endif
#endif
qjunsti_s=((pModel->qprefsti*(1-tmpv))+(pModel->qpref2sti*(Vjun_s-vjv)));
EXIT_IF_ISNAN(((pModel->qprefsti*(1-tmpv))+(pModel->qpref2sti*(Vjun_s-vjv))))
#endif
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pInst->zflaggat_s>0.5))
{
#ifdef _DYNAMIC
if
((pModel->one_minus_PGAT==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1-(vjv*pModel->vbiinvgat)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(vjv*pModel->vbiinvgat)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=0.0;
  tmpv_VD_BD_VS_BS=0.0;
#endif
tmpv_VS_BS=(-vjv_VS_BS*pModel->vbiinvgat)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvgat)))*(-(vjv_VD_BD*pModel->vbiinvgat))*(-vjv_VS_BS*pModel->vbiinvgat)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VD_BD*pModel->vbiinvgat+vjv_VS_BS*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VS_BS_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvgat)))*(-(vjv_VS_BS*pModel->vbiinvgat))*(-vjv_VS_BS*pModel->vbiinvgat)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VS_BS*pModel->vbiinvgat+vjv_VS_BS*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
#endif
tmpv=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1-(vjv*pModel->vbiinvgat)),pModel->one_minus_PGAT)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(vjv*pModel->vbiinvgat)),pModel->one_minus_PGAT)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=0.0;
  tmpv_VD_BD_VS_BS=0.0;
#endif
tmpv_VS_BS=(d10_pow0*(-vjv_VS_BS*pModel->vbiinvgat));
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=fixme;
  tmpv_VS_BS_VS_BS=fixme;
#endif
#endif
tmpv=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjungat_s_VD_BD=0.0;
#endif
qjungat_s_VS_BS=((pModel->qprefgat*(-tmpv_VS_BS))+(pModel->qpref2gat*(Vjun_s_VS_BS-vjv_VS_BS)));
#if defined(_DERIVATE2)
  qjungat_s_VS_BS_VD_BD=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VD_BD)+0.0*(-tmpv_VS_BS)+pModel->qprefgat*(+0.0-tmpv_VS_BS_VD_BD))+(+0.0*(Vjun_s-vjv)+0.0*(-vjv_VD_BD)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+pModel->qpref2gat*(+0.0-vjv_VS_BS_VD_BD)));
  qjungat_s_VS_BS_VS_BS=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VS_BS)+0.0*(-tmpv_VS_BS)+pModel->qprefgat*(+0.0-tmpv_VS_BS_VS_BS))+(+0.0*(Vjun_s-vjv)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+0.0*(Vjun_s_VS_BS-vjv_VS_BS)+pModel->qpref2gat*(+Vjun_s_VS_BS_VS_BS-vjv_VS_BS_VS_BS)));
#endif
#endif
qjungat_s=((pModel->qprefgat*(1-tmpv))+(pModel->qpref2gat*(Vjun_s-vjv)));
EXIT_IF_ISNAN(((pModel->qprefgat*(1-tmpv))+(pModel->qpref2gat*(Vjun_s-vjv))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=0.0;
  tmpv_VD_BD_VS_BS=0.0;
#endif
tmpv_VS_BS=0.0;
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=0.0;
  tmpv_VS_BS_VS_BS=0.0;
#endif
#endif
tmpv=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
vjv_VD_BD=0.0;
#if defined(_DERIVATE2)
  vjv_VD_BD_VD_BD=0.0;
  vjv_VD_BD_VS_BS=0.0;
#endif
vjv_VS_BS=0.0;
#if defined(_DERIVATE2)
  vjv_VS_BS_VD_BD=0.0;
  vjv_VS_BS_VS_BS=0.0;
#endif
#endif
vjv=0.0;
EXIT_IF_ISNAN(0.0)
#endif
pInst->h1=((4.0*pInst->vch_d)*pInst->vch_d);
EXIT_IF_ISNAN(((4.0*pInst->vch_d)*pInst->vch_d))
pInst->h2=(pInst->vch_d/pInst->vfmin_d);
EXIT_IF_ISNAN((pInst->vch_d/pInst->vfmin_d))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h2d_VD_BD=Vjun_d_VD_BD;
#if defined(_DERIVATE2)
  h2d_VD_BD_VD_BD=(+Vjun_d_VD_BD_VD_BD+(+0.0*pInst->h2+0.0*0.0+0.0*0.0+pInst->vch_d*0.0));
  h2d_VD_BD_VS_BS=(+0.0+(+0.0*pInst->h2+0.0*0.0+0.0*0.0+pInst->vch_d*0.0));
#endif
h2d_VS_BS=0.0;
#if defined(_DERIVATE2)
  h2d_VS_BS_VD_BD=0.0;
  h2d_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->h2d=(Vjun_d+(pInst->vch_d*pInst->h2));
EXIT_IF_ISNAN((Vjun_d+(pInst->vch_d*pInst->h2)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h3_VD_BD=h2d_VD_BD;
#if defined(_DERIVATE2)
  h3_VD_BD_VD_BD=(+0.0+h2d_VD_BD_VD_BD);
  h3_VD_BD_VS_BS=(+0.0+h2d_VD_BD_VS_BS);
#endif
h3_VS_BS=h2d_VS_BS;
#if defined(_DERIVATE2)
  h3_VS_BS_VD_BD=(+0.0+h2d_VS_BS_VD_BD);
  h3_VS_BS_VS_BS=(+0.0+h2d_VS_BS_VS_BS);
#endif
#endif
pInst->h3=(pInst->vfmin_d+pInst->h2d);
EXIT_IF_ISNAN((pInst->vfmin_d+pInst->h2d))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(BD,GND)V(D,GND) */
h4_VD_BD=(-h2d_VD_BD);
#if defined(_DERIVATE2)
  h4_VD_BD_VD_BD=(+0.0-h2d_VD_BD_VD_BD);
  h4_VD_BD_VS_BS=(+0.0-h2d_VD_BD_VS_BS);
#endif
h4_VS_BS=(-h2d_VS_BS);
#if defined(_DERIVATE2)
  h4_VS_BS_VD_BD=(+0.0-h2d_VS_BS_VD_BD);
  h4_VS_BS_VS_BS=(+0.0-h2d_VS_BS_VS_BS);
#endif
#endif
pInst->h4=(pInst->vfmin_d-pInst->h2d);
EXIT_IF_ISNAN((pInst->vfmin_d-pInst->h2d))
{
double m00_sqrt(d00_sqrt0,((pInst->h4*pInst->h4)+pInst->h1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->h4*pInst->h4)+pInst->h1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h5_VD_BD=((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))*d10_sqrt0;
#if defined(_DERIVATE2)
  h5_VD_BD_VD_BD=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD)))*((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))+d10_sqrt0*(+(+h4_VD_BD_VD_BD*pInst->h4+h4_VD_BD*h4_VD_BD+h4_VD_BD*h4_VD_BD+pInst->h4*h4_VD_BD_VD_BD)+0.0));
  h5_VD_BD_VS_BS=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS)))*((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))+d10_sqrt0*(+(+h4_VD_BD_VS_BS*pInst->h4+h4_VD_BD*h4_VS_BS+h4_VS_BS*h4_VD_BD+pInst->h4*h4_VD_BD_VS_BS)+0.0));
#endif
h5_VS_BS=((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))*d10_sqrt0;
#if defined(_DERIVATE2)
  h5_VS_BS_VD_BD=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD)))*((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))+d10_sqrt0*(+(+h4_VS_BS_VD_BD*pInst->h4+h4_VS_BS*h4_VD_BD+h4_VD_BD*h4_VS_BS+pInst->h4*h4_VS_BS_VD_BD)+0.0));
  h5_VS_BS_VS_BS=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS)))*((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))+d10_sqrt0*(+(+h4_VS_BS_VS_BS*pInst->h4+h4_VS_BS*h4_VS_BS+h4_VS_BS*h4_VS_BS+pInst->h4*h4_VS_BS_VS_BS)+0.0));
#endif
#endif
pInst->h5=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
vjv_VD_BD=(2.0*((Vjun_d_VD_BD*pInst->vfmin_d*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#if defined(_DERIVATE2)
  vjv_VD_BD_VD_BD=(+0.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))+0.0*(((Vjun_d_VD_BD*pInst->vfmin_d)*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*((Vjun_d_VD_BD*pInst->vfmin_d*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+Vjun_d_VD_BD_VD_BD*pInst->vfmin_d+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)/(pInst->h3+pInst->h5)-(Vjun_d_VD_BD*pInst->vfmin_d*(h3_VD_BD+h5_VD_BD)+(Vjun_d_VD_BD*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD)+(Vjun_d*pInst->vfmin_d)*(+h3_VD_BD_VD_BD+h5_VD_BD_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
  vjv_VD_BD_VS_BS=(+0.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))+0.0*(((0.0)*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*((Vjun_d_VD_BD*pInst->vfmin_d*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_d+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)/(pInst->h3+pInst->h5)-(Vjun_d_VD_BD*pInst->vfmin_d*(h3_VS_BS+h5_VS_BS)+(0.0)*(h3_VD_BD+h5_VD_BD)+(Vjun_d*pInst->vfmin_d)*(+h3_VD_BD_VS_BS+h5_VD_BD_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#endif
vjv_VS_BS=(2.0*(-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#if defined(_DERIVATE2)
  vjv_VS_BS_VD_BD=(+0.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))+0.0*(((Vjun_d_VD_BD*pInst->vfmin_d)*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*(-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_d+0.0*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)/(pInst->h3+pInst->h5)-(0.0*(h3_VD_BD+h5_VD_BD)+(Vjun_d_VD_BD*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)+(Vjun_d*pInst->vfmin_d)*(+h3_VS_BS_VD_BD+h5_VS_BS_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
  vjv_VS_BS_VS_BS=(+0.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))+0.0*(((0.0)*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*(-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_d+0.0*0.0+0.0*0.0+Vjun_d*0.0)/(pInst->h3+pInst->h5)-(0.0*(h3_VS_BS+h5_VS_BS)+(0.0)*(h3_VS_BS+h5_VS_BS)+(Vjun_d*pInst->vfmin_d)*(+h3_VS_BS_VS_BS+h5_VS_BS_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#endif
#endif
vjv=(2.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5)));
EXIT_IF_ISNAN((2.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))))
#endif
#ifdef _DYNAMIC
if
((pInst->zflagbot_d>0.5))
{
#ifdef _DYNAMIC
if
((pModel->one_minus_PBOT_d==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1-(vjv*pModel->vbiinvbot_d)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(vjv*pModel->vbiinvbot_d)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=(-vjv_VD_BD*pModel->vbiinvbot_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvbot_d)))*(-(vjv_VD_BD*pModel->vbiinvbot_d))*(-vjv_VD_BD*pModel->vbiinvbot_d)+d10_sqrt0*(+0.0-(+vjv_VD_BD_VD_BD*pModel->vbiinvbot_d+vjv_VD_BD*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VD_BD_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvbot_d)))*(-(vjv_VS_BS*pModel->vbiinvbot_d))*(-vjv_VD_BD*pModel->vbiinvbot_d)+d10_sqrt0*(+0.0-(+vjv_VD_BD_VS_BS*pModel->vbiinvbot_d+vjv_VD_BD*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
tmpv_VS_BS=(-vjv_VS_BS*pModel->vbiinvbot_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvbot_d)))*(-(vjv_VD_BD*pModel->vbiinvbot_d))*(-vjv_VS_BS*pModel->vbiinvbot_d)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VD_BD*pModel->vbiinvbot_d+vjv_VS_BS*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VS_BS_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvbot_d)))*(-(vjv_VS_BS*pModel->vbiinvbot_d))*(-vjv_VS_BS*pModel->vbiinvbot_d)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VS_BS*pModel->vbiinvbot_d+vjv_VS_BS*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
#endif
tmpv=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1-(vjv*pModel->vbiinvbot_d)),pModel->one_minus_PBOT_d)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(vjv*pModel->vbiinvbot_d)),pModel->one_minus_PBOT_d)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=(d10_pow0*(-vjv_VD_BD*pModel->vbiinvbot_d));
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=fixme;
  tmpv_VD_BD_VS_BS=fixme;
#endif
tmpv_VS_BS=(d10_pow0*(-vjv_VS_BS*pModel->vbiinvbot_d));
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=fixme;
  tmpv_VS_BS_VS_BS=fixme;
#endif
#endif
tmpv=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjunbot_d_VD_BD=((pModel->qprefbot_d*(-tmpv_VD_BD))+(pModel->qpref2bot_d*(Vjun_d_VD_BD-vjv_VD_BD)));
#if defined(_DERIVATE2)
  qjunbot_d_VD_BD_VD_BD=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VD_BD)+0.0*(-tmpv_VD_BD)+pModel->qprefbot_d*(+0.0-tmpv_VD_BD_VD_BD))+(+0.0*(Vjun_d-vjv)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+pModel->qpref2bot_d*(+Vjun_d_VD_BD_VD_BD-vjv_VD_BD_VD_BD)));
  qjunbot_d_VD_BD_VS_BS=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VS_BS)+0.0*(-tmpv_VD_BD)+pModel->qprefbot_d*(+0.0-tmpv_VD_BD_VS_BS))+(+0.0*(Vjun_d-vjv)+0.0*(-vjv_VS_BS)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+pModel->qpref2bot_d*(+0.0-vjv_VD_BD_VS_BS)));
#endif
#if defined(_DERIVATE)
qjunbot_d_VS_BS=((pModel->qprefbot_d*(-tmpv_VS_BS))+(pModel->qpref2bot_d*(-vjv_VS_BS)));
#endif
#endif
qjunbot_d=((pModel->qprefbot_d*(1-tmpv))+(pModel->qpref2bot_d*(Vjun_d-vjv)));
EXIT_IF_ISNAN(((pModel->qprefbot_d*(1-tmpv))+(pModel->qpref2bot_d*(Vjun_d-vjv))))
#endif
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pInst->zflagsti_d>0.5))
{
#ifdef _DYNAMIC
if
((pModel->one_minus_PSTI_d==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1-(vjv*pModel->vbiinvsti_d)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(vjv*pModel->vbiinvsti_d)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=(-vjv_VD_BD*pModel->vbiinvsti_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvsti_d)))*(-(vjv_VD_BD*pModel->vbiinvsti_d))*(-vjv_VD_BD*pModel->vbiinvsti_d)+d10_sqrt0*(+0.0-(+vjv_VD_BD_VD_BD*pModel->vbiinvsti_d+vjv_VD_BD*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VD_BD_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvsti_d)))*(-(vjv_VS_BS*pModel->vbiinvsti_d))*(-vjv_VD_BD*pModel->vbiinvsti_d)+d10_sqrt0*(+0.0-(+vjv_VD_BD_VS_BS*pModel->vbiinvsti_d+vjv_VD_BD*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
tmpv_VS_BS=(-vjv_VS_BS*pModel->vbiinvsti_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvsti_d)))*(-(vjv_VD_BD*pModel->vbiinvsti_d))*(-vjv_VS_BS*pModel->vbiinvsti_d)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VD_BD*pModel->vbiinvsti_d+vjv_VS_BS*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VS_BS_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvsti_d)))*(-(vjv_VS_BS*pModel->vbiinvsti_d))*(-vjv_VS_BS*pModel->vbiinvsti_d)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VS_BS*pModel->vbiinvsti_d+vjv_VS_BS*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
#endif
tmpv=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1-(vjv*pModel->vbiinvsti_d)),pModel->one_minus_PSTI_d)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(vjv*pModel->vbiinvsti_d)),pModel->one_minus_PSTI_d)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=(d10_pow0*(-vjv_VD_BD*pModel->vbiinvsti_d));
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=fixme;
  tmpv_VD_BD_VS_BS=fixme;
#endif
tmpv_VS_BS=(d10_pow0*(-vjv_VS_BS*pModel->vbiinvsti_d));
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=fixme;
  tmpv_VS_BS_VS_BS=fixme;
#endif
#endif
tmpv=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjunsti_d_VD_BD=((pModel->qprefsti_d*(-tmpv_VD_BD))+(pModel->qpref2sti_d*(Vjun_d_VD_BD-vjv_VD_BD)));
#if defined(_DERIVATE2)
  qjunsti_d_VD_BD_VD_BD=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VD_BD)+0.0*(-tmpv_VD_BD)+pModel->qprefsti_d*(+0.0-tmpv_VD_BD_VD_BD))+(+0.0*(Vjun_d-vjv)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+pModel->qpref2sti_d*(+Vjun_d_VD_BD_VD_BD-vjv_VD_BD_VD_BD)));
  qjunsti_d_VD_BD_VS_BS=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VS_BS)+0.0*(-tmpv_VD_BD)+pModel->qprefsti_d*(+0.0-tmpv_VD_BD_VS_BS))+(+0.0*(Vjun_d-vjv)+0.0*(-vjv_VS_BS)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+pModel->qpref2sti_d*(+0.0-vjv_VD_BD_VS_BS)));
#endif
#if defined(_DERIVATE)
qjunsti_d_VS_BS=((pModel->qprefsti_d*(-tmpv_VS_BS))+(pModel->qpref2sti_d*(-vjv_VS_BS)));
#endif
#endif
qjunsti_d=((pModel->qprefsti_d*(1-tmpv))+(pModel->qpref2sti_d*(Vjun_d-vjv)));
EXIT_IF_ISNAN(((pModel->qprefsti_d*(1-tmpv))+(pModel->qpref2sti_d*(Vjun_d-vjv))))
#endif
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pInst->zflaggat_d>0.5))
{
#ifdef _DYNAMIC
if
((pModel->one_minus_PGAT_d==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1-(vjv*pModel->vbiinvgat_d)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(vjv*pModel->vbiinvgat_d)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=(-vjv_VD_BD*pModel->vbiinvgat_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvgat_d)))*(-(vjv_VD_BD*pModel->vbiinvgat_d))*(-vjv_VD_BD*pModel->vbiinvgat_d)+d10_sqrt0*(+0.0-(+vjv_VD_BD_VD_BD*pModel->vbiinvgat_d+vjv_VD_BD*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VD_BD_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvgat_d)))*(-(vjv_VS_BS*pModel->vbiinvgat_d))*(-vjv_VD_BD*pModel->vbiinvgat_d)+d10_sqrt0*(+0.0-(+vjv_VD_BD_VS_BS*pModel->vbiinvgat_d+vjv_VD_BD*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
tmpv_VS_BS=(-vjv_VS_BS*pModel->vbiinvgat_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=(m20_sqrt((1-(vjv*pModel->vbiinvgat_d)))*(-(vjv_VD_BD*pModel->vbiinvgat_d))*(-vjv_VS_BS*pModel->vbiinvgat_d)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VD_BD*pModel->vbiinvgat_d+vjv_VS_BS*0.0+vjv_VD_BD*0.0+vjv*0.0)));
  tmpv_VS_BS_VS_BS=(m20_sqrt((1-(vjv*pModel->vbiinvgat_d)))*(-(vjv_VS_BS*pModel->vbiinvgat_d))*(-vjv_VS_BS*pModel->vbiinvgat_d)+d10_sqrt0*(+0.0-(+vjv_VS_BS_VS_BS*pModel->vbiinvgat_d+vjv_VS_BS*0.0+vjv_VS_BS*0.0+vjv*0.0)));
#endif
#endif
tmpv=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1-(vjv*pModel->vbiinvgat_d)),pModel->one_minus_PGAT_d)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(vjv*pModel->vbiinvgat_d)),pModel->one_minus_PGAT_d)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND)V(D,GND) */
tmpv_VD_BD=(d10_pow0*(-vjv_VD_BD*pModel->vbiinvgat_d));
#if defined(_DERIVATE2)
  tmpv_VD_BD_VD_BD=fixme;
  tmpv_VD_BD_VS_BS=fixme;
#endif
tmpv_VS_BS=(d10_pow0*(-vjv_VS_BS*pModel->vbiinvgat_d));
#if defined(_DERIVATE2)
  tmpv_VS_BS_VD_BD=fixme;
  tmpv_VS_BS_VS_BS=fixme;
#endif
#endif
tmpv=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjungat_d_VD_BD=((pModel->qprefgat_d*(-tmpv_VD_BD))+(pModel->qpref2gat_d*(Vjun_d_VD_BD-vjv_VD_BD)));
#if defined(_DERIVATE2)
  qjungat_d_VD_BD_VD_BD=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VD_BD)+0.0*(-tmpv_VD_BD)+pModel->qprefgat_d*(+0.0-tmpv_VD_BD_VD_BD))+(+0.0*(Vjun_d-vjv)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+pModel->qpref2gat_d*(+Vjun_d_VD_BD_VD_BD-vjv_VD_BD_VD_BD)));
  qjungat_d_VD_BD_VS_BS=(+(+0.0*(1-tmpv)+0.0*(-tmpv_VS_BS)+0.0*(-tmpv_VD_BD)+pModel->qprefgat_d*(+0.0-tmpv_VD_BD_VS_BS))+(+0.0*(Vjun_d-vjv)+0.0*(-vjv_VS_BS)+0.0*(Vjun_d_VD_BD-vjv_VD_BD)+pModel->qpref2gat_d*(+0.0-vjv_VD_BD_VS_BS)));
#endif
#if defined(_DERIVATE)
qjungat_d_VS_BS=((pModel->qprefgat_d*(-tmpv_VS_BS))+(pModel->qpref2gat_d*(-vjv_VS_BS)));
#endif
#endif
qjungat_d=((pModel->qprefgat_d*(1-tmpv))+(pModel->qpref2gat_d*(Vjun_d-vjv)));
EXIT_IF_ISNAN(((pModel->qprefgat_d*(1-tmpv))+(pModel->qpref2gat_d*(Vjun_d-vjv))))
#endif
}
#endif /* if(...) */
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  vbbt_VD_BD_VD_BD=0.0;
  vbbt_VD_BD_VS_BS=0.0;
#endif
vbbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  vbbt_VS_BS_VD_BD=0.0;
  vbbt_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->vbbt=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
two_psistar_VD_BD=0.0;
#if defined(_DERIVATE2)
  two_psistar_VD_BD_VD_BD=0.0;
  two_psistar_VD_BD_VS_BS=0.0;
#endif
two_psistar_VS_BS=0.0;
#if defined(_DERIVATE2)
  two_psistar_VS_BS_VD_BD=0.0;
  two_psistar_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->two_psistar=0.0;
EXIT_IF_ISNAN(0.0)
if
((!(((pInst->ABSOURCE_i==0)&&(pInst->LSSOURCE_i==0))&&(pInst->LGSOURCE_i==0))))
{
pInst->h1=((4.0*pInst->vch_s)*pInst->vch_s);
EXIT_IF_ISNAN(((4.0*pInst->vch_s)*pInst->vch_s))
pInst->h2=(pInst->vch_s/pInst->vfmin_s);
EXIT_IF_ISNAN((pInst->vch_s/pInst->vfmin_s))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h2d_VD_BD=0.0;
#if defined(_DERIVATE2)
  h2d_VD_BD_VD_BD=0.0;
  h2d_VD_BD_VS_BS=0.0;
#endif
h2d_VS_BS=Vjun_s_VS_BS;
#if defined(_DERIVATE2)
  h2d_VS_BS_VD_BD=(+0.0+(+0.0*pInst->h2+0.0*0.0+0.0*0.0+pInst->vch_s*0.0));
  h2d_VS_BS_VS_BS=(+Vjun_s_VS_BS_VS_BS+(+0.0*pInst->h2+0.0*0.0+0.0*0.0+pInst->vch_s*0.0));
#endif
#endif
pInst->h2d=(Vjun_s+(pInst->vch_s*pInst->h2));
EXIT_IF_ISNAN((Vjun_s+(pInst->vch_s*pInst->h2)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h3_VD_BD=h2d_VD_BD;
#if defined(_DERIVATE2)
  h3_VD_BD_VD_BD=(+0.0+h2d_VD_BD_VD_BD);
  h3_VD_BD_VS_BS=(+0.0+h2d_VD_BD_VS_BS);
#endif
h3_VS_BS=h2d_VS_BS;
#if defined(_DERIVATE2)
  h3_VS_BS_VD_BD=(+0.0+h2d_VS_BS_VD_BD);
  h3_VS_BS_VS_BS=(+0.0+h2d_VS_BS_VS_BS);
#endif
#endif
pInst->h3=(pInst->vfmin_s+pInst->h2d);
EXIT_IF_ISNAN((pInst->vfmin_s+pInst->h2d))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(BD,GND)V(D,GND) */
h4_VD_BD=(-h2d_VD_BD);
#if defined(_DERIVATE2)
  h4_VD_BD_VD_BD=(+0.0-h2d_VD_BD_VD_BD);
  h4_VD_BD_VS_BS=(+0.0-h2d_VD_BD_VS_BS);
#endif
h4_VS_BS=(-h2d_VS_BS);
#if defined(_DERIVATE2)
  h4_VS_BS_VD_BD=(+0.0-h2d_VS_BS_VD_BD);
  h4_VS_BS_VS_BS=(+0.0-h2d_VS_BS_VS_BS);
#endif
#endif
pInst->h4=(pInst->vfmin_s-pInst->h2d);
EXIT_IF_ISNAN((pInst->vfmin_s-pInst->h2d))
{
double m00_sqrt(d00_sqrt0,((pInst->h4*pInst->h4)+pInst->h1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->h4*pInst->h4)+pInst->h1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h5_VD_BD=((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))*d10_sqrt0;
#if defined(_DERIVATE2)
  h5_VD_BD_VD_BD=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD)))*((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))+d10_sqrt0*(+(+h4_VD_BD_VD_BD*pInst->h4+h4_VD_BD*h4_VD_BD+h4_VD_BD*h4_VD_BD+pInst->h4*h4_VD_BD_VD_BD)+0.0));
  h5_VD_BD_VS_BS=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS)))*((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))+d10_sqrt0*(+(+h4_VD_BD_VS_BS*pInst->h4+h4_VD_BD*h4_VS_BS+h4_VS_BS*h4_VD_BD+pInst->h4*h4_VD_BD_VS_BS)+0.0));
#endif
h5_VS_BS=((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))*d10_sqrt0;
#if defined(_DERIVATE2)
  h5_VS_BS_VD_BD=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD)))*((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))+d10_sqrt0*(+(+h4_VS_BS_VD_BD*pInst->h4+h4_VS_BS*h4_VD_BD+h4_VD_BD*h4_VS_BS+pInst->h4*h4_VS_BS_VD_BD)+0.0));
  h5_VS_BS_VS_BS=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS)))*((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))+d10_sqrt0*(+(+h4_VS_BS_VS_BS*pInst->h4+h4_VS_BS*h4_VS_BS+h4_VS_BS*h4_VS_BS+pInst->h4*h4_VS_BS_VS_BS)+0.0));
#endif
#endif
pInst->h5=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(BD,GND)V(D,GND) */
vj_VS_BS=(2.0*((Vjun_s_VS_BS*pInst->vfmin_s*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#if defined(_DERIVATE2)
  vj_VS_BS_VS_BS=(+0.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5))+0.0*(((Vjun_s_VS_BS*pInst->vfmin_s)*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*((Vjun_s_VS_BS*pInst->vfmin_s*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+Vjun_s_VS_BS_VS_BS*pInst->vfmin_s+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)/(pInst->h3+pInst->h5)-(Vjun_s_VS_BS*pInst->vfmin_s*(h3_VS_BS+h5_VS_BS)+(Vjun_s_VS_BS*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS)+(Vjun_s*pInst->vfmin_s)*(+h3_VS_BS_VS_BS+h5_VS_BS_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
  vj_VS_BS_VD_BD=(+0.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5))+0.0*(((0.0)*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*((Vjun_s_VS_BS*pInst->vfmin_s*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_s+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)/(pInst->h3+pInst->h5)-(Vjun_s_VS_BS*pInst->vfmin_s*(h3_VD_BD+h5_VD_BD)+(0.0)*(h3_VS_BS+h5_VS_BS)+(Vjun_s*pInst->vfmin_s)*(+h3_VS_BS_VD_BD+h5_VS_BS_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#endif
vj_VD_BD=(2.0*(-(Vjun_s*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#if defined(_DERIVATE2)
  vj_VD_BD_VS_BS=(+0.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5))+0.0*(((Vjun_s_VS_BS*pInst->vfmin_s)*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*(-(Vjun_s*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_s+0.0*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)/(pInst->h3+pInst->h5)-(0.0*(h3_VS_BS+h5_VS_BS)+(Vjun_s_VS_BS*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD)+(Vjun_s*pInst->vfmin_s)*(+h3_VD_BD_VS_BS+h5_VD_BD_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_s*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
  vj_VD_BD_VD_BD=(+0.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5))+0.0*(((0.0)*(pInst->h3+pInst->h5)-(Vjun_s*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*(-(Vjun_s*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_s+0.0*0.0+0.0*0.0+Vjun_s*0.0)/(pInst->h3+pInst->h5)-(0.0*(h3_VD_BD+h5_VD_BD)+(0.0)*(h3_VD_BD+h5_VD_BD)+(Vjun_s*pInst->vfmin_s)*(+h3_VD_BD_VD_BD+h5_VD_BD_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_s*pInst->vfmin_s)*(h3_VD_BD+h5_VD_BD)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#endif
#endif
pInst->vj=(2.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5)));
EXIT_IF_ISNAN((2.0*((Vjun_s*pInst->vfmin_s)/(pInst->h3+pInst->h5))))
if
((Vjun_s<pInst->VMAX_s))
{
{
double m00_fabs(d00_fabs0,(0.5*(Vjun_s*pModel->phitdinv)))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,(0.5*(Vjun_s*pModel->phitdinv)))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
zinv_VD_BD=0.0;
#if defined(_DERIVATE2)
  zinv_VD_BD_VD_BD=0.0;
  zinv_VD_BD_VS_BS=0.0;
#endif
zinv_VS_BS=(0.5*Vjun_s_VS_BS*pModel->phitdinv)*d10_exp0;
#if defined(_DERIVATE2)
  zinv_VS_BS_VD_BD=(m20_exp((0.5*(Vjun_s*pModel->phitdinv)))*((0.5*(0.0)))*(0.5*Vjun_s_VS_BS*pModel->phitdinv)+d10_exp0*(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)));
  zinv_VS_BS_VS_BS=(m20_exp((0.5*(Vjun_s*pModel->phitdinv)))*((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*(0.5*Vjun_s_VS_BS*pModel->phitdinv)+d10_exp0*(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(Vjun_s_VS_BS*pModel->phitdinv)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)));
#endif
#endif
pInst->zinv=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
(((0.5*(Vjun_s*pModel->phitdinv))<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
zinv_VD_BD=0.0;
#if defined(_DERIVATE2)
  zinv_VD_BD_VD_BD=0.0;
  zinv_VD_BD_VS_BS=0.0;
#endif
zinv_VS_BS=(-1.0e-100*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  zinv_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))-(0.0*((((-((0.5*(0.0))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((0.5*((((-((0.5*(0.0))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((-((0.5*(0.0))))*3.3333333333333333e-01)))))))))+0.0*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))+(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*((0.5*((((-((0.5*(0.0))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((-((0.5*(0.0))))*3.3333333333333333e-01))))))+(-((0.5*(0.0))))*(0.5*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+0.0*((((-((0.5*(0.0))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((-((0.5*(0.0))))*3.3333333333333333e-01))))+0.0*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))+(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*((-((0.5*(0.0))))*3.3333333333333333e-01)+(-((0.5*(0.0))))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(+0.0+(+(+0.0-(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0)))*3.3333333333333333e-01+(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*0.0+(-((0.5*(0.0))))*0.0+((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01)))))*((((-((0.5*(0.0))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((0.5*((((-((0.5*(0.0))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((-((0.5*(0.0))))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))));
  zinv_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))-(0.0*((((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((0.5*((((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*3.3333333333333333e-01)))))))))+0.0*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(Vjun_s_VS_BS*pModel->phitdinv)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))+(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*((0.5*((((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*3.3333333333333333e-01))))))+(-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*(0.5*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+0.0*((((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*3.3333333333333333e-01))))+0.0*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(Vjun_s_VS_BS*pModel->phitdinv)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))+(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*3.3333333333333333e-01)+(-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(+0.0+(+(+0.0-(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(Vjun_s_VS_BS*pModel->phitdinv)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0)))*3.3333333333333333e-01+(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*0.0+(-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*0.0+((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(-(0.5*Vjun_s_VS_BS*pModel->phitdinv))*3.3333333333333333e-01)))))*((((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((0.5*((((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*((-((0.5*(Vjun_s_VS_BS*pModel->phitdinv))))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->zinv=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*pModel->phitdinv)))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
zinv_VD_BD=0.0;
#if defined(_DERIVATE2)
  zinv_VD_BD_VD_BD=0.0;
  zinv_VD_BD_VS_BS=0.0;
#endif
zinv_VS_BS=(1.0e100*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  zinv_VS_BS_VD_BD=(+0.0*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((((0.5*(0.0)))*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*((0.5*(((((0.5*(0.0)))*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(0.0)))*3.3333333333333333e-01)))))))))+0.0*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0))-0.0)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(0.5*Vjun_s_VS_BS*pModel->phitdinv)*((0.5*(((((0.5*(0.0)))*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(0.0)))*3.3333333333333333e-01))))))+((0.5*(0.0)))*(0.5*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01)))+((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(+0.0+(+0.0*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((((0.5*(0.0)))*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(0.0)))*3.3333333333333333e-01))))+0.0*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01))+0.5*(+(+(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0))-0.0)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))+(0.5*Vjun_s_VS_BS*pModel->phitdinv)*(((0.5*(0.0)))*3.3333333333333333e-01)+((0.5*(0.0)))*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01+((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(+0.0+(+(+(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+Vjun_s*0.0))-0.0)*3.3333333333333333e-01+(0.5*Vjun_s_VS_BS*pModel->phitdinv)*0.0+((0.5*(0.0)))*0.0+((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*0.0))))))));
  zinv_VS_BS_VS_BS=(+0.0*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*((0.5*(((((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*3.3333333333333333e-01)))))))))+0.0*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(Vjun_s_VS_BS*pModel->phitdinv)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0))-0.0)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(0.5*Vjun_s_VS_BS*pModel->phitdinv)*((0.5*(((((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*3.3333333333333333e-01))))))+((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*(0.5*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01)))+((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(+0.0+(+0.0*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*3.3333333333333333e-01))))+0.0*(((0.5*Vjun_s_VS_BS*pModel->phitdinv)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01))+0.5*(+(+(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(Vjun_s_VS_BS*pModel->phitdinv)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0))-0.0)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))+(0.5*Vjun_s_VS_BS*pModel->phitdinv)*(((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*3.3333333333333333e-01)+((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*(0.5*Vjun_s_VS_BS*pModel->phitdinv)*3.3333333333333333e-01+((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(+0.0+(+(+(+0.0*(Vjun_s*pModel->phitdinv)+0.0*(Vjun_s_VS_BS*pModel->phitdinv)+0.0*Vjun_s_VS_BS*pModel->phitdinv+0.5*(+Vjun_s_VS_BS_VS_BS*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+Vjun_s*0.0))-0.0)*3.3333333333333333e-01+(0.5*Vjun_s_VS_BS*pModel->phitdinv)*0.0+((0.5*(Vjun_s_VS_BS*pModel->phitdinv)))*0.0+((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
pInst->zinv=(1.0e100*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
idmult_VD_BD=0.0;
#if defined(_DERIVATE2)
  idmult_VD_BD_VD_BD=0.0;
  idmult_VD_BD_VS_BS=0.0;
#endif
idmult_VS_BS=((zinv_VS_BS*pInst->zinv)+(pInst->zinv*zinv_VS_BS));
#if defined(_DERIVATE2)
  idmult_VS_BS_VD_BD=(+zinv_VS_BS_VD_BD*pInst->zinv+zinv_VS_BS*zinv_VD_BD+zinv_VD_BD*zinv_VS_BS+pInst->zinv*zinv_VS_BS_VD_BD);
  idmult_VS_BS_VS_BS=(+zinv_VS_BS_VS_BS*pInst->zinv+zinv_VS_BS*zinv_VS_BS+zinv_VS_BS*zinv_VS_BS+pInst->zinv*zinv_VS_BS_VS_BS);
#endif
#endif
pInst->idmult=(pInst->zinv*pInst->zinv);
EXIT_IF_ISNAN((pInst->zinv*pInst->zinv))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
idmult_VD_BD=0.0;
#if defined(_DERIVATE2)
  idmult_VD_BD_VD_BD=0.0;
  idmult_VD_BD_VS_BS=0.0;
#endif
idmult_VS_BS=Vjun_s_VS_BS*pModel->phitdinv*pInst->exp_VMAX_over_phitd_s;
#if defined(_DERIVATE2)
  idmult_VS_BS_VD_BD=(+(+0.0+(+(+0.0-0.0)*pModel->phitdinv+Vjun_s_VS_BS*0.0+0.0*0.0+(Vjun_s-pInst->VMAX_s)*0.0))*pInst->exp_VMAX_over_phitd_s+Vjun_s_VS_BS*pModel->phitdinv*0.0+(0.0)*0.0+(1+((Vjun_s-pInst->VMAX_s)*pModel->phitdinv))*0.0);
  idmult_VS_BS_VS_BS=(+(+0.0+(+(+Vjun_s_VS_BS_VS_BS-0.0)*pModel->phitdinv+Vjun_s_VS_BS*0.0+Vjun_s_VS_BS*0.0+(Vjun_s-pInst->VMAX_s)*0.0))*pInst->exp_VMAX_over_phitd_s+Vjun_s_VS_BS*pModel->phitdinv*0.0+(Vjun_s_VS_BS*pModel->phitdinv)*0.0+(1+((Vjun_s-pInst->VMAX_s)*pModel->phitdinv))*0.0);
#endif
#endif
pInst->idmult=((1+((Vjun_s-pInst->VMAX_s)*pModel->phitdinv))*pInst->exp_VMAX_over_phitd_s);
EXIT_IF_ISNAN(((1+((Vjun_s-pInst->VMAX_s)*pModel->phitdinv))*pInst->exp_VMAX_over_phitd_s))
{
double m00_sqrt(d00_sqrt0,pInst->idmult)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,pInst->idmult)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
zinv_VD_BD=0.0;
#if defined(_DERIVATE2)
  zinv_VD_BD_VD_BD=0.0;
  zinv_VD_BD_VS_BS=0.0;
#endif
zinv_VS_BS=idmult_VS_BS*d10_sqrt0;
#if defined(_DERIVATE2)
  zinv_VS_BS_VD_BD=(m20_sqrt(pInst->idmult)*idmult_VD_BD*idmult_VS_BS+d10_sqrt0*idmult_VS_BS_VD_BD);
  zinv_VS_BS_VS_BS=(m20_sqrt(pInst->idmult)*idmult_VS_BS*idmult_VS_BS+d10_sqrt0*idmult_VS_BS_VS_BS);
#endif
#endif
pInst->zinv=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
idmult_VD_BD=0.0;
#if defined(_DERIVATE2)
  idmult_VD_BD_VD_BD=0.0;
  idmult_VD_BD_VS_BS=0.0;
#endif
idmult_VS_BS=idmult_VS_BS;
#if defined(_DERIVATE2)
  idmult_VS_BS_VD_BD=(+idmult_VS_BS_VD_BD-0.0);
  idmult_VS_BS_VS_BS=(+idmult_VS_BS_VS_BS-0.0);
#endif
#endif
pInst->idmult=(pInst->idmult-1.0);
EXIT_IF_ISNAN((pInst->idmult-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
z_VD_BD=0.0;
#if defined(_DERIVATE2)
  z_VD_BD_VD_BD=0.0;
  z_VD_BD_VS_BS=0.0;
#endif
z_VS_BS=(-1*zinv_VS_BS/pInst->zinv/pInst->zinv);
#if defined(_DERIVATE2)
  z_VS_BS_VD_BD=(0.0/pInst->zinv-(0.0*zinv_VD_BD+0.0*zinv_VS_BS+1*zinv_VS_BS_VD_BD)/pInst->zinv/pInst->zinv+2*1*zinv_VS_BS*zinv_VD_BD/pInst->zinv/pInst->zinv/pInst->zinv);
  z_VS_BS_VS_BS=(0.0/pInst->zinv-(0.0*zinv_VS_BS+0.0*zinv_VS_BS+1*zinv_VS_BS_VS_BS)/pInst->zinv/pInst->zinv+2*1*zinv_VS_BS*zinv_VS_BS/pInst->zinv/pInst->zinv/pInst->zinv);
#endif
#endif
pInst->z=(1/pInst->zinv);
EXIT_IF_ISNAN((1/pInst->zinv))
if
((Vjun_s>0))
{
{
double m00_sqrt(d00_sqrt0,((pInst->z+1.0)*(pInst->z+3.0)))
double m00_logE(d00_logE1,((2.0+pInst->z)+d00_sqrt0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->z+1.0)*(pInst->z+3.0)))
double m10_logE(d10_logE1,d00_logE1,((2.0+pInst->z)+d00_sqrt0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
two_psistar_VD_BD=0.0;
#if defined(_DERIVATE2)
  two_psistar_VD_BD_VD_BD=0.0;
  two_psistar_VD_BD_VS_BS=0.0;
#endif
two_psistar_VS_BS=(2.0*(pModel->phitd*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1));
#if defined(_DERIVATE2)
  two_psistar_VS_BS_VD_BD=(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*d10_logE1+0.0*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE(((2.0+pInst->z)+d00_sqrt0))*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)+d10_logE1*(+(+0.0+z_VS_BS_VD_BD)+(m20_sqrt(((pInst->z+1.0)*(pInst->z+3.0)))*(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))+d10_sqrt0*(+(+z_VS_BS_VD_BD+0.0)*(pInst->z+3.0)+z_VS_BS*z_VD_BD+z_VD_BD*z_VS_BS+(pInst->z+1.0)*(+z_VS_BS_VD_BD+0.0)))))));
  two_psistar_VS_BS_VS_BS=(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*d10_logE1+0.0*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE(((2.0+pInst->z)+d00_sqrt0))*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)+d10_logE1*(+(+0.0+z_VS_BS_VS_BS)+(m20_sqrt(((pInst->z+1.0)*(pInst->z+3.0)))*(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))+d10_sqrt0*(+(+z_VS_BS_VS_BS+0.0)*(pInst->z+3.0)+z_VS_BS*z_VS_BS+z_VS_BS*z_VS_BS+(pInst->z+1.0)*(+z_VS_BS_VS_BS+0.0)))))));
#endif
#endif
pInst->two_psistar=(2.0*(pModel->phitd*d00_logE1));
EXIT_IF_ISNAN((2.0*(pModel->phitd*d00_logE1)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,((1+pInst->zinv)*(1+(3*pInst->zinv))))
double m00_logE(d00_logE1,(((2*pInst->zinv)+1)+d00_sqrt0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((1+pInst->zinv)*(1+(3*pInst->zinv))))
double m10_logE(d10_logE1,d00_logE1,(((2*pInst->zinv)+1)+d00_sqrt0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
two_psistar_VD_BD=0.0;
#if defined(_DERIVATE2)
  two_psistar_VD_BD_VD_BD=0.0;
  two_psistar_VD_BD_VS_BS=0.0;
#endif
two_psistar_VS_BS=((-Vjun_s_VS_BS)+(2.0*(pModel->phitd*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1)));
#if defined(_DERIVATE2)
  two_psistar_VS_BS_VD_BD=(+0.0+(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*d10_logE1+0.0*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE((((2*pInst->zinv)+1)+d00_sqrt0))*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)+d10_logE1*(+(+(+0.0*pInst->zinv+0.0*zinv_VD_BD+0.0*zinv_VS_BS+2*zinv_VS_BS_VD_BD)+0.0)+(m20_sqrt(((1+pInst->zinv)*(1+(3*pInst->zinv))))*(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))+d10_sqrt0*(+(+0.0+zinv_VS_BS_VD_BD)*(1+(3*pInst->zinv))+zinv_VS_BS*((3*zinv_VD_BD))+zinv_VD_BD*(3*zinv_VS_BS)+(1+pInst->zinv)*(+0.0+(+0.0*pInst->zinv+0.0*zinv_VD_BD+0.0*zinv_VS_BS+3*zinv_VS_BS_VD_BD)))))))));
  two_psistar_VS_BS_VS_BS=(+0.0+(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*d10_logE1+0.0*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE((((2*pInst->zinv)+1)+d00_sqrt0))*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)+d10_logE1*(+(+(+0.0*pInst->zinv+0.0*zinv_VS_BS+0.0*zinv_VS_BS+2*zinv_VS_BS_VS_BS)+0.0)+(m20_sqrt(((1+pInst->zinv)*(1+(3*pInst->zinv))))*(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))+d10_sqrt0*(+(+0.0+zinv_VS_BS_VS_BS)*(1+(3*pInst->zinv))+zinv_VS_BS*((3*zinv_VS_BS))+zinv_VS_BS*(3*zinv_VS_BS)+(1+pInst->zinv)*(+0.0+(+0.0*pInst->zinv+0.0*zinv_VS_BS+0.0*zinv_VS_BS+3*zinv_VS_BS_VS_BS)))))))));
#endif
#endif
pInst->two_psistar=((-Vjun_s)+(2.0*(pModel->phitd*d00_logE1)));
EXIT_IF_ISNAN(((-Vjun_s)+(2.0*(pModel->phitd*d00_logE1))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vjlim_VD_BD=0.0;
#if defined(_DERIVATE2)
  vjlim_VD_BD_VD_BD=0.0;
  vjlim_VD_BD_VS_BS=0.0;
#endif
vjlim_VS_BS=(-two_psistar_VS_BS);
#if defined(_DERIVATE2)
  vjlim_VS_BS_VD_BD=(+0.0-two_psistar_VS_BS_VD_BD);
  vjlim_VS_BS_VS_BS=(+0.0-two_psistar_VS_BS_VS_BS);
#endif
#endif
pInst->vjlim=(pInst->vbimin_s-pInst->two_psistar);
EXIT_IF_ISNAN((pInst->vbimin_s-pInst->two_psistar))
{
double m00_sqrt(d00_sqrt0,(((Vjun_s-pInst->vjlim)*(Vjun_s-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vjun_s-pInst->vjlim)*(Vjun_s-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
vjsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  vjsrh_VD_BD_VD_BD=0.0;
  vjsrh_VD_BD_VS_BS=0.0;
#endif
vjsrh_VS_BS=(0.5*((Vjun_s_VS_BS+vjlim_VS_BS)-(((Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(Vjun_s_VS_BS-vjlim_VS_BS)))*d10_sqrt0));
#if defined(_DERIVATE2)
  vjsrh_VS_BS_VD_BD=(+0.0*((Vjun_s+pInst->vjlim)-d00_sqrt0)+0.0*(vjlim_VD_BD-(((((-vjlim_VD_BD)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(-vjlim_VD_BD))))+((0.0)*pModel->phitd))*d10_sqrt0)+0.0*((Vjun_s_VS_BS+vjlim_VS_BS)-(((Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(Vjun_s_VS_BS-vjlim_VS_BS)))*d10_sqrt0)+0.5*(+(+0.0+vjlim_VS_BS_VD_BD)-(m20_sqrt((((Vjun_s-pInst->vjlim)*(Vjun_s-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))*(((((-vjlim_VD_BD)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(-vjlim_VD_BD))))+((0.0)*pModel->phitd))*(((Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(Vjun_s_VS_BS-vjlim_VS_BS)))+d10_sqrt0*(+(+(+0.0-vjlim_VS_BS_VD_BD)*(Vjun_s-pInst->vjlim)+(Vjun_s_VS_BS-vjlim_VS_BS)*(-vjlim_VD_BD)+(-vjlim_VD_BD)*(Vjun_s_VS_BS-vjlim_VS_BS)+(Vjun_s-pInst->vjlim)*(+0.0-vjlim_VS_BS_VD_BD))+(+(+0.0*pModel->phitd+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitd+0.0*0.0+(0.0)*0.0+(4*pModel->phitd)*0.0)))));
  vjsrh_VS_BS_VS_BS=(+0.0*((Vjun_s+pInst->vjlim)-d00_sqrt0)+0.0*((Vjun_s_VS_BS+vjlim_VS_BS)-(((((Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(Vjun_s_VS_BS-vjlim_VS_BS))))+((0.0)*pModel->phitd))*d10_sqrt0)+0.0*((Vjun_s_VS_BS+vjlim_VS_BS)-(((Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(Vjun_s_VS_BS-vjlim_VS_BS)))*d10_sqrt0)+0.5*(+(+Vjun_s_VS_BS_VS_BS+vjlim_VS_BS_VS_BS)-(m20_sqrt((((Vjun_s-pInst->vjlim)*(Vjun_s-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))*(((((Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(Vjun_s_VS_BS-vjlim_VS_BS))))+((0.0)*pModel->phitd))*(((Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s-pInst->vjlim))+((Vjun_s-pInst->vjlim)*(Vjun_s_VS_BS-vjlim_VS_BS)))+d10_sqrt0*(+(+(+Vjun_s_VS_BS_VS_BS-vjlim_VS_BS_VS_BS)*(Vjun_s-pInst->vjlim)+(Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s_VS_BS-vjlim_VS_BS)+(Vjun_s_VS_BS-vjlim_VS_BS)*(Vjun_s_VS_BS-vjlim_VS_BS)+(Vjun_s-pInst->vjlim)*(+Vjun_s_VS_BS_VS_BS-vjlim_VS_BS_VS_BS))+(+(+0.0*pModel->phitd+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitd+0.0*0.0+(0.0)*0.0+(4*pModel->phitd)*0.0)))));
#endif
#endif
pInst->vjsrh=(0.5*((Vjun_s+pInst->vjlim)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((Vjun_s+pInst->vjlim)-d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,(((Vjun_s-pInst->vbbtlim_s)*(Vjun_s-pInst->vbbtlim_s))+((4*pModel->phitr)*pModel->phitr)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vjun_s-pInst->vbbtlim_s)*(Vjun_s-pInst->vbbtlim_s))+((4*pModel->phitr)*pModel->phitr)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  vbbt_VD_BD_VD_BD=0.0;
  vbbt_VD_BD_VS_BS=0.0;
#endif
vbbt_VS_BS=(0.5*(Vjun_s_VS_BS-((Vjun_s_VS_BS*(Vjun_s-pInst->vbbtlim_s))+((Vjun_s-pInst->vbbtlim_s)*Vjun_s_VS_BS))*d10_sqrt0));
#if defined(_DERIVATE2)
  vbbt_VS_BS_VD_BD=(+0.0*((Vjun_s+pInst->vbbtlim_s)-d00_sqrt0)+0.0*(-((0.0)+((0.0)*pModel->phitr))*d10_sqrt0)+0.0*(Vjun_s_VS_BS-((Vjun_s_VS_BS*(Vjun_s-pInst->vbbtlim_s))+((Vjun_s-pInst->vbbtlim_s)*Vjun_s_VS_BS))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt((((Vjun_s-pInst->vbbtlim_s)*(Vjun_s-pInst->vbbtlim_s))+((4*pModel->phitr)*pModel->phitr)))*((0.0)+((0.0)*pModel->phitr))*((Vjun_s_VS_BS*(Vjun_s-pInst->vbbtlim_s))+((Vjun_s-pInst->vbbtlim_s)*Vjun_s_VS_BS))+d10_sqrt0*(+(+(+0.0-0.0)*(Vjun_s-pInst->vbbtlim_s)+Vjun_s_VS_BS*0.0+0.0*Vjun_s_VS_BS+(Vjun_s-pInst->vbbtlim_s)*(+0.0-0.0))+(+(+0.0*pModel->phitr+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitr+0.0*0.0+(0.0)*0.0+(4*pModel->phitr)*0.0)))));
  vbbt_VS_BS_VS_BS=(+0.0*((Vjun_s+pInst->vbbtlim_s)-d00_sqrt0)+0.0*(Vjun_s_VS_BS-((((Vjun_s_VS_BS*(Vjun_s-pInst->vbbtlim_s))+((Vjun_s-pInst->vbbtlim_s)*Vjun_s_VS_BS)))+((0.0)*pModel->phitr))*d10_sqrt0)+0.0*(Vjun_s_VS_BS-((Vjun_s_VS_BS*(Vjun_s-pInst->vbbtlim_s))+((Vjun_s-pInst->vbbtlim_s)*Vjun_s_VS_BS))*d10_sqrt0)+0.5*(+(+Vjun_s_VS_BS_VS_BS+0.0)-(m20_sqrt((((Vjun_s-pInst->vbbtlim_s)*(Vjun_s-pInst->vbbtlim_s))+((4*pModel->phitr)*pModel->phitr)))*((((Vjun_s_VS_BS*(Vjun_s-pInst->vbbtlim_s))+((Vjun_s-pInst->vbbtlim_s)*Vjun_s_VS_BS)))+((0.0)*pModel->phitr))*((Vjun_s_VS_BS*(Vjun_s-pInst->vbbtlim_s))+((Vjun_s-pInst->vbbtlim_s)*Vjun_s_VS_BS))+d10_sqrt0*(+(+(+Vjun_s_VS_BS_VS_BS-0.0)*(Vjun_s-pInst->vbbtlim_s)+Vjun_s_VS_BS*Vjun_s_VS_BS+Vjun_s_VS_BS*Vjun_s_VS_BS+(Vjun_s-pInst->vbbtlim_s)*(+Vjun_s_VS_BS_VS_BS-0.0))+(+(+0.0*pModel->phitr+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitr+0.0*0.0+(0.0)*0.0+(4*pModel->phitr)*0.0)))));
#endif
#endif
pInst->vbbt=(0.5*((Vjun_s+pInst->vbbtlim_s)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((Vjun_s+pInst->vbbtlim_s)-d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,((Vjun_s*Vjun_s)+((4*1E-6)*1E-6)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Vjun_s*Vjun_s)+((4*1E-6)*1E-6)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
vav_VD_BD=0.0;
#if defined(_DERIVATE2)
  vav_VD_BD_VD_BD=0.0;
  vav_VD_BD_VS_BS=0.0;
#endif
vav_VS_BS=(0.5*(Vjun_s_VS_BS-((Vjun_s_VS_BS*Vjun_s)+(Vjun_s*Vjun_s_VS_BS))*d10_sqrt0));
#if defined(_DERIVATE2)
  vav_VS_BS_VD_BD=(+0.0*(Vjun_s-d00_sqrt0)+0.0*(-((0.0)+((0.0)*1E-6))*d10_sqrt0)+0.0*(Vjun_s_VS_BS-((Vjun_s_VS_BS*Vjun_s)+(Vjun_s*Vjun_s_VS_BS))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt(((Vjun_s*Vjun_s)+((4*1E-6)*1E-6)))*((0.0)+((0.0)*1E-6))*((Vjun_s_VS_BS*Vjun_s)+(Vjun_s*Vjun_s_VS_BS))+d10_sqrt0*(+(+(+0.0-0.0)*Vjun_s+Vjun_s_VS_BS*0.0+0.0*Vjun_s_VS_BS+Vjun_s*(+0.0-0.0))+(+(+0.0*1E-6+0.0*0.0+0.0*0.0+4*0.0)*1E-6+0.0*0.0+(0.0)*0.0+(4*1E-6)*0.0)))));
  vav_VS_BS_VS_BS=(+0.0*(Vjun_s-d00_sqrt0)+0.0*(Vjun_s_VS_BS-((((Vjun_s_VS_BS*Vjun_s)+(Vjun_s*Vjun_s_VS_BS)))+((0.0)*1E-6))*d10_sqrt0)+0.0*(Vjun_s_VS_BS-((Vjun_s_VS_BS*Vjun_s)+(Vjun_s*Vjun_s_VS_BS))*d10_sqrt0)+0.5*(+(+Vjun_s_VS_BS_VS_BS+0.0)-(m20_sqrt(((Vjun_s*Vjun_s)+((4*1E-6)*1E-6)))*((((Vjun_s_VS_BS*Vjun_s)+(Vjun_s*Vjun_s_VS_BS)))+((0.0)*1E-6))*((Vjun_s_VS_BS*Vjun_s)+(Vjun_s*Vjun_s_VS_BS))+d10_sqrt0*(+(+(+Vjun_s_VS_BS_VS_BS-0.0)*Vjun_s+Vjun_s_VS_BS*Vjun_s_VS_BS+Vjun_s_VS_BS*Vjun_s_VS_BS+Vjun_s*(+Vjun_s_VS_BS_VS_BS-0.0))+(+(+0.0*1E-6+0.0*0.0+0.0*0.0+4*0.0)*1E-6+0.0*0.0+(0.0)*0.0+(4*1E-6)*0.0)))));
#endif
#endif
pInst->vav=(0.5*(Vjun_s-d00_sqrt0));
EXIT_IF_ISNAN((0.5*(Vjun_s-d00_sqrt0)))
}
}
if
((pInst->ABSOURCE_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijunbot_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunbot_s_VS_BS_VS_BS=0.0;
  ijunbot_s_VS_BS_VD_BD=0.0;
#endif
ijunbot_s_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunbot_s_VD_BD_VS_BS=0.0;
  ijunbot_s_VD_BD_VD_BD=0.0;
#endif
#endif
ijunbot_s=0;
EXIT_IF_ISNAN(0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjunbot_s_VD_BD=0.0;
#endif
qjunbot_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  qjunbot_s_VS_BS_VD_BD=0.0;
  qjunbot_s_VS_BS_VS_BS=0.0;
#endif
#endif
qjunbot_s=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
if
((pModel->one_minus_PBOT==0.5))
{
{
double m00_sqrt(d00_sqrt0,(1-(pInst->vj*pModel->vbiinvbot)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->vj*pModel->vbiinvbot)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vj_VS_BS*pModel->vbiinvbot)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvbot)))*(-(vj_VS_BS*pModel->vbiinvbot))*(-vj_VS_BS*pModel->vbiinvbot)+d10_sqrt0*(+0.0-(+vj_VS_BS_VS_BS*pModel->vbiinvbot+vj_VS_BS*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VS_BS_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvbot)))*(-(vj_VD_BD*pModel->vbiinvbot))*(-vj_VS_BS*pModel->vbiinvbot)+d10_sqrt0*(+0.0-(+vj_VS_BS_VD_BD*pModel->vbiinvbot+vj_VS_BS*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
tmp_VD_BD=(-vj_VD_BD*pModel->vbiinvbot)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvbot)))*(-(vj_VS_BS*pModel->vbiinvbot))*(-vj_VD_BD*pModel->vbiinvbot)+d10_sqrt0*(+0.0-(+vj_VD_BD_VS_BS*pModel->vbiinvbot+vj_VD_BD*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VD_BD_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvbot)))*(-(vj_VD_BD*pModel->vbiinvbot))*(-vj_VD_BD*pModel->vbiinvbot)+d10_sqrt0*(+0.0-(+vj_VD_BD_VD_BD*pModel->vbiinvbot+vj_VD_BD*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(1-(pInst->vj*pModel->vbiinvbot)),pModel->one_minus_PBOT)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(pInst->vj*pModel->vbiinvbot)),pModel->one_minus_PBOT)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vj_VS_BS*pModel->vbiinvbot));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vj_VD_BD*pModel->vbiinvbot));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjunbot_s_VD_BD=((pModel->qprefbot*(-tmp_VD_BD))+(pModel->qpref2bot*(-vj_VD_BD)));
#endif
qjunbot_s_VS_BS=((pModel->qprefbot*(-tmp_VS_BS))+(pModel->qpref2bot*(Vjun_s_VS_BS-vj_VS_BS)));
#if defined(_DERIVATE2)
  qjunbot_s_VS_BS_VD_BD=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+pModel->qprefbot*(+0.0-tmp_VS_BS_VD_BD))+(+0.0*(Vjun_s-pInst->vj)+0.0*(-vj_VD_BD)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+pModel->qpref2bot*(+0.0-vj_VS_BS_VD_BD)));
  qjunbot_s_VS_BS_VS_BS=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+pModel->qprefbot*(+0.0-tmp_VS_BS_VS_BS))+(+0.0*(Vjun_s-pInst->vj)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+pModel->qpref2bot*(+Vjun_s_VS_BS_VS_BS-vj_VS_BS_VS_BS)));
#endif
#endif
qjunbot_s=((pModel->qprefbot*(1-pInst->tmp))+(pModel->qpref2bot*(Vjun_s-pInst->vj)));
EXIT_IF_ISNAN(((pModel->qprefbot*(1-pInst->tmp))+(pModel->qpref2bot*(Vjun_s-pInst->vj))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
id_VD_BD=0.0;
#if defined(_DERIVATE2)
  id_VD_BD_VD_BD=0.0;
  id_VD_BD_VS_BS=0.0;
#endif
id_VS_BS=(pModel->idsatbot*idmult_VS_BS);
#if defined(_DERIVATE2)
  id_VS_BS_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VS_BS+pModel->idsatbot*idmult_VS_BS_VD_BD);
  id_VS_BS_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VS_BS+pModel->idsatbot*idmult_VS_BS_VS_BS);
#endif
#endif
pInst->id=(pModel->idsatbot*pInst->idmult);
EXIT_IF_ISNAN((pModel->idsatbot*pInst->idmult))
if
(((pModel->CSRHBOT_i==0)&&(pModel->CTATBOT_i==0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=0.0;
  isrh_VS_BS_VD_BD=0.0;
#endif
isrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=0.0;
  isrh_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->isrh=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbi_minus_vjsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VD_BD_VD_BD=0.0;
  vbi_minus_vjsrh_VD_BD_VS_BS=0.0;
#endif
vbi_minus_vjsrh_VS_BS=(-vjsrh_VS_BS);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VS_BS_VD_BD=(+0.0-vjsrh_VS_BS_VD_BD);
  vbi_minus_vjsrh_VS_BS_VS_BS=(+0.0-vjsrh_VS_BS_VS_BS);
#endif
#endif
pInst->vbi_minus_vjsrh=(pModel->vbibot-pInst->vjsrh);
EXIT_IF_ISNAN((pModel->vbibot-pInst->vjsrh))
{
double m00_sqrt(d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wsrhstep_VD_BD=0.0;
#if defined(_DERIVATE2)
  wsrhstep_VD_BD_VD_BD=0.0;
  wsrhstep_VD_BD_VS_BS=0.0;
#endif
wsrhstep_VS_BS=(-(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VS_BS_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VS_BS_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
#endif
pInst->wsrhstep=(1-d00_sqrt0);
EXIT_IF_ISNAN((1-d00_sqrt0))
}
if
((pModel->PBOT_i==0.5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=0.0;
  dwsrh_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->dwsrh=0;
EXIT_IF_ISNAN(0)
}
else
{
{
double m00_logE(d00_logE0,pInst->wsrhstep)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,pInst->wsrhstep)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(1-(2*pModel->PBOT_i));
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=(+(+((+(+wsrhstep_VS_BS_VD_BD*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VD_BD)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VD_BD)*(1-(2*pModel->PBOT_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PBOT_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VS_BS_VS_BS=(+(+((+(+wsrhstep_VS_BS_VS_BS*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VS_BS)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VS_BS)*(1-(2*pModel->PBOT_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PBOT_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
#endif
pInst->dwsrh=(((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PBOT_i)));
EXIT_IF_ISNAN((((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PBOT_i))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  wsrh_VD_BD_VD_BD=0.0;
  wsrh_VD_BD_VS_BS=0.0;
#endif
wsrh_VS_BS=(wsrhstep_VS_BS+dwsrh_VS_BS);
#if defined(_DERIVATE2)
  wsrh_VS_BS_VD_BD=(+wsrhstep_VS_BS_VD_BD+dwsrh_VS_BS_VD_BD);
  wsrh_VS_BS_VS_BS=(+wsrhstep_VS_BS_VS_BS+dwsrh_VS_BS_VS_BS);
#endif
#endif
pInst->wsrh=(pInst->wsrhstep+pInst->dwsrh);
EXIT_IF_ISNAN((pInst->wsrhstep+pInst->dwsrh))
if
((pModel->PBOT_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv)*vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VS_BS*pModel->VBIRBOTinv+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRBOTinv)*vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VD_BD*pModel->VBIRBOTinv+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv),pModel->PBOT_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv),pModel->PBOT_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wdep_VS_BS=(pModel->wdepnulrbot*tmp_VS_BS);
#if defined(_DERIVATE2)
  wdep_VS_BS_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+pModel->wdepnulrbot*tmp_VS_BS_VS_BS);
  wdep_VS_BS_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+pModel->wdepnulrbot*tmp_VS_BS_VD_BD);
#endif
wdep_VD_BD=(pModel->wdepnulrbot*tmp_VD_BD);
#if defined(_DERIVATE2)
  wdep_VD_BD_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+pModel->wdepnulrbot*tmp_VD_BD_VS_BS);
  wdep_VD_BD_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+pModel->wdepnulrbot*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->wdep=(pModel->wdepnulrbot*pInst->tmp);
EXIT_IF_ISNAN((pModel->wdepnulrbot*pInst->tmp))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
asrh_VS_BS=(pModel->ftdbot*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)));
#if defined(_DERIVATE2)
  asrh_VS_BS_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdbot*(+(+zinv_VS_BS_VS_BS-0.0)*pInst->wdep+zinv_VS_BS*wdep_VS_BS+zinv_VS_BS*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VS_BS));
  asrh_VS_BS_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdbot*(+(+zinv_VS_BS_VD_BD-0.0)*pInst->wdep+zinv_VS_BS*wdep_VD_BD+zinv_VD_BD*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VD_BD));
#endif
asrh_VD_BD=(pModel->ftdbot*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)));
#if defined(_DERIVATE2)
  asrh_VD_BD_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdbot*(+(+zinv_VD_BD_VS_BS-0.0)*pInst->wdep+zinv_VD_BD*wdep_VS_BS+zinv_VS_BS*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VS_BS));
  asrh_VD_BD_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdbot*(+(+zinv_VD_BD_VD_BD-0.0)*pInst->wdep+zinv_VD_BD*wdep_VD_BD+zinv_VD_BD*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VD_BD));
#endif
#endif
pInst->asrh=(pModel->ftdbot*((pInst->zinv-1)*pInst->wdep));
EXIT_IF_ISNAN((pModel->ftdbot*((pInst->zinv-1)*pInst->wdep)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=(pModel->CSRHBOT_i*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)));
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHBOT_i*(+asrh_VS_BS_VS_BS*pInst->wsrh+asrh_VS_BS*wsrh_VS_BS+asrh_VS_BS*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VS_BS));
  isrh_VS_BS_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHBOT_i*(+asrh_VS_BS_VD_BD*pInst->wsrh+asrh_VS_BS*wsrh_VD_BD+asrh_VD_BD*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VD_BD));
#endif
isrh_VD_BD=(pModel->CSRHBOT_i*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)));
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHBOT_i*(+asrh_VD_BD_VS_BS*pInst->wsrh+asrh_VD_BD*wsrh_VS_BS+asrh_VS_BS*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VS_BS));
  isrh_VD_BD_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHBOT_i*(+asrh_VD_BD_VD_BD*pInst->wsrh+asrh_VD_BD*wsrh_VD_BD+asrh_VD_BD*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VD_BD));
#endif
#endif
pInst->isrh=(pModel->CSRHBOT_i*(pInst->asrh*pInst->wsrh));
EXIT_IF_ISNAN((pModel->CSRHBOT_i*(pInst->asrh*pInst->wsrh)))
}
if
((pModel->CTATBOT_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=0.0;
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=0.0;
  itat_VS_BS_VD_BD=0.0;
#endif
itat_VD_BD=0.0;
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=0.0;
  itat_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->itat=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
btat_VS_BS=(pModel->btatpartbot*((wdep_VS_BS*pModel->one_minus_PBOT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VS_BS_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PBOT)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PBOT)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PBOT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartbot*((+wdep_VS_BS_VS_BS*pModel->one_minus_PBOT+wdep_VS_BS*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PBOT*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VS_BS_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PBOT)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PBOT)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PBOT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartbot*((+wdep_VS_BS_VD_BD*pModel->one_minus_PBOT+wdep_VS_BS*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PBOT*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
btat_VD_BD=(pModel->btatpartbot*((wdep_VD_BD*pModel->one_minus_PBOT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VD_BD_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PBOT)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PBOT)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PBOT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartbot*((+wdep_VD_BD_VS_BS*pModel->one_minus_PBOT+wdep_VD_BD*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PBOT*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VD_BD_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PBOT)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PBOT)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PBOT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartbot*((+wdep_VD_BD_VD_BD*pModel->one_minus_PBOT+wdep_VD_BD*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PBOT*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PBOT)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
#endif
pInst->btat=(pModel->btatpartbot*((pInst->wdep*pModel->one_minus_PBOT)/pInst->vbi_minus_vjsrh));
EXIT_IF_ISNAN((pModel->btatpartbot*((pInst->wdep*pModel->one_minus_PBOT)/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
twoatatoverthreebtat_VS_BS=(-(0.666666666666667*pModel->atatbot)*btat_VS_BS/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VS_BS_VS_BS=((+0.0*pModel->atatbot+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatbot)*btat_VS_BS_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatbot)*btat_VS_BS*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VS_BS_VD_BD=((+0.0*pModel->atatbot+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatbot)*btat_VS_BS_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatbot)*btat_VS_BS*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
twoatatoverthreebtat_VD_BD=(-(0.666666666666667*pModel->atatbot)*btat_VD_BD/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VD_BD_VS_BS=((+0.0*pModel->atatbot+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatbot)*btat_VD_BD_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatbot)*btat_VD_BD*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VD_BD_VD_BD=((+0.0*pModel->atatbot+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatbot)*btat_VD_BD_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatbot)*btat_VD_BD*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
#endif
pInst->twoatatoverthreebtat=((0.666666666666667*pModel->atatbot)/pInst->btat);
EXIT_IF_ISNAN(((0.666666666666667*pModel->atatbot)/pInst->btat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
umaxbeforelimiting_VS_BS=((twoatatoverthreebtat_VS_BS*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VS_BS_VS_BS=(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VS_BS);
  umaxbeforelimiting_VS_BS_VD_BD=(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VD_BD);
#endif
umaxbeforelimiting_VD_BD=((twoatatoverthreebtat_VD_BD*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VD_BD_VS_BS=(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VS_BS);
  umaxbeforelimiting_VD_BD_VD_BD=(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VD_BD);
#endif
#endif
pInst->umaxbeforelimiting=(pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat);
EXIT_IF_ISNAN((pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat))
{
double m00_sqrt(d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umax_VS_BS=((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VS_BS_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VS_BS_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
umax_VD_BD=((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VD_BD_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VD_BD_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
#endif
pInst->umax=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_fabs(d00_fabs0,pInst->umax)
double m00_sqrt(d00_sqrt1,d00_fabs0)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->umax)
double m10_sqrt(d10_sqrt1,d00_sqrt1,d00_fabs0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
sqrtumax_VS_BS=umax_VS_BS*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VS_BS_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VS_BS+d10_fabs0*umax_VS_BS_VS_BS));
  sqrtumax_VS_BS_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VS_BS+d10_fabs0*umax_VS_BS_VD_BD));
#endif
sqrtumax_VD_BD=umax_VD_BD*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VD_BD_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VD_BD+d10_fabs0*umax_VD_BD_VS_BS));
  sqrtumax_VD_BD_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VD_BD+d10_fabs0*umax_VD_BD_VD_BD));
#endif
#endif
pInst->sqrtumax=d00_sqrt1;
EXIT_IF_ISNAN(d00_sqrt1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umaxpoweronepointfive_VS_BS=((umax_VS_BS*pInst->sqrtumax)+(pInst->umax*sqrtumax_VS_BS));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VS_BS_VS_BS=(+umax_VS_BS_VS_BS*pInst->sqrtumax+umax_VS_BS*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VS_BS);
  umaxpoweronepointfive_VS_BS_VD_BD=(+umax_VS_BS_VD_BD*pInst->sqrtumax+umax_VS_BS*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VD_BD);
#endif
umaxpoweronepointfive_VD_BD=((umax_VD_BD*pInst->sqrtumax)+(pInst->umax*sqrtumax_VD_BD));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VD_BD_VS_BS=(+umax_VD_BD_VS_BS*pInst->sqrtumax+umax_VD_BD*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VS_BS);
  umaxpoweronepointfive_VD_BD_VD_BD=(+umax_VD_BD_VD_BD*pInst->sqrtumax+umax_VD_BD*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VD_BD);
#endif
#endif
pInst->umaxpoweronepointfive=(pInst->umax*pInst->sqrtumax);
EXIT_IF_ISNAN((pInst->umax*pInst->sqrtumax))
if
((((-pModel->PBOT_i)*pModel->one_over_one_minus_PBOT)==(-1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(-1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VS_BS_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
wgamma_VD_BD=(-1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VD_BD_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
#endif
pInst->wgamma=(1/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN((1/(1+(pInst->btat*pInst->umaxpoweronepointfive))))
}
else
{
{
double m00_pow(d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PBOT_i)*pModel->one_over_one_minus_PBOT))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PBOT_i)*pModel->one_over_one_minus_PBOT))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(d10_pow0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=fixme;
  wgamma_VS_BS_VD_BD=fixme;
#endif
wgamma_VD_BD=(d10_pow0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=fixme;
  wgamma_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->wgamma=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wtat_VS_BS=((((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VS_BS_VS_BS=((+wsrh_VS_BS_VS_BS*pInst->wgamma+wsrh_VS_BS*wgamma_VS_BS+wsrh_VS_BS*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VS_BS+wgamma_VS_BS_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VS_BS_VD_BD=((+wsrh_VS_BS_VD_BD*pInst->wgamma+wsrh_VS_BS*wgamma_VD_BD+wsrh_VD_BD*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VD_BD+wgamma_VS_BS_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
wtat_VD_BD=((((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VD_BD_VS_BS=((+wsrh_VD_BD_VS_BS*pInst->wgamma+wsrh_VD_BD*wgamma_VS_BS+wsrh_VS_BS*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VS_BS+wgamma_VD_BD_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VD_BD_VD_BD=((+wsrh_VD_BD_VD_BD*pInst->wgamma+wsrh_VD_BD*wgamma_VD_BD+wsrh_VD_BD*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VD_BD+wgamma_VD_BD_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
#endif
pInst->wtat=((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
EXIT_IF_ISNAN(((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma)))
{
double m00_sqrt(d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ktat_VS_BS=(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VS_BS_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VS_BS/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VS_BS_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VD_BD/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
ktat_VD_BD=(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VD_BD_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VS_BS/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VD_BD_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VD_BD/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
#endif
pInst->ktat=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ltat_VS_BS=((2*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))-umax_VS_BS);
#if defined(_DERIVATE2)
  ltat_VS_BS_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VS_BS))-umax_VS_BS_VS_BS);
  ltat_VS_BS_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VD_BD))-umax_VS_BS_VD_BD);
#endif
ltat_VD_BD=((2*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))-umax_VD_BD);
#if defined(_DERIVATE2)
  ltat_VD_BD_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VS_BS))-umax_VD_BD_VS_BS);
  ltat_VD_BD_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VD_BD))-umax_VD_BD_VD_BD);
#endif
#endif
pInst->ltat=((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax);
EXIT_IF_ISNAN(((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
mtat_VS_BS=(((((pModel->atatbot*twoatatoverthreebtat_VS_BS)*pInst->sqrtumax)+((pModel->atatbot*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS))-(pModel->atatbot*umax_VS_BS))+(0.5*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))));
#if defined(_DERIVATE2)
  mtat_VS_BS_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VS_BS+pModel->atatbot*twoatatoverthreebtat_VS_BS_VS_BS)*pInst->sqrtumax+(pModel->atatbot*twoatatoverthreebtat_VS_BS)*sqrtumax_VS_BS+((pModel->atatbot*twoatatoverthreebtat_VS_BS))*sqrtumax_VS_BS+(pModel->atatbot*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VS_BS+pModel->atatbot*umax_VS_BS_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)));
  mtat_VS_BS_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VS_BS+pModel->atatbot*twoatatoverthreebtat_VS_BS_VD_BD)*pInst->sqrtumax+(pModel->atatbot*twoatatoverthreebtat_VS_BS)*sqrtumax_VD_BD+((pModel->atatbot*twoatatoverthreebtat_VD_BD))*sqrtumax_VS_BS+(pModel->atatbot*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VS_BS+pModel->atatbot*umax_VS_BS_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)));
#endif
mtat_VD_BD=(((((pModel->atatbot*twoatatoverthreebtat_VD_BD)*pInst->sqrtumax)+((pModel->atatbot*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD))-(pModel->atatbot*umax_VD_BD))+(0.5*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))));
#if defined(_DERIVATE2)
  mtat_VD_BD_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VD_BD+pModel->atatbot*twoatatoverthreebtat_VD_BD_VS_BS)*pInst->sqrtumax+(pModel->atatbot*twoatatoverthreebtat_VD_BD)*sqrtumax_VS_BS+((pModel->atatbot*twoatatoverthreebtat_VS_BS))*sqrtumax_VD_BD+(pModel->atatbot*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VD_BD+pModel->atatbot*umax_VD_BD_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)));
  mtat_VD_BD_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VD_BD+pModel->atatbot*twoatatoverthreebtat_VD_BD_VD_BD)*pInst->sqrtumax+(pModel->atatbot*twoatatoverthreebtat_VD_BD)*sqrtumax_VD_BD+((pModel->atatbot*twoatatoverthreebtat_VD_BD))*sqrtumax_VD_BD+(pModel->atatbot*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VD_BD+pModel->atatbot*umax_VD_BD_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)));
#endif
#endif
pInst->mtat=((((pModel->atatbot*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatbot*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN(((((pModel->atatbot*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatbot*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive))))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xerfc_VS_BS=((ltat_VS_BS*pInst->ktat)+((pInst->ltat-1)*ktat_VS_BS));
#if defined(_DERIVATE2)
  xerfc_VS_BS_VS_BS=(+(+ltat_VS_BS_VS_BS-0.0)*pInst->ktat+ltat_VS_BS*ktat_VS_BS+ltat_VS_BS*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VS_BS);
  xerfc_VS_BS_VD_BD=(+(+ltat_VS_BS_VD_BD-0.0)*pInst->ktat+ltat_VS_BS*ktat_VD_BD+ltat_VD_BD*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VD_BD);
#endif
xerfc_VD_BD=((ltat_VD_BD*pInst->ktat)+((pInst->ltat-1)*ktat_VD_BD));
#if defined(_DERIVATE2)
  xerfc_VD_BD_VS_BS=(+(+ltat_VD_BD_VS_BS-0.0)*pInst->ktat+ltat_VD_BD*ktat_VS_BS+ltat_VS_BS*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VS_BS);
  xerfc_VD_BD_VD_BD=(+(+ltat_VD_BD_VD_BD-0.0)*pInst->ktat+ltat_VD_BD*ktat_VD_BD+ltat_VD_BD*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VD_BD);
#endif
#endif
pInst->xerfc=((pInst->ltat-1)*pInst->ktat);
EXIT_IF_ISNAN(((pInst->ltat-1)*pInst->ktat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ysq_VS_BS=((xerfc_VS_BS*pInst->xerfc)+(pInst->xerfc*xerfc_VS_BS));
#if defined(_DERIVATE2)
  ysq_VS_BS_VS_BS=(+xerfc_VS_BS_VS_BS*pInst->xerfc+xerfc_VS_BS*xerfc_VS_BS+xerfc_VS_BS*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VS_BS);
  ysq_VS_BS_VD_BD=(+xerfc_VS_BS_VD_BD*pInst->xerfc+xerfc_VS_BS*xerfc_VD_BD+xerfc_VD_BD*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VD_BD);
#endif
ysq_VD_BD=((xerfc_VD_BD*pInst->xerfc)+(pInst->xerfc*xerfc_VD_BD));
#if defined(_DERIVATE2)
  ysq_VD_BD_VS_BS=(+xerfc_VD_BD_VS_BS*pInst->xerfc+xerfc_VD_BD*xerfc_VS_BS+xerfc_VS_BS*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VS_BS);
  ysq_VD_BD_VD_BD=(+xerfc_VD_BD_VD_BD*pInst->xerfc+xerfc_VD_BD*xerfc_VD_BD+xerfc_VD_BD*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VD_BD);
#endif
#endif
pInst->ysq=(pInst->xerfc*pInst->xerfc);
EXIT_IF_ISNAN((pInst->xerfc*pInst->xerfc))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(pModel->perfc*xerfc_VS_BS)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(pModel->perfc*xerfc_VD_BD)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1+(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1+(pModel->perfc*pInst->xerfc))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(-(pModel->perfc*xerfc_VS_BS))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(-(pModel->perfc*xerfc_VD_BD))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1-(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1-(pModel->perfc*pInst->xerfc))))
}
if
((((-pInst->ysq)+pInst->mtat)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,((-pInst->ysq)+pInst->mtat))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((-ysq_VS_BS)+mtat_VS_BS)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VS_BS));
  tmp_VS_BS_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VD_BD));
#endif
tmp_VD_BD=((-ysq_VD_BD)+mtat_VD_BD)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VS_BS));
  tmp_VD_BD_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VD_BD));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
erfcpos_VS_BS=(((((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS));
#if defined(_DERIVATE2)
  erfcpos_VS_BS_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VS_BS);
  erfcpos_VS_BS_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VD_BD);
#endif
erfcpos_VD_BD=(((((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD));
#if defined(_DERIVATE2)
  erfcpos_VD_BD_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VS_BS);
  erfcpos_VD_BD_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->erfcpos=((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp);
EXIT_IF_ISNAN(((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=erfcpos_VS_BS;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=erfcpos_VS_BS_VS_BS;
  erfctimesexpmtat_VS_BS_VD_BD=erfcpos_VS_BS_VD_BD;
#endif
erfctimesexpmtat_VD_BD=erfcpos_VD_BD;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=erfcpos_VD_BD_VS_BS;
  erfctimesexpmtat_VD_BD_VD_BD=erfcpos_VD_BD_VD_BD;
#endif
#endif
pInst->erfctimesexpmtat=pInst->erfcpos;
EXIT_IF_ISNAN(pInst->erfcpos)
}
else
{
if
((pInst->mtat>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,pInst->mtat)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=mtat_VS_BS*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VS_BS+d10_exp0*mtat_VS_BS_VS_BS);
  tmp_VS_BS_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VS_BS+d10_exp0*mtat_VS_BS_VD_BD);
#endif
tmp_VD_BD=mtat_VD_BD*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VD_BD+d10_exp0*mtat_VD_BD_VS_BS);
  tmp_VD_BD_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VD_BD+d10_exp0*mtat_VD_BD_VD_BD);
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=((2*tmp_VS_BS)-erfcpos_VS_BS);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+2*tmp_VS_BS_VS_BS)-erfcpos_VS_BS_VS_BS);
  erfctimesexpmtat_VS_BS_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+2*tmp_VS_BS_VD_BD)-erfcpos_VS_BS_VD_BD);
#endif
erfctimesexpmtat_VD_BD=((2*tmp_VD_BD)-erfcpos_VD_BD);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+2*tmp_VD_BD_VS_BS)-erfcpos_VD_BD_VS_BS);
  erfctimesexpmtat_VD_BD_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+2*tmp_VD_BD_VD_BD)-erfcpos_VD_BD_VD_BD);
#endif
#endif
pInst->erfctimesexpmtat=((2*pInst->tmp)-pInst->erfcpos);
EXIT_IF_ISNAN(((2*pInst->tmp)-pInst->erfcpos))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
gammamax_VS_BS=((1.77245385090551603*0.5)*(((pModel->atatbot*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VS_BS_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatbot*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatbot*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatbot*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VS_BS+pModel->atatbot*erfctimesexpmtat_VS_BS_VS_BS)/pInst->ktat-((pModel->atatbot*erfctimesexpmtat_VS_BS)*ktat_VS_BS+((pModel->atatbot*erfctimesexpmtat_VS_BS))*ktat_VS_BS+(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VS_BS_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatbot*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatbot*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatbot*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VS_BS+pModel->atatbot*erfctimesexpmtat_VS_BS_VD_BD)/pInst->ktat-((pModel->atatbot*erfctimesexpmtat_VS_BS)*ktat_VD_BD+((pModel->atatbot*erfctimesexpmtat_VD_BD))*ktat_VS_BS+(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
gammamax_VD_BD=((1.77245385090551603*0.5)*(((pModel->atatbot*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VD_BD_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatbot*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatbot*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatbot*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VD_BD+pModel->atatbot*erfctimesexpmtat_VD_BD_VS_BS)/pInst->ktat-((pModel->atatbot*erfctimesexpmtat_VD_BD)*ktat_VS_BS+((pModel->atatbot*erfctimesexpmtat_VS_BS))*ktat_VD_BD+(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VD_BD_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatbot*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatbot*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatbot*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VD_BD+pModel->atatbot*erfctimesexpmtat_VD_BD_VD_BD)/pInst->ktat-((pModel->atatbot*erfctimesexpmtat_VD_BD)*ktat_VD_BD+((pModel->atatbot*erfctimesexpmtat_VD_BD))*ktat_VD_BD+(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatbot*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
#endif
pInst->gammamax=((1.77245385090551603*0.5)*((pModel->atatbot*pInst->erfctimesexpmtat)/pInst->ktat));
EXIT_IF_ISNAN(((1.77245385090551603*0.5)*((pModel->atatbot*pInst->erfctimesexpmtat)/pInst->ktat)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=(pModel->CTATBOT_i*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)));
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATBOT_i*(+(+asrh_VS_BS_VS_BS*pInst->gammamax+asrh_VS_BS*gammamax_VS_BS+asrh_VS_BS*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VS_BS)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VS_BS));
  itat_VS_BS_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATBOT_i*(+(+asrh_VS_BS_VD_BD*pInst->gammamax+asrh_VS_BS*gammamax_VD_BD+asrh_VD_BD*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VD_BD)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VD_BD));
#endif
itat_VD_BD=(pModel->CTATBOT_i*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)));
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATBOT_i*(+(+asrh_VD_BD_VS_BS*pInst->gammamax+asrh_VD_BD*gammamax_VS_BS+asrh_VS_BS*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VS_BS)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VS_BS));
  itat_VD_BD_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATBOT_i*(+(+asrh_VD_BD_VD_BD*pInst->gammamax+asrh_VD_BD*gammamax_VD_BD+asrh_VD_BD*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VD_BD)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VD_BD));
#endif
#endif
pInst->itat=(pModel->CTATBOT_i*((pInst->asrh*pInst->gammamax)*pInst->wtat));
EXIT_IF_ISNAN((pModel->CTATBOT_i*((pInst->asrh*pInst->gammamax)*pInst->wtat)))
}
if
((pModel->CBBTBOT_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=0.0;
  ibbt_VS_BS_VD_BD=0.0;
#endif
ibbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=0.0;
  ibbt_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->ibbt=0;
EXIT_IF_ISNAN(0)
}
else
{
if
((pModel->PBOT_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,((pModel->VBIRBOT_i-pInst->vbbt)*pModel->VBIRBOTinv))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pModel->VBIRBOT_i-pInst->vbbt)*pModel->VBIRBOTinv))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vbbt_VS_BS)*pModel->VBIRBOTinv*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt(((pModel->VBIRBOT_i-pInst->vbbt)*pModel->VBIRBOTinv))*((-vbbt_VS_BS)*pModel->VBIRBOTinv)*(-vbbt_VS_BS)*pModel->VBIRBOTinv+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VS_BS)*pModel->VBIRBOTinv+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRBOT_i-pInst->vbbt)*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt(((pModel->VBIRBOT_i-pInst->vbbt)*pModel->VBIRBOTinv))*((-vbbt_VD_BD)*pModel->VBIRBOTinv)*(-vbbt_VS_BS)*pModel->VBIRBOTinv+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VD_BD)*pModel->VBIRBOTinv+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRBOT_i-pInst->vbbt)*0.0));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,((pModel->VBIRBOT_i-pInst->vbbt)*pModel->VBIRBOTinv),pModel->PBOT_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,((pModel->VBIRBOT_i-pInst->vbbt)*pModel->VBIRBOTinv),pModel->PBOT_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vbbt_VS_BS)*pModel->VBIRBOTinv);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Fmaxr_VS_BS=(pModel->one_over_one_minus_PBOT*(((-vbbt_VS_BS)*pModel->wdepnulrinvbot*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VS_BS_VS_BS=(+0.0*(((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvbot)*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvbot*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PBOT*((+(+0.0-vbbt_VS_BS_VS_BS)*pModel->wdepnulrinvbot+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRBOT_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvbot*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvbot)*tmp_VS_BS+((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VS_BS_VD_BD=(+0.0*(((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvbot)*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvbot*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PBOT*((+(+0.0-vbbt_VS_BS_VD_BD)*pModel->wdepnulrinvbot+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRBOT_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvbot*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvbot)*tmp_VS_BS+((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
Fmaxr_VD_BD=(pModel->one_over_one_minus_PBOT*(((-vbbt_VD_BD)*pModel->wdepnulrinvbot*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VD_BD_VS_BS=(+0.0*(((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvbot)*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvbot*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PBOT*((+(+0.0-vbbt_VD_BD_VS_BS)*pModel->wdepnulrinvbot+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRBOT_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvbot*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvbot)*tmp_VD_BD+((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VD_BD_VD_BD=(+0.0*(((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvbot)*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvbot*pInst->tmp-((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PBOT*((+(+0.0-vbbt_VD_BD_VD_BD)*pModel->wdepnulrinvbot+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRBOT_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvbot*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvbot)*tmp_VD_BD+((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)*tmp_VD_BD*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
#endif
pInst->Fmaxr=(pModel->one_over_one_minus_PBOT*(((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)/pInst->tmp));
EXIT_IF_ISNAN((pModel->one_over_one_minus_PBOT*(((pModel->VBIRBOT_i-pInst->vbbt)*pModel->wdepnulrinvbot)/pInst->tmp)))
{
double m00_fabs(d00_fabs0,((-pModel->fbbtbot)/pInst->Fmaxr))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,((-pModel->fbbtbot)/pInst->Fmaxr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VS_BS_VD_BD=(m20_exp(((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
tmp_VD_BD=(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VD_BD_VD_BD=(m20_exp(((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((((-pModel->fbbtbot)/pInst->Fmaxr)<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot)/pInst->Fmaxr))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(1.0e100*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+0.0*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VS_BS_VD_BD=(+0.0*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
tmp_VD_BD=(1.0e100*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+0.0*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtbot)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VD_BD_VD_BD=(+0.0*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtbot)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
pInst->tmp=(1.0e100*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=(pModel->CBBTBOT_i*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)));
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTBOT_i*(+(+(+Vjun_s_VS_BS_VS_BS*pInst->Fmaxr+Vjun_s_VS_BS*Fmaxr_VS_BS+Vjun_s_VS_BS*Fmaxr_VS_BS+Vjun_s*Fmaxr_VS_BS_VS_BS)*pInst->Fmaxr+((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*Fmaxr_VS_BS+(((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*Fmaxr_VS_BS+(Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS_VS_BS)*pInst->tmp+((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VS_BS+((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VS_BS+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VS_BS));
  ibbt_VS_BS_VD_BD=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTBOT_i*(+(+(+0.0*pInst->Fmaxr+Vjun_s_VS_BS*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+Vjun_s*Fmaxr_VS_BS_VD_BD)*pInst->Fmaxr+((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*Fmaxr_VD_BD+((Vjun_s*Fmaxr_VD_BD))*Fmaxr_VS_BS+(Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS_VD_BD)*pInst->tmp+((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VD_BD+(((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VS_BS+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VD_BD));
#endif
ibbt_VD_BD=(pModel->CBBTBOT_i*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)));
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTBOT_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VS_BS+Vjun_s_VS_BS*Fmaxr_VD_BD+Vjun_s*Fmaxr_VD_BD_VS_BS)*pInst->Fmaxr+(Vjun_s*Fmaxr_VD_BD)*Fmaxr_VS_BS+(((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*Fmaxr_VD_BD+(Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD_VS_BS)*pInst->tmp+(((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VS_BS+((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VD_BD+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VS_BS));
  ibbt_VD_BD_VD_BD=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTBOT_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+Vjun_s*Fmaxr_VD_BD_VD_BD)*pInst->Fmaxr+(Vjun_s*Fmaxr_VD_BD)*Fmaxr_VD_BD+((Vjun_s*Fmaxr_VD_BD))*Fmaxr_VD_BD+(Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD_VD_BD)*pInst->tmp+(((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VD_BD+(((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VD_BD+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VD_BD));
#endif
#endif
pInst->ibbt=(pModel->CBBTBOT_i*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp));
EXIT_IF_ISNAN((pModel->CBBTBOT_i*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)))
}
if
((pModel->VBRBOT_i>1000))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=0.0;
  fbreakdown_VS_BS_VD_BD=0.0;
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=1;
EXIT_IF_ISNAN(1)
}
else
{
if
((pInst->vav>((-0.999)*pModel->VBRBOT_i)))
{
if
((pModel->PBRBOT_i==4))
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvbot))
double m00_fabs(d00_fabs1,(pInst->vav*pModel->VBRinvbot))
double m00_fabs(d00_fabs2,(pInst->vav*pModel->VBRinvbot))
double m00_fabs(d00_fabs3,(pInst->vav*pModel->VBRinvbot))
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvbot))
double m10_fabs(d10_fabs1,d00_fabs1,(pInst->vav*pModel->VBRinvbot))
double m10_fabs(d10_fabs2,d00_fabs2,(pInst->vav*pModel->VBRinvbot))
double m10_fabs(d10_fabs3,d00_fabs3,(pInst->vav*pModel->VBRinvbot))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((((((vav_VS_BS*pModel->VBRinvbot*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvbot*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VS_BS*pModel->VBRinvbot*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvbot))*(vav_VS_BS*pModel->VBRinvbot)*vav_VS_BS*pModel->VBRinvbot+d10_fabs0*(+vav_VS_BS_VS_BS*pModel->VBRinvbot+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvbot*d10_fabs0*(vav_VS_BS*pModel->VBRinvbot)*d10_fabs1+(vav_VS_BS*pModel->VBRinvbot)*d10_fabs0*vav_VS_BS*pModel->VBRinvbot*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvbot))*(vav_VS_BS*pModel->VBRinvbot)*vav_VS_BS*pModel->VBRinvbot+d10_fabs1*(+vav_VS_BS_VS_BS*pModel->VBRinvbot+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvbot*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot*d10_fabs1))*(vav_VS_BS*pModel->VBRinvbot)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvbot)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvbot)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvbot*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvbot))*(vav_VS_BS*pModel->VBRinvbot)*vav_VS_BS*pModel->VBRinvbot+d10_fabs2*(+vav_VS_BS_VS_BS*pModel->VBRinvbot+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvbot*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvbot*d10_fabs2))*(vav_VS_BS*pModel->VBRinvbot)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvbot)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvbot)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvbot)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvbot*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvbot))*(vav_VS_BS*pModel->VBRinvbot)*vav_VS_BS*pModel->VBRinvbot+d10_fabs3*(+vav_VS_BS_VS_BS*pModel->VBRinvbot+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VS_BS_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvbot))*(vav_VD_BD*pModel->VBRinvbot)*vav_VS_BS*pModel->VBRinvbot+d10_fabs0*(+vav_VS_BS_VD_BD*pModel->VBRinvbot+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvbot*d10_fabs0*(vav_VD_BD*pModel->VBRinvbot)*d10_fabs1+(vav_VD_BD*pModel->VBRinvbot)*d10_fabs0*vav_VS_BS*pModel->VBRinvbot*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvbot))*(vav_VD_BD*pModel->VBRinvbot)*vav_VS_BS*pModel->VBRinvbot+d10_fabs1*(+vav_VS_BS_VD_BD*pModel->VBRinvbot+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvbot*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot*d10_fabs1))*(vav_VD_BD*pModel->VBRinvbot)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvbot)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvbot)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvbot*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvbot))*(vav_VD_BD*pModel->VBRinvbot)*vav_VS_BS*pModel->VBRinvbot+d10_fabs2*(+vav_VS_BS_VD_BD*pModel->VBRinvbot+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvbot*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvbot*d10_fabs2))*(vav_VD_BD*pModel->VBRinvbot)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvbot)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvbot)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvbot)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvbot*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvbot))*(vav_VD_BD*pModel->VBRinvbot)*vav_VS_BS*pModel->VBRinvbot+d10_fabs3*(+vav_VS_BS_VD_BD*pModel->VBRinvbot+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=(((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3);
EXIT_IF_ISNAN((((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3))
}
}
else
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvbot))
double m00_pow(d00_pow1,d00_fabs0,pModel->PBRBOT_i)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvbot))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->PBRBOT_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow1*vav_VS_BS*pModel->VBRinvbot*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=(-1*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VS_BS_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
fbreakdown_VD_BD=(-1*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VD_BD_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
#endif
pInst->fbreakdown=(1/(1-pInst->tmp));
EXIT_IF_ISNAN((1/(1-pInst->tmp)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=vav_VS_BS*pModel->slopebot;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(+0.0+(+(+vav_VS_BS_VS_BS+(+0.0*pModel->VBRBOT_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopebot+vav_VS_BS*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRBOT_i))*0.0));
  fbreakdown_VS_BS_VD_BD=(+0.0+(+(+vav_VS_BS_VD_BD+(+0.0*pModel->VBRBOT_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopebot+vav_VS_BS*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRBOT_i))*0.0));
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=(pModel->fstopbot+((pInst->vav+(0.999*pModel->VBRBOT_i))*pModel->slopebot));
EXIT_IF_ISNAN((pModel->fstopbot+((pInst->vav+(0.999*pModel->VBRBOT_i))*pModel->slopebot)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijunbot_s_VS_BS=(((((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS));
#if defined(_DERIVATE2)
  ijunbot_s_VS_BS_VS_BS=(+(+(+(+id_VS_BS_VS_BS+isrh_VS_BS_VS_BS)+itat_VS_BS_VS_BS)+ibbt_VS_BS_VS_BS)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VS_BS);
  ijunbot_s_VS_BS_VD_BD=(+(+(+(+id_VS_BS_VD_BD+isrh_VS_BS_VD_BD)+itat_VS_BS_VD_BD)+ibbt_VS_BS_VD_BD)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VD_BD);
#endif
ijunbot_s_VD_BD=(((((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD));
#if defined(_DERIVATE2)
  ijunbot_s_VD_BD_VS_BS=(+(+(+(+id_VD_BD_VS_BS+isrh_VD_BD_VS_BS)+itat_VD_BD_VS_BS)+ibbt_VD_BD_VS_BS)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VS_BS);
  ijunbot_s_VD_BD_VD_BD=(+(+(+(+id_VD_BD_VD_BD+isrh_VD_BD_VD_BD)+itat_VD_BD_VD_BD)+ibbt_VD_BD_VD_BD)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VD_BD);
#endif
#endif
ijunbot_s=((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown);
EXIT_IF_ISNAN(((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown))
}
if
((pInst->LSSOURCE_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijunsti_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunsti_s_VS_BS_VS_BS=0.0;
  ijunsti_s_VS_BS_VD_BD=0.0;
#endif
ijunsti_s_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunsti_s_VD_BD_VS_BS=0.0;
  ijunsti_s_VD_BD_VD_BD=0.0;
#endif
#endif
ijunsti_s=0;
EXIT_IF_ISNAN(0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjunsti_s_VD_BD=0.0;
#endif
qjunsti_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  qjunsti_s_VS_BS_VD_BD=0.0;
  qjunsti_s_VS_BS_VS_BS=0.0;
#endif
#endif
qjunsti_s=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
if
((pModel->one_minus_PSTI==0.5))
{
{
double m00_sqrt(d00_sqrt0,(1-(pInst->vj*pModel->vbiinvsti)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->vj*pModel->vbiinvsti)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vj_VS_BS*pModel->vbiinvsti)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvsti)))*(-(vj_VS_BS*pModel->vbiinvsti))*(-vj_VS_BS*pModel->vbiinvsti)+d10_sqrt0*(+0.0-(+vj_VS_BS_VS_BS*pModel->vbiinvsti+vj_VS_BS*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VS_BS_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvsti)))*(-(vj_VD_BD*pModel->vbiinvsti))*(-vj_VS_BS*pModel->vbiinvsti)+d10_sqrt0*(+0.0-(+vj_VS_BS_VD_BD*pModel->vbiinvsti+vj_VS_BS*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
tmp_VD_BD=(-vj_VD_BD*pModel->vbiinvsti)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvsti)))*(-(vj_VS_BS*pModel->vbiinvsti))*(-vj_VD_BD*pModel->vbiinvsti)+d10_sqrt0*(+0.0-(+vj_VD_BD_VS_BS*pModel->vbiinvsti+vj_VD_BD*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VD_BD_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvsti)))*(-(vj_VD_BD*pModel->vbiinvsti))*(-vj_VD_BD*pModel->vbiinvsti)+d10_sqrt0*(+0.0-(+vj_VD_BD_VD_BD*pModel->vbiinvsti+vj_VD_BD*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(1-(pInst->vj*pModel->vbiinvsti)),pModel->one_minus_PSTI)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(pInst->vj*pModel->vbiinvsti)),pModel->one_minus_PSTI)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vj_VS_BS*pModel->vbiinvsti));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vj_VD_BD*pModel->vbiinvsti));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjunsti_s_VD_BD=((pModel->qprefsti*(-tmp_VD_BD))+(pModel->qpref2sti*(-vj_VD_BD)));
#endif
qjunsti_s_VS_BS=((pModel->qprefsti*(-tmp_VS_BS))+(pModel->qpref2sti*(Vjun_s_VS_BS-vj_VS_BS)));
#if defined(_DERIVATE2)
  qjunsti_s_VS_BS_VD_BD=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+pModel->qprefsti*(+0.0-tmp_VS_BS_VD_BD))+(+0.0*(Vjun_s-pInst->vj)+0.0*(-vj_VD_BD)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+pModel->qpref2sti*(+0.0-vj_VS_BS_VD_BD)));
  qjunsti_s_VS_BS_VS_BS=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+pModel->qprefsti*(+0.0-tmp_VS_BS_VS_BS))+(+0.0*(Vjun_s-pInst->vj)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+pModel->qpref2sti*(+Vjun_s_VS_BS_VS_BS-vj_VS_BS_VS_BS)));
#endif
#endif
qjunsti_s=((pModel->qprefsti*(1-pInst->tmp))+(pModel->qpref2sti*(Vjun_s-pInst->vj)));
EXIT_IF_ISNAN(((pModel->qprefsti*(1-pInst->tmp))+(pModel->qpref2sti*(Vjun_s-pInst->vj))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
id_VD_BD=0.0;
#if defined(_DERIVATE2)
  id_VD_BD_VD_BD=0.0;
  id_VD_BD_VS_BS=0.0;
#endif
id_VS_BS=(pModel->idsatsti*idmult_VS_BS);
#if defined(_DERIVATE2)
  id_VS_BS_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VS_BS+pModel->idsatsti*idmult_VS_BS_VD_BD);
  id_VS_BS_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VS_BS+pModel->idsatsti*idmult_VS_BS_VS_BS);
#endif
#endif
pInst->id=(pModel->idsatsti*pInst->idmult);
EXIT_IF_ISNAN((pModel->idsatsti*pInst->idmult))
if
(((pModel->CSRHSTI_i==0)&&(pModel->CTATSTI_i==0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=0.0;
  isrh_VS_BS_VD_BD=0.0;
#endif
isrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=0.0;
  isrh_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->isrh=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbi_minus_vjsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VD_BD_VD_BD=0.0;
  vbi_minus_vjsrh_VD_BD_VS_BS=0.0;
#endif
vbi_minus_vjsrh_VS_BS=(-vjsrh_VS_BS);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VS_BS_VD_BD=(+0.0-vjsrh_VS_BS_VD_BD);
  vbi_minus_vjsrh_VS_BS_VS_BS=(+0.0-vjsrh_VS_BS_VS_BS);
#endif
#endif
pInst->vbi_minus_vjsrh=(pModel->vbisti-pInst->vjsrh);
EXIT_IF_ISNAN((pModel->vbisti-pInst->vjsrh))
{
double m00_sqrt(d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wsrhstep_VD_BD=0.0;
#if defined(_DERIVATE2)
  wsrhstep_VD_BD_VD_BD=0.0;
  wsrhstep_VD_BD_VS_BS=0.0;
#endif
wsrhstep_VS_BS=(-(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VS_BS_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VS_BS_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
#endif
pInst->wsrhstep=(1-d00_sqrt0);
EXIT_IF_ISNAN((1-d00_sqrt0))
}
if
((pModel->PSTI_i==0.5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=0.0;
  dwsrh_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->dwsrh=0;
EXIT_IF_ISNAN(0)
}
else
{
{
double m00_logE(d00_logE0,pInst->wsrhstep)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,pInst->wsrhstep)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(1-(2*pModel->PSTI_i));
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=(+(+((+(+wsrhstep_VS_BS_VD_BD*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VD_BD)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VD_BD)*(1-(2*pModel->PSTI_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PSTI_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VS_BS_VS_BS=(+(+((+(+wsrhstep_VS_BS_VS_BS*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VS_BS)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VS_BS)*(1-(2*pModel->PSTI_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PSTI_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
#endif
pInst->dwsrh=(((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PSTI_i)));
EXIT_IF_ISNAN((((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PSTI_i))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  wsrh_VD_BD_VD_BD=0.0;
  wsrh_VD_BD_VS_BS=0.0;
#endif
wsrh_VS_BS=(wsrhstep_VS_BS+dwsrh_VS_BS);
#if defined(_DERIVATE2)
  wsrh_VS_BS_VD_BD=(+wsrhstep_VS_BS_VD_BD+dwsrh_VS_BS_VD_BD);
  wsrh_VS_BS_VS_BS=(+wsrhstep_VS_BS_VS_BS+dwsrh_VS_BS_VS_BS);
#endif
#endif
pInst->wsrh=(pInst->wsrhstep+pInst->dwsrh);
EXIT_IF_ISNAN((pInst->wsrhstep+pInst->dwsrh))
if
((pModel->PSTI_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv)*vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VS_BS*pModel->VBIRSTIinv+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRSTIinv)*vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VD_BD*pModel->VBIRSTIinv+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv),pModel->PSTI_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv),pModel->PSTI_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wdep_VS_BS=(pModel->wdepnulrsti*tmp_VS_BS);
#if defined(_DERIVATE2)
  wdep_VS_BS_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+pModel->wdepnulrsti*tmp_VS_BS_VS_BS);
  wdep_VS_BS_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+pModel->wdepnulrsti*tmp_VS_BS_VD_BD);
#endif
wdep_VD_BD=(pModel->wdepnulrsti*tmp_VD_BD);
#if defined(_DERIVATE2)
  wdep_VD_BD_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+pModel->wdepnulrsti*tmp_VD_BD_VS_BS);
  wdep_VD_BD_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+pModel->wdepnulrsti*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->wdep=(pModel->wdepnulrsti*pInst->tmp);
EXIT_IF_ISNAN((pModel->wdepnulrsti*pInst->tmp))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
asrh_VS_BS=(pModel->ftdsti*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)));
#if defined(_DERIVATE2)
  asrh_VS_BS_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdsti*(+(+zinv_VS_BS_VS_BS-0.0)*pInst->wdep+zinv_VS_BS*wdep_VS_BS+zinv_VS_BS*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VS_BS));
  asrh_VS_BS_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdsti*(+(+zinv_VS_BS_VD_BD-0.0)*pInst->wdep+zinv_VS_BS*wdep_VD_BD+zinv_VD_BD*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VD_BD));
#endif
asrh_VD_BD=(pModel->ftdsti*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)));
#if defined(_DERIVATE2)
  asrh_VD_BD_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdsti*(+(+zinv_VD_BD_VS_BS-0.0)*pInst->wdep+zinv_VD_BD*wdep_VS_BS+zinv_VS_BS*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VS_BS));
  asrh_VD_BD_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdsti*(+(+zinv_VD_BD_VD_BD-0.0)*pInst->wdep+zinv_VD_BD*wdep_VD_BD+zinv_VD_BD*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VD_BD));
#endif
#endif
pInst->asrh=(pModel->ftdsti*((pInst->zinv-1)*pInst->wdep));
EXIT_IF_ISNAN((pModel->ftdsti*((pInst->zinv-1)*pInst->wdep)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=(pModel->CSRHSTI_i*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)));
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHSTI_i*(+asrh_VS_BS_VS_BS*pInst->wsrh+asrh_VS_BS*wsrh_VS_BS+asrh_VS_BS*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VS_BS));
  isrh_VS_BS_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHSTI_i*(+asrh_VS_BS_VD_BD*pInst->wsrh+asrh_VS_BS*wsrh_VD_BD+asrh_VD_BD*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VD_BD));
#endif
isrh_VD_BD=(pModel->CSRHSTI_i*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)));
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHSTI_i*(+asrh_VD_BD_VS_BS*pInst->wsrh+asrh_VD_BD*wsrh_VS_BS+asrh_VS_BS*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VS_BS));
  isrh_VD_BD_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHSTI_i*(+asrh_VD_BD_VD_BD*pInst->wsrh+asrh_VD_BD*wsrh_VD_BD+asrh_VD_BD*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VD_BD));
#endif
#endif
pInst->isrh=(pModel->CSRHSTI_i*(pInst->asrh*pInst->wsrh));
EXIT_IF_ISNAN((pModel->CSRHSTI_i*(pInst->asrh*pInst->wsrh)))
}
if
((pModel->CTATSTI_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=0.0;
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=0.0;
  itat_VS_BS_VD_BD=0.0;
#endif
itat_VD_BD=0.0;
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=0.0;
  itat_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->itat=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
btat_VS_BS=(pModel->btatpartsti*((wdep_VS_BS*pModel->one_minus_PSTI*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VS_BS_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PSTI)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PSTI)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PSTI*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartsti*((+wdep_VS_BS_VS_BS*pModel->one_minus_PSTI+wdep_VS_BS*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PSTI*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VS_BS_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PSTI)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PSTI)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PSTI*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartsti*((+wdep_VS_BS_VD_BD*pModel->one_minus_PSTI+wdep_VS_BS*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PSTI*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
btat_VD_BD=(pModel->btatpartsti*((wdep_VD_BD*pModel->one_minus_PSTI*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VD_BD_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PSTI)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PSTI)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PSTI*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartsti*((+wdep_VD_BD_VS_BS*pModel->one_minus_PSTI+wdep_VD_BD*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PSTI*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VD_BD_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PSTI)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PSTI)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PSTI*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartsti*((+wdep_VD_BD_VD_BD*pModel->one_minus_PSTI+wdep_VD_BD*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PSTI*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PSTI)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
#endif
pInst->btat=(pModel->btatpartsti*((pInst->wdep*pModel->one_minus_PSTI)/pInst->vbi_minus_vjsrh));
EXIT_IF_ISNAN((pModel->btatpartsti*((pInst->wdep*pModel->one_minus_PSTI)/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
twoatatoverthreebtat_VS_BS=(-(0.666666666666667*pModel->atatsti)*btat_VS_BS/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VS_BS_VS_BS=((+0.0*pModel->atatsti+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatsti)*btat_VS_BS_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatsti)*btat_VS_BS*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VS_BS_VD_BD=((+0.0*pModel->atatsti+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatsti)*btat_VS_BS_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatsti)*btat_VS_BS*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
twoatatoverthreebtat_VD_BD=(-(0.666666666666667*pModel->atatsti)*btat_VD_BD/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VD_BD_VS_BS=((+0.0*pModel->atatsti+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatsti)*btat_VD_BD_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatsti)*btat_VD_BD*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VD_BD_VD_BD=((+0.0*pModel->atatsti+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatsti)*btat_VD_BD_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatsti)*btat_VD_BD*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
#endif
pInst->twoatatoverthreebtat=((0.666666666666667*pModel->atatsti)/pInst->btat);
EXIT_IF_ISNAN(((0.666666666666667*pModel->atatsti)/pInst->btat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
umaxbeforelimiting_VS_BS=((twoatatoverthreebtat_VS_BS*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VS_BS_VS_BS=(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VS_BS);
  umaxbeforelimiting_VS_BS_VD_BD=(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VD_BD);
#endif
umaxbeforelimiting_VD_BD=((twoatatoverthreebtat_VD_BD*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VD_BD_VS_BS=(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VS_BS);
  umaxbeforelimiting_VD_BD_VD_BD=(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VD_BD);
#endif
#endif
pInst->umaxbeforelimiting=(pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat);
EXIT_IF_ISNAN((pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat))
{
double m00_sqrt(d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umax_VS_BS=((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VS_BS_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VS_BS_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
umax_VD_BD=((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VD_BD_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VD_BD_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
#endif
pInst->umax=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_fabs(d00_fabs0,pInst->umax)
double m00_sqrt(d00_sqrt1,d00_fabs0)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->umax)
double m10_sqrt(d10_sqrt1,d00_sqrt1,d00_fabs0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
sqrtumax_VS_BS=umax_VS_BS*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VS_BS_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VS_BS+d10_fabs0*umax_VS_BS_VS_BS));
  sqrtumax_VS_BS_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VS_BS+d10_fabs0*umax_VS_BS_VD_BD));
#endif
sqrtumax_VD_BD=umax_VD_BD*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VD_BD_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VD_BD+d10_fabs0*umax_VD_BD_VS_BS));
  sqrtumax_VD_BD_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VD_BD+d10_fabs0*umax_VD_BD_VD_BD));
#endif
#endif
pInst->sqrtumax=d00_sqrt1;
EXIT_IF_ISNAN(d00_sqrt1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umaxpoweronepointfive_VS_BS=((umax_VS_BS*pInst->sqrtumax)+(pInst->umax*sqrtumax_VS_BS));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VS_BS_VS_BS=(+umax_VS_BS_VS_BS*pInst->sqrtumax+umax_VS_BS*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VS_BS);
  umaxpoweronepointfive_VS_BS_VD_BD=(+umax_VS_BS_VD_BD*pInst->sqrtumax+umax_VS_BS*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VD_BD);
#endif
umaxpoweronepointfive_VD_BD=((umax_VD_BD*pInst->sqrtumax)+(pInst->umax*sqrtumax_VD_BD));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VD_BD_VS_BS=(+umax_VD_BD_VS_BS*pInst->sqrtumax+umax_VD_BD*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VS_BS);
  umaxpoweronepointfive_VD_BD_VD_BD=(+umax_VD_BD_VD_BD*pInst->sqrtumax+umax_VD_BD*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VD_BD);
#endif
#endif
pInst->umaxpoweronepointfive=(pInst->umax*pInst->sqrtumax);
EXIT_IF_ISNAN((pInst->umax*pInst->sqrtumax))
if
((((-pModel->PSTI_i)*pModel->one_over_one_minus_PSTI)==(-1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(-1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VS_BS_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
wgamma_VD_BD=(-1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VD_BD_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
#endif
pInst->wgamma=(1/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN((1/(1+(pInst->btat*pInst->umaxpoweronepointfive))))
}
else
{
{
double m00_pow(d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PSTI_i)*pModel->one_over_one_minus_PSTI))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PSTI_i)*pModel->one_over_one_minus_PSTI))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(d10_pow0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=fixme;
  wgamma_VS_BS_VD_BD=fixme;
#endif
wgamma_VD_BD=(d10_pow0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=fixme;
  wgamma_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->wgamma=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wtat_VS_BS=((((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VS_BS_VS_BS=((+wsrh_VS_BS_VS_BS*pInst->wgamma+wsrh_VS_BS*wgamma_VS_BS+wsrh_VS_BS*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VS_BS+wgamma_VS_BS_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VS_BS_VD_BD=((+wsrh_VS_BS_VD_BD*pInst->wgamma+wsrh_VS_BS*wgamma_VD_BD+wsrh_VD_BD*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VD_BD+wgamma_VS_BS_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
wtat_VD_BD=((((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VD_BD_VS_BS=((+wsrh_VD_BD_VS_BS*pInst->wgamma+wsrh_VD_BD*wgamma_VS_BS+wsrh_VS_BS*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VS_BS+wgamma_VD_BD_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VD_BD_VD_BD=((+wsrh_VD_BD_VD_BD*pInst->wgamma+wsrh_VD_BD*wgamma_VD_BD+wsrh_VD_BD*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VD_BD+wgamma_VD_BD_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
#endif
pInst->wtat=((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
EXIT_IF_ISNAN(((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma)))
{
double m00_sqrt(d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ktat_VS_BS=(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VS_BS_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VS_BS/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VS_BS_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VD_BD/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
ktat_VD_BD=(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VD_BD_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VS_BS/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VD_BD_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VD_BD/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
#endif
pInst->ktat=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ltat_VS_BS=((2*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))-umax_VS_BS);
#if defined(_DERIVATE2)
  ltat_VS_BS_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VS_BS))-umax_VS_BS_VS_BS);
  ltat_VS_BS_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VD_BD))-umax_VS_BS_VD_BD);
#endif
ltat_VD_BD=((2*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))-umax_VD_BD);
#if defined(_DERIVATE2)
  ltat_VD_BD_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VS_BS))-umax_VD_BD_VS_BS);
  ltat_VD_BD_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VD_BD))-umax_VD_BD_VD_BD);
#endif
#endif
pInst->ltat=((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax);
EXIT_IF_ISNAN(((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
mtat_VS_BS=(((((pModel->atatsti*twoatatoverthreebtat_VS_BS)*pInst->sqrtumax)+((pModel->atatsti*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS))-(pModel->atatsti*umax_VS_BS))+(0.5*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))));
#if defined(_DERIVATE2)
  mtat_VS_BS_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VS_BS+pModel->atatsti*twoatatoverthreebtat_VS_BS_VS_BS)*pInst->sqrtumax+(pModel->atatsti*twoatatoverthreebtat_VS_BS)*sqrtumax_VS_BS+((pModel->atatsti*twoatatoverthreebtat_VS_BS))*sqrtumax_VS_BS+(pModel->atatsti*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VS_BS+pModel->atatsti*umax_VS_BS_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)));
  mtat_VS_BS_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VS_BS+pModel->atatsti*twoatatoverthreebtat_VS_BS_VD_BD)*pInst->sqrtumax+(pModel->atatsti*twoatatoverthreebtat_VS_BS)*sqrtumax_VD_BD+((pModel->atatsti*twoatatoverthreebtat_VD_BD))*sqrtumax_VS_BS+(pModel->atatsti*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VS_BS+pModel->atatsti*umax_VS_BS_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)));
#endif
mtat_VD_BD=(((((pModel->atatsti*twoatatoverthreebtat_VD_BD)*pInst->sqrtumax)+((pModel->atatsti*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD))-(pModel->atatsti*umax_VD_BD))+(0.5*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))));
#if defined(_DERIVATE2)
  mtat_VD_BD_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VD_BD+pModel->atatsti*twoatatoverthreebtat_VD_BD_VS_BS)*pInst->sqrtumax+(pModel->atatsti*twoatatoverthreebtat_VD_BD)*sqrtumax_VS_BS+((pModel->atatsti*twoatatoverthreebtat_VS_BS))*sqrtumax_VD_BD+(pModel->atatsti*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VD_BD+pModel->atatsti*umax_VD_BD_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)));
  mtat_VD_BD_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VD_BD+pModel->atatsti*twoatatoverthreebtat_VD_BD_VD_BD)*pInst->sqrtumax+(pModel->atatsti*twoatatoverthreebtat_VD_BD)*sqrtumax_VD_BD+((pModel->atatsti*twoatatoverthreebtat_VD_BD))*sqrtumax_VD_BD+(pModel->atatsti*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VD_BD+pModel->atatsti*umax_VD_BD_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)));
#endif
#endif
pInst->mtat=((((pModel->atatsti*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatsti*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN(((((pModel->atatsti*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatsti*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive))))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xerfc_VS_BS=((ltat_VS_BS*pInst->ktat)+((pInst->ltat-1)*ktat_VS_BS));
#if defined(_DERIVATE2)
  xerfc_VS_BS_VS_BS=(+(+ltat_VS_BS_VS_BS-0.0)*pInst->ktat+ltat_VS_BS*ktat_VS_BS+ltat_VS_BS*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VS_BS);
  xerfc_VS_BS_VD_BD=(+(+ltat_VS_BS_VD_BD-0.0)*pInst->ktat+ltat_VS_BS*ktat_VD_BD+ltat_VD_BD*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VD_BD);
#endif
xerfc_VD_BD=((ltat_VD_BD*pInst->ktat)+((pInst->ltat-1)*ktat_VD_BD));
#if defined(_DERIVATE2)
  xerfc_VD_BD_VS_BS=(+(+ltat_VD_BD_VS_BS-0.0)*pInst->ktat+ltat_VD_BD*ktat_VS_BS+ltat_VS_BS*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VS_BS);
  xerfc_VD_BD_VD_BD=(+(+ltat_VD_BD_VD_BD-0.0)*pInst->ktat+ltat_VD_BD*ktat_VD_BD+ltat_VD_BD*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VD_BD);
#endif
#endif
pInst->xerfc=((pInst->ltat-1)*pInst->ktat);
EXIT_IF_ISNAN(((pInst->ltat-1)*pInst->ktat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ysq_VS_BS=((xerfc_VS_BS*pInst->xerfc)+(pInst->xerfc*xerfc_VS_BS));
#if defined(_DERIVATE2)
  ysq_VS_BS_VS_BS=(+xerfc_VS_BS_VS_BS*pInst->xerfc+xerfc_VS_BS*xerfc_VS_BS+xerfc_VS_BS*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VS_BS);
  ysq_VS_BS_VD_BD=(+xerfc_VS_BS_VD_BD*pInst->xerfc+xerfc_VS_BS*xerfc_VD_BD+xerfc_VD_BD*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VD_BD);
#endif
ysq_VD_BD=((xerfc_VD_BD*pInst->xerfc)+(pInst->xerfc*xerfc_VD_BD));
#if defined(_DERIVATE2)
  ysq_VD_BD_VS_BS=(+xerfc_VD_BD_VS_BS*pInst->xerfc+xerfc_VD_BD*xerfc_VS_BS+xerfc_VS_BS*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VS_BS);
  ysq_VD_BD_VD_BD=(+xerfc_VD_BD_VD_BD*pInst->xerfc+xerfc_VD_BD*xerfc_VD_BD+xerfc_VD_BD*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VD_BD);
#endif
#endif
pInst->ysq=(pInst->xerfc*pInst->xerfc);
EXIT_IF_ISNAN((pInst->xerfc*pInst->xerfc))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(pModel->perfc*xerfc_VS_BS)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(pModel->perfc*xerfc_VD_BD)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1+(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1+(pModel->perfc*pInst->xerfc))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(-(pModel->perfc*xerfc_VS_BS))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(-(pModel->perfc*xerfc_VD_BD))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1-(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1-(pModel->perfc*pInst->xerfc))))
}
if
((((-pInst->ysq)+pInst->mtat)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,((-pInst->ysq)+pInst->mtat))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((-ysq_VS_BS)+mtat_VS_BS)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VS_BS));
  tmp_VS_BS_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VD_BD));
#endif
tmp_VD_BD=((-ysq_VD_BD)+mtat_VD_BD)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VS_BS));
  tmp_VD_BD_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VD_BD));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
erfcpos_VS_BS=(((((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS));
#if defined(_DERIVATE2)
  erfcpos_VS_BS_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VS_BS);
  erfcpos_VS_BS_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VD_BD);
#endif
erfcpos_VD_BD=(((((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD));
#if defined(_DERIVATE2)
  erfcpos_VD_BD_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VS_BS);
  erfcpos_VD_BD_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->erfcpos=((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp);
EXIT_IF_ISNAN(((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=erfcpos_VS_BS;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=erfcpos_VS_BS_VS_BS;
  erfctimesexpmtat_VS_BS_VD_BD=erfcpos_VS_BS_VD_BD;
#endif
erfctimesexpmtat_VD_BD=erfcpos_VD_BD;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=erfcpos_VD_BD_VS_BS;
  erfctimesexpmtat_VD_BD_VD_BD=erfcpos_VD_BD_VD_BD;
#endif
#endif
pInst->erfctimesexpmtat=pInst->erfcpos;
EXIT_IF_ISNAN(pInst->erfcpos)
}
else
{
if
((pInst->mtat>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,pInst->mtat)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=mtat_VS_BS*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VS_BS+d10_exp0*mtat_VS_BS_VS_BS);
  tmp_VS_BS_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VS_BS+d10_exp0*mtat_VS_BS_VD_BD);
#endif
tmp_VD_BD=mtat_VD_BD*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VD_BD+d10_exp0*mtat_VD_BD_VS_BS);
  tmp_VD_BD_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VD_BD+d10_exp0*mtat_VD_BD_VD_BD);
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=((2*tmp_VS_BS)-erfcpos_VS_BS);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+2*tmp_VS_BS_VS_BS)-erfcpos_VS_BS_VS_BS);
  erfctimesexpmtat_VS_BS_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+2*tmp_VS_BS_VD_BD)-erfcpos_VS_BS_VD_BD);
#endif
erfctimesexpmtat_VD_BD=((2*tmp_VD_BD)-erfcpos_VD_BD);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+2*tmp_VD_BD_VS_BS)-erfcpos_VD_BD_VS_BS);
  erfctimesexpmtat_VD_BD_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+2*tmp_VD_BD_VD_BD)-erfcpos_VD_BD_VD_BD);
#endif
#endif
pInst->erfctimesexpmtat=((2*pInst->tmp)-pInst->erfcpos);
EXIT_IF_ISNAN(((2*pInst->tmp)-pInst->erfcpos))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
gammamax_VS_BS=((1.77245385090551603*0.5)*(((pModel->atatsti*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VS_BS_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatsti*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatsti*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatsti*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VS_BS+pModel->atatsti*erfctimesexpmtat_VS_BS_VS_BS)/pInst->ktat-((pModel->atatsti*erfctimesexpmtat_VS_BS)*ktat_VS_BS+((pModel->atatsti*erfctimesexpmtat_VS_BS))*ktat_VS_BS+(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VS_BS_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatsti*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatsti*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatsti*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VS_BS+pModel->atatsti*erfctimesexpmtat_VS_BS_VD_BD)/pInst->ktat-((pModel->atatsti*erfctimesexpmtat_VS_BS)*ktat_VD_BD+((pModel->atatsti*erfctimesexpmtat_VD_BD))*ktat_VS_BS+(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
gammamax_VD_BD=((1.77245385090551603*0.5)*(((pModel->atatsti*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VD_BD_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatsti*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatsti*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatsti*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VD_BD+pModel->atatsti*erfctimesexpmtat_VD_BD_VS_BS)/pInst->ktat-((pModel->atatsti*erfctimesexpmtat_VD_BD)*ktat_VS_BS+((pModel->atatsti*erfctimesexpmtat_VS_BS))*ktat_VD_BD+(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VD_BD_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatsti*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatsti*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatsti*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VD_BD+pModel->atatsti*erfctimesexpmtat_VD_BD_VD_BD)/pInst->ktat-((pModel->atatsti*erfctimesexpmtat_VD_BD)*ktat_VD_BD+((pModel->atatsti*erfctimesexpmtat_VD_BD))*ktat_VD_BD+(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatsti*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
#endif
pInst->gammamax=((1.77245385090551603*0.5)*((pModel->atatsti*pInst->erfctimesexpmtat)/pInst->ktat));
EXIT_IF_ISNAN(((1.77245385090551603*0.5)*((pModel->atatsti*pInst->erfctimesexpmtat)/pInst->ktat)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=(pModel->CTATSTI_i*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)));
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATSTI_i*(+(+asrh_VS_BS_VS_BS*pInst->gammamax+asrh_VS_BS*gammamax_VS_BS+asrh_VS_BS*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VS_BS)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VS_BS));
  itat_VS_BS_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATSTI_i*(+(+asrh_VS_BS_VD_BD*pInst->gammamax+asrh_VS_BS*gammamax_VD_BD+asrh_VD_BD*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VD_BD)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VD_BD));
#endif
itat_VD_BD=(pModel->CTATSTI_i*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)));
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATSTI_i*(+(+asrh_VD_BD_VS_BS*pInst->gammamax+asrh_VD_BD*gammamax_VS_BS+asrh_VS_BS*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VS_BS)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VS_BS));
  itat_VD_BD_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATSTI_i*(+(+asrh_VD_BD_VD_BD*pInst->gammamax+asrh_VD_BD*gammamax_VD_BD+asrh_VD_BD*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VD_BD)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VD_BD));
#endif
#endif
pInst->itat=(pModel->CTATSTI_i*((pInst->asrh*pInst->gammamax)*pInst->wtat));
EXIT_IF_ISNAN((pModel->CTATSTI_i*((pInst->asrh*pInst->gammamax)*pInst->wtat)))
}
if
((pModel->CBBTSTI_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=0.0;
  ibbt_VS_BS_VD_BD=0.0;
#endif
ibbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=0.0;
  ibbt_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->ibbt=0;
EXIT_IF_ISNAN(0)
}
else
{
if
((pModel->PSTI_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,((pModel->VBIRSTI_i-pInst->vbbt)*pModel->VBIRSTIinv))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pModel->VBIRSTI_i-pInst->vbbt)*pModel->VBIRSTIinv))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vbbt_VS_BS)*pModel->VBIRSTIinv*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt(((pModel->VBIRSTI_i-pInst->vbbt)*pModel->VBIRSTIinv))*((-vbbt_VS_BS)*pModel->VBIRSTIinv)*(-vbbt_VS_BS)*pModel->VBIRSTIinv+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VS_BS)*pModel->VBIRSTIinv+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRSTI_i-pInst->vbbt)*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt(((pModel->VBIRSTI_i-pInst->vbbt)*pModel->VBIRSTIinv))*((-vbbt_VD_BD)*pModel->VBIRSTIinv)*(-vbbt_VS_BS)*pModel->VBIRSTIinv+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VD_BD)*pModel->VBIRSTIinv+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRSTI_i-pInst->vbbt)*0.0));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,((pModel->VBIRSTI_i-pInst->vbbt)*pModel->VBIRSTIinv),pModel->PSTI_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,((pModel->VBIRSTI_i-pInst->vbbt)*pModel->VBIRSTIinv),pModel->PSTI_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vbbt_VS_BS)*pModel->VBIRSTIinv);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Fmaxr_VS_BS=(pModel->one_over_one_minus_PSTI*(((-vbbt_VS_BS)*pModel->wdepnulrinvsti*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VS_BS_VS_BS=(+0.0*(((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvsti)*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvsti*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PSTI*((+(+0.0-vbbt_VS_BS_VS_BS)*pModel->wdepnulrinvsti+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRSTI_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvsti*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvsti)*tmp_VS_BS+((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VS_BS_VD_BD=(+0.0*(((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvsti)*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvsti*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PSTI*((+(+0.0-vbbt_VS_BS_VD_BD)*pModel->wdepnulrinvsti+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRSTI_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvsti*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvsti)*tmp_VS_BS+((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
Fmaxr_VD_BD=(pModel->one_over_one_minus_PSTI*(((-vbbt_VD_BD)*pModel->wdepnulrinvsti*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VD_BD_VS_BS=(+0.0*(((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvsti)*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvsti*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PSTI*((+(+0.0-vbbt_VD_BD_VS_BS)*pModel->wdepnulrinvsti+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRSTI_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvsti*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvsti)*tmp_VD_BD+((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VD_BD_VD_BD=(+0.0*(((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvsti)*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvsti*pInst->tmp-((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PSTI*((+(+0.0-vbbt_VD_BD_VD_BD)*pModel->wdepnulrinvsti+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRSTI_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvsti*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvsti)*tmp_VD_BD+((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)*tmp_VD_BD*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
#endif
pInst->Fmaxr=(pModel->one_over_one_minus_PSTI*(((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)/pInst->tmp));
EXIT_IF_ISNAN((pModel->one_over_one_minus_PSTI*(((pModel->VBIRSTI_i-pInst->vbbt)*pModel->wdepnulrinvsti)/pInst->tmp)))
{
double m00_fabs(d00_fabs0,((-pModel->fbbtsti)/pInst->Fmaxr))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,((-pModel->fbbtsti)/pInst->Fmaxr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VS_BS_VD_BD=(m20_exp(((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
tmp_VD_BD=(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VD_BD_VD_BD=(m20_exp(((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((((-pModel->fbbtsti)/pInst->Fmaxr)<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti)/pInst->Fmaxr))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(1.0e100*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+0.0*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VS_BS_VD_BD=(+0.0*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
tmp_VD_BD=(1.0e100*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+0.0*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtsti)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VD_BD_VD_BD=(+0.0*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtsti)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
pInst->tmp=(1.0e100*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=(pModel->CBBTSTI_i*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)));
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTSTI_i*(+(+(+Vjun_s_VS_BS_VS_BS*pInst->Fmaxr+Vjun_s_VS_BS*Fmaxr_VS_BS+Vjun_s_VS_BS*Fmaxr_VS_BS+Vjun_s*Fmaxr_VS_BS_VS_BS)*pInst->Fmaxr+((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*Fmaxr_VS_BS+(((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*Fmaxr_VS_BS+(Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS_VS_BS)*pInst->tmp+((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VS_BS+((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VS_BS+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VS_BS));
  ibbt_VS_BS_VD_BD=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTSTI_i*(+(+(+0.0*pInst->Fmaxr+Vjun_s_VS_BS*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+Vjun_s*Fmaxr_VS_BS_VD_BD)*pInst->Fmaxr+((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*Fmaxr_VD_BD+((Vjun_s*Fmaxr_VD_BD))*Fmaxr_VS_BS+(Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS_VD_BD)*pInst->tmp+((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VD_BD+(((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VS_BS+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VD_BD));
#endif
ibbt_VD_BD=(pModel->CBBTSTI_i*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)));
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTSTI_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VS_BS+Vjun_s_VS_BS*Fmaxr_VD_BD+Vjun_s*Fmaxr_VD_BD_VS_BS)*pInst->Fmaxr+(Vjun_s*Fmaxr_VD_BD)*Fmaxr_VS_BS+(((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*Fmaxr_VD_BD+(Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD_VS_BS)*pInst->tmp+(((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VS_BS+((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VD_BD+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VS_BS));
  ibbt_VD_BD_VD_BD=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTSTI_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+Vjun_s*Fmaxr_VD_BD_VD_BD)*pInst->Fmaxr+(Vjun_s*Fmaxr_VD_BD)*Fmaxr_VD_BD+((Vjun_s*Fmaxr_VD_BD))*Fmaxr_VD_BD+(Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD_VD_BD)*pInst->tmp+(((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VD_BD+(((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VD_BD+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VD_BD));
#endif
#endif
pInst->ibbt=(pModel->CBBTSTI_i*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp));
EXIT_IF_ISNAN((pModel->CBBTSTI_i*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)))
}
if
((pModel->VBRSTI_i>1000))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=0.0;
  fbreakdown_VS_BS_VD_BD=0.0;
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=1;
EXIT_IF_ISNAN(1)
}
else
{
if
((pInst->vav>((-0.999)*pModel->VBRSTI_i)))
{
if
((pModel->PBRSTI_i==4))
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvsti))
double m00_fabs(d00_fabs1,(pInst->vav*pModel->VBRinvsti))
double m00_fabs(d00_fabs2,(pInst->vav*pModel->VBRinvsti))
double m00_fabs(d00_fabs3,(pInst->vav*pModel->VBRinvsti))
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvsti))
double m10_fabs(d10_fabs1,d00_fabs1,(pInst->vav*pModel->VBRinvsti))
double m10_fabs(d10_fabs2,d00_fabs2,(pInst->vav*pModel->VBRinvsti))
double m10_fabs(d10_fabs3,d00_fabs3,(pInst->vav*pModel->VBRinvsti))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((((((vav_VS_BS*pModel->VBRinvsti*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvsti*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VS_BS*pModel->VBRinvsti*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvsti))*(vav_VS_BS*pModel->VBRinvsti)*vav_VS_BS*pModel->VBRinvsti+d10_fabs0*(+vav_VS_BS_VS_BS*pModel->VBRinvsti+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvsti*d10_fabs0*(vav_VS_BS*pModel->VBRinvsti)*d10_fabs1+(vav_VS_BS*pModel->VBRinvsti)*d10_fabs0*vav_VS_BS*pModel->VBRinvsti*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvsti))*(vav_VS_BS*pModel->VBRinvsti)*vav_VS_BS*pModel->VBRinvsti+d10_fabs1*(+vav_VS_BS_VS_BS*pModel->VBRinvsti+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvsti*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti*d10_fabs1))*(vav_VS_BS*pModel->VBRinvsti)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvsti)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvsti)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvsti*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvsti))*(vav_VS_BS*pModel->VBRinvsti)*vav_VS_BS*pModel->VBRinvsti+d10_fabs2*(+vav_VS_BS_VS_BS*pModel->VBRinvsti+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvsti*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvsti*d10_fabs2))*(vav_VS_BS*pModel->VBRinvsti)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvsti)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvsti)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvsti)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvsti*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvsti))*(vav_VS_BS*pModel->VBRinvsti)*vav_VS_BS*pModel->VBRinvsti+d10_fabs3*(+vav_VS_BS_VS_BS*pModel->VBRinvsti+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VS_BS_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvsti))*(vav_VD_BD*pModel->VBRinvsti)*vav_VS_BS*pModel->VBRinvsti+d10_fabs0*(+vav_VS_BS_VD_BD*pModel->VBRinvsti+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvsti*d10_fabs0*(vav_VD_BD*pModel->VBRinvsti)*d10_fabs1+(vav_VD_BD*pModel->VBRinvsti)*d10_fabs0*vav_VS_BS*pModel->VBRinvsti*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvsti))*(vav_VD_BD*pModel->VBRinvsti)*vav_VS_BS*pModel->VBRinvsti+d10_fabs1*(+vav_VS_BS_VD_BD*pModel->VBRinvsti+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvsti*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti*d10_fabs1))*(vav_VD_BD*pModel->VBRinvsti)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvsti)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvsti)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvsti*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvsti))*(vav_VD_BD*pModel->VBRinvsti)*vav_VS_BS*pModel->VBRinvsti+d10_fabs2*(+vav_VS_BS_VD_BD*pModel->VBRinvsti+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvsti*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvsti*d10_fabs2))*(vav_VD_BD*pModel->VBRinvsti)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvsti)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvsti)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvsti)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvsti*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvsti))*(vav_VD_BD*pModel->VBRinvsti)*vav_VS_BS*pModel->VBRinvsti+d10_fabs3*(+vav_VS_BS_VD_BD*pModel->VBRinvsti+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=(((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3);
EXIT_IF_ISNAN((((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3))
}
}
else
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvsti))
double m00_pow(d00_pow1,d00_fabs0,pModel->PBRSTI_i)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvsti))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->PBRSTI_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow1*vav_VS_BS*pModel->VBRinvsti*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=(-1*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VS_BS_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
fbreakdown_VD_BD=(-1*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VD_BD_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
#endif
pInst->fbreakdown=(1/(1-pInst->tmp));
EXIT_IF_ISNAN((1/(1-pInst->tmp)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=vav_VS_BS*pModel->slopesti;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(+0.0+(+(+vav_VS_BS_VS_BS+(+0.0*pModel->VBRSTI_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopesti+vav_VS_BS*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRSTI_i))*0.0));
  fbreakdown_VS_BS_VD_BD=(+0.0+(+(+vav_VS_BS_VD_BD+(+0.0*pModel->VBRSTI_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopesti+vav_VS_BS*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRSTI_i))*0.0));
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=(pModel->fstopsti+((pInst->vav+(0.999*pModel->VBRSTI_i))*pModel->slopesti));
EXIT_IF_ISNAN((pModel->fstopsti+((pInst->vav+(0.999*pModel->VBRSTI_i))*pModel->slopesti)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijunsti_s_VS_BS=(((((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS));
#if defined(_DERIVATE2)
  ijunsti_s_VS_BS_VS_BS=(+(+(+(+id_VS_BS_VS_BS+isrh_VS_BS_VS_BS)+itat_VS_BS_VS_BS)+ibbt_VS_BS_VS_BS)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VS_BS);
  ijunsti_s_VS_BS_VD_BD=(+(+(+(+id_VS_BS_VD_BD+isrh_VS_BS_VD_BD)+itat_VS_BS_VD_BD)+ibbt_VS_BS_VD_BD)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VD_BD);
#endif
ijunsti_s_VD_BD=(((((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD));
#if defined(_DERIVATE2)
  ijunsti_s_VD_BD_VS_BS=(+(+(+(+id_VD_BD_VS_BS+isrh_VD_BD_VS_BS)+itat_VD_BD_VS_BS)+ibbt_VD_BD_VS_BS)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VS_BS);
  ijunsti_s_VD_BD_VD_BD=(+(+(+(+id_VD_BD_VD_BD+isrh_VD_BD_VD_BD)+itat_VD_BD_VD_BD)+ibbt_VD_BD_VD_BD)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VD_BD);
#endif
#endif
ijunsti_s=((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown);
EXIT_IF_ISNAN(((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown))
}
if
((pInst->LGSOURCE_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijungat_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijungat_s_VS_BS_VS_BS=0.0;
  ijungat_s_VS_BS_VD_BD=0.0;
#endif
ijungat_s_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijungat_s_VD_BD_VS_BS=0.0;
  ijungat_s_VD_BD_VD_BD=0.0;
#endif
#endif
ijungat_s=0;
EXIT_IF_ISNAN(0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjungat_s_VD_BD=0.0;
#endif
qjungat_s_VS_BS=0.0;
#if defined(_DERIVATE2)
  qjungat_s_VS_BS_VD_BD=0.0;
  qjungat_s_VS_BS_VS_BS=0.0;
#endif
#endif
qjungat_s=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
if
((pModel->one_minus_PGAT==0.5))
{
{
double m00_sqrt(d00_sqrt0,(1-(pInst->vj*pModel->vbiinvgat)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->vj*pModel->vbiinvgat)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vj_VS_BS*pModel->vbiinvgat)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvgat)))*(-(vj_VS_BS*pModel->vbiinvgat))*(-vj_VS_BS*pModel->vbiinvgat)+d10_sqrt0*(+0.0-(+vj_VS_BS_VS_BS*pModel->vbiinvgat+vj_VS_BS*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VS_BS_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvgat)))*(-(vj_VD_BD*pModel->vbiinvgat))*(-vj_VS_BS*pModel->vbiinvgat)+d10_sqrt0*(+0.0-(+vj_VS_BS_VD_BD*pModel->vbiinvgat+vj_VS_BS*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
tmp_VD_BD=(-vj_VD_BD*pModel->vbiinvgat)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvgat)))*(-(vj_VS_BS*pModel->vbiinvgat))*(-vj_VD_BD*pModel->vbiinvgat)+d10_sqrt0*(+0.0-(+vj_VD_BD_VS_BS*pModel->vbiinvgat+vj_VD_BD*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VD_BD_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvgat)))*(-(vj_VD_BD*pModel->vbiinvgat))*(-vj_VD_BD*pModel->vbiinvgat)+d10_sqrt0*(+0.0-(+vj_VD_BD_VD_BD*pModel->vbiinvgat+vj_VD_BD*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(1-(pInst->vj*pModel->vbiinvgat)),pModel->one_minus_PGAT)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(pInst->vj*pModel->vbiinvgat)),pModel->one_minus_PGAT)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vj_VS_BS*pModel->vbiinvgat));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vj_VD_BD*pModel->vbiinvgat));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(S,GND) */
#if defined(_DERIVATE)
qjungat_s_VD_BD=((pModel->qprefgat*(-tmp_VD_BD))+(pModel->qpref2gat*(-vj_VD_BD)));
#endif
qjungat_s_VS_BS=((pModel->qprefgat*(-tmp_VS_BS))+(pModel->qpref2gat*(Vjun_s_VS_BS-vj_VS_BS)));
#if defined(_DERIVATE2)
  qjungat_s_VS_BS_VD_BD=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+pModel->qprefgat*(+0.0-tmp_VS_BS_VD_BD))+(+0.0*(Vjun_s-pInst->vj)+0.0*(-vj_VD_BD)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+pModel->qpref2gat*(+0.0-vj_VS_BS_VD_BD)));
  qjungat_s_VS_BS_VS_BS=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+pModel->qprefgat*(+0.0-tmp_VS_BS_VS_BS))+(+0.0*(Vjun_s-pInst->vj)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+0.0*(Vjun_s_VS_BS-vj_VS_BS)+pModel->qpref2gat*(+Vjun_s_VS_BS_VS_BS-vj_VS_BS_VS_BS)));
#endif
#endif
qjungat_s=((pModel->qprefgat*(1-pInst->tmp))+(pModel->qpref2gat*(Vjun_s-pInst->vj)));
EXIT_IF_ISNAN(((pModel->qprefgat*(1-pInst->tmp))+(pModel->qpref2gat*(Vjun_s-pInst->vj))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
id_VD_BD=0.0;
#if defined(_DERIVATE2)
  id_VD_BD_VD_BD=0.0;
  id_VD_BD_VS_BS=0.0;
#endif
id_VS_BS=(pModel->idsatgat*idmult_VS_BS);
#if defined(_DERIVATE2)
  id_VS_BS_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VS_BS+pModel->idsatgat*idmult_VS_BS_VD_BD);
  id_VS_BS_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VS_BS+pModel->idsatgat*idmult_VS_BS_VS_BS);
#endif
#endif
pInst->id=(pModel->idsatgat*pInst->idmult);
EXIT_IF_ISNAN((pModel->idsatgat*pInst->idmult))
if
(((pModel->CSRHGAT_i==0)&&(pModel->CTATGAT_i==0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=0.0;
  isrh_VS_BS_VD_BD=0.0;
#endif
isrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=0.0;
  isrh_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->isrh=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbi_minus_vjsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VD_BD_VD_BD=0.0;
  vbi_minus_vjsrh_VD_BD_VS_BS=0.0;
#endif
vbi_minus_vjsrh_VS_BS=(-vjsrh_VS_BS);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VS_BS_VD_BD=(+0.0-vjsrh_VS_BS_VD_BD);
  vbi_minus_vjsrh_VS_BS_VS_BS=(+0.0-vjsrh_VS_BS_VS_BS);
#endif
#endif
pInst->vbi_minus_vjsrh=(pModel->vbigat-pInst->vjsrh);
EXIT_IF_ISNAN((pModel->vbigat-pInst->vjsrh))
{
double m00_sqrt(d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wsrhstep_VD_BD=0.0;
#if defined(_DERIVATE2)
  wsrhstep_VD_BD_VD_BD=0.0;
  wsrhstep_VD_BD_VS_BS=0.0;
#endif
wsrhstep_VS_BS=(-(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VS_BS_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VS_BS_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
#endif
pInst->wsrhstep=(1-d00_sqrt0);
EXIT_IF_ISNAN((1-d00_sqrt0))
}
if
((pModel->PGAT_i==0.5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=0.0;
  dwsrh_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->dwsrh=0;
EXIT_IF_ISNAN(0)
}
else
{
{
double m00_logE(d00_logE0,pInst->wsrhstep)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,pInst->wsrhstep)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(1-(2*pModel->PGAT_i));
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=(+(+((+(+wsrhstep_VS_BS_VD_BD*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VD_BD)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VD_BD)*(1-(2*pModel->PGAT_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PGAT_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VS_BS_VS_BS=(+(+((+(+wsrhstep_VS_BS_VS_BS*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VS_BS)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VS_BS)*(1-(2*pModel->PGAT_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PGAT_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
#endif
pInst->dwsrh=(((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PGAT_i)));
EXIT_IF_ISNAN((((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PGAT_i))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  wsrh_VD_BD_VD_BD=0.0;
  wsrh_VD_BD_VS_BS=0.0;
#endif
wsrh_VS_BS=(wsrhstep_VS_BS+dwsrh_VS_BS);
#if defined(_DERIVATE2)
  wsrh_VS_BS_VD_BD=(+wsrhstep_VS_BS_VD_BD+dwsrh_VS_BS_VD_BD);
  wsrh_VS_BS_VS_BS=(+wsrhstep_VS_BS_VS_BS+dwsrh_VS_BS_VS_BS);
#endif
#endif
pInst->wsrh=(pInst->wsrhstep+pInst->dwsrh);
EXIT_IF_ISNAN((pInst->wsrhstep+pInst->dwsrh))
if
((pModel->PGAT_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRGATinv))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRGATinv))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRGATinv))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv)*vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VS_BS*pModel->VBIRGATinv+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRGATinv))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRGATinv)*vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VD_BD*pModel->VBIRGATinv+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRGATinv),pModel->PGAT_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRGATinv),pModel->PGAT_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wdep_VS_BS=(pModel->wdepnulrgat*tmp_VS_BS);
#if defined(_DERIVATE2)
  wdep_VS_BS_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+pModel->wdepnulrgat*tmp_VS_BS_VS_BS);
  wdep_VS_BS_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+pModel->wdepnulrgat*tmp_VS_BS_VD_BD);
#endif
wdep_VD_BD=(pModel->wdepnulrgat*tmp_VD_BD);
#if defined(_DERIVATE2)
  wdep_VD_BD_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+pModel->wdepnulrgat*tmp_VD_BD_VS_BS);
  wdep_VD_BD_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+pModel->wdepnulrgat*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->wdep=(pModel->wdepnulrgat*pInst->tmp);
EXIT_IF_ISNAN((pModel->wdepnulrgat*pInst->tmp))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
asrh_VS_BS=(pModel->ftdgat*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)));
#if defined(_DERIVATE2)
  asrh_VS_BS_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdgat*(+(+zinv_VS_BS_VS_BS-0.0)*pInst->wdep+zinv_VS_BS*wdep_VS_BS+zinv_VS_BS*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VS_BS));
  asrh_VS_BS_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdgat*(+(+zinv_VS_BS_VD_BD-0.0)*pInst->wdep+zinv_VS_BS*wdep_VD_BD+zinv_VD_BD*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VD_BD));
#endif
asrh_VD_BD=(pModel->ftdgat*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)));
#if defined(_DERIVATE2)
  asrh_VD_BD_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdgat*(+(+zinv_VD_BD_VS_BS-0.0)*pInst->wdep+zinv_VD_BD*wdep_VS_BS+zinv_VS_BS*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VS_BS));
  asrh_VD_BD_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdgat*(+(+zinv_VD_BD_VD_BD-0.0)*pInst->wdep+zinv_VD_BD*wdep_VD_BD+zinv_VD_BD*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VD_BD));
#endif
#endif
pInst->asrh=(pModel->ftdgat*((pInst->zinv-1)*pInst->wdep));
EXIT_IF_ISNAN((pModel->ftdgat*((pInst->zinv-1)*pInst->wdep)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=(pModel->CSRHGAT_i*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)));
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHGAT_i*(+asrh_VS_BS_VS_BS*pInst->wsrh+asrh_VS_BS*wsrh_VS_BS+asrh_VS_BS*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VS_BS));
  isrh_VS_BS_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHGAT_i*(+asrh_VS_BS_VD_BD*pInst->wsrh+asrh_VS_BS*wsrh_VD_BD+asrh_VD_BD*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VD_BD));
#endif
isrh_VD_BD=(pModel->CSRHGAT_i*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)));
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHGAT_i*(+asrh_VD_BD_VS_BS*pInst->wsrh+asrh_VD_BD*wsrh_VS_BS+asrh_VS_BS*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VS_BS));
  isrh_VD_BD_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHGAT_i*(+asrh_VD_BD_VD_BD*pInst->wsrh+asrh_VD_BD*wsrh_VD_BD+asrh_VD_BD*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VD_BD));
#endif
#endif
pInst->isrh=(pModel->CSRHGAT_i*(pInst->asrh*pInst->wsrh));
EXIT_IF_ISNAN((pModel->CSRHGAT_i*(pInst->asrh*pInst->wsrh)))
}
if
((pModel->CTATGAT_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=0.0;
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=0.0;
  itat_VS_BS_VD_BD=0.0;
#endif
itat_VD_BD=0.0;
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=0.0;
  itat_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->itat=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
btat_VS_BS=(pModel->btatpartgat*((wdep_VS_BS*pModel->one_minus_PGAT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VS_BS_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PGAT)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PGAT)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PGAT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartgat*((+wdep_VS_BS_VS_BS*pModel->one_minus_PGAT+wdep_VS_BS*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PGAT*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VS_BS_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PGAT)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PGAT)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PGAT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartgat*((+wdep_VS_BS_VD_BD*pModel->one_minus_PGAT+wdep_VS_BS*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PGAT*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
btat_VD_BD=(pModel->btatpartgat*((wdep_VD_BD*pModel->one_minus_PGAT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VD_BD_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PGAT)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PGAT)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PGAT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartgat*((+wdep_VD_BD_VS_BS*pModel->one_minus_PGAT+wdep_VD_BD*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PGAT*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VD_BD_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PGAT)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PGAT)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PGAT*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartgat*((+wdep_VD_BD_VD_BD*pModel->one_minus_PGAT+wdep_VD_BD*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PGAT*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PGAT)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
#endif
pInst->btat=(pModel->btatpartgat*((pInst->wdep*pModel->one_minus_PGAT)/pInst->vbi_minus_vjsrh));
EXIT_IF_ISNAN((pModel->btatpartgat*((pInst->wdep*pModel->one_minus_PGAT)/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
twoatatoverthreebtat_VS_BS=(-(0.666666666666667*pModel->atatgat)*btat_VS_BS/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VS_BS_VS_BS=((+0.0*pModel->atatgat+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatgat)*btat_VS_BS_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatgat)*btat_VS_BS*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VS_BS_VD_BD=((+0.0*pModel->atatgat+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatgat)*btat_VS_BS_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatgat)*btat_VS_BS*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
twoatatoverthreebtat_VD_BD=(-(0.666666666666667*pModel->atatgat)*btat_VD_BD/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VD_BD_VS_BS=((+0.0*pModel->atatgat+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatgat)*btat_VD_BD_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatgat)*btat_VD_BD*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VD_BD_VD_BD=((+0.0*pModel->atatgat+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatgat)*btat_VD_BD_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatgat)*btat_VD_BD*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
#endif
pInst->twoatatoverthreebtat=((0.666666666666667*pModel->atatgat)/pInst->btat);
EXIT_IF_ISNAN(((0.666666666666667*pModel->atatgat)/pInst->btat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
umaxbeforelimiting_VS_BS=((twoatatoverthreebtat_VS_BS*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VS_BS_VS_BS=(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VS_BS);
  umaxbeforelimiting_VS_BS_VD_BD=(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VD_BD);
#endif
umaxbeforelimiting_VD_BD=((twoatatoverthreebtat_VD_BD*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VD_BD_VS_BS=(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VS_BS);
  umaxbeforelimiting_VD_BD_VD_BD=(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VD_BD);
#endif
#endif
pInst->umaxbeforelimiting=(pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat);
EXIT_IF_ISNAN((pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat))
{
double m00_sqrt(d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umax_VS_BS=((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VS_BS_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VS_BS_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
umax_VD_BD=((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VD_BD_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VD_BD_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
#endif
pInst->umax=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_fabs(d00_fabs0,pInst->umax)
double m00_sqrt(d00_sqrt1,d00_fabs0)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->umax)
double m10_sqrt(d10_sqrt1,d00_sqrt1,d00_fabs0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
sqrtumax_VS_BS=umax_VS_BS*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VS_BS_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VS_BS+d10_fabs0*umax_VS_BS_VS_BS));
  sqrtumax_VS_BS_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VS_BS+d10_fabs0*umax_VS_BS_VD_BD));
#endif
sqrtumax_VD_BD=umax_VD_BD*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VD_BD_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VD_BD+d10_fabs0*umax_VD_BD_VS_BS));
  sqrtumax_VD_BD_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VD_BD+d10_fabs0*umax_VD_BD_VD_BD));
#endif
#endif
pInst->sqrtumax=d00_sqrt1;
EXIT_IF_ISNAN(d00_sqrt1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umaxpoweronepointfive_VS_BS=((umax_VS_BS*pInst->sqrtumax)+(pInst->umax*sqrtumax_VS_BS));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VS_BS_VS_BS=(+umax_VS_BS_VS_BS*pInst->sqrtumax+umax_VS_BS*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VS_BS);
  umaxpoweronepointfive_VS_BS_VD_BD=(+umax_VS_BS_VD_BD*pInst->sqrtumax+umax_VS_BS*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VD_BD);
#endif
umaxpoweronepointfive_VD_BD=((umax_VD_BD*pInst->sqrtumax)+(pInst->umax*sqrtumax_VD_BD));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VD_BD_VS_BS=(+umax_VD_BD_VS_BS*pInst->sqrtumax+umax_VD_BD*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VS_BS);
  umaxpoweronepointfive_VD_BD_VD_BD=(+umax_VD_BD_VD_BD*pInst->sqrtumax+umax_VD_BD*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VD_BD);
#endif
#endif
pInst->umaxpoweronepointfive=(pInst->umax*pInst->sqrtumax);
EXIT_IF_ISNAN((pInst->umax*pInst->sqrtumax))
if
((((-pModel->PGAT_i)*pModel->one_over_one_minus_PGAT)==(-1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(-1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VS_BS_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
wgamma_VD_BD=(-1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VD_BD_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
#endif
pInst->wgamma=(1/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN((1/(1+(pInst->btat*pInst->umaxpoweronepointfive))))
}
else
{
{
double m00_pow(d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PGAT_i)*pModel->one_over_one_minus_PGAT))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PGAT_i)*pModel->one_over_one_minus_PGAT))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(d10_pow0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=fixme;
  wgamma_VS_BS_VD_BD=fixme;
#endif
wgamma_VD_BD=(d10_pow0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=fixme;
  wgamma_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->wgamma=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wtat_VS_BS=((((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VS_BS_VS_BS=((+wsrh_VS_BS_VS_BS*pInst->wgamma+wsrh_VS_BS*wgamma_VS_BS+wsrh_VS_BS*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VS_BS+wgamma_VS_BS_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VS_BS_VD_BD=((+wsrh_VS_BS_VD_BD*pInst->wgamma+wsrh_VS_BS*wgamma_VD_BD+wsrh_VD_BD*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VD_BD+wgamma_VS_BS_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
wtat_VD_BD=((((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VD_BD_VS_BS=((+wsrh_VD_BD_VS_BS*pInst->wgamma+wsrh_VD_BD*wgamma_VS_BS+wsrh_VS_BS*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VS_BS+wgamma_VD_BD_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VD_BD_VD_BD=((+wsrh_VD_BD_VD_BD*pInst->wgamma+wsrh_VD_BD*wgamma_VD_BD+wsrh_VD_BD*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VD_BD+wgamma_VD_BD_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
#endif
pInst->wtat=((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
EXIT_IF_ISNAN(((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma)))
{
double m00_sqrt(d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ktat_VS_BS=(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VS_BS_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VS_BS/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VS_BS_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VD_BD/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
ktat_VD_BD=(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VD_BD_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VS_BS/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VD_BD_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VD_BD/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
#endif
pInst->ktat=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ltat_VS_BS=((2*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))-umax_VS_BS);
#if defined(_DERIVATE2)
  ltat_VS_BS_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VS_BS))-umax_VS_BS_VS_BS);
  ltat_VS_BS_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VD_BD))-umax_VS_BS_VD_BD);
#endif
ltat_VD_BD=((2*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))-umax_VD_BD);
#if defined(_DERIVATE2)
  ltat_VD_BD_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VS_BS))-umax_VD_BD_VS_BS);
  ltat_VD_BD_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VD_BD))-umax_VD_BD_VD_BD);
#endif
#endif
pInst->ltat=((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax);
EXIT_IF_ISNAN(((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
mtat_VS_BS=(((((pModel->atatgat*twoatatoverthreebtat_VS_BS)*pInst->sqrtumax)+((pModel->atatgat*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS))-(pModel->atatgat*umax_VS_BS))+(0.5*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))));
#if defined(_DERIVATE2)
  mtat_VS_BS_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VS_BS+pModel->atatgat*twoatatoverthreebtat_VS_BS_VS_BS)*pInst->sqrtumax+(pModel->atatgat*twoatatoverthreebtat_VS_BS)*sqrtumax_VS_BS+((pModel->atatgat*twoatatoverthreebtat_VS_BS))*sqrtumax_VS_BS+(pModel->atatgat*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VS_BS+pModel->atatgat*umax_VS_BS_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)));
  mtat_VS_BS_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VS_BS+pModel->atatgat*twoatatoverthreebtat_VS_BS_VD_BD)*pInst->sqrtumax+(pModel->atatgat*twoatatoverthreebtat_VS_BS)*sqrtumax_VD_BD+((pModel->atatgat*twoatatoverthreebtat_VD_BD))*sqrtumax_VS_BS+(pModel->atatgat*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VS_BS+pModel->atatgat*umax_VS_BS_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)));
#endif
mtat_VD_BD=(((((pModel->atatgat*twoatatoverthreebtat_VD_BD)*pInst->sqrtumax)+((pModel->atatgat*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD))-(pModel->atatgat*umax_VD_BD))+(0.5*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))));
#if defined(_DERIVATE2)
  mtat_VD_BD_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VD_BD+pModel->atatgat*twoatatoverthreebtat_VD_BD_VS_BS)*pInst->sqrtumax+(pModel->atatgat*twoatatoverthreebtat_VD_BD)*sqrtumax_VS_BS+((pModel->atatgat*twoatatoverthreebtat_VS_BS))*sqrtumax_VD_BD+(pModel->atatgat*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VD_BD+pModel->atatgat*umax_VD_BD_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)));
  mtat_VD_BD_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VD_BD+pModel->atatgat*twoatatoverthreebtat_VD_BD_VD_BD)*pInst->sqrtumax+(pModel->atatgat*twoatatoverthreebtat_VD_BD)*sqrtumax_VD_BD+((pModel->atatgat*twoatatoverthreebtat_VD_BD))*sqrtumax_VD_BD+(pModel->atatgat*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VD_BD+pModel->atatgat*umax_VD_BD_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)));
#endif
#endif
pInst->mtat=((((pModel->atatgat*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatgat*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN(((((pModel->atatgat*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatgat*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive))))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xerfc_VS_BS=((ltat_VS_BS*pInst->ktat)+((pInst->ltat-1)*ktat_VS_BS));
#if defined(_DERIVATE2)
  xerfc_VS_BS_VS_BS=(+(+ltat_VS_BS_VS_BS-0.0)*pInst->ktat+ltat_VS_BS*ktat_VS_BS+ltat_VS_BS*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VS_BS);
  xerfc_VS_BS_VD_BD=(+(+ltat_VS_BS_VD_BD-0.0)*pInst->ktat+ltat_VS_BS*ktat_VD_BD+ltat_VD_BD*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VD_BD);
#endif
xerfc_VD_BD=((ltat_VD_BD*pInst->ktat)+((pInst->ltat-1)*ktat_VD_BD));
#if defined(_DERIVATE2)
  xerfc_VD_BD_VS_BS=(+(+ltat_VD_BD_VS_BS-0.0)*pInst->ktat+ltat_VD_BD*ktat_VS_BS+ltat_VS_BS*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VS_BS);
  xerfc_VD_BD_VD_BD=(+(+ltat_VD_BD_VD_BD-0.0)*pInst->ktat+ltat_VD_BD*ktat_VD_BD+ltat_VD_BD*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VD_BD);
#endif
#endif
pInst->xerfc=((pInst->ltat-1)*pInst->ktat);
EXIT_IF_ISNAN(((pInst->ltat-1)*pInst->ktat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ysq_VS_BS=((xerfc_VS_BS*pInst->xerfc)+(pInst->xerfc*xerfc_VS_BS));
#if defined(_DERIVATE2)
  ysq_VS_BS_VS_BS=(+xerfc_VS_BS_VS_BS*pInst->xerfc+xerfc_VS_BS*xerfc_VS_BS+xerfc_VS_BS*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VS_BS);
  ysq_VS_BS_VD_BD=(+xerfc_VS_BS_VD_BD*pInst->xerfc+xerfc_VS_BS*xerfc_VD_BD+xerfc_VD_BD*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VD_BD);
#endif
ysq_VD_BD=((xerfc_VD_BD*pInst->xerfc)+(pInst->xerfc*xerfc_VD_BD));
#if defined(_DERIVATE2)
  ysq_VD_BD_VS_BS=(+xerfc_VD_BD_VS_BS*pInst->xerfc+xerfc_VD_BD*xerfc_VS_BS+xerfc_VS_BS*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VS_BS);
  ysq_VD_BD_VD_BD=(+xerfc_VD_BD_VD_BD*pInst->xerfc+xerfc_VD_BD*xerfc_VD_BD+xerfc_VD_BD*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VD_BD);
#endif
#endif
pInst->ysq=(pInst->xerfc*pInst->xerfc);
EXIT_IF_ISNAN((pInst->xerfc*pInst->xerfc))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(pModel->perfc*xerfc_VS_BS)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(pModel->perfc*xerfc_VD_BD)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1+(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1+(pModel->perfc*pInst->xerfc))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(-(pModel->perfc*xerfc_VS_BS))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(-(pModel->perfc*xerfc_VD_BD))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1-(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1-(pModel->perfc*pInst->xerfc))))
}
if
((((-pInst->ysq)+pInst->mtat)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,((-pInst->ysq)+pInst->mtat))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((-ysq_VS_BS)+mtat_VS_BS)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VS_BS));
  tmp_VS_BS_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VD_BD));
#endif
tmp_VD_BD=((-ysq_VD_BD)+mtat_VD_BD)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VS_BS));
  tmp_VD_BD_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VD_BD));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
erfcpos_VS_BS=(((((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS));
#if defined(_DERIVATE2)
  erfcpos_VS_BS_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VS_BS);
  erfcpos_VS_BS_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VD_BD);
#endif
erfcpos_VD_BD=(((((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD));
#if defined(_DERIVATE2)
  erfcpos_VD_BD_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VS_BS);
  erfcpos_VD_BD_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->erfcpos=((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp);
EXIT_IF_ISNAN(((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=erfcpos_VS_BS;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=erfcpos_VS_BS_VS_BS;
  erfctimesexpmtat_VS_BS_VD_BD=erfcpos_VS_BS_VD_BD;
#endif
erfctimesexpmtat_VD_BD=erfcpos_VD_BD;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=erfcpos_VD_BD_VS_BS;
  erfctimesexpmtat_VD_BD_VD_BD=erfcpos_VD_BD_VD_BD;
#endif
#endif
pInst->erfctimesexpmtat=pInst->erfcpos;
EXIT_IF_ISNAN(pInst->erfcpos)
}
else
{
if
((pInst->mtat>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,pInst->mtat)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=mtat_VS_BS*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VS_BS+d10_exp0*mtat_VS_BS_VS_BS);
  tmp_VS_BS_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VS_BS+d10_exp0*mtat_VS_BS_VD_BD);
#endif
tmp_VD_BD=mtat_VD_BD*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VD_BD+d10_exp0*mtat_VD_BD_VS_BS);
  tmp_VD_BD_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VD_BD+d10_exp0*mtat_VD_BD_VD_BD);
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=((2*tmp_VS_BS)-erfcpos_VS_BS);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+2*tmp_VS_BS_VS_BS)-erfcpos_VS_BS_VS_BS);
  erfctimesexpmtat_VS_BS_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+2*tmp_VS_BS_VD_BD)-erfcpos_VS_BS_VD_BD);
#endif
erfctimesexpmtat_VD_BD=((2*tmp_VD_BD)-erfcpos_VD_BD);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+2*tmp_VD_BD_VS_BS)-erfcpos_VD_BD_VS_BS);
  erfctimesexpmtat_VD_BD_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+2*tmp_VD_BD_VD_BD)-erfcpos_VD_BD_VD_BD);
#endif
#endif
pInst->erfctimesexpmtat=((2*pInst->tmp)-pInst->erfcpos);
EXIT_IF_ISNAN(((2*pInst->tmp)-pInst->erfcpos))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
gammamax_VS_BS=((1.77245385090551603*0.5)*(((pModel->atatgat*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VS_BS_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatgat*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatgat*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatgat*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VS_BS+pModel->atatgat*erfctimesexpmtat_VS_BS_VS_BS)/pInst->ktat-((pModel->atatgat*erfctimesexpmtat_VS_BS)*ktat_VS_BS+((pModel->atatgat*erfctimesexpmtat_VS_BS))*ktat_VS_BS+(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VS_BS_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatgat*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatgat*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatgat*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VS_BS+pModel->atatgat*erfctimesexpmtat_VS_BS_VD_BD)/pInst->ktat-((pModel->atatgat*erfctimesexpmtat_VS_BS)*ktat_VD_BD+((pModel->atatgat*erfctimesexpmtat_VD_BD))*ktat_VS_BS+(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
gammamax_VD_BD=((1.77245385090551603*0.5)*(((pModel->atatgat*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VD_BD_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatgat*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatgat*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatgat*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VD_BD+pModel->atatgat*erfctimesexpmtat_VD_BD_VS_BS)/pInst->ktat-((pModel->atatgat*erfctimesexpmtat_VD_BD)*ktat_VS_BS+((pModel->atatgat*erfctimesexpmtat_VS_BS))*ktat_VD_BD+(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VD_BD_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatgat*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatgat*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatgat*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VD_BD+pModel->atatgat*erfctimesexpmtat_VD_BD_VD_BD)/pInst->ktat-((pModel->atatgat*erfctimesexpmtat_VD_BD)*ktat_VD_BD+((pModel->atatgat*erfctimesexpmtat_VD_BD))*ktat_VD_BD+(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatgat*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
#endif
pInst->gammamax=((1.77245385090551603*0.5)*((pModel->atatgat*pInst->erfctimesexpmtat)/pInst->ktat));
EXIT_IF_ISNAN(((1.77245385090551603*0.5)*((pModel->atatgat*pInst->erfctimesexpmtat)/pInst->ktat)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=(pModel->CTATGAT_i*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)));
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATGAT_i*(+(+asrh_VS_BS_VS_BS*pInst->gammamax+asrh_VS_BS*gammamax_VS_BS+asrh_VS_BS*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VS_BS)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VS_BS));
  itat_VS_BS_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATGAT_i*(+(+asrh_VS_BS_VD_BD*pInst->gammamax+asrh_VS_BS*gammamax_VD_BD+asrh_VD_BD*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VD_BD)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VD_BD));
#endif
itat_VD_BD=(pModel->CTATGAT_i*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)));
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATGAT_i*(+(+asrh_VD_BD_VS_BS*pInst->gammamax+asrh_VD_BD*gammamax_VS_BS+asrh_VS_BS*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VS_BS)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VS_BS));
  itat_VD_BD_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATGAT_i*(+(+asrh_VD_BD_VD_BD*pInst->gammamax+asrh_VD_BD*gammamax_VD_BD+asrh_VD_BD*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VD_BD)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VD_BD));
#endif
#endif
pInst->itat=(pModel->CTATGAT_i*((pInst->asrh*pInst->gammamax)*pInst->wtat));
EXIT_IF_ISNAN((pModel->CTATGAT_i*((pInst->asrh*pInst->gammamax)*pInst->wtat)))
}
if
((pModel->CBBTGAT_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=0.0;
  ibbt_VS_BS_VD_BD=0.0;
#endif
ibbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=0.0;
  ibbt_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->ibbt=0;
EXIT_IF_ISNAN(0)
}
else
{
if
((pModel->PGAT_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,((pModel->VBIRGAT_i-pInst->vbbt)*pModel->VBIRGATinv))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pModel->VBIRGAT_i-pInst->vbbt)*pModel->VBIRGATinv))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vbbt_VS_BS)*pModel->VBIRGATinv*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt(((pModel->VBIRGAT_i-pInst->vbbt)*pModel->VBIRGATinv))*((-vbbt_VS_BS)*pModel->VBIRGATinv)*(-vbbt_VS_BS)*pModel->VBIRGATinv+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VS_BS)*pModel->VBIRGATinv+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRGAT_i-pInst->vbbt)*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt(((pModel->VBIRGAT_i-pInst->vbbt)*pModel->VBIRGATinv))*((-vbbt_VD_BD)*pModel->VBIRGATinv)*(-vbbt_VS_BS)*pModel->VBIRGATinv+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VD_BD)*pModel->VBIRGATinv+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRGAT_i-pInst->vbbt)*0.0));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,((pModel->VBIRGAT_i-pInst->vbbt)*pModel->VBIRGATinv),pModel->PGAT_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,((pModel->VBIRGAT_i-pInst->vbbt)*pModel->VBIRGATinv),pModel->PGAT_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vbbt_VS_BS)*pModel->VBIRGATinv);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Fmaxr_VS_BS=(pModel->one_over_one_minus_PGAT*(((-vbbt_VS_BS)*pModel->wdepnulrinvgat*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VS_BS_VS_BS=(+0.0*(((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvgat)*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvgat*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PGAT*((+(+0.0-vbbt_VS_BS_VS_BS)*pModel->wdepnulrinvgat+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRGAT_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvgat*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvgat)*tmp_VS_BS+((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VS_BS_VD_BD=(+0.0*(((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvgat)*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvgat*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PGAT*((+(+0.0-vbbt_VS_BS_VD_BD)*pModel->wdepnulrinvgat+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRGAT_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvgat*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvgat)*tmp_VS_BS+((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
Fmaxr_VD_BD=(pModel->one_over_one_minus_PGAT*(((-vbbt_VD_BD)*pModel->wdepnulrinvgat*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VD_BD_VS_BS=(+0.0*(((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvgat)*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvgat*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PGAT*((+(+0.0-vbbt_VD_BD_VS_BS)*pModel->wdepnulrinvgat+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRGAT_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvgat*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvgat)*tmp_VD_BD+((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VD_BD_VD_BD=(+0.0*(((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvgat)*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvgat*pInst->tmp-((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PGAT*((+(+0.0-vbbt_VD_BD_VD_BD)*pModel->wdepnulrinvgat+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRGAT_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvgat*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvgat)*tmp_VD_BD+((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)*tmp_VD_BD*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
#endif
pInst->Fmaxr=(pModel->one_over_one_minus_PGAT*(((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)/pInst->tmp));
EXIT_IF_ISNAN((pModel->one_over_one_minus_PGAT*(((pModel->VBIRGAT_i-pInst->vbbt)*pModel->wdepnulrinvgat)/pInst->tmp)))
{
double m00_fabs(d00_fabs0,((-pModel->fbbtgat)/pInst->Fmaxr))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,((-pModel->fbbtgat)/pInst->Fmaxr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VS_BS_VD_BD=(m20_exp(((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
tmp_VD_BD=(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VD_BD_VD_BD=(m20_exp(((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((((-pModel->fbbtgat)/pInst->Fmaxr)<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat)/pInst->Fmaxr))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(1.0e100*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+0.0*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VS_BS_VD_BD=(+0.0*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
tmp_VD_BD=(1.0e100*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+0.0*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtgat)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VD_BD_VD_BD=(+0.0*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtgat)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
pInst->tmp=(1.0e100*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=(pModel->CBBTGAT_i*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)));
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTGAT_i*(+(+(+Vjun_s_VS_BS_VS_BS*pInst->Fmaxr+Vjun_s_VS_BS*Fmaxr_VS_BS+Vjun_s_VS_BS*Fmaxr_VS_BS+Vjun_s*Fmaxr_VS_BS_VS_BS)*pInst->Fmaxr+((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*Fmaxr_VS_BS+(((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*Fmaxr_VS_BS+(Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS_VS_BS)*pInst->tmp+((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VS_BS+((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VS_BS+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VS_BS));
  ibbt_VS_BS_VD_BD=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTGAT_i*(+(+(+0.0*pInst->Fmaxr+Vjun_s_VS_BS*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+Vjun_s*Fmaxr_VS_BS_VD_BD)*pInst->Fmaxr+((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*Fmaxr_VD_BD+((Vjun_s*Fmaxr_VD_BD))*Fmaxr_VS_BS+(Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS_VD_BD)*pInst->tmp+((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VD_BD+(((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VS_BS+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VD_BD));
#endif
ibbt_VD_BD=(pModel->CBBTGAT_i*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)));
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTGAT_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VS_BS+Vjun_s_VS_BS*Fmaxr_VD_BD+Vjun_s*Fmaxr_VD_BD_VS_BS)*pInst->Fmaxr+(Vjun_s*Fmaxr_VD_BD)*Fmaxr_VS_BS+(((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*Fmaxr_VD_BD+(Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD_VS_BS)*pInst->tmp+(((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VS_BS+((((((Vjun_s_VS_BS*pInst->Fmaxr)+(Vjun_s*Fmaxr_VS_BS)))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VD_BD+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VS_BS));
  ibbt_VD_BD_VD_BD=(+0.0*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*(((((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTGAT_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+Vjun_s*Fmaxr_VD_BD_VD_BD)*pInst->Fmaxr+(Vjun_s*Fmaxr_VD_BD)*Fmaxr_VD_BD+((Vjun_s*Fmaxr_VD_BD))*Fmaxr_VD_BD+(Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD_VD_BD)*pInst->tmp+(((Vjun_s*Fmaxr_VD_BD)*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VD_BD+(((((Vjun_s*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_s*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VD_BD+((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VD_BD));
#endif
#endif
pInst->ibbt=(pModel->CBBTGAT_i*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp));
EXIT_IF_ISNAN((pModel->CBBTGAT_i*(((Vjun_s*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)))
}
if
((pModel->VBRGAT_i>1000))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=0.0;
  fbreakdown_VS_BS_VD_BD=0.0;
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=1;
EXIT_IF_ISNAN(1)
}
else
{
if
((pInst->vav>((-0.999)*pModel->VBRGAT_i)))
{
if
((pModel->PBRGAT_i==4))
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvgat))
double m00_fabs(d00_fabs1,(pInst->vav*pModel->VBRinvgat))
double m00_fabs(d00_fabs2,(pInst->vav*pModel->VBRinvgat))
double m00_fabs(d00_fabs3,(pInst->vav*pModel->VBRinvgat))
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvgat))
double m10_fabs(d10_fabs1,d00_fabs1,(pInst->vav*pModel->VBRinvgat))
double m10_fabs(d10_fabs2,d00_fabs2,(pInst->vav*pModel->VBRinvgat))
double m10_fabs(d10_fabs3,d00_fabs3,(pInst->vav*pModel->VBRinvgat))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((((((vav_VS_BS*pModel->VBRinvgat*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvgat*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VS_BS*pModel->VBRinvgat*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvgat))*(vav_VS_BS*pModel->VBRinvgat)*vav_VS_BS*pModel->VBRinvgat+d10_fabs0*(+vav_VS_BS_VS_BS*pModel->VBRinvgat+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvgat*d10_fabs0*(vav_VS_BS*pModel->VBRinvgat)*d10_fabs1+(vav_VS_BS*pModel->VBRinvgat)*d10_fabs0*vav_VS_BS*pModel->VBRinvgat*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvgat))*(vav_VS_BS*pModel->VBRinvgat)*vav_VS_BS*pModel->VBRinvgat+d10_fabs1*(+vav_VS_BS_VS_BS*pModel->VBRinvgat+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvgat*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat*d10_fabs1))*(vav_VS_BS*pModel->VBRinvgat)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvgat)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvgat)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvgat*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvgat))*(vav_VS_BS*pModel->VBRinvgat)*vav_VS_BS*pModel->VBRinvgat+d10_fabs2*(+vav_VS_BS_VS_BS*pModel->VBRinvgat+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvgat*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvgat*d10_fabs2))*(vav_VS_BS*pModel->VBRinvgat)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvgat)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvgat)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvgat)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvgat*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvgat))*(vav_VS_BS*pModel->VBRinvgat)*vav_VS_BS*pModel->VBRinvgat+d10_fabs3*(+vav_VS_BS_VS_BS*pModel->VBRinvgat+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VS_BS_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvgat))*(vav_VD_BD*pModel->VBRinvgat)*vav_VS_BS*pModel->VBRinvgat+d10_fabs0*(+vav_VS_BS_VD_BD*pModel->VBRinvgat+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvgat*d10_fabs0*(vav_VD_BD*pModel->VBRinvgat)*d10_fabs1+(vav_VD_BD*pModel->VBRinvgat)*d10_fabs0*vav_VS_BS*pModel->VBRinvgat*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvgat))*(vav_VD_BD*pModel->VBRinvgat)*vav_VS_BS*pModel->VBRinvgat+d10_fabs1*(+vav_VS_BS_VD_BD*pModel->VBRinvgat+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvgat*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat*d10_fabs1))*(vav_VD_BD*pModel->VBRinvgat)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvgat)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvgat)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvgat*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvgat))*(vav_VD_BD*pModel->VBRinvgat)*vav_VS_BS*pModel->VBRinvgat+d10_fabs2*(+vav_VS_BS_VD_BD*pModel->VBRinvgat+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvgat*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvgat*d10_fabs2))*(vav_VD_BD*pModel->VBRinvgat)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvgat)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvgat)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvgat)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvgat*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvgat))*(vav_VD_BD*pModel->VBRinvgat)*vav_VS_BS*pModel->VBRinvgat+d10_fabs3*(+vav_VS_BS_VD_BD*pModel->VBRinvgat+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=(((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3);
EXIT_IF_ISNAN((((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3))
}
}
else
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvgat))
double m00_pow(d00_pow1,d00_fabs0,pModel->PBRGAT_i)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvgat))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->PBRGAT_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow1*vav_VS_BS*pModel->VBRinvgat*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=0.0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=0.0;
  tmp_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->tmp=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=(-1*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VS_BS_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
fbreakdown_VD_BD=(-1*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VD_BD_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
#endif
pInst->fbreakdown=(1/(1-pInst->tmp));
EXIT_IF_ISNAN((1/(1-pInst->tmp)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=vav_VS_BS*pModel->slopegat;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(+0.0+(+(+vav_VS_BS_VS_BS+(+0.0*pModel->VBRGAT_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopegat+vav_VS_BS*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRGAT_i))*0.0));
  fbreakdown_VS_BS_VD_BD=(+0.0+(+(+vav_VS_BS_VD_BD+(+0.0*pModel->VBRGAT_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopegat+vav_VS_BS*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRGAT_i))*0.0));
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=(pModel->fstopgat+((pInst->vav+(0.999*pModel->VBRGAT_i))*pModel->slopegat));
EXIT_IF_ISNAN((pModel->fstopgat+((pInst->vav+(0.999*pModel->VBRGAT_i))*pModel->slopegat)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(S,GND)V(D,GND)V(BP,GND)V(GP,GND) */
ijungat_s_VS_BS=(((((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS));
#if defined(_DERIVATE2)
  ijungat_s_VS_BS_VS_BS=(+(+(+(+id_VS_BS_VS_BS+isrh_VS_BS_VS_BS)+itat_VS_BS_VS_BS)+ibbt_VS_BS_VS_BS)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VS_BS);
  ijungat_s_VS_BS_VD_BD=(+(+(+(+id_VS_BS_VD_BD+isrh_VS_BS_VD_BD)+itat_VS_BS_VD_BD)+ibbt_VS_BS_VD_BD)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VD_BD);
#endif
ijungat_s_VD_BD=(((((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD));
#if defined(_DERIVATE2)
  ijungat_s_VD_BD_VS_BS=(+(+(+(+id_VD_BD_VS_BS+isrh_VD_BD_VS_BS)+itat_VD_BD_VS_BS)+ibbt_VD_BD_VS_BS)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VS_BS);
  ijungat_s_VD_BD_VD_BD=(+(+(+(+id_VD_BD_VD_BD+isrh_VD_BD_VD_BD)+itat_VD_BD_VD_BD)+ibbt_VD_BD_VD_BD)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VD_BD);
#endif
#endif
ijungat_s=((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown);
EXIT_IF_ISNAN(((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(GP,GND)V(BP,GND)V(D,GND)V(S,GND)V(BS,GND) */
ijun_s_VD_BD=(((pInst->ABSOURCE_i*ijunbot_s_VD_BD)+(pInst->LSSOURCE_i*ijunsti_s_VD_BD))+(pInst->LGSOURCE_i*ijungat_s_VD_BD));
#if defined(_DERIVATE2)
  ijun_s_VD_BD_VD_BD=(+(+(+0.0*ijunbot_s+0.0*ijunbot_s_VD_BD+0.0*ijunbot_s_VD_BD+pInst->ABSOURCE_i*ijunbot_s_VD_BD_VD_BD)+(+0.0*ijunsti_s+0.0*ijunsti_s_VD_BD+0.0*ijunsti_s_VD_BD+pInst->LSSOURCE_i*ijunsti_s_VD_BD_VD_BD))+(+0.0*ijungat_s+0.0*ijungat_s_VD_BD+0.0*ijungat_s_VD_BD+pInst->LGSOURCE_i*ijungat_s_VD_BD_VD_BD));
  ijun_s_VD_BD_VS_BS=(+(+(+0.0*ijunbot_s+0.0*ijunbot_s_VS_BS+0.0*ijunbot_s_VD_BD+pInst->ABSOURCE_i*ijunbot_s_VD_BD_VS_BS)+(+0.0*ijunsti_s+0.0*ijunsti_s_VS_BS+0.0*ijunsti_s_VD_BD+pInst->LSSOURCE_i*ijunsti_s_VD_BD_VS_BS))+(+0.0*ijungat_s+0.0*ijungat_s_VS_BS+0.0*ijungat_s_VD_BD+pInst->LGSOURCE_i*ijungat_s_VD_BD_VS_BS));
#endif
ijun_s_VS_BS=(((pInst->ABSOURCE_i*ijunbot_s_VS_BS)+(pInst->LSSOURCE_i*ijunsti_s_VS_BS))+(pInst->LGSOURCE_i*ijungat_s_VS_BS));
#if defined(_DERIVATE2)
  ijun_s_VS_BS_VD_BD=(+(+(+0.0*ijunbot_s+0.0*ijunbot_s_VD_BD+0.0*ijunbot_s_VS_BS+pInst->ABSOURCE_i*ijunbot_s_VS_BS_VD_BD)+(+0.0*ijunsti_s+0.0*ijunsti_s_VD_BD+0.0*ijunsti_s_VS_BS+pInst->LSSOURCE_i*ijunsti_s_VS_BS_VD_BD))+(+0.0*ijungat_s+0.0*ijungat_s_VD_BD+0.0*ijungat_s_VS_BS+pInst->LGSOURCE_i*ijungat_s_VS_BS_VD_BD));
  ijun_s_VS_BS_VS_BS=(+(+(+0.0*ijunbot_s+0.0*ijunbot_s_VS_BS+0.0*ijunbot_s_VS_BS+pInst->ABSOURCE_i*ijunbot_s_VS_BS_VS_BS)+(+0.0*ijunsti_s+0.0*ijunsti_s_VS_BS+0.0*ijunsti_s_VS_BS+pInst->LSSOURCE_i*ijunsti_s_VS_BS_VS_BS))+(+0.0*ijungat_s+0.0*ijungat_s_VS_BS+0.0*ijungat_s_VS_BS+pInst->LGSOURCE_i*ijungat_s_VS_BS_VS_BS));
#endif
#endif
pInst->ijun_s=(((pInst->ABSOURCE_i*ijunbot_s)+(pInst->LSSOURCE_i*ijunsti_s))+(pInst->LGSOURCE_i*ijungat_s));
EXIT_IF_ISNAN((((pInst->ABSOURCE_i*ijunbot_s)+(pInst->LSSOURCE_i*ijunsti_s))+(pInst->LGSOURCE_i*ijungat_s)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  vbbt_VD_BD_VD_BD=0.0;
  vbbt_VD_BD_VS_BS=0.0;
#endif
vbbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  vbbt_VS_BS_VD_BD=0.0;
  vbbt_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->vbbt=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
two_psistar_VD_BD=0.0;
#if defined(_DERIVATE2)
  two_psistar_VD_BD_VD_BD=0.0;
  two_psistar_VD_BD_VS_BS=0.0;
#endif
two_psistar_VS_BS=0.0;
#if defined(_DERIVATE2)
  two_psistar_VS_BS_VD_BD=0.0;
  two_psistar_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->two_psistar=0.0;
EXIT_IF_ISNAN(0.0)
if
((!(((pInst->ABDRAIN_i==0)&&(pInst->LSDRAIN_i==0))&&(pInst->LGDRAIN_i==0))))
{
pInst->h1=((4.0*pInst->vch_d)*pInst->vch_d);
EXIT_IF_ISNAN(((4.0*pInst->vch_d)*pInst->vch_d))
pInst->h2=(pInst->vch_d/pInst->vfmin_d);
EXIT_IF_ISNAN((pInst->vch_d/pInst->vfmin_d))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h2d_VD_BD=Vjun_d_VD_BD;
#if defined(_DERIVATE2)
  h2d_VD_BD_VD_BD=(+Vjun_d_VD_BD_VD_BD+(+0.0*pInst->h2+0.0*0.0+0.0*0.0+pInst->vch_d*0.0));
  h2d_VD_BD_VS_BS=(+0.0+(+0.0*pInst->h2+0.0*0.0+0.0*0.0+pInst->vch_d*0.0));
#endif
h2d_VS_BS=0.0;
#if defined(_DERIVATE2)
  h2d_VS_BS_VD_BD=0.0;
  h2d_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->h2d=(Vjun_d+(pInst->vch_d*pInst->h2));
EXIT_IF_ISNAN((Vjun_d+(pInst->vch_d*pInst->h2)))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h3_VD_BD=h2d_VD_BD;
#if defined(_DERIVATE2)
  h3_VD_BD_VD_BD=(+0.0+h2d_VD_BD_VD_BD);
  h3_VD_BD_VS_BS=(+0.0+h2d_VD_BD_VS_BS);
#endif
h3_VS_BS=h2d_VS_BS;
#if defined(_DERIVATE2)
  h3_VS_BS_VD_BD=(+0.0+h2d_VS_BS_VD_BD);
  h3_VS_BS_VS_BS=(+0.0+h2d_VS_BS_VS_BS);
#endif
#endif
pInst->h3=(pInst->vfmin_d+pInst->h2d);
EXIT_IF_ISNAN((pInst->vfmin_d+pInst->h2d))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(BD,GND)V(D,GND) */
h4_VD_BD=(-h2d_VD_BD);
#if defined(_DERIVATE2)
  h4_VD_BD_VD_BD=(+0.0-h2d_VD_BD_VD_BD);
  h4_VD_BD_VS_BS=(+0.0-h2d_VD_BD_VS_BS);
#endif
h4_VS_BS=(-h2d_VS_BS);
#if defined(_DERIVATE2)
  h4_VS_BS_VD_BD=(+0.0-h2d_VS_BS_VD_BD);
  h4_VS_BS_VS_BS=(+0.0-h2d_VS_BS_VS_BS);
#endif
#endif
pInst->h4=(pInst->vfmin_d-pInst->h2d);
EXIT_IF_ISNAN((pInst->vfmin_d-pInst->h2d))
{
double m00_sqrt(d00_sqrt0,((pInst->h4*pInst->h4)+pInst->h1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->h4*pInst->h4)+pInst->h1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(D,GND)V(BD,GND)V(S,GND)V(BP,GND)V(GP,GND) */
h5_VD_BD=((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))*d10_sqrt0;
#if defined(_DERIVATE2)
  h5_VD_BD_VD_BD=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD)))*((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))+d10_sqrt0*(+(+h4_VD_BD_VD_BD*pInst->h4+h4_VD_BD*h4_VD_BD+h4_VD_BD*h4_VD_BD+pInst->h4*h4_VD_BD_VD_BD)+0.0));
  h5_VD_BD_VS_BS=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS)))*((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD))+d10_sqrt0*(+(+h4_VD_BD_VS_BS*pInst->h4+h4_VD_BD*h4_VS_BS+h4_VS_BS*h4_VD_BD+pInst->h4*h4_VD_BD_VS_BS)+0.0));
#endif
h5_VS_BS=((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))*d10_sqrt0;
#if defined(_DERIVATE2)
  h5_VS_BS_VD_BD=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VD_BD*pInst->h4)+(pInst->h4*h4_VD_BD)))*((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))+d10_sqrt0*(+(+h4_VS_BS_VD_BD*pInst->h4+h4_VS_BS*h4_VD_BD+h4_VD_BD*h4_VS_BS+pInst->h4*h4_VS_BS_VD_BD)+0.0));
  h5_VS_BS_VS_BS=(m20_sqrt(((pInst->h4*pInst->h4)+pInst->h1))*(((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS)))*((h4_VS_BS*pInst->h4)+(pInst->h4*h4_VS_BS))+d10_sqrt0*(+(+h4_VS_BS_VS_BS*pInst->h4+h4_VS_BS*h4_VS_BS+h4_VS_BS*h4_VS_BS+pInst->h4*h4_VS_BS_VS_BS)+0.0));
#endif
#endif
pInst->h5=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(BD,GND)V(D,GND) */
vj_VS_BS=(2.0*(-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#if defined(_DERIVATE2)
  vj_VS_BS_VS_BS=(+0.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))+0.0*(((0.0)*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*(-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_d+0.0*0.0+0.0*0.0+Vjun_d*0.0)/(pInst->h3+pInst->h5)-(0.0*(h3_VS_BS+h5_VS_BS)+(0.0)*(h3_VS_BS+h5_VS_BS)+(Vjun_d*pInst->vfmin_d)*(+h3_VS_BS_VS_BS+h5_VS_BS_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
  vj_VS_BS_VD_BD=(+0.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))+0.0*(((Vjun_d_VD_BD*pInst->vfmin_d)*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*(-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_d+0.0*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)/(pInst->h3+pInst->h5)-(0.0*(h3_VD_BD+h5_VD_BD)+(Vjun_d_VD_BD*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)+(Vjun_d*pInst->vfmin_d)*(+h3_VS_BS_VD_BD+h5_VS_BS_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#endif
vj_VD_BD=(2.0*((Vjun_d_VD_BD*pInst->vfmin_d*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#if defined(_DERIVATE2)
  vj_VD_BD_VS_BS=(+0.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))+0.0*(((0.0)*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VS_BS+h5_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*((Vjun_d_VD_BD*pInst->vfmin_d*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+0.0*pInst->vfmin_d+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)/(pInst->h3+pInst->h5)-(Vjun_d_VD_BD*pInst->vfmin_d*(h3_VS_BS+h5_VS_BS)+(0.0)*(h3_VD_BD+h5_VD_BD)+(Vjun_d*pInst->vfmin_d)*(+h3_VD_BD_VS_BS+h5_VD_BD_VS_BS))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD)*(h3_VS_BS+h5_VS_BS)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
  vj_VD_BD_VD_BD=(+0.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))+0.0*(((Vjun_d_VD_BD*pInst->vfmin_d)*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+0.0*((Vjun_d_VD_BD*pInst->vfmin_d*(pInst->h3+pInst->h5)-(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5))+2.0*((+Vjun_d_VD_BD_VD_BD*pInst->vfmin_d+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)/(pInst->h3+pInst->h5)-(Vjun_d_VD_BD*pInst->vfmin_d*(h3_VD_BD+h5_VD_BD)+(Vjun_d_VD_BD*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD)+(Vjun_d*pInst->vfmin_d)*(+h3_VD_BD_VD_BD+h5_VD_BD_VD_BD))/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)+2*(Vjun_d*pInst->vfmin_d)*(h3_VD_BD+h5_VD_BD)*(h3_VD_BD+h5_VD_BD)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)/(pInst->h3+pInst->h5)));
#endif
#endif
pInst->vj=(2.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5)));
EXIT_IF_ISNAN((2.0*((Vjun_d*pInst->vfmin_d)/(pInst->h3+pInst->h5))))
if
((Vjun_d<pInst->VMAX_d))
{
{
double m00_fabs(d00_fabs0,(0.5*(Vjun_d*pModel->phitdinv)))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,(0.5*(Vjun_d*pModel->phitdinv)))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
zinv_VD_BD=(0.5*Vjun_d_VD_BD*pModel->phitdinv)*d10_exp0;
#if defined(_DERIVATE2)
  zinv_VD_BD_VD_BD=(m20_exp((0.5*(Vjun_d*pModel->phitdinv)))*((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*(0.5*Vjun_d_VD_BD*pModel->phitdinv)+d10_exp0*(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(Vjun_d_VD_BD*pModel->phitdinv)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)));
  zinv_VD_BD_VS_BS=(m20_exp((0.5*(Vjun_d*pModel->phitdinv)))*((0.5*(0.0)))*(0.5*Vjun_d_VD_BD*pModel->phitdinv)+d10_exp0*(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)));
#endif
zinv_VS_BS=0.0;
#if defined(_DERIVATE2)
  zinv_VS_BS_VD_BD=0.0;
  zinv_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->zinv=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
(((0.5*(Vjun_d*pModel->phitdinv))<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
zinv_VD_BD=(-1.0e-100*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  zinv_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))-(0.0*((((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((0.5*((((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*3.3333333333333333e-01)))))))))+0.0*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(Vjun_d_VD_BD*pModel->phitdinv)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))+(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*((0.5*((((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*3.3333333333333333e-01))))))+(-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*(0.5*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+0.0*((((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*3.3333333333333333e-01))))+0.0*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(Vjun_d_VD_BD*pModel->phitdinv)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))+(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*3.3333333333333333e-01)+(-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(+0.0+(+(+0.0-(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(Vjun_d_VD_BD*pModel->phitdinv)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0)))*3.3333333333333333e-01+(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*0.0+(-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*0.0+((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01)))))*((((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((0.5*((((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((-((0.5*(Vjun_d_VD_BD*pModel->phitdinv))))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))));
  zinv_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))-(0.0*((((-((0.5*(0.0))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((0.5*((((-((0.5*(0.0))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((-((0.5*(0.0))))*3.3333333333333333e-01)))))))))+0.0*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))+(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*((0.5*((((-((0.5*(0.0))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((-((0.5*(0.0))))*3.3333333333333333e-01))))))+(-((0.5*(0.0))))*(0.5*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+0.0*((((-((0.5*(0.0))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((-((0.5*(0.0))))*3.3333333333333333e-01))))+0.0*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))+(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*((-((0.5*(0.0))))*3.3333333333333333e-01)+(-((0.5*(0.0))))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01+((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(+0.0+(+(+0.0-(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0)))*3.3333333333333333e-01+(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*0.0+(-((0.5*(0.0))))*0.0+((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(0.5*(((-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(-(0.5*Vjun_d_VD_BD*pModel->phitdinv))*3.3333333333333333e-01)))))*((((-((0.5*(0.0))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((0.5*((((-((0.5*(0.0))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*((-((0.5*(0.0))))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))));
#endif
zinv_VS_BS=0.0;
#if defined(_DERIVATE2)
  zinv_VS_BS_VD_BD=0.0;
  zinv_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->zinv=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*pModel->phitdinv)))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
zinv_VD_BD=(1.0e100*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  zinv_VD_BD_VD_BD=(+0.0*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*((0.5*(((((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*3.3333333333333333e-01)))))))))+0.0*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(Vjun_d_VD_BD*pModel->phitdinv)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0))-0.0)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(0.5*Vjun_d_VD_BD*pModel->phitdinv)*((0.5*(((((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*3.3333333333333333e-01))))))+((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*(0.5*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01)))+((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(+0.0+(+0.0*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*3.3333333333333333e-01))))+0.0*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01))+0.5*(+(+(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(Vjun_d_VD_BD*pModel->phitdinv)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0))-0.0)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))+(0.5*Vjun_d_VD_BD*pModel->phitdinv)*(((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*3.3333333333333333e-01)+((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01+((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(+0.0+(+(+(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(Vjun_d_VD_BD*pModel->phitdinv)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+Vjun_d_VD_BD_VD_BD*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+Vjun_d*0.0))-0.0)*3.3333333333333333e-01+(0.5*Vjun_d_VD_BD*pModel->phitdinv)*0.0+((0.5*(Vjun_d_VD_BD*pModel->phitdinv)))*0.0+((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*0.0))))))));
  zinv_VD_BD_VS_BS=(+0.0*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*(((((0.5*(0.0)))*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*((0.5*(((((0.5*(0.0)))*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(0.0)))*3.3333333333333333e-01)))))))))+0.0*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0))-0.0)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(0.5*Vjun_d_VD_BD*pModel->phitdinv)*((0.5*(((((0.5*(0.0)))*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(0.0)))*3.3333333333333333e-01))))))+((0.5*(0.0)))*(0.5*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01)))+((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(+0.0+(+0.0*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*(((((0.5*(0.0)))*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(((0.5*(0.0)))*3.3333333333333333e-01))))+0.0*(((0.5*Vjun_d_VD_BD*pModel->phitdinv)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01))+0.5*(+(+(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0))-0.0)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))+(0.5*Vjun_d_VD_BD*pModel->phitdinv)*(((0.5*(0.0)))*3.3333333333333333e-01)+((0.5*(0.0)))*(0.5*Vjun_d_VD_BD*pModel->phitdinv)*3.3333333333333333e-01+((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(+0.0+(+(+(+0.0*(Vjun_d*pModel->phitdinv)+0.0*(0.0)+0.0*Vjun_d_VD_BD*pModel->phitdinv+0.5*(+0.0*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+Vjun_d*0.0))-0.0)*3.3333333333333333e-01+(0.5*Vjun_d_VD_BD*pModel->phitdinv)*0.0+((0.5*(0.0)))*0.0+((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*0.0))))))));
#endif
zinv_VS_BS=0.0;
#if defined(_DERIVATE2)
  zinv_VS_BS_VD_BD=0.0;
  zinv_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->zinv=(1.0e100*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*pModel->phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
idmult_VD_BD=((zinv_VD_BD*pInst->zinv)+(pInst->zinv*zinv_VD_BD));
#if defined(_DERIVATE2)
  idmult_VD_BD_VD_BD=(+zinv_VD_BD_VD_BD*pInst->zinv+zinv_VD_BD*zinv_VD_BD+zinv_VD_BD*zinv_VD_BD+pInst->zinv*zinv_VD_BD_VD_BD);
  idmult_VD_BD_VS_BS=(+zinv_VD_BD_VS_BS*pInst->zinv+zinv_VD_BD*zinv_VS_BS+zinv_VS_BS*zinv_VD_BD+pInst->zinv*zinv_VD_BD_VS_BS);
#endif
idmult_VS_BS=((zinv_VS_BS*pInst->zinv)+(pInst->zinv*zinv_VS_BS));
#if defined(_DERIVATE2)
  idmult_VS_BS_VD_BD=(+zinv_VS_BS_VD_BD*pInst->zinv+zinv_VS_BS*zinv_VD_BD+zinv_VD_BD*zinv_VS_BS+pInst->zinv*zinv_VS_BS_VD_BD);
  idmult_VS_BS_VS_BS=(+zinv_VS_BS_VS_BS*pInst->zinv+zinv_VS_BS*zinv_VS_BS+zinv_VS_BS*zinv_VS_BS+pInst->zinv*zinv_VS_BS_VS_BS);
#endif
#endif
pInst->idmult=(pInst->zinv*pInst->zinv);
EXIT_IF_ISNAN((pInst->zinv*pInst->zinv))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
idmult_VD_BD=Vjun_d_VD_BD*pModel->phitdinv*pInst->exp_VMAX_over_phitd_d;
#if defined(_DERIVATE2)
  idmult_VD_BD_VD_BD=(+(+0.0+(+(+Vjun_d_VD_BD_VD_BD-0.0)*pModel->phitdinv+Vjun_d_VD_BD*0.0+Vjun_d_VD_BD*0.0+(Vjun_d-pInst->VMAX_d)*0.0))*pInst->exp_VMAX_over_phitd_d+Vjun_d_VD_BD*pModel->phitdinv*0.0+(Vjun_d_VD_BD*pModel->phitdinv)*0.0+(1+((Vjun_d-pInst->VMAX_d)*pModel->phitdinv))*0.0);
  idmult_VD_BD_VS_BS=(+(+0.0+(+(+0.0-0.0)*pModel->phitdinv+Vjun_d_VD_BD*0.0+0.0*0.0+(Vjun_d-pInst->VMAX_d)*0.0))*pInst->exp_VMAX_over_phitd_d+Vjun_d_VD_BD*pModel->phitdinv*0.0+(0.0)*0.0+(1+((Vjun_d-pInst->VMAX_d)*pModel->phitdinv))*0.0);
#endif
idmult_VS_BS=0.0;
#if defined(_DERIVATE2)
  idmult_VS_BS_VD_BD=0.0;
  idmult_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->idmult=((1+((Vjun_d-pInst->VMAX_d)*pModel->phitdinv))*pInst->exp_VMAX_over_phitd_d);
EXIT_IF_ISNAN(((1+((Vjun_d-pInst->VMAX_d)*pModel->phitdinv))*pInst->exp_VMAX_over_phitd_d))
{
double m00_sqrt(d00_sqrt0,pInst->idmult)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,pInst->idmult)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
zinv_VD_BD=idmult_VD_BD*d10_sqrt0;
#if defined(_DERIVATE2)
  zinv_VD_BD_VD_BD=(m20_sqrt(pInst->idmult)*idmult_VD_BD*idmult_VD_BD+d10_sqrt0*idmult_VD_BD_VD_BD);
  zinv_VD_BD_VS_BS=(m20_sqrt(pInst->idmult)*idmult_VS_BS*idmult_VD_BD+d10_sqrt0*idmult_VD_BD_VS_BS);
#endif
zinv_VS_BS=idmult_VS_BS*d10_sqrt0;
#if defined(_DERIVATE2)
  zinv_VS_BS_VD_BD=(m20_sqrt(pInst->idmult)*idmult_VD_BD*idmult_VS_BS+d10_sqrt0*idmult_VS_BS_VD_BD);
  zinv_VS_BS_VS_BS=(m20_sqrt(pInst->idmult)*idmult_VS_BS*idmult_VS_BS+d10_sqrt0*idmult_VS_BS_VS_BS);
#endif
#endif
pInst->zinv=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
idmult_VD_BD=idmult_VD_BD;
#if defined(_DERIVATE2)
  idmult_VD_BD_VD_BD=(+idmult_VD_BD_VD_BD-0.0);
  idmult_VD_BD_VS_BS=(+idmult_VD_BD_VS_BS-0.0);
#endif
idmult_VS_BS=idmult_VS_BS;
#if defined(_DERIVATE2)
  idmult_VS_BS_VD_BD=(+idmult_VS_BS_VD_BD-0.0);
  idmult_VS_BS_VS_BS=(+idmult_VS_BS_VS_BS-0.0);
#endif
#endif
pInst->idmult=(pInst->idmult-1.0);
EXIT_IF_ISNAN((pInst->idmult-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
z_VD_BD=(-1*zinv_VD_BD/pInst->zinv/pInst->zinv);
#if defined(_DERIVATE2)
  z_VD_BD_VD_BD=(0.0/pInst->zinv-(0.0*zinv_VD_BD+0.0*zinv_VD_BD+1*zinv_VD_BD_VD_BD)/pInst->zinv/pInst->zinv+2*1*zinv_VD_BD*zinv_VD_BD/pInst->zinv/pInst->zinv/pInst->zinv);
  z_VD_BD_VS_BS=(0.0/pInst->zinv-(0.0*zinv_VS_BS+0.0*zinv_VD_BD+1*zinv_VD_BD_VS_BS)/pInst->zinv/pInst->zinv+2*1*zinv_VD_BD*zinv_VS_BS/pInst->zinv/pInst->zinv/pInst->zinv);
#endif
z_VS_BS=(-1*zinv_VS_BS/pInst->zinv/pInst->zinv);
#if defined(_DERIVATE2)
  z_VS_BS_VD_BD=(0.0/pInst->zinv-(0.0*zinv_VD_BD+0.0*zinv_VS_BS+1*zinv_VS_BS_VD_BD)/pInst->zinv/pInst->zinv+2*1*zinv_VS_BS*zinv_VD_BD/pInst->zinv/pInst->zinv/pInst->zinv);
  z_VS_BS_VS_BS=(0.0/pInst->zinv-(0.0*zinv_VS_BS+0.0*zinv_VS_BS+1*zinv_VS_BS_VS_BS)/pInst->zinv/pInst->zinv+2*1*zinv_VS_BS*zinv_VS_BS/pInst->zinv/pInst->zinv/pInst->zinv);
#endif
#endif
pInst->z=(1/pInst->zinv);
EXIT_IF_ISNAN((1/pInst->zinv))
if
((Vjun_d>0))
{
{
double m00_sqrt(d00_sqrt0,((pInst->z+1.0)*(pInst->z+3.0)))
double m00_logE(d00_logE1,((2.0+pInst->z)+d00_sqrt0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->z+1.0)*(pInst->z+3.0)))
double m10_logE(d10_logE1,d00_logE1,((2.0+pInst->z)+d00_sqrt0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
two_psistar_VD_BD=(2.0*(pModel->phitd*(z_VD_BD+((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))*d10_sqrt0)*d10_logE1));
#if defined(_DERIVATE2)
  two_psistar_VD_BD_VD_BD=(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*(z_VD_BD+((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*d10_logE1+0.0*(z_VD_BD+((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE(((2.0+pInst->z)+d00_sqrt0))*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*(z_VD_BD+((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))*d10_sqrt0)+d10_logE1*(+(+0.0+z_VD_BD_VD_BD)+(m20_sqrt(((pInst->z+1.0)*(pInst->z+3.0)))*(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))+d10_sqrt0*(+(+z_VD_BD_VD_BD+0.0)*(pInst->z+3.0)+z_VD_BD*z_VD_BD+z_VD_BD*z_VD_BD+(pInst->z+1.0)*(+z_VD_BD_VD_BD+0.0)))))));
  two_psistar_VD_BD_VS_BS=(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*(z_VD_BD+((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*d10_logE1+0.0*(z_VD_BD+((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE(((2.0+pInst->z)+d00_sqrt0))*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*(z_VD_BD+((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))*d10_sqrt0)+d10_logE1*(+(+0.0+z_VD_BD_VS_BS)+(m20_sqrt(((pInst->z+1.0)*(pInst->z+3.0)))*(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD))+d10_sqrt0*(+(+z_VD_BD_VS_BS+0.0)*(pInst->z+3.0)+z_VD_BD*z_VS_BS+z_VS_BS*z_VD_BD+(pInst->z+1.0)*(+z_VD_BD_VS_BS+0.0)))))));
#endif
two_psistar_VS_BS=(2.0*(pModel->phitd*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1));
#if defined(_DERIVATE2)
  two_psistar_VS_BS_VD_BD=(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*d10_logE1+0.0*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE(((2.0+pInst->z)+d00_sqrt0))*(z_VD_BD+(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*d10_sqrt0)*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)+d10_logE1*(+(+0.0+z_VS_BS_VD_BD)+(m20_sqrt(((pInst->z+1.0)*(pInst->z+3.0)))*(((z_VD_BD*(pInst->z+3.0))+((pInst->z+1.0)*z_VD_BD)))*((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))+d10_sqrt0*(+(+z_VS_BS_VD_BD+0.0)*(pInst->z+3.0)+z_VS_BS*z_VD_BD+z_VD_BD*z_VS_BS+(pInst->z+1.0)*(+z_VS_BS_VD_BD+0.0)))))));
  two_psistar_VS_BS_VS_BS=(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*d10_logE1+0.0*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE(((2.0+pInst->z)+d00_sqrt0))*(z_VS_BS+(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*d10_sqrt0)*(z_VS_BS+((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))*d10_sqrt0)+d10_logE1*(+(+0.0+z_VS_BS_VS_BS)+(m20_sqrt(((pInst->z+1.0)*(pInst->z+3.0)))*(((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS)))*((z_VS_BS*(pInst->z+3.0))+((pInst->z+1.0)*z_VS_BS))+d10_sqrt0*(+(+z_VS_BS_VS_BS+0.0)*(pInst->z+3.0)+z_VS_BS*z_VS_BS+z_VS_BS*z_VS_BS+(pInst->z+1.0)*(+z_VS_BS_VS_BS+0.0)))))));
#endif
#endif
pInst->two_psistar=(2.0*(pModel->phitd*d00_logE1));
EXIT_IF_ISNAN((2.0*(pModel->phitd*d00_logE1)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,((1+pInst->zinv)*(1+(3*pInst->zinv))))
double m00_logE(d00_logE1,(((2*pInst->zinv)+1)+d00_sqrt0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((1+pInst->zinv)*(1+(3*pInst->zinv))))
double m10_logE(d10_logE1,d00_logE1,(((2*pInst->zinv)+1)+d00_sqrt0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
two_psistar_VD_BD=((-Vjun_d_VD_BD)+(2.0*(pModel->phitd*((2*zinv_VD_BD)+((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))*d10_sqrt0)*d10_logE1)));
#if defined(_DERIVATE2)
  two_psistar_VD_BD_VD_BD=(+0.0+(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*((2*zinv_VD_BD)+((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*d10_logE1+0.0*((2*zinv_VD_BD)+((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE((((2*pInst->zinv)+1)+d00_sqrt0))*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*((2*zinv_VD_BD)+((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))*d10_sqrt0)+d10_logE1*(+(+(+0.0*pInst->zinv+0.0*zinv_VD_BD+0.0*zinv_VD_BD+2*zinv_VD_BD_VD_BD)+0.0)+(m20_sqrt(((1+pInst->zinv)*(1+(3*pInst->zinv))))*(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))+d10_sqrt0*(+(+0.0+zinv_VD_BD_VD_BD)*(1+(3*pInst->zinv))+zinv_VD_BD*((3*zinv_VD_BD))+zinv_VD_BD*(3*zinv_VD_BD)+(1+pInst->zinv)*(+0.0+(+0.0*pInst->zinv+0.0*zinv_VD_BD+0.0*zinv_VD_BD+3*zinv_VD_BD_VD_BD)))))))));
  two_psistar_VD_BD_VS_BS=(+0.0+(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*((2*zinv_VD_BD)+((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*d10_logE1+0.0*((2*zinv_VD_BD)+((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE((((2*pInst->zinv)+1)+d00_sqrt0))*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*((2*zinv_VD_BD)+((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))*d10_sqrt0)+d10_logE1*(+(+(+0.0*pInst->zinv+0.0*zinv_VS_BS+0.0*zinv_VD_BD+2*zinv_VD_BD_VS_BS)+0.0)+(m20_sqrt(((1+pInst->zinv)*(1+(3*pInst->zinv))))*(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VD_BD)))+d10_sqrt0*(+(+0.0+zinv_VD_BD_VS_BS)*(1+(3*pInst->zinv))+zinv_VD_BD*((3*zinv_VS_BS))+zinv_VS_BS*(3*zinv_VD_BD)+(1+pInst->zinv)*(+0.0+(+0.0*pInst->zinv+0.0*zinv_VS_BS+0.0*zinv_VD_BD+3*zinv_VD_BD_VS_BS)))))))));
#endif
two_psistar_VS_BS=(2.0*(pModel->phitd*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1));
#if defined(_DERIVATE2)
  two_psistar_VS_BS_VD_BD=(+0.0+(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*d10_logE1+0.0*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE((((2*pInst->zinv)+1)+d00_sqrt0))*(((2*zinv_VD_BD))+(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*d10_sqrt0)*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)+d10_logE1*(+(+(+0.0*pInst->zinv+0.0*zinv_VD_BD+0.0*zinv_VS_BS+2*zinv_VS_BS_VD_BD)+0.0)+(m20_sqrt(((1+pInst->zinv)*(1+(3*pInst->zinv))))*(((zinv_VD_BD*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VD_BD)))))*((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))+d10_sqrt0*(+(+0.0+zinv_VS_BS_VD_BD)*(1+(3*pInst->zinv))+zinv_VS_BS*((3*zinv_VD_BD))+zinv_VD_BD*(3*zinv_VS_BS)+(1+pInst->zinv)*(+0.0+(+0.0*pInst->zinv+0.0*zinv_VD_BD+0.0*zinv_VS_BS+3*zinv_VS_BS_VD_BD)))))))));
  two_psistar_VS_BS_VS_BS=(+0.0+(+0.0*(pModel->phitd*d00_logE1)+0.0*((pModel->phitd*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*d10_logE1))+0.0*(pModel->phitd*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1)+2.0*(+0.0*d00_logE1+0.0*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*d10_logE1+0.0*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)*d10_logE1+pModel->phitd*(m20_logE((((2*pInst->zinv)+1)+d00_sqrt0))*(((2*zinv_VS_BS))+(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*d10_sqrt0)*((2*zinv_VS_BS)+((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))*d10_sqrt0)+d10_logE1*(+(+(+0.0*pInst->zinv+0.0*zinv_VS_BS+0.0*zinv_VS_BS+2*zinv_VS_BS_VS_BS)+0.0)+(m20_sqrt(((1+pInst->zinv)*(1+(3*pInst->zinv))))*(((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*((3*zinv_VS_BS)))))*((zinv_VS_BS*(1+(3*pInst->zinv)))+((1+pInst->zinv)*(3*zinv_VS_BS)))+d10_sqrt0*(+(+0.0+zinv_VS_BS_VS_BS)*(1+(3*pInst->zinv))+zinv_VS_BS*((3*zinv_VS_BS))+zinv_VS_BS*(3*zinv_VS_BS)+(1+pInst->zinv)*(+0.0+(+0.0*pInst->zinv+0.0*zinv_VS_BS+0.0*zinv_VS_BS+3*zinv_VS_BS_VS_BS)))))))));
#endif
#endif
pInst->two_psistar=((-Vjun_d)+(2.0*(pModel->phitd*d00_logE1)));
EXIT_IF_ISNAN(((-Vjun_d)+(2.0*(pModel->phitd*d00_logE1))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vjlim_VD_BD=(-two_psistar_VD_BD);
#if defined(_DERIVATE2)
  vjlim_VD_BD_VD_BD=(+0.0-two_psistar_VD_BD_VD_BD);
  vjlim_VD_BD_VS_BS=(+0.0-two_psistar_VD_BD_VS_BS);
#endif
vjlim_VS_BS=(-two_psistar_VS_BS);
#if defined(_DERIVATE2)
  vjlim_VS_BS_VD_BD=(+0.0-two_psistar_VS_BS_VD_BD);
  vjlim_VS_BS_VS_BS=(+0.0-two_psistar_VS_BS_VS_BS);
#endif
#endif
pInst->vjlim=(pInst->vbimin_d-pInst->two_psistar);
EXIT_IF_ISNAN((pInst->vbimin_d-pInst->two_psistar))
{
double m00_sqrt(d00_sqrt0,(((Vjun_d-pInst->vjlim)*(Vjun_d-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vjun_d-pInst->vjlim)*(Vjun_d-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
vjsrh_VD_BD=(0.5*((Vjun_d_VD_BD+vjlim_VD_BD)-(((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD)))*d10_sqrt0));
#if defined(_DERIVATE2)
  vjsrh_VD_BD_VD_BD=(+0.0*((Vjun_d+pInst->vjlim)-d00_sqrt0)+0.0*((Vjun_d_VD_BD+vjlim_VD_BD)-(((((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD))))+((0.0)*pModel->phitd))*d10_sqrt0)+0.0*((Vjun_d_VD_BD+vjlim_VD_BD)-(((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD)))*d10_sqrt0)+0.5*(+(+Vjun_d_VD_BD_VD_BD+vjlim_VD_BD_VD_BD)-(m20_sqrt((((Vjun_d-pInst->vjlim)*(Vjun_d-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))*(((((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD))))+((0.0)*pModel->phitd))*(((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD)))+d10_sqrt0*(+(+(+Vjun_d_VD_BD_VD_BD-vjlim_VD_BD_VD_BD)*(Vjun_d-pInst->vjlim)+(Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d_VD_BD-vjlim_VD_BD)+(Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d_VD_BD-vjlim_VD_BD)+(Vjun_d-pInst->vjlim)*(+Vjun_d_VD_BD_VD_BD-vjlim_VD_BD_VD_BD))+(+(+0.0*pModel->phitd+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitd+0.0*0.0+(0.0)*0.0+(4*pModel->phitd)*0.0)))));
  vjsrh_VD_BD_VS_BS=(+0.0*((Vjun_d+pInst->vjlim)-d00_sqrt0)+0.0*(vjlim_VS_BS-(((((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS))))+((0.0)*pModel->phitd))*d10_sqrt0)+0.0*((Vjun_d_VD_BD+vjlim_VD_BD)-(((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD)))*d10_sqrt0)+0.5*(+(+0.0+vjlim_VD_BD_VS_BS)-(m20_sqrt((((Vjun_d-pInst->vjlim)*(Vjun_d-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))*(((((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS))))+((0.0)*pModel->phitd))*(((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD)))+d10_sqrt0*(+(+(+0.0-vjlim_VD_BD_VS_BS)*(Vjun_d-pInst->vjlim)+(Vjun_d_VD_BD-vjlim_VD_BD)*(-vjlim_VS_BS)+(-vjlim_VS_BS)*(Vjun_d_VD_BD-vjlim_VD_BD)+(Vjun_d-pInst->vjlim)*(+0.0-vjlim_VD_BD_VS_BS))+(+(+0.0*pModel->phitd+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitd+0.0*0.0+(0.0)*0.0+(4*pModel->phitd)*0.0)))));
#endif
vjsrh_VS_BS=(0.5*(vjlim_VS_BS-(((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS)))*d10_sqrt0));
#if defined(_DERIVATE2)
  vjsrh_VS_BS_VD_BD=(+0.0*((Vjun_d+pInst->vjlim)-d00_sqrt0)+0.0*((Vjun_d_VD_BD+vjlim_VD_BD)-(((((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD))))+((0.0)*pModel->phitd))*d10_sqrt0)+0.0*(vjlim_VS_BS-(((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS)))*d10_sqrt0)+0.5*(+(+0.0+vjlim_VS_BS_VD_BD)-(m20_sqrt((((Vjun_d-pInst->vjlim)*(Vjun_d-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))*(((((Vjun_d_VD_BD-vjlim_VD_BD)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(Vjun_d_VD_BD-vjlim_VD_BD))))+((0.0)*pModel->phitd))*(((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS)))+d10_sqrt0*(+(+(+0.0-vjlim_VS_BS_VD_BD)*(Vjun_d-pInst->vjlim)+(-vjlim_VS_BS)*(Vjun_d_VD_BD-vjlim_VD_BD)+(Vjun_d_VD_BD-vjlim_VD_BD)*(-vjlim_VS_BS)+(Vjun_d-pInst->vjlim)*(+0.0-vjlim_VS_BS_VD_BD))+(+(+0.0*pModel->phitd+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitd+0.0*0.0+(0.0)*0.0+(4*pModel->phitd)*0.0)))));
  vjsrh_VS_BS_VS_BS=(+0.0*((Vjun_d+pInst->vjlim)-d00_sqrt0)+0.0*(vjlim_VS_BS-(((((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS))))+((0.0)*pModel->phitd))*d10_sqrt0)+0.0*(vjlim_VS_BS-(((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS)))*d10_sqrt0)+0.5*(+(+0.0+vjlim_VS_BS_VS_BS)-(m20_sqrt((((Vjun_d-pInst->vjlim)*(Vjun_d-pInst->vjlim))+((4*pModel->phitd)*pModel->phitd)))*(((((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS))))+((0.0)*pModel->phitd))*(((-vjlim_VS_BS)*(Vjun_d-pInst->vjlim))+((Vjun_d-pInst->vjlim)*(-vjlim_VS_BS)))+d10_sqrt0*(+(+(+0.0-vjlim_VS_BS_VS_BS)*(Vjun_d-pInst->vjlim)+(-vjlim_VS_BS)*(-vjlim_VS_BS)+(-vjlim_VS_BS)*(-vjlim_VS_BS)+(Vjun_d-pInst->vjlim)*(+0.0-vjlim_VS_BS_VS_BS))+(+(+0.0*pModel->phitd+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitd+0.0*0.0+(0.0)*0.0+(4*pModel->phitd)*0.0)))));
#endif
#endif
pInst->vjsrh=(0.5*((Vjun_d+pInst->vjlim)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((Vjun_d+pInst->vjlim)-d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,(((Vjun_d-pInst->vbbtlim_d)*(Vjun_d-pInst->vbbtlim_d))+((4*pModel->phitr)*pModel->phitr)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((Vjun_d-pInst->vbbtlim_d)*(Vjun_d-pInst->vbbtlim_d))+((4*pModel->phitr)*pModel->phitr)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbbt_VD_BD=(0.5*(Vjun_d_VD_BD-((Vjun_d_VD_BD*(Vjun_d-pInst->vbbtlim_d))+((Vjun_d-pInst->vbbtlim_d)*Vjun_d_VD_BD))*d10_sqrt0));
#if defined(_DERIVATE2)
  vbbt_VD_BD_VD_BD=(+0.0*((Vjun_d+pInst->vbbtlim_d)-d00_sqrt0)+0.0*(Vjun_d_VD_BD-((((Vjun_d_VD_BD*(Vjun_d-pInst->vbbtlim_d))+((Vjun_d-pInst->vbbtlim_d)*Vjun_d_VD_BD)))+((0.0)*pModel->phitr))*d10_sqrt0)+0.0*(Vjun_d_VD_BD-((Vjun_d_VD_BD*(Vjun_d-pInst->vbbtlim_d))+((Vjun_d-pInst->vbbtlim_d)*Vjun_d_VD_BD))*d10_sqrt0)+0.5*(+(+Vjun_d_VD_BD_VD_BD+0.0)-(m20_sqrt((((Vjun_d-pInst->vbbtlim_d)*(Vjun_d-pInst->vbbtlim_d))+((4*pModel->phitr)*pModel->phitr)))*((((Vjun_d_VD_BD*(Vjun_d-pInst->vbbtlim_d))+((Vjun_d-pInst->vbbtlim_d)*Vjun_d_VD_BD)))+((0.0)*pModel->phitr))*((Vjun_d_VD_BD*(Vjun_d-pInst->vbbtlim_d))+((Vjun_d-pInst->vbbtlim_d)*Vjun_d_VD_BD))+d10_sqrt0*(+(+(+Vjun_d_VD_BD_VD_BD-0.0)*(Vjun_d-pInst->vbbtlim_d)+Vjun_d_VD_BD*Vjun_d_VD_BD+Vjun_d_VD_BD*Vjun_d_VD_BD+(Vjun_d-pInst->vbbtlim_d)*(+Vjun_d_VD_BD_VD_BD-0.0))+(+(+0.0*pModel->phitr+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitr+0.0*0.0+(0.0)*0.0+(4*pModel->phitr)*0.0)))));
  vbbt_VD_BD_VS_BS=(+0.0*((Vjun_d+pInst->vbbtlim_d)-d00_sqrt0)+0.0*(-((0.0)+((0.0)*pModel->phitr))*d10_sqrt0)+0.0*(Vjun_d_VD_BD-((Vjun_d_VD_BD*(Vjun_d-pInst->vbbtlim_d))+((Vjun_d-pInst->vbbtlim_d)*Vjun_d_VD_BD))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt((((Vjun_d-pInst->vbbtlim_d)*(Vjun_d-pInst->vbbtlim_d))+((4*pModel->phitr)*pModel->phitr)))*((0.0)+((0.0)*pModel->phitr))*((Vjun_d_VD_BD*(Vjun_d-pInst->vbbtlim_d))+((Vjun_d-pInst->vbbtlim_d)*Vjun_d_VD_BD))+d10_sqrt0*(+(+(+0.0-0.0)*(Vjun_d-pInst->vbbtlim_d)+Vjun_d_VD_BD*0.0+0.0*Vjun_d_VD_BD+(Vjun_d-pInst->vbbtlim_d)*(+0.0-0.0))+(+(+0.0*pModel->phitr+0.0*0.0+0.0*0.0+4*0.0)*pModel->phitr+0.0*0.0+(0.0)*0.0+(4*pModel->phitr)*0.0)))));
#endif
vbbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  vbbt_VS_BS_VD_BD=0.0;
  vbbt_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->vbbt=(0.5*((Vjun_d+pInst->vbbtlim_d)-d00_sqrt0));
EXIT_IF_ISNAN((0.5*((Vjun_d+pInst->vbbtlim_d)-d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,((Vjun_d*Vjun_d)+((4*1E-6)*1E-6)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Vjun_d*Vjun_d)+((4*1E-6)*1E-6)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
vav_VD_BD=(0.5*(Vjun_d_VD_BD-((Vjun_d_VD_BD*Vjun_d)+(Vjun_d*Vjun_d_VD_BD))*d10_sqrt0));
#if defined(_DERIVATE2)
  vav_VD_BD_VD_BD=(+0.0*(Vjun_d-d00_sqrt0)+0.0*(Vjun_d_VD_BD-((((Vjun_d_VD_BD*Vjun_d)+(Vjun_d*Vjun_d_VD_BD)))+((0.0)*1E-6))*d10_sqrt0)+0.0*(Vjun_d_VD_BD-((Vjun_d_VD_BD*Vjun_d)+(Vjun_d*Vjun_d_VD_BD))*d10_sqrt0)+0.5*(+(+Vjun_d_VD_BD_VD_BD+0.0)-(m20_sqrt(((Vjun_d*Vjun_d)+((4*1E-6)*1E-6)))*((((Vjun_d_VD_BD*Vjun_d)+(Vjun_d*Vjun_d_VD_BD)))+((0.0)*1E-6))*((Vjun_d_VD_BD*Vjun_d)+(Vjun_d*Vjun_d_VD_BD))+d10_sqrt0*(+(+(+Vjun_d_VD_BD_VD_BD-0.0)*Vjun_d+Vjun_d_VD_BD*Vjun_d_VD_BD+Vjun_d_VD_BD*Vjun_d_VD_BD+Vjun_d*(+Vjun_d_VD_BD_VD_BD-0.0))+(+(+0.0*1E-6+0.0*0.0+0.0*0.0+4*0.0)*1E-6+0.0*0.0+(0.0)*0.0+(4*1E-6)*0.0)))));
  vav_VD_BD_VS_BS=(+0.0*(Vjun_d-d00_sqrt0)+0.0*(-((0.0)+((0.0)*1E-6))*d10_sqrt0)+0.0*(Vjun_d_VD_BD-((Vjun_d_VD_BD*Vjun_d)+(Vjun_d*Vjun_d_VD_BD))*d10_sqrt0)+0.5*(+(+0.0+0.0)-(m20_sqrt(((Vjun_d*Vjun_d)+((4*1E-6)*1E-6)))*((0.0)+((0.0)*1E-6))*((Vjun_d_VD_BD*Vjun_d)+(Vjun_d*Vjun_d_VD_BD))+d10_sqrt0*(+(+(+0.0-0.0)*Vjun_d+Vjun_d_VD_BD*0.0+0.0*Vjun_d_VD_BD+Vjun_d*(+0.0-0.0))+(+(+0.0*1E-6+0.0*0.0+0.0*0.0+4*0.0)*1E-6+0.0*0.0+(0.0)*0.0+(4*1E-6)*0.0)))));
#endif
vav_VS_BS=0.0;
#if defined(_DERIVATE2)
  vav_VS_BS_VD_BD=0.0;
  vav_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->vav=(0.5*(Vjun_d-d00_sqrt0));
EXIT_IF_ISNAN((0.5*(Vjun_d-d00_sqrt0)))
}
}
if
((pInst->ABDRAIN_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunbot_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunbot_d_VD_BD_VD_BD=0.0;
  ijunbot_d_VD_BD_VS_BS=0.0;
#endif
ijunbot_d_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunbot_d_VS_BS_VD_BD=0.0;
  ijunbot_d_VS_BS_VS_BS=0.0;
#endif
#endif
ijunbot_d=0;
EXIT_IF_ISNAN(0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjunbot_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  qjunbot_d_VD_BD_VD_BD=0.0;
  qjunbot_d_VD_BD_VS_BS=0.0;
#endif
#if defined(_DERIVATE)
qjunbot_d_VS_BS=0.0;
#endif
#endif
qjunbot_d=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
if
((pModel->one_minus_PBOT_d==0.5))
{
{
double m00_sqrt(d00_sqrt0,(1-(pInst->vj*pModel->vbiinvbot_d)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->vj*pModel->vbiinvbot_d)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vj_VS_BS*pModel->vbiinvbot_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvbot_d)))*(-(vj_VS_BS*pModel->vbiinvbot_d))*(-vj_VS_BS*pModel->vbiinvbot_d)+d10_sqrt0*(+0.0-(+vj_VS_BS_VS_BS*pModel->vbiinvbot_d+vj_VS_BS*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VS_BS_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvbot_d)))*(-(vj_VD_BD*pModel->vbiinvbot_d))*(-vj_VS_BS*pModel->vbiinvbot_d)+d10_sqrt0*(+0.0-(+vj_VS_BS_VD_BD*pModel->vbiinvbot_d+vj_VS_BS*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
tmp_VD_BD=(-vj_VD_BD*pModel->vbiinvbot_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvbot_d)))*(-(vj_VS_BS*pModel->vbiinvbot_d))*(-vj_VD_BD*pModel->vbiinvbot_d)+d10_sqrt0*(+0.0-(+vj_VD_BD_VS_BS*pModel->vbiinvbot_d+vj_VD_BD*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VD_BD_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvbot_d)))*(-(vj_VD_BD*pModel->vbiinvbot_d))*(-vj_VD_BD*pModel->vbiinvbot_d)+d10_sqrt0*(+0.0-(+vj_VD_BD_VD_BD*pModel->vbiinvbot_d+vj_VD_BD*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(1-(pInst->vj*pModel->vbiinvbot_d)),pModel->one_minus_PBOT_d)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(pInst->vj*pModel->vbiinvbot_d)),pModel->one_minus_PBOT_d)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vj_VS_BS*pModel->vbiinvbot_d));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vj_VD_BD*pModel->vbiinvbot_d));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjunbot_d_VD_BD=((pModel->qprefbot_d*(-tmp_VD_BD))+(pModel->qpref2bot_d*(Vjun_d_VD_BD-vj_VD_BD)));
#if defined(_DERIVATE2)
  qjunbot_d_VD_BD_VD_BD=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+pModel->qprefbot_d*(+0.0-tmp_VD_BD_VD_BD))+(+0.0*(Vjun_d-pInst->vj)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+pModel->qpref2bot_d*(+Vjun_d_VD_BD_VD_BD-vj_VD_BD_VD_BD)));
  qjunbot_d_VD_BD_VS_BS=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+pModel->qprefbot_d*(+0.0-tmp_VD_BD_VS_BS))+(+0.0*(Vjun_d-pInst->vj)+0.0*(-vj_VS_BS)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+pModel->qpref2bot_d*(+0.0-vj_VD_BD_VS_BS)));
#endif
#if defined(_DERIVATE)
qjunbot_d_VS_BS=((pModel->qprefbot_d*(-tmp_VS_BS))+(pModel->qpref2bot_d*(-vj_VS_BS)));
#endif
#endif
qjunbot_d=((pModel->qprefbot_d*(1-pInst->tmp))+(pModel->qpref2bot_d*(Vjun_d-pInst->vj)));
EXIT_IF_ISNAN(((pModel->qprefbot_d*(1-pInst->tmp))+(pModel->qpref2bot_d*(Vjun_d-pInst->vj))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
id_VD_BD=(pModel->idsatbot_d*idmult_VD_BD);
#if defined(_DERIVATE2)
  id_VD_BD_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VD_BD+pModel->idsatbot_d*idmult_VD_BD_VD_BD);
  id_VD_BD_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VD_BD+pModel->idsatbot_d*idmult_VD_BD_VS_BS);
#endif
id_VS_BS=(pModel->idsatbot_d*idmult_VS_BS);
#if defined(_DERIVATE2)
  id_VS_BS_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VS_BS+pModel->idsatbot_d*idmult_VS_BS_VD_BD);
  id_VS_BS_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VS_BS+pModel->idsatbot_d*idmult_VS_BS_VS_BS);
#endif
#endif
pInst->id=(pModel->idsatbot_d*pInst->idmult);
EXIT_IF_ISNAN((pModel->idsatbot_d*pInst->idmult))
if
(((pModel->CSRHBOTD_i==0)&&(pModel->CTATBOTD_i==0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=0.0;
  isrh_VS_BS_VD_BD=0.0;
#endif
isrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=0.0;
  isrh_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->isrh=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbi_minus_vjsrh_VD_BD=(-vjsrh_VD_BD);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VD_BD_VD_BD=(+0.0-vjsrh_VD_BD_VD_BD);
  vbi_minus_vjsrh_VD_BD_VS_BS=(+0.0-vjsrh_VD_BD_VS_BS);
#endif
vbi_minus_vjsrh_VS_BS=(-vjsrh_VS_BS);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VS_BS_VD_BD=(+0.0-vjsrh_VS_BS_VD_BD);
  vbi_minus_vjsrh_VS_BS_VS_BS=(+0.0-vjsrh_VS_BS_VS_BS);
#endif
#endif
pInst->vbi_minus_vjsrh=(pModel->vbibot_d-pInst->vjsrh);
EXIT_IF_ISNAN((pModel->vbibot_d-pInst->vjsrh))
{
double m00_sqrt(d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wsrhstep_VD_BD=(-(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VD_BD_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VD_BD_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VD_BD*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VD_BD+pInst->two_psistar*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VD_BD_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VD_BD_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+pInst->two_psistar*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
wsrhstep_VS_BS=(-(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VS_BS_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VS_BS_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
#endif
pInst->wsrhstep=(1-d00_sqrt0);
EXIT_IF_ISNAN((1-d00_sqrt0))
}
if
((pModel->PBOTD_i==0.5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=0.0;
  dwsrh_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->dwsrh=0;
EXIT_IF_ISNAN(0)
}
else
{
{
double m00_logE(d00_logE0,pInst->wsrhstep)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,pInst->wsrhstep)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(1-(2*pModel->PBOTD_i));
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=(+(+((+(+wsrhstep_VD_BD_VD_BD*pInst->wsrhstep+wsrhstep_VD_BD*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VD_BD+pInst->wsrhstep*wsrhstep_VD_BD_VD_BD)*d00_logE0+((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VD_BD*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VD_BD+d10_logE0*wsrhstep_VD_BD_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VD_BD)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VD_BD_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD_VD_BD)*(1-(2*pModel->PBOTD_i))+(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PBOTD_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VD_BD_VS_BS=(+(+((+(+wsrhstep_VD_BD_VS_BS*pInst->wsrhstep+wsrhstep_VD_BD*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VD_BD+pInst->wsrhstep*wsrhstep_VD_BD_VS_BS)*d00_logE0+((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VD_BD*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VD_BD+d10_logE0*wsrhstep_VD_BD_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VD_BD)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VD_BD_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD_VS_BS)*(1-(2*pModel->PBOTD_i))+(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PBOTD_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
dwsrh_VS_BS=(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(1-(2*pModel->PBOTD_i));
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=(+(+((+(+wsrhstep_VS_BS_VD_BD*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VD_BD)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VD_BD)*(1-(2*pModel->PBOTD_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PBOTD_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VS_BS_VS_BS=(+(+((+(+wsrhstep_VS_BS_VS_BS*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VS_BS)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VS_BS)*(1-(2*pModel->PBOTD_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PBOTD_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
#endif
pInst->dwsrh=(((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PBOTD_i)));
EXIT_IF_ISNAN((((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PBOTD_i))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wsrh_VD_BD=(wsrhstep_VD_BD+dwsrh_VD_BD);
#if defined(_DERIVATE2)
  wsrh_VD_BD_VD_BD=(+wsrhstep_VD_BD_VD_BD+dwsrh_VD_BD_VD_BD);
  wsrh_VD_BD_VS_BS=(+wsrhstep_VD_BD_VS_BS+dwsrh_VD_BD_VS_BS);
#endif
wsrh_VS_BS=(wsrhstep_VS_BS+dwsrh_VS_BS);
#if defined(_DERIVATE2)
  wsrh_VS_BS_VD_BD=(+wsrhstep_VS_BS_VD_BD+dwsrh_VS_BS_VD_BD);
  wsrh_VS_BS_VS_BS=(+wsrhstep_VS_BS_VS_BS+dwsrh_VS_BS_VS_BS);
#endif
#endif
pInst->wsrh=(pInst->wsrhstep+pInst->dwsrh);
EXIT_IF_ISNAN((pInst->wsrhstep+pInst->dwsrh))
if
((pModel->PBOTD_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv_d))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv_d))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv_d)*vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VS_BS*pModel->VBIRBOTinv_d+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv_d))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRBOTinv_d)*vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VD_BD*pModel->VBIRBOTinv_d+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
tmp_VD_BD=vbi_minus_vjsrh_VD_BD*pModel->VBIRBOTinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv_d))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv_d)*vbi_minus_vjsrh_VD_BD*pModel->VBIRBOTinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VD_BD_VS_BS*pModel->VBIRBOTinv_d+vbi_minus_vjsrh_VD_BD*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VD_BD_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv_d))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRBOTinv_d)*vbi_minus_vjsrh_VD_BD*pModel->VBIRBOTinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VD_BD_VD_BD*pModel->VBIRBOTinv_d+vbi_minus_vjsrh_VD_BD*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv_d),pModel->PBOTD_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRBOTinv_d),pModel->PBOTD_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*vbi_minus_vjsrh_VS_BS*pModel->VBIRBOTinv_d);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*vbi_minus_vjsrh_VD_BD*pModel->VBIRBOTinv_d);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wdep_VS_BS=(pModel->wdepnulrbot_d*tmp_VS_BS);
#if defined(_DERIVATE2)
  wdep_VS_BS_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+pModel->wdepnulrbot_d*tmp_VS_BS_VS_BS);
  wdep_VS_BS_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+pModel->wdepnulrbot_d*tmp_VS_BS_VD_BD);
#endif
wdep_VD_BD=(pModel->wdepnulrbot_d*tmp_VD_BD);
#if defined(_DERIVATE2)
  wdep_VD_BD_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+pModel->wdepnulrbot_d*tmp_VD_BD_VS_BS);
  wdep_VD_BD_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+pModel->wdepnulrbot_d*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->wdep=(pModel->wdepnulrbot_d*pInst->tmp);
EXIT_IF_ISNAN((pModel->wdepnulrbot_d*pInst->tmp))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
asrh_VS_BS=(pModel->ftdbot_d*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)));
#if defined(_DERIVATE2)
  asrh_VS_BS_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdbot_d*(+(+zinv_VS_BS_VS_BS-0.0)*pInst->wdep+zinv_VS_BS*wdep_VS_BS+zinv_VS_BS*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VS_BS));
  asrh_VS_BS_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdbot_d*(+(+zinv_VS_BS_VD_BD-0.0)*pInst->wdep+zinv_VS_BS*wdep_VD_BD+zinv_VD_BD*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VD_BD));
#endif
asrh_VD_BD=(pModel->ftdbot_d*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)));
#if defined(_DERIVATE2)
  asrh_VD_BD_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdbot_d*(+(+zinv_VD_BD_VS_BS-0.0)*pInst->wdep+zinv_VD_BD*wdep_VS_BS+zinv_VS_BS*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VS_BS));
  asrh_VD_BD_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdbot_d*(+(+zinv_VD_BD_VD_BD-0.0)*pInst->wdep+zinv_VD_BD*wdep_VD_BD+zinv_VD_BD*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VD_BD));
#endif
#endif
pInst->asrh=(pModel->ftdbot_d*((pInst->zinv-1)*pInst->wdep));
EXIT_IF_ISNAN((pModel->ftdbot_d*((pInst->zinv-1)*pInst->wdep)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=(pModel->CSRHBOTD_i*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)));
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHBOTD_i*(+asrh_VS_BS_VS_BS*pInst->wsrh+asrh_VS_BS*wsrh_VS_BS+asrh_VS_BS*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VS_BS));
  isrh_VS_BS_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHBOTD_i*(+asrh_VS_BS_VD_BD*pInst->wsrh+asrh_VS_BS*wsrh_VD_BD+asrh_VD_BD*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VD_BD));
#endif
isrh_VD_BD=(pModel->CSRHBOTD_i*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)));
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHBOTD_i*(+asrh_VD_BD_VS_BS*pInst->wsrh+asrh_VD_BD*wsrh_VS_BS+asrh_VS_BS*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VS_BS));
  isrh_VD_BD_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHBOTD_i*(+asrh_VD_BD_VD_BD*pInst->wsrh+asrh_VD_BD*wsrh_VD_BD+asrh_VD_BD*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VD_BD));
#endif
#endif
pInst->isrh=(pModel->CSRHBOTD_i*(pInst->asrh*pInst->wsrh));
EXIT_IF_ISNAN((pModel->CSRHBOTD_i*(pInst->asrh*pInst->wsrh)))
}
if
((pModel->CTATBOTD_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=0.0;
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=0.0;
  itat_VS_BS_VD_BD=0.0;
#endif
itat_VD_BD=0.0;
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=0.0;
  itat_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->itat=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
btat_VS_BS=(pModel->btatpartbot_d*((wdep_VS_BS*pModel->one_minus_PBOT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VS_BS_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PBOT_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PBOT_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PBOT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartbot_d*((+wdep_VS_BS_VS_BS*pModel->one_minus_PBOT_d+wdep_VS_BS*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PBOT_d*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VS_BS_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PBOT_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PBOT_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PBOT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartbot_d*((+wdep_VS_BS_VD_BD*pModel->one_minus_PBOT_d+wdep_VS_BS*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PBOT_d*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
btat_VD_BD=(pModel->btatpartbot_d*((wdep_VD_BD*pModel->one_minus_PBOT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VD_BD_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PBOT_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PBOT_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PBOT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartbot_d*((+wdep_VD_BD_VS_BS*pModel->one_minus_PBOT_d+wdep_VD_BD*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PBOT_d*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VD_BD_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PBOT_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PBOT_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PBOT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartbot_d*((+wdep_VD_BD_VD_BD*pModel->one_minus_PBOT_d+wdep_VD_BD*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PBOT_d*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PBOT_d)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
#endif
pInst->btat=(pModel->btatpartbot_d*((pInst->wdep*pModel->one_minus_PBOT_d)/pInst->vbi_minus_vjsrh));
EXIT_IF_ISNAN((pModel->btatpartbot_d*((pInst->wdep*pModel->one_minus_PBOT_d)/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
twoatatoverthreebtat_VS_BS=(-(0.666666666666667*pModel->atatbot_d)*btat_VS_BS/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VS_BS_VS_BS=((+0.0*pModel->atatbot_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatbot_d)*btat_VS_BS_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatbot_d)*btat_VS_BS*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VS_BS_VD_BD=((+0.0*pModel->atatbot_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatbot_d)*btat_VS_BS_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatbot_d)*btat_VS_BS*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
twoatatoverthreebtat_VD_BD=(-(0.666666666666667*pModel->atatbot_d)*btat_VD_BD/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VD_BD_VS_BS=((+0.0*pModel->atatbot_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatbot_d)*btat_VD_BD_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatbot_d)*btat_VD_BD*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VD_BD_VD_BD=((+0.0*pModel->atatbot_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatbot_d)*btat_VD_BD_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatbot_d)*btat_VD_BD*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
#endif
pInst->twoatatoverthreebtat=((0.666666666666667*pModel->atatbot_d)/pInst->btat);
EXIT_IF_ISNAN(((0.666666666666667*pModel->atatbot_d)/pInst->btat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
umaxbeforelimiting_VS_BS=((twoatatoverthreebtat_VS_BS*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VS_BS_VS_BS=(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VS_BS);
  umaxbeforelimiting_VS_BS_VD_BD=(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VD_BD);
#endif
umaxbeforelimiting_VD_BD=((twoatatoverthreebtat_VD_BD*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VD_BD_VS_BS=(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VS_BS);
  umaxbeforelimiting_VD_BD_VD_BD=(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VD_BD);
#endif
#endif
pInst->umaxbeforelimiting=(pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat);
EXIT_IF_ISNAN((pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat))
{
double m00_sqrt(d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umax_VS_BS=((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VS_BS_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VS_BS_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
umax_VD_BD=((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VD_BD_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VD_BD_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
#endif
pInst->umax=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_fabs(d00_fabs0,pInst->umax)
double m00_sqrt(d00_sqrt1,d00_fabs0)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->umax)
double m10_sqrt(d10_sqrt1,d00_sqrt1,d00_fabs0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
sqrtumax_VS_BS=umax_VS_BS*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VS_BS_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VS_BS+d10_fabs0*umax_VS_BS_VS_BS));
  sqrtumax_VS_BS_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VS_BS+d10_fabs0*umax_VS_BS_VD_BD));
#endif
sqrtumax_VD_BD=umax_VD_BD*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VD_BD_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VD_BD+d10_fabs0*umax_VD_BD_VS_BS));
  sqrtumax_VD_BD_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VD_BD+d10_fabs0*umax_VD_BD_VD_BD));
#endif
#endif
pInst->sqrtumax=d00_sqrt1;
EXIT_IF_ISNAN(d00_sqrt1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umaxpoweronepointfive_VS_BS=((umax_VS_BS*pInst->sqrtumax)+(pInst->umax*sqrtumax_VS_BS));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VS_BS_VS_BS=(+umax_VS_BS_VS_BS*pInst->sqrtumax+umax_VS_BS*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VS_BS);
  umaxpoweronepointfive_VS_BS_VD_BD=(+umax_VS_BS_VD_BD*pInst->sqrtumax+umax_VS_BS*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VD_BD);
#endif
umaxpoweronepointfive_VD_BD=((umax_VD_BD*pInst->sqrtumax)+(pInst->umax*sqrtumax_VD_BD));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VD_BD_VS_BS=(+umax_VD_BD_VS_BS*pInst->sqrtumax+umax_VD_BD*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VS_BS);
  umaxpoweronepointfive_VD_BD_VD_BD=(+umax_VD_BD_VD_BD*pInst->sqrtumax+umax_VD_BD*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VD_BD);
#endif
#endif
pInst->umaxpoweronepointfive=(pInst->umax*pInst->sqrtumax);
EXIT_IF_ISNAN((pInst->umax*pInst->sqrtumax))
if
((((-pModel->PBOTD_i)*pModel->one_over_one_minus_PBOT_d)==(-1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(-1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VS_BS_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
wgamma_VD_BD=(-1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VD_BD_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
#endif
pInst->wgamma=(1/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN((1/(1+(pInst->btat*pInst->umaxpoweronepointfive))))
}
else
{
{
double m00_pow(d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PBOTD_i)*pModel->one_over_one_minus_PBOT_d))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PBOTD_i)*pModel->one_over_one_minus_PBOT_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(d10_pow0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=fixme;
  wgamma_VS_BS_VD_BD=fixme;
#endif
wgamma_VD_BD=(d10_pow0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=fixme;
  wgamma_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->wgamma=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wtat_VS_BS=((((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VS_BS_VS_BS=((+wsrh_VS_BS_VS_BS*pInst->wgamma+wsrh_VS_BS*wgamma_VS_BS+wsrh_VS_BS*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VS_BS+wgamma_VS_BS_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VS_BS_VD_BD=((+wsrh_VS_BS_VD_BD*pInst->wgamma+wsrh_VS_BS*wgamma_VD_BD+wsrh_VD_BD*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VD_BD+wgamma_VS_BS_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
wtat_VD_BD=((((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VD_BD_VS_BS=((+wsrh_VD_BD_VS_BS*pInst->wgamma+wsrh_VD_BD*wgamma_VS_BS+wsrh_VS_BS*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VS_BS+wgamma_VD_BD_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VD_BD_VD_BD=((+wsrh_VD_BD_VD_BD*pInst->wgamma+wsrh_VD_BD*wgamma_VD_BD+wsrh_VD_BD*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VD_BD+wgamma_VD_BD_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
#endif
pInst->wtat=((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
EXIT_IF_ISNAN(((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma)))
{
double m00_sqrt(d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ktat_VS_BS=(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VS_BS_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VS_BS/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VS_BS_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VD_BD/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
ktat_VD_BD=(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VD_BD_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VS_BS/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VD_BD_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VD_BD/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
#endif
pInst->ktat=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ltat_VS_BS=((2*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))-umax_VS_BS);
#if defined(_DERIVATE2)
  ltat_VS_BS_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VS_BS))-umax_VS_BS_VS_BS);
  ltat_VS_BS_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VD_BD))-umax_VS_BS_VD_BD);
#endif
ltat_VD_BD=((2*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))-umax_VD_BD);
#if defined(_DERIVATE2)
  ltat_VD_BD_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VS_BS))-umax_VD_BD_VS_BS);
  ltat_VD_BD_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VD_BD))-umax_VD_BD_VD_BD);
#endif
#endif
pInst->ltat=((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax);
EXIT_IF_ISNAN(((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
mtat_VS_BS=(((((pModel->atatbot_d*twoatatoverthreebtat_VS_BS)*pInst->sqrtumax)+((pModel->atatbot_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS))-(pModel->atatbot_d*umax_VS_BS))+(0.5*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))));
#if defined(_DERIVATE2)
  mtat_VS_BS_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VS_BS+pModel->atatbot_d*twoatatoverthreebtat_VS_BS_VS_BS)*pInst->sqrtumax+(pModel->atatbot_d*twoatatoverthreebtat_VS_BS)*sqrtumax_VS_BS+((pModel->atatbot_d*twoatatoverthreebtat_VS_BS))*sqrtumax_VS_BS+(pModel->atatbot_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VS_BS+pModel->atatbot_d*umax_VS_BS_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)));
  mtat_VS_BS_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VS_BS+pModel->atatbot_d*twoatatoverthreebtat_VS_BS_VD_BD)*pInst->sqrtumax+(pModel->atatbot_d*twoatatoverthreebtat_VS_BS)*sqrtumax_VD_BD+((pModel->atatbot_d*twoatatoverthreebtat_VD_BD))*sqrtumax_VS_BS+(pModel->atatbot_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VS_BS+pModel->atatbot_d*umax_VS_BS_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)));
#endif
mtat_VD_BD=(((((pModel->atatbot_d*twoatatoverthreebtat_VD_BD)*pInst->sqrtumax)+((pModel->atatbot_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD))-(pModel->atatbot_d*umax_VD_BD))+(0.5*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))));
#if defined(_DERIVATE2)
  mtat_VD_BD_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VD_BD+pModel->atatbot_d*twoatatoverthreebtat_VD_BD_VS_BS)*pInst->sqrtumax+(pModel->atatbot_d*twoatatoverthreebtat_VD_BD)*sqrtumax_VS_BS+((pModel->atatbot_d*twoatatoverthreebtat_VS_BS))*sqrtumax_VD_BD+(pModel->atatbot_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VD_BD+pModel->atatbot_d*umax_VD_BD_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)));
  mtat_VD_BD_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VD_BD+pModel->atatbot_d*twoatatoverthreebtat_VD_BD_VD_BD)*pInst->sqrtumax+(pModel->atatbot_d*twoatatoverthreebtat_VD_BD)*sqrtumax_VD_BD+((pModel->atatbot_d*twoatatoverthreebtat_VD_BD))*sqrtumax_VD_BD+(pModel->atatbot_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VD_BD+pModel->atatbot_d*umax_VD_BD_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)));
#endif
#endif
pInst->mtat=((((pModel->atatbot_d*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatbot_d*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN(((((pModel->atatbot_d*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatbot_d*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive))))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xerfc_VS_BS=((ltat_VS_BS*pInst->ktat)+((pInst->ltat-1)*ktat_VS_BS));
#if defined(_DERIVATE2)
  xerfc_VS_BS_VS_BS=(+(+ltat_VS_BS_VS_BS-0.0)*pInst->ktat+ltat_VS_BS*ktat_VS_BS+ltat_VS_BS*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VS_BS);
  xerfc_VS_BS_VD_BD=(+(+ltat_VS_BS_VD_BD-0.0)*pInst->ktat+ltat_VS_BS*ktat_VD_BD+ltat_VD_BD*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VD_BD);
#endif
xerfc_VD_BD=((ltat_VD_BD*pInst->ktat)+((pInst->ltat-1)*ktat_VD_BD));
#if defined(_DERIVATE2)
  xerfc_VD_BD_VS_BS=(+(+ltat_VD_BD_VS_BS-0.0)*pInst->ktat+ltat_VD_BD*ktat_VS_BS+ltat_VS_BS*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VS_BS);
  xerfc_VD_BD_VD_BD=(+(+ltat_VD_BD_VD_BD-0.0)*pInst->ktat+ltat_VD_BD*ktat_VD_BD+ltat_VD_BD*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VD_BD);
#endif
#endif
pInst->xerfc=((pInst->ltat-1)*pInst->ktat);
EXIT_IF_ISNAN(((pInst->ltat-1)*pInst->ktat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ysq_VS_BS=((xerfc_VS_BS*pInst->xerfc)+(pInst->xerfc*xerfc_VS_BS));
#if defined(_DERIVATE2)
  ysq_VS_BS_VS_BS=(+xerfc_VS_BS_VS_BS*pInst->xerfc+xerfc_VS_BS*xerfc_VS_BS+xerfc_VS_BS*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VS_BS);
  ysq_VS_BS_VD_BD=(+xerfc_VS_BS_VD_BD*pInst->xerfc+xerfc_VS_BS*xerfc_VD_BD+xerfc_VD_BD*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VD_BD);
#endif
ysq_VD_BD=((xerfc_VD_BD*pInst->xerfc)+(pInst->xerfc*xerfc_VD_BD));
#if defined(_DERIVATE2)
  ysq_VD_BD_VS_BS=(+xerfc_VD_BD_VS_BS*pInst->xerfc+xerfc_VD_BD*xerfc_VS_BS+xerfc_VS_BS*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VS_BS);
  ysq_VD_BD_VD_BD=(+xerfc_VD_BD_VD_BD*pInst->xerfc+xerfc_VD_BD*xerfc_VD_BD+xerfc_VD_BD*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VD_BD);
#endif
#endif
pInst->ysq=(pInst->xerfc*pInst->xerfc);
EXIT_IF_ISNAN((pInst->xerfc*pInst->xerfc))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(pModel->perfc*xerfc_VS_BS)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(pModel->perfc*xerfc_VD_BD)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1+(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1+(pModel->perfc*pInst->xerfc))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(-(pModel->perfc*xerfc_VS_BS))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(-(pModel->perfc*xerfc_VD_BD))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1-(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1-(pModel->perfc*pInst->xerfc))))
}
if
((((-pInst->ysq)+pInst->mtat)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,((-pInst->ysq)+pInst->mtat))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((-ysq_VS_BS)+mtat_VS_BS)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VS_BS));
  tmp_VS_BS_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VD_BD));
#endif
tmp_VD_BD=((-ysq_VD_BD)+mtat_VD_BD)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VS_BS));
  tmp_VD_BD_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VD_BD));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
erfcpos_VS_BS=(((((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS));
#if defined(_DERIVATE2)
  erfcpos_VS_BS_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VS_BS);
  erfcpos_VS_BS_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VD_BD);
#endif
erfcpos_VD_BD=(((((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD));
#if defined(_DERIVATE2)
  erfcpos_VD_BD_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VS_BS);
  erfcpos_VD_BD_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->erfcpos=((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp);
EXIT_IF_ISNAN(((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=erfcpos_VS_BS;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=erfcpos_VS_BS_VS_BS;
  erfctimesexpmtat_VS_BS_VD_BD=erfcpos_VS_BS_VD_BD;
#endif
erfctimesexpmtat_VD_BD=erfcpos_VD_BD;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=erfcpos_VD_BD_VS_BS;
  erfctimesexpmtat_VD_BD_VD_BD=erfcpos_VD_BD_VD_BD;
#endif
#endif
pInst->erfctimesexpmtat=pInst->erfcpos;
EXIT_IF_ISNAN(pInst->erfcpos)
}
else
{
if
((pInst->mtat>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,pInst->mtat)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=mtat_VS_BS*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VS_BS+d10_exp0*mtat_VS_BS_VS_BS);
  tmp_VS_BS_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VS_BS+d10_exp0*mtat_VS_BS_VD_BD);
#endif
tmp_VD_BD=mtat_VD_BD*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VD_BD+d10_exp0*mtat_VD_BD_VS_BS);
  tmp_VD_BD_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VD_BD+d10_exp0*mtat_VD_BD_VD_BD);
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=((2*tmp_VS_BS)-erfcpos_VS_BS);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+2*tmp_VS_BS_VS_BS)-erfcpos_VS_BS_VS_BS);
  erfctimesexpmtat_VS_BS_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+2*tmp_VS_BS_VD_BD)-erfcpos_VS_BS_VD_BD);
#endif
erfctimesexpmtat_VD_BD=((2*tmp_VD_BD)-erfcpos_VD_BD);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+2*tmp_VD_BD_VS_BS)-erfcpos_VD_BD_VS_BS);
  erfctimesexpmtat_VD_BD_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+2*tmp_VD_BD_VD_BD)-erfcpos_VD_BD_VD_BD);
#endif
#endif
pInst->erfctimesexpmtat=((2*pInst->tmp)-pInst->erfcpos);
EXIT_IF_ISNAN(((2*pInst->tmp)-pInst->erfcpos))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
gammamax_VS_BS=((1.77245385090551603*0.5)*(((pModel->atatbot_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VS_BS_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatbot_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatbot_d*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatbot_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VS_BS+pModel->atatbot_d*erfctimesexpmtat_VS_BS_VS_BS)/pInst->ktat-((pModel->atatbot_d*erfctimesexpmtat_VS_BS)*ktat_VS_BS+((pModel->atatbot_d*erfctimesexpmtat_VS_BS))*ktat_VS_BS+(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VS_BS_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatbot_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatbot_d*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatbot_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VS_BS+pModel->atatbot_d*erfctimesexpmtat_VS_BS_VD_BD)/pInst->ktat-((pModel->atatbot_d*erfctimesexpmtat_VS_BS)*ktat_VD_BD+((pModel->atatbot_d*erfctimesexpmtat_VD_BD))*ktat_VS_BS+(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
gammamax_VD_BD=((1.77245385090551603*0.5)*(((pModel->atatbot_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VD_BD_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatbot_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatbot_d*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatbot_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VD_BD+pModel->atatbot_d*erfctimesexpmtat_VD_BD_VS_BS)/pInst->ktat-((pModel->atatbot_d*erfctimesexpmtat_VD_BD)*ktat_VS_BS+((pModel->atatbot_d*erfctimesexpmtat_VS_BS))*ktat_VD_BD+(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VD_BD_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatbot_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatbot_d*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatbot_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VD_BD+pModel->atatbot_d*erfctimesexpmtat_VD_BD_VD_BD)/pInst->ktat-((pModel->atatbot_d*erfctimesexpmtat_VD_BD)*ktat_VD_BD+((pModel->atatbot_d*erfctimesexpmtat_VD_BD))*ktat_VD_BD+(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatbot_d*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
#endif
pInst->gammamax=((1.77245385090551603*0.5)*((pModel->atatbot_d*pInst->erfctimesexpmtat)/pInst->ktat));
EXIT_IF_ISNAN(((1.77245385090551603*0.5)*((pModel->atatbot_d*pInst->erfctimesexpmtat)/pInst->ktat)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=(pModel->CTATBOTD_i*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)));
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATBOTD_i*(+(+asrh_VS_BS_VS_BS*pInst->gammamax+asrh_VS_BS*gammamax_VS_BS+asrh_VS_BS*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VS_BS)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VS_BS));
  itat_VS_BS_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATBOTD_i*(+(+asrh_VS_BS_VD_BD*pInst->gammamax+asrh_VS_BS*gammamax_VD_BD+asrh_VD_BD*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VD_BD)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VD_BD));
#endif
itat_VD_BD=(pModel->CTATBOTD_i*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)));
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATBOTD_i*(+(+asrh_VD_BD_VS_BS*pInst->gammamax+asrh_VD_BD*gammamax_VS_BS+asrh_VS_BS*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VS_BS)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VS_BS));
  itat_VD_BD_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATBOTD_i*(+(+asrh_VD_BD_VD_BD*pInst->gammamax+asrh_VD_BD*gammamax_VD_BD+asrh_VD_BD*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VD_BD)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VD_BD));
#endif
#endif
pInst->itat=(pModel->CTATBOTD_i*((pInst->asrh*pInst->gammamax)*pInst->wtat));
EXIT_IF_ISNAN((pModel->CTATBOTD_i*((pInst->asrh*pInst->gammamax)*pInst->wtat)))
}
if
((pModel->CBBTBOTD_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=0.0;
  ibbt_VS_BS_VD_BD=0.0;
#endif
ibbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=0.0;
  ibbt_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->ibbt=0;
EXIT_IF_ISNAN(0)
}
else
{
if
((pModel->PBOTD_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->VBIRBOTinv_d))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->VBIRBOTinv_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vbbt_VS_BS)*pModel->VBIRBOTinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->VBIRBOTinv_d))*((-vbbt_VS_BS)*pModel->VBIRBOTinv_d)*(-vbbt_VS_BS)*pModel->VBIRBOTinv_d+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VS_BS)*pModel->VBIRBOTinv_d+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRBOTD_i-pInst->vbbt)*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->VBIRBOTinv_d))*((-vbbt_VD_BD)*pModel->VBIRBOTinv_d)*(-vbbt_VS_BS)*pModel->VBIRBOTinv_d+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VD_BD)*pModel->VBIRBOTinv_d+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRBOTD_i-pInst->vbbt)*0.0));
#endif
tmp_VD_BD=(-vbbt_VD_BD)*pModel->VBIRBOTinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->VBIRBOTinv_d))*((-vbbt_VS_BS)*pModel->VBIRBOTinv_d)*(-vbbt_VD_BD)*pModel->VBIRBOTinv_d+d10_sqrt0*(+(+0.0-vbbt_VD_BD_VS_BS)*pModel->VBIRBOTinv_d+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRBOTD_i-pInst->vbbt)*0.0));
  tmp_VD_BD_VD_BD=(m20_sqrt(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->VBIRBOTinv_d))*((-vbbt_VD_BD)*pModel->VBIRBOTinv_d)*(-vbbt_VD_BD)*pModel->VBIRBOTinv_d+d10_sqrt0*(+(+0.0-vbbt_VD_BD_VD_BD)*pModel->VBIRBOTinv_d+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRBOTD_i-pInst->vbbt)*0.0));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->VBIRBOTinv_d),pModel->PBOTD_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->VBIRBOTinv_d),pModel->PBOTD_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vbbt_VS_BS)*pModel->VBIRBOTinv_d);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vbbt_VD_BD)*pModel->VBIRBOTinv_d);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Fmaxr_VS_BS=(pModel->one_over_one_minus_PBOT_d*(((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VS_BS_VS_BS=(+0.0*(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d)*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PBOT_d*((+(+0.0-vbbt_VS_BS_VS_BS)*pModel->wdepnulrinvbot_d+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRBOTD_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d)*tmp_VS_BS+((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VS_BS_VD_BD=(+0.0*(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d)*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PBOT_d*((+(+0.0-vbbt_VS_BS_VD_BD)*pModel->wdepnulrinvbot_d+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRBOTD_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d)*tmp_VS_BS+((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
Fmaxr_VD_BD=(pModel->one_over_one_minus_PBOT_d*(((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VD_BD_VS_BS=(+0.0*(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d)*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PBOT_d*((+(+0.0-vbbt_VD_BD_VS_BS)*pModel->wdepnulrinvbot_d+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRBOTD_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvbot_d)*tmp_VD_BD+((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VD_BD_VD_BD=(+0.0*(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d)*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d*pInst->tmp-((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PBOT_d*((+(+0.0-vbbt_VD_BD_VD_BD)*pModel->wdepnulrinvbot_d+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRBOTD_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvbot_d)*tmp_VD_BD+((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)*tmp_VD_BD*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
#endif
pInst->Fmaxr=(pModel->one_over_one_minus_PBOT_d*(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)/pInst->tmp));
EXIT_IF_ISNAN((pModel->one_over_one_minus_PBOT_d*(((pModel->VBIRBOTD_i-pInst->vbbt)*pModel->wdepnulrinvbot_d)/pInst->tmp)))
{
double m00_fabs(d00_fabs0,((-pModel->fbbtbot_d)/pInst->Fmaxr))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,((-pModel->fbbtbot_d)/pInst->Fmaxr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VS_BS_VD_BD=(m20_exp(((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
tmp_VD_BD=(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VD_BD_VD_BD=(m20_exp(((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((((-pModel->fbbtbot_d)/pInst->Fmaxr)<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtbot_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(1.0e100*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+0.0*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VS_BS_VD_BD=(+0.0*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtbot_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
tmp_VD_BD=(1.0e100*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+0.0*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtbot_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VD_BD_VD_BD=(+0.0*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtbot_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtbot_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtbot_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
pInst->tmp=(1.0e100*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtbot_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=(pModel->CBBTBOTD_i*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)));
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTBOTD_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+Vjun_d*Fmaxr_VS_BS_VS_BS)*pInst->Fmaxr+(Vjun_d*Fmaxr_VS_BS)*Fmaxr_VS_BS+((Vjun_d*Fmaxr_VS_BS))*Fmaxr_VS_BS+(Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS_VS_BS)*pInst->tmp+(((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VS_BS+(((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VS_BS+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VS_BS));
  ibbt_VS_BS_VD_BD=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTBOTD_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VD_BD+Vjun_d_VD_BD*Fmaxr_VS_BS+Vjun_d*Fmaxr_VS_BS_VD_BD)*pInst->Fmaxr+(Vjun_d*Fmaxr_VS_BS)*Fmaxr_VD_BD+(((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*Fmaxr_VS_BS+(Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS_VD_BD)*pInst->tmp+(((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VD_BD+((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VS_BS+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VD_BD));
#endif
ibbt_VD_BD=(pModel->CBBTBOTD_i*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)));
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTBOTD_i*(+(+(+0.0*pInst->Fmaxr+Vjun_d_VD_BD*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+Vjun_d*Fmaxr_VD_BD_VS_BS)*pInst->Fmaxr+((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*Fmaxr_VS_BS+((Vjun_d*Fmaxr_VS_BS))*Fmaxr_VD_BD+(Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD_VS_BS)*pInst->tmp+((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VS_BS+(((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VD_BD+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VS_BS));
  ibbt_VD_BD_VD_BD=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTBOTD_i*(+(+(+Vjun_d_VD_BD_VD_BD*pInst->Fmaxr+Vjun_d_VD_BD*Fmaxr_VD_BD+Vjun_d_VD_BD*Fmaxr_VD_BD+Vjun_d*Fmaxr_VD_BD_VD_BD)*pInst->Fmaxr+((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*Fmaxr_VD_BD+(((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*Fmaxr_VD_BD+(Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD_VD_BD)*pInst->tmp+((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VD_BD+((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VD_BD+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VD_BD));
#endif
#endif
pInst->ibbt=(pModel->CBBTBOTD_i*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp));
EXIT_IF_ISNAN((pModel->CBBTBOTD_i*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)))
}
if
((pModel->VBRBOTD_i>1000))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=0.0;
  fbreakdown_VS_BS_VD_BD=0.0;
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=1;
EXIT_IF_ISNAN(1)
}
else
{
if
((pInst->vav>((-0.999)*pModel->VBRBOTD_i)))
{
if
((pModel->PBRBOTD_i==4))
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvbot_d))
double m00_fabs(d00_fabs1,(pInst->vav*pModel->VBRinvbot_d))
double m00_fabs(d00_fabs2,(pInst->vav*pModel->VBRinvbot_d))
double m00_fabs(d00_fabs3,(pInst->vav*pModel->VBRinvbot_d))
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvbot_d))
double m10_fabs(d10_fabs1,d00_fabs1,(pInst->vav*pModel->VBRinvbot_d))
double m10_fabs(d10_fabs2,d00_fabs2,(pInst->vav*pModel->VBRinvbot_d))
double m10_fabs(d10_fabs3,d00_fabs3,(pInst->vav*pModel->VBRinvbot_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((((((vav_VS_BS*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VS_BS*pModel->VBRinvbot_d)*vav_VS_BS*pModel->VBRinvbot_d+d10_fabs0*(+vav_VS_BS_VS_BS*pModel->VBRinvbot_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvbot_d*d10_fabs0*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs1+(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs0*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VS_BS*pModel->VBRinvbot_d)*vav_VS_BS*pModel->VBRinvbot_d+d10_fabs1*(+vav_VS_BS_VS_BS*pModel->VBRinvbot_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs1))*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VS_BS*pModel->VBRinvbot_d)*vav_VS_BS*pModel->VBRinvbot_d+d10_fabs2*(+vav_VS_BS_VS_BS*pModel->VBRinvbot_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs2))*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VS_BS*pModel->VBRinvbot_d)*vav_VS_BS*pModel->VBRinvbot_d+d10_fabs3*(+vav_VS_BS_VS_BS*pModel->VBRinvbot_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VS_BS_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VD_BD*pModel->VBRinvbot_d)*vav_VS_BS*pModel->VBRinvbot_d+d10_fabs0*(+vav_VS_BS_VD_BD*pModel->VBRinvbot_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvbot_d*d10_fabs0*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs1+(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs0*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VD_BD*pModel->VBRinvbot_d)*vav_VS_BS*pModel->VBRinvbot_d+d10_fabs1*(+vav_VS_BS_VD_BD*pModel->VBRinvbot_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs1))*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VD_BD*pModel->VBRinvbot_d)*vav_VS_BS*pModel->VBRinvbot_d+d10_fabs2*(+vav_VS_BS_VD_BD*pModel->VBRinvbot_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs2))*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VD_BD*pModel->VBRinvbot_d)*vav_VS_BS*pModel->VBRinvbot_d+d10_fabs3*(+vav_VS_BS_VD_BD*pModel->VBRinvbot_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
tmp_VD_BD=((((((vav_VD_BD*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VS_BS*pModel->VBRinvbot_d)*vav_VD_BD*pModel->VBRinvbot_d+d10_fabs0*(+vav_VD_BD_VS_BS*pModel->VBRinvbot_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VD_BD*pModel->VBRinvbot_d*d10_fabs0*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs1+(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs0*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VS_BS*pModel->VBRinvbot_d)*vav_VD_BD*pModel->VBRinvbot_d+d10_fabs1*(+vav_VD_BD_VS_BS*pModel->VBRinvbot_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VD_BD*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs1))*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs1)))*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VS_BS*pModel->VBRinvbot_d)*vav_VD_BD*pModel->VBRinvbot_d+d10_fabs2*(+vav_VD_BD_VS_BS*pModel->VBRinvbot_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VD_BD*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs2))*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvbot_d)*d10_fabs2)))*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VS_BS*pModel->VBRinvbot_d)*vav_VD_BD*pModel->VBRinvbot_d+d10_fabs3*(+vav_VD_BD_VS_BS*pModel->VBRinvbot_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VD_BD_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VD_BD*pModel->VBRinvbot_d)*vav_VD_BD*pModel->VBRinvbot_d+d10_fabs0*(+vav_VD_BD_VD_BD*pModel->VBRinvbot_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VD_BD*pModel->VBRinvbot_d*d10_fabs0*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs1+(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs0*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VD_BD*pModel->VBRinvbot_d)*vav_VD_BD*pModel->VBRinvbot_d+d10_fabs1*(+vav_VD_BD_VD_BD*pModel->VBRinvbot_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VD_BD*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs1))*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs1)))*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VD_BD*pModel->VBRinvbot_d)*vav_VD_BD*pModel->VBRinvbot_d+d10_fabs2*(+vav_VD_BD_VD_BD*pModel->VBRinvbot_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VD_BD*pModel->VBRinvbot_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs2))*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvbot_d)*d10_fabs2)))*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvbot_d))*(vav_VD_BD*pModel->VBRinvbot_d)*vav_VD_BD*pModel->VBRinvbot_d+d10_fabs3*(+vav_VD_BD_VD_BD*pModel->VBRinvbot_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
#endif
pInst->tmp=(((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3);
EXIT_IF_ISNAN((((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3))
}
}
else
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvbot_d))
double m00_pow(d00_pow1,d00_fabs0,pModel->PBRBOTD_i)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvbot_d))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->PBRBOTD_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow1*vav_VS_BS*pModel->VBRinvbot_d*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow1*vav_VD_BD*pModel->VBRinvbot_d*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=(-1*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VS_BS_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
fbreakdown_VD_BD=(-1*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VD_BD_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
#endif
pInst->fbreakdown=(1/(1-pInst->tmp));
EXIT_IF_ISNAN((1/(1-pInst->tmp)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=vav_VS_BS*pModel->slopebot_d;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(+0.0+(+(+vav_VS_BS_VS_BS+(+0.0*pModel->VBRBOTD_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopebot_d+vav_VS_BS*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRBOTD_i))*0.0));
  fbreakdown_VS_BS_VD_BD=(+0.0+(+(+vav_VS_BS_VD_BD+(+0.0*pModel->VBRBOTD_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopebot_d+vav_VS_BS*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRBOTD_i))*0.0));
#endif
fbreakdown_VD_BD=vav_VD_BD*pModel->slopebot_d;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(+0.0+(+(+vav_VD_BD_VS_BS+(+0.0*pModel->VBRBOTD_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopebot_d+vav_VD_BD*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRBOTD_i))*0.0));
  fbreakdown_VD_BD_VD_BD=(+0.0+(+(+vav_VD_BD_VD_BD+(+0.0*pModel->VBRBOTD_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopebot_d+vav_VD_BD*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRBOTD_i))*0.0));
#endif
#endif
pInst->fbreakdown=(pModel->fstopbot_d+((pInst->vav+(0.999*pModel->VBRBOTD_i))*pModel->slopebot_d));
EXIT_IF_ISNAN((pModel->fstopbot_d+((pInst->vav+(0.999*pModel->VBRBOTD_i))*pModel->slopebot_d)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunbot_d_VD_BD=(((((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD));
#if defined(_DERIVATE2)
  ijunbot_d_VD_BD_VD_BD=(+(+(+(+id_VD_BD_VD_BD+isrh_VD_BD_VD_BD)+itat_VD_BD_VD_BD)+ibbt_VD_BD_VD_BD)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VD_BD);
  ijunbot_d_VD_BD_VS_BS=(+(+(+(+id_VD_BD_VS_BS+isrh_VD_BD_VS_BS)+itat_VD_BD_VS_BS)+ibbt_VD_BD_VS_BS)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VS_BS);
#endif
ijunbot_d_VS_BS=(((((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS));
#if defined(_DERIVATE2)
  ijunbot_d_VS_BS_VD_BD=(+(+(+(+id_VS_BS_VD_BD+isrh_VS_BS_VD_BD)+itat_VS_BS_VD_BD)+ibbt_VS_BS_VD_BD)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VD_BD);
  ijunbot_d_VS_BS_VS_BS=(+(+(+(+id_VS_BS_VS_BS+isrh_VS_BS_VS_BS)+itat_VS_BS_VS_BS)+ibbt_VS_BS_VS_BS)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VS_BS);
#endif
#endif
ijunbot_d=((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown);
EXIT_IF_ISNAN(((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown))
}
if
((pInst->LSDRAIN_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunsti_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijunsti_d_VD_BD_VD_BD=0.0;
  ijunsti_d_VD_BD_VS_BS=0.0;
#endif
ijunsti_d_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijunsti_d_VS_BS_VD_BD=0.0;
  ijunsti_d_VS_BS_VS_BS=0.0;
#endif
#endif
ijunsti_d=0;
EXIT_IF_ISNAN(0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjunsti_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  qjunsti_d_VD_BD_VD_BD=0.0;
  qjunsti_d_VD_BD_VS_BS=0.0;
#endif
#if defined(_DERIVATE)
qjunsti_d_VS_BS=0.0;
#endif
#endif
qjunsti_d=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
if
((pModel->one_minus_PSTI_d==0.5))
{
{
double m00_sqrt(d00_sqrt0,(1-(pInst->vj*pModel->vbiinvsti_d)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->vj*pModel->vbiinvsti_d)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vj_VS_BS*pModel->vbiinvsti_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvsti_d)))*(-(vj_VS_BS*pModel->vbiinvsti_d))*(-vj_VS_BS*pModel->vbiinvsti_d)+d10_sqrt0*(+0.0-(+vj_VS_BS_VS_BS*pModel->vbiinvsti_d+vj_VS_BS*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VS_BS_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvsti_d)))*(-(vj_VD_BD*pModel->vbiinvsti_d))*(-vj_VS_BS*pModel->vbiinvsti_d)+d10_sqrt0*(+0.0-(+vj_VS_BS_VD_BD*pModel->vbiinvsti_d+vj_VS_BS*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
tmp_VD_BD=(-vj_VD_BD*pModel->vbiinvsti_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvsti_d)))*(-(vj_VS_BS*pModel->vbiinvsti_d))*(-vj_VD_BD*pModel->vbiinvsti_d)+d10_sqrt0*(+0.0-(+vj_VD_BD_VS_BS*pModel->vbiinvsti_d+vj_VD_BD*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VD_BD_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvsti_d)))*(-(vj_VD_BD*pModel->vbiinvsti_d))*(-vj_VD_BD*pModel->vbiinvsti_d)+d10_sqrt0*(+0.0-(+vj_VD_BD_VD_BD*pModel->vbiinvsti_d+vj_VD_BD*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(1-(pInst->vj*pModel->vbiinvsti_d)),pModel->one_minus_PSTI_d)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(pInst->vj*pModel->vbiinvsti_d)),pModel->one_minus_PSTI_d)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vj_VS_BS*pModel->vbiinvsti_d));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vj_VD_BD*pModel->vbiinvsti_d));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjunsti_d_VD_BD=((pModel->qprefsti_d*(-tmp_VD_BD))+(pModel->qpref2sti_d*(Vjun_d_VD_BD-vj_VD_BD)));
#if defined(_DERIVATE2)
  qjunsti_d_VD_BD_VD_BD=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+pModel->qprefsti_d*(+0.0-tmp_VD_BD_VD_BD))+(+0.0*(Vjun_d-pInst->vj)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+pModel->qpref2sti_d*(+Vjun_d_VD_BD_VD_BD-vj_VD_BD_VD_BD)));
  qjunsti_d_VD_BD_VS_BS=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+pModel->qprefsti_d*(+0.0-tmp_VD_BD_VS_BS))+(+0.0*(Vjun_d-pInst->vj)+0.0*(-vj_VS_BS)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+pModel->qpref2sti_d*(+0.0-vj_VD_BD_VS_BS)));
#endif
#if defined(_DERIVATE)
qjunsti_d_VS_BS=((pModel->qprefsti_d*(-tmp_VS_BS))+(pModel->qpref2sti_d*(-vj_VS_BS)));
#endif
#endif
qjunsti_d=((pModel->qprefsti_d*(1-pInst->tmp))+(pModel->qpref2sti_d*(Vjun_d-pInst->vj)));
EXIT_IF_ISNAN(((pModel->qprefsti_d*(1-pInst->tmp))+(pModel->qpref2sti_d*(Vjun_d-pInst->vj))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
id_VD_BD=(pModel->idsatsti_d*idmult_VD_BD);
#if defined(_DERIVATE2)
  id_VD_BD_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VD_BD+pModel->idsatsti_d*idmult_VD_BD_VD_BD);
  id_VD_BD_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VD_BD+pModel->idsatsti_d*idmult_VD_BD_VS_BS);
#endif
id_VS_BS=(pModel->idsatsti_d*idmult_VS_BS);
#if defined(_DERIVATE2)
  id_VS_BS_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VS_BS+pModel->idsatsti_d*idmult_VS_BS_VD_BD);
  id_VS_BS_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VS_BS+pModel->idsatsti_d*idmult_VS_BS_VS_BS);
#endif
#endif
pInst->id=(pModel->idsatsti_d*pInst->idmult);
EXIT_IF_ISNAN((pModel->idsatsti_d*pInst->idmult))
if
(((pModel->CSRHSTID_i==0)&&(pModel->CTATSTID_i==0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=0.0;
  isrh_VS_BS_VD_BD=0.0;
#endif
isrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=0.0;
  isrh_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->isrh=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbi_minus_vjsrh_VD_BD=(-vjsrh_VD_BD);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VD_BD_VD_BD=(+0.0-vjsrh_VD_BD_VD_BD);
  vbi_minus_vjsrh_VD_BD_VS_BS=(+0.0-vjsrh_VD_BD_VS_BS);
#endif
vbi_minus_vjsrh_VS_BS=(-vjsrh_VS_BS);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VS_BS_VD_BD=(+0.0-vjsrh_VS_BS_VD_BD);
  vbi_minus_vjsrh_VS_BS_VS_BS=(+0.0-vjsrh_VS_BS_VS_BS);
#endif
#endif
pInst->vbi_minus_vjsrh=(pModel->vbisti_d-pInst->vjsrh);
EXIT_IF_ISNAN((pModel->vbisti_d-pInst->vjsrh))
{
double m00_sqrt(d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wsrhstep_VD_BD=(-(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VD_BD_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VD_BD_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VD_BD*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VD_BD+pInst->two_psistar*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VD_BD_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VD_BD_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+pInst->two_psistar*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
wsrhstep_VS_BS=(-(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VS_BS_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VS_BS_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
#endif
pInst->wsrhstep=(1-d00_sqrt0);
EXIT_IF_ISNAN((1-d00_sqrt0))
}
if
((pModel->PSTID_i==0.5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=0.0;
  dwsrh_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->dwsrh=0;
EXIT_IF_ISNAN(0)
}
else
{
{
double m00_logE(d00_logE0,pInst->wsrhstep)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,pInst->wsrhstep)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(1-(2*pModel->PSTID_i));
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=(+(+((+(+wsrhstep_VD_BD_VD_BD*pInst->wsrhstep+wsrhstep_VD_BD*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VD_BD+pInst->wsrhstep*wsrhstep_VD_BD_VD_BD)*d00_logE0+((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VD_BD*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VD_BD+d10_logE0*wsrhstep_VD_BD_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VD_BD)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VD_BD_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD_VD_BD)*(1-(2*pModel->PSTID_i))+(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PSTID_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VD_BD_VS_BS=(+(+((+(+wsrhstep_VD_BD_VS_BS*pInst->wsrhstep+wsrhstep_VD_BD*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VD_BD+pInst->wsrhstep*wsrhstep_VD_BD_VS_BS)*d00_logE0+((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VD_BD*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VD_BD+d10_logE0*wsrhstep_VD_BD_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VD_BD)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VD_BD_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD_VS_BS)*(1-(2*pModel->PSTID_i))+(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PSTID_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
dwsrh_VS_BS=(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(1-(2*pModel->PSTID_i));
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=(+(+((+(+wsrhstep_VS_BS_VD_BD*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VD_BD)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VD_BD)*(1-(2*pModel->PSTID_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PSTID_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VS_BS_VS_BS=(+(+((+(+wsrhstep_VS_BS_VS_BS*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VS_BS)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VS_BS)*(1-(2*pModel->PSTID_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PSTID_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
#endif
pInst->dwsrh=(((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PSTID_i)));
EXIT_IF_ISNAN((((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PSTID_i))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wsrh_VD_BD=(wsrhstep_VD_BD+dwsrh_VD_BD);
#if defined(_DERIVATE2)
  wsrh_VD_BD_VD_BD=(+wsrhstep_VD_BD_VD_BD+dwsrh_VD_BD_VD_BD);
  wsrh_VD_BD_VS_BS=(+wsrhstep_VD_BD_VS_BS+dwsrh_VD_BD_VS_BS);
#endif
wsrh_VS_BS=(wsrhstep_VS_BS+dwsrh_VS_BS);
#if defined(_DERIVATE2)
  wsrh_VS_BS_VD_BD=(+wsrhstep_VS_BS_VD_BD+dwsrh_VS_BS_VD_BD);
  wsrh_VS_BS_VS_BS=(+wsrhstep_VS_BS_VS_BS+dwsrh_VS_BS_VS_BS);
#endif
#endif
pInst->wsrh=(pInst->wsrhstep+pInst->dwsrh);
EXIT_IF_ISNAN((pInst->wsrhstep+pInst->dwsrh))
if
((pModel->PSTID_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv_d))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv_d))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv_d)*vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VS_BS*pModel->VBIRSTIinv_d+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv_d))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRSTIinv_d)*vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VD_BD*pModel->VBIRSTIinv_d+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
tmp_VD_BD=vbi_minus_vjsrh_VD_BD*pModel->VBIRSTIinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv_d))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv_d)*vbi_minus_vjsrh_VD_BD*pModel->VBIRSTIinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VD_BD_VS_BS*pModel->VBIRSTIinv_d+vbi_minus_vjsrh_VD_BD*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VD_BD_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv_d))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRSTIinv_d)*vbi_minus_vjsrh_VD_BD*pModel->VBIRSTIinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VD_BD_VD_BD*pModel->VBIRSTIinv_d+vbi_minus_vjsrh_VD_BD*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv_d),pModel->PSTID_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRSTIinv_d),pModel->PSTID_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*vbi_minus_vjsrh_VS_BS*pModel->VBIRSTIinv_d);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*vbi_minus_vjsrh_VD_BD*pModel->VBIRSTIinv_d);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wdep_VS_BS=(pModel->wdepnulrsti_d*tmp_VS_BS);
#if defined(_DERIVATE2)
  wdep_VS_BS_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+pModel->wdepnulrsti_d*tmp_VS_BS_VS_BS);
  wdep_VS_BS_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+pModel->wdepnulrsti_d*tmp_VS_BS_VD_BD);
#endif
wdep_VD_BD=(pModel->wdepnulrsti_d*tmp_VD_BD);
#if defined(_DERIVATE2)
  wdep_VD_BD_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+pModel->wdepnulrsti_d*tmp_VD_BD_VS_BS);
  wdep_VD_BD_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+pModel->wdepnulrsti_d*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->wdep=(pModel->wdepnulrsti_d*pInst->tmp);
EXIT_IF_ISNAN((pModel->wdepnulrsti_d*pInst->tmp))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
asrh_VS_BS=(pModel->ftdsti_d*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)));
#if defined(_DERIVATE2)
  asrh_VS_BS_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdsti_d*(+(+zinv_VS_BS_VS_BS-0.0)*pInst->wdep+zinv_VS_BS*wdep_VS_BS+zinv_VS_BS*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VS_BS));
  asrh_VS_BS_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdsti_d*(+(+zinv_VS_BS_VD_BD-0.0)*pInst->wdep+zinv_VS_BS*wdep_VD_BD+zinv_VD_BD*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VD_BD));
#endif
asrh_VD_BD=(pModel->ftdsti_d*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)));
#if defined(_DERIVATE2)
  asrh_VD_BD_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdsti_d*(+(+zinv_VD_BD_VS_BS-0.0)*pInst->wdep+zinv_VD_BD*wdep_VS_BS+zinv_VS_BS*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VS_BS));
  asrh_VD_BD_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdsti_d*(+(+zinv_VD_BD_VD_BD-0.0)*pInst->wdep+zinv_VD_BD*wdep_VD_BD+zinv_VD_BD*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VD_BD));
#endif
#endif
pInst->asrh=(pModel->ftdsti_d*((pInst->zinv-1)*pInst->wdep));
EXIT_IF_ISNAN((pModel->ftdsti_d*((pInst->zinv-1)*pInst->wdep)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=(pModel->CSRHSTID_i*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)));
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHSTID_i*(+asrh_VS_BS_VS_BS*pInst->wsrh+asrh_VS_BS*wsrh_VS_BS+asrh_VS_BS*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VS_BS));
  isrh_VS_BS_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHSTID_i*(+asrh_VS_BS_VD_BD*pInst->wsrh+asrh_VS_BS*wsrh_VD_BD+asrh_VD_BD*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VD_BD));
#endif
isrh_VD_BD=(pModel->CSRHSTID_i*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)));
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHSTID_i*(+asrh_VD_BD_VS_BS*pInst->wsrh+asrh_VD_BD*wsrh_VS_BS+asrh_VS_BS*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VS_BS));
  isrh_VD_BD_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHSTID_i*(+asrh_VD_BD_VD_BD*pInst->wsrh+asrh_VD_BD*wsrh_VD_BD+asrh_VD_BD*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VD_BD));
#endif
#endif
pInst->isrh=(pModel->CSRHSTID_i*(pInst->asrh*pInst->wsrh));
EXIT_IF_ISNAN((pModel->CSRHSTID_i*(pInst->asrh*pInst->wsrh)))
}
if
((pModel->CTATSTID_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=0.0;
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=0.0;
  itat_VS_BS_VD_BD=0.0;
#endif
itat_VD_BD=0.0;
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=0.0;
  itat_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->itat=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
btat_VS_BS=(pModel->btatpartsti_d*((wdep_VS_BS*pModel->one_minus_PSTI_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VS_BS_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PSTI_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PSTI_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PSTI_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartsti_d*((+wdep_VS_BS_VS_BS*pModel->one_minus_PSTI_d+wdep_VS_BS*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PSTI_d*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VS_BS_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PSTI_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PSTI_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PSTI_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartsti_d*((+wdep_VS_BS_VD_BD*pModel->one_minus_PSTI_d+wdep_VS_BS*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PSTI_d*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
btat_VD_BD=(pModel->btatpartsti_d*((wdep_VD_BD*pModel->one_minus_PSTI_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VD_BD_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PSTI_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PSTI_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PSTI_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartsti_d*((+wdep_VD_BD_VS_BS*pModel->one_minus_PSTI_d+wdep_VD_BD*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PSTI_d*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VD_BD_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PSTI_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PSTI_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PSTI_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartsti_d*((+wdep_VD_BD_VD_BD*pModel->one_minus_PSTI_d+wdep_VD_BD*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PSTI_d*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PSTI_d)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
#endif
pInst->btat=(pModel->btatpartsti_d*((pInst->wdep*pModel->one_minus_PSTI_d)/pInst->vbi_minus_vjsrh));
EXIT_IF_ISNAN((pModel->btatpartsti_d*((pInst->wdep*pModel->one_minus_PSTI_d)/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
twoatatoverthreebtat_VS_BS=(-(0.666666666666667*pModel->atatsti_d)*btat_VS_BS/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VS_BS_VS_BS=((+0.0*pModel->atatsti_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatsti_d)*btat_VS_BS_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatsti_d)*btat_VS_BS*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VS_BS_VD_BD=((+0.0*pModel->atatsti_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatsti_d)*btat_VS_BS_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatsti_d)*btat_VS_BS*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
twoatatoverthreebtat_VD_BD=(-(0.666666666666667*pModel->atatsti_d)*btat_VD_BD/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VD_BD_VS_BS=((+0.0*pModel->atatsti_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatsti_d)*btat_VD_BD_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatsti_d)*btat_VD_BD*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VD_BD_VD_BD=((+0.0*pModel->atatsti_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatsti_d)*btat_VD_BD_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatsti_d)*btat_VD_BD*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
#endif
pInst->twoatatoverthreebtat=((0.666666666666667*pModel->atatsti_d)/pInst->btat);
EXIT_IF_ISNAN(((0.666666666666667*pModel->atatsti_d)/pInst->btat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
umaxbeforelimiting_VS_BS=((twoatatoverthreebtat_VS_BS*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VS_BS_VS_BS=(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VS_BS);
  umaxbeforelimiting_VS_BS_VD_BD=(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VD_BD);
#endif
umaxbeforelimiting_VD_BD=((twoatatoverthreebtat_VD_BD*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VD_BD_VS_BS=(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VS_BS);
  umaxbeforelimiting_VD_BD_VD_BD=(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VD_BD);
#endif
#endif
pInst->umaxbeforelimiting=(pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat);
EXIT_IF_ISNAN((pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat))
{
double m00_sqrt(d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umax_VS_BS=((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VS_BS_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VS_BS_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
umax_VD_BD=((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VD_BD_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VD_BD_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
#endif
pInst->umax=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_fabs(d00_fabs0,pInst->umax)
double m00_sqrt(d00_sqrt1,d00_fabs0)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->umax)
double m10_sqrt(d10_sqrt1,d00_sqrt1,d00_fabs0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
sqrtumax_VS_BS=umax_VS_BS*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VS_BS_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VS_BS+d10_fabs0*umax_VS_BS_VS_BS));
  sqrtumax_VS_BS_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VS_BS+d10_fabs0*umax_VS_BS_VD_BD));
#endif
sqrtumax_VD_BD=umax_VD_BD*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VD_BD_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VD_BD+d10_fabs0*umax_VD_BD_VS_BS));
  sqrtumax_VD_BD_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VD_BD+d10_fabs0*umax_VD_BD_VD_BD));
#endif
#endif
pInst->sqrtumax=d00_sqrt1;
EXIT_IF_ISNAN(d00_sqrt1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umaxpoweronepointfive_VS_BS=((umax_VS_BS*pInst->sqrtumax)+(pInst->umax*sqrtumax_VS_BS));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VS_BS_VS_BS=(+umax_VS_BS_VS_BS*pInst->sqrtumax+umax_VS_BS*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VS_BS);
  umaxpoweronepointfive_VS_BS_VD_BD=(+umax_VS_BS_VD_BD*pInst->sqrtumax+umax_VS_BS*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VD_BD);
#endif
umaxpoweronepointfive_VD_BD=((umax_VD_BD*pInst->sqrtumax)+(pInst->umax*sqrtumax_VD_BD));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VD_BD_VS_BS=(+umax_VD_BD_VS_BS*pInst->sqrtumax+umax_VD_BD*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VS_BS);
  umaxpoweronepointfive_VD_BD_VD_BD=(+umax_VD_BD_VD_BD*pInst->sqrtumax+umax_VD_BD*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VD_BD);
#endif
#endif
pInst->umaxpoweronepointfive=(pInst->umax*pInst->sqrtumax);
EXIT_IF_ISNAN((pInst->umax*pInst->sqrtumax))
if
((((-pModel->PSTID_i)*pModel->one_over_one_minus_PSTI_d)==(-1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(-1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VS_BS_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
wgamma_VD_BD=(-1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VD_BD_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
#endif
pInst->wgamma=(1/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN((1/(1+(pInst->btat*pInst->umaxpoweronepointfive))))
}
else
{
{
double m00_pow(d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PSTID_i)*pModel->one_over_one_minus_PSTI_d))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PSTID_i)*pModel->one_over_one_minus_PSTI_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(d10_pow0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=fixme;
  wgamma_VS_BS_VD_BD=fixme;
#endif
wgamma_VD_BD=(d10_pow0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=fixme;
  wgamma_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->wgamma=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wtat_VS_BS=((((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VS_BS_VS_BS=((+wsrh_VS_BS_VS_BS*pInst->wgamma+wsrh_VS_BS*wgamma_VS_BS+wsrh_VS_BS*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VS_BS+wgamma_VS_BS_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VS_BS_VD_BD=((+wsrh_VS_BS_VD_BD*pInst->wgamma+wsrh_VS_BS*wgamma_VD_BD+wsrh_VD_BD*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VD_BD+wgamma_VS_BS_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
wtat_VD_BD=((((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VD_BD_VS_BS=((+wsrh_VD_BD_VS_BS*pInst->wgamma+wsrh_VD_BD*wgamma_VS_BS+wsrh_VS_BS*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VS_BS+wgamma_VD_BD_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VD_BD_VD_BD=((+wsrh_VD_BD_VD_BD*pInst->wgamma+wsrh_VD_BD*wgamma_VD_BD+wsrh_VD_BD*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VD_BD+wgamma_VD_BD_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
#endif
pInst->wtat=((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
EXIT_IF_ISNAN(((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma)))
{
double m00_sqrt(d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ktat_VS_BS=(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VS_BS_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VS_BS/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VS_BS_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VD_BD/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
ktat_VD_BD=(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VD_BD_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VS_BS/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VD_BD_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VD_BD/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
#endif
pInst->ktat=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ltat_VS_BS=((2*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))-umax_VS_BS);
#if defined(_DERIVATE2)
  ltat_VS_BS_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VS_BS))-umax_VS_BS_VS_BS);
  ltat_VS_BS_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VD_BD))-umax_VS_BS_VD_BD);
#endif
ltat_VD_BD=((2*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))-umax_VD_BD);
#if defined(_DERIVATE2)
  ltat_VD_BD_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VS_BS))-umax_VD_BD_VS_BS);
  ltat_VD_BD_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VD_BD))-umax_VD_BD_VD_BD);
#endif
#endif
pInst->ltat=((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax);
EXIT_IF_ISNAN(((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
mtat_VS_BS=(((((pModel->atatsti_d*twoatatoverthreebtat_VS_BS)*pInst->sqrtumax)+((pModel->atatsti_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS))-(pModel->atatsti_d*umax_VS_BS))+(0.5*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))));
#if defined(_DERIVATE2)
  mtat_VS_BS_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VS_BS+pModel->atatsti_d*twoatatoverthreebtat_VS_BS_VS_BS)*pInst->sqrtumax+(pModel->atatsti_d*twoatatoverthreebtat_VS_BS)*sqrtumax_VS_BS+((pModel->atatsti_d*twoatatoverthreebtat_VS_BS))*sqrtumax_VS_BS+(pModel->atatsti_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VS_BS+pModel->atatsti_d*umax_VS_BS_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)));
  mtat_VS_BS_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VS_BS+pModel->atatsti_d*twoatatoverthreebtat_VS_BS_VD_BD)*pInst->sqrtumax+(pModel->atatsti_d*twoatatoverthreebtat_VS_BS)*sqrtumax_VD_BD+((pModel->atatsti_d*twoatatoverthreebtat_VD_BD))*sqrtumax_VS_BS+(pModel->atatsti_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VS_BS+pModel->atatsti_d*umax_VS_BS_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)));
#endif
mtat_VD_BD=(((((pModel->atatsti_d*twoatatoverthreebtat_VD_BD)*pInst->sqrtumax)+((pModel->atatsti_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD))-(pModel->atatsti_d*umax_VD_BD))+(0.5*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))));
#if defined(_DERIVATE2)
  mtat_VD_BD_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VD_BD+pModel->atatsti_d*twoatatoverthreebtat_VD_BD_VS_BS)*pInst->sqrtumax+(pModel->atatsti_d*twoatatoverthreebtat_VD_BD)*sqrtumax_VS_BS+((pModel->atatsti_d*twoatatoverthreebtat_VS_BS))*sqrtumax_VD_BD+(pModel->atatsti_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VD_BD+pModel->atatsti_d*umax_VD_BD_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)));
  mtat_VD_BD_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VD_BD+pModel->atatsti_d*twoatatoverthreebtat_VD_BD_VD_BD)*pInst->sqrtumax+(pModel->atatsti_d*twoatatoverthreebtat_VD_BD)*sqrtumax_VD_BD+((pModel->atatsti_d*twoatatoverthreebtat_VD_BD))*sqrtumax_VD_BD+(pModel->atatsti_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VD_BD+pModel->atatsti_d*umax_VD_BD_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)));
#endif
#endif
pInst->mtat=((((pModel->atatsti_d*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatsti_d*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN(((((pModel->atatsti_d*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatsti_d*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive))))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xerfc_VS_BS=((ltat_VS_BS*pInst->ktat)+((pInst->ltat-1)*ktat_VS_BS));
#if defined(_DERIVATE2)
  xerfc_VS_BS_VS_BS=(+(+ltat_VS_BS_VS_BS-0.0)*pInst->ktat+ltat_VS_BS*ktat_VS_BS+ltat_VS_BS*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VS_BS);
  xerfc_VS_BS_VD_BD=(+(+ltat_VS_BS_VD_BD-0.0)*pInst->ktat+ltat_VS_BS*ktat_VD_BD+ltat_VD_BD*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VD_BD);
#endif
xerfc_VD_BD=((ltat_VD_BD*pInst->ktat)+((pInst->ltat-1)*ktat_VD_BD));
#if defined(_DERIVATE2)
  xerfc_VD_BD_VS_BS=(+(+ltat_VD_BD_VS_BS-0.0)*pInst->ktat+ltat_VD_BD*ktat_VS_BS+ltat_VS_BS*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VS_BS);
  xerfc_VD_BD_VD_BD=(+(+ltat_VD_BD_VD_BD-0.0)*pInst->ktat+ltat_VD_BD*ktat_VD_BD+ltat_VD_BD*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VD_BD);
#endif
#endif
pInst->xerfc=((pInst->ltat-1)*pInst->ktat);
EXIT_IF_ISNAN(((pInst->ltat-1)*pInst->ktat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ysq_VS_BS=((xerfc_VS_BS*pInst->xerfc)+(pInst->xerfc*xerfc_VS_BS));
#if defined(_DERIVATE2)
  ysq_VS_BS_VS_BS=(+xerfc_VS_BS_VS_BS*pInst->xerfc+xerfc_VS_BS*xerfc_VS_BS+xerfc_VS_BS*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VS_BS);
  ysq_VS_BS_VD_BD=(+xerfc_VS_BS_VD_BD*pInst->xerfc+xerfc_VS_BS*xerfc_VD_BD+xerfc_VD_BD*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VD_BD);
#endif
ysq_VD_BD=((xerfc_VD_BD*pInst->xerfc)+(pInst->xerfc*xerfc_VD_BD));
#if defined(_DERIVATE2)
  ysq_VD_BD_VS_BS=(+xerfc_VD_BD_VS_BS*pInst->xerfc+xerfc_VD_BD*xerfc_VS_BS+xerfc_VS_BS*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VS_BS);
  ysq_VD_BD_VD_BD=(+xerfc_VD_BD_VD_BD*pInst->xerfc+xerfc_VD_BD*xerfc_VD_BD+xerfc_VD_BD*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VD_BD);
#endif
#endif
pInst->ysq=(pInst->xerfc*pInst->xerfc);
EXIT_IF_ISNAN((pInst->xerfc*pInst->xerfc))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(pModel->perfc*xerfc_VS_BS)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(pModel->perfc*xerfc_VD_BD)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1+(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1+(pModel->perfc*pInst->xerfc))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(-(pModel->perfc*xerfc_VS_BS))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(-(pModel->perfc*xerfc_VD_BD))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1-(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1-(pModel->perfc*pInst->xerfc))))
}
if
((((-pInst->ysq)+pInst->mtat)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,((-pInst->ysq)+pInst->mtat))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((-ysq_VS_BS)+mtat_VS_BS)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VS_BS));
  tmp_VS_BS_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VD_BD));
#endif
tmp_VD_BD=((-ysq_VD_BD)+mtat_VD_BD)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VS_BS));
  tmp_VD_BD_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VD_BD));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
erfcpos_VS_BS=(((((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS));
#if defined(_DERIVATE2)
  erfcpos_VS_BS_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VS_BS);
  erfcpos_VS_BS_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VD_BD);
#endif
erfcpos_VD_BD=(((((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD));
#if defined(_DERIVATE2)
  erfcpos_VD_BD_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VS_BS);
  erfcpos_VD_BD_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->erfcpos=((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp);
EXIT_IF_ISNAN(((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=erfcpos_VS_BS;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=erfcpos_VS_BS_VS_BS;
  erfctimesexpmtat_VS_BS_VD_BD=erfcpos_VS_BS_VD_BD;
#endif
erfctimesexpmtat_VD_BD=erfcpos_VD_BD;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=erfcpos_VD_BD_VS_BS;
  erfctimesexpmtat_VD_BD_VD_BD=erfcpos_VD_BD_VD_BD;
#endif
#endif
pInst->erfctimesexpmtat=pInst->erfcpos;
EXIT_IF_ISNAN(pInst->erfcpos)
}
else
{
if
((pInst->mtat>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,pInst->mtat)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=mtat_VS_BS*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VS_BS+d10_exp0*mtat_VS_BS_VS_BS);
  tmp_VS_BS_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VS_BS+d10_exp0*mtat_VS_BS_VD_BD);
#endif
tmp_VD_BD=mtat_VD_BD*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VD_BD+d10_exp0*mtat_VD_BD_VS_BS);
  tmp_VD_BD_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VD_BD+d10_exp0*mtat_VD_BD_VD_BD);
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=((2*tmp_VS_BS)-erfcpos_VS_BS);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+2*tmp_VS_BS_VS_BS)-erfcpos_VS_BS_VS_BS);
  erfctimesexpmtat_VS_BS_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+2*tmp_VS_BS_VD_BD)-erfcpos_VS_BS_VD_BD);
#endif
erfctimesexpmtat_VD_BD=((2*tmp_VD_BD)-erfcpos_VD_BD);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+2*tmp_VD_BD_VS_BS)-erfcpos_VD_BD_VS_BS);
  erfctimesexpmtat_VD_BD_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+2*tmp_VD_BD_VD_BD)-erfcpos_VD_BD_VD_BD);
#endif
#endif
pInst->erfctimesexpmtat=((2*pInst->tmp)-pInst->erfcpos);
EXIT_IF_ISNAN(((2*pInst->tmp)-pInst->erfcpos))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
gammamax_VS_BS=((1.77245385090551603*0.5)*(((pModel->atatsti_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VS_BS_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatsti_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatsti_d*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatsti_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VS_BS+pModel->atatsti_d*erfctimesexpmtat_VS_BS_VS_BS)/pInst->ktat-((pModel->atatsti_d*erfctimesexpmtat_VS_BS)*ktat_VS_BS+((pModel->atatsti_d*erfctimesexpmtat_VS_BS))*ktat_VS_BS+(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VS_BS_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatsti_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatsti_d*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatsti_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VS_BS+pModel->atatsti_d*erfctimesexpmtat_VS_BS_VD_BD)/pInst->ktat-((pModel->atatsti_d*erfctimesexpmtat_VS_BS)*ktat_VD_BD+((pModel->atatsti_d*erfctimesexpmtat_VD_BD))*ktat_VS_BS+(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
gammamax_VD_BD=((1.77245385090551603*0.5)*(((pModel->atatsti_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VD_BD_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatsti_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatsti_d*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatsti_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VD_BD+pModel->atatsti_d*erfctimesexpmtat_VD_BD_VS_BS)/pInst->ktat-((pModel->atatsti_d*erfctimesexpmtat_VD_BD)*ktat_VS_BS+((pModel->atatsti_d*erfctimesexpmtat_VS_BS))*ktat_VD_BD+(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VD_BD_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatsti_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatsti_d*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatsti_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VD_BD+pModel->atatsti_d*erfctimesexpmtat_VD_BD_VD_BD)/pInst->ktat-((pModel->atatsti_d*erfctimesexpmtat_VD_BD)*ktat_VD_BD+((pModel->atatsti_d*erfctimesexpmtat_VD_BD))*ktat_VD_BD+(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatsti_d*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
#endif
pInst->gammamax=((1.77245385090551603*0.5)*((pModel->atatsti_d*pInst->erfctimesexpmtat)/pInst->ktat));
EXIT_IF_ISNAN(((1.77245385090551603*0.5)*((pModel->atatsti_d*pInst->erfctimesexpmtat)/pInst->ktat)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=(pModel->CTATSTID_i*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)));
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATSTID_i*(+(+asrh_VS_BS_VS_BS*pInst->gammamax+asrh_VS_BS*gammamax_VS_BS+asrh_VS_BS*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VS_BS)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VS_BS));
  itat_VS_BS_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATSTID_i*(+(+asrh_VS_BS_VD_BD*pInst->gammamax+asrh_VS_BS*gammamax_VD_BD+asrh_VD_BD*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VD_BD)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VD_BD));
#endif
itat_VD_BD=(pModel->CTATSTID_i*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)));
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATSTID_i*(+(+asrh_VD_BD_VS_BS*pInst->gammamax+asrh_VD_BD*gammamax_VS_BS+asrh_VS_BS*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VS_BS)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VS_BS));
  itat_VD_BD_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATSTID_i*(+(+asrh_VD_BD_VD_BD*pInst->gammamax+asrh_VD_BD*gammamax_VD_BD+asrh_VD_BD*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VD_BD)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VD_BD));
#endif
#endif
pInst->itat=(pModel->CTATSTID_i*((pInst->asrh*pInst->gammamax)*pInst->wtat));
EXIT_IF_ISNAN((pModel->CTATSTID_i*((pInst->asrh*pInst->gammamax)*pInst->wtat)))
}
if
((pModel->CBBTSTID_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=0.0;
  ibbt_VS_BS_VD_BD=0.0;
#endif
ibbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=0.0;
  ibbt_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->ibbt=0;
EXIT_IF_ISNAN(0)
}
else
{
if
((pModel->PSTID_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,((pModel->VBIRSTID_i-pInst->vbbt)*pModel->VBIRSTIinv_d))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pModel->VBIRSTID_i-pInst->vbbt)*pModel->VBIRSTIinv_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vbbt_VS_BS)*pModel->VBIRSTIinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->VBIRSTIinv_d))*((-vbbt_VS_BS)*pModel->VBIRSTIinv_d)*(-vbbt_VS_BS)*pModel->VBIRSTIinv_d+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VS_BS)*pModel->VBIRSTIinv_d+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRSTID_i-pInst->vbbt)*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->VBIRSTIinv_d))*((-vbbt_VD_BD)*pModel->VBIRSTIinv_d)*(-vbbt_VS_BS)*pModel->VBIRSTIinv_d+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VD_BD)*pModel->VBIRSTIinv_d+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRSTID_i-pInst->vbbt)*0.0));
#endif
tmp_VD_BD=(-vbbt_VD_BD)*pModel->VBIRSTIinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->VBIRSTIinv_d))*((-vbbt_VS_BS)*pModel->VBIRSTIinv_d)*(-vbbt_VD_BD)*pModel->VBIRSTIinv_d+d10_sqrt0*(+(+0.0-vbbt_VD_BD_VS_BS)*pModel->VBIRSTIinv_d+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRSTID_i-pInst->vbbt)*0.0));
  tmp_VD_BD_VD_BD=(m20_sqrt(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->VBIRSTIinv_d))*((-vbbt_VD_BD)*pModel->VBIRSTIinv_d)*(-vbbt_VD_BD)*pModel->VBIRSTIinv_d+d10_sqrt0*(+(+0.0-vbbt_VD_BD_VD_BD)*pModel->VBIRSTIinv_d+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRSTID_i-pInst->vbbt)*0.0));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,((pModel->VBIRSTID_i-pInst->vbbt)*pModel->VBIRSTIinv_d),pModel->PSTID_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,((pModel->VBIRSTID_i-pInst->vbbt)*pModel->VBIRSTIinv_d),pModel->PSTID_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vbbt_VS_BS)*pModel->VBIRSTIinv_d);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vbbt_VD_BD)*pModel->VBIRSTIinv_d);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Fmaxr_VS_BS=(pModel->one_over_one_minus_PSTI_d*(((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VS_BS_VS_BS=(+0.0*(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d)*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PSTI_d*((+(+0.0-vbbt_VS_BS_VS_BS)*pModel->wdepnulrinvsti_d+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRSTID_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d)*tmp_VS_BS+((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VS_BS_VD_BD=(+0.0*(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d)*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PSTI_d*((+(+0.0-vbbt_VS_BS_VD_BD)*pModel->wdepnulrinvsti_d+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRSTID_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d)*tmp_VS_BS+((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
Fmaxr_VD_BD=(pModel->one_over_one_minus_PSTI_d*(((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VD_BD_VS_BS=(+0.0*(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d)*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PSTI_d*((+(+0.0-vbbt_VD_BD_VS_BS)*pModel->wdepnulrinvsti_d+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRSTID_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvsti_d)*tmp_VD_BD+((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VD_BD_VD_BD=(+0.0*(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d)*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d*pInst->tmp-((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PSTI_d*((+(+0.0-vbbt_VD_BD_VD_BD)*pModel->wdepnulrinvsti_d+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRSTID_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvsti_d)*tmp_VD_BD+((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)*tmp_VD_BD*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
#endif
pInst->Fmaxr=(pModel->one_over_one_minus_PSTI_d*(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)/pInst->tmp));
EXIT_IF_ISNAN((pModel->one_over_one_minus_PSTI_d*(((pModel->VBIRSTID_i-pInst->vbbt)*pModel->wdepnulrinvsti_d)/pInst->tmp)))
{
double m00_fabs(d00_fabs0,((-pModel->fbbtsti_d)/pInst->Fmaxr))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,((-pModel->fbbtsti_d)/pInst->Fmaxr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VS_BS_VD_BD=(m20_exp(((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
tmp_VD_BD=(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VD_BD_VD_BD=(m20_exp(((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((((-pModel->fbbtsti_d)/pInst->Fmaxr)<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtsti_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(1.0e100*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+0.0*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VS_BS_VD_BD=(+0.0*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtsti_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
tmp_VD_BD=(1.0e100*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+0.0*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtsti_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VD_BD_VD_BD=(+0.0*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtsti_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtsti_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtsti_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
pInst->tmp=(1.0e100*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtsti_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=(pModel->CBBTSTID_i*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)));
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTSTID_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+Vjun_d*Fmaxr_VS_BS_VS_BS)*pInst->Fmaxr+(Vjun_d*Fmaxr_VS_BS)*Fmaxr_VS_BS+((Vjun_d*Fmaxr_VS_BS))*Fmaxr_VS_BS+(Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS_VS_BS)*pInst->tmp+(((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VS_BS+(((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VS_BS+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VS_BS));
  ibbt_VS_BS_VD_BD=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTSTID_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VD_BD+Vjun_d_VD_BD*Fmaxr_VS_BS+Vjun_d*Fmaxr_VS_BS_VD_BD)*pInst->Fmaxr+(Vjun_d*Fmaxr_VS_BS)*Fmaxr_VD_BD+(((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*Fmaxr_VS_BS+(Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS_VD_BD)*pInst->tmp+(((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VD_BD+((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VS_BS+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VD_BD));
#endif
ibbt_VD_BD=(pModel->CBBTSTID_i*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)));
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTSTID_i*(+(+(+0.0*pInst->Fmaxr+Vjun_d_VD_BD*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+Vjun_d*Fmaxr_VD_BD_VS_BS)*pInst->Fmaxr+((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*Fmaxr_VS_BS+((Vjun_d*Fmaxr_VS_BS))*Fmaxr_VD_BD+(Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD_VS_BS)*pInst->tmp+((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VS_BS+(((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VD_BD+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VS_BS));
  ibbt_VD_BD_VD_BD=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTSTID_i*(+(+(+Vjun_d_VD_BD_VD_BD*pInst->Fmaxr+Vjun_d_VD_BD*Fmaxr_VD_BD+Vjun_d_VD_BD*Fmaxr_VD_BD+Vjun_d*Fmaxr_VD_BD_VD_BD)*pInst->Fmaxr+((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*Fmaxr_VD_BD+(((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*Fmaxr_VD_BD+(Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD_VD_BD)*pInst->tmp+((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VD_BD+((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VD_BD+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VD_BD));
#endif
#endif
pInst->ibbt=(pModel->CBBTSTID_i*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp));
EXIT_IF_ISNAN((pModel->CBBTSTID_i*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)))
}
if
((pModel->VBRSTID_i>1000))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=0.0;
  fbreakdown_VS_BS_VD_BD=0.0;
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=1;
EXIT_IF_ISNAN(1)
}
else
{
if
((pInst->vav>((-0.999)*pModel->VBRSTID_i)))
{
if
((pModel->PBRSTID_i==4))
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvsti_d))
double m00_fabs(d00_fabs1,(pInst->vav*pModel->VBRinvsti_d))
double m00_fabs(d00_fabs2,(pInst->vav*pModel->VBRinvsti_d))
double m00_fabs(d00_fabs3,(pInst->vav*pModel->VBRinvsti_d))
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvsti_d))
double m10_fabs(d10_fabs1,d00_fabs1,(pInst->vav*pModel->VBRinvsti_d))
double m10_fabs(d10_fabs2,d00_fabs2,(pInst->vav*pModel->VBRinvsti_d))
double m10_fabs(d10_fabs3,d00_fabs3,(pInst->vav*pModel->VBRinvsti_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((((((vav_VS_BS*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VS_BS*pModel->VBRinvsti_d)*vav_VS_BS*pModel->VBRinvsti_d+d10_fabs0*(+vav_VS_BS_VS_BS*pModel->VBRinvsti_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvsti_d*d10_fabs0*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs1+(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs0*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VS_BS*pModel->VBRinvsti_d)*vav_VS_BS*pModel->VBRinvsti_d+d10_fabs1*(+vav_VS_BS_VS_BS*pModel->VBRinvsti_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs1))*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VS_BS*pModel->VBRinvsti_d)*vav_VS_BS*pModel->VBRinvsti_d+d10_fabs2*(+vav_VS_BS_VS_BS*pModel->VBRinvsti_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs2))*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VS_BS*pModel->VBRinvsti_d)*vav_VS_BS*pModel->VBRinvsti_d+d10_fabs3*(+vav_VS_BS_VS_BS*pModel->VBRinvsti_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VS_BS_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VD_BD*pModel->VBRinvsti_d)*vav_VS_BS*pModel->VBRinvsti_d+d10_fabs0*(+vav_VS_BS_VD_BD*pModel->VBRinvsti_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvsti_d*d10_fabs0*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs1+(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs0*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VD_BD*pModel->VBRinvsti_d)*vav_VS_BS*pModel->VBRinvsti_d+d10_fabs1*(+vav_VS_BS_VD_BD*pModel->VBRinvsti_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs1))*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VD_BD*pModel->VBRinvsti_d)*vav_VS_BS*pModel->VBRinvsti_d+d10_fabs2*(+vav_VS_BS_VD_BD*pModel->VBRinvsti_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs2))*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VD_BD*pModel->VBRinvsti_d)*vav_VS_BS*pModel->VBRinvsti_d+d10_fabs3*(+vav_VS_BS_VD_BD*pModel->VBRinvsti_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
tmp_VD_BD=((((((vav_VD_BD*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VS_BS*pModel->VBRinvsti_d)*vav_VD_BD*pModel->VBRinvsti_d+d10_fabs0*(+vav_VD_BD_VS_BS*pModel->VBRinvsti_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VD_BD*pModel->VBRinvsti_d*d10_fabs0*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs1+(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs0*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VS_BS*pModel->VBRinvsti_d)*vav_VD_BD*pModel->VBRinvsti_d+d10_fabs1*(+vav_VD_BD_VS_BS*pModel->VBRinvsti_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VD_BD*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs1))*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs1)))*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VS_BS*pModel->VBRinvsti_d)*vav_VD_BD*pModel->VBRinvsti_d+d10_fabs2*(+vav_VD_BD_VS_BS*pModel->VBRinvsti_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VD_BD*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs2))*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvsti_d)*d10_fabs2)))*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VS_BS*pModel->VBRinvsti_d)*vav_VD_BD*pModel->VBRinvsti_d+d10_fabs3*(+vav_VD_BD_VS_BS*pModel->VBRinvsti_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VD_BD_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VD_BD*pModel->VBRinvsti_d)*vav_VD_BD*pModel->VBRinvsti_d+d10_fabs0*(+vav_VD_BD_VD_BD*pModel->VBRinvsti_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VD_BD*pModel->VBRinvsti_d*d10_fabs0*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs1+(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs0*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VD_BD*pModel->VBRinvsti_d)*vav_VD_BD*pModel->VBRinvsti_d+d10_fabs1*(+vav_VD_BD_VD_BD*pModel->VBRinvsti_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VD_BD*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs1))*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs1)))*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VD_BD*pModel->VBRinvsti_d)*vav_VD_BD*pModel->VBRinvsti_d+d10_fabs2*(+vav_VD_BD_VD_BD*pModel->VBRinvsti_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VD_BD*pModel->VBRinvsti_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs2))*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvsti_d)*d10_fabs2)))*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvsti_d))*(vav_VD_BD*pModel->VBRinvsti_d)*vav_VD_BD*pModel->VBRinvsti_d+d10_fabs3*(+vav_VD_BD_VD_BD*pModel->VBRinvsti_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
#endif
pInst->tmp=(((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3);
EXIT_IF_ISNAN((((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3))
}
}
else
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvsti_d))
double m00_pow(d00_pow1,d00_fabs0,pModel->PBRSTID_i)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvsti_d))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->PBRSTID_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow1*vav_VS_BS*pModel->VBRinvsti_d*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow1*vav_VD_BD*pModel->VBRinvsti_d*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=(-1*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VS_BS_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
fbreakdown_VD_BD=(-1*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VD_BD_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
#endif
pInst->fbreakdown=(1/(1-pInst->tmp));
EXIT_IF_ISNAN((1/(1-pInst->tmp)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=vav_VS_BS*pModel->slopesti_d;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(+0.0+(+(+vav_VS_BS_VS_BS+(+0.0*pModel->VBRSTID_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopesti_d+vav_VS_BS*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRSTID_i))*0.0));
  fbreakdown_VS_BS_VD_BD=(+0.0+(+(+vav_VS_BS_VD_BD+(+0.0*pModel->VBRSTID_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopesti_d+vav_VS_BS*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRSTID_i))*0.0));
#endif
fbreakdown_VD_BD=vav_VD_BD*pModel->slopesti_d;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(+0.0+(+(+vav_VD_BD_VS_BS+(+0.0*pModel->VBRSTID_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopesti_d+vav_VD_BD*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRSTID_i))*0.0));
  fbreakdown_VD_BD_VD_BD=(+0.0+(+(+vav_VD_BD_VD_BD+(+0.0*pModel->VBRSTID_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopesti_d+vav_VD_BD*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRSTID_i))*0.0));
#endif
#endif
pInst->fbreakdown=(pModel->fstopsti_d+((pInst->vav+(0.999*pModel->VBRSTID_i))*pModel->slopesti_d));
EXIT_IF_ISNAN((pModel->fstopsti_d+((pInst->vav+(0.999*pModel->VBRSTID_i))*pModel->slopesti_d)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijunsti_d_VD_BD=(((((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD));
#if defined(_DERIVATE2)
  ijunsti_d_VD_BD_VD_BD=(+(+(+(+id_VD_BD_VD_BD+isrh_VD_BD_VD_BD)+itat_VD_BD_VD_BD)+ibbt_VD_BD_VD_BD)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VD_BD);
  ijunsti_d_VD_BD_VS_BS=(+(+(+(+id_VD_BD_VS_BS+isrh_VD_BD_VS_BS)+itat_VD_BD_VS_BS)+ibbt_VD_BD_VS_BS)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VS_BS);
#endif
ijunsti_d_VS_BS=(((((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS));
#if defined(_DERIVATE2)
  ijunsti_d_VS_BS_VD_BD=(+(+(+(+id_VS_BS_VD_BD+isrh_VS_BS_VD_BD)+itat_VS_BS_VD_BD)+ibbt_VS_BS_VD_BD)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VD_BD);
  ijunsti_d_VS_BS_VS_BS=(+(+(+(+id_VS_BS_VS_BS+isrh_VS_BS_VS_BS)+itat_VS_BS_VS_BS)+ibbt_VS_BS_VS_BS)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VS_BS);
#endif
#endif
ijunsti_d=((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown);
EXIT_IF_ISNAN(((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown))
}
if
((pInst->LGDRAIN_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijungat_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  ijungat_d_VD_BD_VD_BD=0.0;
  ijungat_d_VD_BD_VS_BS=0.0;
#endif
ijungat_d_VS_BS=0.0;
#if defined(_DERIVATE2)
  ijungat_d_VS_BS_VD_BD=0.0;
  ijungat_d_VS_BS_VS_BS=0.0;
#endif
#endif
ijungat_d=0;
EXIT_IF_ISNAN(0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjungat_d_VD_BD=0.0;
#if defined(_DERIVATE2)
  qjungat_d_VD_BD_VD_BD=0.0;
  qjungat_d_VD_BD_VS_BS=0.0;
#endif
#if defined(_DERIVATE)
qjungat_d_VS_BS=0.0;
#endif
#endif
qjungat_d=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
if
((pModel->one_minus_PGAT_d==0.5))
{
{
double m00_sqrt(d00_sqrt0,(1-(pInst->vj*pModel->vbiinvgat_d)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->vj*pModel->vbiinvgat_d)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vj_VS_BS*pModel->vbiinvgat_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvgat_d)))*(-(vj_VS_BS*pModel->vbiinvgat_d))*(-vj_VS_BS*pModel->vbiinvgat_d)+d10_sqrt0*(+0.0-(+vj_VS_BS_VS_BS*pModel->vbiinvgat_d+vj_VS_BS*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VS_BS_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvgat_d)))*(-(vj_VD_BD*pModel->vbiinvgat_d))*(-vj_VS_BS*pModel->vbiinvgat_d)+d10_sqrt0*(+0.0-(+vj_VS_BS_VD_BD*pModel->vbiinvgat_d+vj_VS_BS*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
tmp_VD_BD=(-vj_VD_BD*pModel->vbiinvgat_d)*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((1-(pInst->vj*pModel->vbiinvgat_d)))*(-(vj_VS_BS*pModel->vbiinvgat_d))*(-vj_VD_BD*pModel->vbiinvgat_d)+d10_sqrt0*(+0.0-(+vj_VD_BD_VS_BS*pModel->vbiinvgat_d+vj_VD_BD*0.0+vj_VS_BS*0.0+pInst->vj*0.0)));
  tmp_VD_BD_VD_BD=(m20_sqrt((1-(pInst->vj*pModel->vbiinvgat_d)))*(-(vj_VD_BD*pModel->vbiinvgat_d))*(-vj_VD_BD*pModel->vbiinvgat_d)+d10_sqrt0*(+0.0-(+vj_VD_BD_VD_BD*pModel->vbiinvgat_d+vj_VD_BD*0.0+vj_VD_BD*0.0+pInst->vj*0.0)));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(1-(pInst->vj*pModel->vbiinvgat_d)),pModel->one_minus_PGAT_d)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1-(pInst->vj*pModel->vbiinvgat_d)),pModel->one_minus_PGAT_d)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vj_VS_BS*pModel->vbiinvgat_d));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vj_VD_BD*pModel->vbiinvgat_d));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(D,GND) */
qjungat_d_VD_BD=((pModel->qprefgat_d*(-tmp_VD_BD))+(pModel->qpref2gat_d*(Vjun_d_VD_BD-vj_VD_BD)));
#if defined(_DERIVATE2)
  qjungat_d_VD_BD_VD_BD=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+pModel->qprefgat_d*(+0.0-tmp_VD_BD_VD_BD))+(+0.0*(Vjun_d-pInst->vj)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+pModel->qpref2gat_d*(+Vjun_d_VD_BD_VD_BD-vj_VD_BD_VD_BD)));
  qjungat_d_VD_BD_VS_BS=(+(+0.0*(1-pInst->tmp)+0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+pModel->qprefgat_d*(+0.0-tmp_VD_BD_VS_BS))+(+0.0*(Vjun_d-pInst->vj)+0.0*(-vj_VS_BS)+0.0*(Vjun_d_VD_BD-vj_VD_BD)+pModel->qpref2gat_d*(+0.0-vj_VD_BD_VS_BS)));
#endif
#if defined(_DERIVATE)
qjungat_d_VS_BS=((pModel->qprefgat_d*(-tmp_VS_BS))+(pModel->qpref2gat_d*(-vj_VS_BS)));
#endif
#endif
qjungat_d=((pModel->qprefgat_d*(1-pInst->tmp))+(pModel->qpref2gat_d*(Vjun_d-pInst->vj)));
EXIT_IF_ISNAN(((pModel->qprefgat_d*(1-pInst->tmp))+(pModel->qpref2gat_d*(Vjun_d-pInst->vj))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
id_VD_BD=(pModel->idsatgat_d*idmult_VD_BD);
#if defined(_DERIVATE2)
  id_VD_BD_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VD_BD+pModel->idsatgat_d*idmult_VD_BD_VD_BD);
  id_VD_BD_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VD_BD+pModel->idsatgat_d*idmult_VD_BD_VS_BS);
#endif
id_VS_BS=(pModel->idsatgat_d*idmult_VS_BS);
#if defined(_DERIVATE2)
  id_VS_BS_VD_BD=(+0.0*pInst->idmult+0.0*idmult_VD_BD+0.0*idmult_VS_BS+pModel->idsatgat_d*idmult_VS_BS_VD_BD);
  id_VS_BS_VS_BS=(+0.0*pInst->idmult+0.0*idmult_VS_BS+0.0*idmult_VS_BS+pModel->idsatgat_d*idmult_VS_BS_VS_BS);
#endif
#endif
pInst->id=(pModel->idsatgat_d*pInst->idmult);
EXIT_IF_ISNAN((pModel->idsatgat_d*pInst->idmult))
if
(((pModel->CSRHGATD_i==0)&&(pModel->CTATGATD_i==0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=0.0;
  isrh_VS_BS_VD_BD=0.0;
#endif
isrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=0.0;
  isrh_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->isrh=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
vbi_minus_vjsrh_VD_BD=(-vjsrh_VD_BD);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VD_BD_VD_BD=(+0.0-vjsrh_VD_BD_VD_BD);
  vbi_minus_vjsrh_VD_BD_VS_BS=(+0.0-vjsrh_VD_BD_VS_BS);
#endif
vbi_minus_vjsrh_VS_BS=(-vjsrh_VS_BS);
#if defined(_DERIVATE2)
  vbi_minus_vjsrh_VS_BS_VD_BD=(+0.0-vjsrh_VS_BS_VD_BD);
  vbi_minus_vjsrh_VS_BS_VS_BS=(+0.0-vjsrh_VS_BS_VS_BS);
#endif
#endif
pInst->vbi_minus_vjsrh=(pModel->vbigat_d-pInst->vjsrh);
EXIT_IF_ISNAN((pModel->vbigat_d-pInst->vjsrh))
{
double m00_sqrt(d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wsrhstep_VD_BD=(-(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VD_BD_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VD_BD_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VD_BD*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VD_BD+pInst->two_psistar*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VD_BD_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VD_BD_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+pInst->two_psistar*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
wsrhstep_VS_BS=(-(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*d10_sqrt0);
#if defined(_DERIVATE2)
  wsrhstep_VS_BS_VD_BD=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VD_BD*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VD_BD/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VD_BD+two_psistar_VD_BD*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
  wsrhstep_VS_BS_VS_BS=(+0.0-(m20_sqrt((1-(pInst->two_psistar/pInst->vbi_minus_vjsrh)))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))*(-((two_psistar_VS_BS*pInst->vbi_minus_vjsrh-pInst->two_psistar*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))+d10_sqrt0*(+0.0-(two_psistar_VS_BS_VS_BS/pInst->vbi_minus_vjsrh-(two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+two_psistar_VS_BS*vbi_minus_vjsrh_VS_BS+pInst->two_psistar*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*pInst->two_psistar*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh))));
#endif
#endif
pInst->wsrhstep=(1-d00_sqrt0);
EXIT_IF_ISNAN((1-d00_sqrt0))
}
if
((pModel->PGATD_i==0.5))
{
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=0.0;
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=0.0;
  dwsrh_VD_BD_VS_BS=0.0;
#endif
dwsrh_VS_BS=0.0;
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=0.0;
  dwsrh_VS_BS_VS_BS=0.0;
#endif
#endif
pInst->dwsrh=0;
EXIT_IF_ISNAN(0)
}
else
{
{
double m00_logE(d00_logE0,pInst->wsrhstep)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,pInst->wsrhstep)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
dwsrh_VD_BD=(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(1-(2*pModel->PGATD_i));
#if defined(_DERIVATE2)
  dwsrh_VD_BD_VD_BD=(+(+((+(+wsrhstep_VD_BD_VD_BD*pInst->wsrhstep+wsrhstep_VD_BD*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VD_BD+pInst->wsrhstep*wsrhstep_VD_BD_VD_BD)*d00_logE0+((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VD_BD*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VD_BD+d10_logE0*wsrhstep_VD_BD_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VD_BD)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VD_BD_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD_VD_BD)*(1-(2*pModel->PGATD_i))+(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PGATD_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VD_BD_VS_BS=(+(+((+(+wsrhstep_VD_BD_VS_BS*pInst->wsrhstep+wsrhstep_VD_BD*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VD_BD+pInst->wsrhstep*wsrhstep_VD_BD_VS_BS)*d00_logE0+((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VD_BD*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VD_BD+d10_logE0*wsrhstep_VD_BD_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VD_BD)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VD_BD_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD_VS_BS)*(1-(2*pModel->PGATD_i))+(((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PGATD_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
dwsrh_VS_BS=(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(1-(2*pModel->PGATD_i));
#if defined(_DERIVATE2)
  dwsrh_VS_BS_VD_BD=(+(+((+(+wsrhstep_VS_BS_VD_BD*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VD_BD+wsrhstep_VD_BD*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VD_BD)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VD_BD*d10_logE0+(((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VD_BD*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VD_BD)+((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VD_BD)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VD_BD)*(1-(2*pModel->PGATD_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VD_BD*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VD_BD)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VD_BD*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VD_BD))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VD_BD)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PGATD_i+0.0*0.0+0.0*0.0+2*0.0)));
  dwsrh_VS_BS_VS_BS=(+(+((+(+wsrhstep_VS_BS_VS_BS*pInst->wsrhstep+wsrhstep_VS_BS*wsrhstep_VS_BS+wsrhstep_VS_BS*wsrhstep_VS_BS+pInst->wsrhstep*wsrhstep_VS_BS_VS_BS)*d00_logE0+((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*wsrhstep_VS_BS*d10_logE0+(((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*wsrhstep_VS_BS*d10_logE0+(pInst->wsrhstep*pInst->wsrhstep)*(m20_logE(pInst->wsrhstep)*wsrhstep_VS_BS*wsrhstep_VS_BS+d10_logE0*wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)-(((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(-wsrhstep_VS_BS)+((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(-wsrhstep_VS_BS)+((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(+0.0-wsrhstep_VS_BS_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)+2*((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS)*(-wsrhstep_VS_BS)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS_VS_BS)*(1-(2*pModel->PGATD_i))+(((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*(-(0.0))+(((((((((wsrhstep_VS_BS*pInst->wsrhstep)+(pInst->wsrhstep*wsrhstep_VS_BS)))*d00_logE0)+((pInst->wsrhstep*pInst->wsrhstep)*wsrhstep_VS_BS*d10_logE0)))*(1-pInst->wsrhstep)-((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)*(-wsrhstep_VS_BS))/(1-pInst->wsrhstep)/(1-pInst->wsrhstep))+wsrhstep_VS_BS)*0.0+((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(+0.0-(+0.0*pModel->PGATD_i+0.0*0.0+0.0*0.0+2*0.0)));
#endif
#endif
pInst->dwsrh=(((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PGATD_i)));
EXIT_IF_ISNAN((((((pInst->wsrhstep*pInst->wsrhstep)*d00_logE0)/(1-pInst->wsrhstep))+pInst->wsrhstep)*(1-(2*pModel->PGATD_i))))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wsrh_VD_BD=(wsrhstep_VD_BD+dwsrh_VD_BD);
#if defined(_DERIVATE2)
  wsrh_VD_BD_VD_BD=(+wsrhstep_VD_BD_VD_BD+dwsrh_VD_BD_VD_BD);
  wsrh_VD_BD_VS_BS=(+wsrhstep_VD_BD_VS_BS+dwsrh_VD_BD_VS_BS);
#endif
wsrh_VS_BS=(wsrhstep_VS_BS+dwsrh_VS_BS);
#if defined(_DERIVATE2)
  wsrh_VS_BS_VD_BD=(+wsrhstep_VS_BS_VD_BD+dwsrh_VS_BS_VD_BD);
  wsrh_VS_BS_VS_BS=(+wsrhstep_VS_BS_VS_BS+dwsrh_VS_BS_VS_BS);
#endif
#endif
pInst->wsrh=(pInst->wsrhstep+pInst->dwsrh);
EXIT_IF_ISNAN((pInst->wsrhstep+pInst->dwsrh))
if
((pModel->PGATD_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRGATinv_d))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->vbi_minus_vjsrh*pModel->VBIRGATinv_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRGATinv_d))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv_d)*vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VS_BS*pModel->VBIRGATinv_d+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRGATinv_d))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRGATinv_d)*vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VS_BS_VD_BD*pModel->VBIRGATinv_d+vbi_minus_vjsrh_VS_BS*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
tmp_VD_BD=vbi_minus_vjsrh_VD_BD*pModel->VBIRGATinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRGATinv_d))*(vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv_d)*vbi_minus_vjsrh_VD_BD*pModel->VBIRGATinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VD_BD_VS_BS*pModel->VBIRGATinv_d+vbi_minus_vjsrh_VD_BD*0.0+vbi_minus_vjsrh_VS_BS*0.0+pInst->vbi_minus_vjsrh*0.0));
  tmp_VD_BD_VD_BD=(m20_sqrt((pInst->vbi_minus_vjsrh*pModel->VBIRGATinv_d))*(vbi_minus_vjsrh_VD_BD*pModel->VBIRGATinv_d)*vbi_minus_vjsrh_VD_BD*pModel->VBIRGATinv_d+d10_sqrt0*(+vbi_minus_vjsrh_VD_BD_VD_BD*pModel->VBIRGATinv_d+vbi_minus_vjsrh_VD_BD*0.0+vbi_minus_vjsrh_VD_BD*0.0+pInst->vbi_minus_vjsrh*0.0));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRGATinv_d),pModel->PGATD_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(pInst->vbi_minus_vjsrh*pModel->VBIRGATinv_d),pModel->PGATD_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*vbi_minus_vjsrh_VS_BS*pModel->VBIRGATinv_d);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*vbi_minus_vjsrh_VD_BD*pModel->VBIRGATinv_d);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wdep_VS_BS=(pModel->wdepnulrgat_d*tmp_VS_BS);
#if defined(_DERIVATE2)
  wdep_VS_BS_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+pModel->wdepnulrgat_d*tmp_VS_BS_VS_BS);
  wdep_VS_BS_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+pModel->wdepnulrgat_d*tmp_VS_BS_VD_BD);
#endif
wdep_VD_BD=(pModel->wdepnulrgat_d*tmp_VD_BD);
#if defined(_DERIVATE2)
  wdep_VD_BD_VS_BS=(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+pModel->wdepnulrgat_d*tmp_VD_BD_VS_BS);
  wdep_VD_BD_VD_BD=(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+pModel->wdepnulrgat_d*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->wdep=(pModel->wdepnulrgat_d*pInst->tmp);
EXIT_IF_ISNAN((pModel->wdepnulrgat_d*pInst->tmp))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
asrh_VS_BS=(pModel->ftdgat_d*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)));
#if defined(_DERIVATE2)
  asrh_VS_BS_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdgat_d*(+(+zinv_VS_BS_VS_BS-0.0)*pInst->wdep+zinv_VS_BS*wdep_VS_BS+zinv_VS_BS*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VS_BS));
  asrh_VS_BS_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS))+pModel->ftdgat_d*(+(+zinv_VS_BS_VD_BD-0.0)*pInst->wdep+zinv_VS_BS*wdep_VD_BD+zinv_VD_BD*wdep_VS_BS+(pInst->zinv-1)*wdep_VS_BS_VD_BD));
#endif
asrh_VD_BD=(pModel->ftdgat_d*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)));
#if defined(_DERIVATE2)
  asrh_VD_BD_VS_BS=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VS_BS*pInst->wdep)+((pInst->zinv-1)*wdep_VS_BS)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdgat_d*(+(+zinv_VD_BD_VS_BS-0.0)*pInst->wdep+zinv_VD_BD*wdep_VS_BS+zinv_VS_BS*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VS_BS));
  asrh_VD_BD_VD_BD=(+0.0*((pInst->zinv-1)*pInst->wdep)+0.0*(((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD)))+0.0*((zinv_VD_BD*pInst->wdep)+((pInst->zinv-1)*wdep_VD_BD))+pModel->ftdgat_d*(+(+zinv_VD_BD_VD_BD-0.0)*pInst->wdep+zinv_VD_BD*wdep_VD_BD+zinv_VD_BD*wdep_VD_BD+(pInst->zinv-1)*wdep_VD_BD_VD_BD));
#endif
#endif
pInst->asrh=(pModel->ftdgat_d*((pInst->zinv-1)*pInst->wdep));
EXIT_IF_ISNAN((pModel->ftdgat_d*((pInst->zinv-1)*pInst->wdep)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
isrh_VS_BS=(pModel->CSRHGATD_i*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)));
#if defined(_DERIVATE2)
  isrh_VS_BS_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHGATD_i*(+asrh_VS_BS_VS_BS*pInst->wsrh+asrh_VS_BS*wsrh_VS_BS+asrh_VS_BS*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VS_BS));
  isrh_VS_BS_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS))+pModel->CSRHGATD_i*(+asrh_VS_BS_VD_BD*pInst->wsrh+asrh_VS_BS*wsrh_VD_BD+asrh_VD_BD*wsrh_VS_BS+pInst->asrh*wsrh_VS_BS_VD_BD));
#endif
isrh_VD_BD=(pModel->CSRHGATD_i*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)));
#if defined(_DERIVATE2)
  isrh_VD_BD_VS_BS=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VS_BS*pInst->wsrh)+(pInst->asrh*wsrh_VS_BS)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHGATD_i*(+asrh_VD_BD_VS_BS*pInst->wsrh+asrh_VD_BD*wsrh_VS_BS+asrh_VS_BS*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VS_BS));
  isrh_VD_BD_VD_BD=(+0.0*(pInst->asrh*pInst->wsrh)+0.0*(((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD)))+0.0*((asrh_VD_BD*pInst->wsrh)+(pInst->asrh*wsrh_VD_BD))+pModel->CSRHGATD_i*(+asrh_VD_BD_VD_BD*pInst->wsrh+asrh_VD_BD*wsrh_VD_BD+asrh_VD_BD*wsrh_VD_BD+pInst->asrh*wsrh_VD_BD_VD_BD));
#endif
#endif
pInst->isrh=(pModel->CSRHGATD_i*(pInst->asrh*pInst->wsrh));
EXIT_IF_ISNAN((pModel->CSRHGATD_i*(pInst->asrh*pInst->wsrh)))
}
if
((pModel->CTATGATD_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=0.0;
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=0.0;
  itat_VS_BS_VD_BD=0.0;
#endif
itat_VD_BD=0.0;
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=0.0;
  itat_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->itat=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
btat_VS_BS=(pModel->btatpartgat_d*((wdep_VS_BS*pModel->one_minus_PGAT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VS_BS_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PGAT_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PGAT_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PGAT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartgat_d*((+wdep_VS_BS_VS_BS*pModel->one_minus_PGAT_d+wdep_VS_BS*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PGAT_d*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VS_BS_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PGAT_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PGAT_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VS_BS*pModel->one_minus_PGAT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartgat_d*((+wdep_VS_BS_VD_BD*pModel->one_minus_PGAT_d+wdep_VS_BS*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VS_BS*pModel->one_minus_PGAT_d*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS+(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
btat_VD_BD=(pModel->btatpartgat_d*((wdep_VD_BD*pModel->one_minus_PGAT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#if defined(_DERIVATE2)
  btat_VD_BD_VS_BS=(+0.0*((pInst->wdep*pModel->one_minus_PGAT_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VS_BS*pModel->one_minus_PGAT_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PGAT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartgat_d*((+wdep_VD_BD_VS_BS*pModel->one_minus_PGAT_d+wdep_VD_BD*0.0+wdep_VS_BS*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PGAT_d*vbi_minus_vjsrh_VS_BS+(wdep_VS_BS*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD_VS_BS)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VS_BS/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
  btat_VD_BD_VD_BD=(+0.0*((pInst->wdep*pModel->one_minus_PGAT_d)/pInst->vbi_minus_vjsrh)+0.0*(((wdep_VD_BD*pModel->one_minus_PGAT_d)*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+0.0*((wdep_VD_BD*pModel->one_minus_PGAT_d*pInst->vbi_minus_vjsrh-(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh)+pModel->btatpartgat_d*((+wdep_VD_BD_VD_BD*pModel->one_minus_PGAT_d+wdep_VD_BD*0.0+wdep_VD_BD*0.0+pInst->wdep*0.0)/pInst->vbi_minus_vjsrh-(wdep_VD_BD*pModel->one_minus_PGAT_d*vbi_minus_vjsrh_VD_BD+(wdep_VD_BD*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD+(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD_VD_BD)/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh+2*(pInst->wdep*pModel->one_minus_PGAT_d)*vbi_minus_vjsrh_VD_BD*vbi_minus_vjsrh_VD_BD/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh/pInst->vbi_minus_vjsrh));
#endif
#endif
pInst->btat=(pModel->btatpartgat_d*((pInst->wdep*pModel->one_minus_PGAT_d)/pInst->vbi_minus_vjsrh));
EXIT_IF_ISNAN((pModel->btatpartgat_d*((pInst->wdep*pModel->one_minus_PGAT_d)/pInst->vbi_minus_vjsrh)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
twoatatoverthreebtat_VS_BS=(-(0.666666666666667*pModel->atatgat_d)*btat_VS_BS/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VS_BS_VS_BS=((+0.0*pModel->atatgat_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatgat_d)*btat_VS_BS_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatgat_d)*btat_VS_BS*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VS_BS_VD_BD=((+0.0*pModel->atatgat_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VS_BS+(0.666666666666667*pModel->atatgat_d)*btat_VS_BS_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatgat_d)*btat_VS_BS*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
twoatatoverthreebtat_VD_BD=(-(0.666666666666667*pModel->atatgat_d)*btat_VD_BD/pInst->btat/pInst->btat);
#if defined(_DERIVATE2)
  twoatatoverthreebtat_VD_BD_VS_BS=((+0.0*pModel->atatgat_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VS_BS+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatgat_d)*btat_VD_BD_VS_BS)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatgat_d)*btat_VD_BD*btat_VS_BS/pInst->btat/pInst->btat/pInst->btat);
  twoatatoverthreebtat_VD_BD_VD_BD=((+0.0*pModel->atatgat_d+0.0*0.0+0.0*0.0+0.666666666666667*0.0)/pInst->btat-(0.0*btat_VD_BD+(0.0)*btat_VD_BD+(0.666666666666667*pModel->atatgat_d)*btat_VD_BD_VD_BD)/pInst->btat/pInst->btat+2*(0.666666666666667*pModel->atatgat_d)*btat_VD_BD*btat_VD_BD/pInst->btat/pInst->btat/pInst->btat);
#endif
#endif
pInst->twoatatoverthreebtat=((0.666666666666667*pModel->atatgat_d)/pInst->btat);
EXIT_IF_ISNAN(((0.666666666666667*pModel->atatgat_d)/pInst->btat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
umaxbeforelimiting_VS_BS=((twoatatoverthreebtat_VS_BS*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VS_BS_VS_BS=(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VS_BS);
  umaxbeforelimiting_VS_BS_VD_BD=(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VS_BS_VD_BD);
#endif
umaxbeforelimiting_VD_BD=((twoatatoverthreebtat_VD_BD*pInst->twoatatoverthreebtat)+(pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD));
#if defined(_DERIVATE2)
  umaxbeforelimiting_VD_BD_VS_BS=(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VS_BS+twoatatoverthreebtat_VS_BS*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VS_BS);
  umaxbeforelimiting_VD_BD_VD_BD=(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->twoatatoverthreebtat+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+twoatatoverthreebtat_VD_BD*twoatatoverthreebtat_VD_BD+pInst->twoatatoverthreebtat*twoatatoverthreebtat_VD_BD_VD_BD);
#endif
#endif
pInst->umaxbeforelimiting=(pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat);
EXIT_IF_ISNAN((pInst->twoatatoverthreebtat*pInst->twoatatoverthreebtat))
{
double m00_sqrt(d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umax_VS_BS=((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VS_BS_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VS_BS_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VS_BS_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
umax_VD_BD=((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*d10_sqrt0;
#if defined(_DERIVATE2)
  umax_VD_BD_VS_BS=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))+(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VS_BS*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VS_BS+umaxbeforelimiting_VS_BS*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VS_BS)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VS_BS*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VS_BS)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
  umax_VD_BD_VD_BD=(m20_sqrt(((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)))*(((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))*((((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1))+d10_sqrt0*((+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)-(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))+(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))+(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*(+(+umaxbeforelimiting_VD_BD_VD_BD*pInst->umaxbeforelimiting+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+umaxbeforelimiting_VD_BD*umaxbeforelimiting_VD_BD+pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD_VD_BD)+0.0))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)+2*(pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)*((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD))*(((umaxbeforelimiting_VD_BD*pInst->umaxbeforelimiting)+(pInst->umaxbeforelimiting*umaxbeforelimiting_VD_BD)))/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)/((pInst->umaxbeforelimiting*pInst->umaxbeforelimiting)+1)));
#endif
#endif
pInst->umax=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_fabs(d00_fabs0,pInst->umax)
double m00_sqrt(d00_sqrt1,d00_fabs0)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->umax)
double m10_sqrt(d10_sqrt1,d00_sqrt1,d00_fabs0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
sqrtumax_VS_BS=umax_VS_BS*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VS_BS_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VS_BS+d10_fabs0*umax_VS_BS_VS_BS));
  sqrtumax_VS_BS_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VS_BS*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VS_BS+d10_fabs0*umax_VS_BS_VD_BD));
#endif
sqrtumax_VD_BD=umax_VD_BD*d10_fabs0*d10_sqrt1;
#if defined(_DERIVATE2)
  sqrtumax_VD_BD_VS_BS=(m20_sqrt(d00_fabs0)*umax_VS_BS*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VS_BS*umax_VD_BD+d10_fabs0*umax_VD_BD_VS_BS));
  sqrtumax_VD_BD_VD_BD=(m20_sqrt(d00_fabs0)*umax_VD_BD*d10_fabs0*umax_VD_BD*d10_fabs0+d10_sqrt1*(m20_fabs(pInst->umax)*umax_VD_BD*umax_VD_BD+d10_fabs0*umax_VD_BD_VD_BD));
#endif
#endif
pInst->sqrtumax=d00_sqrt1;
EXIT_IF_ISNAN(d00_sqrt1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
umaxpoweronepointfive_VS_BS=((umax_VS_BS*pInst->sqrtumax)+(pInst->umax*sqrtumax_VS_BS));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VS_BS_VS_BS=(+umax_VS_BS_VS_BS*pInst->sqrtumax+umax_VS_BS*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VS_BS);
  umaxpoweronepointfive_VS_BS_VD_BD=(+umax_VS_BS_VD_BD*pInst->sqrtumax+umax_VS_BS*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VS_BS+pInst->umax*sqrtumax_VS_BS_VD_BD);
#endif
umaxpoweronepointfive_VD_BD=((umax_VD_BD*pInst->sqrtumax)+(pInst->umax*sqrtumax_VD_BD));
#if defined(_DERIVATE2)
  umaxpoweronepointfive_VD_BD_VS_BS=(+umax_VD_BD_VS_BS*pInst->sqrtumax+umax_VD_BD*sqrtumax_VS_BS+umax_VS_BS*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VS_BS);
  umaxpoweronepointfive_VD_BD_VD_BD=(+umax_VD_BD_VD_BD*pInst->sqrtumax+umax_VD_BD*sqrtumax_VD_BD+umax_VD_BD*sqrtumax_VD_BD+pInst->umax*sqrtumax_VD_BD_VD_BD);
#endif
#endif
pInst->umaxpoweronepointfive=(pInst->umax*pInst->sqrtumax);
EXIT_IF_ISNAN((pInst->umax*pInst->sqrtumax))
if
((((-pModel->PGATD_i)*pModel->one_over_one_minus_PGAT_d)==(-1)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(-1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VS_BS_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+1*(+0.0+(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
wgamma_VD_BD=(-1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
  wgamma_VD_BD_VD_BD=(0.0/(1+(pInst->btat*pInst->umaxpoweronepointfive))-(0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+1*(+0.0+(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))+2*1*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive))/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
#endif
#endif
pInst->wgamma=(1/(1+(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN((1/(1+(pInst->btat*pInst->umaxpoweronepointfive))))
}
else
{
{
double m00_pow(d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PGATD_i)*pModel->one_over_one_minus_PGAT_d))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1+(pInst->btat*pInst->umaxpoweronepointfive)),((-pModel->PGATD_i)*pModel->one_over_one_minus_PGAT_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
wgamma_VS_BS=(d10_pow0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)));
#if defined(_DERIVATE2)
  wgamma_VS_BS_VS_BS=fixme;
  wgamma_VS_BS_VD_BD=fixme;
#endif
wgamma_VD_BD=(d10_pow0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)));
#if defined(_DERIVATE2)
  wgamma_VD_BD_VS_BS=fixme;
  wgamma_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->wgamma=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
wtat_VS_BS=((((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VS_BS_VS_BS=((+wsrh_VS_BS_VS_BS*pInst->wgamma+wsrh_VS_BS*wgamma_VS_BS+wsrh_VS_BS*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VS_BS+wgamma_VS_BS_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VS_BS_VD_BD=((+wsrh_VS_BS_VD_BD*pInst->wgamma+wsrh_VS_BS*wgamma_VD_BD+wsrh_VD_BD*wgamma_VS_BS+pInst->wsrh*wgamma_VS_BS_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VS_BS+wgamma_VS_BS)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VS_BS_VD_BD+wgamma_VS_BS_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VS_BS+wgamma_VS_BS)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
wtat_VD_BD=((((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(pInst->wsrh+pInst->wgamma)-(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#if defined(_DERIVATE2)
  wtat_VD_BD_VS_BS=((+wsrh_VD_BD_VS_BS*pInst->wgamma+wsrh_VD_BD*wgamma_VS_BS+wsrh_VS_BS*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VS_BS)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VS_BS+wgamma_VS_BS)+(((wsrh_VS_BS*pInst->wgamma)+(pInst->wsrh*wgamma_VS_BS)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VS_BS+wgamma_VD_BD_VS_BS))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VS_BS+wgamma_VS_BS)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
  wtat_VD_BD_VD_BD=((+wsrh_VD_BD_VD_BD*pInst->wgamma+wsrh_VD_BD*wgamma_VD_BD+wsrh_VD_BD*wgamma_VD_BD+pInst->wsrh*wgamma_VD_BD_VD_BD)/(pInst->wsrh+pInst->wgamma)-(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD))*(wsrh_VD_BD+wgamma_VD_BD)+(((wsrh_VD_BD*pInst->wgamma)+(pInst->wsrh*wgamma_VD_BD)))*(wsrh_VD_BD+wgamma_VD_BD)+(pInst->wsrh*pInst->wgamma)*(+wsrh_VD_BD_VD_BD+wgamma_VD_BD_VD_BD))/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)+2*(pInst->wsrh*pInst->wgamma)*(wsrh_VD_BD+wgamma_VD_BD)*(wsrh_VD_BD+wgamma_VD_BD)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
#endif
#endif
pInst->wtat=((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma));
EXIT_IF_ISNAN(((pInst->wsrh*pInst->wgamma)/(pInst->wsrh+pInst->wgamma)))
{
double m00_sqrt(d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(0.375*(pInst->btat/pInst->sqrtumax)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ktat_VS_BS=(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VS_BS_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VS_BS/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VS_BS_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VS_BS_VD_BD/pInst->sqrtumax-(btat_VS_BS*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VS_BS+pInst->btat*sqrtumax_VS_BS_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VS_BS*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
ktat_VD_BD=(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))*d10_sqrt0;
#if defined(_DERIVATE2)
  ktat_VD_BD_VS_BS=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VS_BS*pInst->sqrtumax-pInst->btat*sqrtumax_VS_BS)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VS_BS/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VS_BS+btat_VS_BS*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VS_BS)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VS_BS/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
  ktat_VD_BD_VD_BD=(m20_sqrt((0.375*(pInst->btat/pInst->sqrtumax)))*((0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)))*(0.375*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax))+d10_sqrt0*(+0.0*(pInst->btat/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.0*((btat_VD_BD*pInst->sqrtumax-pInst->btat*sqrtumax_VD_BD)/pInst->sqrtumax/pInst->sqrtumax)+0.375*(btat_VD_BD_VD_BD/pInst->sqrtumax-(btat_VD_BD*sqrtumax_VD_BD+btat_VD_BD*sqrtumax_VD_BD+pInst->btat*sqrtumax_VD_BD_VD_BD)/pInst->sqrtumax/pInst->sqrtumax+2*pInst->btat*sqrtumax_VD_BD*sqrtumax_VD_BD/pInst->sqrtumax/pInst->sqrtumax/pInst->sqrtumax)));
#endif
#endif
pInst->ktat=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ltat_VS_BS=((2*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))-umax_VS_BS);
#if defined(_DERIVATE2)
  ltat_VS_BS_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VS_BS))-umax_VS_BS_VS_BS);
  ltat_VS_BS_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS))+2*(+twoatatoverthreebtat_VS_BS_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+pInst->twoatatoverthreebtat*sqrtumax_VS_BS_VD_BD))-umax_VS_BS_VD_BD);
#endif
ltat_VD_BD=((2*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))-umax_VD_BD);
#if defined(_DERIVATE2)
  ltat_VD_BD_VS_BS=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VS_BS*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VS_BS)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VS_BS*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VS_BS+twoatatoverthreebtat_VS_BS*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VS_BS))-umax_VD_BD_VS_BS);
  ltat_VD_BD_VD_BD=(+(+0.0*(pInst->twoatatoverthreebtat*pInst->sqrtumax)+0.0*(((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD)))+0.0*((twoatatoverthreebtat_VD_BD*pInst->sqrtumax)+(pInst->twoatatoverthreebtat*sqrtumax_VD_BD))+2*(+twoatatoverthreebtat_VD_BD_VD_BD*pInst->sqrtumax+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+twoatatoverthreebtat_VD_BD*sqrtumax_VD_BD+pInst->twoatatoverthreebtat*sqrtumax_VD_BD_VD_BD))-umax_VD_BD_VD_BD);
#endif
#endif
pInst->ltat=((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax);
EXIT_IF_ISNAN(((2*(pInst->twoatatoverthreebtat*pInst->sqrtumax))-pInst->umax))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
mtat_VS_BS=(((((pModel->atatgat_d*twoatatoverthreebtat_VS_BS)*pInst->sqrtumax)+((pModel->atatgat_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS))-(pModel->atatgat_d*umax_VS_BS))+(0.5*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))));
#if defined(_DERIVATE2)
  mtat_VS_BS_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VS_BS+pModel->atatgat_d*twoatatoverthreebtat_VS_BS_VS_BS)*pInst->sqrtumax+(pModel->atatgat_d*twoatatoverthreebtat_VS_BS)*sqrtumax_VS_BS+((pModel->atatgat_d*twoatatoverthreebtat_VS_BS))*sqrtumax_VS_BS+(pModel->atatgat_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VS_BS+pModel->atatgat_d*umax_VS_BS_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VS_BS*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VS_BS)));
  mtat_VS_BS_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VS_BS+pModel->atatgat_d*twoatatoverthreebtat_VS_BS_VD_BD)*pInst->sqrtumax+(pModel->atatgat_d*twoatatoverthreebtat_VS_BS)*sqrtumax_VD_BD+((pModel->atatgat_d*twoatatoverthreebtat_VD_BD))*sqrtumax_VS_BS+(pModel->atatgat_d*pInst->twoatatoverthreebtat)*sqrtumax_VS_BS_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VS_BS+pModel->atatgat_d*umax_VS_BS_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS))+0.5*(+btat_VS_BS_VD_BD*pInst->umaxpoweronepointfive+btat_VS_BS*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VS_BS+pInst->btat*umaxpoweronepointfive_VS_BS_VD_BD)));
#endif
mtat_VD_BD=(((((pModel->atatgat_d*twoatatoverthreebtat_VD_BD)*pInst->sqrtumax)+((pModel->atatgat_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD))-(pModel->atatgat_d*umax_VD_BD))+(0.5*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))));
#if defined(_DERIVATE2)
  mtat_VD_BD_VS_BS=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VS_BS+0.0*twoatatoverthreebtat_VD_BD+pModel->atatgat_d*twoatatoverthreebtat_VD_BD_VS_BS)*pInst->sqrtumax+(pModel->atatgat_d*twoatatoverthreebtat_VD_BD)*sqrtumax_VS_BS+((pModel->atatgat_d*twoatatoverthreebtat_VS_BS))*sqrtumax_VD_BD+(pModel->atatgat_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VS_BS)-(+0.0*pInst->umax+0.0*umax_VS_BS+0.0*umax_VD_BD+pModel->atatgat_d*umax_VD_BD_VS_BS))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VS_BS*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VS_BS)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VS_BS*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VS_BS+btat_VS_BS*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VS_BS)));
  mtat_VD_BD_VD_BD=(+(+(+(+0.0*pInst->twoatatoverthreebtat+0.0*twoatatoverthreebtat_VD_BD+0.0*twoatatoverthreebtat_VD_BD+pModel->atatgat_d*twoatatoverthreebtat_VD_BD_VD_BD)*pInst->sqrtumax+(pModel->atatgat_d*twoatatoverthreebtat_VD_BD)*sqrtumax_VD_BD+((pModel->atatgat_d*twoatatoverthreebtat_VD_BD))*sqrtumax_VD_BD+(pModel->atatgat_d*pInst->twoatatoverthreebtat)*sqrtumax_VD_BD_VD_BD)-(+0.0*pInst->umax+0.0*umax_VD_BD+0.0*umax_VD_BD+pModel->atatgat_d*umax_VD_BD_VD_BD))+(+0.0*(pInst->btat*pInst->umaxpoweronepointfive)+0.0*(((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD)))+0.0*((btat_VD_BD*pInst->umaxpoweronepointfive)+(pInst->btat*umaxpoweronepointfive_VD_BD))+0.5*(+btat_VD_BD_VD_BD*pInst->umaxpoweronepointfive+btat_VD_BD*umaxpoweronepointfive_VD_BD+btat_VD_BD*umaxpoweronepointfive_VD_BD+pInst->btat*umaxpoweronepointfive_VD_BD_VD_BD)));
#endif
#endif
pInst->mtat=((((pModel->atatgat_d*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatgat_d*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive)));
EXIT_IF_ISNAN(((((pModel->atatgat_d*pInst->twoatatoverthreebtat)*pInst->sqrtumax)-(pModel->atatgat_d*pInst->umax))+(0.5*(pInst->btat*pInst->umaxpoweronepointfive))))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
xerfc_VS_BS=((ltat_VS_BS*pInst->ktat)+((pInst->ltat-1)*ktat_VS_BS));
#if defined(_DERIVATE2)
  xerfc_VS_BS_VS_BS=(+(+ltat_VS_BS_VS_BS-0.0)*pInst->ktat+ltat_VS_BS*ktat_VS_BS+ltat_VS_BS*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VS_BS);
  xerfc_VS_BS_VD_BD=(+(+ltat_VS_BS_VD_BD-0.0)*pInst->ktat+ltat_VS_BS*ktat_VD_BD+ltat_VD_BD*ktat_VS_BS+(pInst->ltat-1)*ktat_VS_BS_VD_BD);
#endif
xerfc_VD_BD=((ltat_VD_BD*pInst->ktat)+((pInst->ltat-1)*ktat_VD_BD));
#if defined(_DERIVATE2)
  xerfc_VD_BD_VS_BS=(+(+ltat_VD_BD_VS_BS-0.0)*pInst->ktat+ltat_VD_BD*ktat_VS_BS+ltat_VS_BS*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VS_BS);
  xerfc_VD_BD_VD_BD=(+(+ltat_VD_BD_VD_BD-0.0)*pInst->ktat+ltat_VD_BD*ktat_VD_BD+ltat_VD_BD*ktat_VD_BD+(pInst->ltat-1)*ktat_VD_BD_VD_BD);
#endif
#endif
pInst->xerfc=((pInst->ltat-1)*pInst->ktat);
EXIT_IF_ISNAN(((pInst->ltat-1)*pInst->ktat))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ysq_VS_BS=((xerfc_VS_BS*pInst->xerfc)+(pInst->xerfc*xerfc_VS_BS));
#if defined(_DERIVATE2)
  ysq_VS_BS_VS_BS=(+xerfc_VS_BS_VS_BS*pInst->xerfc+xerfc_VS_BS*xerfc_VS_BS+xerfc_VS_BS*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VS_BS);
  ysq_VS_BS_VD_BD=(+xerfc_VS_BS_VD_BD*pInst->xerfc+xerfc_VS_BS*xerfc_VD_BD+xerfc_VD_BD*xerfc_VS_BS+pInst->xerfc*xerfc_VS_BS_VD_BD);
#endif
ysq_VD_BD=((xerfc_VD_BD*pInst->xerfc)+(pInst->xerfc*xerfc_VD_BD));
#if defined(_DERIVATE2)
  ysq_VD_BD_VS_BS=(+xerfc_VD_BD_VS_BS*pInst->xerfc+xerfc_VD_BD*xerfc_VS_BS+xerfc_VS_BS*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VS_BS);
  ysq_VD_BD_VD_BD=(+xerfc_VD_BD_VD_BD*pInst->xerfc+xerfc_VD_BD*xerfc_VD_BD+xerfc_VD_BD*xerfc_VD_BD+pInst->xerfc*xerfc_VD_BD_VD_BD);
#endif
#endif
pInst->ysq=(pInst->xerfc*pInst->xerfc);
EXIT_IF_ISNAN((pInst->xerfc*pInst->xerfc))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(pModel->perfc*xerfc_VS_BS)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VS_BS)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VS_BS)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(pModel->perfc*xerfc_VD_BD)/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VS_BS))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VS_BS))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1+(pModel->perfc*pInst->xerfc))-(0.0*((pModel->perfc*xerfc_VD_BD))+0.0*(pModel->perfc*xerfc_VD_BD)+1*(+0.0+(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))+2*1*(pModel->perfc*xerfc_VD_BD)*((pModel->perfc*xerfc_VD_BD))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc))/(1+(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1+(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1+(pModel->perfc*pInst->xerfc))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
terfc_VS_BS=(-1*(-(pModel->perfc*xerfc_VS_BS))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VS_BS_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VS_BS_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VS_BS))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VS_BS+pModel->perfc*xerfc_VS_BS_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VS_BS))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
terfc_VD_BD=(-1*(-(pModel->perfc*xerfc_VD_BD))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#if defined(_DERIVATE2)
  terfc_VD_BD_VS_BS=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VS_BS)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VS_BS+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VS_BS)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
  terfc_VD_BD_VD_BD=(0.0/(1-(pModel->perfc*pInst->xerfc))-(0.0*(-((pModel->perfc*xerfc_VD_BD)))+0.0*(-(pModel->perfc*xerfc_VD_BD))+1*(+0.0-(+0.0*pInst->xerfc+0.0*xerfc_VD_BD+0.0*xerfc_VD_BD+pModel->perfc*xerfc_VD_BD_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))+2*1*(-(pModel->perfc*xerfc_VD_BD))*(-((pModel->perfc*xerfc_VD_BD)))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc))/(1-(pModel->perfc*pInst->xerfc)));
#endif
#endif
pInst->terfc=(1/(1-(pModel->perfc*pInst->xerfc)));
EXIT_IF_ISNAN((1/(1-(pModel->perfc*pInst->xerfc))))
}
if
((((-pInst->ysq)+pInst->mtat)>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,((-pInst->ysq)+pInst->mtat))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((-ysq_VS_BS)+mtat_VS_BS)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VS_BS));
  tmp_VS_BS_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VS_BS)+mtat_VS_BS)+d10_exp0*(+0.0+mtat_VS_BS_VD_BD));
#endif
tmp_VD_BD=((-ysq_VD_BD)+mtat_VD_BD)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VS_BS)+mtat_VS_BS)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VS_BS));
  tmp_VD_BD_VD_BD=(m20_exp(((-pInst->ysq)+pInst->mtat))*((-ysq_VD_BD)+mtat_VD_BD)*((-ysq_VD_BD)+mtat_VD_BD)+d10_exp0*(+0.0+mtat_VD_BD_VD_BD));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VS_BS))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VS_BS)+mtat_VS_BS))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VS_BS)+mtat_VS_BS))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VS_BS_VD_BD))*3.3333333333333333e-01+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))))+(-((-ysq_VS_BS)+mtat_VS_BS))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)+(-((-ysq_VS_BS)+mtat_VS_BS))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VS_BS))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VS_BS)+mtat_VS_BS))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VS_BS)+mtat_VS_BS))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VS_BS)+mtat_VS_BS))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))-(0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))+(-((-ysq_VD_BD)+mtat_VD_BD))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))))+(-((-ysq_VD_BD)+mtat_VD_BD))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+0.0*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))))+0.0*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01))+0.5*(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))+(-((-ysq_VD_BD)+mtat_VD_BD))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)+(-((-ysq_VD_BD)+mtat_VD_BD))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(+0.0+(+(+0.0-(+0.0+mtat_VD_BD_VD_BD))*3.3333333333333333e-01+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+(-((-ysq_VD_BD)+mtat_VD_BD))*0.0+((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(0.5*(((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((0.5*((((-((-ysq_VD_BD)+mtat_VD_BD))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*((-((-ysq_VD_BD)+mtat_VD_BD))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*(1.0+(((-2.3025850929940458e+02)-((-pInst->ysq)+pInst->mtat))*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
erfcpos_VS_BS=(((((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS));
#if defined(_DERIVATE2)
  erfcpos_VS_BS_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VS_BS*pInst->terfc+terfc_VS_BS*terfc_VS_BS+terfc_VS_BS*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VS_BS)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VS_BS);
  erfcpos_VS_BS_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VS_BS+0.29214664*terfc_VS_BS_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))+pModel->berfc*(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))+pModel->cerfc*(+(+terfc_VS_BS_VD_BD*pInst->terfc+terfc_VS_BS*terfc_VD_BD+terfc_VD_BD*terfc_VS_BS+pInst->terfc*terfc_VS_BS_VD_BD)*pInst->terfc+((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VS_BS+(pInst->terfc*pInst->terfc)*terfc_VS_BS_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VS_BS)+(pModel->berfc*((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))+(pModel->cerfc*((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VS_BS+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VS_BS_VD_BD);
#endif
erfcpos_VD_BD=(((((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*pInst->tmp)+((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD));
#if defined(_DERIVATE2)
  erfcpos_VD_BD_VS_BS=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VS_BS+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VS_BS)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VS_BS*pInst->terfc+terfc_VD_BD*terfc_VS_BS+terfc_VS_BS*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VS_BS)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VS_BS+(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VS_BS)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VS_BS+((((0.29214664*terfc_VS_BS))+((pModel->berfc*(((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS))))))+((pModel->cerfc*((((((terfc_VS_BS*pInst->terfc)+(pInst->terfc*terfc_VS_BS)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VS_BS))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VS_BS);
  erfcpos_VD_BD_VD_BD=(+(+(+(+0.0*pInst->terfc+0.0*terfc_VD_BD+0.0*terfc_VD_BD+0.29214664*terfc_VD_BD_VD_BD)+(+0.0*(pInst->terfc*pInst->terfc)+0.0*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))+0.0*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))+pModel->berfc*(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)))+(+0.0*((pInst->terfc*pInst->terfc)*pInst->terfc)+0.0*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD)))+0.0*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))+pModel->cerfc*(+(+terfc_VD_BD_VD_BD*pInst->terfc+terfc_VD_BD*terfc_VD_BD+terfc_VD_BD*terfc_VD_BD+pInst->terfc*terfc_VD_BD_VD_BD)*pInst->terfc+((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*terfc_VD_BD+(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*terfc_VD_BD+(pInst->terfc*pInst->terfc)*terfc_VD_BD_VD_BD)))*pInst->tmp+(((0.29214664*terfc_VD_BD)+(pModel->berfc*((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))+(pModel->cerfc*((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))*tmp_VD_BD+((((0.29214664*terfc_VD_BD))+((pModel->berfc*(((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD))))))+((pModel->cerfc*((((((terfc_VD_BD*pInst->terfc)+(pInst->terfc*terfc_VD_BD)))*pInst->terfc)+((pInst->terfc*pInst->terfc)*terfc_VD_BD))))))*tmp_VD_BD+(((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*tmp_VD_BD_VD_BD);
#endif
#endif
pInst->erfcpos=((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp);
EXIT_IF_ISNAN(((((0.29214664*pInst->terfc)+(pModel->berfc*(pInst->terfc*pInst->terfc)))+(pModel->cerfc*((pInst->terfc*pInst->terfc)*pInst->terfc)))*pInst->tmp))
if
((pInst->xerfc>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=erfcpos_VS_BS;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=erfcpos_VS_BS_VS_BS;
  erfctimesexpmtat_VS_BS_VD_BD=erfcpos_VS_BS_VD_BD;
#endif
erfctimesexpmtat_VD_BD=erfcpos_VD_BD;
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=erfcpos_VD_BD_VS_BS;
  erfctimesexpmtat_VD_BD_VD_BD=erfcpos_VD_BD_VD_BD;
#endif
#endif
pInst->erfctimesexpmtat=pInst->erfcpos;
EXIT_IF_ISNAN(pInst->erfcpos)
}
else
{
if
((pInst->mtat>(-2.3025850929940458e+02)))
{
{
double m00_exp(d00_exp0,pInst->mtat)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=mtat_VS_BS*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VS_BS+d10_exp0*mtat_VS_BS_VS_BS);
  tmp_VS_BS_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VS_BS+d10_exp0*mtat_VS_BS_VD_BD);
#endif
tmp_VD_BD=mtat_VD_BD*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(pInst->mtat)*mtat_VS_BS*mtat_VD_BD+d10_exp0*mtat_VD_BD_VS_BS);
  tmp_VD_BD_VD_BD=(m20_exp(pInst->mtat)*mtat_VD_BD*mtat_VD_BD+d10_exp0*mtat_VD_BD_VD_BD);
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VS_BS)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VS_BS)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VS_BS_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VS_BS)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VS_BS)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VS_BS_VD_BD)*3.3333333333333333e-01+(-mtat_VS_BS)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VS_BS)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))))+(-mtat_VS_BS)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VS_BS)*3.3333333333333333e-01)+(-mtat_VS_BS)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VS_BS)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VS_BS)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VS_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VS_BS)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VS_BS)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))-(0.0*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))+0.0*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))+(-mtat_VD_BD)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))))+(-mtat_VD_BD)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+0.0*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+0.0*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01))))+0.0*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01))+0.5*(+(+0.0-mtat_VD_BD_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))+(-mtat_VD_BD)*((-mtat_VD_BD)*3.3333333333333333e-01)+(-mtat_VD_BD)*(-mtat_VD_BD)*3.3333333333333333e-01+((-2.3025850929940458e+02)-pInst->mtat)*(+0.0+(+(+0.0-mtat_VD_BD_VD_BD)*3.3333333333333333e-01+(-mtat_VD_BD)*0.0+(-mtat_VD_BD)*0.0+((-2.3025850929940458e+02)-pInst->mtat)*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))+2*1.0e-100*(((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*(0.5*(((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*(-mtat_VD_BD)*3.3333333333333333e-01)))))*((((-mtat_VD_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-pInst->mtat)*((0.5*((((-mtat_VD_BD)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-pInst->mtat)*((-mtat_VD_BD)*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-pInst->mtat)*(1.0+(((-2.3025850929940458e+02)-pInst->mtat)*3.3333333333333333e-01)))))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
erfctimesexpmtat_VS_BS=((2*tmp_VS_BS)-erfcpos_VS_BS);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VS_BS_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VS_BS+2*tmp_VS_BS_VS_BS)-erfcpos_VS_BS_VS_BS);
  erfctimesexpmtat_VS_BS_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VS_BS+2*tmp_VS_BS_VD_BD)-erfcpos_VS_BS_VD_BD);
#endif
erfctimesexpmtat_VD_BD=((2*tmp_VD_BD)-erfcpos_VD_BD);
#if defined(_DERIVATE2)
  erfctimesexpmtat_VD_BD_VS_BS=(+(+0.0*pInst->tmp+0.0*tmp_VS_BS+0.0*tmp_VD_BD+2*tmp_VD_BD_VS_BS)-erfcpos_VD_BD_VS_BS);
  erfctimesexpmtat_VD_BD_VD_BD=(+(+0.0*pInst->tmp+0.0*tmp_VD_BD+0.0*tmp_VD_BD+2*tmp_VD_BD_VD_BD)-erfcpos_VD_BD_VD_BD);
#endif
#endif
pInst->erfctimesexpmtat=((2*pInst->tmp)-pInst->erfcpos);
EXIT_IF_ISNAN(((2*pInst->tmp)-pInst->erfcpos))
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
gammamax_VS_BS=((1.77245385090551603*0.5)*(((pModel->atatgat_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VS_BS_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatgat_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatgat_d*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatgat_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VS_BS+pModel->atatgat_d*erfctimesexpmtat_VS_BS_VS_BS)/pInst->ktat-((pModel->atatgat_d*erfctimesexpmtat_VS_BS)*ktat_VS_BS+((pModel->atatgat_d*erfctimesexpmtat_VS_BS))*ktat_VS_BS+(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VS_BS_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatgat_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatgat_d*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatgat_d*erfctimesexpmtat_VS_BS)*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VS_BS+pModel->atatgat_d*erfctimesexpmtat_VS_BS_VD_BD)/pInst->ktat-((pModel->atatgat_d*erfctimesexpmtat_VS_BS)*ktat_VD_BD+((pModel->atatgat_d*erfctimesexpmtat_VD_BD))*ktat_VS_BS+(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
gammamax_VD_BD=((1.77245385090551603*0.5)*(((pModel->atatgat_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat));
#if defined(_DERIVATE2)
  gammamax_VD_BD_VS_BS=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatgat_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatgat_d*erfctimesexpmtat_VS_BS))*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VS_BS)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatgat_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VS_BS+0.0*erfctimesexpmtat_VD_BD+pModel->atatgat_d*erfctimesexpmtat_VD_BD_VS_BS)/pInst->ktat-((pModel->atatgat_d*erfctimesexpmtat_VD_BD)*ktat_VS_BS+((pModel->atatgat_d*erfctimesexpmtat_VS_BS))*ktat_VD_BD+(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD_VS_BS)/pInst->ktat/pInst->ktat+2*(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VS_BS/pInst->ktat/pInst->ktat/pInst->ktat));
  gammamax_VD_BD_VD_BD=(+(+0.0*0.5+0.0*0.0+0.0*0.0+1.77245385090551603*0.0)*((pModel->atatgat_d*pInst->erfctimesexpmtat)/pInst->ktat)+0.0*((((pModel->atatgat_d*erfctimesexpmtat_VD_BD))*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(0.0)*(((pModel->atatgat_d*erfctimesexpmtat_VD_BD)*pInst->ktat-(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD)/pInst->ktat/pInst->ktat)+(1.77245385090551603*0.5)*((+0.0*pInst->erfctimesexpmtat+0.0*erfctimesexpmtat_VD_BD+0.0*erfctimesexpmtat_VD_BD+pModel->atatgat_d*erfctimesexpmtat_VD_BD_VD_BD)/pInst->ktat-((pModel->atatgat_d*erfctimesexpmtat_VD_BD)*ktat_VD_BD+((pModel->atatgat_d*erfctimesexpmtat_VD_BD))*ktat_VD_BD+(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD_VD_BD)/pInst->ktat/pInst->ktat+2*(pModel->atatgat_d*pInst->erfctimesexpmtat)*ktat_VD_BD*ktat_VD_BD/pInst->ktat/pInst->ktat/pInst->ktat));
#endif
#endif
pInst->gammamax=((1.77245385090551603*0.5)*((pModel->atatgat_d*pInst->erfctimesexpmtat)/pInst->ktat));
EXIT_IF_ISNAN(((1.77245385090551603*0.5)*((pModel->atatgat_d*pInst->erfctimesexpmtat)/pInst->ktat)))
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
itat_VS_BS=(pModel->CTATGATD_i*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)));
#if defined(_DERIVATE2)
  itat_VS_BS_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATGATD_i*(+(+asrh_VS_BS_VS_BS*pInst->gammamax+asrh_VS_BS*gammamax_VS_BS+asrh_VS_BS*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VS_BS)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VS_BS));
  itat_VS_BS_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS))+pModel->CTATGATD_i*(+(+asrh_VS_BS_VD_BD*pInst->gammamax+asrh_VS_BS*gammamax_VD_BD+asrh_VD_BD*gammamax_VS_BS+pInst->asrh*gammamax_VS_BS_VD_BD)*pInst->wtat+((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VS_BS+(pInst->asrh*pInst->gammamax)*wtat_VS_BS_VD_BD));
#endif
itat_VD_BD=(pModel->CTATGATD_i*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)));
#if defined(_DERIVATE2)
  itat_VD_BD_VS_BS=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VS_BS)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATGATD_i*(+(+asrh_VD_BD_VS_BS*pInst->gammamax+asrh_VD_BD*gammamax_VS_BS+asrh_VS_BS*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VS_BS)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VS_BS+(((asrh_VS_BS*pInst->gammamax)+(pInst->asrh*gammamax_VS_BS)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VS_BS));
  itat_VD_BD_VD_BD=(+0.0*((pInst->asrh*pInst->gammamax)*pInst->wtat)+0.0*((((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD)))+0.0*((((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*pInst->wtat)+((pInst->asrh*pInst->gammamax)*wtat_VD_BD))+pModel->CTATGATD_i*(+(+asrh_VD_BD_VD_BD*pInst->gammamax+asrh_VD_BD*gammamax_VD_BD+asrh_VD_BD*gammamax_VD_BD+pInst->asrh*gammamax_VD_BD_VD_BD)*pInst->wtat+((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD))*wtat_VD_BD+(((asrh_VD_BD*pInst->gammamax)+(pInst->asrh*gammamax_VD_BD)))*wtat_VD_BD+(pInst->asrh*pInst->gammamax)*wtat_VD_BD_VD_BD));
#endif
#endif
pInst->itat=(pModel->CTATGATD_i*((pInst->asrh*pInst->gammamax)*pInst->wtat));
EXIT_IF_ISNAN((pModel->CTATGATD_i*((pInst->asrh*pInst->gammamax)*pInst->wtat)))
}
if
((pModel->CBBTGATD_i==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=0.0;
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=0.0;
  ibbt_VS_BS_VD_BD=0.0;
#endif
ibbt_VD_BD=0.0;
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=0.0;
  ibbt_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->ibbt=0;
EXIT_IF_ISNAN(0)
}
else
{
if
((pModel->PGATD_i==0.5))
{
{
double m00_sqrt(d00_sqrt0,((pModel->VBIRGATD_i-pInst->vbbt)*pModel->VBIRGATinv_d))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((pModel->VBIRGATD_i-pInst->vbbt)*pModel->VBIRGATinv_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-vbbt_VS_BS)*pModel->VBIRGATinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_sqrt(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->VBIRGATinv_d))*((-vbbt_VS_BS)*pModel->VBIRGATinv_d)*(-vbbt_VS_BS)*pModel->VBIRGATinv_d+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VS_BS)*pModel->VBIRGATinv_d+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRGATD_i-pInst->vbbt)*0.0));
  tmp_VS_BS_VD_BD=(m20_sqrt(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->VBIRGATinv_d))*((-vbbt_VD_BD)*pModel->VBIRGATinv_d)*(-vbbt_VS_BS)*pModel->VBIRGATinv_d+d10_sqrt0*(+(+0.0-vbbt_VS_BS_VD_BD)*pModel->VBIRGATinv_d+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRGATD_i-pInst->vbbt)*0.0));
#endif
tmp_VD_BD=(-vbbt_VD_BD)*pModel->VBIRGATinv_d*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_sqrt(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->VBIRGATinv_d))*((-vbbt_VS_BS)*pModel->VBIRGATinv_d)*(-vbbt_VD_BD)*pModel->VBIRGATinv_d+d10_sqrt0*(+(+0.0-vbbt_VD_BD_VS_BS)*pModel->VBIRGATinv_d+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRGATD_i-pInst->vbbt)*0.0));
  tmp_VD_BD_VD_BD=(m20_sqrt(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->VBIRGATinv_d))*((-vbbt_VD_BD)*pModel->VBIRGATinv_d)*(-vbbt_VD_BD)*pModel->VBIRGATinv_d+d10_sqrt0*(+(+0.0-vbbt_VD_BD_VD_BD)*pModel->VBIRGATinv_d+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRGATD_i-pInst->vbbt)*0.0));
#endif
#endif
pInst->tmp=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
{
double m00_pow(d00_pow0,((pModel->VBIRGATD_i-pInst->vbbt)*pModel->VBIRGATinv_d),pModel->PGATD_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,((pModel->VBIRGATD_i-pInst->vbbt)*pModel->VBIRGATinv_d),pModel->PGATD_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow0*(-vbbt_VS_BS)*pModel->VBIRGATinv_d);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow0*(-vbbt_VD_BD)*pModel->VBIRGATinv_d);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
Fmaxr_VS_BS=(pModel->one_over_one_minus_PGAT_d*(((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VS_BS_VS_BS=(+0.0*(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d)*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PGAT_d*((+(+0.0-vbbt_VS_BS_VS_BS)*pModel->wdepnulrinvgat_d+(-vbbt_VS_BS)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRGATD_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d)*tmp_VS_BS+((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VS_BS_VD_BD=(+0.0*(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d)*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PGAT_d*((+(+0.0-vbbt_VS_BS_VD_BD)*pModel->wdepnulrinvgat_d+(-vbbt_VS_BS)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRGATD_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d)*tmp_VS_BS+((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
Fmaxr_VD_BD=(pModel->one_over_one_minus_PGAT_d*(((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp));
#if defined(_DERIVATE2)
  Fmaxr_VD_BD_VS_BS=(+0.0*(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)/pInst->tmp)+0.0*((((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d)*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VS_BS)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PGAT_d*((+(+0.0-vbbt_VD_BD_VS_BS)*pModel->wdepnulrinvgat_d+(-vbbt_VD_BD)*0.0+(-vbbt_VS_BS)*0.0+(pModel->VBIRGATD_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d*tmp_VS_BS+((-vbbt_VS_BS)*pModel->wdepnulrinvgat_d)*tmp_VD_BD+((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD_VS_BS)/pInst->tmp/pInst->tmp+2*((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD*tmp_VS_BS/pInst->tmp/pInst->tmp/pInst->tmp));
  Fmaxr_VD_BD_VD_BD=(+0.0*(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)/pInst->tmp)+0.0*((((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d)*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+0.0*(((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d*pInst->tmp-((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD)/pInst->tmp/pInst->tmp)+pModel->one_over_one_minus_PGAT_d*((+(+0.0-vbbt_VD_BD_VD_BD)*pModel->wdepnulrinvgat_d+(-vbbt_VD_BD)*0.0+(-vbbt_VD_BD)*0.0+(pModel->VBIRGATD_i-pInst->vbbt)*0.0)/pInst->tmp-((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d*tmp_VD_BD+((-vbbt_VD_BD)*pModel->wdepnulrinvgat_d)*tmp_VD_BD+((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD_VD_BD)/pInst->tmp/pInst->tmp+2*((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)*tmp_VD_BD*tmp_VD_BD/pInst->tmp/pInst->tmp/pInst->tmp));
#endif
#endif
pInst->Fmaxr=(pModel->one_over_one_minus_PGAT_d*(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)/pInst->tmp));
EXIT_IF_ISNAN((pModel->one_over_one_minus_PGAT_d*(((pModel->VBIRGATD_i-pInst->vbbt)*pModel->wdepnulrinvgat_d)/pInst->tmp)))
{
double m00_fabs(d00_fabs0,((-pModel->fbbtgat_d)/pInst->Fmaxr))
if
((d00_fabs0<2.3025850929940458e+02))
{
{
double m00_exp(d00_exp0,((-pModel->fbbtgat_d)/pInst->Fmaxr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(m20_exp(((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VS_BS_VD_BD=(m20_exp(((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
tmp_VD_BD=(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*d10_exp0;
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(m20_exp(((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
  tmp_VD_BD_VD_BD=(m20_exp(((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)+d10_exp0*(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr));
#endif
#endif
pInst->tmp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
if
((((-pModel->fbbtgat_d)/pInst->Fmaxr)<(-2.3025850929940458e+02)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(-1.0e-100*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VS_BS_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
tmp_VD_BD=(-1.0e-100*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
  tmp_VD_BD_VD_BD=(0.0/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))-(0.0*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))+0.0*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))+1.0e-100*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(+0.0+(+0.0*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+0.0*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))))+0.0*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01))+0.5*(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(+0.0+(+(+0.0-(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*0.0+((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*0.0))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))+2*1.0e-100*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(0.5*(((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((0.5*((((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*((-(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr))*3.3333333333333333e-01)))))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
#endif
#endif
pInst->tmp=(1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-pModel->fbbtgat_d)/pInst->Fmaxr))*3.3333333333333333e-01)))))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(1.0e100*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+0.0*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VS_BS_VD_BD=(+0.0*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VS_BS+(-pModel->fbbtgat_d)*Fmaxr_VS_BS_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VS_BS*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
tmp_VD_BD=(1.0e100*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+0.0*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VS_BS)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtgat_d)*Fmaxr_VS_BS/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
  tmp_VD_BD_VD_BD=(+0.0*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))+0.0*((((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((0.5*((((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))))))+0.0*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))))+1.0e100*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((0.5*((((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))))+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(0.5*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)))+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+0.0*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.0*((((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))))+0.0*(((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01))+0.5*(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*((-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01)+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*3.3333333333333333e-01+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(+0.0+(+(+(0.0/pInst->Fmaxr-(0.0*Fmaxr_VD_BD+0.0*Fmaxr_VD_BD+(-pModel->fbbtgat_d)*Fmaxr_VD_BD_VD_BD)/pInst->Fmaxr/pInst->Fmaxr+2*(-pModel->fbbtgat_d)*Fmaxr_VD_BD*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr/pInst->Fmaxr)-0.0)*3.3333333333333333e-01+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(-(-pModel->fbbtgat_d)*Fmaxr_VD_BD/pInst->Fmaxr/pInst->Fmaxr)*0.0+(((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*0.0))))))));
#endif
#endif
pInst->tmp=(1.0e100*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
EXIT_IF_ISNAN((1.0e100*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*(1.0+((((-pModel->fbbtgat_d)/pInst->Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ibbt_VS_BS=(pModel->CBBTGATD_i*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)));
#if defined(_DERIVATE2)
  ibbt_VS_BS_VS_BS=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTGATD_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VS_BS+0.0*Fmaxr_VS_BS+Vjun_d*Fmaxr_VS_BS_VS_BS)*pInst->Fmaxr+(Vjun_d*Fmaxr_VS_BS)*Fmaxr_VS_BS+((Vjun_d*Fmaxr_VS_BS))*Fmaxr_VS_BS+(Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS_VS_BS)*pInst->tmp+(((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VS_BS+(((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VS_BS+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VS_BS));
  ibbt_VS_BS_VD_BD=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*(((((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS))+pModel->CBBTGATD_i*(+(+(+0.0*pInst->Fmaxr+0.0*Fmaxr_VD_BD+Vjun_d_VD_BD*Fmaxr_VS_BS+Vjun_d*Fmaxr_VS_BS_VD_BD)*pInst->Fmaxr+(Vjun_d*Fmaxr_VS_BS)*Fmaxr_VD_BD+(((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*Fmaxr_VS_BS+(Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS_VD_BD)*pInst->tmp+(((Vjun_d*Fmaxr_VS_BS)*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS))*tmp_VD_BD+((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VS_BS+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS_VD_BD));
#endif
ibbt_VD_BD=(pModel->CBBTGATD_i*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)));
#if defined(_DERIVATE2)
  ibbt_VD_BD_VS_BS=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*((((((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VS_BS)))+0.0*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTGATD_i*(+(+(+0.0*pInst->Fmaxr+Vjun_d_VD_BD*Fmaxr_VS_BS+0.0*Fmaxr_VD_BD+Vjun_d*Fmaxr_VD_BD_VS_BS)*pInst->Fmaxr+((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*Fmaxr_VS_BS+((Vjun_d*Fmaxr_VS_BS))*Fmaxr_VD_BD+(Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD_VS_BS)*pInst->tmp+((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VS_BS+(((((Vjun_d*Fmaxr_VS_BS))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VS_BS)))*tmp_VD_BD+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VS_BS));
  ibbt_VD_BD_VD_BD=(+0.0*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)+0.0*(((((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD)))+0.0*((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*pInst->tmp)+(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD))+pModel->CBBTGATD_i*(+(+(+Vjun_d_VD_BD_VD_BD*pInst->Fmaxr+Vjun_d_VD_BD*Fmaxr_VD_BD+Vjun_d_VD_BD*Fmaxr_VD_BD+Vjun_d*Fmaxr_VD_BD_VD_BD)*pInst->Fmaxr+((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*Fmaxr_VD_BD+(((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*Fmaxr_VD_BD+(Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD_VD_BD)*pInst->tmp+((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD))*tmp_VD_BD+((((((Vjun_d_VD_BD*pInst->Fmaxr)+(Vjun_d*Fmaxr_VD_BD)))*pInst->Fmaxr)+((Vjun_d*pInst->Fmaxr)*Fmaxr_VD_BD)))*tmp_VD_BD+((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*tmp_VD_BD_VD_BD));
#endif
#endif
pInst->ibbt=(pModel->CBBTGATD_i*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp));
EXIT_IF_ISNAN((pModel->CBBTGATD_i*(((Vjun_d*pInst->Fmaxr)*pInst->Fmaxr)*pInst->tmp)))
}
if
((pModel->VBRGATD_i>1000))
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=0.0;
  fbreakdown_VS_BS_VD_BD=0.0;
#endif
fbreakdown_VD_BD=0.0;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=0.0;
  fbreakdown_VD_BD_VD_BD=0.0;
#endif
#endif
pInst->fbreakdown=1;
EXIT_IF_ISNAN(1)
}
else
{
if
((pInst->vav>((-0.999)*pModel->VBRGATD_i)))
{
if
((pModel->PBRGATD_i==4))
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvgat_d))
double m00_fabs(d00_fabs1,(pInst->vav*pModel->VBRinvgat_d))
double m00_fabs(d00_fabs2,(pInst->vav*pModel->VBRinvgat_d))
double m00_fabs(d00_fabs3,(pInst->vav*pModel->VBRinvgat_d))
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvgat_d))
double m10_fabs(d10_fabs1,d00_fabs1,(pInst->vav*pModel->VBRinvgat_d))
double m10_fabs(d10_fabs2,d00_fabs2,(pInst->vav*pModel->VBRinvgat_d))
double m10_fabs(d10_fabs3,d00_fabs3,(pInst->vav*pModel->VBRinvgat_d))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=((((((vav_VS_BS*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VS_BS*pModel->VBRinvgat_d)*vav_VS_BS*pModel->VBRinvgat_d+d10_fabs0*(+vav_VS_BS_VS_BS*pModel->VBRinvgat_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvgat_d*d10_fabs0*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs1+(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs0*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VS_BS*pModel->VBRinvgat_d)*vav_VS_BS*pModel->VBRinvgat_d+d10_fabs1*(+vav_VS_BS_VS_BS*pModel->VBRinvgat_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs1))*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VS_BS*pModel->VBRinvgat_d)*vav_VS_BS*pModel->VBRinvgat_d+d10_fabs2*(+vav_VS_BS_VS_BS*pModel->VBRinvgat_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs2))*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VS_BS*pModel->VBRinvgat_d)*vav_VS_BS*pModel->VBRinvgat_d+d10_fabs3*(+vav_VS_BS_VS_BS*pModel->VBRinvgat_d+vav_VS_BS*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VS_BS_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VD_BD*pModel->VBRinvgat_d)*vav_VS_BS*pModel->VBRinvgat_d+d10_fabs0*(+vav_VS_BS_VD_BD*pModel->VBRinvgat_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VS_BS*pModel->VBRinvgat_d*d10_fabs0*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs1+(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs0*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VD_BD*pModel->VBRinvgat_d)*vav_VS_BS*pModel->VBRinvgat_d+d10_fabs1*(+vav_VS_BS_VD_BD*pModel->VBRinvgat_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VS_BS*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs1))*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs1)))*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VD_BD*pModel->VBRinvgat_d)*vav_VS_BS*pModel->VBRinvgat_d+d10_fabs2*(+vav_VS_BS_VD_BD*pModel->VBRinvgat_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VS_BS*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs2))*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs2)))*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VD_BD*pModel->VBRinvgat_d)*vav_VS_BS*pModel->VBRinvgat_d+d10_fabs3*(+vav_VS_BS_VD_BD*pModel->VBRinvgat_d+vav_VS_BS*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
tmp_VD_BD=((((((vav_VD_BD*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs2))*d00_fabs3)+(((d00_fabs0*d00_fabs1)*d00_fabs2)*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs3));
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VS_BS*pModel->VBRinvgat_d)*vav_VD_BD*pModel->VBRinvgat_d+d10_fabs0*(+vav_VD_BD_VS_BS*pModel->VBRinvgat_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0))*d00_fabs1+vav_VD_BD*pModel->VBRinvgat_d*d10_fabs0*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs1+(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs0*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VS_BS*pModel->VBRinvgat_d)*vav_VD_BD*pModel->VBRinvgat_d+d10_fabs1*(+vav_VD_BD_VS_BS*pModel->VBRinvgat_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VD_BD*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs1))*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs2+((((vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs1)))*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VS_BS*pModel->VBRinvgat_d)*vav_VD_BD*pModel->VBRinvgat_d+d10_fabs2*(+vav_VD_BD_VS_BS*pModel->VBRinvgat_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VD_BD*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs2))*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs3+(((((((vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VS_BS*pModel->VBRinvgat_d)*d10_fabs2)))*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VS_BS*pModel->VBRinvgat_d)*vav_VD_BD*pModel->VBRinvgat_d+d10_fabs3*(+vav_VD_BD_VS_BS*pModel->VBRinvgat_d+vav_VD_BD*0.0+vav_VS_BS*0.0+pInst->vav*0.0)));
  tmp_VD_BD_VD_BD=(+(+(+(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VD_BD*pModel->VBRinvgat_d)*vav_VD_BD*pModel->VBRinvgat_d+d10_fabs0*(+vav_VD_BD_VD_BD*pModel->VBRinvgat_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0))*d00_fabs1+vav_VD_BD*pModel->VBRinvgat_d*d10_fabs0*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs1+(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs0*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs1+d00_fabs0*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VD_BD*pModel->VBRinvgat_d)*vav_VD_BD*pModel->VBRinvgat_d+d10_fabs1*(+vav_VD_BD_VD_BD*pModel->VBRinvgat_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs2+((vav_VD_BD*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs1))*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs2+((((vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs1)))*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs2+(d00_fabs0*d00_fabs1)*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VD_BD*pModel->VBRinvgat_d)*vav_VD_BD*pModel->VBRinvgat_d+d10_fabs2*(+vav_VD_BD_VD_BD*pModel->VBRinvgat_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)))*d00_fabs3+((((vav_VD_BD*pModel->VBRinvgat_d*d10_fabs0*d00_fabs1)+(d00_fabs0*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs1))*d00_fabs2)+((d00_fabs0*d00_fabs1)*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs2))*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs3+(((((((vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs0*d00_fabs1)+(d00_fabs0*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs1)))*d00_fabs2)+((d00_fabs0*d00_fabs1)*(vav_VD_BD*pModel->VBRinvgat_d)*d10_fabs2)))*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs3+((d00_fabs0*d00_fabs1)*d00_fabs2)*(m20_fabs((pInst->vav*pModel->VBRinvgat_d))*(vav_VD_BD*pModel->VBRinvgat_d)*vav_VD_BD*pModel->VBRinvgat_d+d10_fabs3*(+vav_VD_BD_VD_BD*pModel->VBRinvgat_d+vav_VD_BD*0.0+vav_VD_BD*0.0+pInst->vav*0.0)));
#endif
#endif
pInst->tmp=(((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3);
EXIT_IF_ISNAN((((d00_fabs0*d00_fabs1)*d00_fabs2)*d00_fabs3))
}
}
else
{
{
double m00_fabs(d00_fabs0,(pInst->vav*pModel->VBRinvgat_d))
double m00_pow(d00_pow1,d00_fabs0,pModel->PBRGATD_i)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->vav*pModel->VBRinvgat_d))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->PBRGATD_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
tmp_VS_BS=(d10_pow1*vav_VS_BS*pModel->VBRinvgat_d*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VS_BS_VS_BS=fixme;
  tmp_VS_BS_VD_BD=fixme;
#endif
tmp_VD_BD=(d10_pow1*vav_VD_BD*pModel->VBRinvgat_d*d10_fabs0);
#if defined(_DERIVATE2)
  tmp_VD_BD_VS_BS=fixme;
  tmp_VD_BD_VD_BD=fixme;
#endif
#endif
pInst->tmp=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=(-1*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VS_BS_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VS_BS)+1*(+0.0-tmp_VS_BS_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VS_BS)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
fbreakdown_VD_BD=(-1*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp));
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VS_BS)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VS_BS))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VS_BS)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
  fbreakdown_VD_BD_VD_BD=(0.0/(1-pInst->tmp)-(0.0*(-tmp_VD_BD)+0.0*(-tmp_VD_BD)+1*(+0.0-tmp_VD_BD_VD_BD))/(1-pInst->tmp)/(1-pInst->tmp)+2*1*(-tmp_VD_BD)*(-tmp_VD_BD)/(1-pInst->tmp)/(1-pInst->tmp)/(1-pInst->tmp));
#endif
#endif
pInst->fbreakdown=(1/(1-pInst->tmp));
EXIT_IF_ISNAN((1/(1-pInst->tmp)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(S,BS)V(D,BD) ddxprobe=V(BS,GND)V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
fbreakdown_VS_BS=vav_VS_BS*pModel->slopegat_d;
#if defined(_DERIVATE2)
  fbreakdown_VS_BS_VS_BS=(+0.0+(+(+vav_VS_BS_VS_BS+(+0.0*pModel->VBRGATD_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopegat_d+vav_VS_BS*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRGATD_i))*0.0));
  fbreakdown_VS_BS_VD_BD=(+0.0+(+(+vav_VS_BS_VD_BD+(+0.0*pModel->VBRGATD_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopegat_d+vav_VS_BS*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRGATD_i))*0.0));
#endif
fbreakdown_VD_BD=vav_VD_BD*pModel->slopegat_d;
#if defined(_DERIVATE2)
  fbreakdown_VD_BD_VS_BS=(+0.0+(+(+vav_VD_BD_VS_BS+(+0.0*pModel->VBRGATD_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopegat_d+vav_VD_BD*0.0+(vav_VS_BS+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRGATD_i))*0.0));
  fbreakdown_VD_BD_VD_BD=(+0.0+(+(+vav_VD_BD_VD_BD+(+0.0*pModel->VBRGATD_i+0.0*0.0+0.0*0.0+0.999*0.0))*pModel->slopegat_d+vav_VD_BD*0.0+(vav_VD_BD+(0.0))*0.0+(pInst->vav+(0.999*pModel->VBRGATD_i))*0.0));
#endif
#endif
pInst->fbreakdown=(pModel->fstopgat_d+((pInst->vav+(0.999*pModel->VBRGATD_i))*pModel->slopegat_d));
EXIT_IF_ISNAN((pModel->fstopgat_d+((pInst->vav+(0.999*pModel->VBRGATD_i))*pModel->slopegat_d)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(BD,GND)V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
ijungat_d_VD_BD=(((((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD));
#if defined(_DERIVATE2)
  ijungat_d_VD_BD_VD_BD=(+(+(+(+id_VD_BD_VD_BD+isrh_VD_BD_VD_BD)+itat_VD_BD_VD_BD)+ibbt_VD_BD_VD_BD)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VD_BD);
  ijungat_d_VD_BD_VS_BS=(+(+(+(+id_VD_BD_VS_BS+isrh_VD_BD_VS_BS)+itat_VD_BD_VS_BS)+ibbt_VD_BD_VS_BS)*pInst->fbreakdown+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VD_BD_VS_BS);
#endif
ijungat_d_VS_BS=(((((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*pInst->fbreakdown)+((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS));
#if defined(_DERIVATE2)
  ijungat_d_VS_BS_VD_BD=(+(+(+(+id_VS_BS_VD_BD+isrh_VS_BS_VD_BD)+itat_VS_BS_VD_BD)+ibbt_VS_BS_VD_BD)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VD_BD+(((id_VD_BD+isrh_VD_BD)+itat_VD_BD)+ibbt_VD_BD)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VD_BD);
  ijungat_d_VS_BS_VS_BS=(+(+(+(+id_VS_BS_VS_BS+isrh_VS_BS_VS_BS)+itat_VS_BS_VS_BS)+ibbt_VS_BS_VS_BS)*pInst->fbreakdown+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((id_VS_BS+isrh_VS_BS)+itat_VS_BS)+ibbt_VS_BS)*fbreakdown_VS_BS+(((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*fbreakdown_VS_BS_VS_BS);
#endif
#endif
ijungat_d=((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown);
EXIT_IF_ISNAN(((((pInst->id+pInst->isrh)+pInst->itat)+pInst->ibbt)*pInst->fbreakdown))
}
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS) ddxprobe=V(GP,GND)V(BP,GND)V(S,GND)V(D,GND)V(BD,GND) */
ijun_d_VD_BD=(((pInst->ABDRAIN_i*ijunbot_d_VD_BD)+(pInst->LSDRAIN_i*ijunsti_d_VD_BD))+(pInst->LGDRAIN_i*ijungat_d_VD_BD));
#if defined(_DERIVATE2)
  ijun_d_VD_BD_VD_BD=(+(+(+0.0*ijunbot_d+0.0*ijunbot_d_VD_BD+0.0*ijunbot_d_VD_BD+pInst->ABDRAIN_i*ijunbot_d_VD_BD_VD_BD)+(+0.0*ijunsti_d+0.0*ijunsti_d_VD_BD+0.0*ijunsti_d_VD_BD+pInst->LSDRAIN_i*ijunsti_d_VD_BD_VD_BD))+(+0.0*ijungat_d+0.0*ijungat_d_VD_BD+0.0*ijungat_d_VD_BD+pInst->LGDRAIN_i*ijungat_d_VD_BD_VD_BD));
  ijun_d_VD_BD_VS_BS=(+(+(+0.0*ijunbot_d+0.0*ijunbot_d_VS_BS+0.0*ijunbot_d_VD_BD+pInst->ABDRAIN_i*ijunbot_d_VD_BD_VS_BS)+(+0.0*ijunsti_d+0.0*ijunsti_d_VS_BS+0.0*ijunsti_d_VD_BD+pInst->LSDRAIN_i*ijunsti_d_VD_BD_VS_BS))+(+0.0*ijungat_d+0.0*ijungat_d_VS_BS+0.0*ijungat_d_VD_BD+pInst->LGDRAIN_i*ijungat_d_VD_BD_VS_BS));
#endif
ijun_d_VS_BS=(((pInst->ABDRAIN_i*ijunbot_d_VS_BS)+(pInst->LSDRAIN_i*ijunsti_d_VS_BS))+(pInst->LGDRAIN_i*ijungat_d_VS_BS));
#if defined(_DERIVATE2)
  ijun_d_VS_BS_VD_BD=(+(+(+0.0*ijunbot_d+0.0*ijunbot_d_VD_BD+0.0*ijunbot_d_VS_BS+pInst->ABDRAIN_i*ijunbot_d_VS_BS_VD_BD)+(+0.0*ijunsti_d+0.0*ijunsti_d_VD_BD+0.0*ijunsti_d_VS_BS+pInst->LSDRAIN_i*ijunsti_d_VS_BS_VD_BD))+(+0.0*ijungat_d+0.0*ijungat_d_VD_BD+0.0*ijungat_d_VS_BS+pInst->LGDRAIN_i*ijungat_d_VS_BS_VD_BD));
  ijun_d_VS_BS_VS_BS=(+(+(+0.0*ijunbot_d+0.0*ijunbot_d_VS_BS+0.0*ijunbot_d_VS_BS+pInst->ABDRAIN_i*ijunbot_d_VS_BS_VS_BS)+(+0.0*ijunsti_d+0.0*ijunsti_d_VS_BS+0.0*ijunsti_d_VS_BS+pInst->LSDRAIN_i*ijunsti_d_VS_BS_VS_BS))+(+0.0*ijungat_d+0.0*ijungat_d_VS_BS+0.0*ijungat_d_VS_BS+pInst->LGDRAIN_i*ijungat_d_VS_BS_VS_BS));
#endif
#endif
pInst->ijun_d=(((pInst->ABDRAIN_i*ijunbot_d)+(pInst->LSDRAIN_i*ijunsti_d))+(pInst->LGDRAIN_i*ijungat_d));
EXIT_IF_ISNAN((((pInst->ABDRAIN_i*ijunbot_d)+(pInst->LSDRAIN_i*ijunsti_d))+(pInst->LGDRAIN_i*ijungat_d)))
}
}
rgatenoise=(pModel->nt0*pInst->ggate);
EXIT_IF_ISNAN((pModel->nt0*pInst->ggate))
rbulknoise=(pModel->nt0*pInst->gbulk);
EXIT_IF_ISNAN((pModel->nt0*pInst->gbulk))
rjunsnoise=(pModel->nt0*pInst->gjuns);
EXIT_IF_ISNAN((pModel->nt0*pInst->gjuns))
rjundnoise=(pModel->nt0*pInst->gjund);
EXIT_IF_ISNAN((pModel->nt0*pInst->gjund))
rwellnoise=(pModel->nt0*pInst->gwell);
EXIT_IF_ISNAN((pModel->nt0*pInst->gwell))
}
{
if
((pInst->sigVds>0))
{
  _load_static_residual2(D,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Iimpact))
  _load_static_jacobian4(D,BP,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Iimpact_VS_BP))
  _load_static_jacobian4(D,BP,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Iimpact_VD_S))
  _load_static_jacobian4(D,BP,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Iimpact_VGP_S))
  _load_static_residual2(D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Ids))
  _load_static_jacobian4(D,S,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Ids_VS_BP))
  _load_static_jacobian4(D,S,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Ids_VD_S))
  _load_static_jacobian4(D,S,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Ids_VGP_S))
  _load_static_residual2(GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Igcs))
  _load_static_jacobian4(GP,S,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcs_VS_BP))
  _load_static_jacobian4(GP,S,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcs_VD_S))
  _load_static_jacobian4(GP,S,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcs_VGP_S))
  _load_static_residual2(GP,D,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Igcd))
  _load_static_jacobian4(GP,D,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcd_VS_BP))
  _load_static_jacobian4(GP,D,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcd_VD_S))
  _load_static_jacobian4(GP,D,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcd_VGP_S))
}
else
{
  _load_static_residual2(S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Iimpact))
  _load_static_jacobian4(S,BP,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Iimpact_VS_BP))
  _load_static_jacobian4(S,BP,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Iimpact_VD_S))
  _load_static_jacobian4(S,BP,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Iimpact_VGP_S))
  _load_static_residual2(S,D,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Ids))
  _load_static_jacobian4(S,D,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Ids_VS_BP))
  _load_static_jacobian4(S,D,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Ids_VD_S))
  _load_static_jacobian4(S,D,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Ids_VGP_S))
  _load_static_residual2(GP,D,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Igcs))
  _load_static_jacobian4(GP,D,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcs_VS_BP))
  _load_static_jacobian4(GP,D,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcs_VD_S))
  _load_static_jacobian4(GP,D,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcs_VGP_S))
  _load_static_residual2(GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Igcd))
  _load_static_jacobian4(GP,S,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcd_VS_BP))
  _load_static_jacobian4(GP,S,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcd_VD_S))
  _load_static_jacobian4(GP,S,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igcd_VGP_S))
}
  _load_static_residual2(GP,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igb))
  _load_static_jacobian4(GP,BP,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igb_VS_BP))
  _load_static_jacobian4(GP,BP,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igb_VD_S))
  _load_static_jacobian4(GP,BP,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igb_VGP_S))
  _load_static_residual2(GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Igsov))
  _load_static_jacobian4(GP,S,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igsov_VS_BP))
  _load_static_jacobian4(GP,S,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igsov_VD_S))
  _load_static_jacobian4(GP,S,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igsov_VGP_S))
  _load_static_residual2(GP,D,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->Igdov))
  _load_static_jacobian4(GP,D,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igdov_VS_BP))
  _load_static_jacobian4(GP,D,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igdov_VD_S))
  _load_static_jacobian4(GP,D,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igdov_VGP_S))
  _load_static_residual2(S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igisl))
  _load_static_jacobian4(S,BP,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igisl_VD_S))
  _load_static_jacobian4(S,BP,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igisl_VGP_S))
  _load_static_jacobian4(S,BP,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igisl_VS_BP))
  _load_static_residual2(D,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igidl))
  _load_static_jacobian4(D,BP,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igidl_VGP_S))
  _load_static_jacobian4(D,BP,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Igidl_VS_BP))
  _load_static_jacobian4(D,BP,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Igidl_VD_S))
  _load_static_residual2(BS,S,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->ijun_s))
  _load_static_jacobian4(BS,S,S,BS,((pModel->CHNL_TYPE*pInst->MULT_i)*ijun_s_VS_BS))
  _load_static_jacobian4(BS,S,D,BD,((pModel->CHNL_TYPE*pInst->MULT_i)*ijun_s_VD_BD))
  _load_static_residual2(BD,D,((pModel->CHNL_TYPE*pInst->MULT_i)*pInst->ijun_d))
  _load_static_jacobian4(BD,D,S,BS,((pModel->CHNL_TYPE*pInst->MULT_i)*ijun_d_VS_BS))
  _load_static_jacobian4(BD,D,D,BD,((pModel->CHNL_TYPE*pInst->MULT_i)*ijun_d_VD_BD))
  _load_static_residual2(G,GP,((pInst->MULT_i*pInst->ggate)*(NP(G)-NP(GP))))
  _load_static_jacobian4(G,GP,G,GP,((pInst->MULT_i*pInst->ggate)))
pInst->wnoise10=(pInst->MULT_i*rgatenoise);
  _load_static_residual2(BP,BI,((pInst->MULT_i*pInst->gbulk)*(NP(BP)-NP(BI))))
  _load_static_jacobian4(BP,BI,BP,BI,((pInst->MULT_i*pInst->gbulk)))
pInst->wnoise9=(pInst->MULT_i*rbulknoise);
  _load_static_residual2(BS,BI,((pInst->MULT_i*pInst->gjuns)*(NP(BS)-NP(BI))))
  _load_static_jacobian4(BS,BI,BS,BI,((pInst->MULT_i*pInst->gjuns)))
pInst->wnoise8=(pInst->MULT_i*rjunsnoise);
  _load_static_residual2(BD,BI,((pInst->MULT_i*pInst->gjund)*(NP(BD)-NP(BI))))
  _load_static_jacobian4(BD,BI,BD,BI,((pInst->MULT_i*pInst->gjund)))
pInst->wnoise7=(pInst->MULT_i*rjundnoise);
  _load_static_residual2(B,BI,((pInst->MULT_i*pInst->gwell)*(NP(B)-NP(BI))))
  _load_static_jacobian4(B,BI,B,BI,((pInst->MULT_i*pInst->gwell)))
pInst->wnoise6=(pInst->MULT_i*rwellnoise);
  _load_static_residual2(D,S,(_circuit_gmin*(NP(D)-NP(S))))
  _load_static_jacobian4(D,S,D,S,(_circuit_gmin))
}
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(BP,GND)V(GP,GND)V(D,GND) */
Qs_VD_S=(-((Qg_VD_S+Qb_VD_S)+Qd_VD_S));
#if defined(_DERIVATE2)
  Qs_VD_S_VD_S=0.0;
  Qs_VD_S_VGP_S=0.0;
  Qs_VD_S_VS_BP=0.0;
#endif
Qs_VGP_S=(-((Qg_VGP_S+Qb_VGP_S)+Qd_VGP_S));
#if defined(_DERIVATE2)
  Qs_VGP_S_VD_S=0.0;
  Qs_VGP_S_VGP_S=0.0;
  Qs_VGP_S_VS_BP=0.0;
#endif
Qs_VS_BP=(-((Qg_VS_BP+Qb_VS_BP)+Qd_VS_BP));
#if defined(_DERIVATE2)
  Qs_VS_BP_VD_S=0.0;
  Qs_VS_BP_VGP_S=0.0;
  Qs_VS_BP_VS_BP=0.0;
#endif
#endif
Qs=(-((Qg+Qb)+Qd));
EXIT_IF_ISNAN((-((Qg+Qb)+Qd)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(S,BP)V(GP,S) ddxprobe=V(GP,GND) */
#if defined(_DERIVATE)
Qfgs_VD_S=(Qfgs_VD_S+Qgs_ov_VD_S);
#endif
#if defined(_DERIVATE)
Qfgs_VS_BP=(Qfgs_VS_BP+Qgs_ov_VS_BP);
#endif
Qfgs_VGP_S=(Qfgs_VGP_S+Qgs_ov_VGP_S);
#if defined(_DERIVATE2)
  Qfgs_VGP_S_VD_S=(+Qfgs_VGP_S_VD_S+Qgs_ov_VGP_S_VD_S);
  Qfgs_VGP_S_VS_BP=(+Qfgs_VGP_S_VS_BP+Qgs_ov_VGP_S_VS_BP);
  Qfgs_VGP_S_VGP_S=(+Qfgs_VGP_S_VGP_S+Qgs_ov_VGP_S_VGP_S);
#endif
#endif
Qfgs=(Qfgs+Qgs_ov);
EXIT_IF_ISNAN((Qfgs+Qgs_ov))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(S,BP)V(GP,S)V(D,S) ddxprobe=V(GP,GND) */
#if defined(_DERIVATE)
Qfgd_VS_BP=(Qfgd_VS_BP+Qgd_ov_VS_BP);
#endif
Qfgd_VGP_S=(Qfgd_VGP_S+Qgd_ov_VGP_S);
#if defined(_DERIVATE2)
  Qfgd_VGP_S_VS_BP=(+Qfgd_VGP_S_VS_BP+Qgd_ov_VGP_S_VS_BP);
  Qfgd_VGP_S_VGP_S=(+Qfgd_VGP_S_VGP_S+Qgd_ov_VGP_S_VGP_S);
  Qfgd_VGP_S_VD_S=(+Qfgd_VGP_S_VD_S+Qgd_ov_VGP_S_VD_S);
#endif
#if defined(_DERIVATE)
Qfgd_VD_S=(Qfgd_VD_S+Qgd_ov_VD_S);
#endif
#endif
Qfgd=(Qfgd+Qgd_ov);
EXIT_IF_ISNAN((Qfgd+Qgd_ov))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(D,BD)V(S,BS) ddxprobe= */
qjun_s_VD_BD=(((pInst->ABSOURCE_i*qjunbot_s_VD_BD)+(pInst->LSSOURCE_i*qjunsti_s_VD_BD))+(pInst->LGSOURCE_i*qjungat_s_VD_BD));
qjun_s_VS_BS=(((pInst->ABSOURCE_i*qjunbot_s_VS_BS)+(pInst->LSSOURCE_i*qjunsti_s_VS_BS))+(pInst->LGSOURCE_i*qjungat_s_VS_BS));
#endif
qjun_s=(((pInst->ABSOURCE_i*qjunbot_s)+(pInst->LSSOURCE_i*qjunsti_s))+(pInst->LGSOURCE_i*qjungat_s));
EXIT_IF_ISNAN((((pInst->ABSOURCE_i*qjunbot_s)+(pInst->LSSOURCE_i*qjunsti_s))+(pInst->LGSOURCE_i*qjungat_s)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(D,BD)V(S,BS) ddxprobe= */
qjun_d_VD_BD=(((pInst->ABDRAIN_i*qjunbot_d_VD_BD)+(pInst->LSDRAIN_i*qjunsti_d_VD_BD))+(pInst->LGDRAIN_i*qjungat_d_VD_BD));
qjun_d_VS_BS=(((pInst->ABDRAIN_i*qjunbot_d_VS_BS)+(pInst->LSDRAIN_i*qjunsti_d_VS_BS))+(pInst->LGDRAIN_i*qjungat_d_VS_BS));
#endif
qjun_d=(((pInst->ABDRAIN_i*qjunbot_d)+(pInst->LSDRAIN_i*qjunsti_d))+(pInst->LGDRAIN_i*qjungat_d));
EXIT_IF_ISNAN((((pInst->ABDRAIN_i*qjunbot_d)+(pInst->LSDRAIN_i*qjunsti_d))+(pInst->LGDRAIN_i*qjungat_d)))
#endif
#ifdef _DYNAMIC
if
((pInst->sigVds<0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=0.0;
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=0.0;
  temp_VD_BD_VS_BS=0.0;
  temp_VD_BD_VGP_S=0.0;
  temp_VD_BD_VD_S=0.0;
  temp_VD_BD_VS_BP=0.0;
#endif
temp_VS_BS=0.0;
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=0.0;
  temp_VS_BS_VS_BS=0.0;
  temp_VS_BS_VGP_S=0.0;
  temp_VS_BS_VD_S=0.0;
  temp_VS_BS_VS_BP=0.0;
#endif
temp_VGP_S=Qd_VGP_S;
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=0.0;
  temp_VGP_S_VS_BS=0.0;
  temp_VGP_S_VGP_S=Qd_VGP_S_VGP_S;
  temp_VGP_S_VD_S=Qd_VGP_S_VD_S;
  temp_VGP_S_VS_BP=Qd_VGP_S_VS_BP;
#endif
temp_VD_S=Qd_VD_S;
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=0.0;
  temp_VD_S_VS_BS=0.0;
  temp_VD_S_VGP_S=Qd_VD_S_VGP_S;
  temp_VD_S_VD_S=Qd_VD_S_VD_S;
  temp_VD_S_VS_BP=Qd_VD_S_VS_BP;
#endif
temp_VS_BP=Qd_VS_BP;
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=0.0;
  temp_VS_BP_VS_BS=0.0;
  temp_VS_BP_VGP_S=Qd_VS_BP_VGP_S;
  temp_VS_BP_VD_S=Qd_VS_BP_VD_S;
  temp_VS_BP_VS_BP=Qd_VS_BP_VS_BP;
#endif
#endif
temp=Qd;
EXIT_IF_ISNAN(Qd)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe=V(S,GND)V(BP,GND)V(GP,GND)V(D,GND) */
Qd_VGP_S=Qs_VGP_S;
#if defined(_DERIVATE2)
  Qd_VGP_S_VGP_S=Qs_VGP_S_VGP_S;
  Qd_VGP_S_VD_S=Qs_VGP_S_VD_S;
  Qd_VGP_S_VS_BP=Qs_VGP_S_VS_BP;
#endif
Qd_VD_S=Qs_VD_S;
#if defined(_DERIVATE2)
  Qd_VD_S_VGP_S=Qs_VD_S_VGP_S;
  Qd_VD_S_VD_S=Qs_VD_S_VD_S;
  Qd_VD_S_VS_BP=Qs_VD_S_VS_BP;
#endif
Qd_VS_BP=Qs_VS_BP;
#if defined(_DERIVATE2)
  Qd_VS_BP_VGP_S=Qs_VS_BP_VGP_S;
  Qd_VS_BP_VD_S=Qs_VS_BP_VD_S;
  Qd_VS_BP_VS_BP=Qs_VS_BP_VS_BP;
#endif
#endif
Qd=Qs;
EXIT_IF_ISNAN(Qs)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe=V(BP,GND)V(GP,GND)V(D,GND) */
Qs_VD_S=temp_VD_S;
#if defined(_DERIVATE2)
  Qs_VD_S_VD_S=temp_VD_S_VD_S;
  Qs_VD_S_VGP_S=temp_VD_S_VGP_S;
  Qs_VD_S_VS_BP=temp_VD_S_VS_BP;
#endif
Qs_VGP_S=temp_VGP_S;
#if defined(_DERIVATE2)
  Qs_VGP_S_VD_S=temp_VGP_S_VD_S;
  Qs_VGP_S_VGP_S=temp_VGP_S_VGP_S;
  Qs_VGP_S_VS_BP=temp_VGP_S_VS_BP;
#endif
Qs_VS_BP=temp_VS_BP;
#if defined(_DERIVATE2)
  Qs_VS_BP_VD_S=temp_VS_BP_VD_S;
  Qs_VS_BP_VGP_S=temp_VS_BP_VGP_S;
  Qs_VS_BP_VS_BP=temp_VS_BP_VS_BP;
#endif
#endif
Qs=temp;
EXIT_IF_ISNAN(temp)
#endif
}
#endif /* if(...) */
  _load_dynamic_residual2(GP,S,_DDT(((pModel->CHNL_TYPE*pInst->MULT_i)*Qg)))
  _load_dynamic_jacobian4(GP,S,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Qg_VS_BP))
  _load_dynamic_jacobian4(GP,S,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qg_VGP_S))
  _load_dynamic_jacobian4(GP,S,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qg_VD_S))
  _load_dynamic_residual2(BP,S,_DDT(((pModel->CHNL_TYPE*pInst->MULT_i)*Qb)))
  _load_dynamic_jacobian4(BP,S,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Qb_VS_BP))
  _load_dynamic_jacobian4(BP,S,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qb_VGP_S))
  _load_dynamic_jacobian4(BP,S,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qb_VD_S))
  _load_dynamic_residual2(D,S,_DDT(((pModel->CHNL_TYPE*pInst->MULT_i)*Qd)))
  _load_dynamic_jacobian4(D,S,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Qd_VS_BP))
  _load_dynamic_jacobian4(D,S,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qd_VD_S))
  _load_dynamic_jacobian4(D,S,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qd_VGP_S))
  _load_dynamic_residual2(GP,S,_DDT(((pModel->CHNL_TYPE*pInst->MULT_i)*Qfgs)))
  _load_dynamic_jacobian4(GP,S,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qfgs_VGP_S))
  _load_dynamic_jacobian4(GP,S,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Qfgs_VS_BP))
  _load_dynamic_jacobian4(GP,S,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qfgs_VD_S))
  _load_dynamic_residual2(GP,D,_DDT(((pModel->CHNL_TYPE*pInst->MULT_i)*Qfgd)))
  _load_dynamic_jacobian4(GP,D,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qfgd_VD_S))
  _load_dynamic_jacobian4(GP,D,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qfgd_VGP_S))
  _load_dynamic_jacobian4(GP,D,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Qfgd_VS_BP))
  _load_dynamic_residual2(GP,BP,_DDT(((pModel->CHNL_TYPE*pInst->MULT_i)*Qgb_ov)))
  _load_dynamic_jacobian4(GP,BP,S,BP,((pModel->CHNL_TYPE*pInst->MULT_i)*Qgb_ov_VS_BP))
  _load_dynamic_jacobian4(GP,BP,GP,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qgb_ov_VGP_S))
  _load_dynamic_jacobian4(GP,BP,D,S,((pModel->CHNL_TYPE*pInst->MULT_i)*Qgb_ov_VD_S))
  _load_dynamic_residual2(BS,S,_DDT(((pModel->CHNL_TYPE*pInst->MULT_i)*qjun_s)))
  _load_dynamic_jacobian4(BS,S,S,BS,((pModel->CHNL_TYPE*pInst->MULT_i)*qjun_s_VS_BS))
  _load_dynamic_jacobian4(BS,S,D,BD,((pModel->CHNL_TYPE*pInst->MULT_i)*qjun_s_VD_BD))
  _load_dynamic_residual2(BD,D,_DDT(((pModel->CHNL_TYPE*pInst->MULT_i)*qjun_d)))
  _load_dynamic_jacobian4(BD,D,S,BS,((pModel->CHNL_TYPE*pInst->MULT_i)*qjun_d_VS_BS))
  _load_dynamic_jacobian4(BD,D,D,BD,((pModel->CHNL_TYPE*pInst->MULT_i)*qjun_d_VD_BD))
}
{
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Sfl_VD_S=0.0;
Sfl_VGP_S=0.0;
Sfl_VS_BP=0.0;
#endif
pInst->Sfl=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mid_VD_S=0.0;
mid_VGP_S=0.0;
mid_VS_BP=0.0;
#endif
mid=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mig_VD_S=0.0;
mig_VGP_S=0.0;
mig_VS_BP=0.0;
#endif
pInst->mig=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
migid_VD_S=0.0;
migid_VGP_S=0.0;
migid_VS_BP=0.0;
#endif
migid=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
c_igid_VD_S=0.0;
c_igid_VGP_S=0.0;
c_igid_VS_BP=0.0;
#endif
pInst->c_igid=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
CGeff_VD_S=((COX_qm_VD_S*pInst->eta_p)+(pInst->COX_qm*eta_p_VD_S));
CGeff_VGP_S=((COX_qm_VGP_S*pInst->eta_p)+(pInst->COX_qm*eta_p_VGP_S));
CGeff_VS_BP=((COX_qm_VS_BP*pInst->eta_p)+(pInst->COX_qm*eta_p_VS_BP));
#endif
pInst->CGeff=(pInst->COX_qm*pInst->eta_p);
EXIT_IF_ISNAN((pInst->COX_qm*pInst->eta_p))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
sqid_VD_S=0.0;
sqid_VGP_S=0.0;
sqid_VS_BP=0.0;
#endif
pInst->sqid=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
sqig_VD_S=0.0;
sqig_VGP_S=0.0;
sqig_VS_BP=0.0;
#endif
sqig=0.0;
EXIT_IF_ISNAN(0.0)
if
((((pInst->xg>0.0)&&(pInst->MULT_i>0.0))&&(pInst->BET_i>0.0)))
{
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
N1_VD_S=(pInst->Cox_over_q*alpha_VD_S)*pModel->phit;
N1_VGP_S=(pInst->Cox_over_q*alpha_VGP_S)*pModel->phit;
N1_VS_BP=(pInst->Cox_over_q*alpha_VS_BP)*pModel->phit;
#endif
N1=((pInst->Cox_over_q*pInst->alpha)*pModel->phit);
EXIT_IF_ISNAN(((pInst->Cox_over_q*pInst->alpha)*pModel->phit))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Nm1_VD_S=(pInst->Cox_over_q*qim1_VD_S);
Nm1_VGP_S=(pInst->Cox_over_q*qim1_VGP_S);
Nm1_VS_BP=(pInst->Cox_over_q*qim1_VS_BP);
#endif
Nm1=(pInst->Cox_over_q*pInst->qim1);
EXIT_IF_ISNAN((pInst->Cox_over_q*pInst->qim1))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Delta_N1_VD_S=(pInst->Cox_over_q*((alpha_VD_S*pInst->dps)+(pInst->alpha*dps_VD_S)));
Delta_N1_VGP_S=(pInst->Cox_over_q*((alpha_VGP_S*pInst->dps)+(pInst->alpha*dps_VGP_S)));
Delta_N1_VS_BP=(pInst->Cox_over_q*((alpha_VS_BP*pInst->dps)+(pInst->alpha*dps_VS_BP)));
#endif
Delta_N1=(pInst->Cox_over_q*(pInst->alpha*pInst->dps));
EXIT_IF_ISNAN((pInst->Cox_over_q*(pInst->alpha*pInst->dps)))
{
double m00_logE(d00_logE0,((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))
#endif
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Sfl_VD_S=((((-(pInst->NFB_i*N1_VD_S))+(pInst->NFC_i*((N1_VD_S*N1)+(N1*N1_VD_S))))*d00_logE0)+(((pInst->NFA_i-(pInst->NFB_i*N1))+(pInst->NFC_i*(N1*N1)))*(((Nm1_VD_S+(0.5*Delta_N1_VD_S))*(Nm1-(0.5*Delta_N1))-(Nm1+(0.5*Delta_N1))*(Nm1_VD_S-(0.5*Delta_N1_VD_S)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1)))*d10_logE0));
Sfl_VGP_S=((((-(pInst->NFB_i*N1_VGP_S))+(pInst->NFC_i*((N1_VGP_S*N1)+(N1*N1_VGP_S))))*d00_logE0)+(((pInst->NFA_i-(pInst->NFB_i*N1))+(pInst->NFC_i*(N1*N1)))*(((Nm1_VGP_S+(0.5*Delta_N1_VGP_S))*(Nm1-(0.5*Delta_N1))-(Nm1+(0.5*Delta_N1))*(Nm1_VGP_S-(0.5*Delta_N1_VGP_S)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1)))*d10_logE0));
Sfl_VS_BP=((((-(pInst->NFB_i*N1_VS_BP))+(pInst->NFC_i*((N1_VS_BP*N1)+(N1*N1_VS_BP))))*d00_logE0)+(((pInst->NFA_i-(pInst->NFB_i*N1))+(pInst->NFC_i*(N1*N1)))*(((Nm1_VS_BP+(0.5*Delta_N1_VS_BP))*(Nm1-(0.5*Delta_N1))-(Nm1+(0.5*Delta_N1))*(Nm1_VS_BP-(0.5*Delta_N1_VS_BP)))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1)))*d10_logE0));
#endif
pInst->Sfl=(((pInst->NFA_i-(pInst->NFB_i*N1))+(pInst->NFC_i*(N1*N1)))*d00_logE0);
EXIT_IF_ISNAN((((pInst->NFA_i-(pInst->NFB_i*N1))+(pInst->NFC_i*(N1*N1)))*d00_logE0))
}
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Sfl_VD_S=(Sfl_VD_S+(((pInst->NFC_i*(Nm1_VD_S-(2.0*N1_VD_S)))*Delta_N1)+((pInst->NFB_i+(pInst->NFC_i*(Nm1-(2.0*N1))))*Delta_N1_VD_S)));
Sfl_VGP_S=(Sfl_VGP_S+(((pInst->NFC_i*(Nm1_VGP_S-(2.0*N1_VGP_S)))*Delta_N1)+((pInst->NFB_i+(pInst->NFC_i*(Nm1-(2.0*N1))))*Delta_N1_VGP_S)));
Sfl_VS_BP=(Sfl_VS_BP+(((pInst->NFC_i*(Nm1_VS_BP-(2.0*N1_VS_BP)))*Delta_N1)+((pInst->NFB_i+(pInst->NFC_i*(Nm1-(2.0*N1))))*Delta_N1_VS_BP)));
#endif
pInst->Sfl=(pInst->Sfl+((pInst->NFB_i+(pInst->NFC_i*(Nm1-(2.0*N1))))*Delta_N1));
EXIT_IF_ISNAN((pInst->Sfl+((pInst->NFB_i+(pInst->NFC_i*(Nm1-(2.0*N1))))*Delta_N1)))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Sfl_VD_S=(((((((pInst->Sfl_prefac*Ids_VD_S)*pInst->Gvsatinv)+((pInst->Sfl_prefac*pInst->Ids)*Gvsatinv_VD_S))*pInst->Sfl)+(((pInst->Sfl_prefac*pInst->Ids)*pInst->Gvsatinv)*Sfl_VD_S))*N1-(((pInst->Sfl_prefac*pInst->Ids)*pInst->Gvsatinv)*pInst->Sfl)*N1_VD_S)/N1/N1);
Sfl_VGP_S=(((((((pInst->Sfl_prefac*Ids_VGP_S)*pInst->Gvsatinv)+((pInst->Sfl_prefac*pInst->Ids)*Gvsatinv_VGP_S))*pInst->Sfl)+(((pInst->Sfl_prefac*pInst->Ids)*pInst->Gvsatinv)*Sfl_VGP_S))*N1-(((pInst->Sfl_prefac*pInst->Ids)*pInst->Gvsatinv)*pInst->Sfl)*N1_VGP_S)/N1/N1);
Sfl_VS_BP=(((((((pInst->Sfl_prefac*Ids_VS_BP)*pInst->Gvsatinv)+((pInst->Sfl_prefac*pInst->Ids)*Gvsatinv_VS_BP))*pInst->Sfl)+(((pInst->Sfl_prefac*pInst->Ids)*pInst->Gvsatinv)*Sfl_VS_BP))*N1-(((pInst->Sfl_prefac*pInst->Ids)*pInst->Gvsatinv)*pInst->Sfl)*N1_VS_BP)/N1/N1);
#endif
pInst->Sfl=((((pInst->Sfl_prefac*pInst->Ids)*pInst->Gvsatinv)*pInst->Sfl)/N1);
EXIT_IF_ISNAN(((((pInst->Sfl_prefac*pInst->Ids)*pInst->Gvsatinv)*pInst->Sfl)/N1))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Sfl_VD_S=((pInst->Sfl>0.0)?Sfl_VD_S:0.0);
Sfl_VGP_S=((pInst->Sfl>0.0)?Sfl_VGP_S:0.0);
Sfl_VS_BP=((pInst->Sfl>0.0)?Sfl_VS_BP:0.0);
#endif
pInst->Sfl=((pInst->Sfl>0.0)?pInst->Sfl:0.0);
EXIT_IF_ISNAN(((pInst->Sfl>0.0)?pInst->Sfl:0.0))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
H0_VD_S=((qim1_VD_S*pInst->alpha-pInst->qim1*alpha_VD_S)/pInst->alpha/pInst->alpha);
H0_VGP_S=((qim1_VGP_S*pInst->alpha-pInst->qim1*alpha_VGP_S)/pInst->alpha/pInst->alpha);
H0_VS_BP=((qim1_VS_BP*pInst->alpha-pInst->qim1*alpha_VS_BP)/pInst->alpha/pInst->alpha);
#endif
H0=(pInst->qim1/pInst->alpha);
EXIT_IF_ISNAN((pInst->qim1/pInst->alpha))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
t1_VD_S=((qim_VD_S*pInst->qim1-pInst->qim*qim1_VD_S)/pInst->qim1/pInst->qim1);
t1_VGP_S=((qim_VGP_S*pInst->qim1-pInst->qim*qim1_VGP_S)/pInst->qim1/pInst->qim1);
t1_VS_BP=((qim_VS_BP*pInst->qim1-pInst->qim*qim1_VS_BP)/pInst->qim1/pInst->qim1);
#endif
t1=(pInst->qim/pInst->qim1);
EXIT_IF_ISNAN((pInst->qim/pInst->qim1))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
sqt2_VD_S=((0.5*1.6666666666666667e-01)*((dps_VD_S*H0-pInst->dps*H0_VD_S)/H0/H0));
sqt2_VGP_S=((0.5*1.6666666666666667e-01)*((dps_VGP_S*H0-pInst->dps*H0_VGP_S)/H0/H0));
sqt2_VS_BP=((0.5*1.6666666666666667e-01)*((dps_VS_BP*H0-pInst->dps*H0_VS_BP)/H0/H0));
#endif
sqt2=((0.5*1.6666666666666667e-01)*(pInst->dps/H0));
EXIT_IF_ISNAN(((0.5*1.6666666666666667e-01)*(pInst->dps/H0)))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
t2_VD_S=((sqt2_VD_S*sqt2)+(sqt2*sqt2_VD_S));
t2_VGP_S=((sqt2_VGP_S*sqt2)+(sqt2*sqt2_VGP_S));
t2_VS_BP=((sqt2_VS_BP*sqt2)+(sqt2*sqt2_VS_BP));
#endif
t2=(sqt2*sqt2);
EXIT_IF_ISNAN((sqt2*sqt2))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
r_VD_S=((H0_VD_S*pInst->H-H0*H_VD_S)/pInst->H/pInst->H);
r_VGP_S=((H0_VGP_S*pInst->H-H0*H_VGP_S)/pInst->H/pInst->H);
r_VS_BP=((H0_VS_BP*pInst->H-H0*H_VS_BP)/pInst->H/pInst->H);
#endif
r=((H0/pInst->H)-1.0);
EXIT_IF_ISNAN(((H0/pInst->H)-1.0))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
lc_VD_S=(((1.0-(12*(r*t2)))>1e-20)?(-(12*((r_VD_S*t2)+(r*t2_VD_S)))):0.0);
lc_VGP_S=(((1.0-(12*(r*t2)))>1e-20)?(-(12*((r_VGP_S*t2)+(r*t2_VGP_S)))):0.0);
lc_VS_BP=(((1.0-(12*(r*t2)))>1e-20)?(-(12*((r_VS_BP*t2)+(r*t2_VS_BP)))):0.0);
#endif
lc=(((1.0-(12*(r*t2)))>1e-20)?(1.0-(12*(r*t2))):1e-20);
EXIT_IF_ISNAN((((1.0-(12*(r*t2)))>1e-20)?(1.0-(12*(r*t2))):1e-20))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
lcinv2_VD_S=(-1*((lc_VD_S*lc)+(lc*lc_VD_S))/(lc*lc)/(lc*lc));
lcinv2_VGP_S=(-1*((lc_VGP_S*lc)+(lc*lc_VGP_S))/(lc*lc)/(lc*lc));
lcinv2_VS_BP=(-1*((lc_VS_BP*lc)+(lc*lc_VS_BP))/(lc*lc)/(lc*lc));
#endif
lcinv2=(1/(lc*lc));
EXIT_IF_ISNAN((1/(lc*lc)))
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
g_ideal_VGP_S=(pInst->BET_i*((((FdL_VGP_S*pInst->qim1)+(pInst->FdL*qim1_VGP_S))*pInst->Gvsatinv)+((pInst->FdL*pInst->qim1)*Gvsatinv_VGP_S)));
g_ideal_VD_S=(pInst->BET_i*((((FdL_VD_S*pInst->qim1)+(pInst->FdL*qim1_VD_S))*pInst->Gvsatinv)+((pInst->FdL*pInst->qim1)*Gvsatinv_VD_S)));
g_ideal_VS_BP=(pInst->BET_i*((((FdL_VS_BP*pInst->qim1)+(pInst->FdL*qim1_VS_BP))*pInst->Gvsatinv)+((pInst->FdL*pInst->qim1)*Gvsatinv_VS_BP)));
#endif
g_ideal=(pInst->BET_i*((pInst->FdL*pInst->qim1)*pInst->Gvsatinv));
EXIT_IF_ISNAN((pInst->BET_i*((pInst->FdL*pInst->qim1)*pInst->Gvsatinv)))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
CGeff_VD_S=((((((((Gvsat_VD_S*pInst->Gvsat)+(pInst->Gvsat*Gvsat_VD_S))*pInst->COX_qm)+((pInst->Gvsat*pInst->Gvsat)*COX_qm_VD_S))*pInst->eta_p)+(((pInst->Gvsat*pInst->Gvsat)*pInst->COX_qm)*eta_p_VD_S))*(pInst->Gmob_dL*pInst->Gmob_dL)-(((pInst->Gvsat*pInst->Gvsat)*pInst->COX_qm)*pInst->eta_p)*((Gmob_dL_VD_S*pInst->Gmob_dL)+(pInst->Gmob_dL*Gmob_dL_VD_S)))/(pInst->Gmob_dL*pInst->Gmob_dL)/(pInst->Gmob_dL*pInst->Gmob_dL));
CGeff_VGP_S=((((((((Gvsat_VGP_S*pInst->Gvsat)+(pInst->Gvsat*Gvsat_VGP_S))*pInst->COX_qm)+((pInst->Gvsat*pInst->Gvsat)*COX_qm_VGP_S))*pInst->eta_p)+(((pInst->Gvsat*pInst->Gvsat)*pInst->COX_qm)*eta_p_VGP_S))*(pInst->Gmob_dL*pInst->Gmob_dL)-(((pInst->Gvsat*pInst->Gvsat)*pInst->COX_qm)*pInst->eta_p)*((Gmob_dL_VGP_S*pInst->Gmob_dL)+(pInst->Gmob_dL*Gmob_dL_VGP_S)))/(pInst->Gmob_dL*pInst->Gmob_dL)/(pInst->Gmob_dL*pInst->Gmob_dL));
CGeff_VS_BP=((((((((Gvsat_VS_BP*pInst->Gvsat)+(pInst->Gvsat*Gvsat_VS_BP))*pInst->COX_qm)+((pInst->Gvsat*pInst->Gvsat)*COX_qm_VS_BP))*pInst->eta_p)+(((pInst->Gvsat*pInst->Gvsat)*pInst->COX_qm)*eta_p_VS_BP))*(pInst->Gmob_dL*pInst->Gmob_dL)-(((pInst->Gvsat*pInst->Gvsat)*pInst->COX_qm)*pInst->eta_p)*((Gmob_dL_VS_BP*pInst->Gmob_dL)+(pInst->Gmob_dL*Gmob_dL_VS_BP)))/(pInst->Gmob_dL*pInst->Gmob_dL)/(pInst->Gmob_dL*pInst->Gmob_dL));
#endif
pInst->CGeff=((((pInst->Gvsat*pInst->Gvsat)*pInst->COX_qm)*pInst->eta_p)/(pInst->Gmob_dL*pInst->Gmob_dL));
EXIT_IF_ISNAN(((((pInst->Gvsat*pInst->Gvsat)*pInst->COX_qm)*pInst->eta_p)/(pInst->Gmob_dL*pInst->Gmob_dL)))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mid_VD_S=((t1_VD_S+(12*t2_VD_S))-(24*((((t1_VD_S*t2)+((1.0+t1)*t2_VD_S))*r)+(((1.0+t1)*t2)*r_VD_S))));
mid_VGP_S=((t1_VGP_S+(12*t2_VGP_S))-(24*((((t1_VGP_S*t2)+((1.0+t1)*t2_VGP_S))*r)+(((1.0+t1)*t2)*r_VGP_S))));
mid_VS_BP=((t1_VS_BP+(12*t2_VS_BP))-(24*((((t1_VS_BP*t2)+((1.0+t1)*t2_VS_BP))*r)+(((1.0+t1)*t2)*r_VS_BP))));
#endif
mid=((t1+(12*t2))-(24*(((1.0+t1)*t2)*r)));
EXIT_IF_ISNAN(((t1+(12*t2))-(24*(((1.0+t1)*t2)*r))))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mid_VD_S=((mid>1e-40)?mid_VD_S:0.0);
mid_VGP_S=((mid>1e-40)?mid_VGP_S:0.0);
mid_VS_BP=((mid>1e-40)?mid_VS_BP:0.0);
#endif
mid=((mid>1e-40)?mid:1e-40);
EXIT_IF_ISNAN(((mid>1e-40)?mid:1e-40))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mid_VD_S=((((g_ideal_VD_S*lcinv2)+(g_ideal*lcinv2_VD_S))*mid)+((g_ideal*lcinv2)*mid_VD_S));
mid_VGP_S=((((g_ideal_VGP_S*lcinv2)+(g_ideal*lcinv2_VGP_S))*mid)+((g_ideal*lcinv2)*mid_VGP_S));
mid_VS_BP=((((g_ideal_VS_BP*lcinv2)+(g_ideal*lcinv2_VS_BP))*mid)+((g_ideal*lcinv2)*mid_VS_BP));
#endif
mid=((g_ideal*lcinv2)*mid);
EXIT_IF_ISNAN(((g_ideal*lcinv2)*mid))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mig_VD_S=(((t1_VD_S/12.0)-((t2_VD_S*((t1+0.2)-(12*t2)))+(t2*(t1_VD_S-(12*t2_VD_S)))))-(1.6*((((t2_VD_S*((t1+1.0)-(12*t2)))+(t2*(t1_VD_S-(12*t2_VD_S))))*r)+((t2*((t1+1.0)-(12*t2)))*r_VD_S))));
mig_VGP_S=(((t1_VGP_S/12.0)-((t2_VGP_S*((t1+0.2)-(12*t2)))+(t2*(t1_VGP_S-(12*t2_VGP_S)))))-(1.6*((((t2_VGP_S*((t1+1.0)-(12*t2)))+(t2*(t1_VGP_S-(12*t2_VGP_S))))*r)+((t2*((t1+1.0)-(12*t2)))*r_VGP_S))));
mig_VS_BP=(((t1_VS_BP/12.0)-((t2_VS_BP*((t1+0.2)-(12*t2)))+(t2*(t1_VS_BP-(12*t2_VS_BP)))))-(1.6*((((t2_VS_BP*((t1+1.0)-(12*t2)))+(t2*(t1_VS_BP-(12*t2_VS_BP))))*r)+((t2*((t1+1.0)-(12*t2)))*r_VS_BP))));
#endif
pInst->mig=(((t1/12.0)-(t2*((t1+0.2)-(12*t2))))-(1.6*((t2*((t1+1.0)-(12*t2)))*r)));
EXIT_IF_ISNAN((((t1/12.0)-(t2*((t1+0.2)-(12*t2))))-(1.6*((t2*((t1+1.0)-(12*t2)))*r))))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mig_VD_S=((pInst->mig>1e-40)?mig_VD_S:0.0);
mig_VGP_S=((pInst->mig>1e-40)?mig_VGP_S:0.0);
mig_VS_BP=((pInst->mig>1e-40)?mig_VS_BP:0.0);
#endif
pInst->mig=((pInst->mig>1e-40)?pInst->mig:1e-40);
EXIT_IF_ISNAN(((pInst->mig>1e-40)?pInst->mig:1e-40))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mig_VD_S=((((lcinv2_VD_S*g_ideal-lcinv2*g_ideal_VD_S)/g_ideal/g_ideal)*pInst->mig)+((lcinv2/g_ideal)*mig_VD_S));
mig_VGP_S=((((lcinv2_VGP_S*g_ideal-lcinv2*g_ideal_VGP_S)/g_ideal/g_ideal)*pInst->mig)+((lcinv2/g_ideal)*mig_VGP_S));
mig_VS_BP=((((lcinv2_VS_BP*g_ideal-lcinv2*g_ideal_VS_BP)/g_ideal/g_ideal)*pInst->mig)+((lcinv2/g_ideal)*mig_VS_BP));
#endif
pInst->mig=((lcinv2/g_ideal)*pInst->mig);
EXIT_IF_ISNAN(((lcinv2/g_ideal)*pInst->mig))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
migid_VD_S=((((lcinv2_VD_S*sqt2)+(lcinv2*sqt2_VD_S))*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)))+((lcinv2*sqt2)*((-(12*t2_VD_S))-((((t1_VD_S+(19.2*t2_VD_S))-(12*((t1_VD_S*t2)+(t1*t2_VD_S))))*r)+(((t1+(19.2*t2))-(12*(t1*t2)))*r_VD_S)))));
migid_VGP_S=((((lcinv2_VGP_S*sqt2)+(lcinv2*sqt2_VGP_S))*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)))+((lcinv2*sqt2)*((-(12*t2_VGP_S))-((((t1_VGP_S+(19.2*t2_VGP_S))-(12*((t1_VGP_S*t2)+(t1*t2_VGP_S))))*r)+(((t1+(19.2*t2))-(12*(t1*t2)))*r_VGP_S)))));
migid_VS_BP=((((lcinv2_VS_BP*sqt2)+(lcinv2*sqt2_VS_BP))*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)))+((lcinv2*sqt2)*((-(12*t2_VS_BP))-((((t1_VS_BP+(19.2*t2_VS_BP))-(12*((t1_VS_BP*t2)+(t1*t2_VS_BP))))*r)+(((t1+(19.2*t2))-(12*(t1*t2)))*r_VS_BP)))));
#endif
migid=((lcinv2*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
EXIT_IF_ISNAN(((lcinv2*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r))))
if
((pInst->FNTEXC_i>0))
{
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
temp2_exc_VD_S=((qim_VD_S*pInst->xitsb)+(pInst->qim*xitsb_VD_S));
temp2_exc_VGP_S=qim_VGP_S*pInst->xitsb;
temp2_exc_VS_BP=((qim_VS_BP*pInst->xitsb)+(pInst->qim*xitsb_VS_BP));
#endif
temp2_exc=(pInst->qim*pInst->xitsb);
EXIT_IF_ISNAN((pInst->qim*pInst->xitsb))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
wsat_exc_VD_S=(100.0*((temp2_exc_VD_S*(100.0+temp2_exc)-temp2_exc*temp2_exc_VD_S)/(100.0+temp2_exc)/(100.0+temp2_exc)));
wsat_exc_VGP_S=(100.0*((temp2_exc_VGP_S*(100.0+temp2_exc)-temp2_exc*temp2_exc_VGP_S)/(100.0+temp2_exc)/(100.0+temp2_exc)));
wsat_exc_VS_BP=(100.0*((temp2_exc_VS_BP*(100.0+temp2_exc)-temp2_exc*temp2_exc_VS_BP)/(100.0+temp2_exc)/(100.0+temp2_exc)));
#endif
wsat_exc=(100.0*(temp2_exc/(100.0+temp2_exc)));
EXIT_IF_ISNAN((100.0*(temp2_exc/(100.0+temp2_exc))))
if
((pInst->THESATG_i<0))
{
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
temp_exc_VD_S=(-1*(-(pInst->THESATG_i*wsat_exc_VD_S))/(1-(pInst->THESATG_i*wsat_exc))/(1-(pInst->THESATG_i*wsat_exc)));
temp_exc_VGP_S=(-1*(-(pInst->THESATG_i*wsat_exc_VGP_S))/(1-(pInst->THESATG_i*wsat_exc))/(1-(pInst->THESATG_i*wsat_exc)));
temp_exc_VS_BP=(-1*(-(pInst->THESATG_i*wsat_exc_VS_BP))/(1-(pInst->THESATG_i*wsat_exc))/(1-(pInst->THESATG_i*wsat_exc)));
#endif
temp_exc=(1/(1-(pInst->THESATG_i*wsat_exc)));
EXIT_IF_ISNAN((1/(1-(pInst->THESATG_i*wsat_exc))))
}
else
{
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
temp_exc_VD_S=(pInst->THESATG_i*wsat_exc_VD_S);
temp_exc_VGP_S=(pInst->THESATG_i*wsat_exc_VGP_S);
temp_exc_VS_BP=(pInst->THESATG_i*wsat_exc_VS_BP);
#endif
temp_exc=(1+(pInst->THESATG_i*wsat_exc));
EXIT_IF_ISNAN((1+(pInst->THESATG_i*wsat_exc)))
}
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
thesat1_exc_VD_S=(pInst->THESAT_i*((temp_exc_VD_S*pInst->Gmob-temp_exc*Gmob_VD_S)/pInst->Gmob/pInst->Gmob));
thesat1_exc_VGP_S=(pInst->THESAT_i*((temp_exc_VGP_S*pInst->Gmob-temp_exc*Gmob_VGP_S)/pInst->Gmob/pInst->Gmob));
thesat1_exc_VS_BP=(pInst->THESAT_i*((temp_exc_VS_BP*pInst->Gmob-temp_exc*Gmob_VS_BP)/pInst->Gmob/pInst->Gmob));
#endif
thesat1_exc=(pInst->THESAT_i*(temp_exc/pInst->Gmob));
EXIT_IF_ISNAN((pInst->THESAT_i*(temp_exc/pInst->Gmob)))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
zsat_exc_VD_S=((((((thesat1_exc_VD_S*thesat1_exc)+(thesat1_exc*thesat1_exc_VD_S))*pInst->dps)+((thesat1_exc*thesat1_exc)*dps_VD_S))*pInst->dps)+(((thesat1_exc*thesat1_exc)*pInst->dps)*dps_VD_S));
zsat_exc_VGP_S=((((((thesat1_exc_VGP_S*thesat1_exc)+(thesat1_exc*thesat1_exc_VGP_S))*pInst->dps)+((thesat1_exc*thesat1_exc)*dps_VGP_S))*pInst->dps)+(((thesat1_exc*thesat1_exc)*pInst->dps)*dps_VGP_S));
zsat_exc_VS_BP=((((((thesat1_exc_VS_BP*thesat1_exc)+(thesat1_exc*thesat1_exc_VS_BP))*pInst->dps)+((thesat1_exc*thesat1_exc)*dps_VS_BP))*pInst->dps)+(((thesat1_exc*thesat1_exc)*pInst->dps)*dps_VS_BP));
#endif
zsat_exc=(((thesat1_exc*thesat1_exc)*pInst->dps)*pInst->dps);
EXIT_IF_ISNAN((((thesat1_exc*thesat1_exc)*pInst->dps)*pInst->dps))
if
((pModel->CHNL_TYPE==(-1)))
{
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
zsat_exc_VD_S=((zsat_exc_VD_S*(1.0+(thesat1_exc*pInst->dps))-zsat_exc*((thesat1_exc_VD_S*pInst->dps)+(thesat1_exc*dps_VD_S)))/(1.0+(thesat1_exc*pInst->dps))/(1.0+(thesat1_exc*pInst->dps)));
zsat_exc_VGP_S=((zsat_exc_VGP_S*(1.0+(thesat1_exc*pInst->dps))-zsat_exc*((thesat1_exc_VGP_S*pInst->dps)+(thesat1_exc*dps_VGP_S)))/(1.0+(thesat1_exc*pInst->dps))/(1.0+(thesat1_exc*pInst->dps)));
zsat_exc_VS_BP=((zsat_exc_VS_BP*(1.0+(thesat1_exc*pInst->dps))-zsat_exc*((thesat1_exc_VS_BP*pInst->dps)+(thesat1_exc*dps_VS_BP)))/(1.0+(thesat1_exc*pInst->dps))/(1.0+(thesat1_exc*pInst->dps)));
#endif
zsat_exc=(zsat_exc/(1.0+(thesat1_exc*pInst->dps)));
EXIT_IF_ISNAN((zsat_exc/(1.0+(thesat1_exc*pInst->dps))))
}
{
double m00_sqrt(d00_sqrt0,(1.0+(2.0*zsat_exc)))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(2.0*zsat_exc)))
#endif
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
Gvsat_exc_VD_S=(0.5*((Gmob_VD_S*(1.0+d00_sqrt0))+(pInst->Gmob*(2.0*zsat_exc_VD_S)*d10_sqrt0)));
Gvsat_exc_VGP_S=(0.5*((Gmob_VGP_S*(1.0+d00_sqrt0))+(pInst->Gmob*(2.0*zsat_exc_VGP_S)*d10_sqrt0)));
Gvsat_exc_VS_BP=(0.5*((Gmob_VS_BP*(1.0+d00_sqrt0))+(pInst->Gmob*(2.0*zsat_exc_VS_BP)*d10_sqrt0)));
#endif
Gvsat_exc=(0.5*(pInst->Gmob*(1.0+d00_sqrt0)));
EXIT_IF_ISNAN((0.5*(pInst->Gmob*(1.0+d00_sqrt0))))
}
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
gfac_VD_S=((Gmob_VD_S*(Gvsat_exc*lc)-pInst->Gmob*((Gvsat_exc_VD_S*lc)+(Gvsat_exc*lc_VD_S)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
gfac_VGP_S=((Gmob_VGP_S*(Gvsat_exc*lc)-pInst->Gmob*((Gvsat_exc_VGP_S*lc)+(Gvsat_exc*lc_VGP_S)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
gfac_VS_BP=((Gmob_VS_BP*(Gvsat_exc*lc)-pInst->Gmob*((Gvsat_exc_VS_BP*lc)+(Gvsat_exc*lc_VS_BP)))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
#endif
gfac=(pInst->Gmob/(Gvsat_exc*lc));
EXIT_IF_ISNAN((pInst->Gmob/(Gvsat_exc*lc)))
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
Sidexc_VGP_S=(((((((pInst->fac_exc*Ids_VGP_S)*pInst->Vdse)+((pInst->fac_exc*pInst->Ids)*Vdse_VGP_S))*gfac)+(((pInst->fac_exc*pInst->Ids)*pInst->Vdse)*gfac_VGP_S))*gfac)+((((pInst->fac_exc*pInst->Ids)*pInst->Vdse)*gfac)*gfac_VGP_S));
Sidexc_VD_S=(((((((pInst->fac_exc*Ids_VD_S)*pInst->Vdse)+((pInst->fac_exc*pInst->Ids)*Vdse_VD_S))*gfac)+(((pInst->fac_exc*pInst->Ids)*pInst->Vdse)*gfac_VD_S))*gfac)+((((pInst->fac_exc*pInst->Ids)*pInst->Vdse)*gfac)*gfac_VD_S));
Sidexc_VS_BP=(((((((pInst->fac_exc*Ids_VS_BP)*pInst->Vdse)+((pInst->fac_exc*pInst->Ids)*Vdse_VS_BP))*gfac)+(((pInst->fac_exc*pInst->Ids)*pInst->Vdse)*gfac_VS_BP))*gfac)+((((pInst->fac_exc*pInst->Ids)*pInst->Vdse)*gfac)*gfac_VS_BP));
#endif
Sidexc=((((pInst->fac_exc*pInst->Ids)*pInst->Vdse)*gfac)*gfac);
EXIT_IF_ISNAN(((((pInst->fac_exc*pInst->Ids)*pInst->Vdse)*gfac)*gfac))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mid_VD_S=(mid_VD_S+(Sidexc_VD_S/pModel->nt0));
mid_VGP_S=(mid_VGP_S+(Sidexc_VGP_S/pModel->nt0));
mid_VS_BP=(mid_VS_BP+(Sidexc_VS_BP/pModel->nt0));
#endif
mid=(mid+(Sidexc/pModel->nt0));
EXIT_IF_ISNAN((mid+(Sidexc/pModel->nt0)))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
mig_VD_S=(mig_VD_S+((((Sidexc_VD_S*(1+(12*t2)))+(Sidexc*(12*t2_VD_S)))*(((12*g_ideal)*g_ideal)*pModel->nt0)-(Sidexc*(1+(12*t2)))*(((12*g_ideal_VD_S)*g_ideal)+((12*g_ideal)*g_ideal_VD_S))*pModel->nt0)/(((12*g_ideal)*g_ideal)*pModel->nt0)/(((12*g_ideal)*g_ideal)*pModel->nt0)));
mig_VGP_S=(mig_VGP_S+((((Sidexc_VGP_S*(1+(12*t2)))+(Sidexc*(12*t2_VGP_S)))*(((12*g_ideal)*g_ideal)*pModel->nt0)-(Sidexc*(1+(12*t2)))*(((12*g_ideal_VGP_S)*g_ideal)+((12*g_ideal)*g_ideal_VGP_S))*pModel->nt0)/(((12*g_ideal)*g_ideal)*pModel->nt0)/(((12*g_ideal)*g_ideal)*pModel->nt0)));
mig_VS_BP=(mig_VS_BP+((((Sidexc_VS_BP*(1+(12*t2)))+(Sidexc*(12*t2_VS_BP)))*(((12*g_ideal)*g_ideal)*pModel->nt0)-(Sidexc*(1+(12*t2)))*(((12*g_ideal_VS_BP)*g_ideal)+((12*g_ideal)*g_ideal_VS_BP))*pModel->nt0)/(((12*g_ideal)*g_ideal)*pModel->nt0)/(((12*g_ideal)*g_ideal)*pModel->nt0)));
#endif
pInst->mig=(pInst->mig+((Sidexc*(1+(12*t2)))/(((12*g_ideal)*g_ideal)*pModel->nt0)));
EXIT_IF_ISNAN((pInst->mig+((Sidexc*(1+(12*t2)))/(((12*g_ideal)*g_ideal)*pModel->nt0))))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
migid_VD_S=(migid_VD_S-((((((Sidexc_VD_S*sqt2)+(Sidexc*sqt2_VD_S))*(1+r))+((Sidexc*sqt2)*r_VD_S))*(g_ideal*pModel->nt0)-((Sidexc*sqt2)*(1+r))*g_ideal_VD_S*pModel->nt0)/(g_ideal*pModel->nt0)/(g_ideal*pModel->nt0)));
migid_VGP_S=(migid_VGP_S-((((((Sidexc_VGP_S*sqt2)+(Sidexc*sqt2_VGP_S))*(1+r))+((Sidexc*sqt2)*r_VGP_S))*(g_ideal*pModel->nt0)-((Sidexc*sqt2)*(1+r))*g_ideal_VGP_S*pModel->nt0)/(g_ideal*pModel->nt0)/(g_ideal*pModel->nt0)));
migid_VS_BP=(migid_VS_BP-((((((Sidexc_VS_BP*sqt2)+(Sidexc*sqt2_VS_BP))*(1+r))+((Sidexc*sqt2)*r_VS_BP))*(g_ideal*pModel->nt0)-((Sidexc*sqt2)*(1+r))*g_ideal_VS_BP*pModel->nt0)/(g_ideal*pModel->nt0)/(g_ideal*pModel->nt0)));
#endif
migid=(migid-(((Sidexc*sqt2)*(1+r))/(g_ideal*pModel->nt0)));
EXIT_IF_ISNAN((migid-(((Sidexc*sqt2)*(1+r))/(g_ideal*pModel->nt0))))
}
{
double m00_sqrt(d00_sqrt0,(pInst->nt*mid))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->nt*mid))
#endif
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
sqid_VD_S=(pInst->nt*mid_VD_S)*d10_sqrt0;
sqid_VGP_S=(pInst->nt*mid_VGP_S)*d10_sqrt0;
sqid_VS_BP=(pInst->nt*mid_VS_BP)*d10_sqrt0;
#endif
pInst->sqid=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_sqrt(d00_sqrt0,(pInst->nt/pInst->mig))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(pInst->nt/pInst->mig))
#endif
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
sqig_VD_S=(-pInst->nt*mig_VD_S/pInst->mig/pInst->mig)*d10_sqrt0;
sqig_VGP_S=(-pInst->nt*mig_VGP_S/pInst->mig/pInst->mig)*d10_sqrt0;
sqig_VS_BP=(-pInst->nt*mig_VS_BP/pInst->mig/pInst->mig)*d10_sqrt0;
#endif
sqig=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((pInst->sqid==0))
{
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
c_igid_VD_S=0.0;
c_igid_VGP_S=0.0;
c_igid_VS_BP=0.0;
#endif
pInst->c_igid=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
c_igid_VD_S=((((migid_VD_S*sqig)+(migid*sqig_VD_S))*pInst->sqid-(migid*sqig)*sqid_VD_S)/pInst->sqid/pInst->sqid);
c_igid_VGP_S=((((migid_VGP_S*sqig)+(migid*sqig_VGP_S))*pInst->sqid-(migid*sqig)*sqid_VGP_S)/pInst->sqid/pInst->sqid);
c_igid_VS_BP=((((migid_VS_BP*sqig)+(migid*sqig_VS_BP))*pInst->sqid-(migid*sqig)*sqid_VS_BP)/pInst->sqid/pInst->sqid);
#endif
pInst->c_igid=((migid*sqig)/pInst->sqid);
EXIT_IF_ISNAN(((migid*sqig)/pInst->sqid))
}
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
c_igid_VD_S=((pInst->c_igid>0.0)?((pInst->c_igid<1.0)?c_igid_VD_S:0.0):0.0);
c_igid_VGP_S=((pInst->c_igid>0.0)?((pInst->c_igid<1.0)?c_igid_VGP_S:0.0):0.0);
c_igid_VS_BP=((pInst->c_igid>0.0)?((pInst->c_igid<1.0)?c_igid_VS_BP:0.0):0.0);
#endif
pInst->c_igid=((pInst->c_igid>0.0)?((pInst->c_igid<1.0)?pInst->c_igid:1.0):0.0);
EXIT_IF_ISNAN(((pInst->c_igid>0.0)?((pInst->c_igid<1.0)?pInst->c_igid:1.0):0.0))
}
{
double m00_fabs(d00_fabs0,pInst->Igcs)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Igcs)
#endif
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
shot_igcsx_VGP_S=((2.0*1.6021918E-19)*Igcs_VGP_S*d10_fabs0);
shot_igcsx_VD_S=((2.0*1.6021918E-19)*Igcs_VD_S*d10_fabs0);
shot_igcsx_VS_BP=((2.0*1.6021918E-19)*Igcs_VS_BP*d10_fabs0);
#endif
pInst->shot_igcsx=((2.0*1.6021918E-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918E-19)*d00_fabs0))
}
{
double m00_fabs(d00_fabs0,pInst->Igcd)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Igcd)
#endif
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
shot_igcdx_VGP_S=((2.0*1.6021918E-19)*Igcd_VGP_S*d10_fabs0);
shot_igcdx_VD_S=((2.0*1.6021918E-19)*Igcd_VD_S*d10_fabs0);
shot_igcdx_VS_BP=((2.0*1.6021918E-19)*Igcd_VS_BP*d10_fabs0);
#endif
pInst->shot_igcdx=((2.0*1.6021918E-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918E-19)*d00_fabs0))
}
{
double m00_fabs(d00_fabs0,pInst->Igsov)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Igsov)
#endif
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
shot_igsov_VGP_S=((2.0*1.6021918E-19)*Igsov_VGP_S*d10_fabs0);
shot_igsov_VD_S=((2.0*1.6021918E-19)*Igsov_VD_S*d10_fabs0);
shot_igsov_VS_BP=((2.0*1.6021918E-19)*Igsov_VS_BP*d10_fabs0);
#endif
pInst->shot_igsov=((2.0*1.6021918E-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918E-19)*d00_fabs0))
}
{
double m00_fabs(d00_fabs0,pInst->Igdov)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Igdov)
#endif
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
shot_igdov_VGP_S=((2.0*1.6021918E-19)*Igdov_VGP_S*d10_fabs0);
shot_igdov_VD_S=((2.0*1.6021918E-19)*Igdov_VD_S*d10_fabs0);
shot_igdov_VS_BP=((2.0*1.6021918E-19)*Igdov_VS_BP*d10_fabs0);
#endif
pInst->shot_igdov=((2.0*1.6021918E-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918E-19)*d00_fabs0))
}
{
double m00_fabs(d00_fabs0,pInst->Iimpact)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Iimpact)
#endif
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
shot_iavl_VD_S=((2.0*1.6021918E-19)*((mavl_VD_S*d00_fabs0)+((pInst->mavl+1)*Iimpact_VD_S*d10_fabs0)));
shot_iavl_VGP_S=((2.0*1.6021918E-19)*((mavl_VGP_S*d00_fabs0)+((pInst->mavl+1)*Iimpact_VGP_S*d10_fabs0)));
shot_iavl_VS_BP=((2.0*1.6021918E-19)*((mavl_VS_BP*d00_fabs0)+((pInst->mavl+1)*Iimpact_VS_BP*d10_fabs0)));
#endif
pInst->shot_iavl=((2.0*1.6021918E-19)*((pInst->mavl+1)*d00_fabs0));
EXIT_IF_ISNAN(((2.0*1.6021918E-19)*((pInst->mavl+1)*d00_fabs0)))
}
{
double m00_fabs(d00_fabs0,pInst->ijun_s)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->ijun_s)
#endif
#if defined(_DERIVATE) /* probe=V(D,BD)V(S,BS) ddxprobe= */
jnoisex_s_VD_BD=((2.0*1.6021918E-19)*ijun_s_VD_BD*d10_fabs0);
jnoisex_s_VS_BS=((2.0*1.6021918E-19)*ijun_s_VS_BS*d10_fabs0);
#endif
pInst->jnoisex_s=((2.0*1.6021918E-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918E-19)*d00_fabs0))
}
{
double m00_fabs(d00_fabs0,pInst->ijun_d)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->ijun_d)
#endif
#if defined(_DERIVATE) /* probe=V(D,BD)V(S,BS) ddxprobe= */
jnoisex_d_VD_BD=((2.0*1.6021918E-19)*ijun_d_VD_BD*d10_fabs0);
jnoisex_d_VS_BS=((2.0*1.6021918E-19)*ijun_d_VS_BS*d10_fabs0);
#endif
pInst->jnoisex_d=((2.0*1.6021918E-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918E-19)*d00_fabs0))
}
if
((pInst->sigVds>0))
{
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
shot_igs_VGP_S=(shot_igcsx_VGP_S+shot_igsov_VGP_S);
shot_igs_VD_S=(shot_igcsx_VD_S+shot_igsov_VD_S);
shot_igs_VS_BP=(shot_igcsx_VS_BP+shot_igsov_VS_BP);
#endif
shot_igs=(pInst->shot_igcsx+pInst->shot_igsov);
EXIT_IF_ISNAN((pInst->shot_igcsx+pInst->shot_igsov))
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
shot_igd_VGP_S=(shot_igcdx_VGP_S+shot_igdov_VGP_S);
shot_igd_VD_S=(shot_igcdx_VD_S+shot_igdov_VD_S);
shot_igd_VS_BP=(shot_igcdx_VS_BP+shot_igdov_VS_BP);
#endif
shot_igd=(pInst->shot_igcdx+pInst->shot_igdov);
EXIT_IF_ISNAN((pInst->shot_igcdx+pInst->shot_igdov))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP)V(D,BD)V(S,BS) ddxprobe= */
jnoise_s_VD_S=0.0;
jnoise_s_VGP_S=0.0;
jnoise_s_VS_BP=0.0;
jnoise_s_VD_BD=jnoisex_s_VD_BD;
jnoise_s_VS_BS=jnoisex_s_VS_BS;
#endif
jnoise_s=pInst->jnoisex_s;
EXIT_IF_ISNAN(pInst->jnoisex_s)
#if defined(_DERIVATE) /* probe=V(D,BD)V(S,BS)V(D,S)V(GP,S)V(S,BP) ddxprobe= */
jnoise_d_VD_BD=jnoisex_d_VD_BD;
jnoise_d_VS_BS=jnoisex_d_VS_BS;
jnoise_d_VD_S=shot_iavl_VD_S;
jnoise_d_VGP_S=shot_iavl_VGP_S;
jnoise_d_VS_BP=shot_iavl_VS_BP;
#endif
jnoise_d=(pInst->jnoisex_d+pInst->shot_iavl);
EXIT_IF_ISNAN((pInst->jnoisex_d+pInst->shot_iavl))
}
else
{
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
shot_igs_VGP_S=(shot_igcdx_VGP_S+shot_igsov_VGP_S);
shot_igs_VD_S=(shot_igcdx_VD_S+shot_igsov_VD_S);
shot_igs_VS_BP=(shot_igcdx_VS_BP+shot_igsov_VS_BP);
#endif
shot_igs=(pInst->shot_igcdx+pInst->shot_igsov);
EXIT_IF_ISNAN((pInst->shot_igcdx+pInst->shot_igsov))
#if defined(_DERIVATE) /* probe=V(GP,S)V(D,S)V(S,BP) ddxprobe= */
shot_igd_VGP_S=(shot_igcsx_VGP_S+shot_igdov_VGP_S);
shot_igd_VD_S=(shot_igcsx_VD_S+shot_igdov_VD_S);
shot_igd_VS_BP=(shot_igcsx_VS_BP+shot_igdov_VS_BP);
#endif
shot_igd=(pInst->shot_igcsx+pInst->shot_igdov);
EXIT_IF_ISNAN((pInst->shot_igcsx+pInst->shot_igdov))
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP)V(D,BD)V(S,BS) ddxprobe= */
jnoise_s_VD_S=shot_iavl_VD_S;
jnoise_s_VGP_S=shot_iavl_VGP_S;
jnoise_s_VS_BP=shot_iavl_VS_BP;
jnoise_s_VD_BD=jnoisex_s_VD_BD;
jnoise_s_VS_BS=jnoisex_s_VS_BS;
#endif
jnoise_s=(pInst->jnoisex_s+pInst->shot_iavl);
EXIT_IF_ISNAN((pInst->jnoisex_s+pInst->shot_iavl))
#if defined(_DERIVATE) /* probe=V(D,BD)V(S,BS)V(D,S)V(GP,S)V(S,BP) ddxprobe= */
jnoise_d_VD_BD=jnoisex_d_VD_BD;
jnoise_d_VS_BS=jnoisex_d_VS_BS;
jnoise_d_VD_S=0.0;
jnoise_d_VGP_S=0.0;
jnoise_d_VS_BP=0.0;
#endif
jnoise_d=pInst->jnoisex_d;
EXIT_IF_ISNAN(pInst->jnoisex_d)
}
#if defined(_DERIVATE) /* probe=V(D,S)V(GP,S)V(S,BP) ddxprobe= */
sf_VD_S=(((1e6*CGeff_VD_S)*pInst->mig)+((1e6*pInst->CGeff)*mig_VD_S));
sf_VGP_S=(((1e6*CGeff_VGP_S)*pInst->mig)+((1e6*pInst->CGeff)*mig_VGP_S));
sf_VS_BP=(((1e6*CGeff_VS_BP)*pInst->mig)+((1e6*pInst->CGeff)*mig_VS_BP));
#endif
sf=((1e6*pInst->CGeff)*pInst->mig);
EXIT_IF_ISNAN(((1e6*pInst->CGeff)*pInst->mig))
  _load_static_residual1(NOI2,NP(NOI2))
  _load_static_jacobian1(NOI2,NOI2,1.0)
pInst->wnoise5=(((sqig*sqig)*sf)*sf);
  _load_static_residual1(NOI,((-NP(NOI2))/sf))
  _load_static_jacobian2p(NOI,S,BP,(-(-NP(NOI2))*sf_VS_BP/sf/sf))
  _load_static_jacobian2p(NOI,GP,S,(-(-NP(NOI2))*sf_VGP_S/sf/sf))
  _load_static_jacobian2p(NOI,D,S,(-(-NP(NOI2))*sf_VD_S/sf/sf))
  _load_static_jacobian1(NOI,NOI2,((-1.0)/sf))
  _load_static_residual1(NOI,(NP(NOI)/pInst->mig))
  _load_static_jacobian2p(NOI,S,BP,(-NP(NOI)*mig_VS_BP/pInst->mig/pInst->mig))
  _load_static_jacobian2p(NOI,GP,S,(-NP(NOI)*mig_VGP_S/pInst->mig/pInst->mig))
  _load_static_jacobian2p(NOI,D,S,(-NP(NOI)*mig_VD_S/pInst->mig/pInst->mig))
  _load_static_jacobian1(NOI,NOI,(1/pInst->mig))
  _load_dynamic_residual1(NOI,_DDT((pInst->CGeff*NP(NOI))))
  _load_dynamic_jacobian1(NOI,NOI,(pInst->CGeff))
  _load_dynamic_jacobian2p(NOI,S,BP,CGeff_VS_BP*NP(NOI))
  _load_dynamic_jacobian2p(NOI,GP,S,CGeff_VGP_S*NP(NOI))
  _load_dynamic_jacobian2p(NOI,D,S,CGeff_VD_S*NP(NOI))
pInst->fpnoise0=(pInst->MULT_i*pInst->Sfl);
pInst->fenoise0=pInst->EF_i;
pInst->wnoise4=(((pInst->MULT_i*pInst->sqid)*pInst->sqid)*(1.0-(pInst->c_igid*pInst->c_igid)));
pInst->wnoise3=(pInst->MULT_i*shot_igs);
pInst->wnoise2=(pInst->MULT_i*shot_igd);
pInst->wnoise1=(pInst->MULT_i*jnoise_s);
pInst->wnoise0=(pInst->MULT_i*jnoise_d);
}
{
#if defined(_DYNAMIC)
id_op=((pInst->Ids+pInst->Iimpact)-pInst->Igcd);
EXIT_IF_ISNAN(((pInst->Ids+pInst->Iimpact)-pInst->Igcd))
#endif
#if defined(_DYNAMIC)
is=((-pInst->Ids)-pInst->Igcs);
EXIT_IF_ISNAN(((-pInst->Ids)-pInst->Igcs))
#endif
#if defined(_DYNAMIC)
ig=((((pInst->Igcs+pInst->Igcd)+pInst->Igsov)+pInst->Igdov)+Igb);
EXIT_IF_ISNAN(((((pInst->Igcs+pInst->Igcd)+pInst->Igsov)+pInst->Igdov)+Igb))
#endif
#if defined(_DYNAMIC)
ib=((((-pInst->Iimpact)-Igb)-Igidl)-Igisl);
EXIT_IF_ISNAN(((((-pInst->Iimpact)-Igb)-Igidl)-Igisl))
#endif
#if defined(_DYNAMIC)
sig1k=(((2*3.1415926535897931)*1000)*pInst->CGeff);
EXIT_IF_ISNAN((((2*3.1415926535897931)*1000)*pInst->CGeff))
#endif
#if defined(_DYNAMIC)
sig1k=((sig1k*sig1k)*pInst->mig);
EXIT_IF_ISNAN(((sig1k*sig1k)*pInst->mig))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sdint]=pInst->sigVds;
EXIT_IF_ISNAN(pInst->sigVds)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ctype]=pModel->CHNL_TYPE;
EXIT_IF_ISNAN(pModel->CHNL_TYPE)
#endif
#ifdef _DYNAMIC
if
((pInst->sigVds<0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ise]=(pInst->MULT_i*(((is-pInst->Igdov)+Igidl)-pInst->ijun_d));
EXIT_IF_ISNAN((pInst->MULT_i*(((is-pInst->Igdov)+Igidl)-pInst->ijun_d)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ige]=(pInst->MULT_i*ig);
EXIT_IF_ISNAN((pInst->MULT_i*ig))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ide]=(pInst->MULT_i*(((id_op-pInst->Igsov)+Igisl)-pInst->ijun_s));
EXIT_IF_ISNAN((pInst->MULT_i*(((id_op-pInst->Igsov)+Igisl)-pInst->ijun_s)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ibe]=(pInst->MULT_i*((ib+pInst->ijun_s)+pInst->ijun_d));
EXIT_IF_ISNAN((pInst->MULT_i*((ib+pInst->ijun_s)+pInst->ijun_d)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ids]=(pInst->MULT_i*pInst->Ids);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Ids))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idb]=(pInst->MULT_i*((pInst->Iimpact+Igisl)-pInst->ijun_s));
EXIT_IF_ISNAN((pInst->MULT_i*((pInst->Iimpact+Igisl)-pInst->ijun_s)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_isb]=(pInst->MULT_i*(Igidl-pInst->ijun_d));
EXIT_IF_ISNAN((pInst->MULT_i*(Igidl-pInst->ijun_d)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igs]=(pInst->MULT_i*(pInst->Igcs+pInst->Igdov));
EXIT_IF_ISNAN((pInst->MULT_i*(pInst->Igcs+pInst->Igdov)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igd]=(pInst->MULT_i*(pInst->Igcd+pInst->Igsov));
EXIT_IF_ISNAN((pInst->MULT_i*(pInst->Igcd+pInst->Igsov)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igb]=(pInst->MULT_i*Igb);
EXIT_IF_ISNAN((pInst->MULT_i*Igb))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igcs]=(pInst->MULT_i*pInst->Igcs);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Igcs))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igcd]=(pInst->MULT_i*pInst->Igcd);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Igcd))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_iavl]=(pInst->MULT_i*pInst->Iimpact);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Iimpact))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igisl]=(pInst->MULT_i*Igidl);
EXIT_IF_ISNAN((pInst->MULT_i*Igidl))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igidl]=(pInst->MULT_i*Igisl);
EXIT_IF_ISNAN((pInst->MULT_i*Igisl))
#endif
#ifdef _DYNAMIC
if
((pModel->SWJUNEXP_i==1))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijsbot]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijsgat]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijssti]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdbot]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdgat]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdsti]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsbot]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatssti]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsgat]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsbotd]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsstid]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsgatd]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijsbot]=((pInst->MULT_i*pInst->ABDRAIN_i)*ijunbot_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABDRAIN_i)*ijunbot_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijsgat]=((pInst->MULT_i*pInst->LGDRAIN_i)*ijungat_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGDRAIN_i)*ijungat_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijssti]=((pInst->MULT_i*pInst->LSDRAIN_i)*ijunsti_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSDRAIN_i)*ijunsti_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdbot]=((pInst->MULT_i*pInst->ABSOURCE_i)*ijunbot_s);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABSOURCE_i)*ijunbot_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdgat]=((pInst->MULT_i*pInst->LGSOURCE_i)*ijungat_s);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGSOURCE_i)*ijungat_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdsti]=((pInst->MULT_i*pInst->LSSOURCE_i)*ijunsti_s);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSSOURCE_i)*ijunsti_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsbot]=((pInst->MULT_i*pInst->ABSOURCE_i)*pModel->idsatbot);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABSOURCE_i)*pModel->idsatbot))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatssti]=((pInst->MULT_i*pInst->LSSOURCE_i)*pModel->idsatsti);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSSOURCE_i)*pModel->idsatsti))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsgat]=((pInst->MULT_i*pInst->LGSOURCE_i)*pModel->idsatgat);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGSOURCE_i)*pModel->idsatgat))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsbotd]=((pInst->MULT_i*pInst->ABDRAIN_i)*pModel->idsatbot_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABDRAIN_i)*pModel->idsatbot_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsstid]=((pInst->MULT_i*pInst->LSDRAIN_i)*pModel->idsatsti_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSDRAIN_i)*pModel->idsatsti_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsgatd]=((pInst->MULT_i*pInst->LGDRAIN_i)*pModel->idsatgat_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGDRAIN_i)*pModel->idsatgat_d))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijs]=(pInst->MULT_i*pInst->ijun_d);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->ijun_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijd]=(pInst->MULT_i*pInst->ijun_s);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->ijun_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vds]=Vds;
EXIT_IF_ISNAN(Vds)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgs]=Vgs;
EXIT_IF_ISNAN(Vgs)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vsb]=Vsb;
EXIT_IF_ISNAN(Vsb)
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(pInst->phit1*facvsb0))
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vto]=((pInst->VFB_i+(P_D*facvsb0))+(Gf*d00_sqrt0));
EXIT_IF_ISNAN(((pInst->VFB_i+(P_D*facvsb0))+(Gf*d00_sqrt0)))
}
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vts]=vts_i;
EXIT_IF_ISNAN(vts_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vth]=vth_i;
EXIT_IF_ISNAN(vth_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgt]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgs]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vth]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgs]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vth]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vdss]=Vdsat;
EXIT_IF_ISNAN(Vdsat)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vsat]=(Vds-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vdss]);
EXIT_IF_ISNAN((Vds-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vdss]))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=(-ijun_s_VD_BD);
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-ijun_s_VD_BD_VD_BD);
  temp_VD_BD_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-ijun_s_VD_BD_VS_BS);
  temp_VD_BD_VGP_S=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VD_BD_VD_S=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VD_BD_VS_BP=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
#endif
temp_VS_BS=(-ijun_s_VS_BS);
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-ijun_s_VS_BS_VD_BD);
  temp_VS_BS_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-ijun_s_VS_BS_VS_BS);
  temp_VS_BS_VGP_S=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VS_BS_VD_S=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VS_BS_VS_BP=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
#endif
temp_VGP_S=((((Ids_VGP_S+Iimpact_VGP_S)+Igisl_VGP_S)-Igcd_VGP_S)-Igsov_VGP_S);
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VGP_S_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VGP_S_VGP_S=(+(+(+(+(+Ids_VGP_S_VGP_S+Iimpact_VGP_S_VGP_S)+Igisl_VGP_S_VGP_S)-Igcd_VGP_S_VGP_S)-Igsov_VGP_S_VGP_S)-0.0);
  temp_VGP_S_VD_S=(+(+(+(+(+Ids_VGP_S_VD_S+Iimpact_VGP_S_VD_S)+Igisl_VGP_S_VD_S)-Igcd_VGP_S_VD_S)-Igsov_VGP_S_VD_S)-0.0);
  temp_VGP_S_VS_BP=(+(+(+(+(+Ids_VGP_S_VS_BP+Iimpact_VGP_S_VS_BP)+Igisl_VGP_S_VS_BP)-Igcd_VGP_S_VS_BP)-Igsov_VGP_S_VS_BP)-0.0);
#endif
temp_VD_S=((((Ids_VD_S+Iimpact_VD_S)+Igisl_VD_S)-Igcd_VD_S)-Igsov_VD_S);
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VD_S_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VD_S_VGP_S=(+(+(+(+(+Ids_VD_S_VGP_S+Iimpact_VD_S_VGP_S)+Igisl_VD_S_VGP_S)-Igcd_VD_S_VGP_S)-Igsov_VD_S_VGP_S)-0.0);
  temp_VD_S_VD_S=(+(+(+(+(+Ids_VD_S_VD_S+Iimpact_VD_S_VD_S)+Igisl_VD_S_VD_S)-Igcd_VD_S_VD_S)-Igsov_VD_S_VD_S)-0.0);
  temp_VD_S_VS_BP=(+(+(+(+(+Ids_VD_S_VS_BP+Iimpact_VD_S_VS_BP)+Igisl_VD_S_VS_BP)-Igcd_VD_S_VS_BP)-Igsov_VD_S_VS_BP)-0.0);
#endif
temp_VS_BP=((((Ids_VS_BP+Iimpact_VS_BP)+Igisl_VS_BP)-Igcd_VS_BP)-Igsov_VS_BP);
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VS_BP_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VS_BP_VGP_S=(+(+(+(+(+Ids_VS_BP_VGP_S+Iimpact_VS_BP_VGP_S)+Igisl_VS_BP_VGP_S)-Igcd_VS_BP_VGP_S)-Igsov_VS_BP_VGP_S)-0.0);
  temp_VS_BP_VD_S=(+(+(+(+(+Ids_VS_BP_VD_S+Iimpact_VS_BP_VD_S)+Igisl_VS_BP_VD_S)-Igcd_VS_BP_VD_S)-Igsov_VS_BP_VD_S)-0.0);
  temp_VS_BP_VS_BP=(+(+(+(+(+Ids_VS_BP_VS_BP+Iimpact_VS_BP_VS_BP)+Igisl_VS_BP_VS_BP)-Igcd_VS_BP_VS_BP)-Igsov_VS_BP_VS_BP)-0.0);
#endif
#endif
temp=(((((pInst->Ids+pInst->Iimpact)+Igisl)-pInst->Igcd)-pInst->Igsov)-pInst->ijun_s);
EXIT_IF_ISNAN((((((pInst->Ids+pInst->Iimpact)+Igisl)-pInst->Igcd)-pInst->Igsov)-pInst->ijun_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gmb]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gjs]=(pInst->MULT_i*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((pInst->MULT_i*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gjd]=(pInst->MULT_i*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((pInst->MULT_i*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_css]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csg]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csb]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csd]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_css]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csg])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csb]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_css]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csg])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csb]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgs]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgb]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgd]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgs])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgb]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgs])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgb]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cds]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdg]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdb]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdd]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdg]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cds])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdb]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdg]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cds])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdb]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbs]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbg]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbb]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbd]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbb]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbs])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbg]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbb]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbs])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbg]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgsol]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgdol]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsbot]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->ABDRAIN_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->ABDRAIN_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsgat]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LGDRAIN_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LGDRAIN_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjssti]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LSDRAIN_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LSDRAIN_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjs]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsbot]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsgat])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjssti]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsbot]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsgat])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjssti]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdbot]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->ABSOURCE_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->ABSOURCE_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdgat]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LGSOURCE_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LGSOURCE_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdsti]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LSSOURCE_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LSSOURCE_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjd]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdbot]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdgat])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdsti]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdbot]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdgat])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdsti]))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ise]=(pInst->MULT_i*(((is-pInst->Igsov)+Igisl)-pInst->ijun_s));
EXIT_IF_ISNAN((pInst->MULT_i*(((is-pInst->Igsov)+Igisl)-pInst->ijun_s)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ige]=(pInst->MULT_i*ig);
EXIT_IF_ISNAN((pInst->MULT_i*ig))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ide]=(pInst->MULT_i*(((id_op-pInst->Igdov)+Igidl)-pInst->ijun_d));
EXIT_IF_ISNAN((pInst->MULT_i*(((id_op-pInst->Igdov)+Igidl)-pInst->ijun_d)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ibe]=(pInst->MULT_i*((ib+pInst->ijun_s)+pInst->ijun_d));
EXIT_IF_ISNAN((pInst->MULT_i*((ib+pInst->ijun_s)+pInst->ijun_d)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ids]=(pInst->MULT_i*pInst->Ids);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Ids))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idb]=(pInst->MULT_i*((pInst->Iimpact+Igidl)-pInst->ijun_d));
EXIT_IF_ISNAN((pInst->MULT_i*((pInst->Iimpact+Igidl)-pInst->ijun_d)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_isb]=(pInst->MULT_i*(Igisl-pInst->ijun_s));
EXIT_IF_ISNAN((pInst->MULT_i*(Igisl-pInst->ijun_s)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igs]=(pInst->MULT_i*(pInst->Igcs+pInst->Igsov));
EXIT_IF_ISNAN((pInst->MULT_i*(pInst->Igcs+pInst->Igsov)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igd]=(pInst->MULT_i*(pInst->Igcd+pInst->Igdov));
EXIT_IF_ISNAN((pInst->MULT_i*(pInst->Igcd+pInst->Igdov)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igb]=(pInst->MULT_i*Igb);
EXIT_IF_ISNAN((pInst->MULT_i*Igb))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igcs]=(pInst->MULT_i*pInst->Igcs);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Igcs))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igcd]=(pInst->MULT_i*pInst->Igcd);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Igcd))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_iavl]=(pInst->MULT_i*pInst->Iimpact);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Iimpact))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igisl]=(pInst->MULT_i*Igisl);
EXIT_IF_ISNAN((pInst->MULT_i*Igisl))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_igidl]=(pInst->MULT_i*Igidl);
EXIT_IF_ISNAN((pInst->MULT_i*Igidl))
#endif
#ifdef _DYNAMIC
if
((pModel->SWJUNEXP_i==1))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijsbot]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijsgat]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijssti]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdbot]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdgat]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdsti]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsbot]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatssti]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsgat]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsbotd]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsstid]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsgatd]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijsbot]=((pInst->MULT_i*pInst->ABSOURCE_i)*ijunbot_s);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABSOURCE_i)*ijunbot_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijsgat]=((pInst->MULT_i*pInst->LGSOURCE_i)*ijungat_s);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGSOURCE_i)*ijungat_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijssti]=((pInst->MULT_i*pInst->LSSOURCE_i)*ijunsti_s);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSSOURCE_i)*ijunsti_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdbot]=((pInst->MULT_i*pInst->ABDRAIN_i)*ijunbot_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABDRAIN_i)*ijunbot_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdgat]=((pInst->MULT_i*pInst->LGDRAIN_i)*ijungat_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGDRAIN_i)*ijungat_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijdsti]=((pInst->MULT_i*pInst->LSDRAIN_i)*ijunsti_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSDRAIN_i)*ijunsti_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsbot]=((pInst->MULT_i*pInst->ABSOURCE_i)*pModel->idsatbot);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABSOURCE_i)*pModel->idsatbot))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatssti]=((pInst->MULT_i*pInst->LSSOURCE_i)*pModel->idsatsti);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSSOURCE_i)*pModel->idsatsti))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsgat]=((pInst->MULT_i*pInst->LGSOURCE_i)*pModel->idsatgat);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGSOURCE_i)*pModel->idsatgat))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsbotd]=((pInst->MULT_i*pInst->ABDRAIN_i)*pModel->idsatbot_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABDRAIN_i)*pModel->idsatbot_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsstid]=((pInst->MULT_i*pInst->LSDRAIN_i)*pModel->idsatsti_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSDRAIN_i)*pModel->idsatsti_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_idsatsgatd]=((pInst->MULT_i*pInst->LGDRAIN_i)*pModel->idsatgat_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGDRAIN_i)*pModel->idsatgat_d))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijs]=(pInst->MULT_i*pInst->ijun_s);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->ijun_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ijd]=(pInst->MULT_i*pInst->ijun_d);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->ijun_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vds]=Vds;
EXIT_IF_ISNAN(Vds)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgs]=Vgs;
EXIT_IF_ISNAN(Vgs)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vsb]=Vsb;
EXIT_IF_ISNAN(Vsb)
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(pInst->phit1*facvsb0))
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vto]=((pInst->VFB_i+(P_D*facvsb0))+(Gf*d00_sqrt0));
EXIT_IF_ISNAN(((pInst->VFB_i+(P_D*facvsb0))+(Gf*d00_sqrt0)))
}
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vts]=vts_i;
EXIT_IF_ISNAN(vts_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vth]=vth_i;
EXIT_IF_ISNAN(vth_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgt]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgs]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vth]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgs]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vth]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vdss]=Vdsat;
EXIT_IF_ISNAN(Vdsat)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vsat]=(Vds-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vdss]);
EXIT_IF_ISNAN((Vds-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vdss]))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(D,BD)V(S,BS)V(GP,S)V(D,S)V(S,BP) ddxprobe=V(D,GND)V(S,GND)V(BP,GND)V(GP,GND) */
temp_VD_BD=(-ijun_d_VD_BD);
#if defined(_DERIVATE2)
  temp_VD_BD_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-ijun_d_VD_BD_VD_BD);
  temp_VD_BD_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-ijun_d_VD_BD_VS_BS);
  temp_VD_BD_VGP_S=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VD_BD_VD_S=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VD_BD_VS_BP=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
#endif
temp_VS_BS=(-ijun_d_VS_BS);
#if defined(_DERIVATE2)
  temp_VS_BS_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-ijun_d_VS_BS_VD_BD);
  temp_VS_BS_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-ijun_d_VS_BS_VS_BS);
  temp_VS_BS_VGP_S=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VS_BS_VD_S=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VS_BS_VS_BP=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
#endif
temp_VGP_S=((((Ids_VGP_S+Iimpact_VGP_S)+Igidl_VGP_S)-Igcd_VGP_S)-Igdov_VGP_S);
#if defined(_DERIVATE2)
  temp_VGP_S_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VGP_S_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VGP_S_VGP_S=(+(+(+(+(+Ids_VGP_S_VGP_S+Iimpact_VGP_S_VGP_S)+Igidl_VGP_S_VGP_S)-Igcd_VGP_S_VGP_S)-Igdov_VGP_S_VGP_S)-0.0);
  temp_VGP_S_VD_S=(+(+(+(+(+Ids_VGP_S_VD_S+Iimpact_VGP_S_VD_S)+Igidl_VGP_S_VD_S)-Igcd_VGP_S_VD_S)-Igdov_VGP_S_VD_S)-0.0);
  temp_VGP_S_VS_BP=(+(+(+(+(+Ids_VGP_S_VS_BP+Iimpact_VGP_S_VS_BP)+Igidl_VGP_S_VS_BP)-Igcd_VGP_S_VS_BP)-Igdov_VGP_S_VS_BP)-0.0);
#endif
temp_VD_S=((((Ids_VD_S+Iimpact_VD_S)+Igidl_VD_S)-Igcd_VD_S)-Igdov_VD_S);
#if defined(_DERIVATE2)
  temp_VD_S_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VD_S_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VD_S_VGP_S=(+(+(+(+(+Ids_VD_S_VGP_S+Iimpact_VD_S_VGP_S)+Igidl_VD_S_VGP_S)-Igcd_VD_S_VGP_S)-Igdov_VD_S_VGP_S)-0.0);
  temp_VD_S_VD_S=(+(+(+(+(+Ids_VD_S_VD_S+Iimpact_VD_S_VD_S)+Igidl_VD_S_VD_S)-Igcd_VD_S_VD_S)-Igdov_VD_S_VD_S)-0.0);
  temp_VD_S_VS_BP=(+(+(+(+(+Ids_VD_S_VS_BP+Iimpact_VD_S_VS_BP)+Igidl_VD_S_VS_BP)-Igcd_VD_S_VS_BP)-Igdov_VD_S_VS_BP)-0.0);
#endif
temp_VS_BP=((((Ids_VS_BP+Iimpact_VS_BP)+Igidl_VS_BP)-Igcd_VS_BP)-Igdov_VS_BP);
#if defined(_DERIVATE2)
  temp_VS_BP_VD_BD=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VS_BP_VS_BS=(+(+(+(+(+0.0+0.0)+0.0)-0.0)-0.0)-0.0);
  temp_VS_BP_VGP_S=(+(+(+(+(+Ids_VS_BP_VGP_S+Iimpact_VS_BP_VGP_S)+Igidl_VS_BP_VGP_S)-Igcd_VS_BP_VGP_S)-Igdov_VS_BP_VGP_S)-0.0);
  temp_VS_BP_VD_S=(+(+(+(+(+Ids_VS_BP_VD_S+Iimpact_VS_BP_VD_S)+Igidl_VS_BP_VD_S)-Igcd_VS_BP_VD_S)-Igdov_VS_BP_VD_S)-0.0);
  temp_VS_BP_VS_BP=(+(+(+(+(+Ids_VS_BP_VS_BP+Iimpact_VS_BP_VS_BP)+Igidl_VS_BP_VS_BP)-Igcd_VS_BP_VS_BP)-Igdov_VS_BP_VS_BP)-0.0);
#endif
#endif
temp=(((((pInst->Ids+pInst->Iimpact)+Igidl)-pInst->Igcd)-pInst->Igdov)-pInst->ijun_d);
EXIT_IF_ISNAN((((((pInst->Ids+pInst->Iimpact)+Igidl)-pInst->Igcd)-pInst->Igdov)-pInst->ijun_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gmb]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gjs]=((-pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gjd]=((-pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdd]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdg]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdb]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cds]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdd]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdg])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdb]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdd]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdg])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cdb]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgd]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgb]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgs]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgd])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgb]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgd])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgb]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csd]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csg]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csb]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_css]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csg]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csd])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csb]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csg]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csd])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_csb]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbd]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbg]=(((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-pModel->CHNL_TYPE)*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbb]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbs]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbb]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbd])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbg]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbb]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbd])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cbg]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgsol]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgdol]=((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((pModel->CHNL_TYPE*pInst->MULT_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsbot]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->ABSOURCE_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->ABSOURCE_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsgat]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LGSOURCE_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LGSOURCE_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjssti]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LSSOURCE_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LSSOURCE_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjs]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsbot]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsgat])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjssti]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsbot]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjsgat])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjssti]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdbot]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->ABDRAIN_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->ABDRAIN_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdgat]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LGDRAIN_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LGDRAIN_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdsti]=((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LSDRAIN_i)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((-pInst->MULT_i)*pModel->CHNL_TYPE)*pInst->LSDRAIN_i)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjd]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdbot]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdgat])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdsti]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdbot]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdgat])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjdsti]))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_weff]=pInst->WE;
EXIT_IF_ISNAN(pInst->WE)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_leff]=pInst->LE;
EXIT_IF_ISNAN(pInst->LE)
#endif
#ifdef _DYNAMIC
{
double m00_fabs(d00_fabs0,ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds])
if
((d00_fabs0<1e-18))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_u]=0;
EXIT_IF_ISNAN(0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_rout]=0;
EXIT_IF_ISNAN(0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vearly]=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_u]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_rout]=(1.0/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds]);
EXIT_IF_ISNAN((1.0/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vearly]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ide]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ide]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gds]))
#endif
}
}
#endif /* if(...) */
#ifdef _DYNAMIC
{
double m00_fabs(d00_fabs0,ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgt])
if
((d00_fabs0<1e-12))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_beff]=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_fabs(d00_fabs0,ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ide])
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_beff]=((2*d00_fabs0)/(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgt]*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgt]));
EXIT_IF_ISNAN(((2*d00_fabs0)/(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgt]*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vgt])))
}
#endif
}
}
#endif /* if(...) */
#ifdef _DYNAMIC
{
double m00_fabs(d00_fabs0,((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgsol])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgdol]))
if
((d00_fabs0<1e-30))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_fug]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_fug]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]/((2*3.1415926535897931)*((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgsol])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgdol])));
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]/((2*3.1415926535897931)*((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgg]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgsol])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cgdol]))))
#endif
}
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_rg_op]=(pInst->RG_i/pInst->MULT_i);
EXIT_IF_ISNAN((pInst->RG_i/pInst->MULT_i))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sfl]=(pInst->MULT_i*pInst->Sfl);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->Sfl))
#endif
#ifdef _DYNAMIC
{
double m00_fabs(d00_fabs0,ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm])
if
((d00_fabs0<1e-18))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sqrtsff]=0;
EXIT_IF_ISNAN(0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sqrtsfw]=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((pInst->MULT_i*pInst->Sfl)/1000.0))
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sqrtsff]=(d00_sqrt0/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]);
EXIT_IF_ISNAN((d00_sqrt0/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,pInst->MULT_i)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sqrtsfw]=((d00_sqrt0*pInst->sqid)/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]);
EXIT_IF_ISNAN(((d00_sqrt0*pInst->sqid)/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_gm]))
}
#endif
}
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sid]=((pInst->MULT_i*pInst->sqid)*pInst->sqid);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->sqid)*pInst->sqid))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sig]=(((pInst->MULT_i*pInst->nt)*sig1k)/(1+(sig1k*pInst->mig)));
EXIT_IF_ISNAN((((pInst->MULT_i*pInst->nt)*sig1k)/(1+(sig1k*pInst->mig))))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cigid]=pInst->c_igid;
EXIT_IF_ISNAN(pInst->c_igid)
#endif
#ifdef _DYNAMIC
if
((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sid]==0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_fknee]=0;
EXIT_IF_ISNAN(0)
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_fknee]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sfl]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sid]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sfl]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sid]))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_siavl]=(pInst->MULT_i*pInst->shot_iavl);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->shot_iavl))
#endif
#ifdef _DYNAMIC
if
((pInst->sigVds<0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sigs]=(pInst->MULT_i*(pInst->shot_igcsx+pInst->shot_igdov));
EXIT_IF_ISNAN((pInst->MULT_i*(pInst->shot_igcsx+pInst->shot_igdov)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sigd]=(pInst->MULT_i*(pInst->shot_igcdx+pInst->shot_igsov));
EXIT_IF_ISNAN((pInst->MULT_i*(pInst->shot_igcdx+pInst->shot_igsov)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ssi]=(pInst->MULT_i*pInst->jnoisex_d);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->jnoisex_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sdi]=(pInst->MULT_i*pInst->jnoisex_s);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->jnoisex_s))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sigs]=(pInst->MULT_i*(pInst->shot_igcsx+pInst->shot_igsov));
EXIT_IF_ISNAN((pInst->MULT_i*(pInst->shot_igcsx+pInst->shot_igsov)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sigd]=(pInst->MULT_i*(pInst->shot_igcdx+pInst->shot_igdov));
EXIT_IF_ISNAN((pInst->MULT_i*(pInst->shot_igcdx+pInst->shot_igdov)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ssi]=(pInst->MULT_i*pInst->jnoisex_s);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->jnoisex_s))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_sdi]=(pInst->MULT_i*pInst->jnoisex_d);
EXIT_IF_ISNAN((pInst->MULT_i*pInst->jnoisex_d))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_vfb]=pInst->VFB_i;
EXIT_IF_ISNAN(pInst->VFB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stvfb]=pInst->STVFB_i;
EXIT_IF_ISNAN(pInst->STVFB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_tox]=pModel->TOX_i;
EXIT_IF_ISNAN(pModel->TOX_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_epsrox]=pModel->EPSROX_i;
EXIT_IF_ISNAN(pModel->EPSROX_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_neff]=pInst->NEFF_i;
EXIT_IF_ISNAN(pInst->NEFF_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_vnsub]=pInst->VNSUB_i;
EXIT_IF_ISNAN(pInst->VNSUB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_nslp]=pInst->NSLP_i;
EXIT_IF_ISNAN(pInst->NSLP_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_dnsub]=pInst->DNSUB_i;
EXIT_IF_ISNAN(pInst->DNSUB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_dphib]=pInst->DPHIB_i;
EXIT_IF_ISNAN(pInst->DPHIB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_np]=pInst->NP_i;
EXIT_IF_ISNAN(pInst->NP_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_ct]=pInst->CT_i;
EXIT_IF_ISNAN(pInst->CT_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_toxov]=pModel->TOXOV_i;
EXIT_IF_ISNAN(pModel->TOXOV_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_toxovd]=pModel->TOXOVD_i;
EXIT_IF_ISNAN(pModel->TOXOVD_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_nov]=pInst->NOV_i;
EXIT_IF_ISNAN(pInst->NOV_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_novd]=pInst->NOVD_i;
EXIT_IF_ISNAN(pInst->NOVD_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cf]=pInst->CF_i;
EXIT_IF_ISNAN(pInst->CF_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cfb]=pInst->CFB_i;
EXIT_IF_ISNAN(pInst->CFB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_betn]=pInst->BETN_i;
EXIT_IF_ISNAN(pInst->BETN_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stbet]=pInst->STBET_i;
EXIT_IF_ISNAN(pInst->STBET_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_mue]=pInst->MUE_i;
EXIT_IF_ISNAN(pInst->MUE_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stmue]=pInst->STMUE_i;
EXIT_IF_ISNAN(pInst->STMUE_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_themu]=pInst->THEMU_i;
EXIT_IF_ISNAN(pInst->THEMU_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stthemu]=pInst->STTHEMU_i;
EXIT_IF_ISNAN(pInst->STTHEMU_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cs]=pInst->CS_i;
EXIT_IF_ISNAN(pInst->CS_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stcs]=pInst->STCS_i;
EXIT_IF_ISNAN(pInst->STCS_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_xcor]=pInst->XCOR_i;
EXIT_IF_ISNAN(pInst->XCOR_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stxcor]=pInst->STXCOR_i;
EXIT_IF_ISNAN(pInst->STXCOR_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_feta]=pInst->FETA_i;
EXIT_IF_ISNAN(pInst->FETA_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_rs]=pInst->RS_i;
EXIT_IF_ISNAN(pInst->RS_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_strs]=pInst->STRS_i;
EXIT_IF_ISNAN(pInst->STRS_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_rsb]=pInst->RSB_i;
EXIT_IF_ISNAN(pInst->RSB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_rsg]=pInst->RSG_i;
EXIT_IF_ISNAN(pInst->RSG_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_thesat]=pInst->THESAT_i;
EXIT_IF_ISNAN(pInst->THESAT_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stthesat]=pInst->STTHESAT_i;
EXIT_IF_ISNAN(pInst->STTHESAT_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_thesatb]=pInst->THESATB_i;
EXIT_IF_ISNAN(pInst->THESATB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_thesatg]=pInst->THESATG_i;
EXIT_IF_ISNAN(pInst->THESATG_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_ax]=pInst->AX_i;
EXIT_IF_ISNAN(pInst->AX_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_alp]=pInst->ALP_i;
EXIT_IF_ISNAN(pInst->ALP_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_alp1]=pInst->ALP1_i;
EXIT_IF_ISNAN(pInst->ALP1_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_alp2]=pInst->ALP2_i;
EXIT_IF_ISNAN(pInst->ALP2_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_vp]=pInst->VP_i;
EXIT_IF_ISNAN(pInst->VP_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_a1]=pInst->A1_i;
EXIT_IF_ISNAN(pInst->A1_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_a2]=pInst->A2_i;
EXIT_IF_ISNAN(pInst->A2_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_sta2]=pInst->STA2_i;
EXIT_IF_ISNAN(pInst->STA2_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_a3]=pInst->A3_i;
EXIT_IF_ISNAN(pInst->A3_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_a4]=pInst->A4_i;
EXIT_IF_ISNAN(pInst->A4_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_gco]=pInst->GCO_i;
EXIT_IF_ISNAN(pInst->GCO_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_iginv]=pInst->IGINV_i;
EXIT_IF_ISNAN(pInst->IGINV_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_igov]=pInst->IGOV_i;
EXIT_IF_ISNAN(pInst->IGOV_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_igovd]=pInst->IGOVD_i;
EXIT_IF_ISNAN(pInst->IGOVD_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stig]=pInst->STIG_i;
EXIT_IF_ISNAN(pInst->STIG_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_gc2]=pInst->GC2_i;
EXIT_IF_ISNAN(pInst->GC2_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_gc3]=pInst->GC3_i;
EXIT_IF_ISNAN(pInst->GC3_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_chib]=pInst->CHIB_i;
EXIT_IF_ISNAN(pInst->CHIB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_agidl]=pInst->AGIDL_i;
EXIT_IF_ISNAN(pInst->AGIDL_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_agidld]=pInst->AGIDLD_i;
EXIT_IF_ISNAN(pInst->AGIDLD_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_bgidl]=pInst->BGIDL_T;
EXIT_IF_ISNAN(pInst->BGIDL_T)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_bgidld]=pInst->BGIDLD_T;
EXIT_IF_ISNAN(pInst->BGIDLD_T)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stbgidl]=pInst->STBGIDL_i;
EXIT_IF_ISNAN(pInst->STBGIDL_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_stbgidld]=pInst->STBGIDLD_i;
EXIT_IF_ISNAN(pInst->STBGIDLD_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cgidl]=pInst->CGIDL_i;
EXIT_IF_ISNAN(pInst->CGIDL_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cgidld]=pInst->CGIDLD_i;
EXIT_IF_ISNAN(pInst->CGIDLD_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cox]=pInst->COX_i;
EXIT_IF_ISNAN(pInst->COX_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cgov]=pInst->CGOV_i;
EXIT_IF_ISNAN(pInst->CGOV_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cgovd]=pInst->CGOVD_i;
EXIT_IF_ISNAN(pInst->CGOVD_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cgbov]=pInst->CGBOV_i;
EXIT_IF_ISNAN(pInst->CGBOV_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cfr]=pInst->CFR_i;
EXIT_IF_ISNAN(pInst->CFR_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_cfrd]=pInst->CFRD_i;
EXIT_IF_ISNAN(pInst->CFRD_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_fnt]=pInst->FNT_i;
EXIT_IF_ISNAN(pInst->FNT_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_fntexc]=pInst->FNTEXC_i;
EXIT_IF_ISNAN(pInst->FNTEXC_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_nfa]=pInst->NFA_i;
EXIT_IF_ISNAN(pInst->NFA_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_nfb]=pInst->NFB_i;
EXIT_IF_ISNAN(pInst->NFB_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_nfc]=pInst->NFC_i;
EXIT_IF_ISNAN(pInst->NFC_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_ef]=pInst->EF_i;
EXIT_IF_ISNAN(pInst->EF_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_rg]=pInst->RG_i;
EXIT_IF_ISNAN(pInst->RG_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_rbulk]=pInst->RBULK_i;
EXIT_IF_ISNAN(pInst->RBULK_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_rwell]=pInst->RWELL_i;
EXIT_IF_ISNAN(pInst->RWELL_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_rjuns]=pInst->RJUNS_i;
EXIT_IF_ISNAN(pInst->RJUNS_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_lp_rjund]=pInst->RJUND_i;
EXIT_IF_ISNAN(pInst->RJUND_i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_tk]=pModel->TKD;
EXIT_IF_ISNAN(pModel->TKD)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjosbot]=((pInst->MULT_i*pInst->ABSOURCE_i)*pModel->cjobot);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABSOURCE_i)*pModel->cjobot))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjossti]=((pInst->MULT_i*pInst->LSSOURCE_i)*pModel->cjosti);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSSOURCE_i)*pModel->cjosti))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjosgat]=((pInst->MULT_i*pInst->LGSOURCE_i)*pModel->cjogat);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGSOURCE_i)*pModel->cjogat))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vbisbot]=pModel->vbibot;
EXIT_IF_ISNAN(pModel->vbibot)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vbissti]=pModel->vbisti;
EXIT_IF_ISNAN(pModel->vbisti)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vbisgat]=pModel->vbigat;
EXIT_IF_ISNAN(pModel->vbigat)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjosbotd]=((pInst->MULT_i*pInst->ABDRAIN_i)*pModel->cjobot_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->ABDRAIN_i)*pModel->cjobot_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjosstid]=((pInst->MULT_i*pInst->LSDRAIN_i)*pModel->cjosti_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LSDRAIN_i)*pModel->cjosti_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_cjosgatd]=((pInst->MULT_i*pInst->LGDRAIN_i)*pModel->cjogat_d);
EXIT_IF_ISNAN(((pInst->MULT_i*pInst->LGDRAIN_i)*pModel->cjogat_d))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vbisbotd]=pModel->vbibot_d;
EXIT_IF_ISNAN(pModel->vbibot_d)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vbisstid]=pModel->vbisti_d;
EXIT_IF_ISNAN(pModel->vbisti_d)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_vbisgatd]=pModel->vbigat_d;
EXIT_IF_ISNAN(pModel->vbigat_d)
#endif
}
}
